/*===========================================================================*/
/*   (Llib/mpg123_decoder.scm)                                               */
/*   Bigloo (4.3f)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 04 Jul 2019 08:10:18 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo4.3f/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -I Llib -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -unsafe -safee -srfi mpg123 -copt  -copt -fPIC -copt -IClib Llib/mpg123_decoder.scm -o objs/mpg123_decoder.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

/* runtime code modification */
#define BGL_SELF_MODIFYING_CODE 0

#include <bigloo.h>
#include <mpg123.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_musicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
} *BgL_musicz00_bglt;

typedef struct BgL_musicstatusz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_statez00;
   obj_t BgL_volumez00;
   bool_t BgL_repeatz00;
   bool_t BgL_randomz00;
   int BgL_playlistidz00;
   int BgL_playlistlengthz00;
   int BgL_xfadez00;
   int BgL_songz00;
   int BgL_songidz00;
   obj_t BgL_songposz00;
   int BgL_songlengthz00;
   int BgL_bitratez00;
   int BgL_khza7za7;
   obj_t BgL_errz00;
   int BgL_bufferingz00;
} *BgL_musicstatusz00_bglt;

typedef struct BgL_musicbufferz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_urlz00;
   bool_t BgL_z52eofz52;
   obj_t BgL_z52bcondvz52;
   obj_t BgL_z52bmutexz52;
   long BgL_z52inlenz52;
   char * BgL_z52inbufpz52;
   long BgL_z52headz52;
   long BgL_z52tailz52;
   bool_t BgL_z52emptyz52;
} *BgL_musicbufferz00_bglt;

typedef struct BgL_musicbufz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
} *BgL_musicbufz00_bglt;

typedef struct BgL_musicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
} *BgL_musicdecoderz00_bglt;

typedef struct BgL_mpg123zd2handlezd2_bgl {
   header_t header;
   obj_t widening;
   mpg123_handle * BgL_z42builtinz42;
   obj_t BgL_decoderz00;
   long BgL_siza7eza7;
} *BgL_mpg123zd2handlezd2_bglt;

typedef struct BgL_mpg123zd2decoderzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_outbufz00;
   obj_t BgL_z52mpg123z52;
   long BgL_z52z12dseekz40;
   int BgL_z52ratez52;
   int BgL_z52channelsz52;
   obj_t BgL_z52encodingz52;
} *BgL_mpg123zd2decoderzd2_bglt;


static obj_t BGl_z62musicdecoderzd2closezd2m1134z62zz__mpg123_decoderz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00 = BUNSPEC;
static obj_t BGl_z62musicdecoderzd2initzd2mp1132z62zz__mpg123_decoderz00(obj_t, obj_t);
BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
static int BGl_mpg123zd2debugzd2zz__mpg123_decoderz00();
BGL_IMPORT obj_t BGl_musicbufzd2writezd2zz__multimediazd2musicbufzd2(BgL_musicbufz00_bglt, obj_t, long);
static obj_t BGl_objectzd2initzd2zz__mpg123_decoderz00();
static obj_t BGl_z62zc3anonymousza31272ze3ze1zz__mpg123_decoderz00(obj_t);
static obj_t BGl_z62zc3anonymousza31329ze3ze1zz__mpg123_decoderz00(obj_t);
static obj_t BGl_z62musicdecoderzd2positio1138zb0zz__mpg123_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__mpg123_decoderz00();
BGL_IMPORT obj_t make_string(long, unsigned char);
static obj_t BGl_z62lambda1206z62zz__mpg123_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1207z62zz__mpg123_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1218z62zz__mpg123_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1219z62zz__mpg123_decoderz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_conditionzd2variablezd2nilz00zz__threadz00();
BGL_IMPORT int bgl_debug();
static obj_t BGl_z62lambda1258z62zz__mpg123_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1259z62zz__mpg123_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62musicdecoderzd2seekzd2mp1142z62zz__mpg123_decoderz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__mpg123_decoderz00();
static obj_t BGl_z62objectzd2printzd2mpg123zd21130zb0zz__mpg123_decoderz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1270z62zz__mpg123_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1271z62zz__mpg123_decoderz00(obj_t, obj_t, obj_t);
BGL_IMPORT long BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt);
extern long BGl_mpg123zd2infozd2zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt);
static obj_t BGl_newzd2formatzd2zz__mpg123_decoderz00(BgL_mpg123zd2decoderzd2_bglt, BgL_musicbufz00_bglt, BgL_musicbufferz00_bglt);
BGL_IMPORT obj_t BGl_musicdecoderzd2hwparamszd2setz12z12zz__multimediazd2musicbufzd2(BgL_musicdecoderz00_bglt, BgL_musicz00_bglt, BgL_musicbufferz00_bglt);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31220ze3ze1zz__mpg123_decoderz00(obj_t);
static obj_t BGl_za2debugzd2portza2zd2zz__mpg123_decoderz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t, obj_t);
BGL_IMPORT obj_t BGl_musicbufzd2drainzd2zz__multimediazd2musicbufzd2(BgL_musicbufz00_bglt);
static obj_t BGl_z62zc3anonymousza31208ze3ze1zz__mpg123_decoderz00(obj_t);
BGL_IMPORT obj_t BGl_musicbufferzd2streamzd2zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt);
static obj_t BGl_z62musicdecoderzd2decodezd21146z62zz__mpg123_decoderz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__mpg123_decoderz00 = BUNSPEC;
extern obj_t BGl_mpg123zd2getzd2formatz00zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt);
static obj_t BGl_z62zc3anonymousza31260ze3ze1zz__mpg123_decoderz00(obj_t);
static obj_t BGl_toplevelzd2initzd2zz__mpg123_decoderz00();
extern obj_t BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00;
extern long BGl_mpg123zd2positionzd2zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt);
BGL_IMPORT obj_t BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
static obj_t BGl_genericzd2initzd2zz__mpg123_decoderz00();
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62musicdecoderzd2infozd2mp1140z62zz__mpg123_decoderz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31191ze3ze1zz__mpg123_decoderz00(obj_t, obj_t);
extern obj_t BGl_mpg123zd2handlezd2closez00zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt);
static obj_t BGl_debugz00zz__mpg123_decoderz00(obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mutexzd2nilzd2zz__threadz00();
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_musicdecoderz00zz__multimediazd2musicbufzd2;
extern obj_t BGl_mpg123zd2volumezd2setz12z12zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt, obj_t);
BGL_IMPORT obj_t BGl_openzd2outputzd2filez00zz__r4_ports_6_10_1z00(obj_t, obj_t);
BGL_IMPORT obj_t bgl_close_output_port(obj_t);
static long BGl_bufferzd2percentagezd2filledze70ze7zz__mpg123_decoderz00(long, BgL_musicbufferz00_bglt);
BGL_IMPORT BGL_LONGLONG_T bgl_current_microseconds();
extern int bgl_mpg123_decode(obj_t, char *, long, long, char *, long);
static obj_t BGl_z62musicdecoderzd2resetz12zd21136z70zz__mpg123_decoderz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static obj_t BGl_z62lambda1303z62zz__mpg123_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1304z62zz__mpg123_decoderz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_musiczd2errorzd2setz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__mpg123_decoderz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__mpg123_mpg123z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2mp3zd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__datez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
extern obj_t BGl_mpg123zd2handlezd2resetz12z12zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt);
static obj_t BGl_z62lambda1327z62zz__mpg123_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1328z62zz__mpg123_decoderz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_tprintz00zz__r4_output_6_10_3z00(obj_t, obj_t);
static BgL_mpg123zd2decoderzd2_bglt BGl_z62lambda1182z62zz__mpg123_decoderz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT long BGl_mp3zd2indexzd2zz__multimediazd2mp3zd2(obj_t, long);
static obj_t BGl_cnstzd2initzd2zz__mpg123_decoderz00();
static BgL_mpg123zd2decoderzd2_bglt BGl_z62lambda1188z62zz__mpg123_decoderz00(obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zz__mpg123_decoderz00();
static obj_t BGl_debugzd2initz12zc0zz__mpg123_decoderz00(obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__mpg123_decoderz00();
BGL_IMPORT long BGl_musicdecoderzd2positionzd2zz__multimediazd2musicbufzd2(BgL_musicdecoderz00_bglt, BgL_musicbufferz00_bglt);
BGL_IMPORT obj_t BGl_musicbufferzd2seekzd2zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt, obj_t);
BGL_IMPORT long BGl_musicdecoderzd2infozd2zz__multimediazd2musicbufzd2(BgL_musicdecoderz00_bglt);
static obj_t BGl_z62musicdecoderzd2volumezd21144z62zz__mpg123_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_debugzd2stopz12zc0zz__mpg123_decoderz00(obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
extern obj_t BGl_mpg123zd2decodezd2statuszd2ze3symbolz31zz__mpg123_mpg123z00(int);
static obj_t BGl_z62zc3anonymousza31305ze3ze1zz__mpg123_decoderz00(obj_t);
static obj_t __cnst[ 21 ] ;


BGL_IMPORT obj_t BGl_musicdecoderzd2decodezd2envz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musicdecoderzd2volumezd2setz12zd2envzc0zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musicdecoderzd2closezd2envz00zz__multimediazd2musicbufzd2;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1982z00zz__mpg123_decoderz00, BgL_bgl_za762za7c3anonymousza72052za7, BGl_z62zc3anonymousza31208ze3ze1zz__mpg123_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1983z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1207za7622053z00, BGl_z62lambda1207z62zz__mpg123_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1984z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1206za7622054z00, BGl_z62lambda1206z62zz__mpg123_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1985z00zz__mpg123_decoderz00, BgL_bgl_za762za7c3anonymousza72055za7, BGl_z62zc3anonymousza31220ze3ze1zz__mpg123_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1986z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1219za7622056z00, BGl_z62lambda1219z62zz__mpg123_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1987z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1218za7622057z00, BGl_z62lambda1218z62zz__mpg123_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1988z00zz__mpg123_decoderz00, BgL_bgl_za762za7c3anonymousza72058za7, BGl_z62zc3anonymousza31260ze3ze1zz__mpg123_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1989z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1259za7622059z00, BGl_z62lambda1259z62zz__mpg123_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1990z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1258za7622060z00, BGl_z62lambda1258z62zz__mpg123_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1991z00zz__mpg123_decoderz00, BgL_bgl_za762za7c3anonymousza72061za7, BGl_z62zc3anonymousza31272ze3ze1zz__mpg123_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1992z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1271za7622062z00, BGl_z62lambda1271z62zz__mpg123_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1993z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1270za7622063z00, BGl_z62lambda1270z62zz__mpg123_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1994z00zz__mpg123_decoderz00, BgL_bgl_za762za7c3anonymousza72064za7, BGl_z62zc3anonymousza31305ze3ze1zz__mpg123_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1995z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1304za7622065z00, BGl_z62lambda1304z62zz__mpg123_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1996z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1303za7622066z00, BGl_z62lambda1303z62zz__mpg123_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1997z00zz__mpg123_decoderz00, BgL_bgl_za762za7c3anonymousza72067za7, BGl_z62zc3anonymousza31329ze3ze1zz__mpg123_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1998z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1328za7622068z00, BGl_z62lambda1328z62zz__mpg123_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1999z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1327za7622069z00, BGl_z62lambda1327z62zz__mpg123_decoderz00, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_musicdecoderzd2infozd2envz00zz__multimediazd2musicbufzd2;
DEFINE_STRING( BGl_string2003z00zz__mpg123_decoderz00, BgL_bgl_string2003za700za7za7_2070za7, "", 0 );
DEFINE_STRING( BGl_string2005z00zz__mpg123_decoderz00, BgL_bgl_string2005za700za7za7_2071za7, "object-print", 12 );
DEFINE_STRING( BGl_string2007z00zz__mpg123_decoderz00, BgL_bgl_string2007za700za7za7_2072za7, "musicdecoder-init", 17 );
DEFINE_STRING( BGl_string2009z00zz__mpg123_decoderz00, BgL_bgl_string2009za700za7za7_2073za7, "musicdecoder-close", 18 );
DEFINE_STRING( BGl_string2011z00zz__mpg123_decoderz00, BgL_bgl_string2011za700za7za7_2074za7, "musicdecoder-reset!", 19 );
DEFINE_STRING( BGl_string2013z00zz__mpg123_decoderz00, BgL_bgl_string2013za700za7za7_2075za7, "musicdecoder-position", 21 );
DEFINE_STRING( BGl_string2015z00zz__mpg123_decoderz00, BgL_bgl_string2015za700za7za7_2076za7, "musicdecoder-info", 17 );
DEFINE_STRING( BGl_string2017z00zz__mpg123_decoderz00, BgL_bgl_string2017za700za7za7_2077za7, "musicdecoder-seek", 17 );
DEFINE_STRING( BGl_string2019z00zz__mpg123_decoderz00, BgL_bgl_string2019za700za7za7_2078za7, "musicdecoder-volume-set!", 24 );
DEFINE_STRING( BGl_string2021z00zz__mpg123_decoderz00, BgL_bgl_string2021za700za7za7_2079za7, "musicdecoder-decode", 19 );
DEFINE_STRING( BGl_string2022z00zz__mpg123_decoderz00, BgL_bgl_string2022za700za7za7_2080za7, "\033[0m\033[1;33m", 11 );
DEFINE_STRING( BGl_string2023z00zz__mpg123_decoderz00, BgL_bgl_string2023za700za7za7_2081za7, "\033[0m\033[1;32m", 11 );
DEFINE_STRING( BGl_string2024z00zz__mpg123_decoderz00, BgL_bgl_string2024za700za7za7_2082za7, " EOF", 4 );
DEFINE_STRING( BGl_string2025z00zz__mpg123_decoderz00, BgL_bgl_string2025za700za7za7_2083za7, " url=", 5 );
DEFINE_STRING( BGl_string2026z00zz__mpg123_decoderz00, BgL_bgl_string2026za700za7za7_2084za7, "%\033[0m", 5 );
DEFINE_STRING( BGl_string2027z00zz__mpg123_decoderz00, BgL_bgl_string2027za700za7za7_2085za7, "--- MPG123_DECODER, buffer fill: ", 33 );
DEFINE_STRING( BGl_string2028z00zz__mpg123_decoderz00, BgL_bgl_string2028za700za7za7_2086za7, "...", 3 );
DEFINE_STRING( BGl_string2029z00zz__mpg123_decoderz00, BgL_bgl_string2029za700za7za7_2087za7, "--> MPG123_DECODER, broadcast not-full ", 39 );
DEFINE_STRING( BGl_string2030z00zz__mpg123_decoderz00, BgL_bgl_string2030za700za7za7_2088za7, "~~~ MPG123_DECODER, EOF ", 24 );
DEFINE_STRING( BGl_string2031z00zz__mpg123_decoderz00, BgL_bgl_string2031za700za7za7_2089za7, "<-- MPG123_DECODER, wait not-empty ", 35 );
DEFINE_STRING( BGl_string2032z00zz__mpg123_decoderz00, BgL_bgl_string2032za700za7za7_2090za7, " -> status=", 11 );
DEFINE_STRING( BGl_string2033z00zz__mpg123_decoderz00, BgL_bgl_string2033za700za7za7_2091za7, " hd=", 4 );
DEFINE_STRING( BGl_string2034z00zz__mpg123_decoderz00, BgL_bgl_string2034za700za7za7_2092za7, " tl=", 4 );
DEFINE_STRING( BGl_string2035z00zz__mpg123_decoderz00, BgL_bgl_string2035za700za7za7_2093za7, "~~~ MPG123_DECODER, s=", 22 );
DEFINE_STRING( BGl_string2036z00zz__mpg123_decoderz00, BgL_bgl_string2036za700za7za7_2094za7, "offset=", 7 );
DEFINE_STRING( BGl_string2037z00zz__mpg123_decoderz00, BgL_bgl_string2037za700za7za7_2095za7, ":", 1 );
DEFINE_STRING( BGl_string2038z00zz__mpg123_decoderz00, BgL_bgl_string2038za700za7za7_2096za7, ",", 1 );
DEFINE_STRING( BGl_string2039z00zz__mpg123_decoderz00, BgL_bgl_string2039za700za7za7_2097za7, " size=", 6 );
DEFINE_STRING( BGl_string2040z00zz__mpg123_decoderz00, BgL_bgl_string2040za700za7za7_2098za7, "~~~ MPG123_DECODER, OK s=", 25 );
DEFINE_STRING( BGl_string2041z00zz__mpg123_decoderz00, BgL_bgl_string2041za700za7za7_2099za7, " tail=", 6 );
DEFINE_STRING( BGl_string2042z00zz__mpg123_decoderz00, BgL_bgl_string2042za700za7za7_2100za7, " %empty=", 8 );
DEFINE_STRING( BGl_string2043z00zz__mpg123_decoderz00, BgL_bgl_string2043za700za7za7_2101za7, "~~~ MPG123_DECODER, NEED-MORE s=", 32 );
DEFINE_STRING( BGl_string2044z00zz__mpg123_decoderz00, BgL_bgl_string2044za700za7za7_2102za7, "mp3 decoding error", 18 );
DEFINE_STRING( BGl_string2045z00zz__mpg123_decoderz00, BgL_bgl_string2045za700za7za7_2103za7, "~~~ MPG123_SEEK, seek=", 22 );
DEFINE_STRING( BGl_string2046z00zz__mpg123_decoderz00, BgL_bgl_string2046za700za7za7_2104za7, "#|mpg123-decoder|", 17 );
DEFINE_STRING( BGl_string2047z00zz__mpg123_decoderz00, BgL_bgl_string2047za700za7za7_2105za7, "__mpg123_decoder", 16 );
DEFINE_STRING( BGl_string2048z00zz__mpg123_decoderz00, BgL_bgl_string2048za700za7za7_2106za7, "(\"audio/mpeg\") buffering ended stop play pause unknown _ __mpg123_decoder mpg123-decoder symbol %encoding %channels int %rate long %!dseek obj %mpg123 bstring outbuf ", 166 );
BGL_IMPORT obj_t BGl_objectzd2printzd2envz00zz__objectz00;
BGL_IMPORT obj_t BGl_musicdecoderzd2seekzd2envz00zz__multimediazd2musicbufzd2;
DEFINE_STRING( BGl_string1976z00zz__mpg123_decoderz00, BgL_bgl_string1976za700za7za7_2107za7, "Llib/mpg123_decoder.scm", 23 );
DEFINE_STRING( BGl_string1977z00zz__mpg123_decoderz00, BgL_bgl_string1977za700za7za7_2108za7, "/tmp/MPG123.log", 15 );
DEFINE_STRING( BGl_string1978z00zz__mpg123_decoderz00, BgL_bgl_string1978za700za7za7_2109za7, "\n", 1 );
DEFINE_STRING( BGl_string1979z00zz__mpg123_decoderz00, BgL_bgl_string1979za700za7za7_2110za7, " ", 1 );
DEFINE_STRING( BGl_string1980z00zz__mpg123_decoderz00, BgL_bgl_string1980za700za7za7_2111za7, ">>> MPG123_DECODER init ", 24 );
DEFINE_STRING( BGl_string1981z00zz__mpg123_decoderz00, BgL_bgl_string1981za700za7za7_2112za7, ">>> MPG123_DECODER stop ", 24 );
BGL_IMPORT obj_t BGl_musicdecoderzd2resetz12zd2envz12zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musicdecoderzd2positionzd2envz00zz__multimediazd2musicbufzd2;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2000z00zz__mpg123_decoderz00, BgL_bgl_za762za7c3anonymousza72113za7, BGl_z62zc3anonymousza31191ze3ze1zz__mpg123_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2001z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1188za7622114z00, BGl_z62lambda1188z62zz__mpg123_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2002z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1182za7622115z00, BGl_z62lambda1182z62zz__mpg123_decoderz00, 0L, BUNSPEC, 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2004z00zz__mpg123_decoderz00, BgL_bgl_za762objectza7d2prin2116z00, BGl_z62objectzd2printzd2mpg123zd21130zb0zz__mpg123_decoderz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2006z00zz__mpg123_decoderz00, BgL_bgl_za762musicdecoderza72117z00, BGl_z62musicdecoderzd2initzd2mp1132z62zz__mpg123_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2008z00zz__mpg123_decoderz00, BgL_bgl_za762musicdecoderza72118z00, BGl_z62musicdecoderzd2closezd2m1134z62zz__mpg123_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2010z00zz__mpg123_decoderz00, BgL_bgl_za762musicdecoderza72119z00, BGl_z62musicdecoderzd2resetz12zd21136z70zz__mpg123_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2012z00zz__mpg123_decoderz00, BgL_bgl_za762musicdecoderza72120z00, BGl_z62musicdecoderzd2positio1138zb0zz__mpg123_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2014z00zz__mpg123_decoderz00, BgL_bgl_za762musicdecoderza72121z00, BGl_z62musicdecoderzd2infozd2mp1140z62zz__mpg123_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2016z00zz__mpg123_decoderz00, BgL_bgl_za762musicdecoderza72122z00, BGl_z62musicdecoderzd2seekzd2mp1142z62zz__mpg123_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2018z00zz__mpg123_decoderz00, BgL_bgl_za762musicdecoderza72123z00, BGl_z62musicdecoderzd2volumezd21144z62zz__mpg123_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2020z00zz__mpg123_decoderz00, BgL_bgl_za762musicdecoderza72124z00, BGl_z62musicdecoderzd2decodezd21146z62zz__mpg123_decoderz00, 0L, BUNSPEC, 3 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00) );
ADD_ROOT( (void *)(&BGl_za2debugzd2portza2zd2zz__mpg123_decoderz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__mpg123_decoderz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__mpg123_decoderz00(long BgL_checksumz00_1082, char * BgL_fromz00_1083)
{ BGL_FUNCTION_BEGIN;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__mpg123_decoderz00))
{ 
BGl_requirezd2initializa7ationz75zz__mpg123_decoderz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__mpg123_decoderz00(); 
BGl_libraryzd2moduleszd2initz00zz__mpg123_decoderz00(); 
BGl_cnstzd2initzd2zz__mpg123_decoderz00(); 
BGl_importedzd2moduleszd2initz00zz__mpg123_decoderz00(); 
BGl_objectzd2initzd2zz__mpg123_decoderz00(); 
BGl_methodzd2initzd2zz__mpg123_decoderz00(); 
return 
BGl_toplevelzd2initzd2zz__mpg123_decoderz00();}  else 
{ 
return BUNSPEC;} } 
BGL_FUNCTION_END;
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__mpg123_decoderz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__paramz00(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2mp3zd2(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__datez00(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__mpg123_decoder"); 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__mpg123_decoderz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 15 */
{ /* Llib/mpg123_decoder.scm 15 */
obj_t BgL_cportz00_865;
{ /* Llib/mpg123_decoder.scm 15 */
obj_t BgL_stringz00_873;
BgL_stringz00_873 = BGl_string2048z00zz__mpg123_decoderz00; 
{ /* Llib/mpg123_decoder.scm 15 */
obj_t BgL_startz00_874;
BgL_startz00_874 = 
BINT(((long)0)); 
{ /* Llib/mpg123_decoder.scm 15 */
obj_t BgL_endz00_875;
BgL_endz00_875 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_873))); 
{ /* Llib/mpg123_decoder.scm 15 */

BgL_cportz00_865 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_873, BgL_startz00_874, BgL_endz00_875); } } } } 
{ 
long BgL_iz00_866;
BgL_iz00_866 = ((long)20); 
BgL_loopz00_867:
if(
(BgL_iz00_866==((long)-1)))
{ /* Llib/mpg123_decoder.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/mpg123_decoder.scm 15 */
{ /* Llib/mpg123_decoder.scm 15 */
obj_t BgL_arg2050z00_869;
{ /* Llib/mpg123_decoder.scm 15 */

{ /* Llib/mpg123_decoder.scm 15 */
obj_t BgL_locationz00_871;
BgL_locationz00_871 = 
BBOOL(((bool_t)0)); 
{ /* Llib/mpg123_decoder.scm 15 */

BgL_arg2050z00_869 = 
BGl_readz00zz__readerz00(BgL_cportz00_865, BgL_locationz00_871); } } } 
{ /* Llib/mpg123_decoder.scm 15 */
int BgL_tmpz00_1118;
BgL_tmpz00_1118 = 
(int)(BgL_iz00_866); 
CNST_TABLE_SET(BgL_tmpz00_1118, BgL_arg2050z00_869); } } 
{ /* Llib/mpg123_decoder.scm 15 */
int BgL_auxz00_872;
BgL_auxz00_872 = 
(int)(
(BgL_iz00_866-((long)1))); 
{ 
long BgL_iz00_1123;
BgL_iz00_1123 = 
(long)(BgL_auxz00_872); 
BgL_iz00_866 = BgL_iz00_1123; 
goto BgL_loopz00_867;} } } } } } 
BGL_FUNCTION_END;
}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__mpg123_decoderz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 15 */
return 
bgl_gc_roots_register();} 
BGL_FUNCTION_END;
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__mpg123_decoderz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), 
BSTRING_TO_STRING(BGl_string1976z00zz__mpg123_decoderz00)); 
return ( 
BGl_za2debugzd2portza2zd2zz__mpg123_decoderz00 = BFALSE, BUNSPEC) ;} 
BGL_FUNCTION_END;
}



/* mpg123-debug */
int BGl_mpg123zd2debugzd2zz__mpg123_decoderz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 38 */
if(
(((long)0)>((long)0)))
{ /* Llib/mpg123_decoder.scm 39 */
return 
bgl_debug();}  else 
{ /* Llib/mpg123_decoder.scm 39 */
return 
(int)(((long)0));} } 
BGL_FUNCTION_END;
}



/* new-format */
obj_t BGl_newzd2formatzd2zz__mpg123_decoderz00(BgL_mpg123zd2decoderzd2_bglt BgL_decz00_19, BgL_musicbufz00_bglt BgL_amz00_20, BgL_musicbufferz00_bglt BgL_bufferz00_21)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 303 */
{ /* Llib/mpg123_decoder.scm 305 */
obj_t BgL_ratez00_35;
{ /* Llib/mpg123_decoder.scm 306 */
obj_t BgL_arg1151z00_38;
BgL_arg1151z00_38 = 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(BgL_decz00_19))->BgL_z52mpg123z52); 
BgL_ratez00_35 = 
BGl_mpg123zd2getzd2formatz00zz__mpg123_mpg123z00(
((BgL_mpg123zd2handlezd2_bglt)BgL_arg1151z00_38)); } 
{ /* Llib/mpg123_decoder.scm 306 */
obj_t BgL_channelsz00_36;obj_t BgL_encodingz00_37;
{ /* Llib/mpg123_decoder.scm 307 */
int BgL_tmpz00_1135;
BgL_tmpz00_1135 = 
(int)(((long)1)); 
BgL_channelsz00_36 = 
BGL_MVALUES_VAL(BgL_tmpz00_1135); } 
{ /* Llib/mpg123_decoder.scm 307 */
int BgL_tmpz00_1138;
BgL_tmpz00_1138 = 
(int)(((long)2)); 
BgL_encodingz00_37 = 
BGL_MVALUES_VAL(BgL_tmpz00_1138); } 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(BgL_decz00_19))->BgL_z52ratez52)=((int)
CINT(BgL_ratez00_35)),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(BgL_decz00_19))->BgL_z52channelsz52)=((int)
CINT(BgL_channelsz00_36)),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(BgL_decz00_19))->BgL_z52encodingz52)=((obj_t)BgL_encodingz00_37),BUNSPEC); 
BGl_musicdecoderzd2hwparamszd2setz12z12zz__multimediazd2musicbufzd2(
((BgL_musicdecoderz00_bglt)BgL_decz00_19), 
((BgL_musicz00_bglt)BgL_amz00_20), BgL_bufferz00_21); } } 
{ /* Llib/mpg123_decoder.scm 312 */
BgL_musicstatusz00_bglt BgL_i1120z00_40;
BgL_i1120z00_40 = 
(((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_amz00_20)))->BgL_z52statusz52); 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1120z00_40))->BgL_songposz00)=((obj_t)
BINT(
BGl_musicdecoderzd2positionzd2zz__multimediazd2musicbufzd2(
((BgL_musicdecoderz00_bglt)BgL_decz00_19), BgL_bufferz00_21))),BUNSPEC); 
{ /* Llib/mpg123_decoder.scm 314 */
long BgL_bratez00_41;
BgL_bratez00_41 = 
BGl_musicdecoderzd2infozd2zz__multimediazd2musicbufzd2(
((BgL_musicdecoderz00_bglt)BgL_decz00_19)); 
{ /* Llib/mpg123_decoder.scm 315 */
obj_t BgL_ratez00_42;
{ /* Llib/mpg123_decoder.scm 316 */
int BgL_tmpz00_1157;
BgL_tmpz00_1157 = 
(int)(((long)1)); 
BgL_ratez00_42 = 
BGL_MVALUES_VAL(BgL_tmpz00_1157); } 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1120z00_40))->BgL_bitratez00)=((int)
(int)(BgL_bratez00_41)),BUNSPEC); 
return 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1120z00_40))->BgL_khza7za7)=((int)
CINT(BgL_ratez00_42)),BUNSPEC);} } } } 
BGL_FUNCTION_END;
}



/* debug-init! */
obj_t BGl_debugzd2initz12zc0zz__mpg123_decoderz00(obj_t BgL_urlz00_22)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 327 */
{ /* Llib/mpg123_decoder.scm 328 */

BGl_za2debugzd2portza2zd2zz__mpg123_decoderz00 = 
BGl_openzd2outputzd2filez00zz__r4_ports_6_10_1z00(BGl_string1977z00zz__mpg123_decoderz00, BTRUE); } 
{ /* Llib/mpg123_decoder.scm 329 */
BGL_LONGLONG_T BgL_arg1152z00_45;
BgL_arg1152z00_45 = 
bgl_current_microseconds(); 
{ /* Llib/mpg123_decoder.scm 329 */
obj_t BgL_list1153z00_46;
{ /* Llib/mpg123_decoder.scm 329 */
obj_t BgL_arg1154z00_47;
{ /* Llib/mpg123_decoder.scm 329 */
obj_t BgL_arg1155z00_48;
{ /* Llib/mpg123_decoder.scm 329 */
obj_t BgL_arg1156z00_49;
{ /* Llib/mpg123_decoder.scm 329 */
obj_t BgL_arg1157z00_50;
BgL_arg1157z00_50 = 
MAKE_YOUNG_PAIR(BGl_string1978z00zz__mpg123_decoderz00, BNIL); 
BgL_arg1156z00_49 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1152z00_45), BgL_arg1157z00_50); } 
BgL_arg1155z00_48 = 
MAKE_YOUNG_PAIR(BGl_string1979z00zz__mpg123_decoderz00, BgL_arg1156z00_49); } 
BgL_arg1154z00_47 = 
MAKE_YOUNG_PAIR(BgL_urlz00_22, BgL_arg1155z00_48); } 
BgL_list1153z00_46 = 
MAKE_YOUNG_PAIR(BGl_string1980z00zz__mpg123_decoderz00, BgL_arg1154z00_47); } 
return 
BGl_debugz00zz__mpg123_decoderz00(BgL_list1153z00_46);} } } 
BGL_FUNCTION_END;
}



/* debug-stop! */
obj_t BGl_debugzd2stopz12zc0zz__mpg123_decoderz00(obj_t BgL_urlz00_23)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 334 */
{ /* Llib/mpg123_decoder.scm 335 */
BGL_LONGLONG_T BgL_arg1158z00_51;
BgL_arg1158z00_51 = 
bgl_current_microseconds(); 
{ /* Llib/mpg123_decoder.scm 335 */
obj_t BgL_list1159z00_52;
{ /* Llib/mpg123_decoder.scm 335 */
obj_t BgL_arg1162z00_53;
{ /* Llib/mpg123_decoder.scm 335 */
obj_t BgL_arg1163z00_54;
{ /* Llib/mpg123_decoder.scm 335 */
obj_t BgL_arg1165z00_55;
{ /* Llib/mpg123_decoder.scm 335 */
obj_t BgL_arg1166z00_56;
BgL_arg1166z00_56 = 
MAKE_YOUNG_PAIR(BGl_string1978z00zz__mpg123_decoderz00, BNIL); 
BgL_arg1165z00_55 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1158z00_51), BgL_arg1166z00_56); } 
BgL_arg1163z00_54 = 
MAKE_YOUNG_PAIR(BGl_string1979z00zz__mpg123_decoderz00, BgL_arg1165z00_55); } 
BgL_arg1162z00_53 = 
MAKE_YOUNG_PAIR(BgL_urlz00_23, BgL_arg1163z00_54); } 
BgL_list1159z00_52 = 
MAKE_YOUNG_PAIR(BGl_string1981z00zz__mpg123_decoderz00, BgL_arg1162z00_53); } 
BGl_debugz00zz__mpg123_decoderz00(BgL_list1159z00_52); } } 
return 
bgl_close_output_port(BGl_za2debugzd2portza2zd2zz__mpg123_decoderz00);} 
BGL_FUNCTION_END;
}



/* debug */
obj_t BGl_debugz00zz__mpg123_decoderz00(obj_t BgL_argsz00_24)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 341 */
{ 
obj_t BgL_l1125z00_58;
BgL_l1125z00_58 = BgL_argsz00_24; 
BgL_zc3anonymousza31167ze3z83_59:
if(
PAIRP(BgL_l1125z00_58))
{ /* Llib/mpg123_decoder.scm 342 */
{ /* Llib/mpg123_decoder.scm 342 */
obj_t BgL_az00_61;
BgL_az00_61 = 
CAR(BgL_l1125z00_58); 
bgl_display_obj(BgL_az00_61, BGl_za2debugzd2portza2zd2zz__mpg123_decoderz00); } 
{ 
obj_t BgL_l1125z00_1186;
BgL_l1125z00_1186 = 
CDR(BgL_l1125z00_58); 
BgL_l1125z00_58 = BgL_l1125z00_1186; 
goto BgL_zc3anonymousza31167ze3z83_59;} }  else 
{ /* Llib/mpg123_decoder.scm 342 */((bool_t)1); } } 
return 
bgl_flush_output_port(BGl_za2debugzd2portza2zd2zz__mpg123_decoderz00);} 
BGL_FUNCTION_END;
}



/* object-init */
obj_t BGl_objectzd2initzd2zz__mpg123_decoderz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 15 */
{ /* Llib/mpg123_decoder.scm 21 */
obj_t BgL_arg1179z00_67;obj_t BgL_arg1181z00_68;
{ /* Llib/mpg123_decoder.scm 21 */
obj_t BgL_v1127z00_95;
BgL_v1127z00_95 = 
create_vector(((long)6)); 
{ /* Llib/mpg123_decoder.scm 21 */
obj_t BgL_arg1201z00_96;
BgL_arg1201z00_96 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)0)), BGl_proc1984z00zz__mpg123_decoderz00, BGl_proc1983z00zz__mpg123_decoderz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc1982z00zz__mpg123_decoderz00, 
CNST_TABLE_REF(((long)1))); 
VECTOR_SET(BgL_v1127z00_95,((long)0),BgL_arg1201z00_96); } 
{ /* Llib/mpg123_decoder.scm 21 */
obj_t BgL_arg1212z00_111;
BgL_arg1212z00_111 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)2)), BGl_proc1987z00zz__mpg123_decoderz00, BGl_proc1986z00zz__mpg123_decoderz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc1985z00zz__mpg123_decoderz00, 
CNST_TABLE_REF(((long)3))); 
VECTOR_SET(BgL_v1127z00_95,((long)1),BgL_arg1212z00_111); } 
{ /* Llib/mpg123_decoder.scm 21 */
obj_t BgL_arg1235z00_130;
BgL_arg1235z00_130 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)4)), BGl_proc1990z00zz__mpg123_decoderz00, BGl_proc1989z00zz__mpg123_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1988z00zz__mpg123_decoderz00, 
CNST_TABLE_REF(((long)5))); 
VECTOR_SET(BgL_v1127z00_95,((long)2),BgL_arg1235z00_130); } 
{ /* Llib/mpg123_decoder.scm 21 */
obj_t BgL_arg1261z00_143;
BgL_arg1261z00_143 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)6)), BGl_proc1993z00zz__mpg123_decoderz00, BGl_proc1992z00zz__mpg123_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1991z00zz__mpg123_decoderz00, 
CNST_TABLE_REF(((long)7))); 
VECTOR_SET(BgL_v1127z00_95,((long)3),BgL_arg1261z00_143); } 
{ /* Llib/mpg123_decoder.scm 21 */
obj_t BgL_arg1284z00_156;
BgL_arg1284z00_156 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)8)), BGl_proc1996z00zz__mpg123_decoderz00, BGl_proc1995z00zz__mpg123_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1994z00zz__mpg123_decoderz00, 
CNST_TABLE_REF(((long)7))); 
VECTOR_SET(BgL_v1127z00_95,((long)4),BgL_arg1284z00_156); } 
{ /* Llib/mpg123_decoder.scm 21 */
obj_t BgL_arg1317z00_169;
BgL_arg1317z00_169 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)9)), BGl_proc1999z00zz__mpg123_decoderz00, BGl_proc1998z00zz__mpg123_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1997z00zz__mpg123_decoderz00, 
CNST_TABLE_REF(((long)10))); 
VECTOR_SET(BgL_v1127z00_95,((long)5),BgL_arg1317z00_169); } 
BgL_arg1179z00_67 = BgL_v1127z00_95; } 
{ /* Llib/mpg123_decoder.scm 21 */
obj_t BgL_v1128z00_182;
BgL_v1128z00_182 = 
create_vector(((long)0)); 
BgL_arg1181z00_68 = BgL_v1128z00_182; } 
return ( 
BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)11)), 
CNST_TABLE_REF(((long)12)), BGl_musicdecoderz00zz__multimediazd2musicbufzd2, ((long)50873), BGl_proc2002z00zz__mpg123_decoderz00, BGl_proc2001z00zz__mpg123_decoderz00, BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_proc2000z00zz__mpg123_decoderz00, BFALSE, BgL_arg1179z00_67, BgL_arg1181z00_68), BUNSPEC) ;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1191> */
obj_t BGl_z62zc3anonymousza31191ze3ze1zz__mpg123_decoderz00(obj_t BgL_envz00_748, obj_t BgL_new1091z00_749)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 21 */
{ 
BgL_mpg123zd2decoderzd2_bglt BgL_auxz00_1218;
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1091z00_749))))->BgL_mimetypesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1091z00_749))))->BgL_bufferzd2timezd2nearz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1091z00_749))))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1091z00_749))))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1091z00_749))))->BgL_z52z12dpausez40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1091z00_749))))->BgL_z52z12dabortz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1091z00_749))))->BgL_z52z12stopz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1091z00_749))))->BgL_z52dmutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1091z00_749))))->BgL_z52dcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1091z00_749))))->BgL_z52doutcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1091z00_749)))->BgL_outbufz00)=((obj_t)BGl_string2003z00zz__mpg123_decoderz00),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1091z00_749)))->BgL_z52mpg123z52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1091z00_749)))->BgL_z52z12dseekz40)=((long)((long)0)),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1091z00_749)))->BgL_z52ratez52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1091z00_749)))->BgL_z52channelsz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1091z00_749)))->BgL_z52encodingz52)=((obj_t)
CNST_TABLE_REF(((long)13))),BUNSPEC); 
BgL_auxz00_1218 = 
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1091z00_749); 
return 
((obj_t)BgL_auxz00_1218);} } 
BGL_FUNCTION_END;
}



/* &lambda1188 */
BgL_mpg123zd2decoderzd2_bglt BGl_z62lambda1188z62zz__mpg123_decoderz00(obj_t BgL_envz00_750)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 21 */
{ /* Llib/mpg123_decoder.scm 21 */
BgL_mpg123zd2decoderzd2_bglt BgL_new1090z00_879;
BgL_new1090z00_879 = 
((BgL_mpg123zd2decoderzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_mpg123zd2decoderzd2_bgl) ))); 
{ /* Llib/mpg123_decoder.scm 21 */
long BgL_arg1190z00_880;
{ /* Llib/mpg123_decoder.scm 21 */
long BgL_res1892z00_881;
BgL_res1892z00_881 = 
BGL_CLASS_INDEX(BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00); 
BgL_arg1190z00_880 = BgL_res1892z00_881; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1090z00_879), BgL_arg1190z00_880); } 
return BgL_new1090z00_879;} } 
BGL_FUNCTION_END;
}



/* &lambda1182 */
BgL_mpg123zd2decoderzd2_bglt BGl_z62lambda1182z62zz__mpg123_decoderz00(obj_t BgL_envz00_751, obj_t BgL_mimetypes1074z00_752, obj_t BgL_bufferzd2timezd2near1075z00_753, obj_t BgL_bufferzd2siza7ezd2nearzd2rat1076z75_754, obj_t BgL_periodzd2siza7ezd2nearzd2rat1077z75_755, obj_t BgL_z52z12dpause1078z40_756, obj_t BgL_z52z12dabort1079z40_757, obj_t BgL_z52z12stop1080z40_758, obj_t BgL_z52dmutex1081z52_759, obj_t BgL_z52dcondv1082z52_760, obj_t BgL_z52doutcondv1083z52_761, obj_t BgL_outbuf1084z00_762, obj_t BgL_z52mpg1231085z52_763, obj_t BgL_z52z12dseek1086z40_764, obj_t BgL_z52rate1087z52_765, obj_t BgL_z52channels1088z52_766, obj_t BgL_z52encoding1089z52_767)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 21 */
{ /* Llib/mpg123_decoder.scm 21 */
int BgL_bufferzd2timezd2near1075z00_883;int BgL_bufferzd2siza7ezd2nearzd2rat1076z75_884;int BgL_periodzd2siza7ezd2nearzd2rat1077z75_885;bool_t BgL_z52z12dpause1078z40_886;bool_t BgL_z52z12dabort1079z40_887;bool_t BgL_z52z12stop1080z40_888;long BgL_z52z12dseek1086z40_893;int BgL_z52rate1087z52_894;int BgL_z52channels1088z52_895;
BgL_bufferzd2timezd2near1075z00_883 = 
CINT(BgL_bufferzd2timezd2near1075z00_753); 
BgL_bufferzd2siza7ezd2nearzd2rat1076z75_884 = 
CINT(BgL_bufferzd2siza7ezd2nearzd2rat1076z75_754); 
BgL_periodzd2siza7ezd2nearzd2rat1077z75_885 = 
CINT(BgL_periodzd2siza7ezd2nearzd2rat1077z75_755); 
BgL_z52z12dpause1078z40_886 = 
CBOOL(BgL_z52z12dpause1078z40_756); 
BgL_z52z12dabort1079z40_887 = 
CBOOL(BgL_z52z12dabort1079z40_757); 
BgL_z52z12stop1080z40_888 = 
CBOOL(BgL_z52z12stop1080z40_758); 
BgL_z52z12dseek1086z40_893 = 
(long)CINT(BgL_z52z12dseek1086z40_764); 
BgL_z52rate1087z52_894 = 
CINT(BgL_z52rate1087z52_765); 
BgL_z52channels1088z52_895 = 
CINT(BgL_z52channels1088z52_766); 
{ /* Llib/mpg123_decoder.scm 21 */
BgL_mpg123zd2decoderzd2_bglt BgL_new1122z00_897;
{ /* Llib/mpg123_decoder.scm 21 */
BgL_mpg123zd2decoderzd2_bglt BgL_new1121z00_898;
BgL_new1121z00_898 = 
((BgL_mpg123zd2decoderzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_mpg123zd2decoderzd2_bgl) ))); 
{ /* Llib/mpg123_decoder.scm 21 */
long BgL_arg1187z00_899;
{ /* Llib/mpg123_decoder.scm 21 */
long BgL_res1891z00_900;
BgL_res1891z00_900 = 
BGL_CLASS_INDEX(BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00); 
BgL_arg1187z00_899 = BgL_res1891z00_900; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1121z00_898), BgL_arg1187z00_899); } 
BgL_new1122z00_897 = BgL_new1121z00_898; } 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_897)))->BgL_mimetypesz00)=((obj_t)
((obj_t)BgL_mimetypes1074z00_752)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_897)))->BgL_bufferzd2timezd2nearz00)=((int)BgL_bufferzd2timezd2near1075z00_883),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_897)))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)BgL_bufferzd2siza7ezd2nearzd2rat1076z75_884),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_897)))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)BgL_periodzd2siza7ezd2nearzd2rat1077z75_885),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_897)))->BgL_z52z12dpausez40)=((bool_t)BgL_z52z12dpause1078z40_886),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_897)))->BgL_z52z12dabortz40)=((bool_t)BgL_z52z12dabort1079z40_887),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_897)))->BgL_z52z12stopz40)=((bool_t)BgL_z52z12stop1080z40_888),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_897)))->BgL_z52dmutexz52)=((obj_t)
((obj_t)BgL_z52dmutex1081z52_759)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_897)))->BgL_z52dcondvz52)=((obj_t)
((obj_t)BgL_z52dcondv1082z52_760)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_897)))->BgL_z52doutcondvz52)=((obj_t)
((obj_t)BgL_z52doutcondv1083z52_761)),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(BgL_new1122z00_897))->BgL_outbufz00)=((obj_t)
((obj_t)BgL_outbuf1084z00_762)),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(BgL_new1122z00_897))->BgL_z52mpg123z52)=((obj_t)BgL_z52mpg1231085z52_763),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(BgL_new1122z00_897))->BgL_z52z12dseekz40)=((long)BgL_z52z12dseek1086z40_893),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(BgL_new1122z00_897))->BgL_z52ratez52)=((int)BgL_z52rate1087z52_894),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(BgL_new1122z00_897))->BgL_z52channelsz52)=((int)BgL_z52channels1088z52_895),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(BgL_new1122z00_897))->BgL_z52encodingz52)=((obj_t)
((obj_t)BgL_z52encoding1089z52_767)),BUNSPEC); 
{ /* Llib/mpg123_decoder.scm 21 */
obj_t BgL_fun1183z00_901;
BgL_fun1183z00_901 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00); 
PROCEDURE_ENTRY(BgL_fun1183z00_901)(BgL_fun1183z00_901, 
((obj_t)BgL_new1122z00_897), BEOA); } 
return BgL_new1122z00_897;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1329> */
obj_t BGl_z62zc3anonymousza31329ze3ze1zz__mpg123_decoderz00(obj_t BgL_envz00_768)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 21 */
return 
CNST_TABLE_REF(((long)14));} 
BGL_FUNCTION_END;
}



/* &lambda1328 */
obj_t BGl_z62lambda1328z62zz__mpg123_decoderz00(obj_t BgL_envz00_769, obj_t BgL_oz00_770, obj_t BgL_vz00_771)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 21 */
return 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_oz00_770)))->BgL_z52encodingz52)=((obj_t)
((obj_t)BgL_vz00_771)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1327 */
obj_t BGl_z62lambda1327z62zz__mpg123_decoderz00(obj_t BgL_envz00_772, obj_t BgL_oz00_773)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 21 */
return 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_oz00_773)))->BgL_z52encodingz52);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1305> */
obj_t BGl_z62zc3anonymousza31305ze3ze1zz__mpg123_decoderz00(obj_t BgL_envz00_774)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 21 */
return 
BINT(((long)0));} 
BGL_FUNCTION_END;
}



/* &lambda1304 */
obj_t BGl_z62lambda1304z62zz__mpg123_decoderz00(obj_t BgL_envz00_775, obj_t BgL_oz00_776, obj_t BgL_vz00_777)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 21 */
{ /* Llib/mpg123_decoder.scm 21 */
int BgL_vz00_906;
BgL_vz00_906 = 
CINT(BgL_vz00_777); 
return 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_oz00_776)))->BgL_z52channelsz52)=((int)BgL_vz00_906),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1303 */
obj_t BGl_z62lambda1303z62zz__mpg123_decoderz00(obj_t BgL_envz00_778, obj_t BgL_oz00_779)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 21 */
return 
BINT(
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_oz00_779)))->BgL_z52channelsz52));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1272> */
obj_t BGl_z62zc3anonymousza31272ze3ze1zz__mpg123_decoderz00(obj_t BgL_envz00_780)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 21 */
return 
BINT(((long)0));} 
BGL_FUNCTION_END;
}



/* &lambda1271 */
obj_t BGl_z62lambda1271z62zz__mpg123_decoderz00(obj_t BgL_envz00_781, obj_t BgL_oz00_782, obj_t BgL_vz00_783)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 21 */
{ /* Llib/mpg123_decoder.scm 21 */
int BgL_vz00_909;
BgL_vz00_909 = 
CINT(BgL_vz00_783); 
return 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_oz00_782)))->BgL_z52ratez52)=((int)BgL_vz00_909),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1270 */
obj_t BGl_z62lambda1270z62zz__mpg123_decoderz00(obj_t BgL_envz00_784, obj_t BgL_oz00_785)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 21 */
return 
BINT(
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_oz00_785)))->BgL_z52ratez52));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1260> */
obj_t BGl_z62zc3anonymousza31260ze3ze1zz__mpg123_decoderz00(obj_t BgL_envz00_786)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 21 */
return 
BINT(((long)-1));} 
BGL_FUNCTION_END;
}



/* &lambda1259 */
obj_t BGl_z62lambda1259z62zz__mpg123_decoderz00(obj_t BgL_envz00_787, obj_t BgL_oz00_788, obj_t BgL_vz00_789)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 21 */
{ /* Llib/mpg123_decoder.scm 21 */
long BgL_vz00_912;
BgL_vz00_912 = 
(long)CINT(BgL_vz00_789); 
return 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_oz00_788)))->BgL_z52z12dseekz40)=((long)BgL_vz00_912),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1258 */
obj_t BGl_z62lambda1258z62zz__mpg123_decoderz00(obj_t BgL_envz00_790, obj_t BgL_oz00_791)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 21 */
return 
BINT(
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_oz00_791)))->BgL_z52z12dseekz40));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1220> */
obj_t BGl_z62zc3anonymousza31220ze3ze1zz__mpg123_decoderz00(obj_t BgL_envz00_792)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 21 */
{ 
BgL_mpg123zd2handlezd2_bglt BgL_auxz00_1354;
{ /* Llib/mpg123_decoder.scm 23 */
BgL_mpg123zd2handlezd2_bglt BgL_new1124z00_914;
{ /* Llib/mpg123_decoder.scm 23 */
BgL_mpg123zd2handlezd2_bglt BgL_new1123z00_915;
BgL_new1123z00_915 = 
((BgL_mpg123zd2handlezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_mpg123zd2handlezd2_bgl) ))); 
{ /* Llib/mpg123_decoder.scm 23 */
long BgL_arg1234z00_916;
{ /* Llib/mpg123_decoder.scm 23 */
long BgL_res1889z00_917;
BgL_res1889z00_917 = 
BGL_CLASS_INDEX(BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00); 
BgL_arg1234z00_916 = BgL_res1889z00_917; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1123z00_915), BgL_arg1234z00_916); } 
BgL_new1124z00_914 = BgL_new1123z00_915; } 
{ 
void * BgL_auxz00_1359;
{ /* Llib/mpg123_decoder.scm 23 */
obj_t BgL_arg1225z00_918;
{ /* Llib/mpg123_decoder.scm 23 */
obj_t BgL_arg1231z00_919;
{ /* Llib/mpg123_decoder.scm 23 */
obj_t BgL_res1890z00_920;
{ /* Llib/mpg123_decoder.scm 23 */
obj_t BgL_classz00_921;
BgL_classz00_921 = BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00; 
BgL_res1890z00_920 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_921); } 
BgL_arg1231z00_919 = BgL_res1890z00_920; } 
BgL_arg1225z00_918 = 
VECTOR_REF(BgL_arg1231z00_919,((long)0)); } 
BgL_auxz00_1359 = 
FOREIGN_TO_COBJ(
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1225z00_918)); } 
((((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_new1124z00_914))->BgL_z42builtinz42)=((mpg123_handle *)BgL_auxz00_1359),BUNSPEC); } 
((((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_new1124z00_914))->BgL_decoderz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_new1124z00_914))->BgL_siza7eza7)=((long)((long)0)),BUNSPEC); 
{ /* Llib/mpg123_decoder.scm 23 */
obj_t BgL_fun1232z00_922;
BgL_fun1232z00_922 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00); 
PROCEDURE_ENTRY(BgL_fun1232z00_922)(BgL_fun1232z00_922, 
((obj_t)BgL_new1124z00_914), BEOA); } 
BgL_auxz00_1354 = BgL_new1124z00_914; } 
return 
((obj_t)BgL_auxz00_1354);} } 
BGL_FUNCTION_END;
}



/* &lambda1219 */
obj_t BGl_z62lambda1219z62zz__mpg123_decoderz00(obj_t BgL_envz00_793, obj_t BgL_oz00_794, obj_t BgL_vz00_795)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 21 */
return 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_oz00_794)))->BgL_z52mpg123z52)=((obj_t)BgL_vz00_795),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1218 */
obj_t BGl_z62lambda1218z62zz__mpg123_decoderz00(obj_t BgL_envz00_796, obj_t BgL_oz00_797)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 21 */
return 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_oz00_797)))->BgL_z52mpg123z52);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1208> */
obj_t BGl_z62zc3anonymousza31208ze3ze1zz__mpg123_decoderz00(obj_t BgL_envz00_798)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 21 */
{ /* Llib/mpg123_decoder.scm 22 */

return 
make_string(((long)5120), ((unsigned char)' '));} } 
BGL_FUNCTION_END;
}



/* &lambda1207 */
obj_t BGl_z62lambda1207z62zz__mpg123_decoderz00(obj_t BgL_envz00_799, obj_t BgL_oz00_800, obj_t BgL_vz00_801)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 21 */
return 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_oz00_800)))->BgL_outbufz00)=((obj_t)
((obj_t)BgL_vz00_801)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1206 */
obj_t BGl_z62lambda1206z62zz__mpg123_decoderz00(obj_t BgL_envz00_802, obj_t BgL_oz00_803)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 21 */
return 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_oz00_803)))->BgL_outbufz00);} 
BGL_FUNCTION_END;
}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__mpg123_decoderz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 15 */
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* method-init */
obj_t BGl_methodzd2initzd2zz__mpg123_decoderz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2printzd2envz00zz__objectz00, BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00, BGl_proc2004z00zz__mpg123_decoderz00, BGl_string2005z00zz__mpg123_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00, BGl_proc2006z00zz__mpg123_decoderz00, BGl_string2007z00zz__mpg123_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2closezd2envz00zz__multimediazd2musicbufzd2, BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00, BGl_proc2008z00zz__mpg123_decoderz00, BGl_string2009z00zz__mpg123_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2resetz12zd2envz12zz__multimediazd2musicbufzd2, BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00, BGl_proc2010z00zz__mpg123_decoderz00, BGl_string2011z00zz__mpg123_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2positionzd2envz00zz__multimediazd2musicbufzd2, BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00, BGl_proc2012z00zz__mpg123_decoderz00, BGl_string2013z00zz__mpg123_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2infozd2envz00zz__multimediazd2musicbufzd2, BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00, BGl_proc2014z00zz__mpg123_decoderz00, BGl_string2015z00zz__mpg123_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2seekzd2envz00zz__multimediazd2musicbufzd2, BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00, BGl_proc2016z00zz__mpg123_decoderz00, BGl_string2017z00zz__mpg123_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2volumezd2setz12zd2envzc0zz__multimediazd2musicbufzd2, BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00, BGl_proc2018z00zz__mpg123_decoderz00, BGl_string2019z00zz__mpg123_decoderz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2decodezd2envz00zz__multimediazd2musicbufzd2, BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00, BGl_proc2020z00zz__mpg123_decoderz00, BGl_string2021z00zz__mpg123_decoderz00);} 
BGL_FUNCTION_END;
}



/* &musicdecoder-decode-1146 */
obj_t BGl_z62musicdecoderzd2decodezd21146z62zz__mpg123_decoderz00(obj_t BgL_envz00_817, obj_t BgL_decz00_818, obj_t BgL_amz00_819, obj_t BgL_bufferz00_820)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 106 */
{ /* Llib/mpg123_decoder.scm 111 */
bool_t BgL_haszd2beenzd2emptyzd2oncezd2_931;
BgL_haszd2beenzd2emptyzd2oncezd2_931 = ((bool_t)0); 
{ /* Llib/mpg123_decoder.scm 111 */
long BgL_inlenz00_932;
BgL_inlenz00_932 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52inlenz52); 
{ /* Llib/mpg123_decoder.scm 119 */
long BgL_outlenz00_933;
BgL_outlenz00_933 = 
STRING_LENGTH(
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818)))->BgL_outbufz00)); 
{ /* Llib/mpg123_decoder.scm 121 */
long BgL_decsza7za7_934;
{ /* Llib/mpg123_decoder.scm 121 */
long BgL_az00_935;
BgL_az00_935 = 
(((long)2)*BgL_outlenz00_933); 
if(
(BgL_az00_935<BgL_inlenz00_932))
{ /* Llib/mpg123_decoder.scm 121 */
BgL_decsza7za7_934 = BgL_az00_935; }  else 
{ /* Llib/mpg123_decoder.scm 121 */
BgL_decsza7za7_934 = BgL_inlenz00_932; } } 
{ 

{ 

{ 

{ 
long BgL_siza7eza7_955;
{ /* Llib/mpg123_decoder.scm 179 */
bool_t BgL_testz00_1401;
{ /* Llib/mpg123_decoder.scm 179 */
int BgL_arg1551z00_972;
BgL_arg1551z00_972 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_testz00_1401 = 
(
(long)(BgL_arg1551z00_972)>((long)0)); } 
if(BgL_testz00_1401)
{ /* Llib/mpg123_decoder.scm 179 */
BGl_debugzd2initz12zc0zz__mpg123_decoderz00(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_urlz00)); }  else 
{ /* Llib/mpg123_decoder.scm 179 */BFALSE; } } 
if(
(
(long)(
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818)))->BgL_z52ratez52))>((long)0)))
{ /* Llib/mpg123_decoder.scm 183 */
BGl_musicdecoderzd2hwparamszd2setz12z12zz__multimediazd2musicbufzd2(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818)), 
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_819)), 
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)); }  else 
{ /* Llib/mpg123_decoder.scm 183 */BFALSE; } 
{ 

BgL_loopz00_973:
if(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818))))->BgL_z52z12dpausez40))
{ /* Llib/mpg123_decoder.scm 188 */
{ /* Llib/mpg123_decoder.scm 190 */
BgL_musicstatusz00_bglt BgL_i1107z00_974;
BgL_i1107z00_974 = 
(((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_819))))->BgL_z52statusz52); 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1107z00_974))->BgL_songposz00)=((obj_t)
BINT(
BGl_musicdecoderzd2positionzd2zz__multimediazd2musicbufzd2(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818)), 
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))),BUNSPEC); } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_819)), 
CNST_TABLE_REF(((long)15))); 
{ /* Llib/mpg123_decoder.scm 193 */
obj_t BgL_mutex1569z00_975;
BgL_mutex1569z00_975 = 
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818))))->BgL_z52dmutexz52); 
BGL_MUTEX_LOCK(BgL_mutex1569z00_975); 
{ /* Llib/mpg123_decoder.scm 193 */
bool_t BgL_tmp2125z00_1439;
{ 

BgL_liipz00_976:
if(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818))))->BgL_z52z12dpausez40))
{ /* Llib/mpg123_decoder.scm 195 */
{ /* Llib/mpg123_decoder.scm 196 */
obj_t BgL_arg1581z00_977;obj_t BgL_arg1583z00_978;
BgL_arg1581z00_977 = 
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818))))->BgL_z52dcondvz52); 
BgL_arg1583z00_978 = 
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818))))->BgL_z52dmutexz52); 
{ /* Llib/mpg123_decoder.scm 196 */

{ /* Llib/mpg123_decoder.scm 196 */
bool_t BgL_res1929z00_979;
BgL_res1929z00_979 = 
BGL_CONDVAR_WAIT(BgL_arg1581z00_977, BgL_arg1583z00_978); BgL_res1929z00_979; } } } 
goto BgL_liipz00_976;}  else 
{ /* Llib/mpg123_decoder.scm 195 */
BgL_tmp2125z00_1439 = ((bool_t)0); } } 
BGL_MUTEX_UNLOCK(BgL_mutex1569z00_975); BgL_tmp2125z00_1439; } } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_819)), 
CNST_TABLE_REF(((long)16))); 
goto BgL_loopz00_973;}  else 
{ /* Llib/mpg123_decoder.scm 188 */
if(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818))))->BgL_z52z12dabortz40))
{ /* Llib/mpg123_decoder.scm 200 */
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_819)), 
CNST_TABLE_REF(((long)17))); }  else 
{ /* Llib/mpg123_decoder.scm 200 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52emptyz52))
{ /* Llib/mpg123_decoder.scm 203 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52eofz52))
{ /* Llib/mpg123_decoder.scm 205 */
{ /* Llib/mpg123_decoder.scm 207 */
bool_t BgL_testz00_1471;
{ /* Llib/mpg123_decoder.scm 207 */
int BgL_arg1615z00_980;
BgL_arg1615z00_980 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_testz00_1471 = 
(
(long)(BgL_arg1615z00_980)>=((long)2)); } 
if(BgL_testz00_1471)
{ /* Llib/mpg123_decoder.scm 208 */
obj_t BgL_arg1606z00_981;
BgL_arg1606z00_981 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_urlz00); 
{ /* Llib/mpg123_decoder.scm 208 */
obj_t BgL_list1607z00_982;
{ /* Llib/mpg123_decoder.scm 208 */
obj_t BgL_arg1612z00_983;
{ /* Llib/mpg123_decoder.scm 208 */
obj_t BgL_arg1614z00_984;
BgL_arg1614z00_984 = 
MAKE_YOUNG_PAIR(BGl_string1978z00zz__mpg123_decoderz00, BNIL); 
BgL_arg1612z00_983 = 
MAKE_YOUNG_PAIR(BgL_arg1606z00_981, BgL_arg1614z00_984); } 
BgL_list1607z00_982 = 
MAKE_YOUNG_PAIR(BGl_string2030z00zz__mpg123_decoderz00, BgL_arg1612z00_983); } 
BGl_debugz00zz__mpg123_decoderz00(BgL_list1607z00_982); } }  else 
{ /* Llib/mpg123_decoder.scm 207 */BFALSE; } } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_819)), 
CNST_TABLE_REF(((long)18))); }  else 
{ /* Llib/mpg123_decoder.scm 205 */
{ /* Llib/mpg123_decoder.scm 211 */
bool_t BgL_testz00_1485;
{ /* Llib/mpg123_decoder.scm 211 */
int BgL_arg1658z00_985;
BgL_arg1658z00_985 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_testz00_1485 = 
(
(long)(BgL_arg1658z00_985)>=((long)1)); } 
if(BgL_testz00_1485)
{ /* Llib/mpg123_decoder.scm 212 */
obj_t BgL_arg1641z00_986;BGL_LONGLONG_T BgL_arg1644z00_987;
BgL_arg1641z00_986 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_urlz00); 
BgL_arg1644z00_987 = 
bgl_current_microseconds(); 
{ /* Llib/mpg123_decoder.scm 212 */
obj_t BgL_list1645z00_988;
{ /* Llib/mpg123_decoder.scm 212 */
obj_t BgL_arg1648z00_989;
{ /* Llib/mpg123_decoder.scm 212 */
obj_t BgL_arg1649z00_990;
{ /* Llib/mpg123_decoder.scm 212 */
obj_t BgL_arg1652z00_991;
{ /* Llib/mpg123_decoder.scm 212 */
obj_t BgL_arg1657z00_992;
BgL_arg1657z00_992 = 
MAKE_YOUNG_PAIR(BGl_string2028z00zz__mpg123_decoderz00, BNIL); 
BgL_arg1652z00_991 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1644z00_987), BgL_arg1657z00_992); } 
BgL_arg1649z00_990 = 
MAKE_YOUNG_PAIR(BGl_string1979z00zz__mpg123_decoderz00, BgL_arg1652z00_991); } 
BgL_arg1648z00_989 = 
MAKE_YOUNG_PAIR(BgL_arg1641z00_986, BgL_arg1649z00_990); } 
BgL_list1645z00_988 = 
MAKE_YOUNG_PAIR(BGl_string2031z00zz__mpg123_decoderz00, BgL_arg1648z00_989); } 
BGl_debugz00zz__mpg123_decoderz00(BgL_list1645z00_988); } }  else 
{ /* Llib/mpg123_decoder.scm 211 */BFALSE; } } 
{ /* Llib/mpg123_decoder.scm 215 */
BgL_musicstatusz00_bglt BgL_i1109z00_993;
BgL_i1109z00_993 = 
(((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_819))))->BgL_z52statusz52); 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1109z00_993))->BgL_bufferingz00)=((int)
(int)(
BGl_bufferzd2percentagezd2filledze70ze7zz__mpg123_decoderz00(BgL_inlenz00_932, 
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))),BUNSPEC); } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_819)), 
CNST_TABLE_REF(((long)19))); 
{ /* Llib/mpg123_decoder.scm 219 */
obj_t BgL_mutex1659z00_994;
BgL_mutex1659z00_994 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52bmutexz52); 
{ /* Llib/mpg123_decoder.scm 219 */
obj_t BgL_top2127z00_1513;
BgL_top2127z00_1513 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mutex1659z00_994); 
BGL_EXITD_PUSH_PROTECT(BgL_top2127z00_1513, BgL_mutex1659z00_994); BUNSPEC; 
{ /* Llib/mpg123_decoder.scm 219 */
bool_t BgL_tmp2126z00_1512;
{ /* Llib/mpg123_decoder.scm 221 */
bool_t BgL_testz00_1517;
if(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52emptyz52))
{ /* Llib/mpg123_decoder.scm 221 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52eofz52))
{ /* Llib/mpg123_decoder.scm 221 */
BgL_testz00_1517 = ((bool_t)1)
; }  else 
{ /* Llib/mpg123_decoder.scm 221 */
if(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818))))->BgL_z52z12dabortz40))
{ /* Llib/mpg123_decoder.scm 221 */
BgL_testz00_1517 = ((bool_t)1)
; }  else 
{ /* Llib/mpg123_decoder.scm 221 */
BgL_testz00_1517 = 
(
(((long)8)*
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))>BgL_inlenz00_932)
; } } }  else 
{ /* Llib/mpg123_decoder.scm 221 */
BgL_testz00_1517 = ((bool_t)1)
; } 
if(BgL_testz00_1517)
{ /* Llib/mpg123_decoder.scm 221 */
BgL_tmp2126z00_1512 = ((bool_t)0); }  else 
{ /* Llib/mpg123_decoder.scm 225 */
obj_t BgL_arg1664z00_995;obj_t BgL_arg1665z00_996;
BgL_arg1664z00_995 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52bcondvz52); 
BgL_arg1665z00_996 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52bmutexz52); 
{ /* Llib/mpg123_decoder.scm 225 */

{ /* Llib/mpg123_decoder.scm 225 */
bool_t BgL_res1936z00_997;
BgL_res1936z00_997 = 
BGL_CONDVAR_WAIT(BgL_arg1664z00_995, BgL_arg1665z00_996); 
BgL_tmp2126z00_1512 = BgL_res1936z00_997; } } } } 
BGL_EXITD_POP_PROTECT(BgL_top2127z00_1513); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mutex1659z00_994); BgL_tmp2126z00_1512; } } } 
{ /* Llib/mpg123_decoder.scm 226 */
bool_t BgL_testz00_1539;
{ /* Llib/mpg123_decoder.scm 226 */
int BgL_arg1675z00_998;
BgL_arg1675z00_998 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_testz00_1539 = 
(
(long)(BgL_arg1675z00_998)>=((long)1)); } 
if(BgL_testz00_1539)
{ /* Llib/mpg123_decoder.scm 227 */
BGL_LONGLONG_T BgL_arg1669z00_999;
BgL_arg1669z00_999 = 
bgl_current_microseconds(); 
{ /* Llib/mpg123_decoder.scm 227 */
obj_t BgL_list1670z00_1000;
{ /* Llib/mpg123_decoder.scm 227 */
obj_t BgL_arg1672z00_1001;
BgL_arg1672z00_1001 = 
MAKE_YOUNG_PAIR(BGl_string1978z00zz__mpg123_decoderz00, BNIL); 
BgL_list1670z00_1000 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1669z00_999), BgL_arg1672z00_1001); } 
BGl_debugz00zz__mpg123_decoderz00(BgL_list1670z00_1000); } }  else 
{ /* Llib/mpg123_decoder.scm 226 */BFALSE; } } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_819)), 
CNST_TABLE_REF(((long)16))); 
goto BgL_loopz00_973;} }  else 
{ /* Llib/mpg123_decoder.scm 232 */
long BgL_g1112z00_1002;
{ /* Llib/mpg123_decoder.scm 232 */
long BgL_bz00_1003;
if(
(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52headz52)>
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52tailz52)))
{ /* Llib/mpg123_decoder.scm 233 */
BgL_bz00_1003 = 
(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52headz52)-
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52tailz52)); }  else 
{ /* Llib/mpg123_decoder.scm 233 */
BgL_bz00_1003 = 
(BgL_inlenz00_932-
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52tailz52)); } 
if(
(BgL_decsza7za7_934<BgL_bz00_1003))
{ /* Llib/mpg123_decoder.scm 233 */
BgL_g1112z00_1002 = BgL_decsza7za7_934; }  else 
{ /* Llib/mpg123_decoder.scm 233 */
BgL_g1112z00_1002 = BgL_bz00_1003; } } 
{ 
long BgL_sz00_1005;
BgL_sz00_1005 = BgL_g1112z00_1002; 
BgL_flushz00_1004:
{ /* Llib/mpg123_decoder.scm 236 */
int BgL_statusz00_1006;
{ /* Llib/mpg123_decoder.scm 236 */
obj_t BgL_arg1797z00_1007;char * BgL_arg1798z00_1008;long BgL_arg1799z00_1009;obj_t BgL_arg1800z00_1010;
BgL_arg1797z00_1007 = 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818)))->BgL_z52mpg123z52); 
BgL_arg1798z00_1008 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52inbufpz52); 
BgL_arg1799z00_1009 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52tailz52); 
BgL_arg1800z00_1010 = 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818)))->BgL_outbufz00); 
BgL_statusz00_1006 = 
bgl_mpg123_decode(BgL_arg1797z00_1007, BgL_arg1798z00_1008, BgL_arg1799z00_1009, BgL_sz00_1005, 
BSTRING_TO_STRING(BgL_arg1800z00_1010), BgL_outlenz00_933); } 
{ /* Llib/mpg123_decoder.scm 238 */
bool_t BgL_testz00_1578;
{ /* Llib/mpg123_decoder.scm 238 */
int BgL_arg1698z00_1011;
BgL_arg1698z00_1011 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_testz00_1578 = 
(
(long)(BgL_arg1698z00_1011)>=((long)4)); } 
if(BgL_testz00_1578)
{ /* Llib/mpg123_decoder.scm 239 */
long BgL_arg1680z00_1012;long BgL_arg1681z00_1013;obj_t BgL_arg1682z00_1014;
BgL_arg1680z00_1012 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52tailz52); 
BgL_arg1681z00_1013 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52headz52); 
BgL_arg1682z00_1014 = 
BGl_mpg123zd2decodezd2statuszd2ze3symbolz31zz__mpg123_mpg123z00(BgL_statusz00_1006); 
{ /* Llib/mpg123_decoder.scm 239 */
obj_t BgL_list1683z00_1015;
{ /* Llib/mpg123_decoder.scm 239 */
obj_t BgL_arg1689z00_1016;
{ /* Llib/mpg123_decoder.scm 239 */
obj_t BgL_arg1690z00_1017;
{ /* Llib/mpg123_decoder.scm 239 */
obj_t BgL_arg1691z00_1018;
{ /* Llib/mpg123_decoder.scm 239 */
obj_t BgL_arg1692z00_1019;
{ /* Llib/mpg123_decoder.scm 239 */
obj_t BgL_arg1693z00_1020;
{ /* Llib/mpg123_decoder.scm 239 */
obj_t BgL_arg1694z00_1021;
{ /* Llib/mpg123_decoder.scm 239 */
obj_t BgL_arg1696z00_1022;
{ /* Llib/mpg123_decoder.scm 239 */
obj_t BgL_arg1697z00_1023;
BgL_arg1697z00_1023 = 
MAKE_YOUNG_PAIR(BGl_string1978z00zz__mpg123_decoderz00, BNIL); 
BgL_arg1696z00_1022 = 
MAKE_YOUNG_PAIR(BgL_arg1682z00_1014, BgL_arg1697z00_1023); } 
BgL_arg1694z00_1021 = 
MAKE_YOUNG_PAIR(BGl_string2032z00zz__mpg123_decoderz00, BgL_arg1696z00_1022); } 
BgL_arg1693z00_1020 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1681z00_1013), BgL_arg1694z00_1021); } 
BgL_arg1692z00_1019 = 
MAKE_YOUNG_PAIR(BGl_string2033z00zz__mpg123_decoderz00, BgL_arg1693z00_1020); } 
BgL_arg1691z00_1018 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1680z00_1012), BgL_arg1692z00_1019); } 
BgL_arg1690z00_1017 = 
MAKE_YOUNG_PAIR(BGl_string2034z00zz__mpg123_decoderz00, BgL_arg1691z00_1018); } 
BgL_arg1689z00_1016 = 
MAKE_YOUNG_PAIR(
BINT(BgL_sz00_1005), BgL_arg1690z00_1017); } 
BgL_list1683z00_1015 = 
MAKE_YOUNG_PAIR(BGl_string2035z00zz__mpg123_decoderz00, BgL_arg1689z00_1016); } 
BGl_debugz00zz__mpg123_decoderz00(BgL_list1683z00_1015); } }  else 
{ /* Llib/mpg123_decoder.scm 238 */BFALSE; } } 
if(
(BgL_sz00_1005>((long)0)))
{ /* Llib/mpg123_decoder.scm 244 */
BgL_siza7eza7_955 = BgL_sz00_1005; 
{ /* Llib/mpg123_decoder.scm 159 */
long BgL_ntailz00_956;
BgL_ntailz00_956 = 
(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52tailz52)+BgL_siza7eza7_955); 
if(
(BgL_ntailz00_956==BgL_inlenz00_932))
{ /* Llib/mpg123_decoder.scm 160 */
BgL_ntailz00_956 = ((long)0); }  else 
{ /* Llib/mpg123_decoder.scm 160 */BFALSE; } 
if(
(BgL_ntailz00_956==
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52headz52)))
{ /* Llib/mpg123_decoder.scm 163 */
BgL_haszd2beenzd2emptyzd2oncezd2_931 = ((bool_t)1); 
((((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52emptyz52)=((bool_t)((bool_t)1)),BUNSPEC); }  else 
{ /* Llib/mpg123_decoder.scm 163 */BFALSE; } 
((((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52tailz52)=((long)BgL_ntailz00_956),BUNSPEC); } 
{ /* Llib/mpg123_decoder.scm 142 */
bool_t BgL_testz00_1615;
{ /* Llib/mpg123_decoder.scm 142 */
int BgL_arg1868z00_940;
BgL_arg1868z00_940 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_testz00_1615 = 
(
(long)(BgL_arg1868z00_940)>=((long)3)); } 
if(BgL_testz00_1615)
{ /* Llib/mpg123_decoder.scm 143 */
long BgL_pz00_941;
BgL_pz00_941 = 
BGl_bufferzd2percentagezd2filledze70ze7zz__mpg123_decoderz00(BgL_inlenz00_932, 
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)); 
{ /* Llib/mpg123_decoder.scm 144 */
bool_t BgL_testz00_1621;
{ /* Llib/mpg123_decoder.scm 144 */
bool_t BgL_testz00_1622;
{ /* Llib/mpg123_decoder.scm 144 */
bool_t BgL_testz00_1623;
if(
(BgL_pz00_941<((long)75)))
{ /* Llib/mpg123_decoder.scm 144 */
BgL_testz00_1623 = ((bool_t)1)
; }  else 
{ /* Llib/mpg123_decoder.scm 144 */
BgL_testz00_1623 = BgL_haszd2beenzd2emptyzd2oncezd2_931
; } 
if(BgL_testz00_1623)
{ /* Llib/mpg123_decoder.scm 144 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52eofz52))
{ /* Llib/mpg123_decoder.scm 145 */
BgL_testz00_1622 = ((bool_t)0)
; }  else 
{ /* Llib/mpg123_decoder.scm 145 */
BgL_testz00_1622 = ((bool_t)1)
; } }  else 
{ /* Llib/mpg123_decoder.scm 144 */
BgL_testz00_1622 = ((bool_t)0)
; } } 
if(BgL_testz00_1622)
{ /* Llib/mpg123_decoder.scm 144 */
BgL_testz00_1621 = ((bool_t)1)
; }  else 
{ /* Llib/mpg123_decoder.scm 146 */
int BgL_arg1867z00_942;
BgL_arg1867z00_942 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_testz00_1621 = 
(
(long)(BgL_arg1867z00_942)>=((long)4)); } } 
if(BgL_testz00_1621)
{ /* Llib/mpg123_decoder.scm 149 */
obj_t BgL_arg1851z00_943;obj_t BgL_arg1852z00_944;obj_t BgL_arg1853z00_945;
if(
(BgL_pz00_941>=((long)80)))
{ /* Llib/mpg123_decoder.scm 149 */
BgL_arg1851z00_943 = BGl_string2003z00zz__mpg123_decoderz00; }  else 
{ /* Llib/mpg123_decoder.scm 149 */
if(
(BgL_pz00_941>((long)25)))
{ /* Llib/mpg123_decoder.scm 150 */
BgL_arg1851z00_943 = BGl_string2022z00zz__mpg123_decoderz00; }  else 
{ /* Llib/mpg123_decoder.scm 150 */
BgL_arg1851z00_943 = BGl_string2023z00zz__mpg123_decoderz00; } } 
if(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52eofz52))
{ /* Llib/mpg123_decoder.scm 154 */
BgL_arg1852z00_944 = BGl_string2024z00zz__mpg123_decoderz00; }  else 
{ /* Llib/mpg123_decoder.scm 154 */
BgL_arg1852z00_944 = BGl_string2003z00zz__mpg123_decoderz00; } 
BgL_arg1853z00_945 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_urlz00); 
{ /* Llib/mpg123_decoder.scm 147 */
obj_t BgL_list1854z00_946;
{ /* Llib/mpg123_decoder.scm 147 */
obj_t BgL_arg1855z00_947;
{ /* Llib/mpg123_decoder.scm 147 */
obj_t BgL_arg1856z00_948;
{ /* Llib/mpg123_decoder.scm 147 */
obj_t BgL_arg1857z00_949;
{ /* Llib/mpg123_decoder.scm 147 */
obj_t BgL_arg1858z00_950;
{ /* Llib/mpg123_decoder.scm 147 */
obj_t BgL_arg1859z00_951;
{ /* Llib/mpg123_decoder.scm 147 */
obj_t BgL_arg1860z00_952;
{ /* Llib/mpg123_decoder.scm 147 */
obj_t BgL_arg1861z00_953;
BgL_arg1861z00_953 = 
MAKE_YOUNG_PAIR(BGl_string1978z00zz__mpg123_decoderz00, BNIL); 
BgL_arg1860z00_952 = 
MAKE_YOUNG_PAIR(BgL_arg1853z00_945, BgL_arg1861z00_953); } 
BgL_arg1859z00_951 = 
MAKE_YOUNG_PAIR(BGl_string2025z00zz__mpg123_decoderz00, BgL_arg1860z00_952); } 
BgL_arg1858z00_950 = 
MAKE_YOUNG_PAIR(BgL_arg1852z00_944, BgL_arg1859z00_951); } 
BgL_arg1857z00_949 = 
MAKE_YOUNG_PAIR(BGl_string2026z00zz__mpg123_decoderz00, BgL_arg1858z00_950); } 
BgL_arg1856z00_948 = 
MAKE_YOUNG_PAIR(
BINT(BgL_pz00_941), BgL_arg1857z00_949); } 
BgL_arg1855z00_947 = 
MAKE_YOUNG_PAIR(BgL_arg1851z00_943, BgL_arg1856z00_948); } 
BgL_list1854z00_946 = 
MAKE_YOUNG_PAIR(BGl_string2027z00zz__mpg123_decoderz00, BgL_arg1855z00_947); } 
BGl_debugz00zz__mpg123_decoderz00(BgL_list1854z00_946); } }  else 
{ /* Llib/mpg123_decoder.scm 144 */BFALSE; } } }  else 
{ /* Llib/mpg123_decoder.scm 142 */BFALSE; } } 
{ /* Llib/mpg123_decoder.scm 170 */
bool_t BgL_testz00_1651;
{ /* Llib/mpg123_decoder.scm 170 */
bool_t BgL_testz00_1652;
{ /* Llib/mpg123_decoder.scm 137 */
bool_t BgL__ortest_1105z00_938;
BgL__ortest_1105z00_938 = BgL_haszd2beenzd2emptyzd2oncezd2_931; 
if(BgL__ortest_1105z00_938)
{ /* Llib/mpg123_decoder.scm 137 */
BgL_testz00_1652 = BgL__ortest_1105z00_938
; }  else 
{ /* Llib/mpg123_decoder.scm 137 */
BgL_testz00_1652 = 
(
(((long)4)*
(BgL_inlenz00_932-
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820))))>BgL_inlenz00_932)
; } } 
if(BgL_testz00_1652)
{ /* Llib/mpg123_decoder.scm 170 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52eofz52))
{ /* Llib/mpg123_decoder.scm 170 */
BgL_testz00_1651 = ((bool_t)0)
; }  else 
{ /* Llib/mpg123_decoder.scm 170 */
BgL_testz00_1651 = ((bool_t)1)
; } }  else 
{ /* Llib/mpg123_decoder.scm 170 */
BgL_testz00_1651 = ((bool_t)0)
; } } 
if(BgL_testz00_1651)
{ /* Llib/mpg123_decoder.scm 170 */
{ /* Llib/mpg123_decoder.scm 171 */
bool_t BgL_testz00_1662;
{ /* Llib/mpg123_decoder.scm 171 */
int BgL_arg1832z00_957;
BgL_arg1832z00_957 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_testz00_1662 = 
(
(long)(BgL_arg1832z00_957)>=((long)2)); } 
if(BgL_testz00_1662)
{ /* Llib/mpg123_decoder.scm 172 */
obj_t BgL_arg1825z00_958;BGL_LONGLONG_T BgL_arg1826z00_959;
BgL_arg1825z00_958 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_urlz00); 
BgL_arg1826z00_959 = 
bgl_current_microseconds(); 
{ /* Llib/mpg123_decoder.scm 172 */
obj_t BgL_list1827z00_960;
{ /* Llib/mpg123_decoder.scm 172 */
obj_t BgL_arg1828z00_961;
{ /* Llib/mpg123_decoder.scm 172 */
obj_t BgL_arg1829z00_962;
{ /* Llib/mpg123_decoder.scm 172 */
obj_t BgL_arg1830z00_963;
{ /* Llib/mpg123_decoder.scm 172 */
obj_t BgL_arg1831z00_964;
BgL_arg1831z00_964 = 
MAKE_YOUNG_PAIR(BGl_string2028z00zz__mpg123_decoderz00, BNIL); 
BgL_arg1830z00_963 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1826z00_959), BgL_arg1831z00_964); } 
BgL_arg1829z00_962 = 
MAKE_YOUNG_PAIR(BGl_string1979z00zz__mpg123_decoderz00, BgL_arg1830z00_963); } 
BgL_arg1828z00_961 = 
MAKE_YOUNG_PAIR(BgL_arg1825z00_958, BgL_arg1829z00_962); } 
BgL_list1827z00_960 = 
MAKE_YOUNG_PAIR(BGl_string2029z00zz__mpg123_decoderz00, BgL_arg1828z00_961); } 
BGl_debugz00zz__mpg123_decoderz00(BgL_list1827z00_960); } }  else 
{ /* Llib/mpg123_decoder.scm 171 */BFALSE; } } 
{ /* Llib/mpg123_decoder.scm 174 */
obj_t BgL_mutex1833z00_965;
BgL_mutex1833z00_965 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52bmutexz52); 
BGL_MUTEX_LOCK(BgL_mutex1833z00_965); 
{ /* Llib/mpg123_decoder.scm 174 */
bool_t BgL_tmp2128z00_1678;
{ /* Llib/mpg123_decoder.scm 175 */
obj_t BgL_arg1834z00_966;
BgL_arg1834z00_966 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52bcondvz52); 
{ /* Llib/mpg123_decoder.scm 175 */
bool_t BgL_res1923z00_967;
BgL_res1923z00_967 = 
BGL_CONDVAR_BROADCAST(BgL_arg1834z00_966); 
BgL_tmp2128z00_1678 = BgL_res1923z00_967; } } 
BGL_MUTEX_UNLOCK(BgL_mutex1833z00_965); BgL_tmp2128z00_1678; } } 
{ /* Llib/mpg123_decoder.scm 176 */
bool_t BgL_testz00_1684;
{ /* Llib/mpg123_decoder.scm 176 */
int BgL_arg1840z00_968;
BgL_arg1840z00_968 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_testz00_1684 = 
(
(long)(BgL_arg1840z00_968)>=((long)2)); } 
if(BgL_testz00_1684)
{ /* Llib/mpg123_decoder.scm 177 */
BGL_LONGLONG_T BgL_arg1837z00_969;
BgL_arg1837z00_969 = 
bgl_current_microseconds(); 
{ /* Llib/mpg123_decoder.scm 177 */
obj_t BgL_list1838z00_970;
{ /* Llib/mpg123_decoder.scm 177 */
obj_t BgL_arg1839z00_971;
BgL_arg1839z00_971 = 
MAKE_YOUNG_PAIR(BGl_string1978z00zz__mpg123_decoderz00, BNIL); 
BgL_list1838z00_970 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1837z00_969), BgL_arg1839z00_971); } 
BGl_debugz00zz__mpg123_decoderz00(BgL_list1838z00_970); } }  else 
{ /* Llib/mpg123_decoder.scm 176 */BFALSE; } } }  else 
{ /* Llib/mpg123_decoder.scm 170 */BFALSE; } } }  else 
{ /* Llib/mpg123_decoder.scm 244 */BFALSE; } 
if(
(
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818)))->BgL_z52z12dseekz40)>((long)0)))
{ /* Llib/mpg123_decoder.scm 248 */
long BgL_offsetz00_1024;
{ /* Llib/mpg123_decoder.scm 248 */
obj_t BgL_arg1738z00_1025;long BgL_arg1740z00_1026;
BgL_arg1738z00_1025 = 
BGl_musicbufferzd2streamzd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)); 
BgL_arg1740z00_1026 = 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818)))->BgL_z52z12dseekz40); 
BgL_offsetz00_1024 = 
BGl_mp3zd2indexzd2zz__multimediazd2mp3zd2(BgL_arg1738z00_1025, 
(long)(BgL_arg1740z00_1026)); } 
{ /* Llib/mpg123_decoder.scm 249 */
obj_t BgL_arg1708z00_1027;
{ /* Llib/mpg123_decoder.scm 249 */
obj_t BgL_res1946z00_1028;
{ /* Llib/mpg123_decoder.scm 249 */
obj_t BgL_tmpz00_1703;
BgL_tmpz00_1703 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_res1946z00_1028 = 
BGL_ENV_CURRENT_ERROR_PORT(BgL_tmpz00_1703); } 
BgL_arg1708z00_1027 = BgL_res1946z00_1028; } 
{ /* Llib/mpg123_decoder.scm 249 */
obj_t BgL_list1709z00_1029;
{ /* Llib/mpg123_decoder.scm 249 */
obj_t BgL_arg1712z00_1030;
{ /* Llib/mpg123_decoder.scm 249 */
obj_t BgL_arg1715z00_1031;
{ /* Llib/mpg123_decoder.scm 249 */
obj_t BgL_arg1716z00_1032;
{ /* Llib/mpg123_decoder.scm 249 */
obj_t BgL_arg1719z00_1033;
{ /* Llib/mpg123_decoder.scm 249 */
obj_t BgL_arg1725z00_1034;
BgL_arg1725z00_1034 = 
MAKE_YOUNG_PAIR(
make_belong(BgL_offsetz00_1024), BNIL); 
BgL_arg1719z00_1033 = 
MAKE_YOUNG_PAIR(BGl_string2036z00zz__mpg123_decoderz00, BgL_arg1725z00_1034); } 
BgL_arg1716z00_1032 = 
MAKE_YOUNG_PAIR(BGl_string2037z00zz__mpg123_decoderz00, BgL_arg1719z00_1033); } 
BgL_arg1715z00_1031 = 
MAKE_YOUNG_PAIR(
BINT(((long)249)), BgL_arg1716z00_1032); } 
BgL_arg1712z00_1030 = 
MAKE_YOUNG_PAIR(BGl_string2038z00zz__mpg123_decoderz00, BgL_arg1715z00_1031); } 
BgL_list1709z00_1029 = 
MAKE_YOUNG_PAIR(BGl_string1976z00zz__mpg123_decoderz00, BgL_arg1712z00_1030); } 
BGl_tprintz00zz__r4_output_6_10_3z00(BgL_arg1708z00_1027, BgL_list1709z00_1029); } } 
BGl_musicbufferzd2seekzd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820), 
make_belong(BgL_offsetz00_1024)); 
{ /* Llib/mpg123_decoder.scm 251 */
obj_t BgL_arg1737z00_1035;
BgL_arg1737z00_1035 = 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818)))->BgL_z52mpg123z52); 
BGl_mpg123zd2handlezd2resetz12z12zz__mpg123_mpg123z00(
((BgL_mpg123zd2handlezd2_bglt)BgL_arg1737z00_1035)); } 
{ /* Llib/mpg123_decoder.scm 252 */
BgL_musicstatusz00_bglt BgL_i1113z00_1036;
BgL_i1113z00_1036 = 
(((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_819))))->BgL_z52statusz52); 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1113z00_1036))->BgL_songposz00)=((obj_t)
BINT(
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818)))->BgL_z52z12dseekz40))),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818)))->BgL_z52z12dseekz40)=((long)((long)-1)),BUNSPEC); } 
goto BgL_loopz00_973;}  else 
{ /* Llib/mpg123_decoder.scm 247 */
if(
(
(long)(BgL_statusz00_1006)==
(long)(MPG123_OK)))
{ /* Llib/mpg123_decoder.scm 258 */
BgL_mpg123zd2handlezd2_bglt BgL_i1114z00_1037;
BgL_i1114z00_1037 = 
((BgL_mpg123zd2handlezd2_bglt)
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818)))->BgL_z52mpg123z52)); 
{ /* Llib/mpg123_decoder.scm 259 */
bool_t BgL_testz00_1738;
{ /* Llib/mpg123_decoder.scm 259 */
int BgL_arg1757z00_1038;
BgL_arg1757z00_1038 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_testz00_1738 = 
(
(long)(BgL_arg1757z00_1038)>=((long)5)); } 
if(BgL_testz00_1738)
{ /* Llib/mpg123_decoder.scm 260 */
long BgL_arg1751z00_1039;
BgL_arg1751z00_1039 = 
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_i1114z00_1037))->BgL_siza7eza7); 
{ /* Llib/mpg123_decoder.scm 260 */
obj_t BgL_list1752z00_1040;
{ /* Llib/mpg123_decoder.scm 260 */
obj_t BgL_arg1753z00_1041;
{ /* Llib/mpg123_decoder.scm 260 */
obj_t BgL_arg1754z00_1042;
{ /* Llib/mpg123_decoder.scm 260 */
obj_t BgL_arg1755z00_1043;
{ /* Llib/mpg123_decoder.scm 260 */
obj_t BgL_arg1756z00_1044;
BgL_arg1756z00_1044 = 
MAKE_YOUNG_PAIR(BGl_string1978z00zz__mpg123_decoderz00, BNIL); 
BgL_arg1755z00_1043 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1751z00_1039), BgL_arg1756z00_1044); } 
BgL_arg1754z00_1042 = 
MAKE_YOUNG_PAIR(BGl_string2039z00zz__mpg123_decoderz00, BgL_arg1755z00_1043); } 
BgL_arg1753z00_1041 = 
MAKE_YOUNG_PAIR(
BINT(BgL_sz00_1005), BgL_arg1754z00_1042); } 
BgL_list1752z00_1040 = 
MAKE_YOUNG_PAIR(BGl_string2040z00zz__mpg123_decoderz00, BgL_arg1753z00_1041); } 
BGl_debugz00zz__mpg123_decoderz00(BgL_list1752z00_1040); } }  else 
{ /* Llib/mpg123_decoder.scm 259 */BFALSE; } } 
if(
(
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_i1114z00_1037))->BgL_siza7eza7)>((long)0)))
{ /* Llib/mpg123_decoder.scm 262 */
BGl_musicbufzd2writezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufz00_bglt)BgL_amz00_819), 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818)))->BgL_outbufz00), 
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_i1114z00_1037))->BgL_siza7eza7)); 
{ 
long BgL_sz00_1759;
BgL_sz00_1759 = ((long)0); 
BgL_sz00_1005 = BgL_sz00_1759; 
goto BgL_flushz00_1004;} }  else 
{ /* Llib/mpg123_decoder.scm 262 */BFALSE; } }  else 
{ /* Llib/mpg123_decoder.scm 256 */
if(
(
(long)(BgL_statusz00_1006)==
(long)(MPG123_NEED_MORE)))
{ /* Llib/mpg123_decoder.scm 266 */
{ /* Llib/mpg123_decoder.scm 268 */
BgL_mpg123zd2handlezd2_bglt BgL_i1115z00_1045;
BgL_i1115z00_1045 = 
((BgL_mpg123zd2handlezd2_bglt)
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818)))->BgL_z52mpg123z52)); 
{ /* Llib/mpg123_decoder.scm 269 */
bool_t BgL_testz00_1767;
{ /* Llib/mpg123_decoder.scm 269 */
int BgL_arg1778z00_1046;
BgL_arg1778z00_1046 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_testz00_1767 = 
(
(long)(BgL_arg1778z00_1046)>=((long)5)); } 
if(BgL_testz00_1767)
{ /* Llib/mpg123_decoder.scm 270 */
long BgL_arg1766z00_1047;bool_t BgL_arg1767z00_1048;long BgL_arg1768z00_1049;
BgL_arg1766z00_1047 = 
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_i1115z00_1045))->BgL_siza7eza7); 
BgL_arg1767z00_1048 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52emptyz52); 
BgL_arg1768z00_1049 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_z52tailz52); 
{ /* Llib/mpg123_decoder.scm 270 */
obj_t BgL_list1769z00_1050;
{ /* Llib/mpg123_decoder.scm 270 */
obj_t BgL_arg1770z00_1051;
{ /* Llib/mpg123_decoder.scm 270 */
obj_t BgL_arg1771z00_1052;
{ /* Llib/mpg123_decoder.scm 270 */
obj_t BgL_arg1772z00_1053;
{ /* Llib/mpg123_decoder.scm 270 */
obj_t BgL_arg1773z00_1054;
{ /* Llib/mpg123_decoder.scm 270 */
obj_t BgL_arg1774z00_1055;
{ /* Llib/mpg123_decoder.scm 270 */
obj_t BgL_arg1775z00_1056;
{ /* Llib/mpg123_decoder.scm 270 */
obj_t BgL_arg1776z00_1057;
{ /* Llib/mpg123_decoder.scm 270 */
obj_t BgL_arg1777z00_1058;
BgL_arg1777z00_1058 = 
MAKE_YOUNG_PAIR(BGl_string1978z00zz__mpg123_decoderz00, BNIL); 
BgL_arg1776z00_1057 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1768z00_1049), BgL_arg1777z00_1058); } 
BgL_arg1775z00_1056 = 
MAKE_YOUNG_PAIR(BGl_string2041z00zz__mpg123_decoderz00, BgL_arg1776z00_1057); } 
BgL_arg1774z00_1055 = 
MAKE_YOUNG_PAIR(
BBOOL(BgL_arg1767z00_1048), BgL_arg1775z00_1056); } 
BgL_arg1773z00_1054 = 
MAKE_YOUNG_PAIR(BGl_string2042z00zz__mpg123_decoderz00, BgL_arg1774z00_1055); } 
BgL_arg1772z00_1053 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1766z00_1047), BgL_arg1773z00_1054); } 
BgL_arg1771z00_1052 = 
MAKE_YOUNG_PAIR(BGl_string2039z00zz__mpg123_decoderz00, BgL_arg1772z00_1053); } 
BgL_arg1770z00_1051 = 
MAKE_YOUNG_PAIR(
BINT(BgL_sz00_1005), BgL_arg1771z00_1052); } 
BgL_list1769z00_1050 = 
MAKE_YOUNG_PAIR(BGl_string2043z00zz__mpg123_decoderz00, BgL_arg1770z00_1051); } 
BGl_debugz00zz__mpg123_decoderz00(BgL_list1769z00_1050); } }  else 
{ /* Llib/mpg123_decoder.scm 269 */BFALSE; } } 
if(
(
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_i1115z00_1045))->BgL_siza7eza7)>((long)0)))
{ /* Llib/mpg123_decoder.scm 273 */
BGl_musicbufzd2writezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufz00_bglt)BgL_amz00_819), 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818)))->BgL_outbufz00), 
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_i1115z00_1045))->BgL_siza7eza7)); }  else 
{ /* Llib/mpg123_decoder.scm 273 */BFALSE; } } 
goto BgL_loopz00_973;}  else 
{ /* Llib/mpg123_decoder.scm 266 */
if(
(
(long)(BgL_statusz00_1006)==
(long)(MPG123_NEW_FORMAT)))
{ /* Llib/mpg123_decoder.scm 277 */
BGl_newzd2formatzd2zz__mpg123_decoderz00(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818), 
((BgL_musicbufz00_bglt)BgL_amz00_819), 
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)); 
{ /* Llib/mpg123_decoder.scm 280 */
BgL_mpg123zd2handlezd2_bglt BgL_i1116z00_1059;
BgL_i1116z00_1059 = 
((BgL_mpg123zd2handlezd2_bglt)
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818)))->BgL_z52mpg123z52)); 
if(
(
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_i1116z00_1059))->BgL_siza7eza7)>((long)0)))
{ /* Llib/mpg123_decoder.scm 281 */
BGl_musicbufzd2writezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufz00_bglt)BgL_amz00_819), 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818)))->BgL_outbufz00), 
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_i1116z00_1059))->BgL_siza7eza7)); }  else 
{ /* Llib/mpg123_decoder.scm 281 */BFALSE; } } 
{ 
long BgL_sz00_1817;
BgL_sz00_1817 = ((long)0); 
BgL_sz00_1005 = BgL_sz00_1817; 
goto BgL_flushz00_1004;} }  else 
{ /* Llib/mpg123_decoder.scm 277 */
if(
(
(long)(BgL_statusz00_1006)==
(long)(MPG123_DONE)))
{ /* Llib/mpg123_decoder.scm 285 */
{ /* Llib/mpg123_decoder.scm 287 */
BgL_mpg123zd2handlezd2_bglt BgL_i1117z00_1060;
BgL_i1117z00_1060 = 
((BgL_mpg123zd2handlezd2_bglt)
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818)))->BgL_z52mpg123z52)); 
if(
(
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_i1117z00_1060))->BgL_siza7eza7)>((long)0)))
{ /* Llib/mpg123_decoder.scm 288 */
BGl_musicbufzd2writezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufz00_bglt)BgL_amz00_819), 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_818)))->BgL_outbufz00), 
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_i1117z00_1060))->BgL_siza7eza7)); }  else 
{ /* Llib/mpg123_decoder.scm 288 */BFALSE; } } 
BGl_musicbufzd2drainzd2zz__multimediazd2musicbufzd2(
((BgL_musicbufz00_bglt)BgL_amz00_819)); 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_819)), 
CNST_TABLE_REF(((long)18))); }  else 
{ /* Llib/mpg123_decoder.scm 285 */
BGl_musiczd2errorzd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_819)), BGl_string2044z00zz__mpg123_decoderz00); } } } } } } } } } } } 
{ /* Llib/mpg123_decoder.scm 297 */
bool_t BgL_testz00_1842;
{ /* Llib/mpg123_decoder.scm 297 */
int BgL_arg1813z00_1061;
BgL_arg1813z00_1061 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_testz00_1842 = 
(
(long)(BgL_arg1813z00_1061)>((long)0)); } 
if(BgL_testz00_1842)
{ /* Llib/mpg123_decoder.scm 297 */
return 
BGl_debugzd2stopz12zc0zz__mpg123_decoderz00(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_820)))->BgL_urlz00));}  else 
{ /* Llib/mpg123_decoder.scm 297 */
return BFALSE;} } } } } } } } } } } 
BGL_FUNCTION_END;
}



/* buffer-percentage-filled~0 */
long BGl_bufferzd2percentagezd2filledze70ze7zz__mpg123_decoderz00(long BgL_inlenz00_864, BgL_musicbufferz00_bglt BgL_bufferz00_863)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 129 */
{ /* Llib/mpg123_decoder.scm 128 */
BGL_LONGLONG_T BgL_arg1877z00_524;
{ /* Llib/mpg123_decoder.scm 128 */
BGL_LONGLONG_T BgL_arg1878z00_525;BGL_LONGLONG_T BgL_arg1879z00_526;
{ /* Llib/mpg123_decoder.scm 128 */
BGL_LONGLONG_T BgL_arg1880z00_527;
{ /* Llib/mpg123_decoder.scm 128 */
long BgL_arg1881z00_528;
BgL_arg1881z00_528 = 
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(BgL_bufferz00_863); 
{ /* Llib/mpg123_decoder.scm 128 */
BGL_LONGLONG_T BgL_res1900z00_601;
BgL_res1900z00_601 = 
LONG_TO_LLONG(BgL_arg1881z00_528); 
BgL_arg1880z00_527 = BgL_res1900z00_601; } } 
BgL_arg1878z00_525 = 
(((BGL_LONGLONG_T)100)*BgL_arg1880z00_527); } 
{ /* Llib/mpg123_decoder.scm 129 */
BGL_LONGLONG_T BgL_res1902z00_606;
BgL_res1902z00_606 = 
LONG_TO_LLONG(BgL_inlenz00_864); 
BgL_arg1879z00_526 = BgL_res1902z00_606; } 
{ /* Llib/mpg123_decoder.scm 127 */
BGL_LONGLONG_T BgL_res1903z00_609;
BgL_res1903z00_609 = 
(BgL_arg1878z00_525/BgL_arg1879z00_526); 
BgL_arg1877z00_524 = BgL_res1903z00_609; } } 
{ /* Llib/mpg123_decoder.scm 126 */
long BgL_res1904z00_611;
BgL_res1904z00_611 = 
LLONG_TO_LONG(BgL_arg1877z00_524); 
return BgL_res1904z00_611;} } } 
BGL_FUNCTION_END;
}



/* &musicdecoder-volume-1144 */
obj_t BGl_z62musicdecoderzd2volumezd21144z62zz__mpg123_decoderz00(obj_t BgL_envz00_821, obj_t BgL_decz00_822, obj_t BgL_volz00_823)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 99 */
{ /* Llib/mpg123_decoder.scm 101 */
obj_t BgL_arg1534z00_1063;
BgL_arg1534z00_1063 = 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_822)))->BgL_z52mpg123z52); 
return 
BGl_mpg123zd2volumezd2setz12z12zz__mpg123_mpg123z00(
((BgL_mpg123zd2handlezd2_bglt)BgL_arg1534z00_1063), BgL_volz00_823);} } 
BGL_FUNCTION_END;
}



/* &musicdecoder-seek-mp1142 */
obj_t BGl_z62musicdecoderzd2seekzd2mp1142z62zz__mpg123_decoderz00(obj_t BgL_envz00_824, obj_t BgL_decz00_825, obj_t BgL_secz00_826)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 89 */
{ /* Llib/mpg123_decoder.scm 91 */
bool_t BgL_testz00_1859;
{ /* Llib/mpg123_decoder.scm 91 */
int BgL_arg1524z00_1065;
BgL_arg1524z00_1065 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_testz00_1859 = 
(
(long)(BgL_arg1524z00_1065)>=((long)2)); } 
if(BgL_testz00_1859)
{ /* Llib/mpg123_decoder.scm 92 */
obj_t BgL_list1512z00_1066;
{ /* Llib/mpg123_decoder.scm 92 */
obj_t BgL_arg1517z00_1067;
{ /* Llib/mpg123_decoder.scm 92 */
obj_t BgL_arg1523z00_1068;
BgL_arg1523z00_1068 = 
MAKE_YOUNG_PAIR(BGl_string1978z00zz__mpg123_decoderz00, BNIL); 
BgL_arg1517z00_1067 = 
MAKE_YOUNG_PAIR(BgL_secz00_826, BgL_arg1523z00_1068); } 
BgL_list1512z00_1066 = 
MAKE_YOUNG_PAIR(BGl_string2045z00zz__mpg123_decoderz00, BgL_arg1517z00_1067); } 
BGl_debugz00zz__mpg123_decoderz00(BgL_list1512z00_1066); }  else 
{ /* Llib/mpg123_decoder.scm 91 */BFALSE; } } 
if(
(
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_825)))->BgL_z52z12dseekz40)<((long)0)))
{ /* Llib/mpg123_decoder.scm 93 */
return 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_825)))->BgL_z52z12dseekz40)=((long)
(long)CINT(BgL_secz00_826)),BUNSPEC);}  else 
{ /* Llib/mpg123_decoder.scm 93 */
return BFALSE;} } 
BGL_FUNCTION_END;
}



/* &musicdecoder-info-mp1140 */
obj_t BGl_z62musicdecoderzd2infozd2mp1140z62zz__mpg123_decoderz00(obj_t BgL_envz00_827, obj_t BgL_decz00_828)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 82 */
{ /* Llib/mpg123_decoder.scm 83 */
long BgL_tmpz00_1874;
{ /* Llib/mpg123_decoder.scm 84 */
obj_t BgL_arg1499z00_1070;
BgL_arg1499z00_1070 = 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_828)))->BgL_z52mpg123z52); 
BgL_tmpz00_1874 = 
BGl_mpg123zd2infozd2zz__mpg123_mpg123z00(
((BgL_mpg123zd2handlezd2_bglt)BgL_arg1499z00_1070)); } 
return 
BINT(BgL_tmpz00_1874);} } 
BGL_FUNCTION_END;
}



/* &musicdecoder-positio1138 */
obj_t BGl_z62musicdecoderzd2positio1138zb0zz__mpg123_decoderz00(obj_t BgL_envz00_829, obj_t BgL_decz00_830, obj_t BgL_bz00_831)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 75 */
{ /* Llib/mpg123_decoder.scm 76 */
long BgL_tmpz00_1880;
{ /* Llib/mpg123_decoder.scm 77 */
long BgL_arg1418z00_1072;
{ /* Llib/mpg123_decoder.scm 77 */
obj_t BgL_arg1498z00_1073;
BgL_arg1498z00_1073 = 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_830)))->BgL_z52mpg123z52); 
BgL_arg1418z00_1072 = 
BGl_mpg123zd2positionzd2zz__mpg123_mpg123z00(
((BgL_mpg123zd2handlezd2_bglt)BgL_arg1498z00_1073)); } 
BgL_tmpz00_1880 = 
(BgL_arg1418z00_1072/((long)1000)); } 
return 
BINT(BgL_tmpz00_1880);} } 
BGL_FUNCTION_END;
}



/* &musicdecoder-reset!-1136 */
obj_t BGl_z62musicdecoderzd2resetz12zd21136z70zz__mpg123_decoderz00(obj_t BgL_envz00_832, obj_t BgL_decz00_833)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 67 */
{ 

{ /* Llib/mpg123_decoder.scm 69 */
obj_t BgL_arg1417z00_1077;
BgL_arg1417z00_1077 = 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_833)))->BgL_z52mpg123z52); 
BGl_mpg123zd2handlezd2resetz12z12zz__mpg123_mpg123z00(
((BgL_mpg123zd2handlezd2_bglt)BgL_arg1417z00_1077)); } 
{ /* Llib/mpg123_decoder.scm 67 */
obj_t BgL_nextzd2method1135zd2_1076;
BgL_nextzd2method1135zd2_1076 = 
BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
((BgL_objectz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_833)), BGl_musicdecoderzd2resetz12zd2envz12zz__multimediazd2musicbufzd2, BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00); 
return 
PROCEDURE_ENTRY(BgL_nextzd2method1135zd2_1076)(BgL_nextzd2method1135zd2_1076, 
((obj_t)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_833)), BEOA);} } } 
BGL_FUNCTION_END;
}



/* &musicdecoder-close-m1134 */
obj_t BGl_z62musicdecoderzd2closezd2m1134z62zz__mpg123_decoderz00(obj_t BgL_envz00_834, obj_t BgL_decz00_835)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 60 */
{ /* Llib/mpg123_decoder.scm 62 */
obj_t BgL_arg1374z00_1079;
BgL_arg1374z00_1079 = 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_835)))->BgL_z52mpg123z52); 
return 
BGl_mpg123zd2handlezd2closez00zz__mpg123_mpg123z00(
((BgL_mpg123zd2handlezd2_bglt)BgL_arg1374z00_1079));} } 
BGL_FUNCTION_END;
}



/* &musicdecoder-init-mp1132 */
obj_t BGl_z62musicdecoderzd2initzd2mp1132z62zz__mpg123_decoderz00(obj_t BgL_envz00_836, obj_t BgL_decz00_837)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 52 */
if(
NULLP(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_837))))->BgL_mimetypesz00)))
{ /* Llib/mpg123_decoder.scm 54 */
return 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_837))))->BgL_mimetypesz00)=((obj_t)
CNST_TABLE_REF(((long)20))),BUNSPEC);}  else 
{ /* Llib/mpg123_decoder.scm 54 */
return BFALSE;} } 
BGL_FUNCTION_END;
}



/* &object-print-mpg123-1130 */
obj_t BGl_z62objectzd2printzd2mpg123zd21130zb0zz__mpg123_decoderz00(obj_t BgL_envz00_838, obj_t BgL_oz00_839, obj_t BgL_portz00_840, obj_t BgL_printzd2slotzd2_841)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 46 */
{ /* Llib/mpg123_decoder.scm 47 */
obj_t BgL_tmpz00_1913;
BgL_tmpz00_1913 = 
((obj_t)BgL_portz00_840); 
return 
bgl_display_string(BGl_string2046z00zz__mpg123_decoderz00, BgL_tmpz00_1913);} } 
BGL_FUNCTION_END;
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__mpg123_decoderz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpg123_decoder.scm 15 */
return 
BGl_modulezd2initializa7ationz75zz__mpg123_mpg123z00(((long)388603996), 
BSTRING_TO_STRING(BGl_string2047z00zz__mpg123_decoderz00));} 
BGL_FUNCTION_END;
}

#ifdef __cplusplus
}
#endif
