/*===========================================================================*/
/*   (Llib/wav_padec.scm)                                                    */
/*   Bigloo (4.3f)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 04 Jul 2019 08:10:18 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo4.3f/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -I Llib -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -safee -srfi wav -copt  -copt -fPIC -copt -IClib Llib/wav_padec.scm -o objs/wav_padec.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

/* runtime code modification */
#define BGL_SELF_MODIFYING_CODE 0

#include <bigloo.h>
#include <pulse/simple.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_musicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
} *BgL_musicz00_bglt;

typedef struct BgL_musicstatusz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_statez00;
   obj_t BgL_volumez00;
   bool_t BgL_repeatz00;
   bool_t BgL_randomz00;
   int BgL_playlistidz00;
   int BgL_playlistlengthz00;
   int BgL_xfadez00;
   int BgL_songz00;
   int BgL_songidz00;
   obj_t BgL_songposz00;
   int BgL_songlengthz00;
   int BgL_bitratez00;
   int BgL_khza7za7;
   obj_t BgL_errz00;
   int BgL_bufferingz00;
} *BgL_musicstatusz00_bglt;

typedef struct BgL_pulseaudiozd2simplezd2_bgl {
   header_t header;
   obj_t widening;
   pa_simple * BgL_z42builtinz42;
   obj_t BgL_srvnamez00;
   obj_t BgL_namez00;
   obj_t BgL_streamz00;
   long BgL_ratez00;
   long BgL_channelsz00;
   int BgL_bpsz00;
   obj_t BgL_formatz00;
} *BgL_pulseaudiozd2simplezd2_bglt;

typedef struct BgL_musicbufferz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_urlz00;
   bool_t BgL_z52eofz52;
   obj_t BgL_z52bcondvz52;
   obj_t BgL_z52bmutexz52;
   long BgL_z52inlenz52;
   char * BgL_z52inbufpz52;
   long BgL_z52headz52;
   long BgL_z52tailz52;
   bool_t BgL_z52emptyz52;
} *BgL_musicbufferz00_bglt;

typedef struct BgL_pulseaudiomusicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
   struct BgL_pulseaudiozd2simplezd2_bgl * BgL_simplez00;
   obj_t BgL_namez00;
} *BgL_pulseaudiomusicz00_bglt;

typedef struct BgL_musicinfoz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_formatz00;
   long BgL_sampleratez00;
   int BgL_channelsz00;
   int BgL_bpsz00;
   long BgL_durationz00;
} *BgL_musicinfoz00_bglt;

typedef struct BgL_musicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
} *BgL_musicdecoderz00_bglt;

typedef struct BgL_wavinfoz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_formatz00;
   long BgL_sampleratez00;
   int BgL_channelsz00;
   int BgL_bpsz00;
   long BgL_durationz00;
   obj_t BgL_audiofmtz00;
   int BgL_byteratez00;
   int BgL_blockalignz00;
   long BgL_chunksiza7eza7;
} *BgL_wavinfoz00_bglt;

typedef struct BgL_wavmusicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_outbufz00;
   obj_t BgL_z52headerz52;
   int BgL_z52cursorz52;
   int BgL_z52siza7ezf5;
   int BgL_z52positionz52;
} *BgL_wavmusicdecoderz00_bglt;

typedef struct BgL_wavzd2pulseaudiodecoderzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_outbufz00;
   obj_t BgL_z52headerz52;
   int BgL_z52cursorz52;
   int BgL_z52siza7ezf5;
   int BgL_z52positionz52;
} *BgL_wavzd2pulseaudiodecoderzd2_bglt;


BGL_IMPORT bool_t BGl_classzd2fieldzf3z21zz__objectz00(obj_t);
static obj_t BGl_objectzd2initzd2zz__wav_padecz00();
extern obj_t BGl_wavinfoz00zz__wav_wavz00;
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_pulseaudiomusiczd2simplezd2setz12z12zz__pulseaudio_musicz00(BgL_pulseaudiomusicz00_bglt, BgL_pulseaudiozd2simplezd2_bglt);
static obj_t BGl_methodzd2initzd2zz__wav_padecz00();
BGL_IMPORT obj_t BGl_musicbufferz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_conditionzd2variablezd2nilz00zz__threadz00();
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__wav_padecz00();
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_wavzd2pulseaudiodecoderzd2zz__wav_padecz00 = BUNSPEC;
BGL_IMPORT bool_t BGl_zd3fxzd3zz__r4_numbers_6_5_fixnumz00(long, long);
BGL_IMPORT long BGl_bitzd2andzd2zz__bitz00(long, long);
BGL_IMPORT obj_t BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00;
static obj_t BGl_requirezd2initializa7ationz75zz__wav_padecz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza31138ze3ze1zz__wav_padecz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__wav_padecz00();
static obj_t BGl_genericzd2initzd2zz__wav_padecz00();
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mutexzd2nilzd2zz__threadz00();
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_modulezd2initzd2errorz00zz__errorz00(char *, char *);
static BgL_wavzd2pulseaudiodecoderzd2_bglt BGl_z62lambda1115z62zz__wav_padecz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62musicdecoderzd2hwparam1106zb0zz__wav_padecz00(obj_t, obj_t, obj_t, obj_t);
static BgL_wavzd2pulseaudiodecoderzd2_bglt BGl_z62lambda1135z62zz__wav_padecz00(obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__wav_padecz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__wav_decoderz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__wav_wavz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pulseaudio_pulseaudioz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pulseaudio_musicz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pulseaudio_simplez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_musicz00zz__multimediazd2musiczd2;
static obj_t BGl_cnstzd2initzd2zz__wav_padecz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__wav_padecz00();
static obj_t BGl_importedzd2moduleszd2initz00zz__wav_padecz00();
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
BGL_IMPORT obj_t BGl_pulseaudiomusicz00zz__pulseaudio_musicz00;
extern obj_t BGl_wavmusicdecoderz00zz__wav_decoderz00;
static obj_t __cnst[ 5 ] ;


DEFINE_STRING( BGl_string1230z00zz__wav_padecz00, BgL_bgl_string1230za700za7za7_1270za7, "musicdecoder-hwparam1106", 24 );
DEFINE_STRING( BGl_string1231z00zz__wav_padecz00, BgL_bgl_string1231za700za7za7_1271za7, "pulseaudiomusic", 15 );
DEFINE_STRING( BGl_string1232z00zz__wav_padecz00, BgL_bgl_string1232za700za7za7_1272za7, "wavinfo", 7 );
DEFINE_STRING( BGl_string1233z00zz__wav_padecz00, BgL_bgl_string1233za700za7za7_1273za7, "class-field", 11 );
DEFINE_STRING( BGl_string1234z00zz__wav_padecz00, BgL_bgl_string1234za700za7za7_1274za7, "void*", 5 );
DEFINE_STRING( BGl_string1235z00zz__wav_padecz00, BgL_bgl_string1235za700za7za7_1275za7, "musicdecoder-hwparam1106:Wrong number of arguments", 50 );
DEFINE_STRING( BGl_string1236z00zz__wav_padecz00, BgL_bgl_string1236za700za7za7_1276za7, "&musicdecoder-hwparam1106", 25 );
DEFINE_STRING( BGl_string1237z00zz__wav_padecz00, BgL_bgl_string1237za700za7za7_1277za7, "music", 5 );
DEFINE_STRING( BGl_string1238z00zz__wav_padecz00, BgL_bgl_string1238za700za7za7_1278za7, "musicbuffer", 11 );
DEFINE_STRING( BGl_string1239z00zz__wav_padecz00, BgL_bgl_string1239za700za7za7_1279za7, "__wav_padec", 11 );
DEFINE_STRING( BGl_string1240z00zz__wav_padecz00, BgL_bgl_string1240za700za7za7_1280za7, "(funcall fun1146 fun1146 new1100) s16 (funcall fun1116 fun1116 new1102) __wav_padec wav-pulseaudiodecoder ", 106 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1212z00zz__wav_padecz00, BgL_bgl_za762za7c3anonymousza71281za7, BGl_z62zc3anonymousza31138ze3ze1zz__wav_padecz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1213z00zz__wav_padecz00, BgL_bgl_za762lambda1135za7621282z00, BGl_z62lambda1135z62zz__wav_padecz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1214z00zz__wav_padecz00, BgL_bgl_za762lambda1115za7621283z00, BGl_z62lambda1115z62zz__wav_padecz00, 0L, BUNSPEC, 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1228z00zz__wav_padecz00, BgL_bgl_za762musicdecoderza71284z00, BGl_z62musicdecoderzd2hwparam1106zb0zz__wav_padecz00, 0L, BUNSPEC, 3 );
BGL_IMPORT obj_t BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musicdecoderzd2hwparamszd2setz12zd2envzc0zz__multimediazd2musicbufzd2;
DEFINE_STRING( BGl_string1211z00zz__wav_padecz00, BgL_bgl_string1211za700za7za7_1285za7, "Llib/wav_padec.scm", 18 );
DEFINE_STRING( BGl_string1215z00zz__wav_padecz00, BgL_bgl_string1215za700za7za7_1286za7, "", 0 );
DEFINE_STRING( BGl_string1216z00zz__wav_padecz00, BgL_bgl_string1216za700za7za7_1287za7, "/builddir/build/BUILD/bigloo4.3f/api/wav/src/Llib/wav_padec.scm", 63 );
DEFINE_STRING( BGl_string1217z00zz__wav_padecz00, BgL_bgl_string1217za700za7za7_1288za7, "&<anonymous:1138>", 17 );
DEFINE_STRING( BGl_string1218z00zz__wav_padecz00, BgL_bgl_string1218za700za7za7_1289za7, "wav-pulseaudiodecoder", 21 );
DEFINE_STRING( BGl_string1219z00zz__wav_padecz00, BgL_bgl_string1219za700za7za7_1290za7, "lambda1115", 10 );
DEFINE_STRING( BGl_string1220z00zz__wav_padecz00, BgL_bgl_string1220za700za7za7_1291za7, "procedure", 9 );
DEFINE_STRING( BGl_string1221z00zz__wav_padecz00, BgL_bgl_string1221za700za7za7_1292za7, "lambda1115:Wrong number of arguments", 36 );
DEFINE_STRING( BGl_string1222z00zz__wav_padecz00, BgL_bgl_string1222za700za7za7_1293za7, "&lambda1115", 11 );
DEFINE_STRING( BGl_string1223z00zz__wav_padecz00, BgL_bgl_string1223za700za7za7_1294za7, "pair-nil", 8 );
DEFINE_STRING( BGl_string1224z00zz__wav_padecz00, BgL_bgl_string1224za700za7za7_1295za7, "bint", 4 );
DEFINE_STRING( BGl_string1225z00zz__wav_padecz00, BgL_bgl_string1225za700za7za7_1296za7, "mutex", 5 );
DEFINE_STRING( BGl_string1226z00zz__wav_padecz00, BgL_bgl_string1226za700za7za7_1297za7, "condvar", 7 );
DEFINE_STRING( BGl_string1227z00zz__wav_padecz00, BgL_bgl_string1227za700za7za7_1298za7, "bstring", 7 );
DEFINE_STRING( BGl_string1229z00zz__wav_padecz00, BgL_bgl_string1229za700za7za7_1299za7, "musicdecoder-hwparams-set!", 26 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_wavzd2pulseaudiodecoderzd2zz__wav_padecz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__wav_padecz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__wav_padecz00(long BgL_checksumz00_242, char * BgL_fromz00_243)
{ BGL_FUNCTION_BEGIN;
{ 
if(
BGl_zd3fxzd3zz__r4_numbers_6_5_fixnumz00(
(long)CINT(
BINT(
BGl_bitzd2andzd2zz__bitz00(BgL_checksumz00_242, ((long)345689005)))), BgL_checksumz00_242))
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__wav_padecz00))
{ 
BGl_requirezd2initializa7ationz75zz__wav_padecz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__wav_padecz00(); 
BGl_libraryzd2moduleszd2initz00zz__wav_padecz00(); 
BGl_cnstzd2initzd2zz__wav_padecz00(); 
BGl_importedzd2moduleszd2initz00zz__wav_padecz00(); 
BGl_objectzd2initzd2zz__wav_padecz00(); 
BGl_methodzd2initzd2zz__wav_padecz00(); 
return 
BGl_toplevelzd2initzd2zz__wav_padecz00();}  else 
{ 
return BUNSPEC;} }  else 
{ 
char * BgL_sz00_246;
BgL_sz00_246 = 
"__wav_padec"; 
return 
BGl_modulezd2initzd2errorz00zz__errorz00(BgL_sz00_246, BgL_fromz00_243);} } 
BGL_FUNCTION_END;
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__wav_padecz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_padec.scm 15 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__wav_padec"); 
BGl_modulezd2initializa7ationz75zz__pulseaudio_musicz00(((long)0), "__wav_padec"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(((long)0), "__wav_padec"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__wav_padec"); 
BGl_modulezd2initializa7ationz75zz__pulseaudio_simplez00(((long)0), "__wav_padec"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__wav_padec"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__wav_padec"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__wav_padec"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), "__wav_padec"); 
BGl_modulezd2initializa7ationz75zz__pulseaudio_pulseaudioz00(((long)0), "__wav_padec"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__wav_padec"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__wav_padec"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__wav_padec"); 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__wav_padecz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_padec.scm 15 */
{ /* Llib/wav_padec.scm 15 */
obj_t BgL_cportz00_183;
{ /* Llib/wav_padec.scm 15 */
obj_t BgL_stringz00_191;
BgL_stringz00_191 = BGl_string1240z00zz__wav_padecz00; 
{ /* Llib/wav_padec.scm 15 */
obj_t BgL_startz00_192;
BgL_startz00_192 = 
BINT(((long)0)); 
{ /* Llib/wav_padec.scm 15 */
obj_t BgL_endz00_193;
BgL_endz00_193 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_191))); 
{ /* Llib/wav_padec.scm 15 */

BgL_cportz00_183 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_191, BgL_startz00_192, BgL_endz00_193); } } } } 
{ 
long BgL_iz00_184;
BgL_iz00_184 = ((long)4); 
BgL_loopz00_185:
if(
(BgL_iz00_184==((long)-1)))
{ /* Llib/wav_padec.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/wav_padec.scm 15 */
{ /* Llib/wav_padec.scm 15 */
obj_t BgL_arg1256z00_187;
{ /* Llib/wav_padec.scm 15 */

{ /* Llib/wav_padec.scm 15 */
obj_t BgL_locationz00_189;
BgL_locationz00_189 = 
BBOOL(((bool_t)0)); 
{ /* Llib/wav_padec.scm 15 */

BgL_arg1256z00_187 = 
BGl_readz00zz__readerz00(BgL_cportz00_183, BgL_locationz00_189); } } } 
{ /* Llib/wav_padec.scm 15 */
int BgL_tmpz00_287;
BgL_tmpz00_287 = 
(int)(BgL_iz00_184); 
CNST_TABLE_SET(BgL_tmpz00_287, BgL_arg1256z00_187); } } 
{ /* Llib/wav_padec.scm 15 */
int BgL_auxz00_190;
BgL_auxz00_190 = 
(int)(
(BgL_iz00_184-((long)1))); 
{ 
long BgL_iz00_292;
BgL_iz00_292 = 
(long)(BgL_auxz00_190); 
BgL_iz00_184 = BgL_iz00_292; 
goto BgL_loopz00_185;} } } } } } 
BGL_FUNCTION_END;
}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__wav_padecz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_padec.scm 15 */
return 
bgl_gc_roots_register();} 
BGL_FUNCTION_END;
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__wav_padecz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_padec.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), 
BSTRING_TO_STRING(BGl_string1211z00zz__wav_padecz00)); 
BGl_modulezd2initializa7ationz75zz__pulseaudio_pulseaudioz00(((long)0), 
BSTRING_TO_STRING(BGl_string1211z00zz__wav_padecz00)); 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* object-init */
obj_t BGl_objectzd2initzd2zz__wav_padecz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_padec.scm 15 */
{ /* Llib/wav_padec.scm 28 */
obj_t BgL_arg1113z00_17;obj_t BgL_arg1114z00_18;
{ /* Llib/wav_padec.scm 28 */
obj_t BgL_v1103z00_44;
BgL_v1103z00_44 = 
create_vector(((long)0)); 
BgL_arg1113z00_17 = BgL_v1103z00_44; } 
{ /* Llib/wav_padec.scm 28 */
obj_t BgL_v1104z00_45;
BgL_v1104z00_45 = 
create_vector(((long)0)); 
BgL_arg1114z00_18 = BgL_v1104z00_45; } 
return ( 
BGl_wavzd2pulseaudiodecoderzd2zz__wav_padecz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)0)), 
CNST_TABLE_REF(((long)1)), BGl_wavmusicdecoderz00zz__wav_decoderz00, ((long)3710), BGl_proc1214z00zz__wav_padecz00, BGl_proc1213z00zz__wav_padecz00, BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_proc1212z00zz__wav_padecz00, BFALSE, BgL_arg1113z00_17, BgL_arg1114z00_18), BUNSPEC) ;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1138> */
obj_t BGl_z62zc3anonymousza31138ze3ze1zz__wav_padecz00(obj_t BgL_envz00_87, obj_t BgL_new1095z00_88)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_padec.scm 28 */
{ 
BgL_wavzd2pulseaudiodecoderzd2_bglt BgL_auxz00_304;
{ /* Llib/wav_padec.scm 28 */
BgL_wavzd2pulseaudiodecoderzd2_bglt BgL_new1095z00_196;
if(
BGl_isazf3zf3zz__objectz00(BgL_new1095z00_88, BGl_wavzd2pulseaudiodecoderzd2zz__wav_padecz00))
{ /* Llib/wav_padec.scm 28 */
BgL_new1095z00_196 = 
((BgL_wavzd2pulseaudiodecoderzd2_bglt)BgL_new1095z00_88); }  else 
{ 
obj_t BgL_auxz00_308;
BgL_auxz00_308 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1216z00zz__wav_padecz00, 
BINT(((long)1196)), BGl_string1217z00zz__wav_padecz00, BGl_string1218z00zz__wav_padecz00, BgL_new1095z00_88); 
FAILURE(BgL_auxz00_308,BFALSE,BFALSE);} 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1095z00_196)))->BgL_mimetypesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1095z00_196)))->BgL_bufferzd2timezd2nearz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1095z00_196)))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1095z00_196)))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1095z00_196)))->BgL_z52z12dpausez40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1095z00_196)))->BgL_z52z12dabortz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1095z00_196)))->BgL_z52z12stopz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1095z00_196)))->BgL_z52dmutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1095z00_196)))->BgL_z52dcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1095z00_196)))->BgL_z52doutcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1095z00_196)))->BgL_outbufz00)=((obj_t)BGl_string1215z00zz__wav_padecz00),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1095z00_196)))->BgL_z52headerz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1095z00_196)))->BgL_z52cursorz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1095z00_196)))->BgL_z52siza7ezf5)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1095z00_196)))->BgL_z52positionz52)=((int)
(int)(((long)0))),BUNSPEC); 
BgL_auxz00_304 = BgL_new1095z00_196; } 
return 
((obj_t)BgL_auxz00_304);} } 
BGL_FUNCTION_END;
}



/* &lambda1135 */
BgL_wavzd2pulseaudiodecoderzd2_bglt BGl_z62lambda1135z62zz__wav_padecz00(obj_t BgL_envz00_89)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_padec.scm 28 */
{ /* Llib/wav_padec.scm 28 */
BgL_wavzd2pulseaudiodecoderzd2_bglt BgL_new1094z00_197;
BgL_new1094z00_197 = 
((BgL_wavzd2pulseaudiodecoderzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_wavzd2pulseaudiodecoderzd2_bgl) ))); 
{ /* Llib/wav_padec.scm 28 */
long BgL_arg1137z00_198;
{ /* Llib/wav_padec.scm 28 */
long BgL_res1150z00_199;
BgL_res1150z00_199 = 
BGL_CLASS_INDEX(BGl_wavzd2pulseaudiodecoderzd2zz__wav_padecz00); 
BgL_arg1137z00_198 = BgL_res1150z00_199; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1094z00_197), BgL_arg1137z00_198); } 
return BgL_new1094z00_197;} } 
BGL_FUNCTION_END;
}



/* &lambda1115 */
BgL_wavzd2pulseaudiodecoderzd2_bglt BGl_z62lambda1115z62zz__wav_padecz00(obj_t BgL_envz00_90, obj_t BgL_mimetypes1079z00_91, obj_t BgL_bufferzd2timezd2near1080z00_92, obj_t BgL_bufferzd2siza7ezd2nearzd2rat1081z75_93, obj_t BgL_periodzd2siza7ezd2nearzd2rat1082z75_94, obj_t BgL_z52z12dpause1083z40_95, obj_t BgL_z52z12dabort1084z40_96, obj_t BgL_z52z12stop1085z40_97, obj_t BgL_z52dmutex1086z52_98, obj_t BgL_z52dcondv1087z52_99, obj_t BgL_z52doutcondv1088z52_100, obj_t BgL_outbuf1089z00_101, obj_t BgL_z52header1090z52_102, obj_t BgL_z52cursor1091z52_103, obj_t BgL_z52siza7e1092zf5_104, obj_t BgL_z52position1093z52_105)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_padec.scm 28 */
{ /* Llib/wav_padec.scm 28 */
obj_t BgL_mimetypes1079z00_204;int BgL_bufferzd2timezd2near1080z00_205;int BgL_bufferzd2siza7ezd2nearzd2rat1081z75_206;int BgL_periodzd2siza7ezd2nearzd2rat1082z75_207;bool_t BgL_z52z12dpause1083z40_208;bool_t BgL_z52z12dabort1084z40_209;bool_t BgL_z52z12stop1085z40_210;obj_t BgL_z52dmutex1086z52_211;obj_t BgL_z52dcondv1087z52_212;obj_t BgL_z52doutcondv1088z52_213;obj_t BgL_outbuf1089z00_214;int BgL_z52cursor1091z52_215;int BgL_z52siza7e1092zf5_216;int BgL_z52position1093z52_217;
{ /* Llib/wav_padec.scm 28 */
bool_t BgL_testz00_356;
if(
PAIRP(BgL_mimetypes1079z00_91))
{ /* Llib/wav_padec.scm 28 */
BgL_testz00_356 = ((bool_t)1)
; }  else 
{ /* Llib/wav_padec.scm 28 */
BgL_testz00_356 = 
NULLP(BgL_mimetypes1079z00_91)
; } 
if(BgL_testz00_356)
{ /* Llib/wav_padec.scm 28 */
BgL_mimetypes1079z00_204 = BgL_mimetypes1079z00_91; }  else 
{ 
obj_t BgL_auxz00_360;
BgL_auxz00_360 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1216z00zz__wav_padecz00, 
BINT(((long)1196)), BGl_string1222z00zz__wav_padecz00, BGl_string1223z00zz__wav_padecz00, BgL_mimetypes1079z00_91); 
FAILURE(BgL_auxz00_360,BFALSE,BFALSE);} } 
{ /* Llib/wav_padec.scm 28 */
obj_t BgL_tmpz00_364;
if(
INTEGERP(BgL_bufferzd2timezd2near1080z00_92))
{ /* Llib/wav_padec.scm 28 */
BgL_tmpz00_364 = BgL_bufferzd2timezd2near1080z00_92
; }  else 
{ 
obj_t BgL_auxz00_367;
BgL_auxz00_367 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1216z00zz__wav_padecz00, 
BINT(((long)1196)), BGl_string1222z00zz__wav_padecz00, BGl_string1224z00zz__wav_padecz00, BgL_bufferzd2timezd2near1080z00_92); 
FAILURE(BgL_auxz00_367,BFALSE,BFALSE);} 
BgL_bufferzd2timezd2near1080z00_205 = 
CINT(BgL_tmpz00_364); } 
{ /* Llib/wav_padec.scm 28 */
obj_t BgL_tmpz00_372;
if(
INTEGERP(BgL_bufferzd2siza7ezd2nearzd2rat1081z75_93))
{ /* Llib/wav_padec.scm 28 */
BgL_tmpz00_372 = BgL_bufferzd2siza7ezd2nearzd2rat1081z75_93
; }  else 
{ 
obj_t BgL_auxz00_375;
BgL_auxz00_375 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1216z00zz__wav_padecz00, 
BINT(((long)1196)), BGl_string1222z00zz__wav_padecz00, BGl_string1224z00zz__wav_padecz00, BgL_bufferzd2siza7ezd2nearzd2rat1081z75_93); 
FAILURE(BgL_auxz00_375,BFALSE,BFALSE);} 
BgL_bufferzd2siza7ezd2nearzd2rat1081z75_206 = 
CINT(BgL_tmpz00_372); } 
{ /* Llib/wav_padec.scm 28 */
obj_t BgL_tmpz00_380;
if(
INTEGERP(BgL_periodzd2siza7ezd2nearzd2rat1082z75_94))
{ /* Llib/wav_padec.scm 28 */
BgL_tmpz00_380 = BgL_periodzd2siza7ezd2nearzd2rat1082z75_94
; }  else 
{ 
obj_t BgL_auxz00_383;
BgL_auxz00_383 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1216z00zz__wav_padecz00, 
BINT(((long)1196)), BGl_string1222z00zz__wav_padecz00, BGl_string1224z00zz__wav_padecz00, BgL_periodzd2siza7ezd2nearzd2rat1082z75_94); 
FAILURE(BgL_auxz00_383,BFALSE,BFALSE);} 
BgL_periodzd2siza7ezd2nearzd2rat1082z75_207 = 
CINT(BgL_tmpz00_380); } 
BgL_z52z12dpause1083z40_208 = 
CBOOL(BgL_z52z12dpause1083z40_95); 
BgL_z52z12dabort1084z40_209 = 
CBOOL(BgL_z52z12dabort1084z40_96); 
BgL_z52z12stop1085z40_210 = 
CBOOL(BgL_z52z12stop1085z40_97); 
if(
BGL_MUTEXP(BgL_z52dmutex1086z52_98))
{ /* Llib/wav_padec.scm 28 */
BgL_z52dmutex1086z52_211 = BgL_z52dmutex1086z52_98; }  else 
{ 
obj_t BgL_auxz00_393;
BgL_auxz00_393 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1216z00zz__wav_padecz00, 
BINT(((long)1196)), BGl_string1222z00zz__wav_padecz00, BGl_string1225z00zz__wav_padecz00, BgL_z52dmutex1086z52_98); 
FAILURE(BgL_auxz00_393,BFALSE,BFALSE);} 
if(
BGL_CONDVARP(BgL_z52dcondv1087z52_99))
{ /* Llib/wav_padec.scm 28 */
BgL_z52dcondv1087z52_212 = BgL_z52dcondv1087z52_99; }  else 
{ 
obj_t BgL_auxz00_399;
BgL_auxz00_399 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1216z00zz__wav_padecz00, 
BINT(((long)1196)), BGl_string1222z00zz__wav_padecz00, BGl_string1226z00zz__wav_padecz00, BgL_z52dcondv1087z52_99); 
FAILURE(BgL_auxz00_399,BFALSE,BFALSE);} 
if(
BGL_CONDVARP(BgL_z52doutcondv1088z52_100))
{ /* Llib/wav_padec.scm 28 */
BgL_z52doutcondv1088z52_213 = BgL_z52doutcondv1088z52_100; }  else 
{ 
obj_t BgL_auxz00_405;
BgL_auxz00_405 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1216z00zz__wav_padecz00, 
BINT(((long)1196)), BGl_string1222z00zz__wav_padecz00, BGl_string1226z00zz__wav_padecz00, BgL_z52doutcondv1088z52_100); 
FAILURE(BgL_auxz00_405,BFALSE,BFALSE);} 
if(
STRINGP(BgL_outbuf1089z00_101))
{ /* Llib/wav_padec.scm 28 */
BgL_outbuf1089z00_214 = BgL_outbuf1089z00_101; }  else 
{ 
obj_t BgL_auxz00_411;
BgL_auxz00_411 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1216z00zz__wav_padecz00, 
BINT(((long)1196)), BGl_string1222z00zz__wav_padecz00, BGl_string1227z00zz__wav_padecz00, BgL_outbuf1089z00_101); 
FAILURE(BgL_auxz00_411,BFALSE,BFALSE);} 
{ /* Llib/wav_padec.scm 28 */
obj_t BgL_tmpz00_415;
if(
INTEGERP(BgL_z52cursor1091z52_103))
{ /* Llib/wav_padec.scm 28 */
BgL_tmpz00_415 = BgL_z52cursor1091z52_103
; }  else 
{ 
obj_t BgL_auxz00_418;
BgL_auxz00_418 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1216z00zz__wav_padecz00, 
BINT(((long)1196)), BGl_string1222z00zz__wav_padecz00, BGl_string1224z00zz__wav_padecz00, BgL_z52cursor1091z52_103); 
FAILURE(BgL_auxz00_418,BFALSE,BFALSE);} 
BgL_z52cursor1091z52_215 = 
CINT(BgL_tmpz00_415); } 
{ /* Llib/wav_padec.scm 28 */
obj_t BgL_tmpz00_423;
if(
INTEGERP(BgL_z52siza7e1092zf5_104))
{ /* Llib/wav_padec.scm 28 */
BgL_tmpz00_423 = BgL_z52siza7e1092zf5_104
; }  else 
{ 
obj_t BgL_auxz00_426;
BgL_auxz00_426 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1216z00zz__wav_padecz00, 
BINT(((long)1196)), BGl_string1222z00zz__wav_padecz00, BGl_string1224z00zz__wav_padecz00, BgL_z52siza7e1092zf5_104); 
FAILURE(BgL_auxz00_426,BFALSE,BFALSE);} 
BgL_z52siza7e1092zf5_216 = 
CINT(BgL_tmpz00_423); } 
{ /* Llib/wav_padec.scm 28 */
obj_t BgL_tmpz00_431;
if(
INTEGERP(BgL_z52position1093z52_105))
{ /* Llib/wav_padec.scm 28 */
BgL_tmpz00_431 = BgL_z52position1093z52_105
; }  else 
{ 
obj_t BgL_auxz00_434;
BgL_auxz00_434 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1216z00zz__wav_padecz00, 
BINT(((long)1196)), BGl_string1222z00zz__wav_padecz00, BGl_string1224z00zz__wav_padecz00, BgL_z52position1093z52_105); 
FAILURE(BgL_auxz00_434,BFALSE,BFALSE);} 
BgL_z52position1093z52_217 = 
CINT(BgL_tmpz00_431); } 
{ /* Llib/wav_padec.scm 28 */
BgL_wavzd2pulseaudiodecoderzd2_bglt BgL_new1102z00_218;
{ /* Llib/wav_padec.scm 28 */
BgL_wavzd2pulseaudiodecoderzd2_bglt BgL_new1101z00_219;
BgL_new1101z00_219 = 
((BgL_wavzd2pulseaudiodecoderzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_wavzd2pulseaudiodecoderzd2_bgl) ))); 
{ /* Llib/wav_padec.scm 28 */
long BgL_arg1134z00_220;
{ /* Llib/wav_padec.scm 28 */
long BgL_res1149z00_221;
BgL_res1149z00_221 = 
BGL_CLASS_INDEX(BGl_wavzd2pulseaudiodecoderzd2zz__wav_padecz00); 
BgL_arg1134z00_220 = BgL_res1149z00_221; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1101z00_219), BgL_arg1134z00_220); } 
BgL_new1102z00_218 = BgL_new1101z00_219; } 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1102z00_218)))->BgL_mimetypesz00)=((obj_t)BgL_mimetypes1079z00_204),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1102z00_218)))->BgL_bufferzd2timezd2nearz00)=((int)BgL_bufferzd2timezd2near1080z00_205),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1102z00_218)))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)BgL_bufferzd2siza7ezd2nearzd2rat1081z75_206),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1102z00_218)))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)BgL_periodzd2siza7ezd2nearzd2rat1082z75_207),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1102z00_218)))->BgL_z52z12dpausez40)=((bool_t)BgL_z52z12dpause1083z40_208),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1102z00_218)))->BgL_z52z12dabortz40)=((bool_t)BgL_z52z12dabort1084z40_209),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1102z00_218)))->BgL_z52z12stopz40)=((bool_t)BgL_z52z12stop1085z40_210),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1102z00_218)))->BgL_z52dmutexz52)=((obj_t)BgL_z52dmutex1086z52_211),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1102z00_218)))->BgL_z52dcondvz52)=((obj_t)BgL_z52dcondv1087z52_212),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1102z00_218)))->BgL_z52doutcondvz52)=((obj_t)BgL_z52doutcondv1088z52_213),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1102z00_218)))->BgL_outbufz00)=((obj_t)BgL_outbuf1089z00_214),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1102z00_218)))->BgL_z52headerz52)=((obj_t)BgL_z52header1090z52_102),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1102z00_218)))->BgL_z52cursorz52)=((int)BgL_z52cursor1091z52_215),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1102z00_218)))->BgL_z52siza7ezf5)=((int)BgL_z52siza7e1092zf5_216),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1102z00_218)))->BgL_z52positionz52)=((int)BgL_z52position1093z52_217),BUNSPEC); 
{ /* Llib/wav_padec.scm 28 */
obj_t BgL_fun1116z00_222;
BgL_fun1116z00_222 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_wavzd2pulseaudiodecoderzd2zz__wav_padecz00); 
{ /* Llib/wav_padec.scm 28 */
obj_t BgL_funz00_223;
if(
PROCEDUREP(BgL_fun1116z00_222))
{ /* Llib/wav_padec.scm 28 */
BgL_funz00_223 = BgL_fun1116z00_222; }  else 
{ 
obj_t BgL_auxz00_476;
BgL_auxz00_476 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1216z00zz__wav_padecz00, 
BINT(((long)1196)), BGl_string1219z00zz__wav_padecz00, BGl_string1220z00zz__wav_padecz00, BgL_fun1116z00_222); 
FAILURE(BgL_auxz00_476,BFALSE,BFALSE);} 
if(
PROCEDURE_CORRECT_ARITYP(BgL_funz00_223, ((long)1)))
{ /* Llib/wav_padec.scm 28 */
PROCEDURE_ENTRY(BgL_funz00_223)(BgL_fun1116z00_222, 
((obj_t)BgL_new1102z00_218), BEOA); }  else 
{ 
obj_t BgL_auxz00_487;
BgL_auxz00_487 = 
CNST_TABLE_REF(((long)2)); 
FAILURE(BGl_string1221z00zz__wav_padecz00,BgL_auxz00_487,BgL_funz00_223);} } } 
return BgL_new1102z00_218;} } } 
BGL_FUNCTION_END;
}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__wav_padecz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_padec.scm 15 */
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* method-init */
obj_t BGl_methodzd2initzd2zz__wav_padecz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_padec.scm 15 */
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2hwparamszd2setz12zd2envzc0zz__multimediazd2musicbufzd2, BGl_wavzd2pulseaudiodecoderzd2zz__wav_padecz00, BGl_proc1228z00zz__wav_padecz00, BGl_string1229z00zz__wav_padecz00);} 
BGL_FUNCTION_END;
}



/* &musicdecoder-hwparam1106 */
obj_t BGl_z62musicdecoderzd2hwparam1106zb0zz__wav_padecz00(obj_t BgL_envz00_109, obj_t BgL_decz00_110, obj_t BgL_amz00_111, obj_t BgL_bufferz00_112)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_padec.scm 40 */
{ /* Llib/wav_padec.scm 41 */
BgL_wavzd2pulseaudiodecoderzd2_bglt BgL_decz00_224;BgL_musicz00_bglt BgL_amz00_225;BgL_musicbufferz00_bglt BgL_bufferz00_226;
if(
BGl_isazf3zf3zz__objectz00(BgL_decz00_110, BGl_wavzd2pulseaudiodecoderzd2zz__wav_padecz00))
{ /* Llib/wav_padec.scm 41 */
BgL_decz00_224 = 
((BgL_wavzd2pulseaudiodecoderzd2_bglt)BgL_decz00_110); }  else 
{ 
obj_t BgL_auxz00_494;
BgL_auxz00_494 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1216z00zz__wav_padecz00, 
BINT(((long)1880)), BGl_string1236z00zz__wav_padecz00, BGl_string1218z00zz__wav_padecz00, BgL_decz00_110); 
FAILURE(BgL_auxz00_494,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_amz00_111, BGl_musicz00zz__multimediazd2musiczd2))
{ /* Llib/wav_padec.scm 41 */
BgL_amz00_225 = 
((BgL_musicz00_bglt)BgL_amz00_111); }  else 
{ 
obj_t BgL_auxz00_501;
BgL_auxz00_501 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1216z00zz__wav_padecz00, 
BINT(((long)1880)), BGl_string1236z00zz__wav_padecz00, BGl_string1237z00zz__wav_padecz00, BgL_amz00_111); 
FAILURE(BgL_auxz00_501,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_bufferz00_112, BGl_musicbufferz00zz__multimediazd2musicbufzd2))
{ /* Llib/wav_padec.scm 41 */
BgL_bufferz00_226 = 
((BgL_musicbufferz00_bglt)BgL_bufferz00_112); }  else 
{ 
obj_t BgL_auxz00_508;
BgL_auxz00_508 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1216z00zz__wav_padecz00, 
BINT(((long)1880)), BGl_string1236z00zz__wav_padecz00, BGl_string1238z00zz__wav_padecz00, BgL_bufferz00_112); 
FAILURE(BgL_auxz00_508,BFALSE,BFALSE);} 
{ /* Llib/wav_padec.scm 41 */
BgL_pulseaudiomusicz00_bglt BgL_i1096z00_227;
if(
BGl_isazf3zf3zz__objectz00(
((obj_t)BgL_amz00_225), BGl_pulseaudiomusicz00zz__pulseaudio_musicz00))
{ /* Llib/wav_padec.scm 42 */
BgL_i1096z00_227 = 
((BgL_pulseaudiomusicz00_bglt)BgL_amz00_225); }  else 
{ 
obj_t BgL_auxz00_516;
BgL_auxz00_516 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1216z00zz__wav_padecz00, 
BINT(((long)1941)), BGl_string1230z00zz__wav_padecz00, BGl_string1231z00zz__wav_padecz00, 
((obj_t)BgL_amz00_225)); 
FAILURE(BgL_auxz00_516,BFALSE,BFALSE);} 
{ /* Llib/wav_padec.scm 43 */
BgL_wavinfoz00_bglt BgL_i1098z00_228;
{ /* Llib/wav_padec.scm 44 */
obj_t BgL_aux1190z00_229;
BgL_aux1190z00_229 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_224)))->BgL_z52headerz52); 
if(
BGl_isazf3zf3zz__objectz00(BgL_aux1190z00_229, BGl_wavinfoz00zz__wav_wavz00))
{ /* Llib/wav_padec.scm 44 */
BgL_i1098z00_228 = 
((BgL_wavinfoz00_bglt)BgL_aux1190z00_229); }  else 
{ 
obj_t BgL_auxz00_526;
BgL_auxz00_526 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1216z00zz__wav_padecz00, 
BINT(((long)2073)), BGl_string1230z00zz__wav_padecz00, BGl_string1232z00zz__wav_padecz00, BgL_aux1190z00_229); 
FAILURE(BgL_auxz00_526,BFALSE,BFALSE);} } 
{ /* Llib/wav_padec.scm 45 */
BgL_pulseaudiozd2simplezd2_bglt BgL_arg1140z00_230;
{ /* Llib/wav_padec.scm 45 */
BgL_pulseaudiozd2simplezd2_bglt BgL_new1100z00_231;
{ /* Llib/wav_padec.scm 45 */
BgL_pulseaudiozd2simplezd2_bglt BgL_new1099z00_232;
BgL_new1099z00_232 = 
((BgL_pulseaudiozd2simplezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pulseaudiozd2simplezd2_bgl) ))); 
{ /* Llib/wav_padec.scm 45 */
long BgL_arg1148z00_233;
{ /* Llib/wav_padec.scm 45 */
long BgL_res1151z00_234;
BgL_res1151z00_234 = 
BGL_CLASS_INDEX(BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00); 
BgL_arg1148z00_233 = BgL_res1151z00_234; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1099z00_232), BgL_arg1148z00_233); } 
BgL_new1100z00_231 = BgL_new1099z00_232; } 
{ 
void * BgL_auxz00_534;
{ /* Llib/wav_padec.scm 45 */
obj_t BgL_arg1144z00_235;
{ /* Llib/wav_padec.scm 45 */
obj_t BgL_arg1145z00_236;
{ /* Llib/wav_padec.scm 45 */
obj_t BgL_res1152z00_237;
{ /* Llib/wav_padec.scm 45 */
obj_t BgL_classz00_238;
BgL_classz00_238 = BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00; 
BgL_res1152z00_237 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_238); } 
BgL_arg1145z00_236 = BgL_res1152z00_237; } 
BgL_arg1144z00_235 = 
VECTOR_REF(BgL_arg1145z00_236,((long)0)); } 
{ /* Llib/wav_padec.scm 45 */
obj_t BgL_aux1194z00_239;
{ /* Llib/wav_padec.scm 45 */
obj_t BgL_auxz00_537;
if(
BGl_classzd2fieldzf3z21zz__objectz00(BgL_arg1144z00_235))
{ /* Llib/wav_padec.scm 45 */
BgL_auxz00_537 = BgL_arg1144z00_235
; }  else 
{ 
obj_t BgL_auxz00_540;
BgL_auxz00_540 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1216z00zz__wav_padecz00, 
BINT(((long)2113)), BGl_string1230z00zz__wav_padecz00, BGl_string1233z00zz__wav_padecz00, BgL_arg1144z00_235); 
FAILURE(BgL_auxz00_540,BFALSE,BFALSE);} 
BgL_aux1194z00_239 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_auxz00_537); } 
if(
FOREIGNP(BgL_aux1194z00_239))
{ /* Llib/wav_padec.scm 45 */
BgL_auxz00_534 = 
FOREIGN_TO_COBJ(BgL_aux1194z00_239)
; }  else 
{ 
obj_t BgL_auxz00_548;
BgL_auxz00_548 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1216z00zz__wav_padecz00, 
BINT(((long)2113)), BGl_string1230z00zz__wav_padecz00, BGl_string1234z00zz__wav_padecz00, BgL_aux1194z00_239); 
FAILURE(BgL_auxz00_548,BFALSE,BFALSE);} } } 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1100z00_231))->BgL_z42builtinz42)=((pa_simple *)BgL_auxz00_534),BUNSPEC); } 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1100z00_231))->BgL_srvnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1100z00_231))->BgL_namez00)=((obj_t)
(((BgL_pulseaudiomusicz00_bglt)COBJECT(BgL_i1096z00_227))->BgL_namez00)),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1100z00_231))->BgL_streamz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1100z00_231))->BgL_ratez00)=((long)
(((BgL_musicinfoz00_bglt)COBJECT(
((BgL_musicinfoz00_bglt)BgL_i1098z00_228)))->BgL_sampleratez00)),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1100z00_231))->BgL_channelsz00)=((long)
(long)(
(((BgL_musicinfoz00_bglt)COBJECT(
((BgL_musicinfoz00_bglt)BgL_i1098z00_228)))->BgL_channelsz00))),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1100z00_231))->BgL_bpsz00)=((int)
(((BgL_musicinfoz00_bglt)COBJECT(
((BgL_musicinfoz00_bglt)BgL_i1098z00_228)))->BgL_bpsz00)),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1100z00_231))->BgL_formatz00)=((obj_t)
CNST_TABLE_REF(((long)3))),BUNSPEC); 
{ /* Llib/wav_padec.scm 45 */
obj_t BgL_fun1146z00_240;
BgL_fun1146z00_240 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00); 
{ /* Llib/wav_padec.scm 45 */
obj_t BgL_funz00_241;
if(
PROCEDUREP(BgL_fun1146z00_240))
{ /* Llib/wav_padec.scm 45 */
BgL_funz00_241 = BgL_fun1146z00_240; }  else 
{ 
obj_t BgL_auxz00_572;
BgL_auxz00_572 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1216z00zz__wav_padecz00, 
BINT(((long)2113)), BGl_string1230z00zz__wav_padecz00, BGl_string1220z00zz__wav_padecz00, BgL_fun1146z00_240); 
FAILURE(BgL_auxz00_572,BFALSE,BFALSE);} 
if(
PROCEDURE_CORRECT_ARITYP(BgL_funz00_241, ((long)1)))
{ /* Llib/wav_padec.scm 45 */
PROCEDURE_ENTRY(BgL_funz00_241)(BgL_fun1146z00_240, 
((obj_t)BgL_new1100z00_231), BEOA); }  else 
{ 
obj_t BgL_auxz00_583;
BgL_auxz00_583 = 
CNST_TABLE_REF(((long)4)); 
FAILURE(BGl_string1235z00zz__wav_padecz00,BgL_auxz00_583,BgL_funz00_241);} } } 
BgL_arg1140z00_230 = BgL_new1100z00_231; } 
{ /* Llib/wav_padec.scm 44 */
BgL_pulseaudiomusicz00_bglt BgL_auxz00_586;
if(
BGl_isazf3zf3zz__objectz00(
((obj_t)BgL_amz00_225), BGl_pulseaudiomusicz00zz__pulseaudio_musicz00))
{ /* Llib/wav_padec.scm 44 */
BgL_auxz00_586 = 
((BgL_pulseaudiomusicz00_bglt)BgL_amz00_225)
; }  else 
{ 
obj_t BgL_auxz00_591;
BgL_auxz00_591 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1216z00zz__wav_padecz00, 
BINT(((long)2102)), BGl_string1230z00zz__wav_padecz00, BGl_string1231z00zz__wav_padecz00, 
((obj_t)BgL_amz00_225)); 
FAILURE(BgL_auxz00_591,BFALSE,BFALSE);} 
return 
BGl_pulseaudiomusiczd2simplezd2setz12z12zz__pulseaudio_musicz00(BgL_auxz00_586, BgL_arg1140z00_230);} } } } } } 
BGL_FUNCTION_END;
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__wav_padecz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_padec.scm 15 */
BGl_modulezd2initializa7ationz75zz__wav_wavz00(((long)21080121), 
BSTRING_TO_STRING(BGl_string1239z00zz__wav_padecz00)); 
return 
BGl_modulezd2initializa7ationz75zz__wav_decoderz00(((long)0), 
BSTRING_TO_STRING(BGl_string1239z00zz__wav_padecz00));} 
BGL_FUNCTION_END;
}

#ifdef __cplusplus
}
#endif
