/*===========================================================================*/
/*   (Llib/avahi.scm)                                                        */
/*   Bigloo (4.3f)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 04 Jul 2019 08:10:18 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo4.3f/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -I Llib -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -unsafe -safee -srfi avahi -copt -D_REENTRANT -copt -fPIC -copt -IClib Llib/avahi.scm -o objs/avahi.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

/* runtime code modification */
#define BGL_SELF_MODIFYING_CODE 0

#include <bigloo.h>
#include <avahi-client/client.h>
#include <avahi-client/lookup.h>
#include <avahi-client/publish.h>
#include <avahi-common/simple-watch.h>
#include <avahi-common/thread-watch.h>
#include <avahi-common/error.h>
#include <avahi-common/alternative.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_threadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
} *BgL_threadz00_bglt;

typedef struct BgL_z62errorz62_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
   obj_t BgL_procz00;
   obj_t BgL_msgz00;
   obj_t BgL_objz00;
} *BgL_z62errorz62_bglt;

typedef struct BgL_z62exceptionz62_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
} *BgL_z62exceptionz62_bglt;

typedef struct BgL_pthreadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_bodyz00;
   bool_t BgL_detachedpz00;
   obj_t BgL_endzd2resultzd2;
   obj_t BgL_endzd2exceptionzd2;
   void * BgL_z42builtinz42;
} *BgL_pthreadz00_bglt;

typedef struct BgL_z62avahizd2errorzb0_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
   obj_t BgL_procz00;
   obj_t BgL_msgz00;
   obj_t BgL_objz00;
   int BgL_errnoz00;
} *BgL_z62avahizd2errorzb0_bglt;

typedef struct BgL_z62avahizd2collisionzd2errorz62_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
   obj_t BgL_procz00;
   obj_t BgL_msgz00;
   obj_t BgL_objz00;
   int BgL_errnoz00;
} *BgL_z62avahizd2collisionzd2errorz62_bglt;

typedef struct BgL_avahizd2objectzd2_bgl {
   header_t header;
   obj_t widening;
} *BgL_avahizd2objectzd2_bglt;

typedef struct BgL_avahizd2pollzd2_bgl {
   header_t header;
   obj_t widening;
   int BgL_z42ctypez42;
   obj_t BgL_z52procsz52;
} *BgL_avahizd2pollzd2_bglt;

typedef struct BgL_avahizd2simplezd2pollz00_bgl {
   header_t header;
   obj_t widening;
   int BgL_z42ctypez42;
   obj_t BgL_z52procsz52;
   AvahiSimplePoll * BgL_z42builtinz42;
} *BgL_avahizd2simplezd2pollz00_bglt;

typedef struct BgL_avahizd2threadedzd2pollz00_bgl {
   header_t header;
   obj_t widening;
   int BgL_z42ctypez42;
   obj_t BgL_z52procsz52;
   AvahiThreadedPoll * BgL_z42builtinz42;
} *BgL_avahizd2threadedzd2pollz00_bglt;

typedef struct BgL_avahizd2clientzd2_bgl {
   header_t header;
   obj_t widening;
   AvahiClient * BgL_z42builtinz42;
   struct BgL_avahizd2pollzd2_bgl * BgL_pollz00;
   obj_t BgL_flagsz00;
   obj_t BgL_procz00;
   obj_t BgL_z52groupsz52;
   obj_t BgL_z52browsersz52;
   obj_t BgL_resolversz00;
} *BgL_avahizd2clientzd2_bglt;

typedef struct BgL_avahizd2entryzd2groupz00_bgl {
   header_t header;
   obj_t widening;
   AvahiEntryGroup * BgL_z42builtinz42;
   struct BgL_avahizd2clientzd2_bgl * BgL_clientz00;
   obj_t BgL_procz00;
} *BgL_avahizd2entryzd2groupz00_bglt;

typedef struct BgL_avahizd2servicezd2browserz00_bgl {
   header_t header;
   obj_t widening;
   AvahiServiceBrowser * BgL_z42builtinz42;
   struct BgL_avahizd2clientzd2_bgl * BgL_clientz00;
   obj_t BgL_procz00;
   obj_t BgL_typez00;
   obj_t BgL_domainz00;
} *BgL_avahizd2servicezd2browserz00_bglt;

typedef struct BgL_avahizd2servicezd2typezd2browserzd2_bgl {
   header_t header;
   obj_t widening;
   AvahiServiceTypeBrowser * BgL_z42builtinz42;
   struct BgL_avahizd2clientzd2_bgl * BgL_clientz00;
   obj_t BgL_procz00;
   obj_t BgL_domainz00;
} *BgL_avahizd2servicezd2typezd2browserzd2_bglt;

typedef struct BgL_avahizd2domainzd2browserz00_bgl {
   header_t header;
   obj_t widening;
   AvahiDomainBrowser * BgL_z42builtinz42;
   struct BgL_avahizd2clientzd2_bgl * BgL_clientz00;
   obj_t BgL_procz00;
   obj_t BgL_btypez00;
   obj_t BgL_domainz00;
} *BgL_avahizd2domainzd2browserz00_bglt;

typedef struct BgL_avahizd2servicezd2resolverz00_bgl {
   header_t header;
   obj_t widening;
   AvahiServiceResolver * BgL_z42builtinz42;
   struct BgL_avahizd2clientzd2_bgl * BgL_clientz00;
   obj_t BgL_procz00;
   AvahiIfIndex BgL_interfacez00;
   obj_t BgL_protocolz00;
   obj_t BgL_namez00;
   obj_t BgL_typez00;
   obj_t BgL_domainz00;
} *BgL_avahizd2servicezd2resolverz00_bglt;


static obj_t BGl_z62lambda1928z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31959ze3ze1zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda1929z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32019ze3ze1zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62avahizd2threadedzd2pollzd2lockz12za2zz__avahi_avahiz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
BGL_IMPORT obj_t BGl_raisez00zz__errorz00(obj_t);
static obj_t BGl_z62zc3anonymousza31993ze3ze1zz__avahi_avahiz00(obj_t, obj_t);
static BgL_z62avahizd2errorzb0_bglt BGl_z62lambda1789z62zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2servicezd2resolverzd2closezd2zz__avahi_avahiz00(BgL_avahizd2servicezd2resolverz00_bglt);
static BgL_z62avahizd2errorzb0_bglt BGl_z62lambda1791z62zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62lambda1798z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda1799z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32054ze3ze1zz__avahi_avahiz00(obj_t);
BGL_EXPORTED_DECL obj_t bgl_avahi_resolver_event_to_symbol(AvahiResolverEvent);
BGL_EXPORTED_DEF obj_t BGl_avahizd2objectzd2zz__avahi_avahiz00 = BUNSPEC;
BGL_IMPORT void * BGl_z42pthreadzd2nilz90zz__pth_threadz00();
static obj_t BGl_z62avahizd2threadedzd2pollzd2quitzb0zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_avahi_lookup_result_flags_to_symbol(AvahiLookupResultFlags);
BGL_EXPORTED_DEF obj_t BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00 = BUNSPEC;
BGL_EXPORTED_DECL obj_t bgl_avahi_error(char *, char *, obj_t, int);
BGL_EXPORTED_DECL obj_t BGl_avahizd2entryzd2groupzd2closezd2zz__avahi_avahiz00(BgL_avahizd2entryzd2groupz00_bglt);
static obj_t BGl_objectzd2initzd2zz__avahi_avahiz00();
BGL_EXPORTED_DECL obj_t bgl_avahi_browser_event_to_symbol(AvahiBrowserEvent);
static obj_t BGl_z62zc3anonymousza32147ze3ze1zz__avahi_avahiz00(obj_t);
static obj_t BGl_za2avahizd2threadza2zd2zz__avahi_avahiz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_avahizd2entryzd2groupz00zz__avahi_avahiz00 = BUNSPEC;
static obj_t BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00 = BUNSPEC;
BGL_EXPORTED_DECL obj_t bgl_avahi_lookup_flags_to_symbol(AvahiLookupFlags);
static obj_t BGl_z62zc3anonymousza32165ze3ze1zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32076ze3ze1zz__avahi_avahiz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2simplezd2pollzd2quitzd2zz__avahi_avahiz00(BgL_avahizd2simplezd2pollz00_bglt);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_avahi_client_state_to_symbol(AvahiClientState);
BGL_EXPORTED_DECL obj_t BGl_avahizd2initzd2zz__avahi_avahiz00(BgL_avahizd2objectzd2_bglt);
BGL_EXPORTED_DECL obj_t BGl_avahizd2simplezd2pollzd2timeoutzd2zz__avahi_avahiz00(BgL_avahizd2simplezd2pollz00_bglt, long, obj_t);
static obj_t BGl_methodzd2initzd2zz__avahi_avahiz00();
static obj_t BGl_z62zc3anonymousza31810ze3ze1zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32094ze3ze1zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62avahizd2initzb0zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_z62avahizd2errorzb0zz__avahi_avahiz00 = BUNSPEC;
BGL_IMPORT bool_t BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_avahi_entry_group_state_to_symbol(AvahiEntryGroupState);
static obj_t BGl_z62avahizd2entryzd2groupzd2statezd2ze3symbolz81zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62avahizd2entryzd2groupzd2emptyzf3z43zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62avahizd2threadedzd2pollzd2loopzb0zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2100z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2104z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2105z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31831ze3ze1zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62zc3anonymousza31904ze3ze1zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62avahizd2initzd2avahizd2cli1261zb0zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_avahi_lock();
static obj_t BGl_z62lambda2110z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2111z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static BgL_avahizd2domainzd2browserz00_bglt BGl_z62lambda2118z62zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_remq_bang(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2entryzd2groupzd2commitzd2zz__avahi_avahiz00(BgL_avahizd2entryzd2groupz00_bglt);
static obj_t BGl_z62avahizd2threadedzd2pollzd2unlockz12za2zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62avahizd2lookupzd2resultzd2flagszd2ze3symbolz81zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62z52avahizd2signalze2zz__avahi_avahiz00(obj_t);
static BgL_avahizd2domainzd2browserz00_bglt BGl_z62lambda2121z62zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62zc3anonymousza31817ze3ze1zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2128z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2129z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62avahizd2error2365zb0zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_avahizd2simplezd2pollz00zz__avahi_avahiz00 = BUNSPEC;
static obj_t BGl_z62avahizd2initzd2avahizd2ent1263zb0zz__avahi_avahiz00(obj_t, obj_t);
static BgL_avahizd2clientzd2_bglt BGl_z62lambda2134z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31923ze3ze1zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62lambda2135z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2139z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00 = BUNSPEC;
static obj_t BGl_z62avahizd2simplezd2pollzd2quitzb0zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2simplezd2pollzd2loopzd2zz__avahi_avahiz00(BgL_avahizd2simplezd2pollz00_bglt);
static obj_t BGl_z62lambda2140z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31940ze3ze1zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2145z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2146z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62avahizd2domainzd2browserzd2closezb0zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2152z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2153z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_threadzd2startz12zc0zz__threadz00(BgL_threadz00_bglt, obj_t);
static obj_t BGl_z62avahizd2entryzd2groupzd2resetz12za2zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2clientzd2errorzd2messagezd2zz__avahi_avahiz00(BgL_avahizd2clientzd2_bglt);
static obj_t BGl_z62avahizd2threadedzd2pollzd2closezb0zz__avahi_avahiz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62avahizd2entryzd2groupzd2closezb0zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__avahi_avahiz00();
static BgL_avahizd2servicezd2resolverz00_bglt BGl_z62lambda2160z62zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_avahizd2servicezd2resolverz00_bglt BGl_z62lambda2163z62zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62avahizd2initzd2avahizd2dom1270zb0zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32002ze3ze1zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2170z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2171z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31838ze3ze1zz__avahi_avahiz00(obj_t);
static BgL_avahizd2clientzd2_bglt BGl_z62lambda2176z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2177z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_avahizd2gczd2unmarkz12z12zz__avahi_avahiz00(BgL_avahizd2objectzd2_bglt);
static obj_t BGl_z62lambda2181z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2182z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31944ze3ze1zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_avahizd2clientzd2zz__avahi_avahiz00 = BUNSPEC;
static obj_t BGl_z62lambda2186z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2187z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t void_star_to_obj(void *);
static obj_t BGl_z62lambda2191z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2192z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31945ze3ze1zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31856ze3ze1zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62lambda2196z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2197z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
static obj_t BGl_z62z52avahizd2threadzd2initz12z22zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62avahizd2clientzd2closez62zz__avahi_avahiz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
static BgL_z62avahizd2collisionzd2errorz62_bglt BGl_z62lambda1806z62zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31874ze3ze1zz__avahi_avahiz00(obj_t);
static BgL_z62avahizd2collisionzd2errorz62_bglt BGl_z62lambda1808z62zz__avahi_avahiz00(obj_t);
BGL_EXPORTED_DECL obj_t bgl_avahi_unlock();
static obj_t BGl_z62zc3anonymousza32112ze3ze1zz__avahi_avahiz00(obj_t);
BGL_EXPORTED_DECL obj_t bgl_avahi_if_index_to_symbol(AvahiIfIndex);
static obj_t BGl_z62avahizd2alternativezd2hostzd2namezb0zz__avahi_avahiz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_deletez12z12zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t, obj_t);
static BgL_avahizd2objectzd2_bglt BGl_z62lambda1815z62zz__avahi_avahiz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2simplezd2pollzd2closezd2zz__avahi_avahiz00(BgL_avahizd2simplezd2pollz00_bglt);
static BgL_avahizd2pollzd2_bglt BGl_z62lambda1822z62zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62avahizd2threadedzd2pollzd2timeoutzb0zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31892ze3ze1zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62zc3anonymousza31949ze3ze1zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda1829z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32130ze3ze1zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62avahizd2simplezd2pollzd2loopzb0zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda1830z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1836z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda1837z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62z52avahizd2lockz12zf0zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62zc3anonymousza32026ze3ze1zz__avahi_avahiz00(obj_t);
static BgL_avahizd2simplezd2pollz00_bglt BGl_z62lambda1844z62zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t);
static BgL_avahizd2simplezd2pollz00_bglt BGl_z62lambda1847z62zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62avahizd2servicezd2browserzd2closezb0zz__avahi_avahiz00(obj_t, obj_t);
extern AvahiStringList * bgl_avahi_list_to_string_list(obj_t);
static obj_t BGl_z62lambda1854z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31984ze3ze1zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda1855z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__avahi_avahiz00 = BUNSPEC;
static BgL_avahizd2threadedzd2pollz00_bglt BGl_z62lambda1862z62zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t);
static BgL_avahizd2threadedzd2pollz00_bglt BGl_z62lambda1865z62zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62zc3anonymousza31969ze3ze1zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52avahizd2threadzd2initz12z40zz__avahi_avahiz00();
static obj_t BGl_z62lambda1872z62zz__avahi_avahiz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1873z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static BgL_avahizd2clientzd2_bglt BGl_z62lambda1880z62zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_avahizd2clientzd2_bglt BGl_z62lambda1883z62zz__avahi_avahiz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_z62avahizd2collisionzd2errorz62zz__avahi_avahiz00 = BUNSPEC;
static obj_t BGl_toplevelzd2initzd2zz__avahi_avahiz00();
BGL_EXPORTED_DEF obj_t BGl_avahizd2pollzd2zz__avahi_avahiz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza32047ze3ze1zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32209ze3ze1zz__avahi_avahiz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2threadedzd2pollzd2lockz12zc0zz__avahi_avahiz00(BgL_avahizd2threadedzd2pollz00_bglt);
static obj_t BGl_z62lambda1890z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda1891z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static BgL_avahizd2pollzd2_bglt BGl_z62lambda1896z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda1897z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__avahi_avahiz00();
static obj_t BGl_z62zc3anonymousza32154ze3ze1zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62avahizd2ifzd2indexzd2ze3symbolz53zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62avahizd2initzd2avahizd2thr1259zb0zz__avahi_avahiz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62avahizd2simplezd2pollzd2timeoutzb0zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_avahizd2domainzd2browserz00zz__avahi_avahiz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_pthreadz00zz__pth_threadz00;
static obj_t BGl_z62zc3anonymousza31604ze3ze1zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62avahizd2entryzd2groupzd2commitzb0zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32172ze3ze1zz__avahi_avahiz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2clientzd2closez00zz__avahi_avahiz00(BgL_avahizd2clientzd2_bglt);
BGL_EXPORTED_DECL obj_t bgl_avahi_protocol_to_symbol(AvahiProtocol);
static obj_t BGl_z62zc3anonymousza31800ze3ze1zz__avahi_avahiz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2threadedzd2pollzd2unlockz12zc0zz__avahi_avahiz00(BgL_avahizd2threadedzd2pollz00_bglt);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_avahizd2servicezd2typezd2browserzd2zz__avahi_avahiz00 = BUNSPEC;
BGL_EXPORTED_DECL AvahiProtocol bgl_avahi_symbol_to_protocol(obj_t);
static obj_t BGl_z62avahizd2lookupzd2flagszd2ze3symbolz53zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_avahizd2servicezd2resolverz00zz__avahi_avahiz00 = BUNSPEC;
static obj_t BGl_z62avahizd2clientzd2statezd2ze3symbolz53zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32087ze3ze1zz__avahi_avahiz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_dssslzd2getzd2keyzd2restzd2argz00zz__dssslz00(obj_t, obj_t);
static obj_t BGl_z62avahizd2alternativezd2servicezd2namezb0zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62avahizd2simplezd2pollzd2closezb0zz__avahi_avahiz00(obj_t, obj_t);
extern void bgl_avahi_invoke_callbacks();
BGL_EXPORTED_DECL obj_t BGl_avahizd2threadedzd2pollzd2quitzd2zz__avahi_avahiz00(BgL_avahizd2threadedzd2pollz00_bglt);
static BgL_avahizd2entryzd2groupz00_bglt BGl_z62lambda2014z62zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62avahizd2browserzd2eventzd2ze3symbolz53zz__avahi_avahiz00(obj_t, obj_t);
static BgL_avahizd2entryzd2groupz00_bglt BGl_z62lambda2017z62zz__avahi_avahiz00(obj_t);
BGL_IMPORT obj_t BGl_callzd2virtualzd2setterz00zz__objectz00(BgL_objectz00_bglt, int, obj_t);
static obj_t BGl_z62lambda2024z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62avahizd2servicezd2resolverzd2closezb0zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2025z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static obj_t BGl_z62avahizd2initzd2avahizd2sim1257zb0zz__avahi_avahiz00(obj_t, obj_t);
static BgL_avahizd2clientzd2_bglt BGl_z62lambda2030z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2031z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2035z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31824ze3ze1zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2036z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62avahizd2resolverzd2eventzd2ze3symbolz53zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62avahizd2initzd2avahizd2ser1266zb0zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2201z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2202z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62avahizd2initzd2avahizd2ser1268zb0zz__avahi_avahiz00(obj_t, obj_t);
static BgL_avahizd2servicezd2browserz00_bglt BGl_z62lambda2042z62zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31930ze3ze1zz__avahi_avahiz00(obj_t);
static BgL_avahizd2servicezd2browserz00_bglt BGl_z62lambda2045z62zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62lambda2207z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2208z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__avahi_avahiz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pth_threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
static obj_t BGl_z62avahizd2init1254zb0zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2alternativezd2servicezd2namezd2zz__avahi_avahiz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2domainzd2browserzd2closezd2zz__avahi_avahiz00(BgL_avahizd2domainzd2browserz00_bglt);
BGL_IMPORT obj_t BGl_callzd2virtualzd2getterz00zz__objectz00(BgL_objectz00_bglt, int);
static obj_t BGl_z62avahizd2initzd2avahizd2ser1272zb0zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62avahizd2protocolzd2ze3symbolz81zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2052z62zz__avahi_avahiz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_z62errorz62zz__objectz00;
static obj_t BGl_z62lambda2053z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static BgL_avahizd2clientzd2_bglt BGl_z62lambda2058z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2059z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2alternativezd2hostzd2namezd2zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62lambda2063z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2064z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31916ze3ze1zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62lambda2068z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2069z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62avahizd2symbolzd2ze3protocolz81zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_avahizd2symbolzd2ze3domainzd2browserzd2typeze3zz__avahi_avahiz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2threadedzd2pollzd2timeoutzd2zz__avahi_avahiz00(BgL_avahizd2threadedzd2pollz00_bglt, long, obj_t);
static obj_t BGl_z62lambda2074z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2075z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_avahizd2servicezd2browserz00zz__avahi_avahiz00 = BUNSPEC;
static obj_t BGl_cnstzd2initzd2zz__avahi_avahiz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__avahi_avahiz00();
static obj_t BGl_za2avahizd2condvza2zd2zz__avahi_avahiz00 = BUNSPEC;
static obj_t BGl_z62z52avahizd2unlockz12zf0zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62zc3anonymousza31950ze3ze1zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static BgL_avahizd2servicezd2typezd2browserzd2_bglt BGl_z62lambda2082z62zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31934ze3ze1zz__avahi_avahiz00(obj_t, obj_t);
static BgL_avahizd2servicezd2typezd2browserzd2_bglt BGl_z62lambda2085z62zz__avahi_avahiz00(obj_t);
static obj_t BGl_za2avahizd2mutexza2zd2zz__avahi_avahiz00 = BUNSPEC;
static obj_t BGl_z62lambda2092z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31935ze3ze1zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2093z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_objectz00zz__objectz00;
static BgL_avahizd2clientzd2_bglt BGl_z62lambda2099z62zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2servicezd2browserzd2closezd2zz__avahi_avahiz00(BgL_avahizd2servicezd2browserz00_bglt);
static obj_t BGl_z62avahizd2entryzd2groupzd2addzd2servicez12z70zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62avahizd2clientzd2errorzd2messagezb0zz__avahi_avahiz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
BGL_EXPORTED_DECL bool_t BGl_avahizd2entryzd2groupzd2emptyzf3z21zz__avahi_avahiz00(BgL_avahizd2entryzd2groupz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_avahizd2threadedzd2pollzd2closezd2zz__avahi_avahiz00(BgL_avahizd2threadedzd2pollz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_avahizd2threadedzd2pollzd2loopzd2zz__avahi_avahiz00(BgL_avahizd2threadedzd2pollz00_bglt);
static obj_t BGl_z62zc3anonymousza31954ze3ze1zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31849ze3ze1zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31793ze3ze1zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31955ze3ze1zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31939ze3ze1zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_checkzd2errorze70z35zz__avahi_avahiz00(BgL_avahizd2entryzd2groupz00_bglt, int);
static obj_t BGl_z62zc3anonymousza31867ze3ze1zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda1902z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda1903z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2entryzd2groupzd2addzd2servicez12z12zz__avahi_avahiz00(BgL_avahizd2entryzd2groupz00_bglt, obj_t);
static obj_t BGl_z62lambda1908z62zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_avahi_signal();
static obj_t BGl_z62lambda1909z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31320ze3ze1zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62lambda1914z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda1915z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_threadz00zz__threadz00;
static obj_t BGl_z62zc3anonymousza31885ze3ze1zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32123ze3ze1zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2entryzd2groupzd2resetz12zc0zz__avahi_avahiz00(BgL_avahizd2entryzd2groupz00_bglt);
static obj_t BGl_z62lambda1921z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda1922z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31975ze3ze1zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t __cnst[ 101 ] ;


DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2lookupzd2resultzd2flagszd2ze3symbolzd2envz31zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2looku2678z00, BGl_z62avahizd2lookupzd2resultzd2flagszd2ze3symbolz81zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52avahizd2signalzd2envz52zz__avahi_avahiz00, BgL_bgl_za762za752avahiza7d2si2679za7, BGl_z62z52avahizd2signalze2zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2resolverzd2eventzd2ze3symbolzd2envze3zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2resol2680z00, BGl_z62avahizd2resolverzd2eventzd2ze3symbolz53zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2servicezd2browserzd2closezd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2servi2681z00, BGl_z62avahizd2servicezd2browserzd2closezb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52avahizd2lockz12zd2envz40zz__avahi_avahiz00, BgL_bgl_za762za752avahiza7d2lo2682za7, BGl_z62z52avahizd2lockz12zf0zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2servicezd2resolverzd2closezd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2servi2683z00, BGl_z62avahizd2servicezd2resolverzd2closezb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2500z00zz__avahi_avahiz00, BgL_bgl_string2500za700za7za7_2684za7, "Unknown protocol", 16 );
DEFINE_STRING( BGl_string2501z00zz__avahi_avahiz00, BgL_bgl_string2501za700za7za7_2685za7, "&avahi-protocol->symbol", 23 );
DEFINE_STRING( BGl_string2502z00zz__avahi_avahiz00, BgL_bgl_string2502za700za7za7_2686za7, "avahi-symbol->protocol", 22 );
DEFINE_STRING( BGl_string2503z00zz__avahi_avahiz00, BgL_bgl_string2503za700za7za7_2687za7, "&avahi-symbol->protocol", 23 );
DEFINE_STRING( BGl_string2504z00zz__avahi_avahiz00, BgL_bgl_string2504za700za7za7_2688za7, "symbol", 6 );
DEFINE_STRING( BGl_string2505z00zz__avahi_avahiz00, BgL_bgl_string2505za700za7za7_2689za7, "avahi-lookup-flags->symbol", 26 );
DEFINE_STRING( BGl_string2506z00zz__avahi_avahiz00, BgL_bgl_string2506za700za7za7_2690za7, "Unknown lookup-flag", 19 );
DEFINE_STRING( BGl_string2507z00zz__avahi_avahiz00, BgL_bgl_string2507za700za7za7_2691za7, "&avahi-lookup-flags->symbol", 27 );
DEFINE_STRING( BGl_string2508z00zz__avahi_avahiz00, BgL_bgl_string2508za700za7za7_2692za7, "avahi-lookup-result-flags->symbol", 33 );
DEFINE_STRING( BGl_string2509z00zz__avahi_avahiz00, BgL_bgl_string2509za700za7za7_2693za7, "Unknown lookup-result-flag", 26 );
DEFINE_STRING( BGl_string2510z00zz__avahi_avahiz00, BgL_bgl_string2510za700za7za7_2694za7, "&avahi-lookup-result-flags->symbol", 34 );
DEFINE_STRING( BGl_string2511z00zz__avahi_avahiz00, BgL_bgl_string2511za700za7za7_2695za7, "avahi-symbol->domain-browser-type", 33 );
DEFINE_STRING( BGl_string2512z00zz__avahi_avahiz00, BgL_bgl_string2512za700za7za7_2696za7, "Unknown btype", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2600z00zz__avahi_avahiz00, BgL_bgl_za762lambda2068za7622697z00, BGl_z62lambda2068z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2601z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72698za7, BGl_z62zc3anonymousza32076ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2602z00zz__avahi_avahiz00, BgL_bgl_za762lambda2075za7622699z00, BGl_z62lambda2075z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2603z00zz__avahi_avahiz00, BgL_bgl_za762lambda2074za7622700z00, BGl_z62lambda2074z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2604z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72701za7, BGl_z62zc3anonymousza32047ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2605z00zz__avahi_avahiz00, BgL_bgl_za762lambda2045za7622702z00, BGl_z62lambda2045z62zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2606z00zz__avahi_avahiz00, BgL_bgl_za762lambda2042za7622703z00, BGl_z62lambda2042z62zz__avahi_avahiz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2607z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72704za7, BGl_z62zc3anonymousza32094ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2608z00zz__avahi_avahiz00, BgL_bgl_za762lambda2093za7622705z00, BGl_z62lambda2093z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2609z00zz__avahi_avahiz00, BgL_bgl_za762lambda2092za7622706z00, BGl_z62lambda2092z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2simplezd2pollzd2timeoutzd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2simpl2707z00, BGl_z62avahizd2simplezd2pollzd2timeoutzb0zz__avahi_avahiz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2610z00zz__avahi_avahiz00, BgL_bgl_za762lambda2100za7622708z00, BGl_z62lambda2100z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2611z00zz__avahi_avahiz00, BgL_bgl_za762lambda2099za7622709z00, BGl_z62lambda2099z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2612z00zz__avahi_avahiz00, BgL_bgl_za762lambda2105za7622710z00, BGl_z62lambda2105z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2613z00zz__avahi_avahiz00, BgL_bgl_za762lambda2104za7622711z00, BGl_z62lambda2104z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2614z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72712za7, BGl_z62zc3anonymousza32112ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2615z00zz__avahi_avahiz00, BgL_bgl_za762lambda2111za7622713z00, BGl_z62lambda2111z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2616z00zz__avahi_avahiz00, BgL_bgl_za762lambda2110za7622714z00, BGl_z62lambda2110z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2617z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72715za7, BGl_z62zc3anonymousza32087ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2618z00zz__avahi_avahiz00, BgL_bgl_za762lambda2085za7622716z00, BGl_z62lambda2085z62zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2619z00zz__avahi_avahiz00, BgL_bgl_za762lambda2082za7622717z00, BGl_z62lambda2082z62zz__avahi_avahiz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2620z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72718za7, BGl_z62zc3anonymousza32130ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2621z00zz__avahi_avahiz00, BgL_bgl_za762lambda2129za7622719z00, BGl_z62lambda2129z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2622z00zz__avahi_avahiz00, BgL_bgl_za762lambda2128za7622720z00, BGl_z62lambda2128z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2623z00zz__avahi_avahiz00, BgL_bgl_za762lambda2135za7622721z00, BGl_z62lambda2135z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2624z00zz__avahi_avahiz00, BgL_bgl_za762lambda2134za7622722z00, BGl_z62lambda2134z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2625z00zz__avahi_avahiz00, BgL_bgl_za762lambda2140za7622723z00, BGl_z62lambda2140z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2626z00zz__avahi_avahiz00, BgL_bgl_za762lambda2139za7622724z00, BGl_z62lambda2139z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2alternativezd2hostzd2namezd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2alter2725z00, BGl_z62avahizd2alternativezd2hostzd2namezb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2627z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72726za7, BGl_z62zc3anonymousza32147ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2628z00zz__avahi_avahiz00, BgL_bgl_za762lambda2146za7622727z00, BGl_z62lambda2146z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2629z00zz__avahi_avahiz00, BgL_bgl_za762lambda2145za7622728z00, BGl_z62lambda2145z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2threadedzd2pollzd2lockz12zd2envz12zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2threa2729z00, BGl_z62avahizd2threadedzd2pollzd2lockz12za2zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2630z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72730za7, BGl_z62zc3anonymousza32154ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2631z00zz__avahi_avahiz00, BgL_bgl_za762lambda2153za7622731z00, BGl_z62lambda2153z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2632z00zz__avahi_avahiz00, BgL_bgl_za762lambda2152za7622732z00, BGl_z62lambda2152z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2633z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72733za7, BGl_z62zc3anonymousza32123ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2634z00zz__avahi_avahiz00, BgL_bgl_za762lambda2121za7622734z00, BGl_z62lambda2121z62zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2635z00zz__avahi_avahiz00, BgL_bgl_za762lambda2118za7622735z00, BGl_z62lambda2118z62zz__avahi_avahiz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2636z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72736za7, BGl_z62zc3anonymousza32172ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2637z00zz__avahi_avahiz00, BgL_bgl_za762lambda2171za7622737z00, BGl_z62lambda2171z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2638z00zz__avahi_avahiz00, BgL_bgl_za762lambda2170za7622738z00, BGl_z62lambda2170z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2639z00zz__avahi_avahiz00, BgL_bgl_za762lambda2177za7622739z00, BGl_z62lambda2177z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2entryzd2groupzd2emptyzf3zd2envzf3zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2entry2740z00, BGl_z62avahizd2entryzd2groupzd2emptyzf3z43zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2640z00zz__avahi_avahiz00, BgL_bgl_za762lambda2176za7622741z00, BGl_z62lambda2176z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2641z00zz__avahi_avahiz00, BgL_bgl_za762lambda2182za7622742z00, BGl_z62lambda2182z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2642z00zz__avahi_avahiz00, BgL_bgl_za762lambda2181za7622743z00, BGl_z62lambda2181z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2643z00zz__avahi_avahiz00, BgL_bgl_za762lambda2187za7622744z00, BGl_z62lambda2187z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2644z00zz__avahi_avahiz00, BgL_bgl_za762lambda2186za7622745z00, BGl_z62lambda2186z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2645z00zz__avahi_avahiz00, BgL_bgl_za762lambda2192za7622746z00, BGl_z62lambda2192z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2646z00zz__avahi_avahiz00, BgL_bgl_za762lambda2191za7622747z00, BGl_z62lambda2191z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2647z00zz__avahi_avahiz00, BgL_bgl_za762lambda2197za7622748z00, BGl_z62lambda2197z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2648z00zz__avahi_avahiz00, BgL_bgl_za762lambda2196za7622749z00, BGl_z62lambda2196z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2649z00zz__avahi_avahiz00, BgL_bgl_za762lambda2202za7622750z00, BGl_z62lambda2202z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2browserzd2eventzd2ze3symbolzd2envze3zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2brows2751z00, BGl_z62avahizd2browserzd2eventzd2ze3symbolz53zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2650z00zz__avahi_avahiz00, BgL_bgl_za762lambda2201za7622752z00, BGl_z62lambda2201z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2651z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72753za7, BGl_z62zc3anonymousza32209ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2652z00zz__avahi_avahiz00, BgL_bgl_za762lambda2208za7622754z00, BGl_z62lambda2208z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2653z00zz__avahi_avahiz00, BgL_bgl_za762lambda2207za7622755z00, BGl_z62lambda2207z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2654z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72756za7, BGl_z62zc3anonymousza32165ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2655z00zz__avahi_avahiz00, BgL_bgl_za762lambda2163za7622757z00, BGl_z62lambda2163z62zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2656z00zz__avahi_avahiz00, BgL_bgl_za762lambda2160za7622758z00, BGl_z62lambda2160z62zz__avahi_avahiz00, 0L, BUNSPEC, 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2659z00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2init12759z00, BGl_z62avahizd2init1254zb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2663z00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2initza72760za7, BGl_z62avahizd2initzd2avahizd2sim1257zb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2665z00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2initza72761za7, BGl_z62avahizd2initzd2avahizd2thr1259zb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2666z00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2initza72762za7, BGl_z62avahizd2initzd2avahizd2cli1261zb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2667z00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2initza72763za7, BGl_z62avahizd2initzd2avahizd2ent1263zb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2668z00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2initza72764za7, BGl_z62avahizd2initzd2avahizd2ser1266zb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2669z00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2initza72765za7, BGl_z62avahizd2initzd2avahizd2ser1268zb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2670z00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2initza72766za7, BGl_z62avahizd2initzd2avahizd2dom1270zb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2671z00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2initza72767za7, BGl_z62avahizd2initzd2avahizd2ser1272zb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2threadedzd2pollzd2timeoutzd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2threa2768z00, BGl_z62avahizd2threadedzd2pollzd2timeoutzb0zz__avahi_avahiz00, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2entryzd2groupzd2commitzd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2entry2769z00, BGl_z62avahizd2entryzd2groupzd2commitzb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2threadedzd2pollzd2closezd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2threa2770z00, BGl_z62avahizd2threadedzd2pollzd2closezb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2initza72771za7, BGl_z62avahizd2initzb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2lookupzd2flagszd2ze3symbolzd2envze3zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2looku2772z00, BGl_z62avahizd2lookupzd2flagszd2ze3symbolz53zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52avahizd2threadzd2initz12zd2envz92zz__avahi_avahiz00, BgL_bgl_za762za752avahiza7d2th2773za7, BGl_z62z52avahizd2threadzd2initz12z22zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2alternativezd2servicezd2namezd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2alter2774z00, BGl_z62avahizd2alternativezd2servicezd2namezb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2simplezd2pollzd2closezd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2simpl2775z00, BGl_z62avahizd2simplezd2pollzd2closezb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2domainzd2browserzd2closezd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2domai2776z00, BGl_z62avahizd2domainzd2browserzd2closezb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52avahizd2unlockz12zd2envz40zz__avahi_avahiz00, BgL_bgl_za762za752avahiza7d2un2777za7, BGl_z62z52avahizd2unlockz12zf0zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2threadedzd2pollzd2unlockz12zd2envz12zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2threa2778z00, BGl_z62avahizd2threadedzd2pollzd2unlockz12za2zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2simplezd2pollzd2loopzd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2simpl2779z00, BGl_z62avahizd2simplezd2pollzd2loopzb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2threadedzd2pollzd2loopzd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2threa2780z00, BGl_z62avahizd2threadedzd2pollzd2loopzb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2errorzd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2error2781z00, BGl_z62avahizd2error2365zb0zz__avahi_avahiz00, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2ifzd2indexzd2ze3symbolzd2envze3zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2ifza7d22782za7, BGl_z62avahizd2ifzd2indexzd2ze3symbolz53zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2clientzd2closezd2envzd2zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2clien2783z00, BGl_z62avahizd2clientzd2closez62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2513z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72784za7, BGl_z62zc3anonymousza31800ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2514z00zz__avahi_avahiz00, BgL_bgl_za762lambda1799za7622785z00, BGl_z62lambda1799z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2515z00zz__avahi_avahiz00, BgL_bgl_za762lambda1798za7622786z00, BGl_z62lambda1798z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2516z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72787za7, BGl_z62zc3anonymousza31793ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2517z00zz__avahi_avahiz00, BgL_bgl_za762lambda1791za7622788z00, BGl_z62lambda1791z62zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2518z00zz__avahi_avahiz00, BgL_bgl_za762lambda1789za7622789z00, BGl_z62lambda1789z62zz__avahi_avahiz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2519z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72790za7, BGl_z62zc3anonymousza31810ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2446z00zz__avahi_avahiz00, BgL_bgl_string2446za700za7za7_2791za7, "Llib/avahi.scm", 14 );
DEFINE_STRING( BGl_string2447z00zz__avahi_avahiz00, BgL_bgl_string2447za700za7za7_2792za7, "/builddir/build/BUILD/bigloo4.3f/api/avahi/src/Llib/avahi.scm", 61 );
DEFINE_STRING( BGl_string2448z00zz__avahi_avahiz00, BgL_bgl_string2448za700za7za7_2793za7, "&avahi-error2365", 16 );
DEFINE_STRING( BGl_string2449z00zz__avahi_avahiz00, BgL_bgl_string2449za700za7za7_2794za7, "bstring", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2520z00zz__avahi_avahiz00, BgL_bgl_za762lambda1808za7622795z00, BGl_z62lambda1808z62zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2521z00zz__avahi_avahiz00, BgL_bgl_za762lambda1806za7622796z00, BGl_z62lambda1806z62zz__avahi_avahiz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2522z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72797za7, BGl_z62zc3anonymousza31817ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2523z00zz__avahi_avahiz00, BgL_bgl_za762lambda1815za7622798z00, BGl_z62lambda1815z62zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2524z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72799za7, BGl_z62zc3anonymousza31831ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2525z00zz__avahi_avahiz00, BgL_bgl_za762lambda1830za7622800z00, BGl_z62lambda1830z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2450z00zz__avahi_avahiz00, BgL_bgl_string2450za700za7za7_2801za7, "bint", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2526z00zz__avahi_avahiz00, BgL_bgl_za762lambda1829za7622802z00, BGl_z62lambda1829z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2451z00zz__avahi_avahiz00, BgL_bgl_string2451za700za7za7_2803za7, "avahi", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2527z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72804za7, BGl_z62zc3anonymousza31838ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2452z00zz__avahi_avahiz00, BgL_bgl_string2452za700za7za7_2805za7, "&avahi-simple-poll-close", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2528z00zz__avahi_avahiz00, BgL_bgl_za762lambda1837za7622806z00, BGl_z62lambda1837z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2453z00zz__avahi_avahiz00, BgL_bgl_string2453za700za7za7_2807za7, "avahi-simple-poll", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2529z00zz__avahi_avahiz00, BgL_bgl_za762lambda1836za7622808z00, BGl_z62lambda1836z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2454z00zz__avahi_avahiz00, BgL_bgl_string2454za700za7za7_2809za7, "&avahi-simple-poll-loop", 23 );
DEFINE_STRING( BGl_string2455z00zz__avahi_avahiz00, BgL_bgl_string2455za700za7za7_2810za7, "avahi-simple-poll-timeout", 25 );
DEFINE_STRING( BGl_string2456z00zz__avahi_avahiz00, BgL_bgl_string2456za700za7za7_2811za7, "Illegal callback", 16 );
DEFINE_STRING( BGl_string2457z00zz__avahi_avahiz00, BgL_bgl_string2457za700za7za7_2812za7, "&avahi-simple-poll-timeout", 26 );
BGL_IMPORT obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_STRING( BGl_string2458z00zz__avahi_avahiz00, BgL_bgl_string2458za700za7za7_2813za7, "procedure", 9 );
DEFINE_STRING( BGl_string2459z00zz__avahi_avahiz00, BgL_bgl_string2459za700za7za7_2814za7, "&avahi-simple-poll-quit", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2530z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72815za7, BGl_z62zc3anonymousza31824ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2531z00zz__avahi_avahiz00, BgL_bgl_za762lambda1822za7622816z00, BGl_z62lambda1822z62zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2532z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72817za7, BGl_z62zc3anonymousza31856ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2533z00zz__avahi_avahiz00, BgL_bgl_za762lambda1855za7622818z00, BGl_z62lambda1855z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2534z00zz__avahi_avahiz00, BgL_bgl_za762lambda1854za7622819z00, BGl_z62lambda1854z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2535z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72820za7, BGl_z62zc3anonymousza31849ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2460z00zz__avahi_avahiz00, BgL_bgl_string2460za700za7za7_2821za7, "&avahi-threaded-poll-close", 26 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2536z00zz__avahi_avahiz00, BgL_bgl_za762lambda1847za7622822z00, BGl_z62lambda1847z62zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2461z00zz__avahi_avahiz00, BgL_bgl_string2461za700za7za7_2823za7, "avahi-threaded-poll", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2537z00zz__avahi_avahiz00, BgL_bgl_za762lambda1844za7622824z00, BGl_z62lambda1844z62zz__avahi_avahiz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string2462z00zz__avahi_avahiz00, BgL_bgl_string2462za700za7za7_2825za7, "&avahi-threaded-poll-loop", 25 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2538z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72826za7, BGl_z62zc3anonymousza31874ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2463z00zz__avahi_avahiz00, BgL_bgl_string2463za700za7za7_2827za7, "&avahi-threaded-poll-lock!", 26 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2539z00zz__avahi_avahiz00, BgL_bgl_za762lambda1873za7622828z00, BGl_z62lambda1873z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2464z00zz__avahi_avahiz00, BgL_bgl_string2464za700za7za7_2829za7, "&avahi-threaded-poll-unlock!", 28 );
DEFINE_STRING( BGl_string2465z00zz__avahi_avahiz00, BgL_bgl_string2465za700za7za7_2830za7, "avahi-threaded-poll-timeout", 27 );
DEFINE_STRING( BGl_string2466z00zz__avahi_avahiz00, BgL_bgl_string2466za700za7za7_2831za7, "&avahi-threaded-poll-timeout", 28 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2entryzd2groupzd2resetz12zd2envz12zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2entry2832z00, BGl_z62avahizd2entryzd2groupzd2resetz12za2zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2467z00zz__avahi_avahiz00, BgL_bgl_string2467za700za7za7_2833za7, "&avahi-threaded-poll-quit", 25 );
DEFINE_STRING( BGl_string2468z00zz__avahi_avahiz00, BgL_bgl_string2468za700za7za7_2834za7, "&avahi-client-close", 19 );
DEFINE_STRING( BGl_string2469z00zz__avahi_avahiz00, BgL_bgl_string2469za700za7za7_2835za7, "avahi-client", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2540z00zz__avahi_avahiz00, BgL_bgl_za762lambda1872za7622836z00, BGl_z62lambda1872z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2541z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72837za7, BGl_z62zc3anonymousza31867ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2542z00zz__avahi_avahiz00, BgL_bgl_za762lambda1865za7622838z00, BGl_z62lambda1865z62zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2543z00zz__avahi_avahiz00, BgL_bgl_za762lambda1862za7622839z00, BGl_z62lambda1862z62zz__avahi_avahiz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2544z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72840za7, BGl_z62zc3anonymousza31892ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2545z00zz__avahi_avahiz00, BgL_bgl_za762lambda1891za7622841z00, BGl_z62lambda1891z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2470z00zz__avahi_avahiz00, BgL_bgl_string2470za700za7za7_2842za7, "&avahi-client-error-message", 27 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2546z00zz__avahi_avahiz00, BgL_bgl_za762lambda1890za7622843z00, BGl_z62lambda1890z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2471z00zz__avahi_avahiz00, BgL_bgl_string2471za700za7za7_2844za7, "avahi-client-state->symbol", 26 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2547z00zz__avahi_avahiz00, BgL_bgl_za762lambda1897za7622845z00, BGl_z62lambda1897z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2472z00zz__avahi_avahiz00, BgL_bgl_string2472za700za7za7_2846za7, "Unknown state", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2548z00zz__avahi_avahiz00, BgL_bgl_za762lambda1896za7622847z00, BGl_z62lambda1896z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2473z00zz__avahi_avahiz00, BgL_bgl_string2473za700za7za7_2848za7, "&avahi-client-state->symbol", 27 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2549z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72849za7, BGl_z62zc3anonymousza31904ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2474z00zz__avahi_avahiz00, BgL_bgl_string2474za700za7za7_2850za7, "&avahi-entry-group-close", 24 );
DEFINE_STRING( BGl_string2475z00zz__avahi_avahiz00, BgL_bgl_string2475za700za7za7_2851za7, "avahi-entry-group", 17 );
DEFINE_STRING( BGl_string2476z00zz__avahi_avahiz00, BgL_bgl_string2476za700za7za7_2852za7, "&avahi-entry-group-empty?", 25 );
DEFINE_STRING( BGl_string2477z00zz__avahi_avahiz00, BgL_bgl_string2477za700za7za7_2853za7, "&avahi-entry-group-commit", 25 );
DEFINE_STRING( BGl_string2478z00zz__avahi_avahiz00, BgL_bgl_string2478za700za7za7_2854za7, "&avahi-entry-group-reset!", 25 );
DEFINE_STRING( BGl_string2479z00zz__avahi_avahiz00, BgL_bgl_string2479za700za7za7_2855za7, "avahi-entry-group-add-service", 29 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2protocolzd2ze3symbolzd2envz31zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2proto2856z00, BGl_z62avahizd2protocolzd2ze3symbolz81zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2550z00zz__avahi_avahiz00, BgL_bgl_za762lambda1903za7622857z00, BGl_z62lambda1903z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2551z00zz__avahi_avahiz00, BgL_bgl_za762lambda1902za7622858z00, BGl_z62lambda1902z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2552z00zz__avahi_avahiz00, BgL_bgl_za762lambda1909za7622859z00, BGl_z62lambda1909z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2553z00zz__avahi_avahiz00, BgL_bgl_za762lambda1908za7622860z00, BGl_z62lambda1908z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2554z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72861za7, BGl_z62zc3anonymousza31916ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2555z00zz__avahi_avahiz00, BgL_bgl_za762lambda1915za7622862z00, BGl_z62lambda1915z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2480z00zz__avahi_avahiz00, BgL_bgl_string2480za700za7za7_2863za7, "&avahi-entry-group-add-service!", 31 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2556z00zz__avahi_avahiz00, BgL_bgl_za762lambda1914za7622864z00, BGl_z62lambda1914z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2481z00zz__avahi_avahiz00, BgL_bgl_string2481za700za7za7_2865za7, "avahi-entry-group-state->symbol", 31 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2557z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72866za7, BGl_z62zc3anonymousza31923ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2482z00zz__avahi_avahiz00, BgL_bgl_string2482za700za7za7_2867za7, "&avahi-entry-group-state->symbol", 32 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2558z00zz__avahi_avahiz00, BgL_bgl_za762lambda1922za7622868z00, BGl_z62lambda1922z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2483z00zz__avahi_avahiz00, BgL_bgl_string2483za700za7za7_2869za7, "&avahi-alternative-host-name", 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2559z00zz__avahi_avahiz00, BgL_bgl_za762lambda1921za7622870z00, BGl_z62lambda1921z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2484z00zz__avahi_avahiz00, BgL_bgl_string2484za700za7za7_2871za7, "&avahi-alternative-service-name", 31 );
DEFINE_STRING( BGl_string2485z00zz__avahi_avahiz00, BgL_bgl_string2485za700za7za7_2872za7, "&avahi-service-browser-close", 28 );
DEFINE_STRING( BGl_string2486z00zz__avahi_avahiz00, BgL_bgl_string2486za700za7za7_2873za7, "avahi-service-browser", 21 );
DEFINE_STRING( BGl_string2487z00zz__avahi_avahiz00, BgL_bgl_string2487za700za7za7_2874za7, "&avahi-domain-browser-close", 27 );
DEFINE_STRING( BGl_string2488z00zz__avahi_avahiz00, BgL_bgl_string2488za700za7za7_2875za7, "avahi-domain-browser", 20 );
DEFINE_STRING( BGl_string2489z00zz__avahi_avahiz00, BgL_bgl_string2489za700za7za7_2876za7, "&avahi-service-resolver-close", 29 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2clientzd2errorzd2messagezd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2clien2877z00, BGl_z62avahizd2clientzd2errorzd2messagezb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2560z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72878za7, BGl_z62zc3anonymousza31930ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2561z00zz__avahi_avahiz00, BgL_bgl_za762lambda1929za7622879z00, BGl_z62lambda1929z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2562z00zz__avahi_avahiz00, BgL_bgl_za762lambda1928za7622880z00, BGl_z62lambda1928z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2563z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72881za7, BGl_z62zc3anonymousza31935ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2564z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72882za7, BGl_z62zc3anonymousza31934ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2565z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72883za7, BGl_z62zc3anonymousza31940ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2490z00zz__avahi_avahiz00, BgL_bgl_string2490za700za7za7_2884za7, "avahi-service-resolver", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2566z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72885za7, BGl_z62zc3anonymousza31939ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2491z00zz__avahi_avahiz00, BgL_bgl_string2491za700za7za7_2886za7, "avahi-browser-event->symbol", 27 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2567z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72887za7, BGl_z62zc3anonymousza31945ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2492z00zz__avahi_avahiz00, BgL_bgl_string2492za700za7za7_2888za7, "Unknown event", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2568z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72889za7, BGl_z62zc3anonymousza31944ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2493z00zz__avahi_avahiz00, BgL_bgl_string2493za700za7za7_2890za7, "&avahi-browser-event->symbol", 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2569z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72891za7, BGl_z62zc3anonymousza31950ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2494z00zz__avahi_avahiz00, BgL_bgl_string2494za700za7za7_2892za7, "avahi-resolver-event->symbol", 28 );
DEFINE_STRING( BGl_string2657z00zz__avahi_avahiz00, BgL_bgl_string2657za700za7za7_2893za7, "", 0 );
DEFINE_STRING( BGl_string2495z00zz__avahi_avahiz00, BgL_bgl_string2495za700za7za7_2894za7, "&avahi-resolver-event->symbol", 29 );
DEFINE_STRING( BGl_string2658z00zz__avahi_avahiz00, BgL_bgl_string2658za700za7za7_2895za7, "nil", 3 );
DEFINE_STRING( BGl_string2496z00zz__avahi_avahiz00, BgL_bgl_string2496za700za7za7_2896za7, "avahi-if-index->symbol", 22 );
DEFINE_STRING( BGl_string2497z00zz__avahi_avahiz00, BgL_bgl_string2497za700za7za7_2897za7, "Unknown index", 13 );
DEFINE_STRING( BGl_string2498z00zz__avahi_avahiz00, BgL_bgl_string2498za700za7za7_2898za7, "&avahi-if-index->symbol", 23 );
DEFINE_STRING( BGl_string2499z00zz__avahi_avahiz00, BgL_bgl_string2499za700za7za7_2899za7, "avahi-protocol->symbol", 22 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2symbolzd2ze3protocolzd2envz31zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2symbo2900z00, BGl_z62avahizd2symbolzd2ze3protocolz81zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2570z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72901za7, BGl_z62zc3anonymousza31949ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2571z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72902za7, BGl_z62zc3anonymousza31955ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2572z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72903za7, BGl_z62zc3anonymousza31954ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2660z00zz__avahi_avahiz00, BgL_bgl_string2660za700za7za7_2904za7, "avahi-init1254", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2573z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72905za7, BGl_z62zc3anonymousza31959ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2661z00zz__avahi_avahiz00, BgL_bgl_string2661za700za7za7_2906za7, "&avahi-init", 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2574z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72907za7, BGl_z62zc3anonymousza31969ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2662z00zz__avahi_avahiz00, BgL_bgl_string2662za700za7za7_2908za7, "avahi-object", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2575z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72909za7, BGl_z62zc3anonymousza31975ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2576z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72910za7, BGl_z62zc3anonymousza31984ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2664z00zz__avahi_avahiz00, BgL_bgl_string2664za700za7za7_2911za7, "avahi-init", 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2577z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72912za7, BGl_z62zc3anonymousza31993ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2578z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72913za7, BGl_z62zc3anonymousza32002ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2579z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72914za7, BGl_z62zc3anonymousza31885ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2580z00zz__avahi_avahiz00, BgL_bgl_za762lambda1883za7622915z00, BGl_z62lambda1883z62zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2581z00zz__avahi_avahiz00, BgL_bgl_za762lambda1880za7622916z00, BGl_z62lambda1880z62zz__avahi_avahiz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2582z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72917za7, BGl_z62zc3anonymousza32026ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2583z00zz__avahi_avahiz00, BgL_bgl_za762lambda2025za7622918z00, BGl_z62lambda2025z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2584z00zz__avahi_avahiz00, BgL_bgl_za762lambda2024za7622919z00, BGl_z62lambda2024z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2672z00zz__avahi_avahiz00, BgL_bgl_string2672za700za7za7_2920za7, "avahi-service-type-browser", 26 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2585z00zz__avahi_avahiz00, BgL_bgl_za762lambda2031za7622921z00, BGl_z62lambda2031z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2673z00zz__avahi_avahiz00, BgL_bgl_string2673za700za7za7_2922za7, "avahi-client-init", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2586z00zz__avahi_avahiz00, BgL_bgl_za762lambda2030za7622923z00, BGl_z62lambda2030z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2674z00zz__avahi_avahiz00, BgL_bgl_string2674za700za7za7_2924za7, "none nil avahi-domain-browser-browse _ avahi-service-resolver name protocol $avahi-if-index interface $avahi-service-resolver avahi-domain-browser $avahi-domain-browser avahi-service-type-browser $avahi-service-type-browser avahi-service-browser domain type $avahi-service-browser avahi-entry-group client $avahi-entry-group avahi-client state hostname-fqdn domainname hostname bstring version resolvers %browsers %groups procedure proc symbol flags poll $avahi-client avahi-threaded-poll $avahi-threaded-poll avahi-simple-poll $avahi-simple-poll $builtin avahi-poll pair-nil %procs $ctype avahi-object &avahi-collision-error __avahi_avahi &avahi-error int errno (quote avahi-domain-browser-max) (quote avahi-domain-browser-browse-legacy) (quote avahi-domain-browser-register-default) (quote avahi-domain-browser-register) (quote avahi-domain-browser-browse-default) (quote avahi-domain-browser-browse) btype eq? avahi-lookup-result-default avahi-lookup-result-static avahi-lookup-result-our-own avahi-lookup-result-local av"
"ahi-lookup-result-multicast avahi-lookup-result-wide-area avahi-lookup-result-cached avahi-lookup-default avahi-lookup-no-address avahi-lookup-no-txt avahi-proto-unspec avahi-proto-inet6 avahi-proto-inet avahi-if-unspec avahi-resolver-failure avahi-resolver-found avahi-browser-failure avahi-browser-all-for-now avahi-browser-cache-exhausted avahi-browser-remove avahi-browser-new avahi-entry-group-failure avahi-entry-group-collision avahi-entry-group-established avahi-entry-group-registering avahi-entry-group-uncommited (:subtype :port :host :domain :type :name) :subtype :port :host :domain :type :name avahi-client-connecting avahi-client-failure avahi-client-collision avahi-client-running avahi-client-registering condition-variable mutex avahi ", 1777 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2587z00zz__avahi_avahiz00, BgL_bgl_za762lambda2036za7622925z00, BGl_z62lambda2036z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2588z00zz__avahi_avahiz00, BgL_bgl_za762lambda2035za7622926z00, BGl_z62lambda2035z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2589z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72927za7, BGl_z62zc3anonymousza32019ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2590z00zz__avahi_avahiz00, BgL_bgl_za762lambda2017za7622928z00, BGl_z62lambda2017z62zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2591z00zz__avahi_avahiz00, BgL_bgl_za762lambda2014za7622929z00, BGl_z62lambda2014z62zz__avahi_avahiz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2592z00zz__avahi_avahiz00, BgL_bgl_za762za7c3anonymousza72930za7, BGl_z62zc3anonymousza32054ze3ze1zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2593z00zz__avahi_avahiz00, BgL_bgl_za762lambda2053za7622931z00, BGl_z62lambda2053z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2594z00zz__avahi_avahiz00, BgL_bgl_za762lambda2052za7622932z00, BGl_z62lambda2052z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2595z00zz__avahi_avahiz00, BgL_bgl_za762lambda2059za7622933z00, BGl_z62lambda2059z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2596z00zz__avahi_avahiz00, BgL_bgl_za762lambda2058za7622934z00, BGl_z62lambda2058z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2597z00zz__avahi_avahiz00, BgL_bgl_za762lambda2064za7622935z00, BGl_z62lambda2064z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2598z00zz__avahi_avahiz00, BgL_bgl_za762lambda2063za7622936z00, BGl_z62lambda2063z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2599z00zz__avahi_avahiz00, BgL_bgl_za762lambda2069za7622937z00, BGl_z62lambda2069z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2entryzd2groupzd2statezd2ze3symbolzd2envz31zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2entry2938z00, BGl_z62avahizd2entryzd2groupzd2statezd2ze3symbolz81zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2simplezd2pollzd2quitzd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2simpl2939z00, BGl_z62avahizd2simplezd2pollzd2quitzb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2entryzd2groupzd2addzd2servicez12zd2envzc0zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2entry2940z00, va_generic_entry, BGl_z62avahizd2entryzd2groupzd2addzd2servicez12z70zz__avahi_avahiz00, BUNSPEC, -2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2clientzd2statezd2ze3symbolzd2envze3zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2clien2941z00, BGl_z62avahizd2clientzd2statezd2ze3symbolz53zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2entryzd2groupzd2closezd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2entry2942z00, BGl_z62avahizd2entryzd2groupzd2closezb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2threadedzd2pollzd2quitzd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2threa2943z00, BGl_z62avahizd2threadedzd2pollzd2quitzb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_equalzf3zd2envz21zz__r4_equivalence_6_2z00;

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_avahizd2objectzd2zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_za2avahizd2threadza2zd2zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_avahizd2entryzd2groupz00zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_z62avahizd2errorzb0zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_avahizd2simplezd2pollz00zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_avahizd2clientzd2zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_z62avahizd2collisionzd2errorz62zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_avahizd2pollzd2zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_avahizd2domainzd2browserz00zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_avahizd2servicezd2typezd2browserzd2zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_avahizd2servicezd2resolverz00zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_avahizd2servicezd2browserz00zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_za2avahizd2condvza2zd2zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_za2avahizd2mutexza2zd2zz__avahi_avahiz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__avahi_avahiz00(long BgL_checksumz00_2993, char * BgL_fromz00_2994)
{ BGL_FUNCTION_BEGIN;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__avahi_avahiz00))
{ 
BGl_requirezd2initializa7ationz75zz__avahi_avahiz00 = 
BBOOL(((bool_t)0)); 
BGL_GC_INIT(); 
BGl_gczd2rootszd2initz00zz__avahi_avahiz00(); 
BGl_libraryzd2moduleszd2initz00zz__avahi_avahiz00(); 
BGl_cnstzd2initzd2zz__avahi_avahiz00(); 
BGl_objectzd2initzd2zz__avahi_avahiz00(); 
BGl_genericzd2initzd2zz__avahi_avahiz00(); 
BGl_methodzd2initzd2zz__avahi_avahiz00(); 
return 
BGl_toplevelzd2initzd2zz__avahi_avahiz00();}  else 
{ 
return BUNSPEC;} } 
BGL_FUNCTION_END;
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__avahi_avahiz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 15 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__dssslz00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__avahi_avahi"); 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__avahi_avahiz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 15 */
{ /* Llib/avahi.scm 15 */
obj_t BgL_cportz00_2615;
{ /* Llib/avahi.scm 15 */
obj_t BgL_stringz00_2623;
BgL_stringz00_2623 = BGl_string2674z00zz__avahi_avahiz00; 
{ /* Llib/avahi.scm 15 */
obj_t BgL_startz00_2624;
BgL_startz00_2624 = 
BINT(((long)0)); 
{ /* Llib/avahi.scm 15 */
obj_t BgL_endz00_2625;
BgL_endz00_2625 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_2623))); 
{ /* Llib/avahi.scm 15 */

BgL_cportz00_2615 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_2623, BgL_startz00_2624, BgL_endz00_2625); } } } } 
{ 
long BgL_iz00_2616;
BgL_iz00_2616 = ((long)100); 
BgL_loopz00_2617:
if(
(BgL_iz00_2616==((long)-1)))
{ /* Llib/avahi.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/avahi.scm 15 */
{ /* Llib/avahi.scm 15 */
obj_t BgL_arg2676z00_2619;
{ /* Llib/avahi.scm 15 */

{ /* Llib/avahi.scm 15 */
obj_t BgL_locationz00_2621;
BgL_locationz00_2621 = 
BBOOL(((bool_t)0)); 
{ /* Llib/avahi.scm 15 */

BgL_arg2676z00_2619 = 
BGl_readz00zz__readerz00(BgL_cportz00_2615, BgL_locationz00_2621); } } } 
{ /* Llib/avahi.scm 15 */
int BgL_tmpz00_3029;
BgL_tmpz00_3029 = 
(int)(BgL_iz00_2616); 
CNST_TABLE_SET(BgL_tmpz00_3029, BgL_arg2676z00_2619); } } 
{ /* Llib/avahi.scm 15 */
int BgL_auxz00_2622;
BgL_auxz00_2622 = 
(int)(
(BgL_iz00_2616-((long)1))); 
{ 
long BgL_iz00_3034;
BgL_iz00_3034 = 
(long)(BgL_auxz00_2622); 
BgL_iz00_2616 = BgL_iz00_3034; 
goto BgL_loopz00_2617;} } } } } } 
BGL_FUNCTION_END;
}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__avahi_avahiz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 15 */
return 
bgl_gc_roots_register();} 
BGL_FUNCTION_END;
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__avahi_avahiz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 15 */
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), 
BSTRING_TO_STRING(BGl_string2446z00zz__avahi_avahiz00)); 
{ /* Llib/avahi.scm 201 */
obj_t BgL_res2240z00_1232;
{ /* Llib/avahi.scm 201 */
obj_t BgL_namez00_1231;
BgL_namez00_1231 = 
CNST_TABLE_REF(((long)0)); 
BgL_res2240z00_1232 = 
bgl_make_mutex(BgL_namez00_1231); } 
BGl_za2avahizd2mutexza2zd2zz__avahi_avahiz00 = BgL_res2240z00_1232; } 
{ /* Llib/avahi.scm 202 */
obj_t BgL_res2241z00_1234;
{ /* Llib/avahi.scm 202 */
obj_t BgL_namez00_1233;
BgL_namez00_1233 = 
CNST_TABLE_REF(((long)0)); 
BgL_res2241z00_1234 = 
bgl_make_condvar(BgL_namez00_1233); } 
BGl_za2avahizd2condvza2zd2zz__avahi_avahiz00 = BgL_res2241z00_1234; } 
BGl_za2avahizd2threadza2zd2zz__avahi_avahiz00 = BUNSPEC; 
BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00 = BNIL; 
{ /* Llib/avahi.scm 245 */

{ /* Llib/avahi.scm 245 */
obj_t BgL_namez00_56;
BgL_namez00_56 = 
BGl_gensymz00zz__r4_symbols_6_4z00(
CNST_TABLE_REF(((long)1))); 
{ /* Llib/avahi.scm 245 */

{ /* Llib/avahi.scm 245 */
obj_t BgL_res2242z00_1235;
BgL_res2242z00_1235 = 
bgl_make_mutex(BgL_namez00_56); 
BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00 = BgL_res2242z00_1235; } } } } 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* avahi-error */
BGL_EXPORTED_DEF obj_t bgl_avahi_error(char * BgL_procz00_3, char * BgL_msgz00_4, obj_t BgL_objz00_5, int BgL_errnoz00_6)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 212 */
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1290z00_65;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1141z00_66;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1140z00_69;
BgL_new1140z00_69 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 214 */
long BgL_arg1318z00_70;
{ /* Llib/avahi.scm 214 */
long BgL_res2243z00_1237;
BgL_res2243z00_1237 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BgL_arg1318z00_70 = BgL_res2243z00_1237; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1140z00_69), BgL_arg1318z00_70); } 
BgL_new1141z00_66 = BgL_new1140z00_69; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_66)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_66)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_3054;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1302z00_67;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1317z00_68;
{ /* Llib/avahi.scm 214 */
obj_t BgL_res2244z00_1241;
{ /* Llib/avahi.scm 214 */
obj_t BgL_classz00_1240;
BgL_classz00_1240 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_res2244z00_1241 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1240); } 
BgL_arg1317z00_68 = BgL_res2244z00_1241; } 
BgL_arg1302z00_67 = 
VECTOR_REF(BgL_arg1317z00_68,((long)2)); } 
BgL_auxz00_3054 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1302z00_67); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_66)))->BgL_stackz00)=((obj_t)BgL_auxz00_3054),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_66)))->BgL_procz00)=((obj_t)
string_to_bstring(BgL_procz00_3)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_66)))->BgL_msgz00)=((obj_t)
string_to_bstring(BgL_msgz00_4)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_66)))->BgL_objz00)=((obj_t)BgL_objz00_5),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1141z00_66))->BgL_errnoz00)=((int)BgL_errnoz00_6),BUNSPEC); 
BgL_arg1290z00_65 = BgL_new1141z00_66; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1290z00_65));} } 
BGL_FUNCTION_END;
}



/* &avahi-error2365 */
obj_t BGl_z62avahizd2error2365zb0zz__avahi_avahiz00(obj_t BgL_envz00_1890, obj_t BgL_procz00_1891, obj_t BgL_msgz00_1892, obj_t BgL_objz00_1893, obj_t BgL_errnoz00_1894)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 212 */
{ /* Llib/avahi.scm 214 */
int BgL_auxz00_3089;char * BgL_auxz00_3080;char * BgL_auxz00_3071;
{ /* Llib/avahi.scm 214 */
obj_t BgL_tmpz00_3090;
if(
INTEGERP(BgL_errnoz00_1894))
{ /* Llib/avahi.scm 214 */
BgL_tmpz00_3090 = BgL_errnoz00_1894
; }  else 
{ 
obj_t BgL_auxz00_3093;
BgL_auxz00_3093 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)8538)), BGl_string2448z00zz__avahi_avahiz00, BGl_string2450z00zz__avahi_avahiz00, BgL_errnoz00_1894); 
FAILURE(BgL_auxz00_3093,BFALSE,BFALSE);} 
BgL_auxz00_3089 = 
CINT(BgL_tmpz00_3090); } 
{ /* Llib/avahi.scm 214 */
obj_t BgL_tmpz00_3081;
if(
STRINGP(BgL_msgz00_1892))
{ /* Llib/avahi.scm 214 */
BgL_tmpz00_3081 = BgL_msgz00_1892
; }  else 
{ 
obj_t BgL_auxz00_3084;
BgL_auxz00_3084 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)8538)), BGl_string2448z00zz__avahi_avahiz00, BGl_string2449z00zz__avahi_avahiz00, BgL_msgz00_1892); 
FAILURE(BgL_auxz00_3084,BFALSE,BFALSE);} 
BgL_auxz00_3080 = 
BSTRING_TO_STRING(BgL_tmpz00_3081); } 
{ /* Llib/avahi.scm 214 */
obj_t BgL_tmpz00_3072;
if(
STRINGP(BgL_procz00_1891))
{ /* Llib/avahi.scm 214 */
BgL_tmpz00_3072 = BgL_procz00_1891
; }  else 
{ 
obj_t BgL_auxz00_3075;
BgL_auxz00_3075 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)8538)), BGl_string2448z00zz__avahi_avahiz00, BGl_string2449z00zz__avahi_avahiz00, BgL_procz00_1891); 
FAILURE(BgL_auxz00_3075,BFALSE,BFALSE);} 
BgL_auxz00_3071 = 
BSTRING_TO_STRING(BgL_tmpz00_3072); } 
return 
bgl_avahi_error(BgL_auxz00_3071, BgL_auxz00_3080, BgL_objz00_1893, BgL_auxz00_3089);} } 
BGL_FUNCTION_END;
}



/* %avahi-lock! */
BGL_EXPORTED_DEF obj_t bgl_avahi_lock()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 223 */
{ /* Llib/avahi.scm 224 */
obj_t BgL_g1149z00_1243;
BgL_g1149z00_1243 = BGl_za2avahizd2mutexza2zd2zz__avahi_avahiz00; 
{ /* Llib/avahi.scm 224 */

{ /* Llib/avahi.scm 224 */
int BgL_arg1646z00_1248;
BgL_arg1646z00_1248 = 
BGL_MUTEX_LOCK(BgL_g1149z00_1243); 
return 
BBOOL(
(
(long)(BgL_arg1646z00_1248)==((long)0)));} } } } 
BGL_FUNCTION_END;
}



/* &%avahi-lock! */
obj_t BGl_z62z52avahizd2lockz12zf0zz__avahi_avahiz00(obj_t BgL_envz00_1895)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 223 */
return 
bgl_avahi_lock();} 
BGL_FUNCTION_END;
}



/* %avahi-unlock! */
BGL_EXPORTED_DEF obj_t bgl_avahi_unlock()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 229 */
{ /* Llib/avahi.scm 230 */
obj_t BgL_mz00_1256;
BgL_mz00_1256 = BGl_za2avahizd2mutexza2zd2zz__avahi_avahiz00; 
{ /* Llib/avahi.scm 230 */
int BgL_arg1643z00_1257;
BgL_arg1643z00_1257 = 
BGL_MUTEX_UNLOCK(BgL_mz00_1256); 
return 
BBOOL(
(
(long)(BgL_arg1643z00_1257)==((long)0)));} } } 
BGL_FUNCTION_END;
}



/* &%avahi-unlock! */
obj_t BGl_z62z52avahizd2unlockz12zf0zz__avahi_avahiz00(obj_t BgL_envz00_1896)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 229 */
return 
bgl_avahi_unlock();} 
BGL_FUNCTION_END;
}



/* %avahi-signal */
BGL_EXPORTED_DEF obj_t bgl_avahi_signal()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 235 */
{ /* Llib/avahi.scm 236 */
bool_t BgL_res2249z00_1261;
BgL_res2249z00_1261 = 
BGL_CONDVAR_SIGNAL(BGl_za2avahizd2condvza2zd2zz__avahi_avahiz00); 
return 
BBOOL(BgL_res2249z00_1261);} } 
BGL_FUNCTION_END;
}



/* &%avahi-signal */
obj_t BGl_z62z52avahizd2signalze2zz__avahi_avahiz00(obj_t BgL_envz00_1897)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 235 */
return 
bgl_avahi_signal();} 
BGL_FUNCTION_END;
}



/* avahi-gc-unmark! */
obj_t BGl_avahizd2gczd2unmarkz12z12zz__avahi_avahiz00(BgL_avahizd2objectzd2_bglt BgL_oz00_8)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 257 */
{ /* Llib/avahi.scm 258 */
obj_t BgL_top2945z00_3113;
BgL_top2945z00_3113 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); 
BGL_EXITD_PUSH_PROTECT(BgL_top2945z00_3113, BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); BUNSPEC; 
{ /* Llib/avahi.scm 258 */
obj_t BgL_tmp2944z00_3112;
{ /* Llib/avahi.scm 259 */
obj_t BgL_g1806z00_74;
BgL_g1806z00_74 = BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00; 
{ /* Llib/avahi.scm 259 */

BgL_tmp2944z00_3112 = ( 
BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00 = 
BGl_deletez12z12zz__r4_pairs_and_lists_6_3z00(
((obj_t)BgL_oz00_8), BgL_g1806z00_74, BGl_equalzf3zd2envz21zz__r4_equivalence_6_2z00), BUNSPEC) ; } } 
BGL_EXITD_POP_PROTECT(BgL_top2945z00_3113); BUNSPEC; 
BGL_MUTEX_UNLOCK(BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); 
return BgL_tmp2944z00_3112;} } } 
BGL_FUNCTION_END;
}



/* %avahi-thread-init! */
BGL_EXPORTED_DEF obj_t BGl_z52avahizd2threadzd2initz12z40zz__avahi_avahiz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 264 */
if(
BGl_isazf3zf3zz__objectz00(BGl_za2avahizd2threadza2zd2zz__avahi_avahiz00, BGl_threadz00zz__threadz00))
{ /* Llib/avahi.scm 265 */
return BFALSE;}  else 
{ /* Llib/avahi.scm 267 */
obj_t BgL_lkz00_77;obj_t BgL_cvz00_78;
{ /* Llib/avahi.scm 267 */

{ /* Llib/avahi.scm 267 */
obj_t BgL_namez00_94;
BgL_namez00_94 = 
BGl_gensymz00zz__r4_symbols_6_4z00(
CNST_TABLE_REF(((long)1))); 
{ /* Llib/avahi.scm 267 */

{ /* Llib/avahi.scm 267 */
obj_t BgL_res2250z00_1262;
BgL_res2250z00_1262 = 
bgl_make_mutex(BgL_namez00_94); 
BgL_lkz00_77 = BgL_res2250z00_1262; } } } } 
{ /* Llib/avahi.scm 268 */

{ /* Llib/avahi.scm 268 */
obj_t BgL_namez00_95;
BgL_namez00_95 = 
BGl_gensymz00zz__r4_symbols_6_4z00(
CNST_TABLE_REF(((long)2))); 
{ /* Llib/avahi.scm 268 */

{ /* Llib/avahi.scm 268 */
obj_t BgL_res2251z00_1263;
BgL_res2251z00_1263 = 
bgl_make_condvar(BgL_namez00_95); 
BgL_cvz00_78 = BgL_res2251z00_1263; } } } } 
{ /* Llib/avahi.scm 270 */
BgL_pthreadz00_bglt BgL_new1143z00_79;
{ /* Llib/avahi.scm 271 */
BgL_pthreadz00_bglt BgL_new1142z00_88;
BgL_new1142z00_88 = 
((BgL_pthreadz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pthreadz00_bgl) ))); 
{ /* Llib/avahi.scm 271 */
long BgL_arg1325z00_89;
{ /* Llib/avahi.scm 271 */
long BgL_res2252z00_1265;
BgL_res2252z00_1265 = 
BGL_CLASS_INDEX(BGl_pthreadz00zz__pth_threadz00); 
BgL_arg1325z00_89 = BgL_res2252z00_1265; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1142z00_88), BgL_arg1325z00_89); } 
BgL_new1143z00_79 = BgL_new1142z00_88; } 
((((BgL_threadz00_bglt)COBJECT(
((BgL_threadz00_bglt)BgL_new1143z00_79)))->BgL_namez00)=((obj_t)BGl_string2451z00zz__avahi_avahiz00),BUNSPEC); 
{ 
obj_t BgL_auxz00_3135;
{ /* Llib/avahi.scm 272 */
obj_t BgL_zc3anonymousza31320ze3z83_1901;
BgL_zc3anonymousza31320ze3z83_1901 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza31320ze3ze1zz__avahi_avahiz00, 
(int)(((long)0)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3anonymousza31320ze3z83_1901, 
(int)(((long)0)), BgL_lkz00_77); 
PROCEDURE_SET(BgL_zc3anonymousza31320ze3z83_1901, 
(int)(((long)1)), BgL_cvz00_78); 
BgL_auxz00_3135 = BgL_zc3anonymousza31320ze3z83_1901; } 
((((BgL_pthreadz00_bglt)COBJECT(BgL_new1143z00_79))->BgL_bodyz00)=((obj_t)BgL_auxz00_3135),BUNSPEC); } 
((((BgL_pthreadz00_bglt)COBJECT(BgL_new1143z00_79))->BgL_detachedpz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(BgL_new1143z00_79))->BgL_endzd2resultzd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(BgL_new1143z00_79))->BgL_endzd2exceptionzd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(BgL_new1143z00_79))->BgL_z42builtinz42)=((void *)
BGl_z42pthreadzd2nilz90zz__pth_threadz00()),BUNSPEC); 
{ /* Llib/avahi.scm 270 */
obj_t BgL_fun1322z00_87;
BgL_fun1322z00_87 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_pthreadz00zz__pth_threadz00); 
PROCEDURE_ENTRY(BgL_fun1322z00_87)(BgL_fun1322z00_87, 
((obj_t)BgL_new1143z00_79), BEOA); } 
BGl_za2avahizd2threadza2zd2zz__avahi_avahiz00 = 
((obj_t)BgL_new1143z00_79); } 
{ /* Llib/avahi.scm 281 */
obj_t BgL_top2947z00_3157;
BgL_top2947z00_3157 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_lkz00_77); 
BGL_EXITD_PUSH_PROTECT(BgL_top2947z00_3157, BgL_lkz00_77); BUNSPEC; 
{ /* Llib/avahi.scm 281 */
obj_t BgL_tmp2946z00_3156;
BGl_threadzd2startz12zc0zz__threadz00(
((BgL_threadz00_bglt)BGl_za2avahizd2threadza2zd2zz__avahi_avahiz00), BNIL); 
{ /* Llib/avahi.scm 283 */

{ /* Llib/avahi.scm 283 */
bool_t BgL_res2257z00_1283;
BgL_res2257z00_1283 = 
BGL_CONDVAR_WAIT(BgL_cvz00_78, BgL_lkz00_77); 
BgL_tmp2946z00_3156 = 
BBOOL(BgL_res2257z00_1283); } } 
BGL_EXITD_POP_PROTECT(BgL_top2947z00_3157); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_lkz00_77); 
return BgL_tmp2946z00_3156;} } } } 
BGL_FUNCTION_END;
}



/* &%avahi-thread-init! */
obj_t BGl_z62z52avahizd2threadzd2initz12z22zz__avahi_avahiz00(obj_t BgL_envz00_1902)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 264 */
return 
BGl_z52avahizd2threadzd2initz12z40zz__avahi_avahiz00();} 
BGL_FUNCTION_END;
}



/* &<anonymous:1320> */
obj_t BGl_z62zc3anonymousza31320ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_1903)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 272 */
{ /* Llib/avahi.scm 273 */
obj_t BgL_lkz00_1904;obj_t BgL_cvz00_1905;
BgL_lkz00_1904 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1903, 
(int)(((long)0)))); 
BgL_cvz00_1905 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1903, 
(int)(((long)1)))); 
BGL_MUTEX_LOCK(BgL_lkz00_1904); 
{ /* Llib/avahi.scm 273 */
bool_t BgL_tmp2948z00_3174;
{ /* Llib/avahi.scm 274 */
bool_t BgL_res2253z00_2628;
BgL_res2253z00_2628 = 
BGL_CONDVAR_SIGNAL(BgL_cvz00_1905); 
BgL_tmp2948z00_3174 = BgL_res2253z00_2628; } 
BGL_MUTEX_UNLOCK(BgL_lkz00_1904); BgL_tmp2948z00_3174; } 
{ 

BgL_loopz00_2629:
BGL_MUTEX_LOCK(BGl_za2avahizd2mutexza2zd2zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 276 */
bool_t BgL_tmp2949z00_3178;
{ /* Llib/avahi.scm 278 */
obj_t BgL_g1143z00_2630;obj_t BgL_g1144z00_2631;
BgL_g1143z00_2630 = BGl_za2avahizd2condvza2zd2zz__avahi_avahiz00; 
BgL_g1144z00_2631 = BGl_za2avahizd2mutexza2zd2zz__avahi_avahiz00; 
{ /* Llib/avahi.scm 277 */

{ /* Llib/avahi.scm 277 */
bool_t BgL_res2255z00_2632;
BgL_res2255z00_2632 = 
BGL_CONDVAR_WAIT(BgL_g1143z00_2630, BgL_g1144z00_2631); 
BgL_tmp2949z00_3178 = BgL_res2255z00_2632; } } } 
BGL_MUTEX_UNLOCK(BGl_za2avahizd2mutexza2zd2zz__avahi_avahiz00); BgL_tmp2949z00_3178; } 
bgl_avahi_invoke_callbacks(); BUNSPEC; 
goto BgL_loopz00_2629;} } } 
BGL_FUNCTION_END;
}



/* avahi-simple-poll-close */
BGL_EXPORTED_DEF obj_t BGl_avahizd2simplezd2pollzd2closezd2zz__avahi_avahiz00(BgL_avahizd2simplezd2pollz00_bglt BgL_oz00_11)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 304 */
bgl_avahi_simple_poll_close(BgL_oz00_11); BUNSPEC; 
BGl_avahizd2gczd2unmarkz12z12zz__avahi_avahiz00(
((BgL_avahizd2objectzd2_bglt)BgL_oz00_11)); 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* &avahi-simple-poll-close */
obj_t BGl_z62avahizd2simplezd2pollzd2closezb0zz__avahi_avahiz00(obj_t BgL_envz00_1906, obj_t BgL_oz00_1907)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 304 */
{ /* Llib/avahi.scm 305 */
BgL_avahizd2simplezd2pollz00_bglt BgL_auxz00_3186;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1907, BGl_avahizd2simplezd2pollz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 305 */
BgL_auxz00_3186 = 
((BgL_avahizd2simplezd2pollz00_bglt)BgL_oz00_1907)
; }  else 
{ 
obj_t BgL_auxz00_3190;
BgL_auxz00_3190 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)12511)), BGl_string2452z00zz__avahi_avahiz00, BGl_string2453z00zz__avahi_avahiz00, BgL_oz00_1907); 
FAILURE(BgL_auxz00_3190,BFALSE,BFALSE);} 
return 
BGl_avahizd2simplezd2pollzd2closezd2zz__avahi_avahiz00(BgL_auxz00_3186);} } 
BGL_FUNCTION_END;
}



/* avahi-simple-poll-loop */
BGL_EXPORTED_DEF obj_t BGl_avahizd2simplezd2pollzd2loopzd2zz__avahi_avahiz00(BgL_avahizd2simplezd2pollz00_bglt BgL_oz00_12)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 312 */
{ /* Llib/avahi.scm 314 */
AvahiSimplePoll * BgL_arg1336z00_1285;
BgL_arg1336z00_1285 = 
(((BgL_avahizd2simplezd2pollz00_bglt)COBJECT(BgL_oz00_12))->BgL_z42builtinz42); 
avahi_simple_poll_loop(BgL_arg1336z00_1285); BUNSPEC; } 
return 
((obj_t)BgL_oz00_12);} 
BGL_FUNCTION_END;
}



/* &avahi-simple-poll-loop */
obj_t BGl_z62avahizd2simplezd2pollzd2loopzb0zz__avahi_avahiz00(obj_t BgL_envz00_1908, obj_t BgL_oz00_1909)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 312 */
{ /* Llib/avahi.scm 313 */
BgL_avahizd2simplezd2pollz00_bglt BgL_auxz00_3198;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1909, BGl_avahizd2simplezd2pollz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 313 */
BgL_auxz00_3198 = 
((BgL_avahizd2simplezd2pollz00_bglt)BgL_oz00_1909)
; }  else 
{ 
obj_t BgL_auxz00_3202;
BgL_auxz00_3202 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)12834)), BGl_string2454z00zz__avahi_avahiz00, BGl_string2453z00zz__avahi_avahiz00, BgL_oz00_1909); 
FAILURE(BgL_auxz00_3202,BFALSE,BFALSE);} 
return 
BGl_avahizd2simplezd2pollzd2loopzd2zz__avahi_avahiz00(BgL_auxz00_3198);} } 
BGL_FUNCTION_END;
}



/* avahi-simple-poll-timeout */
BGL_EXPORTED_DEF obj_t BGl_avahizd2simplezd2pollzd2timeoutzd2zz__avahi_avahiz00(BgL_avahizd2simplezd2pollz00_bglt BgL_oz00_13, long BgL_tz00_14, obj_t BgL_procz00_15)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 320 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_procz00_15, 
(int)(((long)0))))
{ /* Llib/avahi.scm 321 */
{ 
obj_t BgL_auxz00_3210;
{ /* Llib/avahi.scm 323 */
obj_t BgL_arg1373z00_100;
BgL_arg1373z00_100 = 
(((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_oz00_13)))->BgL_z52procsz52); 
BgL_auxz00_3210 = 
MAKE_YOUNG_PAIR(BgL_procz00_15, BgL_arg1373z00_100); } 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_oz00_13)))->BgL_z52procsz52)=((obj_t)BgL_auxz00_3210),BUNSPEC); } 
{ /* Llib/avahi.scm 324 */
AvahiSimplePoll * BgL_arg1374z00_101;
BgL_arg1374z00_101 = 
(((BgL_avahizd2simplezd2pollz00_bglt)COBJECT(BgL_oz00_13))->BgL_z42builtinz42); 
{ /* Llib/avahi.scm 324 */
long BgL_tmpz00_3217;
BgL_tmpz00_3217 = 
(long)(BgL_tz00_14); 
bgl_avahi_simple_poll_timeout(BgL_arg1374z00_101, BgL_tmpz00_3217, BgL_procz00_15); } 
return BUNSPEC;} }  else 
{ /* Llib/avahi.scm 325 */
char * BgL_procz00_1286;char * BgL_msgz00_1287;
BgL_procz00_1286 = 
BSTRING_TO_STRING(BGl_string2455z00zz__avahi_avahiz00); 
BgL_msgz00_1287 = 
BSTRING_TO_STRING(BGl_string2456z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1290z00_1289;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1141z00_1290;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1140z00_1291;
BgL_new1140z00_1291 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 214 */
long BgL_arg1318z00_1292;
{ /* Llib/avahi.scm 214 */
long BgL_res2243z00_1293;
BgL_res2243z00_1293 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BgL_arg1318z00_1292 = BgL_res2243z00_1293; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1140z00_1291), BgL_arg1318z00_1292); } 
BgL_new1141z00_1290 = BgL_new1140z00_1291; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_1290)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_1290)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_3230;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1302z00_1297;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1317z00_1298;
{ /* Llib/avahi.scm 214 */
obj_t BgL_res2244z00_1299;
{ /* Llib/avahi.scm 214 */
obj_t BgL_classz00_1300;
BgL_classz00_1300 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_res2244z00_1299 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1300); } 
BgL_arg1317z00_1298 = BgL_res2244z00_1299; } 
BgL_arg1302z00_1297 = 
VECTOR_REF(BgL_arg1317z00_1298,((long)2)); } 
BgL_auxz00_3230 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1302z00_1297); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_1290)))->BgL_stackz00)=((obj_t)BgL_auxz00_3230),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_1290)))->BgL_procz00)=((obj_t)
string_to_bstring(BgL_procz00_1286)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_1290)))->BgL_msgz00)=((obj_t)
string_to_bstring(BgL_msgz00_1287)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_1290)))->BgL_objz00)=((obj_t)BgL_procz00_15),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1141z00_1290))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1290z00_1289 = BgL_new1141z00_1290; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1290z00_1289));} } } 
BGL_FUNCTION_END;
}



/* &avahi-simple-poll-timeout */
obj_t BGl_z62avahizd2simplezd2pollzd2timeoutzb0zz__avahi_avahiz00(obj_t BgL_envz00_1910, obj_t BgL_oz00_1911, obj_t BgL_tz00_1912, obj_t BgL_procz00_1913)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 320 */
{ /* Llib/avahi.scm 321 */
obj_t BgL_auxz00_3264;long BgL_auxz00_3255;BgL_avahizd2simplezd2pollz00_bglt BgL_auxz00_3247;
if(
PROCEDUREP(BgL_procz00_1913))
{ /* Llib/avahi.scm 321 */
BgL_auxz00_3264 = BgL_procz00_1913
; }  else 
{ 
obj_t BgL_auxz00_3267;
BgL_auxz00_3267 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)13237)), BGl_string2457z00zz__avahi_avahiz00, BGl_string2458z00zz__avahi_avahiz00, BgL_procz00_1913); 
FAILURE(BgL_auxz00_3267,BFALSE,BFALSE);} 
{ /* Llib/avahi.scm 321 */
obj_t BgL_tmpz00_3256;
if(
INTEGERP(BgL_tz00_1912))
{ /* Llib/avahi.scm 321 */
BgL_tmpz00_3256 = BgL_tz00_1912
; }  else 
{ 
obj_t BgL_auxz00_3259;
BgL_auxz00_3259 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)13237)), BGl_string2457z00zz__avahi_avahiz00, BGl_string2450z00zz__avahi_avahiz00, BgL_tz00_1912); 
FAILURE(BgL_auxz00_3259,BFALSE,BFALSE);} 
BgL_auxz00_3255 = 
(long)CINT(BgL_tmpz00_3256); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1911, BGl_avahizd2simplezd2pollz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 321 */
BgL_auxz00_3247 = 
((BgL_avahizd2simplezd2pollz00_bglt)BgL_oz00_1911)
; }  else 
{ 
obj_t BgL_auxz00_3251;
BgL_auxz00_3251 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)13237)), BGl_string2457z00zz__avahi_avahiz00, BGl_string2453z00zz__avahi_avahiz00, BgL_oz00_1911); 
FAILURE(BgL_auxz00_3251,BFALSE,BFALSE);} 
return 
BGl_avahizd2simplezd2pollzd2timeoutzd2zz__avahi_avahiz00(BgL_auxz00_3247, BgL_auxz00_3255, BgL_auxz00_3264);} } 
BGL_FUNCTION_END;
}



/* avahi-simple-poll-quit */
BGL_EXPORTED_DEF obj_t BGl_avahizd2simplezd2pollzd2quitzd2zz__avahi_avahiz00(BgL_avahizd2simplezd2pollz00_bglt BgL_oz00_16)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 331 */
{ /* Llib/avahi.scm 333 */
AvahiSimplePoll * BgL_arg1417z00_1303;
BgL_arg1417z00_1303 = 
(((BgL_avahizd2simplezd2pollz00_bglt)COBJECT(BgL_oz00_16))->BgL_z42builtinz42); 
avahi_simple_poll_quit(BgL_arg1417z00_1303); BUNSPEC; } 
return 
((obj_t)BgL_oz00_16);} 
BGL_FUNCTION_END;
}



/* &avahi-simple-poll-quit */
obj_t BGl_z62avahizd2simplezd2pollzd2quitzb0zz__avahi_avahiz00(obj_t BgL_envz00_1914, obj_t BgL_oz00_1915)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 331 */
{ /* Llib/avahi.scm 332 */
BgL_avahizd2simplezd2pollz00_bglt BgL_auxz00_3275;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1915, BGl_avahizd2simplezd2pollz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 332 */
BgL_auxz00_3275 = 
((BgL_avahizd2simplezd2pollz00_bglt)BgL_oz00_1915)
; }  else 
{ 
obj_t BgL_auxz00_3279;
BgL_auxz00_3279 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)13797)), BGl_string2459z00zz__avahi_avahiz00, BGl_string2453z00zz__avahi_avahiz00, BgL_oz00_1915); 
FAILURE(BgL_auxz00_3279,BFALSE,BFALSE);} 
return 
BGl_avahizd2simplezd2pollzd2quitzd2zz__avahi_avahiz00(BgL_auxz00_3275);} } 
BGL_FUNCTION_END;
}



/* avahi-threaded-poll-close */
BGL_EXPORTED_DEF obj_t BGl_avahizd2threadedzd2pollzd2closezd2zz__avahi_avahiz00(BgL_avahizd2threadedzd2pollz00_bglt BgL_oz00_18)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 350 */
bgl_avahi_threaded_poll_close(BgL_oz00_18); BUNSPEC; 
BGl_avahizd2gczd2unmarkz12z12zz__avahi_avahiz00(
((BgL_avahizd2objectzd2_bglt)BgL_oz00_18)); 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* &avahi-threaded-poll-close */
obj_t BGl_z62avahizd2threadedzd2pollzd2closezb0zz__avahi_avahiz00(obj_t BgL_envz00_1916, obj_t BgL_oz00_1917)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 350 */
{ /* Llib/avahi.scm 351 */
BgL_avahizd2threadedzd2pollz00_bglt BgL_auxz00_3287;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1917, BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 351 */
BgL_auxz00_3287 = 
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_oz00_1917)
; }  else 
{ 
obj_t BgL_auxz00_3291;
BgL_auxz00_3291 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)14645)), BGl_string2460z00zz__avahi_avahiz00, BGl_string2461z00zz__avahi_avahiz00, BgL_oz00_1917); 
FAILURE(BgL_auxz00_3291,BFALSE,BFALSE);} 
return 
BGl_avahizd2threadedzd2pollzd2closezd2zz__avahi_avahiz00(BgL_auxz00_3287);} } 
BGL_FUNCTION_END;
}



/* avahi-threaded-poll-loop */
BGL_EXPORTED_DEF obj_t BGl_avahizd2threadedzd2pollzd2loopzd2zz__avahi_avahiz00(BgL_avahizd2threadedzd2pollz00_bglt BgL_oz00_19)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 358 */
{ /* Llib/avahi.scm 360 */
AvahiThreadedPoll * BgL_arg1418z00_1305;
BgL_arg1418z00_1305 = 
(((BgL_avahizd2threadedzd2pollz00_bglt)COBJECT(BgL_oz00_19))->BgL_z42builtinz42); 
avahi_threaded_poll_start(BgL_arg1418z00_1305); BUNSPEC; } 
return 
((obj_t)BgL_oz00_19);} 
BGL_FUNCTION_END;
}



/* &avahi-threaded-poll-loop */
obj_t BGl_z62avahizd2threadedzd2pollzd2loopzb0zz__avahi_avahiz00(obj_t BgL_envz00_1918, obj_t BgL_oz00_1919)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 358 */
{ /* Llib/avahi.scm 359 */
BgL_avahizd2threadedzd2pollz00_bglt BgL_auxz00_3299;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1919, BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 359 */
BgL_auxz00_3299 = 
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_oz00_1919)
; }  else 
{ 
obj_t BgL_auxz00_3303;
BgL_auxz00_3303 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)14972)), BGl_string2462z00zz__avahi_avahiz00, BGl_string2461z00zz__avahi_avahiz00, BgL_oz00_1919); 
FAILURE(BgL_auxz00_3303,BFALSE,BFALSE);} 
return 
BGl_avahizd2threadedzd2pollzd2loopzd2zz__avahi_avahiz00(BgL_auxz00_3299);} } 
BGL_FUNCTION_END;
}



/* avahi-threaded-poll-lock! */
BGL_EXPORTED_DEF obj_t BGl_avahizd2threadedzd2pollzd2lockz12zc0zz__avahi_avahiz00(BgL_avahizd2threadedzd2pollz00_bglt BgL_oz00_20)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 366 */
{ /* Llib/avahi.scm 368 */
AvahiThreadedPoll * BgL_arg1498z00_1307;
BgL_arg1498z00_1307 = 
(((BgL_avahizd2threadedzd2pollz00_bglt)COBJECT(BgL_oz00_20))->BgL_z42builtinz42); 
avahi_threaded_poll_lock(BgL_arg1498z00_1307); BUNSPEC; } 
return 
((obj_t)BgL_oz00_20);} 
BGL_FUNCTION_END;
}



/* &avahi-threaded-poll-lock! */
obj_t BGl_z62avahizd2threadedzd2pollzd2lockz12za2zz__avahi_avahiz00(obj_t BgL_envz00_1920, obj_t BgL_oz00_1921)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 366 */
{ /* Llib/avahi.scm 367 */
BgL_avahizd2threadedzd2pollz00_bglt BgL_auxz00_3311;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1921, BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 367 */
BgL_auxz00_3311 = 
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_oz00_1921)
; }  else 
{ 
obj_t BgL_auxz00_3315;
BgL_auxz00_3315 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)15357)), BGl_string2463z00zz__avahi_avahiz00, BGl_string2461z00zz__avahi_avahiz00, BgL_oz00_1921); 
FAILURE(BgL_auxz00_3315,BFALSE,BFALSE);} 
return 
BGl_avahizd2threadedzd2pollzd2lockz12zc0zz__avahi_avahiz00(BgL_auxz00_3311);} } 
BGL_FUNCTION_END;
}



/* avahi-threaded-poll-unlock! */
BGL_EXPORTED_DEF obj_t BGl_avahizd2threadedzd2pollzd2unlockz12zc0zz__avahi_avahiz00(BgL_avahizd2threadedzd2pollz00_bglt BgL_oz00_21)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 374 */
{ /* Llib/avahi.scm 376 */
AvahiThreadedPoll * BgL_arg1499z00_1309;
BgL_arg1499z00_1309 = 
(((BgL_avahizd2threadedzd2pollz00_bglt)COBJECT(BgL_oz00_21))->BgL_z42builtinz42); 
avahi_threaded_poll_unlock(BgL_arg1499z00_1309); BUNSPEC; } 
return 
((obj_t)BgL_oz00_21);} 
BGL_FUNCTION_END;
}



/* &avahi-threaded-poll-unlock! */
obj_t BGl_z62avahizd2threadedzd2pollzd2unlockz12za2zz__avahi_avahiz00(obj_t BgL_envz00_1922, obj_t BgL_oz00_1923)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 374 */
{ /* Llib/avahi.scm 375 */
BgL_avahizd2threadedzd2pollz00_bglt BgL_auxz00_3323;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1923, BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 375 */
BgL_auxz00_3323 = 
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_oz00_1923)
; }  else 
{ 
obj_t BgL_auxz00_3327;
BgL_auxz00_3327 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)15744)), BGl_string2464z00zz__avahi_avahiz00, BGl_string2461z00zz__avahi_avahiz00, BgL_oz00_1923); 
FAILURE(BgL_auxz00_3327,BFALSE,BFALSE);} 
return 
BGl_avahizd2threadedzd2pollzd2unlockz12zc0zz__avahi_avahiz00(BgL_auxz00_3323);} } 
BGL_FUNCTION_END;
}



/* avahi-threaded-poll-timeout */
BGL_EXPORTED_DEF obj_t BGl_avahizd2threadedzd2pollzd2timeoutzd2zz__avahi_avahiz00(BgL_avahizd2threadedzd2pollz00_bglt BgL_oz00_22, long BgL_tz00_23, obj_t BgL_procz00_24)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 382 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_procz00_24, 
(int)(((long)0))))
{ /* Llib/avahi.scm 383 */
{ 
obj_t BgL_auxz00_3335;
{ /* Llib/avahi.scm 385 */
obj_t BgL_arg1509z00_112;
BgL_arg1509z00_112 = 
(((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_oz00_22)))->BgL_z52procsz52); 
BgL_auxz00_3335 = 
MAKE_YOUNG_PAIR(BgL_procz00_24, BgL_arg1509z00_112); } 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_oz00_22)))->BgL_z52procsz52)=((obj_t)BgL_auxz00_3335),BUNSPEC); } 
{ /* Llib/avahi.scm 386 */
AvahiThreadedPoll * BgL_arg1510z00_113;
BgL_arg1510z00_113 = 
(((BgL_avahizd2threadedzd2pollz00_bglt)COBJECT(BgL_oz00_22))->BgL_z42builtinz42); 
{ /* Llib/avahi.scm 386 */
long BgL_tmpz00_3342;
BgL_tmpz00_3342 = 
(long)(BgL_tz00_23); 
bgl_avahi_threaded_poll_timeout(BgL_arg1510z00_113, BgL_tmpz00_3342, BgL_procz00_24); } 
return BUNSPEC;} }  else 
{ /* Llib/avahi.scm 387 */
char * BgL_procz00_1310;char * BgL_msgz00_1311;
BgL_procz00_1310 = 
BSTRING_TO_STRING(BGl_string2465z00zz__avahi_avahiz00); 
BgL_msgz00_1311 = 
BSTRING_TO_STRING(BGl_string2456z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1290z00_1313;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1141z00_1314;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1140z00_1315;
BgL_new1140z00_1315 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 214 */
long BgL_arg1318z00_1316;
{ /* Llib/avahi.scm 214 */
long BgL_res2243z00_1317;
BgL_res2243z00_1317 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BgL_arg1318z00_1316 = BgL_res2243z00_1317; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1140z00_1315), BgL_arg1318z00_1316); } 
BgL_new1141z00_1314 = BgL_new1140z00_1315; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_1314)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_1314)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_3355;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1302z00_1321;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1317z00_1322;
{ /* Llib/avahi.scm 214 */
obj_t BgL_res2244z00_1323;
{ /* Llib/avahi.scm 214 */
obj_t BgL_classz00_1324;
BgL_classz00_1324 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_res2244z00_1323 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1324); } 
BgL_arg1317z00_1322 = BgL_res2244z00_1323; } 
BgL_arg1302z00_1321 = 
VECTOR_REF(BgL_arg1317z00_1322,((long)2)); } 
BgL_auxz00_3355 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1302z00_1321); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_1314)))->BgL_stackz00)=((obj_t)BgL_auxz00_3355),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_1314)))->BgL_procz00)=((obj_t)
string_to_bstring(BgL_procz00_1310)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_1314)))->BgL_msgz00)=((obj_t)
string_to_bstring(BgL_msgz00_1311)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_1314)))->BgL_objz00)=((obj_t)BgL_procz00_24),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1141z00_1314))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1290z00_1313 = BgL_new1141z00_1314; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1290z00_1313));} } } 
BGL_FUNCTION_END;
}



/* &avahi-threaded-poll-timeout */
obj_t BGl_z62avahizd2threadedzd2pollzd2timeoutzb0zz__avahi_avahiz00(obj_t BgL_envz00_1924, obj_t BgL_oz00_1925, obj_t BgL_tz00_1926, obj_t BgL_procz00_1927)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 382 */
{ /* Llib/avahi.scm 383 */
obj_t BgL_auxz00_3389;long BgL_auxz00_3380;BgL_avahizd2threadedzd2pollz00_bglt BgL_auxz00_3372;
if(
PROCEDUREP(BgL_procz00_1927))
{ /* Llib/avahi.scm 383 */
BgL_auxz00_3389 = BgL_procz00_1927
; }  else 
{ 
obj_t BgL_auxz00_3392;
BgL_auxz00_3392 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)16157)), BGl_string2466z00zz__avahi_avahiz00, BGl_string2458z00zz__avahi_avahiz00, BgL_procz00_1927); 
FAILURE(BgL_auxz00_3392,BFALSE,BFALSE);} 
{ /* Llib/avahi.scm 383 */
obj_t BgL_tmpz00_3381;
if(
INTEGERP(BgL_tz00_1926))
{ /* Llib/avahi.scm 383 */
BgL_tmpz00_3381 = BgL_tz00_1926
; }  else 
{ 
obj_t BgL_auxz00_3384;
BgL_auxz00_3384 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)16157)), BGl_string2466z00zz__avahi_avahiz00, BGl_string2450z00zz__avahi_avahiz00, BgL_tz00_1926); 
FAILURE(BgL_auxz00_3384,BFALSE,BFALSE);} 
BgL_auxz00_3380 = 
(long)CINT(BgL_tmpz00_3381); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1925, BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 383 */
BgL_auxz00_3372 = 
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_oz00_1925)
; }  else 
{ 
obj_t BgL_auxz00_3376;
BgL_auxz00_3376 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)16157)), BGl_string2466z00zz__avahi_avahiz00, BGl_string2461z00zz__avahi_avahiz00, BgL_oz00_1925); 
FAILURE(BgL_auxz00_3376,BFALSE,BFALSE);} 
return 
BGl_avahizd2threadedzd2pollzd2timeoutzd2zz__avahi_avahiz00(BgL_auxz00_3372, BgL_auxz00_3380, BgL_auxz00_3389);} } 
BGL_FUNCTION_END;
}



/* avahi-threaded-poll-quit */
BGL_EXPORTED_DEF obj_t BGl_avahizd2threadedzd2pollzd2quitzd2zz__avahi_avahiz00(BgL_avahizd2threadedzd2pollz00_bglt BgL_oz00_25)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 393 */
{ /* Llib/avahi.scm 395 */
AvahiThreadedPoll * BgL_arg1517z00_1327;
BgL_arg1517z00_1327 = 
(((BgL_avahizd2threadedzd2pollz00_bglt)COBJECT(BgL_oz00_25))->BgL_z42builtinz42); 
avahi_threaded_poll_stop(BgL_arg1517z00_1327); BUNSPEC; } 
return 
((obj_t)BgL_oz00_25);} 
BGL_FUNCTION_END;
}



/* &avahi-threaded-poll-quit */
obj_t BGl_z62avahizd2threadedzd2pollzd2quitzb0zz__avahi_avahiz00(obj_t BgL_envz00_1928, obj_t BgL_oz00_1929)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 393 */
{ /* Llib/avahi.scm 394 */
BgL_avahizd2threadedzd2pollz00_bglt BgL_auxz00_3400;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1929, BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 394 */
BgL_auxz00_3400 = 
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_oz00_1929)
; }  else 
{ 
obj_t BgL_auxz00_3404;
BgL_auxz00_3404 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)16727)), BGl_string2467z00zz__avahi_avahiz00, BGl_string2461z00zz__avahi_avahiz00, BgL_oz00_1929); 
FAILURE(BgL_auxz00_3404,BFALSE,BFALSE);} 
return 
BGl_avahizd2threadedzd2pollzd2quitzd2zz__avahi_avahiz00(BgL_auxz00_3400);} } 
BGL_FUNCTION_END;
}



/* avahi-client-close */
BGL_EXPORTED_DEF obj_t BGl_avahizd2clientzd2closez00zz__avahi_avahiz00(BgL_avahizd2clientzd2_bglt BgL_oz00_27)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 413 */
bgl_avahi_client_close(BgL_oz00_27); BUNSPEC; 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_oz00_27))->BgL_z52groupsz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_oz00_27))->BgL_z52browsersz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_oz00_27))->BgL_resolversz00)=((obj_t)BNIL),BUNSPEC); 
return 
BGl_avahizd2gczd2unmarkz12z12zz__avahi_avahiz00(
((BgL_avahizd2objectzd2_bglt)BgL_oz00_27));} 
BGL_FUNCTION_END;
}



/* &avahi-client-close */
obj_t BGl_z62avahizd2clientzd2closez62zz__avahi_avahiz00(obj_t BgL_envz00_1930, obj_t BgL_oz00_1931)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 413 */
{ /* Llib/avahi.scm 414 */
BgL_avahizd2clientzd2_bglt BgL_auxz00_3415;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1931, BGl_avahizd2clientzd2zz__avahi_avahiz00))
{ /* Llib/avahi.scm 414 */
BgL_auxz00_3415 = 
((BgL_avahizd2clientzd2_bglt)BgL_oz00_1931)
; }  else 
{ 
obj_t BgL_auxz00_3419;
BgL_auxz00_3419 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)17628)), BGl_string2468z00zz__avahi_avahiz00, BGl_string2469z00zz__avahi_avahiz00, BgL_oz00_1931); 
FAILURE(BgL_auxz00_3419,BFALSE,BFALSE);} 
return 
BGl_avahizd2clientzd2closez00zz__avahi_avahiz00(BgL_auxz00_3415);} } 
BGL_FUNCTION_END;
}



/* avahi-client-error-message */
BGL_EXPORTED_DEF obj_t BGl_avahizd2clientzd2errorzd2messagezd2zz__avahi_avahiz00(BgL_avahizd2clientzd2_bglt BgL_oz00_28)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 424 */
{ /* Llib/avahi.scm 426 */
int BgL_arg1523z00_1329;
{ /* Llib/avahi.scm 426 */
AvahiClient * BgL_tmpz00_3424;
BgL_tmpz00_3424 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_oz00_28))->BgL_z42builtinz42); 
BgL_arg1523z00_1329 = 
avahi_client_errno(BgL_tmpz00_3424); } 
return 
string_to_bstring(
(char *)avahi_strerror(BgL_arg1523z00_1329));} } 
BGL_FUNCTION_END;
}



/* &avahi-client-error-message */
obj_t BGl_z62avahizd2clientzd2errorzd2messagezb0zz__avahi_avahiz00(obj_t BgL_envz00_1932, obj_t BgL_oz00_1933)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 424 */
{ /* Llib/avahi.scm 425 */
BgL_avahizd2clientzd2_bglt BgL_auxz00_3429;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1933, BGl_avahizd2clientzd2zz__avahi_avahiz00))
{ /* Llib/avahi.scm 425 */
BgL_auxz00_3429 = 
((BgL_avahizd2clientzd2_bglt)BgL_oz00_1933)
; }  else 
{ 
obj_t BgL_auxz00_3433;
BgL_auxz00_3433 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)18076)), BGl_string2470z00zz__avahi_avahiz00, BGl_string2469z00zz__avahi_avahiz00, BgL_oz00_1933); 
FAILURE(BgL_auxz00_3433,BFALSE,BFALSE);} 
return 
BGl_avahizd2clientzd2errorzd2messagezd2zz__avahi_avahiz00(BgL_auxz00_3429);} } 
BGL_FUNCTION_END;
}



/* avahi-client-state->symbol */
BGL_EXPORTED_DEF obj_t bgl_avahi_client_state_to_symbol(AvahiClientState BgL_statez00_29)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 431 */
if(
(BgL_statez00_29==AVAHI_CLIENT_S_REGISTERING))
{ /* Llib/avahi.scm 433 */
return 
CNST_TABLE_REF(((long)3));}  else 
{ /* Llib/avahi.scm 433 */
if(
(BgL_statez00_29==AVAHI_CLIENT_S_RUNNING))
{ /* Llib/avahi.scm 435 */
return 
CNST_TABLE_REF(((long)4));}  else 
{ /* Llib/avahi.scm 435 */
if(
(BgL_statez00_29==AVAHI_CLIENT_S_COLLISION))
{ /* Llib/avahi.scm 437 */
return 
CNST_TABLE_REF(((long)5));}  else 
{ /* Llib/avahi.scm 437 */
if(
(BgL_statez00_29==AVAHI_CLIENT_FAILURE))
{ /* Llib/avahi.scm 439 */
return 
CNST_TABLE_REF(((long)6));}  else 
{ /* Llib/avahi.scm 439 */
if(
(BgL_statez00_29==AVAHI_CLIENT_CONNECTING))
{ /* Llib/avahi.scm 441 */
return 
CNST_TABLE_REF(((long)7));}  else 
{ /* Llib/avahi.scm 444 */
char * BgL_procz00_1346;char * BgL_msgz00_1347;
BgL_procz00_1346 = 
BSTRING_TO_STRING(BGl_string2471z00zz__avahi_avahiz00); 
BgL_msgz00_1347 = 
BSTRING_TO_STRING(BGl_string2472z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1290z00_1349;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1141z00_1350;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1140z00_1351;
BgL_new1140z00_1351 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 214 */
long BgL_arg1318z00_1352;
{ /* Llib/avahi.scm 214 */
long BgL_res2243z00_1353;
BgL_res2243z00_1353 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BgL_arg1318z00_1352 = BgL_res2243z00_1353; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1140z00_1351), BgL_arg1318z00_1352); } 
BgL_new1141z00_1350 = BgL_new1140z00_1351; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_1350)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_1350)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_3463;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1302z00_1357;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1317z00_1358;
{ /* Llib/avahi.scm 214 */
obj_t BgL_res2244z00_1359;
{ /* Llib/avahi.scm 214 */
obj_t BgL_classz00_1360;
BgL_classz00_1360 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_res2244z00_1359 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1360); } 
BgL_arg1317z00_1358 = BgL_res2244z00_1359; } 
BgL_arg1302z00_1357 = 
VECTOR_REF(BgL_arg1317z00_1358,((long)2)); } 
BgL_auxz00_3463 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1302z00_1357); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_1350)))->BgL_stackz00)=((obj_t)BgL_auxz00_3463),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_1350)))->BgL_procz00)=((obj_t)
string_to_bstring(BgL_procz00_1346)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_1350)))->BgL_msgz00)=((obj_t)
string_to_bstring(BgL_msgz00_1347)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_1350)))->BgL_objz00)=((obj_t)
BINT(BgL_statez00_29)),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1141z00_1350))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1290z00_1349 = BgL_new1141z00_1350; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1290z00_1349));} } } } } } } 
BGL_FUNCTION_END;
}



/* &avahi-client-state->symbol */
obj_t BGl_z62avahizd2clientzd2statezd2ze3symbolz53zz__avahi_avahiz00(obj_t BgL_envz00_1934, obj_t BgL_statez00_1935)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 431 */
{ /* Llib/avahi.scm 433 */
AvahiClientState BgL_auxz00_3481;
{ /* Llib/avahi.scm 433 */
obj_t BgL_tmpz00_3482;
if(
INTEGERP(BgL_statez00_1935))
{ /* Llib/avahi.scm 433 */
BgL_tmpz00_3482 = BgL_statez00_1935
; }  else 
{ 
obj_t BgL_auxz00_3485;
BgL_auxz00_3485 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)18475)), BGl_string2473z00zz__avahi_avahiz00, BGl_string2450z00zz__avahi_avahiz00, BgL_statez00_1935); 
FAILURE(BgL_auxz00_3485,BFALSE,BFALSE);} 
BgL_auxz00_3481 = 
(long)CINT(BgL_tmpz00_3482); } 
return 
bgl_avahi_client_state_to_symbol(BgL_auxz00_3481);} } 
BGL_FUNCTION_END;
}



/* avahi-entry-group-close */
BGL_EXPORTED_DEF obj_t BGl_avahizd2entryzd2groupzd2closezd2zz__avahi_avahiz00(BgL_avahizd2entryzd2groupz00_bglt BgL_oz00_31)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 463 */
bgl_avahi_entry_group_close(BgL_oz00_31); BUNSPEC; 
{ /* Llib/avahi.scm 466 */
BgL_avahizd2clientzd2_bglt BgL_i1160z00_126;
BgL_i1160z00_126 = 
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(BgL_oz00_31))->BgL_clientz00); 
{ 
obj_t BgL_auxz00_3493;
{ /* Llib/avahi.scm 467 */
obj_t BgL_arg1531z00_127;
BgL_arg1531z00_127 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1160z00_126))->BgL_z52groupsz52); 
BgL_auxz00_3493 = 
bgl_remq_bang(
((obj_t)BgL_oz00_31), BgL_arg1531z00_127); } 
return 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1160z00_126))->BgL_z52groupsz52)=((obj_t)BgL_auxz00_3493),BUNSPEC);} } } 
BGL_FUNCTION_END;
}



/* &avahi-entry-group-close */
obj_t BGl_z62avahizd2entryzd2groupzd2closezb0zz__avahi_avahiz00(obj_t BgL_envz00_1936, obj_t BgL_oz00_1937)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 463 */
{ /* Llib/avahi.scm 464 */
BgL_avahizd2entryzd2groupz00_bglt BgL_auxz00_3498;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1937, BGl_avahizd2entryzd2groupz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 464 */
BgL_auxz00_3498 = 
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_1937)
; }  else 
{ 
obj_t BgL_auxz00_3502;
BgL_auxz00_3502 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)19887)), BGl_string2474z00zz__avahi_avahiz00, BGl_string2475z00zz__avahi_avahiz00, BgL_oz00_1937); 
FAILURE(BgL_auxz00_3502,BFALSE,BFALSE);} 
return 
BGl_avahizd2entryzd2groupzd2closezd2zz__avahi_avahiz00(BgL_auxz00_3498);} } 
BGL_FUNCTION_END;
}



/* avahi-entry-group-empty? */
BGL_EXPORTED_DEF bool_t BGl_avahizd2entryzd2groupzd2emptyzf3z21zz__avahi_avahiz00(BgL_avahizd2entryzd2groupz00_bglt BgL_oz00_32)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 472 */
{ /* Llib/avahi.scm 474 */
AvahiEntryGroup * BgL_arg1533z00_1363;
BgL_arg1533z00_1363 = 
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(BgL_oz00_32))->BgL_z42builtinz42); 
avahi_entry_group_is_empty(BgL_arg1533z00_1363); 
return ((bool_t)1);} } 
BGL_FUNCTION_END;
}



/* &avahi-entry-group-empty? */
obj_t BGl_z62avahizd2entryzd2groupzd2emptyzf3z43zz__avahi_avahiz00(obj_t BgL_envz00_1938, obj_t BgL_oz00_1939)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 472 */
{ /* Llib/avahi.scm 473 */
bool_t BgL_tmpz00_3509;
{ /* Llib/avahi.scm 473 */
BgL_avahizd2entryzd2groupz00_bglt BgL_auxz00_3510;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1939, BGl_avahizd2entryzd2groupz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 473 */
BgL_auxz00_3510 = 
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_1939)
; }  else 
{ 
obj_t BgL_auxz00_3514;
BgL_auxz00_3514 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)20314)), BGl_string2476z00zz__avahi_avahiz00, BGl_string2475z00zz__avahi_avahiz00, BgL_oz00_1939); 
FAILURE(BgL_auxz00_3514,BFALSE,BFALSE);} 
BgL_tmpz00_3509 = 
BGl_avahizd2entryzd2groupzd2emptyzf3z21zz__avahi_avahiz00(BgL_auxz00_3510); } 
return 
BBOOL(BgL_tmpz00_3509);} } 
BGL_FUNCTION_END;
}



/* avahi-entry-group-commit */
BGL_EXPORTED_DEF obj_t BGl_avahizd2entryzd2groupzd2commitzd2zz__avahi_avahiz00(BgL_avahizd2entryzd2groupz00_bglt BgL_oz00_33)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 479 */
{ /* Llib/avahi.scm 481 */
int BgL_nz00_131;
{ /* Llib/avahi.scm 481 */
AvahiEntryGroup * BgL_tmpz00_3520;
BgL_tmpz00_3520 = 
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(BgL_oz00_33))->BgL_z42builtinz42); 
BgL_nz00_131 = 
avahi_entry_group_commit(BgL_tmpz00_3520); } 
if(
(
(long)(BgL_nz00_131)>=((long)0)))
{ /* Llib/avahi.scm 482 */
return BFALSE;}  else 
{ /* Llib/avahi.scm 483 */
char * BgL_arg1548z00_133;
BgL_arg1548z00_133 = 
(char *)avahi_strerror(BgL_nz00_131); 
return 
bgl_avahi_error(
BSTRING_TO_STRING(BGl_string2475z00zz__avahi_avahiz00), BgL_arg1548z00_133, 
((obj_t)BgL_oz00_33), BgL_nz00_131);} } } 
BGL_FUNCTION_END;
}



/* &avahi-entry-group-commit */
obj_t BGl_z62avahizd2entryzd2groupzd2commitzb0zz__avahi_avahiz00(obj_t BgL_envz00_1940, obj_t BgL_oz00_1941)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 479 */
{ /* Llib/avahi.scm 480 */
BgL_avahizd2entryzd2groupz00_bglt BgL_auxz00_3530;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1941, BGl_avahizd2entryzd2groupz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 480 */
BgL_auxz00_3530 = 
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_1941)
; }  else 
{ 
obj_t BgL_auxz00_3534;
BgL_auxz00_3534 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)20686)), BGl_string2477z00zz__avahi_avahiz00, BGl_string2475z00zz__avahi_avahiz00, BgL_oz00_1941); 
FAILURE(BgL_auxz00_3534,BFALSE,BFALSE);} 
return 
BGl_avahizd2entryzd2groupzd2commitzd2zz__avahi_avahiz00(BgL_auxz00_3530);} } 
BGL_FUNCTION_END;
}



/* avahi-entry-group-reset! */
BGL_EXPORTED_DEF obj_t BGl_avahizd2entryzd2groupzd2resetz12zc0zz__avahi_avahiz00(BgL_avahizd2entryzd2groupz00_bglt BgL_oz00_34)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 488 */
{ /* Llib/avahi.scm 490 */
BgL_avahizd2clientzd2_bglt BgL_i1164z00_136;
BgL_i1164z00_136 = 
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(BgL_oz00_34))->BgL_clientz00); 
{ 
obj_t BgL_auxz00_3540;
{ /* Llib/avahi.scm 491 */
obj_t BgL_arg1550z00_137;
BgL_arg1550z00_137 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1164z00_136))->BgL_z52groupsz52); 
BgL_auxz00_3540 = 
bgl_remq_bang(
((obj_t)BgL_oz00_34), BgL_arg1550z00_137); } 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1164z00_136))->BgL_z52groupsz52)=((obj_t)BgL_auxz00_3540),BUNSPEC); } } 
{ /* Llib/avahi.scm 492 */
int BgL_nz00_138;
{ /* Llib/avahi.scm 492 */
AvahiEntryGroup * BgL_tmpz00_3545;
BgL_tmpz00_3545 = 
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(BgL_oz00_34))->BgL_z42builtinz42); 
BgL_nz00_138 = 
avahi_entry_group_reset(BgL_tmpz00_3545); } 
if(
(
(long)(BgL_nz00_138)>=((long)0)))
{ /* Llib/avahi.scm 493 */
return BFALSE;}  else 
{ /* Llib/avahi.scm 494 */
char * BgL_arg1552z00_140;
BgL_arg1552z00_140 = 
(char *)avahi_strerror(BgL_nz00_138); 
return 
bgl_avahi_error(
BSTRING_TO_STRING(BGl_string2475z00zz__avahi_avahiz00), BgL_arg1552z00_140, 
((obj_t)BgL_oz00_34), BgL_nz00_138);} } } 
BGL_FUNCTION_END;
}



/* &avahi-entry-group-reset! */
obj_t BGl_z62avahizd2entryzd2groupzd2resetz12za2zz__avahi_avahiz00(obj_t BgL_envz00_1942, obj_t BgL_oz00_1943)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 488 */
{ /* Llib/avahi.scm 489 */
BgL_avahizd2entryzd2groupz00_bglt BgL_auxz00_3555;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1943, BGl_avahizd2entryzd2groupz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 489 */
BgL_auxz00_3555 = 
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_1943)
; }  else 
{ 
obj_t BgL_auxz00_3559;
BgL_auxz00_3559 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)21155)), BGl_string2478z00zz__avahi_avahiz00, BGl_string2475z00zz__avahi_avahiz00, BgL_oz00_1943); 
FAILURE(BgL_auxz00_3559,BFALSE,BFALSE);} 
return 
BGl_avahizd2entryzd2groupzd2resetz12zc0zz__avahi_avahiz00(BgL_auxz00_3555);} } 
BGL_FUNCTION_END;
}



/* avahi-entry-group-add-service! */
BGL_EXPORTED_DEF obj_t BGl_avahizd2entryzd2groupzd2addzd2servicez12z12zz__avahi_avahiz00(BgL_avahizd2entryzd2groupz00_bglt BgL_oz00_35, obj_t BgL_namez00_36)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 499 */
{ /* Llib/avahi.scm 186 */
obj_t BgL_namez00_143;
BgL_namez00_143 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_namez00_36, 
CNST_TABLE_REF(((long)8)), BFALSE); 
{ /* Llib/avahi.scm 186 */
obj_t BgL_typez00_144;
BgL_typez00_144 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_namez00_36, 
CNST_TABLE_REF(((long)9)), BFALSE); 
{ /* Llib/avahi.scm 186 */
obj_t BgL_domainz00_145;
BgL_domainz00_145 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_namez00_36, 
CNST_TABLE_REF(((long)10)), BFALSE); 
{ /* Llib/avahi.scm 186 */
obj_t BgL_hostz00_146;
BgL_hostz00_146 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_namez00_36, 
CNST_TABLE_REF(((long)11)), BFALSE); 
{ /* Llib/avahi.scm 186 */
obj_t BgL_portz00_147;
BgL_portz00_147 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_namez00_36, 
CNST_TABLE_REF(((long)12)), BFALSE); 
{ /* Llib/avahi.scm 186 */
obj_t BgL_subtypez00_148;
BgL_subtypez00_148 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_namez00_36, 
CNST_TABLE_REF(((long)13)), BFALSE); 
{ /* Llib/avahi.scm 186 */
obj_t BgL_txtz00_149;
BgL_txtz00_149 = 
BGl_dssslzd2getzd2keyzd2restzd2argz00zz__dssslz00(BgL_namez00_36, 
CNST_TABLE_REF(((long)14))); 
if(
CBOOL(BgL_subtypez00_148))
{ /* Llib/avahi.scm 523 */
int BgL_arg1567z00_152;
{ /* Llib/avahi.scm 523 */
AvahiEntryGroup * BgL_arg1568z00_153;obj_t BgL_arg1569z00_154;
BgL_arg1568z00_153 = 
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(BgL_oz00_35))->BgL_z42builtinz42); 
if(
CBOOL(BgL_domainz00_145))
{ /* Llib/avahi.scm 529 */
BgL_arg1569z00_154 = BgL_domainz00_145; }  else 
{ /* Llib/avahi.scm 529 */
BgL_arg1569z00_154 = 
string_to_bstring(
((char *)0L)); } 
{ /* Llib/avahi.scm 523 */
char * BgL_auxz00_3591;char * BgL_auxz00_3589;char * BgL_auxz00_3587;char * BgL_tmpz00_3585;
BgL_auxz00_3591 = 
BSTRING_TO_STRING(BgL_subtypez00_148); 
BgL_auxz00_3589 = 
BSTRING_TO_STRING(BgL_arg1569z00_154); 
BgL_auxz00_3587 = 
BSTRING_TO_STRING(BgL_typez00_144); 
BgL_tmpz00_3585 = 
BSTRING_TO_STRING(BgL_namez00_143); 
BgL_arg1567z00_152 = 
avahi_entry_group_add_service_subtype(BgL_arg1568z00_153, AVAHI_IF_UNSPEC, AVAHI_PROTO_UNSPEC, 0L, BgL_tmpz00_3585, BgL_auxz00_3587, BgL_auxz00_3589, BgL_auxz00_3591); } } 
return 
BGl_checkzd2errorze70z35zz__avahi_avahiz00(BgL_oz00_35, BgL_arg1567z00_152);}  else 
{ /* Llib/avahi.scm 520 */
if(
PAIRP(BgL_txtz00_149))
{ /* Llib/avahi.scm 533 */
AvahiStringList * BgL_lz00_157;
BgL_lz00_157 = 
bgl_avahi_list_to_string_list(BgL_txtz00_149); 
{ /* Llib/avahi.scm 534 */
obj_t BgL_exitd1173z00_158;
BgL_exitd1173z00_158 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ 
obj_t BgL_zc3anonymousza31604ze3z83_1944;
BgL_zc3anonymousza31604ze3z83_1944 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza31604ze3ze1zz__avahi_avahiz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza31604ze3z83_1944, 
(int)(((long)0)), 
void_star_to_obj(BgL_lz00_157)); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1173z00_158, BgL_zc3anonymousza31604ze3z83_1944); 
{ /* Llib/avahi.scm 536 */
obj_t BgL_tmp1175z00_160;
{ /* Llib/avahi.scm 536 */
int BgL_arg1581z00_161;
{ /* Llib/avahi.scm 536 */
AvahiEntryGroup * BgL_arg1583z00_162;obj_t BgL_arg1602z00_163;obj_t BgL_arg1603z00_164;
BgL_arg1583z00_162 = 
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(BgL_oz00_35))->BgL_z42builtinz42); 
if(
CBOOL(BgL_domainz00_145))
{ /* Llib/avahi.scm 542 */
BgL_arg1602z00_163 = BgL_domainz00_145; }  else 
{ /* Llib/avahi.scm 542 */
BgL_arg1602z00_163 = 
string_to_bstring(
((char *)0L)); } 
if(
CBOOL(BgL_hostz00_146))
{ /* Llib/avahi.scm 543 */
BgL_arg1603z00_164 = BgL_hostz00_146; }  else 
{ /* Llib/avahi.scm 543 */
BgL_arg1603z00_164 = 
string_to_bstring(
((char *)0L)); } 
{ /* Llib/avahi.scm 536 */
int BgL_auxz00_3623;char * BgL_auxz00_3621;char * BgL_auxz00_3619;char * BgL_auxz00_3617;char * BgL_tmpz00_3615;
BgL_auxz00_3623 = 
CINT(BgL_portz00_147); 
BgL_auxz00_3621 = 
BSTRING_TO_STRING(BgL_arg1603z00_164); 
BgL_auxz00_3619 = 
BSTRING_TO_STRING(BgL_arg1602z00_163); 
BgL_auxz00_3617 = 
BSTRING_TO_STRING(BgL_typez00_144); 
BgL_tmpz00_3615 = 
BSTRING_TO_STRING(BgL_namez00_143); 
BgL_arg1581z00_161 = 
avahi_entry_group_add_service_strlst(BgL_arg1583z00_162, AVAHI_IF_UNSPEC, AVAHI_PROTO_UNSPEC, 0L, BgL_tmpz00_3615, BgL_auxz00_3617, BgL_auxz00_3619, BgL_auxz00_3621, BgL_auxz00_3623, BgL_lz00_157); } } 
BgL_tmp1175z00_160 = 
BGl_checkzd2errorze70z35zz__avahi_avahiz00(BgL_oz00_35, BgL_arg1581z00_161); } 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1173z00_158); 
avahi_string_list_free(BgL_lz00_157); BUNSPEC; 
return BgL_tmp1175z00_160;} } } }  else 
{ /* Llib/avahi.scm 549 */
int BgL_arg1606z00_169;
{ /* Llib/avahi.scm 549 */
AvahiEntryGroup * BgL_arg1612z00_170;obj_t BgL_arg1614z00_171;obj_t BgL_arg1615z00_172;char * BgL_arg1619z00_173;
BgL_arg1612z00_170 = 
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(BgL_oz00_35))->BgL_z42builtinz42); 
if(
CBOOL(BgL_domainz00_145))
{ /* Llib/avahi.scm 555 */
BgL_arg1614z00_171 = BgL_domainz00_145; }  else 
{ /* Llib/avahi.scm 555 */
BgL_arg1614z00_171 = 
string_to_bstring(
((char *)0L)); } 
if(
CBOOL(BgL_hostz00_146))
{ /* Llib/avahi.scm 556 */
BgL_arg1615z00_172 = BgL_hostz00_146; }  else 
{ /* Llib/avahi.scm 556 */
BgL_arg1615z00_172 = 
string_to_bstring(
((char *)0L)); } 
BgL_arg1619z00_173 = 
((char *)0L); 
{ /* Llib/avahi.scm 549 */
int BgL_auxz00_3647;char * BgL_auxz00_3645;char * BgL_auxz00_3643;char * BgL_auxz00_3641;char * BgL_tmpz00_3639;
BgL_auxz00_3647 = 
CINT(BgL_portz00_147); 
BgL_auxz00_3645 = 
BSTRING_TO_STRING(BgL_arg1615z00_172); 
BgL_auxz00_3643 = 
BSTRING_TO_STRING(BgL_arg1614z00_171); 
BgL_auxz00_3641 = 
BSTRING_TO_STRING(BgL_typez00_144); 
BgL_tmpz00_3639 = 
BSTRING_TO_STRING(BgL_namez00_143); 
BgL_arg1606z00_169 = 
avahi_entry_group_add_service(BgL_arg1612z00_170, AVAHI_IF_UNSPEC, AVAHI_PROTO_UNSPEC, 0L, BgL_tmpz00_3639, BgL_auxz00_3641, BgL_auxz00_3643, BgL_auxz00_3645, BgL_auxz00_3647, BgL_arg1619z00_173); } } 
return 
BGl_checkzd2errorze70z35zz__avahi_avahiz00(BgL_oz00_35, BgL_arg1606z00_169);} } } } } } } } } } 
BGL_FUNCTION_END;
}



/* check-error~0 */
obj_t BGl_checkzd2errorze70z35zz__avahi_avahiz00(BgL_avahizd2entryzd2groupz00_bglt BgL_oz00_2493, int BgL_nz00_176)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 516 */
if(
(
(long)(BgL_nz00_176)<((long)0)))
{ /* Llib/avahi.scm 506 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1641z00_179;
if(
(
(long)(BgL_nz00_176)==
(long)(AVAHI_ERR_COLLISION)))
{ /* Llib/avahi.scm 507 */
BgL_z62avahizd2collisionzd2errorz62_bglt BgL_new1168z00_181;
{ /* Llib/avahi.scm 507 */
BgL_z62avahizd2collisionzd2errorz62_bglt BgL_new1167z00_184;
BgL_new1167z00_184 = 
((BgL_z62avahizd2collisionzd2errorz62_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2collisionzd2errorz62_bgl) ))); 
{ /* Llib/avahi.scm 507 */
long BgL_arg1649z00_185;
{ /* Llib/avahi.scm 507 */
long BgL_res2267z00_1374;
BgL_res2267z00_1374 = 
BGL_CLASS_INDEX(BGl_z62avahizd2collisionzd2errorz62zz__avahi_avahiz00); 
BgL_arg1649z00_185 = BgL_res2267z00_1374; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1167z00_184), BgL_arg1649z00_185); } 
BgL_new1168z00_181 = BgL_new1167z00_184; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1168z00_181)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1168z00_181)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_3666;
{ /* Llib/avahi.scm 507 */
obj_t BgL_arg1644z00_182;
{ /* Llib/avahi.scm 507 */
obj_t BgL_arg1648z00_183;
{ /* Llib/avahi.scm 507 */
obj_t BgL_res2268z00_1378;
{ /* Llib/avahi.scm 507 */
obj_t BgL_classz00_1377;
BgL_classz00_1377 = BGl_z62avahizd2collisionzd2errorz62zz__avahi_avahiz00; 
BgL_res2268z00_1378 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1377); } 
BgL_arg1648z00_183 = BgL_res2268z00_1378; } 
BgL_arg1644z00_182 = 
VECTOR_REF(BgL_arg1648z00_183,((long)2)); } 
BgL_auxz00_3666 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1644z00_182); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1168z00_181)))->BgL_stackz00)=((obj_t)BgL_auxz00_3666),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1168z00_181)))->BgL_procz00)=((obj_t)BGl_string2479z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1168z00_181)))->BgL_msgz00)=((obj_t)
string_to_bstring(
(char *)avahi_strerror(BgL_nz00_176))),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1168z00_181)))->BgL_objz00)=((obj_t)
((obj_t)BgL_oz00_2493)),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(
((BgL_z62avahizd2errorzb0_bglt)BgL_new1168z00_181)))->BgL_errnoz00)=((int)BgL_nz00_176),BUNSPEC); 
BgL_arg1641z00_179 = 
((BgL_z62avahizd2errorzb0_bglt)BgL_new1168z00_181); }  else 
{ /* Llib/avahi.scm 512 */
BgL_z62avahizd2errorzb0_bglt BgL_new1170z00_186;
{ /* Llib/avahi.scm 512 */
BgL_z62avahizd2errorzb0_bglt BgL_new1169z00_189;
BgL_new1169z00_189 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 512 */
long BgL_arg1658z00_190;
{ /* Llib/avahi.scm 512 */
long BgL_res2269z00_1381;
BgL_res2269z00_1381 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BgL_arg1658z00_190 = BgL_res2269z00_1381; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1169z00_189), BgL_arg1658z00_190); } 
BgL_new1170z00_186 = BgL_new1169z00_189; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1170z00_186)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1170z00_186)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_3692;
{ /* Llib/avahi.scm 512 */
obj_t BgL_arg1652z00_187;
{ /* Llib/avahi.scm 512 */
obj_t BgL_arg1657z00_188;
{ /* Llib/avahi.scm 512 */
obj_t BgL_res2270z00_1385;
{ /* Llib/avahi.scm 512 */
obj_t BgL_classz00_1384;
BgL_classz00_1384 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_res2270z00_1385 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1384); } 
BgL_arg1657z00_188 = BgL_res2270z00_1385; } 
BgL_arg1652z00_187 = 
VECTOR_REF(BgL_arg1657z00_188,((long)2)); } 
BgL_auxz00_3692 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1652z00_187); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1170z00_186)))->BgL_stackz00)=((obj_t)BgL_auxz00_3692),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1170z00_186)))->BgL_procz00)=((obj_t)BGl_string2479z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1170z00_186)))->BgL_msgz00)=((obj_t)
string_to_bstring(
(char *)avahi_strerror(BgL_nz00_176))),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1170z00_186)))->BgL_objz00)=((obj_t)
((obj_t)BgL_oz00_2493)),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1170z00_186))->BgL_errnoz00)=((int)BgL_nz00_176),BUNSPEC); 
BgL_arg1641z00_179 = BgL_new1170z00_186; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1641z00_179));}  else 
{ /* Llib/avahi.scm 504 */
return BFALSE;} } 
BGL_FUNCTION_END;
}



/* &avahi-entry-group-add-service! */
obj_t BGl_z62avahizd2entryzd2groupzd2addzd2servicez12z70zz__avahi_avahiz00(obj_t BgL_envz00_1945, obj_t BgL_oz00_1946, obj_t BgL_namez00_1947)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 499 */
{ /* Llib/avahi.scm 186 */
BgL_avahizd2entryzd2groupz00_bglt BgL_auxz00_3710;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1946, BGl_avahizd2entryzd2groupz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 186 */
BgL_auxz00_3710 = 
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_1946)
; }  else 
{ 
obj_t BgL_auxz00_3714;
BgL_auxz00_3714 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)7339)), BGl_string2480z00zz__avahi_avahiz00, BGl_string2475z00zz__avahi_avahiz00, BgL_oz00_1946); 
FAILURE(BgL_auxz00_3714,BFALSE,BFALSE);} 
return 
BGl_avahizd2entryzd2groupzd2addzd2servicez12z12zz__avahi_avahiz00(BgL_auxz00_3710, BgL_namez00_1947);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1604> */
obj_t BGl_z62zc3anonymousza31604ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_1948)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 534 */
{ 
AvahiStringList * BgL_lz00_1949;
BgL_lz00_1949 = 
FOREIGN_TO_COBJ(
PROCEDURE_REF(BgL_envz00_1948, 
(int)(((long)0)))); 
avahi_string_list_free(BgL_lz00_1949); 
return BUNSPEC;} } 
BGL_FUNCTION_END;
}



/* avahi-entry-group-state->symbol */
BGL_EXPORTED_DEF obj_t bgl_avahi_entry_group_state_to_symbol(AvahiEntryGroupState BgL_statez00_37)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 563 */
if(
(BgL_statez00_37==AVAHI_ENTRY_GROUP_UNCOMMITED))
{ /* Llib/avahi.scm 565 */
return 
CNST_TABLE_REF(((long)15));}  else 
{ /* Llib/avahi.scm 565 */
if(
(BgL_statez00_37==AVAHI_ENTRY_GROUP_REGISTERING))
{ /* Llib/avahi.scm 567 */
return 
CNST_TABLE_REF(((long)16));}  else 
{ /* Llib/avahi.scm 567 */
if(
(BgL_statez00_37==AVAHI_ENTRY_GROUP_ESTABLISHED))
{ /* Llib/avahi.scm 569 */
return 
CNST_TABLE_REF(((long)17));}  else 
{ /* Llib/avahi.scm 569 */
if(
(BgL_statez00_37==AVAHI_ENTRY_GROUP_COLLISION))
{ /* Llib/avahi.scm 571 */
return 
CNST_TABLE_REF(((long)18));}  else 
{ /* Llib/avahi.scm 571 */
if(
(BgL_statez00_37==AVAHI_ENTRY_GROUP_FAILURE))
{ /* Llib/avahi.scm 573 */
return 
CNST_TABLE_REF(((long)19));}  else 
{ /* Llib/avahi.scm 577 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1664z00_197;
{ /* Llib/avahi.scm 577 */
BgL_z62avahizd2errorzb0_bglt BgL_new1181z00_198;
{ /* Llib/avahi.scm 577 */
BgL_z62avahizd2errorzb0_bglt BgL_new1180z00_201;
BgL_new1180z00_201 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 577 */
long BgL_arg1667z00_202;
{ /* Llib/avahi.scm 577 */
long BgL_res2277z00_1404;
BgL_res2277z00_1404 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BgL_arg1667z00_202 = BgL_res2277z00_1404; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1180z00_201), BgL_arg1667z00_202); } 
BgL_new1181z00_198 = BgL_new1180z00_201; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1181z00_198)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1181z00_198)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_3746;
{ /* Llib/avahi.scm 577 */
obj_t BgL_arg1665z00_199;
{ /* Llib/avahi.scm 577 */
obj_t BgL_arg1666z00_200;
{ /* Llib/avahi.scm 577 */
obj_t BgL_res2278z00_1408;
{ /* Llib/avahi.scm 577 */
obj_t BgL_classz00_1407;
BgL_classz00_1407 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_res2278z00_1408 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1407); } 
BgL_arg1666z00_200 = BgL_res2278z00_1408; } 
BgL_arg1665z00_199 = 
VECTOR_REF(BgL_arg1666z00_200,((long)2)); } 
BgL_auxz00_3746 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1665z00_199); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1181z00_198)))->BgL_stackz00)=((obj_t)BgL_auxz00_3746),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1181z00_198)))->BgL_procz00)=((obj_t)BGl_string2481z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1181z00_198)))->BgL_msgz00)=((obj_t)BGl_string2472z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1181z00_198)))->BgL_objz00)=((obj_t)
BINT(BgL_statez00_37)),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1181z00_198))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1664z00_197 = BgL_new1181z00_198; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1664z00_197));} } } } } } 
BGL_FUNCTION_END;
}



/* &avahi-entry-group-state->symbol */
obj_t BGl_z62avahizd2entryzd2groupzd2statezd2ze3symbolz81zz__avahi_avahiz00(obj_t BgL_envz00_1950, obj_t BgL_statez00_1951)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 563 */
{ /* Llib/avahi.scm 565 */
AvahiEntryGroupState BgL_auxz00_3762;
{ /* Llib/avahi.scm 565 */
obj_t BgL_tmpz00_3763;
if(
INTEGERP(BgL_statez00_1951))
{ /* Llib/avahi.scm 565 */
BgL_tmpz00_3763 = BgL_statez00_1951
; }  else 
{ 
obj_t BgL_auxz00_3766;
BgL_auxz00_3766 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)23435)), BGl_string2482z00zz__avahi_avahiz00, BGl_string2450z00zz__avahi_avahiz00, BgL_statez00_1951); 
FAILURE(BgL_auxz00_3766,BFALSE,BFALSE);} 
BgL_auxz00_3762 = 
(long)CINT(BgL_tmpz00_3763); } 
return 
bgl_avahi_entry_group_state_to_symbol(BgL_auxz00_3762);} } 
BGL_FUNCTION_END;
}



/* avahi-alternative-host-name */
BGL_EXPORTED_DEF obj_t BGl_avahizd2alternativezd2hostzd2namezd2zz__avahi_avahiz00(obj_t BgL_namez00_38)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 586 */
{ /* Llib/avahi.scm 587 */
char * BgL_tmpz00_3772;
{ /* Llib/avahi.scm 587 */
char * BgL_tmpz00_3773;
BgL_tmpz00_3773 = 
BSTRING_TO_STRING(BgL_namez00_38); 
BgL_tmpz00_3772 = 
avahi_alternative_host_name(BgL_tmpz00_3773); } 
return 
string_to_bstring(BgL_tmpz00_3772);} } 
BGL_FUNCTION_END;
}



/* &avahi-alternative-host-name */
obj_t BGl_z62avahizd2alternativezd2hostzd2namezb0zz__avahi_avahiz00(obj_t BgL_envz00_1952, obj_t BgL_namez00_1953)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 586 */
{ /* Llib/avahi.scm 587 */
obj_t BgL_auxz00_3777;
if(
STRINGP(BgL_namez00_1953))
{ /* Llib/avahi.scm 587 */
BgL_auxz00_3777 = BgL_namez00_1953
; }  else 
{ 
obj_t BgL_auxz00_3780;
BgL_auxz00_3780 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)24353)), BGl_string2483z00zz__avahi_avahiz00, BGl_string2449z00zz__avahi_avahiz00, BgL_namez00_1953); 
FAILURE(BgL_auxz00_3780,BFALSE,BFALSE);} 
return 
BGl_avahizd2alternativezd2hostzd2namezd2zz__avahi_avahiz00(BgL_auxz00_3777);} } 
BGL_FUNCTION_END;
}



/* avahi-alternative-service-name */
BGL_EXPORTED_DEF obj_t BGl_avahizd2alternativezd2servicezd2namezd2zz__avahi_avahiz00(obj_t BgL_namez00_39)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 592 */
{ /* Llib/avahi.scm 593 */
char * BgL_tmpz00_3785;
{ /* Llib/avahi.scm 593 */
char * BgL_tmpz00_3786;
BgL_tmpz00_3786 = 
BSTRING_TO_STRING(BgL_namez00_39); 
BgL_tmpz00_3785 = 
avahi_alternative_service_name(BgL_tmpz00_3786); } 
return 
string_to_bstring(BgL_tmpz00_3785);} } 
BGL_FUNCTION_END;
}



/* &avahi-alternative-service-name */
obj_t BGl_z62avahizd2alternativezd2servicezd2namezb0zz__avahi_avahiz00(obj_t BgL_envz00_1954, obj_t BgL_namez00_1955)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 592 */
{ /* Llib/avahi.scm 593 */
obj_t BgL_auxz00_3790;
if(
STRINGP(BgL_namez00_1955))
{ /* Llib/avahi.scm 593 */
BgL_auxz00_3790 = BgL_namez00_1955
; }  else 
{ 
obj_t BgL_auxz00_3793;
BgL_auxz00_3793 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)24662)), BGl_string2484z00zz__avahi_avahiz00, BGl_string2449z00zz__avahi_avahiz00, BgL_namez00_1955); 
FAILURE(BgL_auxz00_3793,BFALSE,BFALSE);} 
return 
BGl_avahizd2alternativezd2servicezd2namezd2zz__avahi_avahiz00(BgL_auxz00_3790);} } 
BGL_FUNCTION_END;
}



/* avahi-service-browser-close */
BGL_EXPORTED_DEF obj_t BGl_avahizd2servicezd2browserzd2closezd2zz__avahi_avahiz00(BgL_avahizd2servicezd2browserz00_bglt BgL_oz00_41)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 611 */
bgl_avahi_service_browser_close(BgL_oz00_41); BUNSPEC; 
{ /* Llib/avahi.scm 614 */
BgL_avahizd2clientzd2_bglt BgL_i1185z00_204;
BgL_i1185z00_204 = 
(((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(BgL_oz00_41))->BgL_clientz00); 
{ 
obj_t BgL_auxz00_3800;
{ /* Llib/avahi.scm 615 */
obj_t BgL_arg1669z00_205;
BgL_arg1669z00_205 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1185z00_204))->BgL_z52browsersz52); 
BgL_auxz00_3800 = 
bgl_remq_bang(
((obj_t)BgL_oz00_41), BgL_arg1669z00_205); } 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1185z00_204))->BgL_z52browsersz52)=((obj_t)BgL_auxz00_3800),BUNSPEC); } } 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* &avahi-service-browser-close */
obj_t BGl_z62avahizd2servicezd2browserzd2closezb0zz__avahi_avahiz00(obj_t BgL_envz00_1956, obj_t BgL_oz00_1957)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 611 */
{ /* Llib/avahi.scm 612 */
BgL_avahizd2servicezd2browserz00_bglt BgL_auxz00_3805;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1957, BGl_avahizd2servicezd2browserz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 612 */
BgL_auxz00_3805 = 
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_1957)
; }  else 
{ 
obj_t BgL_auxz00_3809;
BgL_auxz00_3809 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)25634)), BGl_string2485z00zz__avahi_avahiz00, BGl_string2486z00zz__avahi_avahiz00, BgL_oz00_1957); 
FAILURE(BgL_auxz00_3809,BFALSE,BFALSE);} 
return 
BGl_avahizd2servicezd2browserzd2closezd2zz__avahi_avahiz00(BgL_auxz00_3805);} } 
BGL_FUNCTION_END;
}



/* avahi-domain-browser-close */
BGL_EXPORTED_DEF obj_t BGl_avahizd2domainzd2browserzd2closezd2zz__avahi_avahiz00(BgL_avahizd2domainzd2browserz00_bglt BgL_oz00_45)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 653 */
bgl_avahi_domain_browser_close(BgL_oz00_45); BUNSPEC; 
BGl_avahizd2gczd2unmarkz12z12zz__avahi_avahiz00(
((BgL_avahizd2objectzd2_bglt)BgL_oz00_45)); 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* &avahi-domain-browser-close */
obj_t BGl_z62avahizd2domainzd2browserzd2closezb0zz__avahi_avahiz00(obj_t BgL_envz00_1958, obj_t BgL_oz00_1959)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 653 */
{ /* Llib/avahi.scm 654 */
BgL_avahizd2domainzd2browserz00_bglt BgL_auxz00_3817;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1959, BGl_avahizd2domainzd2browserz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 654 */
BgL_auxz00_3817 = 
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_1959)
; }  else 
{ 
obj_t BgL_auxz00_3821;
BgL_auxz00_3821 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)27636)), BGl_string2487z00zz__avahi_avahiz00, BGl_string2488z00zz__avahi_avahiz00, BgL_oz00_1959); 
FAILURE(BgL_auxz00_3821,BFALSE,BFALSE);} 
return 
BGl_avahizd2domainzd2browserzd2closezd2zz__avahi_avahiz00(BgL_auxz00_3817);} } 
BGL_FUNCTION_END;
}



/* avahi-service-resolver-close */
BGL_EXPORTED_DEF obj_t BGl_avahizd2servicezd2resolverzd2closezd2zz__avahi_avahiz00(BgL_avahizd2servicezd2resolverz00_bglt BgL_oz00_47)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 674 */
bgl_avahi_service_resolver_close(BgL_oz00_47); BUNSPEC; 
{ /* Llib/avahi.scm 677 */
BgL_avahizd2clientzd2_bglt BgL_i1191z00_207;
BgL_i1191z00_207 = 
(((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(BgL_oz00_47))->BgL_clientz00); 
{ 
obj_t BgL_auxz00_3828;
{ /* Llib/avahi.scm 678 */
obj_t BgL_arg1670z00_208;
BgL_arg1670z00_208 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1191z00_207))->BgL_resolversz00); 
BgL_auxz00_3828 = 
bgl_remq_bang(
((obj_t)BgL_oz00_47), BgL_arg1670z00_208); } 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1191z00_207))->BgL_resolversz00)=((obj_t)BgL_auxz00_3828),BUNSPEC); } } 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* &avahi-service-resolver-close */
obj_t BGl_z62avahizd2servicezd2resolverzd2closezb0zz__avahi_avahiz00(obj_t BgL_envz00_1960, obj_t BgL_oz00_1961)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 674 */
{ /* Llib/avahi.scm 675 */
BgL_avahizd2servicezd2resolverz00_bglt BgL_auxz00_3833;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1961, BGl_avahizd2servicezd2resolverz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 675 */
BgL_auxz00_3833 = 
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_1961)
; }  else 
{ 
obj_t BgL_auxz00_3837;
BgL_auxz00_3837 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)28622)), BGl_string2489z00zz__avahi_avahiz00, BGl_string2490z00zz__avahi_avahiz00, BgL_oz00_1961); 
FAILURE(BgL_auxz00_3837,BFALSE,BFALSE);} 
return 
BGl_avahizd2servicezd2resolverzd2closezd2zz__avahi_avahiz00(BgL_auxz00_3833);} } 
BGL_FUNCTION_END;
}



/* avahi-browser-event->symbol */
BGL_EXPORTED_DEF obj_t bgl_avahi_browser_event_to_symbol(AvahiBrowserEvent BgL_eventz00_48)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 684 */
if(
(BgL_eventz00_48==AVAHI_BROWSER_NEW))
{ /* Llib/avahi.scm 686 */
return 
CNST_TABLE_REF(((long)20));}  else 
{ /* Llib/avahi.scm 686 */
if(
(BgL_eventz00_48==AVAHI_BROWSER_REMOVE))
{ /* Llib/avahi.scm 688 */
return 
CNST_TABLE_REF(((long)21));}  else 
{ /* Llib/avahi.scm 688 */
if(
(BgL_eventz00_48==AVAHI_BROWSER_CACHE_EXHAUSTED))
{ /* Llib/avahi.scm 690 */
return 
CNST_TABLE_REF(((long)22));}  else 
{ /* Llib/avahi.scm 690 */
if(
(BgL_eventz00_48==AVAHI_BROWSER_ALL_FOR_NOW))
{ /* Llib/avahi.scm 692 */
return 
CNST_TABLE_REF(((long)23));}  else 
{ /* Llib/avahi.scm 692 */
if(
(BgL_eventz00_48==AVAHI_BROWSER_FAILURE))
{ /* Llib/avahi.scm 694 */
return 
CNST_TABLE_REF(((long)24));}  else 
{ /* Llib/avahi.scm 698 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1678z00_214;
{ /* Llib/avahi.scm 698 */
BgL_z62avahizd2errorzb0_bglt BgL_new1193z00_215;
{ /* Llib/avahi.scm 698 */
BgL_z62avahizd2errorzb0_bglt BgL_new1192z00_218;
BgL_new1192z00_218 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 698 */
long BgL_arg1681z00_219;
{ /* Llib/avahi.scm 698 */
long BgL_res2284z00_1426;
BgL_res2284z00_1426 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BgL_arg1681z00_219 = BgL_res2284z00_1426; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1192z00_218), BgL_arg1681z00_219); } 
BgL_new1193z00_215 = BgL_new1192z00_218; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1193z00_215)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1193z00_215)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_3865;
{ /* Llib/avahi.scm 698 */
obj_t BgL_arg1679z00_216;
{ /* Llib/avahi.scm 698 */
obj_t BgL_arg1680z00_217;
{ /* Llib/avahi.scm 698 */
obj_t BgL_res2285z00_1430;
{ /* Llib/avahi.scm 698 */
obj_t BgL_classz00_1429;
BgL_classz00_1429 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_res2285z00_1430 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1429); } 
BgL_arg1680z00_217 = BgL_res2285z00_1430; } 
BgL_arg1679z00_216 = 
VECTOR_REF(BgL_arg1680z00_217,((long)2)); } 
BgL_auxz00_3865 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1679z00_216); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1193z00_215)))->BgL_stackz00)=((obj_t)BgL_auxz00_3865),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1193z00_215)))->BgL_procz00)=((obj_t)BGl_string2491z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1193z00_215)))->BgL_msgz00)=((obj_t)BGl_string2492z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1193z00_215)))->BgL_objz00)=((obj_t)
BINT(BgL_eventz00_48)),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1193z00_215))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1678z00_214 = BgL_new1193z00_215; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1678z00_214));} } } } } } 
BGL_FUNCTION_END;
}



/* &avahi-browser-event->symbol */
obj_t BGl_z62avahizd2browserzd2eventzd2ze3symbolz53zz__avahi_avahiz00(obj_t BgL_envz00_1962, obj_t BgL_eventz00_1963)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 684 */
{ /* Llib/avahi.scm 686 */
AvahiBrowserEvent BgL_auxz00_3881;
{ /* Llib/avahi.scm 686 */
obj_t BgL_tmpz00_3882;
if(
INTEGERP(BgL_eventz00_1963))
{ /* Llib/avahi.scm 686 */
BgL_tmpz00_3882 = BgL_eventz00_1963
; }  else 
{ 
obj_t BgL_auxz00_3885;
BgL_auxz00_3885 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)29092)), BGl_string2493z00zz__avahi_avahiz00, BGl_string2450z00zz__avahi_avahiz00, BgL_eventz00_1963); 
FAILURE(BgL_auxz00_3885,BFALSE,BFALSE);} 
BgL_auxz00_3881 = 
(long)CINT(BgL_tmpz00_3882); } 
return 
bgl_avahi_browser_event_to_symbol(BgL_auxz00_3881);} } 
BGL_FUNCTION_END;
}



/* avahi-resolver-event->symbol */
BGL_EXPORTED_DEF obj_t bgl_avahi_resolver_event_to_symbol(AvahiResolverEvent BgL_eventz00_49)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 707 */
if(
(BgL_eventz00_49==AVAHI_RESOLVER_FOUND))
{ /* Llib/avahi.scm 709 */
return 
CNST_TABLE_REF(((long)25));}  else 
{ /* Llib/avahi.scm 709 */
if(
(BgL_eventz00_49==AVAHI_RESOLVER_FAILURE))
{ /* Llib/avahi.scm 711 */
return 
CNST_TABLE_REF(((long)26));}  else 
{ /* Llib/avahi.scm 715 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1689z00_222;
{ /* Llib/avahi.scm 715 */
BgL_z62avahizd2errorzb0_bglt BgL_new1195z00_223;
{ /* Llib/avahi.scm 715 */
BgL_z62avahizd2errorzb0_bglt BgL_new1194z00_226;
BgL_new1194z00_226 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 715 */
long BgL_arg1692z00_227;
{ /* Llib/avahi.scm 715 */
long BgL_res2288z00_1439;
BgL_res2288z00_1439 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BgL_arg1692z00_227 = BgL_res2288z00_1439; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1194z00_226), BgL_arg1692z00_227); } 
BgL_new1195z00_223 = BgL_new1194z00_226; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1195z00_223)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1195z00_223)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_3905;
{ /* Llib/avahi.scm 715 */
obj_t BgL_arg1690z00_224;
{ /* Llib/avahi.scm 715 */
obj_t BgL_arg1691z00_225;
{ /* Llib/avahi.scm 715 */
obj_t BgL_res2289z00_1443;
{ /* Llib/avahi.scm 715 */
obj_t BgL_classz00_1442;
BgL_classz00_1442 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_res2289z00_1443 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1442); } 
BgL_arg1691z00_225 = BgL_res2289z00_1443; } 
BgL_arg1690z00_224 = 
VECTOR_REF(BgL_arg1691z00_225,((long)2)); } 
BgL_auxz00_3905 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1690z00_224); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1195z00_223)))->BgL_stackz00)=((obj_t)BgL_auxz00_3905),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1195z00_223)))->BgL_procz00)=((obj_t)BGl_string2494z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1195z00_223)))->BgL_msgz00)=((obj_t)BGl_string2492z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1195z00_223)))->BgL_objz00)=((obj_t)
BINT(BgL_eventz00_49)),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1195z00_223))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1689z00_222 = BgL_new1195z00_223; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1689z00_222));} } } 
BGL_FUNCTION_END;
}



/* &avahi-resolver-event->symbol */
obj_t BGl_z62avahizd2resolverzd2eventzd2ze3symbolz53zz__avahi_avahiz00(obj_t BgL_envz00_1964, obj_t BgL_eventz00_1965)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 707 */
{ /* Llib/avahi.scm 709 */
AvahiResolverEvent BgL_auxz00_3921;
{ /* Llib/avahi.scm 709 */
obj_t BgL_tmpz00_3922;
if(
INTEGERP(BgL_eventz00_1965))
{ /* Llib/avahi.scm 709 */
BgL_tmpz00_3922 = BgL_eventz00_1965
; }  else 
{ 
obj_t BgL_auxz00_3925;
BgL_auxz00_3925 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)29961)), BGl_string2495z00zz__avahi_avahiz00, BGl_string2450z00zz__avahi_avahiz00, BgL_eventz00_1965); 
FAILURE(BgL_auxz00_3925,BFALSE,BFALSE);} 
BgL_auxz00_3921 = 
(long)CINT(BgL_tmpz00_3922); } 
return 
bgl_avahi_resolver_event_to_symbol(BgL_auxz00_3921);} } 
BGL_FUNCTION_END;
}



/* avahi-if-index->symbol */
BGL_EXPORTED_DEF obj_t bgl_avahi_if_index_to_symbol(AvahiIfIndex BgL_indexz00_50)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 724 */
if(
(BgL_indexz00_50==AVAHI_IF_UNSPEC))
{ /* Llib/avahi.scm 726 */
return 
CNST_TABLE_REF(((long)27));}  else 
{ /* Llib/avahi.scm 729 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1694z00_229;
{ /* Llib/avahi.scm 729 */
BgL_z62avahizd2errorzb0_bglt BgL_new1197z00_230;
{ /* Llib/avahi.scm 729 */
BgL_z62avahizd2errorzb0_bglt BgL_new1196z00_233;
BgL_new1196z00_233 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 729 */
long BgL_arg1698z00_234;
{ /* Llib/avahi.scm 729 */
long BgL_res2291z00_1449;
BgL_res2291z00_1449 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BgL_arg1698z00_234 = BgL_res2291z00_1449; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1196z00_233), BgL_arg1698z00_234); } 
BgL_new1197z00_230 = BgL_new1196z00_233; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1197z00_230)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1197z00_230)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_3942;
{ /* Llib/avahi.scm 729 */
obj_t BgL_arg1696z00_231;
{ /* Llib/avahi.scm 729 */
obj_t BgL_arg1697z00_232;
{ /* Llib/avahi.scm 729 */
obj_t BgL_res2292z00_1453;
{ /* Llib/avahi.scm 729 */
obj_t BgL_classz00_1452;
BgL_classz00_1452 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_res2292z00_1453 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1452); } 
BgL_arg1697z00_232 = BgL_res2292z00_1453; } 
BgL_arg1696z00_231 = 
VECTOR_REF(BgL_arg1697z00_232,((long)2)); } 
BgL_auxz00_3942 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1696z00_231); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1197z00_230)))->BgL_stackz00)=((obj_t)BgL_auxz00_3942),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1197z00_230)))->BgL_procz00)=((obj_t)BGl_string2496z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1197z00_230)))->BgL_msgz00)=((obj_t)BGl_string2497z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1197z00_230)))->BgL_objz00)=((obj_t)
BINT(BgL_indexz00_50)),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1197z00_230))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1694z00_229 = BgL_new1197z00_230; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1694z00_229));} } 
BGL_FUNCTION_END;
}



/* &avahi-if-index->symbol */
obj_t BGl_z62avahizd2ifzd2indexzd2ze3symbolz53zz__avahi_avahiz00(obj_t BgL_envz00_1966, obj_t BgL_indexz00_1967)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 724 */
{ /* Llib/avahi.scm 726 */
AvahiIfIndex BgL_auxz00_3958;
{ /* Llib/avahi.scm 726 */
obj_t BgL_tmpz00_3959;
if(
INTEGERP(BgL_indexz00_1967))
{ /* Llib/avahi.scm 726 */
BgL_tmpz00_3959 = BgL_indexz00_1967
; }  else 
{ 
obj_t BgL_auxz00_3962;
BgL_auxz00_3962 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)30586)), BGl_string2498z00zz__avahi_avahiz00, BGl_string2450z00zz__avahi_avahiz00, BgL_indexz00_1967); 
FAILURE(BgL_auxz00_3962,BFALSE,BFALSE);} 
BgL_auxz00_3958 = 
(long)CINT(BgL_tmpz00_3959); } 
return 
bgl_avahi_if_index_to_symbol(BgL_auxz00_3958);} } 
BGL_FUNCTION_END;
}



/* avahi-protocol->symbol */
BGL_EXPORTED_DEF obj_t bgl_avahi_protocol_to_symbol(AvahiProtocol BgL_protoz00_51)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 738 */
if(
(BgL_protoz00_51==AVAHI_PROTO_INET))
{ /* Llib/avahi.scm 740 */
return 
CNST_TABLE_REF(((long)28));}  else 
{ /* Llib/avahi.scm 740 */
if(
(BgL_protoz00_51==AVAHI_PROTO_INET6))
{ /* Llib/avahi.scm 742 */
return 
CNST_TABLE_REF(((long)29));}  else 
{ /* Llib/avahi.scm 742 */
if(
(BgL_protoz00_51==AVAHI_PROTO_UNSPEC))
{ /* Llib/avahi.scm 744 */
return 
CNST_TABLE_REF(((long)30));}  else 
{ /* Llib/avahi.scm 748 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1704z00_238;
{ /* Llib/avahi.scm 748 */
BgL_z62avahizd2errorzb0_bglt BgL_new1199z00_239;
{ /* Llib/avahi.scm 748 */
BgL_z62avahizd2errorzb0_bglt BgL_new1198z00_242;
BgL_new1198z00_242 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 748 */
long BgL_arg1712z00_243;
{ /* Llib/avahi.scm 748 */
long BgL_res2296z00_1465;
BgL_res2296z00_1465 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BgL_arg1712z00_243 = BgL_res2296z00_1465; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1198z00_242), BgL_arg1712z00_243); } 
BgL_new1199z00_239 = BgL_new1198z00_242; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1199z00_239)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1199z00_239)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_3985;
{ /* Llib/avahi.scm 748 */
obj_t BgL_arg1705z00_240;
{ /* Llib/avahi.scm 748 */
obj_t BgL_arg1708z00_241;
{ /* Llib/avahi.scm 748 */
obj_t BgL_res2297z00_1469;
{ /* Llib/avahi.scm 748 */
obj_t BgL_classz00_1468;
BgL_classz00_1468 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_res2297z00_1469 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1468); } 
BgL_arg1708z00_241 = BgL_res2297z00_1469; } 
BgL_arg1705z00_240 = 
VECTOR_REF(BgL_arg1708z00_241,((long)2)); } 
BgL_auxz00_3985 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1705z00_240); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1199z00_239)))->BgL_stackz00)=((obj_t)BgL_auxz00_3985),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1199z00_239)))->BgL_procz00)=((obj_t)BGl_string2499z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1199z00_239)))->BgL_msgz00)=((obj_t)BGl_string2500z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1199z00_239)))->BgL_objz00)=((obj_t)
BINT(BgL_protoz00_51)),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1199z00_239))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1704z00_238 = BgL_new1199z00_239; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1704z00_238));} } } } 
BGL_FUNCTION_END;
}



/* &avahi-protocol->symbol */
obj_t BGl_z62avahizd2protocolzd2ze3symbolz81zz__avahi_avahiz00(obj_t BgL_envz00_1968, obj_t BgL_protoz00_1969)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 738 */
{ /* Llib/avahi.scm 740 */
AvahiProtocol BgL_auxz00_4001;
{ /* Llib/avahi.scm 740 */
obj_t BgL_tmpz00_4002;
if(
INTEGERP(BgL_protoz00_1969))
{ /* Llib/avahi.scm 740 */
BgL_tmpz00_4002 = BgL_protoz00_1969
; }  else 
{ 
obj_t BgL_auxz00_4005;
BgL_auxz00_4005 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)31113)), BGl_string2501z00zz__avahi_avahiz00, BGl_string2450z00zz__avahi_avahiz00, BgL_protoz00_1969); 
FAILURE(BgL_auxz00_4005,BFALSE,BFALSE);} 
BgL_auxz00_4001 = 
(long)CINT(BgL_tmpz00_4002); } 
return 
bgl_avahi_protocol_to_symbol(BgL_auxz00_4001);} } 
BGL_FUNCTION_END;
}



/* avahi-symbol->protocol */
BGL_EXPORTED_DEF AvahiProtocol bgl_avahi_symbol_to_protocol(obj_t BgL_protoz00_52)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 757 */
if(
(BgL_protoz00_52==
CNST_TABLE_REF(((long)28))))
{ /* Llib/avahi.scm 758 */
return AVAHI_PROTO_INET;}  else 
{ /* Llib/avahi.scm 758 */
if(
(BgL_protoz00_52==
CNST_TABLE_REF(((long)29))))
{ /* Llib/avahi.scm 758 */
return AVAHI_PROTO_INET6;}  else 
{ /* Llib/avahi.scm 758 */
if(
(BgL_protoz00_52==
CNST_TABLE_REF(((long)30))))
{ /* Llib/avahi.scm 758 */
return AVAHI_PROTO_UNSPEC;}  else 
{ /* Llib/avahi.scm 767 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1719z00_248;
{ /* Llib/avahi.scm 767 */
BgL_z62avahizd2errorzb0_bglt BgL_new1201z00_249;
{ /* Llib/avahi.scm 767 */
BgL_z62avahizd2errorzb0_bglt BgL_new1200z00_252;
BgL_new1200z00_252 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 767 */
long BgL_arg1738z00_253;
{ /* Llib/avahi.scm 767 */
long BgL_res2301z00_1478;
BgL_res2301z00_1478 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BgL_arg1738z00_253 = BgL_res2301z00_1478; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1200z00_252), BgL_arg1738z00_253); } 
BgL_new1201z00_249 = BgL_new1200z00_252; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1201z00_249)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1201z00_249)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_4028;
{ /* Llib/avahi.scm 767 */
obj_t BgL_arg1725z00_250;
{ /* Llib/avahi.scm 767 */
obj_t BgL_arg1737z00_251;
{ /* Llib/avahi.scm 767 */
obj_t BgL_res2302z00_1482;
{ /* Llib/avahi.scm 767 */
obj_t BgL_classz00_1481;
BgL_classz00_1481 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_res2302z00_1482 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1481); } 
BgL_arg1737z00_251 = BgL_res2302z00_1482; } 
BgL_arg1725z00_250 = 
VECTOR_REF(BgL_arg1737z00_251,((long)2)); } 
BgL_auxz00_4028 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1725z00_250); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1201z00_249)))->BgL_stackz00)=((obj_t)BgL_auxz00_4028),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1201z00_249)))->BgL_procz00)=((obj_t)BGl_string2502z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1201z00_249)))->BgL_msgz00)=((obj_t)BGl_string2500z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1201z00_249)))->BgL_objz00)=((obj_t)BgL_protoz00_52),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1201z00_249))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1719z00_248 = BgL_new1201z00_249; } 
return 
(long)CINT(
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1719z00_248)));} } } } 
BGL_FUNCTION_END;
}



/* &avahi-symbol->protocol */
obj_t BGl_z62avahizd2symbolzd2ze3protocolz81zz__avahi_avahiz00(obj_t BgL_envz00_1970, obj_t BgL_protoz00_1971)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 757 */
{ /* Llib/avahi.scm 758 */
long BgL_tmpz00_4044;
{ /* Llib/avahi.scm 758 */
obj_t BgL_auxz00_4045;
if(
SYMBOLP(BgL_protoz00_1971))
{ /* Llib/avahi.scm 758 */
BgL_auxz00_4045 = BgL_protoz00_1971
; }  else 
{ 
obj_t BgL_auxz00_4048;
BgL_auxz00_4048 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)31763)), BGl_string2503z00zz__avahi_avahiz00, BGl_string2504z00zz__avahi_avahiz00, BgL_protoz00_1971); 
FAILURE(BgL_auxz00_4048,BFALSE,BFALSE);} 
BgL_tmpz00_4044 = 
bgl_avahi_symbol_to_protocol(BgL_auxz00_4045); } 
return 
BINT(BgL_tmpz00_4044);} } 
BGL_FUNCTION_END;
}



/* avahi-lookup-flags->symbol */
BGL_EXPORTED_DEF obj_t bgl_avahi_lookup_flags_to_symbol(AvahiLookupFlags BgL_flagz00_53)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 776 */
if(
(BgL_flagz00_53==AVAHI_LOOKUP_NO_TXT))
{ /* Llib/avahi.scm 778 */
return 
CNST_TABLE_REF(((long)31));}  else 
{ /* Llib/avahi.scm 778 */
if(
(BgL_flagz00_53==AVAHI_LOOKUP_NO_ADDRESS))
{ /* Llib/avahi.scm 780 */
return 
CNST_TABLE_REF(((long)32));}  else 
{ /* Llib/avahi.scm 780 */
if(
(BgL_flagz00_53==((long)0)))
{ /* Llib/avahi.scm 782 */
return 
CNST_TABLE_REF(((long)33));}  else 
{ /* Llib/avahi.scm 786 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1747z00_257;
{ /* Llib/avahi.scm 786 */
BgL_z62avahizd2errorzb0_bglt BgL_new1203z00_258;
{ /* Llib/avahi.scm 786 */
BgL_z62avahizd2errorzb0_bglt BgL_new1202z00_261;
BgL_new1202z00_261 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 786 */
long BgL_arg1750z00_262;
{ /* Llib/avahi.scm 786 */
long BgL_res2306z00_1493;
BgL_res2306z00_1493 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BgL_arg1750z00_262 = BgL_res2306z00_1493; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1202z00_261), BgL_arg1750z00_262); } 
BgL_new1203z00_258 = BgL_new1202z00_261; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1203z00_258)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1203z00_258)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_4071;
{ /* Llib/avahi.scm 786 */
obj_t BgL_arg1748z00_259;
{ /* Llib/avahi.scm 786 */
obj_t BgL_arg1749z00_260;
{ /* Llib/avahi.scm 786 */
obj_t BgL_res2307z00_1497;
{ /* Llib/avahi.scm 786 */
obj_t BgL_classz00_1496;
BgL_classz00_1496 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_res2307z00_1497 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1496); } 
BgL_arg1749z00_260 = BgL_res2307z00_1497; } 
BgL_arg1748z00_259 = 
VECTOR_REF(BgL_arg1749z00_260,((long)2)); } 
BgL_auxz00_4071 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1748z00_259); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1203z00_258)))->BgL_stackz00)=((obj_t)BgL_auxz00_4071),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1203z00_258)))->BgL_procz00)=((obj_t)BGl_string2505z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1203z00_258)))->BgL_msgz00)=((obj_t)BGl_string2506z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1203z00_258)))->BgL_objz00)=((obj_t)
BINT(BgL_flagz00_53)),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1203z00_258))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1747z00_257 = BgL_new1203z00_258; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1747z00_257));} } } } 
BGL_FUNCTION_END;
}



/* &avahi-lookup-flags->symbol */
obj_t BGl_z62avahizd2lookupzd2flagszd2ze3symbolz53zz__avahi_avahiz00(obj_t BgL_envz00_1972, obj_t BgL_flagz00_1973)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 776 */
{ /* Llib/avahi.scm 778 */
AvahiLookupFlags BgL_auxz00_4087;
{ /* Llib/avahi.scm 778 */
obj_t BgL_tmpz00_4088;
if(
INTEGERP(BgL_flagz00_1973))
{ /* Llib/avahi.scm 778 */
BgL_tmpz00_4088 = BgL_flagz00_1973
; }  else 
{ 
obj_t BgL_auxz00_4091;
BgL_auxz00_4091 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)32426)), BGl_string2507z00zz__avahi_avahiz00, BGl_string2450z00zz__avahi_avahiz00, BgL_flagz00_1973); 
FAILURE(BgL_auxz00_4091,BFALSE,BFALSE);} 
BgL_auxz00_4087 = 
(long)CINT(BgL_tmpz00_4088); } 
return 
bgl_avahi_lookup_flags_to_symbol(BgL_auxz00_4087);} } 
BGL_FUNCTION_END;
}



/* avahi-lookup-result-flags->symbol */
BGL_EXPORTED_DEF obj_t bgl_avahi_lookup_result_flags_to_symbol(AvahiLookupResultFlags BgL_flagz00_54)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 795 */
if(
(BgL_flagz00_54==AVAHI_LOOKUP_RESULT_CACHED))
{ /* Llib/avahi.scm 797 */
return 
CNST_TABLE_REF(((long)34));}  else 
{ /* Llib/avahi.scm 797 */
if(
(BgL_flagz00_54==AVAHI_LOOKUP_RESULT_WIDE_AREA))
{ /* Llib/avahi.scm 799 */
return 
CNST_TABLE_REF(((long)35));}  else 
{ /* Llib/avahi.scm 799 */
if(
(BgL_flagz00_54==AVAHI_LOOKUP_RESULT_MULTICAST))
{ /* Llib/avahi.scm 801 */
return 
CNST_TABLE_REF(((long)36));}  else 
{ /* Llib/avahi.scm 801 */
if(
(BgL_flagz00_54==AVAHI_LOOKUP_RESULT_LOCAL))
{ /* Llib/avahi.scm 803 */
return 
CNST_TABLE_REF(((long)37));}  else 
{ /* Llib/avahi.scm 803 */
if(
(BgL_flagz00_54==AVAHI_LOOKUP_RESULT_OUR_OWN))
{ /* Llib/avahi.scm 805 */
return 
CNST_TABLE_REF(((long)38));}  else 
{ /* Llib/avahi.scm 805 */
if(
(BgL_flagz00_54==AVAHI_LOOKUP_RESULT_STATIC))
{ /* Llib/avahi.scm 807 */
return 
CNST_TABLE_REF(((long)39));}  else 
{ /* Llib/avahi.scm 807 */
if(
(BgL_flagz00_54==((long)0)))
{ /* Llib/avahi.scm 809 */
return 
CNST_TABLE_REF(((long)40));}  else 
{ /* Llib/avahi.scm 813 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1758z00_270;
{ /* Llib/avahi.scm 813 */
BgL_z62avahizd2errorzb0_bglt BgL_new1205z00_271;
{ /* Llib/avahi.scm 813 */
BgL_z62avahizd2errorzb0_bglt BgL_new1204z00_274;
BgL_new1204z00_274 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 813 */
long BgL_arg1761z00_275;
{ /* Llib/avahi.scm 813 */
long BgL_res2315z00_1520;
BgL_res2315z00_1520 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BgL_arg1761z00_275 = BgL_res2315z00_1520; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1204z00_274), BgL_arg1761z00_275); } 
BgL_new1205z00_271 = BgL_new1204z00_274; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1205z00_271)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1205z00_271)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_4126;
{ /* Llib/avahi.scm 813 */
obj_t BgL_arg1759z00_272;
{ /* Llib/avahi.scm 813 */
obj_t BgL_arg1760z00_273;
{ /* Llib/avahi.scm 813 */
obj_t BgL_res2316z00_1524;
{ /* Llib/avahi.scm 813 */
obj_t BgL_classz00_1523;
BgL_classz00_1523 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_res2316z00_1524 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1523); } 
BgL_arg1760z00_273 = BgL_res2316z00_1524; } 
BgL_arg1759z00_272 = 
VECTOR_REF(BgL_arg1760z00_273,((long)2)); } 
BgL_auxz00_4126 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1759z00_272); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1205z00_271)))->BgL_stackz00)=((obj_t)BgL_auxz00_4126),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1205z00_271)))->BgL_procz00)=((obj_t)BGl_string2508z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1205z00_271)))->BgL_msgz00)=((obj_t)BGl_string2509z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1205z00_271)))->BgL_objz00)=((obj_t)
BINT(BgL_flagz00_54)),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1205z00_271))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1758z00_270 = BgL_new1205z00_271; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1758z00_270));} } } } } } } } 
BGL_FUNCTION_END;
}



/* &avahi-lookup-result-flags->symbol */
obj_t BGl_z62avahizd2lookupzd2resultzd2flagszd2ze3symbolz81zz__avahi_avahiz00(obj_t BgL_envz00_1974, obj_t BgL_flagz00_1975)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 795 */
{ /* Llib/avahi.scm 797 */
AvahiLookupResultFlags BgL_auxz00_4142;
{ /* Llib/avahi.scm 797 */
obj_t BgL_tmpz00_4143;
if(
INTEGERP(BgL_flagz00_1975))
{ /* Llib/avahi.scm 797 */
BgL_tmpz00_4143 = BgL_flagz00_1975
; }  else 
{ 
obj_t BgL_auxz00_4146;
BgL_auxz00_4146 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)33123)), BGl_string2510z00zz__avahi_avahiz00, BGl_string2450z00zz__avahi_avahiz00, BgL_flagz00_1975); 
FAILURE(BgL_auxz00_4146,BFALSE,BFALSE);} 
BgL_auxz00_4142 = 
(long)CINT(BgL_tmpz00_4143); } 
return 
bgl_avahi_lookup_result_flags_to_symbol(BgL_auxz00_4142);} } 
BGL_FUNCTION_END;
}



/* avahi-symbol->domain-browser-type */
obj_t BGl_avahizd2symbolzd2ze3domainzd2browserzd2typeze3zz__avahi_avahiz00(obj_t BgL_btypez00_55)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 822 */
{ /* Llib/avahi.scm 823 */
bool_t BgL_testz00_4152;
if(
(BgL_btypez00_55==
CNST_TABLE_REF(((long)41))))
{ /* Llib/avahi.scm 823 */
BgL_testz00_4152 = ((bool_t)1)
; }  else 
{ /* Llib/avahi.scm 823 */
if(
(BgL_btypez00_55==
CNST_TABLE_REF(((long)42))))
{ /* Llib/avahi.scm 823 */
BgL_testz00_4152 = ((bool_t)1)
; }  else 
{ /* Llib/avahi.scm 823 */
BgL_testz00_4152 = 
BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(BgL_btypez00_55, 
CNST_TABLE_REF(((long)43)))
; } } 
if(BgL_testz00_4152)
{ /* Llib/avahi.scm 823 */
return 
BINT(AVAHI_DOMAIN_BROWSER_BROWSE);}  else 
{ /* Llib/avahi.scm 823 */
bool_t BgL_testz00_4162;
if(
(BgL_btypez00_55==
CNST_TABLE_REF(((long)41))))
{ /* Llib/avahi.scm 823 */
BgL_testz00_4162 = ((bool_t)1)
; }  else 
{ /* Llib/avahi.scm 823 */
if(
(BgL_btypez00_55==
CNST_TABLE_REF(((long)42))))
{ /* Llib/avahi.scm 823 */
BgL_testz00_4162 = ((bool_t)1)
; }  else 
{ /* Llib/avahi.scm 823 */
BgL_testz00_4162 = 
BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(BgL_btypez00_55, 
CNST_TABLE_REF(((long)44)))
; } } 
if(BgL_testz00_4162)
{ /* Llib/avahi.scm 823 */
return 
BINT(AVAHI_DOMAIN_BROWSER_BROWSE_DEFAULT);}  else 
{ /* Llib/avahi.scm 823 */
bool_t BgL_testz00_4172;
if(
(BgL_btypez00_55==
CNST_TABLE_REF(((long)41))))
{ /* Llib/avahi.scm 823 */
BgL_testz00_4172 = ((bool_t)1)
; }  else 
{ /* Llib/avahi.scm 823 */
if(
(BgL_btypez00_55==
CNST_TABLE_REF(((long)42))))
{ /* Llib/avahi.scm 823 */
BgL_testz00_4172 = ((bool_t)1)
; }  else 
{ /* Llib/avahi.scm 823 */
BgL_testz00_4172 = 
BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(BgL_btypez00_55, 
CNST_TABLE_REF(((long)45)))
; } } 
if(BgL_testz00_4172)
{ /* Llib/avahi.scm 823 */
return 
BINT(AVAHI_DOMAIN_BROWSER_REGISTER);}  else 
{ /* Llib/avahi.scm 823 */
bool_t BgL_testz00_4182;
if(
(BgL_btypez00_55==
CNST_TABLE_REF(((long)41))))
{ /* Llib/avahi.scm 823 */
BgL_testz00_4182 = ((bool_t)1)
; }  else 
{ /* Llib/avahi.scm 823 */
if(
(BgL_btypez00_55==
CNST_TABLE_REF(((long)42))))
{ /* Llib/avahi.scm 823 */
BgL_testz00_4182 = ((bool_t)1)
; }  else 
{ /* Llib/avahi.scm 823 */
BgL_testz00_4182 = 
BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(BgL_btypez00_55, 
CNST_TABLE_REF(((long)46)))
; } } 
if(BgL_testz00_4182)
{ /* Llib/avahi.scm 823 */
return 
BINT(AVAHI_DOMAIN_BROWSER_REGISTER_DEFAULT);}  else 
{ /* Llib/avahi.scm 823 */
bool_t BgL_testz00_4192;
if(
(BgL_btypez00_55==
CNST_TABLE_REF(((long)41))))
{ /* Llib/avahi.scm 823 */
BgL_testz00_4192 = ((bool_t)1)
; }  else 
{ /* Llib/avahi.scm 823 */
if(
(BgL_btypez00_55==
CNST_TABLE_REF(((long)42))))
{ /* Llib/avahi.scm 823 */
BgL_testz00_4192 = ((bool_t)1)
; }  else 
{ /* Llib/avahi.scm 823 */
BgL_testz00_4192 = 
BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(BgL_btypez00_55, 
CNST_TABLE_REF(((long)47)))
; } } 
if(BgL_testz00_4192)
{ /* Llib/avahi.scm 823 */
return 
BINT(AVAHI_DOMAIN_BROWSER_BROWSE_LEGACY);}  else 
{ /* Llib/avahi.scm 823 */
bool_t BgL_testz00_4202;
if(
(BgL_btypez00_55==
CNST_TABLE_REF(((long)41))))
{ /* Llib/avahi.scm 823 */
BgL_testz00_4202 = ((bool_t)1)
; }  else 
{ /* Llib/avahi.scm 823 */
if(
(BgL_btypez00_55==
CNST_TABLE_REF(((long)42))))
{ /* Llib/avahi.scm 823 */
BgL_testz00_4202 = ((bool_t)1)
; }  else 
{ /* Llib/avahi.scm 823 */
BgL_testz00_4202 = 
BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(BgL_btypez00_55, 
CNST_TABLE_REF(((long)48)))
; } } 
if(BgL_testz00_4202)
{ /* Llib/avahi.scm 823 */
return 
BINT(AVAHI_DOMAIN_BROWSER_MAX);}  else 
{ /* Llib/avahi.scm 838 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1780z00_295;
{ /* Llib/avahi.scm 838 */
BgL_z62avahizd2errorzb0_bglt BgL_new1207z00_296;
{ /* Llib/avahi.scm 838 */
BgL_z62avahizd2errorzb0_bglt BgL_new1206z00_299;
BgL_new1206z00_299 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 838 */
long BgL_arg1783z00_300;
{ /* Llib/avahi.scm 838 */
long BgL_res2329z00_1551;
BgL_res2329z00_1551 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BgL_arg1783z00_300 = BgL_res2329z00_1551; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1206z00_299), BgL_arg1783z00_300); } 
BgL_new1207z00_296 = BgL_new1206z00_299; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1207z00_296)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1207z00_296)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_4220;
{ /* Llib/avahi.scm 838 */
obj_t BgL_arg1781z00_297;
{ /* Llib/avahi.scm 838 */
obj_t BgL_arg1782z00_298;
{ /* Llib/avahi.scm 838 */
obj_t BgL_res2330z00_1555;
{ /* Llib/avahi.scm 838 */
obj_t BgL_classz00_1554;
BgL_classz00_1554 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_res2330z00_1555 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1554); } 
BgL_arg1782z00_298 = BgL_res2330z00_1555; } 
BgL_arg1781z00_297 = 
VECTOR_REF(BgL_arg1782z00_298,((long)2)); } 
BgL_auxz00_4220 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1781z00_297); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1207z00_296)))->BgL_stackz00)=((obj_t)BgL_auxz00_4220),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1207z00_296)))->BgL_procz00)=((obj_t)BGl_string2511z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1207z00_296)))->BgL_msgz00)=((obj_t)BGl_string2512z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1207z00_296)))->BgL_objz00)=((obj_t)BgL_btypez00_55),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1207z00_296))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1780z00_295 = BgL_new1207z00_296; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1780z00_295));} } } } } } } } 
BGL_FUNCTION_END;
}



/* object-init */
obj_t BGl_objectzd2initzd2zz__avahi_avahiz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 15 */
{ /* Llib/avahi.scm 50 */
obj_t BgL_arg1787z00_316;obj_t BgL_arg1788z00_317;
{ /* Llib/avahi.scm 50 */
obj_t BgL_v1230z00_334;
BgL_v1230z00_334 = 
create_vector(((long)1)); 
{ /* Llib/avahi.scm 50 */
obj_t BgL_arg1794z00_335;
BgL_arg1794z00_335 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)49)), BGl_proc2515z00zz__avahi_avahiz00, BGl_proc2514z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2513z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)50))); 
VECTOR_SET(BgL_v1230z00_334,((long)0),BgL_arg1794z00_335); } 
BgL_arg1787z00_316 = BgL_v1230z00_334; } 
{ /* Llib/avahi.scm 50 */
obj_t BgL_v1231z00_348;
BgL_v1231z00_348 = 
create_vector(((long)0)); 
BgL_arg1788z00_317 = BgL_v1231z00_348; } 
BGl_z62avahizd2errorzb0zz__avahi_avahiz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)51)), 
CNST_TABLE_REF(((long)52)), BGl_z62errorz62zz__objectz00, ((long)37908), BGl_proc2518z00zz__avahi_avahiz00, BGl_proc2517z00zz__avahi_avahiz00, BFALSE, BGl_proc2516z00zz__avahi_avahiz00, BFALSE, BgL_arg1787z00_316, BgL_arg1788z00_317); } 
{ /* Llib/avahi.scm 52 */
obj_t BgL_arg1804z00_355;obj_t BgL_arg1805z00_356;
{ /* Llib/avahi.scm 52 */
obj_t BgL_v1232z00_373;
BgL_v1232z00_373 = 
create_vector(((long)0)); 
BgL_arg1804z00_355 = BgL_v1232z00_373; } 
{ /* Llib/avahi.scm 52 */
obj_t BgL_v1233z00_374;
BgL_v1233z00_374 = 
create_vector(((long)0)); 
BgL_arg1805z00_356 = BgL_v1233z00_374; } 
BGl_z62avahizd2collisionzd2errorz62zz__avahi_avahiz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)53)), 
CNST_TABLE_REF(((long)52)), BGl_z62avahizd2errorzb0zz__avahi_avahiz00, ((long)15882), BGl_proc2521z00zz__avahi_avahiz00, BGl_proc2520z00zz__avahi_avahiz00, BFALSE, BGl_proc2519z00zz__avahi_avahiz00, BFALSE, BgL_arg1804z00_355, BgL_arg1805z00_356); } 
{ /* Llib/avahi.scm 54 */
obj_t BgL_arg1813z00_380;obj_t BgL_arg1814z00_381;
{ /* Llib/avahi.scm 54 */
obj_t BgL_v1234z00_387;
BgL_v1234z00_387 = 
create_vector(((long)0)); 
BgL_arg1813z00_380 = BgL_v1234z00_387; } 
{ /* Llib/avahi.scm 54 */
obj_t BgL_v1235z00_388;
BgL_v1235z00_388 = 
create_vector(((long)0)); 
BgL_arg1814z00_381 = BgL_v1235z00_388; } 
BGl_avahizd2objectzd2zz__avahi_avahiz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)54)), 
CNST_TABLE_REF(((long)52)), BGl_objectz00zz__objectz00, ((long)39383), BFALSE, BGl_proc2523z00zz__avahi_avahiz00, BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_proc2522z00zz__avahi_avahiz00, BFALSE, BgL_arg1813z00_380, BgL_arg1814z00_381); } 
{ /* Llib/avahi.scm 57 */
obj_t BgL_arg1820z00_393;obj_t BgL_arg1821z00_394;
{ /* Llib/avahi.scm 57 */
obj_t BgL_v1236z00_400;
BgL_v1236z00_400 = 
create_vector(((long)2)); 
{ /* Llib/avahi.scm 57 */
obj_t BgL_arg1825z00_401;
BgL_arg1825z00_401 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)55)), BGl_proc2526z00zz__avahi_avahiz00, BGl_proc2525z00zz__avahi_avahiz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2524z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)50))); 
VECTOR_SET(BgL_v1236z00_400,((long)0),BgL_arg1825z00_401); } 
{ /* Llib/avahi.scm 57 */
obj_t BgL_arg1832z00_414;
BgL_arg1832z00_414 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)56)), BGl_proc2529z00zz__avahi_avahiz00, BGl_proc2528z00zz__avahi_avahiz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2527z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)57))); 
VECTOR_SET(BgL_v1236z00_400,((long)1),BgL_arg1832z00_414); } 
BgL_arg1820z00_393 = BgL_v1236z00_400; } 
{ /* Llib/avahi.scm 57 */
obj_t BgL_v1237z00_427;
BgL_v1237z00_427 = 
create_vector(((long)0)); 
BgL_arg1821z00_394 = BgL_v1237z00_427; } 
BGl_avahizd2pollzd2zz__avahi_avahiz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)58)), 
CNST_TABLE_REF(((long)52)), BGl_avahizd2objectzd2zz__avahi_avahiz00, ((long)43719), BFALSE, BGl_proc2531z00zz__avahi_avahiz00, BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_proc2530z00zz__avahi_avahiz00, BFALSE, BgL_arg1820z00_393, BgL_arg1821z00_394); } 
{ /* Llib/avahi.scm 61 */
obj_t BgL_arg1842z00_433;obj_t BgL_arg1843z00_434;
{ /* Llib/avahi.scm 61 */
obj_t BgL_v1238z00_448;
BgL_v1238z00_448 = 
create_vector(((long)1)); 
{ /* Llib/avahi.scm 61 */
obj_t BgL_arg1850z00_449;
BgL_arg1850z00_449 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc2534z00zz__avahi_avahiz00, BGl_proc2533z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2532z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)60))); 
VECTOR_SET(BgL_v1238z00_448,((long)0),BgL_arg1850z00_449); } 
BgL_arg1842z00_433 = BgL_v1238z00_448; } 
{ /* Llib/avahi.scm 61 */
obj_t BgL_v1239z00_462;
BgL_v1239z00_462 = 
create_vector(((long)0)); 
BgL_arg1843z00_434 = BgL_v1239z00_462; } 
BGl_avahizd2simplezd2pollz00zz__avahi_avahiz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)61)), 
CNST_TABLE_REF(((long)52)), BGl_avahizd2pollzd2zz__avahi_avahiz00, ((long)59689), BGl_proc2537z00zz__avahi_avahiz00, BGl_proc2536z00zz__avahi_avahiz00, BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_proc2535z00zz__avahi_avahiz00, BFALSE, BgL_arg1842z00_433, BgL_arg1843z00_434); } 
{ /* Llib/avahi.scm 64 */
obj_t BgL_arg1860z00_469;obj_t BgL_arg1861z00_470;
{ /* Llib/avahi.scm 64 */
obj_t BgL_v1240z00_484;
BgL_v1240z00_484 = 
create_vector(((long)1)); 
{ /* Llib/avahi.scm 64 */
obj_t BgL_arg1868z00_485;
BgL_arg1868z00_485 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc2540z00zz__avahi_avahiz00, BGl_proc2539z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2538z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)62))); 
VECTOR_SET(BgL_v1240z00_484,((long)0),BgL_arg1868z00_485); } 
BgL_arg1860z00_469 = BgL_v1240z00_484; } 
{ /* Llib/avahi.scm 64 */
obj_t BgL_v1241z00_498;
BgL_v1241z00_498 = 
create_vector(((long)0)); 
BgL_arg1861z00_470 = BgL_v1241z00_498; } 
BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)63)), 
CNST_TABLE_REF(((long)52)), BGl_avahizd2pollzd2zz__avahi_avahiz00, ((long)39682), BGl_proc2543z00zz__avahi_avahiz00, BGl_proc2542z00zz__avahi_avahiz00, BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_proc2541z00zz__avahi_avahiz00, BFALSE, BgL_arg1860z00_469, BgL_arg1861z00_470); } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1878z00_505;obj_t BgL_arg1879z00_506;
{ /* Llib/avahi.scm 67 */
obj_t BgL_v1242z00_524;
BgL_v1242z00_524 = 
create_vector(((long)12)); 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1886z00_525;
BgL_arg1886z00_525 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc2546z00zz__avahi_avahiz00, BGl_proc2545z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2544z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)64))); 
VECTOR_SET(BgL_v1242z00_524,((long)0),BgL_arg1886z00_525); } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1893z00_538;
BgL_arg1893z00_538 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)65)), BGl_proc2548z00zz__avahi_avahiz00, BGl_proc2547z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_avahizd2pollzd2zz__avahi_avahiz00); 
VECTOR_SET(BgL_v1242z00_524,((long)1),BgL_arg1893z00_538); } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1898z00_548;
BgL_arg1898z00_548 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)66)), BGl_proc2551z00zz__avahi_avahiz00, BGl_proc2550z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2549z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)67))); 
VECTOR_SET(BgL_v1242z00_524,((long)2),BgL_arg1898z00_548); } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1905z00_561;
BgL_arg1905z00_561 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)68)), BGl_proc2553z00zz__avahi_avahiz00, BGl_proc2552z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)69))); 
VECTOR_SET(BgL_v1242z00_524,((long)3),BgL_arg1905z00_561); } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1910z00_571;
BgL_arg1910z00_571 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)70)), BGl_proc2556z00zz__avahi_avahiz00, BGl_proc2555z00zz__avahi_avahiz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2554z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)57))); 
VECTOR_SET(BgL_v1242z00_524,((long)4),BgL_arg1910z00_571); } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1917z00_584;
BgL_arg1917z00_584 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)71)), BGl_proc2559z00zz__avahi_avahiz00, BGl_proc2558z00zz__avahi_avahiz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2557z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)57))); 
VECTOR_SET(BgL_v1242z00_524,((long)5),BgL_arg1917z00_584); } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1924z00_597;
BgL_arg1924z00_597 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)72)), BGl_proc2562z00zz__avahi_avahiz00, BGl_proc2561z00zz__avahi_avahiz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2560z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)57))); 
VECTOR_SET(BgL_v1242z00_524,((long)6),BgL_arg1924z00_597); } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1931z00_610;
BgL_arg1931z00_610 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)73)), BGl_proc2564z00zz__avahi_avahiz00, BGl_proc2563z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)74))); 
VECTOR_SET(BgL_v1242z00_524,((long)7),BgL_arg1931z00_610); } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1936z00_620;
BgL_arg1936z00_620 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)75)), BGl_proc2566z00zz__avahi_avahiz00, BGl_proc2565z00zz__avahi_avahiz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)74))); 
VECTOR_SET(BgL_v1242z00_524,((long)8),BgL_arg1936z00_620); } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1941z00_630;
BgL_arg1941z00_630 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)76)), BGl_proc2568z00zz__avahi_avahiz00, BGl_proc2567z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)74))); 
VECTOR_SET(BgL_v1242z00_524,((long)9),BgL_arg1941z00_630); } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1946z00_640;
BgL_arg1946z00_640 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)77)), BGl_proc2570z00zz__avahi_avahiz00, BGl_proc2569z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)74))); 
VECTOR_SET(BgL_v1242z00_524,((long)10),BgL_arg1946z00_640); } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1951z00_650;
BgL_arg1951z00_650 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)78)), BGl_proc2572z00zz__avahi_avahiz00, BGl_proc2571z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)67))); 
VECTOR_SET(BgL_v1242z00_524,((long)11),BgL_arg1951z00_650); } 
BgL_arg1878z00_505 = BgL_v1242z00_524; } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_v1243z00_660;
BgL_v1243z00_660 = 
create_vector(((long)5)); 
{ /* Llib/avahi.scm 78 */
obj_t BgL_arg1956z00_661;
{ /* Llib/avahi.scm 78 */
obj_t BgL_arg1957z00_662;
BgL_arg1957z00_662 = 
MAKE_YOUNG_PAIR(BGl_proc2573z00zz__avahi_avahiz00, BFALSE); 
BgL_arg1956z00_661 = 
MAKE_YOUNG_PAIR(
BINT(((long)0)), BgL_arg1957z00_662); } 
VECTOR_SET(BgL_v1243z00_660,((long)0),BgL_arg1956z00_661); } 
{ /* Llib/avahi.scm 83 */
obj_t BgL_arg1965z00_675;
{ /* Llib/avahi.scm 83 */
obj_t BgL_arg1966z00_676;
BgL_arg1966z00_676 = 
MAKE_YOUNG_PAIR(BGl_proc2574z00zz__avahi_avahiz00, BGl_proc2575z00zz__avahi_avahiz00); 
BgL_arg1965z00_675 = 
MAKE_YOUNG_PAIR(
BINT(((long)1)), BgL_arg1966z00_676); } 
VECTOR_SET(BgL_v1243z00_660,((long)1),BgL_arg1965z00_675); } 
{ /* Llib/avahi.scm 92 */
obj_t BgL_arg1981z00_703;
{ /* Llib/avahi.scm 92 */
obj_t BgL_arg1982z00_704;
BgL_arg1982z00_704 = 
MAKE_YOUNG_PAIR(BGl_proc2576z00zz__avahi_avahiz00, BFALSE); 
BgL_arg1981z00_703 = 
MAKE_YOUNG_PAIR(
BINT(((long)2)), BgL_arg1982z00_704); } 
VECTOR_SET(BgL_v1243z00_660,((long)2),BgL_arg1981z00_703); } 
{ /* Llib/avahi.scm 98 */
obj_t BgL_arg1990z00_717;
{ /* Llib/avahi.scm 98 */
obj_t BgL_arg1991z00_718;
BgL_arg1991z00_718 = 
MAKE_YOUNG_PAIR(BGl_proc2577z00zz__avahi_avahiz00, BFALSE); 
BgL_arg1990z00_717 = 
MAKE_YOUNG_PAIR(
BINT(((long)3)), BgL_arg1991z00_718); } 
VECTOR_SET(BgL_v1243z00_660,((long)3),BgL_arg1990z00_717); } 
{ /* Llib/avahi.scm 104 */
obj_t BgL_arg1999z00_731;
{ /* Llib/avahi.scm 104 */
obj_t BgL_arg2000z00_732;
BgL_arg2000z00_732 = 
MAKE_YOUNG_PAIR(BGl_proc2578z00zz__avahi_avahiz00, BFALSE); 
BgL_arg1999z00_731 = 
MAKE_YOUNG_PAIR(
BINT(((long)4)), BgL_arg2000z00_732); } 
VECTOR_SET(BgL_v1243z00_660,((long)4),BgL_arg1999z00_731); } 
BgL_arg1879z00_506 = BgL_v1243z00_660; } 
BGl_avahizd2clientzd2zz__avahi_avahiz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)79)), 
CNST_TABLE_REF(((long)52)), BGl_avahizd2objectzd2zz__avahi_avahiz00, ((long)28649), BGl_proc2581z00zz__avahi_avahiz00, BGl_proc2580z00zz__avahi_avahiz00, BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_proc2579z00zz__avahi_avahiz00, BFALSE, BgL_arg1878z00_505, BgL_arg1879z00_506); } 
{ /* Llib/avahi.scm 110 */
obj_t BgL_arg2012z00_752;obj_t BgL_arg2013z00_753;
{ /* Llib/avahi.scm 110 */
obj_t BgL_v1244z00_767;
BgL_v1244z00_767 = 
create_vector(((long)3)); 
{ /* Llib/avahi.scm 110 */
obj_t BgL_arg2020z00_768;
BgL_arg2020z00_768 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc2584z00zz__avahi_avahiz00, BGl_proc2583z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2582z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)80))); 
VECTOR_SET(BgL_v1244z00_767,((long)0),BgL_arg2020z00_768); } 
{ /* Llib/avahi.scm 110 */
obj_t BgL_arg2027z00_781;
BgL_arg2027z00_781 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)81)), BGl_proc2586z00zz__avahi_avahiz00, BGl_proc2585z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_avahizd2clientzd2zz__avahi_avahiz00); 
VECTOR_SET(BgL_v1244z00_767,((long)1),BgL_arg2027z00_781); } 
{ /* Llib/avahi.scm 110 */
obj_t BgL_arg2032z00_791;
BgL_arg2032z00_791 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)68)), BGl_proc2588z00zz__avahi_avahiz00, BGl_proc2587z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)69))); 
VECTOR_SET(BgL_v1244z00_767,((long)2),BgL_arg2032z00_791); } 
BgL_arg2012z00_752 = BgL_v1244z00_767; } 
{ /* Llib/avahi.scm 110 */
obj_t BgL_v1245z00_801;
BgL_v1245z00_801 = 
create_vector(((long)0)); 
BgL_arg2013z00_753 = BgL_v1245z00_801; } 
BGl_avahizd2entryzd2groupz00zz__avahi_avahiz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)82)), 
CNST_TABLE_REF(((long)52)), BGl_avahizd2objectzd2zz__avahi_avahiz00, ((long)3478), BGl_proc2591z00zz__avahi_avahiz00, BGl_proc2590z00zz__avahi_avahiz00, BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_proc2589z00zz__avahi_avahiz00, BFALSE, BgL_arg2012z00_752, BgL_arg2013z00_753); } 
{ /* Llib/avahi.scm 115 */
obj_t BgL_arg2040z00_808;obj_t BgL_arg2041z00_809;
{ /* Llib/avahi.scm 115 */
obj_t BgL_v1246z00_825;
BgL_v1246z00_825 = 
create_vector(((long)5)); 
{ /* Llib/avahi.scm 115 */
obj_t BgL_arg2048z00_826;
BgL_arg2048z00_826 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc2594z00zz__avahi_avahiz00, BGl_proc2593z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2592z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)83))); 
VECTOR_SET(BgL_v1246z00_825,((long)0),BgL_arg2048z00_826); } 
{ /* Llib/avahi.scm 115 */
obj_t BgL_arg2055z00_839;
BgL_arg2055z00_839 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)81)), BGl_proc2596z00zz__avahi_avahiz00, BGl_proc2595z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_avahizd2clientzd2zz__avahi_avahiz00); 
VECTOR_SET(BgL_v1246z00_825,((long)1),BgL_arg2055z00_839); } 
{ /* Llib/avahi.scm 115 */
obj_t BgL_arg2060z00_849;
BgL_arg2060z00_849 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)68)), BGl_proc2598z00zz__avahi_avahiz00, BGl_proc2597z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)69))); 
VECTOR_SET(BgL_v1246z00_825,((long)2),BgL_arg2060z00_849); } 
{ /* Llib/avahi.scm 115 */
obj_t BgL_arg2065z00_859;
BgL_arg2065z00_859 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)84)), BGl_proc2600z00zz__avahi_avahiz00, BGl_proc2599z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)74))); 
VECTOR_SET(BgL_v1246z00_825,((long)3),BgL_arg2065z00_859); } 
{ /* Llib/avahi.scm 115 */
obj_t BgL_arg2070z00_869;
BgL_arg2070z00_869 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)85)), BGl_proc2603z00zz__avahi_avahiz00, BGl_proc2602z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2601z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)74))); 
VECTOR_SET(BgL_v1246z00_825,((long)4),BgL_arg2070z00_869); } 
BgL_arg2040z00_808 = BgL_v1246z00_825; } 
{ /* Llib/avahi.scm 115 */
obj_t BgL_v1247z00_882;
BgL_v1247z00_882 = 
create_vector(((long)0)); 
BgL_arg2041z00_809 = BgL_v1247z00_882; } 
BGl_avahizd2servicezd2browserz00zz__avahi_avahiz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)86)), 
CNST_TABLE_REF(((long)52)), BGl_avahizd2objectzd2zz__avahi_avahiz00, ((long)44122), BGl_proc2606z00zz__avahi_avahiz00, BGl_proc2605z00zz__avahi_avahiz00, BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_proc2604z00zz__avahi_avahiz00, BFALSE, BgL_arg2040z00_808, BgL_arg2041z00_809); } 
{ /* Llib/avahi.scm 122 */
obj_t BgL_arg2080z00_889;obj_t BgL_arg2081z00_890;
{ /* Llib/avahi.scm 122 */
obj_t BgL_v1248z00_905;
BgL_v1248z00_905 = 
create_vector(((long)4)); 
{ /* Llib/avahi.scm 122 */
obj_t BgL_arg2088z00_906;
BgL_arg2088z00_906 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc2609z00zz__avahi_avahiz00, BGl_proc2608z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2607z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)87))); 
VECTOR_SET(BgL_v1248z00_905,((long)0),BgL_arg2088z00_906); } 
{ /* Llib/avahi.scm 122 */
obj_t BgL_arg2095z00_919;
BgL_arg2095z00_919 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)81)), BGl_proc2611z00zz__avahi_avahiz00, BGl_proc2610z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_avahizd2clientzd2zz__avahi_avahiz00); 
VECTOR_SET(BgL_v1248z00_905,((long)1),BgL_arg2095z00_919); } 
{ /* Llib/avahi.scm 122 */
obj_t BgL_arg2101z00_929;
BgL_arg2101z00_929 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)68)), BGl_proc2613z00zz__avahi_avahiz00, BGl_proc2612z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)69))); 
VECTOR_SET(BgL_v1248z00_905,((long)2),BgL_arg2101z00_929); } 
{ /* Llib/avahi.scm 122 */
obj_t BgL_arg2106z00_939;
BgL_arg2106z00_939 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)85)), BGl_proc2616z00zz__avahi_avahiz00, BGl_proc2615z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2614z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)74))); 
VECTOR_SET(BgL_v1248z00_905,((long)3),BgL_arg2106z00_939); } 
BgL_arg2080z00_889 = BgL_v1248z00_905; } 
{ /* Llib/avahi.scm 122 */
obj_t BgL_v1249z00_952;
BgL_v1249z00_952 = 
create_vector(((long)0)); 
BgL_arg2081z00_890 = BgL_v1249z00_952; } 
BGl_avahizd2servicezd2typezd2browserzd2zz__avahi_avahiz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)88)), 
CNST_TABLE_REF(((long)52)), BGl_avahizd2objectzd2zz__avahi_avahiz00, ((long)22928), BGl_proc2619z00zz__avahi_avahiz00, BGl_proc2618z00zz__avahi_avahiz00, BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_proc2617z00zz__avahi_avahiz00, BFALSE, BgL_arg2080z00_889, BgL_arg2081z00_890); } 
{ /* Llib/avahi.scm 128 */
obj_t BgL_arg2116z00_959;obj_t BgL_arg2117z00_960;
{ /* Llib/avahi.scm 128 */
obj_t BgL_v1250z00_976;
BgL_v1250z00_976 = 
create_vector(((long)5)); 
{ /* Llib/avahi.scm 128 */
obj_t BgL_arg2124z00_977;
BgL_arg2124z00_977 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc2622z00zz__avahi_avahiz00, BGl_proc2621z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2620z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)89))); 
VECTOR_SET(BgL_v1250z00_976,((long)0),BgL_arg2124z00_977); } 
{ /* Llib/avahi.scm 128 */
obj_t BgL_arg2131z00_990;
BgL_arg2131z00_990 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)81)), BGl_proc2624z00zz__avahi_avahiz00, BGl_proc2623z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_avahizd2clientzd2zz__avahi_avahiz00); 
VECTOR_SET(BgL_v1250z00_976,((long)1),BgL_arg2131z00_990); } 
{ /* Llib/avahi.scm 128 */
obj_t BgL_arg2136z00_1000;
BgL_arg2136z00_1000 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)68)), BGl_proc2626z00zz__avahi_avahiz00, BGl_proc2625z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)69))); 
VECTOR_SET(BgL_v1250z00_976,((long)2),BgL_arg2136z00_1000); } 
{ /* Llib/avahi.scm 128 */
obj_t BgL_arg2141z00_1010;
BgL_arg2141z00_1010 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)42)), BGl_proc2629z00zz__avahi_avahiz00, BGl_proc2628z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2627z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)67))); 
VECTOR_SET(BgL_v1250z00_976,((long)3),BgL_arg2141z00_1010); } 
{ /* Llib/avahi.scm 128 */
obj_t BgL_arg2148z00_1023;
BgL_arg2148z00_1023 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)85)), BGl_proc2632z00zz__avahi_avahiz00, BGl_proc2631z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2630z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)74))); 
VECTOR_SET(BgL_v1250z00_976,((long)4),BgL_arg2148z00_1023); } 
BgL_arg2116z00_959 = BgL_v1250z00_976; } 
{ /* Llib/avahi.scm 128 */
obj_t BgL_v1251z00_1036;
BgL_v1251z00_1036 = 
create_vector(((long)0)); 
BgL_arg2117z00_960 = BgL_v1251z00_1036; } 
BGl_avahizd2domainzd2browserz00zz__avahi_avahiz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)90)), 
CNST_TABLE_REF(((long)52)), BGl_avahizd2objectzd2zz__avahi_avahiz00, ((long)49790), BGl_proc2635z00zz__avahi_avahiz00, BGl_proc2634z00zz__avahi_avahiz00, BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_proc2633z00zz__avahi_avahiz00, BFALSE, BgL_arg2116z00_959, BgL_arg2117z00_960); } 
{ /* Llib/avahi.scm 135 */
obj_t BgL_arg2158z00_1043;obj_t BgL_arg2159z00_1044;
{ /* Llib/avahi.scm 135 */
obj_t BgL_v1252z00_1063;
BgL_v1252z00_1063 = 
create_vector(((long)8)); 
{ /* Llib/avahi.scm 135 */
obj_t BgL_arg2166z00_1064;
BgL_arg2166z00_1064 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc2638z00zz__avahi_avahiz00, BGl_proc2637z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2636z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)91))); 
VECTOR_SET(BgL_v1252z00_1063,((long)0),BgL_arg2166z00_1064); } 
{ /* Llib/avahi.scm 135 */
obj_t BgL_arg2173z00_1077;
BgL_arg2173z00_1077 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)81)), BGl_proc2640z00zz__avahi_avahiz00, BGl_proc2639z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_avahizd2clientzd2zz__avahi_avahiz00); 
VECTOR_SET(BgL_v1252z00_1063,((long)1),BgL_arg2173z00_1077); } 
{ /* Llib/avahi.scm 135 */
obj_t BgL_arg2178z00_1087;
BgL_arg2178z00_1087 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)68)), BGl_proc2642z00zz__avahi_avahiz00, BGl_proc2641z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)69))); 
VECTOR_SET(BgL_v1252z00_1063,((long)2),BgL_arg2178z00_1087); } 
{ /* Llib/avahi.scm 135 */
obj_t BgL_arg2183z00_1097;
BgL_arg2183z00_1097 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)92)), BGl_proc2644z00zz__avahi_avahiz00, BGl_proc2643z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)93))); 
VECTOR_SET(BgL_v1252z00_1063,((long)3),BgL_arg2183z00_1097); } 
{ /* Llib/avahi.scm 135 */
obj_t BgL_arg2188z00_1107;
BgL_arg2188z00_1107 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)94)), BGl_proc2646z00zz__avahi_avahiz00, BGl_proc2645z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)67))); 
VECTOR_SET(BgL_v1252z00_1063,((long)4),BgL_arg2188z00_1107); } 
{ /* Llib/avahi.scm 135 */
obj_t BgL_arg2193z00_1117;
BgL_arg2193z00_1117 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)95)), BGl_proc2648z00zz__avahi_avahiz00, BGl_proc2647z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)74))); 
VECTOR_SET(BgL_v1252z00_1063,((long)5),BgL_arg2193z00_1117); } 
{ /* Llib/avahi.scm 135 */
obj_t BgL_arg2198z00_1127;
BgL_arg2198z00_1127 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)84)), BGl_proc2650z00zz__avahi_avahiz00, BGl_proc2649z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)74))); 
VECTOR_SET(BgL_v1252z00_1063,((long)6),BgL_arg2198z00_1127); } 
{ /* Llib/avahi.scm 135 */
obj_t BgL_arg2203z00_1137;
BgL_arg2203z00_1137 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)85)), BGl_proc2653z00zz__avahi_avahiz00, BGl_proc2652z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2651z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)74))); 
VECTOR_SET(BgL_v1252z00_1063,((long)7),BgL_arg2203z00_1137); } 
BgL_arg2158z00_1043 = BgL_v1252z00_1063; } 
{ /* Llib/avahi.scm 135 */
obj_t BgL_v1253z00_1150;
BgL_v1253z00_1150 = 
create_vector(((long)0)); 
BgL_arg2159z00_1044 = BgL_v1253z00_1150; } 
return ( 
BGl_avahizd2servicezd2resolverz00zz__avahi_avahiz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)96)), 
CNST_TABLE_REF(((long)52)), BGl_avahizd2objectzd2zz__avahi_avahiz00, ((long)20996), BGl_proc2656z00zz__avahi_avahiz00, BGl_proc2655z00zz__avahi_avahiz00, BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_proc2654z00zz__avahi_avahiz00, BFALSE, BgL_arg2158z00_1043, BgL_arg2159z00_1044), BUNSPEC) ;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2165> */
obj_t BGl_z62zc3anonymousza32165ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2123, obj_t BgL_new1139z00_2124)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 135 */
{ 
BgL_avahizd2servicezd2resolverz00_bglt BgL_auxz00_4477;
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_new1139z00_2124)))->BgL_z42builtinz42)=((AvahiServiceResolver *)
0L),BUNSPEC); 
{ 
BgL_avahizd2clientzd2_bglt BgL_auxz00_4481;
{ /* Llib/avahi.scm 135 */
obj_t BgL_classz00_2634;
BgL_classz00_2634 = BGl_avahizd2clientzd2zz__avahi_avahiz00; 
{ /* Llib/avahi.scm 135 */
obj_t BgL__ortest_1106z00_2635;
BgL__ortest_1106z00_2635 = 
BGL_CLASS_NIL(BgL_classz00_2634); 
if(
CBOOL(BgL__ortest_1106z00_2635))
{ /* Llib/avahi.scm 135 */
BgL_auxz00_4481 = 
((BgL_avahizd2clientzd2_bglt)BgL__ortest_1106z00_2635)
; }  else 
{ /* Llib/avahi.scm 135 */
BgL_auxz00_4481 = 
((BgL_avahizd2clientzd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2634))
; } } } 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_new1139z00_2124)))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)BgL_auxz00_4481),BUNSPEC); } 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_new1139z00_2124)))->BgL_procz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_new1139z00_2124)))->BgL_interfacez00)=((AvahiIfIndex)
0L),BUNSPEC); 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_new1139z00_2124)))->BgL_protocolz00)=((obj_t)
CNST_TABLE_REF(((long)97))),BUNSPEC); 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_new1139z00_2124)))->BgL_namez00)=((obj_t)BGl_string2657z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_new1139z00_2124)))->BgL_typez00)=((obj_t)BGl_string2657z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_new1139z00_2124)))->BgL_domainz00)=((obj_t)BGl_string2657z00zz__avahi_avahiz00),BUNSPEC); 
BgL_auxz00_4477 = 
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_new1139z00_2124); 
return 
((obj_t)BgL_auxz00_4477);} } 
BGL_FUNCTION_END;
}



/* &lambda2163 */
BgL_avahizd2servicezd2resolverz00_bglt BGl_z62lambda2163z62zz__avahi_avahiz00(obj_t BgL_envz00_2125)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 135 */
{ /* Llib/avahi.scm 135 */
BgL_avahizd2servicezd2resolverz00_bglt BgL_new1138z00_2636;
BgL_new1138z00_2636 = 
((BgL_avahizd2servicezd2resolverz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2servicezd2resolverz00_bgl) ))); 
{ /* Llib/avahi.scm 135 */
long BgL_arg2164z00_2637;
{ /* Llib/avahi.scm 135 */
long BgL_res2352z00_2638;
BgL_res2352z00_2638 = 
BGL_CLASS_INDEX(BGl_avahizd2servicezd2resolverz00zz__avahi_avahiz00); 
BgL_arg2164z00_2637 = BgL_res2352z00_2638; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1138z00_2636), BgL_arg2164z00_2637); } 
return BgL_new1138z00_2636;} } 
BGL_FUNCTION_END;
}



/* &lambda2160 */
BgL_avahizd2servicezd2resolverz00_bglt BGl_z62lambda2160z62zz__avahi_avahiz00(obj_t BgL_envz00_2126, obj_t BgL_z42builtin1130z42_2127, obj_t BgL_client1131z00_2128, obj_t BgL_proc1132z00_2129, obj_t BgL_interface1133z00_2130, obj_t BgL_protocol1134z00_2131, obj_t BgL_name1135z00_2132, obj_t BgL_type1136z00_2133, obj_t BgL_domain1137z00_2134)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 135 */
{ /* Llib/avahi.scm 135 */
AvahiServiceResolver * BgL_z42builtin1130z42_2639;AvahiIfIndex BgL_interface1133z00_2642;
BgL_z42builtin1130z42_2639 = 
FOREIGN_TO_COBJ(BgL_z42builtin1130z42_2127); 
BgL_interface1133z00_2642 = 
(long)CINT(BgL_interface1133z00_2130); 
{ /* Llib/avahi.scm 135 */
BgL_avahizd2servicezd2resolverz00_bglt BgL_new1227z00_2647;
{ /* Llib/avahi.scm 135 */
BgL_avahizd2servicezd2resolverz00_bglt BgL_new1226z00_2648;
BgL_new1226z00_2648 = 
((BgL_avahizd2servicezd2resolverz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2servicezd2resolverz00_bgl) ))); 
{ /* Llib/avahi.scm 135 */
long BgL_arg2162z00_2649;
{ /* Llib/avahi.scm 135 */
long BgL_res2351z00_2650;
BgL_res2351z00_2650 = 
BGL_CLASS_INDEX(BGl_avahizd2servicezd2resolverz00zz__avahi_avahiz00); 
BgL_arg2162z00_2649 = BgL_res2351z00_2650; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1226z00_2648), BgL_arg2162z00_2649); } 
BgL_new1227z00_2647 = BgL_new1226z00_2648; } 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(BgL_new1227z00_2647))->BgL_z42builtinz42)=((AvahiServiceResolver *)BgL_z42builtin1130z42_2639),BUNSPEC); 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(BgL_new1227z00_2647))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)
((BgL_avahizd2clientzd2_bglt)BgL_client1131z00_2128)),BUNSPEC); 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(BgL_new1227z00_2647))->BgL_procz00)=((obj_t)
((obj_t)BgL_proc1132z00_2129)),BUNSPEC); 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(BgL_new1227z00_2647))->BgL_interfacez00)=((AvahiIfIndex)BgL_interface1133z00_2642),BUNSPEC); 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(BgL_new1227z00_2647))->BgL_protocolz00)=((obj_t)
((obj_t)BgL_protocol1134z00_2131)),BUNSPEC); 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(BgL_new1227z00_2647))->BgL_namez00)=((obj_t)
((obj_t)BgL_name1135z00_2132)),BUNSPEC); 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(BgL_new1227z00_2647))->BgL_typez00)=((obj_t)
((obj_t)BgL_type1136z00_2133)),BUNSPEC); 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(BgL_new1227z00_2647))->BgL_domainz00)=((obj_t)
((obj_t)BgL_domain1137z00_2134)),BUNSPEC); 
{ /* Llib/avahi.scm 135 */
obj_t BgL_fun2161z00_2651;
BgL_fun2161z00_2651 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_avahizd2servicezd2resolverz00zz__avahi_avahiz00); 
PROCEDURE_ENTRY(BgL_fun2161z00_2651)(BgL_fun2161z00_2651, 
((obj_t)BgL_new1227z00_2647), BEOA); } 
return BgL_new1227z00_2647;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2209> */
obj_t BGl_z62zc3anonymousza32209ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2135)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 135 */
return BGl_string2657z00zz__avahi_avahiz00;} 
BGL_FUNCTION_END;
}



/* &lambda2208 */
obj_t BGl_z62lambda2208z62zz__avahi_avahiz00(obj_t BgL_envz00_2136, obj_t BgL_oz00_2137, obj_t BgL_vz00_2138)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 135 */
return 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2137)))->BgL_domainz00)=((obj_t)
((obj_t)BgL_vz00_2138)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2207 */
obj_t BGl_z62lambda2207z62zz__avahi_avahiz00(obj_t BgL_envz00_2139, obj_t BgL_oz00_2140)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 135 */
return 
(((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2140)))->BgL_domainz00);} 
BGL_FUNCTION_END;
}



/* &lambda2202 */
obj_t BGl_z62lambda2202z62zz__avahi_avahiz00(obj_t BgL_envz00_2141, obj_t BgL_oz00_2142, obj_t BgL_vz00_2143)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 135 */
return 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2142)))->BgL_typez00)=((obj_t)
((obj_t)BgL_vz00_2143)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2201 */
obj_t BGl_z62lambda2201z62zz__avahi_avahiz00(obj_t BgL_envz00_2144, obj_t BgL_oz00_2145)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 135 */
return 
(((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2145)))->BgL_typez00);} 
BGL_FUNCTION_END;
}



/* &lambda2197 */
obj_t BGl_z62lambda2197z62zz__avahi_avahiz00(obj_t BgL_envz00_2146, obj_t BgL_oz00_2147, obj_t BgL_vz00_2148)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 135 */
return 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2147)))->BgL_namez00)=((obj_t)
((obj_t)BgL_vz00_2148)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2196 */
obj_t BGl_z62lambda2196z62zz__avahi_avahiz00(obj_t BgL_envz00_2149, obj_t BgL_oz00_2150)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 135 */
return 
(((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2150)))->BgL_namez00);} 
BGL_FUNCTION_END;
}



/* &lambda2192 */
obj_t BGl_z62lambda2192z62zz__avahi_avahiz00(obj_t BgL_envz00_2151, obj_t BgL_oz00_2152, obj_t BgL_vz00_2153)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 135 */
return 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2152)))->BgL_protocolz00)=((obj_t)
((obj_t)BgL_vz00_2153)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2191 */
obj_t BGl_z62lambda2191z62zz__avahi_avahiz00(obj_t BgL_envz00_2154, obj_t BgL_oz00_2155)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 135 */
return 
(((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2155)))->BgL_protocolz00);} 
BGL_FUNCTION_END;
}



/* &lambda2187 */
obj_t BGl_z62lambda2187z62zz__avahi_avahiz00(obj_t BgL_envz00_2156, obj_t BgL_oz00_2157, obj_t BgL_vz00_2158)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 135 */
{ /* Llib/avahi.scm 135 */
AvahiIfIndex BgL_vz00_2665;
BgL_vz00_2665 = 
(long)CINT(BgL_vz00_2158); 
return 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2157)))->BgL_interfacez00)=((AvahiIfIndex)BgL_vz00_2665),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2186 */
obj_t BGl_z62lambda2186z62zz__avahi_avahiz00(obj_t BgL_envz00_2159, obj_t BgL_oz00_2160)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 135 */
return 
BINT(
(((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2160)))->BgL_interfacez00));} 
BGL_FUNCTION_END;
}



/* &lambda2182 */
obj_t BGl_z62lambda2182z62zz__avahi_avahiz00(obj_t BgL_envz00_2161, obj_t BgL_oz00_2162, obj_t BgL_vz00_2163)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 135 */
return 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2162)))->BgL_procz00)=((obj_t)
((obj_t)BgL_vz00_2163)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2181 */
obj_t BGl_z62lambda2181z62zz__avahi_avahiz00(obj_t BgL_envz00_2164, obj_t BgL_oz00_2165)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 135 */
return 
(((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2165)))->BgL_procz00);} 
BGL_FUNCTION_END;
}



/* &lambda2177 */
obj_t BGl_z62lambda2177z62zz__avahi_avahiz00(obj_t BgL_envz00_2166, obj_t BgL_oz00_2167, obj_t BgL_vz00_2168)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 135 */
return 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2167)))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)
((BgL_avahizd2clientzd2_bglt)BgL_vz00_2168)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2176 */
BgL_avahizd2clientzd2_bglt BGl_z62lambda2176z62zz__avahi_avahiz00(obj_t BgL_envz00_2169, obj_t BgL_oz00_2170)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 135 */
return 
(((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2170)))->BgL_clientz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2172> */
obj_t BGl_z62zc3anonymousza32172ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2171)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 135 */
return 
void_star_to_obj(
(0L));} 
BGL_FUNCTION_END;
}



/* &lambda2171 */
obj_t BGl_z62lambda2171z62zz__avahi_avahiz00(obj_t BgL_envz00_2172, obj_t BgL_oz00_2173, obj_t BgL_vz00_2174)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 135 */
{ /* Llib/avahi.scm 135 */
AvahiServiceResolver * BgL_vz00_2674;
BgL_vz00_2674 = 
FOREIGN_TO_COBJ(BgL_vz00_2174); 
return 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2173)))->BgL_z42builtinz42)=((AvahiServiceResolver *)BgL_vz00_2674),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2170 */
obj_t BGl_z62lambda2170z62zz__avahi_avahiz00(obj_t BgL_envz00_2175, obj_t BgL_oz00_2176)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 135 */
return 
void_star_to_obj(
(((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2176)))->BgL_z42builtinz42));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2123> */
obj_t BGl_z62zc3anonymousza32123ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2177, obj_t BgL_new1128z00_2178)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 128 */
{ 
BgL_avahizd2domainzd2browserz00_bglt BgL_auxz00_4580;
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_new1128z00_2178)))->BgL_z42builtinz42)=((AvahiDomainBrowser *)
0L),BUNSPEC); 
{ 
BgL_avahizd2clientzd2_bglt BgL_auxz00_4584;
{ /* Llib/avahi.scm 128 */
obj_t BgL_classz00_2677;
BgL_classz00_2677 = BGl_avahizd2clientzd2zz__avahi_avahiz00; 
{ /* Llib/avahi.scm 128 */
obj_t BgL__ortest_1106z00_2678;
BgL__ortest_1106z00_2678 = 
BGL_CLASS_NIL(BgL_classz00_2677); 
if(
CBOOL(BgL__ortest_1106z00_2678))
{ /* Llib/avahi.scm 128 */
BgL_auxz00_4584 = 
((BgL_avahizd2clientzd2_bglt)BgL__ortest_1106z00_2678)
; }  else 
{ /* Llib/avahi.scm 128 */
BgL_auxz00_4584 = 
((BgL_avahizd2clientzd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2677))
; } } } 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_new1128z00_2178)))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)BgL_auxz00_4584),BUNSPEC); } 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_new1128z00_2178)))->BgL_procz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_new1128z00_2178)))->BgL_btypez00)=((obj_t)
CNST_TABLE_REF(((long)97))),BUNSPEC); 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_new1128z00_2178)))->BgL_domainz00)=((obj_t)BGl_string2657z00zz__avahi_avahiz00),BUNSPEC); 
BgL_auxz00_4580 = 
((BgL_avahizd2domainzd2browserz00_bglt)BgL_new1128z00_2178); 
return 
((obj_t)BgL_auxz00_4580);} } 
BGL_FUNCTION_END;
}



/* &lambda2121 */
BgL_avahizd2domainzd2browserz00_bglt BGl_z62lambda2121z62zz__avahi_avahiz00(obj_t BgL_envz00_2179)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 128 */
{ /* Llib/avahi.scm 128 */
BgL_avahizd2domainzd2browserz00_bglt BgL_new1127z00_2679;
BgL_new1127z00_2679 = 
((BgL_avahizd2domainzd2browserz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2domainzd2browserz00_bgl) ))); 
{ /* Llib/avahi.scm 128 */
long BgL_arg2122z00_2680;
{ /* Llib/avahi.scm 128 */
long BgL_res2350z00_2681;
BgL_res2350z00_2681 = 
BGL_CLASS_INDEX(BGl_avahizd2domainzd2browserz00zz__avahi_avahiz00); 
BgL_arg2122z00_2680 = BgL_res2350z00_2681; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1127z00_2679), BgL_arg2122z00_2680); } 
return BgL_new1127z00_2679;} } 
BGL_FUNCTION_END;
}



/* &lambda2118 */
BgL_avahizd2domainzd2browserz00_bglt BGl_z62lambda2118z62zz__avahi_avahiz00(obj_t BgL_envz00_2180, obj_t BgL_z42builtin1122z42_2181, obj_t BgL_client1123z00_2182, obj_t BgL_proc1124z00_2183, obj_t BgL_btype1125z00_2184, obj_t BgL_domain1126z00_2185)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 128 */
{ /* Llib/avahi.scm 128 */
AvahiDomainBrowser * BgL_z42builtin1122z42_2682;
BgL_z42builtin1122z42_2682 = 
FOREIGN_TO_COBJ(BgL_z42builtin1122z42_2181); 
{ /* Llib/avahi.scm 128 */
BgL_avahizd2domainzd2browserz00_bglt BgL_new1225z00_2687;
{ /* Llib/avahi.scm 128 */
BgL_avahizd2domainzd2browserz00_bglt BgL_new1224z00_2688;
BgL_new1224z00_2688 = 
((BgL_avahizd2domainzd2browserz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2domainzd2browserz00_bgl) ))); 
{ /* Llib/avahi.scm 128 */
long BgL_arg2120z00_2689;
{ /* Llib/avahi.scm 128 */
long BgL_res2349z00_2690;
BgL_res2349z00_2690 = 
BGL_CLASS_INDEX(BGl_avahizd2domainzd2browserz00zz__avahi_avahiz00); 
BgL_arg2120z00_2689 = BgL_res2349z00_2690; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1224z00_2688), BgL_arg2120z00_2689); } 
BgL_new1225z00_2687 = BgL_new1224z00_2688; } 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(BgL_new1225z00_2687))->BgL_z42builtinz42)=((AvahiDomainBrowser *)BgL_z42builtin1122z42_2682),BUNSPEC); 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(BgL_new1225z00_2687))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)
((BgL_avahizd2clientzd2_bglt)BgL_client1123z00_2182)),BUNSPEC); 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(BgL_new1225z00_2687))->BgL_procz00)=((obj_t)
((obj_t)BgL_proc1124z00_2183)),BUNSPEC); 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(BgL_new1225z00_2687))->BgL_btypez00)=((obj_t)
((obj_t)BgL_btype1125z00_2184)),BUNSPEC); 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(BgL_new1225z00_2687))->BgL_domainz00)=((obj_t)
((obj_t)BgL_domain1126z00_2185)),BUNSPEC); 
{ /* Llib/avahi.scm 128 */
obj_t BgL_fun2119z00_2691;
BgL_fun2119z00_2691 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_avahizd2domainzd2browserz00zz__avahi_avahiz00); 
PROCEDURE_ENTRY(BgL_fun2119z00_2691)(BgL_fun2119z00_2691, 
((obj_t)BgL_new1225z00_2687), BEOA); } 
return BgL_new1225z00_2687;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2154> */
obj_t BGl_z62zc3anonymousza32154ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2186)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 128 */
return BGl_string2657z00zz__avahi_avahiz00;} 
BGL_FUNCTION_END;
}



/* &lambda2153 */
obj_t BGl_z62lambda2153z62zz__avahi_avahiz00(obj_t BgL_envz00_2187, obj_t BgL_oz00_2188, obj_t BgL_vz00_2189)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 128 */
return 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2188)))->BgL_domainz00)=((obj_t)
((obj_t)BgL_vz00_2189)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2152 */
obj_t BGl_z62lambda2152z62zz__avahi_avahiz00(obj_t BgL_envz00_2190, obj_t BgL_oz00_2191)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 128 */
return 
(((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2191)))->BgL_domainz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2147> */
obj_t BGl_z62zc3anonymousza32147ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2192)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 128 */
return 
CNST_TABLE_REF(((long)98));} 
BGL_FUNCTION_END;
}



/* &lambda2146 */
obj_t BGl_z62lambda2146z62zz__avahi_avahiz00(obj_t BgL_envz00_2193, obj_t BgL_oz00_2194, obj_t BgL_vz00_2195)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 128 */
return 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2194)))->BgL_btypez00)=((obj_t)
((obj_t)BgL_vz00_2195)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2145 */
obj_t BGl_z62lambda2145z62zz__avahi_avahiz00(obj_t BgL_envz00_2196, obj_t BgL_oz00_2197)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 128 */
return 
(((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2197)))->BgL_btypez00);} 
BGL_FUNCTION_END;
}



/* &lambda2140 */
obj_t BGl_z62lambda2140z62zz__avahi_avahiz00(obj_t BgL_envz00_2198, obj_t BgL_oz00_2199, obj_t BgL_vz00_2200)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 128 */
return 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2199)))->BgL_procz00)=((obj_t)
((obj_t)BgL_vz00_2200)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2139 */
obj_t BGl_z62lambda2139z62zz__avahi_avahiz00(obj_t BgL_envz00_2201, obj_t BgL_oz00_2202)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 128 */
return 
(((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2202)))->BgL_procz00);} 
BGL_FUNCTION_END;
}



/* &lambda2135 */
obj_t BGl_z62lambda2135z62zz__avahi_avahiz00(obj_t BgL_envz00_2203, obj_t BgL_oz00_2204, obj_t BgL_vz00_2205)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 128 */
return 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2204)))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)
((BgL_avahizd2clientzd2_bglt)BgL_vz00_2205)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2134 */
BgL_avahizd2clientzd2_bglt BGl_z62lambda2134z62zz__avahi_avahiz00(obj_t BgL_envz00_2206, obj_t BgL_oz00_2207)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 128 */
return 
(((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2207)))->BgL_clientz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2130> */
obj_t BGl_z62zc3anonymousza32130ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2208)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 128 */
return 
void_star_to_obj(
(0L));} 
BGL_FUNCTION_END;
}



/* &lambda2129 */
obj_t BGl_z62lambda2129z62zz__avahi_avahiz00(obj_t BgL_envz00_2209, obj_t BgL_oz00_2210, obj_t BgL_vz00_2211)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 128 */
{ /* Llib/avahi.scm 128 */
AvahiDomainBrowser * BgL_vz00_2705;
BgL_vz00_2705 = 
FOREIGN_TO_COBJ(BgL_vz00_2211); 
return 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2210)))->BgL_z42builtinz42)=((AvahiDomainBrowser *)BgL_vz00_2705),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2128 */
obj_t BGl_z62lambda2128z62zz__avahi_avahiz00(obj_t BgL_envz00_2212, obj_t BgL_oz00_2213)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 128 */
return 
void_star_to_obj(
(((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2213)))->BgL_z42builtinz42));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2087> */
obj_t BGl_z62zc3anonymousza32087ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2214, obj_t BgL_new1120z00_2215)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 122 */
{ 
BgL_avahizd2servicezd2typezd2browserzd2_bglt BgL_auxz00_4655;
((((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_new1120z00_2215)))->BgL_z42builtinz42)=((AvahiServiceTypeBrowser *)
0L),BUNSPEC); 
{ 
BgL_avahizd2clientzd2_bglt BgL_auxz00_4659;
{ /* Llib/avahi.scm 122 */
obj_t BgL_classz00_2708;
BgL_classz00_2708 = BGl_avahizd2clientzd2zz__avahi_avahiz00; 
{ /* Llib/avahi.scm 122 */
obj_t BgL__ortest_1106z00_2709;
BgL__ortest_1106z00_2709 = 
BGL_CLASS_NIL(BgL_classz00_2708); 
if(
CBOOL(BgL__ortest_1106z00_2709))
{ /* Llib/avahi.scm 122 */
BgL_auxz00_4659 = 
((BgL_avahizd2clientzd2_bglt)BgL__ortest_1106z00_2709)
; }  else 
{ /* Llib/avahi.scm 122 */
BgL_auxz00_4659 = 
((BgL_avahizd2clientzd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2708))
; } } } 
((((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_new1120z00_2215)))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)BgL_auxz00_4659),BUNSPEC); } 
((((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_new1120z00_2215)))->BgL_procz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_new1120z00_2215)))->BgL_domainz00)=((obj_t)BGl_string2657z00zz__avahi_avahiz00),BUNSPEC); 
BgL_auxz00_4655 = 
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_new1120z00_2215); 
return 
((obj_t)BgL_auxz00_4655);} } 
BGL_FUNCTION_END;
}



/* &lambda2085 */
BgL_avahizd2servicezd2typezd2browserzd2_bglt BGl_z62lambda2085z62zz__avahi_avahiz00(obj_t BgL_envz00_2216)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 122 */
{ /* Llib/avahi.scm 122 */
BgL_avahizd2servicezd2typezd2browserzd2_bglt BgL_new1119z00_2710;
BgL_new1119z00_2710 = 
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2servicezd2typezd2browserzd2_bgl) ))); 
{ /* Llib/avahi.scm 122 */
long BgL_arg2086z00_2711;
{ /* Llib/avahi.scm 122 */
long BgL_res2348z00_2712;
BgL_res2348z00_2712 = 
BGL_CLASS_INDEX(BGl_avahizd2servicezd2typezd2browserzd2zz__avahi_avahiz00); 
BgL_arg2086z00_2711 = BgL_res2348z00_2712; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1119z00_2710), BgL_arg2086z00_2711); } 
return BgL_new1119z00_2710;} } 
BGL_FUNCTION_END;
}



/* &lambda2082 */
BgL_avahizd2servicezd2typezd2browserzd2_bglt BGl_z62lambda2082z62zz__avahi_avahiz00(obj_t BgL_envz00_2217, obj_t BgL_z42builtin1115z42_2218, obj_t BgL_client1116z00_2219, obj_t BgL_proc1117z00_2220, obj_t BgL_domain1118z00_2221)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 122 */
{ /* Llib/avahi.scm 122 */
AvahiServiceTypeBrowser * BgL_z42builtin1115z42_2713;
BgL_z42builtin1115z42_2713 = 
FOREIGN_TO_COBJ(BgL_z42builtin1115z42_2218); 
{ /* Llib/avahi.scm 122 */
BgL_avahizd2servicezd2typezd2browserzd2_bglt BgL_new1223z00_2717;
{ /* Llib/avahi.scm 122 */
BgL_avahizd2servicezd2typezd2browserzd2_bglt BgL_new1222z00_2718;
BgL_new1222z00_2718 = 
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2servicezd2typezd2browserzd2_bgl) ))); 
{ /* Llib/avahi.scm 122 */
long BgL_arg2084z00_2719;
{ /* Llib/avahi.scm 122 */
long BgL_res2347z00_2720;
BgL_res2347z00_2720 = 
BGL_CLASS_INDEX(BGl_avahizd2servicezd2typezd2browserzd2zz__avahi_avahiz00); 
BgL_arg2084z00_2719 = BgL_res2347z00_2720; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1222z00_2718), BgL_arg2084z00_2719); } 
BgL_new1223z00_2717 = BgL_new1222z00_2718; } 
((((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(BgL_new1223z00_2717))->BgL_z42builtinz42)=((AvahiServiceTypeBrowser *)BgL_z42builtin1115z42_2713),BUNSPEC); 
((((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(BgL_new1223z00_2717))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)
((BgL_avahizd2clientzd2_bglt)BgL_client1116z00_2219)),BUNSPEC); 
((((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(BgL_new1223z00_2717))->BgL_procz00)=((obj_t)
((obj_t)BgL_proc1117z00_2220)),BUNSPEC); 
((((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(BgL_new1223z00_2717))->BgL_domainz00)=((obj_t)
((obj_t)BgL_domain1118z00_2221)),BUNSPEC); 
{ /* Llib/avahi.scm 122 */
obj_t BgL_fun2083z00_2721;
BgL_fun2083z00_2721 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_avahizd2servicezd2typezd2browserzd2zz__avahi_avahiz00); 
PROCEDURE_ENTRY(BgL_fun2083z00_2721)(BgL_fun2083z00_2721, 
((obj_t)BgL_new1223z00_2717), BEOA); } 
return BgL_new1223z00_2717;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2112> */
obj_t BGl_z62zc3anonymousza32112ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2222)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 122 */
return BGl_string2657z00zz__avahi_avahiz00;} 
BGL_FUNCTION_END;
}



/* &lambda2111 */
obj_t BGl_z62lambda2111z62zz__avahi_avahiz00(obj_t BgL_envz00_2223, obj_t BgL_oz00_2224, obj_t BgL_vz00_2225)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 122 */
return 
((((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_oz00_2224)))->BgL_domainz00)=((obj_t)
((obj_t)BgL_vz00_2225)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2110 */
obj_t BGl_z62lambda2110z62zz__avahi_avahiz00(obj_t BgL_envz00_2226, obj_t BgL_oz00_2227)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 122 */
return 
(((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_oz00_2227)))->BgL_domainz00);} 
BGL_FUNCTION_END;
}



/* &lambda2105 */
obj_t BGl_z62lambda2105z62zz__avahi_avahiz00(obj_t BgL_envz00_2228, obj_t BgL_oz00_2229, obj_t BgL_vz00_2230)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 122 */
return 
((((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_oz00_2229)))->BgL_procz00)=((obj_t)
((obj_t)BgL_vz00_2230)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2104 */
obj_t BGl_z62lambda2104z62zz__avahi_avahiz00(obj_t BgL_envz00_2231, obj_t BgL_oz00_2232)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 122 */
return 
(((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_oz00_2232)))->BgL_procz00);} 
BGL_FUNCTION_END;
}



/* &lambda2100 */
obj_t BGl_z62lambda2100z62zz__avahi_avahiz00(obj_t BgL_envz00_2233, obj_t BgL_oz00_2234, obj_t BgL_vz00_2235)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 122 */
return 
((((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_oz00_2234)))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)
((BgL_avahizd2clientzd2_bglt)BgL_vz00_2235)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2099 */
BgL_avahizd2clientzd2_bglt BGl_z62lambda2099z62zz__avahi_avahiz00(obj_t BgL_envz00_2236, obj_t BgL_oz00_2237)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 122 */
return 
(((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_oz00_2237)))->BgL_clientz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2094> */
obj_t BGl_z62zc3anonymousza32094ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2238)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 122 */
return 
void_star_to_obj(
(0L));} 
BGL_FUNCTION_END;
}



/* &lambda2093 */
obj_t BGl_z62lambda2093z62zz__avahi_avahiz00(obj_t BgL_envz00_2239, obj_t BgL_oz00_2240, obj_t BgL_vz00_2241)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 122 */
{ /* Llib/avahi.scm 122 */
AvahiServiceTypeBrowser * BgL_vz00_2732;
BgL_vz00_2732 = 
FOREIGN_TO_COBJ(BgL_vz00_2241); 
return 
((((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_oz00_2240)))->BgL_z42builtinz42)=((AvahiServiceTypeBrowser *)BgL_vz00_2732),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2092 */
obj_t BGl_z62lambda2092z62zz__avahi_avahiz00(obj_t BgL_envz00_2242, obj_t BgL_oz00_2243)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 122 */
return 
void_star_to_obj(
(((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_oz00_2243)))->BgL_z42builtinz42));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2047> */
obj_t BGl_z62zc3anonymousza32047ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2244, obj_t BgL_new1113z00_2245)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 115 */
{ 
BgL_avahizd2servicezd2browserz00_bglt BgL_auxz00_4719;
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_new1113z00_2245)))->BgL_z42builtinz42)=((AvahiServiceBrowser *)
0L),BUNSPEC); 
{ 
BgL_avahizd2clientzd2_bglt BgL_auxz00_4723;
{ /* Llib/avahi.scm 115 */
obj_t BgL_classz00_2735;
BgL_classz00_2735 = BGl_avahizd2clientzd2zz__avahi_avahiz00; 
{ /* Llib/avahi.scm 115 */
obj_t BgL__ortest_1106z00_2736;
BgL__ortest_1106z00_2736 = 
BGL_CLASS_NIL(BgL_classz00_2735); 
if(
CBOOL(BgL__ortest_1106z00_2736))
{ /* Llib/avahi.scm 115 */
BgL_auxz00_4723 = 
((BgL_avahizd2clientzd2_bglt)BgL__ortest_1106z00_2736)
; }  else 
{ /* Llib/avahi.scm 115 */
BgL_auxz00_4723 = 
((BgL_avahizd2clientzd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2735))
; } } } 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_new1113z00_2245)))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)BgL_auxz00_4723),BUNSPEC); } 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_new1113z00_2245)))->BgL_procz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_new1113z00_2245)))->BgL_typez00)=((obj_t)BGl_string2657z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_new1113z00_2245)))->BgL_domainz00)=((obj_t)BGl_string2657z00zz__avahi_avahiz00),BUNSPEC); 
BgL_auxz00_4719 = 
((BgL_avahizd2servicezd2browserz00_bglt)BgL_new1113z00_2245); 
return 
((obj_t)BgL_auxz00_4719);} } 
BGL_FUNCTION_END;
}



/* &lambda2045 */
BgL_avahizd2servicezd2browserz00_bglt BGl_z62lambda2045z62zz__avahi_avahiz00(obj_t BgL_envz00_2246)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 115 */
{ /* Llib/avahi.scm 115 */
BgL_avahizd2servicezd2browserz00_bglt BgL_new1112z00_2737;
BgL_new1112z00_2737 = 
((BgL_avahizd2servicezd2browserz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2servicezd2browserz00_bgl) ))); 
{ /* Llib/avahi.scm 115 */
long BgL_arg2046z00_2738;
{ /* Llib/avahi.scm 115 */
long BgL_res2346z00_2739;
BgL_res2346z00_2739 = 
BGL_CLASS_INDEX(BGl_avahizd2servicezd2browserz00zz__avahi_avahiz00); 
BgL_arg2046z00_2738 = BgL_res2346z00_2739; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1112z00_2737), BgL_arg2046z00_2738); } 
return BgL_new1112z00_2737;} } 
BGL_FUNCTION_END;
}



/* &lambda2042 */
BgL_avahizd2servicezd2browserz00_bglt BGl_z62lambda2042z62zz__avahi_avahiz00(obj_t BgL_envz00_2247, obj_t BgL_z42builtin1107z42_2248, obj_t BgL_client1108z00_2249, obj_t BgL_proc1109z00_2250, obj_t BgL_type1110z00_2251, obj_t BgL_domain1111z00_2252)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 115 */
{ /* Llib/avahi.scm 115 */
AvahiServiceBrowser * BgL_z42builtin1107z42_2740;
BgL_z42builtin1107z42_2740 = 
FOREIGN_TO_COBJ(BgL_z42builtin1107z42_2248); 
{ /* Llib/avahi.scm 115 */
BgL_avahizd2servicezd2browserz00_bglt BgL_new1221z00_2745;
{ /* Llib/avahi.scm 115 */
BgL_avahizd2servicezd2browserz00_bglt BgL_new1220z00_2746;
BgL_new1220z00_2746 = 
((BgL_avahizd2servicezd2browserz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2servicezd2browserz00_bgl) ))); 
{ /* Llib/avahi.scm 115 */
long BgL_arg2044z00_2747;
{ /* Llib/avahi.scm 115 */
long BgL_res2345z00_2748;
BgL_res2345z00_2748 = 
BGL_CLASS_INDEX(BGl_avahizd2servicezd2browserz00zz__avahi_avahiz00); 
BgL_arg2044z00_2747 = BgL_res2345z00_2748; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1220z00_2746), BgL_arg2044z00_2747); } 
BgL_new1221z00_2745 = BgL_new1220z00_2746; } 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(BgL_new1221z00_2745))->BgL_z42builtinz42)=((AvahiServiceBrowser *)BgL_z42builtin1107z42_2740),BUNSPEC); 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(BgL_new1221z00_2745))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)
((BgL_avahizd2clientzd2_bglt)BgL_client1108z00_2249)),BUNSPEC); 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(BgL_new1221z00_2745))->BgL_procz00)=((obj_t)
((obj_t)BgL_proc1109z00_2250)),BUNSPEC); 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(BgL_new1221z00_2745))->BgL_typez00)=((obj_t)
((obj_t)BgL_type1110z00_2251)),BUNSPEC); 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(BgL_new1221z00_2745))->BgL_domainz00)=((obj_t)
((obj_t)BgL_domain1111z00_2252)),BUNSPEC); 
{ /* Llib/avahi.scm 115 */
obj_t BgL_fun2043z00_2749;
BgL_fun2043z00_2749 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_avahizd2servicezd2browserz00zz__avahi_avahiz00); 
PROCEDURE_ENTRY(BgL_fun2043z00_2749)(BgL_fun2043z00_2749, 
((obj_t)BgL_new1221z00_2745), BEOA); } 
return BgL_new1221z00_2745;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2076> */
obj_t BGl_z62zc3anonymousza32076ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2253)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 115 */
return BGl_string2657z00zz__avahi_avahiz00;} 
BGL_FUNCTION_END;
}



/* &lambda2075 */
obj_t BGl_z62lambda2075z62zz__avahi_avahiz00(obj_t BgL_envz00_2254, obj_t BgL_oz00_2255, obj_t BgL_vz00_2256)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 115 */
return 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2255)))->BgL_domainz00)=((obj_t)
((obj_t)BgL_vz00_2256)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2074 */
obj_t BGl_z62lambda2074z62zz__avahi_avahiz00(obj_t BgL_envz00_2257, obj_t BgL_oz00_2258)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 115 */
return 
(((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2258)))->BgL_domainz00);} 
BGL_FUNCTION_END;
}



/* &lambda2069 */
obj_t BGl_z62lambda2069z62zz__avahi_avahiz00(obj_t BgL_envz00_2259, obj_t BgL_oz00_2260, obj_t BgL_vz00_2261)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 115 */
return 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2260)))->BgL_typez00)=((obj_t)
((obj_t)BgL_vz00_2261)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2068 */
obj_t BGl_z62lambda2068z62zz__avahi_avahiz00(obj_t BgL_envz00_2262, obj_t BgL_oz00_2263)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 115 */
return 
(((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2263)))->BgL_typez00);} 
BGL_FUNCTION_END;
}



/* &lambda2064 */
obj_t BGl_z62lambda2064z62zz__avahi_avahiz00(obj_t BgL_envz00_2264, obj_t BgL_oz00_2265, obj_t BgL_vz00_2266)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 115 */
return 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2265)))->BgL_procz00)=((obj_t)
((obj_t)BgL_vz00_2266)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2063 */
obj_t BGl_z62lambda2063z62zz__avahi_avahiz00(obj_t BgL_envz00_2267, obj_t BgL_oz00_2268)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 115 */
return 
(((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2268)))->BgL_procz00);} 
BGL_FUNCTION_END;
}



/* &lambda2059 */
obj_t BGl_z62lambda2059z62zz__avahi_avahiz00(obj_t BgL_envz00_2269, obj_t BgL_oz00_2270, obj_t BgL_vz00_2271)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 115 */
return 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2270)))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)
((BgL_avahizd2clientzd2_bglt)BgL_vz00_2271)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2058 */
BgL_avahizd2clientzd2_bglt BGl_z62lambda2058z62zz__avahi_avahiz00(obj_t BgL_envz00_2272, obj_t BgL_oz00_2273)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 115 */
return 
(((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2273)))->BgL_clientz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2054> */
obj_t BGl_z62zc3anonymousza32054ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2274)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 115 */
return 
void_star_to_obj(
(0L));} 
BGL_FUNCTION_END;
}



/* &lambda2053 */
obj_t BGl_z62lambda2053z62zz__avahi_avahiz00(obj_t BgL_envz00_2275, obj_t BgL_oz00_2276, obj_t BgL_vz00_2277)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 115 */
{ /* Llib/avahi.scm 115 */
AvahiServiceBrowser * BgL_vz00_2763;
BgL_vz00_2763 = 
FOREIGN_TO_COBJ(BgL_vz00_2277); 
return 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2276)))->BgL_z42builtinz42)=((AvahiServiceBrowser *)BgL_vz00_2763),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2052 */
obj_t BGl_z62lambda2052z62zz__avahi_avahiz00(obj_t BgL_envz00_2278, obj_t BgL_oz00_2279)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 115 */
return 
void_star_to_obj(
(((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2279)))->BgL_z42builtinz42));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2019> */
obj_t BGl_z62zc3anonymousza32019ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2280, obj_t BgL_new1105z00_2281)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 110 */
{ 
BgL_avahizd2entryzd2groupz00_bglt BgL_auxz00_4792;
((((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(
((BgL_avahizd2entryzd2groupz00_bglt)BgL_new1105z00_2281)))->BgL_z42builtinz42)=((AvahiEntryGroup *)
0L),BUNSPEC); 
{ 
BgL_avahizd2clientzd2_bglt BgL_auxz00_4796;
{ /* Llib/avahi.scm 110 */
obj_t BgL_classz00_2766;
BgL_classz00_2766 = BGl_avahizd2clientzd2zz__avahi_avahiz00; 
{ /* Llib/avahi.scm 110 */
obj_t BgL__ortest_1106z00_2767;
BgL__ortest_1106z00_2767 = 
BGL_CLASS_NIL(BgL_classz00_2766); 
if(
CBOOL(BgL__ortest_1106z00_2767))
{ /* Llib/avahi.scm 110 */
BgL_auxz00_4796 = 
((BgL_avahizd2clientzd2_bglt)BgL__ortest_1106z00_2767)
; }  else 
{ /* Llib/avahi.scm 110 */
BgL_auxz00_4796 = 
((BgL_avahizd2clientzd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2766))
; } } } 
((((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(
((BgL_avahizd2entryzd2groupz00_bglt)BgL_new1105z00_2281)))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)BgL_auxz00_4796),BUNSPEC); } 
((((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(
((BgL_avahizd2entryzd2groupz00_bglt)BgL_new1105z00_2281)))->BgL_procz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_4792 = 
((BgL_avahizd2entryzd2groupz00_bglt)BgL_new1105z00_2281); 
return 
((obj_t)BgL_auxz00_4792);} } 
BGL_FUNCTION_END;
}



/* &lambda2017 */
BgL_avahizd2entryzd2groupz00_bglt BGl_z62lambda2017z62zz__avahi_avahiz00(obj_t BgL_envz00_2282)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 110 */
{ /* Llib/avahi.scm 110 */
BgL_avahizd2entryzd2groupz00_bglt BgL_new1104z00_2768;
BgL_new1104z00_2768 = 
((BgL_avahizd2entryzd2groupz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2entryzd2groupz00_bgl) ))); 
{ /* Llib/avahi.scm 110 */
long BgL_arg2018z00_2769;
{ /* Llib/avahi.scm 110 */
long BgL_res2344z00_2770;
BgL_res2344z00_2770 = 
BGL_CLASS_INDEX(BGl_avahizd2entryzd2groupz00zz__avahi_avahiz00); 
BgL_arg2018z00_2769 = BgL_res2344z00_2770; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1104z00_2768), BgL_arg2018z00_2769); } 
return BgL_new1104z00_2768;} } 
BGL_FUNCTION_END;
}



/* &lambda2014 */
BgL_avahizd2entryzd2groupz00_bglt BGl_z62lambda2014z62zz__avahi_avahiz00(obj_t BgL_envz00_2283, obj_t BgL_z42builtin1101z42_2284, obj_t BgL_client1102z00_2285, obj_t BgL_proc1103z00_2286)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 110 */
{ /* Llib/avahi.scm 110 */
AvahiEntryGroup * BgL_z42builtin1101z42_2771;
BgL_z42builtin1101z42_2771 = 
FOREIGN_TO_COBJ(BgL_z42builtin1101z42_2284); 
{ /* Llib/avahi.scm 110 */
BgL_avahizd2entryzd2groupz00_bglt BgL_new1219z00_2774;
{ /* Llib/avahi.scm 110 */
BgL_avahizd2entryzd2groupz00_bglt BgL_new1218z00_2775;
BgL_new1218z00_2775 = 
((BgL_avahizd2entryzd2groupz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2entryzd2groupz00_bgl) ))); 
{ /* Llib/avahi.scm 110 */
long BgL_arg2016z00_2776;
{ /* Llib/avahi.scm 110 */
long BgL_res2343z00_2777;
BgL_res2343z00_2777 = 
BGL_CLASS_INDEX(BGl_avahizd2entryzd2groupz00zz__avahi_avahiz00); 
BgL_arg2016z00_2776 = BgL_res2343z00_2777; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1218z00_2775), BgL_arg2016z00_2776); } 
BgL_new1219z00_2774 = BgL_new1218z00_2775; } 
((((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(BgL_new1219z00_2774))->BgL_z42builtinz42)=((AvahiEntryGroup *)BgL_z42builtin1101z42_2771),BUNSPEC); 
((((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(BgL_new1219z00_2774))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)
((BgL_avahizd2clientzd2_bglt)BgL_client1102z00_2285)),BUNSPEC); 
((((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(BgL_new1219z00_2774))->BgL_procz00)=((obj_t)
((obj_t)BgL_proc1103z00_2286)),BUNSPEC); 
{ /* Llib/avahi.scm 110 */
obj_t BgL_fun2015z00_2778;
BgL_fun2015z00_2778 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_avahizd2entryzd2groupz00zz__avahi_avahiz00); 
PROCEDURE_ENTRY(BgL_fun2015z00_2778)(BgL_fun2015z00_2778, 
((obj_t)BgL_new1219z00_2774), BEOA); } 
return BgL_new1219z00_2774;} } } 
BGL_FUNCTION_END;
}



/* &lambda2036 */
obj_t BGl_z62lambda2036z62zz__avahi_avahiz00(obj_t BgL_envz00_2287, obj_t BgL_oz00_2288, obj_t BgL_vz00_2289)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 110 */
return 
((((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_2288)))->BgL_procz00)=((obj_t)
((obj_t)BgL_vz00_2289)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2035 */
obj_t BGl_z62lambda2035z62zz__avahi_avahiz00(obj_t BgL_envz00_2290, obj_t BgL_oz00_2291)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 110 */
return 
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_2291)))->BgL_procz00);} 
BGL_FUNCTION_END;
}



/* &lambda2031 */
obj_t BGl_z62lambda2031z62zz__avahi_avahiz00(obj_t BgL_envz00_2292, obj_t BgL_oz00_2293, obj_t BgL_vz00_2294)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 110 */
return 
((((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_2293)))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)
((BgL_avahizd2clientzd2_bglt)BgL_vz00_2294)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2030 */
BgL_avahizd2clientzd2_bglt BGl_z62lambda2030z62zz__avahi_avahiz00(obj_t BgL_envz00_2295, obj_t BgL_oz00_2296)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 110 */
return 
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_2296)))->BgL_clientz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2026> */
obj_t BGl_z62zc3anonymousza32026ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2297)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 110 */
return 
void_star_to_obj(
(0L));} 
BGL_FUNCTION_END;
}



/* &lambda2025 */
obj_t BGl_z62lambda2025z62zz__avahi_avahiz00(obj_t BgL_envz00_2298, obj_t BgL_oz00_2299, obj_t BgL_vz00_2300)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 110 */
{ /* Llib/avahi.scm 110 */
AvahiEntryGroup * BgL_vz00_2786;
BgL_vz00_2786 = 
FOREIGN_TO_COBJ(BgL_vz00_2300); 
return 
((((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_2299)))->BgL_z42builtinz42)=((AvahiEntryGroup *)BgL_vz00_2786),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2024 */
obj_t BGl_z62lambda2024z62zz__avahi_avahiz00(obj_t BgL_envz00_2301, obj_t BgL_oz00_2302)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 110 */
return 
void_star_to_obj(
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_2302)))->BgL_z42builtinz42));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1885> */
obj_t BGl_z62zc3anonymousza31885ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2303, obj_t BgL_new1099z00_2304)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
{ 
BgL_avahizd2clientzd2_bglt BgL_auxz00_4847;
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_new1099z00_2304)))->BgL_z42builtinz42)=((AvahiClient *)
0L),BUNSPEC); 
{ 
BgL_avahizd2pollzd2_bglt BgL_auxz00_4851;
{ /* Llib/avahi.scm 67 */
obj_t BgL_classz00_2789;
BgL_classz00_2789 = BGl_avahizd2pollzd2zz__avahi_avahiz00; 
{ /* Llib/avahi.scm 67 */
obj_t BgL__ortest_1106z00_2790;
BgL__ortest_1106z00_2790 = 
BGL_CLASS_NIL(BgL_classz00_2789); 
if(
CBOOL(BgL__ortest_1106z00_2790))
{ /* Llib/avahi.scm 67 */
BgL_auxz00_4851 = 
((BgL_avahizd2pollzd2_bglt)BgL__ortest_1106z00_2790)
; }  else 
{ /* Llib/avahi.scm 67 */
BgL_auxz00_4851 = 
((BgL_avahizd2pollzd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2789))
; } } } 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_new1099z00_2304)))->BgL_pollz00)=((BgL_avahizd2pollzd2_bglt)BgL_auxz00_4851),BUNSPEC); } 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_new1099z00_2304)))->BgL_flagsz00)=((obj_t)
CNST_TABLE_REF(((long)97))),BUNSPEC); 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_new1099z00_2304)))->BgL_procz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_new1099z00_2304)))->BgL_z52groupsz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_new1099z00_2304)))->BgL_z52browsersz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_new1099z00_2304)))->BgL_resolversz00)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_4847 = 
((BgL_avahizd2clientzd2_bglt)BgL_new1099z00_2304); 
return 
((obj_t)BgL_auxz00_4847);} } 
BGL_FUNCTION_END;
}



/* &lambda1883 */
BgL_avahizd2clientzd2_bglt BGl_z62lambda1883z62zz__avahi_avahiz00(obj_t BgL_envz00_2305)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
{ /* Llib/avahi.scm 67 */
BgL_avahizd2clientzd2_bglt BgL_new1098z00_2791;
BgL_new1098z00_2791 = 
((BgL_avahizd2clientzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2clientzd2_bgl) ))); 
{ /* Llib/avahi.scm 67 */
long BgL_arg1884z00_2792;
{ /* Llib/avahi.scm 67 */
long BgL_res2342z00_2793;
BgL_res2342z00_2793 = 
BGL_CLASS_INDEX(BGl_avahizd2clientzd2zz__avahi_avahiz00); 
BgL_arg1884z00_2792 = BgL_res2342z00_2793; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1098z00_2791), BgL_arg1884z00_2792); } 
return BgL_new1098z00_2791;} } 
BGL_FUNCTION_END;
}



/* &lambda1880 */
BgL_avahizd2clientzd2_bglt BGl_z62lambda1880z62zz__avahi_avahiz00(obj_t BgL_envz00_2306, obj_t BgL_z42builtin1091z42_2307, obj_t BgL_poll1092z00_2308, obj_t BgL_flags1093z00_2309, obj_t BgL_proc1094z00_2310, obj_t BgL_z52groups1095z52_2311, obj_t BgL_z52browsers1096z52_2312, obj_t BgL_resolvers1097z00_2313)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
{ /* Llib/avahi.scm 67 */
AvahiClient * BgL_z42builtin1091z42_2794;
BgL_z42builtin1091z42_2794 = 
FOREIGN_TO_COBJ(BgL_z42builtin1091z42_2307); 
{ /* Llib/avahi.scm 67 */
BgL_avahizd2clientzd2_bglt BgL_new1217z00_2801;
{ /* Llib/avahi.scm 67 */
BgL_avahizd2clientzd2_bglt BgL_new1216z00_2802;
BgL_new1216z00_2802 = 
((BgL_avahizd2clientzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2clientzd2_bgl) ))); 
{ /* Llib/avahi.scm 67 */
long BgL_arg1882z00_2803;
{ /* Llib/avahi.scm 67 */
long BgL_res2341z00_2804;
BgL_res2341z00_2804 = 
BGL_CLASS_INDEX(BGl_avahizd2clientzd2zz__avahi_avahiz00); 
BgL_arg1882z00_2803 = BgL_res2341z00_2804; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1216z00_2802), BgL_arg1882z00_2803); } 
BgL_new1217z00_2801 = BgL_new1216z00_2802; } 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_new1217z00_2801))->BgL_z42builtinz42)=((AvahiClient *)BgL_z42builtin1091z42_2794),BUNSPEC); 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_new1217z00_2801))->BgL_pollz00)=((BgL_avahizd2pollzd2_bglt)
((BgL_avahizd2pollzd2_bglt)BgL_poll1092z00_2308)),BUNSPEC); 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_new1217z00_2801))->BgL_flagsz00)=((obj_t)
((obj_t)BgL_flags1093z00_2309)),BUNSPEC); 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_new1217z00_2801))->BgL_procz00)=((obj_t)
((obj_t)BgL_proc1094z00_2310)),BUNSPEC); 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_new1217z00_2801))->BgL_z52groupsz52)=((obj_t)
((obj_t)BgL_z52groups1095z52_2311)),BUNSPEC); 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_new1217z00_2801))->BgL_z52browsersz52)=((obj_t)
((obj_t)BgL_z52browsers1096z52_2312)),BUNSPEC); 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_new1217z00_2801))->BgL_resolversz00)=((obj_t)
((obj_t)BgL_resolvers1097z00_2313)),BUNSPEC); 
{ /* Llib/avahi.scm 67 */
obj_t BgL_fun1881z00_2805;
BgL_fun1881z00_2805 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_avahizd2clientzd2zz__avahi_avahiz00); 
PROCEDURE_ENTRY(BgL_fun1881z00_2805)(BgL_fun1881z00_2805, 
((obj_t)BgL_new1217z00_2801), BEOA); } 
return BgL_new1217z00_2801;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2002> */
obj_t BGl_z62zc3anonymousza32002ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2314, obj_t BgL_oz00_2315)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 101 */
{ /* Llib/avahi.scm 104 */
bool_t BgL_testz00_4901;
{ /* Llib/avahi.scm 104 */
AvahiClient * BgL_arg2007z00_2806;
BgL_arg2007z00_2806 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2315)))->BgL_z42builtinz42); 
BgL_testz00_4901 = 
(BgL_arg2007z00_2806 == 0L); } 
if(BgL_testz00_4901)
{ /* Llib/avahi.scm 104 */
return 
CNST_TABLE_REF(((long)99));}  else 
{ /* Llib/avahi.scm 107 */
AvahiClientState BgL_arg2005z00_2807;
{ /* Llib/avahi.scm 107 */
AvahiClient * BgL_arg2006z00_2808;
BgL_arg2006z00_2808 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2315)))->BgL_z42builtinz42); 
BgL_arg2005z00_2807 = 
avahi_client_get_state(BgL_arg2006z00_2808); } 
return 
bgl_avahi_client_state_to_symbol(BgL_arg2005z00_2807);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1993> */
obj_t BGl_z62zc3anonymousza31993ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2316, obj_t BgL_oz00_2317)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 95 */
{ /* Llib/avahi.scm 98 */
bool_t BgL_testz00_4910;
{ /* Llib/avahi.scm 98 */
AvahiClient * BgL_arg1997z00_2809;
BgL_arg1997z00_2809 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2317)))->BgL_z42builtinz42); 
BgL_testz00_4910 = 
(BgL_arg1997z00_2809 == 0L); } 
if(BgL_testz00_4910)
{ /* Llib/avahi.scm 98 */
return BGl_string2658z00zz__avahi_avahiz00;}  else 
{ /* Llib/avahi.scm 100 */
AvahiClient * BgL_arg1996z00_2810;
BgL_arg1996z00_2810 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2317)))->BgL_z42builtinz42); 
return 
string_to_bstring(
avahi_client_get_host_name_fqdn(BgL_arg1996z00_2810));} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1984> */
obj_t BGl_z62zc3anonymousza31984ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2318, obj_t BgL_oz00_2319)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 89 */
{ /* Llib/avahi.scm 92 */
bool_t BgL_testz00_4918;
{ /* Llib/avahi.scm 92 */
AvahiClient * BgL_arg1988z00_2811;
BgL_arg1988z00_2811 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2319)))->BgL_z42builtinz42); 
BgL_testz00_4918 = 
(BgL_arg1988z00_2811 == 0L); } 
if(BgL_testz00_4918)
{ /* Llib/avahi.scm 92 */
return BGl_string2658z00zz__avahi_avahiz00;}  else 
{ /* Llib/avahi.scm 94 */
AvahiClient * BgL_arg1987z00_2812;
BgL_arg1987z00_2812 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2319)))->BgL_z42builtinz42); 
return 
string_to_bstring(
avahi_client_get_domain_name(BgL_arg1987z00_2812));} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1975> */
obj_t BGl_z62zc3anonymousza31975ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2320, obj_t BgL_oz00_2321, obj_t BgL_vz00_2322)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 81 */
{ /* Llib/avahi.scm 87 */
bool_t BgL_testz00_4926;
{ /* Llib/avahi.scm 87 */
AvahiClient * BgL_arg1979z00_2813;
BgL_arg1979z00_2813 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2321)))->BgL_z42builtinz42); 
BgL_testz00_4926 = 
(BgL_arg1979z00_2813 == 0L); } 
if(BgL_testz00_4926)
{ /* Llib/avahi.scm 87 */
return BFALSE;}  else 
{ /* Llib/avahi.scm 88 */
AvahiClient * BgL_arg1978z00_2814;
BgL_arg1978z00_2814 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2321)))->BgL_z42builtinz42); 
{ /* Llib/avahi.scm 88 */
char * BgL_tmpz00_4932;
{ /* Llib/avahi.scm 88 */
char * BgL_tmpz00_4933;
BgL_tmpz00_4933 = 
BSTRING_TO_STRING(
((obj_t)BgL_vz00_2322)); 
BgL_tmpz00_4932 = 
avahi_client_set_host_name(BgL_arg1978z00_2814, BgL_tmpz00_4933); } 
return 
string_to_bstring(BgL_tmpz00_4932);} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1969> */
obj_t BGl_z62zc3anonymousza31969ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2323, obj_t BgL_oz00_2324)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 81 */
{ /* Llib/avahi.scm 83 */
bool_t BgL_testz00_4938;
{ /* Llib/avahi.scm 83 */
AvahiClient * BgL_arg1973z00_2815;
BgL_arg1973z00_2815 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2324)))->BgL_z42builtinz42); 
BgL_testz00_4938 = 
(BgL_arg1973z00_2815 == 0L); } 
if(BgL_testz00_4938)
{ /* Llib/avahi.scm 83 */
return BGl_string2658z00zz__avahi_avahiz00;}  else 
{ /* Llib/avahi.scm 85 */
AvahiClient * BgL_arg1972z00_2816;
BgL_arg1972z00_2816 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2324)))->BgL_z42builtinz42); 
return 
string_to_bstring(
avahi_client_get_host_name(BgL_arg1972z00_2816));} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1959> */
obj_t BGl_z62zc3anonymousza31959ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2325, obj_t BgL_oz00_2326)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 75 */
{ /* Llib/avahi.scm 78 */
bool_t BgL_testz00_4946;
{ /* Llib/avahi.scm 78 */
AvahiClient * BgL_arg1963z00_2817;
BgL_arg1963z00_2817 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2326)))->BgL_z42builtinz42); 
BgL_testz00_4946 = 
(BgL_arg1963z00_2817 == 0L); } 
if(BgL_testz00_4946)
{ /* Llib/avahi.scm 78 */
return BGl_string2658z00zz__avahi_avahiz00;}  else 
{ /* Llib/avahi.scm 80 */
AvahiClient * BgL_arg1962z00_2818;
BgL_arg1962z00_2818 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2326)))->BgL_z42builtinz42); 
return 
string_to_bstring(
avahi_client_get_version_string(BgL_arg1962z00_2818));} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1955> */
obj_t BGl_z62zc3anonymousza31955ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2327, obj_t BgL_oz00_2328, obj_t BgL_vz00_2329)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2328), 
(int)(((long)4)), BgL_vz00_2329);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1954> */
obj_t BGl_z62zc3anonymousza31954ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2330, obj_t BgL_oz00_2331)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2331), 
(int)(((long)4)));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1950> */
obj_t BGl_z62zc3anonymousza31950ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2332, obj_t BgL_oz00_2333, obj_t BgL_vz00_2334)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2333), 
(int)(((long)3)), BgL_vz00_2334);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1949> */
obj_t BGl_z62zc3anonymousza31949ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2335, obj_t BgL_oz00_2336)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2336), 
(int)(((long)3)));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1945> */
obj_t BGl_z62zc3anonymousza31945ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2337, obj_t BgL_oz00_2338, obj_t BgL_vz00_2339)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2338), 
(int)(((long)2)), BgL_vz00_2339);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1944> */
obj_t BGl_z62zc3anonymousza31944ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2340, obj_t BgL_oz00_2341)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2341), 
(int)(((long)2)));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1940> */
obj_t BGl_z62zc3anonymousza31940ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2342, obj_t BgL_oz00_2343, obj_t BgL_vz00_2344)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2343), 
(int)(((long)1)), BgL_vz00_2344);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1939> */
obj_t BGl_z62zc3anonymousza31939ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2345, obj_t BgL_oz00_2346)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2346), 
(int)(((long)1)));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1935> */
obj_t BGl_z62zc3anonymousza31935ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2347, obj_t BgL_oz00_2348, obj_t BgL_vz00_2349)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2348), 
(int)(((long)0)), BgL_vz00_2349);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1934> */
obj_t BGl_z62zc3anonymousza31934ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2350, obj_t BgL_oz00_2351)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2351), 
(int)(((long)0)));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1930> */
obj_t BGl_z62zc3anonymousza31930ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2352)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return BNIL;} 
BGL_FUNCTION_END;
}



/* &lambda1929 */
obj_t BGl_z62lambda1929z62zz__avahi_avahiz00(obj_t BgL_envz00_2353, obj_t BgL_oz00_2354, obj_t BgL_vz00_2355)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2354)))->BgL_resolversz00)=((obj_t)
((obj_t)BgL_vz00_2355)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1928 */
obj_t BGl_z62lambda1928z62zz__avahi_avahiz00(obj_t BgL_envz00_2356, obj_t BgL_oz00_2357)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2357)))->BgL_resolversz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1923> */
obj_t BGl_z62zc3anonymousza31923ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2358)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return BNIL;} 
BGL_FUNCTION_END;
}



/* &lambda1922 */
obj_t BGl_z62lambda1922z62zz__avahi_avahiz00(obj_t BgL_envz00_2359, obj_t BgL_oz00_2360, obj_t BgL_vz00_2361)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2360)))->BgL_z52browsersz52)=((obj_t)
((obj_t)BgL_vz00_2361)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1921 */
obj_t BGl_z62lambda1921z62zz__avahi_avahiz00(obj_t BgL_envz00_2362, obj_t BgL_oz00_2363)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2363)))->BgL_z52browsersz52);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1916> */
obj_t BGl_z62zc3anonymousza31916ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2364)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return BNIL;} 
BGL_FUNCTION_END;
}



/* &lambda1915 */
obj_t BGl_z62lambda1915z62zz__avahi_avahiz00(obj_t BgL_envz00_2365, obj_t BgL_oz00_2366, obj_t BgL_vz00_2367)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2366)))->BgL_z52groupsz52)=((obj_t)
((obj_t)BgL_vz00_2367)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1914 */
obj_t BGl_z62lambda1914z62zz__avahi_avahiz00(obj_t BgL_envz00_2368, obj_t BgL_oz00_2369)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2369)))->BgL_z52groupsz52);} 
BGL_FUNCTION_END;
}



/* &lambda1909 */
obj_t BGl_z62lambda1909z62zz__avahi_avahiz00(obj_t BgL_envz00_2370, obj_t BgL_oz00_2371, obj_t BgL_vz00_2372)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2371)))->BgL_procz00)=((obj_t)
((obj_t)BgL_vz00_2372)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1908 */
obj_t BGl_z62lambda1908z62zz__avahi_avahiz00(obj_t BgL_envz00_2373, obj_t BgL_oz00_2374)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2374)))->BgL_procz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1904> */
obj_t BGl_z62zc3anonymousza31904ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2375)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
CNST_TABLE_REF(((long)100));} 
BGL_FUNCTION_END;
}



/* &lambda1903 */
obj_t BGl_z62lambda1903z62zz__avahi_avahiz00(obj_t BgL_envz00_2376, obj_t BgL_oz00_2377, obj_t BgL_vz00_2378)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2377)))->BgL_flagsz00)=((obj_t)
((obj_t)BgL_vz00_2378)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1902 */
obj_t BGl_z62lambda1902z62zz__avahi_avahiz00(obj_t BgL_envz00_2379, obj_t BgL_oz00_2380)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2380)))->BgL_flagsz00);} 
BGL_FUNCTION_END;
}



/* &lambda1897 */
obj_t BGl_z62lambda1897z62zz__avahi_avahiz00(obj_t BgL_envz00_2381, obj_t BgL_oz00_2382, obj_t BgL_vz00_2383)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2382)))->BgL_pollz00)=((BgL_avahizd2pollzd2_bglt)
((BgL_avahizd2pollzd2_bglt)BgL_vz00_2383)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1896 */
BgL_avahizd2pollzd2_bglt BGl_z62lambda1896z62zz__avahi_avahiz00(obj_t BgL_envz00_2384, obj_t BgL_oz00_2385)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2385)))->BgL_pollz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1892> */
obj_t BGl_z62zc3anonymousza31892ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2386)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
void_star_to_obj(
(0L));} 
BGL_FUNCTION_END;
}



/* &lambda1891 */
obj_t BGl_z62lambda1891z62zz__avahi_avahiz00(obj_t BgL_envz00_2387, obj_t BgL_oz00_2388, obj_t BgL_vz00_2389)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
{ /* Llib/avahi.scm 67 */
AvahiClient * BgL_vz00_2838;
BgL_vz00_2838 = 
FOREIGN_TO_COBJ(BgL_vz00_2389); 
return 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2388)))->BgL_z42builtinz42)=((AvahiClient *)BgL_vz00_2838),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1890 */
obj_t BGl_z62lambda1890z62zz__avahi_avahiz00(obj_t BgL_envz00_2390, obj_t BgL_oz00_2391)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 67 */
return 
void_star_to_obj(
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2391)))->BgL_z42builtinz42));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1867> */
obj_t BGl_z62zc3anonymousza31867ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2392, obj_t BgL_new1089z00_2393)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 64 */
{ 
BgL_avahizd2threadedzd2pollz00_bglt BgL_auxz00_5023;
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_new1089z00_2393))))->BgL_z42ctypez42)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_new1089z00_2393))))->BgL_z52procsz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_avahizd2threadedzd2pollz00_bglt)COBJECT(
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_new1089z00_2393)))->BgL_z42builtinz42)=((AvahiThreadedPoll *)
0L),BUNSPEC); 
BgL_auxz00_5023 = 
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_new1089z00_2393); 
return 
((obj_t)BgL_auxz00_5023);} } 
BGL_FUNCTION_END;
}



/* &lambda1865 */
BgL_avahizd2threadedzd2pollz00_bglt BGl_z62lambda1865z62zz__avahi_avahiz00(obj_t BgL_envz00_2394)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 64 */
{ /* Llib/avahi.scm 64 */
BgL_avahizd2threadedzd2pollz00_bglt BgL_new1088z00_2841;
BgL_new1088z00_2841 = 
((BgL_avahizd2threadedzd2pollz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2threadedzd2pollz00_bgl) ))); 
{ /* Llib/avahi.scm 64 */
long BgL_arg1866z00_2842;
{ /* Llib/avahi.scm 64 */
long BgL_res2340z00_2843;
BgL_res2340z00_2843 = 
BGL_CLASS_INDEX(BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00); 
BgL_arg1866z00_2842 = BgL_res2340z00_2843; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1088z00_2841), BgL_arg1866z00_2842); } 
return BgL_new1088z00_2841;} } 
BGL_FUNCTION_END;
}



/* &lambda1862 */
BgL_avahizd2threadedzd2pollz00_bglt BGl_z62lambda1862z62zz__avahi_avahiz00(obj_t BgL_envz00_2395, obj_t BgL_z42ctype1085z42_2396, obj_t BgL_z52procs1086z52_2397, obj_t BgL_z42builtin1087z42_2398)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 64 */
{ /* Llib/avahi.scm 64 */
int BgL_z42ctype1085z42_2844;AvahiThreadedPoll * BgL_z42builtin1087z42_2846;
BgL_z42ctype1085z42_2844 = 
CINT(BgL_z42ctype1085z42_2396); 
BgL_z42builtin1087z42_2846 = 
FOREIGN_TO_COBJ(BgL_z42builtin1087z42_2398); 
{ /* Llib/avahi.scm 64 */
BgL_avahizd2threadedzd2pollz00_bglt BgL_new1215z00_2847;
{ /* Llib/avahi.scm 64 */
BgL_avahizd2threadedzd2pollz00_bglt BgL_new1214z00_2848;
BgL_new1214z00_2848 = 
((BgL_avahizd2threadedzd2pollz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2threadedzd2pollz00_bgl) ))); 
{ /* Llib/avahi.scm 64 */
long BgL_arg1864z00_2849;
{ /* Llib/avahi.scm 64 */
long BgL_res2339z00_2850;
BgL_res2339z00_2850 = 
BGL_CLASS_INDEX(BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00); 
BgL_arg1864z00_2849 = BgL_res2339z00_2850; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1214z00_2848), BgL_arg1864z00_2849); } 
BgL_new1215z00_2847 = BgL_new1214z00_2848; } 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_new1215z00_2847)))->BgL_z42ctypez42)=((int)BgL_z42ctype1085z42_2844),BUNSPEC); 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_new1215z00_2847)))->BgL_z52procsz52)=((obj_t)
((obj_t)BgL_z52procs1086z52_2397)),BUNSPEC); 
((((BgL_avahizd2threadedzd2pollz00_bglt)COBJECT(BgL_new1215z00_2847))->BgL_z42builtinz42)=((AvahiThreadedPoll *)BgL_z42builtin1087z42_2846),BUNSPEC); 
{ /* Llib/avahi.scm 64 */
obj_t BgL_fun1863z00_2851;
BgL_fun1863z00_2851 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00); 
PROCEDURE_ENTRY(BgL_fun1863z00_2851)(BgL_fun1863z00_2851, 
((obj_t)BgL_new1215z00_2847), BEOA); } 
return BgL_new1215z00_2847;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1874> */
obj_t BGl_z62zc3anonymousza31874ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2399)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 64 */
return 
void_star_to_obj(
(0L));} 
BGL_FUNCTION_END;
}



/* &lambda1873 */
obj_t BGl_z62lambda1873z62zz__avahi_avahiz00(obj_t BgL_envz00_2400, obj_t BgL_oz00_2401, obj_t BgL_vz00_2402)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 64 */
{ /* Llib/avahi.scm 64 */
AvahiThreadedPoll * BgL_vz00_2853;
BgL_vz00_2853 = 
FOREIGN_TO_COBJ(BgL_vz00_2402); 
return 
((((BgL_avahizd2threadedzd2pollz00_bglt)COBJECT(
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_oz00_2401)))->BgL_z42builtinz42)=((AvahiThreadedPoll *)BgL_vz00_2853),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1872 */
obj_t BGl_z62lambda1872z62zz__avahi_avahiz00(obj_t BgL_envz00_2403, obj_t BgL_oz00_2404)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 64 */
return 
void_star_to_obj(
(((BgL_avahizd2threadedzd2pollz00_bglt)COBJECT(
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_oz00_2404)))->BgL_z42builtinz42));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1849> */
obj_t BGl_z62zc3anonymousza31849ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2405, obj_t BgL_new1083z00_2406)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 61 */
{ 
BgL_avahizd2simplezd2pollz00_bglt BgL_auxz00_5066;
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)
((BgL_avahizd2simplezd2pollz00_bglt)BgL_new1083z00_2406))))->BgL_z42ctypez42)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)
((BgL_avahizd2simplezd2pollz00_bglt)BgL_new1083z00_2406))))->BgL_z52procsz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_avahizd2simplezd2pollz00_bglt)COBJECT(
((BgL_avahizd2simplezd2pollz00_bglt)BgL_new1083z00_2406)))->BgL_z42builtinz42)=((AvahiSimplePoll *)
0L),BUNSPEC); 
BgL_auxz00_5066 = 
((BgL_avahizd2simplezd2pollz00_bglt)BgL_new1083z00_2406); 
return 
((obj_t)BgL_auxz00_5066);} } 
BGL_FUNCTION_END;
}



/* &lambda1847 */
BgL_avahizd2simplezd2pollz00_bglt BGl_z62lambda1847z62zz__avahi_avahiz00(obj_t BgL_envz00_2407)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 61 */
{ /* Llib/avahi.scm 61 */
BgL_avahizd2simplezd2pollz00_bglt BgL_new1082z00_2856;
BgL_new1082z00_2856 = 
((BgL_avahizd2simplezd2pollz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2simplezd2pollz00_bgl) ))); 
{ /* Llib/avahi.scm 61 */
long BgL_arg1848z00_2857;
{ /* Llib/avahi.scm 61 */
long BgL_res2338z00_2858;
BgL_res2338z00_2858 = 
BGL_CLASS_INDEX(BGl_avahizd2simplezd2pollz00zz__avahi_avahiz00); 
BgL_arg1848z00_2857 = BgL_res2338z00_2858; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1082z00_2856), BgL_arg1848z00_2857); } 
return BgL_new1082z00_2856;} } 
BGL_FUNCTION_END;
}



/* &lambda1844 */
BgL_avahizd2simplezd2pollz00_bglt BGl_z62lambda1844z62zz__avahi_avahiz00(obj_t BgL_envz00_2408, obj_t BgL_z42ctype1079z42_2409, obj_t BgL_z52procs1080z52_2410, obj_t BgL_z42builtin1081z42_2411)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 61 */
{ /* Llib/avahi.scm 61 */
int BgL_z42ctype1079z42_2859;AvahiSimplePoll * BgL_z42builtin1081z42_2861;
BgL_z42ctype1079z42_2859 = 
CINT(BgL_z42ctype1079z42_2409); 
BgL_z42builtin1081z42_2861 = 
FOREIGN_TO_COBJ(BgL_z42builtin1081z42_2411); 
{ /* Llib/avahi.scm 61 */
BgL_avahizd2simplezd2pollz00_bglt BgL_new1213z00_2862;
{ /* Llib/avahi.scm 61 */
BgL_avahizd2simplezd2pollz00_bglt BgL_new1212z00_2863;
BgL_new1212z00_2863 = 
((BgL_avahizd2simplezd2pollz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2simplezd2pollz00_bgl) ))); 
{ /* Llib/avahi.scm 61 */
long BgL_arg1846z00_2864;
{ /* Llib/avahi.scm 61 */
long BgL_res2337z00_2865;
BgL_res2337z00_2865 = 
BGL_CLASS_INDEX(BGl_avahizd2simplezd2pollz00zz__avahi_avahiz00); 
BgL_arg1846z00_2864 = BgL_res2337z00_2865; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1212z00_2863), BgL_arg1846z00_2864); } 
BgL_new1213z00_2862 = BgL_new1212z00_2863; } 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_new1213z00_2862)))->BgL_z42ctypez42)=((int)BgL_z42ctype1079z42_2859),BUNSPEC); 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_new1213z00_2862)))->BgL_z52procsz52)=((obj_t)
((obj_t)BgL_z52procs1080z52_2410)),BUNSPEC); 
((((BgL_avahizd2simplezd2pollz00_bglt)COBJECT(BgL_new1213z00_2862))->BgL_z42builtinz42)=((AvahiSimplePoll *)BgL_z42builtin1081z42_2861),BUNSPEC); 
{ /* Llib/avahi.scm 61 */
obj_t BgL_fun1845z00_2866;
BgL_fun1845z00_2866 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_avahizd2simplezd2pollz00zz__avahi_avahiz00); 
PROCEDURE_ENTRY(BgL_fun1845z00_2866)(BgL_fun1845z00_2866, 
((obj_t)BgL_new1213z00_2862), BEOA); } 
return BgL_new1213z00_2862;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1856> */
obj_t BGl_z62zc3anonymousza31856ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2412)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 61 */
return 
void_star_to_obj(
(0L));} 
BGL_FUNCTION_END;
}



/* &lambda1855 */
obj_t BGl_z62lambda1855z62zz__avahi_avahiz00(obj_t BgL_envz00_2413, obj_t BgL_oz00_2414, obj_t BgL_vz00_2415)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 61 */
{ /* Llib/avahi.scm 61 */
AvahiSimplePoll * BgL_vz00_2868;
BgL_vz00_2868 = 
FOREIGN_TO_COBJ(BgL_vz00_2415); 
return 
((((BgL_avahizd2simplezd2pollz00_bglt)COBJECT(
((BgL_avahizd2simplezd2pollz00_bglt)BgL_oz00_2414)))->BgL_z42builtinz42)=((AvahiSimplePoll *)BgL_vz00_2868),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1854 */
obj_t BGl_z62lambda1854z62zz__avahi_avahiz00(obj_t BgL_envz00_2416, obj_t BgL_oz00_2417)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 61 */
return 
void_star_to_obj(
(((BgL_avahizd2simplezd2pollz00_bglt)COBJECT(
((BgL_avahizd2simplezd2pollz00_bglt)BgL_oz00_2417)))->BgL_z42builtinz42));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1824> */
obj_t BGl_z62zc3anonymousza31824ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2418, obj_t BgL_new1077z00_2419)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 57 */
{ 
BgL_avahizd2pollzd2_bglt BgL_auxz00_5109;
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_new1077z00_2419)))->BgL_z42ctypez42)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_new1077z00_2419)))->BgL_z52procsz52)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_5109 = 
((BgL_avahizd2pollzd2_bglt)BgL_new1077z00_2419); 
return 
((obj_t)BgL_auxz00_5109);} } 
BGL_FUNCTION_END;
}



/* &lambda1822 */
BgL_avahizd2pollzd2_bglt BGl_z62lambda1822z62zz__avahi_avahiz00(obj_t BgL_envz00_2420)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 57 */
{ /* Llib/avahi.scm 57 */
BgL_avahizd2pollzd2_bglt BgL_new1076z00_2871;
BgL_new1076z00_2871 = 
((BgL_avahizd2pollzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2pollzd2_bgl) ))); 
{ /* Llib/avahi.scm 57 */
long BgL_arg1823z00_2872;
{ /* Llib/avahi.scm 57 */
long BgL_res2336z00_2873;
BgL_res2336z00_2873 = 
BGL_CLASS_INDEX(BGl_avahizd2pollzd2zz__avahi_avahiz00); 
BgL_arg1823z00_2872 = BgL_res2336z00_2873; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1076z00_2871), BgL_arg1823z00_2872); } 
return BgL_new1076z00_2871;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1838> */
obj_t BGl_z62zc3anonymousza31838ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2421)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 57 */
return BNIL;} 
BGL_FUNCTION_END;
}



/* &lambda1837 */
obj_t BGl_z62lambda1837z62zz__avahi_avahiz00(obj_t BgL_envz00_2422, obj_t BgL_oz00_2423, obj_t BgL_vz00_2424)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 57 */
return 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_oz00_2423)))->BgL_z52procsz52)=((obj_t)
((obj_t)BgL_vz00_2424)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1836 */
obj_t BGl_z62lambda1836z62zz__avahi_avahiz00(obj_t BgL_envz00_2425, obj_t BgL_oz00_2426)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 57 */
return 
(((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_oz00_2426)))->BgL_z52procsz52);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1831> */
obj_t BGl_z62zc3anonymousza31831ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2427)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 57 */
return 
BINT(((long)-1));} 
BGL_FUNCTION_END;
}



/* &lambda1830 */
obj_t BGl_z62lambda1830z62zz__avahi_avahiz00(obj_t BgL_envz00_2428, obj_t BgL_oz00_2429, obj_t BgL_vz00_2430)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 57 */
{ /* Llib/avahi.scm 57 */
int BgL_vz00_2878;
BgL_vz00_2878 = 
CINT(BgL_vz00_2430); 
return 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_oz00_2429)))->BgL_z42ctypez42)=((int)BgL_vz00_2878),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1829 */
obj_t BGl_z62lambda1829z62zz__avahi_avahiz00(obj_t BgL_envz00_2431, obj_t BgL_oz00_2432)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 57 */
return 
BINT(
(((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_oz00_2432)))->BgL_z42ctypez42));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1817> */
obj_t BGl_z62zc3anonymousza31817ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2433, obj_t BgL_new1074z00_2434)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 54 */
return 
((obj_t)
((BgL_avahizd2objectzd2_bglt)BgL_new1074z00_2434));} 
BGL_FUNCTION_END;
}



/* &lambda1815 */
BgL_avahizd2objectzd2_bglt BGl_z62lambda1815z62zz__avahi_avahiz00(obj_t BgL_envz00_2435)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 54 */
{ /* Llib/avahi.scm 54 */
BgL_avahizd2objectzd2_bglt BgL_new1073z00_2881;
BgL_new1073z00_2881 = 
((BgL_avahizd2objectzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2objectzd2_bgl) ))); 
{ /* Llib/avahi.scm 54 */
long BgL_arg1816z00_2882;
{ /* Llib/avahi.scm 54 */
long BgL_res2335z00_2883;
BgL_res2335z00_2883 = 
BGL_CLASS_INDEX(BGl_avahizd2objectzd2zz__avahi_avahiz00); 
BgL_arg1816z00_2882 = BgL_res2335z00_2883; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1073z00_2881), BgL_arg1816z00_2882); } 
return BgL_new1073z00_2881;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1810> */
obj_t BGl_z62zc3anonymousza31810ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2436, obj_t BgL_new1071z00_2437)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 52 */
{ 
BgL_z62avahizd2collisionzd2errorz62_bglt BgL_auxz00_5139;
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_z62avahizd2collisionzd2errorz62_bglt)BgL_new1071z00_2437))))->BgL_fnamez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_z62avahizd2collisionzd2errorz62_bglt)BgL_new1071z00_2437))))->BgL_locationz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_z62avahizd2collisionzd2errorz62_bglt)BgL_new1071z00_2437))))->BgL_stackz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)
((BgL_z62avahizd2collisionzd2errorz62_bglt)BgL_new1071z00_2437))))->BgL_procz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)
((BgL_z62avahizd2collisionzd2errorz62_bglt)BgL_new1071z00_2437))))->BgL_msgz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)
((BgL_z62avahizd2collisionzd2errorz62_bglt)BgL_new1071z00_2437))))->BgL_objz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(
((BgL_z62avahizd2errorzb0_bglt)
((BgL_z62avahizd2collisionzd2errorz62_bglt)BgL_new1071z00_2437))))->BgL_errnoz00)=((int)
(int)(((long)0))),BUNSPEC); 
BgL_auxz00_5139 = 
((BgL_z62avahizd2collisionzd2errorz62_bglt)BgL_new1071z00_2437); 
return 
((obj_t)BgL_auxz00_5139);} } 
BGL_FUNCTION_END;
}



/* &lambda1808 */
BgL_z62avahizd2collisionzd2errorz62_bglt BGl_z62lambda1808z62zz__avahi_avahiz00(obj_t BgL_envz00_2438)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 52 */
{ /* Llib/avahi.scm 52 */
BgL_z62avahizd2collisionzd2errorz62_bglt BgL_new1070z00_2885;
BgL_new1070z00_2885 = 
((BgL_z62avahizd2collisionzd2errorz62_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2collisionzd2errorz62_bgl) ))); 
{ /* Llib/avahi.scm 52 */
long BgL_arg1809z00_2886;
{ /* Llib/avahi.scm 52 */
long BgL_res2334z00_2887;
BgL_res2334z00_2887 = 
BGL_CLASS_INDEX(BGl_z62avahizd2collisionzd2errorz62zz__avahi_avahiz00); 
BgL_arg1809z00_2886 = BgL_res2334z00_2887; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1070z00_2885), BgL_arg1809z00_2886); } 
return BgL_new1070z00_2885;} } 
BGL_FUNCTION_END;
}



/* &lambda1806 */
BgL_z62avahizd2collisionzd2errorz62_bglt BGl_z62lambda1806z62zz__avahi_avahiz00(obj_t BgL_envz00_2439, obj_t BgL_fname1063z00_2440, obj_t BgL_location1064z00_2441, obj_t BgL_stack1065z00_2442, obj_t BgL_proc1066z00_2443, obj_t BgL_msg1067z00_2444, obj_t BgL_obj1068z00_2445, obj_t BgL_errno1069z00_2446)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 52 */
{ /* Llib/avahi.scm 52 */
int BgL_errno1069z00_2888;
BgL_errno1069z00_2888 = 
CINT(BgL_errno1069z00_2446); 
{ /* Llib/avahi.scm 52 */
BgL_z62avahizd2collisionzd2errorz62_bglt BgL_new1211z00_2889;
{ /* Llib/avahi.scm 52 */
BgL_z62avahizd2collisionzd2errorz62_bglt BgL_new1210z00_2890;
BgL_new1210z00_2890 = 
((BgL_z62avahizd2collisionzd2errorz62_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2collisionzd2errorz62_bgl) ))); 
{ /* Llib/avahi.scm 52 */
long BgL_arg1807z00_2891;
{ /* Llib/avahi.scm 52 */
long BgL_res2333z00_2892;
BgL_res2333z00_2892 = 
BGL_CLASS_INDEX(BGl_z62avahizd2collisionzd2errorz62zz__avahi_avahiz00); 
BgL_arg1807z00_2891 = BgL_res2333z00_2892; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1210z00_2890), BgL_arg1807z00_2891); } 
BgL_new1211z00_2889 = BgL_new1210z00_2890; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1211z00_2889)))->BgL_fnamez00)=((obj_t)BgL_fname1063z00_2440),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1211z00_2889)))->BgL_locationz00)=((obj_t)BgL_location1064z00_2441),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1211z00_2889)))->BgL_stackz00)=((obj_t)BgL_stack1065z00_2442),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1211z00_2889)))->BgL_procz00)=((obj_t)BgL_proc1066z00_2443),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1211z00_2889)))->BgL_msgz00)=((obj_t)BgL_msg1067z00_2444),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1211z00_2889)))->BgL_objz00)=((obj_t)BgL_obj1068z00_2445),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(
((BgL_z62avahizd2errorzb0_bglt)BgL_new1211z00_2889)))->BgL_errnoz00)=((int)BgL_errno1069z00_2888),BUNSPEC); 
return BgL_new1211z00_2889;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1793> */
obj_t BGl_z62zc3anonymousza31793ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2447, obj_t BgL_new1061z00_2448)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 50 */
{ 
BgL_z62avahizd2errorzb0_bglt BgL_auxz00_5187;
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_z62avahizd2errorzb0_bglt)BgL_new1061z00_2448))))->BgL_fnamez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_z62avahizd2errorzb0_bglt)BgL_new1061z00_2448))))->BgL_locationz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_z62avahizd2errorzb0_bglt)BgL_new1061z00_2448))))->BgL_stackz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)
((BgL_z62avahizd2errorzb0_bglt)BgL_new1061z00_2448))))->BgL_procz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)
((BgL_z62avahizd2errorzb0_bglt)BgL_new1061z00_2448))))->BgL_msgz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)
((BgL_z62avahizd2errorzb0_bglt)BgL_new1061z00_2448))))->BgL_objz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(
((BgL_z62avahizd2errorzb0_bglt)BgL_new1061z00_2448)))->BgL_errnoz00)=((int)
(int)(((long)0))),BUNSPEC); 
BgL_auxz00_5187 = 
((BgL_z62avahizd2errorzb0_bglt)BgL_new1061z00_2448); 
return 
((obj_t)BgL_auxz00_5187);} } 
BGL_FUNCTION_END;
}



/* &lambda1791 */
BgL_z62avahizd2errorzb0_bglt BGl_z62lambda1791z62zz__avahi_avahiz00(obj_t BgL_envz00_2449)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 50 */
{ /* Llib/avahi.scm 50 */
BgL_z62avahizd2errorzb0_bglt BgL_new1060z00_2894;
BgL_new1060z00_2894 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 50 */
long BgL_arg1792z00_2895;
{ /* Llib/avahi.scm 50 */
long BgL_res2332z00_2896;
BgL_res2332z00_2896 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BgL_arg1792z00_2895 = BgL_res2332z00_2896; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1060z00_2894), BgL_arg1792z00_2895); } 
return BgL_new1060z00_2894;} } 
BGL_FUNCTION_END;
}



/* &lambda1789 */
BgL_z62avahizd2errorzb0_bglt BGl_z62lambda1789z62zz__avahi_avahiz00(obj_t BgL_envz00_2450, obj_t BgL_fname1052z00_2451, obj_t BgL_location1053z00_2452, obj_t BgL_stack1054z00_2453, obj_t BgL_proc1055z00_2454, obj_t BgL_msg1056z00_2455, obj_t BgL_obj1057z00_2456, obj_t BgL_errno1058z00_2457)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 50 */
{ /* Llib/avahi.scm 50 */
int BgL_errno1058z00_2897;
BgL_errno1058z00_2897 = 
CINT(BgL_errno1058z00_2457); 
{ /* Llib/avahi.scm 50 */
BgL_z62avahizd2errorzb0_bglt BgL_new1209z00_2898;
{ /* Llib/avahi.scm 50 */
BgL_z62avahizd2errorzb0_bglt BgL_new1208z00_2899;
BgL_new1208z00_2899 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 50 */
long BgL_arg1790z00_2900;
{ /* Llib/avahi.scm 50 */
long BgL_res2331z00_2901;
BgL_res2331z00_2901 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BgL_arg1790z00_2900 = BgL_res2331z00_2901; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1208z00_2899), BgL_arg1790z00_2900); } 
BgL_new1209z00_2898 = BgL_new1208z00_2899; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1209z00_2898)))->BgL_fnamez00)=((obj_t)BgL_fname1052z00_2451),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1209z00_2898)))->BgL_locationz00)=((obj_t)BgL_location1053z00_2452),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1209z00_2898)))->BgL_stackz00)=((obj_t)BgL_stack1054z00_2453),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1209z00_2898)))->BgL_procz00)=((obj_t)BgL_proc1055z00_2454),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1209z00_2898)))->BgL_msgz00)=((obj_t)BgL_msg1056z00_2455),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1209z00_2898)))->BgL_objz00)=((obj_t)BgL_obj1057z00_2456),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1209z00_2898))->BgL_errnoz00)=((int)BgL_errno1058z00_2897),BUNSPEC); 
return BgL_new1209z00_2898;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1800> */
obj_t BGl_z62zc3anonymousza31800ze3ze1zz__avahi_avahiz00(obj_t BgL_envz00_2458)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 50 */
return 
BINT(((long)0));} 
BGL_FUNCTION_END;
}



/* &lambda1799 */
obj_t BGl_z62lambda1799z62zz__avahi_avahiz00(obj_t BgL_envz00_2459, obj_t BgL_oz00_2460, obj_t BgL_vz00_2461)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 50 */
{ /* Llib/avahi.scm 50 */
int BgL_vz00_2903;
BgL_vz00_2903 = 
CINT(BgL_vz00_2461); 
return 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(
((BgL_z62avahizd2errorzb0_bglt)BgL_oz00_2460)))->BgL_errnoz00)=((int)BgL_vz00_2903),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1798 */
obj_t BGl_z62lambda1798z62zz__avahi_avahiz00(obj_t BgL_envz00_2462, obj_t BgL_oz00_2463)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 50 */
return 
BINT(
(((BgL_z62avahizd2errorzb0_bglt)COBJECT(
((BgL_z62avahizd2errorzb0_bglt)BgL_oz00_2463)))->BgL_errnoz00));} 
BGL_FUNCTION_END;
}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__avahi_avahiz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 15 */
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_proc2659z00zz__avahi_avahiz00, BGl_avahizd2objectzd2zz__avahi_avahiz00, BGl_string2660z00zz__avahi_avahiz00);} 
BGL_FUNCTION_END;
}



/* &avahi-init1254 */
obj_t BGl_z62avahizd2init1254zb0zz__avahi_avahiz00(obj_t BgL_envz00_2467, obj_t BgL_oz00_2468)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 288 */
return 
((obj_t)
((BgL_avahizd2objectzd2_bglt)BgL_oz00_2468));} 
BGL_FUNCTION_END;
}



/* avahi-init */
BGL_EXPORTED_DEF obj_t BGl_avahizd2initzd2zz__avahi_avahiz00(BgL_avahizd2objectzd2_bglt BgL_oz00_9)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 288 */
{ /* Llib/avahi.scm 288 */
obj_t BgL_method1255z00_1158;
{ /* Llib/avahi.scm 288 */
obj_t BgL_res2364z00_1791;
{ /* Llib/avahi.scm 288 */
long BgL_objzd2classzd2numz00_1748;
{ /* Llib/avahi.scm 288 */
long BgL_res2353z00_1751;
BgL_res2353z00_1751 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_9)); 
BgL_objzd2classzd2numz00_1748 = BgL_res2353z00_1751; } 
{ /* Llib/avahi.scm 288 */
obj_t BgL_arg1742z00_1749;
BgL_arg1742z00_1749 = 
PROCEDURE_REF(BGl_avahizd2initzd2envz00zz__avahi_avahiz00, 
(int)(((long)1))); 
{ /* Llib/avahi.scm 288 */
int BgL_offsetz00_1753;
BgL_offsetz00_1753 = 
(int)(BgL_objzd2classzd2numz00_1748); 
{ /* Llib/avahi.scm 288 */
long BgL_offsetz00_1754;
BgL_offsetz00_1754 = 
(
(long)(BgL_offsetz00_1753)-OBJECT_TYPE); 
{ /* Llib/avahi.scm 288 */
long BgL_modz00_1755;
{ /* Llib/avahi.scm 288 */
int BgL_arg1744z00_1756;
BgL_arg1744z00_1756 = 
(int)(((long)16)); 
{ /* Llib/avahi.scm 288 */
long BgL_res2356z00_1766;
{ /* Llib/avahi.scm 288 */
long BgL_tmpz00_5251;
BgL_tmpz00_5251 = 
(long)(BgL_arg1744z00_1756); 
BgL_res2356z00_1766 = 
(BgL_offsetz00_1754/BgL_tmpz00_5251); } 
BgL_modz00_1755 = BgL_res2356z00_1766; } } 
{ /* Llib/avahi.scm 288 */
long BgL_restz00_1757;
{ /* Llib/avahi.scm 288 */
int BgL_arg1743z00_1758;
BgL_arg1743z00_1758 = 
(int)(((long)16)); 
{ /* Llib/avahi.scm 288 */
long BgL_res2363z00_1786;
{ /* Llib/avahi.scm 288 */
long BgL_n1z00_1768;long BgL_n2z00_1769;
BgL_n1z00_1768 = BgL_offsetz00_1754; 
BgL_n2z00_1769 = 
(long)(BgL_arg1743z00_1758); 
{ /* Llib/avahi.scm 288 */
bool_t BgL_testz00_5256;
{ /* Llib/avahi.scm 288 */
long BgL_arg1283z00_1771;
BgL_arg1283z00_1771 = 
(((BgL_n1z00_1768) | (BgL_n2z00_1769)) & -2147483648); 
BgL_testz00_5256 = 
(BgL_arg1283z00_1771==((long)0)); } 
if(BgL_testz00_5256)
{ /* Llib/avahi.scm 288 */
int32_t BgL_arg1272z00_1772;
{ /* Llib/avahi.scm 288 */
int32_t BgL_arg1278z00_1773;int32_t BgL_arg1279z00_1774;
{ /* Llib/avahi.scm 288 */
int32_t BgL_res2359z00_1778;
BgL_res2359z00_1778 = 
(int32_t)(BgL_n1z00_1768); 
BgL_arg1278z00_1773 = BgL_res2359z00_1778; } 
{ /* Llib/avahi.scm 288 */
int32_t BgL_res2360z00_1780;
BgL_res2360z00_1780 = 
(int32_t)(BgL_n2z00_1769); 
BgL_arg1279z00_1774 = BgL_res2360z00_1780; } 
BgL_arg1272z00_1772 = 
(BgL_arg1278z00_1773%BgL_arg1279z00_1774); } 
{ /* Llib/avahi.scm 288 */
long BgL_res2362z00_1785;
{ /* Llib/avahi.scm 288 */
long BgL_arg1409z00_1782;
BgL_arg1409z00_1782 = 
(long)(BgL_arg1272z00_1772); 
{ /* Llib/avahi.scm 288 */
long BgL_res2361z00_1784;
BgL_res2361z00_1784 = 
(long)(BgL_arg1409z00_1782); 
BgL_res2362z00_1785 = BgL_res2361z00_1784; } } 
BgL_res2363z00_1786 = BgL_res2362z00_1785; } }  else 
{ /* Llib/avahi.scm 288 */
BgL_res2363z00_1786 = 
(BgL_n1z00_1768%BgL_n2z00_1769); } } } 
BgL_restz00_1757 = BgL_res2363z00_1786; } } 
{ /* Llib/avahi.scm 288 */

{ /* Llib/avahi.scm 288 */
obj_t BgL_bucketz00_1759;
BgL_bucketz00_1759 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_1749),BgL_modz00_1755); 
BgL_res2364z00_1791 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_1759),BgL_restz00_1757); } } } } } } } } 
BgL_method1255z00_1158 = BgL_res2364z00_1791; } 
return 
PROCEDURE_ENTRY(BgL_method1255z00_1158)(BgL_method1255z00_1158, 
((obj_t)BgL_oz00_9), BEOA);} } 
BGL_FUNCTION_END;
}



/* &avahi-init */
obj_t BGl_z62avahizd2initzb0zz__avahi_avahiz00(obj_t BgL_envz00_2464, obj_t BgL_oz00_2465)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 288 */
{ /* Llib/avahi.scm 288 */
BgL_avahizd2objectzd2_bglt BgL_auxz00_5274;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_2465, BGl_avahizd2objectzd2zz__avahi_avahiz00))
{ /* Llib/avahi.scm 288 */
BgL_auxz00_5274 = 
((BgL_avahizd2objectzd2_bglt)BgL_oz00_2465)
; }  else 
{ 
obj_t BgL_auxz00_5278;
BgL_auxz00_5278 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2447z00zz__avahi_avahiz00, 
BINT(((long)11745)), BGl_string2661z00zz__avahi_avahiz00, BGl_string2662z00zz__avahi_avahiz00, BgL_oz00_2465); 
FAILURE(BgL_auxz00_5278,BFALSE,BFALSE);} 
return 
BGl_avahizd2initzd2zz__avahi_avahiz00(BgL_auxz00_5274);} } 
BGL_FUNCTION_END;
}



/* method-init */
obj_t BGl_methodzd2initzd2zz__avahi_avahiz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_avahizd2simplezd2pollz00zz__avahi_avahiz00, BGl_proc2663z00zz__avahi_avahiz00, BGl_string2664z00zz__avahi_avahiz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00, BGl_proc2665z00zz__avahi_avahiz00, BGl_string2664z00zz__avahi_avahiz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_avahizd2clientzd2zz__avahi_avahiz00, BGl_proc2666z00zz__avahi_avahiz00, BGl_string2664z00zz__avahi_avahiz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_avahizd2entryzd2groupz00zz__avahi_avahiz00, BGl_proc2667z00zz__avahi_avahiz00, BGl_string2664z00zz__avahi_avahiz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_avahizd2servicezd2browserz00zz__avahi_avahiz00, BGl_proc2668z00zz__avahi_avahiz00, BGl_string2664z00zz__avahi_avahiz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_avahizd2servicezd2typezd2browserzd2zz__avahi_avahiz00, BGl_proc2669z00zz__avahi_avahiz00, BGl_string2664z00zz__avahi_avahiz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_avahizd2domainzd2browserz00zz__avahi_avahiz00, BGl_proc2670z00zz__avahi_avahiz00, BGl_string2664z00zz__avahi_avahiz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_avahizd2servicezd2resolverz00zz__avahi_avahiz00, BGl_proc2671z00zz__avahi_avahiz00, BGl_string2664z00zz__avahi_avahiz00);} 
BGL_FUNCTION_END;
}



/* &avahi-init-avahi-ser1272 */
obj_t BGl_z62avahizd2initzd2avahizd2ser1272zb0zz__avahi_avahiz00(obj_t BgL_envz00_2477, obj_t BgL_oz00_2478)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 661 */
if(
PROCEDURE_CORRECT_ARITYP(
(((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2478)))->BgL_procz00), 
(int)(((long)12))))
{ /* Llib/avahi.scm 663 */
{ /* Llib/avahi.scm 665 */
BgL_avahizd2clientzd2_bglt BgL_i1189z00_2907;
BgL_i1189z00_2907 = 
(((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2478)))->BgL_clientz00); 
{ 
obj_t BgL_auxz00_5298;
{ /* Llib/avahi.scm 666 */
obj_t BgL_arg2237z00_2908;
BgL_arg2237z00_2908 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1189z00_2907))->BgL_resolversz00); 
BgL_auxz00_5298 = 
MAKE_YOUNG_PAIR(
((obj_t)
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2478)), BgL_arg2237z00_2908); } 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1189z00_2907))->BgL_resolversz00)=((obj_t)BgL_auxz00_5298),BUNSPEC); } } 
{ /* Llib/avahi.scm 667 */
BgL_avahizd2servicezd2resolverz00_bglt BgL_tmpz00_5304;
BgL_tmpz00_5304 = 
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2478); 
bgl_avahi_service_resolver_new(BgL_tmpz00_5304); } 
return BUNSPEC;}  else 
{ /* Llib/avahi.scm 668 */
obj_t BgL_arg2238z00_2909;
BgL_arg2238z00_2909 = 
(((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2478)))->BgL_procz00); 
{ /* Llib/avahi.scm 668 */
char * BgL_procz00_2910;char * BgL_msgz00_2911;
BgL_procz00_2910 = 
BSTRING_TO_STRING(BGl_string2490z00zz__avahi_avahiz00); 
BgL_msgz00_2911 = 
BSTRING_TO_STRING(BGl_string2456z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1290z00_2912;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1141z00_2913;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1140z00_2914;
BgL_new1140z00_2914 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 214 */
long BgL_arg1318z00_2915;
{ /* Llib/avahi.scm 214 */
long BgL_res2243z00_2916;
BgL_res2243z00_2916 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BgL_arg1318z00_2915 = BgL_res2243z00_2916; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1140z00_2914), BgL_arg1318z00_2915); } 
BgL_new1141z00_2913 = BgL_new1140z00_2914; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_2913)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_2913)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_5319;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1302z00_2917;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1317z00_2918;
{ /* Llib/avahi.scm 214 */
obj_t BgL_res2244z00_2919;
{ /* Llib/avahi.scm 214 */
obj_t BgL_classz00_2920;
BgL_classz00_2920 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_res2244z00_2919 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_2920); } 
BgL_arg1317z00_2918 = BgL_res2244z00_2919; } 
BgL_arg1302z00_2917 = 
VECTOR_REF(BgL_arg1317z00_2918,((long)2)); } 
BgL_auxz00_5319 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1302z00_2917); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_2913)))->BgL_stackz00)=((obj_t)BgL_auxz00_5319),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_2913)))->BgL_procz00)=((obj_t)
string_to_bstring(BgL_procz00_2910)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_2913)))->BgL_msgz00)=((obj_t)
string_to_bstring(BgL_msgz00_2911)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_2913)))->BgL_objz00)=((obj_t)BgL_arg2238z00_2909),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1141z00_2913))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1290z00_2912 = BgL_new1141z00_2913; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1290z00_2912));} } } } 
BGL_FUNCTION_END;
}



/* &avahi-init-avahi-dom1270 */
obj_t BGl_z62avahizd2initzd2avahizd2dom1270zb0zz__avahi_avahiz00(obj_t BgL_envz00_2479, obj_t BgL_oz00_2480)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 641 */
if(
PROCEDURE_CORRECT_ARITYP(
(((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2480)))->BgL_procz00), 
(int)(((long)5))))
{ /* Llib/avahi.scm 643 */
BGL_MUTEX_LOCK(BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 251 */
obj_t BgL_tmp2950z00_5341;
BgL_tmp2950z00_5341 = ( 
BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00 = 
MAKE_YOUNG_PAIR(
((obj_t)
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2480)), BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00), BUNSPEC) ; 
BGL_MUTEX_UNLOCK(BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); BgL_tmp2950z00_5341; } 
{ /* Llib/avahi.scm 646 */
obj_t BgL_arg2231z00_2922;
BgL_arg2231z00_2922 = 
BGl_avahizd2symbolzd2ze3domainzd2browserzd2typeze3zz__avahi_avahiz00(
(((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2480)))->BgL_btypez00)); 
{ /* Llib/avahi.scm 646 */
AvahiDomainBrowserType BgL_auxz00_5352;BgL_avahizd2domainzd2browserz00_bglt BgL_tmpz00_5350;
BgL_auxz00_5352 = 
(long)CINT(BgL_arg2231z00_2922); 
BgL_tmpz00_5350 = 
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2480); 
bgl_avahi_domain_browser_new(BgL_tmpz00_5350, BgL_auxz00_5352); } 
return BUNSPEC;} }  else 
{ /* Llib/avahi.scm 647 */
obj_t BgL_arg2233z00_2923;
BgL_arg2233z00_2923 = 
(((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2480)))->BgL_procz00); 
{ /* Llib/avahi.scm 647 */
char * BgL_procz00_2924;char * BgL_msgz00_2925;
BgL_procz00_2924 = 
BSTRING_TO_STRING(BGl_string2488z00zz__avahi_avahiz00); 
BgL_msgz00_2925 = 
BSTRING_TO_STRING(BGl_string2456z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1290z00_2926;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1141z00_2927;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1140z00_2928;
BgL_new1140z00_2928 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 214 */
long BgL_arg1318z00_2929;
{ /* Llib/avahi.scm 214 */
long BgL_res2243z00_2930;
BgL_res2243z00_2930 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BgL_arg1318z00_2929 = BgL_res2243z00_2930; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1140z00_2928), BgL_arg1318z00_2929); } 
BgL_new1141z00_2927 = BgL_new1140z00_2928; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_2927)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_2927)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_5367;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1302z00_2931;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1317z00_2932;
{ /* Llib/avahi.scm 214 */
obj_t BgL_res2244z00_2933;
{ /* Llib/avahi.scm 214 */
obj_t BgL_classz00_2934;
BgL_classz00_2934 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_res2244z00_2933 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_2934); } 
BgL_arg1317z00_2932 = BgL_res2244z00_2933; } 
BgL_arg1302z00_2931 = 
VECTOR_REF(BgL_arg1317z00_2932,((long)2)); } 
BgL_auxz00_5367 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1302z00_2931); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_2927)))->BgL_stackz00)=((obj_t)BgL_auxz00_5367),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_2927)))->BgL_procz00)=((obj_t)
string_to_bstring(BgL_procz00_2924)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_2927)))->BgL_msgz00)=((obj_t)
string_to_bstring(BgL_msgz00_2925)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_2927)))->BgL_objz00)=((obj_t)BgL_arg2233z00_2923),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1141z00_2927))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1290z00_2926 = BgL_new1141z00_2927; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1290z00_2926));} } } } 
BGL_FUNCTION_END;
}



/* &avahi-init-avahi-ser1268 */
obj_t BGl_z62avahizd2initzd2avahizd2ser1268zb0zz__avahi_avahiz00(obj_t BgL_envz00_2481, obj_t BgL_oz00_2482)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 621 */
if(
PROCEDURE_CORRECT_ARITYP(
(((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_oz00_2482)))->BgL_procz00), 
(int)(((long)7))))
{ /* Llib/avahi.scm 623 */
BGL_MUTEX_LOCK(BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 251 */
obj_t BgL_tmp2951z00_5389;
BgL_tmp2951z00_5389 = ( 
BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00 = 
MAKE_YOUNG_PAIR(
((obj_t)
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_oz00_2482)), BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00), BUNSPEC) ; 
BGL_MUTEX_UNLOCK(BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); BgL_tmp2951z00_5389; } 
{ /* Llib/avahi.scm 626 */
BgL_avahizd2servicezd2typezd2browserzd2_bglt BgL_tmpz00_5395;
BgL_tmpz00_5395 = 
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_oz00_2482); 
bgl_avahi_service_type_browser_new(BgL_tmpz00_5395); } 
return BUNSPEC;}  else 
{ /* Llib/avahi.scm 627 */
obj_t BgL_arg2227z00_2936;
BgL_arg2227z00_2936 = 
(((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_oz00_2482)))->BgL_procz00); 
{ /* Llib/avahi.scm 627 */
char * BgL_procz00_2937;char * BgL_msgz00_2938;
BgL_procz00_2937 = 
BSTRING_TO_STRING(BGl_string2672z00zz__avahi_avahiz00); 
BgL_msgz00_2938 = 
BSTRING_TO_STRING(BGl_string2456z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1290z00_2939;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1141z00_2940;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1140z00_2941;
BgL_new1140z00_2941 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 214 */
long BgL_arg1318z00_2942;
{ /* Llib/avahi.scm 214 */
long BgL_res2243z00_2943;
BgL_res2243z00_2943 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BgL_arg1318z00_2942 = BgL_res2243z00_2943; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1140z00_2941), BgL_arg1318z00_2942); } 
BgL_new1141z00_2940 = BgL_new1140z00_2941; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_2940)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_2940)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_5410;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1302z00_2944;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1317z00_2945;
{ /* Llib/avahi.scm 214 */
obj_t BgL_res2244z00_2946;
{ /* Llib/avahi.scm 214 */
obj_t BgL_classz00_2947;
BgL_classz00_2947 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_res2244z00_2946 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_2947); } 
BgL_arg1317z00_2945 = BgL_res2244z00_2946; } 
BgL_arg1302z00_2944 = 
VECTOR_REF(BgL_arg1317z00_2945,((long)2)); } 
BgL_auxz00_5410 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1302z00_2944); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_2940)))->BgL_stackz00)=((obj_t)BgL_auxz00_5410),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_2940)))->BgL_procz00)=((obj_t)
string_to_bstring(BgL_procz00_2937)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_2940)))->BgL_msgz00)=((obj_t)
string_to_bstring(BgL_msgz00_2938)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_2940)))->BgL_objz00)=((obj_t)BgL_arg2227z00_2936),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1141z00_2940))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1290z00_2939 = BgL_new1141z00_2940; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1290z00_2939));} } } } 
BGL_FUNCTION_END;
}



/* &avahi-init-avahi-ser1266 */
obj_t BGl_z62avahizd2initzd2avahizd2ser1266zb0zz__avahi_avahiz00(obj_t BgL_envz00_2483, obj_t BgL_oz00_2484)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 598 */
if(
PROCEDURE_CORRECT_ARITYP(
(((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2484)))->BgL_procz00), 
(int)(((long)8))))
{ /* Llib/avahi.scm 600 */
{ /* Llib/avahi.scm 602 */
BgL_avahizd2clientzd2_bglt BgL_i1183z00_2949;
BgL_i1183z00_2949 = 
(((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2484)))->BgL_clientz00); 
{ 
obj_t BgL_auxz00_5434;
{ /* Llib/avahi.scm 603 */
obj_t BgL_arg2222z00_2950;
BgL_arg2222z00_2950 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1183z00_2949))->BgL_z52browsersz52); 
BgL_auxz00_5434 = 
MAKE_YOUNG_PAIR(
((obj_t)
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2484)), BgL_arg2222z00_2950); } 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1183z00_2949))->BgL_z52browsersz52)=((obj_t)BgL_auxz00_5434),BUNSPEC); } } 
{ /* Llib/avahi.scm 604 */
BgL_avahizd2servicezd2browserz00_bglt BgL_tmpz00_5440;
BgL_tmpz00_5440 = 
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2484); 
bgl_avahi_service_browser_new(BgL_tmpz00_5440); } 
return BUNSPEC;}  else 
{ /* Llib/avahi.scm 605 */
obj_t BgL_arg2223z00_2951;
BgL_arg2223z00_2951 = 
(((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2484)))->BgL_procz00); 
{ /* Llib/avahi.scm 605 */
char * BgL_procz00_2952;char * BgL_msgz00_2953;
BgL_procz00_2952 = 
BSTRING_TO_STRING(BGl_string2486z00zz__avahi_avahiz00); 
BgL_msgz00_2953 = 
BSTRING_TO_STRING(BGl_string2456z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1290z00_2954;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1141z00_2955;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1140z00_2956;
BgL_new1140z00_2956 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 214 */
long BgL_arg1318z00_2957;
{ /* Llib/avahi.scm 214 */
long BgL_res2243z00_2958;
BgL_res2243z00_2958 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BgL_arg1318z00_2957 = BgL_res2243z00_2958; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1140z00_2956), BgL_arg1318z00_2957); } 
BgL_new1141z00_2955 = BgL_new1140z00_2956; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_2955)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_2955)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_5455;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1302z00_2959;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1317z00_2960;
{ /* Llib/avahi.scm 214 */
obj_t BgL_res2244z00_2961;
{ /* Llib/avahi.scm 214 */
obj_t BgL_classz00_2962;
BgL_classz00_2962 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_res2244z00_2961 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_2962); } 
BgL_arg1317z00_2960 = BgL_res2244z00_2961; } 
BgL_arg1302z00_2959 = 
VECTOR_REF(BgL_arg1317z00_2960,((long)2)); } 
BgL_auxz00_5455 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1302z00_2959); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_2955)))->BgL_stackz00)=((obj_t)BgL_auxz00_5455),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_2955)))->BgL_procz00)=((obj_t)
string_to_bstring(BgL_procz00_2952)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_2955)))->BgL_msgz00)=((obj_t)
string_to_bstring(BgL_msgz00_2953)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_2955)))->BgL_objz00)=((obj_t)BgL_arg2223z00_2951),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1141z00_2955))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1290z00_2954 = BgL_new1141z00_2955; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1290z00_2954));} } } } 
BGL_FUNCTION_END;
}



/* &avahi-init-avahi-ent1263 */
obj_t BGl_z62avahizd2initzd2avahizd2ent1263zb0zz__avahi_avahiz00(obj_t BgL_envz00_2485, obj_t BgL_oz00_2486)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 450 */
if(
PROCEDURE_CORRECT_ARITYP(
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_2486)))->BgL_procz00), 
(int)(((long)2))))
{ /* Llib/avahi.scm 452 */
{ /* Llib/avahi.scm 454 */
BgL_avahizd2clientzd2_bglt BgL_i1158z00_2964;
BgL_i1158z00_2964 = 
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_2486)))->BgL_clientz00); 
{ 
obj_t BgL_auxz00_5479;
{ /* Llib/avahi.scm 455 */
obj_t BgL_arg2217z00_2965;
BgL_arg2217z00_2965 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1158z00_2964))->BgL_z52groupsz52); 
BgL_auxz00_5479 = 
MAKE_YOUNG_PAIR(
((obj_t)
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_2486)), BgL_arg2217z00_2965); } 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1158z00_2964))->BgL_z52groupsz52)=((obj_t)BgL_auxz00_5479),BUNSPEC); } } 
{ /* Llib/avahi.scm 456 */
BgL_avahizd2entryzd2groupz00_bglt BgL_tmpz00_5485;
BgL_tmpz00_5485 = 
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_2486); 
bgl_avahi_entry_group_new(BgL_tmpz00_5485); } 
return BUNSPEC;}  else 
{ /* Llib/avahi.scm 457 */
obj_t BgL_arg2218z00_2966;
BgL_arg2218z00_2966 = 
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_2486)))->BgL_procz00); 
{ /* Llib/avahi.scm 457 */
char * BgL_procz00_2967;char * BgL_msgz00_2968;
BgL_procz00_2967 = 
BSTRING_TO_STRING(BGl_string2475z00zz__avahi_avahiz00); 
BgL_msgz00_2968 = 
BSTRING_TO_STRING(BGl_string2456z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1290z00_2969;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1141z00_2970;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1140z00_2971;
BgL_new1140z00_2971 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 214 */
long BgL_arg1318z00_2972;
{ /* Llib/avahi.scm 214 */
long BgL_res2243z00_2973;
BgL_res2243z00_2973 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BgL_arg1318z00_2972 = BgL_res2243z00_2973; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1140z00_2971), BgL_arg1318z00_2972); } 
BgL_new1141z00_2970 = BgL_new1140z00_2971; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_2970)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_2970)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_5500;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1302z00_2974;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1317z00_2975;
{ /* Llib/avahi.scm 214 */
obj_t BgL_res2244z00_2976;
{ /* Llib/avahi.scm 214 */
obj_t BgL_classz00_2977;
BgL_classz00_2977 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_res2244z00_2976 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_2977); } 
BgL_arg1317z00_2975 = BgL_res2244z00_2976; } 
BgL_arg1302z00_2974 = 
VECTOR_REF(BgL_arg1317z00_2975,((long)2)); } 
BgL_auxz00_5500 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1302z00_2974); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_2970)))->BgL_stackz00)=((obj_t)BgL_auxz00_5500),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_2970)))->BgL_procz00)=((obj_t)
string_to_bstring(BgL_procz00_2967)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_2970)))->BgL_msgz00)=((obj_t)
string_to_bstring(BgL_msgz00_2968)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_2970)))->BgL_objz00)=((obj_t)BgL_arg2218z00_2966),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1141z00_2970))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1290z00_2969 = BgL_new1141z00_2970; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1290z00_2969));} } } } 
BGL_FUNCTION_END;
}



/* &avahi-init-avahi-cli1261 */
obj_t BGl_z62avahizd2initzd2avahizd2cli1261zb0zz__avahi_avahiz00(obj_t BgL_envz00_2487, obj_t BgL_oz00_2488)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 401 */
if(
PROCEDURE_CORRECT_ARITYP(
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2488)))->BgL_procz00), 
(int)(((long)2))))
{ /* Llib/avahi.scm 403 */
BGL_MUTEX_LOCK(BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 251 */
obj_t BgL_tmp2952z00_5522;
BgL_tmp2952z00_5522 = ( 
BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00 = 
MAKE_YOUNG_PAIR(
((obj_t)
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2488)), BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00), BUNSPEC) ; 
BGL_MUTEX_UNLOCK(BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); BgL_tmp2952z00_5522; } 
{ /* Llib/avahi.scm 406 */
BgL_avahizd2clientzd2_bglt BgL_tmpz00_5528;
BgL_tmpz00_5528 = 
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2488); 
bgl_avahi_client_new(BgL_tmpz00_5528); } 
return BUNSPEC;}  else 
{ /* Llib/avahi.scm 407 */
obj_t BgL_arg2213z00_2979;
BgL_arg2213z00_2979 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2488)))->BgL_procz00); 
{ /* Llib/avahi.scm 407 */
char * BgL_procz00_2980;char * BgL_msgz00_2981;
BgL_procz00_2980 = 
BSTRING_TO_STRING(BGl_string2673z00zz__avahi_avahiz00); 
BgL_msgz00_2981 = 
BSTRING_TO_STRING(BGl_string2456z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1290z00_2982;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1141z00_2983;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1140z00_2984;
BgL_new1140z00_2984 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 214 */
long BgL_arg1318z00_2985;
{ /* Llib/avahi.scm 214 */
long BgL_res2243z00_2986;
BgL_res2243z00_2986 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BgL_arg1318z00_2985 = BgL_res2243z00_2986; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1140z00_2984), BgL_arg1318z00_2985); } 
BgL_new1141z00_2983 = BgL_new1140z00_2984; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_2983)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_2983)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_5543;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1302z00_2987;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1317z00_2988;
{ /* Llib/avahi.scm 214 */
obj_t BgL_res2244z00_2989;
{ /* Llib/avahi.scm 214 */
obj_t BgL_classz00_2990;
BgL_classz00_2990 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_res2244z00_2989 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_2990); } 
BgL_arg1317z00_2988 = BgL_res2244z00_2989; } 
BgL_arg1302z00_2987 = 
VECTOR_REF(BgL_arg1317z00_2988,((long)2)); } 
BgL_auxz00_5543 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1302z00_2987); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1141z00_2983)))->BgL_stackz00)=((obj_t)BgL_auxz00_5543),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_2983)))->BgL_procz00)=((obj_t)
string_to_bstring(BgL_procz00_2980)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_2983)))->BgL_msgz00)=((obj_t)
string_to_bstring(BgL_msgz00_2981)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1141z00_2983)))->BgL_objz00)=((obj_t)BgL_arg2213z00_2979),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1141z00_2983))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1290z00_2982 = BgL_new1141z00_2983; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1290z00_2982));} } } } 
BGL_FUNCTION_END;
}



/* &avahi-init-avahi-thr1259 */
obj_t BGl_z62avahizd2initzd2avahizd2thr1259zb0zz__avahi_avahiz00(obj_t BgL_envz00_2489, obj_t BgL_oz00_2490)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 339 */
BGL_MUTEX_LOCK(BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 251 */
obj_t BgL_tmp2953z00_5560;
BgL_tmp2953z00_5560 = ( 
BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00 = 
MAKE_YOUNG_PAIR(
((obj_t)
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_oz00_2490)), BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00), BUNSPEC) ; 
BGL_MUTEX_UNLOCK(BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); BgL_tmp2953z00_5560; } 
{ /* Llib/avahi.scm 341 */
BgL_avahizd2threadedzd2pollz00_bglt BgL_tmpz00_5566;
BgL_tmpz00_5566 = 
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_oz00_2490); 
bgl_avahi_threaded_poll_new(BgL_tmpz00_5566); } BUNSPEC; 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_oz00_2490))))->BgL_z42ctypez42)=((int)
(int)(((long)2))),BUNSPEC); 
BGl_z52avahizd2threadzd2initz12z40zz__avahi_avahiz00(); 
return 
((obj_t)
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_oz00_2490));} 
BGL_FUNCTION_END;
}



/* &avahi-init-avahi-sim1257 */
obj_t BGl_z62avahizd2initzd2avahizd2sim1257zb0zz__avahi_avahiz00(obj_t BgL_envz00_2491, obj_t BgL_oz00_2492)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/avahi.scm 294 */
BGL_MUTEX_LOCK(BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 251 */
obj_t BgL_tmp2954z00_5576;
BgL_tmp2954z00_5576 = ( 
BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00 = 
MAKE_YOUNG_PAIR(
((obj_t)
((BgL_avahizd2simplezd2pollz00_bglt)BgL_oz00_2492)), BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00), BUNSPEC) ; 
BGL_MUTEX_UNLOCK(BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); BgL_tmp2954z00_5576; } 
{ /* Llib/avahi.scm 296 */
BgL_avahizd2simplezd2pollz00_bglt BgL_tmpz00_5582;
BgL_tmpz00_5582 = 
((BgL_avahizd2simplezd2pollz00_bglt)BgL_oz00_2492); 
bgl_avahi_simple_poll_new(BgL_tmpz00_5582); } BUNSPEC; 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)
((BgL_avahizd2simplezd2pollz00_bglt)BgL_oz00_2492))))->BgL_z42ctypez42)=((int)
(int)(((long)1))),BUNSPEC); 
return 
((obj_t)
((BgL_avahizd2simplezd2pollz00_bglt)BgL_oz00_2492));} 
BGL_FUNCTION_END;
}

#ifdef __cplusplus
}
#endif
