/*===========================================================================*/
/*   (Llib/block_ciphers.scm)                                                */
/*   Bigloo (4.3f)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 04 Jul 2019 08:10:18 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo4.3f/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -I Llib -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -unsafe -safee -copt -fPIC -copt -IPosix Llib/block_ciphers.scm -o objs/block_ciphers.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

/* runtime code modification */
#define BGL_SELF_MODIFYING_CODE 0

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_blockzd2cipherzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   long BgL_blockzd2siza7ez75;
   long BgL_preferredzd2keyzd2lengthz00;
   obj_t BgL_encryptz12z12;
   obj_t BgL_decryptz12z12;
   obj_t BgL_keyzd2ze3encryptzd2paramze3;
   obj_t BgL_keyzd2ze3decryptzd2paramze3;
} *BgL_blockzd2cipherzd2_bglt;

typedef struct BgL_cipherzd2statezd2_bgl {
   header_t header;
   obj_t widening;
   long BgL_blockzd2siza7ez75;
   obj_t BgL_cipherz00;
   obj_t BgL_paramz00;
} *BgL_cipherzd2statezd2_bglt;

typedef struct BgL_ecbzd2encryptzd2_bgl {
   header_t header;
   obj_t widening;
   long BgL_blockzd2siza7ez75;
   obj_t BgL_cipherz00;
   obj_t BgL_paramz00;
} *BgL_ecbzd2encryptzd2_bglt;

typedef struct BgL_ecbzd2decryptzd2_bgl {
   header_t header;
   obj_t widening;
   long BgL_blockzd2siza7ez75;
   obj_t BgL_cipherz00;
   obj_t BgL_paramz00;
} *BgL_ecbzd2decryptzd2_bglt;

typedef struct BgL_cbczd2encryptzd2_bgl {
   header_t header;
   obj_t widening;
   long BgL_blockzd2siza7ez75;
   obj_t BgL_cipherz00;
   obj_t BgL_paramz00;
   obj_t BgL_bufferz00;
   obj_t BgL_chainz00;
} *BgL_cbczd2encryptzd2_bglt;

typedef struct BgL_cbczd2decryptzd2_bgl {
   header_t header;
   obj_t widening;
   long BgL_blockzd2siza7ez75;
   obj_t BgL_cipherz00;
   obj_t BgL_paramz00;
   obj_t BgL_bufferz00;
   obj_t BgL_chainz00;
} *BgL_cbczd2decryptzd2_bglt;

typedef struct BgL_pcbczd2encryptzd2_bgl {
   header_t header;
   obj_t widening;
   long BgL_blockzd2siza7ez75;
   obj_t BgL_cipherz00;
   obj_t BgL_paramz00;
   obj_t BgL_bufferz00;
   obj_t BgL_chainz00;
} *BgL_pcbczd2encryptzd2_bglt;

typedef struct BgL_pcbczd2decryptzd2_bgl {
   header_t header;
   obj_t widening;
   long BgL_blockzd2siza7ez75;
   obj_t BgL_cipherz00;
   obj_t BgL_paramz00;
   obj_t BgL_bufferz00;
   obj_t BgL_chainz00;
} *BgL_pcbczd2decryptzd2_bglt;

typedef struct BgL_streamzd2cipherzd2statez00_bgl {
   header_t header;
   obj_t widening;
   long BgL_blockzd2siza7ez75;
   obj_t BgL_cipherz00;
   obj_t BgL_paramz00;
} *BgL_streamzd2cipherzd2statez00_bglt;

typedef struct BgL_cfbzd2encryptzd2_bgl {
   header_t header;
   obj_t widening;
   long BgL_blockzd2siza7ez75;
   obj_t BgL_cipherz00;
   obj_t BgL_paramz00;
   obj_t BgL_chainz00;
} *BgL_cfbzd2encryptzd2_bglt;

typedef struct BgL_cfbzd2decryptzd2_bgl {
   header_t header;
   obj_t widening;
   long BgL_blockzd2siza7ez75;
   obj_t BgL_cipherz00;
   obj_t BgL_paramz00;
   obj_t BgL_bufferz00;
   obj_t BgL_chainz00;
} *BgL_cfbzd2decryptzd2_bglt;

typedef struct BgL_ofbz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_blockzd2siza7ez75;
   obj_t BgL_cipherz00;
   obj_t BgL_paramz00;
   obj_t BgL_chainz00;
} *BgL_ofbz00_bglt;

typedef struct BgL_ctrz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_blockzd2siza7ez75;
   obj_t BgL_cipherz00;
   obj_t BgL_paramz00;
   obj_t BgL_noncez00;
   obj_t BgL_noncezd2strzd2;
   long BgL_blockzd2counterzd2;
   obj_t BgL_noncezd2initz12zc0;
   obj_t BgL_noncezd2updatez12zc0;
} *BgL_ctrz00_bglt;

typedef struct BgL_cipherzd2modezd2statez00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_encryptzf3zf3;
   long BgL_blockzd2siza7ez75;
   struct BgL_cipherzd2statezd2_bgl * BgL_cipherzd2statezd2;
   obj_t BgL_ivzd2actionzd2;
   obj_t BgL_ivz00;
   obj_t BgL_padzf2unpadzf2;
   obj_t BgL_loopzd2bufferzd2;
   long BgL_posz00;
} *BgL_cipherzd2modezd2statez00_bglt;


static obj_t BGl_z62decryptzd2fastzd2stringz62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_PCBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_decryptzd2stringzd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
static obj_t BGl_z62dozd2cipherzd2blockz12zd2PCB1326za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32231ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2blockz12zd2PCB1330za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_search1423ze70ze7zz__cryptozd2blockzd2ciphersz00(long, obj_t, obj_t, long);
static obj_t BGl_CFBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static long BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_cipherzd2modezd2statez00_bglt, obj_t, long, obj_t, obj_t, long, obj_t);
static obj_t BGl__decryptzd2filezd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32413ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__cryptozd2blockzd2ciphersz00();
BGL_EXPORTED_DECL obj_t BGl_decryptzd2sendcharszd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_cfbzd2decryptzd2_bglt BGl_createzd2CFBzd2decryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, long);
BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_Blockzd2Cipherzd2zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
static obj_t BGl_z62dozd2cipherzd2IVzd2initz121305za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_registerzd2cipherz12zc0zz__cryptozd2blockzd2ciphersz00(obj_t, BgL_blockzd2cipherzd2_bglt);
static obj_t BGl_z62dozd2cipherzd2IVzd2initz12za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_search1434ze70ze7zz__cryptozd2blockzd2ciphersz00(long, obj_t, obj_t, long);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_decryptzd2filezd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__cryptozd2blockzd2ciphersz00();
BGL_EXPORTED_DECL obj_t BGl_encryptz00zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62encryptzd2fastzd2stringz62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32256ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static long BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_cipherzd2modezd2statez00_bglt, obj_t, long, obj_t, obj_t, long, obj_t);
BGL_IMPORT obj_t make_string(long, unsigned char);
static BgL_blockzd2cipherzd2_bglt BGl_z62blockzd2cipherzd2descriptionz62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32363ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_search1445ze70ze7zz__cryptozd2blockzd2ciphersz00(long, obj_t, obj_t, long);
static obj_t BGl_search1390ze70ze7zz__cryptozd2blockzd2ciphersz00(long, obj_t, obj_t, long);
static BgL_ctrz00_bglt BGl_createzd2CTRzd2statez00zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, long);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32470ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_z62zc3anonymousza32276ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62encryptzd2fastzd2portz62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_cbczd2decryptzd2_bglt BGl_createzd2CBCzd2decryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, long);
static obj_t BGl_z62encryptzd2fastzd2mmapz62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_writezd2lastzd2decryptedz12ze70zf5zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, BgL_cipherzd2modezd2statez00_bglt, long, obj_t, long);
static obj_t BGl_z62zc3anonymousza32189ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2blockz12zd2CBC1318za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_search1456ze70ze7zz__cryptozd2blockzd2ciphersz00(long, obj_t, obj_t, long);
static obj_t BGl_z62dozd2cipherzd2blockz12zd2CBC1322za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_encryptzd2fastzd2stringz00zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32296ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl__encryptzd2stringzd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62readzd2stringzd2atz12z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, long, obj_t, long, long);
static obj_t BGl_z62lambda2300z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2301z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2305z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2306z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static BgL_cfbzd2encryptzd2_bglt BGl_createzd2CFBzd2encryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, long);
static obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2O1344z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static BgL_pcbczd2encryptzd2_bglt BGl_z62lambda2312z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_CBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
static BgL_pcbczd2encryptzd2_bglt BGl_z62lambda2314z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_dozd2cipherzd2IVzd2initz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_cipherzd2statezd2_bglt, obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2320z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2321z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__cryptozd2blockzd2ciphersz00();
static obj_t BGl_z62lambda2325z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2326z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2P1324z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32477ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2P1328z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
BGL_IMPORT long bgl_rgc_blit_string(obj_t, char *, long, long);
static BgL_pcbczd2decryptzd2_bglt BGl_z62lambda2332z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_pcbczd2decryptzd2_bglt BGl_z62lambda2334z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_search1467ze70ze7zz__cryptozd2blockzd2ciphersz00(long, obj_t, obj_t, long);
static obj_t BGl_z62zc3anonymousza32494ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_Cipherzd2Modezd2Statez00zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
static obj_t BGl_CTRz00zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
static obj_t BGl_z62decryptzd2fastzd2portz62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2340z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2341z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_dozd2cipherzd2blockz12z12zz__cryptozd2blockzd2ciphersz00(BgL_cipherzd2statezd2_bglt, obj_t, long, obj_t, long);
static obj_t BGl_z62lambda2345z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static BgL_pcbczd2decryptzd2_bglt BGl_createzd2PCBCzd2decryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, long);
static obj_t BGl_z62lambda2346z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static BgL_blockzd2cipherzd2_bglt BGl_z62lambda2185z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62readzd2portzd2atz12z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, long, obj_t, long, long);
static BgL_blockzd2cipherzd2_bglt BGl_z62lambda2187z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl__decryptz00zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32015ze33299ze1zz__cryptozd2blockzd2ciphersz00(obj_t);
static BgL_streamzd2cipherzd2statez00_bglt BGl_z62lambda2351z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_z62decryptzd2fastzd2mmapz62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2193z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2194z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static BgL_cfbzd2encryptzd2_bglt BGl_z62lambda2359z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2198z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2199z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static BgL_cfbzd2encryptzd2_bglt BGl_z62lambda2361z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_z62lambda2367z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2368z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl__decryptzd2stringzd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2partialzd2bl1309zb0zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
BGL_IMPORT obj_t blit_string(obj_t, long, obj_t, long, long);
static BgL_cfbzd2decryptzd2_bglt BGl_z62lambda2374z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_cfbzd2decryptzd2_bglt BGl_z62lambda2376z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_z62lambda2382z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl__encryptzd2portzd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2383z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_search1478ze70ze7zz__cryptozd2blockzd2ciphersz00(long, obj_t, obj_t, long);
static obj_t BGl_z62lambda2387z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2388z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static BgL_cbczd2encryptzd2_bglt BGl_createzd2CBCzd2encryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, long);
static BgL_ofbz00_bglt BGl_z62lambda2394z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_ofbz00_bglt BGl_z62lambda2396z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl__encryptzd2mmapzd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2partialzd2bl1336zb0zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_dozd2cipherzd2partialzd2blockz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_cipherzd2statezd2_bglt, obj_t, long, obj_t, long, long, long);
static obj_t BGl_z62dozd2cipherzd2blockz12zd2ECB1312za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2blockz12zd2ECB1314za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2partialzd2bl1342zb0zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2partialzd2bl1348zb0zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_za2ciphersza2z00zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
static obj_t BGl_z62dozd2cipherzd2partialzd2bl1354zb0zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_encryptzd2portzd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_Streamzd2Cipherzd2Statez00zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
static obj_t BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
static obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2C1316z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
static obj_t BGl_OFBz00zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
extern obj_t BGl_stringzd2ze3keyzd2hashze3zz__cryptozd2string2keyzd2(obj_t, long, obj_t);
BGL_EXPORTED_DECL obj_t BGl_encryptzd2mmapzd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2C1320z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2C1332z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2C1338z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2blockz12zd2CFB1334za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__cryptozd2blockzd2ciphersz00();
static obj_t BGl_encryptzd2fastzd2mmapz00zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2blockz12zd2CFB1340za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2C1350z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__cryptozd2blockzd2ciphersz00();
static BgL_pcbczd2encryptzd2_bglt BGl_createzd2PCBCzd2encryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, long);
static obj_t BGl_z62writezd2portzd2atz12z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32316ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
static BgL_cipherzd2statezd2_bglt BGl_createzd2ECBzd2statez00zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, long, bool_t);
static obj_t BGl_z62zc3anonymousza32155ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_CBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2blockz121307z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32336ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_ECBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62defaultzd2noncezd2updatez12z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32353ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl__encryptzd2filezd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl__encryptz00zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static BgL_ofbz00_bglt BGl_createzd2OFBzd2statez00zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, long);
static obj_t BGl_z62dozd2cipherzd2blockz12zd2CTR1352za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_PCBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
BGL_IMPORT obj_t bgl_close_input_port(obj_t);
static obj_t BGl_z62dozd2cipherzd2blockz12zd2OFB1346za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32266ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(obj_t);
static obj_t BGl_z62registerzd2cipherz12za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_close_output_port(obj_t);
BGL_EXPORTED_DECL obj_t BGl_encryptzd2filezd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62defaultzd2noncezd2initz12z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static BgL_cipherzd2modezd2statez00_bglt BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_search1357ze70ze7zz__cryptozd2blockzd2ciphersz00(long, obj_t, obj_t, long);
static obj_t BGl_z62zc3anonymousza32155ze33300ze1zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_CFBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza32448ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62readzd2mmapzd2atz12z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, long, obj_t, long, long);
static obj_t BGl_z62lambda2203z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2204z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2208z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2209z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__cryptozd2blockzd2ciphersz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__cryptozd2string2keyzd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__cryptozd2cipherzd2paddingz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__cryptozd2utilzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__mmapz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
static obj_t BGl_z62lambda2213z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2214z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2218z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2219z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2223z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
extern obj_t BGl_makezd2randomzd2stringz00zz__cryptozd2utilzd2(long, obj_t);
static obj_t BGl_z62lambda2224z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2partialzd2blockz12za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_cipherzd2statezd2_bglt BGl_z62lambda2229z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_z62zc3anonymousza32378ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl__encryptzd2sendcharszd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
BGL_IMPORT bool_t rgc_buffer_eof_p(obj_t);
static obj_t BGl_z62lambda2235z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2236z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_search1368ze70ze7zz__cryptozd2blockzd2ciphersz00(long, obj_t, obj_t, long);
static obj_t BGl_cnstzd2initzd2zz__cryptozd2blockzd2ciphersz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__cryptozd2blockzd2ciphersz00();
static obj_t BGl_importedzd2moduleszd2initz00zz__cryptozd2blockzd2ciphersz00();
static obj_t BGl_z62lambda2240z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2402z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2241z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2403z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2245z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2246z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static BgL_ctrz00_bglt BGl_z62lambda2409z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL BgL_blockzd2cipherzd2_bglt BGl_blockzd2cipherzd2descriptionz00zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl__decryptzd2portzd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static BgL_ctrz00_bglt BGl_z62lambda2411z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static BgL_ecbzd2encryptzd2_bglt BGl_z62lambda2252z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t);
static BgL_ecbzd2encryptzd2_bglt BGl_z62lambda2254z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_z62lambda2417z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2418z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_objectz00zz__objectz00;
BGL_EXPORTED_DECL obj_t BGl_decryptz00zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2422z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2423z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl__decryptzd2mmapzd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static BgL_ecbzd2decryptzd2_bglt BGl_z62lambda2262z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t);
static BgL_ecbzd2decryptzd2_bglt BGl_z62lambda2264z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_z62lambda2427z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2428z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32398ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_search1401ze70ze7zz__cryptozd2blockzd2ciphersz00(long, obj_t, obj_t, long);
static obj_t BGl_z62lambda2432z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2433z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static BgL_cbczd2encryptzd2_bglt BGl_z62lambda2272z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_cbczd2encryptzd2_bglt BGl_z62lambda2274z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_z62lambda2437z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2438z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_encryptzd2stringzd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2280z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2281z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static BgL_cipherzd2modezd2statez00_bglt BGl_z62lambda2444z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_cipherzd2modezd2statez00_bglt BGl_z62lambda2446z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_search1379ze70ze7zz__cryptozd2blockzd2ciphersz00(long, obj_t, obj_t, long);
static obj_t BGl_z62lambda2285z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2286z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_decryptzd2portzd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2452z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2453z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static BgL_cbczd2decryptzd2_bglt BGl_z62lambda2292z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_cbczd2decryptzd2_bglt BGl_z62lambda2294z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_z62lambda2457z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2458z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32015ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_decryptzd2mmapzd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_cipherzd2statezd2_bglt BGl_z62lambda2462z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2463z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2468z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2469z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2475z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2476z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static BgL_cipherzd2modezd2statez00_bglt BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_ECBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
static obj_t BGl__decryptzd2sendcharszd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_search1412ze70ze7zz__cryptozd2blockzd2ciphersz00(long, obj_t, obj_t, long);
BGL_EXPORTED_DECL obj_t BGl_encryptzd2sendcharszd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2481z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2482z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2blockz12z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2486z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2487z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2492z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2493z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t __cnst[ 93 ] ;


extern obj_t BGl_bytezd2unpadzd2envz00zz__cryptozd2cipherzd2paddingz00;
extern obj_t BGl_za7erozd2padzd2envza7zz__cryptozd2cipherzd2paddingz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_encryptzd2fastzd2stringzd2envzd2zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762encryptza7d2fas3937z00, BGl_z62encryptzd2fastzd2stringz62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 9 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_decryptzd2envzd2zz__cryptozd2blockzd2ciphersz00, BgL_bgl__decryptza700za7za7__c3938za7, opt_generic_entry, BGl__decryptz00zz__cryptozd2blockzd2ciphersz00, BFALSE, -1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_decryptzd2fastzd2mmapzd2envzd2zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762decryptza7d2fas3939z00, BGl_z62decryptzd2fastzd2mmapz62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 9 );
extern obj_t BGl_sha1sumzd2binzd2envz00zz__cryptozd2utilzd2;
DEFINE_STATIC_BGL_GENERIC( BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3940za7, BGl_z62dozd2cipherzd2blockz12z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_decryptzd2filezd2envz00zz__cryptozd2blockzd2ciphersz00, BgL_bgl__decryptza7d2fileza73941z00, opt_generic_entry, BGl__decryptzd2filezd2zz__cryptozd2blockzd2ciphersz00, BFALSE, -1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_encryptzd2fastzd2portzd2envzd2zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762encryptza7d2fas3942z00, BGl_z62encryptzd2fastzd2portz62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 9 );
extern obj_t BGl_nozd2unpadzd2envz00zz__cryptozd2cipherzd2paddingz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_decryptzd2portzd2envz00zz__cryptozd2blockzd2ciphersz00, BgL_bgl__decryptza7d2portza73943z00, opt_generic_entry, BGl__decryptzd2portzd2zz__cryptozd2blockzd2ciphersz00, BFALSE, -1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_decryptzd2fastzd2stringzd2envzd2zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762decryptza7d2fas3944z00, BGl_z62decryptzd2fastzd2stringz62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 9 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_encryptzd2sendcharszd2envz00zz__cryptozd2blockzd2ciphersz00, BgL_bgl__encryptza7d2sendc3945za7, opt_generic_entry, BGl__encryptzd2sendcharszd2zz__cryptozd2blockzd2ciphersz00, BFALSE, -1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3906z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3946za7, BGl_z62dozd2cipherzd2blockz12zd2ECB1312za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3908z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3947za7, BGl_z62dozd2cipherzd2blockz12zd2ECB1314za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3909z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3948za7, BGl_z62dozd2cipherzd2IVzd2initz12zd2C1316z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3911z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3949za7, BGl_z62dozd2cipherzd2blockz12zd2CBC1318za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3912z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3950za7, BGl_z62dozd2cipherzd2IVzd2initz12zd2C1320z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3913z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3951za7, BGl_z62dozd2cipherzd2blockz12zd2CBC1322za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3914z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3952za7, BGl_z62dozd2cipherzd2IVzd2initz12zd2P1324z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3915z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3953za7, BGl_z62dozd2cipherzd2blockz12zd2PCB1326za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3916z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3954za7, BGl_z62dozd2cipherzd2IVzd2initz12zd2P1328z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3917z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3955za7, BGl_z62dozd2cipherzd2blockz12zd2PCB1330za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3918z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3956za7, BGl_z62dozd2cipherzd2IVzd2initz12zd2C1332z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3919z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3957za7, BGl_z62dozd2cipherzd2blockz12zd2CFB1334za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3920z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3958za7, BGl_z62dozd2cipherzd2partialzd2bl1336zb0zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3922z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3959za7, BGl_z62dozd2cipherzd2IVzd2initz12zd2C1338z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3923z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3960za7, BGl_z62dozd2cipherzd2blockz12zd2CFB1340za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3924z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3961za7, BGl_z62dozd2cipherzd2partialzd2bl1342zb0zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3925z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3962za7, BGl_z62dozd2cipherzd2IVzd2initz12zd2O1344z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3926z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3963za7, BGl_z62dozd2cipherzd2blockz12zd2OFB1346za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3927z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3964za7, BGl_z62dozd2cipherzd2partialzd2bl1348zb0zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3928z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3965za7, BGl_z62dozd2cipherzd2IVzd2initz12zd2C1350z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3929z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3966za7, BGl_z62dozd2cipherzd2blockz12zd2CTR1352za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
BGL_IMPORT obj_t BGl_blitzd2stringzd2urz12zd2envzc0zz__r4_strings_6_7z00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3930z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3967za7, BGl_z62dozd2cipherzd2partialzd2bl1354zb0zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3781z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2194za7623968z00, BGl_z62lambda2194z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3782z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2193za7623969z00, BGl_z62lambda2193z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_encryptzd2filezd2envz00zz__cryptozd2blockzd2ciphersz00, BgL_bgl__encryptza7d2fileza73970z00, opt_generic_entry, BGl__encryptzd2filezd2zz__cryptozd2blockzd2ciphersz00, BFALSE, -1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3783z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2199za7623971z00, BGl_z62lambda2199z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3784z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2198za7623972z00, BGl_z62lambda2198z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
extern obj_t BGl_isozd210126zd2padzd2envzd2zz__cryptozd2cipherzd2paddingz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3785z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2204za7623973z00, BGl_z62lambda2204z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3786z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2203za7623974z00, BGl_z62lambda2203z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3787z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2209za7623975z00, BGl_z62lambda2209z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3788z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2208za7623976z00, BGl_z62lambda2208z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3789z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2214za7623977z00, BGl_z62lambda2214z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
extern obj_t BGl_za7erozd2unpadzd2envza7zz__cryptozd2cipherzd2paddingz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3790z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2213za7623978z00, BGl_z62lambda2213z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3791z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2219za7623979z00, BGl_z62lambda2219z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3792z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2218za7623980z00, BGl_z62lambda2218z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3793z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2224za7623981z00, BGl_z62lambda2224z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3794z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2223za7623982z00, BGl_z62lambda2223z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3795z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3anonymousza73983za7, BGl_z62zc3anonymousza32189ze3ze1zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3796z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2187za7623984z00, BGl_z62lambda2187z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3797z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2185za7623985z00, BGl_z62lambda2185z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3798z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2236za7623986z00, BGl_z62lambda2236z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3799z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2235za7623987z00, BGl_z62lambda2235z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_BGL_L_PROCEDURE(BGl_readzd2mmapzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762readza7d2mmapza7d3988za7, BGl_z62readzd2mmapzd2atz12z70zz__cryptozd2blockzd2ciphersz00 );
DEFINE_STRING( BGl_string3894z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3894za700za7za7_3989za7, "", 0 );
DEFINE_STRING( BGl_string3896z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3896za700za7za7_3990za7, "do-cipher-IV-init!1305", 22 );
DEFINE_STRING( BGl_string3898z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3898za700za7za7_3991za7, "do-cipher-block!1307", 20 );
DEFINE_STATIC_BGL_GENERIC( BGl_dozd2cipherzd2IVzd2initz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3992za7, BGl_z62dozd2cipherzd2IVzd2initz12za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_encryptzd2portzd2envz00zz__cryptozd2blockzd2ciphersz00, BgL_bgl__encryptza7d2portza73993z00, opt_generic_entry, BGl__encryptzd2portzd2zz__cryptozd2blockzd2ciphersz00, BFALSE, -1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_decryptzd2stringzd2envz00zz__cryptozd2blockzd2ciphersz00, BgL_bgl__decryptza7d2strin3994za7, opt_generic_entry, BGl__decryptzd2stringzd2zz__cryptozd2blockzd2ciphersz00, BFALSE, -1 );
extern obj_t BGl_nozd2padzd2envz00zz__cryptozd2cipherzd2paddingz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_defaultzd2noncezd2updatez12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762defaultza7d2non3995z00, BGl_z62defaultzd2noncezd2updatez12z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 3 );
DEFINE_BGL_L_PROCEDURE(BGl_readzd2stringzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762readza7d2string3996z00, BGl_z62readzd2stringzd2atz12z70zz__cryptozd2blockzd2ciphersz00 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_registerzd2cipherz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762registerza7d2ci3997z00, BGl_z62registerzd2cipherz12za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_encryptzd2fastzd2mmapzd2envzd2zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762encryptza7d2fas3998z00, BGl_z62encryptzd2fastzd2mmapz62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 9 );
extern obj_t BGl_ansizd2xze2923zd2padzd2envz30zz__cryptozd2cipherzd2paddingz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_blockzd2cipherzd2descriptionzd2envzd2zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762blockza7d2ciphe3999z00, BGl_z62blockzd2cipherzd2descriptionz62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
extern obj_t BGl_bitzd2unpadzd2envz00zz__cryptozd2cipherzd2paddingz00;
DEFINE_BGL_L_PROCEDURE(BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762readza7d2portza7d4000za7, BGl_z62readzd2portzd2atz12z70zz__cryptozd2blockzd2ciphersz00 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_decryptzd2mmapzd2envz00zz__cryptozd2blockzd2ciphersz00, BgL_bgl__decryptza7d2mmapza74001z00, opt_generic_entry, BGl__decryptzd2mmapzd2zz__cryptozd2blockzd2ciphersz00, BFALSE, -1 );
BGL_IMPORT obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762writeza7d2portza74002za7, BGl_z62writezd2portzd2atz12z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_decryptzd2fastzd2portzd2envzd2zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762decryptza7d2fas4003z00, BGl_z62decryptzd2fastzd2portz62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 9 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3800z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2241za7624004z00, BGl_z62lambda2241z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3801z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2240za7624005z00, BGl_z62lambda2240z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3802z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2246za7624006z00, BGl_z62lambda2246z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3803z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2245za7624007z00, BGl_z62lambda2245z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3804z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3anonymousza74008za7, BGl_z62zc3anonymousza32231ze3ze1zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3805z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2229za7624009z00, BGl_z62lambda2229z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3806z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3anonymousza74010za7, BGl_z62zc3anonymousza32256ze3ze1zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3807z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2254za7624011z00, BGl_z62lambda2254z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3808z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2252za7624012z00, BGl_z62lambda2252z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3809z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3anonymousza74013za7, BGl_z62zc3anonymousza32266ze3ze1zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3739za700za7za7_4014za7, "/builddir/build/BUILD/bigloo4.3f/api/crypto/src/Llib/block_ciphers.scm", 70 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3810z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2264za7624015z00, BGl_z62lambda2264z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3811z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2262za7624016z00, BGl_z62lambda2262z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3812z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2281za7624017z00, BGl_z62lambda2281z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3900z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3900za700za7za7_4018za7, "do-cipher-partial-bl1309", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3813z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2280za7624019z00, BGl_z62lambda2280z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3901z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3901za700za7za7_4020za7, "Internal Error: Could not find method for state", 47 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3814z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2286za7624021z00, BGl_z62lambda2286z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3902z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3902za700za7za7_4022za7, "&do-cipher-IV-init!", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3815z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2285za7624023z00, BGl_z62lambda2285z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3740z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3740za700za7za7_4024za7, "&default-nonce-init!", 20 );
DEFINE_STRING( BGl_string3903z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3903za700za7za7_4025za7, "Cipher-State", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3816z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3anonymousza74026za7, BGl_z62zc3anonymousza32276ze3ze1zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3741za700za7za7_4027za7, "bstring", 7 );
DEFINE_STRING( BGl_string3904z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3904za700za7za7_4028za7, "&do-cipher-block!", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3817z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2274za7624029z00, BGl_z62lambda2274z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3742z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3742za700za7za7_4030za7, "&default-nonce-update!", 22 );
DEFINE_STRING( BGl_string3905z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3905za700za7za7_4031za7, "&do-cipher-partial-block!", 25 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3818z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2272za7624032z00, BGl_z62lambda2272z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string3743z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3743za700za7za7_4033za7, "Internal Error. Unexpected IV-action", 36 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3819z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2301za7624034z00, BGl_z62lambda2301z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3744z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3744za700za7za7_4035za7, "Could not read IV", 17 );
DEFINE_STRING( BGl_string3907z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3907za700za7za7_4036za7, "do-cipher-block!", 16 );
DEFINE_STRING( BGl_string3745z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3745za700za7za7_4037za7, "Message size must be a multiple of block-size", 45 );
DEFINE_STRING( BGl_string3746z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3746za700za7za7_4038za7, "Unknown cipher mode", 19 );
DEFINE_STRING( BGl_string3747z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3747za700za7za7_4039za7, "Invalid padding mode", 20 );
DEFINE_STRING( BGl_string3748z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3748za700za7za7_4040za7, "IV vector is too small", 22 );
DEFINE_STRING( BGl_string3749z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3749za700za7za7_4041za7, "Illegal keyword argument", 24 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_decryptzd2sendcharszd2envz00zz__cryptozd2blockzd2ciphersz00, BgL_bgl__decryptza7d2sendc4042za7, opt_generic_entry, BGl__decryptzd2sendcharszd2zz__cryptozd2blockzd2ciphersz00, BFALSE, -1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3820z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2300za7624043z00, BGl_z62lambda2300z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3821z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2306za7624044z00, BGl_z62lambda2306z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3822z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2305za7624045z00, BGl_z62lambda2305z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3910z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3910za700za7za7_4046za7, "do-cipher-IV-init!", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3823z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3anonymousza74047za7, BGl_z62zc3anonymousza32296ze3ze1zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3824z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2294za7624048z00, BGl_z62lambda2294z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3825z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2292za7624049z00, BGl_z62lambda2292z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string3750z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3750za700za7za7_4050za7, "_encrypt", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3826z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2321za7624051z00, BGl_z62lambda2321z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3751za700za7za7_4052za7, "bint", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3827z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2320za7624053z00, BGl_z62lambda2320z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3752z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3752za700za7za7_4054za7, "symbol", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3828z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2326za7624055z00, BGl_z62lambda2326z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3753z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3753za700za7za7_4056za7, "procedure", 9 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3829z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2325za7624057z00, BGl_z62lambda2325z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3754z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3754za700za7za7_4058za7, "wrong number of arguments: [3..9] expected, provided", 52 );
DEFINE_STRING( BGl_string3755z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3755za700za7za7_4059za7, "_encrypt-string", 15 );
DEFINE_STRING( BGl_string3756z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3756za700za7za7_4060za7, "&encrypt-fast-string", 20 );
DEFINE_STRING( BGl_string3757z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3757za700za7za7_4061za7, "_encrypt-mmap", 13 );
DEFINE_STRING( BGl_string3758z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3758za700za7za7_4062za7, "mmap", 4 );
DEFINE_STRING( BGl_string3759z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3759za700za7za7_4063za7, "&encrypt-fast-mmap", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_defaultzd2noncezd2initz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762defaultza7d2non4064z00, BGl_z62defaultzd2noncezd2initz12z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3830z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3anonymousza74065za7, BGl_z62zc3anonymousza32316ze3ze1zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3831z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2314za7624066z00, BGl_z62lambda2314z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3832z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2312za7624067z00, BGl_z62lambda2312z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3833z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2341za7624068z00, BGl_z62lambda2341z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3921z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3921za700za7za7_4069za7, "do-cipher-partial-block!", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3834z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2340za7624070z00, BGl_z62lambda2340z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3835z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2346za7624071z00, BGl_z62lambda2346z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3760z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3760za700za7za7_4072za7, "_encrypt-port", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3836z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2345za7624073z00, BGl_z62lambda2345z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3761z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3761za700za7za7_4074za7, "input-port", 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3837z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3anonymousza74075za7, BGl_z62zc3anonymousza32336ze3ze1zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3762z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3762za700za7za7_4076za7, "&encrypt-fast-port", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3838z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2334za7624077z00, BGl_z62lambda2334z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3763z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3763za700za7za7_4078za7, "_encrypt-file", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3839z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2332za7624079z00, BGl_z62lambda2332z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string3764z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3764za700za7za7_4080za7, "Could not open file", 19 );
DEFINE_STRING( BGl_string3765z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3765za700za7za7_4081za7, "_encrypt-sendchars", 18 );
DEFINE_STRING( BGl_string3766z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3766za700za7za7_4082za7, "output-port", 11 );
DEFINE_STRING( BGl_string3767z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3767za700za7za7_4083za7, "wrong number of arguments: [4..10] expected, provided", 53 );
DEFINE_STRING( BGl_string3768z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3768za700za7za7_4084za7, "_decrypt", 8 );
DEFINE_STRING( BGl_string3769z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3769za700za7za7_4085za7, "_decrypt-string", 15 );
extern obj_t BGl_bitzd2padzd2envz00zz__cryptozd2cipherzd2paddingz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3840z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3anonymousza74086za7, BGl_z62zc3anonymousza32353ze3ze1zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3841z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2351za7624087z00, BGl_z62lambda2351z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3842z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2368za7624088z00, BGl_z62lambda2368z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3843z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2367za7624089z00, BGl_z62lambda2367z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3931z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3931za700za7za7_4090za7, "__crypto-block-ciphers", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3844z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3anonymousza74091za7, BGl_z62zc3anonymousza32363ze3ze1zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3932z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3932za700za7za7_4092za7, "cipher-IV-init en/decrypt-block en/decrypt-partial-block unspecified _ Cipher-Mode-State pos loop-buffer pad/unpad symbol IV-action cipher-state bool encrypt? CTR nonce-update! nonce-init! block-counter nonce-str nonce OFB CFB-Decrypt CFB-Encrypt Stream-Cipher-State PCBC-Decrypt PCBC-Encrypt CBC-Decrypt CBC-Encrypt chain buffer ECB-Decrypt ECB-Encrypt Cipher-State obj param cipher __crypto-block-ciphers Block-Cipher key->decrypt-param key->encrypt-param decrypt! procedure encrypt! preferred-key-length long block-size bstring name block-cipher-description decrypt-sendchars decrypt-file decrypt-file::bstring decrypt-port::bstring decrypt-mmap::bstring decrypt-string::bstring decrypt::bstring encrypt-sendchars encrypt-file encrypt-file::bstring encrypt-port::bstring encrypt-mmap::bstring encrypt-string::bstring :string->key :pad :nonce-update! :nonce-init! :mode :IV encrypt::bstring (:IV :mode :nonce-init! :nonce-update! :pad :string->key) encryption zero pkcs7 iso-10126 ansi-x.923 bit none encrypt ctr ofb pcbc "
"cbc cfb ecb decrypt decrypt-input! IV read encrypt-input! do-nothing done write init ", 1109 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3845z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2361za7624093z00, BGl_z62lambda2361z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3770z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3770za700za7za7_4094za7, "&decrypt-fast-string", 20 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3846z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2359za7624095z00, BGl_z62lambda2359z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3771z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3771za700za7za7_4096za7, "_decrypt-mmap", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3847z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2383za7624097z00, BGl_z62lambda2383z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3772z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3772za700za7za7_4098za7, "&decrypt-fast-mmap", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3848z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2382za7624099z00, BGl_z62lambda2382z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3773z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3773za700za7za7_4100za7, "_decrypt-port", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3849z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2388za7624101z00, BGl_z62lambda2388z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3774z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3774za700za7za7_4102za7, "&decrypt-fast-port", 18 );
DEFINE_STRING( BGl_string3775z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3775za700za7za7_4103za7, "_decrypt-file", 13 );
DEFINE_STRING( BGl_string3776z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3776za700za7za7_4104za7, "_decrypt-sendchars", 18 );
DEFINE_STRING( BGl_string3777z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3777za700za7za7_4105za7, "&register-cipher!", 17 );
DEFINE_STRING( BGl_string3778z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3778za700za7za7_4106za7, "Block-Cipher", 12 );
DEFINE_STRING( BGl_string3779z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3779za700za7za7_4107za7, "Could not find cipher", 21 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_encryptzd2mmapzd2envz00zz__cryptozd2blockzd2ciphersz00, BgL_bgl__encryptza7d2mmapza74108z00, opt_generic_entry, BGl__encryptzd2mmapzd2zz__cryptozd2blockzd2ciphersz00, BFALSE, -1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3850z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2387za7624109z00, BGl_z62lambda2387z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_GENERIC( BGl_dozd2cipherzd2partialzd2blockz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d4110za7, BGl_z62dozd2cipherzd2partialzd2blockz12za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3851z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3anonymousza74111za7, BGl_z62zc3anonymousza32378ze3ze1zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3852z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2376za7624112z00, BGl_z62lambda2376z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3853z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2374za7624113z00, BGl_z62lambda2374z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3854z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2403za7624114z00, BGl_z62lambda2403z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3855z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2402za7624115z00, BGl_z62lambda2402z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3780z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3780za700za7za7_4116za7, "&block-cipher-description", 25 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3856z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3anonymousza74117za7, BGl_z62zc3anonymousza32398ze3ze1zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3857z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2396za7624118z00, BGl_z62lambda2396z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3858z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2394za7624119z00, BGl_z62lambda2394z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3859z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2418za7624120z00, BGl_z62lambda2418z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3860z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2417za7624121z00, BGl_z62lambda2417z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3861z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2423za7624122z00, BGl_z62lambda2423z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3862z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2422za7624123z00, BGl_z62lambda2422z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3863z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2428za7624124z00, BGl_z62lambda2428z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3864z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2427za7624125z00, BGl_z62lambda2427z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3865z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2433za7624126z00, BGl_z62lambda2433z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3866z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2432za7624127z00, BGl_z62lambda2432z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3867z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2438za7624128z00, BGl_z62lambda2438z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3868z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2437za7624129z00, BGl_z62lambda2437z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3869z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3anonymousza74130za7, BGl_z62zc3anonymousza32413ze3ze1zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3870z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2411za7624131z00, BGl_z62lambda2411z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3871z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2409za7624132z00, BGl_z62lambda2409z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3872z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2453za7624133z00, BGl_z62lambda2453z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3873z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2452za7624134z00, BGl_z62lambda2452z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3874z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2458za7624135z00, BGl_z62lambda2458z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3875z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2457za7624136z00, BGl_z62lambda2457z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3876z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2463za7624137z00, BGl_z62lambda2463z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3877z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2462za7624138z00, BGl_z62lambda2462z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3878z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3anonymousza74139za7, BGl_z62zc3anonymousza32470ze3ze1zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3879z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2469za7624140z00, BGl_z62lambda2469z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
extern obj_t BGl_pkcs7zd2padzd2envz00zz__cryptozd2cipherzd2paddingz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3880z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2468za7624141z00, BGl_z62lambda2468z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3881z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3anonymousza74142za7, BGl_z62zc3anonymousza32477ze3ze1zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3882z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2476za7624143z00, BGl_z62lambda2476z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3883z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2475za7624144z00, BGl_z62lambda2475z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3884z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2482za7624145z00, BGl_z62lambda2482z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3885z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2481za7624146z00, BGl_z62lambda2481z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3886z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2487za7624147z00, BGl_z62lambda2487z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3887z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2486za7624148z00, BGl_z62lambda2486z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3888z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3anonymousza74149za7, BGl_z62zc3anonymousza32494ze3ze1zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3889z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2493za7624150z00, BGl_z62lambda2493z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3890z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2492za7624151z00, BGl_z62lambda2492z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3891z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3anonymousza74152za7, BGl_z62zc3anonymousza32448ze3ze1zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3892z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2446za7624153z00, BGl_z62lambda2446z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3893z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2444za7624154z00, BGl_z62lambda2444z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3895z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d4155za7, BGl_z62dozd2cipherzd2IVzd2initz121305za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3897z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d4156za7, BGl_z62dozd2cipherzd2blockz121307z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3899z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d4157za7, BGl_z62dozd2cipherzd2partialzd2bl1309zb0zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 7 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_encryptzd2stringzd2envz00zz__cryptozd2blockzd2ciphersz00, BgL_bgl__encryptza7d2strin4158za7, opt_generic_entry, BGl__encryptzd2stringzd2zz__cryptozd2blockzd2ciphersz00, BFALSE, -1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_encryptzd2envzd2zz__cryptozd2blockzd2ciphersz00, BgL_bgl__encryptza700za7za7__c4159za7, opt_generic_entry, BGl__encryptz00zz__cryptozd2blockzd2ciphersz00, BFALSE, -1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_PCBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_CFBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_Blockzd2Cipherzd2zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_CBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_Cipherzd2Modezd2Statez00zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_CTRz00zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_za2ciphersza2z00zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_Streamzd2Cipherzd2Statez00zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_OFBz00zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_CBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_ECBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_PCBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_CFBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_ECBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__cryptozd2blockzd2ciphersz00(long BgL_checksumz00_6695, char * BgL_fromz00_6696)
{ BGL_FUNCTION_BEGIN;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__cryptozd2blockzd2ciphersz00))
{ 
BGl_requirezd2initializa7ationz75zz__cryptozd2blockzd2ciphersz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__cryptozd2blockzd2ciphersz00(); 
BGl_libraryzd2moduleszd2initz00zz__cryptozd2blockzd2ciphersz00(); 
BGl_cnstzd2initzd2zz__cryptozd2blockzd2ciphersz00(); 
BGl_importedzd2moduleszd2initz00zz__cryptozd2blockzd2ciphersz00(); 
BGl_objectzd2initzd2zz__cryptozd2blockzd2ciphersz00(); 
BGl_genericzd2initzd2zz__cryptozd2blockzd2ciphersz00(); 
BGl_methodzd2initzd2zz__cryptozd2blockzd2ciphersz00(); 
return 
BGl_toplevelzd2initzd2zz__cryptozd2blockzd2ciphersz00();}  else 
{ 
return BUNSPEC;} } 
BGL_FUNCTION_END;
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__cryptozd2blockzd2ciphersz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 1 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__mmapz00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__crypto-block-ciphers"); 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__cryptozd2blockzd2ciphersz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 1 */
{ /* Llib/block_ciphers.scm 1 */
obj_t BgL_cportz00_6117;
{ /* Llib/block_ciphers.scm 1 */
obj_t BgL_stringz00_6125;
BgL_stringz00_6125 = BGl_string3932z00zz__cryptozd2blockzd2ciphersz00; 
{ /* Llib/block_ciphers.scm 1 */
obj_t BgL_startz00_6126;
BgL_startz00_6126 = 
BINT(((long)0)); 
{ /* Llib/block_ciphers.scm 1 */
obj_t BgL_endz00_6127;
BgL_endz00_6127 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_6125))); 
{ /* Llib/block_ciphers.scm 1 */

BgL_cportz00_6117 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_6125, BgL_startz00_6126, BgL_endz00_6127); } } } } 
{ 
long BgL_iz00_6118;
BgL_iz00_6118 = ((long)92); 
BgL_loopz00_6119:
if(
(BgL_iz00_6118==((long)-1)))
{ /* Llib/block_ciphers.scm 1 */
return BUNSPEC;}  else 
{ /* Llib/block_ciphers.scm 1 */
{ /* Llib/block_ciphers.scm 1 */
obj_t BgL_arg3934z00_6121;
{ /* Llib/block_ciphers.scm 1 */

{ /* Llib/block_ciphers.scm 1 */
obj_t BgL_locationz00_6123;
BgL_locationz00_6123 = 
BBOOL(((bool_t)0)); 
{ /* Llib/block_ciphers.scm 1 */

BgL_arg3934z00_6121 = 
BGl_readz00zz__readerz00(BgL_cportz00_6117, BgL_locationz00_6123); } } } 
{ /* Llib/block_ciphers.scm 1 */
int BgL_tmpz00_6733;
BgL_tmpz00_6733 = 
(int)(BgL_iz00_6118); 
CNST_TABLE_SET(BgL_tmpz00_6733, BgL_arg3934z00_6121); } } 
{ /* Llib/block_ciphers.scm 1 */
int BgL_auxz00_6124;
BgL_auxz00_6124 = 
(int)(
(BgL_iz00_6118-((long)1))); 
{ 
long BgL_iz00_6738;
BgL_iz00_6738 = 
(long)(BgL_auxz00_6124); 
BgL_iz00_6118 = BgL_iz00_6738; 
goto BgL_loopz00_6119;} } } } } } 
BGL_FUNCTION_END;
}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__cryptozd2blockzd2ciphersz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 1 */
return 
bgl_gc_roots_register();} 
BGL_FUNCTION_END;
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__cryptozd2blockzd2ciphersz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 1 */
return ( 
BGl_za2ciphersza2z00zz__cryptozd2blockzd2ciphersz00 = BNIL, BUNSPEC) ;} 
BGL_FUNCTION_END;
}



/* &read-string-at! */
obj_t BGl_z62readzd2stringzd2atz12z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4916, obj_t BgL_strz00_4917, long BgL_strzd2poszd2_4918, obj_t BgL_tozd2strzd2_4919, long BgL_tozd2poszd2_4920, long BgL_lenz00_4921)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 142 */
{ /* Llib/block_ciphers.scm 143 */
long BgL_tmpz00_6741;
{ /* Llib/block_ciphers.scm 143 */
long BgL_strzd2lenzd2_6137;
BgL_strzd2lenzd2_6137 = 
STRING_LENGTH(
((obj_t)BgL_strz00_4917)); 
{ /* Llib/block_ciphers.scm 143 */

if(
(
(BgL_strzd2poszd2_4918+BgL_lenz00_4921)<=BgL_strzd2lenzd2_6137))
{ /* Llib/block_ciphers.scm 144 */
blit_string(
((obj_t)BgL_strz00_4917), BgL_strzd2poszd2_4918, BgL_tozd2strzd2_4919, BgL_tozd2poszd2_4920, BgL_lenz00_4921); 
BgL_tmpz00_6741 = BgL_lenz00_4921; }  else 
{ /* Llib/block_ciphers.scm 148 */
long BgL_remainingzd2lenzd2_6141;
BgL_remainingzd2lenzd2_6141 = 
(BgL_strzd2lenzd2_6137-BgL_strzd2poszd2_4918); 
blit_string(
((obj_t)BgL_strz00_4917), BgL_strzd2poszd2_4918, BgL_tozd2strzd2_4919, BgL_tozd2poszd2_4920, BgL_remainingzd2lenzd2_6141); 
BgL_tmpz00_6741 = BgL_remainingzd2lenzd2_6141; } } } 
return 
BINT(BgL_tmpz00_6741);} } 
BGL_FUNCTION_END;
}



/* &read-mmap-at! */
obj_t BGl_z62readzd2mmapzd2atz12z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4922, obj_t BgL_mmapz00_4923, long BgL_mmapzd2poszd2_4924, obj_t BgL_tozd2strzd2_4925, long BgL_tozd2poszd2_4926, long BgL_lenz00_4927)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 151 */
{ /* Llib/block_ciphers.scm 152 */
long BgL_tmpz00_6753;
{ 
long BgL_lenz00_6143;
BgL_lenz00_6143 = BgL_lenz00_4927; 
BgL_readzd2mmapzd2atz12z12_6142:
{ /* Llib/block_ciphers.scm 152 */
long BgL_mmapzd2lenzd2_6144;
{ /* Llib/block_ciphers.scm 152 */
long BgL_res2667z00_6145;
{ /* Llib/block_ciphers.scm 152 */
obj_t BgL_tmpz00_6754;
BgL_tmpz00_6754 = 
((obj_t)BgL_mmapz00_4923); 
BgL_res2667z00_6145 = 
BGL_MMAP_LENGTH(BgL_tmpz00_6754); } 
BgL_mmapzd2lenzd2_6144 = BgL_res2667z00_6145; } 
if(
(BgL_lenz00_6143==((long)0)))
{ /* Llib/block_ciphers.scm 154 */
BgL_tmpz00_6753 = ((long)0)
; }  else 
{ /* Llib/block_ciphers.scm 155 */
bool_t BgL_testz00_6759;
{ /* Llib/block_ciphers.scm 155 */
long BgL_n2z00_6146;
BgL_n2z00_6146 = 
(long)(BgL_mmapzd2lenzd2_6144); 
BgL_testz00_6759 = 
(
(BgL_mmapzd2poszd2_4924+BgL_lenz00_6143)>BgL_n2z00_6146); } 
if(BgL_testz00_6759)
{ /* Llib/block_ciphers.scm 156 */
long BgL_arg1568z00_6147;
{ /* Llib/block_ciphers.scm 156 */
long BgL_za71za7_6148;
BgL_za71za7_6148 = 
(long)(BgL_mmapzd2lenzd2_6144); 
BgL_arg1568z00_6147 = 
(BgL_za71za7_6148-BgL_mmapzd2poszd2_4924); } 
{ 
long BgL_lenz00_6765;
BgL_lenz00_6765 = BgL_arg1568z00_6147; 
BgL_lenz00_6143 = BgL_lenz00_6765; 
goto BgL_readzd2mmapzd2atz12z12_6142;} }  else 
{ 
long BgL_iz00_6150;
BgL_iz00_6150 = ((long)0); 
BgL_loopz00_6149:
if(
(BgL_iz00_6150==BgL_lenz00_6143))
{ /* Llib/block_ciphers.scm 159 */
BgL_tmpz00_6753 = BgL_lenz00_6143
; }  else 
{ /* Llib/block_ciphers.scm 159 */
{ /* Llib/block_ciphers.scm 162 */
long BgL_arg1581z00_6151;unsigned char BgL_arg1583z00_6152;
BgL_arg1581z00_6151 = 
(BgL_tozd2poszd2_4926+BgL_iz00_6150); 
{ /* Llib/block_ciphers.scm 163 */
long BgL_arg1602z00_6153;
BgL_arg1602z00_6153 = 
(BgL_mmapzd2poszd2_4924+BgL_iz00_6150); 
{ /* Llib/block_ciphers.scm 163 */
unsigned char BgL_res2677z00_6154;
{ /* Llib/block_ciphers.scm 163 */
long BgL_iz00_6155;
BgL_iz00_6155 = 
(long)(BgL_arg1602z00_6153); 
{ /* Llib/block_ciphers.scm 163 */
unsigned char BgL_cz00_6156;
{ /* Llib/block_ciphers.scm 163 */
obj_t BgL_tmpz00_6771;
BgL_tmpz00_6771 = 
((obj_t)BgL_mmapz00_4923); 
BgL_cz00_6156 = 
BGL_MMAP_REF(BgL_tmpz00_6771, BgL_iz00_6155); } 
{ /* Llib/block_ciphers.scm 163 */
long BgL_arg1630z00_6157;
BgL_arg1630z00_6157 = 
(BgL_iz00_6155+((long)1)); 
{ /* Llib/block_ciphers.scm 163 */
long BgL_res2676z00_6158;
{ /* Llib/block_ciphers.scm 163 */
obj_t BgL_tmpz00_6775;
BgL_tmpz00_6775 = 
((obj_t)BgL_mmapz00_4923); 
BGL_MMAP_RP_SET(BgL_tmpz00_6775, BgL_arg1630z00_6157); } BUNSPEC; 
BgL_res2676z00_6158 = BgL_arg1630z00_6157; BgL_res2676z00_6158; } } 
BgL_res2677z00_6154 = BgL_cz00_6156; } } 
BgL_arg1583z00_6152 = BgL_res2677z00_6154; } } 
STRING_SET(BgL_tozd2strzd2_4925, BgL_arg1581z00_6151, BgL_arg1583z00_6152); } 
{ 
long BgL_iz00_6779;
BgL_iz00_6779 = 
(BgL_iz00_6150+((long)1)); 
BgL_iz00_6150 = BgL_iz00_6779; 
goto BgL_loopz00_6149;} } } } } } 
return 
BINT(BgL_tmpz00_6753);} } 
BGL_FUNCTION_END;
}



/* &read-port-at! */
obj_t BGl_z62readzd2portzd2atz12z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4928, obj_t BgL_pz00_4929, long BgL_pzd2poszd2_4930, obj_t BgL_tozd2strzd2_4931, long BgL_tozd2poszd2_4932, long BgL_lenz00_4933)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 165 */
{ /* Llib/block_ciphers.scm 166 */
obj_t BgL_nz00_6163;
{ /* Llib/block_ciphers.scm 166 */
long BgL_nz00_6164;
BgL_nz00_6164 = 
bgl_rgc_blit_string(BgL_pz00_4929, 
BSTRING_TO_STRING(BgL_tozd2strzd2_4931), BgL_tozd2poszd2_4932, BgL_lenz00_4933); 
{ /* Llib/block_ciphers.scm 166 */
bool_t BgL_testz00_6784;
if(
(BgL_nz00_6164==((long)0)))
{ /* Llib/block_ciphers.scm 166 */
BgL_testz00_6784 = 
rgc_buffer_eof_p(BgL_pz00_4929)
; }  else 
{ /* Llib/block_ciphers.scm 166 */
BgL_testz00_6784 = ((bool_t)0)
; } 
if(BgL_testz00_6784)
{ /* Llib/block_ciphers.scm 166 */
BgL_nz00_6163 = BEOF; }  else 
{ /* Llib/block_ciphers.scm 166 */
BgL_nz00_6163 = 
BINT(BgL_nz00_6164); } } } 
{ /* Llib/block_ciphers.scm 167 */
bool_t BgL_testz00_6789;
{ /* Llib/block_ciphers.scm 167 */
bool_t BgL_res2680z00_6165;
BgL_res2680z00_6165 = 
EOF_OBJECTP(BgL_nz00_6163); 
BgL_testz00_6789 = BgL_res2680z00_6165; } 
if(BgL_testz00_6789)
{ /* Llib/block_ciphers.scm 167 */
return 
BINT(((long)0));}  else 
{ /* Llib/block_ciphers.scm 167 */
return BgL_nz00_6163;} } } } 
BGL_FUNCTION_END;
}



/* &write-port-at! */
obj_t BGl_z62writezd2portzd2atz12z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4934, obj_t BgL_fromz00_4935, obj_t BgL_fromzd2poszd2_4936, obj_t BgL_pz00_4937, obj_t BgL_pzd2poszd2_4938, obj_t BgL_lenz00_4939)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 171 */
{ /* Llib/block_ciphers.scm 173 */
bool_t BgL_tmpz00_6792;
{ /* Llib/block_ciphers.scm 173 */
long BgL_fromzd2poszd2_6166;
BgL_fromzd2poszd2_6166 = 
(long)CINT(BgL_fromzd2poszd2_4936); 
{ 
long BgL_iz00_6169;
BgL_iz00_6169 = ((long)0); 
BgL_loopz00_6168:
if(
(BgL_iz00_6169==
(long)CINT(BgL_lenz00_4939)))
{ /* Llib/block_ciphers.scm 173 */
BgL_tmpz00_6792 = ((bool_t)0)
; }  else 
{ /* Llib/block_ciphers.scm 173 */
{ /* Llib/block_ciphers.scm 174 */
unsigned char BgL_arg1612z00_6170;
BgL_arg1612z00_6170 = 
STRING_REF(
((obj_t)BgL_fromz00_4935), 
(BgL_fromzd2poszd2_6166+BgL_iz00_6169)); 
{ /* Llib/block_ciphers.scm 174 */
obj_t BgL_tmpz00_6800;
BgL_tmpz00_6800 = 
((obj_t)BgL_pz00_4937); 
bgl_display_char(BgL_arg1612z00_6170, BgL_tmpz00_6800); } } 
{ 
long BgL_iz00_6803;
BgL_iz00_6803 = 
(BgL_iz00_6169+((long)1)); 
BgL_iz00_6169 = BgL_iz00_6803; 
goto BgL_loopz00_6168;} } } } 
return 
BBOOL(BgL_tmpz00_6792);} } 
BGL_FUNCTION_END;
}



/* &default-nonce-init! */
obj_t BGl_z62defaultzd2noncezd2initz12z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4940, obj_t BgL_strz00_4941, obj_t BgL_noncez00_4942)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 189 */
{ /* Llib/block_ciphers.scm 190 */
obj_t BgL_strz00_6171;
if(
STRINGP(BgL_strz00_4941))
{ /* Llib/block_ciphers.scm 190 */
BgL_strz00_6171 = BgL_strz00_4941; }  else 
{ 
obj_t BgL_auxz00_6808;
BgL_auxz00_6808 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)6773)), BGl_string3740z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_strz00_4941); 
FAILURE(BgL_auxz00_6808,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 190 */
long BgL_arg1652z00_6172;
{ /* Llib/block_ciphers.scm 190 */
long BgL_az00_6173;long BgL_bz00_6174;
BgL_az00_6173 = 
STRING_LENGTH(BgL_strz00_6171); 
BgL_bz00_6174 = 
STRING_LENGTH(
((obj_t)BgL_noncez00_4942)); 
if(
(BgL_az00_6173<BgL_bz00_6174))
{ /* Llib/block_ciphers.scm 191 */
BgL_arg1652z00_6172 = BgL_az00_6173; }  else 
{ /* Llib/block_ciphers.scm 191 */
BgL_arg1652z00_6172 = BgL_bz00_6174; } } 
return 
blit_string(
((obj_t)BgL_noncez00_4942), ((long)0), BgL_strz00_6171, ((long)0), BgL_arg1652z00_6172);} } } 
BGL_FUNCTION_END;
}



/* &default-nonce-update! */
obj_t BGl_z62defaultzd2noncezd2updatez12z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4943, obj_t BgL_strz00_4944, obj_t BgL_noncez00_4945, obj_t BgL_iz00_4946)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 192 */
{ /* Llib/block_ciphers.scm 193 */
obj_t BgL_strz00_6175;
if(
STRINGP(BgL_strz00_4944))
{ /* Llib/block_ciphers.scm 193 */
BgL_strz00_6175 = BgL_strz00_4944; }  else 
{ 
obj_t BgL_auxz00_6821;
BgL_auxz00_6821 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)6889)), BGl_string3742z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_strz00_4944); 
FAILURE(BgL_auxz00_6821,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 193 */
long BgL_g1157z00_6176;
BgL_g1157z00_6176 = 
(
STRING_LENGTH(BgL_strz00_6175)-((long)1)); 
{ 
long BgL_iz00_6178;
BgL_iz00_6178 = BgL_g1157z00_6176; 
BgL_loopz00_6177:
if(
(BgL_iz00_6178>=((long)0)))
{ /* Llib/block_ciphers.scm 195 */
long BgL_cz00_6179;
BgL_cz00_6179 = 
(
STRING_REF(BgL_strz00_6175, BgL_iz00_6178)); 
if(
(BgL_cz00_6179==((long)255)))
{ /* Llib/block_ciphers.scm 196 */
STRING_SET(BgL_strz00_6175, BgL_iz00_6178, ((unsigned char)'\000')); 
{ 
long BgL_iz00_6834;
BgL_iz00_6834 = 
(BgL_iz00_6178-((long)1)); 
BgL_iz00_6178 = BgL_iz00_6834; 
goto BgL_loopz00_6177;} }  else 
{ /* Llib/block_ciphers.scm 200 */
unsigned char BgL_tmpz00_6836;
BgL_tmpz00_6836 = 
(
(BgL_cz00_6179+((long)1))); 
return 
STRING_SET(BgL_strz00_6175, BgL_iz00_6178, BgL_tmpz00_6836);} }  else 
{ /* Llib/block_ciphers.scm 194 */
return BFALSE;} } } } } 
BGL_FUNCTION_END;
}



/* create-ECB-state */
BgL_cipherzd2statezd2_bglt BGl_createzd2ECBzd2statez00zz__cryptozd2blockzd2ciphersz00(obj_t BgL_enzf2decryptzf2_50, obj_t BgL_paramz00_51, long BgL_blockzd2siza7ez75_52, bool_t BgL_encryptzf3zf3_53)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 223 */
if(BgL_encryptzf3zf3_53)
{ /* Llib/block_ciphers.scm 225 */
BgL_ecbzd2encryptzd2_bglt BgL_new1159z00_496;
{ /* Llib/block_ciphers.scm 228 */
BgL_ecbzd2encryptzd2_bglt BgL_new1158z00_497;
BgL_new1158z00_497 = 
((BgL_ecbzd2encryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ecbzd2encryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 228 */
long BgL_arg1666z00_498;
{ /* Llib/block_ciphers.scm 228 */
long BgL_res2697z00_2716;
BgL_res2697z00_2716 = 
BGL_CLASS_INDEX(BGl_ECBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg1666z00_498 = BgL_res2697z00_2716; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1158z00_497), BgL_arg1666z00_498); } 
{ /* Llib/block_ciphers.scm 228 */
BgL_objectz00_bglt BgL_tmpz00_6845;
BgL_tmpz00_6845 = 
((BgL_objectz00_bglt)BgL_new1158z00_497); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_6845, BFALSE); } 
BgL_new1159z00_496 = BgL_new1158z00_497; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1159z00_496)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7ez75_52),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1159z00_496)))->BgL_cipherz00)=((obj_t)BgL_enzf2decryptzf2_50),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1159z00_496)))->BgL_paramz00)=((obj_t)BgL_paramz00_51),BUNSPEC); 
return 
((BgL_cipherzd2statezd2_bglt)BgL_new1159z00_496);}  else 
{ /* Llib/block_ciphers.scm 229 */
BgL_ecbzd2decryptzd2_bglt BgL_new1161z00_499;
{ /* Llib/block_ciphers.scm 232 */
BgL_ecbzd2decryptzd2_bglt BgL_new1160z00_500;
BgL_new1160z00_500 = 
((BgL_ecbzd2decryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ecbzd2decryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 232 */
long BgL_arg1667z00_501;
{ /* Llib/block_ciphers.scm 232 */
long BgL_res2698z00_2720;
BgL_res2698z00_2720 = 
BGL_CLASS_INDEX(BGl_ECBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg1667z00_501 = BgL_res2698z00_2720; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1160z00_500), BgL_arg1667z00_501); } 
{ /* Llib/block_ciphers.scm 232 */
BgL_objectz00_bglt BgL_tmpz00_6859;
BgL_tmpz00_6859 = 
((BgL_objectz00_bglt)BgL_new1160z00_500); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_6859, BFALSE); } 
BgL_new1161z00_499 = BgL_new1160z00_500; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1161z00_499)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7ez75_52),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1161z00_499)))->BgL_cipherz00)=((obj_t)BgL_enzf2decryptzf2_50),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1161z00_499)))->BgL_paramz00)=((obj_t)BgL_paramz00_51),BUNSPEC); 
return 
((BgL_cipherzd2statezd2_bglt)BgL_new1161z00_499);} } 
BGL_FUNCTION_END;
}



/* create-CBC-encryption-state */
BgL_cbczd2encryptzd2_bglt BGl_createzd2CBCzd2encryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_encryptz00_64, obj_t BgL_paramz00_65, long BgL_blockzd2siza7ez75_66)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 242 */
{ /* Llib/block_ciphers.scm 243 */
BgL_cbczd2encryptzd2_bglt BgL_new1165z00_502;
{ /* Llib/block_ciphers.scm 246 */
BgL_cbczd2encryptzd2_bglt BgL_new1164z00_507;
BgL_new1164z00_507 = 
((BgL_cbczd2encryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cbczd2encryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 246 */
long BgL_arg1669z00_508;
{ /* Llib/block_ciphers.scm 246 */
long BgL_res2699z00_2724;
BgL_res2699z00_2724 = 
BGL_CLASS_INDEX(BGl_CBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg1669z00_508 = BgL_res2699z00_2724; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1164z00_507), BgL_arg1669z00_508); } 
{ /* Llib/block_ciphers.scm 246 */
BgL_objectz00_bglt BgL_tmpz00_6873;
BgL_tmpz00_6873 = 
((BgL_objectz00_bglt)BgL_new1164z00_507); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_6873, BFALSE); } 
BgL_new1165z00_502 = BgL_new1164z00_507; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1165z00_502)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7ez75_66),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1165z00_502)))->BgL_cipherz00)=((obj_t)BgL_encryptz00_64),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1165z00_502)))->BgL_paramz00)=((obj_t)BgL_paramz00_65),BUNSPEC); 
{ 
obj_t BgL_auxz00_6882;
{ /* Llib/block_ciphers.scm 247 */

{ /* Llib/block_ciphers.scm 247 */
obj_t BgL_res2700z00_2728;
BgL_res2700z00_2728 = 
make_string(BgL_blockzd2siza7ez75_66, ((unsigned char)' ')); 
BgL_auxz00_6882 = BgL_res2700z00_2728; } } 
((((BgL_cbczd2encryptzd2_bglt)COBJECT(BgL_new1165z00_502))->BgL_bufferz00)=((obj_t)BgL_auxz00_6882),BUNSPEC); } 
{ 
obj_t BgL_auxz00_6885;
{ /* Llib/block_ciphers.scm 248 */

{ /* Llib/block_ciphers.scm 248 */
obj_t BgL_res2701z00_2730;
BgL_res2701z00_2730 = 
make_string(BgL_blockzd2siza7ez75_66, ((unsigned char)' ')); 
BgL_auxz00_6885 = BgL_res2701z00_2730; } } 
((((BgL_cbczd2encryptzd2_bglt)COBJECT(BgL_new1165z00_502))->BgL_chainz00)=((obj_t)BgL_auxz00_6885),BUNSPEC); } 
return BgL_new1165z00_502;} } 
BGL_FUNCTION_END;
}



/* create-CBC-decryption-state */
BgL_cbczd2decryptzd2_bglt BGl_createzd2CBCzd2decryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_decryptz00_74, obj_t BgL_paramz00_75, long BgL_blockzd2siza7ez75_76)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 259 */
{ /* Llib/block_ciphers.scm 260 */
BgL_cbczd2decryptzd2_bglt BgL_new1169z00_509;
{ /* Llib/block_ciphers.scm 263 */
BgL_cbczd2decryptzd2_bglt BgL_new1168z00_514;
BgL_new1168z00_514 = 
((BgL_cbczd2decryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cbczd2decryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 263 */
long BgL_arg1670z00_515;
{ /* Llib/block_ciphers.scm 263 */
long BgL_res2702z00_2732;
BgL_res2702z00_2732 = 
BGL_CLASS_INDEX(BGl_CBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg1670z00_515 = BgL_res2702z00_2732; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1168z00_514), BgL_arg1670z00_515); } 
{ /* Llib/block_ciphers.scm 263 */
BgL_objectz00_bglt BgL_tmpz00_6892;
BgL_tmpz00_6892 = 
((BgL_objectz00_bglt)BgL_new1168z00_514); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_6892, BFALSE); } 
BgL_new1169z00_509 = BgL_new1168z00_514; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1169z00_509)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7ez75_76),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1169z00_509)))->BgL_cipherz00)=((obj_t)BgL_decryptz00_74),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1169z00_509)))->BgL_paramz00)=((obj_t)BgL_paramz00_75),BUNSPEC); 
{ 
obj_t BgL_auxz00_6901;
{ /* Llib/block_ciphers.scm 264 */

{ /* Llib/block_ciphers.scm 264 */
obj_t BgL_res2703z00_2736;
BgL_res2703z00_2736 = 
make_string(BgL_blockzd2siza7ez75_76, ((unsigned char)' ')); 
BgL_auxz00_6901 = BgL_res2703z00_2736; } } 
((((BgL_cbczd2decryptzd2_bglt)COBJECT(BgL_new1169z00_509))->BgL_bufferz00)=((obj_t)BgL_auxz00_6901),BUNSPEC); } 
{ 
obj_t BgL_auxz00_6904;
{ /* Llib/block_ciphers.scm 265 */

{ /* Llib/block_ciphers.scm 265 */
obj_t BgL_res2704z00_2738;
BgL_res2704z00_2738 = 
make_string(BgL_blockzd2siza7ez75_76, ((unsigned char)' ')); 
BgL_auxz00_6904 = BgL_res2704z00_2738; } } 
((((BgL_cbczd2decryptzd2_bglt)COBJECT(BgL_new1169z00_509))->BgL_chainz00)=((obj_t)BgL_auxz00_6904),BUNSPEC); } 
return BgL_new1169z00_509;} } 
BGL_FUNCTION_END;
}



/* create-PCBC-encryption-state */
BgL_pcbczd2encryptzd2_bglt BGl_createzd2PCBCzd2encryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_encryptz00_84, obj_t BgL_paramz00_85, long BgL_blockzd2siza7ez75_86)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 280 */
{ /* Llib/block_ciphers.scm 281 */
BgL_pcbczd2encryptzd2_bglt BgL_new1173z00_516;
{ /* Llib/block_ciphers.scm 285 */
BgL_pcbczd2encryptzd2_bglt BgL_new1172z00_521;
BgL_new1172z00_521 = 
((BgL_pcbczd2encryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pcbczd2encryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 285 */
long BgL_arg1672z00_522;
{ /* Llib/block_ciphers.scm 285 */
long BgL_res2705z00_2740;
BgL_res2705z00_2740 = 
BGL_CLASS_INDEX(BGl_PCBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg1672z00_522 = BgL_res2705z00_2740; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1172z00_521), BgL_arg1672z00_522); } 
{ /* Llib/block_ciphers.scm 285 */
BgL_objectz00_bglt BgL_tmpz00_6911;
BgL_tmpz00_6911 = 
((BgL_objectz00_bglt)BgL_new1172z00_521); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_6911, BFALSE); } 
BgL_new1173z00_516 = BgL_new1172z00_521; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1173z00_516)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7ez75_86),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1173z00_516)))->BgL_cipherz00)=((obj_t)BgL_encryptz00_84),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1173z00_516)))->BgL_paramz00)=((obj_t)BgL_paramz00_85),BUNSPEC); 
{ 
obj_t BgL_auxz00_6920;
{ /* Llib/block_ciphers.scm 282 */

{ /* Llib/block_ciphers.scm 282 */
obj_t BgL_res2706z00_2744;
BgL_res2706z00_2744 = 
make_string(BgL_blockzd2siza7ez75_86, ((unsigned char)' ')); 
BgL_auxz00_6920 = BgL_res2706z00_2744; } } 
((((BgL_pcbczd2encryptzd2_bglt)COBJECT(BgL_new1173z00_516))->BgL_bufferz00)=((obj_t)BgL_auxz00_6920),BUNSPEC); } 
{ 
obj_t BgL_auxz00_6923;
{ /* Llib/block_ciphers.scm 286 */

{ /* Llib/block_ciphers.scm 286 */
obj_t BgL_res2707z00_2746;
BgL_res2707z00_2746 = 
make_string(BgL_blockzd2siza7ez75_86, ((unsigned char)' ')); 
BgL_auxz00_6923 = BgL_res2707z00_2746; } } 
((((BgL_pcbczd2encryptzd2_bglt)COBJECT(BgL_new1173z00_516))->BgL_chainz00)=((obj_t)BgL_auxz00_6923),BUNSPEC); } 
return BgL_new1173z00_516;} } 
BGL_FUNCTION_END;
}



/* create-PCBC-decryption-state */
BgL_pcbczd2decryptzd2_bglt BGl_createzd2PCBCzd2decryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_decryptz00_94, obj_t BgL_paramz00_95, long BgL_blockzd2siza7ez75_96)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 298 */
{ /* Llib/block_ciphers.scm 299 */
BgL_pcbczd2decryptzd2_bglt BgL_new1177z00_523;
{ /* Llib/block_ciphers.scm 303 */
BgL_pcbczd2decryptzd2_bglt BgL_new1176z00_528;
BgL_new1176z00_528 = 
((BgL_pcbczd2decryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pcbczd2decryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 303 */
long BgL_arg1675z00_529;
{ /* Llib/block_ciphers.scm 303 */
long BgL_res2708z00_2748;
BgL_res2708z00_2748 = 
BGL_CLASS_INDEX(BGl_PCBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg1675z00_529 = BgL_res2708z00_2748; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1176z00_528), BgL_arg1675z00_529); } 
{ /* Llib/block_ciphers.scm 303 */
BgL_objectz00_bglt BgL_tmpz00_6930;
BgL_tmpz00_6930 = 
((BgL_objectz00_bglt)BgL_new1176z00_528); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_6930, BFALSE); } 
BgL_new1177z00_523 = BgL_new1176z00_528; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1177z00_523)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7ez75_96),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1177z00_523)))->BgL_cipherz00)=((obj_t)BgL_decryptz00_94),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1177z00_523)))->BgL_paramz00)=((obj_t)BgL_paramz00_95),BUNSPEC); 
{ 
obj_t BgL_auxz00_6939;
{ /* Llib/block_ciphers.scm 300 */

{ /* Llib/block_ciphers.scm 300 */
obj_t BgL_res2709z00_2752;
BgL_res2709z00_2752 = 
make_string(BgL_blockzd2siza7ez75_96, ((unsigned char)' ')); 
BgL_auxz00_6939 = BgL_res2709z00_2752; } } 
((((BgL_pcbczd2decryptzd2_bglt)COBJECT(BgL_new1177z00_523))->BgL_bufferz00)=((obj_t)BgL_auxz00_6939),BUNSPEC); } 
{ 
obj_t BgL_auxz00_6942;
{ /* Llib/block_ciphers.scm 304 */

{ /* Llib/block_ciphers.scm 304 */
obj_t BgL_res2710z00_2754;
BgL_res2710z00_2754 = 
make_string(BgL_blockzd2siza7ez75_96, ((unsigned char)' ')); 
BgL_auxz00_6942 = BgL_res2710z00_2754; } } 
((((BgL_pcbczd2decryptzd2_bglt)COBJECT(BgL_new1177z00_523))->BgL_chainz00)=((obj_t)BgL_auxz00_6942),BUNSPEC); } 
return BgL_new1177z00_523;} } 
BGL_FUNCTION_END;
}



/* create-CFB-encryption-state */
BgL_cfbzd2encryptzd2_bglt BGl_createzd2CFBzd2encryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_encryptz00_104, obj_t BgL_paramz00_105, long BgL_blockzd2siza7ez75_106)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 318 */
{ /* Llib/block_ciphers.scm 319 */
BgL_cfbzd2encryptzd2_bglt BgL_new1181z00_530;
{ /* Llib/block_ciphers.scm 322 */
BgL_cfbzd2encryptzd2_bglt BgL_new1180z00_533;
BgL_new1180z00_533 = 
((BgL_cfbzd2encryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cfbzd2encryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 322 */
long BgL_arg1676z00_534;
{ /* Llib/block_ciphers.scm 322 */
long BgL_res2711z00_2756;
BgL_res2711z00_2756 = 
BGL_CLASS_INDEX(BGl_CFBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg1676z00_534 = BgL_res2711z00_2756; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1180z00_533), BgL_arg1676z00_534); } 
{ /* Llib/block_ciphers.scm 322 */
BgL_objectz00_bglt BgL_tmpz00_6949;
BgL_tmpz00_6949 = 
((BgL_objectz00_bglt)BgL_new1180z00_533); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_6949, BFALSE); } 
BgL_new1181z00_530 = BgL_new1180z00_533; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1181z00_530)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7ez75_106),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1181z00_530)))->BgL_cipherz00)=((obj_t)BgL_encryptz00_104),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1181z00_530)))->BgL_paramz00)=((obj_t)BgL_paramz00_105),BUNSPEC); 
{ 
obj_t BgL_auxz00_6958;
{ /* Llib/block_ciphers.scm 323 */

{ /* Llib/block_ciphers.scm 323 */
obj_t BgL_res2712z00_2760;
BgL_res2712z00_2760 = 
make_string(BgL_blockzd2siza7ez75_106, ((unsigned char)' ')); 
BgL_auxz00_6958 = BgL_res2712z00_2760; } } 
((((BgL_cfbzd2encryptzd2_bglt)COBJECT(BgL_new1181z00_530))->BgL_chainz00)=((obj_t)BgL_auxz00_6958),BUNSPEC); } 
return BgL_new1181z00_530;} } 
BGL_FUNCTION_END;
}



/* create-CFB-decryption-state */
BgL_cfbzd2decryptzd2_bglt BGl_createzd2CFBzd2decryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_encryptz00_121, obj_t BgL_paramz00_122, long BgL_blockzd2siza7ez75_123)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 341 */
{ /* Llib/block_ciphers.scm 342 */
BgL_cfbzd2decryptzd2_bglt BgL_new1186z00_535;
{ /* Llib/block_ciphers.scm 346 */
BgL_cfbzd2decryptzd2_bglt BgL_new1185z00_540;
BgL_new1185z00_540 = 
((BgL_cfbzd2decryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cfbzd2decryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 346 */
long BgL_arg1677z00_541;
{ /* Llib/block_ciphers.scm 346 */
long BgL_res2713z00_2762;
BgL_res2713z00_2762 = 
BGL_CLASS_INDEX(BGl_CFBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg1677z00_541 = BgL_res2713z00_2762; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1185z00_540), BgL_arg1677z00_541); } 
{ /* Llib/block_ciphers.scm 346 */
BgL_objectz00_bglt BgL_tmpz00_6965;
BgL_tmpz00_6965 = 
((BgL_objectz00_bglt)BgL_new1185z00_540); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_6965, BFALSE); } 
BgL_new1186z00_535 = BgL_new1185z00_540; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1186z00_535)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7ez75_123),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1186z00_535)))->BgL_cipherz00)=((obj_t)BgL_encryptz00_121),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1186z00_535)))->BgL_paramz00)=((obj_t)BgL_paramz00_122),BUNSPEC); 
{ 
obj_t BgL_auxz00_6974;
{ /* Llib/block_ciphers.scm 343 */

{ /* Llib/block_ciphers.scm 343 */
obj_t BgL_res2714z00_2766;
BgL_res2714z00_2766 = 
make_string(BgL_blockzd2siza7ez75_123, ((unsigned char)' ')); 
BgL_auxz00_6974 = BgL_res2714z00_2766; } } 
((((BgL_cfbzd2decryptzd2_bglt)COBJECT(BgL_new1186z00_535))->BgL_bufferz00)=((obj_t)BgL_auxz00_6974),BUNSPEC); } 
{ 
obj_t BgL_auxz00_6977;
{ /* Llib/block_ciphers.scm 347 */

{ /* Llib/block_ciphers.scm 347 */
obj_t BgL_res2715z00_2768;
BgL_res2715z00_2768 = 
make_string(BgL_blockzd2siza7ez75_123, ((unsigned char)' ')); 
BgL_auxz00_6977 = BgL_res2715z00_2768; } } 
((((BgL_cfbzd2decryptzd2_bglt)COBJECT(BgL_new1186z00_535))->BgL_chainz00)=((obj_t)BgL_auxz00_6977),BUNSPEC); } 
return BgL_new1186z00_535;} } 
BGL_FUNCTION_END;
}



/* create-OFB-state */
BgL_ofbz00_bglt BGl_createzd2OFBzd2statez00zz__cryptozd2blockzd2ciphersz00(obj_t BgL_encryptz00_138, obj_t BgL_paramz00_139, long BgL_blockzd2siza7ez75_140)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 369 */
{ /* Llib/block_ciphers.scm 370 */
BgL_ofbz00_bglt BgL_new1191z00_542;
{ /* Llib/block_ciphers.scm 373 */
BgL_ofbz00_bglt BgL_new1190z00_545;
BgL_new1190z00_545 = 
((BgL_ofbz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ofbz00_bgl) ))); 
{ /* Llib/block_ciphers.scm 373 */
long BgL_arg1678z00_546;
{ /* Llib/block_ciphers.scm 373 */
long BgL_res2716z00_2770;
BgL_res2716z00_2770 = 
BGL_CLASS_INDEX(BGl_OFBz00zz__cryptozd2blockzd2ciphersz00); 
BgL_arg1678z00_546 = BgL_res2716z00_2770; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1190z00_545), BgL_arg1678z00_546); } 
{ /* Llib/block_ciphers.scm 373 */
BgL_objectz00_bglt BgL_tmpz00_6984;
BgL_tmpz00_6984 = 
((BgL_objectz00_bglt)BgL_new1190z00_545); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_6984, BFALSE); } 
BgL_new1191z00_542 = BgL_new1190z00_545; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1191z00_542)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7ez75_140),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1191z00_542)))->BgL_cipherz00)=((obj_t)BgL_encryptz00_138),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1191z00_542)))->BgL_paramz00)=((obj_t)BgL_paramz00_139),BUNSPEC); 
{ 
obj_t BgL_auxz00_6993;
{ /* Llib/block_ciphers.scm 374 */

{ /* Llib/block_ciphers.scm 374 */
obj_t BgL_res2717z00_2774;
BgL_res2717z00_2774 = 
make_string(BgL_blockzd2siza7ez75_140, ((unsigned char)' ')); 
BgL_auxz00_6993 = BgL_res2717z00_2774; } } 
((((BgL_ofbz00_bglt)COBJECT(BgL_new1191z00_542))->BgL_chainz00)=((obj_t)BgL_auxz00_6993),BUNSPEC); } 
return BgL_new1191z00_542;} } 
BGL_FUNCTION_END;
}



/* create-CTR-state */
BgL_ctrz00_bglt BGl_createzd2CTRzd2statez00zz__cryptozd2blockzd2ciphersz00(obj_t BgL_encryptz00_155, obj_t BgL_paramz00_156, obj_t BgL_noncezd2initz12zc0_157, obj_t BgL_noncezd2updatez12zc0_158, long BgL_blockzd2siza7ez75_159)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 394 */
{ /* Llib/block_ciphers.scm 397 */
BgL_ctrz00_bglt BgL_new1196z00_547;
{ /* Llib/block_ciphers.scm 405 */
BgL_ctrz00_bglt BgL_new1195z00_550;
BgL_new1195z00_550 = 
((BgL_ctrz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ctrz00_bgl) ))); 
{ /* Llib/block_ciphers.scm 405 */
long BgL_arg1679z00_551;
{ /* Llib/block_ciphers.scm 405 */
long BgL_res2718z00_2776;
BgL_res2718z00_2776 = 
BGL_CLASS_INDEX(BGl_CTRz00zz__cryptozd2blockzd2ciphersz00); 
BgL_arg1679z00_551 = BgL_res2718z00_2776; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1195z00_550), BgL_arg1679z00_551); } 
{ /* Llib/block_ciphers.scm 405 */
BgL_objectz00_bglt BgL_tmpz00_7000;
BgL_tmpz00_7000 = 
((BgL_objectz00_bglt)BgL_new1195z00_550); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_7000, BFALSE); } 
BgL_new1196z00_547 = BgL_new1195z00_550; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1196z00_547)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7ez75_159),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1196z00_547)))->BgL_cipherz00)=((obj_t)BgL_encryptz00_155),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1196z00_547)))->BgL_paramz00)=((obj_t)BgL_paramz00_156),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(BgL_new1196z00_547))->BgL_noncez00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
obj_t BgL_auxz00_7010;
{ /* Llib/block_ciphers.scm 401 */

{ /* Llib/block_ciphers.scm 401 */
obj_t BgL_res2719z00_2780;
BgL_res2719z00_2780 = 
make_string(BgL_blockzd2siza7ez75_159, ((unsigned char)' ')); 
BgL_auxz00_7010 = BgL_res2719z00_2780; } } 
((((BgL_ctrz00_bglt)COBJECT(BgL_new1196z00_547))->BgL_noncezd2strzd2)=((obj_t)BgL_auxz00_7010),BUNSPEC); } 
((((BgL_ctrz00_bglt)COBJECT(BgL_new1196z00_547))->BgL_blockzd2counterzd2)=((long)((long)0)),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(BgL_new1196z00_547))->BgL_noncezd2initz12zc0)=((obj_t)BgL_noncezd2initz12zc0_157),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(BgL_new1196z00_547))->BgL_noncezd2updatez12zc0)=((obj_t)BgL_noncezd2updatez12zc0_158),BUNSPEC); 
return BgL_new1196z00_547;} } 
BGL_FUNCTION_END;
}



/* encrypt-input! */
long BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_cipherzd2modezd2statez00_bglt BgL_modezd2statezd2_174, obj_t BgL_fromz00_175, long BgL_fromzd2poszd2_176, obj_t BgL_readzd2atz12zc0_177, obj_t BgL_toz00_178, long BgL_tozd2poszd2_179, obj_t BgL_writezd2atz12zc0_180)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 433 */
{ /* Llib/block_ciphers.scm 439 */
obj_t BgL_casezd2valuezd2_553;
BgL_casezd2valuezd2_553 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_ivzd2actionzd2); 
if(
(BgL_casezd2valuezd2_553==
CNST_TABLE_REF(((long)0))))
{ /* Llib/block_ciphers.scm 439 */
BGl_dozd2cipherzd2IVzd2initz12zc0zz__cryptozd2blockzd2ciphersz00(
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_cipherzd2statezd2), 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_ivz00)); }  else 
{ /* Llib/block_ciphers.scm 439 */
if(
(BgL_casezd2valuezd2_553==
CNST_TABLE_REF(((long)1))))
{ /* Llib/block_ciphers.scm 439 */
BGl_dozd2cipherzd2IVzd2initz12zc0zz__cryptozd2blockzd2ciphersz00(
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_cipherzd2statezd2), 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_ivz00)); 
{ /* Llib/block_ciphers.scm 443 */
obj_t BgL_arg1691z00_560;long BgL_arg1692z00_561;
BgL_arg1691z00_560 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_ivz00); 
BgL_arg1692z00_561 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_blockzd2siza7ez75); 
PROCEDURE_ENTRY(BgL_writezd2atz12zc0_180)(BgL_writezd2atz12zc0_180, BgL_arg1691z00_560, 
BINT(((long)0)), BgL_toz00_178, 
BINT(BgL_tozd2poszd2_179), 
BINT(BgL_arg1692z00_561), BEOA); } 
BgL_tozd2poszd2_179 = 
(BgL_tozd2poszd2_179+
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_blockzd2siza7ez75)); }  else 
{ /* Llib/block_ciphers.scm 439 */
if(
(BgL_casezd2valuezd2_553==
CNST_TABLE_REF(((long)2))))
{ /* Llib/block_ciphers.scm 439 */
CNST_TABLE_REF(((long)3)); }  else 
{ /* Llib/block_ciphers.scm 446 */
obj_t BgL_arg1696z00_564;
BgL_arg1696z00_564 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_ivzd2actionzd2); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)4)), BGl_string3743z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1696z00_564); } } } } 
{ /* Llib/block_ciphers.scm 450 */
obj_t BgL_bufferz00_565;obj_t BgL_padz00_566;
BgL_bufferz00_565 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_loopzd2bufferzd2); 
BgL_padz00_566 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_padzf2unpadzf2); 
{ 
long BgL_iz00_568;
BgL_iz00_568 = ((long)0); 
BgL_zc3anonymousza31697ze3z83_569:
{ /* Llib/block_ciphers.scm 453 */
obj_t BgL_nbzd2copiedzd2_570;
{ /* Llib/block_ciphers.scm 453 */
long BgL_arg1755z00_595;long BgL_arg1756z00_596;
BgL_arg1755z00_595 = 
(BgL_fromzd2poszd2_176+BgL_iz00_568); 
BgL_arg1756z00_596 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_blockzd2siza7ez75); 
BgL_nbzd2copiedzd2_570 = 
PROCEDURE_L_ENTRY(BgL_readzd2atz12zc0_177)(BgL_readzd2atz12zc0_177, BgL_fromz00_175, BgL_arg1755z00_595, BgL_bufferz00_565, ((long)0), BgL_arg1756z00_596); } 
{ /* Llib/block_ciphers.scm 457 */
bool_t BgL_testz00_7063;
if(
(
(long)CINT(BgL_nbzd2copiedzd2_570)<
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_blockzd2siza7ez75)))
{ /* Llib/block_ciphers.scm 457 */
if(
CBOOL(BgL_padz00_566))
{ /* Llib/block_ciphers.scm 457 */
BgL_testz00_7063 = ((bool_t)0)
; }  else 
{ /* Llib/block_ciphers.scm 457 */
BgL_testz00_7063 = ((bool_t)1)
; } }  else 
{ /* Llib/block_ciphers.scm 457 */
BgL_testz00_7063 = ((bool_t)0)
; } 
if(BgL_testz00_7063)
{ /* Llib/block_ciphers.scm 457 */
if(
(
(long)CINT(BgL_nbzd2copiedzd2_570)==((long)0)))
{ /* Llib/block_ciphers.scm 458 */
return 
(BgL_iz00_568+BgL_tozd2poszd2_179);}  else 
{ /* Llib/block_ciphers.scm 458 */
BGl_dozd2cipherzd2partialzd2blockz12zc0zz__cryptozd2blockzd2ciphersz00(
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_cipherzd2statezd2), BgL_bufferz00_565, ((long)0), BgL_bufferz00_565, ((long)0), ((long)0), 
(long)CINT(BgL_nbzd2copiedzd2_570)); 
{ /* Llib/block_ciphers.scm 464 */
long BgL_arg1715z00_577;
BgL_arg1715z00_577 = 
(BgL_tozd2poszd2_179+BgL_iz00_568); 
PROCEDURE_ENTRY(BgL_writezd2atz12zc0_180)(BgL_writezd2atz12zc0_180, BgL_bufferz00_565, 
BINT(((long)0)), BgL_toz00_178, 
BINT(BgL_arg1715z00_577), BgL_nbzd2copiedzd2_570, BEOA); } 
return 
(BgL_iz00_568+
(BgL_tozd2poszd2_179+
(long)CINT(BgL_nbzd2copiedzd2_570)));} }  else 
{ /* Llib/block_ciphers.scm 457 */
if(
(
(long)CINT(BgL_nbzd2copiedzd2_570)<
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_blockzd2siza7ez75)))
{ /* Llib/block_ciphers.scm 466 */
if(
CBOOL(
PROCEDURE_ENTRY(BgL_padz00_566)(BgL_padz00_566, BgL_bufferz00_565, BgL_nbzd2copiedzd2_570, BEOA)))
{ /* Llib/block_ciphers.scm 467 */
BGl_dozd2cipherzd2blockz12z12zz__cryptozd2blockzd2ciphersz00(
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_cipherzd2statezd2), BgL_bufferz00_565, ((long)0), BgL_bufferz00_565, ((long)0)); 
{ /* Llib/block_ciphers.scm 470 */
long BgL_arg1737z00_583;long BgL_arg1738z00_584;
BgL_arg1737z00_583 = 
(BgL_tozd2poszd2_179+BgL_iz00_568); 
BgL_arg1738z00_584 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_blockzd2siza7ez75); 
PROCEDURE_ENTRY(BgL_writezd2atz12zc0_180)(BgL_writezd2atz12zc0_180, BgL_bufferz00_565, 
BINT(((long)0)), BgL_toz00_178, 
BINT(BgL_arg1737z00_583), 
BINT(BgL_arg1738z00_584), BEOA); } 
return 
(BgL_iz00_568+
(BgL_tozd2poszd2_179+
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_blockzd2siza7ez75)));}  else 
{ /* Llib/block_ciphers.scm 467 */
return 
(BgL_iz00_568+BgL_tozd2poszd2_179);} }  else 
{ /* Llib/block_ciphers.scm 466 */
BGl_dozd2cipherzd2blockz12z12zz__cryptozd2blockzd2ciphersz00(
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_cipherzd2statezd2), BgL_bufferz00_565, ((long)0), BgL_bufferz00_565, ((long)0)); 
{ /* Llib/block_ciphers.scm 475 */
long BgL_arg1749z00_588;long BgL_arg1750z00_589;
BgL_arg1749z00_588 = 
(BgL_tozd2poszd2_179+BgL_iz00_568); 
BgL_arg1750z00_589 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_blockzd2siza7ez75); 
PROCEDURE_ENTRY(BgL_writezd2atz12zc0_180)(BgL_writezd2atz12zc0_180, BgL_bufferz00_565, 
BINT(((long)0)), BgL_toz00_178, 
BINT(BgL_arg1749z00_588), 
BINT(BgL_arg1750z00_589), BEOA); } 
{ 
long BgL_iz00_7136;
BgL_iz00_7136 = 
(BgL_iz00_568+
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_blockzd2siza7ez75)); 
BgL_iz00_568 = BgL_iz00_7136; 
goto BgL_zc3anonymousza31697ze3z83_569;} } } } } } } } 
BGL_FUNCTION_END;
}



/* decrypt-input! */
long BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_cipherzd2modezd2statez00_bglt BgL_modezd2statezd2_181, obj_t BgL_fromz00_182, long BgL_fromzd2poszd2_183, obj_t BgL_readzd2atz12zc0_184, obj_t BgL_toz00_185, long BgL_tozd2poszd2_186, obj_t BgL_writezd2atz12zc0_187)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 479 */
{ /* Llib/block_ciphers.scm 485 */
obj_t BgL_casezd2valuezd2_600;
BgL_casezd2valuezd2_600 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_ivzd2actionzd2); 
if(
(BgL_casezd2valuezd2_600==
CNST_TABLE_REF(((long)0))))
{ /* Llib/block_ciphers.scm 485 */
BGl_dozd2cipherzd2IVzd2initz12zc0zz__cryptozd2blockzd2ciphersz00(
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_cipherzd2statezd2), 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_ivz00)); }  else 
{ /* Llib/block_ciphers.scm 485 */
if(
(BgL_casezd2valuezd2_600==
CNST_TABLE_REF(((long)5))))
{ /* Llib/block_ciphers.scm 488 */
obj_t BgL_nbzd2readzd2_605;
{ /* Llib/block_ciphers.scm 488 */
obj_t BgL_arg1767z00_612;long BgL_arg1768z00_613;
BgL_arg1767z00_612 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_loopzd2bufferzd2); 
BgL_arg1768z00_613 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_blockzd2siza7ez75); 
BgL_nbzd2readzd2_605 = 
PROCEDURE_L_ENTRY(BgL_readzd2atz12zc0_184)(BgL_readzd2atz12zc0_184, BgL_fromz00_182, BgL_fromzd2poszd2_183, BgL_arg1767z00_612, ((long)0), BgL_arg1768z00_613); } 
if(
(
(long)CINT(BgL_nbzd2readzd2_605)==
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_blockzd2siza7ez75)))
{ /* Llib/block_ciphers.scm 489 */BFALSE; }  else 
{ /* Llib/block_ciphers.scm 489 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)6)), BGl_string3744z00zz__cryptozd2blockzd2ciphersz00, BgL_nbzd2readzd2_605); } 
BGl_dozd2cipherzd2IVzd2initz12zc0zz__cryptozd2blockzd2ciphersz00(
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_cipherzd2statezd2), 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_loopzd2bufferzd2)); 
BgL_fromzd2poszd2_183 = 
(BgL_fromzd2poszd2_183+
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_blockzd2siza7ez75)); }  else 
{ /* Llib/block_ciphers.scm 485 */
if(
(BgL_casezd2valuezd2_600==
CNST_TABLE_REF(((long)2))))
{ /* Llib/block_ciphers.scm 485 */
CNST_TABLE_REF(((long)3)); }  else 
{ /* Llib/block_ciphers.scm 496 */
obj_t BgL_arg1770z00_615;
BgL_arg1770z00_615 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_ivzd2actionzd2); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)7)), BGl_string3743z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1770z00_615); } } } } 
{ /* Llib/block_ciphers.scm 504 */
obj_t BgL_bufferz00_616;obj_t BgL_unpadz00_617;obj_t BgL_lastzd2decryptedzd2_618;
BgL_bufferz00_616 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_loopzd2bufferzd2); 
BgL_unpadz00_617 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_padzf2unpadzf2); 
{ /* Llib/block_ciphers.scm 507 */
long BgL_arg1802z00_657;
BgL_arg1802z00_657 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_blockzd2siza7ez75); 
{ /* Llib/block_ciphers.scm 507 */

BgL_lastzd2decryptedzd2_618 = 
make_string(BgL_arg1802z00_657, ((unsigned char)' ')); } } 
{ 
long BgL_iz00_620;
{ /* Llib/block_ciphers.scm 508 */
obj_t BgL_tmpz00_7181;
BgL_iz00_620 = ((long)0); 
BgL_zc3anonymousza31771ze3z83_621:
{ /* Llib/block_ciphers.scm 509 */
obj_t BgL_nbzd2copiedzd2_622;
{ /* Llib/block_ciphers.scm 509 */
long BgL_arg1800z00_654;long BgL_arg1801z00_655;
BgL_arg1800z00_654 = 
(BgL_fromzd2poszd2_183+BgL_iz00_620); 
BgL_arg1801z00_655 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_blockzd2siza7ez75); 
BgL_nbzd2copiedzd2_622 = 
PROCEDURE_L_ENTRY(BgL_readzd2atz12zc0_184)(BgL_readzd2atz12zc0_184, BgL_fromz00_182, BgL_arg1800z00_654, BgL_bufferz00_616, ((long)0), BgL_arg1801z00_655); } 
{ /* Llib/block_ciphers.scm 513 */
bool_t BgL_testz00_7192;
if(
(
(long)CINT(BgL_nbzd2copiedzd2_622)<
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_blockzd2siza7ez75)))
{ /* Llib/block_ciphers.scm 513 */
if(
CBOOL(BgL_unpadz00_617))
{ /* Llib/block_ciphers.scm 513 */
BgL_testz00_7192 = ((bool_t)0)
; }  else 
{ /* Llib/block_ciphers.scm 513 */
BgL_testz00_7192 = ((bool_t)1)
; } }  else 
{ /* Llib/block_ciphers.scm 513 */
BgL_testz00_7192 = ((bool_t)0)
; } 
if(BgL_testz00_7192)
{ /* Llib/block_ciphers.scm 513 */
BGl_writezd2lastzd2decryptedz12ze70zf5zz__cryptozd2blockzd2ciphersz00(BgL_toz00_185, BgL_writezd2atz12zc0_187, BgL_modezd2statezd2_181, BgL_tozd2poszd2_186, BgL_lastzd2decryptedzd2_618, 
(BgL_iz00_620-
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_blockzd2siza7ez75))); 
if(
(
(long)CINT(BgL_nbzd2copiedzd2_622)==((long)0)))
{ /* Llib/block_ciphers.scm 515 */
BgL_tmpz00_7181 = 
BINT(
(BgL_iz00_620+BgL_tozd2poszd2_186))
; }  else 
{ /* Llib/block_ciphers.scm 515 */
BGl_dozd2cipherzd2partialzd2blockz12zc0zz__cryptozd2blockzd2ciphersz00(
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_cipherzd2statezd2), BgL_bufferz00_616, ((long)0), BgL_bufferz00_616, ((long)0), ((long)0), 
(long)CINT(BgL_nbzd2copiedzd2_622)); 
{ /* Llib/block_ciphers.scm 521 */
long BgL_arg1780z00_631;
BgL_arg1780z00_631 = 
(BgL_tozd2poszd2_186+BgL_iz00_620); 
PROCEDURE_ENTRY(BgL_writezd2atz12zc0_187)(BgL_writezd2atz12zc0_187, BgL_bufferz00_616, 
BINT(((long)0)), BgL_toz00_185, 
BINT(BgL_arg1780z00_631), BgL_nbzd2copiedzd2_622, BEOA); } 
BgL_tmpz00_7181 = 
BINT(
(BgL_iz00_620+
(BgL_tozd2poszd2_186+
(long)CINT(BgL_nbzd2copiedzd2_622)))); } }  else 
{ /* Llib/block_ciphers.scm 513 */
if(
(
(long)CINT(BgL_nbzd2copiedzd2_622)<
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_blockzd2siza7ez75)))
{ /* Llib/block_ciphers.scm 525 */
bool_t BgL_testz00_7229;
if(
(
(long)CINT(BgL_nbzd2copiedzd2_622)==((long)0)))
{ /* Llib/block_ciphers.scm 525 */
BgL_testz00_7229 = 
(BgL_iz00_620==((long)0))
; }  else 
{ /* Llib/block_ciphers.scm 525 */
BgL_testz00_7229 = ((bool_t)0)
; } 
if(BgL_testz00_7229)
{ /* Llib/block_ciphers.scm 525 */
BgL_tmpz00_7181 = 
BINT(BgL_tozd2poszd2_186)
; }  else 
{ /* Llib/block_ciphers.scm 525 */
if(
(
(long)CINT(BgL_nbzd2copiedzd2_622)==((long)0)))
{ /* Llib/block_ciphers.scm 528 */
obj_t BgL_plainzd2charszd2_638;
BgL_plainzd2charszd2_638 = 
PROCEDURE_ENTRY(BgL_unpadz00_617)(BgL_unpadz00_617, BgL_lastzd2decryptedzd2_618, BEOA); 
{ /* Llib/block_ciphers.scm 530 */
long BgL_arg1787z00_639;
BgL_arg1787z00_639 = 
(BgL_tozd2poszd2_186+
(BgL_iz00_620-
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_blockzd2siza7ez75))); 
PROCEDURE_ENTRY(BgL_writezd2atz12zc0_187)(BgL_writezd2atz12zc0_187, BgL_lastzd2decryptedzd2_618, 
BINT(((long)0)), BgL_toz00_185, 
BINT(BgL_arg1787z00_639), BgL_plainzd2charszd2_638, BEOA); } 
BgL_tmpz00_7181 = 
BINT(
(
(BgL_iz00_620-
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_blockzd2siza7ez75))+
(BgL_tozd2poszd2_186+
(long)CINT(BgL_plainzd2charszd2_638)))); }  else 
{ /* Llib/block_ciphers.scm 527 */
BgL_tmpz00_7181 = 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string3745z00zz__cryptozd2blockzd2ciphersz00, BgL_nbzd2copiedzd2_622)
; } } }  else 
{ /* Llib/block_ciphers.scm 523 */
BGl_writezd2lastzd2decryptedz12ze70zf5zz__cryptozd2blockzd2ciphersz00(BgL_toz00_185, BgL_writezd2atz12zc0_187, BgL_modezd2statezd2_181, BgL_tozd2poszd2_186, BgL_lastzd2decryptedzd2_618, 
(BgL_iz00_620-
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_blockzd2siza7ez75))); 
BGl_dozd2cipherzd2blockz12z12zz__cryptozd2blockzd2ciphersz00(
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_cipherzd2statezd2), BgL_bufferz00_616, ((long)0), BgL_lastzd2decryptedzd2_618, ((long)0)); 
{ 
long BgL_iz00_7268;
BgL_iz00_7268 = 
(BgL_iz00_620+
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_blockzd2siza7ez75)); 
BgL_iz00_620 = BgL_iz00_7268; 
goto BgL_zc3anonymousza31771ze3z83_621;} } } } } 
return 
(long)CINT(BgL_tmpz00_7181);} } } } 
BGL_FUNCTION_END;
}



/* write-last-decrypted!~0 */
obj_t BGl_writezd2lastzd2decryptedz12ze70zf5zz__cryptozd2blockzd2ciphersz00(obj_t BgL_toz00_5670, obj_t BgL_writezd2atz12zc0_5669, BgL_cipherzd2modezd2statez00_bglt BgL_i1201z00_5668, long BgL_tozd2poszd2_5667, obj_t BgL_lastzd2decryptedzd2_660, long BgL_iz00_661)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 502 */
if(
(BgL_iz00_661<((long)0)))
{ /* Llib/block_ciphers.scm 501 */
return BFALSE;}  else 
{ /* Llib/block_ciphers.scm 502 */
long BgL_arg1805z00_664;long BgL_arg1806z00_665;
BgL_arg1805z00_664 = 
(BgL_tozd2poszd2_5667+BgL_iz00_661); 
BgL_arg1806z00_665 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_i1201z00_5668))->BgL_blockzd2siza7ez75); 
return 
PROCEDURE_ENTRY(BgL_writezd2atz12zc0_5669)(BgL_writezd2atz12zc0_5669, BgL_lastzd2decryptedzd2_660, 
BINT(((long)0)), BgL_toz00_5670, 
BINT(BgL_arg1805z00_664), 
BINT(BgL_arg1806z00_665), BEOA);} } 
BGL_FUNCTION_END;
}



/* create-encryption-state */
BgL_cipherzd2modezd2statez00_bglt BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_188, obj_t BgL_passwordz00_189, obj_t BgL_ivz00_190, obj_t BgL_modez00_191, obj_t BgL_padz00_192, obj_t BgL_noncezd2initz12zc0_193, obj_t BgL_noncezd2updatez12zc0_194, obj_t BgL_stringzd2ze3keyz31_195)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 594 */
{ /* Llib/block_ciphers.scm 597 */
BgL_blockzd2cipherzd2_bglt BgL_i1202z00_667;
BgL_i1202z00_667 = 
BGl_blockzd2cipherzd2descriptionz00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_188); 
{ 
obj_t BgL_modez00_719;obj_t BgL_paramz00_720;long BgL_bsz00_721;
{ /* Llib/block_ciphers.scm 615 */
obj_t BgL_keyz00_669;
if(
CBOOL(BgL_stringzd2ze3keyz31_195))
{ /* Llib/block_ciphers.scm 615 */
BgL_keyz00_669 = 
PROCEDURE_ENTRY(BgL_stringzd2ze3keyz31_195)(BgL_stringzd2ze3keyz31_195, BgL_passwordz00_189, BEOA); }  else 
{ /* Llib/block_ciphers.scm 615 */
BgL_keyz00_669 = 
BGl_stringzd2ze3keyzd2hashze3zz__cryptozd2string2keyzd2(BgL_passwordz00_189, 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1202z00_667))->BgL_preferredzd2keyzd2lengthz00), BGl_sha1sumzd2binzd2envz00zz__cryptozd2utilzd2); } 
{ /* Llib/block_ciphers.scm 615 */
obj_t BgL_padzd2proczd2_670;
{ /* Llib/block_ciphers.scm 619 */
bool_t BgL_testz00_7296;
{ /* Llib/block_ciphers.scm 619 */
bool_t BgL__ortest_1205z00_716;
BgL__ortest_1205z00_716 = 
(BgL_modez00_191==
CNST_TABLE_REF(((long)9))); 
if(BgL__ortest_1205z00_716)
{ /* Llib/block_ciphers.scm 619 */
BgL_testz00_7296 = BgL__ortest_1205z00_716
; }  else 
{ /* Llib/block_ciphers.scm 619 */
bool_t BgL__ortest_1206z00_717;
BgL__ortest_1206z00_717 = 
(BgL_modez00_191==
CNST_TABLE_REF(((long)11))); 
if(BgL__ortest_1206z00_717)
{ /* Llib/block_ciphers.scm 619 */
BgL_testz00_7296 = BgL__ortest_1206z00_717
; }  else 
{ /* Llib/block_ciphers.scm 619 */
BgL_testz00_7296 = 
(BgL_modez00_191==
CNST_TABLE_REF(((long)12)))
; } } } 
if(BgL_testz00_7296)
{ /* Llib/block_ciphers.scm 619 */
if(
(BgL_padz00_192==
CNST_TABLE_REF(((long)16))))
{ /* Llib/block_ciphers.scm 621 */
BgL_padzd2proczd2_670 = BGl_nozd2padzd2envz00zz__cryptozd2cipherzd2paddingz00; }  else 
{ /* Llib/block_ciphers.scm 621 */
if(
(BgL_padz00_192==
CNST_TABLE_REF(((long)17))))
{ /* Llib/block_ciphers.scm 621 */
BgL_padzd2proczd2_670 = BGl_bitzd2padzd2envz00zz__cryptozd2cipherzd2paddingz00; }  else 
{ /* Llib/block_ciphers.scm 621 */
if(
(BgL_padz00_192==
CNST_TABLE_REF(((long)18))))
{ /* Llib/block_ciphers.scm 621 */
BgL_padzd2proczd2_670 = BGl_ansizd2xze2923zd2padzd2envz30zz__cryptozd2cipherzd2paddingz00; }  else 
{ /* Llib/block_ciphers.scm 621 */
if(
(BgL_padz00_192==
CNST_TABLE_REF(((long)19))))
{ /* Llib/block_ciphers.scm 621 */
BgL_padzd2proczd2_670 = BGl_isozd210126zd2padzd2envzd2zz__cryptozd2cipherzd2paddingz00; }  else 
{ /* Llib/block_ciphers.scm 621 */
if(
(BgL_padz00_192==
CNST_TABLE_REF(((long)20))))
{ /* Llib/block_ciphers.scm 621 */
BgL_padzd2proczd2_670 = BGl_pkcs7zd2padzd2envz00zz__cryptozd2cipherzd2paddingz00; }  else 
{ /* Llib/block_ciphers.scm 621 */
if(
(BgL_padz00_192==
CNST_TABLE_REF(((long)21))))
{ /* Llib/block_ciphers.scm 621 */
BgL_padzd2proczd2_670 = BGl_za7erozd2padzd2envza7zz__cryptozd2cipherzd2paddingz00; }  else 
{ /* Llib/block_ciphers.scm 621 */
if(
PROCEDUREP(BgL_padz00_192))
{ /* Llib/block_ciphers.scm 628 */
BgL_padzd2proczd2_670 = BgL_padz00_192; }  else 
{ /* Llib/block_ciphers.scm 628 */
BgL_padzd2proczd2_670 = 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)15)), BGl_string3747z00zz__cryptozd2blockzd2ciphersz00, BgL_padz00_192); } } } } } } } }  else 
{ /* Llib/block_ciphers.scm 619 */
BgL_padzd2proczd2_670 = BFALSE; } } 
{ /* Llib/block_ciphers.scm 619 */
obj_t BgL_encryptionzd2ivzd2_671;
if(
CBOOL(BgL_ivz00_190))
{ /* Llib/block_ciphers.scm 634 */
BgL_encryptionzd2ivzd2_671 = BgL_ivz00_190; }  else 
{ /* Llib/block_ciphers.scm 634 */
if(
(BgL_modez00_191==
CNST_TABLE_REF(((long)9))))
{ /* Llib/block_ciphers.scm 635 */
BgL_encryptionzd2ivzd2_671 = BFALSE; }  else 
{ /* Llib/block_ciphers.scm 635 */
BgL_encryptionzd2ivzd2_671 = 
BGl_makezd2randomzd2stringz00zz__cryptozd2utilzd2(
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1202z00_667))->BgL_blockzd2siza7ez75), BFALSE); } } 
{ /* Llib/block_ciphers.scm 634 */
obj_t BgL_paramz00_672;
{ /* Llib/block_ciphers.scm 639 */
obj_t BgL_fun1825z00_698;
BgL_fun1825z00_698 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1202z00_667))->BgL_keyzd2ze3encryptzd2paramze3); 
BgL_paramz00_672 = 
PROCEDURE_ENTRY(BgL_fun1825z00_698)(BgL_fun1825z00_698, BgL_keyz00_669, BEOA); } 
{ /* Llib/block_ciphers.scm 639 */
obj_t BgL_statez00_673;
BgL_modez00_719 = BgL_modez00_191; 
BgL_paramz00_720 = BgL_paramz00_672; 
BgL_bsz00_721 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1202z00_667))->BgL_blockzd2siza7ez75); 
if(
(BgL_modez00_719==
CNST_TABLE_REF(((long)9))))
{ /* Llib/block_ciphers.scm 602 */
obj_t BgL_arg1839z00_725;
BgL_arg1839z00_725 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1202z00_667))->BgL_encryptz12z12); 
BgL_statez00_673 = 
((obj_t)
BGl_createzd2ECBzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_arg1839z00_725, BgL_paramz00_720, BgL_bsz00_721, ((bool_t)1))); }  else 
{ /* Llib/block_ciphers.scm 601 */
if(
(BgL_modez00_719==
CNST_TABLE_REF(((long)10))))
{ /* Llib/block_ciphers.scm 603 */
obj_t BgL_arg1841z00_727;
BgL_arg1841z00_727 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1202z00_667))->BgL_encryptz12z12); 
BgL_statez00_673 = 
((obj_t)
BGl_createzd2CFBzd2encryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(BgL_arg1841z00_727, BgL_paramz00_720, BgL_bsz00_721)); }  else 
{ /* Llib/block_ciphers.scm 601 */
if(
(BgL_modez00_719==
CNST_TABLE_REF(((long)11))))
{ /* Llib/block_ciphers.scm 604 */
obj_t BgL_arg1843z00_729;
BgL_arg1843z00_729 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1202z00_667))->BgL_encryptz12z12); 
BgL_statez00_673 = 
((obj_t)
BGl_createzd2CBCzd2encryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(BgL_arg1843z00_729, BgL_paramz00_720, BgL_bsz00_721)); }  else 
{ /* Llib/block_ciphers.scm 601 */
if(
(BgL_modez00_719==
CNST_TABLE_REF(((long)12))))
{ /* Llib/block_ciphers.scm 605 */
obj_t BgL_arg1845z00_731;
BgL_arg1845z00_731 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1202z00_667))->BgL_encryptz12z12); 
BgL_statez00_673 = 
((obj_t)
BGl_createzd2PCBCzd2encryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(BgL_arg1845z00_731, BgL_paramz00_720, BgL_bsz00_721)); }  else 
{ /* Llib/block_ciphers.scm 601 */
if(
(BgL_modez00_719==
CNST_TABLE_REF(((long)13))))
{ /* Llib/block_ciphers.scm 606 */
obj_t BgL_arg1847z00_733;
BgL_arg1847z00_733 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1202z00_667))->BgL_encryptz12z12); 
BgL_statez00_673 = 
((obj_t)
BGl_createzd2OFBzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_arg1847z00_733, BgL_paramz00_720, BgL_bsz00_721)); }  else 
{ /* Llib/block_ciphers.scm 601 */
if(
(BgL_modez00_719==
CNST_TABLE_REF(((long)14))))
{ /* Llib/block_ciphers.scm 607 */
obj_t BgL_arg1849z00_735;obj_t BgL_arg1850z00_736;obj_t BgL_arg1851z00_737;
BgL_arg1849z00_735 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1202z00_667))->BgL_encryptz12z12); 
if(
CBOOL(BgL_noncezd2initz12zc0_193))
{ /* Llib/block_ciphers.scm 608 */
BgL_arg1850z00_736 = BgL_noncezd2initz12zc0_193; }  else 
{ /* Llib/block_ciphers.scm 608 */
BgL_arg1850z00_736 = BGl_defaultzd2noncezd2initz12zd2envzc0zz__cryptozd2blockzd2ciphersz00; } 
if(
CBOOL(BgL_noncezd2updatez12zc0_194))
{ /* Llib/block_ciphers.scm 609 */
BgL_arg1851z00_737 = BgL_noncezd2updatez12zc0_194; }  else 
{ /* Llib/block_ciphers.scm 609 */
BgL_arg1851z00_737 = BGl_defaultzd2noncezd2updatez12zd2envzc0zz__cryptozd2blockzd2ciphersz00; } 
BgL_statez00_673 = 
((obj_t)
BGl_createzd2CTRzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_arg1849z00_735, BgL_paramz00_720, BgL_arg1850z00_736, BgL_arg1851z00_737, BgL_bsz00_721)); }  else 
{ /* Llib/block_ciphers.scm 601 */
BgL_statez00_673 = 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)15)), BGl_string3746z00zz__cryptozd2blockzd2ciphersz00, BgL_modez00_719); } } } } } } 
{ /* Llib/block_ciphers.scm 640 */

if(
(BgL_modez00_191==
CNST_TABLE_REF(((long)9))))
{ /* Llib/block_ciphers.scm 642 */
CNST_TABLE_REF(((long)3)); }  else 
{ /* Llib/block_ciphers.scm 642 */
if(
(BgL_modez00_191==
CNST_TABLE_REF(((long)14))))
{ /* Llib/block_ciphers.scm 643 */
CNST_TABLE_REF(((long)3)); }  else 
{ /* Llib/block_ciphers.scm 645 */
bool_t BgL_testz00_7390;
if(
STRINGP(BgL_encryptionzd2ivzd2_671))
{ /* Llib/block_ciphers.scm 645 */
if(
(
STRING_LENGTH(BgL_encryptionzd2ivzd2_671)>=
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1202z00_667))->BgL_blockzd2siza7ez75)))
{ /* Llib/block_ciphers.scm 646 */
BgL_testz00_7390 = ((bool_t)0)
; }  else 
{ /* Llib/block_ciphers.scm 646 */
BgL_testz00_7390 = ((bool_t)1)
; } }  else 
{ /* Llib/block_ciphers.scm 645 */
BgL_testz00_7390 = ((bool_t)1)
; } 
if(BgL_testz00_7390)
{ /* Llib/block_ciphers.scm 649 */
obj_t BgL_arg1816z00_683;
if(
STRINGP(BgL_ivz00_190))
{ /* Llib/block_ciphers.scm 649 */
BgL_arg1816z00_683 = 
BINT(
STRING_LENGTH(BgL_ivz00_190)); }  else 
{ /* Llib/block_ciphers.scm 649 */
BgL_arg1816z00_683 = BgL_ivz00_190; } 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)22)), BGl_string3748z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1816z00_683); }  else 
{ /* Llib/block_ciphers.scm 645 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 652 */
BgL_cipherzd2modezd2statez00_bglt BgL_new1209z00_689;
{ /* Llib/block_ciphers.scm 653 */
BgL_cipherzd2modezd2statez00_bglt BgL_new1208z00_695;
BgL_new1208z00_695 = 
((BgL_cipherzd2modezd2statez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cipherzd2modezd2statez00_bgl) ))); 
{ /* Llib/block_ciphers.scm 653 */
long BgL_arg1823z00_696;
{ /* Llib/block_ciphers.scm 653 */
long BgL_res2784z00_2940;
BgL_res2784z00_2940 = 
BGL_CLASS_INDEX(BGl_Cipherzd2Modezd2Statez00zz__cryptozd2blockzd2ciphersz00); 
BgL_arg1823z00_696 = BgL_res2784z00_2940; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1208z00_695), BgL_arg1823z00_696); } 
{ /* Llib/block_ciphers.scm 653 */
BgL_objectz00_bglt BgL_tmpz00_7407;
BgL_tmpz00_7407 = 
((BgL_objectz00_bglt)BgL_new1208z00_695); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_7407, BFALSE); } 
BgL_new1209z00_689 = BgL_new1208z00_695; } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1209z00_689))->BgL_encryptzf3zf3)=((bool_t)((bool_t)1)),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1209z00_689))->BgL_blockzd2siza7ez75)=((long)
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1202z00_667))->BgL_blockzd2siza7ez75)),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1209z00_689))->BgL_cipherzd2statezd2)=((BgL_cipherzd2statezd2_bglt)
((BgL_cipherzd2statezd2_bglt)BgL_statez00_673)),BUNSPEC); 
{ 
obj_t BgL_auxz00_7415;
if(
(BgL_modez00_191==
CNST_TABLE_REF(((long)9))))
{ /* Llib/block_ciphers.scm 657 */
BgL_auxz00_7415 = 
CNST_TABLE_REF(((long)2))
; }  else 
{ /* Llib/block_ciphers.scm 658 */
bool_t BgL_testz00_7420;
if(
CBOOL(BgL_ivz00_190))
{ /* Llib/block_ciphers.scm 658 */
BgL_testz00_7420 = ((bool_t)0)
; }  else 
{ /* Llib/block_ciphers.scm 658 */
BgL_testz00_7420 = 
CBOOL(BgL_encryptionzd2ivzd2_671)
; } 
if(BgL_testz00_7420)
{ /* Llib/block_ciphers.scm 658 */
BgL_auxz00_7415 = 
CNST_TABLE_REF(((long)1))
; }  else 
{ /* Llib/block_ciphers.scm 658 */
BgL_auxz00_7415 = 
CNST_TABLE_REF(((long)0))
; } } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1209z00_689))->BgL_ivzd2actionzd2)=((obj_t)BgL_auxz00_7415),BUNSPEC); } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1209z00_689))->BgL_ivz00)=((obj_t)BgL_encryptionzd2ivzd2_671),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1209z00_689))->BgL_padzf2unpadzf2)=((obj_t)BgL_padzd2proczd2_670),BUNSPEC); 
{ 
obj_t BgL_auxz00_7429;
{ /* Llib/block_ciphers.scm 662 */
long BgL_arg1822z00_692;
BgL_arg1822z00_692 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1202z00_667))->BgL_blockzd2siza7ez75); 
{ /* Llib/block_ciphers.scm 662 */

{ /* Llib/block_ciphers.scm 662 */
obj_t BgL_res2785z00_2944;
BgL_res2785z00_2944 = 
make_string(BgL_arg1822z00_692, ((unsigned char)' ')); 
BgL_auxz00_7429 = BgL_res2785z00_2944; } } } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1209z00_689))->BgL_loopzd2bufferzd2)=((obj_t)BgL_auxz00_7429),BUNSPEC); } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1209z00_689))->BgL_posz00)=((long)((long)0)),BUNSPEC); 
return BgL_new1209z00_689;} } } } } } } } } } 
BGL_FUNCTION_END;
}



/* create-decryption-state */
BgL_cipherzd2modezd2statez00_bglt BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_196, obj_t BgL_passwordz00_197, obj_t BgL_ivz00_198, obj_t BgL_modez00_199, obj_t BgL_padz00_200, obj_t BgL_noncezd2initz12zc0_201, obj_t BgL_noncezd2updatez12zc0_202, obj_t BgL_stringzd2ze3keyz31_203)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 664 */
{ /* Llib/block_ciphers.scm 667 */
BgL_blockzd2cipherzd2_bglt BgL_i1210z00_741;
BgL_i1210z00_741 = 
BGl_blockzd2cipherzd2descriptionz00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_196); 
{ 
obj_t BgL_modez00_795;obj_t BgL_paramz00_796;long BgL_bsz00_797;
{ /* Llib/block_ciphers.scm 686 */
obj_t BgL_keyz00_743;
if(
CBOOL(BgL_stringzd2ze3keyz31_203))
{ /* Llib/block_ciphers.scm 686 */
BgL_keyz00_743 = 
PROCEDURE_ENTRY(BgL_stringzd2ze3keyz31_203)(BgL_stringzd2ze3keyz31_203, BgL_passwordz00_197, BEOA); }  else 
{ /* Llib/block_ciphers.scm 686 */
BgL_keyz00_743 = 
BGl_stringzd2ze3keyzd2hashze3zz__cryptozd2string2keyzd2(BgL_passwordz00_197, 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1210z00_741))->BgL_preferredzd2keyzd2lengthz00), BGl_sha1sumzd2binzd2envz00zz__cryptozd2utilzd2); } 
{ /* Llib/block_ciphers.scm 686 */
obj_t BgL_unpadzd2proczd2_744;
{ /* Llib/block_ciphers.scm 690 */
bool_t BgL_testz00_7443;
{ /* Llib/block_ciphers.scm 690 */
bool_t BgL__ortest_1213z00_792;
BgL__ortest_1213z00_792 = 
(BgL_modez00_199==
CNST_TABLE_REF(((long)9))); 
if(BgL__ortest_1213z00_792)
{ /* Llib/block_ciphers.scm 690 */
BgL_testz00_7443 = BgL__ortest_1213z00_792
; }  else 
{ /* Llib/block_ciphers.scm 690 */
bool_t BgL__ortest_1214z00_793;
BgL__ortest_1214z00_793 = 
(BgL_modez00_199==
CNST_TABLE_REF(((long)11))); 
if(BgL__ortest_1214z00_793)
{ /* Llib/block_ciphers.scm 690 */
BgL_testz00_7443 = BgL__ortest_1214z00_793
; }  else 
{ /* Llib/block_ciphers.scm 690 */
BgL_testz00_7443 = 
(BgL_modez00_199==
CNST_TABLE_REF(((long)12)))
; } } } 
if(BgL_testz00_7443)
{ /* Llib/block_ciphers.scm 690 */
if(
(BgL_padz00_200==
CNST_TABLE_REF(((long)16))))
{ /* Llib/block_ciphers.scm 692 */
BgL_unpadzd2proczd2_744 = BGl_nozd2unpadzd2envz00zz__cryptozd2cipherzd2paddingz00; }  else 
{ /* Llib/block_ciphers.scm 692 */
if(
(BgL_padz00_200==
CNST_TABLE_REF(((long)17))))
{ /* Llib/block_ciphers.scm 692 */
BgL_unpadzd2proczd2_744 = BGl_bitzd2unpadzd2envz00zz__cryptozd2cipherzd2paddingz00; }  else 
{ /* Llib/block_ciphers.scm 692 */
bool_t BgL_testz00_7458;
{ /* Llib/block_ciphers.scm 692 */
bool_t BgL__ortest_1215z00_790;
BgL__ortest_1215z00_790 = 
(BgL_padz00_200==
CNST_TABLE_REF(((long)18))); 
if(BgL__ortest_1215z00_790)
{ /* Llib/block_ciphers.scm 692 */
BgL_testz00_7458 = BgL__ortest_1215z00_790
; }  else 
{ /* Llib/block_ciphers.scm 692 */
bool_t BgL__ortest_1216z00_791;
BgL__ortest_1216z00_791 = 
(BgL_padz00_200==
CNST_TABLE_REF(((long)19))); 
if(BgL__ortest_1216z00_791)
{ /* Llib/block_ciphers.scm 692 */
BgL_testz00_7458 = BgL__ortest_1216z00_791
; }  else 
{ /* Llib/block_ciphers.scm 692 */
BgL_testz00_7458 = 
(BgL_padz00_200==
CNST_TABLE_REF(((long)20)))
; } } } 
if(BgL_testz00_7458)
{ /* Llib/block_ciphers.scm 692 */
BgL_unpadzd2proczd2_744 = BGl_bytezd2unpadzd2envz00zz__cryptozd2cipherzd2paddingz00; }  else 
{ /* Llib/block_ciphers.scm 692 */
if(
(BgL_padz00_200==
CNST_TABLE_REF(((long)21))))
{ /* Llib/block_ciphers.scm 692 */
BgL_unpadzd2proczd2_744 = BGl_za7erozd2unpadzd2envza7zz__cryptozd2cipherzd2paddingz00; }  else 
{ /* Llib/block_ciphers.scm 692 */
if(
PROCEDUREP(BgL_padz00_200))
{ /* Llib/block_ciphers.scm 698 */
BgL_unpadzd2proczd2_744 = BgL_padz00_200; }  else 
{ /* Llib/block_ciphers.scm 698 */
BgL_unpadzd2proczd2_744 = 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string3747z00zz__cryptozd2blockzd2ciphersz00, BgL_padz00_200); } } } } } }  else 
{ /* Llib/block_ciphers.scm 690 */
BgL_unpadzd2proczd2_744 = BFALSE; } } 
{ /* Llib/block_ciphers.scm 690 */
obj_t BgL_paramz00_745;
{ /* Llib/block_ciphers.scm 704 */
bool_t BgL_testz00_7474;
{ /* Llib/block_ciphers.scm 704 */
bool_t BgL__ortest_1217z00_776;
BgL__ortest_1217z00_776 = 
(BgL_modez00_199==
CNST_TABLE_REF(((long)9))); 
if(BgL__ortest_1217z00_776)
{ /* Llib/block_ciphers.scm 704 */
BgL_testz00_7474 = BgL__ortest_1217z00_776
; }  else 
{ /* Llib/block_ciphers.scm 704 */
bool_t BgL__ortest_1218z00_777;
BgL__ortest_1218z00_777 = 
(BgL_modez00_199==
CNST_TABLE_REF(((long)11))); 
if(BgL__ortest_1218z00_777)
{ /* Llib/block_ciphers.scm 704 */
BgL_testz00_7474 = BgL__ortest_1218z00_777
; }  else 
{ /* Llib/block_ciphers.scm 704 */
BgL_testz00_7474 = 
(BgL_modez00_199==
CNST_TABLE_REF(((long)12)))
; } } } 
if(BgL_testz00_7474)
{ /* Llib/block_ciphers.scm 705 */
obj_t BgL_fun1870z00_774;
BgL_fun1870z00_774 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1210z00_741))->BgL_keyzd2ze3decryptzd2paramze3); 
BgL_paramz00_745 = 
PROCEDURE_ENTRY(BgL_fun1870z00_774)(BgL_fun1870z00_774, BgL_keyz00_743, BEOA); }  else 
{ /* Llib/block_ciphers.scm 706 */
obj_t BgL_fun1871z00_775;
BgL_fun1871z00_775 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1210z00_741))->BgL_keyzd2ze3encryptzd2paramze3); 
BgL_paramz00_745 = 
PROCEDURE_ENTRY(BgL_fun1871z00_775)(BgL_fun1871z00_775, BgL_keyz00_743, BEOA); } } 
{ /* Llib/block_ciphers.scm 704 */
obj_t BgL_statez00_746;
BgL_modez00_795 = BgL_modez00_199; 
BgL_paramz00_796 = BgL_paramz00_745; 
BgL_bsz00_797 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1210z00_741))->BgL_blockzd2siza7ez75); 
if(
(BgL_modez00_795==
CNST_TABLE_REF(((long)9))))
{ /* Llib/block_ciphers.scm 673 */
obj_t BgL_arg1881z00_801;
BgL_arg1881z00_801 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1210z00_741))->BgL_decryptz12z12); 
BgL_statez00_746 = 
((obj_t)
BGl_createzd2ECBzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_arg1881z00_801, BgL_paramz00_796, BgL_bsz00_797, ((bool_t)0))); }  else 
{ /* Llib/block_ciphers.scm 672 */
if(
(BgL_modez00_795==
CNST_TABLE_REF(((long)11))))
{ /* Llib/block_ciphers.scm 674 */
obj_t BgL_arg1883z00_803;
BgL_arg1883z00_803 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1210z00_741))->BgL_decryptz12z12); 
BgL_statez00_746 = 
((obj_t)
BGl_createzd2CBCzd2decryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(BgL_arg1883z00_803, BgL_paramz00_796, BgL_bsz00_797)); }  else 
{ /* Llib/block_ciphers.scm 672 */
if(
(BgL_modez00_795==
CNST_TABLE_REF(((long)12))))
{ /* Llib/block_ciphers.scm 675 */
obj_t BgL_arg1885z00_805;
BgL_arg1885z00_805 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1210z00_741))->BgL_decryptz12z12); 
BgL_statez00_746 = 
((obj_t)
BGl_createzd2PCBCzd2decryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(BgL_arg1885z00_805, BgL_paramz00_796, BgL_bsz00_797)); }  else 
{ /* Llib/block_ciphers.scm 672 */
if(
(BgL_modez00_795==
CNST_TABLE_REF(((long)10))))
{ /* Llib/block_ciphers.scm 676 */
obj_t BgL_arg1887z00_807;
BgL_arg1887z00_807 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1210z00_741))->BgL_encryptz12z12); 
BgL_statez00_746 = 
((obj_t)
BGl_createzd2CFBzd2decryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(BgL_arg1887z00_807, BgL_paramz00_796, BgL_bsz00_797)); }  else 
{ /* Llib/block_ciphers.scm 672 */
if(
(BgL_modez00_795==
CNST_TABLE_REF(((long)13))))
{ /* Llib/block_ciphers.scm 677 */
obj_t BgL_arg1889z00_809;
BgL_arg1889z00_809 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1210z00_741))->BgL_encryptz12z12); 
BgL_statez00_746 = 
((obj_t)
BGl_createzd2OFBzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_arg1889z00_809, BgL_paramz00_796, BgL_bsz00_797)); }  else 
{ /* Llib/block_ciphers.scm 672 */
if(
(BgL_modez00_795==
CNST_TABLE_REF(((long)14))))
{ /* Llib/block_ciphers.scm 678 */
obj_t BgL_arg1891z00_811;obj_t BgL_arg1892z00_812;obj_t BgL_arg1893z00_813;
BgL_arg1891z00_811 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1210z00_741))->BgL_encryptz12z12); 
if(
CBOOL(BgL_noncezd2initz12zc0_201))
{ /* Llib/block_ciphers.scm 679 */
BgL_arg1892z00_812 = BgL_noncezd2initz12zc0_201; }  else 
{ /* Llib/block_ciphers.scm 679 */
BgL_arg1892z00_812 = BGl_defaultzd2noncezd2initz12zd2envzc0zz__cryptozd2blockzd2ciphersz00; } 
if(
CBOOL(BgL_noncezd2updatez12zc0_202))
{ /* Llib/block_ciphers.scm 680 */
BgL_arg1893z00_813 = BgL_noncezd2updatez12zc0_202; }  else 
{ /* Llib/block_ciphers.scm 680 */
BgL_arg1893z00_813 = BGl_defaultzd2noncezd2updatez12zd2envzc0zz__cryptozd2blockzd2ciphersz00; } 
BgL_statez00_746 = 
((obj_t)
BGl_createzd2CTRzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_arg1891z00_811, BgL_paramz00_796, BgL_arg1892z00_812, BgL_arg1893z00_813, BgL_bsz00_797)); }  else 
{ /* Llib/block_ciphers.scm 672 */
BgL_statez00_746 = 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string3746z00zz__cryptozd2blockzd2ciphersz00, BgL_modez00_795); } } } } } } 
{ /* Llib/block_ciphers.scm 707 */

if(
(BgL_modez00_199==
CNST_TABLE_REF(((long)9))))
{ /* Llib/block_ciphers.scm 709 */
CNST_TABLE_REF(((long)3)); }  else 
{ /* Llib/block_ciphers.scm 709 */
if(
(BgL_modez00_199==
CNST_TABLE_REF(((long)14))))
{ /* Llib/block_ciphers.scm 710 */
CNST_TABLE_REF(((long)3)); }  else 
{ /* Llib/block_ciphers.scm 710 */
if(
CBOOL(BgL_ivz00_198))
{ /* Llib/block_ciphers.scm 713 */
bool_t BgL_testz00_7546;
if(
STRINGP(BgL_ivz00_198))
{ /* Llib/block_ciphers.scm 713 */
if(
(
STRING_LENGTH(BgL_ivz00_198)>=
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1210z00_741))->BgL_blockzd2siza7ez75)))
{ /* Llib/block_ciphers.scm 714 */
BgL_testz00_7546 = ((bool_t)0)
; }  else 
{ /* Llib/block_ciphers.scm 714 */
BgL_testz00_7546 = ((bool_t)1)
; } }  else 
{ /* Llib/block_ciphers.scm 713 */
BgL_testz00_7546 = ((bool_t)1)
; } 
if(BgL_testz00_7546)
{ /* Llib/block_ciphers.scm 717 */
obj_t BgL_arg1861z00_756;
if(
STRINGP(BgL_ivz00_198))
{ /* Llib/block_ciphers.scm 717 */
BgL_arg1861z00_756 = 
BINT(
STRING_LENGTH(BgL_ivz00_198)); }  else 
{ /* Llib/block_ciphers.scm 717 */
BgL_arg1861z00_756 = BgL_ivz00_198; } 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)22)), BGl_string3748z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1861z00_756); }  else 
{ /* Llib/block_ciphers.scm 713 */BFALSE; } }  else 
{ /* Llib/block_ciphers.scm 711 */
CNST_TABLE_REF(((long)3)); } } } 
{ /* Llib/block_ciphers.scm 720 */
BgL_cipherzd2modezd2statez00_bglt BgL_new1220z00_762;
{ /* Llib/block_ciphers.scm 721 */
BgL_cipherzd2modezd2statez00_bglt BgL_new1219z00_767;
BgL_new1219z00_767 = 
((BgL_cipherzd2modezd2statez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cipherzd2modezd2statez00_bgl) ))); 
{ /* Llib/block_ciphers.scm 721 */
long BgL_arg1867z00_768;
{ /* Llib/block_ciphers.scm 721 */
long BgL_res2801z00_2974;
BgL_res2801z00_2974 = 
BGL_CLASS_INDEX(BGl_Cipherzd2Modezd2Statez00zz__cryptozd2blockzd2ciphersz00); 
BgL_arg1867z00_768 = BgL_res2801z00_2974; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1219z00_767), BgL_arg1867z00_768); } 
{ /* Llib/block_ciphers.scm 721 */
BgL_objectz00_bglt BgL_tmpz00_7564;
BgL_tmpz00_7564 = 
((BgL_objectz00_bglt)BgL_new1219z00_767); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_7564, BFALSE); } 
BgL_new1220z00_762 = BgL_new1219z00_767; } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1220z00_762))->BgL_encryptzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1220z00_762))->BgL_blockzd2siza7ez75)=((long)
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1210z00_741))->BgL_blockzd2siza7ez75)),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1220z00_762))->BgL_cipherzd2statezd2)=((BgL_cipherzd2statezd2_bglt)
((BgL_cipherzd2statezd2_bglt)BgL_statez00_746)),BUNSPEC); 
{ 
obj_t BgL_auxz00_7572;
if(
(BgL_modez00_199==
CNST_TABLE_REF(((long)9))))
{ /* Llib/block_ciphers.scm 725 */
BgL_auxz00_7572 = 
CNST_TABLE_REF(((long)2))
; }  else 
{ /* Llib/block_ciphers.scm 725 */
if(
CBOOL(BgL_ivz00_198))
{ /* Llib/block_ciphers.scm 726 */
BgL_auxz00_7572 = 
CNST_TABLE_REF(((long)0))
; }  else 
{ /* Llib/block_ciphers.scm 726 */
BgL_auxz00_7572 = 
CNST_TABLE_REF(((long)5))
; } } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1220z00_762))->BgL_ivzd2actionzd2)=((obj_t)BgL_auxz00_7572),BUNSPEC); } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1220z00_762))->BgL_ivz00)=((obj_t)BgL_ivz00_198),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1220z00_762))->BgL_padzf2unpadzf2)=((obj_t)BgL_unpadzd2proczd2_744),BUNSPEC); 
{ 
obj_t BgL_auxz00_7584;
{ /* Llib/block_ciphers.scm 730 */
long BgL_arg1866z00_764;
BgL_arg1866z00_764 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1210z00_741))->BgL_blockzd2siza7ez75); 
{ /* Llib/block_ciphers.scm 730 */

{ /* Llib/block_ciphers.scm 730 */
obj_t BgL_res2802z00_2978;
BgL_res2802z00_2978 = 
make_string(BgL_arg1866z00_764, ((unsigned char)' ')); 
BgL_auxz00_7584 = BgL_res2802z00_2978; } } } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1220z00_762))->BgL_loopzd2bufferzd2)=((obj_t)BgL_auxz00_7584),BUNSPEC); } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1220z00_762))->BgL_posz00)=((long)((long)0)),BUNSPEC); 
return BgL_new1220z00_762;} } } } } } } } } 
BGL_FUNCTION_END;
}



/* _encrypt */
obj_t BGl__encryptz00zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_214, obj_t BgL_opt1355z00_213)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 736 */
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_cipherz00_821;obj_t BgL_plainz00_822;obj_t BgL_passwordz00_823;
BgL_cipherz00_821 = 
VECTOR_REF(BgL_opt1355z00_213,((long)0)); 
BgL_plainz00_822 = 
VECTOR_REF(BgL_opt1355z00_213,((long)1)); 
BgL_passwordz00_823 = 
VECTOR_REF(BgL_opt1355z00_213,((long)2)); 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_ivz00_824;
BgL_ivz00_824 = BFALSE; 
{ /* Llib/block_ciphers.scm 737 */
obj_t BgL_modez00_825;
BgL_modez00_825 = 
CNST_TABLE_REF(((long)10)); 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_noncezd2initz12zc0_826;
BgL_noncezd2initz12zc0_826 = BFALSE; 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_noncezd2updatez12zc0_827;
BgL_noncezd2updatez12zc0_827 = BFALSE; 
{ /* Llib/block_ciphers.scm 737 */
obj_t BgL_padz00_828;
BgL_padz00_828 = 
CNST_TABLE_REF(((long)16)); 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_stringzd2ze3keyz31_829;
BgL_stringzd2ze3keyz31_829 = BFALSE; 
{ /* Llib/block_ciphers.scm 736 */

{ 
long BgL_iz00_830;
BgL_iz00_830 = ((long)3); 
BgL_check1358z00_831:
if(
(BgL_iz00_830==
VECTOR_LENGTH(BgL_opt1355z00_213)))
{ /* Llib/block_ciphers.scm 736 */BNIL; }  else 
{ /* Llib/block_ciphers.scm 736 */
bool_t BgL_testz00_7597;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_arg1899z00_837;
BgL_arg1899z00_837 = 
VECTOR_REF(BgL_opt1355z00_213,BgL_iz00_830); 
BgL_testz00_7597 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1899z00_837, 
CNST_TABLE_REF(((long)23)))); } 
if(BgL_testz00_7597)
{ 
long BgL_iz00_7602;
BgL_iz00_7602 = 
(BgL_iz00_830+((long)2)); 
BgL_iz00_830 = BgL_iz00_7602; 
goto BgL_check1358z00_831;}  else 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_arg1898z00_836;
BgL_arg1898z00_836 = 
VECTOR_REF(BgL_opt1355z00_213,BgL_iz00_830); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)24)), BGl_string3749z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1898z00_836); } } } 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_index1360z00_838;
BgL_index1360z00_838 = 
BGl_search1357ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1355z00_213), BgL_opt1355z00_213, 
CNST_TABLE_REF(((long)25)), ((long)3)); 
{ /* Llib/block_ciphers.scm 736 */
bool_t BgL_testz00_7610;
{ /* Llib/block_ciphers.scm 736 */
long BgL_n1z00_3001;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_tmpz00_7611;
if(
INTEGERP(BgL_index1360z00_838))
{ /* Llib/block_ciphers.scm 736 */
BgL_tmpz00_7611 = BgL_index1360z00_838
; }  else 
{ 
obj_t BgL_auxz00_7614;
BgL_auxz00_7614 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26745)), BGl_string3750z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1360z00_838); 
FAILURE(BgL_auxz00_7614,BFALSE,BFALSE);} 
BgL_n1z00_3001 = 
(long)CINT(BgL_tmpz00_7611); } 
BgL_testz00_7610 = 
(BgL_n1z00_3001>=((long)0)); } 
if(BgL_testz00_7610)
{ 
long BgL_auxz00_7620;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_tmpz00_7621;
if(
INTEGERP(BgL_index1360z00_838))
{ /* Llib/block_ciphers.scm 736 */
BgL_tmpz00_7621 = BgL_index1360z00_838
; }  else 
{ 
obj_t BgL_auxz00_7624;
BgL_auxz00_7624 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26745)), BGl_string3750z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1360z00_838); 
FAILURE(BgL_auxz00_7624,BFALSE,BFALSE);} 
BgL_auxz00_7620 = 
(long)CINT(BgL_tmpz00_7621); } 
BgL_ivz00_824 = 
VECTOR_REF(BgL_opt1355z00_213,BgL_auxz00_7620); }  else 
{ /* Llib/block_ciphers.scm 736 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_index1361z00_840;
BgL_index1361z00_840 = 
BGl_search1357ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1355z00_213), BgL_opt1355z00_213, 
CNST_TABLE_REF(((long)26)), ((long)3)); 
{ /* Llib/block_ciphers.scm 736 */
bool_t BgL_testz00_7633;
{ /* Llib/block_ciphers.scm 736 */
long BgL_n1z00_3003;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_tmpz00_7634;
if(
INTEGERP(BgL_index1361z00_840))
{ /* Llib/block_ciphers.scm 736 */
BgL_tmpz00_7634 = BgL_index1361z00_840
; }  else 
{ 
obj_t BgL_auxz00_7637;
BgL_auxz00_7637 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26745)), BGl_string3750z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1361z00_840); 
FAILURE(BgL_auxz00_7637,BFALSE,BFALSE);} 
BgL_n1z00_3003 = 
(long)CINT(BgL_tmpz00_7634); } 
BgL_testz00_7633 = 
(BgL_n1z00_3003>=((long)0)); } 
if(BgL_testz00_7633)
{ 
long BgL_auxz00_7643;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_tmpz00_7644;
if(
INTEGERP(BgL_index1361z00_840))
{ /* Llib/block_ciphers.scm 736 */
BgL_tmpz00_7644 = BgL_index1361z00_840
; }  else 
{ 
obj_t BgL_auxz00_7647;
BgL_auxz00_7647 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26745)), BGl_string3750z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1361z00_840); 
FAILURE(BgL_auxz00_7647,BFALSE,BFALSE);} 
BgL_auxz00_7643 = 
(long)CINT(BgL_tmpz00_7644); } 
BgL_modez00_825 = 
VECTOR_REF(BgL_opt1355z00_213,BgL_auxz00_7643); }  else 
{ /* Llib/block_ciphers.scm 736 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_index1362z00_842;
BgL_index1362z00_842 = 
BGl_search1357ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1355z00_213), BgL_opt1355z00_213, 
CNST_TABLE_REF(((long)27)), ((long)3)); 
{ /* Llib/block_ciphers.scm 736 */
bool_t BgL_testz00_7656;
{ /* Llib/block_ciphers.scm 736 */
long BgL_n1z00_3005;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_tmpz00_7657;
if(
INTEGERP(BgL_index1362z00_842))
{ /* Llib/block_ciphers.scm 736 */
BgL_tmpz00_7657 = BgL_index1362z00_842
; }  else 
{ 
obj_t BgL_auxz00_7660;
BgL_auxz00_7660 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26745)), BGl_string3750z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1362z00_842); 
FAILURE(BgL_auxz00_7660,BFALSE,BFALSE);} 
BgL_n1z00_3005 = 
(long)CINT(BgL_tmpz00_7657); } 
BgL_testz00_7656 = 
(BgL_n1z00_3005>=((long)0)); } 
if(BgL_testz00_7656)
{ 
long BgL_auxz00_7666;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_tmpz00_7667;
if(
INTEGERP(BgL_index1362z00_842))
{ /* Llib/block_ciphers.scm 736 */
BgL_tmpz00_7667 = BgL_index1362z00_842
; }  else 
{ 
obj_t BgL_auxz00_7670;
BgL_auxz00_7670 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26745)), BGl_string3750z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1362z00_842); 
FAILURE(BgL_auxz00_7670,BFALSE,BFALSE);} 
BgL_auxz00_7666 = 
(long)CINT(BgL_tmpz00_7667); } 
BgL_noncezd2initz12zc0_826 = 
VECTOR_REF(BgL_opt1355z00_213,BgL_auxz00_7666); }  else 
{ /* Llib/block_ciphers.scm 736 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_index1363z00_844;
BgL_index1363z00_844 = 
BGl_search1357ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1355z00_213), BgL_opt1355z00_213, 
CNST_TABLE_REF(((long)28)), ((long)3)); 
{ /* Llib/block_ciphers.scm 736 */
bool_t BgL_testz00_7679;
{ /* Llib/block_ciphers.scm 736 */
long BgL_n1z00_3007;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_tmpz00_7680;
if(
INTEGERP(BgL_index1363z00_844))
{ /* Llib/block_ciphers.scm 736 */
BgL_tmpz00_7680 = BgL_index1363z00_844
; }  else 
{ 
obj_t BgL_auxz00_7683;
BgL_auxz00_7683 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26745)), BGl_string3750z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1363z00_844); 
FAILURE(BgL_auxz00_7683,BFALSE,BFALSE);} 
BgL_n1z00_3007 = 
(long)CINT(BgL_tmpz00_7680); } 
BgL_testz00_7679 = 
(BgL_n1z00_3007>=((long)0)); } 
if(BgL_testz00_7679)
{ 
long BgL_auxz00_7689;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_tmpz00_7690;
if(
INTEGERP(BgL_index1363z00_844))
{ /* Llib/block_ciphers.scm 736 */
BgL_tmpz00_7690 = BgL_index1363z00_844
; }  else 
{ 
obj_t BgL_auxz00_7693;
BgL_auxz00_7693 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26745)), BGl_string3750z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1363z00_844); 
FAILURE(BgL_auxz00_7693,BFALSE,BFALSE);} 
BgL_auxz00_7689 = 
(long)CINT(BgL_tmpz00_7690); } 
BgL_noncezd2updatez12zc0_827 = 
VECTOR_REF(BgL_opt1355z00_213,BgL_auxz00_7689); }  else 
{ /* Llib/block_ciphers.scm 736 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_index1364z00_846;
BgL_index1364z00_846 = 
BGl_search1357ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1355z00_213), BgL_opt1355z00_213, 
CNST_TABLE_REF(((long)29)), ((long)3)); 
{ /* Llib/block_ciphers.scm 736 */
bool_t BgL_testz00_7702;
{ /* Llib/block_ciphers.scm 736 */
long BgL_n1z00_3009;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_tmpz00_7703;
if(
INTEGERP(BgL_index1364z00_846))
{ /* Llib/block_ciphers.scm 736 */
BgL_tmpz00_7703 = BgL_index1364z00_846
; }  else 
{ 
obj_t BgL_auxz00_7706;
BgL_auxz00_7706 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26745)), BGl_string3750z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1364z00_846); 
FAILURE(BgL_auxz00_7706,BFALSE,BFALSE);} 
BgL_n1z00_3009 = 
(long)CINT(BgL_tmpz00_7703); } 
BgL_testz00_7702 = 
(BgL_n1z00_3009>=((long)0)); } 
if(BgL_testz00_7702)
{ 
long BgL_auxz00_7712;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_tmpz00_7713;
if(
INTEGERP(BgL_index1364z00_846))
{ /* Llib/block_ciphers.scm 736 */
BgL_tmpz00_7713 = BgL_index1364z00_846
; }  else 
{ 
obj_t BgL_auxz00_7716;
BgL_auxz00_7716 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26745)), BGl_string3750z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1364z00_846); 
FAILURE(BgL_auxz00_7716,BFALSE,BFALSE);} 
BgL_auxz00_7712 = 
(long)CINT(BgL_tmpz00_7713); } 
BgL_padz00_828 = 
VECTOR_REF(BgL_opt1355z00_213,BgL_auxz00_7712); }  else 
{ /* Llib/block_ciphers.scm 736 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_index1365z00_848;
BgL_index1365z00_848 = 
BGl_search1357ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1355z00_213), BgL_opt1355z00_213, 
CNST_TABLE_REF(((long)30)), ((long)3)); 
{ /* Llib/block_ciphers.scm 736 */
bool_t BgL_testz00_7725;
{ /* Llib/block_ciphers.scm 736 */
long BgL_n1z00_3011;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_tmpz00_7726;
if(
INTEGERP(BgL_index1365z00_848))
{ /* Llib/block_ciphers.scm 736 */
BgL_tmpz00_7726 = BgL_index1365z00_848
; }  else 
{ 
obj_t BgL_auxz00_7729;
BgL_auxz00_7729 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26745)), BGl_string3750z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1365z00_848); 
FAILURE(BgL_auxz00_7729,BFALSE,BFALSE);} 
BgL_n1z00_3011 = 
(long)CINT(BgL_tmpz00_7726); } 
BgL_testz00_7725 = 
(BgL_n1z00_3011>=((long)0)); } 
if(BgL_testz00_7725)
{ 
long BgL_auxz00_7735;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_tmpz00_7736;
if(
INTEGERP(BgL_index1365z00_848))
{ /* Llib/block_ciphers.scm 736 */
BgL_tmpz00_7736 = BgL_index1365z00_848
; }  else 
{ 
obj_t BgL_auxz00_7739;
BgL_auxz00_7739 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26745)), BGl_string3750z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1365z00_848); 
FAILURE(BgL_auxz00_7739,BFALSE,BFALSE);} 
BgL_auxz00_7735 = 
(long)CINT(BgL_tmpz00_7736); } 
BgL_stringzd2ze3keyz31_829 = 
VECTOR_REF(BgL_opt1355z00_213,BgL_auxz00_7735); }  else 
{ /* Llib/block_ciphers.scm 736 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_arg1906z00_850;obj_t BgL_arg1907z00_851;obj_t BgL_arg1908z00_852;
BgL_arg1906z00_850 = 
VECTOR_REF(BgL_opt1355z00_213,((long)0)); 
BgL_arg1907z00_851 = 
VECTOR_REF(BgL_opt1355z00_213,((long)1)); 
BgL_arg1908z00_852 = 
VECTOR_REF(BgL_opt1355z00_213,((long)2)); 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_ivz00_853;
BgL_ivz00_853 = BgL_ivz00_824; 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_modez00_854;
BgL_modez00_854 = BgL_modez00_825; 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_noncezd2initz12zc0_855;
BgL_noncezd2initz12zc0_855 = BgL_noncezd2initz12zc0_826; 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_noncezd2updatez12zc0_856;
BgL_noncezd2updatez12zc0_856 = BgL_noncezd2updatez12zc0_827; 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_padz00_857;
BgL_padz00_857 = BgL_padz00_828; 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_stringzd2ze3keyz31_858;
BgL_stringzd2ze3keyz31_858 = BgL_stringzd2ze3keyz31_829; 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_res2819z00_3023;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_cipherz00_3013;obj_t BgL_passwordz00_3014;
if(
SYMBOLP(BgL_arg1906z00_850))
{ /* Llib/block_ciphers.scm 736 */
BgL_cipherz00_3013 = BgL_arg1906z00_850; }  else 
{ 
obj_t BgL_auxz00_7750;
BgL_auxz00_7750 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26745)), BGl_string3750z00zz__cryptozd2blockzd2ciphersz00, BGl_string3752z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1906z00_850); 
FAILURE(BgL_auxz00_7750,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg1908z00_852))
{ /* Llib/block_ciphers.scm 736 */
BgL_passwordz00_3014 = BgL_arg1908z00_852; }  else 
{ 
obj_t BgL_auxz00_7756;
BgL_auxz00_7756 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26745)), BGl_string3750z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1908z00_852); 
FAILURE(BgL_auxz00_7756,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 740 */
obj_t BgL_redirectz00_3015;
if(
STRINGP(BgL_arg1907z00_851))
{ /* Llib/block_ciphers.scm 741 */
BgL_redirectz00_3015 = BGl_encryptzd2fastzd2stringzd2envzd2zz__cryptozd2blockzd2ciphersz00; }  else 
{ /* Llib/block_ciphers.scm 742 */
bool_t BgL_testz00_7762;
{ /* Llib/block_ciphers.scm 742 */
bool_t BgL_res2817z00_3020;
BgL_res2817z00_3020 = 
BGL_MMAPP(BgL_arg1907z00_851); 
BgL_testz00_7762 = BgL_res2817z00_3020; } 
if(BgL_testz00_7762)
{ /* Llib/block_ciphers.scm 742 */
BgL_redirectz00_3015 = BGl_encryptzd2fastzd2mmapzd2envzd2zz__cryptozd2blockzd2ciphersz00; }  else 
{ /* Llib/block_ciphers.scm 743 */
bool_t BgL_testz00_7764;
{ /* Llib/block_ciphers.scm 743 */
bool_t BgL__ortest_1056z00_3021;
BgL__ortest_1056z00_3021 = 
OUTPUT_PORTP(BgL_arg1907z00_851); 
if(BgL__ortest_1056z00_3021)
{ /* Llib/block_ciphers.scm 743 */
BgL_testz00_7764 = BgL__ortest_1056z00_3021
; }  else 
{ /* Llib/block_ciphers.scm 743 */
BgL_testz00_7764 = 
INPUT_PORTP(BgL_arg1907z00_851)
; } } 
if(BgL_testz00_7764)
{ /* Llib/block_ciphers.scm 743 */
BgL_redirectz00_3015 = BGl_encryptzd2fastzd2portzd2envzd2zz__cryptozd2blockzd2ciphersz00; }  else 
{ /* Llib/block_ciphers.scm 743 */
CNST_TABLE_REF(((long)15)); 
BgL_redirectz00_3015 = BgL_arg1907z00_851; } } } 
{ /* Llib/block_ciphers.scm 747 */
obj_t BgL_aux3335z00_5705;
{ /* Llib/block_ciphers.scm 747 */
obj_t BgL_tmpz00_7780;
{ /* Llib/block_ciphers.scm 747 */
bool_t BgL_test3334z00_5704;
BgL_test3334z00_5704 = 
PROCEDUREP(BgL_redirectz00_3015); 
if(BgL_test3334z00_5704)
{ /* Llib/block_ciphers.scm 747 */
BgL_tmpz00_7780 = BgL_redirectz00_3015
; }  else 
{ 
obj_t BgL_auxz00_7783;
BgL_auxz00_7783 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27156)), BGl_string3750z00zz__cryptozd2blockzd2ciphersz00, BGl_string3753z00zz__cryptozd2blockzd2ciphersz00, BgL_redirectz00_3015); 
FAILURE(BgL_auxz00_7783,BFALSE,BFALSE);} } 
BgL_aux3335z00_5705 = 
PROCEDURE_ENTRY(BgL_tmpz00_7780)(BgL_redirectz00_3015, BgL_cipherz00_3013, BgL_arg1907z00_851, BgL_passwordz00_3014, BgL_ivz00_853, BgL_modez00_854, BgL_padz00_857, BgL_noncezd2initz12zc0_855, BgL_noncezd2updatez12zc0_856, BgL_stringzd2ze3keyz31_858, BEOA); } 
if(
STRINGP(BgL_aux3335z00_5705))
{ /* Llib/block_ciphers.scm 747 */
BgL_res2819z00_3023 = BgL_aux3335z00_5705; }  else 
{ 
obj_t BgL_auxz00_7789;
BgL_auxz00_7789 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27156)), BGl_string3750z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_aux3335z00_5705); 
FAILURE(BgL_auxz00_7789,BFALSE,BFALSE);} } } } 
return BgL_res2819z00_3023;} } } } } } } } } } } } } } } } } 
BGL_FUNCTION_END;
}



/* search1357~0 */
obj_t BGl_search1357ze70ze7zz__cryptozd2blockzd2ciphersz00(long BgL_l1356z00_5666, obj_t BgL_opt1355z00_5665, obj_t BgL_k1z00_818, long BgL_iz00_819)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 736 */
BGl_search1357ze70ze7zz__cryptozd2blockzd2ciphersz00:
if(
(BgL_iz00_819==BgL_l1356z00_5666))
{ /* Llib/block_ciphers.scm 736 */
return 
BINT(((long)-1));}  else 
{ /* Llib/block_ciphers.scm 736 */
if(
(BgL_iz00_819==
(BgL_l1356z00_5666-((long)1))))
{ /* Llib/block_ciphers.scm 736 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)24)), BGl_string3754z00zz__cryptozd2blockzd2ciphersz00, 
BINT(
VECTOR_LENGTH(BgL_opt1355z00_5665)));}  else 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_vz00_863;
BgL_vz00_863 = 
VECTOR_REF(BgL_opt1355z00_5665,BgL_iz00_819); 
if(
(BgL_vz00_863==BgL_k1z00_818))
{ /* Llib/block_ciphers.scm 736 */
return 
BINT(
(BgL_iz00_819+((long)1)));}  else 
{ 
long BgL_iz00_7808;
BgL_iz00_7808 = 
(BgL_iz00_819+((long)2)); 
BgL_iz00_819 = BgL_iz00_7808; 
goto BGl_search1357ze70ze7zz__cryptozd2blockzd2ciphersz00;} } } } 
BGL_FUNCTION_END;
}



/* encrypt */
BGL_EXPORTED_DEF obj_t BGl_encryptz00zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_204, obj_t BgL_plaintextz00_205, obj_t BgL_passwordz00_206, obj_t BgL_ivz00_207, obj_t BgL_modez00_208, obj_t BgL_noncezd2initz12zc0_209, obj_t BgL_noncezd2updatez12zc0_210, obj_t BgL_padz00_211, obj_t BgL_stringzd2ze3keyz31_212)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 736 */
{ /* Llib/block_ciphers.scm 740 */
obj_t BgL_redirectz00_3024;
if(
STRINGP(BgL_plaintextz00_205))
{ /* Llib/block_ciphers.scm 741 */
BgL_redirectz00_3024 = BGl_encryptzd2fastzd2stringzd2envzd2zz__cryptozd2blockzd2ciphersz00; }  else 
{ /* Llib/block_ciphers.scm 742 */
bool_t BgL_testz00_7812;
{ /* Llib/block_ciphers.scm 742 */
bool_t BgL_res2821z00_3029;
BgL_res2821z00_3029 = 
BGL_MMAPP(BgL_plaintextz00_205); 
BgL_testz00_7812 = BgL_res2821z00_3029; } 
if(BgL_testz00_7812)
{ /* Llib/block_ciphers.scm 742 */
BgL_redirectz00_3024 = BGl_encryptzd2fastzd2mmapzd2envzd2zz__cryptozd2blockzd2ciphersz00; }  else 
{ /* Llib/block_ciphers.scm 743 */
bool_t BgL_testz00_7814;
{ /* Llib/block_ciphers.scm 743 */
bool_t BgL__ortest_1056z00_3030;
BgL__ortest_1056z00_3030 = 
OUTPUT_PORTP(BgL_plaintextz00_205); 
if(BgL__ortest_1056z00_3030)
{ /* Llib/block_ciphers.scm 743 */
BgL_testz00_7814 = BgL__ortest_1056z00_3030
; }  else 
{ /* Llib/block_ciphers.scm 743 */
BgL_testz00_7814 = 
INPUT_PORTP(BgL_plaintextz00_205)
; } } 
if(BgL_testz00_7814)
{ /* Llib/block_ciphers.scm 743 */
BgL_redirectz00_3024 = BGl_encryptzd2fastzd2portzd2envzd2zz__cryptozd2blockzd2ciphersz00; }  else 
{ /* Llib/block_ciphers.scm 743 */
CNST_TABLE_REF(((long)15)); 
BgL_redirectz00_3024 = BgL_plaintextz00_205; } } } 
return 
PROCEDURE_ENTRY(BgL_redirectz00_3024)(BgL_redirectz00_3024, BgL_cipherz00_204, BgL_plaintextz00_205, BgL_passwordz00_206, BgL_ivz00_207, BgL_modez00_208, BgL_padz00_211, BgL_noncezd2initz12zc0_209, BgL_noncezd2updatez12zc0_210, BgL_stringzd2ze3keyz31_212, BEOA);} } 
BGL_FUNCTION_END;
}



/* _encrypt-string */
obj_t BGl__encryptzd2stringzd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_225, obj_t BgL_opt1366z00_224)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 750 */
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_cipherz00_875;obj_t BgL_plaintextz00_876;obj_t BgL_passwordz00_877;
BgL_cipherz00_875 = 
VECTOR_REF(BgL_opt1366z00_224,((long)0)); 
BgL_plaintextz00_876 = 
VECTOR_REF(BgL_opt1366z00_224,((long)1)); 
BgL_passwordz00_877 = 
VECTOR_REF(BgL_opt1366z00_224,((long)2)); 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_ivz00_878;
BgL_ivz00_878 = BFALSE; 
{ /* Llib/block_ciphers.scm 751 */
obj_t BgL_modez00_879;
BgL_modez00_879 = 
CNST_TABLE_REF(((long)10)); 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_noncezd2initz12zc0_880;
BgL_noncezd2initz12zc0_880 = BFALSE; 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_noncezd2updatez12zc0_881;
BgL_noncezd2updatez12zc0_881 = BFALSE; 
{ /* Llib/block_ciphers.scm 752 */
obj_t BgL_padz00_882;
BgL_padz00_882 = 
CNST_TABLE_REF(((long)16)); 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_stringzd2ze3keyz31_883;
BgL_stringzd2ze3keyz31_883 = BFALSE; 
{ /* Llib/block_ciphers.scm 750 */

{ 
long BgL_iz00_884;
BgL_iz00_884 = ((long)3); 
BgL_check1369z00_885:
if(
(BgL_iz00_884==
VECTOR_LENGTH(BgL_opt1366z00_224)))
{ /* Llib/block_ciphers.scm 750 */BNIL; }  else 
{ /* Llib/block_ciphers.scm 750 */
bool_t BgL_testz00_7839;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_arg1924z00_891;
BgL_arg1924z00_891 = 
VECTOR_REF(BgL_opt1366z00_224,BgL_iz00_884); 
BgL_testz00_7839 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1924z00_891, 
CNST_TABLE_REF(((long)23)))); } 
if(BgL_testz00_7839)
{ 
long BgL_iz00_7844;
BgL_iz00_7844 = 
(BgL_iz00_884+((long)2)); 
BgL_iz00_884 = BgL_iz00_7844; 
goto BgL_check1369z00_885;}  else 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_arg1923z00_890;
BgL_arg1923z00_890 = 
VECTOR_REF(BgL_opt1366z00_224,BgL_iz00_884); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)31)), BGl_string3749z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1923z00_890); } } } 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_index1371z00_892;
BgL_index1371z00_892 = 
BGl_search1368ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1366z00_224), BgL_opt1366z00_224, 
CNST_TABLE_REF(((long)25)), ((long)3)); 
{ /* Llib/block_ciphers.scm 750 */
bool_t BgL_testz00_7852;
{ /* Llib/block_ciphers.scm 750 */
long BgL_n1z00_3054;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_tmpz00_7853;
if(
INTEGERP(BgL_index1371z00_892))
{ /* Llib/block_ciphers.scm 750 */
BgL_tmpz00_7853 = BgL_index1371z00_892
; }  else 
{ 
obj_t BgL_auxz00_7856;
BgL_auxz00_7856 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27248)), BGl_string3755z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1371z00_892); 
FAILURE(BgL_auxz00_7856,BFALSE,BFALSE);} 
BgL_n1z00_3054 = 
(long)CINT(BgL_tmpz00_7853); } 
BgL_testz00_7852 = 
(BgL_n1z00_3054>=((long)0)); } 
if(BgL_testz00_7852)
{ 
long BgL_auxz00_7862;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_tmpz00_7863;
if(
INTEGERP(BgL_index1371z00_892))
{ /* Llib/block_ciphers.scm 750 */
BgL_tmpz00_7863 = BgL_index1371z00_892
; }  else 
{ 
obj_t BgL_auxz00_7866;
BgL_auxz00_7866 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27248)), BGl_string3755z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1371z00_892); 
FAILURE(BgL_auxz00_7866,BFALSE,BFALSE);} 
BgL_auxz00_7862 = 
(long)CINT(BgL_tmpz00_7863); } 
BgL_ivz00_878 = 
VECTOR_REF(BgL_opt1366z00_224,BgL_auxz00_7862); }  else 
{ /* Llib/block_ciphers.scm 750 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_index1372z00_894;
BgL_index1372z00_894 = 
BGl_search1368ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1366z00_224), BgL_opt1366z00_224, 
CNST_TABLE_REF(((long)26)), ((long)3)); 
{ /* Llib/block_ciphers.scm 750 */
bool_t BgL_testz00_7875;
{ /* Llib/block_ciphers.scm 750 */
long BgL_n1z00_3056;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_tmpz00_7876;
if(
INTEGERP(BgL_index1372z00_894))
{ /* Llib/block_ciphers.scm 750 */
BgL_tmpz00_7876 = BgL_index1372z00_894
; }  else 
{ 
obj_t BgL_auxz00_7879;
BgL_auxz00_7879 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27248)), BGl_string3755z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1372z00_894); 
FAILURE(BgL_auxz00_7879,BFALSE,BFALSE);} 
BgL_n1z00_3056 = 
(long)CINT(BgL_tmpz00_7876); } 
BgL_testz00_7875 = 
(BgL_n1z00_3056>=((long)0)); } 
if(BgL_testz00_7875)
{ 
long BgL_auxz00_7885;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_tmpz00_7886;
if(
INTEGERP(BgL_index1372z00_894))
{ /* Llib/block_ciphers.scm 750 */
BgL_tmpz00_7886 = BgL_index1372z00_894
; }  else 
{ 
obj_t BgL_auxz00_7889;
BgL_auxz00_7889 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27248)), BGl_string3755z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1372z00_894); 
FAILURE(BgL_auxz00_7889,BFALSE,BFALSE);} 
BgL_auxz00_7885 = 
(long)CINT(BgL_tmpz00_7886); } 
BgL_modez00_879 = 
VECTOR_REF(BgL_opt1366z00_224,BgL_auxz00_7885); }  else 
{ /* Llib/block_ciphers.scm 750 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_index1373z00_896;
BgL_index1373z00_896 = 
BGl_search1368ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1366z00_224), BgL_opt1366z00_224, 
CNST_TABLE_REF(((long)27)), ((long)3)); 
{ /* Llib/block_ciphers.scm 750 */
bool_t BgL_testz00_7898;
{ /* Llib/block_ciphers.scm 750 */
long BgL_n1z00_3058;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_tmpz00_7899;
if(
INTEGERP(BgL_index1373z00_896))
{ /* Llib/block_ciphers.scm 750 */
BgL_tmpz00_7899 = BgL_index1373z00_896
; }  else 
{ 
obj_t BgL_auxz00_7902;
BgL_auxz00_7902 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27248)), BGl_string3755z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1373z00_896); 
FAILURE(BgL_auxz00_7902,BFALSE,BFALSE);} 
BgL_n1z00_3058 = 
(long)CINT(BgL_tmpz00_7899); } 
BgL_testz00_7898 = 
(BgL_n1z00_3058>=((long)0)); } 
if(BgL_testz00_7898)
{ 
long BgL_auxz00_7908;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_tmpz00_7909;
if(
INTEGERP(BgL_index1373z00_896))
{ /* Llib/block_ciphers.scm 750 */
BgL_tmpz00_7909 = BgL_index1373z00_896
; }  else 
{ 
obj_t BgL_auxz00_7912;
BgL_auxz00_7912 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27248)), BGl_string3755z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1373z00_896); 
FAILURE(BgL_auxz00_7912,BFALSE,BFALSE);} 
BgL_auxz00_7908 = 
(long)CINT(BgL_tmpz00_7909); } 
BgL_noncezd2initz12zc0_880 = 
VECTOR_REF(BgL_opt1366z00_224,BgL_auxz00_7908); }  else 
{ /* Llib/block_ciphers.scm 750 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_index1374z00_898;
BgL_index1374z00_898 = 
BGl_search1368ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1366z00_224), BgL_opt1366z00_224, 
CNST_TABLE_REF(((long)28)), ((long)3)); 
{ /* Llib/block_ciphers.scm 750 */
bool_t BgL_testz00_7921;
{ /* Llib/block_ciphers.scm 750 */
long BgL_n1z00_3060;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_tmpz00_7922;
if(
INTEGERP(BgL_index1374z00_898))
{ /* Llib/block_ciphers.scm 750 */
BgL_tmpz00_7922 = BgL_index1374z00_898
; }  else 
{ 
obj_t BgL_auxz00_7925;
BgL_auxz00_7925 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27248)), BGl_string3755z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1374z00_898); 
FAILURE(BgL_auxz00_7925,BFALSE,BFALSE);} 
BgL_n1z00_3060 = 
(long)CINT(BgL_tmpz00_7922); } 
BgL_testz00_7921 = 
(BgL_n1z00_3060>=((long)0)); } 
if(BgL_testz00_7921)
{ 
long BgL_auxz00_7931;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_tmpz00_7932;
if(
INTEGERP(BgL_index1374z00_898))
{ /* Llib/block_ciphers.scm 750 */
BgL_tmpz00_7932 = BgL_index1374z00_898
; }  else 
{ 
obj_t BgL_auxz00_7935;
BgL_auxz00_7935 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27248)), BGl_string3755z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1374z00_898); 
FAILURE(BgL_auxz00_7935,BFALSE,BFALSE);} 
BgL_auxz00_7931 = 
(long)CINT(BgL_tmpz00_7932); } 
BgL_noncezd2updatez12zc0_881 = 
VECTOR_REF(BgL_opt1366z00_224,BgL_auxz00_7931); }  else 
{ /* Llib/block_ciphers.scm 750 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_index1375z00_900;
BgL_index1375z00_900 = 
BGl_search1368ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1366z00_224), BgL_opt1366z00_224, 
CNST_TABLE_REF(((long)29)), ((long)3)); 
{ /* Llib/block_ciphers.scm 750 */
bool_t BgL_testz00_7944;
{ /* Llib/block_ciphers.scm 750 */
long BgL_n1z00_3062;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_tmpz00_7945;
if(
INTEGERP(BgL_index1375z00_900))
{ /* Llib/block_ciphers.scm 750 */
BgL_tmpz00_7945 = BgL_index1375z00_900
; }  else 
{ 
obj_t BgL_auxz00_7948;
BgL_auxz00_7948 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27248)), BGl_string3755z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1375z00_900); 
FAILURE(BgL_auxz00_7948,BFALSE,BFALSE);} 
BgL_n1z00_3062 = 
(long)CINT(BgL_tmpz00_7945); } 
BgL_testz00_7944 = 
(BgL_n1z00_3062>=((long)0)); } 
if(BgL_testz00_7944)
{ 
long BgL_auxz00_7954;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_tmpz00_7955;
if(
INTEGERP(BgL_index1375z00_900))
{ /* Llib/block_ciphers.scm 750 */
BgL_tmpz00_7955 = BgL_index1375z00_900
; }  else 
{ 
obj_t BgL_auxz00_7958;
BgL_auxz00_7958 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27248)), BGl_string3755z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1375z00_900); 
FAILURE(BgL_auxz00_7958,BFALSE,BFALSE);} 
BgL_auxz00_7954 = 
(long)CINT(BgL_tmpz00_7955); } 
BgL_padz00_882 = 
VECTOR_REF(BgL_opt1366z00_224,BgL_auxz00_7954); }  else 
{ /* Llib/block_ciphers.scm 750 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_index1376z00_902;
BgL_index1376z00_902 = 
BGl_search1368ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1366z00_224), BgL_opt1366z00_224, 
CNST_TABLE_REF(((long)30)), ((long)3)); 
{ /* Llib/block_ciphers.scm 750 */
bool_t BgL_testz00_7967;
{ /* Llib/block_ciphers.scm 750 */
long BgL_n1z00_3064;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_tmpz00_7968;
if(
INTEGERP(BgL_index1376z00_902))
{ /* Llib/block_ciphers.scm 750 */
BgL_tmpz00_7968 = BgL_index1376z00_902
; }  else 
{ 
obj_t BgL_auxz00_7971;
BgL_auxz00_7971 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27248)), BGl_string3755z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1376z00_902); 
FAILURE(BgL_auxz00_7971,BFALSE,BFALSE);} 
BgL_n1z00_3064 = 
(long)CINT(BgL_tmpz00_7968); } 
BgL_testz00_7967 = 
(BgL_n1z00_3064>=((long)0)); } 
if(BgL_testz00_7967)
{ 
long BgL_auxz00_7977;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_tmpz00_7978;
if(
INTEGERP(BgL_index1376z00_902))
{ /* Llib/block_ciphers.scm 750 */
BgL_tmpz00_7978 = BgL_index1376z00_902
; }  else 
{ 
obj_t BgL_auxz00_7981;
BgL_auxz00_7981 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27248)), BGl_string3755z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1376z00_902); 
FAILURE(BgL_auxz00_7981,BFALSE,BFALSE);} 
BgL_auxz00_7977 = 
(long)CINT(BgL_tmpz00_7978); } 
BgL_stringzd2ze3keyz31_883 = 
VECTOR_REF(BgL_opt1366z00_224,BgL_auxz00_7977); }  else 
{ /* Llib/block_ciphers.scm 750 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_arg1931z00_904;obj_t BgL_arg1932z00_905;obj_t BgL_arg1933z00_906;
BgL_arg1931z00_904 = 
VECTOR_REF(BgL_opt1366z00_224,((long)0)); 
BgL_arg1932z00_905 = 
VECTOR_REF(BgL_opt1366z00_224,((long)1)); 
BgL_arg1933z00_906 = 
VECTOR_REF(BgL_opt1366z00_224,((long)2)); 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_ivz00_907;
BgL_ivz00_907 = BgL_ivz00_878; 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_modez00_908;
BgL_modez00_908 = BgL_modez00_879; 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_noncezd2initz12zc0_909;
BgL_noncezd2initz12zc0_909 = BgL_noncezd2initz12zc0_880; 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_noncezd2updatez12zc0_910;
BgL_noncezd2updatez12zc0_910 = BgL_noncezd2updatez12zc0_881; 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_padz00_911;
BgL_padz00_911 = BgL_padz00_882; 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_stringzd2ze3keyz31_912;
BgL_stringzd2ze3keyz31_912 = BgL_stringzd2ze3keyz31_883; 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_res2836z00_3069;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_cipherz00_3066;obj_t BgL_plaintextz00_3067;obj_t BgL_passwordz00_3068;
if(
SYMBOLP(BgL_arg1931z00_904))
{ /* Llib/block_ciphers.scm 750 */
BgL_cipherz00_3066 = BgL_arg1931z00_904; }  else 
{ 
obj_t BgL_auxz00_7992;
BgL_auxz00_7992 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27248)), BGl_string3755z00zz__cryptozd2blockzd2ciphersz00, BGl_string3752z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1931z00_904); 
FAILURE(BgL_auxz00_7992,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg1932z00_905))
{ /* Llib/block_ciphers.scm 750 */
BgL_plaintextz00_3067 = BgL_arg1932z00_905; }  else 
{ 
obj_t BgL_auxz00_7998;
BgL_auxz00_7998 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27248)), BGl_string3755z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1932z00_905); 
FAILURE(BgL_auxz00_7998,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg1933z00_906))
{ /* Llib/block_ciphers.scm 750 */
BgL_passwordz00_3068 = BgL_arg1933z00_906; }  else 
{ 
obj_t BgL_auxz00_8004;
BgL_auxz00_8004 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27248)), BGl_string3755z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1933z00_906); 
FAILURE(BgL_auxz00_8004,BFALSE,BFALSE);} 
BgL_res2836z00_3069 = 
BGl_encryptzd2fastzd2stringz00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_3066, BgL_plaintextz00_3067, BgL_passwordz00_3068, BgL_ivz00_907, BgL_modez00_908, BgL_padz00_911, BgL_noncezd2initz12zc0_909, BgL_noncezd2updatez12zc0_910, BgL_stringzd2ze3keyz31_912); } 
return BgL_res2836z00_3069;} } } } } } } } } } } } } } } } } 
BGL_FUNCTION_END;
}



/* search1368~0 */
obj_t BGl_search1368ze70ze7zz__cryptozd2blockzd2ciphersz00(long BgL_l1367z00_5664, obj_t BgL_opt1366z00_5663, obj_t BgL_k1z00_872, long BgL_iz00_873)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 750 */
BGl_search1368ze70ze7zz__cryptozd2blockzd2ciphersz00:
if(
(BgL_iz00_873==BgL_l1367z00_5664))
{ /* Llib/block_ciphers.scm 750 */
return 
BINT(((long)-1));}  else 
{ /* Llib/block_ciphers.scm 750 */
if(
(BgL_iz00_873==
(BgL_l1367z00_5664-((long)1))))
{ /* Llib/block_ciphers.scm 750 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)31)), BGl_string3754z00zz__cryptozd2blockzd2ciphersz00, 
BINT(
VECTOR_LENGTH(BgL_opt1366z00_5663)));}  else 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_vz00_917;
BgL_vz00_917 = 
VECTOR_REF(BgL_opt1366z00_5663,BgL_iz00_873); 
if(
(BgL_vz00_917==BgL_k1z00_872))
{ /* Llib/block_ciphers.scm 750 */
return 
BINT(
(BgL_iz00_873+((long)1)));}  else 
{ 
long BgL_iz00_8024;
BgL_iz00_8024 = 
(BgL_iz00_873+((long)2)); 
BgL_iz00_873 = BgL_iz00_8024; 
goto BGl_search1368ze70ze7zz__cryptozd2blockzd2ciphersz00;} } } } 
BGL_FUNCTION_END;
}



/* encrypt-string */
BGL_EXPORTED_DEF obj_t BGl_encryptzd2stringzd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_215, obj_t BgL_plaintextz00_216, obj_t BgL_passwordz00_217, obj_t BgL_ivz00_218, obj_t BgL_modez00_219, obj_t BgL_noncezd2initz12zc0_220, obj_t BgL_noncezd2updatez12zc0_221, obj_t BgL_padz00_222, obj_t BgL_stringzd2ze3keyz31_223)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 750 */
{ /* Llib/block_ciphers.scm 765 */
BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3071;
BgL_statez00_3071 = 
BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_215, BgL_passwordz00_217, BgL_ivz00_218, BgL_modez00_219, BgL_padz00_222, BgL_noncezd2initz12zc0_220, BgL_noncezd2updatez12zc0_221, BgL_stringzd2ze3keyz31_223); 
{ /* Llib/block_ciphers.scm 765 */
long BgL_blockzd2siza7ez75_3072;
BgL_blockzd2siza7ez75_3072 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_statez00_3071))->BgL_blockzd2siza7ez75); 
{ /* Llib/block_ciphers.scm 768 */
obj_t BgL_strz00_3074;
{ /* Llib/block_ciphers.scm 770 */
long BgL_arg1942z00_3075;
BgL_arg1942z00_3075 = 
(
(((long)2)*BgL_blockzd2siza7ez75_3072)+
STRING_LENGTH(BgL_plaintextz00_216)); 
{ /* Llib/block_ciphers.scm 770 */

BgL_strz00_3074 = 
make_string(BgL_arg1942z00_3075, ((unsigned char)' ')); } } 
{ /* Llib/block_ciphers.scm 770 */

{ /* Llib/block_ciphers.scm 771 */
long BgL_tmpz00_8032;
BgL_tmpz00_8032 = 
BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3071, BgL_plaintextz00_216, ((long)0), BGl_readzd2stringzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_strz00_3074, ((long)0), BGl_blitzd2stringzd2urz12zd2envzc0zz__r4_strings_6_7z00); 
return 
bgl_string_shrink(BgL_strz00_3074, BgL_tmpz00_8032);} } } } } } 
BGL_FUNCTION_END;
}



/* encrypt-fast-string */
obj_t BGl_encryptzd2fastzd2stringz00zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_226, obj_t BgL_plaintextz00_227, obj_t BgL_passwordz00_228, obj_t BgL_ivz00_229, obj_t BgL_modez00_230, obj_t BgL_padz00_231, obj_t BgL_noncezd2initz12zc0_232, obj_t BgL_noncezd2updatez12zc0_233, obj_t BgL_stringzd2ze3keyz31_234)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 759 */
{ /* Llib/block_ciphers.scm 765 */
BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3092;
BgL_statez00_3092 = 
BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_226, BgL_passwordz00_228, BgL_ivz00_229, BgL_modez00_230, BgL_padz00_231, BgL_noncezd2initz12zc0_232, BgL_noncezd2updatez12zc0_233, BgL_stringzd2ze3keyz31_234); 
{ /* Llib/block_ciphers.scm 765 */
long BgL_blockzd2siza7ez75_3093;
BgL_blockzd2siza7ez75_3093 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_statez00_3092))->BgL_blockzd2siza7ez75); 
{ /* Llib/block_ciphers.scm 768 */
obj_t BgL_strz00_3095;
{ /* Llib/block_ciphers.scm 770 */
long BgL_arg1942z00_3096;
BgL_arg1942z00_3096 = 
(
(((long)2)*BgL_blockzd2siza7ez75_3093)+
STRING_LENGTH(BgL_plaintextz00_227)); 
{ /* Llib/block_ciphers.scm 770 */

BgL_strz00_3095 = 
make_string(BgL_arg1942z00_3096, ((unsigned char)' ')); } } 
{ /* Llib/block_ciphers.scm 770 */

{ /* Llib/block_ciphers.scm 771 */
long BgL_tmpz00_8041;
BgL_tmpz00_8041 = 
BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3092, BgL_plaintextz00_227, ((long)0), BGl_readzd2stringzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_strz00_3095, ((long)0), BGl_blitzd2stringzd2urz12zd2envzc0zz__r4_strings_6_7z00); 
return 
bgl_string_shrink(BgL_strz00_3095, BgL_tmpz00_8041);} } } } } } 
BGL_FUNCTION_END;
}



/* &encrypt-fast-string */
obj_t BGl_z62encryptzd2fastzd2stringz62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4975, obj_t BgL_cipherz00_4976, obj_t BgL_plaintextz00_4977, obj_t BgL_passwordz00_4978, obj_t BgL_ivz00_4979, obj_t BgL_modez00_4980, obj_t BgL_padz00_4981, obj_t BgL_noncezd2initz12zc0_4982, obj_t BgL_noncezd2updatez12zc0_4983, obj_t BgL_stringzd2ze3keyz31_4984)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 759 */
{ /* Llib/block_ciphers.scm 765 */
obj_t BgL_auxz00_8044;
if(
STRINGP(BgL_plaintextz00_4977))
{ /* Llib/block_ciphers.scm 765 */
BgL_auxz00_8044 = BgL_plaintextz00_4977
; }  else 
{ 
obj_t BgL_auxz00_8047;
BgL_auxz00_8047 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27766)), BGl_string3756z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_plaintextz00_4977); 
FAILURE(BgL_auxz00_8047,BFALSE,BFALSE);} 
return 
BGl_encryptzd2fastzd2stringz00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_4976, BgL_auxz00_8044, BgL_passwordz00_4978, BgL_ivz00_4979, BgL_modez00_4980, BgL_padz00_4981, BgL_noncezd2initz12zc0_4982, BgL_noncezd2updatez12zc0_4983, BgL_stringzd2ze3keyz31_4984);} } 
BGL_FUNCTION_END;
}



/* _encrypt-mmap */
obj_t BGl__encryptzd2mmapzd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_245, obj_t BgL_opt1377z00_244)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 776 */
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_cipherz00_935;obj_t BgL_plaintextz00_936;obj_t BgL_passwordz00_937;
BgL_cipherz00_935 = 
VECTOR_REF(BgL_opt1377z00_244,((long)0)); 
BgL_plaintextz00_936 = 
VECTOR_REF(BgL_opt1377z00_244,((long)1)); 
BgL_passwordz00_937 = 
VECTOR_REF(BgL_opt1377z00_244,((long)2)); 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_ivz00_938;
BgL_ivz00_938 = BFALSE; 
{ /* Llib/block_ciphers.scm 777 */
obj_t BgL_modez00_939;
BgL_modez00_939 = 
CNST_TABLE_REF(((long)10)); 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_noncezd2initz12zc0_940;
BgL_noncezd2initz12zc0_940 = BFALSE; 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_noncezd2updatez12zc0_941;
BgL_noncezd2updatez12zc0_941 = BFALSE; 
{ /* Llib/block_ciphers.scm 777 */
obj_t BgL_padz00_942;
BgL_padz00_942 = 
CNST_TABLE_REF(((long)16)); 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_stringzd2ze3keyz31_943;
BgL_stringzd2ze3keyz31_943 = BFALSE; 
{ /* Llib/block_ciphers.scm 776 */

{ 
long BgL_iz00_944;
BgL_iz00_944 = ((long)3); 
BgL_check1380z00_945:
if(
(BgL_iz00_944==
VECTOR_LENGTH(BgL_opt1377z00_244)))
{ /* Llib/block_ciphers.scm 776 */BNIL; }  else 
{ /* Llib/block_ciphers.scm 776 */
bool_t BgL_testz00_8060;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_arg1950z00_951;
BgL_arg1950z00_951 = 
VECTOR_REF(BgL_opt1377z00_244,BgL_iz00_944); 
BgL_testz00_8060 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1950z00_951, 
CNST_TABLE_REF(((long)23)))); } 
if(BgL_testz00_8060)
{ 
long BgL_iz00_8065;
BgL_iz00_8065 = 
(BgL_iz00_944+((long)2)); 
BgL_iz00_944 = BgL_iz00_8065; 
goto BgL_check1380z00_945;}  else 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_arg1949z00_950;
BgL_arg1949z00_950 = 
VECTOR_REF(BgL_opt1377z00_244,BgL_iz00_944); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)32)), BGl_string3749z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1949z00_950); } } } 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_index1382z00_952;
BgL_index1382z00_952 = 
BGl_search1379ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1377z00_244), BgL_opt1377z00_244, 
CNST_TABLE_REF(((long)25)), ((long)3)); 
{ /* Llib/block_ciphers.scm 776 */
bool_t BgL_testz00_8073;
{ /* Llib/block_ciphers.scm 776 */
long BgL_n1z00_3135;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_tmpz00_8074;
if(
INTEGERP(BgL_index1382z00_952))
{ /* Llib/block_ciphers.scm 776 */
BgL_tmpz00_8074 = BgL_index1382z00_952
; }  else 
{ 
obj_t BgL_auxz00_8077;
BgL_auxz00_8077 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28176)), BGl_string3757z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1382z00_952); 
FAILURE(BgL_auxz00_8077,BFALSE,BFALSE);} 
BgL_n1z00_3135 = 
(long)CINT(BgL_tmpz00_8074); } 
BgL_testz00_8073 = 
(BgL_n1z00_3135>=((long)0)); } 
if(BgL_testz00_8073)
{ 
long BgL_auxz00_8083;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_tmpz00_8084;
if(
INTEGERP(BgL_index1382z00_952))
{ /* Llib/block_ciphers.scm 776 */
BgL_tmpz00_8084 = BgL_index1382z00_952
; }  else 
{ 
obj_t BgL_auxz00_8087;
BgL_auxz00_8087 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28176)), BGl_string3757z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1382z00_952); 
FAILURE(BgL_auxz00_8087,BFALSE,BFALSE);} 
BgL_auxz00_8083 = 
(long)CINT(BgL_tmpz00_8084); } 
BgL_ivz00_938 = 
VECTOR_REF(BgL_opt1377z00_244,BgL_auxz00_8083); }  else 
{ /* Llib/block_ciphers.scm 776 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_index1383z00_954;
BgL_index1383z00_954 = 
BGl_search1379ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1377z00_244), BgL_opt1377z00_244, 
CNST_TABLE_REF(((long)26)), ((long)3)); 
{ /* Llib/block_ciphers.scm 776 */
bool_t BgL_testz00_8096;
{ /* Llib/block_ciphers.scm 776 */
long BgL_n1z00_3137;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_tmpz00_8097;
if(
INTEGERP(BgL_index1383z00_954))
{ /* Llib/block_ciphers.scm 776 */
BgL_tmpz00_8097 = BgL_index1383z00_954
; }  else 
{ 
obj_t BgL_auxz00_8100;
BgL_auxz00_8100 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28176)), BGl_string3757z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1383z00_954); 
FAILURE(BgL_auxz00_8100,BFALSE,BFALSE);} 
BgL_n1z00_3137 = 
(long)CINT(BgL_tmpz00_8097); } 
BgL_testz00_8096 = 
(BgL_n1z00_3137>=((long)0)); } 
if(BgL_testz00_8096)
{ 
long BgL_auxz00_8106;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_tmpz00_8107;
if(
INTEGERP(BgL_index1383z00_954))
{ /* Llib/block_ciphers.scm 776 */
BgL_tmpz00_8107 = BgL_index1383z00_954
; }  else 
{ 
obj_t BgL_auxz00_8110;
BgL_auxz00_8110 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28176)), BGl_string3757z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1383z00_954); 
FAILURE(BgL_auxz00_8110,BFALSE,BFALSE);} 
BgL_auxz00_8106 = 
(long)CINT(BgL_tmpz00_8107); } 
BgL_modez00_939 = 
VECTOR_REF(BgL_opt1377z00_244,BgL_auxz00_8106); }  else 
{ /* Llib/block_ciphers.scm 776 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_index1384z00_956;
BgL_index1384z00_956 = 
BGl_search1379ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1377z00_244), BgL_opt1377z00_244, 
CNST_TABLE_REF(((long)27)), ((long)3)); 
{ /* Llib/block_ciphers.scm 776 */
bool_t BgL_testz00_8119;
{ /* Llib/block_ciphers.scm 776 */
long BgL_n1z00_3139;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_tmpz00_8120;
if(
INTEGERP(BgL_index1384z00_956))
{ /* Llib/block_ciphers.scm 776 */
BgL_tmpz00_8120 = BgL_index1384z00_956
; }  else 
{ 
obj_t BgL_auxz00_8123;
BgL_auxz00_8123 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28176)), BGl_string3757z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1384z00_956); 
FAILURE(BgL_auxz00_8123,BFALSE,BFALSE);} 
BgL_n1z00_3139 = 
(long)CINT(BgL_tmpz00_8120); } 
BgL_testz00_8119 = 
(BgL_n1z00_3139>=((long)0)); } 
if(BgL_testz00_8119)
{ 
long BgL_auxz00_8129;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_tmpz00_8130;
if(
INTEGERP(BgL_index1384z00_956))
{ /* Llib/block_ciphers.scm 776 */
BgL_tmpz00_8130 = BgL_index1384z00_956
; }  else 
{ 
obj_t BgL_auxz00_8133;
BgL_auxz00_8133 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28176)), BGl_string3757z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1384z00_956); 
FAILURE(BgL_auxz00_8133,BFALSE,BFALSE);} 
BgL_auxz00_8129 = 
(long)CINT(BgL_tmpz00_8130); } 
BgL_noncezd2initz12zc0_940 = 
VECTOR_REF(BgL_opt1377z00_244,BgL_auxz00_8129); }  else 
{ /* Llib/block_ciphers.scm 776 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_index1385z00_958;
BgL_index1385z00_958 = 
BGl_search1379ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1377z00_244), BgL_opt1377z00_244, 
CNST_TABLE_REF(((long)28)), ((long)3)); 
{ /* Llib/block_ciphers.scm 776 */
bool_t BgL_testz00_8142;
{ /* Llib/block_ciphers.scm 776 */
long BgL_n1z00_3141;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_tmpz00_8143;
if(
INTEGERP(BgL_index1385z00_958))
{ /* Llib/block_ciphers.scm 776 */
BgL_tmpz00_8143 = BgL_index1385z00_958
; }  else 
{ 
obj_t BgL_auxz00_8146;
BgL_auxz00_8146 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28176)), BGl_string3757z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1385z00_958); 
FAILURE(BgL_auxz00_8146,BFALSE,BFALSE);} 
BgL_n1z00_3141 = 
(long)CINT(BgL_tmpz00_8143); } 
BgL_testz00_8142 = 
(BgL_n1z00_3141>=((long)0)); } 
if(BgL_testz00_8142)
{ 
long BgL_auxz00_8152;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_tmpz00_8153;
if(
INTEGERP(BgL_index1385z00_958))
{ /* Llib/block_ciphers.scm 776 */
BgL_tmpz00_8153 = BgL_index1385z00_958
; }  else 
{ 
obj_t BgL_auxz00_8156;
BgL_auxz00_8156 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28176)), BGl_string3757z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1385z00_958); 
FAILURE(BgL_auxz00_8156,BFALSE,BFALSE);} 
BgL_auxz00_8152 = 
(long)CINT(BgL_tmpz00_8153); } 
BgL_noncezd2updatez12zc0_941 = 
VECTOR_REF(BgL_opt1377z00_244,BgL_auxz00_8152); }  else 
{ /* Llib/block_ciphers.scm 776 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_index1386z00_960;
BgL_index1386z00_960 = 
BGl_search1379ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1377z00_244), BgL_opt1377z00_244, 
CNST_TABLE_REF(((long)29)), ((long)3)); 
{ /* Llib/block_ciphers.scm 776 */
bool_t BgL_testz00_8165;
{ /* Llib/block_ciphers.scm 776 */
long BgL_n1z00_3143;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_tmpz00_8166;
if(
INTEGERP(BgL_index1386z00_960))
{ /* Llib/block_ciphers.scm 776 */
BgL_tmpz00_8166 = BgL_index1386z00_960
; }  else 
{ 
obj_t BgL_auxz00_8169;
BgL_auxz00_8169 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28176)), BGl_string3757z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1386z00_960); 
FAILURE(BgL_auxz00_8169,BFALSE,BFALSE);} 
BgL_n1z00_3143 = 
(long)CINT(BgL_tmpz00_8166); } 
BgL_testz00_8165 = 
(BgL_n1z00_3143>=((long)0)); } 
if(BgL_testz00_8165)
{ 
long BgL_auxz00_8175;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_tmpz00_8176;
if(
INTEGERP(BgL_index1386z00_960))
{ /* Llib/block_ciphers.scm 776 */
BgL_tmpz00_8176 = BgL_index1386z00_960
; }  else 
{ 
obj_t BgL_auxz00_8179;
BgL_auxz00_8179 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28176)), BGl_string3757z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1386z00_960); 
FAILURE(BgL_auxz00_8179,BFALSE,BFALSE);} 
BgL_auxz00_8175 = 
(long)CINT(BgL_tmpz00_8176); } 
BgL_padz00_942 = 
VECTOR_REF(BgL_opt1377z00_244,BgL_auxz00_8175); }  else 
{ /* Llib/block_ciphers.scm 776 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_index1387z00_962;
BgL_index1387z00_962 = 
BGl_search1379ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1377z00_244), BgL_opt1377z00_244, 
CNST_TABLE_REF(((long)30)), ((long)3)); 
{ /* Llib/block_ciphers.scm 776 */
bool_t BgL_testz00_8188;
{ /* Llib/block_ciphers.scm 776 */
long BgL_n1z00_3145;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_tmpz00_8189;
if(
INTEGERP(BgL_index1387z00_962))
{ /* Llib/block_ciphers.scm 776 */
BgL_tmpz00_8189 = BgL_index1387z00_962
; }  else 
{ 
obj_t BgL_auxz00_8192;
BgL_auxz00_8192 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28176)), BGl_string3757z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1387z00_962); 
FAILURE(BgL_auxz00_8192,BFALSE,BFALSE);} 
BgL_n1z00_3145 = 
(long)CINT(BgL_tmpz00_8189); } 
BgL_testz00_8188 = 
(BgL_n1z00_3145>=((long)0)); } 
if(BgL_testz00_8188)
{ 
long BgL_auxz00_8198;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_tmpz00_8199;
if(
INTEGERP(BgL_index1387z00_962))
{ /* Llib/block_ciphers.scm 776 */
BgL_tmpz00_8199 = BgL_index1387z00_962
; }  else 
{ 
obj_t BgL_auxz00_8202;
BgL_auxz00_8202 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28176)), BGl_string3757z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1387z00_962); 
FAILURE(BgL_auxz00_8202,BFALSE,BFALSE);} 
BgL_auxz00_8198 = 
(long)CINT(BgL_tmpz00_8199); } 
BgL_stringzd2ze3keyz31_943 = 
VECTOR_REF(BgL_opt1377z00_244,BgL_auxz00_8198); }  else 
{ /* Llib/block_ciphers.scm 776 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_arg1957z00_964;obj_t BgL_arg1958z00_965;obj_t BgL_arg1959z00_966;
BgL_arg1957z00_964 = 
VECTOR_REF(BgL_opt1377z00_244,((long)0)); 
BgL_arg1958z00_965 = 
VECTOR_REF(BgL_opt1377z00_244,((long)1)); 
BgL_arg1959z00_966 = 
VECTOR_REF(BgL_opt1377z00_244,((long)2)); 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_ivz00_967;
BgL_ivz00_967 = BgL_ivz00_938; 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_modez00_968;
BgL_modez00_968 = BgL_modez00_939; 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_noncezd2initz12zc0_969;
BgL_noncezd2initz12zc0_969 = BgL_noncezd2initz12zc0_940; 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_noncezd2updatez12zc0_970;
BgL_noncezd2updatez12zc0_970 = BgL_noncezd2updatez12zc0_941; 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_padz00_971;
BgL_padz00_971 = BgL_padz00_942; 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_stringzd2ze3keyz31_972;
BgL_stringzd2ze3keyz31_972 = BgL_stringzd2ze3keyz31_943; 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_res2858z00_3150;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_cipherz00_3147;obj_t BgL_plaintextz00_3148;obj_t BgL_passwordz00_3149;
if(
SYMBOLP(BgL_arg1957z00_964))
{ /* Llib/block_ciphers.scm 776 */
BgL_cipherz00_3147 = BgL_arg1957z00_964; }  else 
{ 
obj_t BgL_auxz00_8213;
BgL_auxz00_8213 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28176)), BGl_string3757z00zz__cryptozd2blockzd2ciphersz00, BGl_string3752z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1957z00_964); 
FAILURE(BgL_auxz00_8213,BFALSE,BFALSE);} 
if(
BGL_MMAPP(BgL_arg1958z00_965))
{ /* Llib/block_ciphers.scm 776 */
BgL_plaintextz00_3148 = BgL_arg1958z00_965; }  else 
{ 
obj_t BgL_auxz00_8219;
BgL_auxz00_8219 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28176)), BGl_string3757z00zz__cryptozd2blockzd2ciphersz00, BGl_string3758z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1958z00_965); 
FAILURE(BgL_auxz00_8219,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg1959z00_966))
{ /* Llib/block_ciphers.scm 776 */
BgL_passwordz00_3149 = BgL_arg1959z00_966; }  else 
{ 
obj_t BgL_auxz00_8225;
BgL_auxz00_8225 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28176)), BGl_string3757z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1959z00_966); 
FAILURE(BgL_auxz00_8225,BFALSE,BFALSE);} 
BgL_res2858z00_3150 = 
BGl_encryptzd2fastzd2mmapz00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_3147, BgL_plaintextz00_3148, BgL_passwordz00_3149, BgL_ivz00_967, BgL_modez00_968, BgL_padz00_971, BgL_noncezd2initz12zc0_969, BgL_noncezd2updatez12zc0_970, BgL_stringzd2ze3keyz31_972); } 
return BgL_res2858z00_3150;} } } } } } } } } } } } } } } } } 
BGL_FUNCTION_END;
}



/* search1379~0 */
obj_t BGl_search1379ze70ze7zz__cryptozd2blockzd2ciphersz00(long BgL_l1378z00_5662, obj_t BgL_opt1377z00_5661, obj_t BgL_k1z00_932, long BgL_iz00_933)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 776 */
BGl_search1379ze70ze7zz__cryptozd2blockzd2ciphersz00:
if(
(BgL_iz00_933==BgL_l1378z00_5662))
{ /* Llib/block_ciphers.scm 776 */
return 
BINT(((long)-1));}  else 
{ /* Llib/block_ciphers.scm 776 */
if(
(BgL_iz00_933==
(BgL_l1378z00_5662-((long)1))))
{ /* Llib/block_ciphers.scm 776 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)32)), BGl_string3754z00zz__cryptozd2blockzd2ciphersz00, 
BINT(
VECTOR_LENGTH(BgL_opt1377z00_5661)));}  else 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_vz00_977;
BgL_vz00_977 = 
VECTOR_REF(BgL_opt1377z00_5661,BgL_iz00_933); 
if(
(BgL_vz00_977==BgL_k1z00_932))
{ /* Llib/block_ciphers.scm 776 */
return 
BINT(
(BgL_iz00_933+((long)1)));}  else 
{ 
long BgL_iz00_8245;
BgL_iz00_8245 = 
(BgL_iz00_933+((long)2)); 
BgL_iz00_933 = BgL_iz00_8245; 
goto BGl_search1379ze70ze7zz__cryptozd2blockzd2ciphersz00;} } } } 
BGL_FUNCTION_END;
}



/* encrypt-mmap */
BGL_EXPORTED_DEF obj_t BGl_encryptzd2mmapzd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_235, obj_t BgL_plaintextz00_236, obj_t BgL_passwordz00_237, obj_t BgL_ivz00_238, obj_t BgL_modez00_239, obj_t BgL_noncezd2initz12zc0_240, obj_t BgL_noncezd2updatez12zc0_241, obj_t BgL_padz00_242, obj_t BgL_stringzd2ze3keyz31_243)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 776 */
{ /* Llib/block_ciphers.scm 789 */
long BgL_lenz00_3152;
{ /* Llib/block_ciphers.scm 789 */
long BgL_res2859z00_3163;
BgL_res2859z00_3163 = 
BGL_MMAP_LENGTH(BgL_plaintextz00_236); 
BgL_lenz00_3152 = BgL_res2859z00_3163; } 
{ /* Llib/block_ciphers.scm 789 */
BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3153;
BgL_statez00_3153 = 
BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_235, BgL_passwordz00_237, BgL_ivz00_238, BgL_modez00_239, BgL_padz00_242, BgL_noncezd2initz12zc0_240, BgL_noncezd2updatez12zc0_241, BgL_stringzd2ze3keyz31_243); 
{ /* Llib/block_ciphers.scm 790 */
obj_t BgL_strz00_3154;
{ /* Llib/block_ciphers.scm 793 */
long BgL_arg1968z00_3155;
{ /* Llib/block_ciphers.scm 793 */
long BgL_za72za7_3167;
BgL_za72za7_3167 = 
(long)(BgL_lenz00_3152); 
BgL_arg1968z00_3155 = 
(
(((long)2)*
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_statez00_3153))->BgL_blockzd2siza7ez75))+BgL_za72za7_3167); } 
{ /* Llib/block_ciphers.scm 793 */

BgL_strz00_3154 = 
make_string(BgL_arg1968z00_3155, ((unsigned char)' ')); } } 
{ /* Llib/block_ciphers.scm 793 */

{ /* Llib/block_ciphers.scm 796 */
long BgL_tmpz00_8254;
BgL_tmpz00_8254 = 
BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3153, BgL_plaintextz00_236, ((long)0), BGl_readzd2mmapzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_strz00_3154, ((long)0), BGl_blitzd2stringzd2urz12zd2envzc0zz__r4_strings_6_7z00); 
return 
bgl_string_shrink(BgL_strz00_3154, BgL_tmpz00_8254);} } } } } } 
BGL_FUNCTION_END;
}



/* encrypt-fast-mmap */
obj_t BGl_encryptzd2fastzd2mmapz00zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_246, obj_t BgL_plaintextz00_247, obj_t BgL_passwordz00_248, obj_t BgL_ivz00_249, obj_t BgL_modez00_250, obj_t BgL_padz00_251, obj_t BgL_noncezd2initz12zc0_252, obj_t BgL_noncezd2updatez12zc0_253, obj_t BgL_stringzd2ze3keyz31_254)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 784 */
{ /* Llib/block_ciphers.scm 789 */
long BgL_lenz00_3173;
{ /* Llib/block_ciphers.scm 789 */
long BgL_res2863z00_3184;
BgL_res2863z00_3184 = 
BGL_MMAP_LENGTH(BgL_plaintextz00_247); 
BgL_lenz00_3173 = BgL_res2863z00_3184; } 
{ /* Llib/block_ciphers.scm 789 */
BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3174;
BgL_statez00_3174 = 
BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_246, BgL_passwordz00_248, BgL_ivz00_249, BgL_modez00_250, BgL_padz00_251, BgL_noncezd2initz12zc0_252, BgL_noncezd2updatez12zc0_253, BgL_stringzd2ze3keyz31_254); 
{ /* Llib/block_ciphers.scm 790 */
obj_t BgL_strz00_3175;
{ /* Llib/block_ciphers.scm 793 */
long BgL_arg1968z00_3176;
{ /* Llib/block_ciphers.scm 793 */
long BgL_za72za7_3188;
BgL_za72za7_3188 = 
(long)(BgL_lenz00_3173); 
BgL_arg1968z00_3176 = 
(
(((long)2)*
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_statez00_3174))->BgL_blockzd2siza7ez75))+BgL_za72za7_3188); } 
{ /* Llib/block_ciphers.scm 793 */

BgL_strz00_3175 = 
make_string(BgL_arg1968z00_3176, ((unsigned char)' ')); } } 
{ /* Llib/block_ciphers.scm 793 */

{ /* Llib/block_ciphers.scm 796 */
long BgL_tmpz00_8264;
BgL_tmpz00_8264 = 
BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3174, BgL_plaintextz00_247, ((long)0), BGl_readzd2mmapzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_strz00_3175, ((long)0), BGl_blitzd2stringzd2urz12zd2envzc0zz__r4_strings_6_7z00); 
return 
bgl_string_shrink(BgL_strz00_3175, BgL_tmpz00_8264);} } } } } } 
BGL_FUNCTION_END;
}



/* &encrypt-fast-mmap */
obj_t BGl_z62encryptzd2fastzd2mmapz62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4985, obj_t BgL_cipherz00_4986, obj_t BgL_plaintextz00_4987, obj_t BgL_passwordz00_4988, obj_t BgL_ivz00_4989, obj_t BgL_modez00_4990, obj_t BgL_padz00_4991, obj_t BgL_noncezd2initz12zc0_4992, obj_t BgL_noncezd2updatez12zc0_4993, obj_t BgL_stringzd2ze3keyz31_4994)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 784 */
{ /* Llib/block_ciphers.scm 789 */
obj_t BgL_auxz00_8267;
if(
BGL_MMAPP(BgL_plaintextz00_4987))
{ /* Llib/block_ciphers.scm 789 */
BgL_auxz00_8267 = BgL_plaintextz00_4987
; }  else 
{ 
obj_t BgL_auxz00_8270;
BgL_auxz00_8270 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28697)), BGl_string3759z00zz__cryptozd2blockzd2ciphersz00, BGl_string3758z00zz__cryptozd2blockzd2ciphersz00, BgL_plaintextz00_4987); 
FAILURE(BgL_auxz00_8270,BFALSE,BFALSE);} 
return 
BGl_encryptzd2fastzd2mmapz00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_4986, BgL_auxz00_8267, BgL_passwordz00_4988, BgL_ivz00_4989, BgL_modez00_4990, BgL_padz00_4991, BgL_noncezd2initz12zc0_4992, BgL_noncezd2updatez12zc0_4993, BgL_stringzd2ze3keyz31_4994);} } 
BGL_FUNCTION_END;
}



/* _encrypt-port */
obj_t BGl__encryptzd2portzd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_265, obj_t BgL_opt1388z00_264)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 801 */
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_cipherz00_995;obj_t BgL_plaintextz00_996;obj_t BgL_passwordz00_997;
BgL_cipherz00_995 = 
VECTOR_REF(BgL_opt1388z00_264,((long)0)); 
BgL_plaintextz00_996 = 
VECTOR_REF(BgL_opt1388z00_264,((long)1)); 
BgL_passwordz00_997 = 
VECTOR_REF(BgL_opt1388z00_264,((long)2)); 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_ivz00_998;
BgL_ivz00_998 = BFALSE; 
{ /* Llib/block_ciphers.scm 802 */
obj_t BgL_modez00_999;
BgL_modez00_999 = 
CNST_TABLE_REF(((long)10)); 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_noncezd2initz12zc0_1000;
BgL_noncezd2initz12zc0_1000 = BFALSE; 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_noncezd2updatez12zc0_1001;
BgL_noncezd2updatez12zc0_1001 = BFALSE; 
{ /* Llib/block_ciphers.scm 802 */
obj_t BgL_padz00_1002;
BgL_padz00_1002 = 
CNST_TABLE_REF(((long)16)); 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_stringzd2ze3keyz31_1003;
BgL_stringzd2ze3keyz31_1003 = BFALSE; 
{ /* Llib/block_ciphers.scm 801 */

{ 
long BgL_iz00_1004;
BgL_iz00_1004 = ((long)3); 
BgL_check1391z00_1005:
if(
(BgL_iz00_1004==
VECTOR_LENGTH(BgL_opt1388z00_264)))
{ /* Llib/block_ciphers.scm 801 */BNIL; }  else 
{ /* Llib/block_ciphers.scm 801 */
bool_t BgL_testz00_8283;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_arg1976z00_1011;
BgL_arg1976z00_1011 = 
VECTOR_REF(BgL_opt1388z00_264,BgL_iz00_1004); 
BgL_testz00_8283 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1976z00_1011, 
CNST_TABLE_REF(((long)23)))); } 
if(BgL_testz00_8283)
{ 
long BgL_iz00_8288;
BgL_iz00_8288 = 
(BgL_iz00_1004+((long)2)); 
BgL_iz00_1004 = BgL_iz00_8288; 
goto BgL_check1391z00_1005;}  else 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_arg1975z00_1010;
BgL_arg1975z00_1010 = 
VECTOR_REF(BgL_opt1388z00_264,BgL_iz00_1004); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)33)), BGl_string3749z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1975z00_1010); } } } 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_index1393z00_1012;
BgL_index1393z00_1012 = 
BGl_search1390ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1388z00_264), BgL_opt1388z00_264, 
CNST_TABLE_REF(((long)25)), ((long)3)); 
{ /* Llib/block_ciphers.scm 801 */
bool_t BgL_testz00_8296;
{ /* Llib/block_ciphers.scm 801 */
long BgL_n1z00_3216;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_tmpz00_8297;
if(
INTEGERP(BgL_index1393z00_1012))
{ /* Llib/block_ciphers.scm 801 */
BgL_tmpz00_8297 = BgL_index1393z00_1012
; }  else 
{ 
obj_t BgL_auxz00_8300;
BgL_auxz00_8300 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29094)), BGl_string3760z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1393z00_1012); 
FAILURE(BgL_auxz00_8300,BFALSE,BFALSE);} 
BgL_n1z00_3216 = 
(long)CINT(BgL_tmpz00_8297); } 
BgL_testz00_8296 = 
(BgL_n1z00_3216>=((long)0)); } 
if(BgL_testz00_8296)
{ 
long BgL_auxz00_8306;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_tmpz00_8307;
if(
INTEGERP(BgL_index1393z00_1012))
{ /* Llib/block_ciphers.scm 801 */
BgL_tmpz00_8307 = BgL_index1393z00_1012
; }  else 
{ 
obj_t BgL_auxz00_8310;
BgL_auxz00_8310 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29094)), BGl_string3760z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1393z00_1012); 
FAILURE(BgL_auxz00_8310,BFALSE,BFALSE);} 
BgL_auxz00_8306 = 
(long)CINT(BgL_tmpz00_8307); } 
BgL_ivz00_998 = 
VECTOR_REF(BgL_opt1388z00_264,BgL_auxz00_8306); }  else 
{ /* Llib/block_ciphers.scm 801 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_index1394z00_1014;
BgL_index1394z00_1014 = 
BGl_search1390ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1388z00_264), BgL_opt1388z00_264, 
CNST_TABLE_REF(((long)26)), ((long)3)); 
{ /* Llib/block_ciphers.scm 801 */
bool_t BgL_testz00_8319;
{ /* Llib/block_ciphers.scm 801 */
long BgL_n1z00_3218;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_tmpz00_8320;
if(
INTEGERP(BgL_index1394z00_1014))
{ /* Llib/block_ciphers.scm 801 */
BgL_tmpz00_8320 = BgL_index1394z00_1014
; }  else 
{ 
obj_t BgL_auxz00_8323;
BgL_auxz00_8323 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29094)), BGl_string3760z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1394z00_1014); 
FAILURE(BgL_auxz00_8323,BFALSE,BFALSE);} 
BgL_n1z00_3218 = 
(long)CINT(BgL_tmpz00_8320); } 
BgL_testz00_8319 = 
(BgL_n1z00_3218>=((long)0)); } 
if(BgL_testz00_8319)
{ 
long BgL_auxz00_8329;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_tmpz00_8330;
if(
INTEGERP(BgL_index1394z00_1014))
{ /* Llib/block_ciphers.scm 801 */
BgL_tmpz00_8330 = BgL_index1394z00_1014
; }  else 
{ 
obj_t BgL_auxz00_8333;
BgL_auxz00_8333 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29094)), BGl_string3760z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1394z00_1014); 
FAILURE(BgL_auxz00_8333,BFALSE,BFALSE);} 
BgL_auxz00_8329 = 
(long)CINT(BgL_tmpz00_8330); } 
BgL_modez00_999 = 
VECTOR_REF(BgL_opt1388z00_264,BgL_auxz00_8329); }  else 
{ /* Llib/block_ciphers.scm 801 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_index1395z00_1016;
BgL_index1395z00_1016 = 
BGl_search1390ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1388z00_264), BgL_opt1388z00_264, 
CNST_TABLE_REF(((long)27)), ((long)3)); 
{ /* Llib/block_ciphers.scm 801 */
bool_t BgL_testz00_8342;
{ /* Llib/block_ciphers.scm 801 */
long BgL_n1z00_3220;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_tmpz00_8343;
if(
INTEGERP(BgL_index1395z00_1016))
{ /* Llib/block_ciphers.scm 801 */
BgL_tmpz00_8343 = BgL_index1395z00_1016
; }  else 
{ 
obj_t BgL_auxz00_8346;
BgL_auxz00_8346 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29094)), BGl_string3760z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1395z00_1016); 
FAILURE(BgL_auxz00_8346,BFALSE,BFALSE);} 
BgL_n1z00_3220 = 
(long)CINT(BgL_tmpz00_8343); } 
BgL_testz00_8342 = 
(BgL_n1z00_3220>=((long)0)); } 
if(BgL_testz00_8342)
{ 
long BgL_auxz00_8352;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_tmpz00_8353;
if(
INTEGERP(BgL_index1395z00_1016))
{ /* Llib/block_ciphers.scm 801 */
BgL_tmpz00_8353 = BgL_index1395z00_1016
; }  else 
{ 
obj_t BgL_auxz00_8356;
BgL_auxz00_8356 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29094)), BGl_string3760z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1395z00_1016); 
FAILURE(BgL_auxz00_8356,BFALSE,BFALSE);} 
BgL_auxz00_8352 = 
(long)CINT(BgL_tmpz00_8353); } 
BgL_noncezd2initz12zc0_1000 = 
VECTOR_REF(BgL_opt1388z00_264,BgL_auxz00_8352); }  else 
{ /* Llib/block_ciphers.scm 801 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_index1396z00_1018;
BgL_index1396z00_1018 = 
BGl_search1390ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1388z00_264), BgL_opt1388z00_264, 
CNST_TABLE_REF(((long)28)), ((long)3)); 
{ /* Llib/block_ciphers.scm 801 */
bool_t BgL_testz00_8365;
{ /* Llib/block_ciphers.scm 801 */
long BgL_n1z00_3222;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_tmpz00_8366;
if(
INTEGERP(BgL_index1396z00_1018))
{ /* Llib/block_ciphers.scm 801 */
BgL_tmpz00_8366 = BgL_index1396z00_1018
; }  else 
{ 
obj_t BgL_auxz00_8369;
BgL_auxz00_8369 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29094)), BGl_string3760z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1396z00_1018); 
FAILURE(BgL_auxz00_8369,BFALSE,BFALSE);} 
BgL_n1z00_3222 = 
(long)CINT(BgL_tmpz00_8366); } 
BgL_testz00_8365 = 
(BgL_n1z00_3222>=((long)0)); } 
if(BgL_testz00_8365)
{ 
long BgL_auxz00_8375;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_tmpz00_8376;
if(
INTEGERP(BgL_index1396z00_1018))
{ /* Llib/block_ciphers.scm 801 */
BgL_tmpz00_8376 = BgL_index1396z00_1018
; }  else 
{ 
obj_t BgL_auxz00_8379;
BgL_auxz00_8379 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29094)), BGl_string3760z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1396z00_1018); 
FAILURE(BgL_auxz00_8379,BFALSE,BFALSE);} 
BgL_auxz00_8375 = 
(long)CINT(BgL_tmpz00_8376); } 
BgL_noncezd2updatez12zc0_1001 = 
VECTOR_REF(BgL_opt1388z00_264,BgL_auxz00_8375); }  else 
{ /* Llib/block_ciphers.scm 801 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_index1397z00_1020;
BgL_index1397z00_1020 = 
BGl_search1390ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1388z00_264), BgL_opt1388z00_264, 
CNST_TABLE_REF(((long)29)), ((long)3)); 
{ /* Llib/block_ciphers.scm 801 */
bool_t BgL_testz00_8388;
{ /* Llib/block_ciphers.scm 801 */
long BgL_n1z00_3224;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_tmpz00_8389;
if(
INTEGERP(BgL_index1397z00_1020))
{ /* Llib/block_ciphers.scm 801 */
BgL_tmpz00_8389 = BgL_index1397z00_1020
; }  else 
{ 
obj_t BgL_auxz00_8392;
BgL_auxz00_8392 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29094)), BGl_string3760z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1397z00_1020); 
FAILURE(BgL_auxz00_8392,BFALSE,BFALSE);} 
BgL_n1z00_3224 = 
(long)CINT(BgL_tmpz00_8389); } 
BgL_testz00_8388 = 
(BgL_n1z00_3224>=((long)0)); } 
if(BgL_testz00_8388)
{ 
long BgL_auxz00_8398;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_tmpz00_8399;
if(
INTEGERP(BgL_index1397z00_1020))
{ /* Llib/block_ciphers.scm 801 */
BgL_tmpz00_8399 = BgL_index1397z00_1020
; }  else 
{ 
obj_t BgL_auxz00_8402;
BgL_auxz00_8402 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29094)), BGl_string3760z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1397z00_1020); 
FAILURE(BgL_auxz00_8402,BFALSE,BFALSE);} 
BgL_auxz00_8398 = 
(long)CINT(BgL_tmpz00_8399); } 
BgL_padz00_1002 = 
VECTOR_REF(BgL_opt1388z00_264,BgL_auxz00_8398); }  else 
{ /* Llib/block_ciphers.scm 801 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_index1398z00_1022;
BgL_index1398z00_1022 = 
BGl_search1390ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1388z00_264), BgL_opt1388z00_264, 
CNST_TABLE_REF(((long)30)), ((long)3)); 
{ /* Llib/block_ciphers.scm 801 */
bool_t BgL_testz00_8411;
{ /* Llib/block_ciphers.scm 801 */
long BgL_n1z00_3226;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_tmpz00_8412;
if(
INTEGERP(BgL_index1398z00_1022))
{ /* Llib/block_ciphers.scm 801 */
BgL_tmpz00_8412 = BgL_index1398z00_1022
; }  else 
{ 
obj_t BgL_auxz00_8415;
BgL_auxz00_8415 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29094)), BGl_string3760z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1398z00_1022); 
FAILURE(BgL_auxz00_8415,BFALSE,BFALSE);} 
BgL_n1z00_3226 = 
(long)CINT(BgL_tmpz00_8412); } 
BgL_testz00_8411 = 
(BgL_n1z00_3226>=((long)0)); } 
if(BgL_testz00_8411)
{ 
long BgL_auxz00_8421;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_tmpz00_8422;
if(
INTEGERP(BgL_index1398z00_1022))
{ /* Llib/block_ciphers.scm 801 */
BgL_tmpz00_8422 = BgL_index1398z00_1022
; }  else 
{ 
obj_t BgL_auxz00_8425;
BgL_auxz00_8425 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29094)), BGl_string3760z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1398z00_1022); 
FAILURE(BgL_auxz00_8425,BFALSE,BFALSE);} 
BgL_auxz00_8421 = 
(long)CINT(BgL_tmpz00_8422); } 
BgL_stringzd2ze3keyz31_1003 = 
VECTOR_REF(BgL_opt1388z00_264,BgL_auxz00_8421); }  else 
{ /* Llib/block_ciphers.scm 801 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_arg1983z00_1024;obj_t BgL_arg1984z00_1025;obj_t BgL_arg1985z00_1026;
BgL_arg1983z00_1024 = 
VECTOR_REF(BgL_opt1388z00_264,((long)0)); 
BgL_arg1984z00_1025 = 
VECTOR_REF(BgL_opt1388z00_264,((long)1)); 
BgL_arg1985z00_1026 = 
VECTOR_REF(BgL_opt1388z00_264,((long)2)); 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_ivz00_1027;
BgL_ivz00_1027 = BgL_ivz00_998; 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_modez00_1028;
BgL_modez00_1028 = BgL_modez00_999; 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_noncezd2initz12zc0_1029;
BgL_noncezd2initz12zc0_1029 = BgL_noncezd2initz12zc0_1000; 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_noncezd2updatez12zc0_1030;
BgL_noncezd2updatez12zc0_1030 = BgL_noncezd2updatez12zc0_1001; 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_padz00_1031;
BgL_padz00_1031 = BgL_padz00_1002; 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_stringzd2ze3keyz31_1032;
BgL_stringzd2ze3keyz31_1032 = BgL_stringzd2ze3keyz31_1003; 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_res2880z00_3236;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_cipherz00_3228;obj_t BgL_plaintextz00_3229;obj_t BgL_passwordz00_3230;
if(
SYMBOLP(BgL_arg1983z00_1024))
{ /* Llib/block_ciphers.scm 801 */
BgL_cipherz00_3228 = BgL_arg1983z00_1024; }  else 
{ 
obj_t BgL_auxz00_8436;
BgL_auxz00_8436 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29094)), BGl_string3760z00zz__cryptozd2blockzd2ciphersz00, BGl_string3752z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1983z00_1024); 
FAILURE(BgL_auxz00_8436,BFALSE,BFALSE);} 
if(
INPUT_PORTP(BgL_arg1984z00_1025))
{ /* Llib/block_ciphers.scm 801 */
BgL_plaintextz00_3229 = BgL_arg1984z00_1025; }  else 
{ 
obj_t BgL_auxz00_8442;
BgL_auxz00_8442 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29094)), BGl_string3760z00zz__cryptozd2blockzd2ciphersz00, BGl_string3761z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1984z00_1025); 
FAILURE(BgL_auxz00_8442,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg1985z00_1026))
{ /* Llib/block_ciphers.scm 801 */
BgL_passwordz00_3230 = BgL_arg1985z00_1026; }  else 
{ 
obj_t BgL_auxz00_8448;
BgL_auxz00_8448 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29094)), BGl_string3760z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1985z00_1026); 
FAILURE(BgL_auxz00_8448,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 812 */
obj_t BgL_pz00_3232;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3233;
{ /* Llib/block_ciphers.scm 812 */

{ /* Llib/block_ciphers.scm 812 */

BgL_pz00_3232 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
BgL_statez00_3233 = 
BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_3228, BgL_passwordz00_3230, BgL_ivz00_1027, BgL_modez00_1028, BgL_padz00_1031, BgL_noncezd2initz12zc0_1029, BgL_noncezd2updatez12zc0_1030, BgL_stringzd2ze3keyz31_1032); 
BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3233, BgL_plaintextz00_3229, ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_pz00_3232, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00); 
{ /* Llib/block_ciphers.scm 819 */
obj_t BgL_aux3431z00_5801;
BgL_aux3431z00_5801 = 
bgl_close_output_port(BgL_pz00_3232); 
if(
STRINGP(BgL_aux3431z00_5801))
{ /* Llib/block_ciphers.scm 819 */
BgL_res2880z00_3236 = BgL_aux3431z00_5801; }  else 
{ 
obj_t BgL_auxz00_8458;
BgL_auxz00_8458 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29782)), BGl_string3760z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_aux3431z00_5801); 
FAILURE(BgL_auxz00_8458,BFALSE,BFALSE);} } } } 
return BgL_res2880z00_3236;} } } } } } } } } } } } } } } } } 
BGL_FUNCTION_END;
}



/* search1390~0 */
obj_t BGl_search1390ze70ze7zz__cryptozd2blockzd2ciphersz00(long BgL_l1389z00_5660, obj_t BgL_opt1388z00_5659, obj_t BgL_k1z00_992, long BgL_iz00_993)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 801 */
BGl_search1390ze70ze7zz__cryptozd2blockzd2ciphersz00:
if(
(BgL_iz00_993==BgL_l1389z00_5660))
{ /* Llib/block_ciphers.scm 801 */
return 
BINT(((long)-1));}  else 
{ /* Llib/block_ciphers.scm 801 */
if(
(BgL_iz00_993==
(BgL_l1389z00_5660-((long)1))))
{ /* Llib/block_ciphers.scm 801 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)33)), BGl_string3754z00zz__cryptozd2blockzd2ciphersz00, 
BINT(
VECTOR_LENGTH(BgL_opt1388z00_5659)));}  else 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_vz00_1037;
BgL_vz00_1037 = 
VECTOR_REF(BgL_opt1388z00_5659,BgL_iz00_993); 
if(
(BgL_vz00_1037==BgL_k1z00_992))
{ /* Llib/block_ciphers.scm 801 */
return 
BINT(
(BgL_iz00_993+((long)1)));}  else 
{ 
long BgL_iz00_8477;
BgL_iz00_8477 = 
(BgL_iz00_993+((long)2)); 
BgL_iz00_993 = BgL_iz00_8477; 
goto BGl_search1390ze70ze7zz__cryptozd2blockzd2ciphersz00;} } } } 
BGL_FUNCTION_END;
}



/* encrypt-port */
BGL_EXPORTED_DEF obj_t BGl_encryptzd2portzd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_255, obj_t BgL_plaintextz00_256, obj_t BgL_passwordz00_257, obj_t BgL_ivz00_258, obj_t BgL_modez00_259, obj_t BgL_noncezd2initz12zc0_260, obj_t BgL_noncezd2updatez12zc0_261, obj_t BgL_padz00_262, obj_t BgL_stringzd2ze3keyz31_263)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 801 */
{ /* Llib/block_ciphers.scm 812 */
obj_t BgL_pz00_3238;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3239;
{ /* Llib/block_ciphers.scm 812 */

{ /* Llib/block_ciphers.scm 812 */

BgL_pz00_3238 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
BgL_statez00_3239 = 
BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_255, BgL_passwordz00_257, BgL_ivz00_258, BgL_modez00_259, BgL_padz00_262, BgL_noncezd2initz12zc0_260, BgL_noncezd2updatez12zc0_261, BgL_stringzd2ze3keyz31_263); 
BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3239, BgL_plaintextz00_256, ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_pz00_3238, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00); 
return 
bgl_close_output_port(BgL_pz00_3238);} } 
BGL_FUNCTION_END;
}



/* &encrypt-fast-port */
obj_t BGl_z62encryptzd2fastzd2portz62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4995, obj_t BgL_cipherz00_4996, obj_t BgL_plaintextz00_4997, obj_t BgL_passwordz00_4998, obj_t BgL_ivz00_4999, obj_t BgL_modez00_5000, obj_t BgL_padz00_5001, obj_t BgL_noncezd2initz12zc0_5002, obj_t BgL_noncezd2updatez12zc0_5003, obj_t BgL_stringzd2ze3keyz31_5004)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 809 */
{ /* Llib/block_ciphers.scm 812 */
obj_t BgL_plaintextz00_6180;
if(
INPUT_PORTP(BgL_plaintextz00_4997))
{ /* Llib/block_ciphers.scm 812 */
BgL_plaintextz00_6180 = BgL_plaintextz00_4997; }  else 
{ 
obj_t BgL_auxz00_8485;
BgL_auxz00_8485 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29540)), BGl_string3762z00zz__cryptozd2blockzd2ciphersz00, BGl_string3761z00zz__cryptozd2blockzd2ciphersz00, BgL_plaintextz00_4997); 
FAILURE(BgL_auxz00_8485,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 812 */
obj_t BgL_pz00_6181;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_6182;
{ /* Llib/block_ciphers.scm 812 */

{ /* Llib/block_ciphers.scm 812 */

BgL_pz00_6181 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
BgL_statez00_6182 = 
BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_4996, BgL_passwordz00_4998, BgL_ivz00_4999, BgL_modez00_5000, BgL_padz00_5001, BgL_noncezd2initz12zc0_5002, BgL_noncezd2updatez12zc0_5003, BgL_stringzd2ze3keyz31_5004); 
BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_6182, BgL_plaintextz00_6180, ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_pz00_6181, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00); 
return 
bgl_close_output_port(BgL_pz00_6181);} } } 
BGL_FUNCTION_END;
}



/* _encrypt-file */
obj_t BGl__encryptzd2filezd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_285, obj_t BgL_opt1399z00_284)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 821 */
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_cipherz00_1048;obj_t BgL_filenamez00_1049;obj_t BgL_passwordz00_1050;
BgL_cipherz00_1048 = 
VECTOR_REF(BgL_opt1399z00_284,((long)0)); 
BgL_filenamez00_1049 = 
VECTOR_REF(BgL_opt1399z00_284,((long)1)); 
BgL_passwordz00_1050 = 
VECTOR_REF(BgL_opt1399z00_284,((long)2)); 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_ivz00_1051;
BgL_ivz00_1051 = BFALSE; 
{ /* Llib/block_ciphers.scm 822 */
obj_t BgL_modez00_1052;
BgL_modez00_1052 = 
CNST_TABLE_REF(((long)10)); 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_noncezd2initz12zc0_1053;
BgL_noncezd2initz12zc0_1053 = BFALSE; 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_noncezd2updatez12zc0_1054;
BgL_noncezd2updatez12zc0_1054 = BFALSE; 
{ /* Llib/block_ciphers.scm 822 */
obj_t BgL_padz00_1055;
BgL_padz00_1055 = 
CNST_TABLE_REF(((long)16)); 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_stringzd2ze3keyz31_1056;
BgL_stringzd2ze3keyz31_1056 = BFALSE; 
{ /* Llib/block_ciphers.scm 821 */

{ 
long BgL_iz00_1057;
BgL_iz00_1057 = ((long)3); 
BgL_check1402z00_1058:
if(
(BgL_iz00_1057==
VECTOR_LENGTH(BgL_opt1399z00_284)))
{ /* Llib/block_ciphers.scm 821 */BNIL; }  else 
{ /* Llib/block_ciphers.scm 821 */
bool_t BgL_testz00_8501;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_arg1998z00_1064;
BgL_arg1998z00_1064 = 
VECTOR_REF(BgL_opt1399z00_284,BgL_iz00_1057); 
BgL_testz00_8501 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1998z00_1064, 
CNST_TABLE_REF(((long)23)))); } 
if(BgL_testz00_8501)
{ 
long BgL_iz00_8506;
BgL_iz00_8506 = 
(BgL_iz00_1057+((long)2)); 
BgL_iz00_1057 = BgL_iz00_8506; 
goto BgL_check1402z00_1058;}  else 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_arg1997z00_1063;
BgL_arg1997z00_1063 = 
VECTOR_REF(BgL_opt1399z00_284,BgL_iz00_1057); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)34)), BGl_string3749z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1997z00_1063); } } } 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_index1404z00_1065;
BgL_index1404z00_1065 = 
BGl_search1401ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1399z00_284), BgL_opt1399z00_284, 
CNST_TABLE_REF(((long)25)), ((long)3)); 
{ /* Llib/block_ciphers.scm 821 */
bool_t BgL_testz00_8514;
{ /* Llib/block_ciphers.scm 821 */
long BgL_n1z00_3268;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_tmpz00_8515;
if(
INTEGERP(BgL_index1404z00_1065))
{ /* Llib/block_ciphers.scm 821 */
BgL_tmpz00_8515 = BgL_index1404z00_1065
; }  else 
{ 
obj_t BgL_auxz00_8518;
BgL_auxz00_8518 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29807)), BGl_string3763z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1404z00_1065); 
FAILURE(BgL_auxz00_8518,BFALSE,BFALSE);} 
BgL_n1z00_3268 = 
(long)CINT(BgL_tmpz00_8515); } 
BgL_testz00_8514 = 
(BgL_n1z00_3268>=((long)0)); } 
if(BgL_testz00_8514)
{ 
long BgL_auxz00_8524;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_tmpz00_8525;
if(
INTEGERP(BgL_index1404z00_1065))
{ /* Llib/block_ciphers.scm 821 */
BgL_tmpz00_8525 = BgL_index1404z00_1065
; }  else 
{ 
obj_t BgL_auxz00_8528;
BgL_auxz00_8528 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29807)), BGl_string3763z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1404z00_1065); 
FAILURE(BgL_auxz00_8528,BFALSE,BFALSE);} 
BgL_auxz00_8524 = 
(long)CINT(BgL_tmpz00_8525); } 
BgL_ivz00_1051 = 
VECTOR_REF(BgL_opt1399z00_284,BgL_auxz00_8524); }  else 
{ /* Llib/block_ciphers.scm 821 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_index1405z00_1067;
BgL_index1405z00_1067 = 
BGl_search1401ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1399z00_284), BgL_opt1399z00_284, 
CNST_TABLE_REF(((long)26)), ((long)3)); 
{ /* Llib/block_ciphers.scm 821 */
bool_t BgL_testz00_8537;
{ /* Llib/block_ciphers.scm 821 */
long BgL_n1z00_3270;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_tmpz00_8538;
if(
INTEGERP(BgL_index1405z00_1067))
{ /* Llib/block_ciphers.scm 821 */
BgL_tmpz00_8538 = BgL_index1405z00_1067
; }  else 
{ 
obj_t BgL_auxz00_8541;
BgL_auxz00_8541 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29807)), BGl_string3763z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1405z00_1067); 
FAILURE(BgL_auxz00_8541,BFALSE,BFALSE);} 
BgL_n1z00_3270 = 
(long)CINT(BgL_tmpz00_8538); } 
BgL_testz00_8537 = 
(BgL_n1z00_3270>=((long)0)); } 
if(BgL_testz00_8537)
{ 
long BgL_auxz00_8547;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_tmpz00_8548;
if(
INTEGERP(BgL_index1405z00_1067))
{ /* Llib/block_ciphers.scm 821 */
BgL_tmpz00_8548 = BgL_index1405z00_1067
; }  else 
{ 
obj_t BgL_auxz00_8551;
BgL_auxz00_8551 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29807)), BGl_string3763z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1405z00_1067); 
FAILURE(BgL_auxz00_8551,BFALSE,BFALSE);} 
BgL_auxz00_8547 = 
(long)CINT(BgL_tmpz00_8548); } 
BgL_modez00_1052 = 
VECTOR_REF(BgL_opt1399z00_284,BgL_auxz00_8547); }  else 
{ /* Llib/block_ciphers.scm 821 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_index1406z00_1069;
BgL_index1406z00_1069 = 
BGl_search1401ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1399z00_284), BgL_opt1399z00_284, 
CNST_TABLE_REF(((long)27)), ((long)3)); 
{ /* Llib/block_ciphers.scm 821 */
bool_t BgL_testz00_8560;
{ /* Llib/block_ciphers.scm 821 */
long BgL_n1z00_3272;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_tmpz00_8561;
if(
INTEGERP(BgL_index1406z00_1069))
{ /* Llib/block_ciphers.scm 821 */
BgL_tmpz00_8561 = BgL_index1406z00_1069
; }  else 
{ 
obj_t BgL_auxz00_8564;
BgL_auxz00_8564 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29807)), BGl_string3763z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1406z00_1069); 
FAILURE(BgL_auxz00_8564,BFALSE,BFALSE);} 
BgL_n1z00_3272 = 
(long)CINT(BgL_tmpz00_8561); } 
BgL_testz00_8560 = 
(BgL_n1z00_3272>=((long)0)); } 
if(BgL_testz00_8560)
{ 
long BgL_auxz00_8570;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_tmpz00_8571;
if(
INTEGERP(BgL_index1406z00_1069))
{ /* Llib/block_ciphers.scm 821 */
BgL_tmpz00_8571 = BgL_index1406z00_1069
; }  else 
{ 
obj_t BgL_auxz00_8574;
BgL_auxz00_8574 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29807)), BGl_string3763z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1406z00_1069); 
FAILURE(BgL_auxz00_8574,BFALSE,BFALSE);} 
BgL_auxz00_8570 = 
(long)CINT(BgL_tmpz00_8571); } 
BgL_noncezd2initz12zc0_1053 = 
VECTOR_REF(BgL_opt1399z00_284,BgL_auxz00_8570); }  else 
{ /* Llib/block_ciphers.scm 821 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_index1407z00_1071;
BgL_index1407z00_1071 = 
BGl_search1401ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1399z00_284), BgL_opt1399z00_284, 
CNST_TABLE_REF(((long)28)), ((long)3)); 
{ /* Llib/block_ciphers.scm 821 */
bool_t BgL_testz00_8583;
{ /* Llib/block_ciphers.scm 821 */
long BgL_n1z00_3274;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_tmpz00_8584;
if(
INTEGERP(BgL_index1407z00_1071))
{ /* Llib/block_ciphers.scm 821 */
BgL_tmpz00_8584 = BgL_index1407z00_1071
; }  else 
{ 
obj_t BgL_auxz00_8587;
BgL_auxz00_8587 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29807)), BGl_string3763z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1407z00_1071); 
FAILURE(BgL_auxz00_8587,BFALSE,BFALSE);} 
BgL_n1z00_3274 = 
(long)CINT(BgL_tmpz00_8584); } 
BgL_testz00_8583 = 
(BgL_n1z00_3274>=((long)0)); } 
if(BgL_testz00_8583)
{ 
long BgL_auxz00_8593;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_tmpz00_8594;
if(
INTEGERP(BgL_index1407z00_1071))
{ /* Llib/block_ciphers.scm 821 */
BgL_tmpz00_8594 = BgL_index1407z00_1071
; }  else 
{ 
obj_t BgL_auxz00_8597;
BgL_auxz00_8597 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29807)), BGl_string3763z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1407z00_1071); 
FAILURE(BgL_auxz00_8597,BFALSE,BFALSE);} 
BgL_auxz00_8593 = 
(long)CINT(BgL_tmpz00_8594); } 
BgL_noncezd2updatez12zc0_1054 = 
VECTOR_REF(BgL_opt1399z00_284,BgL_auxz00_8593); }  else 
{ /* Llib/block_ciphers.scm 821 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_index1408z00_1073;
BgL_index1408z00_1073 = 
BGl_search1401ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1399z00_284), BgL_opt1399z00_284, 
CNST_TABLE_REF(((long)29)), ((long)3)); 
{ /* Llib/block_ciphers.scm 821 */
bool_t BgL_testz00_8606;
{ /* Llib/block_ciphers.scm 821 */
long BgL_n1z00_3276;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_tmpz00_8607;
if(
INTEGERP(BgL_index1408z00_1073))
{ /* Llib/block_ciphers.scm 821 */
BgL_tmpz00_8607 = BgL_index1408z00_1073
; }  else 
{ 
obj_t BgL_auxz00_8610;
BgL_auxz00_8610 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29807)), BGl_string3763z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1408z00_1073); 
FAILURE(BgL_auxz00_8610,BFALSE,BFALSE);} 
BgL_n1z00_3276 = 
(long)CINT(BgL_tmpz00_8607); } 
BgL_testz00_8606 = 
(BgL_n1z00_3276>=((long)0)); } 
if(BgL_testz00_8606)
{ 
long BgL_auxz00_8616;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_tmpz00_8617;
if(
INTEGERP(BgL_index1408z00_1073))
{ /* Llib/block_ciphers.scm 821 */
BgL_tmpz00_8617 = BgL_index1408z00_1073
; }  else 
{ 
obj_t BgL_auxz00_8620;
BgL_auxz00_8620 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29807)), BGl_string3763z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1408z00_1073); 
FAILURE(BgL_auxz00_8620,BFALSE,BFALSE);} 
BgL_auxz00_8616 = 
(long)CINT(BgL_tmpz00_8617); } 
BgL_padz00_1055 = 
VECTOR_REF(BgL_opt1399z00_284,BgL_auxz00_8616); }  else 
{ /* Llib/block_ciphers.scm 821 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_index1409z00_1075;
BgL_index1409z00_1075 = 
BGl_search1401ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1399z00_284), BgL_opt1399z00_284, 
CNST_TABLE_REF(((long)30)), ((long)3)); 
{ /* Llib/block_ciphers.scm 821 */
bool_t BgL_testz00_8629;
{ /* Llib/block_ciphers.scm 821 */
long BgL_n1z00_3278;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_tmpz00_8630;
if(
INTEGERP(BgL_index1409z00_1075))
{ /* Llib/block_ciphers.scm 821 */
BgL_tmpz00_8630 = BgL_index1409z00_1075
; }  else 
{ 
obj_t BgL_auxz00_8633;
BgL_auxz00_8633 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29807)), BGl_string3763z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1409z00_1075); 
FAILURE(BgL_auxz00_8633,BFALSE,BFALSE);} 
BgL_n1z00_3278 = 
(long)CINT(BgL_tmpz00_8630); } 
BgL_testz00_8629 = 
(BgL_n1z00_3278>=((long)0)); } 
if(BgL_testz00_8629)
{ 
long BgL_auxz00_8639;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_tmpz00_8640;
if(
INTEGERP(BgL_index1409z00_1075))
{ /* Llib/block_ciphers.scm 821 */
BgL_tmpz00_8640 = BgL_index1409z00_1075
; }  else 
{ 
obj_t BgL_auxz00_8643;
BgL_auxz00_8643 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29807)), BGl_string3763z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1409z00_1075); 
FAILURE(BgL_auxz00_8643,BFALSE,BFALSE);} 
BgL_auxz00_8639 = 
(long)CINT(BgL_tmpz00_8640); } 
BgL_stringzd2ze3keyz31_1056 = 
VECTOR_REF(BgL_opt1399z00_284,BgL_auxz00_8639); }  else 
{ /* Llib/block_ciphers.scm 821 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_arg2005z00_1077;obj_t BgL_arg2006z00_1078;obj_t BgL_arg2007z00_1079;
BgL_arg2005z00_1077 = 
VECTOR_REF(BgL_opt1399z00_284,((long)0)); 
BgL_arg2006z00_1078 = 
VECTOR_REF(BgL_opt1399z00_284,((long)1)); 
BgL_arg2007z00_1079 = 
VECTOR_REF(BgL_opt1399z00_284,((long)2)); 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_ivz00_1080;
BgL_ivz00_1080 = BgL_ivz00_1051; 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_modez00_1081;
BgL_modez00_1081 = BgL_modez00_1052; 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_noncezd2initz12zc0_1082;
BgL_noncezd2initz12zc0_1082 = BgL_noncezd2initz12zc0_1053; 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_noncezd2updatez12zc0_1083;
BgL_noncezd2updatez12zc0_1083 = BgL_noncezd2updatez12zc0_1054; 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_padz00_1084;
BgL_padz00_1084 = BgL_padz00_1055; 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_stringzd2ze3keyz31_1085;
BgL_stringzd2ze3keyz31_1085 = BgL_stringzd2ze3keyz31_1056; 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_res2894z00_3297;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_cipherz00_3280;obj_t BgL_filenamez00_3281;obj_t BgL_passwordz00_3282;
if(
SYMBOLP(BgL_arg2005z00_1077))
{ /* Llib/block_ciphers.scm 821 */
BgL_cipherz00_3280 = BgL_arg2005z00_1077; }  else 
{ 
obj_t BgL_auxz00_8654;
BgL_auxz00_8654 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29807)), BGl_string3763z00zz__cryptozd2blockzd2ciphersz00, BGl_string3752z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2005z00_1077); 
FAILURE(BgL_auxz00_8654,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg2006z00_1078))
{ /* Llib/block_ciphers.scm 821 */
BgL_filenamez00_3281 = BgL_arg2006z00_1078; }  else 
{ 
obj_t BgL_auxz00_8660;
BgL_auxz00_8660 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29807)), BGl_string3763z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2006z00_1078); 
FAILURE(BgL_auxz00_8660,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg2007z00_1079))
{ /* Llib/block_ciphers.scm 821 */
BgL_passwordz00_3282 = BgL_arg2007z00_1079; }  else 
{ 
obj_t BgL_auxz00_8666;
BgL_auxz00_8666 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29807)), BGl_string3763z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2007z00_1079); 
FAILURE(BgL_auxz00_8666,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 825 */
obj_t BgL_pz00_3283;
{ /* Llib/block_ciphers.scm 825 */

BgL_pz00_3283 = 
BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(BgL_filenamez00_3281, BTRUE, 
BINT(((long)5000000))); } 
if(
CBOOL(BgL_pz00_3283))
{ /* Llib/block_ciphers.scm 826 */BFALSE; }  else 
{ /* Llib/block_ciphers.scm 826 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)35)), BGl_string3764z00zz__cryptozd2blockzd2ciphersz00, BgL_filenamez00_3281); } 
{ /* Llib/block_ciphers.scm 830 */
obj_t BgL_exitd1228z00_3287;
BgL_exitd1228z00_3287 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Llib/block_ciphers.scm 834 */
obj_t BgL_zc3anonymousza32015ze3z83_5011;
BgL_zc3anonymousza32015ze3z83_5011 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32015ze3ze1zz__cryptozd2blockzd2ciphersz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza32015ze3z83_5011, 
(int)(((long)0)), BgL_pz00_3283); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1228z00_3287, BgL_zc3anonymousza32015ze3z83_5011); 
{ /* Llib/block_ciphers.scm 831 */
obj_t BgL_tmp1230z00_3289;
{ /* Llib/block_ciphers.scm 831 */
obj_t BgL_plaintextz00_3291;
if(
INPUT_PORTP(BgL_pz00_3283))
{ /* Llib/block_ciphers.scm 831 */
BgL_plaintextz00_3291 = BgL_pz00_3283; }  else 
{ 
obj_t BgL_auxz00_8685;
BgL_auxz00_8685 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30174)), BGl_string3763z00zz__cryptozd2blockzd2ciphersz00, BGl_string3761z00zz__cryptozd2blockzd2ciphersz00, BgL_pz00_3283); 
FAILURE(BgL_auxz00_8685,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 812 */
obj_t BgL_pz00_3292;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3293;
{ /* Llib/block_ciphers.scm 812 */

{ /* Llib/block_ciphers.scm 812 */

BgL_pz00_3292 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
BgL_statez00_3293 = 
BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_3280, BgL_passwordz00_3282, BgL_ivz00_1080, BgL_modez00_1081, BgL_padz00_1084, BgL_noncezd2initz12zc0_1082, BgL_noncezd2updatez12zc0_1083, BgL_stringzd2ze3keyz31_1085); 
BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3293, BgL_plaintextz00_3291, ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_pz00_3292, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00); 
BgL_tmp1230z00_3289 = 
bgl_close_output_port(BgL_pz00_3292); } } 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1228z00_3287); 
{ /* Llib/block_ciphers.scm 834 */
obj_t BgL_portz00_3296;
if(
INPUT_PORTP(BgL_pz00_3283))
{ /* Llib/block_ciphers.scm 834 */
BgL_portz00_3296 = BgL_pz00_3283; }  else 
{ 
obj_t BgL_auxz00_8696;
BgL_auxz00_8696 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30270)), BGl_string3763z00zz__cryptozd2blockzd2ciphersz00, BGl_string3761z00zz__cryptozd2blockzd2ciphersz00, BgL_pz00_3283); 
FAILURE(BgL_auxz00_8696,BFALSE,BFALSE);} 
bgl_close_input_port(BgL_portz00_3296); } 
if(
STRINGP(BgL_tmp1230z00_3289))
{ /* Llib/block_ciphers.scm 830 */
BgL_res2894z00_3297 = BgL_tmp1230z00_3289; }  else 
{ 
obj_t BgL_auxz00_8703;
BgL_auxz00_8703 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30130)), BGl_string3763z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_tmp1230z00_3289); 
FAILURE(BgL_auxz00_8703,BFALSE,BFALSE);} } } } } } 
return BgL_res2894z00_3297;} } } } } } } } } } } } } } } } } 
BGL_FUNCTION_END;
}



/* search1401~0 */
obj_t BGl_search1401ze70ze7zz__cryptozd2blockzd2ciphersz00(long BgL_l1400z00_5658, obj_t BgL_opt1399z00_5657, obj_t BgL_k1z00_1045, long BgL_iz00_1046)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 821 */
BGl_search1401ze70ze7zz__cryptozd2blockzd2ciphersz00:
if(
(BgL_iz00_1046==BgL_l1400z00_5658))
{ /* Llib/block_ciphers.scm 821 */
return 
BINT(((long)-1));}  else 
{ /* Llib/block_ciphers.scm 821 */
if(
(BgL_iz00_1046==
(BgL_l1400z00_5658-((long)1))))
{ /* Llib/block_ciphers.scm 821 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)34)), BGl_string3754z00zz__cryptozd2blockzd2ciphersz00, 
BINT(
VECTOR_LENGTH(BgL_opt1399z00_5657)));}  else 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_vz00_1090;
BgL_vz00_1090 = 
VECTOR_REF(BgL_opt1399z00_5657,BgL_iz00_1046); 
if(
(BgL_vz00_1090==BgL_k1z00_1045))
{ /* Llib/block_ciphers.scm 821 */
return 
BINT(
(BgL_iz00_1046+((long)1)));}  else 
{ 
long BgL_iz00_8722;
BgL_iz00_8722 = 
(BgL_iz00_1046+((long)2)); 
BgL_iz00_1046 = BgL_iz00_8722; 
goto BGl_search1401ze70ze7zz__cryptozd2blockzd2ciphersz00;} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2015> */
obj_t BGl_z62zc3anonymousza32015ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5012)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 830 */
{ /* Llib/block_ciphers.scm 834 */
obj_t BgL_pz00_5013;
BgL_pz00_5013 = 
PROCEDURE_REF(BgL_envz00_5012, 
(int)(((long)0))); 
return 
bgl_close_input_port(
((obj_t)BgL_pz00_5013));} } 
BGL_FUNCTION_END;
}



/* encrypt-file */
BGL_EXPORTED_DEF obj_t BGl_encryptzd2filezd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_275, obj_t BgL_filenamez00_276, obj_t BgL_passwordz00_277, obj_t BgL_ivz00_278, obj_t BgL_modez00_279, obj_t BgL_noncezd2initz12zc0_280, obj_t BgL_noncezd2updatez12zc0_281, obj_t BgL_padz00_282, obj_t BgL_stringzd2ze3keyz31_283)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 821 */
{ /* Llib/block_ciphers.scm 825 */
obj_t BgL_pz00_3298;
{ /* Llib/block_ciphers.scm 825 */

BgL_pz00_3298 = 
BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(BgL_filenamez00_276, BTRUE, 
BINT(((long)5000000))); } 
if(
CBOOL(BgL_pz00_3298))
{ /* Llib/block_ciphers.scm 826 */BFALSE; }  else 
{ /* Llib/block_ciphers.scm 826 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)35)), BGl_string3764z00zz__cryptozd2blockzd2ciphersz00, BgL_filenamez00_276); } 
{ /* Llib/block_ciphers.scm 830 */
obj_t BgL_exitd1228z00_3302;
BgL_exitd1228z00_3302 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Llib/block_ciphers.scm 834 */
obj_t BgL_zc3anonymousza32015ze3z83_5014;
BgL_zc3anonymousza32015ze3z83_5014 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32015ze33299ze1zz__cryptozd2blockzd2ciphersz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza32015ze3z83_5014, 
(int)(((long)0)), BgL_pz00_3298); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1228z00_3302, BgL_zc3anonymousza32015ze3z83_5014); 
{ /* Llib/block_ciphers.scm 831 */
obj_t BgL_tmp1230z00_3304;
{ /* Llib/block_ciphers.scm 812 */
obj_t BgL_pz00_3307;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3308;
{ /* Llib/block_ciphers.scm 812 */

{ /* Llib/block_ciphers.scm 812 */

BgL_pz00_3307 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
BgL_statez00_3308 = 
BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_275, BgL_passwordz00_277, BgL_ivz00_278, BgL_modez00_279, BgL_padz00_282, BgL_noncezd2initz12zc0_280, BgL_noncezd2updatez12zc0_281, BgL_stringzd2ze3keyz31_283); 
BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3308, 
((obj_t)BgL_pz00_3298), ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_pz00_3307, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00); 
BgL_tmp1230z00_3304 = 
bgl_close_output_port(BgL_pz00_3307); } 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1228z00_3302); 
bgl_close_input_port(
((obj_t)BgL_pz00_3298)); 
return BgL_tmp1230z00_3304;} } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2015>3299 */
obj_t BGl_z62zc3anonymousza32015ze33299ze1zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5015)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 830 */
{ /* Llib/block_ciphers.scm 834 */
obj_t BgL_pz00_5016;
BgL_pz00_5016 = 
PROCEDURE_REF(BgL_envz00_5015, 
(int)(((long)0))); 
return 
bgl_close_input_port(
((obj_t)BgL_pz00_5016));} } 
BGL_FUNCTION_END;
}



/* _encrypt-sendchars */
obj_t BGl__encryptzd2sendcharszd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_297, obj_t BgL_opt1410z00_296)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 836 */
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_cipherz00_1107;obj_t BgL_inz00_1108;obj_t BgL_outz00_1109;obj_t BgL_passwordz00_1110;
BgL_cipherz00_1107 = 
VECTOR_REF(BgL_opt1410z00_296,((long)0)); 
BgL_inz00_1108 = 
VECTOR_REF(BgL_opt1410z00_296,((long)1)); 
BgL_outz00_1109 = 
VECTOR_REF(BgL_opt1410z00_296,((long)2)); 
BgL_passwordz00_1110 = 
VECTOR_REF(BgL_opt1410z00_296,((long)3)); 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_ivz00_1111;
BgL_ivz00_1111 = BFALSE; 
{ /* Llib/block_ciphers.scm 838 */
obj_t BgL_modez00_1112;
BgL_modez00_1112 = 
CNST_TABLE_REF(((long)10)); 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_noncezd2initz12zc0_1113;
BgL_noncezd2initz12zc0_1113 = BFALSE; 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_noncezd2updatez12zc0_1114;
BgL_noncezd2updatez12zc0_1114 = BFALSE; 
{ /* Llib/block_ciphers.scm 838 */
obj_t BgL_padz00_1115;
BgL_padz00_1115 = 
CNST_TABLE_REF(((long)16)); 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_stringzd2ze3keyz31_1116;
BgL_stringzd2ze3keyz31_1116 = BFALSE; 
{ /* Llib/block_ciphers.scm 836 */

{ 
long BgL_iz00_1117;
BgL_iz00_1117 = ((long)4); 
BgL_check1413z00_1118:
if(
(BgL_iz00_1117==
VECTOR_LENGTH(BgL_opt1410z00_296)))
{ /* Llib/block_ciphers.scm 836 */BNIL; }  else 
{ /* Llib/block_ciphers.scm 836 */
bool_t BgL_testz00_8762;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_arg2021z00_1124;
BgL_arg2021z00_1124 = 
VECTOR_REF(BgL_opt1410z00_296,BgL_iz00_1117); 
BgL_testz00_8762 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg2021z00_1124, 
CNST_TABLE_REF(((long)23)))); } 
if(BgL_testz00_8762)
{ 
long BgL_iz00_8767;
BgL_iz00_8767 = 
(BgL_iz00_1117+((long)2)); 
BgL_iz00_1117 = BgL_iz00_8767; 
goto BgL_check1413z00_1118;}  else 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_arg2020z00_1123;
BgL_arg2020z00_1123 = 
VECTOR_REF(BgL_opt1410z00_296,BgL_iz00_1117); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)36)), BGl_string3749z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2020z00_1123); } } } 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_index1415z00_1125;
BgL_index1415z00_1125 = 
BGl_search1412ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1410z00_296), BgL_opt1410z00_296, 
CNST_TABLE_REF(((long)25)), ((long)4)); 
{ /* Llib/block_ciphers.scm 836 */
bool_t BgL_testz00_8775;
{ /* Llib/block_ciphers.scm 836 */
long BgL_n1z00_3334;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_tmpz00_8776;
if(
INTEGERP(BgL_index1415z00_1125))
{ /* Llib/block_ciphers.scm 836 */
BgL_tmpz00_8776 = BgL_index1415z00_1125
; }  else 
{ 
obj_t BgL_auxz00_8779;
BgL_auxz00_8779 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30277)), BGl_string3765z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1415z00_1125); 
FAILURE(BgL_auxz00_8779,BFALSE,BFALSE);} 
BgL_n1z00_3334 = 
(long)CINT(BgL_tmpz00_8776); } 
BgL_testz00_8775 = 
(BgL_n1z00_3334>=((long)0)); } 
if(BgL_testz00_8775)
{ 
long BgL_auxz00_8785;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_tmpz00_8786;
if(
INTEGERP(BgL_index1415z00_1125))
{ /* Llib/block_ciphers.scm 836 */
BgL_tmpz00_8786 = BgL_index1415z00_1125
; }  else 
{ 
obj_t BgL_auxz00_8789;
BgL_auxz00_8789 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30277)), BGl_string3765z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1415z00_1125); 
FAILURE(BgL_auxz00_8789,BFALSE,BFALSE);} 
BgL_auxz00_8785 = 
(long)CINT(BgL_tmpz00_8786); } 
BgL_ivz00_1111 = 
VECTOR_REF(BgL_opt1410z00_296,BgL_auxz00_8785); }  else 
{ /* Llib/block_ciphers.scm 836 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_index1416z00_1127;
BgL_index1416z00_1127 = 
BGl_search1412ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1410z00_296), BgL_opt1410z00_296, 
CNST_TABLE_REF(((long)26)), ((long)4)); 
{ /* Llib/block_ciphers.scm 836 */
bool_t BgL_testz00_8798;
{ /* Llib/block_ciphers.scm 836 */
long BgL_n1z00_3336;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_tmpz00_8799;
if(
INTEGERP(BgL_index1416z00_1127))
{ /* Llib/block_ciphers.scm 836 */
BgL_tmpz00_8799 = BgL_index1416z00_1127
; }  else 
{ 
obj_t BgL_auxz00_8802;
BgL_auxz00_8802 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30277)), BGl_string3765z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1416z00_1127); 
FAILURE(BgL_auxz00_8802,BFALSE,BFALSE);} 
BgL_n1z00_3336 = 
(long)CINT(BgL_tmpz00_8799); } 
BgL_testz00_8798 = 
(BgL_n1z00_3336>=((long)0)); } 
if(BgL_testz00_8798)
{ 
long BgL_auxz00_8808;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_tmpz00_8809;
if(
INTEGERP(BgL_index1416z00_1127))
{ /* Llib/block_ciphers.scm 836 */
BgL_tmpz00_8809 = BgL_index1416z00_1127
; }  else 
{ 
obj_t BgL_auxz00_8812;
BgL_auxz00_8812 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30277)), BGl_string3765z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1416z00_1127); 
FAILURE(BgL_auxz00_8812,BFALSE,BFALSE);} 
BgL_auxz00_8808 = 
(long)CINT(BgL_tmpz00_8809); } 
BgL_modez00_1112 = 
VECTOR_REF(BgL_opt1410z00_296,BgL_auxz00_8808); }  else 
{ /* Llib/block_ciphers.scm 836 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_index1417z00_1129;
BgL_index1417z00_1129 = 
BGl_search1412ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1410z00_296), BgL_opt1410z00_296, 
CNST_TABLE_REF(((long)27)), ((long)4)); 
{ /* Llib/block_ciphers.scm 836 */
bool_t BgL_testz00_8821;
{ /* Llib/block_ciphers.scm 836 */
long BgL_n1z00_3338;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_tmpz00_8822;
if(
INTEGERP(BgL_index1417z00_1129))
{ /* Llib/block_ciphers.scm 836 */
BgL_tmpz00_8822 = BgL_index1417z00_1129
; }  else 
{ 
obj_t BgL_auxz00_8825;
BgL_auxz00_8825 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30277)), BGl_string3765z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1417z00_1129); 
FAILURE(BgL_auxz00_8825,BFALSE,BFALSE);} 
BgL_n1z00_3338 = 
(long)CINT(BgL_tmpz00_8822); } 
BgL_testz00_8821 = 
(BgL_n1z00_3338>=((long)0)); } 
if(BgL_testz00_8821)
{ 
long BgL_auxz00_8831;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_tmpz00_8832;
if(
INTEGERP(BgL_index1417z00_1129))
{ /* Llib/block_ciphers.scm 836 */
BgL_tmpz00_8832 = BgL_index1417z00_1129
; }  else 
{ 
obj_t BgL_auxz00_8835;
BgL_auxz00_8835 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30277)), BGl_string3765z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1417z00_1129); 
FAILURE(BgL_auxz00_8835,BFALSE,BFALSE);} 
BgL_auxz00_8831 = 
(long)CINT(BgL_tmpz00_8832); } 
BgL_noncezd2initz12zc0_1113 = 
VECTOR_REF(BgL_opt1410z00_296,BgL_auxz00_8831); }  else 
{ /* Llib/block_ciphers.scm 836 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_index1418z00_1131;
BgL_index1418z00_1131 = 
BGl_search1412ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1410z00_296), BgL_opt1410z00_296, 
CNST_TABLE_REF(((long)28)), ((long)4)); 
{ /* Llib/block_ciphers.scm 836 */
bool_t BgL_testz00_8844;
{ /* Llib/block_ciphers.scm 836 */
long BgL_n1z00_3340;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_tmpz00_8845;
if(
INTEGERP(BgL_index1418z00_1131))
{ /* Llib/block_ciphers.scm 836 */
BgL_tmpz00_8845 = BgL_index1418z00_1131
; }  else 
{ 
obj_t BgL_auxz00_8848;
BgL_auxz00_8848 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30277)), BGl_string3765z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1418z00_1131); 
FAILURE(BgL_auxz00_8848,BFALSE,BFALSE);} 
BgL_n1z00_3340 = 
(long)CINT(BgL_tmpz00_8845); } 
BgL_testz00_8844 = 
(BgL_n1z00_3340>=((long)0)); } 
if(BgL_testz00_8844)
{ 
long BgL_auxz00_8854;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_tmpz00_8855;
if(
INTEGERP(BgL_index1418z00_1131))
{ /* Llib/block_ciphers.scm 836 */
BgL_tmpz00_8855 = BgL_index1418z00_1131
; }  else 
{ 
obj_t BgL_auxz00_8858;
BgL_auxz00_8858 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30277)), BGl_string3765z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1418z00_1131); 
FAILURE(BgL_auxz00_8858,BFALSE,BFALSE);} 
BgL_auxz00_8854 = 
(long)CINT(BgL_tmpz00_8855); } 
BgL_noncezd2updatez12zc0_1114 = 
VECTOR_REF(BgL_opt1410z00_296,BgL_auxz00_8854); }  else 
{ /* Llib/block_ciphers.scm 836 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_index1419z00_1133;
BgL_index1419z00_1133 = 
BGl_search1412ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1410z00_296), BgL_opt1410z00_296, 
CNST_TABLE_REF(((long)29)), ((long)4)); 
{ /* Llib/block_ciphers.scm 836 */
bool_t BgL_testz00_8867;
{ /* Llib/block_ciphers.scm 836 */
long BgL_n1z00_3342;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_tmpz00_8868;
if(
INTEGERP(BgL_index1419z00_1133))
{ /* Llib/block_ciphers.scm 836 */
BgL_tmpz00_8868 = BgL_index1419z00_1133
; }  else 
{ 
obj_t BgL_auxz00_8871;
BgL_auxz00_8871 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30277)), BGl_string3765z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1419z00_1133); 
FAILURE(BgL_auxz00_8871,BFALSE,BFALSE);} 
BgL_n1z00_3342 = 
(long)CINT(BgL_tmpz00_8868); } 
BgL_testz00_8867 = 
(BgL_n1z00_3342>=((long)0)); } 
if(BgL_testz00_8867)
{ 
long BgL_auxz00_8877;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_tmpz00_8878;
if(
INTEGERP(BgL_index1419z00_1133))
{ /* Llib/block_ciphers.scm 836 */
BgL_tmpz00_8878 = BgL_index1419z00_1133
; }  else 
{ 
obj_t BgL_auxz00_8881;
BgL_auxz00_8881 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30277)), BGl_string3765z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1419z00_1133); 
FAILURE(BgL_auxz00_8881,BFALSE,BFALSE);} 
BgL_auxz00_8877 = 
(long)CINT(BgL_tmpz00_8878); } 
BgL_padz00_1115 = 
VECTOR_REF(BgL_opt1410z00_296,BgL_auxz00_8877); }  else 
{ /* Llib/block_ciphers.scm 836 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_index1420z00_1135;
BgL_index1420z00_1135 = 
BGl_search1412ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1410z00_296), BgL_opt1410z00_296, 
CNST_TABLE_REF(((long)30)), ((long)4)); 
{ /* Llib/block_ciphers.scm 836 */
bool_t BgL_testz00_8890;
{ /* Llib/block_ciphers.scm 836 */
long BgL_n1z00_3344;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_tmpz00_8891;
if(
INTEGERP(BgL_index1420z00_1135))
{ /* Llib/block_ciphers.scm 836 */
BgL_tmpz00_8891 = BgL_index1420z00_1135
; }  else 
{ 
obj_t BgL_auxz00_8894;
BgL_auxz00_8894 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30277)), BGl_string3765z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1420z00_1135); 
FAILURE(BgL_auxz00_8894,BFALSE,BFALSE);} 
BgL_n1z00_3344 = 
(long)CINT(BgL_tmpz00_8891); } 
BgL_testz00_8890 = 
(BgL_n1z00_3344>=((long)0)); } 
if(BgL_testz00_8890)
{ 
long BgL_auxz00_8900;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_tmpz00_8901;
if(
INTEGERP(BgL_index1420z00_1135))
{ /* Llib/block_ciphers.scm 836 */
BgL_tmpz00_8901 = BgL_index1420z00_1135
; }  else 
{ 
obj_t BgL_auxz00_8904;
BgL_auxz00_8904 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30277)), BGl_string3765z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1420z00_1135); 
FAILURE(BgL_auxz00_8904,BFALSE,BFALSE);} 
BgL_auxz00_8900 = 
(long)CINT(BgL_tmpz00_8901); } 
BgL_stringzd2ze3keyz31_1116 = 
VECTOR_REF(BgL_opt1410z00_296,BgL_auxz00_8900); }  else 
{ /* Llib/block_ciphers.scm 836 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_arg2028z00_1137;obj_t BgL_arg2029z00_1138;obj_t BgL_arg2030z00_1139;obj_t BgL_arg2031z00_1140;
BgL_arg2028z00_1137 = 
VECTOR_REF(BgL_opt1410z00_296,((long)0)); 
BgL_arg2029z00_1138 = 
VECTOR_REF(BgL_opt1410z00_296,((long)1)); 
BgL_arg2030z00_1139 = 
VECTOR_REF(BgL_opt1410z00_296,((long)2)); 
BgL_arg2031z00_1140 = 
VECTOR_REF(BgL_opt1410z00_296,((long)3)); 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_ivz00_1141;
BgL_ivz00_1141 = BgL_ivz00_1111; 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_modez00_1142;
BgL_modez00_1142 = BgL_modez00_1112; 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_noncezd2initz12zc0_1143;
BgL_noncezd2initz12zc0_1143 = BgL_noncezd2initz12zc0_1113; 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_noncezd2updatez12zc0_1144;
BgL_noncezd2updatez12zc0_1144 = BgL_noncezd2updatez12zc0_1114; 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_padz00_1145;
BgL_padz00_1145 = BgL_padz00_1115; 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_stringzd2ze3keyz31_1146;
BgL_stringzd2ze3keyz31_1146 = BgL_stringzd2ze3keyz31_1116; 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_cipherz00_3346;obj_t BgL_inz00_3347;obj_t BgL_outz00_3348;obj_t BgL_passwordz00_3349;
if(
SYMBOLP(BgL_arg2028z00_1137))
{ /* Llib/block_ciphers.scm 836 */
BgL_cipherz00_3346 = BgL_arg2028z00_1137; }  else 
{ 
obj_t BgL_auxz00_8916;
BgL_auxz00_8916 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30277)), BGl_string3765z00zz__cryptozd2blockzd2ciphersz00, BGl_string3752z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2028z00_1137); 
FAILURE(BgL_auxz00_8916,BFALSE,BFALSE);} 
if(
INPUT_PORTP(BgL_arg2029z00_1138))
{ /* Llib/block_ciphers.scm 836 */
BgL_inz00_3347 = BgL_arg2029z00_1138; }  else 
{ 
obj_t BgL_auxz00_8922;
BgL_auxz00_8922 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30277)), BGl_string3765z00zz__cryptozd2blockzd2ciphersz00, BGl_string3761z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2029z00_1138); 
FAILURE(BgL_auxz00_8922,BFALSE,BFALSE);} 
if(
OUTPUT_PORTP(BgL_arg2030z00_1139))
{ /* Llib/block_ciphers.scm 836 */
BgL_outz00_3348 = BgL_arg2030z00_1139; }  else 
{ 
obj_t BgL_auxz00_8928;
BgL_auxz00_8928 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30277)), BGl_string3765z00zz__cryptozd2blockzd2ciphersz00, BGl_string3766z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2030z00_1139); 
FAILURE(BgL_auxz00_8928,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg2031z00_1140))
{ /* Llib/block_ciphers.scm 836 */
BgL_passwordz00_3349 = BgL_arg2031z00_1140; }  else 
{ 
obj_t BgL_auxz00_8934;
BgL_auxz00_8934 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30277)), BGl_string3765z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2031z00_1140); 
FAILURE(BgL_auxz00_8934,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 841 */
BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3350;
BgL_statez00_3350 = 
BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_3346, BgL_passwordz00_3349, BgL_ivz00_1141, BgL_modez00_1142, BgL_padz00_1145, BgL_noncezd2initz12zc0_1143, BgL_noncezd2updatez12zc0_1144, BgL_stringzd2ze3keyz31_1146); 
return 
BINT(
BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3350, BgL_inz00_3347, ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_outz00_3348, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00));} } } } } } } } } } } } } } } } } } 
BGL_FUNCTION_END;
}



/* search1412~0 */
obj_t BGl_search1412ze70ze7zz__cryptozd2blockzd2ciphersz00(long BgL_l1411z00_5656, obj_t BgL_opt1410z00_5655, obj_t BgL_k1z00_1104, long BgL_iz00_1105)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 836 */
BGl_search1412ze70ze7zz__cryptozd2blockzd2ciphersz00:
if(
(BgL_iz00_1105==BgL_l1411z00_5656))
{ /* Llib/block_ciphers.scm 836 */
return 
BINT(((long)-1));}  else 
{ /* Llib/block_ciphers.scm 836 */
if(
(BgL_iz00_1105==
(BgL_l1411z00_5656-((long)1))))
{ /* Llib/block_ciphers.scm 836 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)36)), BGl_string3767z00zz__cryptozd2blockzd2ciphersz00, 
BINT(
VECTOR_LENGTH(BgL_opt1410z00_5655)));}  else 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_vz00_1151;
BgL_vz00_1151 = 
VECTOR_REF(BgL_opt1410z00_5655,BgL_iz00_1105); 
if(
(BgL_vz00_1151==BgL_k1z00_1104))
{ /* Llib/block_ciphers.scm 836 */
return 
BINT(
(BgL_iz00_1105+((long)1)));}  else 
{ 
long BgL_iz00_8956;
BgL_iz00_8956 = 
(BgL_iz00_1105+((long)2)); 
BgL_iz00_1105 = BgL_iz00_8956; 
goto BGl_search1412ze70ze7zz__cryptozd2blockzd2ciphersz00;} } } } 
BGL_FUNCTION_END;
}



/* encrypt-sendchars */
BGL_EXPORTED_DEF obj_t BGl_encryptzd2sendcharszd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_286, obj_t BgL_inz00_287, obj_t BgL_outz00_288, obj_t BgL_passwordz00_289, obj_t BgL_ivz00_290, obj_t BgL_modez00_291, obj_t BgL_noncezd2initz12zc0_292, obj_t BgL_noncezd2updatez12zc0_293, obj_t BgL_padz00_294, obj_t BgL_stringzd2ze3keyz31_295)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 836 */
{ /* Llib/block_ciphers.scm 841 */
BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3351;
BgL_statez00_3351 = 
BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_286, BgL_passwordz00_289, BgL_ivz00_290, BgL_modez00_291, BgL_padz00_294, BgL_noncezd2initz12zc0_292, BgL_noncezd2updatez12zc0_293, BgL_stringzd2ze3keyz31_295); 
return 
BINT(
BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3351, BgL_inz00_287, ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_outz00_288, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00));} } 
BGL_FUNCTION_END;
}



/* _decrypt */
obj_t BGl__decryptz00zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_308, obj_t BgL_opt1421z00_307)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 850 */
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_cipherz00_1160;obj_t BgL_ciphertextz00_1161;obj_t BgL_passwordz00_1162;
BgL_cipherz00_1160 = 
VECTOR_REF(BgL_opt1421z00_307,((long)0)); 
BgL_ciphertextz00_1161 = 
VECTOR_REF(BgL_opt1421z00_307,((long)1)); 
BgL_passwordz00_1162 = 
VECTOR_REF(BgL_opt1421z00_307,((long)2)); 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_ivz00_1163;
BgL_ivz00_1163 = BFALSE; 
{ /* Llib/block_ciphers.scm 851 */
obj_t BgL_modez00_1164;
BgL_modez00_1164 = 
CNST_TABLE_REF(((long)10)); 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_noncezd2initz12zc0_1165;
BgL_noncezd2initz12zc0_1165 = BFALSE; 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_noncezd2updatez12zc0_1166;
BgL_noncezd2updatez12zc0_1166 = BFALSE; 
{ /* Llib/block_ciphers.scm 851 */
obj_t BgL_padz00_1167;
BgL_padz00_1167 = 
CNST_TABLE_REF(((long)16)); 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_stringzd2ze3keyz31_1168;
BgL_stringzd2ze3keyz31_1168 = BFALSE; 
{ /* Llib/block_ciphers.scm 850 */

{ 
long BgL_iz00_1169;
BgL_iz00_1169 = ((long)3); 
BgL_check1424z00_1170:
if(
(BgL_iz00_1169==
VECTOR_LENGTH(BgL_opt1421z00_307)))
{ /* Llib/block_ciphers.scm 850 */BNIL; }  else 
{ /* Llib/block_ciphers.scm 850 */
bool_t BgL_testz00_8969;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_arg2044z00_1176;
BgL_arg2044z00_1176 = 
VECTOR_REF(BgL_opt1421z00_307,BgL_iz00_1169); 
BgL_testz00_8969 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg2044z00_1176, 
CNST_TABLE_REF(((long)23)))); } 
if(BgL_testz00_8969)
{ 
long BgL_iz00_8974;
BgL_iz00_8974 = 
(BgL_iz00_1169+((long)2)); 
BgL_iz00_1169 = BgL_iz00_8974; 
goto BgL_check1424z00_1170;}  else 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_arg2043z00_1175;
BgL_arg2043z00_1175 = 
VECTOR_REF(BgL_opt1421z00_307,BgL_iz00_1169); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)37)), BGl_string3749z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2043z00_1175); } } } 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_index1426z00_1177;
BgL_index1426z00_1177 = 
BGl_search1423ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1421z00_307), BgL_opt1421z00_307, 
CNST_TABLE_REF(((long)25)), ((long)3)); 
{ /* Llib/block_ciphers.scm 850 */
bool_t BgL_testz00_8982;
{ /* Llib/block_ciphers.scm 850 */
long BgL_n1z00_3374;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_tmpz00_8983;
if(
INTEGERP(BgL_index1426z00_1177))
{ /* Llib/block_ciphers.scm 850 */
BgL_tmpz00_8983 = BgL_index1426z00_1177
; }  else 
{ 
obj_t BgL_auxz00_8986;
BgL_auxz00_8986 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30763)), BGl_string3768z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1426z00_1177); 
FAILURE(BgL_auxz00_8986,BFALSE,BFALSE);} 
BgL_n1z00_3374 = 
(long)CINT(BgL_tmpz00_8983); } 
BgL_testz00_8982 = 
(BgL_n1z00_3374>=((long)0)); } 
if(BgL_testz00_8982)
{ 
long BgL_auxz00_8992;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_tmpz00_8993;
if(
INTEGERP(BgL_index1426z00_1177))
{ /* Llib/block_ciphers.scm 850 */
BgL_tmpz00_8993 = BgL_index1426z00_1177
; }  else 
{ 
obj_t BgL_auxz00_8996;
BgL_auxz00_8996 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30763)), BGl_string3768z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1426z00_1177); 
FAILURE(BgL_auxz00_8996,BFALSE,BFALSE);} 
BgL_auxz00_8992 = 
(long)CINT(BgL_tmpz00_8993); } 
BgL_ivz00_1163 = 
VECTOR_REF(BgL_opt1421z00_307,BgL_auxz00_8992); }  else 
{ /* Llib/block_ciphers.scm 850 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_index1427z00_1179;
BgL_index1427z00_1179 = 
BGl_search1423ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1421z00_307), BgL_opt1421z00_307, 
CNST_TABLE_REF(((long)26)), ((long)3)); 
{ /* Llib/block_ciphers.scm 850 */
bool_t BgL_testz00_9005;
{ /* Llib/block_ciphers.scm 850 */
long BgL_n1z00_3376;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_tmpz00_9006;
if(
INTEGERP(BgL_index1427z00_1179))
{ /* Llib/block_ciphers.scm 850 */
BgL_tmpz00_9006 = BgL_index1427z00_1179
; }  else 
{ 
obj_t BgL_auxz00_9009;
BgL_auxz00_9009 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30763)), BGl_string3768z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1427z00_1179); 
FAILURE(BgL_auxz00_9009,BFALSE,BFALSE);} 
BgL_n1z00_3376 = 
(long)CINT(BgL_tmpz00_9006); } 
BgL_testz00_9005 = 
(BgL_n1z00_3376>=((long)0)); } 
if(BgL_testz00_9005)
{ 
long BgL_auxz00_9015;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_tmpz00_9016;
if(
INTEGERP(BgL_index1427z00_1179))
{ /* Llib/block_ciphers.scm 850 */
BgL_tmpz00_9016 = BgL_index1427z00_1179
; }  else 
{ 
obj_t BgL_auxz00_9019;
BgL_auxz00_9019 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30763)), BGl_string3768z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1427z00_1179); 
FAILURE(BgL_auxz00_9019,BFALSE,BFALSE);} 
BgL_auxz00_9015 = 
(long)CINT(BgL_tmpz00_9016); } 
BgL_modez00_1164 = 
VECTOR_REF(BgL_opt1421z00_307,BgL_auxz00_9015); }  else 
{ /* Llib/block_ciphers.scm 850 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_index1428z00_1181;
BgL_index1428z00_1181 = 
BGl_search1423ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1421z00_307), BgL_opt1421z00_307, 
CNST_TABLE_REF(((long)27)), ((long)3)); 
{ /* Llib/block_ciphers.scm 850 */
bool_t BgL_testz00_9028;
{ /* Llib/block_ciphers.scm 850 */
long BgL_n1z00_3378;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_tmpz00_9029;
if(
INTEGERP(BgL_index1428z00_1181))
{ /* Llib/block_ciphers.scm 850 */
BgL_tmpz00_9029 = BgL_index1428z00_1181
; }  else 
{ 
obj_t BgL_auxz00_9032;
BgL_auxz00_9032 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30763)), BGl_string3768z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1428z00_1181); 
FAILURE(BgL_auxz00_9032,BFALSE,BFALSE);} 
BgL_n1z00_3378 = 
(long)CINT(BgL_tmpz00_9029); } 
BgL_testz00_9028 = 
(BgL_n1z00_3378>=((long)0)); } 
if(BgL_testz00_9028)
{ 
long BgL_auxz00_9038;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_tmpz00_9039;
if(
INTEGERP(BgL_index1428z00_1181))
{ /* Llib/block_ciphers.scm 850 */
BgL_tmpz00_9039 = BgL_index1428z00_1181
; }  else 
{ 
obj_t BgL_auxz00_9042;
BgL_auxz00_9042 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30763)), BGl_string3768z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1428z00_1181); 
FAILURE(BgL_auxz00_9042,BFALSE,BFALSE);} 
BgL_auxz00_9038 = 
(long)CINT(BgL_tmpz00_9039); } 
BgL_noncezd2initz12zc0_1165 = 
VECTOR_REF(BgL_opt1421z00_307,BgL_auxz00_9038); }  else 
{ /* Llib/block_ciphers.scm 850 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_index1429z00_1183;
BgL_index1429z00_1183 = 
BGl_search1423ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1421z00_307), BgL_opt1421z00_307, 
CNST_TABLE_REF(((long)28)), ((long)3)); 
{ /* Llib/block_ciphers.scm 850 */
bool_t BgL_testz00_9051;
{ /* Llib/block_ciphers.scm 850 */
long BgL_n1z00_3380;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_tmpz00_9052;
if(
INTEGERP(BgL_index1429z00_1183))
{ /* Llib/block_ciphers.scm 850 */
BgL_tmpz00_9052 = BgL_index1429z00_1183
; }  else 
{ 
obj_t BgL_auxz00_9055;
BgL_auxz00_9055 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30763)), BGl_string3768z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1429z00_1183); 
FAILURE(BgL_auxz00_9055,BFALSE,BFALSE);} 
BgL_n1z00_3380 = 
(long)CINT(BgL_tmpz00_9052); } 
BgL_testz00_9051 = 
(BgL_n1z00_3380>=((long)0)); } 
if(BgL_testz00_9051)
{ 
long BgL_auxz00_9061;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_tmpz00_9062;
if(
INTEGERP(BgL_index1429z00_1183))
{ /* Llib/block_ciphers.scm 850 */
BgL_tmpz00_9062 = BgL_index1429z00_1183
; }  else 
{ 
obj_t BgL_auxz00_9065;
BgL_auxz00_9065 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30763)), BGl_string3768z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1429z00_1183); 
FAILURE(BgL_auxz00_9065,BFALSE,BFALSE);} 
BgL_auxz00_9061 = 
(long)CINT(BgL_tmpz00_9062); } 
BgL_noncezd2updatez12zc0_1166 = 
VECTOR_REF(BgL_opt1421z00_307,BgL_auxz00_9061); }  else 
{ /* Llib/block_ciphers.scm 850 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_index1430z00_1185;
BgL_index1430z00_1185 = 
BGl_search1423ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1421z00_307), BgL_opt1421z00_307, 
CNST_TABLE_REF(((long)29)), ((long)3)); 
{ /* Llib/block_ciphers.scm 850 */
bool_t BgL_testz00_9074;
{ /* Llib/block_ciphers.scm 850 */
long BgL_n1z00_3382;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_tmpz00_9075;
if(
INTEGERP(BgL_index1430z00_1185))
{ /* Llib/block_ciphers.scm 850 */
BgL_tmpz00_9075 = BgL_index1430z00_1185
; }  else 
{ 
obj_t BgL_auxz00_9078;
BgL_auxz00_9078 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30763)), BGl_string3768z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1430z00_1185); 
FAILURE(BgL_auxz00_9078,BFALSE,BFALSE);} 
BgL_n1z00_3382 = 
(long)CINT(BgL_tmpz00_9075); } 
BgL_testz00_9074 = 
(BgL_n1z00_3382>=((long)0)); } 
if(BgL_testz00_9074)
{ 
long BgL_auxz00_9084;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_tmpz00_9085;
if(
INTEGERP(BgL_index1430z00_1185))
{ /* Llib/block_ciphers.scm 850 */
BgL_tmpz00_9085 = BgL_index1430z00_1185
; }  else 
{ 
obj_t BgL_auxz00_9088;
BgL_auxz00_9088 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30763)), BGl_string3768z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1430z00_1185); 
FAILURE(BgL_auxz00_9088,BFALSE,BFALSE);} 
BgL_auxz00_9084 = 
(long)CINT(BgL_tmpz00_9085); } 
BgL_padz00_1167 = 
VECTOR_REF(BgL_opt1421z00_307,BgL_auxz00_9084); }  else 
{ /* Llib/block_ciphers.scm 850 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_index1431z00_1187;
BgL_index1431z00_1187 = 
BGl_search1423ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1421z00_307), BgL_opt1421z00_307, 
CNST_TABLE_REF(((long)30)), ((long)3)); 
{ /* Llib/block_ciphers.scm 850 */
bool_t BgL_testz00_9097;
{ /* Llib/block_ciphers.scm 850 */
long BgL_n1z00_3384;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_tmpz00_9098;
if(
INTEGERP(BgL_index1431z00_1187))
{ /* Llib/block_ciphers.scm 850 */
BgL_tmpz00_9098 = BgL_index1431z00_1187
; }  else 
{ 
obj_t BgL_auxz00_9101;
BgL_auxz00_9101 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30763)), BGl_string3768z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1431z00_1187); 
FAILURE(BgL_auxz00_9101,BFALSE,BFALSE);} 
BgL_n1z00_3384 = 
(long)CINT(BgL_tmpz00_9098); } 
BgL_testz00_9097 = 
(BgL_n1z00_3384>=((long)0)); } 
if(BgL_testz00_9097)
{ 
long BgL_auxz00_9107;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_tmpz00_9108;
if(
INTEGERP(BgL_index1431z00_1187))
{ /* Llib/block_ciphers.scm 850 */
BgL_tmpz00_9108 = BgL_index1431z00_1187
; }  else 
{ 
obj_t BgL_auxz00_9111;
BgL_auxz00_9111 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30763)), BGl_string3768z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1431z00_1187); 
FAILURE(BgL_auxz00_9111,BFALSE,BFALSE);} 
BgL_auxz00_9107 = 
(long)CINT(BgL_tmpz00_9108); } 
BgL_stringzd2ze3keyz31_1168 = 
VECTOR_REF(BgL_opt1421z00_307,BgL_auxz00_9107); }  else 
{ /* Llib/block_ciphers.scm 850 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_arg2051z00_1189;obj_t BgL_arg2052z00_1190;obj_t BgL_arg2053z00_1191;
BgL_arg2051z00_1189 = 
VECTOR_REF(BgL_opt1421z00_307,((long)0)); 
BgL_arg2052z00_1190 = 
VECTOR_REF(BgL_opt1421z00_307,((long)1)); 
BgL_arg2053z00_1191 = 
VECTOR_REF(BgL_opt1421z00_307,((long)2)); 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_ivz00_1192;
BgL_ivz00_1192 = BgL_ivz00_1163; 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_modez00_1193;
BgL_modez00_1193 = BgL_modez00_1164; 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_noncezd2initz12zc0_1194;
BgL_noncezd2initz12zc0_1194 = BgL_noncezd2initz12zc0_1165; 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_noncezd2updatez12zc0_1195;
BgL_noncezd2updatez12zc0_1195 = BgL_noncezd2updatez12zc0_1166; 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_padz00_1196;
BgL_padz00_1196 = BgL_padz00_1167; 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_stringzd2ze3keyz31_1197;
BgL_stringzd2ze3keyz31_1197 = BgL_stringzd2ze3keyz31_1168; 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_res2924z00_3396;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_cipherz00_3386;obj_t BgL_passwordz00_3387;
if(
SYMBOLP(BgL_arg2051z00_1189))
{ /* Llib/block_ciphers.scm 850 */
BgL_cipherz00_3386 = BgL_arg2051z00_1189; }  else 
{ 
obj_t BgL_auxz00_9122;
BgL_auxz00_9122 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30763)), BGl_string3768z00zz__cryptozd2blockzd2ciphersz00, BGl_string3752z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2051z00_1189); 
FAILURE(BgL_auxz00_9122,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg2053z00_1191))
{ /* Llib/block_ciphers.scm 850 */
BgL_passwordz00_3387 = BgL_arg2053z00_1191; }  else 
{ 
obj_t BgL_auxz00_9128;
BgL_auxz00_9128 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30763)), BGl_string3768z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2053z00_1191); 
FAILURE(BgL_auxz00_9128,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 854 */
obj_t BgL_redirectz00_3388;
if(
STRINGP(BgL_arg2052z00_1190))
{ /* Llib/block_ciphers.scm 855 */
BgL_redirectz00_3388 = BGl_decryptzd2fastzd2stringzd2envzd2zz__cryptozd2blockzd2ciphersz00; }  else 
{ /* Llib/block_ciphers.scm 856 */
bool_t BgL_testz00_9134;
{ /* Llib/block_ciphers.scm 856 */
bool_t BgL_res2922z00_3393;
BgL_res2922z00_3393 = 
BGL_MMAPP(BgL_arg2052z00_1190); 
BgL_testz00_9134 = BgL_res2922z00_3393; } 
if(BgL_testz00_9134)
{ /* Llib/block_ciphers.scm 856 */
BgL_redirectz00_3388 = BGl_decryptzd2fastzd2mmapzd2envzd2zz__cryptozd2blockzd2ciphersz00; }  else 
{ /* Llib/block_ciphers.scm 857 */
bool_t BgL_testz00_9136;
{ /* Llib/block_ciphers.scm 857 */
bool_t BgL__ortest_1056z00_3394;
BgL__ortest_1056z00_3394 = 
OUTPUT_PORTP(BgL_arg2052z00_1190); 
if(BgL__ortest_1056z00_3394)
{ /* Llib/block_ciphers.scm 857 */
BgL_testz00_9136 = BgL__ortest_1056z00_3394
; }  else 
{ /* Llib/block_ciphers.scm 857 */
BgL_testz00_9136 = 
INPUT_PORTP(BgL_arg2052z00_1190)
; } } 
if(BgL_testz00_9136)
{ /* Llib/block_ciphers.scm 857 */
BgL_redirectz00_3388 = BGl_decryptzd2fastzd2portzd2envzd2zz__cryptozd2blockzd2ciphersz00; }  else 
{ /* Llib/block_ciphers.scm 857 */
CNST_TABLE_REF(((long)8)); 
BgL_redirectz00_3388 = BgL_arg2052z00_1190; } } } 
{ /* Llib/block_ciphers.scm 861 */
obj_t BgL_aux3533z00_5903;
{ /* Llib/block_ciphers.scm 861 */
obj_t BgL_tmpz00_9152;
{ /* Llib/block_ciphers.scm 861 */
bool_t BgL_test3532z00_5902;
BgL_test3532z00_5902 = 
PROCEDUREP(BgL_redirectz00_3388); 
if(BgL_test3532z00_5902)
{ /* Llib/block_ciphers.scm 861 */
BgL_tmpz00_9152 = BgL_redirectz00_3388
; }  else 
{ 
obj_t BgL_auxz00_9155;
BgL_auxz00_9155 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31179)), BGl_string3768z00zz__cryptozd2blockzd2ciphersz00, BGl_string3753z00zz__cryptozd2blockzd2ciphersz00, BgL_redirectz00_3388); 
FAILURE(BgL_auxz00_9155,BFALSE,BFALSE);} } 
BgL_aux3533z00_5903 = 
PROCEDURE_ENTRY(BgL_tmpz00_9152)(BgL_redirectz00_3388, BgL_cipherz00_3386, BgL_arg2052z00_1190, BgL_passwordz00_3387, BgL_ivz00_1192, BgL_modez00_1193, BgL_padz00_1196, BgL_noncezd2initz12zc0_1194, BgL_noncezd2updatez12zc0_1195, BgL_stringzd2ze3keyz31_1197, BEOA); } 
if(
STRINGP(BgL_aux3533z00_5903))
{ /* Llib/block_ciphers.scm 861 */
BgL_res2924z00_3396 = BgL_aux3533z00_5903; }  else 
{ 
obj_t BgL_auxz00_9161;
BgL_auxz00_9161 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31179)), BGl_string3768z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_aux3533z00_5903); 
FAILURE(BgL_auxz00_9161,BFALSE,BFALSE);} } } } 
return BgL_res2924z00_3396;} } } } } } } } } } } } } } } } } 
BGL_FUNCTION_END;
}



/* search1423~0 */
obj_t BGl_search1423ze70ze7zz__cryptozd2blockzd2ciphersz00(long BgL_l1422z00_5654, obj_t BgL_opt1421z00_5653, obj_t BgL_k1z00_1157, long BgL_iz00_1158)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 850 */
BGl_search1423ze70ze7zz__cryptozd2blockzd2ciphersz00:
if(
(BgL_iz00_1158==BgL_l1422z00_5654))
{ /* Llib/block_ciphers.scm 850 */
return 
BINT(((long)-1));}  else 
{ /* Llib/block_ciphers.scm 850 */
if(
(BgL_iz00_1158==
(BgL_l1422z00_5654-((long)1))))
{ /* Llib/block_ciphers.scm 850 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)37)), BGl_string3754z00zz__cryptozd2blockzd2ciphersz00, 
BINT(
VECTOR_LENGTH(BgL_opt1421z00_5653)));}  else 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_vz00_1202;
BgL_vz00_1202 = 
VECTOR_REF(BgL_opt1421z00_5653,BgL_iz00_1158); 
if(
(BgL_vz00_1202==BgL_k1z00_1157))
{ /* Llib/block_ciphers.scm 850 */
return 
BINT(
(BgL_iz00_1158+((long)1)));}  else 
{ 
long BgL_iz00_9180;
BgL_iz00_9180 = 
(BgL_iz00_1158+((long)2)); 
BgL_iz00_1158 = BgL_iz00_9180; 
goto BGl_search1423ze70ze7zz__cryptozd2blockzd2ciphersz00;} } } } 
BGL_FUNCTION_END;
}



/* decrypt */
BGL_EXPORTED_DEF obj_t BGl_decryptz00zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_298, obj_t BgL_ciphertextz00_299, obj_t BgL_passwordz00_300, obj_t BgL_ivz00_301, obj_t BgL_modez00_302, obj_t BgL_noncezd2initz12zc0_303, obj_t BgL_noncezd2updatez12zc0_304, obj_t BgL_padz00_305, obj_t BgL_stringzd2ze3keyz31_306)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 850 */
{ /* Llib/block_ciphers.scm 854 */
obj_t BgL_redirectz00_3397;
if(
STRINGP(BgL_ciphertextz00_299))
{ /* Llib/block_ciphers.scm 855 */
BgL_redirectz00_3397 = BGl_decryptzd2fastzd2stringzd2envzd2zz__cryptozd2blockzd2ciphersz00; }  else 
{ /* Llib/block_ciphers.scm 856 */
bool_t BgL_testz00_9184;
{ /* Llib/block_ciphers.scm 856 */
bool_t BgL_res2926z00_3402;
BgL_res2926z00_3402 = 
BGL_MMAPP(BgL_ciphertextz00_299); 
BgL_testz00_9184 = BgL_res2926z00_3402; } 
if(BgL_testz00_9184)
{ /* Llib/block_ciphers.scm 856 */
BgL_redirectz00_3397 = BGl_decryptzd2fastzd2mmapzd2envzd2zz__cryptozd2blockzd2ciphersz00; }  else 
{ /* Llib/block_ciphers.scm 857 */
bool_t BgL_testz00_9186;
{ /* Llib/block_ciphers.scm 857 */
bool_t BgL__ortest_1056z00_3403;
BgL__ortest_1056z00_3403 = 
OUTPUT_PORTP(BgL_ciphertextz00_299); 
if(BgL__ortest_1056z00_3403)
{ /* Llib/block_ciphers.scm 857 */
BgL_testz00_9186 = BgL__ortest_1056z00_3403
; }  else 
{ /* Llib/block_ciphers.scm 857 */
BgL_testz00_9186 = 
INPUT_PORTP(BgL_ciphertextz00_299)
; } } 
if(BgL_testz00_9186)
{ /* Llib/block_ciphers.scm 857 */
BgL_redirectz00_3397 = BGl_decryptzd2fastzd2portzd2envzd2zz__cryptozd2blockzd2ciphersz00; }  else 
{ /* Llib/block_ciphers.scm 857 */
CNST_TABLE_REF(((long)8)); 
BgL_redirectz00_3397 = BgL_ciphertextz00_299; } } } 
return 
PROCEDURE_ENTRY(BgL_redirectz00_3397)(BgL_redirectz00_3397, BgL_cipherz00_298, BgL_ciphertextz00_299, BgL_passwordz00_300, BgL_ivz00_301, BgL_modez00_302, BgL_padz00_305, BgL_noncezd2initz12zc0_303, BgL_noncezd2updatez12zc0_304, BgL_stringzd2ze3keyz31_306, BEOA);} } 
BGL_FUNCTION_END;
}



/* _decrypt-string */
obj_t BGl__decryptzd2stringzd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_319, obj_t BgL_opt1432z00_318)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 864 */
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_cipherz00_1214;obj_t BgL_ciphertextz00_1215;obj_t BgL_passwordz00_1216;
BgL_cipherz00_1214 = 
VECTOR_REF(BgL_opt1432z00_318,((long)0)); 
BgL_ciphertextz00_1215 = 
VECTOR_REF(BgL_opt1432z00_318,((long)1)); 
BgL_passwordz00_1216 = 
VECTOR_REF(BgL_opt1432z00_318,((long)2)); 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_ivz00_1217;
BgL_ivz00_1217 = BFALSE; 
{ /* Llib/block_ciphers.scm 865 */
obj_t BgL_modez00_1218;
BgL_modez00_1218 = 
CNST_TABLE_REF(((long)10)); 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_noncezd2initz12zc0_1219;
BgL_noncezd2initz12zc0_1219 = BFALSE; 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_noncezd2updatez12zc0_1220;
BgL_noncezd2updatez12zc0_1220 = BFALSE; 
{ /* Llib/block_ciphers.scm 865 */
obj_t BgL_padz00_1221;
BgL_padz00_1221 = 
CNST_TABLE_REF(((long)16)); 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_stringzd2ze3keyz31_1222;
BgL_stringzd2ze3keyz31_1222 = BFALSE; 
{ /* Llib/block_ciphers.scm 864 */

{ 
long BgL_iz00_1223;
BgL_iz00_1223 = ((long)3); 
BgL_check1435z00_1224:
if(
(BgL_iz00_1223==
VECTOR_LENGTH(BgL_opt1432z00_318)))
{ /* Llib/block_ciphers.scm 864 */BNIL; }  else 
{ /* Llib/block_ciphers.scm 864 */
bool_t BgL_testz00_9211;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_arg2069z00_1230;
BgL_arg2069z00_1230 = 
VECTOR_REF(BgL_opt1432z00_318,BgL_iz00_1223); 
BgL_testz00_9211 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg2069z00_1230, 
CNST_TABLE_REF(((long)23)))); } 
if(BgL_testz00_9211)
{ 
long BgL_iz00_9216;
BgL_iz00_9216 = 
(BgL_iz00_1223+((long)2)); 
BgL_iz00_1223 = BgL_iz00_9216; 
goto BgL_check1435z00_1224;}  else 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_arg2068z00_1229;
BgL_arg2068z00_1229 = 
VECTOR_REF(BgL_opt1432z00_318,BgL_iz00_1223); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)38)), BGl_string3749z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2068z00_1229); } } } 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_index1437z00_1231;
BgL_index1437z00_1231 = 
BGl_search1434ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1432z00_318), BgL_opt1432z00_318, 
CNST_TABLE_REF(((long)25)), ((long)3)); 
{ /* Llib/block_ciphers.scm 864 */
bool_t BgL_testz00_9224;
{ /* Llib/block_ciphers.scm 864 */
long BgL_n1z00_3427;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_tmpz00_9225;
if(
INTEGERP(BgL_index1437z00_1231))
{ /* Llib/block_ciphers.scm 864 */
BgL_tmpz00_9225 = BgL_index1437z00_1231
; }  else 
{ 
obj_t BgL_auxz00_9228;
BgL_auxz00_9228 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31272)), BGl_string3769z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1437z00_1231); 
FAILURE(BgL_auxz00_9228,BFALSE,BFALSE);} 
BgL_n1z00_3427 = 
(long)CINT(BgL_tmpz00_9225); } 
BgL_testz00_9224 = 
(BgL_n1z00_3427>=((long)0)); } 
if(BgL_testz00_9224)
{ 
long BgL_auxz00_9234;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_tmpz00_9235;
if(
INTEGERP(BgL_index1437z00_1231))
{ /* Llib/block_ciphers.scm 864 */
BgL_tmpz00_9235 = BgL_index1437z00_1231
; }  else 
{ 
obj_t BgL_auxz00_9238;
BgL_auxz00_9238 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31272)), BGl_string3769z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1437z00_1231); 
FAILURE(BgL_auxz00_9238,BFALSE,BFALSE);} 
BgL_auxz00_9234 = 
(long)CINT(BgL_tmpz00_9235); } 
BgL_ivz00_1217 = 
VECTOR_REF(BgL_opt1432z00_318,BgL_auxz00_9234); }  else 
{ /* Llib/block_ciphers.scm 864 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_index1438z00_1233;
BgL_index1438z00_1233 = 
BGl_search1434ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1432z00_318), BgL_opt1432z00_318, 
CNST_TABLE_REF(((long)26)), ((long)3)); 
{ /* Llib/block_ciphers.scm 864 */
bool_t BgL_testz00_9247;
{ /* Llib/block_ciphers.scm 864 */
long BgL_n1z00_3429;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_tmpz00_9248;
if(
INTEGERP(BgL_index1438z00_1233))
{ /* Llib/block_ciphers.scm 864 */
BgL_tmpz00_9248 = BgL_index1438z00_1233
; }  else 
{ 
obj_t BgL_auxz00_9251;
BgL_auxz00_9251 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31272)), BGl_string3769z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1438z00_1233); 
FAILURE(BgL_auxz00_9251,BFALSE,BFALSE);} 
BgL_n1z00_3429 = 
(long)CINT(BgL_tmpz00_9248); } 
BgL_testz00_9247 = 
(BgL_n1z00_3429>=((long)0)); } 
if(BgL_testz00_9247)
{ 
long BgL_auxz00_9257;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_tmpz00_9258;
if(
INTEGERP(BgL_index1438z00_1233))
{ /* Llib/block_ciphers.scm 864 */
BgL_tmpz00_9258 = BgL_index1438z00_1233
; }  else 
{ 
obj_t BgL_auxz00_9261;
BgL_auxz00_9261 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31272)), BGl_string3769z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1438z00_1233); 
FAILURE(BgL_auxz00_9261,BFALSE,BFALSE);} 
BgL_auxz00_9257 = 
(long)CINT(BgL_tmpz00_9258); } 
BgL_modez00_1218 = 
VECTOR_REF(BgL_opt1432z00_318,BgL_auxz00_9257); }  else 
{ /* Llib/block_ciphers.scm 864 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_index1439z00_1235;
BgL_index1439z00_1235 = 
BGl_search1434ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1432z00_318), BgL_opt1432z00_318, 
CNST_TABLE_REF(((long)27)), ((long)3)); 
{ /* Llib/block_ciphers.scm 864 */
bool_t BgL_testz00_9270;
{ /* Llib/block_ciphers.scm 864 */
long BgL_n1z00_3431;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_tmpz00_9271;
if(
INTEGERP(BgL_index1439z00_1235))
{ /* Llib/block_ciphers.scm 864 */
BgL_tmpz00_9271 = BgL_index1439z00_1235
; }  else 
{ 
obj_t BgL_auxz00_9274;
BgL_auxz00_9274 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31272)), BGl_string3769z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1439z00_1235); 
FAILURE(BgL_auxz00_9274,BFALSE,BFALSE);} 
BgL_n1z00_3431 = 
(long)CINT(BgL_tmpz00_9271); } 
BgL_testz00_9270 = 
(BgL_n1z00_3431>=((long)0)); } 
if(BgL_testz00_9270)
{ 
long BgL_auxz00_9280;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_tmpz00_9281;
if(
INTEGERP(BgL_index1439z00_1235))
{ /* Llib/block_ciphers.scm 864 */
BgL_tmpz00_9281 = BgL_index1439z00_1235
; }  else 
{ 
obj_t BgL_auxz00_9284;
BgL_auxz00_9284 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31272)), BGl_string3769z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1439z00_1235); 
FAILURE(BgL_auxz00_9284,BFALSE,BFALSE);} 
BgL_auxz00_9280 = 
(long)CINT(BgL_tmpz00_9281); } 
BgL_noncezd2initz12zc0_1219 = 
VECTOR_REF(BgL_opt1432z00_318,BgL_auxz00_9280); }  else 
{ /* Llib/block_ciphers.scm 864 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_index1440z00_1237;
BgL_index1440z00_1237 = 
BGl_search1434ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1432z00_318), BgL_opt1432z00_318, 
CNST_TABLE_REF(((long)28)), ((long)3)); 
{ /* Llib/block_ciphers.scm 864 */
bool_t BgL_testz00_9293;
{ /* Llib/block_ciphers.scm 864 */
long BgL_n1z00_3433;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_tmpz00_9294;
if(
INTEGERP(BgL_index1440z00_1237))
{ /* Llib/block_ciphers.scm 864 */
BgL_tmpz00_9294 = BgL_index1440z00_1237
; }  else 
{ 
obj_t BgL_auxz00_9297;
BgL_auxz00_9297 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31272)), BGl_string3769z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1440z00_1237); 
FAILURE(BgL_auxz00_9297,BFALSE,BFALSE);} 
BgL_n1z00_3433 = 
(long)CINT(BgL_tmpz00_9294); } 
BgL_testz00_9293 = 
(BgL_n1z00_3433>=((long)0)); } 
if(BgL_testz00_9293)
{ 
long BgL_auxz00_9303;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_tmpz00_9304;
if(
INTEGERP(BgL_index1440z00_1237))
{ /* Llib/block_ciphers.scm 864 */
BgL_tmpz00_9304 = BgL_index1440z00_1237
; }  else 
{ 
obj_t BgL_auxz00_9307;
BgL_auxz00_9307 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31272)), BGl_string3769z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1440z00_1237); 
FAILURE(BgL_auxz00_9307,BFALSE,BFALSE);} 
BgL_auxz00_9303 = 
(long)CINT(BgL_tmpz00_9304); } 
BgL_noncezd2updatez12zc0_1220 = 
VECTOR_REF(BgL_opt1432z00_318,BgL_auxz00_9303); }  else 
{ /* Llib/block_ciphers.scm 864 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_index1441z00_1239;
BgL_index1441z00_1239 = 
BGl_search1434ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1432z00_318), BgL_opt1432z00_318, 
CNST_TABLE_REF(((long)29)), ((long)3)); 
{ /* Llib/block_ciphers.scm 864 */
bool_t BgL_testz00_9316;
{ /* Llib/block_ciphers.scm 864 */
long BgL_n1z00_3435;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_tmpz00_9317;
if(
INTEGERP(BgL_index1441z00_1239))
{ /* Llib/block_ciphers.scm 864 */
BgL_tmpz00_9317 = BgL_index1441z00_1239
; }  else 
{ 
obj_t BgL_auxz00_9320;
BgL_auxz00_9320 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31272)), BGl_string3769z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1441z00_1239); 
FAILURE(BgL_auxz00_9320,BFALSE,BFALSE);} 
BgL_n1z00_3435 = 
(long)CINT(BgL_tmpz00_9317); } 
BgL_testz00_9316 = 
(BgL_n1z00_3435>=((long)0)); } 
if(BgL_testz00_9316)
{ 
long BgL_auxz00_9326;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_tmpz00_9327;
if(
INTEGERP(BgL_index1441z00_1239))
{ /* Llib/block_ciphers.scm 864 */
BgL_tmpz00_9327 = BgL_index1441z00_1239
; }  else 
{ 
obj_t BgL_auxz00_9330;
BgL_auxz00_9330 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31272)), BGl_string3769z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1441z00_1239); 
FAILURE(BgL_auxz00_9330,BFALSE,BFALSE);} 
BgL_auxz00_9326 = 
(long)CINT(BgL_tmpz00_9327); } 
BgL_padz00_1221 = 
VECTOR_REF(BgL_opt1432z00_318,BgL_auxz00_9326); }  else 
{ /* Llib/block_ciphers.scm 864 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_index1442z00_1241;
BgL_index1442z00_1241 = 
BGl_search1434ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1432z00_318), BgL_opt1432z00_318, 
CNST_TABLE_REF(((long)30)), ((long)3)); 
{ /* Llib/block_ciphers.scm 864 */
bool_t BgL_testz00_9339;
{ /* Llib/block_ciphers.scm 864 */
long BgL_n1z00_3437;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_tmpz00_9340;
if(
INTEGERP(BgL_index1442z00_1241))
{ /* Llib/block_ciphers.scm 864 */
BgL_tmpz00_9340 = BgL_index1442z00_1241
; }  else 
{ 
obj_t BgL_auxz00_9343;
BgL_auxz00_9343 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31272)), BGl_string3769z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1442z00_1241); 
FAILURE(BgL_auxz00_9343,BFALSE,BFALSE);} 
BgL_n1z00_3437 = 
(long)CINT(BgL_tmpz00_9340); } 
BgL_testz00_9339 = 
(BgL_n1z00_3437>=((long)0)); } 
if(BgL_testz00_9339)
{ 
long BgL_auxz00_9349;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_tmpz00_9350;
if(
INTEGERP(BgL_index1442z00_1241))
{ /* Llib/block_ciphers.scm 864 */
BgL_tmpz00_9350 = BgL_index1442z00_1241
; }  else 
{ 
obj_t BgL_auxz00_9353;
BgL_auxz00_9353 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31272)), BGl_string3769z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1442z00_1241); 
FAILURE(BgL_auxz00_9353,BFALSE,BFALSE);} 
BgL_auxz00_9349 = 
(long)CINT(BgL_tmpz00_9350); } 
BgL_stringzd2ze3keyz31_1222 = 
VECTOR_REF(BgL_opt1432z00_318,BgL_auxz00_9349); }  else 
{ /* Llib/block_ciphers.scm 864 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_arg2076z00_1243;obj_t BgL_arg2077z00_1244;obj_t BgL_arg2078z00_1245;
BgL_arg2076z00_1243 = 
VECTOR_REF(BgL_opt1432z00_318,((long)0)); 
BgL_arg2077z00_1244 = 
VECTOR_REF(BgL_opt1432z00_318,((long)1)); 
BgL_arg2078z00_1245 = 
VECTOR_REF(BgL_opt1432z00_318,((long)2)); 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_ivz00_1246;
BgL_ivz00_1246 = BgL_ivz00_1217; 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_modez00_1247;
BgL_modez00_1247 = BgL_modez00_1218; 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_noncezd2initz12zc0_1248;
BgL_noncezd2initz12zc0_1248 = BgL_noncezd2initz12zc0_1219; 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_noncezd2updatez12zc0_1249;
BgL_noncezd2updatez12zc0_1249 = BgL_noncezd2updatez12zc0_1220; 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_padz00_1250;
BgL_padz00_1250 = BgL_padz00_1221; 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_stringzd2ze3keyz31_1251;
BgL_stringzd2ze3keyz31_1251 = BgL_stringzd2ze3keyz31_1222; 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_res2944z00_3457;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_cipherz00_3439;obj_t BgL_ciphertextz00_3440;obj_t BgL_passwordz00_3441;
if(
SYMBOLP(BgL_arg2076z00_1243))
{ /* Llib/block_ciphers.scm 864 */
BgL_cipherz00_3439 = BgL_arg2076z00_1243; }  else 
{ 
obj_t BgL_auxz00_9364;
BgL_auxz00_9364 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31272)), BGl_string3769z00zz__cryptozd2blockzd2ciphersz00, BGl_string3752z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2076z00_1243); 
FAILURE(BgL_auxz00_9364,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg2077z00_1244))
{ /* Llib/block_ciphers.scm 864 */
BgL_ciphertextz00_3440 = BgL_arg2077z00_1244; }  else 
{ 
obj_t BgL_auxz00_9370;
BgL_auxz00_9370 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31272)), BGl_string3769z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2077z00_1244); 
FAILURE(BgL_auxz00_9370,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg2078z00_1245))
{ /* Llib/block_ciphers.scm 864 */
BgL_passwordz00_3441 = BgL_arg2078z00_1245; }  else 
{ 
obj_t BgL_auxz00_9376;
BgL_auxz00_9376 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31272)), BGl_string3769z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2078z00_1245); 
FAILURE(BgL_auxz00_9376,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 868 */
obj_t BgL_res2943z00_3456;
{ /* Llib/block_ciphers.scm 874 */
obj_t BgL_strz00_3444;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3445;
{ /* Llib/block_ciphers.scm 874 */
long BgL_arg2087z00_3446;
BgL_arg2087z00_3446 = 
STRING_LENGTH(BgL_ciphertextz00_3440); 
{ /* Llib/block_ciphers.scm 874 */

BgL_strz00_3444 = 
make_string(BgL_arg2087z00_3446, ((unsigned char)' ')); } } 
BgL_statez00_3445 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_3439, BgL_passwordz00_3441, BgL_ivz00_1246, BgL_modez00_1247, BgL_padz00_1250, BgL_noncezd2initz12zc0_1248, BgL_noncezd2updatez12zc0_1249, BgL_stringzd2ze3keyz31_1251); 
{ /* Llib/block_ciphers.scm 878 */
long BgL_tmpz00_9383;
BgL_tmpz00_9383 = 
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3445, BgL_ciphertextz00_3440, ((long)0), BGl_readzd2stringzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_strz00_3444, ((long)0), BGl_blitzd2stringzd2urz12zd2envzc0zz__r4_strings_6_7z00); 
BgL_res2943z00_3456 = 
bgl_string_shrink(BgL_strz00_3444, BgL_tmpz00_9383); } } 
BgL_res2944z00_3457 = BgL_res2943z00_3456; } } 
return BgL_res2944z00_3457;} } } } } } } } } } } } } } } } } 
BGL_FUNCTION_END;
}



/* search1434~0 */
obj_t BGl_search1434ze70ze7zz__cryptozd2blockzd2ciphersz00(long BgL_l1433z00_5652, obj_t BgL_opt1432z00_5651, obj_t BgL_k1z00_1211, long BgL_iz00_1212)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 864 */
BGl_search1434ze70ze7zz__cryptozd2blockzd2ciphersz00:
if(
(BgL_iz00_1212==BgL_l1433z00_5652))
{ /* Llib/block_ciphers.scm 864 */
return 
BINT(((long)-1));}  else 
{ /* Llib/block_ciphers.scm 864 */
if(
(BgL_iz00_1212==
(BgL_l1433z00_5652-((long)1))))
{ /* Llib/block_ciphers.scm 864 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)38)), BGl_string3754z00zz__cryptozd2blockzd2ciphersz00, 
BINT(
VECTOR_LENGTH(BgL_opt1432z00_5651)));}  else 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_vz00_1256;
BgL_vz00_1256 = 
VECTOR_REF(BgL_opt1432z00_5651,BgL_iz00_1212); 
if(
(BgL_vz00_1256==BgL_k1z00_1211))
{ /* Llib/block_ciphers.scm 864 */
return 
BINT(
(BgL_iz00_1212+((long)1)));}  else 
{ 
long BgL_iz00_9401;
BgL_iz00_9401 = 
(BgL_iz00_1212+((long)2)); 
BgL_iz00_1212 = BgL_iz00_9401; 
goto BGl_search1434ze70ze7zz__cryptozd2blockzd2ciphersz00;} } } } 
BGL_FUNCTION_END;
}



/* decrypt-string */
BGL_EXPORTED_DEF obj_t BGl_decryptzd2stringzd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_309, obj_t BgL_ciphertextz00_310, obj_t BgL_passwordz00_311, obj_t BgL_ivz00_312, obj_t BgL_modez00_313, obj_t BgL_noncezd2initz12zc0_314, obj_t BgL_noncezd2updatez12zc0_315, obj_t BgL_padz00_316, obj_t BgL_stringzd2ze3keyz31_317)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 864 */
{ /* Llib/block_ciphers.scm 868 */
obj_t BgL_res2947z00_3472;
{ /* Llib/block_ciphers.scm 874 */
obj_t BgL_strz00_3460;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3461;
{ /* Llib/block_ciphers.scm 874 */
long BgL_arg2087z00_3462;
BgL_arg2087z00_3462 = 
STRING_LENGTH(BgL_ciphertextz00_310); 
{ /* Llib/block_ciphers.scm 874 */

BgL_strz00_3460 = 
make_string(BgL_arg2087z00_3462, ((unsigned char)' ')); } } 
BgL_statez00_3461 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_309, BgL_passwordz00_311, BgL_ivz00_312, BgL_modez00_313, BgL_padz00_316, BgL_noncezd2initz12zc0_314, BgL_noncezd2updatez12zc0_315, BgL_stringzd2ze3keyz31_317); 
{ /* Llib/block_ciphers.scm 878 */
long BgL_tmpz00_9406;
BgL_tmpz00_9406 = 
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3461, BgL_ciphertextz00_310, ((long)0), BGl_readzd2stringzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_strz00_3460, ((long)0), BGl_blitzd2stringzd2urz12zd2envzc0zz__r4_strings_6_7z00); 
BgL_res2947z00_3472 = 
bgl_string_shrink(BgL_strz00_3460, BgL_tmpz00_9406); } } 
return BgL_res2947z00_3472;} } 
BGL_FUNCTION_END;
}



/* &decrypt-fast-string */
obj_t BGl_z62decryptzd2fastzd2stringz62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5017, obj_t BgL_cipherz00_5018, obj_t BgL_ciphertextz00_5019, obj_t BgL_passwordz00_5020, obj_t BgL_ivz00_5021, obj_t BgL_modez00_5022, obj_t BgL_padz00_5023, obj_t BgL_noncezd2initz12zc0_5024, obj_t BgL_noncezd2updatez12zc0_5025, obj_t BgL_stringzd2ze3keyz31_5026)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 871 */
{ /* Llib/block_ciphers.scm 874 */
obj_t BgL_ciphertextz00_6183;obj_t BgL_passwordz00_6184;
if(
STRINGP(BgL_ciphertextz00_5019))
{ /* Llib/block_ciphers.scm 874 */
BgL_ciphertextz00_6183 = BgL_ciphertextz00_5019; }  else 
{ 
obj_t BgL_auxz00_9411;
BgL_auxz00_9411 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31721)), BGl_string3770z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_ciphertextz00_5019); 
FAILURE(BgL_auxz00_9411,BFALSE,BFALSE);} 
if(
STRINGP(BgL_passwordz00_5020))
{ /* Llib/block_ciphers.scm 874 */
BgL_passwordz00_6184 = BgL_passwordz00_5020; }  else 
{ 
obj_t BgL_auxz00_9417;
BgL_auxz00_9417 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31721)), BGl_string3770z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_passwordz00_5020); 
FAILURE(BgL_auxz00_9417,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 874 */
obj_t BgL_strz00_6185;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_6186;
{ /* Llib/block_ciphers.scm 874 */
long BgL_arg2087z00_6187;
BgL_arg2087z00_6187 = 
STRING_LENGTH(BgL_ciphertextz00_6183); 
{ /* Llib/block_ciphers.scm 874 */

BgL_strz00_6185 = 
make_string(BgL_arg2087z00_6187, ((unsigned char)' ')); } } 
BgL_statez00_6186 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_5018, BgL_passwordz00_6184, BgL_ivz00_5021, BgL_modez00_5022, BgL_padz00_5023, BgL_noncezd2initz12zc0_5024, BgL_noncezd2updatez12zc0_5025, BgL_stringzd2ze3keyz31_5026); 
{ /* Llib/block_ciphers.scm 878 */
long BgL_tmpz00_9424;
BgL_tmpz00_9424 = 
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_6186, BgL_ciphertextz00_6183, ((long)0), BGl_readzd2stringzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_strz00_6185, ((long)0), BGl_blitzd2stringzd2urz12zd2envzc0zz__r4_strings_6_7z00); 
return 
bgl_string_shrink(BgL_strz00_6185, BgL_tmpz00_9424);} } } } 
BGL_FUNCTION_END;
}



/* _decrypt-mmap */
obj_t BGl__decryptzd2mmapzd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_339, obj_t BgL_opt1443z00_338)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 883 */
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_cipherz00_1270;obj_t BgL_ciphertextz00_1271;obj_t BgL_passwordz00_1272;
BgL_cipherz00_1270 = 
VECTOR_REF(BgL_opt1443z00_338,((long)0)); 
BgL_ciphertextz00_1271 = 
VECTOR_REF(BgL_opt1443z00_338,((long)1)); 
BgL_passwordz00_1272 = 
VECTOR_REF(BgL_opt1443z00_338,((long)2)); 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_ivz00_1273;
BgL_ivz00_1273 = BFALSE; 
{ /* Llib/block_ciphers.scm 884 */
obj_t BgL_modez00_1274;
BgL_modez00_1274 = 
CNST_TABLE_REF(((long)10)); 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_noncezd2initz12zc0_1275;
BgL_noncezd2initz12zc0_1275 = BFALSE; 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_noncezd2updatez12zc0_1276;
BgL_noncezd2updatez12zc0_1276 = BFALSE; 
{ /* Llib/block_ciphers.scm 884 */
obj_t BgL_padz00_1277;
BgL_padz00_1277 = 
CNST_TABLE_REF(((long)16)); 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_stringzd2ze3keyz31_1278;
BgL_stringzd2ze3keyz31_1278 = BFALSE; 
{ /* Llib/block_ciphers.scm 883 */

{ 
long BgL_iz00_1279;
BgL_iz00_1279 = ((long)3); 
BgL_check1446z00_1280:
if(
(BgL_iz00_1279==
VECTOR_LENGTH(BgL_opt1443z00_338)))
{ /* Llib/block_ciphers.scm 883 */BNIL; }  else 
{ /* Llib/block_ciphers.scm 883 */
bool_t BgL_testz00_9435;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_arg2093z00_1286;
BgL_arg2093z00_1286 = 
VECTOR_REF(BgL_opt1443z00_338,BgL_iz00_1279); 
BgL_testz00_9435 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg2093z00_1286, 
CNST_TABLE_REF(((long)23)))); } 
if(BgL_testz00_9435)
{ 
long BgL_iz00_9440;
BgL_iz00_9440 = 
(BgL_iz00_1279+((long)2)); 
BgL_iz00_1279 = BgL_iz00_9440; 
goto BgL_check1446z00_1280;}  else 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_arg2092z00_1285;
BgL_arg2092z00_1285 = 
VECTOR_REF(BgL_opt1443z00_338,BgL_iz00_1279); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)39)), BGl_string3749z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2092z00_1285); } } } 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_index1448z00_1287;
BgL_index1448z00_1287 = 
BGl_search1445ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1443z00_338), BgL_opt1443z00_338, 
CNST_TABLE_REF(((long)25)), ((long)3)); 
{ /* Llib/block_ciphers.scm 883 */
bool_t BgL_testz00_9448;
{ /* Llib/block_ciphers.scm 883 */
long BgL_n1z00_3507;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_tmpz00_9449;
if(
INTEGERP(BgL_index1448z00_1287))
{ /* Llib/block_ciphers.scm 883 */
BgL_tmpz00_9449 = BgL_index1448z00_1287
; }  else 
{ 
obj_t BgL_auxz00_9452;
BgL_auxz00_9452 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32021)), BGl_string3771z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1448z00_1287); 
FAILURE(BgL_auxz00_9452,BFALSE,BFALSE);} 
BgL_n1z00_3507 = 
(long)CINT(BgL_tmpz00_9449); } 
BgL_testz00_9448 = 
(BgL_n1z00_3507>=((long)0)); } 
if(BgL_testz00_9448)
{ 
long BgL_auxz00_9458;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_tmpz00_9459;
if(
INTEGERP(BgL_index1448z00_1287))
{ /* Llib/block_ciphers.scm 883 */
BgL_tmpz00_9459 = BgL_index1448z00_1287
; }  else 
{ 
obj_t BgL_auxz00_9462;
BgL_auxz00_9462 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32021)), BGl_string3771z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1448z00_1287); 
FAILURE(BgL_auxz00_9462,BFALSE,BFALSE);} 
BgL_auxz00_9458 = 
(long)CINT(BgL_tmpz00_9459); } 
BgL_ivz00_1273 = 
VECTOR_REF(BgL_opt1443z00_338,BgL_auxz00_9458); }  else 
{ /* Llib/block_ciphers.scm 883 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_index1449z00_1289;
BgL_index1449z00_1289 = 
BGl_search1445ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1443z00_338), BgL_opt1443z00_338, 
CNST_TABLE_REF(((long)26)), ((long)3)); 
{ /* Llib/block_ciphers.scm 883 */
bool_t BgL_testz00_9471;
{ /* Llib/block_ciphers.scm 883 */
long BgL_n1z00_3509;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_tmpz00_9472;
if(
INTEGERP(BgL_index1449z00_1289))
{ /* Llib/block_ciphers.scm 883 */
BgL_tmpz00_9472 = BgL_index1449z00_1289
; }  else 
{ 
obj_t BgL_auxz00_9475;
BgL_auxz00_9475 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32021)), BGl_string3771z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1449z00_1289); 
FAILURE(BgL_auxz00_9475,BFALSE,BFALSE);} 
BgL_n1z00_3509 = 
(long)CINT(BgL_tmpz00_9472); } 
BgL_testz00_9471 = 
(BgL_n1z00_3509>=((long)0)); } 
if(BgL_testz00_9471)
{ 
long BgL_auxz00_9481;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_tmpz00_9482;
if(
INTEGERP(BgL_index1449z00_1289))
{ /* Llib/block_ciphers.scm 883 */
BgL_tmpz00_9482 = BgL_index1449z00_1289
; }  else 
{ 
obj_t BgL_auxz00_9485;
BgL_auxz00_9485 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32021)), BGl_string3771z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1449z00_1289); 
FAILURE(BgL_auxz00_9485,BFALSE,BFALSE);} 
BgL_auxz00_9481 = 
(long)CINT(BgL_tmpz00_9482); } 
BgL_modez00_1274 = 
VECTOR_REF(BgL_opt1443z00_338,BgL_auxz00_9481); }  else 
{ /* Llib/block_ciphers.scm 883 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_index1450z00_1291;
BgL_index1450z00_1291 = 
BGl_search1445ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1443z00_338), BgL_opt1443z00_338, 
CNST_TABLE_REF(((long)27)), ((long)3)); 
{ /* Llib/block_ciphers.scm 883 */
bool_t BgL_testz00_9494;
{ /* Llib/block_ciphers.scm 883 */
long BgL_n1z00_3511;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_tmpz00_9495;
if(
INTEGERP(BgL_index1450z00_1291))
{ /* Llib/block_ciphers.scm 883 */
BgL_tmpz00_9495 = BgL_index1450z00_1291
; }  else 
{ 
obj_t BgL_auxz00_9498;
BgL_auxz00_9498 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32021)), BGl_string3771z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1450z00_1291); 
FAILURE(BgL_auxz00_9498,BFALSE,BFALSE);} 
BgL_n1z00_3511 = 
(long)CINT(BgL_tmpz00_9495); } 
BgL_testz00_9494 = 
(BgL_n1z00_3511>=((long)0)); } 
if(BgL_testz00_9494)
{ 
long BgL_auxz00_9504;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_tmpz00_9505;
if(
INTEGERP(BgL_index1450z00_1291))
{ /* Llib/block_ciphers.scm 883 */
BgL_tmpz00_9505 = BgL_index1450z00_1291
; }  else 
{ 
obj_t BgL_auxz00_9508;
BgL_auxz00_9508 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32021)), BGl_string3771z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1450z00_1291); 
FAILURE(BgL_auxz00_9508,BFALSE,BFALSE);} 
BgL_auxz00_9504 = 
(long)CINT(BgL_tmpz00_9505); } 
BgL_noncezd2initz12zc0_1275 = 
VECTOR_REF(BgL_opt1443z00_338,BgL_auxz00_9504); }  else 
{ /* Llib/block_ciphers.scm 883 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_index1451z00_1293;
BgL_index1451z00_1293 = 
BGl_search1445ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1443z00_338), BgL_opt1443z00_338, 
CNST_TABLE_REF(((long)28)), ((long)3)); 
{ /* Llib/block_ciphers.scm 883 */
bool_t BgL_testz00_9517;
{ /* Llib/block_ciphers.scm 883 */
long BgL_n1z00_3513;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_tmpz00_9518;
if(
INTEGERP(BgL_index1451z00_1293))
{ /* Llib/block_ciphers.scm 883 */
BgL_tmpz00_9518 = BgL_index1451z00_1293
; }  else 
{ 
obj_t BgL_auxz00_9521;
BgL_auxz00_9521 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32021)), BGl_string3771z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1451z00_1293); 
FAILURE(BgL_auxz00_9521,BFALSE,BFALSE);} 
BgL_n1z00_3513 = 
(long)CINT(BgL_tmpz00_9518); } 
BgL_testz00_9517 = 
(BgL_n1z00_3513>=((long)0)); } 
if(BgL_testz00_9517)
{ 
long BgL_auxz00_9527;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_tmpz00_9528;
if(
INTEGERP(BgL_index1451z00_1293))
{ /* Llib/block_ciphers.scm 883 */
BgL_tmpz00_9528 = BgL_index1451z00_1293
; }  else 
{ 
obj_t BgL_auxz00_9531;
BgL_auxz00_9531 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32021)), BGl_string3771z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1451z00_1293); 
FAILURE(BgL_auxz00_9531,BFALSE,BFALSE);} 
BgL_auxz00_9527 = 
(long)CINT(BgL_tmpz00_9528); } 
BgL_noncezd2updatez12zc0_1276 = 
VECTOR_REF(BgL_opt1443z00_338,BgL_auxz00_9527); }  else 
{ /* Llib/block_ciphers.scm 883 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_index1452z00_1295;
BgL_index1452z00_1295 = 
BGl_search1445ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1443z00_338), BgL_opt1443z00_338, 
CNST_TABLE_REF(((long)29)), ((long)3)); 
{ /* Llib/block_ciphers.scm 883 */
bool_t BgL_testz00_9540;
{ /* Llib/block_ciphers.scm 883 */
long BgL_n1z00_3515;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_tmpz00_9541;
if(
INTEGERP(BgL_index1452z00_1295))
{ /* Llib/block_ciphers.scm 883 */
BgL_tmpz00_9541 = BgL_index1452z00_1295
; }  else 
{ 
obj_t BgL_auxz00_9544;
BgL_auxz00_9544 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32021)), BGl_string3771z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1452z00_1295); 
FAILURE(BgL_auxz00_9544,BFALSE,BFALSE);} 
BgL_n1z00_3515 = 
(long)CINT(BgL_tmpz00_9541); } 
BgL_testz00_9540 = 
(BgL_n1z00_3515>=((long)0)); } 
if(BgL_testz00_9540)
{ 
long BgL_auxz00_9550;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_tmpz00_9551;
if(
INTEGERP(BgL_index1452z00_1295))
{ /* Llib/block_ciphers.scm 883 */
BgL_tmpz00_9551 = BgL_index1452z00_1295
; }  else 
{ 
obj_t BgL_auxz00_9554;
BgL_auxz00_9554 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32021)), BGl_string3771z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1452z00_1295); 
FAILURE(BgL_auxz00_9554,BFALSE,BFALSE);} 
BgL_auxz00_9550 = 
(long)CINT(BgL_tmpz00_9551); } 
BgL_padz00_1277 = 
VECTOR_REF(BgL_opt1443z00_338,BgL_auxz00_9550); }  else 
{ /* Llib/block_ciphers.scm 883 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_index1453z00_1297;
BgL_index1453z00_1297 = 
BGl_search1445ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1443z00_338), BgL_opt1443z00_338, 
CNST_TABLE_REF(((long)30)), ((long)3)); 
{ /* Llib/block_ciphers.scm 883 */
bool_t BgL_testz00_9563;
{ /* Llib/block_ciphers.scm 883 */
long BgL_n1z00_3517;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_tmpz00_9564;
if(
INTEGERP(BgL_index1453z00_1297))
{ /* Llib/block_ciphers.scm 883 */
BgL_tmpz00_9564 = BgL_index1453z00_1297
; }  else 
{ 
obj_t BgL_auxz00_9567;
BgL_auxz00_9567 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32021)), BGl_string3771z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1453z00_1297); 
FAILURE(BgL_auxz00_9567,BFALSE,BFALSE);} 
BgL_n1z00_3517 = 
(long)CINT(BgL_tmpz00_9564); } 
BgL_testz00_9563 = 
(BgL_n1z00_3517>=((long)0)); } 
if(BgL_testz00_9563)
{ 
long BgL_auxz00_9573;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_tmpz00_9574;
if(
INTEGERP(BgL_index1453z00_1297))
{ /* Llib/block_ciphers.scm 883 */
BgL_tmpz00_9574 = BgL_index1453z00_1297
; }  else 
{ 
obj_t BgL_auxz00_9577;
BgL_auxz00_9577 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32021)), BGl_string3771z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1453z00_1297); 
FAILURE(BgL_auxz00_9577,BFALSE,BFALSE);} 
BgL_auxz00_9573 = 
(long)CINT(BgL_tmpz00_9574); } 
BgL_stringzd2ze3keyz31_1278 = 
VECTOR_REF(BgL_opt1443z00_338,BgL_auxz00_9573); }  else 
{ /* Llib/block_ciphers.scm 883 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_arg2100z00_1299;obj_t BgL_arg2101z00_1300;obj_t BgL_arg2102z00_1301;
BgL_arg2100z00_1299 = 
VECTOR_REF(BgL_opt1443z00_338,((long)0)); 
BgL_arg2101z00_1300 = 
VECTOR_REF(BgL_opt1443z00_338,((long)1)); 
BgL_arg2102z00_1301 = 
VECTOR_REF(BgL_opt1443z00_338,((long)2)); 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_ivz00_1302;
BgL_ivz00_1302 = BgL_ivz00_1273; 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_modez00_1303;
BgL_modez00_1303 = BgL_modez00_1274; 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_noncezd2initz12zc0_1304;
BgL_noncezd2initz12zc0_1304 = BgL_noncezd2initz12zc0_1275; 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_noncezd2updatez12zc0_1305;
BgL_noncezd2updatez12zc0_1305 = BgL_noncezd2updatez12zc0_1276; 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_padz00_1306;
BgL_padz00_1306 = BgL_padz00_1277; 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_stringzd2ze3keyz31_1307;
BgL_stringzd2ze3keyz31_1307 = BgL_stringzd2ze3keyz31_1278; 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_res2966z00_3537;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_cipherz00_3519;obj_t BgL_ciphertextz00_3520;obj_t BgL_passwordz00_3521;
if(
SYMBOLP(BgL_arg2100z00_1299))
{ /* Llib/block_ciphers.scm 883 */
BgL_cipherz00_3519 = BgL_arg2100z00_1299; }  else 
{ 
obj_t BgL_auxz00_9588;
BgL_auxz00_9588 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32021)), BGl_string3771z00zz__cryptozd2blockzd2ciphersz00, BGl_string3752z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2100z00_1299); 
FAILURE(BgL_auxz00_9588,BFALSE,BFALSE);} 
if(
BGL_MMAPP(BgL_arg2101z00_1300))
{ /* Llib/block_ciphers.scm 883 */
BgL_ciphertextz00_3520 = BgL_arg2101z00_1300; }  else 
{ 
obj_t BgL_auxz00_9594;
BgL_auxz00_9594 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32021)), BGl_string3771z00zz__cryptozd2blockzd2ciphersz00, BGl_string3758z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2101z00_1300); 
FAILURE(BgL_auxz00_9594,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg2102z00_1301))
{ /* Llib/block_ciphers.scm 883 */
BgL_passwordz00_3521 = BgL_arg2102z00_1301; }  else 
{ 
obj_t BgL_auxz00_9600;
BgL_auxz00_9600 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32021)), BGl_string3771z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2102z00_1301); 
FAILURE(BgL_auxz00_9600,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 887 */
obj_t BgL_res2965z00_3536;
{ /* Llib/block_ciphers.scm 893 */
long BgL_lenz00_3524;
{ /* Llib/block_ciphers.scm 893 */
long BgL_res2963z00_3531;
BgL_res2963z00_3531 = 
BGL_MMAP_LENGTH(BgL_ciphertextz00_3520); 
BgL_lenz00_3524 = BgL_res2963z00_3531; } 
{ /* Llib/block_ciphers.scm 893 */
obj_t BgL_strz00_3525;
{ /* Llib/block_ciphers.scm 894 */

{ /* Llib/block_ciphers.scm 894 */
obj_t BgL_res2964z00_3533;
{ /* Llib/block_ciphers.scm 894 */
long BgL_kz00_3532;
BgL_kz00_3532 = 
(long)(BgL_lenz00_3524); 
BgL_res2964z00_3533 = 
make_string(BgL_kz00_3532, ((unsigned char)' ')); } 
BgL_strz00_3525 = BgL_res2964z00_3533; } } 
{ /* Llib/block_ciphers.scm 894 */
BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3528;
BgL_statez00_3528 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_3519, BgL_passwordz00_3521, BgL_ivz00_1302, BgL_modez00_1303, BgL_padz00_1306, BgL_noncezd2initz12zc0_1304, BgL_noncezd2updatez12zc0_1305, BgL_stringzd2ze3keyz31_1307); 
{ /* Llib/block_ciphers.scm 895 */

{ /* Llib/block_ciphers.scm 898 */
long BgL_tmpz00_9608;
BgL_tmpz00_9608 = 
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3528, BgL_ciphertextz00_3520, ((long)0), BGl_readzd2mmapzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_strz00_3525, ((long)0), BGl_blitzd2stringzd2urz12zd2envzc0zz__r4_strings_6_7z00); 
BgL_res2965z00_3536 = 
bgl_string_shrink(BgL_strz00_3525, BgL_tmpz00_9608); } } } } } 
BgL_res2966z00_3537 = BgL_res2965z00_3536; } } 
return BgL_res2966z00_3537;} } } } } } } } } } } } } } } } } 
BGL_FUNCTION_END;
}



/* search1445~0 */
obj_t BGl_search1445ze70ze7zz__cryptozd2blockzd2ciphersz00(long BgL_l1444z00_5650, obj_t BgL_opt1443z00_5649, obj_t BgL_k1z00_1267, long BgL_iz00_1268)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 883 */
BGl_search1445ze70ze7zz__cryptozd2blockzd2ciphersz00:
if(
(BgL_iz00_1268==BgL_l1444z00_5650))
{ /* Llib/block_ciphers.scm 883 */
return 
BINT(((long)-1));}  else 
{ /* Llib/block_ciphers.scm 883 */
if(
(BgL_iz00_1268==
(BgL_l1444z00_5650-((long)1))))
{ /* Llib/block_ciphers.scm 883 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)39)), BGl_string3754z00zz__cryptozd2blockzd2ciphersz00, 
BINT(
VECTOR_LENGTH(BgL_opt1443z00_5649)));}  else 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_vz00_1312;
BgL_vz00_1312 = 
VECTOR_REF(BgL_opt1443z00_5649,BgL_iz00_1268); 
if(
(BgL_vz00_1312==BgL_k1z00_1267))
{ /* Llib/block_ciphers.scm 883 */
return 
BINT(
(BgL_iz00_1268+((long)1)));}  else 
{ 
long BgL_iz00_9626;
BgL_iz00_9626 = 
(BgL_iz00_1268+((long)2)); 
BgL_iz00_1268 = BgL_iz00_9626; 
goto BGl_search1445ze70ze7zz__cryptozd2blockzd2ciphersz00;} } } } 
BGL_FUNCTION_END;
}



/* decrypt-mmap */
BGL_EXPORTED_DEF obj_t BGl_decryptzd2mmapzd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_329, obj_t BgL_ciphertextz00_330, obj_t BgL_passwordz00_331, obj_t BgL_ivz00_332, obj_t BgL_modez00_333, obj_t BgL_noncezd2initz12zc0_334, obj_t BgL_noncezd2updatez12zc0_335, obj_t BgL_padz00_336, obj_t BgL_stringzd2ze3keyz31_337)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 883 */
{ /* Llib/block_ciphers.scm 887 */
obj_t BgL_res2969z00_3552;
{ /* Llib/block_ciphers.scm 893 */
long BgL_lenz00_3540;
{ /* Llib/block_ciphers.scm 893 */
long BgL_res2967z00_3547;
BgL_res2967z00_3547 = 
BGL_MMAP_LENGTH(BgL_ciphertextz00_330); 
BgL_lenz00_3540 = BgL_res2967z00_3547; } 
{ /* Llib/block_ciphers.scm 893 */
obj_t BgL_strz00_3541;
{ /* Llib/block_ciphers.scm 894 */

{ /* Llib/block_ciphers.scm 894 */
obj_t BgL_res2968z00_3549;
{ /* Llib/block_ciphers.scm 894 */
long BgL_kz00_3548;
BgL_kz00_3548 = 
(long)(BgL_lenz00_3540); 
BgL_res2968z00_3549 = 
make_string(BgL_kz00_3548, ((unsigned char)' ')); } 
BgL_strz00_3541 = BgL_res2968z00_3549; } } 
{ /* Llib/block_ciphers.scm 894 */
BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3544;
BgL_statez00_3544 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_329, BgL_passwordz00_331, BgL_ivz00_332, BgL_modez00_333, BgL_padz00_336, BgL_noncezd2initz12zc0_334, BgL_noncezd2updatez12zc0_335, BgL_stringzd2ze3keyz31_337); 
{ /* Llib/block_ciphers.scm 895 */

{ /* Llib/block_ciphers.scm 898 */
long BgL_tmpz00_9632;
BgL_tmpz00_9632 = 
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3544, BgL_ciphertextz00_330, ((long)0), BGl_readzd2mmapzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_strz00_3541, ((long)0), BGl_blitzd2stringzd2urz12zd2envzc0zz__r4_strings_6_7z00); 
BgL_res2969z00_3552 = 
bgl_string_shrink(BgL_strz00_3541, BgL_tmpz00_9632); } } } } } 
return BgL_res2969z00_3552;} } 
BGL_FUNCTION_END;
}



/* &decrypt-fast-mmap */
obj_t BGl_z62decryptzd2fastzd2mmapz62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5027, obj_t BgL_cipherz00_5028, obj_t BgL_ciphertextz00_5029, obj_t BgL_passwordz00_5030, obj_t BgL_ivz00_5031, obj_t BgL_modez00_5032, obj_t BgL_padz00_5033, obj_t BgL_noncezd2initz12zc0_5034, obj_t BgL_noncezd2updatez12zc0_5035, obj_t BgL_stringzd2ze3keyz31_5036)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 890 */
{ /* Llib/block_ciphers.scm 893 */
obj_t BgL_ciphertextz00_6188;obj_t BgL_passwordz00_6189;
if(
BGL_MMAPP(BgL_ciphertextz00_5029))
{ /* Llib/block_ciphers.scm 893 */
BgL_ciphertextz00_6188 = BgL_ciphertextz00_5029; }  else 
{ 
obj_t BgL_auxz00_9637;
BgL_auxz00_9637 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32475)), BGl_string3772z00zz__cryptozd2blockzd2ciphersz00, BGl_string3758z00zz__cryptozd2blockzd2ciphersz00, BgL_ciphertextz00_5029); 
FAILURE(BgL_auxz00_9637,BFALSE,BFALSE);} 
if(
STRINGP(BgL_passwordz00_5030))
{ /* Llib/block_ciphers.scm 893 */
BgL_passwordz00_6189 = BgL_passwordz00_5030; }  else 
{ 
obj_t BgL_auxz00_9643;
BgL_auxz00_9643 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32475)), BGl_string3772z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_passwordz00_5030); 
FAILURE(BgL_auxz00_9643,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 893 */
long BgL_lenz00_6190;
{ /* Llib/block_ciphers.scm 893 */
long BgL_res2970z00_6191;
BgL_res2970z00_6191 = 
BGL_MMAP_LENGTH(BgL_ciphertextz00_6188); 
BgL_lenz00_6190 = BgL_res2970z00_6191; } 
{ /* Llib/block_ciphers.scm 893 */
obj_t BgL_strz00_6192;
{ /* Llib/block_ciphers.scm 894 */

{ /* Llib/block_ciphers.scm 894 */
obj_t BgL_res2971z00_6193;
{ /* Llib/block_ciphers.scm 894 */
long BgL_kz00_6194;
BgL_kz00_6194 = 
(long)(BgL_lenz00_6190); 
BgL_res2971z00_6193 = 
make_string(BgL_kz00_6194, ((unsigned char)' ')); } 
BgL_strz00_6192 = BgL_res2971z00_6193; } } 
{ /* Llib/block_ciphers.scm 894 */
BgL_cipherzd2modezd2statez00_bglt BgL_statez00_6195;
BgL_statez00_6195 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_5028, BgL_passwordz00_6189, BgL_ivz00_5031, BgL_modez00_5032, BgL_padz00_5033, BgL_noncezd2initz12zc0_5034, BgL_noncezd2updatez12zc0_5035, BgL_stringzd2ze3keyz31_5036); 
{ /* Llib/block_ciphers.scm 895 */

{ /* Llib/block_ciphers.scm 898 */
long BgL_tmpz00_9651;
BgL_tmpz00_9651 = 
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_6195, BgL_ciphertextz00_6188, ((long)0), BGl_readzd2mmapzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_strz00_6192, ((long)0), BGl_blitzd2stringzd2urz12zd2envzc0zz__r4_strings_6_7z00); 
return 
bgl_string_shrink(BgL_strz00_6192, BgL_tmpz00_9651);} } } } } } } 
BGL_FUNCTION_END;
}



/* _decrypt-port */
obj_t BGl__decryptzd2portzd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_359, obj_t BgL_opt1454z00_358)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 903 */
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_cipherz00_1326;obj_t BgL_ciphertextz00_1327;obj_t BgL_passwordz00_1328;
BgL_cipherz00_1326 = 
VECTOR_REF(BgL_opt1454z00_358,((long)0)); 
BgL_ciphertextz00_1327 = 
VECTOR_REF(BgL_opt1454z00_358,((long)1)); 
BgL_passwordz00_1328 = 
VECTOR_REF(BgL_opt1454z00_358,((long)2)); 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_ivz00_1329;
BgL_ivz00_1329 = BFALSE; 
{ /* Llib/block_ciphers.scm 904 */
obj_t BgL_modez00_1330;
BgL_modez00_1330 = 
CNST_TABLE_REF(((long)10)); 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_noncezd2initz12zc0_1331;
BgL_noncezd2initz12zc0_1331 = BFALSE; 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_noncezd2updatez12zc0_1332;
BgL_noncezd2updatez12zc0_1332 = BFALSE; 
{ /* Llib/block_ciphers.scm 904 */
obj_t BgL_padz00_1333;
BgL_padz00_1333 = 
CNST_TABLE_REF(((long)16)); 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_stringzd2ze3keyz31_1334;
BgL_stringzd2ze3keyz31_1334 = BFALSE; 
{ /* Llib/block_ciphers.scm 903 */

{ 
long BgL_iz00_1335;
BgL_iz00_1335 = ((long)3); 
BgL_check1457z00_1336:
if(
(BgL_iz00_1335==
VECTOR_LENGTH(BgL_opt1454z00_358)))
{ /* Llib/block_ciphers.scm 903 */BNIL; }  else 
{ /* Llib/block_ciphers.scm 903 */
bool_t BgL_testz00_9662;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_arg2116z00_1342;
BgL_arg2116z00_1342 = 
VECTOR_REF(BgL_opt1454z00_358,BgL_iz00_1335); 
BgL_testz00_9662 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg2116z00_1342, 
CNST_TABLE_REF(((long)23)))); } 
if(BgL_testz00_9662)
{ 
long BgL_iz00_9667;
BgL_iz00_9667 = 
(BgL_iz00_1335+((long)2)); 
BgL_iz00_1335 = BgL_iz00_9667; 
goto BgL_check1457z00_1336;}  else 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_arg2115z00_1341;
BgL_arg2115z00_1341 = 
VECTOR_REF(BgL_opt1454z00_358,BgL_iz00_1335); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)40)), BGl_string3749z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2115z00_1341); } } } 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_index1459z00_1343;
BgL_index1459z00_1343 = 
BGl_search1456ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1454z00_358), BgL_opt1454z00_358, 
CNST_TABLE_REF(((long)25)), ((long)3)); 
{ /* Llib/block_ciphers.scm 903 */
bool_t BgL_testz00_9675;
{ /* Llib/block_ciphers.scm 903 */
long BgL_n1z00_3587;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_tmpz00_9676;
if(
INTEGERP(BgL_index1459z00_1343))
{ /* Llib/block_ciphers.scm 903 */
BgL_tmpz00_9676 = BgL_index1459z00_1343
; }  else 
{ 
obj_t BgL_auxz00_9679;
BgL_auxz00_9679 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32788)), BGl_string3773z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1459z00_1343); 
FAILURE(BgL_auxz00_9679,BFALSE,BFALSE);} 
BgL_n1z00_3587 = 
(long)CINT(BgL_tmpz00_9676); } 
BgL_testz00_9675 = 
(BgL_n1z00_3587>=((long)0)); } 
if(BgL_testz00_9675)
{ 
long BgL_auxz00_9685;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_tmpz00_9686;
if(
INTEGERP(BgL_index1459z00_1343))
{ /* Llib/block_ciphers.scm 903 */
BgL_tmpz00_9686 = BgL_index1459z00_1343
; }  else 
{ 
obj_t BgL_auxz00_9689;
BgL_auxz00_9689 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32788)), BGl_string3773z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1459z00_1343); 
FAILURE(BgL_auxz00_9689,BFALSE,BFALSE);} 
BgL_auxz00_9685 = 
(long)CINT(BgL_tmpz00_9686); } 
BgL_ivz00_1329 = 
VECTOR_REF(BgL_opt1454z00_358,BgL_auxz00_9685); }  else 
{ /* Llib/block_ciphers.scm 903 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_index1460z00_1345;
BgL_index1460z00_1345 = 
BGl_search1456ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1454z00_358), BgL_opt1454z00_358, 
CNST_TABLE_REF(((long)26)), ((long)3)); 
{ /* Llib/block_ciphers.scm 903 */
bool_t BgL_testz00_9698;
{ /* Llib/block_ciphers.scm 903 */
long BgL_n1z00_3589;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_tmpz00_9699;
if(
INTEGERP(BgL_index1460z00_1345))
{ /* Llib/block_ciphers.scm 903 */
BgL_tmpz00_9699 = BgL_index1460z00_1345
; }  else 
{ 
obj_t BgL_auxz00_9702;
BgL_auxz00_9702 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32788)), BGl_string3773z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1460z00_1345); 
FAILURE(BgL_auxz00_9702,BFALSE,BFALSE);} 
BgL_n1z00_3589 = 
(long)CINT(BgL_tmpz00_9699); } 
BgL_testz00_9698 = 
(BgL_n1z00_3589>=((long)0)); } 
if(BgL_testz00_9698)
{ 
long BgL_auxz00_9708;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_tmpz00_9709;
if(
INTEGERP(BgL_index1460z00_1345))
{ /* Llib/block_ciphers.scm 903 */
BgL_tmpz00_9709 = BgL_index1460z00_1345
; }  else 
{ 
obj_t BgL_auxz00_9712;
BgL_auxz00_9712 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32788)), BGl_string3773z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1460z00_1345); 
FAILURE(BgL_auxz00_9712,BFALSE,BFALSE);} 
BgL_auxz00_9708 = 
(long)CINT(BgL_tmpz00_9709); } 
BgL_modez00_1330 = 
VECTOR_REF(BgL_opt1454z00_358,BgL_auxz00_9708); }  else 
{ /* Llib/block_ciphers.scm 903 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_index1461z00_1347;
BgL_index1461z00_1347 = 
BGl_search1456ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1454z00_358), BgL_opt1454z00_358, 
CNST_TABLE_REF(((long)27)), ((long)3)); 
{ /* Llib/block_ciphers.scm 903 */
bool_t BgL_testz00_9721;
{ /* Llib/block_ciphers.scm 903 */
long BgL_n1z00_3591;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_tmpz00_9722;
if(
INTEGERP(BgL_index1461z00_1347))
{ /* Llib/block_ciphers.scm 903 */
BgL_tmpz00_9722 = BgL_index1461z00_1347
; }  else 
{ 
obj_t BgL_auxz00_9725;
BgL_auxz00_9725 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32788)), BGl_string3773z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1461z00_1347); 
FAILURE(BgL_auxz00_9725,BFALSE,BFALSE);} 
BgL_n1z00_3591 = 
(long)CINT(BgL_tmpz00_9722); } 
BgL_testz00_9721 = 
(BgL_n1z00_3591>=((long)0)); } 
if(BgL_testz00_9721)
{ 
long BgL_auxz00_9731;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_tmpz00_9732;
if(
INTEGERP(BgL_index1461z00_1347))
{ /* Llib/block_ciphers.scm 903 */
BgL_tmpz00_9732 = BgL_index1461z00_1347
; }  else 
{ 
obj_t BgL_auxz00_9735;
BgL_auxz00_9735 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32788)), BGl_string3773z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1461z00_1347); 
FAILURE(BgL_auxz00_9735,BFALSE,BFALSE);} 
BgL_auxz00_9731 = 
(long)CINT(BgL_tmpz00_9732); } 
BgL_noncezd2initz12zc0_1331 = 
VECTOR_REF(BgL_opt1454z00_358,BgL_auxz00_9731); }  else 
{ /* Llib/block_ciphers.scm 903 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_index1462z00_1349;
BgL_index1462z00_1349 = 
BGl_search1456ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1454z00_358), BgL_opt1454z00_358, 
CNST_TABLE_REF(((long)28)), ((long)3)); 
{ /* Llib/block_ciphers.scm 903 */
bool_t BgL_testz00_9744;
{ /* Llib/block_ciphers.scm 903 */
long BgL_n1z00_3593;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_tmpz00_9745;
if(
INTEGERP(BgL_index1462z00_1349))
{ /* Llib/block_ciphers.scm 903 */
BgL_tmpz00_9745 = BgL_index1462z00_1349
; }  else 
{ 
obj_t BgL_auxz00_9748;
BgL_auxz00_9748 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32788)), BGl_string3773z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1462z00_1349); 
FAILURE(BgL_auxz00_9748,BFALSE,BFALSE);} 
BgL_n1z00_3593 = 
(long)CINT(BgL_tmpz00_9745); } 
BgL_testz00_9744 = 
(BgL_n1z00_3593>=((long)0)); } 
if(BgL_testz00_9744)
{ 
long BgL_auxz00_9754;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_tmpz00_9755;
if(
INTEGERP(BgL_index1462z00_1349))
{ /* Llib/block_ciphers.scm 903 */
BgL_tmpz00_9755 = BgL_index1462z00_1349
; }  else 
{ 
obj_t BgL_auxz00_9758;
BgL_auxz00_9758 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32788)), BGl_string3773z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1462z00_1349); 
FAILURE(BgL_auxz00_9758,BFALSE,BFALSE);} 
BgL_auxz00_9754 = 
(long)CINT(BgL_tmpz00_9755); } 
BgL_noncezd2updatez12zc0_1332 = 
VECTOR_REF(BgL_opt1454z00_358,BgL_auxz00_9754); }  else 
{ /* Llib/block_ciphers.scm 903 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_index1463z00_1351;
BgL_index1463z00_1351 = 
BGl_search1456ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1454z00_358), BgL_opt1454z00_358, 
CNST_TABLE_REF(((long)29)), ((long)3)); 
{ /* Llib/block_ciphers.scm 903 */
bool_t BgL_testz00_9767;
{ /* Llib/block_ciphers.scm 903 */
long BgL_n1z00_3595;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_tmpz00_9768;
if(
INTEGERP(BgL_index1463z00_1351))
{ /* Llib/block_ciphers.scm 903 */
BgL_tmpz00_9768 = BgL_index1463z00_1351
; }  else 
{ 
obj_t BgL_auxz00_9771;
BgL_auxz00_9771 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32788)), BGl_string3773z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1463z00_1351); 
FAILURE(BgL_auxz00_9771,BFALSE,BFALSE);} 
BgL_n1z00_3595 = 
(long)CINT(BgL_tmpz00_9768); } 
BgL_testz00_9767 = 
(BgL_n1z00_3595>=((long)0)); } 
if(BgL_testz00_9767)
{ 
long BgL_auxz00_9777;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_tmpz00_9778;
if(
INTEGERP(BgL_index1463z00_1351))
{ /* Llib/block_ciphers.scm 903 */
BgL_tmpz00_9778 = BgL_index1463z00_1351
; }  else 
{ 
obj_t BgL_auxz00_9781;
BgL_auxz00_9781 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32788)), BGl_string3773z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1463z00_1351); 
FAILURE(BgL_auxz00_9781,BFALSE,BFALSE);} 
BgL_auxz00_9777 = 
(long)CINT(BgL_tmpz00_9778); } 
BgL_padz00_1333 = 
VECTOR_REF(BgL_opt1454z00_358,BgL_auxz00_9777); }  else 
{ /* Llib/block_ciphers.scm 903 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_index1464z00_1353;
BgL_index1464z00_1353 = 
BGl_search1456ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1454z00_358), BgL_opt1454z00_358, 
CNST_TABLE_REF(((long)30)), ((long)3)); 
{ /* Llib/block_ciphers.scm 903 */
bool_t BgL_testz00_9790;
{ /* Llib/block_ciphers.scm 903 */
long BgL_n1z00_3597;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_tmpz00_9791;
if(
INTEGERP(BgL_index1464z00_1353))
{ /* Llib/block_ciphers.scm 903 */
BgL_tmpz00_9791 = BgL_index1464z00_1353
; }  else 
{ 
obj_t BgL_auxz00_9794;
BgL_auxz00_9794 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32788)), BGl_string3773z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1464z00_1353); 
FAILURE(BgL_auxz00_9794,BFALSE,BFALSE);} 
BgL_n1z00_3597 = 
(long)CINT(BgL_tmpz00_9791); } 
BgL_testz00_9790 = 
(BgL_n1z00_3597>=((long)0)); } 
if(BgL_testz00_9790)
{ 
long BgL_auxz00_9800;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_tmpz00_9801;
if(
INTEGERP(BgL_index1464z00_1353))
{ /* Llib/block_ciphers.scm 903 */
BgL_tmpz00_9801 = BgL_index1464z00_1353
; }  else 
{ 
obj_t BgL_auxz00_9804;
BgL_auxz00_9804 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32788)), BGl_string3773z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1464z00_1353); 
FAILURE(BgL_auxz00_9804,BFALSE,BFALSE);} 
BgL_auxz00_9800 = 
(long)CINT(BgL_tmpz00_9801); } 
BgL_stringzd2ze3keyz31_1334 = 
VECTOR_REF(BgL_opt1454z00_358,BgL_auxz00_9800); }  else 
{ /* Llib/block_ciphers.scm 903 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_arg2123z00_1355;obj_t BgL_arg2124z00_1356;obj_t BgL_arg2125z00_1357;
BgL_arg2123z00_1355 = 
VECTOR_REF(BgL_opt1454z00_358,((long)0)); 
BgL_arg2124z00_1356 = 
VECTOR_REF(BgL_opt1454z00_358,((long)1)); 
BgL_arg2125z00_1357 = 
VECTOR_REF(BgL_opt1454z00_358,((long)2)); 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_ivz00_1358;
BgL_ivz00_1358 = BgL_ivz00_1329; 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_modez00_1359;
BgL_modez00_1359 = BgL_modez00_1330; 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_noncezd2initz12zc0_1360;
BgL_noncezd2initz12zc0_1360 = BgL_noncezd2initz12zc0_1331; 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_noncezd2updatez12zc0_1361;
BgL_noncezd2updatez12zc0_1361 = BgL_noncezd2updatez12zc0_1332; 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_padz00_1362;
BgL_padz00_1362 = BgL_padz00_1333; 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_stringzd2ze3keyz31_1363;
BgL_stringzd2ze3keyz31_1363 = BgL_stringzd2ze3keyz31_1334; 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_res2986z00_3609;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_cipherz00_3599;obj_t BgL_ciphertextz00_3600;obj_t BgL_passwordz00_3601;
if(
SYMBOLP(BgL_arg2123z00_1355))
{ /* Llib/block_ciphers.scm 903 */
BgL_cipherz00_3599 = BgL_arg2123z00_1355; }  else 
{ 
obj_t BgL_auxz00_9815;
BgL_auxz00_9815 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32788)), BGl_string3773z00zz__cryptozd2blockzd2ciphersz00, BGl_string3752z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2123z00_1355); 
FAILURE(BgL_auxz00_9815,BFALSE,BFALSE);} 
if(
INPUT_PORTP(BgL_arg2124z00_1356))
{ /* Llib/block_ciphers.scm 903 */
BgL_ciphertextz00_3600 = BgL_arg2124z00_1356; }  else 
{ 
obj_t BgL_auxz00_9821;
BgL_auxz00_9821 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32788)), BGl_string3773z00zz__cryptozd2blockzd2ciphersz00, BGl_string3761z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2124z00_1356); 
FAILURE(BgL_auxz00_9821,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg2125z00_1357))
{ /* Llib/block_ciphers.scm 903 */
BgL_passwordz00_3601 = BgL_arg2125z00_1357; }  else 
{ 
obj_t BgL_auxz00_9827;
BgL_auxz00_9827 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32788)), BGl_string3773z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2125z00_1357); 
FAILURE(BgL_auxz00_9827,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 907 */
obj_t BgL_res2985z00_3608;
{ /* Llib/block_ciphers.scm 913 */
obj_t BgL_pz00_3604;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3605;
{ /* Llib/block_ciphers.scm 913 */

{ /* Llib/block_ciphers.scm 913 */

BgL_pz00_3604 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
BgL_statez00_3605 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_3599, BgL_passwordz00_3601, BgL_ivz00_1358, BgL_modez00_1359, BgL_padz00_1362, BgL_noncezd2initz12zc0_1360, BgL_noncezd2updatez12zc0_1361, BgL_stringzd2ze3keyz31_1363); 
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3605, BgL_ciphertextz00_3600, ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_pz00_3604, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00); 
{ /* Llib/block_ciphers.scm 920 */
obj_t BgL_aux3633z00_6003;
BgL_aux3633z00_6003 = 
bgl_close_output_port(BgL_pz00_3604); 
if(
STRINGP(BgL_aux3633z00_6003))
{ /* Llib/block_ciphers.scm 920 */
BgL_res2985z00_3608 = BgL_aux3633z00_6003; }  else 
{ 
obj_t BgL_auxz00_9837;
BgL_auxz00_9837 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33496)), BGl_string3773z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_aux3633z00_6003); 
FAILURE(BgL_auxz00_9837,BFALSE,BFALSE);} } } 
BgL_res2986z00_3609 = BgL_res2985z00_3608; } } 
return BgL_res2986z00_3609;} } } } } } } } } } } } } } } } } 
BGL_FUNCTION_END;
}



/* search1456~0 */
obj_t BGl_search1456ze70ze7zz__cryptozd2blockzd2ciphersz00(long BgL_l1455z00_5648, obj_t BgL_opt1454z00_5647, obj_t BgL_k1z00_1323, long BgL_iz00_1324)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 903 */
BGl_search1456ze70ze7zz__cryptozd2blockzd2ciphersz00:
if(
(BgL_iz00_1324==BgL_l1455z00_5648))
{ /* Llib/block_ciphers.scm 903 */
return 
BINT(((long)-1));}  else 
{ /* Llib/block_ciphers.scm 903 */
if(
(BgL_iz00_1324==
(BgL_l1455z00_5648-((long)1))))
{ /* Llib/block_ciphers.scm 903 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)40)), BGl_string3754z00zz__cryptozd2blockzd2ciphersz00, 
BINT(
VECTOR_LENGTH(BgL_opt1454z00_5647)));}  else 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_vz00_1368;
BgL_vz00_1368 = 
VECTOR_REF(BgL_opt1454z00_5647,BgL_iz00_1324); 
if(
(BgL_vz00_1368==BgL_k1z00_1323))
{ /* Llib/block_ciphers.scm 903 */
return 
BINT(
(BgL_iz00_1324+((long)1)));}  else 
{ 
long BgL_iz00_9856;
BgL_iz00_9856 = 
(BgL_iz00_1324+((long)2)); 
BgL_iz00_1324 = BgL_iz00_9856; 
goto BGl_search1456ze70ze7zz__cryptozd2blockzd2ciphersz00;} } } } 
BGL_FUNCTION_END;
}



/* decrypt-port */
BGL_EXPORTED_DEF obj_t BGl_decryptzd2portzd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_349, obj_t BgL_ciphertextz00_350, obj_t BgL_passwordz00_351, obj_t BgL_ivz00_352, obj_t BgL_modez00_353, obj_t BgL_noncezd2initz12zc0_354, obj_t BgL_noncezd2updatez12zc0_355, obj_t BgL_padz00_356, obj_t BgL_stringzd2ze3keyz31_357)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 903 */
{ /* Llib/block_ciphers.scm 907 */
obj_t BgL_res2987z00_3616;
{ /* Llib/block_ciphers.scm 913 */
obj_t BgL_pz00_3612;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3613;
{ /* Llib/block_ciphers.scm 913 */

{ /* Llib/block_ciphers.scm 913 */

BgL_pz00_3612 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
BgL_statez00_3613 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_349, BgL_passwordz00_351, BgL_ivz00_352, BgL_modez00_353, BgL_padz00_356, BgL_noncezd2initz12zc0_354, BgL_noncezd2updatez12zc0_355, BgL_stringzd2ze3keyz31_357); 
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3613, BgL_ciphertextz00_350, ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_pz00_3612, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00); 
BgL_res2987z00_3616 = 
bgl_close_output_port(BgL_pz00_3612); } 
return BgL_res2987z00_3616;} } 
BGL_FUNCTION_END;
}



/* &decrypt-fast-port */
obj_t BGl_z62decryptzd2fastzd2portz62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5037, obj_t BgL_cipherz00_5038, obj_t BgL_ciphertextz00_5039, obj_t BgL_passwordz00_5040, obj_t BgL_ivz00_5041, obj_t BgL_modez00_5042, obj_t BgL_padz00_5043, obj_t BgL_noncezd2initz12zc0_5044, obj_t BgL_noncezd2updatez12zc0_5045, obj_t BgL_stringzd2ze3keyz31_5046)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 910 */
{ /* Llib/block_ciphers.scm 913 */
obj_t BgL_ciphertextz00_6196;obj_t BgL_passwordz00_6197;
if(
INPUT_PORTP(BgL_ciphertextz00_5039))
{ /* Llib/block_ciphers.scm 913 */
BgL_ciphertextz00_6196 = BgL_ciphertextz00_5039; }  else 
{ 
obj_t BgL_auxz00_9864;
BgL_auxz00_9864 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33253)), BGl_string3774z00zz__cryptozd2blockzd2ciphersz00, BGl_string3761z00zz__cryptozd2blockzd2ciphersz00, BgL_ciphertextz00_5039); 
FAILURE(BgL_auxz00_9864,BFALSE,BFALSE);} 
if(
STRINGP(BgL_passwordz00_5040))
{ /* Llib/block_ciphers.scm 913 */
BgL_passwordz00_6197 = BgL_passwordz00_5040; }  else 
{ 
obj_t BgL_auxz00_9870;
BgL_auxz00_9870 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33253)), BGl_string3774z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_passwordz00_5040); 
FAILURE(BgL_auxz00_9870,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 913 */
obj_t BgL_pz00_6198;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_6199;
{ /* Llib/block_ciphers.scm 913 */

{ /* Llib/block_ciphers.scm 913 */

BgL_pz00_6198 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
BgL_statez00_6199 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_5038, BgL_passwordz00_6197, BgL_ivz00_5041, BgL_modez00_5042, BgL_padz00_5043, BgL_noncezd2initz12zc0_5044, BgL_noncezd2updatez12zc0_5045, BgL_stringzd2ze3keyz31_5046); 
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_6199, BgL_ciphertextz00_6196, ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_pz00_6198, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00); 
return 
bgl_close_output_port(BgL_pz00_6198);} } } 
BGL_FUNCTION_END;
}



/* _decrypt-file */
obj_t BGl__decryptzd2filezd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_379, obj_t BgL_opt1465z00_378)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 922 */
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_cipherz00_1379;obj_t BgL_filenamez00_1380;obj_t BgL_passwordz00_1381;
BgL_cipherz00_1379 = 
VECTOR_REF(BgL_opt1465z00_378,((long)0)); 
BgL_filenamez00_1380 = 
VECTOR_REF(BgL_opt1465z00_378,((long)1)); 
BgL_passwordz00_1381 = 
VECTOR_REF(BgL_opt1465z00_378,((long)2)); 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_ivz00_1382;
BgL_ivz00_1382 = BFALSE; 
{ /* Llib/block_ciphers.scm 923 */
obj_t BgL_modez00_1383;
BgL_modez00_1383 = 
CNST_TABLE_REF(((long)10)); 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_noncezd2initz12zc0_1384;
BgL_noncezd2initz12zc0_1384 = BFALSE; 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_noncezd2updatez12zc0_1385;
BgL_noncezd2updatez12zc0_1385 = BFALSE; 
{ /* Llib/block_ciphers.scm 923 */
obj_t BgL_padz00_1386;
BgL_padz00_1386 = 
CNST_TABLE_REF(((long)16)); 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_stringzd2ze3keyz31_1387;
BgL_stringzd2ze3keyz31_1387 = BFALSE; 
{ /* Llib/block_ciphers.scm 922 */

{ 
long BgL_iz00_1388;
BgL_iz00_1388 = ((long)3); 
BgL_check1468z00_1389:
if(
(BgL_iz00_1388==
VECTOR_LENGTH(BgL_opt1465z00_378)))
{ /* Llib/block_ciphers.scm 922 */BNIL; }  else 
{ /* Llib/block_ciphers.scm 922 */
bool_t BgL_testz00_9886;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_arg2138z00_1395;
BgL_arg2138z00_1395 = 
VECTOR_REF(BgL_opt1465z00_378,BgL_iz00_1388); 
BgL_testz00_9886 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg2138z00_1395, 
CNST_TABLE_REF(((long)23)))); } 
if(BgL_testz00_9886)
{ 
long BgL_iz00_9891;
BgL_iz00_9891 = 
(BgL_iz00_1388+((long)2)); 
BgL_iz00_1388 = BgL_iz00_9891; 
goto BgL_check1468z00_1389;}  else 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_arg2137z00_1394;
BgL_arg2137z00_1394 = 
VECTOR_REF(BgL_opt1465z00_378,BgL_iz00_1388); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)41)), BGl_string3749z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2137z00_1394); } } } 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_index1470z00_1396;
BgL_index1470z00_1396 = 
BGl_search1467ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1465z00_378), BgL_opt1465z00_378, 
CNST_TABLE_REF(((long)25)), ((long)3)); 
{ /* Llib/block_ciphers.scm 922 */
bool_t BgL_testz00_9899;
{ /* Llib/block_ciphers.scm 922 */
long BgL_n1z00_3643;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_tmpz00_9900;
if(
INTEGERP(BgL_index1470z00_1396))
{ /* Llib/block_ciphers.scm 922 */
BgL_tmpz00_9900 = BgL_index1470z00_1396
; }  else 
{ 
obj_t BgL_auxz00_9903;
BgL_auxz00_9903 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33521)), BGl_string3775z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1470z00_1396); 
FAILURE(BgL_auxz00_9903,BFALSE,BFALSE);} 
BgL_n1z00_3643 = 
(long)CINT(BgL_tmpz00_9900); } 
BgL_testz00_9899 = 
(BgL_n1z00_3643>=((long)0)); } 
if(BgL_testz00_9899)
{ 
long BgL_auxz00_9909;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_tmpz00_9910;
if(
INTEGERP(BgL_index1470z00_1396))
{ /* Llib/block_ciphers.scm 922 */
BgL_tmpz00_9910 = BgL_index1470z00_1396
; }  else 
{ 
obj_t BgL_auxz00_9913;
BgL_auxz00_9913 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33521)), BGl_string3775z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1470z00_1396); 
FAILURE(BgL_auxz00_9913,BFALSE,BFALSE);} 
BgL_auxz00_9909 = 
(long)CINT(BgL_tmpz00_9910); } 
BgL_ivz00_1382 = 
VECTOR_REF(BgL_opt1465z00_378,BgL_auxz00_9909); }  else 
{ /* Llib/block_ciphers.scm 922 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_index1471z00_1398;
BgL_index1471z00_1398 = 
BGl_search1467ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1465z00_378), BgL_opt1465z00_378, 
CNST_TABLE_REF(((long)26)), ((long)3)); 
{ /* Llib/block_ciphers.scm 922 */
bool_t BgL_testz00_9922;
{ /* Llib/block_ciphers.scm 922 */
long BgL_n1z00_3645;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_tmpz00_9923;
if(
INTEGERP(BgL_index1471z00_1398))
{ /* Llib/block_ciphers.scm 922 */
BgL_tmpz00_9923 = BgL_index1471z00_1398
; }  else 
{ 
obj_t BgL_auxz00_9926;
BgL_auxz00_9926 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33521)), BGl_string3775z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1471z00_1398); 
FAILURE(BgL_auxz00_9926,BFALSE,BFALSE);} 
BgL_n1z00_3645 = 
(long)CINT(BgL_tmpz00_9923); } 
BgL_testz00_9922 = 
(BgL_n1z00_3645>=((long)0)); } 
if(BgL_testz00_9922)
{ 
long BgL_auxz00_9932;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_tmpz00_9933;
if(
INTEGERP(BgL_index1471z00_1398))
{ /* Llib/block_ciphers.scm 922 */
BgL_tmpz00_9933 = BgL_index1471z00_1398
; }  else 
{ 
obj_t BgL_auxz00_9936;
BgL_auxz00_9936 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33521)), BGl_string3775z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1471z00_1398); 
FAILURE(BgL_auxz00_9936,BFALSE,BFALSE);} 
BgL_auxz00_9932 = 
(long)CINT(BgL_tmpz00_9933); } 
BgL_modez00_1383 = 
VECTOR_REF(BgL_opt1465z00_378,BgL_auxz00_9932); }  else 
{ /* Llib/block_ciphers.scm 922 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_index1472z00_1400;
BgL_index1472z00_1400 = 
BGl_search1467ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1465z00_378), BgL_opt1465z00_378, 
CNST_TABLE_REF(((long)27)), ((long)3)); 
{ /* Llib/block_ciphers.scm 922 */
bool_t BgL_testz00_9945;
{ /* Llib/block_ciphers.scm 922 */
long BgL_n1z00_3647;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_tmpz00_9946;
if(
INTEGERP(BgL_index1472z00_1400))
{ /* Llib/block_ciphers.scm 922 */
BgL_tmpz00_9946 = BgL_index1472z00_1400
; }  else 
{ 
obj_t BgL_auxz00_9949;
BgL_auxz00_9949 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33521)), BGl_string3775z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1472z00_1400); 
FAILURE(BgL_auxz00_9949,BFALSE,BFALSE);} 
BgL_n1z00_3647 = 
(long)CINT(BgL_tmpz00_9946); } 
BgL_testz00_9945 = 
(BgL_n1z00_3647>=((long)0)); } 
if(BgL_testz00_9945)
{ 
long BgL_auxz00_9955;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_tmpz00_9956;
if(
INTEGERP(BgL_index1472z00_1400))
{ /* Llib/block_ciphers.scm 922 */
BgL_tmpz00_9956 = BgL_index1472z00_1400
; }  else 
{ 
obj_t BgL_auxz00_9959;
BgL_auxz00_9959 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33521)), BGl_string3775z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1472z00_1400); 
FAILURE(BgL_auxz00_9959,BFALSE,BFALSE);} 
BgL_auxz00_9955 = 
(long)CINT(BgL_tmpz00_9956); } 
BgL_noncezd2initz12zc0_1384 = 
VECTOR_REF(BgL_opt1465z00_378,BgL_auxz00_9955); }  else 
{ /* Llib/block_ciphers.scm 922 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_index1473z00_1402;
BgL_index1473z00_1402 = 
BGl_search1467ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1465z00_378), BgL_opt1465z00_378, 
CNST_TABLE_REF(((long)28)), ((long)3)); 
{ /* Llib/block_ciphers.scm 922 */
bool_t BgL_testz00_9968;
{ /* Llib/block_ciphers.scm 922 */
long BgL_n1z00_3649;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_tmpz00_9969;
if(
INTEGERP(BgL_index1473z00_1402))
{ /* Llib/block_ciphers.scm 922 */
BgL_tmpz00_9969 = BgL_index1473z00_1402
; }  else 
{ 
obj_t BgL_auxz00_9972;
BgL_auxz00_9972 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33521)), BGl_string3775z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1473z00_1402); 
FAILURE(BgL_auxz00_9972,BFALSE,BFALSE);} 
BgL_n1z00_3649 = 
(long)CINT(BgL_tmpz00_9969); } 
BgL_testz00_9968 = 
(BgL_n1z00_3649>=((long)0)); } 
if(BgL_testz00_9968)
{ 
long BgL_auxz00_9978;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_tmpz00_9979;
if(
INTEGERP(BgL_index1473z00_1402))
{ /* Llib/block_ciphers.scm 922 */
BgL_tmpz00_9979 = BgL_index1473z00_1402
; }  else 
{ 
obj_t BgL_auxz00_9982;
BgL_auxz00_9982 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33521)), BGl_string3775z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1473z00_1402); 
FAILURE(BgL_auxz00_9982,BFALSE,BFALSE);} 
BgL_auxz00_9978 = 
(long)CINT(BgL_tmpz00_9979); } 
BgL_noncezd2updatez12zc0_1385 = 
VECTOR_REF(BgL_opt1465z00_378,BgL_auxz00_9978); }  else 
{ /* Llib/block_ciphers.scm 922 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_index1474z00_1404;
BgL_index1474z00_1404 = 
BGl_search1467ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1465z00_378), BgL_opt1465z00_378, 
CNST_TABLE_REF(((long)29)), ((long)3)); 
{ /* Llib/block_ciphers.scm 922 */
bool_t BgL_testz00_9991;
{ /* Llib/block_ciphers.scm 922 */
long BgL_n1z00_3651;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_tmpz00_9992;
if(
INTEGERP(BgL_index1474z00_1404))
{ /* Llib/block_ciphers.scm 922 */
BgL_tmpz00_9992 = BgL_index1474z00_1404
; }  else 
{ 
obj_t BgL_auxz00_9995;
BgL_auxz00_9995 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33521)), BGl_string3775z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1474z00_1404); 
FAILURE(BgL_auxz00_9995,BFALSE,BFALSE);} 
BgL_n1z00_3651 = 
(long)CINT(BgL_tmpz00_9992); } 
BgL_testz00_9991 = 
(BgL_n1z00_3651>=((long)0)); } 
if(BgL_testz00_9991)
{ 
long BgL_auxz00_10001;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_tmpz00_10002;
if(
INTEGERP(BgL_index1474z00_1404))
{ /* Llib/block_ciphers.scm 922 */
BgL_tmpz00_10002 = BgL_index1474z00_1404
; }  else 
{ 
obj_t BgL_auxz00_10005;
BgL_auxz00_10005 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33521)), BGl_string3775z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1474z00_1404); 
FAILURE(BgL_auxz00_10005,BFALSE,BFALSE);} 
BgL_auxz00_10001 = 
(long)CINT(BgL_tmpz00_10002); } 
BgL_padz00_1386 = 
VECTOR_REF(BgL_opt1465z00_378,BgL_auxz00_10001); }  else 
{ /* Llib/block_ciphers.scm 922 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_index1475z00_1406;
BgL_index1475z00_1406 = 
BGl_search1467ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1465z00_378), BgL_opt1465z00_378, 
CNST_TABLE_REF(((long)30)), ((long)3)); 
{ /* Llib/block_ciphers.scm 922 */
bool_t BgL_testz00_10014;
{ /* Llib/block_ciphers.scm 922 */
long BgL_n1z00_3653;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_tmpz00_10015;
if(
INTEGERP(BgL_index1475z00_1406))
{ /* Llib/block_ciphers.scm 922 */
BgL_tmpz00_10015 = BgL_index1475z00_1406
; }  else 
{ 
obj_t BgL_auxz00_10018;
BgL_auxz00_10018 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33521)), BGl_string3775z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1475z00_1406); 
FAILURE(BgL_auxz00_10018,BFALSE,BFALSE);} 
BgL_n1z00_3653 = 
(long)CINT(BgL_tmpz00_10015); } 
BgL_testz00_10014 = 
(BgL_n1z00_3653>=((long)0)); } 
if(BgL_testz00_10014)
{ 
long BgL_auxz00_10024;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_tmpz00_10025;
if(
INTEGERP(BgL_index1475z00_1406))
{ /* Llib/block_ciphers.scm 922 */
BgL_tmpz00_10025 = BgL_index1475z00_1406
; }  else 
{ 
obj_t BgL_auxz00_10028;
BgL_auxz00_10028 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33521)), BGl_string3775z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1475z00_1406); 
FAILURE(BgL_auxz00_10028,BFALSE,BFALSE);} 
BgL_auxz00_10024 = 
(long)CINT(BgL_tmpz00_10025); } 
BgL_stringzd2ze3keyz31_1387 = 
VECTOR_REF(BgL_opt1465z00_378,BgL_auxz00_10024); }  else 
{ /* Llib/block_ciphers.scm 922 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_arg2145z00_1408;obj_t BgL_arg2146z00_1409;obj_t BgL_arg2147z00_1410;
BgL_arg2145z00_1408 = 
VECTOR_REF(BgL_opt1465z00_378,((long)0)); 
BgL_arg2146z00_1409 = 
VECTOR_REF(BgL_opt1465z00_378,((long)1)); 
BgL_arg2147z00_1410 = 
VECTOR_REF(BgL_opt1465z00_378,((long)2)); 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_ivz00_1411;
BgL_ivz00_1411 = BgL_ivz00_1382; 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_modez00_1412;
BgL_modez00_1412 = BgL_modez00_1383; 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_noncezd2initz12zc0_1413;
BgL_noncezd2initz12zc0_1413 = BgL_noncezd2initz12zc0_1384; 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_noncezd2updatez12zc0_1414;
BgL_noncezd2updatez12zc0_1414 = BgL_noncezd2updatez12zc0_1385; 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_padz00_1415;
BgL_padz00_1415 = BgL_padz00_1386; 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_stringzd2ze3keyz31_1416;
BgL_stringzd2ze3keyz31_1416 = BgL_stringzd2ze3keyz31_1387; 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_res3002z00_3674;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_cipherz00_3655;obj_t BgL_filenamez00_3656;obj_t BgL_passwordz00_3657;
if(
SYMBOLP(BgL_arg2145z00_1408))
{ /* Llib/block_ciphers.scm 922 */
BgL_cipherz00_3655 = BgL_arg2145z00_1408; }  else 
{ 
obj_t BgL_auxz00_10039;
BgL_auxz00_10039 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33521)), BGl_string3775z00zz__cryptozd2blockzd2ciphersz00, BGl_string3752z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2145z00_1408); 
FAILURE(BgL_auxz00_10039,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg2146z00_1409))
{ /* Llib/block_ciphers.scm 922 */
BgL_filenamez00_3656 = BgL_arg2146z00_1409; }  else 
{ 
obj_t BgL_auxz00_10045;
BgL_auxz00_10045 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33521)), BGl_string3775z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2146z00_1409); 
FAILURE(BgL_auxz00_10045,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg2147z00_1410))
{ /* Llib/block_ciphers.scm 922 */
BgL_passwordz00_3657 = BgL_arg2147z00_1410; }  else 
{ 
obj_t BgL_auxz00_10051;
BgL_auxz00_10051 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33521)), BGl_string3775z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2147z00_1410); 
FAILURE(BgL_auxz00_10051,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 926 */
obj_t BgL_pz00_3658;
{ /* Llib/block_ciphers.scm 926 */

BgL_pz00_3658 = 
BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(BgL_filenamez00_3656, BTRUE, 
BINT(((long)5000000))); } 
if(
CBOOL(BgL_pz00_3658))
{ /* Llib/block_ciphers.scm 927 */BFALSE; }  else 
{ /* Llib/block_ciphers.scm 927 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)42)), BGl_string3764z00zz__cryptozd2blockzd2ciphersz00, BgL_filenamez00_3656); } 
{ /* Llib/block_ciphers.scm 931 */
obj_t BgL_exitd1237z00_3662;
BgL_exitd1237z00_3662 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Llib/block_ciphers.scm 935 */
obj_t BgL_zc3anonymousza32155ze3z83_5047;
BgL_zc3anonymousza32155ze3z83_5047 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32155ze3ze1zz__cryptozd2blockzd2ciphersz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza32155ze3z83_5047, 
(int)(((long)0)), BgL_pz00_3658); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1237z00_3662, BgL_zc3anonymousza32155ze3z83_5047); 
{ /* Llib/block_ciphers.scm 932 */
obj_t BgL_tmp1239z00_3664;
{ /* Llib/block_ciphers.scm 932 */
obj_t BgL_res3001z00_3672;
{ /* Llib/block_ciphers.scm 932 */
obj_t BgL_ciphertextz00_3666;
if(
INPUT_PORTP(BgL_pz00_3658))
{ /* Llib/block_ciphers.scm 932 */
BgL_ciphertextz00_3666 = BgL_pz00_3658; }  else 
{ 
obj_t BgL_auxz00_10070;
BgL_auxz00_10070 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33888)), BGl_string3775z00zz__cryptozd2blockzd2ciphersz00, BGl_string3761z00zz__cryptozd2blockzd2ciphersz00, BgL_pz00_3658); 
FAILURE(BgL_auxz00_10070,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 913 */
obj_t BgL_pz00_3668;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3669;
{ /* Llib/block_ciphers.scm 913 */

{ /* Llib/block_ciphers.scm 913 */

BgL_pz00_3668 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
BgL_statez00_3669 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_3655, BgL_passwordz00_3657, BgL_ivz00_1411, BgL_modez00_1412, BgL_padz00_1415, BgL_noncezd2initz12zc0_1413, BgL_noncezd2updatez12zc0_1414, BgL_stringzd2ze3keyz31_1416); 
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3669, BgL_ciphertextz00_3666, ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_pz00_3668, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00); 
{ /* Llib/block_ciphers.scm 920 */
obj_t BgL_aux3671z00_6041;
BgL_aux3671z00_6041 = 
bgl_close_output_port(BgL_pz00_3668); 
if(
STRINGP(BgL_aux3671z00_6041))
{ /* Llib/block_ciphers.scm 920 */
BgL_res3001z00_3672 = BgL_aux3671z00_6041; }  else 
{ 
obj_t BgL_auxz00_10080;
BgL_auxz00_10080 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33496)), BGl_string3775z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_aux3671z00_6041); 
FAILURE(BgL_auxz00_10080,BFALSE,BFALSE);} } } } 
BgL_tmp1239z00_3664 = BgL_res3001z00_3672; } 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1237z00_3662); 
{ /* Llib/block_ciphers.scm 935 */
obj_t BgL_portz00_3673;
if(
INPUT_PORTP(BgL_pz00_3658))
{ /* Llib/block_ciphers.scm 935 */
BgL_portz00_3673 = BgL_pz00_3658; }  else 
{ 
obj_t BgL_auxz00_10087;
BgL_auxz00_10087 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33984)), BGl_string3775z00zz__cryptozd2blockzd2ciphersz00, BGl_string3761z00zz__cryptozd2blockzd2ciphersz00, BgL_pz00_3658); 
FAILURE(BgL_auxz00_10087,BFALSE,BFALSE);} 
bgl_close_input_port(BgL_portz00_3673); } 
BgL_res3002z00_3674 = BgL_tmp1239z00_3664; } } } } } 
return BgL_res3002z00_3674;} } } } } } } } } } } } } } } } } 
BGL_FUNCTION_END;
}



/* search1467~0 */
obj_t BGl_search1467ze70ze7zz__cryptozd2blockzd2ciphersz00(long BgL_l1466z00_5646, obj_t BgL_opt1465z00_5645, obj_t BgL_k1z00_1376, long BgL_iz00_1377)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 922 */
BGl_search1467ze70ze7zz__cryptozd2blockzd2ciphersz00:
if(
(BgL_iz00_1377==BgL_l1466z00_5646))
{ /* Llib/block_ciphers.scm 922 */
return 
BINT(((long)-1));}  else 
{ /* Llib/block_ciphers.scm 922 */
if(
(BgL_iz00_1377==
(BgL_l1466z00_5646-((long)1))))
{ /* Llib/block_ciphers.scm 922 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)41)), BGl_string3754z00zz__cryptozd2blockzd2ciphersz00, 
BINT(
VECTOR_LENGTH(BgL_opt1465z00_5645)));}  else 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_vz00_1421;
BgL_vz00_1421 = 
VECTOR_REF(BgL_opt1465z00_5645,BgL_iz00_1377); 
if(
(BgL_vz00_1421==BgL_k1z00_1376))
{ /* Llib/block_ciphers.scm 922 */
return 
BINT(
(BgL_iz00_1377+((long)1)));}  else 
{ 
long BgL_iz00_10107;
BgL_iz00_10107 = 
(BgL_iz00_1377+((long)2)); 
BgL_iz00_1377 = BgL_iz00_10107; 
goto BGl_search1467ze70ze7zz__cryptozd2blockzd2ciphersz00;} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2155> */
obj_t BGl_z62zc3anonymousza32155ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5048)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 931 */
{ /* Llib/block_ciphers.scm 935 */
obj_t BgL_pz00_5049;
BgL_pz00_5049 = 
PROCEDURE_REF(BgL_envz00_5048, 
(int)(((long)0))); 
return 
bgl_close_input_port(
((obj_t)BgL_pz00_5049));} } 
BGL_FUNCTION_END;
}



/* decrypt-file */
BGL_EXPORTED_DEF obj_t BGl_decryptzd2filezd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_369, obj_t BgL_filenamez00_370, obj_t BgL_passwordz00_371, obj_t BgL_ivz00_372, obj_t BgL_modez00_373, obj_t BgL_noncezd2initz12zc0_374, obj_t BgL_noncezd2updatez12zc0_375, obj_t BgL_padz00_376, obj_t BgL_stringzd2ze3keyz31_377)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 922 */
{ /* Llib/block_ciphers.scm 926 */
obj_t BgL_pz00_3675;
{ /* Llib/block_ciphers.scm 926 */

BgL_pz00_3675 = 
BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(BgL_filenamez00_370, BTRUE, 
BINT(((long)5000000))); } 
if(
CBOOL(BgL_pz00_3675))
{ /* Llib/block_ciphers.scm 927 */BFALSE; }  else 
{ /* Llib/block_ciphers.scm 927 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)42)), BGl_string3764z00zz__cryptozd2blockzd2ciphersz00, BgL_filenamez00_370); } 
{ /* Llib/block_ciphers.scm 931 */
obj_t BgL_exitd1237z00_3679;
BgL_exitd1237z00_3679 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Llib/block_ciphers.scm 935 */
obj_t BgL_zc3anonymousza32155ze3z83_5050;
BgL_zc3anonymousza32155ze3z83_5050 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32155ze33300ze1zz__cryptozd2blockzd2ciphersz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza32155ze3z83_5050, 
(int)(((long)0)), BgL_pz00_3675); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1237z00_3679, BgL_zc3anonymousza32155ze3z83_5050); 
{ /* Llib/block_ciphers.scm 932 */
obj_t BgL_tmp1239z00_3681;
{ /* Llib/block_ciphers.scm 932 */
obj_t BgL_res3003z00_3689;
{ /* Llib/block_ciphers.scm 913 */
obj_t BgL_pz00_3685;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3686;
{ /* Llib/block_ciphers.scm 913 */

{ /* Llib/block_ciphers.scm 913 */

BgL_pz00_3685 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
BgL_statez00_3686 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_369, BgL_passwordz00_371, BgL_ivz00_372, BgL_modez00_373, BgL_padz00_376, BgL_noncezd2initz12zc0_374, BgL_noncezd2updatez12zc0_375, BgL_stringzd2ze3keyz31_377); 
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3686, 
((obj_t)BgL_pz00_3675), ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_pz00_3685, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00); 
BgL_res3003z00_3689 = 
bgl_close_output_port(BgL_pz00_3685); } 
BgL_tmp1239z00_3681 = BgL_res3003z00_3689; } 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1237z00_3679); 
bgl_close_input_port(
((obj_t)BgL_pz00_3675)); 
return BgL_tmp1239z00_3681;} } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2155>3300 */
obj_t BGl_z62zc3anonymousza32155ze33300ze1zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5051)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 931 */
{ /* Llib/block_ciphers.scm 935 */
obj_t BgL_pz00_5052;
BgL_pz00_5052 = 
PROCEDURE_REF(BgL_envz00_5051, 
(int)(((long)0))); 
return 
bgl_close_input_port(
((obj_t)BgL_pz00_5052));} } 
BGL_FUNCTION_END;
}



/* _decrypt-sendchars */
obj_t BGl__decryptzd2sendcharszd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_391, obj_t BgL_opt1476z00_390)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 937 */
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_cipherz00_1438;obj_t BgL_inz00_1439;obj_t BgL_outz00_1440;obj_t BgL_passwordz00_1441;
BgL_cipherz00_1438 = 
VECTOR_REF(BgL_opt1476z00_390,((long)0)); 
BgL_inz00_1439 = 
VECTOR_REF(BgL_opt1476z00_390,((long)1)); 
BgL_outz00_1440 = 
VECTOR_REF(BgL_opt1476z00_390,((long)2)); 
BgL_passwordz00_1441 = 
VECTOR_REF(BgL_opt1476z00_390,((long)3)); 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_ivz00_1442;
BgL_ivz00_1442 = BFALSE; 
{ /* Llib/block_ciphers.scm 939 */
obj_t BgL_modez00_1443;
BgL_modez00_1443 = 
CNST_TABLE_REF(((long)10)); 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_noncezd2initz12zc0_1444;
BgL_noncezd2initz12zc0_1444 = BFALSE; 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_noncezd2updatez12zc0_1445;
BgL_noncezd2updatez12zc0_1445 = BFALSE; 
{ /* Llib/block_ciphers.scm 939 */
obj_t BgL_padz00_1446;
BgL_padz00_1446 = 
CNST_TABLE_REF(((long)16)); 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_stringzd2ze3keyz31_1447;
BgL_stringzd2ze3keyz31_1447 = BFALSE; 
{ /* Llib/block_ciphers.scm 937 */

{ 
long BgL_iz00_1448;
BgL_iz00_1448 = ((long)4); 
BgL_check1479z00_1449:
if(
(BgL_iz00_1448==
VECTOR_LENGTH(BgL_opt1476z00_390)))
{ /* Llib/block_ciphers.scm 937 */BNIL; }  else 
{ /* Llib/block_ciphers.scm 937 */
bool_t BgL_testz00_10147;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_arg2161z00_1455;
BgL_arg2161z00_1455 = 
VECTOR_REF(BgL_opt1476z00_390,BgL_iz00_1448); 
BgL_testz00_10147 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg2161z00_1455, 
CNST_TABLE_REF(((long)23)))); } 
if(BgL_testz00_10147)
{ 
long BgL_iz00_10152;
BgL_iz00_10152 = 
(BgL_iz00_1448+((long)2)); 
BgL_iz00_1448 = BgL_iz00_10152; 
goto BgL_check1479z00_1449;}  else 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_arg2160z00_1454;
BgL_arg2160z00_1454 = 
VECTOR_REF(BgL_opt1476z00_390,BgL_iz00_1448); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)43)), BGl_string3749z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2160z00_1454); } } } 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_index1481z00_1456;
BgL_index1481z00_1456 = 
BGl_search1478ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1476z00_390), BgL_opt1476z00_390, 
CNST_TABLE_REF(((long)25)), ((long)4)); 
{ /* Llib/block_ciphers.scm 937 */
bool_t BgL_testz00_10160;
{ /* Llib/block_ciphers.scm 937 */
long BgL_n1z00_3713;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_tmpz00_10161;
if(
INTEGERP(BgL_index1481z00_1456))
{ /* Llib/block_ciphers.scm 937 */
BgL_tmpz00_10161 = BgL_index1481z00_1456
; }  else 
{ 
obj_t BgL_auxz00_10164;
BgL_auxz00_10164 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33991)), BGl_string3776z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1481z00_1456); 
FAILURE(BgL_auxz00_10164,BFALSE,BFALSE);} 
BgL_n1z00_3713 = 
(long)CINT(BgL_tmpz00_10161); } 
BgL_testz00_10160 = 
(BgL_n1z00_3713>=((long)0)); } 
if(BgL_testz00_10160)
{ 
long BgL_auxz00_10170;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_tmpz00_10171;
if(
INTEGERP(BgL_index1481z00_1456))
{ /* Llib/block_ciphers.scm 937 */
BgL_tmpz00_10171 = BgL_index1481z00_1456
; }  else 
{ 
obj_t BgL_auxz00_10174;
BgL_auxz00_10174 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33991)), BGl_string3776z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1481z00_1456); 
FAILURE(BgL_auxz00_10174,BFALSE,BFALSE);} 
BgL_auxz00_10170 = 
(long)CINT(BgL_tmpz00_10171); } 
BgL_ivz00_1442 = 
VECTOR_REF(BgL_opt1476z00_390,BgL_auxz00_10170); }  else 
{ /* Llib/block_ciphers.scm 937 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_index1482z00_1458;
BgL_index1482z00_1458 = 
BGl_search1478ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1476z00_390), BgL_opt1476z00_390, 
CNST_TABLE_REF(((long)26)), ((long)4)); 
{ /* Llib/block_ciphers.scm 937 */
bool_t BgL_testz00_10183;
{ /* Llib/block_ciphers.scm 937 */
long BgL_n1z00_3715;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_tmpz00_10184;
if(
INTEGERP(BgL_index1482z00_1458))
{ /* Llib/block_ciphers.scm 937 */
BgL_tmpz00_10184 = BgL_index1482z00_1458
; }  else 
{ 
obj_t BgL_auxz00_10187;
BgL_auxz00_10187 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33991)), BGl_string3776z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1482z00_1458); 
FAILURE(BgL_auxz00_10187,BFALSE,BFALSE);} 
BgL_n1z00_3715 = 
(long)CINT(BgL_tmpz00_10184); } 
BgL_testz00_10183 = 
(BgL_n1z00_3715>=((long)0)); } 
if(BgL_testz00_10183)
{ 
long BgL_auxz00_10193;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_tmpz00_10194;
if(
INTEGERP(BgL_index1482z00_1458))
{ /* Llib/block_ciphers.scm 937 */
BgL_tmpz00_10194 = BgL_index1482z00_1458
; }  else 
{ 
obj_t BgL_auxz00_10197;
BgL_auxz00_10197 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33991)), BGl_string3776z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1482z00_1458); 
FAILURE(BgL_auxz00_10197,BFALSE,BFALSE);} 
BgL_auxz00_10193 = 
(long)CINT(BgL_tmpz00_10194); } 
BgL_modez00_1443 = 
VECTOR_REF(BgL_opt1476z00_390,BgL_auxz00_10193); }  else 
{ /* Llib/block_ciphers.scm 937 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_index1483z00_1460;
BgL_index1483z00_1460 = 
BGl_search1478ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1476z00_390), BgL_opt1476z00_390, 
CNST_TABLE_REF(((long)27)), ((long)4)); 
{ /* Llib/block_ciphers.scm 937 */
bool_t BgL_testz00_10206;
{ /* Llib/block_ciphers.scm 937 */
long BgL_n1z00_3717;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_tmpz00_10207;
if(
INTEGERP(BgL_index1483z00_1460))
{ /* Llib/block_ciphers.scm 937 */
BgL_tmpz00_10207 = BgL_index1483z00_1460
; }  else 
{ 
obj_t BgL_auxz00_10210;
BgL_auxz00_10210 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33991)), BGl_string3776z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1483z00_1460); 
FAILURE(BgL_auxz00_10210,BFALSE,BFALSE);} 
BgL_n1z00_3717 = 
(long)CINT(BgL_tmpz00_10207); } 
BgL_testz00_10206 = 
(BgL_n1z00_3717>=((long)0)); } 
if(BgL_testz00_10206)
{ 
long BgL_auxz00_10216;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_tmpz00_10217;
if(
INTEGERP(BgL_index1483z00_1460))
{ /* Llib/block_ciphers.scm 937 */
BgL_tmpz00_10217 = BgL_index1483z00_1460
; }  else 
{ 
obj_t BgL_auxz00_10220;
BgL_auxz00_10220 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33991)), BGl_string3776z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1483z00_1460); 
FAILURE(BgL_auxz00_10220,BFALSE,BFALSE);} 
BgL_auxz00_10216 = 
(long)CINT(BgL_tmpz00_10217); } 
BgL_noncezd2initz12zc0_1444 = 
VECTOR_REF(BgL_opt1476z00_390,BgL_auxz00_10216); }  else 
{ /* Llib/block_ciphers.scm 937 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_index1484z00_1462;
BgL_index1484z00_1462 = 
BGl_search1478ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1476z00_390), BgL_opt1476z00_390, 
CNST_TABLE_REF(((long)28)), ((long)4)); 
{ /* Llib/block_ciphers.scm 937 */
bool_t BgL_testz00_10229;
{ /* Llib/block_ciphers.scm 937 */
long BgL_n1z00_3719;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_tmpz00_10230;
if(
INTEGERP(BgL_index1484z00_1462))
{ /* Llib/block_ciphers.scm 937 */
BgL_tmpz00_10230 = BgL_index1484z00_1462
; }  else 
{ 
obj_t BgL_auxz00_10233;
BgL_auxz00_10233 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33991)), BGl_string3776z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1484z00_1462); 
FAILURE(BgL_auxz00_10233,BFALSE,BFALSE);} 
BgL_n1z00_3719 = 
(long)CINT(BgL_tmpz00_10230); } 
BgL_testz00_10229 = 
(BgL_n1z00_3719>=((long)0)); } 
if(BgL_testz00_10229)
{ 
long BgL_auxz00_10239;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_tmpz00_10240;
if(
INTEGERP(BgL_index1484z00_1462))
{ /* Llib/block_ciphers.scm 937 */
BgL_tmpz00_10240 = BgL_index1484z00_1462
; }  else 
{ 
obj_t BgL_auxz00_10243;
BgL_auxz00_10243 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33991)), BGl_string3776z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1484z00_1462); 
FAILURE(BgL_auxz00_10243,BFALSE,BFALSE);} 
BgL_auxz00_10239 = 
(long)CINT(BgL_tmpz00_10240); } 
BgL_noncezd2updatez12zc0_1445 = 
VECTOR_REF(BgL_opt1476z00_390,BgL_auxz00_10239); }  else 
{ /* Llib/block_ciphers.scm 937 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_index1485z00_1464;
BgL_index1485z00_1464 = 
BGl_search1478ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1476z00_390), BgL_opt1476z00_390, 
CNST_TABLE_REF(((long)29)), ((long)4)); 
{ /* Llib/block_ciphers.scm 937 */
bool_t BgL_testz00_10252;
{ /* Llib/block_ciphers.scm 937 */
long BgL_n1z00_3721;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_tmpz00_10253;
if(
INTEGERP(BgL_index1485z00_1464))
{ /* Llib/block_ciphers.scm 937 */
BgL_tmpz00_10253 = BgL_index1485z00_1464
; }  else 
{ 
obj_t BgL_auxz00_10256;
BgL_auxz00_10256 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33991)), BGl_string3776z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1485z00_1464); 
FAILURE(BgL_auxz00_10256,BFALSE,BFALSE);} 
BgL_n1z00_3721 = 
(long)CINT(BgL_tmpz00_10253); } 
BgL_testz00_10252 = 
(BgL_n1z00_3721>=((long)0)); } 
if(BgL_testz00_10252)
{ 
long BgL_auxz00_10262;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_tmpz00_10263;
if(
INTEGERP(BgL_index1485z00_1464))
{ /* Llib/block_ciphers.scm 937 */
BgL_tmpz00_10263 = BgL_index1485z00_1464
; }  else 
{ 
obj_t BgL_auxz00_10266;
BgL_auxz00_10266 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33991)), BGl_string3776z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1485z00_1464); 
FAILURE(BgL_auxz00_10266,BFALSE,BFALSE);} 
BgL_auxz00_10262 = 
(long)CINT(BgL_tmpz00_10263); } 
BgL_padz00_1446 = 
VECTOR_REF(BgL_opt1476z00_390,BgL_auxz00_10262); }  else 
{ /* Llib/block_ciphers.scm 937 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_index1486z00_1466;
BgL_index1486z00_1466 = 
BGl_search1478ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1476z00_390), BgL_opt1476z00_390, 
CNST_TABLE_REF(((long)30)), ((long)4)); 
{ /* Llib/block_ciphers.scm 937 */
bool_t BgL_testz00_10275;
{ /* Llib/block_ciphers.scm 937 */
long BgL_n1z00_3723;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_tmpz00_10276;
if(
INTEGERP(BgL_index1486z00_1466))
{ /* Llib/block_ciphers.scm 937 */
BgL_tmpz00_10276 = BgL_index1486z00_1466
; }  else 
{ 
obj_t BgL_auxz00_10279;
BgL_auxz00_10279 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33991)), BGl_string3776z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1486z00_1466); 
FAILURE(BgL_auxz00_10279,BFALSE,BFALSE);} 
BgL_n1z00_3723 = 
(long)CINT(BgL_tmpz00_10276); } 
BgL_testz00_10275 = 
(BgL_n1z00_3723>=((long)0)); } 
if(BgL_testz00_10275)
{ 
long BgL_auxz00_10285;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_tmpz00_10286;
if(
INTEGERP(BgL_index1486z00_1466))
{ /* Llib/block_ciphers.scm 937 */
BgL_tmpz00_10286 = BgL_index1486z00_1466
; }  else 
{ 
obj_t BgL_auxz00_10289;
BgL_auxz00_10289 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33991)), BGl_string3776z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_index1486z00_1466); 
FAILURE(BgL_auxz00_10289,BFALSE,BFALSE);} 
BgL_auxz00_10285 = 
(long)CINT(BgL_tmpz00_10286); } 
BgL_stringzd2ze3keyz31_1447 = 
VECTOR_REF(BgL_opt1476z00_390,BgL_auxz00_10285); }  else 
{ /* Llib/block_ciphers.scm 937 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_arg2168z00_1468;obj_t BgL_arg2169z00_1469;obj_t BgL_arg2170z00_1470;obj_t BgL_arg2171z00_1471;
BgL_arg2168z00_1468 = 
VECTOR_REF(BgL_opt1476z00_390,((long)0)); 
BgL_arg2169z00_1469 = 
VECTOR_REF(BgL_opt1476z00_390,((long)1)); 
BgL_arg2170z00_1470 = 
VECTOR_REF(BgL_opt1476z00_390,((long)2)); 
BgL_arg2171z00_1471 = 
VECTOR_REF(BgL_opt1476z00_390,((long)3)); 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_ivz00_1472;
BgL_ivz00_1472 = BgL_ivz00_1442; 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_modez00_1473;
BgL_modez00_1473 = BgL_modez00_1443; 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_noncezd2initz12zc0_1474;
BgL_noncezd2initz12zc0_1474 = BgL_noncezd2initz12zc0_1444; 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_noncezd2updatez12zc0_1475;
BgL_noncezd2updatez12zc0_1475 = BgL_noncezd2updatez12zc0_1445; 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_padz00_1476;
BgL_padz00_1476 = BgL_padz00_1446; 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_stringzd2ze3keyz31_1477;
BgL_stringzd2ze3keyz31_1477 = BgL_stringzd2ze3keyz31_1447; 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_cipherz00_3725;obj_t BgL_inz00_3726;obj_t BgL_outz00_3727;obj_t BgL_passwordz00_3728;
if(
SYMBOLP(BgL_arg2168z00_1468))
{ /* Llib/block_ciphers.scm 937 */
BgL_cipherz00_3725 = BgL_arg2168z00_1468; }  else 
{ 
obj_t BgL_auxz00_10301;
BgL_auxz00_10301 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33991)), BGl_string3776z00zz__cryptozd2blockzd2ciphersz00, BGl_string3752z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2168z00_1468); 
FAILURE(BgL_auxz00_10301,BFALSE,BFALSE);} 
if(
INPUT_PORTP(BgL_arg2169z00_1469))
{ /* Llib/block_ciphers.scm 937 */
BgL_inz00_3726 = BgL_arg2169z00_1469; }  else 
{ 
obj_t BgL_auxz00_10307;
BgL_auxz00_10307 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33991)), BGl_string3776z00zz__cryptozd2blockzd2ciphersz00, BGl_string3761z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2169z00_1469); 
FAILURE(BgL_auxz00_10307,BFALSE,BFALSE);} 
if(
OUTPUT_PORTP(BgL_arg2170z00_1470))
{ /* Llib/block_ciphers.scm 937 */
BgL_outz00_3727 = BgL_arg2170z00_1470; }  else 
{ 
obj_t BgL_auxz00_10313;
BgL_auxz00_10313 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33991)), BGl_string3776z00zz__cryptozd2blockzd2ciphersz00, BGl_string3766z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2170z00_1470); 
FAILURE(BgL_auxz00_10313,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg2171z00_1471))
{ /* Llib/block_ciphers.scm 937 */
BgL_passwordz00_3728 = BgL_arg2171z00_1471; }  else 
{ 
obj_t BgL_auxz00_10319;
BgL_auxz00_10319 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33991)), BGl_string3776z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2171z00_1471); 
FAILURE(BgL_auxz00_10319,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 941 */
BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3729;
BgL_statez00_3729 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_3725, BgL_passwordz00_3728, BgL_ivz00_1472, BgL_modez00_1473, BgL_padz00_1476, BgL_noncezd2initz12zc0_1474, BgL_noncezd2updatez12zc0_1475, BgL_stringzd2ze3keyz31_1477); 
return 
BINT(
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3729, BgL_inz00_3726, ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_outz00_3727, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00));} } } } } } } } } } } } } } } } } } 
BGL_FUNCTION_END;
}



/* search1478~0 */
obj_t BGl_search1478ze70ze7zz__cryptozd2blockzd2ciphersz00(long BgL_l1477z00_5644, obj_t BgL_opt1476z00_5643, obj_t BgL_k1z00_1435, long BgL_iz00_1436)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 937 */
BGl_search1478ze70ze7zz__cryptozd2blockzd2ciphersz00:
if(
(BgL_iz00_1436==BgL_l1477z00_5644))
{ /* Llib/block_ciphers.scm 937 */
return 
BINT(((long)-1));}  else 
{ /* Llib/block_ciphers.scm 937 */
if(
(BgL_iz00_1436==
(BgL_l1477z00_5644-((long)1))))
{ /* Llib/block_ciphers.scm 937 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)43)), BGl_string3767z00zz__cryptozd2blockzd2ciphersz00, 
BINT(
VECTOR_LENGTH(BgL_opt1476z00_5643)));}  else 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_vz00_1482;
BgL_vz00_1482 = 
VECTOR_REF(BgL_opt1476z00_5643,BgL_iz00_1436); 
if(
(BgL_vz00_1482==BgL_k1z00_1435))
{ /* Llib/block_ciphers.scm 937 */
return 
BINT(
(BgL_iz00_1436+((long)1)));}  else 
{ 
long BgL_iz00_10341;
BgL_iz00_10341 = 
(BgL_iz00_1436+((long)2)); 
BgL_iz00_1436 = BgL_iz00_10341; 
goto BGl_search1478ze70ze7zz__cryptozd2blockzd2ciphersz00;} } } } 
BGL_FUNCTION_END;
}



/* decrypt-sendchars */
BGL_EXPORTED_DEF obj_t BGl_decryptzd2sendcharszd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_380, obj_t BgL_inz00_381, obj_t BgL_outz00_382, obj_t BgL_passwordz00_383, obj_t BgL_ivz00_384, obj_t BgL_modez00_385, obj_t BgL_noncezd2initz12zc0_386, obj_t BgL_noncezd2updatez12zc0_387, obj_t BgL_padz00_388, obj_t BgL_stringzd2ze3keyz31_389)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 937 */
{ /* Llib/block_ciphers.scm 941 */
BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3730;
BgL_statez00_3730 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_380, BgL_passwordz00_383, BgL_ivz00_384, BgL_modez00_385, BgL_padz00_388, BgL_noncezd2initz12zc0_386, BgL_noncezd2updatez12zc0_387, BgL_stringzd2ze3keyz31_389); 
return 
BINT(
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3730, BgL_inz00_381, ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_outz00_382, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00));} } 
BGL_FUNCTION_END;
}



/* register-cipher! */
BGL_EXPORTED_DEF obj_t BGl_registerzd2cipherz12zc0zz__cryptozd2blockzd2ciphersz00(obj_t BgL_lookupzd2namezd2_392, BgL_blockzd2cipherzd2_bglt BgL_descz00_393)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 952 */
{ /* Llib/block_ciphers.scm 953 */
obj_t BgL_arg2179z00_3731;
BgL_arg2179z00_3731 = 
MAKE_YOUNG_PAIR(BgL_lookupzd2namezd2_392, 
((obj_t)BgL_descz00_393)); 
return ( 
BGl_za2ciphersza2z00zz__cryptozd2blockzd2ciphersz00 = 
MAKE_YOUNG_PAIR(BgL_arg2179z00_3731, BGl_za2ciphersza2z00zz__cryptozd2blockzd2ciphersz00), BUNSPEC) ;} } 
BGL_FUNCTION_END;
}



/* &register-cipher! */
obj_t BGl_z62registerzd2cipherz12za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5053, obj_t BgL_lookupzd2namezd2_5054, obj_t BgL_descz00_5055)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 952 */
{ /* Llib/block_ciphers.scm 953 */
BgL_blockzd2cipherzd2_bglt BgL_auxz00_10356;obj_t BgL_auxz00_10349;
if(
BGl_isazf3zf3zz__objectz00(BgL_descz00_5055, BGl_Blockzd2Cipherzd2zz__cryptozd2blockzd2ciphersz00))
{ /* Llib/block_ciphers.scm 953 */
BgL_auxz00_10356 = 
((BgL_blockzd2cipherzd2_bglt)BgL_descz00_5055)
; }  else 
{ 
obj_t BgL_auxz00_10360;
BgL_auxz00_10360 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)34555)), BGl_string3777z00zz__cryptozd2blockzd2ciphersz00, BGl_string3778z00zz__cryptozd2blockzd2ciphersz00, BgL_descz00_5055); 
FAILURE(BgL_auxz00_10360,BFALSE,BFALSE);} 
if(
SYMBOLP(BgL_lookupzd2namezd2_5054))
{ /* Llib/block_ciphers.scm 953 */
BgL_auxz00_10349 = BgL_lookupzd2namezd2_5054
; }  else 
{ 
obj_t BgL_auxz00_10352;
BgL_auxz00_10352 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)34555)), BGl_string3777z00zz__cryptozd2blockzd2ciphersz00, BGl_string3752z00zz__cryptozd2blockzd2ciphersz00, BgL_lookupzd2namezd2_5054); 
FAILURE(BgL_auxz00_10352,BFALSE,BFALSE);} 
return 
BGl_registerzd2cipherz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_auxz00_10349, BgL_auxz00_10356);} } 
BGL_FUNCTION_END;
}



/* block-cipher-description */
BGL_EXPORTED_DEF BgL_blockzd2cipherzd2_bglt BGl_blockzd2cipherzd2descriptionz00zz__cryptozd2blockzd2ciphersz00(obj_t BgL_lookupzd2namezd2_394)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 955 */
{ /* Llib/block_ciphers.scm 956 */
obj_t BgL_desczd2pzd2_1488;
BgL_desczd2pzd2_1488 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_lookupzd2namezd2_394, BGl_za2ciphersza2z00zz__cryptozd2blockzd2ciphersz00); 
if(
CBOOL(BgL_desczd2pzd2_1488))
{ /* Llib/block_ciphers.scm 957 */BFALSE; }  else 
{ /* Llib/block_ciphers.scm 957 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)44)), BGl_string3779z00zz__cryptozd2blockzd2ciphersz00, BgL_lookupzd2namezd2_394); } 
return 
((BgL_blockzd2cipherzd2_bglt)
CDR(
((obj_t)BgL_desczd2pzd2_1488)));} } 
BGL_FUNCTION_END;
}



/* &block-cipher-description */
BgL_blockzd2cipherzd2_bglt BGl_z62blockzd2cipherzd2descriptionz62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5056, obj_t BgL_lookupzd2namezd2_5057)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 955 */
{ /* Llib/block_ciphers.scm 956 */
obj_t BgL_auxz00_10373;
if(
SYMBOLP(BgL_lookupzd2namezd2_5057))
{ /* Llib/block_ciphers.scm 956 */
BgL_auxz00_10373 = BgL_lookupzd2namezd2_5057
; }  else 
{ 
obj_t BgL_auxz00_10376;
BgL_auxz00_10376 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)34687)), BGl_string3780z00zz__cryptozd2blockzd2ciphersz00, BGl_string3752z00zz__cryptozd2blockzd2ciphersz00, BgL_lookupzd2namezd2_5057); 
FAILURE(BgL_auxz00_10376,BFALSE,BFALSE);} 
return 
BGl_blockzd2cipherzd2descriptionz00zz__cryptozd2blockzd2ciphersz00(BgL_auxz00_10373);} } 
BGL_FUNCTION_END;
}



/* object-init */
obj_t BGl_objectzd2initzd2zz__cryptozd2blockzd2ciphersz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 1 */
{ /* Llib/block_ciphers.scm 6 */
obj_t BgL_arg2183z00_1492;obj_t BgL_arg2184z00_1493;
{ /* Llib/block_ciphers.scm 6 */
obj_t BgL_v1277z00_1510;
BgL_v1277z00_1510 = 
create_vector(((long)7)); 
{ /* Llib/block_ciphers.scm 6 */
obj_t BgL_arg2190z00_1511;
BgL_arg2190z00_1511 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)45)), BGl_proc3782z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3781z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)46))); 
VECTOR_SET(BgL_v1277z00_1510,((long)0),BgL_arg2190z00_1511); } 
{ /* Llib/block_ciphers.scm 6 */
obj_t BgL_arg2195z00_1521;
BgL_arg2195z00_1521 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)47)), BGl_proc3784z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3783z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)48))); 
VECTOR_SET(BgL_v1277z00_1510,((long)1),BgL_arg2195z00_1521); } 
{ /* Llib/block_ciphers.scm 6 */
obj_t BgL_arg2200z00_1531;
BgL_arg2200z00_1531 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)49)), BGl_proc3786z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3785z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)48))); 
VECTOR_SET(BgL_v1277z00_1510,((long)2),BgL_arg2200z00_1531); } 
{ /* Llib/block_ciphers.scm 6 */
obj_t BgL_arg2205z00_1541;
BgL_arg2205z00_1541 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)50)), BGl_proc3788z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3787z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)51))); 
VECTOR_SET(BgL_v1277z00_1510,((long)3),BgL_arg2205z00_1541); } 
{ /* Llib/block_ciphers.scm 6 */
obj_t BgL_arg2210z00_1551;
BgL_arg2210z00_1551 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)52)), BGl_proc3790z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3789z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)51))); 
VECTOR_SET(BgL_v1277z00_1510,((long)4),BgL_arg2210z00_1551); } 
{ /* Llib/block_ciphers.scm 6 */
obj_t BgL_arg2215z00_1561;
BgL_arg2215z00_1561 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)53)), BGl_proc3792z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3791z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)51))); 
VECTOR_SET(BgL_v1277z00_1510,((long)5),BgL_arg2215z00_1561); } 
{ /* Llib/block_ciphers.scm 6 */
obj_t BgL_arg2220z00_1571;
BgL_arg2220z00_1571 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)54)), BGl_proc3794z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3793z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)51))); 
VECTOR_SET(BgL_v1277z00_1510,((long)6),BgL_arg2220z00_1571); } 
BgL_arg2183z00_1492 = BgL_v1277z00_1510; } 
{ /* Llib/block_ciphers.scm 6 */
obj_t BgL_v1278z00_1581;
BgL_v1278z00_1581 = 
create_vector(((long)0)); 
BgL_arg2184z00_1493 = BgL_v1278z00_1581; } 
BGl_Blockzd2Cipherzd2zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)55)), 
CNST_TABLE_REF(((long)56)), BGl_objectz00zz__objectz00, ((long)63399), BGl_proc3797z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3796z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3795z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2183z00_1492, BgL_arg2184z00_1493); } 
{ /* Llib/block_ciphers.scm 77 */
obj_t BgL_arg2227z00_1587;obj_t BgL_arg2228z00_1588;
{ /* Llib/block_ciphers.scm 77 */
obj_t BgL_v1279z00_1594;
BgL_v1279z00_1594 = 
create_vector(((long)3)); 
{ /* Llib/block_ciphers.scm 77 */
obj_t BgL_arg2232z00_1595;
BgL_arg2232z00_1595 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)47)), BGl_proc3799z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3798z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)48))); 
VECTOR_SET(BgL_v1279z00_1594,((long)0),BgL_arg2232z00_1595); } 
{ /* Llib/block_ciphers.scm 77 */
obj_t BgL_arg2237z00_1605;
BgL_arg2237z00_1605 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)57)), BGl_proc3801z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3800z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)51))); 
VECTOR_SET(BgL_v1279z00_1594,((long)1),BgL_arg2237z00_1605); } 
{ /* Llib/block_ciphers.scm 77 */
obj_t BgL_arg2242z00_1615;
BgL_arg2242z00_1615 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)58)), BGl_proc3803z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3802z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)59))); 
VECTOR_SET(BgL_v1279z00_1594,((long)2),BgL_arg2242z00_1615); } 
BgL_arg2227z00_1587 = BgL_v1279z00_1594; } 
{ /* Llib/block_ciphers.scm 77 */
obj_t BgL_v1280z00_1625;
BgL_v1280z00_1625 = 
create_vector(((long)0)); 
BgL_arg2228z00_1588 = BgL_v1280z00_1625; } 
BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)60)), 
CNST_TABLE_REF(((long)56)), BGl_objectz00zz__objectz00, ((long)46511), BFALSE, BGl_proc3805z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3804z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2227z00_1587, BgL_arg2228z00_1588); } 
{ /* Llib/block_ciphers.scm 81 */
obj_t BgL_arg2250z00_1631;obj_t BgL_arg2251z00_1632;
{ /* Llib/block_ciphers.scm 81 */
obj_t BgL_v1281z00_1645;
BgL_v1281z00_1645 = 
create_vector(((long)0)); 
BgL_arg2250z00_1631 = BgL_v1281z00_1645; } 
{ /* Llib/block_ciphers.scm 81 */
obj_t BgL_v1282z00_1646;
BgL_v1282z00_1646 = 
create_vector(((long)0)); 
BgL_arg2251z00_1632 = BgL_v1282z00_1646; } 
BGl_ECBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)61)), 
CNST_TABLE_REF(((long)56)), BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00, ((long)15877), BGl_proc3808z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3807z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3806z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2250z00_1631, BgL_arg2251z00_1632); } 
{ /* Llib/block_ciphers.scm 82 */
obj_t BgL_arg2260z00_1653;obj_t BgL_arg2261z00_1654;
{ /* Llib/block_ciphers.scm 82 */
obj_t BgL_v1283z00_1667;
BgL_v1283z00_1667 = 
create_vector(((long)0)); 
BgL_arg2260z00_1653 = BgL_v1283z00_1667; } 
{ /* Llib/block_ciphers.scm 82 */
obj_t BgL_v1284z00_1668;
BgL_v1284z00_1668 = 
create_vector(((long)0)); 
BgL_arg2261z00_1654 = BgL_v1284z00_1668; } 
BGl_ECBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)62)), 
CNST_TABLE_REF(((long)56)), BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00, ((long)55855), BGl_proc3811z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3810z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3809z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2260z00_1653, BgL_arg2261z00_1654); } 
{ /* Llib/block_ciphers.scm 83 */
obj_t BgL_arg2270z00_1675;obj_t BgL_arg2271z00_1676;
{ /* Llib/block_ciphers.scm 83 */
obj_t BgL_v1285z00_1691;
BgL_v1285z00_1691 = 
create_vector(((long)2)); 
{ /* Llib/block_ciphers.scm 83 */
obj_t BgL_arg2277z00_1692;
BgL_arg2277z00_1692 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)63)), BGl_proc3813z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3812z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)46))); 
VECTOR_SET(BgL_v1285z00_1691,((long)0),BgL_arg2277z00_1692); } 
{ /* Llib/block_ciphers.scm 83 */
obj_t BgL_arg2282z00_1702;
BgL_arg2282z00_1702 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)64)), BGl_proc3815z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3814z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)46))); 
VECTOR_SET(BgL_v1285z00_1691,((long)1),BgL_arg2282z00_1702); } 
BgL_arg2270z00_1675 = BgL_v1285z00_1691; } 
{ /* Llib/block_ciphers.scm 83 */
obj_t BgL_v1286z00_1712;
BgL_v1286z00_1712 = 
create_vector(((long)0)); 
BgL_arg2271z00_1676 = BgL_v1286z00_1712; } 
BGl_CBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)65)), 
CNST_TABLE_REF(((long)56)), BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00, ((long)16316), BGl_proc3818z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3817z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3816z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2270z00_1675, BgL_arg2271z00_1676); } 
{ /* Llib/block_ciphers.scm 86 */
obj_t BgL_arg2290z00_1719;obj_t BgL_arg2291z00_1720;
{ /* Llib/block_ciphers.scm 86 */
obj_t BgL_v1287z00_1735;
BgL_v1287z00_1735 = 
create_vector(((long)2)); 
{ /* Llib/block_ciphers.scm 86 */
obj_t BgL_arg2297z00_1736;
BgL_arg2297z00_1736 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)63)), BGl_proc3820z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3819z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)46))); 
VECTOR_SET(BgL_v1287z00_1735,((long)0),BgL_arg2297z00_1736); } 
{ /* Llib/block_ciphers.scm 86 */
obj_t BgL_arg2302z00_1746;
BgL_arg2302z00_1746 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)64)), BGl_proc3822z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3821z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)46))); 
VECTOR_SET(BgL_v1287z00_1735,((long)1),BgL_arg2302z00_1746); } 
BgL_arg2290z00_1719 = BgL_v1287z00_1735; } 
{ /* Llib/block_ciphers.scm 86 */
obj_t BgL_v1288z00_1756;
BgL_v1288z00_1756 = 
create_vector(((long)0)); 
BgL_arg2291z00_1720 = BgL_v1288z00_1756; } 
BGl_CBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)66)), 
CNST_TABLE_REF(((long)56)), BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00, ((long)41938), BGl_proc3825z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3824z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3823z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2290z00_1719, BgL_arg2291z00_1720); } 
{ /* Llib/block_ciphers.scm 89 */
obj_t BgL_arg2310z00_1763;obj_t BgL_arg2311z00_1764;
{ /* Llib/block_ciphers.scm 89 */
obj_t BgL_v1289z00_1779;
BgL_v1289z00_1779 = 
create_vector(((long)2)); 
{ /* Llib/block_ciphers.scm 89 */
obj_t BgL_arg2317z00_1780;
BgL_arg2317z00_1780 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)63)), BGl_proc3827z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3826z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)46))); 
VECTOR_SET(BgL_v1289z00_1779,((long)0),BgL_arg2317z00_1780); } 
{ /* Llib/block_ciphers.scm 89 */
obj_t BgL_arg2322z00_1790;
BgL_arg2322z00_1790 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)64)), BGl_proc3829z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3828z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)46))); 
VECTOR_SET(BgL_v1289z00_1779,((long)1),BgL_arg2322z00_1790); } 
BgL_arg2310z00_1763 = BgL_v1289z00_1779; } 
{ /* Llib/block_ciphers.scm 89 */
obj_t BgL_v1290z00_1800;
BgL_v1290z00_1800 = 
create_vector(((long)0)); 
BgL_arg2311z00_1764 = BgL_v1290z00_1800; } 
BGl_PCBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)67)), 
CNST_TABLE_REF(((long)56)), BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00, ((long)34988), BGl_proc3832z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3831z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3830z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2310z00_1763, BgL_arg2311z00_1764); } 
{ /* Llib/block_ciphers.scm 92 */
obj_t BgL_arg2330z00_1807;obj_t BgL_arg2331z00_1808;
{ /* Llib/block_ciphers.scm 92 */
obj_t BgL_v1291z00_1823;
BgL_v1291z00_1823 = 
create_vector(((long)2)); 
{ /* Llib/block_ciphers.scm 92 */
obj_t BgL_arg2337z00_1824;
BgL_arg2337z00_1824 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)63)), BGl_proc3834z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3833z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)46))); 
VECTOR_SET(BgL_v1291z00_1823,((long)0),BgL_arg2337z00_1824); } 
{ /* Llib/block_ciphers.scm 92 */
obj_t BgL_arg2342z00_1834;
BgL_arg2342z00_1834 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)64)), BGl_proc3836z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3835z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)46))); 
VECTOR_SET(BgL_v1291z00_1823,((long)1),BgL_arg2342z00_1834); } 
BgL_arg2330z00_1807 = BgL_v1291z00_1823; } 
{ /* Llib/block_ciphers.scm 92 */
obj_t BgL_v1292z00_1844;
BgL_v1292z00_1844 = 
create_vector(((long)0)); 
BgL_arg2331z00_1808 = BgL_v1292z00_1844; } 
BGl_PCBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)68)), 
CNST_TABLE_REF(((long)56)), BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00, ((long)11458), BGl_proc3839z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3838z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3837z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2330z00_1807, BgL_arg2331z00_1808); } 
{ /* Llib/block_ciphers.scm 96 */
obj_t BgL_arg2349z00_1850;obj_t BgL_arg2350z00_1851;
{ /* Llib/block_ciphers.scm 96 */
obj_t BgL_v1293z00_1857;
BgL_v1293z00_1857 = 
create_vector(((long)0)); 
BgL_arg2349z00_1850 = BgL_v1293z00_1857; } 
{ /* Llib/block_ciphers.scm 96 */
obj_t BgL_v1294z00_1858;
BgL_v1294z00_1858 = 
create_vector(((long)0)); 
BgL_arg2350z00_1851 = BgL_v1294z00_1858; } 
BGl_Streamzd2Cipherzd2Statez00zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)69)), 
CNST_TABLE_REF(((long)56)), BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00, ((long)43473), BFALSE, BGl_proc3841z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3840z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2349z00_1850, BgL_arg2350z00_1851); } 
{ /* Llib/block_ciphers.scm 97 */
obj_t BgL_arg2357z00_1864;obj_t BgL_arg2358z00_1865;
{ /* Llib/block_ciphers.scm 97 */
obj_t BgL_v1295z00_1879;
BgL_v1295z00_1879 = 
create_vector(((long)1)); 
{ /* Llib/block_ciphers.scm 97 */
obj_t BgL_arg2364z00_1880;
BgL_arg2364z00_1880 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)64)), BGl_proc3843z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3842z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)46))); 
VECTOR_SET(BgL_v1295z00_1879,((long)0),BgL_arg2364z00_1880); } 
BgL_arg2357z00_1864 = BgL_v1295z00_1879; } 
{ /* Llib/block_ciphers.scm 97 */
obj_t BgL_v1296z00_1890;
BgL_v1296z00_1890 = 
create_vector(((long)0)); 
BgL_arg2358z00_1865 = BgL_v1296z00_1890; } 
BGl_CFBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)70)), 
CNST_TABLE_REF(((long)56)), BGl_Streamzd2Cipherzd2Statez00zz__cryptozd2blockzd2ciphersz00, ((long)46218), BGl_proc3846z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3845z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3844z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2357z00_1864, BgL_arg2358z00_1865); } 
{ /* Llib/block_ciphers.scm 99 */
obj_t BgL_arg2372z00_1897;obj_t BgL_arg2373z00_1898;
{ /* Llib/block_ciphers.scm 99 */
obj_t BgL_v1297z00_1913;
BgL_v1297z00_1913 = 
create_vector(((long)2)); 
{ /* Llib/block_ciphers.scm 99 */
obj_t BgL_arg2379z00_1914;
BgL_arg2379z00_1914 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)63)), BGl_proc3848z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3847z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)46))); 
VECTOR_SET(BgL_v1297z00_1913,((long)0),BgL_arg2379z00_1914); } 
{ /* Llib/block_ciphers.scm 99 */
obj_t BgL_arg2384z00_1924;
BgL_arg2384z00_1924 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)64)), BGl_proc3850z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3849z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)46))); 
VECTOR_SET(BgL_v1297z00_1913,((long)1),BgL_arg2384z00_1924); } 
BgL_arg2372z00_1897 = BgL_v1297z00_1913; } 
{ /* Llib/block_ciphers.scm 99 */
obj_t BgL_v1298z00_1934;
BgL_v1298z00_1934 = 
create_vector(((long)0)); 
BgL_arg2373z00_1898 = BgL_v1298z00_1934; } 
BGl_CFBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)71)), 
CNST_TABLE_REF(((long)56)), BGl_Streamzd2Cipherzd2Statez00zz__cryptozd2blockzd2ciphersz00, ((long)63662), BGl_proc3853z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3852z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3851z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2372z00_1897, BgL_arg2373z00_1898); } 
{ /* Llib/block_ciphers.scm 102 */
obj_t BgL_arg2392z00_1941;obj_t BgL_arg2393z00_1942;
{ /* Llib/block_ciphers.scm 102 */
obj_t BgL_v1299z00_1956;
BgL_v1299z00_1956 = 
create_vector(((long)1)); 
{ /* Llib/block_ciphers.scm 102 */
obj_t BgL_arg2399z00_1957;
BgL_arg2399z00_1957 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)64)), BGl_proc3855z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3854z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)46))); 
VECTOR_SET(BgL_v1299z00_1956,((long)0),BgL_arg2399z00_1957); } 
BgL_arg2392z00_1941 = BgL_v1299z00_1956; } 
{ /* Llib/block_ciphers.scm 102 */
obj_t BgL_v1300z00_1967;
BgL_v1300z00_1967 = 
create_vector(((long)0)); 
BgL_arg2393z00_1942 = BgL_v1300z00_1967; } 
BGl_OFBz00zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)72)), 
CNST_TABLE_REF(((long)56)), BGl_Streamzd2Cipherzd2Statez00zz__cryptozd2blockzd2ciphersz00, ((long)15584), BGl_proc3858z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3857z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3856z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2392z00_1941, BgL_arg2393z00_1942); } 
{ /* Llib/block_ciphers.scm 104 */
obj_t BgL_arg2407z00_1974;obj_t BgL_arg2408z00_1975;
{ /* Llib/block_ciphers.scm 104 */
obj_t BgL_v1301z00_1993;
BgL_v1301z00_1993 = 
create_vector(((long)5)); 
{ /* Llib/block_ciphers.scm 104 */
obj_t BgL_arg2414z00_1994;
BgL_arg2414z00_1994 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)73)), BGl_proc3860z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3859z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)59))); 
VECTOR_SET(BgL_v1301z00_1993,((long)0),BgL_arg2414z00_1994); } 
{ /* Llib/block_ciphers.scm 104 */
obj_t BgL_arg2419z00_2004;
BgL_arg2419z00_2004 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)74)), BGl_proc3862z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3861z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)46))); 
VECTOR_SET(BgL_v1301z00_1993,((long)1),BgL_arg2419z00_2004); } 
{ /* Llib/block_ciphers.scm 104 */
obj_t BgL_arg2424z00_2014;
BgL_arg2424z00_2014 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)75)), BGl_proc3864z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3863z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)48))); 
VECTOR_SET(BgL_v1301z00_1993,((long)2),BgL_arg2424z00_2014); } 
{ /* Llib/block_ciphers.scm 104 */
obj_t BgL_arg2429z00_2024;
BgL_arg2429z00_2024 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)76)), BGl_proc3866z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3865z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)51))); 
VECTOR_SET(BgL_v1301z00_1993,((long)3),BgL_arg2429z00_2024); } 
{ /* Llib/block_ciphers.scm 104 */
obj_t BgL_arg2434z00_2034;
BgL_arg2434z00_2034 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)77)), BGl_proc3868z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3867z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)51))); 
VECTOR_SET(BgL_v1301z00_1993,((long)4),BgL_arg2434z00_2034); } 
BgL_arg2407z00_1974 = BgL_v1301z00_1993; } 
{ /* Llib/block_ciphers.scm 104 */
obj_t BgL_v1302z00_2044;
BgL_v1302z00_2044 = 
create_vector(((long)0)); 
BgL_arg2408z00_1975 = BgL_v1302z00_2044; } 
BGl_CTRz00zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)78)), 
CNST_TABLE_REF(((long)56)), BGl_Streamzd2Cipherzd2Statez00zz__cryptozd2blockzd2ciphersz00, ((long)15240), BGl_proc3871z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3870z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3869z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2407z00_1974, BgL_arg2408z00_1975); } 
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL_arg2442z00_2051;obj_t BgL_arg2443z00_2052;
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL_v1303z00_2070;
BgL_v1303z00_2070 = 
create_vector(((long)8)); 
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL_arg2449z00_2071;
BgL_arg2449z00_2071 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)79)), BGl_proc3873z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3872z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)80))); 
VECTOR_SET(BgL_v1303z00_2070,((long)0),BgL_arg2449z00_2071); } 
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL_arg2454z00_2081;
BgL_arg2454z00_2081 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)47)), BGl_proc3875z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3874z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)48))); 
VECTOR_SET(BgL_v1303z00_2070,((long)1),BgL_arg2454z00_2081); } 
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL_arg2459z00_2091;
BgL_arg2459z00_2091 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)81)), BGl_proc3877z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3876z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00); 
VECTOR_SET(BgL_v1303z00_2070,((long)2),BgL_arg2459z00_2091); } 
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL_arg2464z00_2101;
BgL_arg2464z00_2101 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)82)), BGl_proc3880z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3879z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3878z00zz__cryptozd2blockzd2ciphersz00, 
CNST_TABLE_REF(((long)83))); 
VECTOR_SET(BgL_v1303z00_2070,((long)3),BgL_arg2464z00_2101); } 
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL_arg2471z00_2114;
BgL_arg2471z00_2114 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)6)), BGl_proc3883z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3882z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3881z00zz__cryptozd2blockzd2ciphersz00, 
CNST_TABLE_REF(((long)59))); 
VECTOR_SET(BgL_v1303z00_2070,((long)4),BgL_arg2471z00_2114); } 
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL_arg2478z00_2127;
BgL_arg2478z00_2127 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)84)), BGl_proc3885z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3884z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)59))); 
VECTOR_SET(BgL_v1303z00_2070,((long)5),BgL_arg2478z00_2127); } 
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL_arg2483z00_2137;
BgL_arg2483z00_2137 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)85)), BGl_proc3887z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3886z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)46))); 
VECTOR_SET(BgL_v1303z00_2070,((long)6),BgL_arg2483z00_2137); } 
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL_arg2488z00_2147;
BgL_arg2488z00_2147 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)86)), BGl_proc3890z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3889z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3888z00zz__cryptozd2blockzd2ciphersz00, 
CNST_TABLE_REF(((long)48))); 
VECTOR_SET(BgL_v1303z00_2070,((long)7),BgL_arg2488z00_2147); } 
BgL_arg2442z00_2051 = BgL_v1303z00_2070; } 
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL_v1304z00_2160;
BgL_v1304z00_2160 = 
create_vector(((long)0)); 
BgL_arg2443z00_2052 = BgL_v1304z00_2160; } 
return ( 
BGl_Cipherzd2Modezd2Statez00zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)87)), 
CNST_TABLE_REF(((long)56)), BGl_objectz00zz__objectz00, ((long)41267), BGl_proc3893z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3892z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3891z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2442z00_2051, BgL_arg2443z00_2052), BUNSPEC) ;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2448> */
obj_t BGl_z62zc3anonymousza32448ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5174, obj_t BgL_new1149z00_5175)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 111 */
{ 
BgL_cipherzd2modezd2statez00_bglt BgL_auxz00_10590;
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_new1149z00_5175)))->BgL_encryptzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_new1149z00_5175)))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
{ 
BgL_cipherzd2statezd2_bglt BgL_auxz00_10595;
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL_classz00_6201;
BgL_classz00_6201 = BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00; 
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL__ortest_1106z00_6202;
BgL__ortest_1106z00_6202 = 
BGL_CLASS_NIL(BgL_classz00_6201); 
if(
CBOOL(BgL__ortest_1106z00_6202))
{ /* Llib/block_ciphers.scm 111 */
BgL_auxz00_10595 = 
((BgL_cipherzd2statezd2_bglt)BgL__ortest_1106z00_6202)
; }  else 
{ /* Llib/block_ciphers.scm 111 */
BgL_auxz00_10595 = 
((BgL_cipherzd2statezd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_6201))
; } } } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_new1149z00_5175)))->BgL_cipherzd2statezd2)=((BgL_cipherzd2statezd2_bglt)BgL_auxz00_10595),BUNSPEC); } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_new1149z00_5175)))->BgL_ivzd2actionzd2)=((obj_t)
CNST_TABLE_REF(((long)88))),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_new1149z00_5175)))->BgL_ivz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_new1149z00_5175)))->BgL_padzf2unpadzf2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_new1149z00_5175)))->BgL_loopzd2bufferzd2)=((obj_t)BGl_string3894z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_new1149z00_5175)))->BgL_posz00)=((long)((long)0)),BUNSPEC); 
BgL_auxz00_10590 = 
((BgL_cipherzd2modezd2statez00_bglt)BgL_new1149z00_5175); 
return 
((obj_t)BgL_auxz00_10590);} } 
BGL_FUNCTION_END;
}



/* &lambda2446 */
BgL_cipherzd2modezd2statez00_bglt BGl_z62lambda2446z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5176)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 111 */
{ /* Llib/block_ciphers.scm 111 */
BgL_cipherzd2modezd2statez00_bglt BgL_new1148z00_6203;
BgL_new1148z00_6203 = 
((BgL_cipherzd2modezd2statez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cipherzd2modezd2statez00_bgl) ))); 
{ /* Llib/block_ciphers.scm 111 */
long BgL_arg2447z00_6204;
{ /* Llib/block_ciphers.scm 111 */
long BgL_res3042z00_6205;
BgL_res3042z00_6205 = 
BGL_CLASS_INDEX(BGl_Cipherzd2Modezd2Statez00zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2447z00_6204 = BgL_res3042z00_6205; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1148z00_6203), BgL_arg2447z00_6204); } 
{ /* Llib/block_ciphers.scm 111 */
BgL_objectz00_bglt BgL_tmpz00_10621;
BgL_tmpz00_10621 = 
((BgL_objectz00_bglt)BgL_new1148z00_6203); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10621, BFALSE); } 
return BgL_new1148z00_6203;} } 
BGL_FUNCTION_END;
}



/* &lambda2444 */
BgL_cipherzd2modezd2statez00_bglt BGl_z62lambda2444z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5177, obj_t BgL_encryptzf31140zf3_5178, obj_t BgL_blockzd2siza7e1141z75_5179, obj_t BgL_cipherzd2state1142zd2_5180, obj_t BgL_ivzd2action1143zd2_5181, obj_t BgL_iv1144z00_5182, obj_t BgL_padzf2unpad1145zf2_5183, obj_t BgL_loopzd2buffer1146zd2_5184, obj_t BgL_pos1147z00_5185)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 111 */
{ /* Llib/block_ciphers.scm 111 */
bool_t BgL_encryptzf31140zf3_6206;long BgL_blockzd2siza7e1141z75_6207;long BgL_pos1147z00_6211;
BgL_encryptzf31140zf3_6206 = 
CBOOL(BgL_encryptzf31140zf3_5178); 
BgL_blockzd2siza7e1141z75_6207 = 
(long)CINT(BgL_blockzd2siza7e1141z75_5179); 
BgL_pos1147z00_6211 = 
(long)CINT(BgL_pos1147z00_5185); 
{ /* Llib/block_ciphers.scm 111 */
BgL_cipherzd2modezd2statez00_bglt BgL_new1264z00_6212;
{ /* Llib/block_ciphers.scm 111 */
BgL_cipherzd2modezd2statez00_bglt BgL_new1263z00_6213;
BgL_new1263z00_6213 = 
((BgL_cipherzd2modezd2statez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cipherzd2modezd2statez00_bgl) ))); 
{ /* Llib/block_ciphers.scm 111 */
long BgL_arg2445z00_6214;
{ /* Llib/block_ciphers.scm 111 */
long BgL_res3041z00_6215;
BgL_res3041z00_6215 = 
BGL_CLASS_INDEX(BGl_Cipherzd2Modezd2Statez00zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2445z00_6214 = BgL_res3041z00_6215; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1263z00_6213), BgL_arg2445z00_6214); } 
{ /* Llib/block_ciphers.scm 111 */
BgL_objectz00_bglt BgL_tmpz00_10631;
BgL_tmpz00_10631 = 
((BgL_objectz00_bglt)BgL_new1263z00_6213); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10631, BFALSE); } 
BgL_new1264z00_6212 = BgL_new1263z00_6213; } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1264z00_6212))->BgL_encryptzf3zf3)=((bool_t)BgL_encryptzf31140zf3_6206),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1264z00_6212))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7e1141z75_6207),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1264z00_6212))->BgL_cipherzd2statezd2)=((BgL_cipherzd2statezd2_bglt)
((BgL_cipherzd2statezd2_bglt)BgL_cipherzd2state1142zd2_5180)),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1264z00_6212))->BgL_ivzd2actionzd2)=((obj_t)
((obj_t)BgL_ivzd2action1143zd2_5181)),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1264z00_6212))->BgL_ivz00)=((obj_t)BgL_iv1144z00_5182),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1264z00_6212))->BgL_padzf2unpadzf2)=((obj_t)BgL_padzf2unpad1145zf2_5183),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1264z00_6212))->BgL_loopzd2bufferzd2)=((obj_t)
((obj_t)BgL_loopzd2buffer1146zd2_5184)),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1264z00_6212))->BgL_posz00)=((long)BgL_pos1147z00_6211),BUNSPEC); 
return BgL_new1264z00_6212;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2494> */
obj_t BGl_z62zc3anonymousza32494ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5186)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 111 */
return 
BINT(((long)0));} 
BGL_FUNCTION_END;
}



/* &lambda2493 */
obj_t BGl_z62lambda2493z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5187, obj_t BgL_oz00_5188, obj_t BgL_vz00_5189)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 111 */
{ /* Llib/block_ciphers.scm 111 */
long BgL_vz00_6217;
BgL_vz00_6217 = 
(long)CINT(BgL_vz00_5189); 
return 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_5188)))->BgL_posz00)=((long)BgL_vz00_6217),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2492 */
obj_t BGl_z62lambda2492z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5190, obj_t BgL_oz00_5191)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 111 */
return 
BINT(
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_5191)))->BgL_posz00));} 
BGL_FUNCTION_END;
}



/* &lambda2487 */
obj_t BGl_z62lambda2487z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5192, obj_t BgL_oz00_5193, obj_t BgL_vz00_5194)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 111 */
return 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_5193)))->BgL_loopzd2bufferzd2)=((obj_t)
((obj_t)BgL_vz00_5194)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2486 */
obj_t BGl_z62lambda2486z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5195, obj_t BgL_oz00_5196)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 111 */
return 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_5196)))->BgL_loopzd2bufferzd2);} 
BGL_FUNCTION_END;
}



/* &lambda2482 */
obj_t BGl_z62lambda2482z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5197, obj_t BgL_oz00_5198, obj_t BgL_vz00_5199)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 111 */
return 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_5198)))->BgL_padzf2unpadzf2)=((obj_t)BgL_vz00_5199),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2481 */
obj_t BGl_z62lambda2481z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5200, obj_t BgL_oz00_5201)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 111 */
return 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_5201)))->BgL_padzf2unpadzf2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2477> */
obj_t BGl_z62zc3anonymousza32477ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5202)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 111 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &lambda2476 */
obj_t BGl_z62lambda2476z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5203, obj_t BgL_oz00_5204, obj_t BgL_vz00_5205)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 111 */
return 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_5204)))->BgL_ivz00)=((obj_t)BgL_vz00_5205),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2475 */
obj_t BGl_z62lambda2475z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5206, obj_t BgL_oz00_5207)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 111 */
return 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_5207)))->BgL_ivz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2470> */
obj_t BGl_z62zc3anonymousza32470ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5208)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 111 */
return 
CNST_TABLE_REF(((long)89));} 
BGL_FUNCTION_END;
}



/* &lambda2469 */
obj_t BGl_z62lambda2469z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5209, obj_t BgL_oz00_5210, obj_t BgL_vz00_5211)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 111 */
return 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_5210)))->BgL_ivzd2actionzd2)=((obj_t)
((obj_t)BgL_vz00_5211)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2468 */
obj_t BGl_z62lambda2468z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5212, obj_t BgL_oz00_5213)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 111 */
return 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_5213)))->BgL_ivzd2actionzd2);} 
BGL_FUNCTION_END;
}



/* &lambda2463 */
obj_t BGl_z62lambda2463z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5214, obj_t BgL_oz00_5215, obj_t BgL_vz00_5216)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 111 */
return 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_5215)))->BgL_cipherzd2statezd2)=((BgL_cipherzd2statezd2_bglt)
((BgL_cipherzd2statezd2_bglt)BgL_vz00_5216)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2462 */
BgL_cipherzd2statezd2_bglt BGl_z62lambda2462z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5217, obj_t BgL_oz00_5218)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 111 */
return 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_5218)))->BgL_cipherzd2statezd2);} 
BGL_FUNCTION_END;
}



/* &lambda2458 */
obj_t BGl_z62lambda2458z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5219, obj_t BgL_oz00_5220, obj_t BgL_vz00_5221)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 111 */
{ /* Llib/block_ciphers.scm 111 */
long BgL_vz00_6233;
BgL_vz00_6233 = 
(long)CINT(BgL_vz00_5221); 
return 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_5220)))->BgL_blockzd2siza7ez75)=((long)BgL_vz00_6233),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2457 */
obj_t BGl_z62lambda2457z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5222, obj_t BgL_oz00_5223)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 111 */
return 
BINT(
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_5223)))->BgL_blockzd2siza7ez75));} 
BGL_FUNCTION_END;
}



/* &lambda2453 */
obj_t BGl_z62lambda2453z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5224, obj_t BgL_oz00_5225, obj_t BgL_vz00_5226)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 111 */
{ /* Llib/block_ciphers.scm 111 */
bool_t BgL_vz00_6236;
BgL_vz00_6236 = 
CBOOL(BgL_vz00_5226); 
return 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_5225)))->BgL_encryptzf3zf3)=((bool_t)BgL_vz00_6236),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2452 */
obj_t BGl_z62lambda2452z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5227, obj_t BgL_oz00_5228)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 111 */
return 
BBOOL(
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_5228)))->BgL_encryptzf3zf3));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2413> */
obj_t BGl_z62zc3anonymousza32413ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5229, obj_t BgL_new1138z00_5230)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 104 */
{ 
BgL_ctrz00_bglt BgL_auxz00_10689;
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ctrz00_bglt)BgL_new1138z00_5230))))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ctrz00_bglt)BgL_new1138z00_5230))))->BgL_cipherz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ctrz00_bglt)BgL_new1138z00_5230))))->BgL_paramz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_new1138z00_5230)))->BgL_noncez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_new1138z00_5230)))->BgL_noncezd2strzd2)=((obj_t)BGl_string3894z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_new1138z00_5230)))->BgL_blockzd2counterzd2)=((long)((long)0)),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_new1138z00_5230)))->BgL_noncezd2initz12zc0)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_new1138z00_5230)))->BgL_noncezd2updatez12zc0)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_10689 = 
((BgL_ctrz00_bglt)BgL_new1138z00_5230); 
return 
((obj_t)BgL_auxz00_10689);} } 
BGL_FUNCTION_END;
}



/* &lambda2411 */
BgL_ctrz00_bglt BGl_z62lambda2411z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5231)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 104 */
{ /* Llib/block_ciphers.scm 104 */
BgL_ctrz00_bglt BgL_new1137z00_6239;
BgL_new1137z00_6239 = 
((BgL_ctrz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ctrz00_bgl) ))); 
{ /* Llib/block_ciphers.scm 104 */
long BgL_arg2412z00_6240;
{ /* Llib/block_ciphers.scm 104 */
long BgL_res3040z00_6241;
BgL_res3040z00_6241 = 
BGL_CLASS_INDEX(BGl_CTRz00zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2412z00_6240 = BgL_res3040z00_6241; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1137z00_6239), BgL_arg2412z00_6240); } 
{ /* Llib/block_ciphers.scm 104 */
BgL_objectz00_bglt BgL_tmpz00_10715;
BgL_tmpz00_10715 = 
((BgL_objectz00_bglt)BgL_new1137z00_6239); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10715, BFALSE); } 
return BgL_new1137z00_6239;} } 
BGL_FUNCTION_END;
}



/* &lambda2409 */
BgL_ctrz00_bglt BGl_z62lambda2409z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5232, obj_t BgL_blockzd2siza7e1129z75_5233, obj_t BgL_cipher1130z00_5234, obj_t BgL_param1131z00_5235, obj_t BgL_nonce1132z00_5236, obj_t BgL_noncezd2str1133zd2_5237, obj_t BgL_blockzd2counter1134zd2_5238, obj_t BgL_noncezd2initz121135zc0_5239, obj_t BgL_noncezd2updatez121136zc0_5240)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 104 */
{ /* Llib/block_ciphers.scm 104 */
long BgL_blockzd2siza7e1129z75_6242;long BgL_blockzd2counter1134zd2_6245;
BgL_blockzd2siza7e1129z75_6242 = 
(long)CINT(BgL_blockzd2siza7e1129z75_5233); 
BgL_blockzd2counter1134zd2_6245 = 
(long)CINT(BgL_blockzd2counter1134zd2_5238); 
{ /* Llib/block_ciphers.scm 104 */
BgL_ctrz00_bglt BgL_new1262z00_6248;
{ /* Llib/block_ciphers.scm 104 */
BgL_ctrz00_bglt BgL_new1261z00_6249;
BgL_new1261z00_6249 = 
((BgL_ctrz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ctrz00_bgl) ))); 
{ /* Llib/block_ciphers.scm 104 */
long BgL_arg2410z00_6250;
{ /* Llib/block_ciphers.scm 104 */
long BgL_res3039z00_6251;
BgL_res3039z00_6251 = 
BGL_CLASS_INDEX(BGl_CTRz00zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2410z00_6250 = BgL_res3039z00_6251; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1261z00_6249), BgL_arg2410z00_6250); } 
{ /* Llib/block_ciphers.scm 104 */
BgL_objectz00_bglt BgL_tmpz00_10724;
BgL_tmpz00_10724 = 
((BgL_objectz00_bglt)BgL_new1261z00_6249); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10724, BFALSE); } 
BgL_new1262z00_6248 = BgL_new1261z00_6249; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1262z00_6248)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7e1129z75_6242),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1262z00_6248)))->BgL_cipherz00)=((obj_t)
((obj_t)BgL_cipher1130z00_5234)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1262z00_6248)))->BgL_paramz00)=((obj_t)BgL_param1131z00_5235),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(BgL_new1262z00_6248))->BgL_noncez00)=((obj_t)BgL_nonce1132z00_5236),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(BgL_new1262z00_6248))->BgL_noncezd2strzd2)=((obj_t)
((obj_t)BgL_noncezd2str1133zd2_5237)),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(BgL_new1262z00_6248))->BgL_blockzd2counterzd2)=((long)BgL_blockzd2counter1134zd2_6245),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(BgL_new1262z00_6248))->BgL_noncezd2initz12zc0)=((obj_t)
((obj_t)BgL_noncezd2initz121135zc0_5239)),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(BgL_new1262z00_6248))->BgL_noncezd2updatez12zc0)=((obj_t)
((obj_t)BgL_noncezd2updatez121136zc0_5240)),BUNSPEC); 
return BgL_new1262z00_6248;} } } 
BGL_FUNCTION_END;
}



/* &lambda2438 */
obj_t BGl_z62lambda2438z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5241, obj_t BgL_oz00_5242, obj_t BgL_vz00_5243)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 104 */
return 
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_oz00_5242)))->BgL_noncezd2updatez12zc0)=((obj_t)
((obj_t)BgL_vz00_5243)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2437 */
obj_t BGl_z62lambda2437z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5244, obj_t BgL_oz00_5245)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 104 */
return 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_oz00_5245)))->BgL_noncezd2updatez12zc0);} 
BGL_FUNCTION_END;
}



/* &lambda2433 */
obj_t BGl_z62lambda2433z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5246, obj_t BgL_oz00_5247, obj_t BgL_vz00_5248)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 104 */
return 
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_oz00_5247)))->BgL_noncezd2initz12zc0)=((obj_t)
((obj_t)BgL_vz00_5248)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2432 */
obj_t BGl_z62lambda2432z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5249, obj_t BgL_oz00_5250)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 104 */
return 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_oz00_5250)))->BgL_noncezd2initz12zc0);} 
BGL_FUNCTION_END;
}



/* &lambda2428 */
obj_t BGl_z62lambda2428z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5251, obj_t BgL_oz00_5252, obj_t BgL_vz00_5253)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 104 */
{ /* Llib/block_ciphers.scm 104 */
long BgL_vz00_6259;
BgL_vz00_6259 = 
(long)CINT(BgL_vz00_5253); 
return 
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_oz00_5252)))->BgL_blockzd2counterzd2)=((long)BgL_vz00_6259),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2427 */
obj_t BGl_z62lambda2427z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5254, obj_t BgL_oz00_5255)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 104 */
return 
BINT(
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_oz00_5255)))->BgL_blockzd2counterzd2));} 
BGL_FUNCTION_END;
}



/* &lambda2423 */
obj_t BGl_z62lambda2423z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5256, obj_t BgL_oz00_5257, obj_t BgL_vz00_5258)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 104 */
return 
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_oz00_5257)))->BgL_noncezd2strzd2)=((obj_t)
((obj_t)BgL_vz00_5258)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2422 */
obj_t BGl_z62lambda2422z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5259, obj_t BgL_oz00_5260)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 104 */
return 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_oz00_5260)))->BgL_noncezd2strzd2);} 
BGL_FUNCTION_END;
}



/* &lambda2418 */
obj_t BGl_z62lambda2418z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5261, obj_t BgL_oz00_5262, obj_t BgL_vz00_5263)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 104 */
return 
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_oz00_5262)))->BgL_noncez00)=((obj_t)BgL_vz00_5263),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2417 */
obj_t BGl_z62lambda2417z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5264, obj_t BgL_oz00_5265)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 104 */
return 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_oz00_5265)))->BgL_noncez00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2398> */
obj_t BGl_z62zc3anonymousza32398ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5266, obj_t BgL_new1127z00_5267)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 102 */
{ 
BgL_ofbz00_bglt BgL_auxz00_10767;
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ofbz00_bglt)BgL_new1127z00_5267))))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ofbz00_bglt)BgL_new1127z00_5267))))->BgL_cipherz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ofbz00_bglt)BgL_new1127z00_5267))))->BgL_paramz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ofbz00_bglt)COBJECT(
((BgL_ofbz00_bglt)BgL_new1127z00_5267)))->BgL_chainz00)=((obj_t)BGl_string3894z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
BgL_auxz00_10767 = 
((BgL_ofbz00_bglt)BgL_new1127z00_5267); 
return 
((obj_t)BgL_auxz00_10767);} } 
BGL_FUNCTION_END;
}



/* &lambda2396 */
BgL_ofbz00_bglt BGl_z62lambda2396z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5268)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 102 */
{ /* Llib/block_ciphers.scm 102 */
BgL_ofbz00_bglt BgL_new1126z00_6267;
BgL_new1126z00_6267 = 
((BgL_ofbz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ofbz00_bgl) ))); 
{ /* Llib/block_ciphers.scm 102 */
long BgL_arg2397z00_6268;
{ /* Llib/block_ciphers.scm 102 */
long BgL_res3038z00_6269;
BgL_res3038z00_6269 = 
BGL_CLASS_INDEX(BGl_OFBz00zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2397z00_6268 = BgL_res3038z00_6269; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1126z00_6267), BgL_arg2397z00_6268); } 
{ /* Llib/block_ciphers.scm 102 */
BgL_objectz00_bglt BgL_tmpz00_10785;
BgL_tmpz00_10785 = 
((BgL_objectz00_bglt)BgL_new1126z00_6267); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10785, BFALSE); } 
return BgL_new1126z00_6267;} } 
BGL_FUNCTION_END;
}



/* &lambda2394 */
BgL_ofbz00_bglt BGl_z62lambda2394z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5269, obj_t BgL_blockzd2siza7e1122z75_5270, obj_t BgL_cipher1123z00_5271, obj_t BgL_param1124z00_5272, obj_t BgL_chain1125z00_5273)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 102 */
{ /* Llib/block_ciphers.scm 102 */
long BgL_blockzd2siza7e1122z75_6270;
BgL_blockzd2siza7e1122z75_6270 = 
(long)CINT(BgL_blockzd2siza7e1122z75_5270); 
{ /* Llib/block_ciphers.scm 102 */
BgL_ofbz00_bglt BgL_new1260z00_6273;
{ /* Llib/block_ciphers.scm 102 */
BgL_ofbz00_bglt BgL_new1259z00_6274;
BgL_new1259z00_6274 = 
((BgL_ofbz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ofbz00_bgl) ))); 
{ /* Llib/block_ciphers.scm 102 */
long BgL_arg2395z00_6275;
{ /* Llib/block_ciphers.scm 102 */
long BgL_res3037z00_6276;
BgL_res3037z00_6276 = 
BGL_CLASS_INDEX(BGl_OFBz00zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2395z00_6275 = BgL_res3037z00_6276; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1259z00_6274), BgL_arg2395z00_6275); } 
{ /* Llib/block_ciphers.scm 102 */
BgL_objectz00_bglt BgL_tmpz00_10793;
BgL_tmpz00_10793 = 
((BgL_objectz00_bglt)BgL_new1259z00_6274); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10793, BFALSE); } 
BgL_new1260z00_6273 = BgL_new1259z00_6274; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1260z00_6273)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7e1122z75_6270),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1260z00_6273)))->BgL_cipherz00)=((obj_t)
((obj_t)BgL_cipher1123z00_5271)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1260z00_6273)))->BgL_paramz00)=((obj_t)BgL_param1124z00_5272),BUNSPEC); 
((((BgL_ofbz00_bglt)COBJECT(BgL_new1260z00_6273))->BgL_chainz00)=((obj_t)
((obj_t)BgL_chain1125z00_5273)),BUNSPEC); 
return BgL_new1260z00_6273;} } } 
BGL_FUNCTION_END;
}



/* &lambda2403 */
obj_t BGl_z62lambda2403z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5274, obj_t BgL_oz00_5275, obj_t BgL_vz00_5276)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 102 */
return 
((((BgL_ofbz00_bglt)COBJECT(
((BgL_ofbz00_bglt)BgL_oz00_5275)))->BgL_chainz00)=((obj_t)
((obj_t)BgL_vz00_5276)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2402 */
obj_t BGl_z62lambda2402z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5277, obj_t BgL_oz00_5278)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 102 */
return 
(((BgL_ofbz00_bglt)COBJECT(
((BgL_ofbz00_bglt)BgL_oz00_5278)))->BgL_chainz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2378> */
obj_t BGl_z62zc3anonymousza32378ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5279, obj_t BgL_new1120z00_5280)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 99 */
{ 
BgL_cfbzd2decryptzd2_bglt BgL_auxz00_10810;
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2decryptzd2_bglt)BgL_new1120z00_5280))))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2decryptzd2_bglt)BgL_new1120z00_5280))))->BgL_cipherz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2decryptzd2_bglt)BgL_new1120z00_5280))))->BgL_paramz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_new1120z00_5280)))->BgL_bufferz00)=((obj_t)BGl_string3894z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
((((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_new1120z00_5280)))->BgL_chainz00)=((obj_t)BGl_string3894z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
BgL_auxz00_10810 = 
((BgL_cfbzd2decryptzd2_bglt)BgL_new1120z00_5280); 
return 
((obj_t)BgL_auxz00_10810);} } 
BGL_FUNCTION_END;
}



/* &lambda2376 */
BgL_cfbzd2decryptzd2_bglt BGl_z62lambda2376z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5281)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 99 */
{ /* Llib/block_ciphers.scm 99 */
BgL_cfbzd2decryptzd2_bglt BgL_new1119z00_6281;
BgL_new1119z00_6281 = 
((BgL_cfbzd2decryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cfbzd2decryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 99 */
long BgL_arg2377z00_6282;
{ /* Llib/block_ciphers.scm 99 */
long BgL_res3036z00_6283;
BgL_res3036z00_6283 = 
BGL_CLASS_INDEX(BGl_CFBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2377z00_6282 = BgL_res3036z00_6283; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1119z00_6281), BgL_arg2377z00_6282); } 
{ /* Llib/block_ciphers.scm 99 */
BgL_objectz00_bglt BgL_tmpz00_10830;
BgL_tmpz00_10830 = 
((BgL_objectz00_bglt)BgL_new1119z00_6281); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10830, BFALSE); } 
return BgL_new1119z00_6281;} } 
BGL_FUNCTION_END;
}



/* &lambda2374 */
BgL_cfbzd2decryptzd2_bglt BGl_z62lambda2374z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5282, obj_t BgL_blockzd2siza7e1114z75_5283, obj_t BgL_cipher1115z00_5284, obj_t BgL_param1116z00_5285, obj_t BgL_buffer1117z00_5286, obj_t BgL_chain1118z00_5287)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 99 */
{ /* Llib/block_ciphers.scm 99 */
long BgL_blockzd2siza7e1114z75_6284;
BgL_blockzd2siza7e1114z75_6284 = 
(long)CINT(BgL_blockzd2siza7e1114z75_5283); 
{ /* Llib/block_ciphers.scm 99 */
BgL_cfbzd2decryptzd2_bglt BgL_new1258z00_6288;
{ /* Llib/block_ciphers.scm 99 */
BgL_cfbzd2decryptzd2_bglt BgL_new1257z00_6289;
BgL_new1257z00_6289 = 
((BgL_cfbzd2decryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cfbzd2decryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 99 */
long BgL_arg2375z00_6290;
{ /* Llib/block_ciphers.scm 99 */
long BgL_res3035z00_6291;
BgL_res3035z00_6291 = 
BGL_CLASS_INDEX(BGl_CFBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2375z00_6290 = BgL_res3035z00_6291; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1257z00_6289), BgL_arg2375z00_6290); } 
{ /* Llib/block_ciphers.scm 99 */
BgL_objectz00_bglt BgL_tmpz00_10838;
BgL_tmpz00_10838 = 
((BgL_objectz00_bglt)BgL_new1257z00_6289); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10838, BFALSE); } 
BgL_new1258z00_6288 = BgL_new1257z00_6289; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1258z00_6288)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7e1114z75_6284),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1258z00_6288)))->BgL_cipherz00)=((obj_t)
((obj_t)BgL_cipher1115z00_5284)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1258z00_6288)))->BgL_paramz00)=((obj_t)BgL_param1116z00_5285),BUNSPEC); 
((((BgL_cfbzd2decryptzd2_bglt)COBJECT(BgL_new1258z00_6288))->BgL_bufferz00)=((obj_t)
((obj_t)BgL_buffer1117z00_5286)),BUNSPEC); 
((((BgL_cfbzd2decryptzd2_bglt)COBJECT(BgL_new1258z00_6288))->BgL_chainz00)=((obj_t)
((obj_t)BgL_chain1118z00_5287)),BUNSPEC); 
return BgL_new1258z00_6288;} } } 
BGL_FUNCTION_END;
}



/* &lambda2388 */
obj_t BGl_z62lambda2388z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5288, obj_t BgL_oz00_5289, obj_t BgL_vz00_5290)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 99 */
return 
((((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_oz00_5289)))->BgL_chainz00)=((obj_t)
((obj_t)BgL_vz00_5290)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2387 */
obj_t BGl_z62lambda2387z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5291, obj_t BgL_oz00_5292)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 99 */
return 
(((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_oz00_5292)))->BgL_chainz00);} 
BGL_FUNCTION_END;
}



/* &lambda2383 */
obj_t BGl_z62lambda2383z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5293, obj_t BgL_oz00_5294, obj_t BgL_vz00_5295)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 99 */
return 
((((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_oz00_5294)))->BgL_bufferz00)=((obj_t)
((obj_t)BgL_vz00_5295)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2382 */
obj_t BGl_z62lambda2382z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5296, obj_t BgL_oz00_5297)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 99 */
return 
(((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_oz00_5297)))->BgL_bufferz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2363> */
obj_t BGl_z62zc3anonymousza32363ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5298, obj_t BgL_new1112z00_5299)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 97 */
{ 
BgL_cfbzd2encryptzd2_bglt BgL_auxz00_10862;
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2encryptzd2_bglt)BgL_new1112z00_5299))))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2encryptzd2_bglt)BgL_new1112z00_5299))))->BgL_cipherz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2encryptzd2_bglt)BgL_new1112z00_5299))))->BgL_paramz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_new1112z00_5299)))->BgL_chainz00)=((obj_t)BGl_string3894z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
BgL_auxz00_10862 = 
((BgL_cfbzd2encryptzd2_bglt)BgL_new1112z00_5299); 
return 
((obj_t)BgL_auxz00_10862);} } 
BGL_FUNCTION_END;
}



/* &lambda2361 */
BgL_cfbzd2encryptzd2_bglt BGl_z62lambda2361z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5300)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 97 */
{ /* Llib/block_ciphers.scm 97 */
BgL_cfbzd2encryptzd2_bglt BgL_new1111z00_6299;
BgL_new1111z00_6299 = 
((BgL_cfbzd2encryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cfbzd2encryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 97 */
long BgL_arg2362z00_6300;
{ /* Llib/block_ciphers.scm 97 */
long BgL_res3034z00_6301;
BgL_res3034z00_6301 = 
BGL_CLASS_INDEX(BGl_CFBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2362z00_6300 = BgL_res3034z00_6301; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1111z00_6299), BgL_arg2362z00_6300); } 
{ /* Llib/block_ciphers.scm 97 */
BgL_objectz00_bglt BgL_tmpz00_10880;
BgL_tmpz00_10880 = 
((BgL_objectz00_bglt)BgL_new1111z00_6299); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10880, BFALSE); } 
return BgL_new1111z00_6299;} } 
BGL_FUNCTION_END;
}



/* &lambda2359 */
BgL_cfbzd2encryptzd2_bglt BGl_z62lambda2359z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5301, obj_t BgL_blockzd2siza7e1107z75_5302, obj_t BgL_cipher1108z00_5303, obj_t BgL_param1109z00_5304, obj_t BgL_chain1110z00_5305)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 97 */
{ /* Llib/block_ciphers.scm 97 */
long BgL_blockzd2siza7e1107z75_6302;
BgL_blockzd2siza7e1107z75_6302 = 
(long)CINT(BgL_blockzd2siza7e1107z75_5302); 
{ /* Llib/block_ciphers.scm 97 */
BgL_cfbzd2encryptzd2_bglt BgL_new1256z00_6305;
{ /* Llib/block_ciphers.scm 97 */
BgL_cfbzd2encryptzd2_bglt BgL_new1255z00_6306;
BgL_new1255z00_6306 = 
((BgL_cfbzd2encryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cfbzd2encryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 97 */
long BgL_arg2360z00_6307;
{ /* Llib/block_ciphers.scm 97 */
long BgL_res3033z00_6308;
BgL_res3033z00_6308 = 
BGL_CLASS_INDEX(BGl_CFBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2360z00_6307 = BgL_res3033z00_6308; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1255z00_6306), BgL_arg2360z00_6307); } 
{ /* Llib/block_ciphers.scm 97 */
BgL_objectz00_bglt BgL_tmpz00_10888;
BgL_tmpz00_10888 = 
((BgL_objectz00_bglt)BgL_new1255z00_6306); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10888, BFALSE); } 
BgL_new1256z00_6305 = BgL_new1255z00_6306; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1256z00_6305)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7e1107z75_6302),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1256z00_6305)))->BgL_cipherz00)=((obj_t)
((obj_t)BgL_cipher1108z00_5303)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1256z00_6305)))->BgL_paramz00)=((obj_t)BgL_param1109z00_5304),BUNSPEC); 
((((BgL_cfbzd2encryptzd2_bglt)COBJECT(BgL_new1256z00_6305))->BgL_chainz00)=((obj_t)
((obj_t)BgL_chain1110z00_5305)),BUNSPEC); 
return BgL_new1256z00_6305;} } } 
BGL_FUNCTION_END;
}



/* &lambda2368 */
obj_t BGl_z62lambda2368z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5306, obj_t BgL_oz00_5307, obj_t BgL_vz00_5308)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 97 */
return 
((((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_oz00_5307)))->BgL_chainz00)=((obj_t)
((obj_t)BgL_vz00_5308)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2367 */
obj_t BGl_z62lambda2367z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5309, obj_t BgL_oz00_5310)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 97 */
return 
(((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_oz00_5310)))->BgL_chainz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2353> */
obj_t BGl_z62zc3anonymousza32353ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5311, obj_t BgL_new1105z00_5312)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 96 */
{ 
BgL_streamzd2cipherzd2statez00_bglt BgL_auxz00_10905;
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_streamzd2cipherzd2statez00_bglt)BgL_new1105z00_5312))))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_streamzd2cipherzd2statez00_bglt)BgL_new1105z00_5312))))->BgL_cipherz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_streamzd2cipherzd2statez00_bglt)BgL_new1105z00_5312))))->BgL_paramz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_10905 = 
((BgL_streamzd2cipherzd2statez00_bglt)BgL_new1105z00_5312); 
return 
((obj_t)BgL_auxz00_10905);} } 
BGL_FUNCTION_END;
}



/* &lambda2351 */
BgL_streamzd2cipherzd2statez00_bglt BGl_z62lambda2351z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5313)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 96 */
{ /* Llib/block_ciphers.scm 96 */
BgL_streamzd2cipherzd2statez00_bglt BgL_new1104z00_6313;
BgL_new1104z00_6313 = 
((BgL_streamzd2cipherzd2statez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_streamzd2cipherzd2statez00_bgl) ))); 
{ /* Llib/block_ciphers.scm 96 */
long BgL_arg2352z00_6314;
{ /* Llib/block_ciphers.scm 96 */
long BgL_res3032z00_6315;
BgL_res3032z00_6315 = 
BGL_CLASS_INDEX(BGl_Streamzd2Cipherzd2Statez00zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2352z00_6314 = BgL_res3032z00_6315; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1104z00_6313), BgL_arg2352z00_6314); } 
return BgL_new1104z00_6313;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2336> */
obj_t BGl_z62zc3anonymousza32336ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5314, obj_t BgL_new1102z00_5315)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 92 */
{ 
BgL_pcbczd2decryptzd2_bglt BgL_auxz00_10921;
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2decryptzd2_bglt)BgL_new1102z00_5315))))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2decryptzd2_bglt)BgL_new1102z00_5315))))->BgL_cipherz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2decryptzd2_bglt)BgL_new1102z00_5315))))->BgL_paramz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_new1102z00_5315)))->BgL_bufferz00)=((obj_t)BGl_string3894z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
((((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_new1102z00_5315)))->BgL_chainz00)=((obj_t)BGl_string3894z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
BgL_auxz00_10921 = 
((BgL_pcbczd2decryptzd2_bglt)BgL_new1102z00_5315); 
return 
((obj_t)BgL_auxz00_10921);} } 
BGL_FUNCTION_END;
}



/* &lambda2334 */
BgL_pcbczd2decryptzd2_bglt BGl_z62lambda2334z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5316)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 92 */
{ /* Llib/block_ciphers.scm 92 */
BgL_pcbczd2decryptzd2_bglt BgL_new1101z00_6317;
BgL_new1101z00_6317 = 
((BgL_pcbczd2decryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pcbczd2decryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 92 */
long BgL_arg2335z00_6318;
{ /* Llib/block_ciphers.scm 92 */
long BgL_res3031z00_6319;
BgL_res3031z00_6319 = 
BGL_CLASS_INDEX(BGl_PCBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2335z00_6318 = BgL_res3031z00_6319; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1101z00_6317), BgL_arg2335z00_6318); } 
{ /* Llib/block_ciphers.scm 92 */
BgL_objectz00_bglt BgL_tmpz00_10941;
BgL_tmpz00_10941 = 
((BgL_objectz00_bglt)BgL_new1101z00_6317); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10941, BFALSE); } 
return BgL_new1101z00_6317;} } 
BGL_FUNCTION_END;
}



/* &lambda2332 */
BgL_pcbczd2decryptzd2_bglt BGl_z62lambda2332z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5317, obj_t BgL_blockzd2siza7e1096z75_5318, obj_t BgL_cipher1097z00_5319, obj_t BgL_param1098z00_5320, obj_t BgL_buffer1099z00_5321, obj_t BgL_chain1100z00_5322)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 92 */
{ /* Llib/block_ciphers.scm 92 */
long BgL_blockzd2siza7e1096z75_6320;
BgL_blockzd2siza7e1096z75_6320 = 
(long)CINT(BgL_blockzd2siza7e1096z75_5318); 
{ /* Llib/block_ciphers.scm 92 */
BgL_pcbczd2decryptzd2_bglt BgL_new1254z00_6324;
{ /* Llib/block_ciphers.scm 92 */
BgL_pcbczd2decryptzd2_bglt BgL_new1253z00_6325;
BgL_new1253z00_6325 = 
((BgL_pcbczd2decryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pcbczd2decryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 92 */
long BgL_arg2333z00_6326;
{ /* Llib/block_ciphers.scm 92 */
long BgL_res3030z00_6327;
BgL_res3030z00_6327 = 
BGL_CLASS_INDEX(BGl_PCBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2333z00_6326 = BgL_res3030z00_6327; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1253z00_6325), BgL_arg2333z00_6326); } 
{ /* Llib/block_ciphers.scm 92 */
BgL_objectz00_bglt BgL_tmpz00_10949;
BgL_tmpz00_10949 = 
((BgL_objectz00_bglt)BgL_new1253z00_6325); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10949, BFALSE); } 
BgL_new1254z00_6324 = BgL_new1253z00_6325; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1254z00_6324)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7e1096z75_6320),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1254z00_6324)))->BgL_cipherz00)=((obj_t)
((obj_t)BgL_cipher1097z00_5319)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1254z00_6324)))->BgL_paramz00)=((obj_t)BgL_param1098z00_5320),BUNSPEC); 
((((BgL_pcbczd2decryptzd2_bglt)COBJECT(BgL_new1254z00_6324))->BgL_bufferz00)=((obj_t)
((obj_t)BgL_buffer1099z00_5321)),BUNSPEC); 
((((BgL_pcbczd2decryptzd2_bglt)COBJECT(BgL_new1254z00_6324))->BgL_chainz00)=((obj_t)
((obj_t)BgL_chain1100z00_5322)),BUNSPEC); 
return BgL_new1254z00_6324;} } } 
BGL_FUNCTION_END;
}



/* &lambda2346 */
obj_t BGl_z62lambda2346z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5323, obj_t BgL_oz00_5324, obj_t BgL_vz00_5325)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 92 */
return 
((((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_oz00_5324)))->BgL_chainz00)=((obj_t)
((obj_t)BgL_vz00_5325)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2345 */
obj_t BGl_z62lambda2345z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5326, obj_t BgL_oz00_5327)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 92 */
return 
(((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_oz00_5327)))->BgL_chainz00);} 
BGL_FUNCTION_END;
}



/* &lambda2341 */
obj_t BGl_z62lambda2341z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5328, obj_t BgL_oz00_5329, obj_t BgL_vz00_5330)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 92 */
return 
((((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_oz00_5329)))->BgL_bufferz00)=((obj_t)
((obj_t)BgL_vz00_5330)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2340 */
obj_t BGl_z62lambda2340z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5331, obj_t BgL_oz00_5332)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 92 */
return 
(((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_oz00_5332)))->BgL_bufferz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2316> */
obj_t BGl_z62zc3anonymousza32316ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5333, obj_t BgL_new1094z00_5334)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 89 */
{ 
BgL_pcbczd2encryptzd2_bglt BgL_auxz00_10973;
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2encryptzd2_bglt)BgL_new1094z00_5334))))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2encryptzd2_bglt)BgL_new1094z00_5334))))->BgL_cipherz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2encryptzd2_bglt)BgL_new1094z00_5334))))->BgL_paramz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_new1094z00_5334)))->BgL_bufferz00)=((obj_t)BGl_string3894z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
((((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_new1094z00_5334)))->BgL_chainz00)=((obj_t)BGl_string3894z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
BgL_auxz00_10973 = 
((BgL_pcbczd2encryptzd2_bglt)BgL_new1094z00_5334); 
return 
((obj_t)BgL_auxz00_10973);} } 
BGL_FUNCTION_END;
}



/* &lambda2314 */
BgL_pcbczd2encryptzd2_bglt BGl_z62lambda2314z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5335)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 89 */
{ /* Llib/block_ciphers.scm 89 */
BgL_pcbczd2encryptzd2_bglt BgL_new1093z00_6335;
BgL_new1093z00_6335 = 
((BgL_pcbczd2encryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pcbczd2encryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 89 */
long BgL_arg2315z00_6336;
{ /* Llib/block_ciphers.scm 89 */
long BgL_res3029z00_6337;
BgL_res3029z00_6337 = 
BGL_CLASS_INDEX(BGl_PCBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2315z00_6336 = BgL_res3029z00_6337; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1093z00_6335), BgL_arg2315z00_6336); } 
{ /* Llib/block_ciphers.scm 89 */
BgL_objectz00_bglt BgL_tmpz00_10993;
BgL_tmpz00_10993 = 
((BgL_objectz00_bglt)BgL_new1093z00_6335); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10993, BFALSE); } 
return BgL_new1093z00_6335;} } 
BGL_FUNCTION_END;
}



/* &lambda2312 */
BgL_pcbczd2encryptzd2_bglt BGl_z62lambda2312z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5336, obj_t BgL_blockzd2siza7e1088z75_5337, obj_t BgL_cipher1089z00_5338, obj_t BgL_param1090z00_5339, obj_t BgL_buffer1091z00_5340, obj_t BgL_chain1092z00_5341)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 89 */
{ /* Llib/block_ciphers.scm 89 */
long BgL_blockzd2siza7e1088z75_6338;
BgL_blockzd2siza7e1088z75_6338 = 
(long)CINT(BgL_blockzd2siza7e1088z75_5337); 
{ /* Llib/block_ciphers.scm 89 */
BgL_pcbczd2encryptzd2_bglt BgL_new1252z00_6342;
{ /* Llib/block_ciphers.scm 89 */
BgL_pcbczd2encryptzd2_bglt BgL_new1251z00_6343;
BgL_new1251z00_6343 = 
((BgL_pcbczd2encryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pcbczd2encryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 89 */
long BgL_arg2313z00_6344;
{ /* Llib/block_ciphers.scm 89 */
long BgL_res3028z00_6345;
BgL_res3028z00_6345 = 
BGL_CLASS_INDEX(BGl_PCBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2313z00_6344 = BgL_res3028z00_6345; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1251z00_6343), BgL_arg2313z00_6344); } 
{ /* Llib/block_ciphers.scm 89 */
BgL_objectz00_bglt BgL_tmpz00_11001;
BgL_tmpz00_11001 = 
((BgL_objectz00_bglt)BgL_new1251z00_6343); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_11001, BFALSE); } 
BgL_new1252z00_6342 = BgL_new1251z00_6343; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1252z00_6342)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7e1088z75_6338),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1252z00_6342)))->BgL_cipherz00)=((obj_t)
((obj_t)BgL_cipher1089z00_5338)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1252z00_6342)))->BgL_paramz00)=((obj_t)BgL_param1090z00_5339),BUNSPEC); 
((((BgL_pcbczd2encryptzd2_bglt)COBJECT(BgL_new1252z00_6342))->BgL_bufferz00)=((obj_t)
((obj_t)BgL_buffer1091z00_5340)),BUNSPEC); 
((((BgL_pcbczd2encryptzd2_bglt)COBJECT(BgL_new1252z00_6342))->BgL_chainz00)=((obj_t)
((obj_t)BgL_chain1092z00_5341)),BUNSPEC); 
return BgL_new1252z00_6342;} } } 
BGL_FUNCTION_END;
}



/* &lambda2326 */
obj_t BGl_z62lambda2326z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5342, obj_t BgL_oz00_5343, obj_t BgL_vz00_5344)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 89 */
return 
((((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_oz00_5343)))->BgL_chainz00)=((obj_t)
((obj_t)BgL_vz00_5344)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2325 */
obj_t BGl_z62lambda2325z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5345, obj_t BgL_oz00_5346)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 89 */
return 
(((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_oz00_5346)))->BgL_chainz00);} 
BGL_FUNCTION_END;
}



/* &lambda2321 */
obj_t BGl_z62lambda2321z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5347, obj_t BgL_oz00_5348, obj_t BgL_vz00_5349)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 89 */
return 
((((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_oz00_5348)))->BgL_bufferz00)=((obj_t)
((obj_t)BgL_vz00_5349)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2320 */
obj_t BGl_z62lambda2320z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5350, obj_t BgL_oz00_5351)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 89 */
return 
(((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_oz00_5351)))->BgL_bufferz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2296> */
obj_t BGl_z62zc3anonymousza32296ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5352, obj_t BgL_new1086z00_5353)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 86 */
{ 
BgL_cbczd2decryptzd2_bglt BgL_auxz00_11025;
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2decryptzd2_bglt)BgL_new1086z00_5353))))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2decryptzd2_bglt)BgL_new1086z00_5353))))->BgL_cipherz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2decryptzd2_bglt)BgL_new1086z00_5353))))->BgL_paramz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_new1086z00_5353)))->BgL_bufferz00)=((obj_t)BGl_string3894z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
((((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_new1086z00_5353)))->BgL_chainz00)=((obj_t)BGl_string3894z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
BgL_auxz00_11025 = 
((BgL_cbczd2decryptzd2_bglt)BgL_new1086z00_5353); 
return 
((obj_t)BgL_auxz00_11025);} } 
BGL_FUNCTION_END;
}



/* &lambda2294 */
BgL_cbczd2decryptzd2_bglt BGl_z62lambda2294z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5354)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 86 */
{ /* Llib/block_ciphers.scm 86 */
BgL_cbczd2decryptzd2_bglt BgL_new1085z00_6353;
BgL_new1085z00_6353 = 
((BgL_cbczd2decryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cbczd2decryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 86 */
long BgL_arg2295z00_6354;
{ /* Llib/block_ciphers.scm 86 */
long BgL_res3027z00_6355;
BgL_res3027z00_6355 = 
BGL_CLASS_INDEX(BGl_CBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2295z00_6354 = BgL_res3027z00_6355; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1085z00_6353), BgL_arg2295z00_6354); } 
{ /* Llib/block_ciphers.scm 86 */
BgL_objectz00_bglt BgL_tmpz00_11045;
BgL_tmpz00_11045 = 
((BgL_objectz00_bglt)BgL_new1085z00_6353); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_11045, BFALSE); } 
return BgL_new1085z00_6353;} } 
BGL_FUNCTION_END;
}



/* &lambda2292 */
BgL_cbczd2decryptzd2_bglt BGl_z62lambda2292z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5355, obj_t BgL_blockzd2siza7e1080z75_5356, obj_t BgL_cipher1081z00_5357, obj_t BgL_param1082z00_5358, obj_t BgL_buffer1083z00_5359, obj_t BgL_chain1084z00_5360)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 86 */
{ /* Llib/block_ciphers.scm 86 */
long BgL_blockzd2siza7e1080z75_6356;
BgL_blockzd2siza7e1080z75_6356 = 
(long)CINT(BgL_blockzd2siza7e1080z75_5356); 
{ /* Llib/block_ciphers.scm 86 */
BgL_cbczd2decryptzd2_bglt BgL_new1250z00_6360;
{ /* Llib/block_ciphers.scm 86 */
BgL_cbczd2decryptzd2_bglt BgL_new1249z00_6361;
BgL_new1249z00_6361 = 
((BgL_cbczd2decryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cbczd2decryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 86 */
long BgL_arg2293z00_6362;
{ /* Llib/block_ciphers.scm 86 */
long BgL_res3026z00_6363;
BgL_res3026z00_6363 = 
BGL_CLASS_INDEX(BGl_CBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2293z00_6362 = BgL_res3026z00_6363; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1249z00_6361), BgL_arg2293z00_6362); } 
{ /* Llib/block_ciphers.scm 86 */
BgL_objectz00_bglt BgL_tmpz00_11053;
BgL_tmpz00_11053 = 
((BgL_objectz00_bglt)BgL_new1249z00_6361); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_11053, BFALSE); } 
BgL_new1250z00_6360 = BgL_new1249z00_6361; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1250z00_6360)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7e1080z75_6356),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1250z00_6360)))->BgL_cipherz00)=((obj_t)
((obj_t)BgL_cipher1081z00_5357)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1250z00_6360)))->BgL_paramz00)=((obj_t)BgL_param1082z00_5358),BUNSPEC); 
((((BgL_cbczd2decryptzd2_bglt)COBJECT(BgL_new1250z00_6360))->BgL_bufferz00)=((obj_t)
((obj_t)BgL_buffer1083z00_5359)),BUNSPEC); 
((((BgL_cbczd2decryptzd2_bglt)COBJECT(BgL_new1250z00_6360))->BgL_chainz00)=((obj_t)
((obj_t)BgL_chain1084z00_5360)),BUNSPEC); 
return BgL_new1250z00_6360;} } } 
BGL_FUNCTION_END;
}



/* &lambda2306 */
obj_t BGl_z62lambda2306z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5361, obj_t BgL_oz00_5362, obj_t BgL_vz00_5363)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 86 */
return 
((((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_oz00_5362)))->BgL_chainz00)=((obj_t)
((obj_t)BgL_vz00_5363)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2305 */
obj_t BGl_z62lambda2305z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5364, obj_t BgL_oz00_5365)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 86 */
return 
(((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_oz00_5365)))->BgL_chainz00);} 
BGL_FUNCTION_END;
}



/* &lambda2301 */
obj_t BGl_z62lambda2301z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5366, obj_t BgL_oz00_5367, obj_t BgL_vz00_5368)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 86 */
return 
((((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_oz00_5367)))->BgL_bufferz00)=((obj_t)
((obj_t)BgL_vz00_5368)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2300 */
obj_t BGl_z62lambda2300z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5369, obj_t BgL_oz00_5370)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 86 */
return 
(((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_oz00_5370)))->BgL_bufferz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2276> */
obj_t BGl_z62zc3anonymousza32276ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5371, obj_t BgL_new1078z00_5372)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 83 */
{ 
BgL_cbczd2encryptzd2_bglt BgL_auxz00_11077;
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2encryptzd2_bglt)BgL_new1078z00_5372))))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2encryptzd2_bglt)BgL_new1078z00_5372))))->BgL_cipherz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2encryptzd2_bglt)BgL_new1078z00_5372))))->BgL_paramz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_cbczd2encryptzd2_bglt)COBJECT(
((BgL_cbczd2encryptzd2_bglt)BgL_new1078z00_5372)))->BgL_bufferz00)=((obj_t)BGl_string3894z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
((((BgL_cbczd2encryptzd2_bglt)COBJECT(
((BgL_cbczd2encryptzd2_bglt)BgL_new1078z00_5372)))->BgL_chainz00)=((obj_t)BGl_string3894z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
BgL_auxz00_11077 = 
((BgL_cbczd2encryptzd2_bglt)BgL_new1078z00_5372); 
return 
((obj_t)BgL_auxz00_11077);} } 
BGL_FUNCTION_END;
}



/* &lambda2274 */
BgL_cbczd2encryptzd2_bglt BGl_z62lambda2274z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5373)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 83 */
{ /* Llib/block_ciphers.scm 83 */
BgL_cbczd2encryptzd2_bglt BgL_new1077z00_6371;
BgL_new1077z00_6371 = 
((BgL_cbczd2encryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cbczd2encryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 83 */
long BgL_arg2275z00_6372;
{ /* Llib/block_ciphers.scm 83 */
long BgL_res3025z00_6373;
BgL_res3025z00_6373 = 
BGL_CLASS_INDEX(BGl_CBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2275z00_6372 = BgL_res3025z00_6373; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1077z00_6371), BgL_arg2275z00_6372); } 
{ /* Llib/block_ciphers.scm 83 */
BgL_objectz00_bglt BgL_tmpz00_11097;
BgL_tmpz00_11097 = 
((BgL_objectz00_bglt)BgL_new1077z00_6371); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_11097, BFALSE); } 
return BgL_new1077z00_6371;} } 
BGL_FUNCTION_END;
}



/* &lambda2272 */
BgL_cbczd2encryptzd2_bglt BGl_z62lambda2272z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5374, obj_t BgL_blockzd2siza7e1072z75_5375, obj_t BgL_cipher1073z00_5376, obj_t BgL_param1074z00_5377, obj_t BgL_buffer1075z00_5378, obj_t BgL_chain1076z00_5379)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 83 */
{ /* Llib/block_ciphers.scm 83 */
long BgL_blockzd2siza7e1072z75_6374;
BgL_blockzd2siza7e1072z75_6374 = 
(long)CINT(BgL_blockzd2siza7e1072z75_5375); 
{ /* Llib/block_ciphers.scm 83 */
BgL_cbczd2encryptzd2_bglt BgL_new1248z00_6378;
{ /* Llib/block_ciphers.scm 83 */
BgL_cbczd2encryptzd2_bglt BgL_new1247z00_6379;
BgL_new1247z00_6379 = 
((BgL_cbczd2encryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cbczd2encryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 83 */
long BgL_arg2273z00_6380;
{ /* Llib/block_ciphers.scm 83 */
long BgL_res3024z00_6381;
BgL_res3024z00_6381 = 
BGL_CLASS_INDEX(BGl_CBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2273z00_6380 = BgL_res3024z00_6381; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1247z00_6379), BgL_arg2273z00_6380); } 
{ /* Llib/block_ciphers.scm 83 */
BgL_objectz00_bglt BgL_tmpz00_11105;
BgL_tmpz00_11105 = 
((BgL_objectz00_bglt)BgL_new1247z00_6379); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_11105, BFALSE); } 
BgL_new1248z00_6378 = BgL_new1247z00_6379; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1248z00_6378)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7e1072z75_6374),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1248z00_6378)))->BgL_cipherz00)=((obj_t)
((obj_t)BgL_cipher1073z00_5376)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1248z00_6378)))->BgL_paramz00)=((obj_t)BgL_param1074z00_5377),BUNSPEC); 
((((BgL_cbczd2encryptzd2_bglt)COBJECT(BgL_new1248z00_6378))->BgL_bufferz00)=((obj_t)
((obj_t)BgL_buffer1075z00_5378)),BUNSPEC); 
((((BgL_cbczd2encryptzd2_bglt)COBJECT(BgL_new1248z00_6378))->BgL_chainz00)=((obj_t)
((obj_t)BgL_chain1076z00_5379)),BUNSPEC); 
return BgL_new1248z00_6378;} } } 
BGL_FUNCTION_END;
}



/* &lambda2286 */
obj_t BGl_z62lambda2286z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5380, obj_t BgL_oz00_5381, obj_t BgL_vz00_5382)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 83 */
return 
((((BgL_cbczd2encryptzd2_bglt)COBJECT(
((BgL_cbczd2encryptzd2_bglt)BgL_oz00_5381)))->BgL_chainz00)=((obj_t)
((obj_t)BgL_vz00_5382)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2285 */
obj_t BGl_z62lambda2285z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5383, obj_t BgL_oz00_5384)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 83 */
return 
(((BgL_cbczd2encryptzd2_bglt)COBJECT(
((BgL_cbczd2encryptzd2_bglt)BgL_oz00_5384)))->BgL_chainz00);} 
BGL_FUNCTION_END;
}



/* &lambda2281 */
obj_t BGl_z62lambda2281z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5385, obj_t BgL_oz00_5386, obj_t BgL_vz00_5387)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 83 */
return 
((((BgL_cbczd2encryptzd2_bglt)COBJECT(
((BgL_cbczd2encryptzd2_bglt)BgL_oz00_5386)))->BgL_bufferz00)=((obj_t)
((obj_t)BgL_vz00_5387)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2280 */
obj_t BGl_z62lambda2280z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5388, obj_t BgL_oz00_5389)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 83 */
return 
(((BgL_cbczd2encryptzd2_bglt)COBJECT(
((BgL_cbczd2encryptzd2_bglt)BgL_oz00_5389)))->BgL_bufferz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2266> */
obj_t BGl_z62zc3anonymousza32266ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5390, obj_t BgL_new1070z00_5391)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 82 */
{ 
BgL_ecbzd2decryptzd2_bglt BgL_auxz00_11129;
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ecbzd2decryptzd2_bglt)BgL_new1070z00_5391))))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ecbzd2decryptzd2_bglt)BgL_new1070z00_5391))))->BgL_cipherz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ecbzd2decryptzd2_bglt)BgL_new1070z00_5391))))->BgL_paramz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_11129 = 
((BgL_ecbzd2decryptzd2_bglt)BgL_new1070z00_5391); 
return 
((obj_t)BgL_auxz00_11129);} } 
BGL_FUNCTION_END;
}



/* &lambda2264 */
BgL_ecbzd2decryptzd2_bglt BGl_z62lambda2264z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5392)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 82 */
{ /* Llib/block_ciphers.scm 82 */
BgL_ecbzd2decryptzd2_bglt BgL_new1069z00_6389;
BgL_new1069z00_6389 = 
((BgL_ecbzd2decryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ecbzd2decryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 82 */
long BgL_arg2265z00_6390;
{ /* Llib/block_ciphers.scm 82 */
long BgL_res3023z00_6391;
BgL_res3023z00_6391 = 
BGL_CLASS_INDEX(BGl_ECBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2265z00_6390 = BgL_res3023z00_6391; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1069z00_6389), BgL_arg2265z00_6390); } 
{ /* Llib/block_ciphers.scm 82 */
BgL_objectz00_bglt BgL_tmpz00_11145;
BgL_tmpz00_11145 = 
((BgL_objectz00_bglt)BgL_new1069z00_6389); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_11145, BFALSE); } 
return BgL_new1069z00_6389;} } 
BGL_FUNCTION_END;
}



/* &lambda2262 */
BgL_ecbzd2decryptzd2_bglt BGl_z62lambda2262z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5393, obj_t BgL_blockzd2siza7e1066z75_5394, obj_t BgL_cipher1067z00_5395, obj_t BgL_param1068z00_5396)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 82 */
{ /* Llib/block_ciphers.scm 82 */
long BgL_blockzd2siza7e1066z75_6392;
BgL_blockzd2siza7e1066z75_6392 = 
(long)CINT(BgL_blockzd2siza7e1066z75_5394); 
{ /* Llib/block_ciphers.scm 82 */
BgL_ecbzd2decryptzd2_bglt BgL_new1246z00_6394;
{ /* Llib/block_ciphers.scm 82 */
BgL_ecbzd2decryptzd2_bglt BgL_new1245z00_6395;
BgL_new1245z00_6395 = 
((BgL_ecbzd2decryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ecbzd2decryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 82 */
long BgL_arg2263z00_6396;
{ /* Llib/block_ciphers.scm 82 */
long BgL_res3022z00_6397;
BgL_res3022z00_6397 = 
BGL_CLASS_INDEX(BGl_ECBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2263z00_6396 = BgL_res3022z00_6397; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1245z00_6395), BgL_arg2263z00_6396); } 
{ /* Llib/block_ciphers.scm 82 */
BgL_objectz00_bglt BgL_tmpz00_11153;
BgL_tmpz00_11153 = 
((BgL_objectz00_bglt)BgL_new1245z00_6395); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_11153, BFALSE); } 
BgL_new1246z00_6394 = BgL_new1245z00_6395; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1246z00_6394)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7e1066z75_6392),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1246z00_6394)))->BgL_cipherz00)=((obj_t)
((obj_t)BgL_cipher1067z00_5395)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1246z00_6394)))->BgL_paramz00)=((obj_t)BgL_param1068z00_5396),BUNSPEC); 
return BgL_new1246z00_6394;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2256> */
obj_t BGl_z62zc3anonymousza32256ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5397, obj_t BgL_new1064z00_5398)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 81 */
{ 
BgL_ecbzd2encryptzd2_bglt BgL_auxz00_11163;
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ecbzd2encryptzd2_bglt)BgL_new1064z00_5398))))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ecbzd2encryptzd2_bglt)BgL_new1064z00_5398))))->BgL_cipherz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ecbzd2encryptzd2_bglt)BgL_new1064z00_5398))))->BgL_paramz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_11163 = 
((BgL_ecbzd2encryptzd2_bglt)BgL_new1064z00_5398); 
return 
((obj_t)BgL_auxz00_11163);} } 
BGL_FUNCTION_END;
}



/* &lambda2254 */
BgL_ecbzd2encryptzd2_bglt BGl_z62lambda2254z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5399)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 81 */
{ /* Llib/block_ciphers.scm 81 */
BgL_ecbzd2encryptzd2_bglt BgL_new1063z00_6399;
BgL_new1063z00_6399 = 
((BgL_ecbzd2encryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ecbzd2encryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 81 */
long BgL_arg2255z00_6400;
{ /* Llib/block_ciphers.scm 81 */
long BgL_res3021z00_6401;
BgL_res3021z00_6401 = 
BGL_CLASS_INDEX(BGl_ECBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2255z00_6400 = BgL_res3021z00_6401; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1063z00_6399), BgL_arg2255z00_6400); } 
{ /* Llib/block_ciphers.scm 81 */
BgL_objectz00_bglt BgL_tmpz00_11179;
BgL_tmpz00_11179 = 
((BgL_objectz00_bglt)BgL_new1063z00_6399); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_11179, BFALSE); } 
return BgL_new1063z00_6399;} } 
BGL_FUNCTION_END;
}



/* &lambda2252 */
BgL_ecbzd2encryptzd2_bglt BGl_z62lambda2252z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5400, obj_t BgL_blockzd2siza7e1060z75_5401, obj_t BgL_cipher1061z00_5402, obj_t BgL_param1062z00_5403)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 81 */
{ /* Llib/block_ciphers.scm 81 */
long BgL_blockzd2siza7e1060z75_6402;
BgL_blockzd2siza7e1060z75_6402 = 
(long)CINT(BgL_blockzd2siza7e1060z75_5401); 
{ /* Llib/block_ciphers.scm 81 */
BgL_ecbzd2encryptzd2_bglt BgL_new1244z00_6404;
{ /* Llib/block_ciphers.scm 81 */
BgL_ecbzd2encryptzd2_bglt BgL_new1243z00_6405;
BgL_new1243z00_6405 = 
((BgL_ecbzd2encryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ecbzd2encryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 81 */
long BgL_arg2253z00_6406;
{ /* Llib/block_ciphers.scm 81 */
long BgL_res3020z00_6407;
BgL_res3020z00_6407 = 
BGL_CLASS_INDEX(BGl_ECBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2253z00_6406 = BgL_res3020z00_6407; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1243z00_6405), BgL_arg2253z00_6406); } 
{ /* Llib/block_ciphers.scm 81 */
BgL_objectz00_bglt BgL_tmpz00_11187;
BgL_tmpz00_11187 = 
((BgL_objectz00_bglt)BgL_new1243z00_6405); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_11187, BFALSE); } 
BgL_new1244z00_6404 = BgL_new1243z00_6405; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1244z00_6404)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7e1060z75_6402),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1244z00_6404)))->BgL_cipherz00)=((obj_t)
((obj_t)BgL_cipher1061z00_5402)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1244z00_6404)))->BgL_paramz00)=((obj_t)BgL_param1062z00_5403),BUNSPEC); 
return BgL_new1244z00_6404;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2231> */
obj_t BGl_z62zc3anonymousza32231ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5404, obj_t BgL_new1058z00_5405)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 77 */
{ 
BgL_cipherzd2statezd2_bglt BgL_auxz00_11197;
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1058z00_5405)))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1058z00_5405)))->BgL_cipherz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1058z00_5405)))->BgL_paramz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_11197 = 
((BgL_cipherzd2statezd2_bglt)BgL_new1058z00_5405); 
return 
((obj_t)BgL_auxz00_11197);} } 
BGL_FUNCTION_END;
}



/* &lambda2229 */
BgL_cipherzd2statezd2_bglt BGl_z62lambda2229z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5406)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 77 */
{ /* Llib/block_ciphers.scm 77 */
BgL_cipherzd2statezd2_bglt BgL_new1057z00_6409;
BgL_new1057z00_6409 = 
((BgL_cipherzd2statezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cipherzd2statezd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 77 */
long BgL_arg2230z00_6410;
{ /* Llib/block_ciphers.scm 77 */
long BgL_res3019z00_6411;
BgL_res3019z00_6411 = 
BGL_CLASS_INDEX(BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2230z00_6410 = BgL_res3019z00_6411; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1057z00_6409), BgL_arg2230z00_6410); } 
return BgL_new1057z00_6409;} } 
BGL_FUNCTION_END;
}



/* &lambda2246 */
obj_t BGl_z62lambda2246z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5407, obj_t BgL_oz00_5408, obj_t BgL_vz00_5409)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 77 */
return 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_oz00_5408)))->BgL_paramz00)=((obj_t)BgL_vz00_5409),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2245 */
obj_t BGl_z62lambda2245z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5410, obj_t BgL_oz00_5411)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 77 */
return 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_oz00_5411)))->BgL_paramz00);} 
BGL_FUNCTION_END;
}



/* &lambda2241 */
obj_t BGl_z62lambda2241z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5412, obj_t BgL_oz00_5413, obj_t BgL_vz00_5414)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 77 */
return 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_oz00_5413)))->BgL_cipherz00)=((obj_t)
((obj_t)BgL_vz00_5414)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2240 */
obj_t BGl_z62lambda2240z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5415, obj_t BgL_oz00_5416)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 77 */
return 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_oz00_5416)))->BgL_cipherz00);} 
BGL_FUNCTION_END;
}



/* &lambda2236 */
obj_t BGl_z62lambda2236z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5417, obj_t BgL_oz00_5418, obj_t BgL_vz00_5419)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 77 */
{ /* Llib/block_ciphers.scm 77 */
long BgL_vz00_6418;
BgL_vz00_6418 = 
(long)CINT(BgL_vz00_5419); 
return 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_oz00_5418)))->BgL_blockzd2siza7ez75)=((long)BgL_vz00_6418),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2235 */
obj_t BGl_z62lambda2235z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5420, obj_t BgL_oz00_5421)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 77 */
return 
BINT(
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_oz00_5421)))->BgL_blockzd2siza7ez75));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2189> */
obj_t BGl_z62zc3anonymousza32189ze3ze1zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5422, obj_t BgL_new1055z00_5423)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 6 */
{ 
BgL_blockzd2cipherzd2_bglt BgL_auxz00_11225;
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_new1055z00_5423)))->BgL_namez00)=((obj_t)BGl_string3894z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_new1055z00_5423)))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_new1055z00_5423)))->BgL_preferredzd2keyzd2lengthz00)=((long)((long)0)),BUNSPEC); 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_new1055z00_5423)))->BgL_encryptz12z12)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_new1055z00_5423)))->BgL_decryptz12z12)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_new1055z00_5423)))->BgL_keyzd2ze3encryptzd2paramze3)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_new1055z00_5423)))->BgL_keyzd2ze3decryptzd2paramze3)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_11225 = 
((BgL_blockzd2cipherzd2_bglt)BgL_new1055z00_5423); 
return 
((obj_t)BgL_auxz00_11225);} } 
BGL_FUNCTION_END;
}



/* &lambda2187 */
BgL_blockzd2cipherzd2_bglt BGl_z62lambda2187z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5424)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 6 */
{ /* Llib/block_ciphers.scm 6 */
BgL_blockzd2cipherzd2_bglt BgL_new1054z00_6421;
BgL_new1054z00_6421 = 
((BgL_blockzd2cipherzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_blockzd2cipherzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 6 */
long BgL_arg2188z00_6422;
{ /* Llib/block_ciphers.scm 6 */
long BgL_res3018z00_6423;
BgL_res3018z00_6423 = 
BGL_CLASS_INDEX(BGl_Blockzd2Cipherzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2188z00_6422 = BgL_res3018z00_6423; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1054z00_6421), BgL_arg2188z00_6422); } 
{ /* Llib/block_ciphers.scm 6 */
BgL_objectz00_bglt BgL_tmpz00_11246;
BgL_tmpz00_11246 = 
((BgL_objectz00_bglt)BgL_new1054z00_6421); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_11246, BFALSE); } 
return BgL_new1054z00_6421;} } 
BGL_FUNCTION_END;
}



/* &lambda2185 */
BgL_blockzd2cipherzd2_bglt BGl_z62lambda2185z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5425, obj_t BgL_name1047z00_5426, obj_t BgL_blockzd2siza7e1048z75_5427, obj_t BgL_preferredzd2keyzd2length1049z00_5428, obj_t BgL_encryptz121050z12_5429, obj_t BgL_decryptz121051z12_5430, obj_t BgL_keyzd2ze3encryptzd2param1052ze3_5431, obj_t BgL_keyzd2ze3decryptzd2param1053ze3_5432)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 6 */
{ /* Llib/block_ciphers.scm 6 */
long BgL_blockzd2siza7e1048z75_6425;long BgL_preferredzd2keyzd2length1049z00_6426;
BgL_blockzd2siza7e1048z75_6425 = 
(long)CINT(BgL_blockzd2siza7e1048z75_5427); 
BgL_preferredzd2keyzd2length1049z00_6426 = 
(long)CINT(BgL_preferredzd2keyzd2length1049z00_5428); 
{ /* Llib/block_ciphers.scm 6 */
BgL_blockzd2cipherzd2_bglt BgL_new1242z00_6431;
{ /* Llib/block_ciphers.scm 6 */
BgL_blockzd2cipherzd2_bglt BgL_new1241z00_6432;
BgL_new1241z00_6432 = 
((BgL_blockzd2cipherzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_blockzd2cipherzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 6 */
long BgL_arg2186z00_6433;
{ /* Llib/block_ciphers.scm 6 */
long BgL_res3017z00_6434;
BgL_res3017z00_6434 = 
BGL_CLASS_INDEX(BGl_Blockzd2Cipherzd2zz__cryptozd2blockzd2ciphersz00); 
BgL_arg2186z00_6433 = BgL_res3017z00_6434; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1241z00_6432), BgL_arg2186z00_6433); } 
{ /* Llib/block_ciphers.scm 6 */
BgL_objectz00_bglt BgL_tmpz00_11255;
BgL_tmpz00_11255 = 
((BgL_objectz00_bglt)BgL_new1241z00_6432); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_11255, BFALSE); } 
BgL_new1242z00_6431 = BgL_new1241z00_6432; } 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_new1242z00_6431))->BgL_namez00)=((obj_t)
((obj_t)BgL_name1047z00_5426)),BUNSPEC); 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_new1242z00_6431))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7e1048z75_6425),BUNSPEC); 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_new1242z00_6431))->BgL_preferredzd2keyzd2lengthz00)=((long)BgL_preferredzd2keyzd2length1049z00_6426),BUNSPEC); 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_new1242z00_6431))->BgL_encryptz12z12)=((obj_t)
((obj_t)BgL_encryptz121050z12_5429)),BUNSPEC); 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_new1242z00_6431))->BgL_decryptz12z12)=((obj_t)
((obj_t)BgL_decryptz121051z12_5430)),BUNSPEC); 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_new1242z00_6431))->BgL_keyzd2ze3encryptzd2paramze3)=((obj_t)
((obj_t)BgL_keyzd2ze3encryptzd2param1052ze3_5431)),BUNSPEC); 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_new1242z00_6431))->BgL_keyzd2ze3decryptzd2paramze3)=((obj_t)
((obj_t)BgL_keyzd2ze3decryptzd2param1053ze3_5432)),BUNSPEC); 
return BgL_new1242z00_6431;} } } 
BGL_FUNCTION_END;
}



/* &lambda2224 */
obj_t BGl_z62lambda2224z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5433, obj_t BgL_oz00_5434, obj_t BgL_vz00_5435)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 6 */
return 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_5434)))->BgL_keyzd2ze3decryptzd2paramze3)=((obj_t)
((obj_t)BgL_vz00_5435)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2223 */
obj_t BGl_z62lambda2223z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5436, obj_t BgL_oz00_5437)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 6 */
return 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_5437)))->BgL_keyzd2ze3decryptzd2paramze3);} 
BGL_FUNCTION_END;
}



/* &lambda2219 */
obj_t BGl_z62lambda2219z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5438, obj_t BgL_oz00_5439, obj_t BgL_vz00_5440)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 6 */
return 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_5439)))->BgL_keyzd2ze3encryptzd2paramze3)=((obj_t)
((obj_t)BgL_vz00_5440)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2218 */
obj_t BGl_z62lambda2218z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5441, obj_t BgL_oz00_5442)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 6 */
return 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_5442)))->BgL_keyzd2ze3encryptzd2paramze3);} 
BGL_FUNCTION_END;
}



/* &lambda2214 */
obj_t BGl_z62lambda2214z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5443, obj_t BgL_oz00_5444, obj_t BgL_vz00_5445)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 6 */
return 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_5444)))->BgL_decryptz12z12)=((obj_t)
((obj_t)BgL_vz00_5445)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2213 */
obj_t BGl_z62lambda2213z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5446, obj_t BgL_oz00_5447)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 6 */
return 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_5447)))->BgL_decryptz12z12);} 
BGL_FUNCTION_END;
}



/* &lambda2209 */
obj_t BGl_z62lambda2209z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5448, obj_t BgL_oz00_5449, obj_t BgL_vz00_5450)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 6 */
return 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_5449)))->BgL_encryptz12z12)=((obj_t)
((obj_t)BgL_vz00_5450)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2208 */
obj_t BGl_z62lambda2208z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5451, obj_t BgL_oz00_5452)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 6 */
return 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_5452)))->BgL_encryptz12z12);} 
BGL_FUNCTION_END;
}



/* &lambda2204 */
obj_t BGl_z62lambda2204z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5453, obj_t BgL_oz00_5454, obj_t BgL_vz00_5455)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 6 */
{ /* Llib/block_ciphers.scm 6 */
long BgL_vz00_6448;
BgL_vz00_6448 = 
(long)CINT(BgL_vz00_5455); 
return 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_5454)))->BgL_preferredzd2keyzd2lengthz00)=((long)BgL_vz00_6448),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2203 */
obj_t BGl_z62lambda2203z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5456, obj_t BgL_oz00_5457)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 6 */
return 
BINT(
(((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_5457)))->BgL_preferredzd2keyzd2lengthz00));} 
BGL_FUNCTION_END;
}



/* &lambda2199 */
obj_t BGl_z62lambda2199z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5458, obj_t BgL_oz00_5459, obj_t BgL_vz00_5460)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 6 */
{ /* Llib/block_ciphers.scm 6 */
long BgL_vz00_6451;
BgL_vz00_6451 = 
(long)CINT(BgL_vz00_5460); 
return 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_5459)))->BgL_blockzd2siza7ez75)=((long)BgL_vz00_6451),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2198 */
obj_t BGl_z62lambda2198z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5461, obj_t BgL_oz00_5462)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 6 */
return 
BINT(
(((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_5462)))->BgL_blockzd2siza7ez75));} 
BGL_FUNCTION_END;
}



/* &lambda2194 */
obj_t BGl_z62lambda2194z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5463, obj_t BgL_oz00_5464, obj_t BgL_vz00_5465)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 6 */
return 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_5464)))->BgL_namez00)=((obj_t)
((obj_t)BgL_vz00_5465)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2193 */
obj_t BGl_z62lambda2193z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5466, obj_t BgL_oz00_5467)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 6 */
return 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_5467)))->BgL_namez00);} 
BGL_FUNCTION_END;
}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__cryptozd2blockzd2ciphersz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 1 */
BGl_registerzd2genericz12zc0zz__objectz00(BGl_dozd2cipherzd2IVzd2initz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_proc3895z00zz__cryptozd2blockzd2ciphersz00, BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00, BGl_string3896z00zz__cryptozd2blockzd2ciphersz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BGl_proc3897z00zz__cryptozd2blockzd2ciphersz00, BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00, BGl_string3898z00zz__cryptozd2blockzd2ciphersz00); 
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_dozd2cipherzd2partialzd2blockz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_proc3899z00zz__cryptozd2blockzd2ciphersz00, BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00, BGl_string3900z00zz__cryptozd2blockzd2ciphersz00);} 
BGL_FUNCTION_END;
}



/* &do-cipher-partial-bl1309 */
obj_t BGl_z62dozd2cipherzd2partialzd2bl1309zb0zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5471, obj_t BgL_statez00_5472, obj_t BgL_fromz00_5473, obj_t BgL_fromzd2blockzd2posz00_5474, obj_t BgL_toz00_5475, obj_t BgL_tozd2blockzd2posz00_5476, obj_t BgL_atz00_5477, obj_t BgL_lenz00_5478)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 212 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)90)), BGl_string3901z00zz__cryptozd2blockzd2ciphersz00, 
((obj_t)
((BgL_cipherzd2statezd2_bglt)BgL_statez00_5472)));} 
BGL_FUNCTION_END;
}



/* &do-cipher-block!1307 */
obj_t BGl_z62dozd2cipherzd2blockz121307z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5479, obj_t BgL_statez00_5480, obj_t BgL_fromz00_5481, obj_t BgL_fromzd2poszd2_5482, obj_t BgL_toz00_5483, obj_t BgL_tozd2poszd2_5484)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 206 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)91)), BGl_string3901z00zz__cryptozd2blockzd2ciphersz00, 
((obj_t)
((BgL_cipherzd2statezd2_bglt)BgL_statez00_5480)));} 
BGL_FUNCTION_END;
}



/* &do-cipher-IV-init!1305 */
obj_t BGl_z62dozd2cipherzd2IVzd2initz121305za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5485, obj_t BgL_statez00_5486, obj_t BgL_ivz00_5487)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 202 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)92)), BGl_string3901z00zz__cryptozd2blockzd2ciphersz00, 
((obj_t)
((BgL_cipherzd2statezd2_bglt)BgL_statez00_5486)));} 
BGL_FUNCTION_END;
}



/* do-cipher-IV-init! */
obj_t BGl_dozd2cipherzd2IVzd2initz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_cipherzd2statezd2_bglt BgL_statez00_36, obj_t BgL_ivz00_37)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 202 */
{ /* Llib/block_ciphers.scm 202 */
obj_t BgL_method1306z00_2187;
{ /* Llib/block_ciphers.scm 202 */
obj_t BgL_res3054z00_3954;
{ /* Llib/block_ciphers.scm 202 */
long BgL_objzd2classzd2numz00_3911;
{ /* Llib/block_ciphers.scm 202 */
long BgL_res3043z00_3914;
BgL_res3043z00_3914 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_statez00_36)); 
BgL_objzd2classzd2numz00_3911 = BgL_res3043z00_3914; } 
{ /* Llib/block_ciphers.scm 202 */
obj_t BgL_arg1742z00_3912;
BgL_arg1742z00_3912 = 
PROCEDURE_REF(BGl_dozd2cipherzd2IVzd2initz12zd2envz12zz__cryptozd2blockzd2ciphersz00, 
(int)(((long)1))); 
{ /* Llib/block_ciphers.scm 202 */
int BgL_offsetz00_3916;
BgL_offsetz00_3916 = 
(int)(BgL_objzd2classzd2numz00_3911); 
{ /* Llib/block_ciphers.scm 202 */
long BgL_offsetz00_3917;
BgL_offsetz00_3917 = 
(
(long)(BgL_offsetz00_3916)-OBJECT_TYPE); 
{ /* Llib/block_ciphers.scm 202 */
long BgL_modz00_3918;
{ /* Llib/block_ciphers.scm 202 */
int BgL_arg1744z00_3919;
BgL_arg1744z00_3919 = 
(int)(((long)16)); 
{ /* Llib/block_ciphers.scm 202 */
long BgL_res3046z00_3929;
{ /* Llib/block_ciphers.scm 202 */
long BgL_tmpz00_11330;
BgL_tmpz00_11330 = 
(long)(BgL_arg1744z00_3919); 
BgL_res3046z00_3929 = 
(BgL_offsetz00_3917/BgL_tmpz00_11330); } 
BgL_modz00_3918 = BgL_res3046z00_3929; } } 
{ /* Llib/block_ciphers.scm 202 */
long BgL_restz00_3920;
{ /* Llib/block_ciphers.scm 202 */
int BgL_arg1743z00_3921;
BgL_arg1743z00_3921 = 
(int)(((long)16)); 
{ /* Llib/block_ciphers.scm 202 */
long BgL_res3053z00_3949;
{ /* Llib/block_ciphers.scm 202 */
long BgL_n1z00_3931;long BgL_n2z00_3932;
BgL_n1z00_3931 = BgL_offsetz00_3917; 
BgL_n2z00_3932 = 
(long)(BgL_arg1743z00_3921); 
{ /* Llib/block_ciphers.scm 202 */
bool_t BgL_testz00_11335;
{ /* Llib/block_ciphers.scm 202 */
long BgL_arg1283z00_3934;
BgL_arg1283z00_3934 = 
(((BgL_n1z00_3931) | (BgL_n2z00_3932)) & -2147483648); 
BgL_testz00_11335 = 
(BgL_arg1283z00_3934==((long)0)); } 
if(BgL_testz00_11335)
{ /* Llib/block_ciphers.scm 202 */
int32_t BgL_arg1272z00_3935;
{ /* Llib/block_ciphers.scm 202 */
int32_t BgL_arg1278z00_3936;int32_t BgL_arg1279z00_3937;
{ /* Llib/block_ciphers.scm 202 */
int32_t BgL_res3049z00_3941;
BgL_res3049z00_3941 = 
(int32_t)(BgL_n1z00_3931); 
BgL_arg1278z00_3936 = BgL_res3049z00_3941; } 
{ /* Llib/block_ciphers.scm 202 */
int32_t BgL_res3050z00_3943;
BgL_res3050z00_3943 = 
(int32_t)(BgL_n2z00_3932); 
BgL_arg1279z00_3937 = BgL_res3050z00_3943; } 
BgL_arg1272z00_3935 = 
(BgL_arg1278z00_3936%BgL_arg1279z00_3937); } 
{ /* Llib/block_ciphers.scm 202 */
long BgL_res3052z00_3948;
{ /* Llib/block_ciphers.scm 202 */
long BgL_arg1409z00_3945;
BgL_arg1409z00_3945 = 
(long)(BgL_arg1272z00_3935); 
{ /* Llib/block_ciphers.scm 202 */
long BgL_res3051z00_3947;
BgL_res3051z00_3947 = 
(long)(BgL_arg1409z00_3945); 
BgL_res3052z00_3948 = BgL_res3051z00_3947; } } 
BgL_res3053z00_3949 = BgL_res3052z00_3948; } }  else 
{ /* Llib/block_ciphers.scm 202 */
BgL_res3053z00_3949 = 
(BgL_n1z00_3931%BgL_n2z00_3932); } } } 
BgL_restz00_3920 = BgL_res3053z00_3949; } } 
{ /* Llib/block_ciphers.scm 202 */

{ /* Llib/block_ciphers.scm 202 */
obj_t BgL_bucketz00_3922;
BgL_bucketz00_3922 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3912),BgL_modz00_3918); 
BgL_res3054z00_3954 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3922),BgL_restz00_3920); } } } } } } } } 
BgL_method1306z00_2187 = BgL_res3054z00_3954; } 
return 
PROCEDURE_ENTRY(BgL_method1306z00_2187)(BgL_method1306z00_2187, 
((obj_t)BgL_statez00_36), BgL_ivz00_37, BEOA);} } 
BGL_FUNCTION_END;
}



/* &do-cipher-IV-init! */
obj_t BGl_z62dozd2cipherzd2IVzd2initz12za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5488, obj_t BgL_statez00_5489, obj_t BgL_ivz00_5490)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 202 */
{ /* Llib/block_ciphers.scm 202 */
BgL_cipherzd2statezd2_bglt BgL_auxz00_11354;
if(
BGl_isazf3zf3zz__objectz00(BgL_statez00_5489, BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00))
{ /* Llib/block_ciphers.scm 202 */
BgL_auxz00_11354 = 
((BgL_cipherzd2statezd2_bglt)BgL_statez00_5489)
; }  else 
{ 
obj_t BgL_auxz00_11358;
BgL_auxz00_11358 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7145)), BGl_string3902z00zz__cryptozd2blockzd2ciphersz00, BGl_string3903z00zz__cryptozd2blockzd2ciphersz00, BgL_statez00_5489); 
FAILURE(BgL_auxz00_11358,BFALSE,BFALSE);} 
return 
BGl_dozd2cipherzd2IVzd2initz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_auxz00_11354, BgL_ivz00_5490);} } 
BGL_FUNCTION_END;
}



/* do-cipher-block! */
obj_t BGl_dozd2cipherzd2blockz12z12zz__cryptozd2blockzd2ciphersz00(BgL_cipherzd2statezd2_bglt BgL_statez00_38, obj_t BgL_fromz00_39, long BgL_fromzd2poszd2_40, obj_t BgL_toz00_41, long BgL_tozd2poszd2_42)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 206 */
{ /* Llib/block_ciphers.scm 206 */
obj_t BgL_method1308z00_2188;
{ /* Llib/block_ciphers.scm 206 */
obj_t BgL_res3066z00_3999;
{ /* Llib/block_ciphers.scm 206 */
long BgL_objzd2classzd2numz00_3956;
{ /* Llib/block_ciphers.scm 206 */
long BgL_res3055z00_3959;
BgL_res3055z00_3959 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_statez00_38)); 
BgL_objzd2classzd2numz00_3956 = BgL_res3055z00_3959; } 
{ /* Llib/block_ciphers.scm 206 */
obj_t BgL_arg1742z00_3957;
BgL_arg1742z00_3957 = 
PROCEDURE_REF(BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, 
(int)(((long)1))); 
{ /* Llib/block_ciphers.scm 206 */
int BgL_offsetz00_3961;
BgL_offsetz00_3961 = 
(int)(BgL_objzd2classzd2numz00_3956); 
{ /* Llib/block_ciphers.scm 206 */
long BgL_offsetz00_3962;
BgL_offsetz00_3962 = 
(
(long)(BgL_offsetz00_3961)-OBJECT_TYPE); 
{ /* Llib/block_ciphers.scm 206 */
long BgL_modz00_3963;
{ /* Llib/block_ciphers.scm 206 */
int BgL_arg1744z00_3964;
BgL_arg1744z00_3964 = 
(int)(((long)16)); 
{ /* Llib/block_ciphers.scm 206 */
long BgL_res3058z00_3974;
{ /* Llib/block_ciphers.scm 206 */
long BgL_tmpz00_11371;
BgL_tmpz00_11371 = 
(long)(BgL_arg1744z00_3964); 
BgL_res3058z00_3974 = 
(BgL_offsetz00_3962/BgL_tmpz00_11371); } 
BgL_modz00_3963 = BgL_res3058z00_3974; } } 
{ /* Llib/block_ciphers.scm 206 */
long BgL_restz00_3965;
{ /* Llib/block_ciphers.scm 206 */
int BgL_arg1743z00_3966;
BgL_arg1743z00_3966 = 
(int)(((long)16)); 
{ /* Llib/block_ciphers.scm 206 */
long BgL_res3065z00_3994;
{ /* Llib/block_ciphers.scm 206 */
long BgL_n1z00_3976;long BgL_n2z00_3977;
BgL_n1z00_3976 = BgL_offsetz00_3962; 
BgL_n2z00_3977 = 
(long)(BgL_arg1743z00_3966); 
{ /* Llib/block_ciphers.scm 206 */
bool_t BgL_testz00_11376;
{ /* Llib/block_ciphers.scm 206 */
long BgL_arg1283z00_3979;
BgL_arg1283z00_3979 = 
(((BgL_n1z00_3976) | (BgL_n2z00_3977)) & -2147483648); 
BgL_testz00_11376 = 
(BgL_arg1283z00_3979==((long)0)); } 
if(BgL_testz00_11376)
{ /* Llib/block_ciphers.scm 206 */
int32_t BgL_arg1272z00_3980;
{ /* Llib/block_ciphers.scm 206 */
int32_t BgL_arg1278z00_3981;int32_t BgL_arg1279z00_3982;
{ /* Llib/block_ciphers.scm 206 */
int32_t BgL_res3061z00_3986;
BgL_res3061z00_3986 = 
(int32_t)(BgL_n1z00_3976); 
BgL_arg1278z00_3981 = BgL_res3061z00_3986; } 
{ /* Llib/block_ciphers.scm 206 */
int32_t BgL_res3062z00_3988;
BgL_res3062z00_3988 = 
(int32_t)(BgL_n2z00_3977); 
BgL_arg1279z00_3982 = BgL_res3062z00_3988; } 
BgL_arg1272z00_3980 = 
(BgL_arg1278z00_3981%BgL_arg1279z00_3982); } 
{ /* Llib/block_ciphers.scm 206 */
long BgL_res3064z00_3993;
{ /* Llib/block_ciphers.scm 206 */
long BgL_arg1409z00_3990;
BgL_arg1409z00_3990 = 
(long)(BgL_arg1272z00_3980); 
{ /* Llib/block_ciphers.scm 206 */
long BgL_res3063z00_3992;
BgL_res3063z00_3992 = 
(long)(BgL_arg1409z00_3990); 
BgL_res3064z00_3993 = BgL_res3063z00_3992; } } 
BgL_res3065z00_3994 = BgL_res3064z00_3993; } }  else 
{ /* Llib/block_ciphers.scm 206 */
BgL_res3065z00_3994 = 
(BgL_n1z00_3976%BgL_n2z00_3977); } } } 
BgL_restz00_3965 = BgL_res3065z00_3994; } } 
{ /* Llib/block_ciphers.scm 206 */

{ /* Llib/block_ciphers.scm 206 */
obj_t BgL_bucketz00_3967;
BgL_bucketz00_3967 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3957),BgL_modz00_3963); 
BgL_res3066z00_3999 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3967),BgL_restz00_3965); } } } } } } } } 
BgL_method1308z00_2188 = BgL_res3066z00_3999; } 
return 
PROCEDURE_ENTRY(BgL_method1308z00_2188)(BgL_method1308z00_2188, 
((obj_t)BgL_statez00_38), BgL_fromz00_39, 
BINT(BgL_fromzd2poszd2_40), BgL_toz00_41, 
BINT(BgL_tozd2poszd2_42), BEOA);} } 
BGL_FUNCTION_END;
}



/* &do-cipher-block! */
obj_t BGl_z62dozd2cipherzd2blockz12z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5491, obj_t BgL_statez00_5492, obj_t BgL_fromz00_5493, obj_t BgL_fromzd2poszd2_5494, obj_t BgL_toz00_5495, obj_t BgL_tozd2poszd2_5496)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 206 */
{ /* Llib/block_ciphers.scm 206 */
long BgL_auxz00_11431;obj_t BgL_auxz00_11424;long BgL_auxz00_11415;obj_t BgL_auxz00_11408;BgL_cipherzd2statezd2_bglt BgL_auxz00_11400;
{ /* Llib/block_ciphers.scm 206 */
obj_t BgL_tmpz00_11432;
if(
INTEGERP(BgL_tozd2poszd2_5496))
{ /* Llib/block_ciphers.scm 206 */
BgL_tmpz00_11432 = BgL_tozd2poszd2_5496
; }  else 
{ 
obj_t BgL_auxz00_11435;
BgL_auxz00_11435 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7295)), BGl_string3904z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_tozd2poszd2_5496); 
FAILURE(BgL_auxz00_11435,BFALSE,BFALSE);} 
BgL_auxz00_11431 = 
(long)CINT(BgL_tmpz00_11432); } 
if(
STRINGP(BgL_toz00_5495))
{ /* Llib/block_ciphers.scm 206 */
BgL_auxz00_11424 = BgL_toz00_5495
; }  else 
{ 
obj_t BgL_auxz00_11427;
BgL_auxz00_11427 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7295)), BGl_string3904z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_toz00_5495); 
FAILURE(BgL_auxz00_11427,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 206 */
obj_t BgL_tmpz00_11416;
if(
INTEGERP(BgL_fromzd2poszd2_5494))
{ /* Llib/block_ciphers.scm 206 */
BgL_tmpz00_11416 = BgL_fromzd2poszd2_5494
; }  else 
{ 
obj_t BgL_auxz00_11419;
BgL_auxz00_11419 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7295)), BGl_string3904z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_fromzd2poszd2_5494); 
FAILURE(BgL_auxz00_11419,BFALSE,BFALSE);} 
BgL_auxz00_11415 = 
(long)CINT(BgL_tmpz00_11416); } 
if(
STRINGP(BgL_fromz00_5493))
{ /* Llib/block_ciphers.scm 206 */
BgL_auxz00_11408 = BgL_fromz00_5493
; }  else 
{ 
obj_t BgL_auxz00_11411;
BgL_auxz00_11411 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7295)), BGl_string3904z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_fromz00_5493); 
FAILURE(BgL_auxz00_11411,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_statez00_5492, BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00))
{ /* Llib/block_ciphers.scm 206 */
BgL_auxz00_11400 = 
((BgL_cipherzd2statezd2_bglt)BgL_statez00_5492)
; }  else 
{ 
obj_t BgL_auxz00_11404;
BgL_auxz00_11404 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7295)), BGl_string3904z00zz__cryptozd2blockzd2ciphersz00, BGl_string3903z00zz__cryptozd2blockzd2ciphersz00, BgL_statez00_5492); 
FAILURE(BgL_auxz00_11404,BFALSE,BFALSE);} 
return 
BGl_dozd2cipherzd2blockz12z12zz__cryptozd2blockzd2ciphersz00(BgL_auxz00_11400, BgL_auxz00_11408, BgL_auxz00_11415, BgL_auxz00_11424, BgL_auxz00_11431);} } 
BGL_FUNCTION_END;
}



/* do-cipher-partial-block! */
obj_t BGl_dozd2cipherzd2partialzd2blockz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_cipherzd2statezd2_bglt BgL_statez00_43, obj_t BgL_fromz00_44, long BgL_fromzd2blockzd2posz00_45, obj_t BgL_toz00_46, long BgL_tozd2blockzd2posz00_47, long BgL_atz00_48, long BgL_lenz00_49)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 212 */
{ /* Llib/block_ciphers.scm 212 */
obj_t BgL_method1310z00_2189;
{ /* Llib/block_ciphers.scm 212 */
obj_t BgL_res3078z00_4044;
{ /* Llib/block_ciphers.scm 212 */
long BgL_objzd2classzd2numz00_4001;
{ /* Llib/block_ciphers.scm 212 */
long BgL_res3067z00_4004;
BgL_res3067z00_4004 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_statez00_43)); 
BgL_objzd2classzd2numz00_4001 = BgL_res3067z00_4004; } 
{ /* Llib/block_ciphers.scm 212 */
obj_t BgL_arg1742z00_4002;
BgL_arg1742z00_4002 = 
PROCEDURE_REF(BGl_dozd2cipherzd2partialzd2blockz12zd2envz12zz__cryptozd2blockzd2ciphersz00, 
(int)(((long)1))); 
{ /* Llib/block_ciphers.scm 212 */
int BgL_offsetz00_4006;
BgL_offsetz00_4006 = 
(int)(BgL_objzd2classzd2numz00_4001); 
{ /* Llib/block_ciphers.scm 212 */
long BgL_offsetz00_4007;
BgL_offsetz00_4007 = 
(
(long)(BgL_offsetz00_4006)-OBJECT_TYPE); 
{ /* Llib/block_ciphers.scm 212 */
long BgL_modz00_4008;
{ /* Llib/block_ciphers.scm 212 */
int BgL_arg1744z00_4009;
BgL_arg1744z00_4009 = 
(int)(((long)16)); 
{ /* Llib/block_ciphers.scm 212 */
long BgL_res3070z00_4019;
{ /* Llib/block_ciphers.scm 212 */
long BgL_tmpz00_11449;
BgL_tmpz00_11449 = 
(long)(BgL_arg1744z00_4009); 
BgL_res3070z00_4019 = 
(BgL_offsetz00_4007/BgL_tmpz00_11449); } 
BgL_modz00_4008 = BgL_res3070z00_4019; } } 
{ /* Llib/block_ciphers.scm 212 */
long BgL_restz00_4010;
{ /* Llib/block_ciphers.scm 212 */
int BgL_arg1743z00_4011;
BgL_arg1743z00_4011 = 
(int)(((long)16)); 
{ /* Llib/block_ciphers.scm 212 */
long BgL_res3077z00_4039;
{ /* Llib/block_ciphers.scm 212 */
long BgL_n1z00_4021;long BgL_n2z00_4022;
BgL_n1z00_4021 = BgL_offsetz00_4007; 
BgL_n2z00_4022 = 
(long)(BgL_arg1743z00_4011); 
{ /* Llib/block_ciphers.scm 212 */
bool_t BgL_testz00_11454;
{ /* Llib/block_ciphers.scm 212 */
long BgL_arg1283z00_4024;
BgL_arg1283z00_4024 = 
(((BgL_n1z00_4021) | (BgL_n2z00_4022)) & -2147483648); 
BgL_testz00_11454 = 
(BgL_arg1283z00_4024==((long)0)); } 
if(BgL_testz00_11454)
{ /* Llib/block_ciphers.scm 212 */
int32_t BgL_arg1272z00_4025;
{ /* Llib/block_ciphers.scm 212 */
int32_t BgL_arg1278z00_4026;int32_t BgL_arg1279z00_4027;
{ /* Llib/block_ciphers.scm 212 */
int32_t BgL_res3073z00_4031;
BgL_res3073z00_4031 = 
(int32_t)(BgL_n1z00_4021); 
BgL_arg1278z00_4026 = BgL_res3073z00_4031; } 
{ /* Llib/block_ciphers.scm 212 */
int32_t BgL_res3074z00_4033;
BgL_res3074z00_4033 = 
(int32_t)(BgL_n2z00_4022); 
BgL_arg1279z00_4027 = BgL_res3074z00_4033; } 
BgL_arg1272z00_4025 = 
(BgL_arg1278z00_4026%BgL_arg1279z00_4027); } 
{ /* Llib/block_ciphers.scm 212 */
long BgL_res3076z00_4038;
{ /* Llib/block_ciphers.scm 212 */
long BgL_arg1409z00_4035;
BgL_arg1409z00_4035 = 
(long)(BgL_arg1272z00_4025); 
{ /* Llib/block_ciphers.scm 212 */
long BgL_res3075z00_4037;
BgL_res3075z00_4037 = 
(long)(BgL_arg1409z00_4035); 
BgL_res3076z00_4038 = BgL_res3075z00_4037; } } 
BgL_res3077z00_4039 = BgL_res3076z00_4038; } }  else 
{ /* Llib/block_ciphers.scm 212 */
BgL_res3077z00_4039 = 
(BgL_n1z00_4021%BgL_n2z00_4022); } } } 
BgL_restz00_4010 = BgL_res3077z00_4039; } } 
{ /* Llib/block_ciphers.scm 212 */

{ /* Llib/block_ciphers.scm 212 */
obj_t BgL_bucketz00_4012;
BgL_bucketz00_4012 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4002),BgL_modz00_4008); 
BgL_res3078z00_4044 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4012),BgL_restz00_4010); } } } } } } } } 
BgL_method1310z00_2189 = BgL_res3078z00_4044; } 
return 
PROCEDURE_ENTRY(BgL_method1310z00_2189)(BgL_method1310z00_2189, 
((obj_t)BgL_statez00_43), BgL_fromz00_44, 
BINT(BgL_fromzd2blockzd2posz00_45), BgL_toz00_46, 
BINT(BgL_tozd2blockzd2posz00_47), 
BINT(BgL_atz00_48), 
BINT(BgL_lenz00_49), BEOA);} } 
BGL_FUNCTION_END;
}



/* &do-cipher-partial-block! */
obj_t BGl_z62dozd2cipherzd2partialzd2blockz12za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5497, obj_t BgL_statez00_5498, obj_t BgL_fromz00_5499, obj_t BgL_fromzd2blockzd2posz00_5500, obj_t BgL_toz00_5501, obj_t BgL_tozd2blockzd2posz00_5502, obj_t BgL_atz00_5503, obj_t BgL_lenz00_5504)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 212 */
{ /* Llib/block_ciphers.scm 212 */
long BgL_auxz00_11531;long BgL_auxz00_11522;long BgL_auxz00_11513;obj_t BgL_auxz00_11506;long BgL_auxz00_11497;obj_t BgL_auxz00_11490;BgL_cipherzd2statezd2_bglt BgL_auxz00_11482;
{ /* Llib/block_ciphers.scm 212 */
obj_t BgL_tmpz00_11532;
if(
INTEGERP(BgL_lenz00_5504))
{ /* Llib/block_ciphers.scm 212 */
BgL_tmpz00_11532 = BgL_lenz00_5504
; }  else 
{ 
obj_t BgL_auxz00_11535;
BgL_auxz00_11535 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7508)), BGl_string3905z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_lenz00_5504); 
FAILURE(BgL_auxz00_11535,BFALSE,BFALSE);} 
BgL_auxz00_11531 = 
(long)CINT(BgL_tmpz00_11532); } 
{ /* Llib/block_ciphers.scm 212 */
obj_t BgL_tmpz00_11523;
if(
INTEGERP(BgL_atz00_5503))
{ /* Llib/block_ciphers.scm 212 */
BgL_tmpz00_11523 = BgL_atz00_5503
; }  else 
{ 
obj_t BgL_auxz00_11526;
BgL_auxz00_11526 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7508)), BGl_string3905z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_atz00_5503); 
FAILURE(BgL_auxz00_11526,BFALSE,BFALSE);} 
BgL_auxz00_11522 = 
(long)CINT(BgL_tmpz00_11523); } 
{ /* Llib/block_ciphers.scm 212 */
obj_t BgL_tmpz00_11514;
if(
INTEGERP(BgL_tozd2blockzd2posz00_5502))
{ /* Llib/block_ciphers.scm 212 */
BgL_tmpz00_11514 = BgL_tozd2blockzd2posz00_5502
; }  else 
{ 
obj_t BgL_auxz00_11517;
BgL_auxz00_11517 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7508)), BGl_string3905z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_tozd2blockzd2posz00_5502); 
FAILURE(BgL_auxz00_11517,BFALSE,BFALSE);} 
BgL_auxz00_11513 = 
(long)CINT(BgL_tmpz00_11514); } 
if(
STRINGP(BgL_toz00_5501))
{ /* Llib/block_ciphers.scm 212 */
BgL_auxz00_11506 = BgL_toz00_5501
; }  else 
{ 
obj_t BgL_auxz00_11509;
BgL_auxz00_11509 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7508)), BGl_string3905z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_toz00_5501); 
FAILURE(BgL_auxz00_11509,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 212 */
obj_t BgL_tmpz00_11498;
if(
INTEGERP(BgL_fromzd2blockzd2posz00_5500))
{ /* Llib/block_ciphers.scm 212 */
BgL_tmpz00_11498 = BgL_fromzd2blockzd2posz00_5500
; }  else 
{ 
obj_t BgL_auxz00_11501;
BgL_auxz00_11501 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7508)), BGl_string3905z00zz__cryptozd2blockzd2ciphersz00, BGl_string3751z00zz__cryptozd2blockzd2ciphersz00, BgL_fromzd2blockzd2posz00_5500); 
FAILURE(BgL_auxz00_11501,BFALSE,BFALSE);} 
BgL_auxz00_11497 = 
(long)CINT(BgL_tmpz00_11498); } 
if(
STRINGP(BgL_fromz00_5499))
{ /* Llib/block_ciphers.scm 212 */
BgL_auxz00_11490 = BgL_fromz00_5499
; }  else 
{ 
obj_t BgL_auxz00_11493;
BgL_auxz00_11493 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7508)), BGl_string3905z00zz__cryptozd2blockzd2ciphersz00, BGl_string3741z00zz__cryptozd2blockzd2ciphersz00, BgL_fromz00_5499); 
FAILURE(BgL_auxz00_11493,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_statez00_5498, BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00))
{ /* Llib/block_ciphers.scm 212 */
BgL_auxz00_11482 = 
((BgL_cipherzd2statezd2_bglt)BgL_statez00_5498)
; }  else 
{ 
obj_t BgL_auxz00_11486;
BgL_auxz00_11486 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3739z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7508)), BGl_string3905z00zz__cryptozd2blockzd2ciphersz00, BGl_string3903z00zz__cryptozd2blockzd2ciphersz00, BgL_statez00_5498); 
FAILURE(BgL_auxz00_11486,BFALSE,BFALSE);} 
return 
BGl_dozd2cipherzd2partialzd2blockz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_auxz00_11482, BgL_auxz00_11490, BgL_auxz00_11497, BgL_auxz00_11506, BgL_auxz00_11513, BgL_auxz00_11522, BgL_auxz00_11531);} } 
BGL_FUNCTION_END;
}



/* method-init */
obj_t BGl_methodzd2initzd2zz__cryptozd2blockzd2ciphersz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 1 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BGl_ECBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3906z00zz__cryptozd2blockzd2ciphersz00, BGl_string3907z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BGl_ECBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3908z00zz__cryptozd2blockzd2ciphersz00, BGl_string3907z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2IVzd2initz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_CBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3909z00zz__cryptozd2blockzd2ciphersz00, BGl_string3910z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BGl_CBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3911z00zz__cryptozd2blockzd2ciphersz00, BGl_string3907z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2IVzd2initz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_CBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3912z00zz__cryptozd2blockzd2ciphersz00, BGl_string3910z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BGl_CBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3913z00zz__cryptozd2blockzd2ciphersz00, BGl_string3907z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2IVzd2initz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_PCBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3914z00zz__cryptozd2blockzd2ciphersz00, BGl_string3910z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BGl_PCBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3915z00zz__cryptozd2blockzd2ciphersz00, BGl_string3907z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2IVzd2initz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_PCBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3916z00zz__cryptozd2blockzd2ciphersz00, BGl_string3910z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BGl_PCBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3917z00zz__cryptozd2blockzd2ciphersz00, BGl_string3907z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2IVzd2initz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_CFBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3918z00zz__cryptozd2blockzd2ciphersz00, BGl_string3910z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BGl_CFBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3919z00zz__cryptozd2blockzd2ciphersz00, BGl_string3907z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2partialzd2blockz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_CFBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3920z00zz__cryptozd2blockzd2ciphersz00, BGl_string3921z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2IVzd2initz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_CFBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3922z00zz__cryptozd2blockzd2ciphersz00, BGl_string3910z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BGl_CFBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3923z00zz__cryptozd2blockzd2ciphersz00, BGl_string3907z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2partialzd2blockz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_CFBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3924z00zz__cryptozd2blockzd2ciphersz00, BGl_string3921z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2IVzd2initz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_OFBz00zz__cryptozd2blockzd2ciphersz00, BGl_proc3925z00zz__cryptozd2blockzd2ciphersz00, BGl_string3910z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BGl_OFBz00zz__cryptozd2blockzd2ciphersz00, BGl_proc3926z00zz__cryptozd2blockzd2ciphersz00, BGl_string3907z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2partialzd2blockz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_OFBz00zz__cryptozd2blockzd2ciphersz00, BGl_proc3927z00zz__cryptozd2blockzd2ciphersz00, BGl_string3921z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2IVzd2initz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_CTRz00zz__cryptozd2blockzd2ciphersz00, BGl_proc3928z00zz__cryptozd2blockzd2ciphersz00, BGl_string3910z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BGl_CTRz00zz__cryptozd2blockzd2ciphersz00, BGl_proc3929z00zz__cryptozd2blockzd2ciphersz00, BGl_string3907z00zz__cryptozd2blockzd2ciphersz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2partialzd2blockz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_CTRz00zz__cryptozd2blockzd2ciphersz00, BGl_proc3930z00zz__cryptozd2blockzd2ciphersz00, BGl_string3921z00zz__cryptozd2blockzd2ciphersz00);} 
BGL_FUNCTION_END;
}



/* &do-cipher-partial-bl1354 */
obj_t BGl_z62dozd2cipherzd2partialzd2bl1354zb0zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5527, obj_t BgL_statez00_5528, obj_t BgL_fromz00_5529, obj_t BgL_fromzd2poszd2_5530, obj_t BgL_toz00_5531, obj_t BgL_tozd2poszd2_5532, obj_t BgL_atz00_5533, obj_t BgL_lenz00_5534)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 417 */
{ /* Llib/block_ciphers.scm 419 */
bool_t BgL_tmpz00_11563;
if(
(
(long)CINT(BgL_atz00_5533)==((long)0)))
{ /* Llib/block_ciphers.scm 421 */
{ /* Llib/block_ciphers.scm 422 */
obj_t BgL_fun2625z00_6470;
BgL_fun2625z00_6470 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_5528)))->BgL_noncezd2updatez12zc0); 
{ /* Llib/block_ciphers.scm 422 */
obj_t BgL_arg2622z00_6471;obj_t BgL_arg2623z00_6472;long BgL_arg2624z00_6473;
BgL_arg2622z00_6471 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_5528)))->BgL_noncezd2strzd2); 
BgL_arg2623z00_6472 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_5528)))->BgL_noncez00); 
BgL_arg2624z00_6473 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_5528)))->BgL_blockzd2counterzd2); 
PROCEDURE_ENTRY(BgL_fun2625z00_6470)(BgL_fun2625z00_6470, BgL_arg2622z00_6471, BgL_arg2623z00_6472, 
BINT(BgL_arg2624z00_6473), BEOA); } } 
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_5528)))->BgL_blockzd2counterzd2)=((long)
(
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_5528)))->BgL_blockzd2counterzd2)+((long)1))),BUNSPEC); 
{ /* Llib/block_ciphers.scm 424 */
obj_t BgL_fun2630z00_6474;
BgL_fun2630z00_6474 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ctrz00_bglt)BgL_statez00_5528))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 424 */
obj_t BgL_arg2627z00_6475;obj_t BgL_arg2628z00_6476;obj_t BgL_arg2629z00_6477;
BgL_arg2627z00_6475 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_5528)))->BgL_noncezd2strzd2); 
BgL_arg2628z00_6476 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_5528)))->BgL_noncezd2strzd2); 
BgL_arg2629z00_6477 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ctrz00_bglt)BgL_statez00_5528))))->BgL_paramz00); 
PROCEDURE_ENTRY(BgL_fun2630z00_6474)(BgL_fun2630z00_6474, BgL_arg2627z00_6475, 
BINT(((long)0)), BgL_arg2628z00_6476, 
BINT(((long)0)), BgL_arg2629z00_6477, BEOA); } } }  else 
{ /* Llib/block_ciphers.scm 421 */BFALSE; } 
{ /* Llib/block_ciphers.scm 425 */
long BgL_arg2631z00_6478;long BgL_arg2632z00_6479;obj_t BgL_arg2633z00_6480;
BgL_arg2631z00_6478 = 
(
(long)CINT(BgL_tozd2poszd2_5532)+
(long)CINT(BgL_atz00_5533)); 
BgL_arg2632z00_6479 = 
(
(long)CINT(BgL_fromzd2poszd2_5530)+
(long)CINT(BgL_atz00_5533)); 
BgL_arg2633z00_6480 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_5528)))->BgL_noncezd2strzd2); 
{ 
long BgL_iz00_6482;
BgL_iz00_6482 = ((long)0); 
BgL_loopz00_6481:
if(
(BgL_iz00_6482==
(BgL_arg2631z00_6478+
(long)CINT(BgL_lenz00_5534))))
{ /* Llib/block_ciphers.scm 128 */
BgL_tmpz00_11563 = ((bool_t)0)
; }  else 
{ /* Llib/block_ciphers.scm 128 */
{ /* Llib/block_ciphers.scm 129 */
long BgL_arg1517z00_6483;unsigned char BgL_arg1523z00_6484;
BgL_arg1517z00_6483 = 
(BgL_arg2631z00_6478+BgL_iz00_6482); 
BgL_arg1523z00_6484 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_fromz00_5529), 
(BgL_arg2632z00_6479+BgL_iz00_6482))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2633z00_6480, 
(
(long)CINT(BgL_atz00_5533)+BgL_iz00_6482)))))))); 
{ /* Llib/block_ciphers.scm 129 */
unsigned char BgL_charz00_6485;
BgL_charz00_6485 = 
(unsigned char)(BgL_arg1523z00_6484); 
{ /* Llib/block_ciphers.scm 129 */
obj_t BgL_tmpz00_11636;
BgL_tmpz00_11636 = 
((obj_t)BgL_toz00_5531); 
STRING_SET(BgL_tmpz00_11636, BgL_arg1517z00_6483, BgL_charz00_6485); } } } 
{ 
long BgL_iz00_11639;
BgL_iz00_11639 = 
(BgL_iz00_6482+((long)1)); 
BgL_iz00_6482 = BgL_iz00_11639; 
goto BgL_loopz00_6481;} } } } 
return 
BBOOL(BgL_tmpz00_11563);} } 
BGL_FUNCTION_END;
}



/* &do-cipher-block!-CTR1352 */
obj_t BGl_z62dozd2cipherzd2blockz12zd2CTR1352za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5535, obj_t BgL_statez00_5536, obj_t BgL_fromz00_5537, obj_t BgL_fromzd2poszd2_5538, obj_t BgL_toz00_5539, obj_t BgL_tozd2poszd2_5540)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 410 */
{ /* Llib/block_ciphers.scm 413 */
obj_t BgL_fun2613z00_6487;
BgL_fun2613z00_6487 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_5536)))->BgL_noncezd2updatez12zc0); 
{ /* Llib/block_ciphers.scm 413 */
obj_t BgL_arg2610z00_6488;obj_t BgL_arg2611z00_6489;long BgL_arg2612z00_6490;
BgL_arg2610z00_6488 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_5536)))->BgL_noncezd2strzd2); 
BgL_arg2611z00_6489 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_5536)))->BgL_noncez00); 
BgL_arg2612z00_6490 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_5536)))->BgL_blockzd2counterzd2); 
PROCEDURE_ENTRY(BgL_fun2613z00_6487)(BgL_fun2613z00_6487, BgL_arg2610z00_6488, BgL_arg2611z00_6489, 
BINT(BgL_arg2612z00_6490), BEOA); } } 
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_5536)))->BgL_blockzd2counterzd2)=((long)
(
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_5536)))->BgL_blockzd2counterzd2)+((long)1))),BUNSPEC); 
{ /* Llib/block_ciphers.scm 415 */
obj_t BgL_fun2618z00_6491;
BgL_fun2618z00_6491 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ctrz00_bglt)BgL_statez00_5536))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 415 */
obj_t BgL_arg2615z00_6492;obj_t BgL_arg2616z00_6493;obj_t BgL_arg2617z00_6494;
BgL_arg2615z00_6492 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_5536)))->BgL_noncezd2strzd2); 
BgL_arg2616z00_6493 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_5536)))->BgL_noncezd2strzd2); 
BgL_arg2617z00_6494 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ctrz00_bglt)BgL_statez00_5536))))->BgL_paramz00); 
PROCEDURE_ENTRY(BgL_fun2618z00_6491)(BgL_fun2618z00_6491, BgL_arg2615z00_6492, 
BINT(((long)0)), BgL_arg2616z00_6493, 
BINT(((long)0)), BgL_arg2617z00_6494, BEOA); } } 
{ /* Llib/block_ciphers.scm 416 */
obj_t BgL_arg2619z00_6495;long BgL_arg2620z00_6496;
BgL_arg2619z00_6495 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_5536)))->BgL_noncezd2strzd2); 
BgL_arg2620z00_6496 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ctrz00_bglt)BgL_statez00_5536))))->BgL_blockzd2siza7ez75); 
{ 
long BgL_iz00_6498;
BgL_iz00_6498 = ((long)0); 
BgL_loopz00_6497:
if(
(BgL_iz00_6498==BgL_arg2620z00_6496))
{ /* Llib/block_ciphers.scm 416 */
return BgL_toz00_5539;}  else 
{ /* Llib/block_ciphers.scm 416 */
{ /* Llib/block_ciphers.scm 416 */
long BgL_arg2636z00_6499;unsigned char BgL_arg2637z00_6500;
BgL_arg2636z00_6499 = 
(
(long)CINT(BgL_tozd2poszd2_5540)+BgL_iz00_6498); 
BgL_arg2637z00_6500 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_fromz00_5537), 
(
(long)CINT(BgL_fromzd2poszd2_5538)+BgL_iz00_6498))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2619z00_6495, 
(((long)0)+BgL_iz00_6498)))))))); 
{ /* Llib/block_ciphers.scm 416 */
unsigned char BgL_charz00_6501;
BgL_charz00_6501 = 
(unsigned char)(BgL_arg2637z00_6500); 
{ /* Llib/block_ciphers.scm 416 */
obj_t BgL_tmpz00_11707;
BgL_tmpz00_11707 = 
((obj_t)BgL_toz00_5539); 
STRING_SET(BgL_tmpz00_11707, BgL_arg2636z00_6499, BgL_charz00_6501); } } } 
{ 
long BgL_iz00_11710;
BgL_iz00_11710 = 
(BgL_iz00_6498+((long)1)); 
BgL_iz00_6498 = BgL_iz00_11710; 
goto BgL_loopz00_6497;} } } } } 
BGL_FUNCTION_END;
}



/* &do-cipher-IV-init!-C1350 */
obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2C1350z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5541, obj_t BgL_statez00_5542, obj_t BgL_ivz00_5543)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 406 */
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_5542)))->BgL_noncez00)=((obj_t)BgL_ivz00_5543),BUNSPEC); 
{ /* Llib/block_ciphers.scm 409 */
obj_t BgL_fun2609z00_6503;
BgL_fun2609z00_6503 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_5542)))->BgL_noncezd2initz12zc0); 
{ /* Llib/block_ciphers.scm 409 */
obj_t BgL_arg2607z00_6504;obj_t BgL_arg2608z00_6505;
BgL_arg2607z00_6504 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_5542)))->BgL_noncezd2strzd2); 
BgL_arg2608z00_6505 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_5542)))->BgL_noncez00); 
return 
PROCEDURE_ENTRY(BgL_fun2609z00_6503)(BgL_fun2609z00_6503, BgL_arg2607z00_6504, BgL_arg2608z00_6505, BEOA);} } } 
BGL_FUNCTION_END;
}



/* &do-cipher-partial-bl1348 */
obj_t BGl_z62dozd2cipherzd2partialzd2bl1348zb0zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5544, obj_t BgL_statez00_5545, obj_t BgL_fromz00_5546, obj_t BgL_fromzd2poszd2_5547, obj_t BgL_toz00_5548, obj_t BgL_tozd2poszd2_5549, obj_t BgL_atz00_5550, obj_t BgL_lenz00_5551)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 382 */
{ /* Llib/block_ciphers.scm 384 */
bool_t BgL_tmpz00_11725;
if(
(
(long)CINT(BgL_atz00_5550)==((long)0)))
{ /* Llib/block_ciphers.scm 386 */
obj_t BgL_fun2603z00_6507;
BgL_fun2603z00_6507 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ofbz00_bglt)BgL_statez00_5545))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 386 */
obj_t BgL_arg2600z00_6508;obj_t BgL_arg2601z00_6509;obj_t BgL_arg2602z00_6510;
BgL_arg2600z00_6508 = 
(((BgL_ofbz00_bglt)COBJECT(
((BgL_ofbz00_bglt)BgL_statez00_5545)))->BgL_chainz00); 
BgL_arg2601z00_6509 = 
(((BgL_ofbz00_bglt)COBJECT(
((BgL_ofbz00_bglt)BgL_statez00_5545)))->BgL_chainz00); 
BgL_arg2602z00_6510 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ofbz00_bglt)BgL_statez00_5545))))->BgL_paramz00); 
PROCEDURE_ENTRY(BgL_fun2603z00_6507)(BgL_fun2603z00_6507, BgL_arg2600z00_6508, 
BINT(((long)0)), BgL_arg2601z00_6509, 
BINT(((long)0)), BgL_arg2602z00_6510, BEOA); } }  else 
{ /* Llib/block_ciphers.scm 385 */BFALSE; } 
{ /* Llib/block_ciphers.scm 387 */
long BgL_arg2604z00_6511;long BgL_arg2605z00_6512;obj_t BgL_arg2606z00_6513;
BgL_arg2604z00_6511 = 
(
(long)CINT(BgL_tozd2poszd2_5549)+
(long)CINT(BgL_atz00_5550)); 
BgL_arg2605z00_6512 = 
(
(long)CINT(BgL_fromzd2poszd2_5547)+
(long)CINT(BgL_atz00_5550)); 
BgL_arg2606z00_6513 = 
(((BgL_ofbz00_bglt)COBJECT(
((BgL_ofbz00_bglt)BgL_statez00_5545)))->BgL_chainz00); 
{ 
long BgL_iz00_6515;
BgL_iz00_6515 = ((long)0); 
BgL_loopz00_6514:
if(
(BgL_iz00_6515==
(BgL_arg2604z00_6511+
(long)CINT(BgL_lenz00_5551))))
{ /* Llib/block_ciphers.scm 128 */
BgL_tmpz00_11725 = ((bool_t)0)
; }  else 
{ /* Llib/block_ciphers.scm 128 */
{ /* Llib/block_ciphers.scm 129 */
long BgL_arg1517z00_6516;unsigned char BgL_arg1523z00_6517;
BgL_arg1517z00_6516 = 
(BgL_arg2604z00_6511+BgL_iz00_6515); 
BgL_arg1523z00_6517 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_fromz00_5546), 
(BgL_arg2605z00_6512+BgL_iz00_6515))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2606z00_6513, 
(
(long)CINT(BgL_atz00_5550)+BgL_iz00_6515)))))))); 
{ /* Llib/block_ciphers.scm 129 */
unsigned char BgL_charz00_6518;
BgL_charz00_6518 = 
(unsigned char)(BgL_arg1523z00_6517); 
{ /* Llib/block_ciphers.scm 129 */
obj_t BgL_tmpz00_11778;
BgL_tmpz00_11778 = 
((obj_t)BgL_toz00_5548); 
STRING_SET(BgL_tmpz00_11778, BgL_arg1517z00_6516, BgL_charz00_6518); } } } 
{ 
long BgL_iz00_11781;
BgL_iz00_11781 = 
(BgL_iz00_6515+((long)1)); 
BgL_iz00_6515 = BgL_iz00_11781; 
goto BgL_loopz00_6514;} } } } 
return 
BBOOL(BgL_tmpz00_11725);} } 
BGL_FUNCTION_END;
}



/* &do-cipher-block!-OFB1346 */
obj_t BGl_z62dozd2cipherzd2blockz12zd2OFB1346za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5552, obj_t BgL_statez00_5553, obj_t BgL_fromz00_5554, obj_t BgL_fromzd2poszd2_5555, obj_t BgL_toz00_5556, obj_t BgL_tozd2poszd2_5557)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 378 */
{ /* Llib/block_ciphers.scm 380 */
obj_t BgL_fun2596z00_6520;
BgL_fun2596z00_6520 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ofbz00_bglt)BgL_statez00_5553))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 380 */
obj_t BgL_arg2593z00_6521;obj_t BgL_arg2594z00_6522;obj_t BgL_arg2595z00_6523;
BgL_arg2593z00_6521 = 
(((BgL_ofbz00_bglt)COBJECT(
((BgL_ofbz00_bglt)BgL_statez00_5553)))->BgL_chainz00); 
BgL_arg2594z00_6522 = 
(((BgL_ofbz00_bglt)COBJECT(
((BgL_ofbz00_bglt)BgL_statez00_5553)))->BgL_chainz00); 
BgL_arg2595z00_6523 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ofbz00_bglt)BgL_statez00_5553))))->BgL_paramz00); 
PROCEDURE_ENTRY(BgL_fun2596z00_6520)(BgL_fun2596z00_6520, BgL_arg2593z00_6521, 
BINT(((long)0)), BgL_arg2594z00_6522, 
BINT(((long)0)), BgL_arg2595z00_6523, BEOA); } } 
{ /* Llib/block_ciphers.scm 381 */
obj_t BgL_arg2597z00_6524;long BgL_arg2598z00_6525;
BgL_arg2597z00_6524 = 
(((BgL_ofbz00_bglt)COBJECT(
((BgL_ofbz00_bglt)BgL_statez00_5553)))->BgL_chainz00); 
BgL_arg2598z00_6525 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ofbz00_bglt)BgL_statez00_5553))))->BgL_blockzd2siza7ez75); 
{ 
long BgL_iz00_6527;
BgL_iz00_6527 = ((long)0); 
BgL_loopz00_6526:
if(
(BgL_iz00_6527==BgL_arg2598z00_6525))
{ /* Llib/block_ciphers.scm 381 */
return BgL_toz00_5556;}  else 
{ /* Llib/block_ciphers.scm 381 */
{ /* Llib/block_ciphers.scm 381 */
long BgL_arg2636z00_6528;unsigned char BgL_arg2637z00_6529;
BgL_arg2636z00_6528 = 
(
(long)CINT(BgL_tozd2poszd2_5557)+BgL_iz00_6527); 
BgL_arg2637z00_6529 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_fromz00_5554), 
(
(long)CINT(BgL_fromzd2poszd2_5555)+BgL_iz00_6527))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2597z00_6524, 
(((long)0)+BgL_iz00_6527)))))))); 
{ /* Llib/block_ciphers.scm 381 */
unsigned char BgL_charz00_6530;
BgL_charz00_6530 = 
(unsigned char)(BgL_arg2637z00_6529); 
{ /* Llib/block_ciphers.scm 381 */
obj_t BgL_tmpz00_11829;
BgL_tmpz00_11829 = 
((obj_t)BgL_toz00_5556); 
STRING_SET(BgL_tmpz00_11829, BgL_arg2636z00_6528, BgL_charz00_6530); } } } 
{ 
long BgL_iz00_11832;
BgL_iz00_11832 = 
(BgL_iz00_6527+((long)1)); 
BgL_iz00_6527 = BgL_iz00_11832; 
goto BgL_loopz00_6526;} } } } } 
BGL_FUNCTION_END;
}



/* &do-cipher-IV-init!-O1344 */
obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2O1344z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5558, obj_t BgL_statez00_5559, obj_t BgL_ivz00_5560)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 375 */
{ /* Llib/block_ciphers.scm 377 */
obj_t BgL_arg2591z00_6532;long BgL_arg2592z00_6533;
BgL_arg2591z00_6532 = 
(((BgL_ofbz00_bglt)COBJECT(
((BgL_ofbz00_bglt)BgL_statez00_5559)))->BgL_chainz00); 
BgL_arg2592z00_6533 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ofbz00_bglt)BgL_statez00_5559))))->BgL_blockzd2siza7ez75); 
return 
blit_string(
((obj_t)BgL_ivz00_5560), ((long)0), BgL_arg2591z00_6532, ((long)0), BgL_arg2592z00_6533);} } 
BGL_FUNCTION_END;
}



/* &do-cipher-partial-bl1342 */
obj_t BGl_z62dozd2cipherzd2partialzd2bl1342zb0zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5561, obj_t BgL_statez00_5562, obj_t BgL_fromz00_5563, obj_t BgL_fromzd2poszd2_5564, obj_t BgL_toz00_5565, obj_t BgL_tozd2poszd2_5566, obj_t BgL_atz00_5567, obj_t BgL_lenz00_5568)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 356 */
{ /* Llib/block_ciphers.scm 358 */
bool_t BgL_tmpz00_11841;
if(
(
(long)CINT(BgL_atz00_5567)==((long)0)))
{ /* Llib/block_ciphers.scm 360 */
obj_t BgL_fun2585z00_6535;
BgL_fun2585z00_6535 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5562))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 360 */
obj_t BgL_arg2582z00_6536;obj_t BgL_arg2583z00_6537;obj_t BgL_arg2584z00_6538;
BgL_arg2582z00_6536 = 
(((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5562)))->BgL_chainz00); 
BgL_arg2583z00_6537 = 
(((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5562)))->BgL_bufferz00); 
BgL_arg2584z00_6538 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5562))))->BgL_paramz00); 
PROCEDURE_ENTRY(BgL_fun2585z00_6535)(BgL_fun2585z00_6535, BgL_arg2582z00_6536, 
BINT(((long)0)), BgL_arg2583z00_6537, 
BINT(((long)0)), BgL_arg2584z00_6538, BEOA); } }  else 
{ /* Llib/block_ciphers.scm 359 */BFALSE; } 
{ /* Llib/block_ciphers.scm 361 */
long BgL_arg2586z00_6539;obj_t BgL_arg2587z00_6540;
BgL_arg2586z00_6539 = 
(
(long)CINT(BgL_fromzd2poszd2_5564)+
(long)CINT(BgL_atz00_5567)); 
BgL_arg2587z00_6540 = 
(((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5562)))->BgL_chainz00); 
{ /* Llib/block_ciphers.scm 361 */
long BgL_o2z00_6541;long BgL_lz00_6542;
BgL_o2z00_6541 = 
(long)CINT(BgL_atz00_5567); 
BgL_lz00_6542 = 
(long)CINT(BgL_lenz00_5568); 
blit_string(
((obj_t)BgL_fromz00_5563), BgL_arg2586z00_6539, BgL_arg2587z00_6540, BgL_o2z00_6541, BgL_lz00_6542); } } 
{ /* Llib/block_ciphers.scm 362 */
long BgL_arg2588z00_6543;obj_t BgL_arg2589z00_6544;long BgL_arg2590z00_6545;
BgL_arg2588z00_6543 = 
(
(long)CINT(BgL_tozd2poszd2_5566)+
(long)CINT(BgL_atz00_5567)); 
BgL_arg2589z00_6544 = 
(((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5562)))->BgL_bufferz00); 
BgL_arg2590z00_6545 = 
(
(long)CINT(BgL_fromzd2poszd2_5564)+
(long)CINT(BgL_atz00_5567)); 
{ 
long BgL_iz00_6547;
BgL_iz00_6547 = ((long)0); 
BgL_loopz00_6546:
if(
(BgL_iz00_6547==
(BgL_arg2588z00_6543+
(long)CINT(BgL_lenz00_5568))))
{ /* Llib/block_ciphers.scm 128 */
BgL_tmpz00_11841 = ((bool_t)0)
; }  else 
{ /* Llib/block_ciphers.scm 128 */
{ /* Llib/block_ciphers.scm 129 */
long BgL_arg1517z00_6548;unsigned char BgL_arg1523z00_6549;
BgL_arg1517z00_6548 = 
(BgL_arg2588z00_6543+BgL_iz00_6547); 
BgL_arg1523z00_6549 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2589z00_6544, 
(((long)0)+BgL_iz00_6547))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_fromz00_5563), 
(BgL_arg2590z00_6545+BgL_iz00_6547)))))))); 
{ /* Llib/block_ciphers.scm 129 */
unsigned char BgL_charz00_6550;
BgL_charz00_6550 = 
(unsigned char)(BgL_arg1523z00_6549); 
{ /* Llib/block_ciphers.scm 129 */
obj_t BgL_tmpz00_11902;
BgL_tmpz00_11902 = 
((obj_t)BgL_toz00_5565); 
STRING_SET(BgL_tmpz00_11902, BgL_arg1517z00_6548, BgL_charz00_6550); } } } 
{ 
long BgL_iz00_11905;
BgL_iz00_11905 = 
(BgL_iz00_6547+((long)1)); 
BgL_iz00_6547 = BgL_iz00_11905; 
goto BgL_loopz00_6546;} } } } 
return 
BBOOL(BgL_tmpz00_11841);} } 
BGL_FUNCTION_END;
}



/* &do-cipher-block!-CFB1340 */
obj_t BGl_z62dozd2cipherzd2blockz12zd2CFB1340za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5569, obj_t BgL_statez00_5570, obj_t BgL_fromz00_5571, obj_t BgL_fromzd2poszd2_5572, obj_t BgL_toz00_5573, obj_t BgL_tozd2poszd2_5574)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 351 */
{ /* Llib/block_ciphers.scm 353 */
obj_t BgL_fun2576z00_6552;
BgL_fun2576z00_6552 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5570))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 353 */
obj_t BgL_arg2573z00_6553;obj_t BgL_arg2574z00_6554;obj_t BgL_arg2575z00_6555;
BgL_arg2573z00_6553 = 
(((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5570)))->BgL_chainz00); 
BgL_arg2574z00_6554 = 
(((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5570)))->BgL_bufferz00); 
BgL_arg2575z00_6555 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5570))))->BgL_paramz00); 
PROCEDURE_ENTRY(BgL_fun2576z00_6552)(BgL_fun2576z00_6552, BgL_arg2573z00_6553, 
BINT(((long)0)), BgL_arg2574z00_6554, 
BINT(((long)0)), BgL_arg2575z00_6555, BEOA); } } 
{ /* Llib/block_ciphers.scm 354 */
obj_t BgL_arg2577z00_6556;long BgL_arg2578z00_6557;
BgL_arg2577z00_6556 = 
(((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5570)))->BgL_chainz00); 
BgL_arg2578z00_6557 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5570))))->BgL_blockzd2siza7ez75); 
{ /* Llib/block_ciphers.scm 354 */
long BgL_o1z00_6558;
BgL_o1z00_6558 = 
(long)CINT(BgL_fromzd2poszd2_5572); 
blit_string(
((obj_t)BgL_fromz00_5571), BgL_o1z00_6558, BgL_arg2577z00_6556, ((long)0), BgL_arg2578z00_6557); } } 
{ /* Llib/block_ciphers.scm 355 */
obj_t BgL_arg2579z00_6559;long BgL_arg2580z00_6560;
BgL_arg2579z00_6559 = 
(((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5570)))->BgL_bufferz00); 
BgL_arg2580z00_6560 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5570))))->BgL_blockzd2siza7ez75); 
{ 
long BgL_iz00_6562;
BgL_iz00_6562 = ((long)0); 
BgL_loopz00_6561:
if(
(BgL_iz00_6562==BgL_arg2580z00_6560))
{ /* Llib/block_ciphers.scm 355 */
return BgL_toz00_5573;}  else 
{ /* Llib/block_ciphers.scm 355 */
{ /* Llib/block_ciphers.scm 355 */
long BgL_arg2636z00_6563;unsigned char BgL_arg2637z00_6564;
BgL_arg2636z00_6563 = 
(
(long)CINT(BgL_tozd2poszd2_5574)+BgL_iz00_6562); 
BgL_arg2637z00_6564 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2579z00_6559, 
(((long)0)+BgL_iz00_6562))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_fromz00_5571), 
(
(long)CINT(BgL_fromzd2poszd2_5572)+BgL_iz00_6562)))))))); 
{ /* Llib/block_ciphers.scm 355 */
unsigned char BgL_charz00_6565;
BgL_charz00_6565 = 
(unsigned char)(BgL_arg2637z00_6564); 
{ /* Llib/block_ciphers.scm 355 */
obj_t BgL_tmpz00_11961;
BgL_tmpz00_11961 = 
((obj_t)BgL_toz00_5573); 
STRING_SET(BgL_tmpz00_11961, BgL_arg2636z00_6563, BgL_charz00_6565); } } } 
{ 
long BgL_iz00_11964;
BgL_iz00_11964 = 
(BgL_iz00_6562+((long)1)); 
BgL_iz00_6562 = BgL_iz00_11964; 
goto BgL_loopz00_6561;} } } } } 
BGL_FUNCTION_END;
}



/* &do-cipher-IV-init!-C1338 */
obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2C1338z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5575, obj_t BgL_statez00_5576, obj_t BgL_ivz00_5577)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 348 */
{ /* Llib/block_ciphers.scm 350 */
obj_t BgL_arg2571z00_6567;long BgL_arg2572z00_6568;
BgL_arg2571z00_6567 = 
(((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5576)))->BgL_chainz00); 
BgL_arg2572z00_6568 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5576))))->BgL_blockzd2siza7ez75); 
return 
blit_string(
((obj_t)BgL_ivz00_5577), ((long)0), BgL_arg2571z00_6567, ((long)0), BgL_arg2572z00_6568);} } 
BGL_FUNCTION_END;
}



/* &do-cipher-partial-bl1336 */
obj_t BGl_z62dozd2cipherzd2partialzd2bl1336zb0zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5578, obj_t BgL_statez00_5579, obj_t BgL_fromz00_5580, obj_t BgL_fromzd2poszd2_5581, obj_t BgL_toz00_5582, obj_t BgL_tozd2poszd2_5583, obj_t BgL_atz00_5584, obj_t BgL_lenz00_5585)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 332 */
if(
(
(long)CINT(BgL_atz00_5584)==((long)0)))
{ /* Llib/block_ciphers.scm 336 */
obj_t BgL_fun2565z00_6570;
BgL_fun2565z00_6570 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5579))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 336 */
obj_t BgL_arg2562z00_6571;obj_t BgL_arg2563z00_6572;obj_t BgL_arg2564z00_6573;
BgL_arg2562z00_6571 = 
(((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5579)))->BgL_chainz00); 
BgL_arg2563z00_6572 = 
(((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5579)))->BgL_chainz00); 
BgL_arg2564z00_6573 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5579))))->BgL_paramz00); 
PROCEDURE_ENTRY(BgL_fun2565z00_6570)(BgL_fun2565z00_6570, BgL_arg2562z00_6571, 
BINT(((long)0)), BgL_arg2563z00_6572, 
BINT(((long)0)), BgL_arg2564z00_6573, BEOA); } }  else 
{ /* Llib/block_ciphers.scm 335 */BFALSE; } 
{ /* Llib/block_ciphers.scm 337 */
obj_t BgL_arg2566z00_6574;obj_t BgL_arg2567z00_6575;long BgL_arg2568z00_6576;
BgL_arg2566z00_6574 = 
(((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5579)))->BgL_chainz00); 
BgL_arg2567z00_6575 = 
(((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5579)))->BgL_chainz00); 
BgL_arg2568z00_6576 = 
(
(long)CINT(BgL_fromzd2poszd2_5581)+
(long)CINT(BgL_atz00_5584)); 
{ 
long BgL_iz00_6578;
BgL_iz00_6578 = ((long)0); 
BgL_loopz00_6577:
if(
(BgL_iz00_6578==
(
(long)CINT(BgL_atz00_5584)+
(long)CINT(BgL_lenz00_5585))))
{ /* Llib/block_ciphers.scm 128 */((bool_t)0); }  else 
{ /* Llib/block_ciphers.scm 128 */
{ /* Llib/block_ciphers.scm 129 */
long BgL_arg1517z00_6579;unsigned char BgL_arg1523z00_6580;
BgL_arg1517z00_6579 = 
(
(long)CINT(BgL_atz00_5584)+BgL_iz00_6578); 
BgL_arg1523z00_6580 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2567z00_6575, 
(
(long)CINT(BgL_atz00_5584)+BgL_iz00_6578))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_fromz00_5580), 
(BgL_arg2568z00_6576+BgL_iz00_6578)))))))); 
{ /* Llib/block_ciphers.scm 129 */
unsigned char BgL_tmpz00_12025;
BgL_tmpz00_12025 = 
(unsigned char)(BgL_arg1523z00_6580); 
STRING_SET(BgL_arg2566z00_6574, BgL_arg1517z00_6579, BgL_tmpz00_12025); } } 
{ 
long BgL_iz00_12028;
BgL_iz00_12028 = 
(BgL_iz00_6578+((long)1)); 
BgL_iz00_6578 = BgL_iz00_12028; 
goto BgL_loopz00_6577;} } } } 
{ /* Llib/block_ciphers.scm 338 */
obj_t BgL_arg2569z00_6581;long BgL_arg2570z00_6582;
BgL_arg2569z00_6581 = 
(((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5579)))->BgL_chainz00); 
BgL_arg2570z00_6582 = 
(
(long)CINT(BgL_tozd2poszd2_5583)+
(long)CINT(BgL_atz00_5584)); 
{ /* Llib/block_ciphers.scm 338 */
long BgL_o1z00_6583;long BgL_lz00_6584;
BgL_o1z00_6583 = 
(long)CINT(BgL_atz00_5584); 
BgL_lz00_6584 = 
(long)CINT(BgL_lenz00_5585); 
return 
blit_string(BgL_arg2569z00_6581, BgL_o1z00_6583, 
((obj_t)BgL_toz00_5582), BgL_arg2570z00_6582, BgL_lz00_6584);} } } 
BGL_FUNCTION_END;
}



/* &do-cipher-block!-CFB1334 */
obj_t BGl_z62dozd2cipherzd2blockz12zd2CFB1334za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5586, obj_t BgL_statez00_5587, obj_t BgL_fromz00_5588, obj_t BgL_fromzd2poszd2_5589, obj_t BgL_toz00_5590, obj_t BgL_tozd2poszd2_5591)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 327 */
{ /* Llib/block_ciphers.scm 329 */
obj_t BgL_fun2555z00_6586;
BgL_fun2555z00_6586 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5587))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 329 */
obj_t BgL_arg2552z00_6587;obj_t BgL_arg2553z00_6588;obj_t BgL_arg2554z00_6589;
BgL_arg2552z00_6587 = 
(((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5587)))->BgL_chainz00); 
BgL_arg2553z00_6588 = 
(((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5587)))->BgL_chainz00); 
BgL_arg2554z00_6589 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5587))))->BgL_paramz00); 
PROCEDURE_ENTRY(BgL_fun2555z00_6586)(BgL_fun2555z00_6586, BgL_arg2552z00_6587, 
BINT(((long)0)), BgL_arg2553z00_6588, 
BINT(((long)0)), BgL_arg2554z00_6589, BEOA); } } 
{ /* Llib/block_ciphers.scm 330 */
obj_t BgL_arg2556z00_6590;obj_t BgL_arg2557z00_6591;long BgL_arg2558z00_6592;
BgL_arg2556z00_6590 = 
(((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5587)))->BgL_chainz00); 
BgL_arg2557z00_6591 = 
(((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5587)))->BgL_chainz00); 
BgL_arg2558z00_6592 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5587))))->BgL_blockzd2siza7ez75); 
{ 
long BgL_iz00_6594;
BgL_iz00_6594 = ((long)0); 
BgL_loopz00_6593:
if(
(BgL_iz00_6594==BgL_arg2558z00_6592))
{ /* Llib/block_ciphers.scm 330 */BgL_arg2556z00_6590; }  else 
{ /* Llib/block_ciphers.scm 330 */
{ /* Llib/block_ciphers.scm 330 */
long BgL_arg2636z00_6595;unsigned char BgL_arg2637z00_6596;
BgL_arg2636z00_6595 = 
(((long)0)+BgL_iz00_6594); 
BgL_arg2637z00_6596 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_fromz00_5588), 
(
(long)CINT(BgL_fromzd2poszd2_5589)+BgL_iz00_6594))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2557z00_6591, 
(((long)0)+BgL_iz00_6594)))))))); 
{ /* Llib/block_ciphers.scm 330 */
unsigned char BgL_tmpz00_12084;
BgL_tmpz00_12084 = 
(unsigned char)(BgL_arg2637z00_6596); 
STRING_SET(BgL_arg2556z00_6590, BgL_arg2636z00_6595, BgL_tmpz00_12084); } } 
{ 
long BgL_iz00_12087;
BgL_iz00_12087 = 
(BgL_iz00_6594+((long)1)); 
BgL_iz00_6594 = BgL_iz00_12087; 
goto BgL_loopz00_6593;} } } } 
{ /* Llib/block_ciphers.scm 331 */
obj_t BgL_arg2559z00_6597;long BgL_arg2560z00_6598;
BgL_arg2559z00_6597 = 
(((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5587)))->BgL_chainz00); 
BgL_arg2560z00_6598 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5587))))->BgL_blockzd2siza7ez75); 
{ /* Llib/block_ciphers.scm 331 */
long BgL_o2z00_6599;
BgL_o2z00_6599 = 
(long)CINT(BgL_tozd2poszd2_5591); 
return 
blit_string(BgL_arg2559z00_6597, ((long)0), 
((obj_t)BgL_toz00_5590), BgL_o2z00_6599, BgL_arg2560z00_6598);} } } 
BGL_FUNCTION_END;
}



/* &do-cipher-IV-init!-C1332 */
obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2C1332z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5592, obj_t BgL_statez00_5593, obj_t BgL_ivz00_5594)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 324 */
{ /* Llib/block_ciphers.scm 326 */
obj_t BgL_arg2550z00_6601;long BgL_arg2551z00_6602;
BgL_arg2550z00_6601 = 
(((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5593)))->BgL_chainz00); 
BgL_arg2551z00_6602 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5593))))->BgL_blockzd2siza7ez75); 
return 
blit_string(
((obj_t)BgL_ivz00_5594), ((long)0), BgL_arg2550z00_6601, ((long)0), BgL_arg2551z00_6602);} } 
BGL_FUNCTION_END;
}



/* &do-cipher-block!-PCB1330 */
obj_t BGl_z62dozd2cipherzd2blockz12zd2PCB1330za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5595, obj_t BgL_statez00_5596, obj_t BgL_fromz00_5597, obj_t BgL_fromzd2poszd2_5598, obj_t BgL_toz00_5599, obj_t BgL_tozd2poszd2_5600)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 308 */
{ /* Llib/block_ciphers.scm 310 */
obj_t BgL_fun2540z00_6604;
BgL_fun2540z00_6604 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5596))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 310 */
obj_t BgL_arg2538z00_6605;obj_t BgL_arg2539z00_6606;
BgL_arg2538z00_6605 = 
(((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5596)))->BgL_bufferz00); 
BgL_arg2539z00_6606 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5596))))->BgL_paramz00); 
PROCEDURE_ENTRY(BgL_fun2540z00_6604)(BgL_fun2540z00_6604, BgL_fromz00_5597, BgL_fromzd2poszd2_5598, BgL_arg2538z00_6605, 
BINT(((long)0)), BgL_arg2539z00_6606, BEOA); } } 
{ /* Llib/block_ciphers.scm 311 */
obj_t BgL_arg2541z00_6607;obj_t BgL_arg2542z00_6608;obj_t BgL_arg2543z00_6609;long BgL_arg2544z00_6610;
BgL_arg2541z00_6607 = 
(((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5596)))->BgL_bufferz00); 
BgL_arg2542z00_6608 = 
(((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5596)))->BgL_bufferz00); 
BgL_arg2543z00_6609 = 
(((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5596)))->BgL_chainz00); 
BgL_arg2544z00_6610 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5596))))->BgL_blockzd2siza7ez75); 
{ 
long BgL_iz00_6612;
BgL_iz00_6612 = ((long)0); 
BgL_loopz00_6611:
if(
(BgL_iz00_6612==BgL_arg2544z00_6610))
{ /* Llib/block_ciphers.scm 311 */BgL_arg2541z00_6607; }  else 
{ /* Llib/block_ciphers.scm 311 */
{ /* Llib/block_ciphers.scm 311 */
long BgL_arg2636z00_6613;unsigned char BgL_arg2637z00_6614;
BgL_arg2636z00_6613 = 
(((long)0)+BgL_iz00_6612); 
BgL_arg2637z00_6614 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2542z00_6608, 
(((long)0)+BgL_iz00_6612))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2543z00_6609, 
(((long)0)+BgL_iz00_6612)))))))); 
{ /* Llib/block_ciphers.scm 311 */
unsigned char BgL_tmpz00_12146;
BgL_tmpz00_12146 = 
(unsigned char)(BgL_arg2637z00_6614); 
STRING_SET(BgL_arg2541z00_6607, BgL_arg2636z00_6613, BgL_tmpz00_12146); } } 
{ 
long BgL_iz00_12149;
BgL_iz00_12149 = 
(BgL_iz00_6612+((long)1)); 
BgL_iz00_6612 = BgL_iz00_12149; 
goto BgL_loopz00_6611;} } } } 
{ /* Llib/block_ciphers.scm 312 */
obj_t BgL_arg2545z00_6615;obj_t BgL_arg2546z00_6616;long BgL_arg2547z00_6617;
BgL_arg2545z00_6615 = 
(((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5596)))->BgL_chainz00); 
BgL_arg2546z00_6616 = 
(((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5596)))->BgL_bufferz00); 
BgL_arg2547z00_6617 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5596))))->BgL_blockzd2siza7ez75); 
{ 
long BgL_iz00_6619;
BgL_iz00_6619 = ((long)0); 
BgL_loopz00_6618:
if(
(BgL_iz00_6619==BgL_arg2547z00_6617))
{ /* Llib/block_ciphers.scm 312 */BgL_arg2545z00_6615; }  else 
{ /* Llib/block_ciphers.scm 312 */
{ /* Llib/block_ciphers.scm 312 */
long BgL_arg2636z00_6620;unsigned char BgL_arg2637z00_6621;
BgL_arg2636z00_6620 = 
(((long)0)+BgL_iz00_6619); 
BgL_arg2637z00_6621 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_fromz00_5597), 
(
(long)CINT(BgL_fromzd2poszd2_5598)+BgL_iz00_6619))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2546z00_6616, 
(((long)0)+BgL_iz00_6619)))))))); 
{ /* Llib/block_ciphers.scm 312 */
unsigned char BgL_tmpz00_12176;
BgL_tmpz00_12176 = 
(unsigned char)(BgL_arg2637z00_6621); 
STRING_SET(BgL_arg2545z00_6615, BgL_arg2636z00_6620, BgL_tmpz00_12176); } } 
{ 
long BgL_iz00_12179;
BgL_iz00_12179 = 
(BgL_iz00_6619+((long)1)); 
BgL_iz00_6619 = BgL_iz00_12179; 
goto BgL_loopz00_6618;} } } } 
{ /* Llib/block_ciphers.scm 313 */
obj_t BgL_arg2548z00_6622;long BgL_arg2549z00_6623;
BgL_arg2548z00_6622 = 
(((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5596)))->BgL_bufferz00); 
BgL_arg2549z00_6623 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5596))))->BgL_blockzd2siza7ez75); 
{ /* Llib/block_ciphers.scm 313 */
long BgL_o2z00_6624;
BgL_o2z00_6624 = 
(long)CINT(BgL_tozd2poszd2_5600); 
return 
blit_string(BgL_arg2548z00_6622, ((long)0), 
((obj_t)BgL_toz00_5599), BgL_o2z00_6624, BgL_arg2549z00_6623);} } } 
BGL_FUNCTION_END;
}



/* &do-cipher-IV-init!-P1328 */
obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2P1328z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5601, obj_t BgL_statez00_5602, obj_t BgL_ivz00_5603)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 305 */
{ /* Llib/block_ciphers.scm 307 */
obj_t BgL_arg2536z00_6626;long BgL_arg2537z00_6627;
BgL_arg2536z00_6626 = 
(((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5602)))->BgL_chainz00); 
BgL_arg2537z00_6627 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5602))))->BgL_blockzd2siza7ez75); 
return 
blit_string(
((obj_t)BgL_ivz00_5603), ((long)0), BgL_arg2536z00_6626, ((long)0), BgL_arg2537z00_6627);} } 
BGL_FUNCTION_END;
}



/* &do-cipher-block!-PCB1326 */
obj_t BGl_z62dozd2cipherzd2blockz12zd2PCB1326za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5604, obj_t BgL_statez00_5605, obj_t BgL_fromz00_5606, obj_t BgL_fromzd2poszd2_5607, obj_t BgL_toz00_5608, obj_t BgL_tozd2poszd2_5609)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 290 */
{ /* Llib/block_ciphers.scm 292 */
obj_t BgL_arg2524z00_6629;obj_t BgL_arg2525z00_6630;long BgL_arg2526z00_6631;
BgL_arg2524z00_6629 = 
(((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5605)))->BgL_bufferz00); 
BgL_arg2525z00_6630 = 
(((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5605)))->BgL_chainz00); 
BgL_arg2526z00_6631 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5605))))->BgL_blockzd2siza7ez75); 
{ 
long BgL_iz00_6633;
BgL_iz00_6633 = ((long)0); 
BgL_loopz00_6632:
if(
(BgL_iz00_6633==BgL_arg2526z00_6631))
{ /* Llib/block_ciphers.scm 292 */BgL_arg2524z00_6629; }  else 
{ /* Llib/block_ciphers.scm 292 */
{ /* Llib/block_ciphers.scm 292 */
long BgL_arg2636z00_6634;unsigned char BgL_arg2637z00_6635;
BgL_arg2636z00_6634 = 
(((long)0)+BgL_iz00_6633); 
BgL_arg2637z00_6635 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2525z00_6630, 
(((long)0)+BgL_iz00_6633))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_fromz00_5606), 
(
(long)CINT(BgL_fromzd2poszd2_5607)+BgL_iz00_6633)))))))); 
{ /* Llib/block_ciphers.scm 292 */
unsigned char BgL_tmpz00_12221;
BgL_tmpz00_12221 = 
(unsigned char)(BgL_arg2637z00_6635); 
STRING_SET(BgL_arg2524z00_6629, BgL_arg2636z00_6634, BgL_tmpz00_12221); } } 
{ 
long BgL_iz00_12224;
BgL_iz00_12224 = 
(BgL_iz00_6633+((long)1)); 
BgL_iz00_6633 = BgL_iz00_12224; 
goto BgL_loopz00_6632;} } } } 
{ /* Llib/block_ciphers.scm 293 */
obj_t BgL_fun2530z00_6636;
BgL_fun2530z00_6636 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5605))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 293 */
obj_t BgL_arg2527z00_6637;obj_t BgL_arg2528z00_6638;obj_t BgL_arg2529z00_6639;
BgL_arg2527z00_6637 = 
(((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5605)))->BgL_bufferz00); 
BgL_arg2528z00_6638 = 
(((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5605)))->BgL_bufferz00); 
BgL_arg2529z00_6639 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5605))))->BgL_paramz00); 
PROCEDURE_ENTRY(BgL_fun2530z00_6636)(BgL_fun2530z00_6636, BgL_arg2527z00_6637, 
BINT(((long)0)), BgL_arg2528z00_6638, 
BINT(((long)0)), BgL_arg2529z00_6639, BEOA); } } 
{ /* Llib/block_ciphers.scm 294 */
obj_t BgL_arg2531z00_6640;obj_t BgL_arg2532z00_6641;long BgL_arg2533z00_6642;
BgL_arg2531z00_6640 = 
(((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5605)))->BgL_chainz00); 
BgL_arg2532z00_6641 = 
(((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5605)))->BgL_bufferz00); 
BgL_arg2533z00_6642 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5605))))->BgL_blockzd2siza7ez75); 
{ 
long BgL_iz00_6644;
BgL_iz00_6644 = ((long)0); 
BgL_loopz00_6643:
if(
(BgL_iz00_6644==BgL_arg2533z00_6642))
{ /* Llib/block_ciphers.scm 294 */BgL_arg2531z00_6640; }  else 
{ /* Llib/block_ciphers.scm 294 */
{ /* Llib/block_ciphers.scm 294 */
long BgL_arg2636z00_6645;unsigned char BgL_arg2637z00_6646;
BgL_arg2636z00_6645 = 
(((long)0)+BgL_iz00_6644); 
BgL_arg2637z00_6646 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_fromz00_5606), 
(
(long)CINT(BgL_fromzd2poszd2_5607)+BgL_iz00_6644))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2532z00_6641, 
(((long)0)+BgL_iz00_6644)))))))); 
{ /* Llib/block_ciphers.scm 294 */
unsigned char BgL_tmpz00_12271;
BgL_tmpz00_12271 = 
(unsigned char)(BgL_arg2637z00_6646); 
STRING_SET(BgL_arg2531z00_6640, BgL_arg2636z00_6645, BgL_tmpz00_12271); } } 
{ 
long BgL_iz00_12274;
BgL_iz00_12274 = 
(BgL_iz00_6644+((long)1)); 
BgL_iz00_6644 = BgL_iz00_12274; 
goto BgL_loopz00_6643;} } } } 
{ /* Llib/block_ciphers.scm 295 */
obj_t BgL_arg2534z00_6647;long BgL_arg2535z00_6648;
BgL_arg2534z00_6647 = 
(((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5605)))->BgL_bufferz00); 
BgL_arg2535z00_6648 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5605))))->BgL_blockzd2siza7ez75); 
{ /* Llib/block_ciphers.scm 295 */
long BgL_o2z00_6649;
BgL_o2z00_6649 = 
(long)CINT(BgL_tozd2poszd2_5609); 
return 
blit_string(BgL_arg2534z00_6647, ((long)0), 
((obj_t)BgL_toz00_5608), BgL_o2z00_6649, BgL_arg2535z00_6648);} } } 
BGL_FUNCTION_END;
}



/* &do-cipher-IV-init!-P1324 */
obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2P1324z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5610, obj_t BgL_statez00_5611, obj_t BgL_ivz00_5612)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 287 */
{ /* Llib/block_ciphers.scm 289 */
obj_t BgL_arg2522z00_6651;long BgL_arg2523z00_6652;
BgL_arg2522z00_6651 = 
(((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5611)))->BgL_chainz00); 
BgL_arg2523z00_6652 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5611))))->BgL_blockzd2siza7ez75); 
return 
blit_string(
((obj_t)BgL_ivz00_5612), ((long)0), BgL_arg2522z00_6651, ((long)0), BgL_arg2523z00_6652);} } 
BGL_FUNCTION_END;
}



/* &do-cipher-block!-CBC1322 */
obj_t BGl_z62dozd2cipherzd2blockz12zd2CBC1322za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5613, obj_t BgL_statez00_5614, obj_t BgL_fromz00_5615, obj_t BgL_fromzd2poszd2_5616, obj_t BgL_toz00_5617, obj_t BgL_tozd2poszd2_5618)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 269 */
{ /* Llib/block_ciphers.scm 271 */
obj_t BgL_arg2515z00_6654;long BgL_arg2516z00_6655;
BgL_arg2515z00_6654 = 
(((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5614)))->BgL_bufferz00); 
BgL_arg2516z00_6655 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5614))))->BgL_blockzd2siza7ez75); 
{ /* Llib/block_ciphers.scm 271 */
long BgL_o1z00_6656;
BgL_o1z00_6656 = 
(long)CINT(BgL_fromzd2poszd2_5616); 
blit_string(
((obj_t)BgL_fromz00_5615), BgL_o1z00_6656, BgL_arg2515z00_6654, ((long)0), BgL_arg2516z00_6655); } } 
{ /* Llib/block_ciphers.scm 272 */
obj_t BgL_fun2519z00_6657;
BgL_fun2519z00_6657 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5614))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 272 */
obj_t BgL_arg2517z00_6658;obj_t BgL_arg2518z00_6659;
BgL_arg2517z00_6658 = 
(((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5614)))->BgL_bufferz00); 
BgL_arg2518z00_6659 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5614))))->BgL_paramz00); 
PROCEDURE_ENTRY(BgL_fun2519z00_6657)(BgL_fun2519z00_6657, BgL_arg2517z00_6658, 
BINT(((long)0)), BgL_toz00_5617, BgL_tozd2poszd2_5618, BgL_arg2518z00_6659, BEOA); } } 
{ /* Llib/block_ciphers.scm 273 */
obj_t BgL_arg2520z00_6660;long BgL_arg2521z00_6661;
BgL_arg2520z00_6660 = 
(((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5614)))->BgL_chainz00); 
BgL_arg2521z00_6661 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5614))))->BgL_blockzd2siza7ez75); 
{ 
long BgL_iz00_6663;
BgL_iz00_6663 = ((long)0); 
BgL_loopz00_6662:
if(
(BgL_iz00_6663==BgL_arg2521z00_6661))
{ /* Llib/block_ciphers.scm 273 */BgL_toz00_5617; }  else 
{ /* Llib/block_ciphers.scm 273 */
{ /* Llib/block_ciphers.scm 273 */
long BgL_arg2636z00_6664;unsigned char BgL_arg2637z00_6665;
BgL_arg2636z00_6664 = 
(
(long)CINT(BgL_tozd2poszd2_5618)+BgL_iz00_6663); 
BgL_arg2637z00_6665 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_toz00_5617), 
(
(long)CINT(BgL_tozd2poszd2_5618)+BgL_iz00_6663))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2520z00_6660, 
(((long)0)+BgL_iz00_6663)))))))); 
{ /* Llib/block_ciphers.scm 273 */
unsigned char BgL_charz00_6666;
BgL_charz00_6666 = 
(unsigned char)(BgL_arg2637z00_6665); 
{ /* Llib/block_ciphers.scm 273 */
obj_t BgL_tmpz00_12341;
BgL_tmpz00_12341 = 
((obj_t)BgL_toz00_5617); 
STRING_SET(BgL_tmpz00_12341, BgL_arg2636z00_6664, BgL_charz00_6666); } } } 
{ 
long BgL_iz00_12344;
BgL_iz00_12344 = 
(BgL_iz00_6663+((long)1)); 
BgL_iz00_6663 = BgL_iz00_12344; 
goto BgL_loopz00_6662;} } } } 
{ /* Llib/block_ciphers.scm 274 */
obj_t BgL_tmpz00_6667;
BgL_tmpz00_6667 = 
(((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5614)))->BgL_chainz00); 
((((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5614)))->BgL_chainz00)=((obj_t)
(((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5614)))->BgL_bufferz00)),BUNSPEC); 
return 
((((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5614)))->BgL_bufferz00)=((obj_t)BgL_tmpz00_6667),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &do-cipher-IV-init!-C1320 */
obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2C1320z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5619, obj_t BgL_statez00_5620, obj_t BgL_ivz00_5621)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 266 */
{ /* Llib/block_ciphers.scm 268 */
obj_t BgL_arg2513z00_6669;long BgL_arg2514z00_6670;
BgL_arg2513z00_6669 = 
(((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5620)))->BgL_chainz00); 
BgL_arg2514z00_6670 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5620))))->BgL_blockzd2siza7ez75); 
return 
blit_string(
((obj_t)BgL_ivz00_5621), ((long)0), BgL_arg2513z00_6669, ((long)0), BgL_arg2514z00_6670);} } 
BGL_FUNCTION_END;
}



/* &do-cipher-block!-CBC1318 */
obj_t BGl_z62dozd2cipherzd2blockz12zd2CBC1318za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5622, obj_t BgL_statez00_5623, obj_t BgL_fromz00_5624, obj_t BgL_fromzd2poszd2_5625, obj_t BgL_toz00_5626, obj_t BgL_tozd2poszd2_5627)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 252 */
{ /* Llib/block_ciphers.scm 254 */
obj_t BgL_arg2504z00_6672;obj_t BgL_arg2505z00_6673;long BgL_arg2506z00_6674;
BgL_arg2504z00_6672 = 
(((BgL_cbczd2encryptzd2_bglt)COBJECT(
((BgL_cbczd2encryptzd2_bglt)BgL_statez00_5623)))->BgL_bufferz00); 
BgL_arg2505z00_6673 = 
(((BgL_cbczd2encryptzd2_bglt)COBJECT(
((BgL_cbczd2encryptzd2_bglt)BgL_statez00_5623)))->BgL_chainz00); 
BgL_arg2506z00_6674 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2encryptzd2_bglt)BgL_statez00_5623))))->BgL_blockzd2siza7ez75); 
{ 
long BgL_iz00_6676;
BgL_iz00_6676 = ((long)0); 
BgL_loopz00_6675:
if(
(BgL_iz00_6676==BgL_arg2506z00_6674))
{ /* Llib/block_ciphers.scm 254 */BgL_arg2504z00_6672; }  else 
{ /* Llib/block_ciphers.scm 254 */
{ /* Llib/block_ciphers.scm 254 */
long BgL_arg2636z00_6677;unsigned char BgL_arg2637z00_6678;
BgL_arg2636z00_6677 = 
(((long)0)+BgL_iz00_6676); 
BgL_arg2637z00_6678 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2505z00_6673, 
(((long)0)+BgL_iz00_6676))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_fromz00_5624), 
(
(long)CINT(BgL_fromzd2poszd2_5625)+BgL_iz00_6676)))))))); 
{ /* Llib/block_ciphers.scm 254 */
unsigned char BgL_tmpz00_12386;
BgL_tmpz00_12386 = 
(unsigned char)(BgL_arg2637z00_6678); 
STRING_SET(BgL_arg2504z00_6672, BgL_arg2636z00_6677, BgL_tmpz00_12386); } } 
{ 
long BgL_iz00_12389;
BgL_iz00_12389 = 
(BgL_iz00_6676+((long)1)); 
BgL_iz00_6676 = BgL_iz00_12389; 
goto BgL_loopz00_6675;} } } } 
{ /* Llib/block_ciphers.scm 255 */
obj_t BgL_fun2510z00_6679;
BgL_fun2510z00_6679 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2encryptzd2_bglt)BgL_statez00_5623))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 255 */
obj_t BgL_arg2507z00_6680;obj_t BgL_arg2508z00_6681;obj_t BgL_arg2509z00_6682;
BgL_arg2507z00_6680 = 
(((BgL_cbczd2encryptzd2_bglt)COBJECT(
((BgL_cbczd2encryptzd2_bglt)BgL_statez00_5623)))->BgL_bufferz00); 
BgL_arg2508z00_6681 = 
(((BgL_cbczd2encryptzd2_bglt)COBJECT(
((BgL_cbczd2encryptzd2_bglt)BgL_statez00_5623)))->BgL_chainz00); 
BgL_arg2509z00_6682 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2encryptzd2_bglt)BgL_statez00_5623))))->BgL_paramz00); 
PROCEDURE_ENTRY(BgL_fun2510z00_6679)(BgL_fun2510z00_6679, BgL_arg2507z00_6680, 
BINT(((long)0)), BgL_arg2508z00_6681, 
BINT(((long)0)), BgL_arg2509z00_6682, BEOA); } } 
{ /* Llib/block_ciphers.scm 256 */
obj_t BgL_arg2511z00_6683;long BgL_arg2512z00_6684;
BgL_arg2511z00_6683 = 
(((BgL_cbczd2encryptzd2_bglt)COBJECT(
((BgL_cbczd2encryptzd2_bglt)BgL_statez00_5623)))->BgL_chainz00); 
BgL_arg2512z00_6684 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2encryptzd2_bglt)BgL_statez00_5623))))->BgL_blockzd2siza7ez75); 
{ /* Llib/block_ciphers.scm 256 */
long BgL_o2z00_6685;
BgL_o2z00_6685 = 
(long)CINT(BgL_tozd2poszd2_5627); 
return 
blit_string(BgL_arg2511z00_6683, ((long)0), 
((obj_t)BgL_toz00_5626), BgL_o2z00_6685, BgL_arg2512z00_6684);} } } 
BGL_FUNCTION_END;
}



/* &do-cipher-IV-init!-C1316 */
obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2C1316z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5628, obj_t BgL_statez00_5629, obj_t BgL_ivz00_5630)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 249 */
{ /* Llib/block_ciphers.scm 251 */
obj_t BgL_arg2502z00_6687;long BgL_arg2503z00_6688;
BgL_arg2502z00_6687 = 
(((BgL_cbczd2encryptzd2_bglt)COBJECT(
((BgL_cbczd2encryptzd2_bglt)BgL_statez00_5629)))->BgL_chainz00); 
BgL_arg2503z00_6688 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2encryptzd2_bglt)BgL_statez00_5629))))->BgL_blockzd2siza7ez75); 
return 
blit_string(
((obj_t)BgL_ivz00_5630), ((long)0), BgL_arg2502z00_6687, ((long)0), BgL_arg2503z00_6688);} } 
BGL_FUNCTION_END;
}



/* &do-cipher-block!-ECB1314 */
obj_t BGl_z62dozd2cipherzd2blockz12zd2ECB1314za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5631, obj_t BgL_statez00_5632, obj_t BgL_fromz00_5633, obj_t BgL_fromzd2poszd2_5634, obj_t BgL_toz00_5635, obj_t BgL_tozd2poszd2_5636)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 236 */
{ /* Llib/block_ciphers.scm 238 */
obj_t BgL_fun2501z00_6690;
BgL_fun2501z00_6690 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ecbzd2decryptzd2_bglt)BgL_statez00_5632))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 238 */
obj_t BgL_arg2500z00_6691;
BgL_arg2500z00_6691 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ecbzd2decryptzd2_bglt)BgL_statez00_5632))))->BgL_paramz00); 
return 
PROCEDURE_ENTRY(BgL_fun2501z00_6690)(BgL_fun2501z00_6690, BgL_fromz00_5633, BgL_fromzd2poszd2_5634, BgL_toz00_5635, BgL_tozd2poszd2_5636, BgL_arg2500z00_6691, BEOA);} } } 
BGL_FUNCTION_END;
}



/* &do-cipher-block!-ECB1312 */
obj_t BGl_z62dozd2cipherzd2blockz12zd2ECB1312za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5637, obj_t BgL_statez00_5638, obj_t BgL_fromz00_5639, obj_t BgL_fromzd2poszd2_5640, obj_t BgL_toz00_5641, obj_t BgL_tozd2poszd2_5642)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 233 */
{ /* Llib/block_ciphers.scm 235 */
obj_t BgL_fun2499z00_6693;
BgL_fun2499z00_6693 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ecbzd2encryptzd2_bglt)BgL_statez00_5638))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 235 */
obj_t BgL_arg2498z00_6694;
BgL_arg2498z00_6694 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ecbzd2encryptzd2_bglt)BgL_statez00_5638))))->BgL_paramz00); 
return 
PROCEDURE_ENTRY(BgL_fun2499z00_6693)(BgL_fun2499z00_6693, BgL_fromz00_5639, BgL_fromzd2poszd2_5640, BgL_toz00_5641, BgL_tozd2poszd2_5642, BgL_arg2498z00_6694, BEOA);} } } 
BGL_FUNCTION_END;
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__cryptozd2blockzd2ciphersz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/block_ciphers.scm 1 */
BGl_modulezd2initializa7ationz75zz__cryptozd2utilzd2(((long)300158978), 
BSTRING_TO_STRING(BGl_string3931z00zz__cryptozd2blockzd2ciphersz00)); 
BGl_modulezd2initializa7ationz75zz__cryptozd2cipherzd2paddingz00(((long)63410218), 
BSTRING_TO_STRING(BGl_string3931z00zz__cryptozd2blockzd2ciphersz00)); 
return 
BGl_modulezd2initializa7ationz75zz__cryptozd2string2keyzd2(((long)210905795), 
BSTRING_TO_STRING(BGl_string3931z00zz__cryptozd2blockzd2ciphersz00));} 
BGL_FUNCTION_END;
}

#ifdef __cplusplus
}
#endif
