/*===========================================================================*/
/*   (Llib/uvtypes.scm)                                                      */
/*   Bigloo (4.3f)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 04 Jul 2019 08:10:18 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo4.3f/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -I Llib -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -srfi libuv -copt  -safee -unsafe -copt -fPIC -copt -IClib Llib/uvtypes.scm -o objs/uvtypes.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

/* runtime code modification */
#define BGL_SELF_MODIFYING_CODE 0

#include <bigloo.h>
#include <uv.h>
#include <buv.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_z52uvz52_bgl {
   header_t header;
   obj_t widening;
} *BgL_z52uvz52_bglt;

typedef struct BgL_uvhandlez00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
} *BgL_uvhandlez00_bglt;

typedef struct BgL_uvloopz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   obj_t BgL_z52mutexz52;
} *BgL_uvloopz00_bglt;

typedef struct BgL_uvwatcherz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_cbz00;
} *BgL_uvwatcherz00_bglt;

typedef struct BgL_uvstreamz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_z52allocz52;
   obj_t BgL_z52offsetz52;
   obj_t BgL_z52procaz52;
   obj_t BgL_z52proccz52;
   obj_t BgL_z52callbackz52;
} *BgL_uvstreamz00_bglt;

typedef struct BgL_uvtcpz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_z52allocz52;
   obj_t BgL_z52offsetz52;
   obj_t BgL_z52procaz52;
   obj_t BgL_z52proccz52;
   obj_t BgL_z52callbackz52;
} *BgL_uvtcpz00_bglt;

typedef struct BgL_uvudpz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_z52allocz52;
   obj_t BgL_z52offsetz52;
   obj_t BgL_z52procaz52;
   obj_t BgL_z52proccz52;
   obj_t BgL_z52callbackz52;
   obj_t BgL_z52procmz52;
} *BgL_uvudpz00_bglt;

typedef struct BgL_uvpipez00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_z52allocz52;
   obj_t BgL_z52offsetz52;
   obj_t BgL_z52procaz52;
   obj_t BgL_z52proccz52;
   obj_t BgL_z52callbackz52;
   bool_t BgL_ipcz00;
} *BgL_uvpipez00_bglt;

typedef struct BgL_uvttyz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_z52allocz52;
   obj_t BgL_z52offsetz52;
   obj_t BgL_z52procaz52;
   obj_t BgL_z52proccz52;
   obj_t BgL_z52callbackz52;
   int BgL_fdz00;
   bool_t BgL_readablez00;
} *BgL_uvttyz00_bglt;

typedef struct BgL_uvtimerz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_cbz00;
   uint64_t BgL_repeatz00;
   bool_t BgL_refz00;
} *BgL_uvtimerz00_bglt;

typedef struct BgL_uvidlez00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_cbz00;
} *BgL_uvidlez00_bglt;

typedef struct BgL_uvasyncz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_cbz00;
} *BgL_uvasyncz00_bglt;

typedef struct BgL_uvpollz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_cbz00;
   int BgL_fdz00;
} *BgL_uvpollz00_bglt;

typedef struct BgL_uvfilez00_bgl {
   header_t header;
   obj_t widening;
   int BgL_fdz00;
   obj_t BgL_pathz00;
} *BgL_uvfilez00_bglt;

typedef struct BgL_uvfseventz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_cbz00;
} *BgL_uvfseventz00_bglt;

typedef struct BgL_uvfspollz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_cbz00;
} *BgL_uvfspollz00_bglt;

typedef struct BgL_uvcheckz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_cbz00;
} *BgL_uvcheckz00_bglt;

typedef struct BgL_uvprocessz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   obj_t BgL_z42onexitz42;
} *BgL_uvprocessz00_bglt;

typedef struct BgL_uvprocessoptionsz00_bgl {
   header_t header;
   obj_t widening;
   uv_process_options_t * BgL_z42builtinz42;
} *BgL_uvprocessoptionsz00_bglt;

typedef struct BgL_uvworkz00_bgl {
   header_t header;
   obj_t widening;
   uv_work_t * BgL_z42builtinz42;
   obj_t BgL_z52workzd2cbz80;
   obj_t BgL_z52afterzd2cbz80;
} *BgL_uvworkz00_bglt;


static obj_t BGl_z62zc3anonymousza31959ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32035ze3ze1zz__libuv_typesz00(obj_t);
static BgL_uvwatcherz00_bglt BGl_z62lambda1770z62zz__libuv_typesz00(obj_t);
static BgL_uvidlez00_bglt BGl_z62lambda1932z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62z52uvzd2initze2zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvidlez00_bglt BGl_z62lambda1935z62zz__libuv_typesz00(obj_t);
static BgL_uvloopz00_bglt BGl_z62lambda1776z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1777z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
static obj_t BGl_z62zc3anonymousza32109ze3ze1zz__libuv_typesz00(obj_t, obj_t, obj_t);
static BgL_uvasyncz00_bglt BGl_z62lambda1943z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1782z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1783z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static BgL_uvasyncz00_bglt BGl_z62lambda1946z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3anonymousza32126ze3ze1zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_uv_handle_type_symbol(int);
static BgL_uvstreamz00_bglt BGl_z62lambda1790z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_uv_guess_handle(int);
static BgL_uvpollz00_bglt BGl_z62lambda1954z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_uvstreamz00_bglt BGl_z62lambda1793z62zz__libuv_typesz00(obj_t);
static BgL_uvpollz00_bglt BGl_z62lambda1957z62zz__libuv_typesz00(obj_t);
static BgL_uvloopz00_bglt BGl_z62lambda1799z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32070ze3ze1zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1963z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1964z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31995ze3ze1zz__libuv_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvFsEventz00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza32039ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvfilez00_bglt BGl_z62lambda1970z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static BgL_uvfilez00_bglt BGl_z62lambda1972z62zz__libuv_typesz00(obj_t);
BGL_EXPORTED_DECL bool_t BGl_uvzd2gcmarkszd2emptyzf3zf3zz__libuv_typesz00(BgL_uvhandlez00_bglt);
static obj_t BGl_z62lambda1978z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1979z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32129ze3ze1zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1983z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1984z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32146ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__libuv_typesz00();
static BgL_uvfseventz00_bglt BGl_z62lambda1990z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_uvzd2pushzd2gcmarkz12z12zz__libuv_typesz00(BgL_uvhandlez00_bglt, obj_t);
static obj_t BGl_z62uvzd2handlezd2typezd2symbolzb0zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvfseventz00_bglt BGl_z62lambda1993z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3anonymousza32090ze3ze1zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32074ze3ze1zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32058ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32075ze3ze1zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32149ze3ze1zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvHandlez00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza32182ze3ze1zz__libuv_typesz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52uvzd2initz80zz__libuv_typesz00(BgL_z52uvz52_bglt);
static obj_t BGl_z62zc3anonymousza32166ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__libuv_typesz00();
BGL_EXPORTED_DEF obj_t BGl_UvLoopz00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza32094ze3ze1zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2namez00zz__objectz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvPipez00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza32095ze3ze1zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32079ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62uvzd2idzb0zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31707ze3ze1zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3anonymousza32169ze3ze1zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2accessorz00zz__objectz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvWorkz00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza31814ze3ze1zz__libuv_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvProcessz00zz__libuv_typesz00 = BUNSPEC;
extern obj_t bgl_uv_process_options_env_get(uv_process_options_t *);
static obj_t BGl_z62zc3anonymousza31743ze3ze1zz__libuv_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvTcpz00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza32189ze3ze1zz__libuv_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvPollz00zz__libuv_typesz00 = BUNSPEC;
extern void bgl_uv_process_options_env_set(uv_process_options_t *, obj_t);
static obj_t BGl_z62zc3anonymousza31835ze3ze1zz__libuv_typesz00(obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__libuv_typesz00();
static obj_t BGl_z62zc3anonymousza31926ze3ze1zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3anonymousza31765ze3ze1zz__libuv_typesz00(obj_t);
static BgL_uvworkz00_bglt BGl_z62lambda2177z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_uvzd2strerrorzd2zz__libuv_typesz00(int);
static obj_t BGl_z62objectzd2printzd2UvHandl1340z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t);
static BgL_uvworkz00_bglt BGl_z62lambda2180z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda2187z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda2188z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2namezd2zz__objectz00(obj_t);
BGL_IMPORT obj_t void_star_to_obj(void *);
static obj_t BGl_z62lambda2193z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda2194z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31678ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda2198z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda2199z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
static obj_t BGl_z62zc3anonymousza31784ze3ze1zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3anonymousza31695ze3ze1zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3anonymousza31857ze3ze1zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32006ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1800z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1805z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1806z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1812z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1813z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31891ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31875ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31948ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1819z62zz__libuv_typesz00(obj_t, obj_t);
static BgL_z52uvz52_bglt BGl_z62lambda1659z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3anonymousza32040ze3ze1zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_z52Uvz52zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1820z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1826z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1827z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static BgL_uvhandlez00_bglt BGl_z62lambda1671z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1833z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1834z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static BgL_uvhandlez00_bglt BGl_z62lambda1676z62zz__libuv_typesz00(obj_t);
static BgL_uvtcpz00_bglt BGl_z62lambda1841z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_uvtcpz00_bglt BGl_z62lambda1844z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1683z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1684z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62uvzd2strerrorzb0zz__libuv_typesz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_uv_pop_gcmark(BgL_uvhandlez00_bglt, obj_t);
static obj_t BGl_z62zc3anonymousza32116ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvudpz00_bglt BGl_z62lambda1852z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1693z62zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvudpz00_bglt BGl_z62lambda1855z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1694z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32044ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32028ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1862z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1863z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL char * BGl_uvzd2versionzd2zz__libuv_typesz00();
static BgL_uvpipez00_bglt BGl_z62lambda1870z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_uvpipez00_bglt BGl_z62lambda1873z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62uvzd2guesszd2handlez62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1879z62zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
static obj_t BGl_z62z52uvzd2init1337ze2zz__libuv_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvTtyz00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza32119ze3ze1zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1880z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvFsPollz00zz__libuv_typesz00 = BUNSPEC;
static BgL_uvttyz00_bglt BGl_z62lambda1886z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_uvttyz00_bglt BGl_z62lambda1889z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62uvzd2versionzb0zz__libuv_typesz00(obj_t);
static obj_t BGl_toplevelzd2initzd2zz__libuv_typesz00();
static obj_t BGl_z62zc3anonymousza32136ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1895z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1896z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32080ze3ze1zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__libuv_typesz00();
static obj_t BGl_z62zc3anonymousza32065ze3ze1zz__libuv_typesz00(obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62uvzd2pushzd2gcmarkz12z70zz__libuv_typesz00(obj_t, obj_t, obj_t);
extern void bgl_uv_process_options_args_set(uv_process_options_t *, obj_t);
static obj_t BGl_z62zc3anonymousza32139ze3ze1zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvIdlez00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza32156ze3ze1zz__libuv_typesz00(obj_t, obj_t);
BGL_EXPORTED_DECL int BGl_uvzd2idzd2zz__libuv_typesz00(BgL_uvhandlez00_bglt);
BGL_EXPORTED_DEF obj_t BGl_UvFilez00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza32084ze3ze1zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mutexzd2nilzd2zz__threadz00();
BGL_EXPORTED_DEF obj_t BGl_UvAsyncz00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza32085ze3ze1zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32069ze3ze1zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32159ze3ze1zz__libuv_typesz00(obj_t, obj_t, obj_t);
static BgL_uvfspollz00_bglt BGl_z62lambda2001z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_uvfspollz00_bglt BGl_z62lambda2004z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3anonymousza31821ze3ze1zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3anonymousza32089ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvcheckz00_bglt BGl_z62lambda2012z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_uvcheckz00_bglt BGl_z62lambda2015z62zz__libuv_typesz00(obj_t);
BGL_IMPORT obj_t BGl_callzd2virtualzd2setterz00zz__objectz00(BgL_objectz00_bglt, int, obj_t);
BGL_IMPORT bool_t BGl_nilzf3zf3zz__objectz00(BgL_objectz00_bglt);
static BgL_uvprocessz00_bglt BGl_z62lambda2023z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t bgl_uv_process_options_args_get(uv_process_options_t *);
static obj_t BGl_z62zc3anonymousza31912ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvprocessz00_bglt BGl_z62lambda2026z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3anonymousza31807ze3ze1zz__libuv_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvStreamz00zz__libuv_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_UvWatcherz00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62uvzd2gcmarkszd2emptyzf3z91zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static obj_t BGl_z62lambda2033z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda2034z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31719ze3ze1zz__libuv_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvProcessOptionsz00zz__libuv_typesz00 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__libuv_typesz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_callzd2virtualzd2getterz00zz__objectz00(BgL_objectz00_bglt, int);
static BgL_uvprocessoptionsz00_bglt BGl_z62lambda2053z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31664ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvprocessoptionsz00_bglt BGl_z62lambda2056z62zz__libuv_typesz00(obj_t);
BGL_IMPORT obj_t BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(long, long);
static obj_t BGl_z62lambda2063z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda2064z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvUdpz00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza31828ze3ze1zz__libuv_typesz00(obj_t);
static obj_t BGl_cnstzd2initzd2zz__libuv_typesz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__libuv_typesz00();
BGL_EXPORTED_DECL obj_t BGl_uvzd2errzd2namez00zz__libuv_typesz00(int);
static obj_t BGl_z62zc3anonymousza31772ze3ze1zz__libuv_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvTimerz00zz__libuv_typesz00 = BUNSPEC;
BGL_EXPORTED_DECL BgL_uvfilez00_bglt bgl_uv_new_file(int, obj_t);
static obj_t BGl_z62zc3anonymousza31846ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31919ze3ze1zz__libuv_typesz00(obj_t);
BGL_IMPORT obj_t BGl_objectz00zz__objectz00;
static obj_t BGl_z62zc3anonymousza32100ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31685ze3ze1zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3anonymousza31758ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32101ze3ze1zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1705z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1706z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31864ze3ze1zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3anonymousza31937ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62uvzd2popzd2gcmarkz12z70zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1717z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1718z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvCheckz00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1900z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1901z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1741z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1742z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static BgL_uvtimerz00_bglt BGl_z62lambda1907z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31795ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32106ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32017ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvtimerz00_bglt BGl_z62lambda1910z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62uvzd2errzd2namez62zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvloopz00_bglt BGl_z62lambda1752z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31974ze3ze1zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1917z62zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvloopz00_bglt BGl_z62lambda1756z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1918z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static BgL_uvfilez00_bglt BGl_z62uvzd2newzd2filez62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1924z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1763z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1925z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1764z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t __cnst[ 71 ] ;


DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2guesszd2handlezd2envzd2zz__libuv_typesz00, BgL_bgl_za762uvza7d2guessza7d22463za7, BGl_z62uvzd2guesszd2handlez62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_listzd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2400z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72464za7, BGl_z62zc3anonymousza32040ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2401z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72465za7, BGl_z62zc3anonymousza32039ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2402z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72466za7, BGl_z62zc3anonymousza32044ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2403z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72467za7, BGl_z62zc3anonymousza32028ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2404z00zz__libuv_typesz00, BgL_bgl_za762lambda2026za7622468z00, BGl_z62lambda2026z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2405z00zz__libuv_typesz00, BgL_bgl_za762lambda2023za7622469z00, BGl_z62lambda2023z62zz__libuv_typesz00, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2406z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72470za7, BGl_z62zc3anonymousza32065ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2407z00zz__libuv_typesz00, BgL_bgl_za762lambda2064za7622471z00, BGl_z62lambda2064z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2408z00zz__libuv_typesz00, BgL_bgl_za762lambda2063za7622472z00, BGl_z62lambda2063z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2409z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72473za7, BGl_z62zc3anonymousza32070ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2410z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72474za7, BGl_z62zc3anonymousza32069ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2411z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72475za7, BGl_z62zc3anonymousza32075ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2412z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72476za7, BGl_z62zc3anonymousza32074ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2413z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72477za7, BGl_z62zc3anonymousza32080ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2414z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72478za7, BGl_z62zc3anonymousza32079ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2415z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72479za7, BGl_z62zc3anonymousza32085ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2416z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72480za7, BGl_z62zc3anonymousza32084ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2417z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72481za7, BGl_z62zc3anonymousza32090ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2418z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72482za7, BGl_z62zc3anonymousza32089ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2419z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72483za7, BGl_z62zc3anonymousza32095ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2420z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72484za7, BGl_z62zc3anonymousza32094ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2421z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72485za7, BGl_z62zc3anonymousza32101ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2422z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72486za7, BGl_z62zc3anonymousza32100ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2423z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72487za7, BGl_z62zc3anonymousza32106ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2424z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72488za7, BGl_z62zc3anonymousza32109ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2425z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72489za7, BGl_z62zc3anonymousza32116ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2426z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72490za7, BGl_z62zc3anonymousza32119ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2427z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72491za7, BGl_z62zc3anonymousza32126ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2428z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72492za7, BGl_z62zc3anonymousza32129ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2429z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72493za7, BGl_z62zc3anonymousza32136ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2430z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72494za7, BGl_z62zc3anonymousza32139ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2431z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72495za7, BGl_z62zc3anonymousza32146ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2432z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72496za7, BGl_z62zc3anonymousza32149ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2433z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72497za7, BGl_z62zc3anonymousza32156ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2434z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72498za7, BGl_z62zc3anonymousza32159ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2435z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72499za7, BGl_z62zc3anonymousza32166ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2436z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72500za7, BGl_z62zc3anonymousza32169ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2437z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72501za7, BGl_z62zc3anonymousza32058ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2438z00zz__libuv_typesz00, BgL_bgl_za762lambda2056za7622502z00, BGl_z62lambda2056z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2439z00zz__libuv_typesz00, BgL_bgl_za762lambda2053za7622503z00, BGl_z62lambda2053z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2440z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72504za7, BGl_z62zc3anonymousza32189ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2441z00zz__libuv_typesz00, BgL_bgl_za762lambda2188za7622505z00, BGl_z62lambda2188z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2442z00zz__libuv_typesz00, BgL_bgl_za762lambda2187za7622506z00, BGl_z62lambda2187z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2443z00zz__libuv_typesz00, BgL_bgl_za762lambda2194za7622507z00, BGl_z62lambda2194z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2444z00zz__libuv_typesz00, BgL_bgl_za762lambda2193za7622508z00, BGl_z62lambda2193z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2445z00zz__libuv_typesz00, BgL_bgl_za762lambda2199za7622509z00, BGl_z62lambda2199z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2446z00zz__libuv_typesz00, BgL_bgl_za762lambda2198za7622510z00, BGl_z62lambda2198z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2447z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72511za7, BGl_z62zc3anonymousza32182ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2448z00zz__libuv_typesz00, BgL_bgl_za762lambda2180za7622512z00, BGl_z62lambda2180z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2449z00zz__libuv_typesz00, BgL_bgl_za762lambda2177za7622513z00, BGl_z62lambda2177z62zz__libuv_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2287z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72514za7, BGl_z62zc3anonymousza31664ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2288z00zz__libuv_typesz00, BgL_bgl_za762lambda1659za7622515z00, BGl_z62lambda1659z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2289z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72516za7, BGl_z62zc3anonymousza31685ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2450z00zz__libuv_typesz00, BgL_bgl_za762za752uvza7d2init12517za7, BGl_z62z52uvzd2init1337ze2zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2452z00zz__libuv_typesz00, BgL_bgl_za762objectza7d2prin2518z00, BGl_z62objectzd2printzd2UvHandl1340z62zz__libuv_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2290z00zz__libuv_typesz00, BgL_bgl_za762lambda1684za7622519z00, BGl_z62lambda1684z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2291z00zz__libuv_typesz00, BgL_bgl_za762lambda1683za7622520z00, BGl_z62lambda1683z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2292z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72521za7, BGl_z62zc3anonymousza31695ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2293z00zz__libuv_typesz00, BgL_bgl_za762lambda1694za7622522z00, BGl_z62lambda1694z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2294z00zz__libuv_typesz00, BgL_bgl_za762lambda1693za7622523z00, BGl_z62lambda1693z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2295z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72524za7, BGl_z62zc3anonymousza31707ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2296z00zz__libuv_typesz00, BgL_bgl_za762lambda1706za7622525z00, BGl_z62lambda1706z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2297z00zz__libuv_typesz00, BgL_bgl_za762lambda1705za7622526z00, BGl_z62lambda1705z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2298z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72527za7, BGl_z62zc3anonymousza31719ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2299z00zz__libuv_typesz00, BgL_bgl_za762lambda1718za7622528z00, BGl_z62lambda1718z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2gcmarkszd2emptyzf3zd2envz21zz__libuv_typesz00, BgL_bgl_za762uvza7d2gcmarksza72529za7, BGl_z62uvzd2gcmarkszd2emptyzf3z91zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2errzd2namezd2envzd2zz__libuv_typesz00, BgL_bgl_za762uvza7d2errza7d2na2530za7, BGl_z62uvzd2errzd2namez62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2pushzd2gcmarkz12zd2envzc0zz__libuv_typesz00, BgL_bgl_za762uvza7d2pushza7d2g2531za7, BGl_z62uvzd2pushzd2gcmarkz12z70zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2newzd2filezd2envzd2zz__libuv_typesz00, BgL_bgl_za762uvza7d2newza7d2fi2532za7, BGl_z62uvzd2newzd2filez62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2idzd2envz00zz__libuv_typesz00, BgL_bgl_za762uvza7d2idza7b0za7za7_2533za7, BGl_z62uvzd2idzb0zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2strerrorzd2envz00zz__libuv_typesz00, BgL_bgl_za762uvza7d2strerror2534z00, BGl_z62uvzd2strerrorzb0zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2300z00zz__libuv_typesz00, BgL_bgl_za762lambda1717za7622535z00, BGl_z62lambda1717z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2301z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72536za7, BGl_z62zc3anonymousza31743ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2302z00zz__libuv_typesz00, BgL_bgl_za762lambda1742za7622537z00, BGl_z62lambda1742z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2303z00zz__libuv_typesz00, BgL_bgl_za762lambda1741za7622538z00, BGl_z62lambda1741z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2304z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72539za7, BGl_z62zc3anonymousza31678ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2305z00zz__libuv_typesz00, BgL_bgl_za762lambda1676za7622540z00, BGl_z62lambda1676z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2306z00zz__libuv_typesz00, BgL_bgl_za762lambda1671za7622541z00, BGl_z62lambda1671z62zz__libuv_typesz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2307z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72542za7, BGl_z62zc3anonymousza31765ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2308z00zz__libuv_typesz00, BgL_bgl_za762lambda1764za7622543z00, BGl_z62lambda1764z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2309z00zz__libuv_typesz00, BgL_bgl_za762lambda1763za7622544z00, BGl_z62lambda1763z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2310z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72545za7, BGl_z62zc3anonymousza31758ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2311z00zz__libuv_typesz00, BgL_bgl_za762lambda1756za7622546z00, BGl_z62lambda1756z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2312z00zz__libuv_typesz00, BgL_bgl_za762lambda1752za7622547z00, BGl_z62lambda1752z62zz__libuv_typesz00, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2313z00zz__libuv_typesz00, BgL_bgl_za762lambda1777za7622548z00, BGl_z62lambda1777z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2314z00zz__libuv_typesz00, BgL_bgl_za762lambda1776za7622549z00, BGl_z62lambda1776z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2315z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72550za7, BGl_z62zc3anonymousza31784ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2316z00zz__libuv_typesz00, BgL_bgl_za762lambda1783za7622551z00, BGl_z62lambda1783z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2317z00zz__libuv_typesz00, BgL_bgl_za762lambda1782za7622552z00, BGl_z62lambda1782z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2318z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72553za7, BGl_z62zc3anonymousza31772ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2319z00zz__libuv_typesz00, BgL_bgl_za762lambda1770za7622554z00, BGl_z62lambda1770z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2320z00zz__libuv_typesz00, BgL_bgl_za762lambda1800za7622555z00, BGl_z62lambda1800z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2321z00zz__libuv_typesz00, BgL_bgl_za762lambda1799za7622556z00, BGl_z62lambda1799z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2322z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72557za7, BGl_z62zc3anonymousza31807ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2323z00zz__libuv_typesz00, BgL_bgl_za762lambda1806za7622558z00, BGl_z62lambda1806z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2324z00zz__libuv_typesz00, BgL_bgl_za762lambda1805za7622559z00, BGl_z62lambda1805z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2325z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72560za7, BGl_z62zc3anonymousza31814ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2326z00zz__libuv_typesz00, BgL_bgl_za762lambda1813za7622561z00, BGl_z62lambda1813z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2327z00zz__libuv_typesz00, BgL_bgl_za762lambda1812za7622562z00, BGl_z62lambda1812z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2328z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72563za7, BGl_z62zc3anonymousza31821ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2329z00zz__libuv_typesz00, BgL_bgl_za762lambda1820za7622564z00, BGl_z62lambda1820z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2330z00zz__libuv_typesz00, BgL_bgl_za762lambda1819za7622565z00, BGl_z62lambda1819z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2331z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72566za7, BGl_z62zc3anonymousza31828ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2332z00zz__libuv_typesz00, BgL_bgl_za762lambda1827za7622567z00, BGl_z62lambda1827z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2333z00zz__libuv_typesz00, BgL_bgl_za762lambda1826za7622568z00, BGl_z62lambda1826z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2334z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72569za7, BGl_z62zc3anonymousza31835ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2335z00zz__libuv_typesz00, BgL_bgl_za762lambda1834za7622570z00, BGl_z62lambda1834z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2336z00zz__libuv_typesz00, BgL_bgl_za762lambda1833za7622571z00, BGl_z62lambda1833z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2337z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72572za7, BGl_z62zc3anonymousza31795ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2338z00zz__libuv_typesz00, BgL_bgl_za762lambda1793za7622573z00, BGl_z62lambda1793z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2339z00zz__libuv_typesz00, BgL_bgl_za762lambda1790za7622574z00, BGl_z62lambda1790z62zz__libuv_typesz00, 0L, BUNSPEC, 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2340z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72575za7, BGl_z62zc3anonymousza31846ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2341z00zz__libuv_typesz00, BgL_bgl_za762lambda1844za7622576z00, BGl_z62lambda1844z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2342z00zz__libuv_typesz00, BgL_bgl_za762lambda1841za7622577z00, BGl_z62lambda1841z62zz__libuv_typesz00, 0L, BUNSPEC, 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2343z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72578za7, BGl_z62zc3anonymousza31864ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2popzd2gcmarkz12zd2envzc0zz__libuv_typesz00, BgL_bgl_za762uvza7d2popza7d2gc2579za7, BGl_z62uvzd2popzd2gcmarkz12z70zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2344z00zz__libuv_typesz00, BgL_bgl_za762lambda1863za7622580z00, BGl_z62lambda1863z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2345z00zz__libuv_typesz00, BgL_bgl_za762lambda1862za7622581z00, BGl_z62lambda1862z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2346z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72582za7, BGl_z62zc3anonymousza31857ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2347z00zz__libuv_typesz00, BgL_bgl_za762lambda1855za7622583z00, BGl_z62lambda1855z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2348z00zz__libuv_typesz00, BgL_bgl_za762lambda1852za7622584z00, BGl_z62lambda1852z62zz__libuv_typesz00, 0L, BUNSPEC, 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2349z00zz__libuv_typesz00, BgL_bgl_za762lambda1880za7622585z00, BGl_z62lambda1880z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2350z00zz__libuv_typesz00, BgL_bgl_za762lambda1879za7622586z00, BGl_z62lambda1879z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2351z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72587za7, BGl_z62zc3anonymousza31875ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2352z00zz__libuv_typesz00, BgL_bgl_za762lambda1873za7622588z00, BGl_z62lambda1873z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2353z00zz__libuv_typesz00, BgL_bgl_za762lambda1870za7622589z00, BGl_z62lambda1870z62zz__libuv_typesz00, 0L, BUNSPEC, 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2354z00zz__libuv_typesz00, BgL_bgl_za762lambda1896za7622590z00, BGl_z62lambda1896z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2355z00zz__libuv_typesz00, BgL_bgl_za762lambda1895za7622591z00, BGl_z62lambda1895z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2356z00zz__libuv_typesz00, BgL_bgl_za762lambda1901za7622592z00, BGl_z62lambda1901z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2357z00zz__libuv_typesz00, BgL_bgl_za762lambda1900za7622593z00, BGl_z62lambda1900z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2358z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72594za7, BGl_z62zc3anonymousza31891ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2359z00zz__libuv_typesz00, BgL_bgl_za762lambda1889za7622595z00, BGl_z62lambda1889z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2286z00zz__libuv_typesz00, BgL_bgl_string2286za700za7za7_2596za7, "", 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2360z00zz__libuv_typesz00, BgL_bgl_za762lambda1886za7622597z00, BGl_z62lambda1886z62zz__libuv_typesz00, 0L, BUNSPEC, 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2361z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72598za7, BGl_z62zc3anonymousza31919ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2362z00zz__libuv_typesz00, BgL_bgl_za762lambda1918za7622599z00, BGl_z62lambda1918z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2363z00zz__libuv_typesz00, BgL_bgl_za762lambda1917za7622600z00, BGl_z62lambda1917z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2451z00zz__libuv_typesz00, BgL_bgl_string2451za700za7za7_2601za7, "%uv-init1337", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2364z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72602za7, BGl_z62zc3anonymousza31926ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2365z00zz__libuv_typesz00, BgL_bgl_za762lambda1925za7622603z00, BGl_z62lambda1925z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2453z00zz__libuv_typesz00, BgL_bgl_string2453za700za7za7_2604za7, "object-print", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2366z00zz__libuv_typesz00, BgL_bgl_za762lambda1924za7622605z00, BGl_z62lambda1924z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2454z00zz__libuv_typesz00, BgL_bgl_string2454za700za7za7_2606za7, " [", 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2367z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72607za7, BGl_z62zc3anonymousza31912ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2455z00zz__libuv_typesz00, BgL_bgl_string2455za700za7za7_2608za7, "#|", 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2368z00zz__libuv_typesz00, BgL_bgl_za762lambda1910za7622609z00, BGl_z62lambda1910z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2456z00zz__libuv_typesz00, BgL_bgl_string2456za700za7za7_2610za7, " (0x", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2369z00zz__libuv_typesz00, BgL_bgl_za762lambda1907za7622611z00, BGl_z62lambda1907z62zz__libuv_typesz00, 0L, BUNSPEC, 9 );
DEFINE_STRING( BGl_string2457z00zz__libuv_typesz00, BgL_bgl_string2457za700za7za7_2612za7, ")", 1 );
BGL_IMPORT obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_STRING( BGl_string2458z00zz__libuv_typesz00, BgL_bgl_string2458za700za7za7_2613za7, " nil|", 5 );
DEFINE_STRING( BGl_string2459z00zz__libuv_typesz00, BgL_bgl_string2459za700za7za7_2614za7, "(#\\$ #\\%) UvWork %after-cb %work-cb $uv_work_t UvProcessOptions gid uid flags cwd env args file $uv_process_options_t UvProcess pid $onexit UvCheck UvFsPoll UvFsEvent UvFile bstring path UvPoll UvAsync UvIdle UvTimer ref uint64 repeat UvTty readable int fd UvPipe ipc UvUdp %procm UvTcp UvStream %callback %procc %proca %offset %alloc UvWatcher procedure cb loop UvLoop mutex %mutex UvHandle bool closed %gcmarkstail pair-nil %gcmarkshead obj %onclose $uv_handle_t $builtin __libuv_types %Uv UNDEFINED UNKNOWN FILE PIPE UDP TTY TCP ", 532 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2370z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72615za7, BGl_z62zc3anonymousza31937ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2371z00zz__libuv_typesz00, BgL_bgl_za762lambda1935za7622616z00, BGl_z62lambda1935z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2372z00zz__libuv_typesz00, BgL_bgl_za762lambda1932za7622617z00, BGl_z62lambda1932z62zz__libuv_typesz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2373z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72618za7, BGl_z62zc3anonymousza31948ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2374z00zz__libuv_typesz00, BgL_bgl_za762lambda1946za7622619z00, BGl_z62lambda1946z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2375z00zz__libuv_typesz00, BgL_bgl_za762lambda1943za7622620z00, BGl_z62lambda1943z62zz__libuv_typesz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2376z00zz__libuv_typesz00, BgL_bgl_za762lambda1964za7622621z00, BGl_z62lambda1964z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2377z00zz__libuv_typesz00, BgL_bgl_za762lambda1963za7622622z00, BGl_z62lambda1963z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2378z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72623za7, BGl_z62zc3anonymousza31959ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2379z00zz__libuv_typesz00, BgL_bgl_za762lambda1957za7622624z00, BGl_z62lambda1957z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2380z00zz__libuv_typesz00, BgL_bgl_za762lambda1954za7622625z00, BGl_z62lambda1954z62zz__libuv_typesz00, 0L, BUNSPEC, 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2381z00zz__libuv_typesz00, BgL_bgl_za762lambda1979za7622626z00, BGl_z62lambda1979z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2382z00zz__libuv_typesz00, BgL_bgl_za762lambda1978za7622627z00, BGl_z62lambda1978z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2383z00zz__libuv_typesz00, BgL_bgl_za762lambda1984za7622628z00, BGl_z62lambda1984z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2384z00zz__libuv_typesz00, BgL_bgl_za762lambda1983za7622629z00, BGl_z62lambda1983z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2385z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72630za7, BGl_z62zc3anonymousza31974ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2386z00zz__libuv_typesz00, BgL_bgl_za762lambda1972za7622631z00, BGl_z62lambda1972z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2387z00zz__libuv_typesz00, BgL_bgl_za762lambda1970za7622632z00, BGl_z62lambda1970z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2388z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72633za7, BGl_z62zc3anonymousza31995ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2389z00zz__libuv_typesz00, BgL_bgl_za762lambda1993za7622634z00, BGl_z62lambda1993z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2390z00zz__libuv_typesz00, BgL_bgl_za762lambda1990za7622635z00, BGl_z62lambda1990z62zz__libuv_typesz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2391z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72636za7, BGl_z62zc3anonymousza32006ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2392z00zz__libuv_typesz00, BgL_bgl_za762lambda2004za7622637z00, BGl_z62lambda2004z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2393z00zz__libuv_typesz00, BgL_bgl_za762lambda2001za7622638z00, BGl_z62lambda2001z62zz__libuv_typesz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2394z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72639za7, BGl_z62zc3anonymousza32017ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2395z00zz__libuv_typesz00, BgL_bgl_za762lambda2015za7622640z00, BGl_z62lambda2015z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
BGL_IMPORT obj_t BGl_objectzd2printzd2envz00zz__objectz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2396z00zz__libuv_typesz00, BgL_bgl_za762lambda2012za7622641z00, BGl_z62lambda2012z62zz__libuv_typesz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2397z00zz__libuv_typesz00, BgL_bgl_za762za7c3anonymousza72642za7, BGl_z62zc3anonymousza32035ze3ze1zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2398z00zz__libuv_typesz00, BgL_bgl_za762lambda2034za7622643z00, BGl_z62lambda2034z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2399z00zz__libuv_typesz00, BgL_bgl_za762lambda2033za7622644z00, BGl_z62lambda2033z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BgL_bgl_za762za752uvza7d2initza72645z00, BGl_z62z52uvzd2initze2zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2versionzd2envz00zz__libuv_typesz00, BgL_bgl_za762uvza7d2versionza72646za7, BGl_z62uvzd2versionzb0zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2handlezd2typezd2symbolzd2envz00zz__libuv_typesz00, BgL_bgl_za762uvza7d2handleza7d2647za7, BGl_z62uvzd2handlezd2typezd2symbolzb0zz__libuv_typesz00, 0L, BUNSPEC, 1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_UvFsEventz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvHandlez00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvLoopz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvPipez00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvWorkz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvProcessz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvTcpz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvPollz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_z52Uvz52zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvTtyz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvFsPollz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvIdlez00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvFilez00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvAsyncz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvStreamz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvWatcherz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvProcessOptionsz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvUdpz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvTimerz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvCheckz00zz__libuv_typesz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__libuv_typesz00(long BgL_checksumz00_2792, char * BgL_fromz00_2793)
{ BGL_FUNCTION_BEGIN;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__libuv_typesz00))
{ 
BGl_requirezd2initializa7ationz75zz__libuv_typesz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__libuv_typesz00(); 
BGl_libraryzd2moduleszd2initz00zz__libuv_typesz00(); 
BGl_cnstzd2initzd2zz__libuv_typesz00(); 
BGl_objectzd2initzd2zz__libuv_typesz00(); 
BGl_genericzd2initzd2zz__libuv_typesz00(); 
BGl_methodzd2initzd2zz__libuv_typesz00(); 
return 
BGl_toplevelzd2initzd2zz__libuv_typesz00();}  else 
{ 
return BUNSPEC;} } 
BGL_FUNCTION_END;
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__libuv_typesz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 15 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__libuv_types"); 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__libuv_typesz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 15 */
{ /* Llib/uvtypes.scm 15 */
obj_t BgL_cportz00_2370;
{ /* Llib/uvtypes.scm 15 */
obj_t BgL_stringz00_2378;
BgL_stringz00_2378 = BGl_string2459z00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 15 */
obj_t BgL_startz00_2379;
BgL_startz00_2379 = 
BINT(((long)0)); 
{ /* Llib/uvtypes.scm 15 */
obj_t BgL_endz00_2380;
BgL_endz00_2380 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_2378))); 
{ /* Llib/uvtypes.scm 15 */

BgL_cportz00_2370 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_2378, BgL_startz00_2379, BgL_endz00_2380); } } } } 
{ 
long BgL_iz00_2371;
BgL_iz00_2371 = ((long)70); 
BgL_loopz00_2372:
if(
(BgL_iz00_2371==((long)-1)))
{ /* Llib/uvtypes.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/uvtypes.scm 15 */
{ /* Llib/uvtypes.scm 15 */
obj_t BgL_arg2461z00_2374;
{ /* Llib/uvtypes.scm 15 */

{ /* Llib/uvtypes.scm 15 */
obj_t BgL_locationz00_2376;
BgL_locationz00_2376 = 
BBOOL(((bool_t)0)); 
{ /* Llib/uvtypes.scm 15 */

BgL_arg2461z00_2374 = 
BGl_readz00zz__readerz00(BgL_cportz00_2370, BgL_locationz00_2376); } } } 
{ /* Llib/uvtypes.scm 15 */
int BgL_tmpz00_2823;
BgL_tmpz00_2823 = 
(int)(BgL_iz00_2371); 
CNST_TABLE_SET(BgL_tmpz00_2823, BgL_arg2461z00_2374); } } 
{ /* Llib/uvtypes.scm 15 */
int BgL_auxz00_2377;
BgL_auxz00_2377 = 
(int)(
(BgL_iz00_2371-((long)1))); 
{ 
long BgL_iz00_2828;
BgL_iz00_2828 = 
(long)(BgL_auxz00_2377); 
BgL_iz00_2371 = BgL_iz00_2828; 
goto BgL_loopz00_2372;} } } } } } 
BGL_FUNCTION_END;
}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__libuv_typesz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 15 */
return 
bgl_gc_roots_register();} 
BGL_FUNCTION_END;
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__libuv_typesz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 15 */
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* uv-version */
BGL_EXPORTED_DEF char * BGl_uvzd2versionzd2zz__libuv_typesz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 174 */
return 
(char *)uv_version_string();} 
BGL_FUNCTION_END;
}



/* &uv-version */
obj_t BGl_z62uvzd2versionzb0zz__libuv_typesz00(obj_t BgL_envz00_1719)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 174 */
return 
string_to_bstring(
BGl_uvzd2versionzd2zz__libuv_typesz00());} 
BGL_FUNCTION_END;
}



/* uv-id */
BGL_EXPORTED_DEF int BGl_uvzd2idzd2zz__libuv_typesz00(BgL_uvhandlez00_bglt BgL_oz00_3)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 180 */
{ /* Llib/uvtypes.scm 182 */
uv_handle_t * BgL_arg1417z00_1233;
BgL_arg1417z00_1233 = 
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_3))->BgL_z42builtinz42); 
return 
(int)(
(long)(BgL_arg1417z00_1233));} } 
BGL_FUNCTION_END;
}



/* &uv-id */
obj_t BGl_z62uvzd2idzb0zz__libuv_typesz00(obj_t BgL_envz00_1720, obj_t BgL_oz00_1721)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 180 */
return 
BINT(
BGl_uvzd2idzd2zz__libuv_typesz00(
((BgL_uvhandlez00_bglt)BgL_oz00_1721)));} 
BGL_FUNCTION_END;
}



/* uv-new-file */
BGL_EXPORTED_DEF BgL_uvfilez00_bglt bgl_uv_new_file(int BgL_fdz00_8, obj_t BgL_pathz00_9)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 228 */
{ /* Llib/uvtypes.scm 229 */
BgL_uvfilez00_bglt BgL_new1242z00_1234;
{ /* Llib/uvtypes.scm 230 */
BgL_uvfilez00_bglt BgL_new1241z00_1235;
BgL_new1241z00_1235 = 
((BgL_uvfilez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvfilez00_bgl) ))); 
{ /* Llib/uvtypes.scm 230 */
long BgL_arg1418z00_1236;
{ /* Llib/uvtypes.scm 230 */
long BgL_res2213z00_1238;
BgL_res2213z00_1238 = 
BGL_CLASS_INDEX(BGl_UvFilez00zz__libuv_typesz00); 
BgL_arg1418z00_1236 = BgL_res2213z00_1238; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1241z00_1235), BgL_arg1418z00_1236); } 
BgL_new1242z00_1234 = BgL_new1241z00_1235; } 
((((BgL_uvfilez00_bglt)COBJECT(BgL_new1242z00_1234))->BgL_fdz00)=((int)BgL_fdz00_8),BUNSPEC); 
((((BgL_uvfilez00_bglt)COBJECT(BgL_new1242z00_1234))->BgL_pathz00)=((obj_t)BgL_pathz00_9),BUNSPEC); 
return BgL_new1242z00_1234;} } 
BGL_FUNCTION_END;
}



/* &uv-new-file */
BgL_uvfilez00_bglt BGl_z62uvzd2newzd2filez62zz__libuv_typesz00(obj_t BgL_envz00_1722, obj_t BgL_fdz00_1723, obj_t BgL_pathz00_1724)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 228 */
return 
bgl_uv_new_file(
CINT(BgL_fdz00_1723), BgL_pathz00_1724);} 
BGL_FUNCTION_END;
}



/* uv-strerror */
BGL_EXPORTED_DEF obj_t BGl_uvzd2strerrorzd2zz__libuv_typesz00(int BgL_errnoz00_10)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 236 */
{ /* Llib/uvtypes.scm 237 */
char * BgL_sz00_1241;
BgL_sz00_1241 = 
(char *)uv_strerror(BgL_errnoz00_10); 
if(
((char *)0L) ==(BgL_sz00_1241))
{ /* Llib/uvtypes.scm 238 */
return BGl_string2286z00zz__libuv_typesz00;}  else 
{ /* Llib/uvtypes.scm 238 */
return 
string_to_bstring(BgL_sz00_1241);} } } 
BGL_FUNCTION_END;
}



/* &uv-strerror */
obj_t BGl_z62uvzd2strerrorzb0zz__libuv_typesz00(obj_t BgL_envz00_1725, obj_t BgL_errnoz00_1726)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 236 */
return 
BGl_uvzd2strerrorzd2zz__libuv_typesz00(
CINT(BgL_errnoz00_1726));} 
BGL_FUNCTION_END;
}



/* uv-err-name */
BGL_EXPORTED_DEF obj_t BGl_uvzd2errzd2namez00zz__libuv_typesz00(int BgL_errnoz00_11)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 245 */
{ /* Llib/uvtypes.scm 246 */
char * BgL_sz00_1243;
BgL_sz00_1243 = 
(char *)uv_err_name(BgL_errnoz00_11); 
if(
((char *)0L) ==(BgL_sz00_1243))
{ /* Llib/uvtypes.scm 247 */
return BGl_string2286z00zz__libuv_typesz00;}  else 
{ /* Llib/uvtypes.scm 247 */
return 
string_to_bstring(BgL_sz00_1243);} } } 
BGL_FUNCTION_END;
}



/* &uv-err-name */
obj_t BGl_z62uvzd2errzd2namez62zz__libuv_typesz00(obj_t BgL_envz00_1727, obj_t BgL_errnoz00_1728)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 245 */
return 
BGl_uvzd2errzd2namez00zz__libuv_typesz00(
CINT(BgL_errnoz00_1728));} 
BGL_FUNCTION_END;
}



/* uv-guess-handle */
BGL_EXPORTED_DEF obj_t bgl_uv_guess_handle(int BgL_fdz00_12)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 254 */
{ /* Llib/uvtypes.scm 255 */
int BgL_arg1498z00_1245;
BgL_arg1498z00_1245 = 
uv_guess_handle(BgL_fdz00_12); 
return 
bgl_uv_handle_type_symbol(BgL_arg1498z00_1245);} } 
BGL_FUNCTION_END;
}



/* &uv-guess-handle */
obj_t BGl_z62uvzd2guesszd2handlez62zz__libuv_typesz00(obj_t BgL_envz00_1729, obj_t BgL_fdz00_1730)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 254 */
return 
bgl_uv_guess_handle(
CINT(BgL_fdz00_1730));} 
BGL_FUNCTION_END;
}



/* uv-handle-type-symbol */
BGL_EXPORTED_DEF obj_t bgl_uv_handle_type_symbol(int BgL_rz00_13)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 260 */
if(
(
(long)(BgL_rz00_13)==
(long)(UV_TCP)))
{ /* Llib/uvtypes.scm 262 */
return 
CNST_TABLE_REF(((long)0));}  else 
{ /* Llib/uvtypes.scm 262 */
if(
(
(long)(BgL_rz00_13)==
(long)(UV_TTY)))
{ /* Llib/uvtypes.scm 263 */
return 
CNST_TABLE_REF(((long)1));}  else 
{ /* Llib/uvtypes.scm 263 */
if(
(
(long)(BgL_rz00_13)==
(long)(UV_UDP)))
{ /* Llib/uvtypes.scm 264 */
return 
CNST_TABLE_REF(((long)2));}  else 
{ /* Llib/uvtypes.scm 264 */
if(
(
(long)(BgL_rz00_13)==
(long)(UV_NAMED_PIPE)))
{ /* Llib/uvtypes.scm 265 */
return 
CNST_TABLE_REF(((long)3));}  else 
{ /* Llib/uvtypes.scm 265 */
if(
(
(long)(BgL_rz00_13)==
(long)(UV_FILE)))
{ /* Llib/uvtypes.scm 266 */
return 
CNST_TABLE_REF(((long)4));}  else 
{ /* Llib/uvtypes.scm 266 */
if(
(
(long)(BgL_rz00_13)==
(long)(UV_UNKNOWN_HANDLE)))
{ /* Llib/uvtypes.scm 267 */
return 
CNST_TABLE_REF(((long)5));}  else 
{ /* Llib/uvtypes.scm 267 */
return 
CNST_TABLE_REF(((long)6));} } } } } } } 
BGL_FUNCTION_END;
}



/* &uv-handle-type-symbol */
obj_t BGl_z62uvzd2handlezd2typezd2symbolzb0zz__libuv_typesz00(obj_t BgL_envz00_1731, obj_t BgL_rz00_1732)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 260 */
return 
bgl_uv_handle_type_symbol(
CINT(BgL_rz00_1732));} 
BGL_FUNCTION_END;
}



/* uv-push-gcmark! */
BGL_EXPORTED_DEF obj_t BGl_uvzd2pushzd2gcmarkz12z12zz__libuv_typesz00(BgL_uvhandlez00_bglt BgL_oz00_14, obj_t BgL_valz00_15)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 273 */
if(
NULLP(
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_14))->BgL_z52gcmarkstailz52)))
{ /* Llib/uvtypes.scm 275 */
((((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_14))->BgL_z52gcmarksheadz52)=((obj_t)
MAKE_YOUNG_PAIR(BgL_valz00_15, BNIL)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_14))->BgL_z52gcmarkstailz52)=((obj_t)
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_14))->BgL_z52gcmarksheadz52)),BUNSPEC); }  else 
{ /* Llib/uvtypes.scm 275 */
{ /* Llib/uvtypes.scm 280 */
obj_t BgL_arg1517z00_2383;obj_t BgL_arg1523z00_2384;
BgL_arg1517z00_2383 = 
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_14))->BgL_z52gcmarkstailz52); 
BgL_arg1523z00_2384 = 
MAKE_YOUNG_PAIR(BgL_valz00_15, BNIL); 
{ /* Llib/uvtypes.scm 280 */
obj_t BgL_tmpz00_2906;
BgL_tmpz00_2906 = 
((obj_t)BgL_arg1517z00_2383); 
SET_CDR(BgL_tmpz00_2906, BgL_arg1523z00_2384); } } 
{ 
obj_t BgL_auxz00_2909;
{ /* Llib/uvtypes.scm 281 */
obj_t BgL_pairz00_2385;
BgL_pairz00_2385 = 
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_14))->BgL_z52gcmarkstailz52); 
BgL_auxz00_2909 = 
CDR(BgL_pairz00_2385); } 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_14))->BgL_z52gcmarkstailz52)=((obj_t)BgL_auxz00_2909),BUNSPEC); } } 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* &uv-push-gcmark! */
obj_t BGl_z62uvzd2pushzd2gcmarkz12z70zz__libuv_typesz00(obj_t BgL_envz00_1733, obj_t BgL_oz00_1734, obj_t BgL_valz00_1735)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 273 */
return 
BGl_uvzd2pushzd2gcmarkz12z12zz__libuv_typesz00(
((BgL_uvhandlez00_bglt)BgL_oz00_1734), BgL_valz00_1735);} 
BGL_FUNCTION_END;
}



/* uv-pop-gcmark! */
BGL_EXPORTED_DEF obj_t bgl_uv_pop_gcmark(BgL_uvhandlez00_bglt BgL_oz00_16, obj_t BgL_valz00_17)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 287 */
if(
NULLP(
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarksheadz52)))
{ /* Llib/uvtypes.scm 289 */
return BFALSE;}  else 
{ /* Llib/uvtypes.scm 289 */
if(
(BgL_valz00_17==
CAR(
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarksheadz52))))
{ /* Llib/uvtypes.scm 290 */
if(
(
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarksheadz52)==
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarkstailz52)))
{ /* Llib/uvtypes.scm 291 */
((((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
return 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC);}  else 
{ 
obj_t BgL_auxz00_2928;
{ /* Llib/uvtypes.scm 295 */
obj_t BgL_pairz00_1275;
BgL_pairz00_1275 = 
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarksheadz52); 
BgL_auxz00_2928 = 
CDR(BgL_pairz00_1275); } 
return 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarksheadz52)=((obj_t)BgL_auxz00_2928),BUNSPEC);} }  else 
{ 
obj_t BgL_pz00_64;
BgL_pz00_64 = 
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarksheadz52); 
BgL_zc3anonymousza31584ze3z83_65:
{ /* Llib/uvtypes.scm 297 */
obj_t BgL_nz00_66;
BgL_nz00_66 = 
CDR(
((obj_t)BgL_pz00_64)); 
if(
PAIRP(BgL_nz00_66))
{ /* Llib/uvtypes.scm 298 */
if(
(
CAR(BgL_nz00_66)==BgL_valz00_17))
{ /* Llib/uvtypes.scm 299 */
if(
(BgL_nz00_66==
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarkstailz52)))
{ /* Llib/uvtypes.scm 301 */
((((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarkstailz52)=((obj_t)BgL_pz00_64),BUNSPEC); }  else 
{ /* Llib/uvtypes.scm 301 */BFALSE; } 
{ /* Llib/uvtypes.scm 303 */
obj_t BgL_arg1614z00_73;
BgL_arg1614z00_73 = 
CDR(BgL_nz00_66); 
{ /* Llib/uvtypes.scm 303 */
obj_t BgL_tmpz00_2944;
BgL_tmpz00_2944 = 
((obj_t)BgL_pz00_64); 
return 
SET_CDR(BgL_tmpz00_2944, BgL_arg1614z00_73);} } }  else 
{ 
obj_t BgL_pz00_2947;
BgL_pz00_2947 = BgL_nz00_66; 
BgL_pz00_64 = BgL_pz00_2947; 
goto BgL_zc3anonymousza31584ze3z83_65;} }  else 
{ /* Llib/uvtypes.scm 298 */
return BFALSE;} } } } } 
BGL_FUNCTION_END;
}



/* &uv-pop-gcmark! */
obj_t BGl_z62uvzd2popzd2gcmarkz12z70zz__libuv_typesz00(obj_t BgL_envz00_1736, obj_t BgL_oz00_1737, obj_t BgL_valz00_1738)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 287 */
return 
bgl_uv_pop_gcmark(
((BgL_uvhandlez00_bglt)BgL_oz00_1737), BgL_valz00_1738);} 
BGL_FUNCTION_END;
}



/* uv-gcmarks-empty? */
BGL_EXPORTED_DEF bool_t BGl_uvzd2gcmarkszd2emptyzf3zf3zz__libuv_typesz00(BgL_uvhandlez00_bglt BgL_oz00_18)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 309 */
return 
NULLP(
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_18))->BgL_z52gcmarksheadz52));} 
BGL_FUNCTION_END;
}



/* &uv-gcmarks-empty? */
obj_t BGl_z62uvzd2gcmarkszd2emptyzf3z91zz__libuv_typesz00(obj_t BgL_envz00_1739, obj_t BgL_oz00_1740)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 309 */
return 
BBOOL(
BGl_uvzd2gcmarkszd2emptyzf3zf3zz__libuv_typesz00(
((BgL_uvhandlez00_bglt)BgL_oz00_1740)));} 
BGL_FUNCTION_END;
}



/* object-init */
obj_t BGl_objectzd2initzd2zz__libuv_typesz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 15 */
{ /* Llib/uvtypes.scm 23 */
obj_t BgL_arg1657z00_83;obj_t BgL_arg1658z00_84;
{ /* Llib/uvtypes.scm 23 */
obj_t BgL_v1297z00_90;
BgL_v1297z00_90 = 
create_vector(((long)0)); 
BgL_arg1657z00_83 = BgL_v1297z00_90; } 
{ /* Llib/uvtypes.scm 23 */
obj_t BgL_v1298z00_91;
BgL_v1298z00_91 = 
create_vector(((long)0)); 
BgL_arg1658z00_84 = BgL_v1298z00_91; } 
BGl_z52Uvz52zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)7)), 
CNST_TABLE_REF(((long)8)), BGl_objectz00zz__objectz00, ((long)23285), BFALSE, BGl_proc2288z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2287z00zz__libuv_typesz00, BFALSE, BgL_arg1657z00_83, BgL_arg1658z00_84); } 
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_arg1669z00_97;obj_t BgL_arg1670z00_98;
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_v1299z00_114;
BgL_v1299z00_114 = 
create_vector(((long)5)); 
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_arg1679z00_115;
BgL_arg1679z00_115 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)9)), BGl_proc2291z00zz__libuv_typesz00, BGl_proc2290z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2289z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)10))); 
VECTOR_SET(BgL_v1299z00_114,((long)0),BgL_arg1679z00_115); } 
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_arg1689z00_128;
BgL_arg1689z00_128 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)11)), BGl_proc2294z00zz__libuv_typesz00, BGl_proc2293z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2292z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1299z00_114,((long)1),BgL_arg1689z00_128); } 
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_arg1696z00_141;
BgL_arg1696z00_141 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)13)), BGl_proc2297z00zz__libuv_typesz00, BGl_proc2296z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2295z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1299z00_114,((long)2),BgL_arg1696z00_141); } 
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_arg1708z00_154;
BgL_arg1708z00_154 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)15)), BGl_proc2300z00zz__libuv_typesz00, BGl_proc2299z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2298z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1299z00_114,((long)3),BgL_arg1708z00_154); } 
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_arg1725z00_167;
BgL_arg1725z00_167 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)16)), BGl_proc2303z00zz__libuv_typesz00, BGl_proc2302z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2301z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1299z00_114,((long)4),BgL_arg1725z00_167); } 
BgL_arg1669z00_97 = BgL_v1299z00_114; } 
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_v1300z00_180;
BgL_v1300z00_180 = 
create_vector(((long)0)); 
BgL_arg1670z00_98 = BgL_v1300z00_180; } 
BGl_UvHandlez00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)18)), 
CNST_TABLE_REF(((long)8)), BGl_z52Uvz52zz__libuv_typesz00, ((long)36343), BGl_proc2306z00zz__libuv_typesz00, BGl_proc2305z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2304z00zz__libuv_typesz00, BFALSE, BgL_arg1669z00_97, BgL_arg1670z00_98); } 
{ /* Llib/uvtypes.scm 33 */
obj_t BgL_arg1750z00_187;obj_t BgL_arg1751z00_188;
{ /* Llib/uvtypes.scm 33 */
obj_t BgL_v1301z00_205;
BgL_v1301z00_205 = 
create_vector(((long)1)); 
{ /* Llib/uvtypes.scm 33 */
obj_t BgL_arg1759z00_206;
BgL_arg1759z00_206 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)19)), BGl_proc2309z00zz__libuv_typesz00, BGl_proc2308z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2307z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)20))); 
VECTOR_SET(BgL_v1301z00_205,((long)0),BgL_arg1759z00_206); } 
BgL_arg1750z00_187 = BgL_v1301z00_205; } 
{ /* Llib/uvtypes.scm 33 */
obj_t BgL_v1302z00_220;
BgL_v1302z00_220 = 
create_vector(((long)0)); 
BgL_arg1751z00_188 = BgL_v1302z00_220; } 
BGl_UvLoopz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)21)), 
CNST_TABLE_REF(((long)8)), BGl_UvHandlez00zz__libuv_typesz00, ((long)33046), BGl_proc2312z00zz__libuv_typesz00, BGl_proc2311z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2310z00zz__libuv_typesz00, BFALSE, BgL_arg1750z00_187, BgL_arg1751z00_188); } 
{ /* Llib/uvtypes.scm 36 */
obj_t BgL_arg1768z00_226;obj_t BgL_arg1769z00_227;
{ /* Llib/uvtypes.scm 36 */
obj_t BgL_v1303z00_233;
BgL_v1303z00_233 = 
create_vector(((long)2)); 
{ /* Llib/uvtypes.scm 36 */
obj_t BgL_arg1773z00_234;
BgL_arg1773z00_234 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)22)), BGl_proc2314z00zz__libuv_typesz00, BGl_proc2313z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_UvLoopz00zz__libuv_typesz00); 
VECTOR_SET(BgL_v1303z00_233,((long)0),BgL_arg1773z00_234); } 
{ /* Llib/uvtypes.scm 36 */
obj_t BgL_arg1778z00_244;
BgL_arg1778z00_244 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)23)), BGl_proc2317z00zz__libuv_typesz00, BGl_proc2316z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2315z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)24))); 
VECTOR_SET(BgL_v1303z00_233,((long)1),BgL_arg1778z00_244); } 
BgL_arg1768z00_226 = BgL_v1303z00_233; } 
{ /* Llib/uvtypes.scm 36 */
obj_t BgL_v1304z00_257;
BgL_v1304z00_257 = 
create_vector(((long)0)); 
BgL_arg1769z00_227 = BgL_v1304z00_257; } 
BGl_UvWatcherz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)25)), 
CNST_TABLE_REF(((long)8)), BGl_UvHandlez00zz__libuv_typesz00, ((long)54967), BFALSE, BGl_proc2319z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2318z00zz__libuv_typesz00, BFALSE, BgL_arg1768z00_226, BgL_arg1769z00_227); } 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_arg1788z00_263;obj_t BgL_arg1789z00_264;
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_v1305z00_286;
BgL_v1305z00_286 = 
create_vector(((long)6)); 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_arg1796z00_287;
BgL_arg1796z00_287 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)22)), BGl_proc2321z00zz__libuv_typesz00, BGl_proc2320z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_UvLoopz00zz__libuv_typesz00); 
VECTOR_SET(BgL_v1305z00_286,((long)0),BgL_arg1796z00_287); } 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_arg1801z00_297;
BgL_arg1801z00_297 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)26)), BGl_proc2324z00zz__libuv_typesz00, BGl_proc2323z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2322z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1305z00_286,((long)1),BgL_arg1801z00_297); } 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_arg1808z00_310;
BgL_arg1808z00_310 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)27)), BGl_proc2327z00zz__libuv_typesz00, BGl_proc2326z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2325z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1305z00_286,((long)2),BgL_arg1808z00_310); } 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_arg1815z00_323;
BgL_arg1815z00_323 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)28)), BGl_proc2330z00zz__libuv_typesz00, BGl_proc2329z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2328z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1305z00_286,((long)3),BgL_arg1815z00_323); } 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_arg1822z00_336;
BgL_arg1822z00_336 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)29)), BGl_proc2333z00zz__libuv_typesz00, BGl_proc2332z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2331z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1305z00_286,((long)4),BgL_arg1822z00_336); } 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_arg1829z00_349;
BgL_arg1829z00_349 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)30)), BGl_proc2336z00zz__libuv_typesz00, BGl_proc2335z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2334z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1305z00_286,((long)5),BgL_arg1829z00_349); } 
BgL_arg1788z00_263 = BgL_v1305z00_286; } 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_v1306z00_362;
BgL_v1306z00_362 = 
create_vector(((long)0)); 
BgL_arg1789z00_264 = BgL_v1306z00_362; } 
BGl_UvStreamz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)31)), 
CNST_TABLE_REF(((long)8)), BGl_UvHandlez00zz__libuv_typesz00, ((long)11232), BGl_proc2339z00zz__libuv_typesz00, BGl_proc2338z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2337z00zz__libuv_typesz00, BFALSE, BgL_arg1788z00_263, BgL_arg1789z00_264); } 
{ /* Llib/uvtypes.scm 48 */
obj_t BgL_arg1839z00_369;obj_t BgL_arg1840z00_370;
{ /* Llib/uvtypes.scm 48 */
obj_t BgL_v1307z00_392;
BgL_v1307z00_392 = 
create_vector(((long)0)); 
BgL_arg1839z00_369 = BgL_v1307z00_392; } 
{ /* Llib/uvtypes.scm 48 */
obj_t BgL_v1308z00_393;
BgL_v1308z00_393 = 
create_vector(((long)0)); 
BgL_arg1840z00_370 = BgL_v1308z00_393; } 
BGl_UvTcpz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)32)), 
CNST_TABLE_REF(((long)8)), BGl_UvStreamz00zz__libuv_typesz00, ((long)12982), BGl_proc2342z00zz__libuv_typesz00, BGl_proc2341z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2340z00zz__libuv_typesz00, BFALSE, BgL_arg1839z00_369, BgL_arg1840z00_370); } 
{ /* Llib/uvtypes.scm 50 */
obj_t BgL_arg1850z00_400;obj_t BgL_arg1851z00_401;
{ /* Llib/uvtypes.scm 50 */
obj_t BgL_v1309z00_424;
BgL_v1309z00_424 = 
create_vector(((long)1)); 
{ /* Llib/uvtypes.scm 50 */
obj_t BgL_arg1858z00_425;
BgL_arg1858z00_425 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)33)), BGl_proc2345z00zz__libuv_typesz00, BGl_proc2344z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2343z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1309z00_424,((long)0),BgL_arg1858z00_425); } 
BgL_arg1850z00_400 = BgL_v1309z00_424; } 
{ /* Llib/uvtypes.scm 50 */
obj_t BgL_v1310z00_438;
BgL_v1310z00_438 = 
create_vector(((long)0)); 
BgL_arg1851z00_401 = BgL_v1310z00_438; } 
BGl_UvUdpz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)34)), 
CNST_TABLE_REF(((long)8)), BGl_UvStreamz00zz__libuv_typesz00, ((long)61053), BGl_proc2348z00zz__libuv_typesz00, BGl_proc2347z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2346z00zz__libuv_typesz00, BFALSE, BgL_arg1850z00_400, BgL_arg1851z00_401); } 
{ /* Llib/uvtypes.scm 53 */
obj_t BgL_arg1868z00_445;obj_t BgL_arg1869z00_446;
{ /* Llib/uvtypes.scm 53 */
obj_t BgL_v1311z00_469;
BgL_v1311z00_469 = 
create_vector(((long)1)); 
{ /* Llib/uvtypes.scm 53 */
obj_t BgL_arg1876z00_470;
BgL_arg1876z00_470 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)35)), BGl_proc2350z00zz__libuv_typesz00, BGl_proc2349z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1311z00_469,((long)0),BgL_arg1876z00_470); } 
BgL_arg1868z00_445 = BgL_v1311z00_469; } 
{ /* Llib/uvtypes.scm 53 */
obj_t BgL_v1312z00_480;
BgL_v1312z00_480 = 
create_vector(((long)0)); 
BgL_arg1869z00_446 = BgL_v1312z00_480; } 
BGl_UvPipez00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)36)), 
CNST_TABLE_REF(((long)8)), BGl_UvStreamz00zz__libuv_typesz00, ((long)59138), BGl_proc2353z00zz__libuv_typesz00, BGl_proc2352z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2351z00zz__libuv_typesz00, BFALSE, BgL_arg1868z00_445, BgL_arg1869z00_446); } 
{ /* Llib/uvtypes.scm 56 */
obj_t BgL_arg1884z00_487;obj_t BgL_arg1885z00_488;
{ /* Llib/uvtypes.scm 56 */
obj_t BgL_v1313z00_512;
BgL_v1313z00_512 = 
create_vector(((long)2)); 
{ /* Llib/uvtypes.scm 56 */
obj_t BgL_arg1892z00_513;
BgL_arg1892z00_513 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)37)), BGl_proc2355z00zz__libuv_typesz00, BGl_proc2354z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)38))); 
VECTOR_SET(BgL_v1313z00_512,((long)0),BgL_arg1892z00_513); } 
{ /* Llib/uvtypes.scm 56 */
obj_t BgL_arg1897z00_523;
BgL_arg1897z00_523 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)39)), BGl_proc2357z00zz__libuv_typesz00, BGl_proc2356z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1313z00_512,((long)1),BgL_arg1897z00_523); } 
BgL_arg1884z00_487 = BgL_v1313z00_512; } 
{ /* Llib/uvtypes.scm 56 */
obj_t BgL_v1314z00_533;
BgL_v1314z00_533 = 
create_vector(((long)0)); 
BgL_arg1885z00_488 = BgL_v1314z00_533; } 
BGl_UvTtyz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)40)), 
CNST_TABLE_REF(((long)8)), BGl_UvStreamz00zz__libuv_typesz00, ((long)33681), BGl_proc2360z00zz__libuv_typesz00, BGl_proc2359z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2358z00zz__libuv_typesz00, BFALSE, BgL_arg1884z00_487, BgL_arg1885z00_488); } 
{ /* Llib/uvtypes.scm 60 */
obj_t BgL_arg1905z00_540;obj_t BgL_arg1906z00_541;
{ /* Llib/uvtypes.scm 60 */
obj_t BgL_v1315z00_561;
BgL_v1315z00_561 = 
create_vector(((long)2)); 
{ /* Llib/uvtypes.scm 60 */
obj_t BgL_arg1913z00_562;
BgL_arg1913z00_562 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)41)), BGl_proc2363z00zz__libuv_typesz00, BGl_proc2362z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2361z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)42))); 
VECTOR_SET(BgL_v1315z00_561,((long)0),BgL_arg1913z00_562); } 
{ /* Llib/uvtypes.scm 60 */
obj_t BgL_arg1920z00_575;
BgL_arg1920z00_575 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)43)), BGl_proc2366z00zz__libuv_typesz00, BGl_proc2365z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2364z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1315z00_561,((long)1),BgL_arg1920z00_575); } 
BgL_arg1905z00_540 = BgL_v1315z00_561; } 
{ /* Llib/uvtypes.scm 60 */
obj_t BgL_v1316z00_588;
BgL_v1316z00_588 = 
create_vector(((long)0)); 
BgL_arg1906z00_541 = BgL_v1316z00_588; } 
BGl_UvTimerz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)44)), 
CNST_TABLE_REF(((long)8)), BGl_UvWatcherz00zz__libuv_typesz00, ((long)48924), BGl_proc2369z00zz__libuv_typesz00, BGl_proc2368z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2367z00zz__libuv_typesz00, BFALSE, BgL_arg1905z00_540, BgL_arg1906z00_541); } 
{ /* Llib/uvtypes.scm 64 */
obj_t BgL_arg1930z00_595;obj_t BgL_arg1931z00_596;
{ /* Llib/uvtypes.scm 64 */
obj_t BgL_v1317z00_614;
BgL_v1317z00_614 = 
create_vector(((long)0)); 
BgL_arg1930z00_595 = BgL_v1317z00_614; } 
{ /* Llib/uvtypes.scm 64 */
obj_t BgL_v1318z00_615;
BgL_v1318z00_615 = 
create_vector(((long)0)); 
BgL_arg1931z00_596 = BgL_v1318z00_615; } 
BGl_UvIdlez00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)45)), 
CNST_TABLE_REF(((long)8)), BGl_UvWatcherz00zz__libuv_typesz00, ((long)3465), BGl_proc2372z00zz__libuv_typesz00, BGl_proc2371z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2370z00zz__libuv_typesz00, BFALSE, BgL_arg1930z00_595, BgL_arg1931z00_596); } 
{ /* Llib/uvtypes.scm 66 */
obj_t BgL_arg1941z00_622;obj_t BgL_arg1942z00_623;
{ /* Llib/uvtypes.scm 66 */
obj_t BgL_v1319z00_641;
BgL_v1319z00_641 = 
create_vector(((long)0)); 
BgL_arg1941z00_622 = BgL_v1319z00_641; } 
{ /* Llib/uvtypes.scm 66 */
obj_t BgL_v1320z00_642;
BgL_v1320z00_642 = 
create_vector(((long)0)); 
BgL_arg1942z00_623 = BgL_v1320z00_642; } 
BGl_UvAsyncz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)46)), 
CNST_TABLE_REF(((long)8)), BGl_UvWatcherz00zz__libuv_typesz00, ((long)42569), BGl_proc2375z00zz__libuv_typesz00, BGl_proc2374z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2373z00zz__libuv_typesz00, BFALSE, BgL_arg1941z00_622, BgL_arg1942z00_623); } 
{ /* Llib/uvtypes.scm 68 */
obj_t BgL_arg1952z00_649;obj_t BgL_arg1953z00_650;
{ /* Llib/uvtypes.scm 68 */
obj_t BgL_v1321z00_669;
BgL_v1321z00_669 = 
create_vector(((long)1)); 
{ /* Llib/uvtypes.scm 68 */
obj_t BgL_arg1960z00_670;
BgL_arg1960z00_670 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)37)), BGl_proc2377z00zz__libuv_typesz00, BGl_proc2376z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)38))); 
VECTOR_SET(BgL_v1321z00_669,((long)0),BgL_arg1960z00_670); } 
BgL_arg1952z00_649 = BgL_v1321z00_669; } 
{ /* Llib/uvtypes.scm 68 */
obj_t BgL_v1322z00_680;
BgL_v1322z00_680 = 
create_vector(((long)0)); 
BgL_arg1953z00_650 = BgL_v1322z00_680; } 
BGl_UvPollz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)47)), 
CNST_TABLE_REF(((long)8)), BGl_UvWatcherz00zz__libuv_typesz00, ((long)5968), BGl_proc2380z00zz__libuv_typesz00, BGl_proc2379z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2378z00zz__libuv_typesz00, BFALSE, BgL_arg1952z00_649, BgL_arg1953z00_650); } 
{ /* Llib/uvtypes.scm 71 */
obj_t BgL_arg1968z00_687;obj_t BgL_arg1969z00_688;
{ /* Llib/uvtypes.scm 71 */
obj_t BgL_v1323z00_700;
BgL_v1323z00_700 = 
create_vector(((long)2)); 
{ /* Llib/uvtypes.scm 71 */
obj_t BgL_arg1975z00_701;
BgL_arg1975z00_701 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)37)), BGl_proc2382z00zz__libuv_typesz00, BGl_proc2381z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)38))); 
VECTOR_SET(BgL_v1323z00_700,((long)0),BgL_arg1975z00_701); } 
{ /* Llib/uvtypes.scm 71 */
obj_t BgL_arg1980z00_711;
BgL_arg1980z00_711 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)48)), BGl_proc2384z00zz__libuv_typesz00, BGl_proc2383z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)49))); 
VECTOR_SET(BgL_v1323z00_700,((long)1),BgL_arg1980z00_711); } 
BgL_arg1968z00_687 = BgL_v1323z00_700; } 
{ /* Llib/uvtypes.scm 71 */
obj_t BgL_v1324z00_721;
BgL_v1324z00_721 = 
create_vector(((long)0)); 
BgL_arg1969z00_688 = BgL_v1324z00_721; } 
BGl_UvFilez00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)50)), 
CNST_TABLE_REF(((long)8)), BGl_objectz00zz__objectz00, ((long)50283), BGl_proc2387z00zz__libuv_typesz00, BGl_proc2386z00zz__libuv_typesz00, BFALSE, BGl_proc2385z00zz__libuv_typesz00, BFALSE, BgL_arg1968z00_687, BgL_arg1969z00_688); } 
{ /* Llib/uvtypes.scm 75 */
obj_t BgL_arg1988z00_728;obj_t BgL_arg1989z00_729;
{ /* Llib/uvtypes.scm 75 */
obj_t BgL_v1325z00_747;
BgL_v1325z00_747 = 
create_vector(((long)0)); 
BgL_arg1988z00_728 = BgL_v1325z00_747; } 
{ /* Llib/uvtypes.scm 75 */
obj_t BgL_v1326z00_748;
BgL_v1326z00_748 = 
create_vector(((long)0)); 
BgL_arg1989z00_729 = BgL_v1326z00_748; } 
BGl_UvFsEventz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)51)), 
CNST_TABLE_REF(((long)8)), BGl_UvWatcherz00zz__libuv_typesz00, ((long)49452), BGl_proc2390z00zz__libuv_typesz00, BGl_proc2389z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2388z00zz__libuv_typesz00, BFALSE, BgL_arg1988z00_728, BgL_arg1989z00_729); } 
{ /* Llib/uvtypes.scm 77 */
obj_t BgL_arg1999z00_755;obj_t BgL_arg2000z00_756;
{ /* Llib/uvtypes.scm 77 */
obj_t BgL_v1327z00_774;
BgL_v1327z00_774 = 
create_vector(((long)0)); 
BgL_arg1999z00_755 = BgL_v1327z00_774; } 
{ /* Llib/uvtypes.scm 77 */
obj_t BgL_v1328z00_775;
BgL_v1328z00_775 = 
create_vector(((long)0)); 
BgL_arg2000z00_756 = BgL_v1328z00_775; } 
BGl_UvFsPollz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)52)), 
CNST_TABLE_REF(((long)8)), BGl_UvWatcherz00zz__libuv_typesz00, ((long)33371), BGl_proc2393z00zz__libuv_typesz00, BGl_proc2392z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2391z00zz__libuv_typesz00, BFALSE, BgL_arg1999z00_755, BgL_arg2000z00_756); } 
{ /* Llib/uvtypes.scm 79 */
obj_t BgL_arg2010z00_782;obj_t BgL_arg2011z00_783;
{ /* Llib/uvtypes.scm 79 */
obj_t BgL_v1329z00_801;
BgL_v1329z00_801 = 
create_vector(((long)0)); 
BgL_arg2010z00_782 = BgL_v1329z00_801; } 
{ /* Llib/uvtypes.scm 79 */
obj_t BgL_v1330z00_802;
BgL_v1330z00_802 = 
create_vector(((long)0)); 
BgL_arg2011z00_783 = BgL_v1330z00_802; } 
BGl_UvCheckz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)53)), 
CNST_TABLE_REF(((long)8)), BGl_UvWatcherz00zz__libuv_typesz00, ((long)52457), BGl_proc2396z00zz__libuv_typesz00, BGl_proc2395z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2394z00zz__libuv_typesz00, BFALSE, BgL_arg2010z00_782, BgL_arg2011z00_783); } 
{ /* Llib/uvtypes.scm 81 */
obj_t BgL_arg2021z00_809;obj_t BgL_arg2022z00_810;
{ /* Llib/uvtypes.scm 81 */
obj_t BgL_v1331z00_827;
BgL_v1331z00_827 = 
create_vector(((long)2)); 
{ /* Llib/uvtypes.scm 81 */
obj_t BgL_arg2029z00_828;
BgL_arg2029z00_828 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)54)), BGl_proc2399z00zz__libuv_typesz00, BGl_proc2398z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2397z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1331z00_827,((long)0),BgL_arg2029z00_828); } 
{ /* Llib/uvtypes.scm 81 */
obj_t BgL_arg2036z00_841;
BgL_arg2036z00_841 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)55)), BGl_proc2401z00zz__libuv_typesz00, BGl_proc2400z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)38))); 
VECTOR_SET(BgL_v1331z00_827,((long)1),BgL_arg2036z00_841); } 
BgL_arg2021z00_809 = BgL_v1331z00_827; } 
{ /* Llib/uvtypes.scm 81 */
obj_t BgL_v1332z00_851;
BgL_v1332z00_851 = 
create_vector(((long)1)); 
{ /* Llib/uvtypes.scm 85 */
obj_t BgL_arg2041z00_852;
{ /* Llib/uvtypes.scm 85 */
obj_t BgL_arg2042z00_853;
BgL_arg2042z00_853 = 
MAKE_YOUNG_PAIR(BGl_proc2402z00zz__libuv_typesz00, BFALSE); 
BgL_arg2041z00_852 = 
MAKE_YOUNG_PAIR(
BINT(((long)0)), BgL_arg2042z00_853); } 
VECTOR_SET(BgL_v1332z00_851,((long)0),BgL_arg2041z00_852); } 
BgL_arg2022z00_810 = BgL_v1332z00_851; } 
BGl_UvProcessz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)56)), 
CNST_TABLE_REF(((long)8)), BGl_UvHandlez00zz__libuv_typesz00, ((long)11647), BGl_proc2405z00zz__libuv_typesz00, BGl_proc2404z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2403z00zz__libuv_typesz00, BFALSE, BgL_arg2021z00_809, BgL_arg2022z00_810); } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2051z00_871;obj_t BgL_arg2052z00_872;
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_v1333z00_884;
BgL_v1333z00_884 = 
create_vector(((long)8)); 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2059z00_885;
BgL_arg2059z00_885 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)9)), BGl_proc2408z00zz__libuv_typesz00, BGl_proc2407z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2406z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)57))); 
VECTOR_SET(BgL_v1333z00_884,((long)0),BgL_arg2059z00_885); } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2066z00_898;
BgL_arg2066z00_898 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)58)), BGl_proc2410z00zz__libuv_typesz00, BGl_proc2409z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1333z00_884,((long)1),BgL_arg2066z00_898); } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2071z00_908;
BgL_arg2071z00_908 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc2412z00zz__libuv_typesz00, BGl_proc2411z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1333z00_884,((long)2),BgL_arg2071z00_908); } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2076z00_918;
BgL_arg2076z00_918 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)60)), BGl_proc2414z00zz__libuv_typesz00, BGl_proc2413z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1333z00_884,((long)3),BgL_arg2076z00_918); } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2081z00_928;
BgL_arg2081z00_928 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)61)), BGl_proc2416z00zz__libuv_typesz00, BGl_proc2415z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1333z00_884,((long)4),BgL_arg2081z00_928); } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2086z00_938;
BgL_arg2086z00_938 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)62)), BGl_proc2418z00zz__libuv_typesz00, BGl_proc2417z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1333z00_884,((long)5),BgL_arg2086z00_938); } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2091z00_948;
BgL_arg2091z00_948 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)63)), BGl_proc2420z00zz__libuv_typesz00, BGl_proc2419z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1333z00_884,((long)6),BgL_arg2091z00_948); } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2096z00_958;
BgL_arg2096z00_958 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)64)), BGl_proc2422z00zz__libuv_typesz00, BGl_proc2421z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1333z00_884,((long)7),BgL_arg2096z00_958); } 
BgL_arg2051z00_871 = BgL_v1333z00_884; } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_v1334z00_968;
BgL_v1334z00_968 = 
create_vector(((long)7)); 
{ /* Llib/uvtypes.scm 94 */
obj_t BgL_arg2102z00_969;
{ /* Llib/uvtypes.scm 94 */
obj_t BgL_arg2103z00_970;
BgL_arg2103z00_970 = 
MAKE_YOUNG_PAIR(BGl_proc2423z00zz__libuv_typesz00, BGl_proc2424z00zz__libuv_typesz00); 
BgL_arg2102z00_969 = 
MAKE_YOUNG_PAIR(
BINT(((long)0)), BgL_arg2103z00_970); } 
VECTOR_SET(BgL_v1334z00_968,((long)0),BgL_arg2102z00_969); } 
{ /* Llib/uvtypes.scm 102 */
obj_t BgL_arg2112z00_993;
{ /* Llib/uvtypes.scm 102 */
obj_t BgL_arg2113z00_994;
BgL_arg2113z00_994 = 
MAKE_YOUNG_PAIR(BGl_proc2425z00zz__libuv_typesz00, BGl_proc2426z00zz__libuv_typesz00); 
BgL_arg2112z00_993 = 
MAKE_YOUNG_PAIR(
BINT(((long)1)), BgL_arg2113z00_994); } 
VECTOR_SET(BgL_v1334z00_968,((long)1),BgL_arg2112z00_993); } 
{ /* Llib/uvtypes.scm 110 */
obj_t BgL_arg2122z00_1017;
{ /* Llib/uvtypes.scm 110 */
obj_t BgL_arg2123z00_1018;
BgL_arg2123z00_1018 = 
MAKE_YOUNG_PAIR(BGl_proc2427z00zz__libuv_typesz00, BGl_proc2428z00zz__libuv_typesz00); 
BgL_arg2122z00_1017 = 
MAKE_YOUNG_PAIR(
BINT(((long)2)), BgL_arg2123z00_1018); } 
VECTOR_SET(BgL_v1334z00_968,((long)2),BgL_arg2122z00_1017); } 
{ /* Llib/uvtypes.scm 118 */
obj_t BgL_arg2132z00_1041;
{ /* Llib/uvtypes.scm 118 */
obj_t BgL_arg2133z00_1042;
BgL_arg2133z00_1042 = 
MAKE_YOUNG_PAIR(BGl_proc2429z00zz__libuv_typesz00, BGl_proc2430z00zz__libuv_typesz00); 
BgL_arg2132z00_1041 = 
MAKE_YOUNG_PAIR(
BINT(((long)3)), BgL_arg2133z00_1042); } 
VECTOR_SET(BgL_v1334z00_968,((long)3),BgL_arg2132z00_1041); } 
{ /* Llib/uvtypes.scm 126 */
obj_t BgL_arg2142z00_1065;
{ /* Llib/uvtypes.scm 126 */
obj_t BgL_arg2143z00_1066;
BgL_arg2143z00_1066 = 
MAKE_YOUNG_PAIR(BGl_proc2431z00zz__libuv_typesz00, BGl_proc2432z00zz__libuv_typesz00); 
BgL_arg2142z00_1065 = 
MAKE_YOUNG_PAIR(
BINT(((long)4)), BgL_arg2143z00_1066); } 
VECTOR_SET(BgL_v1334z00_968,((long)4),BgL_arg2142z00_1065); } 
{ /* Llib/uvtypes.scm 134 */
obj_t BgL_arg2152z00_1089;
{ /* Llib/uvtypes.scm 134 */
obj_t BgL_arg2153z00_1090;
BgL_arg2153z00_1090 = 
MAKE_YOUNG_PAIR(BGl_proc2433z00zz__libuv_typesz00, BGl_proc2434z00zz__libuv_typesz00); 
BgL_arg2152z00_1089 = 
MAKE_YOUNG_PAIR(
BINT(((long)5)), BgL_arg2153z00_1090); } 
VECTOR_SET(BgL_v1334z00_968,((long)5),BgL_arg2152z00_1089); } 
{ /* Llib/uvtypes.scm 142 */
obj_t BgL_arg2162z00_1113;
{ /* Llib/uvtypes.scm 142 */
obj_t BgL_arg2163z00_1114;
BgL_arg2163z00_1114 = 
MAKE_YOUNG_PAIR(BGl_proc2435z00zz__libuv_typesz00, BGl_proc2436z00zz__libuv_typesz00); 
BgL_arg2162z00_1113 = 
MAKE_YOUNG_PAIR(
BINT(((long)6)), BgL_arg2163z00_1114); } 
VECTOR_SET(BgL_v1334z00_968,((long)6),BgL_arg2162z00_1113); } 
BgL_arg2052z00_872 = BgL_v1334z00_968; } 
BGl_UvProcessOptionsz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)65)), 
CNST_TABLE_REF(((long)8)), BGl_z52Uvz52zz__libuv_typesz00, ((long)34792), BGl_proc2439z00zz__libuv_typesz00, BGl_proc2438z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2437z00zz__libuv_typesz00, BFALSE, BgL_arg2051z00_871, BgL_arg2052z00_872); } 
{ /* Llib/uvtypes.scm 149 */
obj_t BgL_arg2175z00_1143;obj_t BgL_arg2176z00_1144;
{ /* Llib/uvtypes.scm 149 */
obj_t BgL_v1335z00_1158;
BgL_v1335z00_1158 = 
create_vector(((long)3)); 
{ /* Llib/uvtypes.scm 149 */
obj_t BgL_arg2183z00_1159;
BgL_arg2183z00_1159 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)9)), BGl_proc2442z00zz__libuv_typesz00, BGl_proc2441z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2440z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)66))); 
VECTOR_SET(BgL_v1335z00_1158,((long)0),BgL_arg2183z00_1159); } 
{ /* Llib/uvtypes.scm 149 */
obj_t BgL_arg2190z00_1172;
BgL_arg2190z00_1172 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)67)), BGl_proc2444z00zz__libuv_typesz00, BGl_proc2443z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)24))); 
VECTOR_SET(BgL_v1335z00_1158,((long)1),BgL_arg2190z00_1172); } 
{ /* Llib/uvtypes.scm 149 */
obj_t BgL_arg2195z00_1182;
BgL_arg2195z00_1182 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)68)), BGl_proc2446z00zz__libuv_typesz00, BGl_proc2445z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)24))); 
VECTOR_SET(BgL_v1335z00_1158,((long)2),BgL_arg2195z00_1182); } 
BgL_arg2175z00_1143 = BgL_v1335z00_1158; } 
{ /* Llib/uvtypes.scm 149 */
obj_t BgL_v1336z00_1192;
BgL_v1336z00_1192 = 
create_vector(((long)0)); 
BgL_arg2176z00_1144 = BgL_v1336z00_1192; } 
return ( 
BGl_UvWorkz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)69)), 
CNST_TABLE_REF(((long)8)), BGl_z52Uvz52zz__libuv_typesz00, ((long)37721), BGl_proc2449z00zz__libuv_typesz00, BGl_proc2448z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2447z00zz__libuv_typesz00, BFALSE, BgL_arg2175z00_1143, BgL_arg2176z00_1144), BUNSPEC) ;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2182> */
obj_t BGl_z62zc3anonymousza32182ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1909, obj_t BgL_new1239z00_1910)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 149 */
{ 
BgL_uvworkz00_bglt BgL_auxz00_3230;
((((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_new1239z00_1910)))->BgL_z42builtinz42)=((uv_work_t *)
0L),BUNSPEC); 
((((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_new1239z00_1910)))->BgL_z52workzd2cbz80)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_new1239z00_1910)))->BgL_z52afterzd2cbz80)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_3230 = 
((BgL_uvworkz00_bglt)BgL_new1239z00_1910); 
return 
((obj_t)BgL_auxz00_3230);} } 
BGL_FUNCTION_END;
}



/* &lambda2180 */
BgL_uvworkz00_bglt BGl_z62lambda2180z62zz__libuv_typesz00(obj_t BgL_envz00_1911)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 149 */
{ /* Llib/uvtypes.scm 149 */
BgL_uvworkz00_bglt BgL_new1238z00_2387;
BgL_new1238z00_2387 = 
((BgL_uvworkz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvworkz00_bgl) ))); 
{ /* Llib/uvtypes.scm 149 */
long BgL_arg2181z00_2388;
{ /* Llib/uvtypes.scm 149 */
long BgL_res2262z00_2389;
BgL_res2262z00_2389 = 
BGL_CLASS_INDEX(BGl_UvWorkz00zz__libuv_typesz00); 
BgL_arg2181z00_2388 = BgL_res2262z00_2389; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1238z00_2387), BgL_arg2181z00_2388); } 
return BgL_new1238z00_2387;} } 
BGL_FUNCTION_END;
}



/* &lambda2177 */
BgL_uvworkz00_bglt BGl_z62lambda2177z62zz__libuv_typesz00(obj_t BgL_envz00_1912, obj_t BgL_z42builtin1235z42_1913, obj_t BgL_z52workzd2cb1236z80_1914, obj_t BgL_z52afterzd2cb1237z80_1915)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 149 */
{ /* Llib/uvtypes.scm 149 */
uv_work_t * BgL_z42builtin1235z42_2390;
BgL_z42builtin1235z42_2390 = 
FOREIGN_TO_COBJ(BgL_z42builtin1235z42_1913); 
{ /* Llib/uvtypes.scm 149 */
BgL_uvworkz00_bglt BgL_new1296z00_2393;
{ /* Llib/uvtypes.scm 149 */
BgL_uvworkz00_bglt BgL_new1295z00_2394;
BgL_new1295z00_2394 = 
((BgL_uvworkz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvworkz00_bgl) ))); 
{ /* Llib/uvtypes.scm 149 */
long BgL_arg2179z00_2395;
{ /* Llib/uvtypes.scm 149 */
long BgL_res2261z00_2396;
BgL_res2261z00_2396 = 
BGL_CLASS_INDEX(BGl_UvWorkz00zz__libuv_typesz00); 
BgL_arg2179z00_2395 = BgL_res2261z00_2396; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1295z00_2394), BgL_arg2179z00_2395); } 
BgL_new1296z00_2393 = BgL_new1295z00_2394; } 
((((BgL_uvworkz00_bglt)COBJECT(BgL_new1296z00_2393))->BgL_z42builtinz42)=((uv_work_t *)BgL_z42builtin1235z42_2390),BUNSPEC); 
((((BgL_uvworkz00_bglt)COBJECT(BgL_new1296z00_2393))->BgL_z52workzd2cbz80)=((obj_t)
((obj_t)BgL_z52workzd2cb1236z80_1914)),BUNSPEC); 
((((BgL_uvworkz00_bglt)COBJECT(BgL_new1296z00_2393))->BgL_z52afterzd2cbz80)=((obj_t)
((obj_t)BgL_z52afterzd2cb1237z80_1915)),BUNSPEC); 
{ /* Llib/uvtypes.scm 149 */
obj_t BgL_fun2178z00_2397;
BgL_fun2178z00_2397 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvWorkz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun2178z00_2397)(BgL_fun2178z00_2397, 
((obj_t)BgL_new1296z00_2393), BEOA); } 
return BgL_new1296z00_2393;} } } 
BGL_FUNCTION_END;
}



/* &lambda2199 */
obj_t BGl_z62lambda2199z62zz__libuv_typesz00(obj_t BgL_envz00_1916, obj_t BgL_oz00_1917, obj_t BgL_vz00_1918)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 149 */
return 
((((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_oz00_1917)))->BgL_z52afterzd2cbz80)=((obj_t)
((obj_t)BgL_vz00_1918)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2198 */
obj_t BGl_z62lambda2198z62zz__libuv_typesz00(obj_t BgL_envz00_1919, obj_t BgL_oz00_1920)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 149 */
return 
(((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_oz00_1920)))->BgL_z52afterzd2cbz80);} 
BGL_FUNCTION_END;
}



/* &lambda2194 */
obj_t BGl_z62lambda2194z62zz__libuv_typesz00(obj_t BgL_envz00_1921, obj_t BgL_oz00_1922, obj_t BgL_vz00_1923)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 149 */
return 
((((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_oz00_1922)))->BgL_z52workzd2cbz80)=((obj_t)
((obj_t)BgL_vz00_1923)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2193 */
obj_t BGl_z62lambda2193z62zz__libuv_typesz00(obj_t BgL_envz00_1924, obj_t BgL_oz00_1925)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 149 */
return 
(((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_oz00_1925)))->BgL_z52workzd2cbz80);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2189> */
obj_t BGl_z62zc3anonymousza32189ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1926)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 149 */
return 
void_star_to_obj(0L);} 
BGL_FUNCTION_END;
}



/* &lambda2188 */
obj_t BGl_z62lambda2188z62zz__libuv_typesz00(obj_t BgL_envz00_1927, obj_t BgL_oz00_1928, obj_t BgL_vz00_1929)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 149 */
{ /* Llib/uvtypes.scm 149 */
uv_work_t * BgL_vz00_2405;
BgL_vz00_2405 = 
FOREIGN_TO_COBJ(BgL_vz00_1929); 
return 
((((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_oz00_1928)))->BgL_z42builtinz42)=((uv_work_t *)BgL_vz00_2405),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2187 */
obj_t BGl_z62lambda2187z62zz__libuv_typesz00(obj_t BgL_envz00_1930, obj_t BgL_oz00_1931)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 149 */
return 
void_star_to_obj(
(((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_oz00_1931)))->BgL_z42builtinz42));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2058> */
obj_t BGl_z62zc3anonymousza32058ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1932, obj_t BgL_new1233z00_1933)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 89 */
{ 
BgL_uvprocessoptionsz00_bglt BgL_auxz00_3277;
((((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_new1233z00_1933)))->BgL_z42builtinz42)=((uv_process_options_t *)
0L),BUNSPEC); 
BgL_auxz00_3277 = 
((BgL_uvprocessoptionsz00_bglt)BgL_new1233z00_1933); 
return 
((obj_t)BgL_auxz00_3277);} } 
BGL_FUNCTION_END;
}



/* &lambda2056 */
BgL_uvprocessoptionsz00_bglt BGl_z62lambda2056z62zz__libuv_typesz00(obj_t BgL_envz00_1934)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 89 */
{ /* Llib/uvtypes.scm 89 */
BgL_uvprocessoptionsz00_bglt BgL_new1232z00_2408;
BgL_new1232z00_2408 = 
((BgL_uvprocessoptionsz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvprocessoptionsz00_bgl) ))); 
{ /* Llib/uvtypes.scm 89 */
long BgL_arg2057z00_2409;
{ /* Llib/uvtypes.scm 89 */
long BgL_res2260z00_2410;
BgL_res2260z00_2410 = 
BGL_CLASS_INDEX(BGl_UvProcessOptionsz00zz__libuv_typesz00); 
BgL_arg2057z00_2409 = BgL_res2260z00_2410; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1232z00_2408), BgL_arg2057z00_2409); } 
return BgL_new1232z00_2408;} } 
BGL_FUNCTION_END;
}



/* &lambda2053 */
BgL_uvprocessoptionsz00_bglt BGl_z62lambda2053z62zz__libuv_typesz00(obj_t BgL_envz00_1935, obj_t BgL_z42builtin1231z42_1936)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 89 */
{ /* Llib/uvtypes.scm 89 */
uv_process_options_t * BgL_z42builtin1231z42_2411;
BgL_z42builtin1231z42_2411 = 
FOREIGN_TO_COBJ(BgL_z42builtin1231z42_1936); 
{ /* Llib/uvtypes.scm 89 */
BgL_uvprocessoptionsz00_bglt BgL_new1280z00_2412;
{ /* Llib/uvtypes.scm 89 */
BgL_uvprocessoptionsz00_bglt BgL_new1279z00_2413;
BgL_new1279z00_2413 = 
((BgL_uvprocessoptionsz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvprocessoptionsz00_bgl) ))); 
{ /* Llib/uvtypes.scm 89 */
long BgL_arg2055z00_2414;
{ /* Llib/uvtypes.scm 89 */
long BgL_res2259z00_2415;
BgL_res2259z00_2415 = 
BGL_CLASS_INDEX(BGl_UvProcessOptionsz00zz__libuv_typesz00); 
BgL_arg2055z00_2414 = BgL_res2259z00_2415; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1279z00_2413), BgL_arg2055z00_2414); } 
BgL_new1280z00_2412 = BgL_new1279z00_2413; } 
((((BgL_uvprocessoptionsz00_bglt)COBJECT(BgL_new1280z00_2412))->BgL_z42builtinz42)=((uv_process_options_t *)BgL_z42builtin1231z42_2411),BUNSPEC); 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_fun2054z00_2416;
BgL_fun2054z00_2416 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvProcessOptionsz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun2054z00_2416)(BgL_fun2054z00_2416, 
((obj_t)BgL_new1280z00_2412), BEOA); } 
return BgL_new1280z00_2412;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2169> */
obj_t BGl_z62zc3anonymousza32169ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1937, obj_t BgL_oz00_1938, obj_t BgL_vz00_1939)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 140 */
{ /* Llib/uvtypes.scm 146 */
uv_process_options_t * BgL_arg2170z00_2417;
BgL_arg2170z00_2417 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1938)))->BgL_z42builtinz42); 
{ /* Llib/uvtypes.scm 146 */
int BgL_tmpz00_3301;
BgL_tmpz00_3301 = 
CINT(BgL_vz00_1939); 
BGL_UV_PROCESS_OPTIONS_GID_SET(BgL_arg2170z00_2417, BgL_tmpz00_3301); } BUNSPEC; } 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* &<anonymous:2166> */
obj_t BGl_z62zc3anonymousza32166ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1940, obj_t BgL_oz00_1941)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 140 */
{ /* Llib/uvtypes.scm 142 */
int BgL_tmpz00_3304;
{ /* Llib/uvtypes.scm 143 */
uv_process_options_t * BgL_arg2167z00_2418;
BgL_arg2167z00_2418 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1941)))->BgL_z42builtinz42); 
BgL_tmpz00_3304 = 
BGL_UV_PROCESS_OPTIONS_GID_GET(BgL_arg2167z00_2418); } 
return 
BINT(BgL_tmpz00_3304);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2159> */
obj_t BGl_z62zc3anonymousza32159ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1942, obj_t BgL_oz00_1943, obj_t BgL_vz00_1944)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 132 */
{ /* Llib/uvtypes.scm 138 */
uv_process_options_t * BgL_arg2160z00_2419;
BgL_arg2160z00_2419 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1943)))->BgL_z42builtinz42); 
{ /* Llib/uvtypes.scm 138 */
int BgL_tmpz00_3311;
BgL_tmpz00_3311 = 
CINT(BgL_vz00_1944); 
BGL_UV_PROCESS_OPTIONS_UID_SET(BgL_arg2160z00_2419, BgL_tmpz00_3311); } BUNSPEC; } 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* &<anonymous:2156> */
obj_t BGl_z62zc3anonymousza32156ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1945, obj_t BgL_oz00_1946)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 132 */
{ /* Llib/uvtypes.scm 134 */
int BgL_tmpz00_3314;
{ /* Llib/uvtypes.scm 135 */
uv_process_options_t * BgL_arg2157z00_2420;
BgL_arg2157z00_2420 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1946)))->BgL_z42builtinz42); 
BgL_tmpz00_3314 = 
BGL_UV_PROCESS_OPTIONS_UID_GET(BgL_arg2157z00_2420); } 
return 
BINT(BgL_tmpz00_3314);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2149> */
obj_t BGl_z62zc3anonymousza32149ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1947, obj_t BgL_oz00_1948, obj_t BgL_vz00_1949)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 124 */
{ /* Llib/uvtypes.scm 130 */
uv_process_options_t * BgL_arg2150z00_2421;
BgL_arg2150z00_2421 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1948)))->BgL_z42builtinz42); 
{ /* Llib/uvtypes.scm 130 */
int BgL_tmpz00_3321;
BgL_tmpz00_3321 = 
CINT(BgL_vz00_1949); 
BGL_UV_PROCESS_OPTIONS_FLAGS_SET(BgL_arg2150z00_2421, BgL_tmpz00_3321); } BUNSPEC; } 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* &<anonymous:2146> */
obj_t BGl_z62zc3anonymousza32146ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1950, obj_t BgL_oz00_1951)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 124 */
{ /* Llib/uvtypes.scm 126 */
int BgL_tmpz00_3324;
{ /* Llib/uvtypes.scm 127 */
uv_process_options_t * BgL_arg2147z00_2422;
BgL_arg2147z00_2422 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1951)))->BgL_z42builtinz42); 
BgL_tmpz00_3324 = 
BGL_UV_PROCESS_OPTIONS_FLAGS_GET(BgL_arg2147z00_2422); } 
return 
BINT(BgL_tmpz00_3324);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2139> */
obj_t BGl_z62zc3anonymousza32139ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1952, obj_t BgL_oz00_1953, obj_t BgL_vz00_1954)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 116 */
{ /* Llib/uvtypes.scm 122 */
uv_process_options_t * BgL_arg2140z00_2423;
BgL_arg2140z00_2423 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1953)))->BgL_z42builtinz42); 
{ /* Llib/uvtypes.scm 122 */
char * BgL_tmpz00_3331;
BgL_tmpz00_3331 = 
BSTRING_TO_STRING(BgL_vz00_1954); 
BGL_UV_PROCESS_OPTIONS_CWD_SET(BgL_arg2140z00_2423, BgL_tmpz00_3331); } BUNSPEC; } 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* &<anonymous:2136> */
obj_t BGl_z62zc3anonymousza32136ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1955, obj_t BgL_oz00_1956)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 116 */
{ /* Llib/uvtypes.scm 118 */
char * BgL_tmpz00_3334;
{ /* Llib/uvtypes.scm 119 */
uv_process_options_t * BgL_arg2137z00_2424;
BgL_arg2137z00_2424 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1956)))->BgL_z42builtinz42); 
BgL_tmpz00_3334 = 
BGL_UV_PROCESS_OPTIONS_CWD_GET(BgL_arg2137z00_2424); } 
return 
string_to_bstring(BgL_tmpz00_3334);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2129> */
obj_t BGl_z62zc3anonymousza32129ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1957, obj_t BgL_oz00_1958, obj_t BgL_vz00_1959)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 108 */
{ /* Llib/uvtypes.scm 114 */
uv_process_options_t * BgL_arg2130z00_2425;
BgL_arg2130z00_2425 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1958)))->BgL_z42builtinz42); 
bgl_uv_process_options_env_set(BgL_arg2130z00_2425, BgL_vz00_1959); BUNSPEC; } 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* &<anonymous:2126> */
obj_t BGl_z62zc3anonymousza32126ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1960, obj_t BgL_oz00_1961)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 108 */
{ /* Llib/uvtypes.scm 111 */
uv_process_options_t * BgL_arg2127z00_2426;
BgL_arg2127z00_2426 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1961)))->BgL_z42builtinz42); 
return 
bgl_uv_process_options_env_get(BgL_arg2127z00_2426);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2119> */
obj_t BGl_z62zc3anonymousza32119ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1962, obj_t BgL_oz00_1963, obj_t BgL_vz00_1964)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 100 */
{ /* Llib/uvtypes.scm 106 */
uv_process_options_t * BgL_arg2120z00_2427;
BgL_arg2120z00_2427 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1963)))->BgL_z42builtinz42); 
bgl_uv_process_options_args_set(BgL_arg2120z00_2427, BgL_vz00_1964); BUNSPEC; } 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* &<anonymous:2116> */
obj_t BGl_z62zc3anonymousza32116ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1965, obj_t BgL_oz00_1966)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 100 */
{ /* Llib/uvtypes.scm 103 */
uv_process_options_t * BgL_arg2117z00_2428;
BgL_arg2117z00_2428 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1966)))->BgL_z42builtinz42); 
return 
bgl_uv_process_options_args_get(BgL_arg2117z00_2428);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2109> */
obj_t BGl_z62zc3anonymousza32109ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1967, obj_t BgL_oz00_1968, obj_t BgL_vz00_1969)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 92 */
{ /* Llib/uvtypes.scm 98 */
uv_process_options_t * BgL_arg2110z00_2429;
BgL_arg2110z00_2429 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1968)))->BgL_z42builtinz42); 
{ /* Llib/uvtypes.scm 98 */
char * BgL_tmpz00_3353;
BgL_tmpz00_3353 = 
BSTRING_TO_STRING(BgL_vz00_1969); 
BGL_UV_PROCESS_OPTIONS_FILE_SET(BgL_arg2110z00_2429, BgL_tmpz00_3353); } BUNSPEC; } 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* &<anonymous:2106> */
obj_t BGl_z62zc3anonymousza32106ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1970, obj_t BgL_oz00_1971)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 92 */
{ /* Llib/uvtypes.scm 94 */
char * BgL_tmpz00_3356;
{ /* Llib/uvtypes.scm 95 */
uv_process_options_t * BgL_arg2107z00_2430;
BgL_arg2107z00_2430 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1971)))->BgL_z42builtinz42); 
BgL_tmpz00_3356 = 
BGL_UV_PROCESS_OPTIONS_FILE_GET(BgL_arg2107z00_2430); } 
return 
string_to_bstring(BgL_tmpz00_3356);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2101> */
obj_t BGl_z62zc3anonymousza32101ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1972, obj_t BgL_oz00_1973, obj_t BgL_vz00_1974)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1973), 
(int)(((long)6)), BgL_vz00_1974);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2100> */
obj_t BGl_z62zc3anonymousza32100ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1975, obj_t BgL_oz00_1976)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1976), 
(int)(((long)6)));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2095> */
obj_t BGl_z62zc3anonymousza32095ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1977, obj_t BgL_oz00_1978, obj_t BgL_vz00_1979)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1978), 
(int)(((long)5)), BgL_vz00_1979);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2094> */
obj_t BGl_z62zc3anonymousza32094ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1980, obj_t BgL_oz00_1981)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1981), 
(int)(((long)5)));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2090> */
obj_t BGl_z62zc3anonymousza32090ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1982, obj_t BgL_oz00_1983, obj_t BgL_vz00_1984)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1983), 
(int)(((long)4)), BgL_vz00_1984);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2089> */
obj_t BGl_z62zc3anonymousza32089ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1985, obj_t BgL_oz00_1986)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1986), 
(int)(((long)4)));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2085> */
obj_t BGl_z62zc3anonymousza32085ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1987, obj_t BgL_oz00_1988, obj_t BgL_vz00_1989)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1988), 
(int)(((long)3)), BgL_vz00_1989);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2084> */
obj_t BGl_z62zc3anonymousza32084ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1990, obj_t BgL_oz00_1991)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1991), 
(int)(((long)3)));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2080> */
obj_t BGl_z62zc3anonymousza32080ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1992, obj_t BgL_oz00_1993, obj_t BgL_vz00_1994)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1993), 
(int)(((long)2)), BgL_vz00_1994);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2079> */
obj_t BGl_z62zc3anonymousza32079ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1995, obj_t BgL_oz00_1996)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1996), 
(int)(((long)2)));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2075> */
obj_t BGl_z62zc3anonymousza32075ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_1997, obj_t BgL_oz00_1998, obj_t BgL_vz00_1999)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1998), 
(int)(((long)1)), BgL_vz00_1999);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2074> */
obj_t BGl_z62zc3anonymousza32074ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2000, obj_t BgL_oz00_2001)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2001), 
(int)(((long)1)));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2070> */
obj_t BGl_z62zc3anonymousza32070ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2002, obj_t BgL_oz00_2003, obj_t BgL_vz00_2004)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2003), 
(int)(((long)0)), BgL_vz00_2004);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2069> */
obj_t BGl_z62zc3anonymousza32069ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2005, obj_t BgL_oz00_2006)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2006), 
(int)(((long)0)));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2065> */
obj_t BGl_z62zc3anonymousza32065ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2007)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 89 */
return 
void_star_to_obj(
((uv_process_options_t *)GC_MALLOC( sizeof( uv_process_options_t ) )));} 
BGL_FUNCTION_END;
}



/* &lambda2064 */
obj_t BGl_z62lambda2064z62zz__libuv_typesz00(obj_t BgL_envz00_2008, obj_t BgL_oz00_2009, obj_t BgL_vz00_2010)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 89 */
{ /* Llib/uvtypes.scm 89 */
uv_process_options_t * BgL_vz00_2432;
BgL_vz00_2432 = 
FOREIGN_TO_COBJ(BgL_vz00_2010); 
return 
((((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_2009)))->BgL_z42builtinz42)=((uv_process_options_t *)BgL_vz00_2432),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2063 */
obj_t BGl_z62lambda2063z62zz__libuv_typesz00(obj_t BgL_envz00_2011, obj_t BgL_oz00_2012)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 89 */
return 
void_star_to_obj(
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_2012)))->BgL_z42builtinz42));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2028> */
obj_t BGl_z62zc3anonymousza32028ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2013, obj_t BgL_new1229z00_2014)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 81 */
{ 
BgL_uvprocessz00_bglt BgL_auxz00_3411;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvprocessz00_bglt)BgL_new1229z00_2014))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvprocessz00_bglt)BgL_new1229z00_2014))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvprocessz00_bglt)BgL_new1229z00_2014))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvprocessz00_bglt)BgL_new1229z00_2014))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvprocessz00_bglt)BgL_new1229z00_2014))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_uvprocessz00_bglt)COBJECT(
((BgL_uvprocessz00_bglt)BgL_new1229z00_2014)))->BgL_z42onexitz42)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_3411 = 
((BgL_uvprocessz00_bglt)BgL_new1229z00_2014); 
return 
((obj_t)BgL_auxz00_3411);} } 
BGL_FUNCTION_END;
}



/* &lambda2026 */
BgL_uvprocessz00_bglt BGl_z62lambda2026z62zz__libuv_typesz00(obj_t BgL_envz00_2015)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 81 */
{ /* Llib/uvtypes.scm 81 */
BgL_uvprocessz00_bglt BgL_new1228z00_2435;
BgL_new1228z00_2435 = 
((BgL_uvprocessz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvprocessz00_bgl) ))); 
{ /* Llib/uvtypes.scm 81 */
long BgL_arg2027z00_2436;
{ /* Llib/uvtypes.scm 81 */
long BgL_res2258z00_2437;
BgL_res2258z00_2437 = 
BGL_CLASS_INDEX(BGl_UvProcessz00zz__libuv_typesz00); 
BgL_arg2027z00_2436 = BgL_res2258z00_2437; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1228z00_2435), BgL_arg2027z00_2436); } 
return BgL_new1228z00_2435;} } 
BGL_FUNCTION_END;
}



/* &lambda2023 */
BgL_uvprocessz00_bglt BGl_z62lambda2023z62zz__libuv_typesz00(obj_t BgL_envz00_2016, obj_t BgL_z42builtin1222z42_2017, obj_t BgL_z52onclose1223z52_2018, obj_t BgL_z52gcmarkshead1224z52_2019, obj_t BgL_z52gcmarkstail1225z52_2020, obj_t BgL_closed1226z00_2021, obj_t BgL_z42onexit1227z42_2022)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 81 */
{ /* Llib/uvtypes.scm 81 */
uv_handle_t * BgL_z42builtin1222z42_2438;bool_t BgL_closed1226z00_2441;
BgL_z42builtin1222z42_2438 = 
FOREIGN_TO_COBJ(BgL_z42builtin1222z42_2017); 
BgL_closed1226z00_2441 = 
CBOOL(BgL_closed1226z00_2021); 
{ /* Llib/uvtypes.scm 81 */
BgL_uvprocessz00_bglt BgL_new1277z00_2442;
{ /* Llib/uvtypes.scm 81 */
BgL_uvprocessz00_bglt BgL_new1276z00_2443;
BgL_new1276z00_2443 = 
((BgL_uvprocessz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvprocessz00_bgl) ))); 
{ /* Llib/uvtypes.scm 81 */
long BgL_arg2025z00_2444;
{ /* Llib/uvtypes.scm 81 */
long BgL_res2257z00_2445;
BgL_res2257z00_2445 = 
BGL_CLASS_INDEX(BGl_UvProcessz00zz__libuv_typesz00); 
BgL_arg2025z00_2444 = BgL_res2257z00_2445; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1276z00_2443), BgL_arg2025z00_2444); } 
BgL_new1277z00_2442 = BgL_new1276z00_2443; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1277z00_2442)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1222z42_2438),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1277z00_2442)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1223z52_2018),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1277z00_2442)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1224z52_2019)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1277z00_2442)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1225z52_2020)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1277z00_2442)))->BgL_closedz00)=((bool_t)BgL_closed1226z00_2441),BUNSPEC); 
((((BgL_uvprocessz00_bglt)COBJECT(BgL_new1277z00_2442))->BgL_z42onexitz42)=((obj_t)BgL_z42onexit1227z42_2022),BUNSPEC); 
{ /* Llib/uvtypes.scm 81 */
obj_t BgL_fun2024z00_2446;
BgL_fun2024z00_2446 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvProcessz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun2024z00_2446)(BgL_fun2024z00_2446, 
((obj_t)BgL_new1277z00_2442), BEOA); } 
return BgL_new1277z00_2442;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2044> */
obj_t BGl_z62zc3anonymousza32044ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2023, obj_t BgL_oz00_2024)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 83 */
{ /* Llib/uvtypes.scm 85 */
int BgL_tmpz00_3461;
{ /* Llib/uvtypes.scm 86 */
uv_process_t * BgL_arg2045z00_2447;
{ /* Llib/uvtypes.scm 86 */
uv_handle_t * BgL_arg2046z00_2448;
BgL_arg2046z00_2448 = 
(((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvprocessz00_bglt)BgL_oz00_2024))))->BgL_z42builtinz42); 
BgL_arg2045z00_2447 = 
(uv_process_t *)(BgL_arg2046z00_2448); } 
BgL_tmpz00_3461 = 
(BgL_arg2045z00_2447->pid); } 
return 
BINT(BgL_tmpz00_3461);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2040> */
obj_t BGl_z62zc3anonymousza32040ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2025, obj_t BgL_oz00_2026, obj_t BgL_vz00_2027)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 81 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2026), 
(int)(((long)0)), BgL_vz00_2027);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2039> */
obj_t BGl_z62zc3anonymousza32039ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2028, obj_t BgL_oz00_2029)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 81 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2029), 
(int)(((long)0)));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2035> */
obj_t BGl_z62zc3anonymousza32035ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2030)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 81 */
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* &lambda2034 */
obj_t BGl_z62lambda2034z62zz__libuv_typesz00(obj_t BgL_envz00_2031, obj_t BgL_oz00_2032, obj_t BgL_vz00_2033)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 81 */
return 
((((BgL_uvprocessz00_bglt)COBJECT(
((BgL_uvprocessz00_bglt)BgL_oz00_2032)))->BgL_z42onexitz42)=((obj_t)BgL_vz00_2033),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2033 */
obj_t BGl_z62lambda2033z62zz__libuv_typesz00(obj_t BgL_envz00_2034, obj_t BgL_oz00_2035)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 81 */
return 
(((BgL_uvprocessz00_bglt)COBJECT(
((BgL_uvprocessz00_bglt)BgL_oz00_2035)))->BgL_z42onexitz42);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2017> */
obj_t BGl_z62zc3anonymousza32017ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2036, obj_t BgL_new1220z00_2037)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 79 */
{ 
BgL_uvcheckz00_bglt BgL_auxz00_3478;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvcheckz00_bglt)BgL_new1220z00_2037))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvcheckz00_bglt)BgL_new1220z00_2037))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvcheckz00_bglt)BgL_new1220z00_2037))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvcheckz00_bglt)BgL_new1220z00_2037))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvcheckz00_bglt)BgL_new1220z00_2037))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_3495;
{ /* Llib/uvtypes.scm 79 */
obj_t BgL_classz00_2452;
BgL_classz00_2452 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 79 */
obj_t BgL__ortest_1106z00_2453;
BgL__ortest_1106z00_2453 = 
BGL_CLASS_NIL(BgL_classz00_2452); 
if(
CBOOL(BgL__ortest_1106z00_2453))
{ /* Llib/uvtypes.scm 79 */
BgL_auxz00_3495 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2453)
; }  else 
{ /* Llib/uvtypes.scm 79 */
BgL_auxz00_3495 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2452))
; } } } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvcheckz00_bglt)BgL_new1220z00_2037))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_3495),BUNSPEC); } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvcheckz00_bglt)BgL_new1220z00_2037))))->BgL_cbz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_3478 = 
((BgL_uvcheckz00_bglt)BgL_new1220z00_2037); 
return 
((obj_t)BgL_auxz00_3478);} } 
BGL_FUNCTION_END;
}



/* &lambda2015 */
BgL_uvcheckz00_bglt BGl_z62lambda2015z62zz__libuv_typesz00(obj_t BgL_envz00_2038)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 79 */
{ /* Llib/uvtypes.scm 79 */
BgL_uvcheckz00_bglt BgL_new1219z00_2454;
BgL_new1219z00_2454 = 
((BgL_uvcheckz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvcheckz00_bgl) ))); 
{ /* Llib/uvtypes.scm 79 */
long BgL_arg2016z00_2455;
{ /* Llib/uvtypes.scm 79 */
long BgL_res2256z00_2456;
BgL_res2256z00_2456 = 
BGL_CLASS_INDEX(BGl_UvCheckz00zz__libuv_typesz00); 
BgL_arg2016z00_2455 = BgL_res2256z00_2456; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1219z00_2454), BgL_arg2016z00_2455); } 
return BgL_new1219z00_2454;} } 
BGL_FUNCTION_END;
}



/* &lambda2012 */
BgL_uvcheckz00_bglt BGl_z62lambda2012z62zz__libuv_typesz00(obj_t BgL_envz00_2039, obj_t BgL_z42builtin1212z42_2040, obj_t BgL_z52onclose1213z52_2041, obj_t BgL_z52gcmarkshead1214z52_2042, obj_t BgL_z52gcmarkstail1215z52_2043, obj_t BgL_closed1216z00_2044, obj_t BgL_loop1217z00_2045, obj_t BgL_cb1218z00_2046)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 79 */
{ /* Llib/uvtypes.scm 79 */
uv_handle_t * BgL_z42builtin1212z42_2457;bool_t BgL_closed1216z00_2460;
BgL_z42builtin1212z42_2457 = 
FOREIGN_TO_COBJ(BgL_z42builtin1212z42_2040); 
BgL_closed1216z00_2460 = 
CBOOL(BgL_closed1216z00_2044); 
{ /* Llib/uvtypes.scm 79 */
BgL_uvcheckz00_bglt BgL_new1275z00_2463;
{ /* Llib/uvtypes.scm 79 */
BgL_uvcheckz00_bglt BgL_new1274z00_2464;
BgL_new1274z00_2464 = 
((BgL_uvcheckz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvcheckz00_bgl) ))); 
{ /* Llib/uvtypes.scm 79 */
long BgL_arg2014z00_2465;
{ /* Llib/uvtypes.scm 79 */
long BgL_res2255z00_2466;
BgL_res2255z00_2466 = 
BGL_CLASS_INDEX(BGl_UvCheckz00zz__libuv_typesz00); 
BgL_arg2014z00_2465 = BgL_res2255z00_2466; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1274z00_2464), BgL_arg2014z00_2465); } 
BgL_new1275z00_2463 = BgL_new1274z00_2464; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1275z00_2463)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1212z42_2457),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1275z00_2463)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1213z52_2041),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1275z00_2463)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1214z52_2042)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1275z00_2463)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1215z52_2043)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1275z00_2463)))->BgL_closedz00)=((bool_t)BgL_closed1216z00_2460),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1275z00_2463)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1217z00_2045)),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1275z00_2463)))->BgL_cbz00)=((obj_t)
((obj_t)BgL_cb1218z00_2046)),BUNSPEC); 
{ /* Llib/uvtypes.scm 79 */
obj_t BgL_fun2013z00_2467;
BgL_fun2013z00_2467 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvCheckz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun2013z00_2467)(BgL_fun2013z00_2467, 
((obj_t)BgL_new1275z00_2463), BEOA); } 
return BgL_new1275z00_2463;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2006> */
obj_t BGl_z62zc3anonymousza32006ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2047, obj_t BgL_new1210z00_2048)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 77 */
{ 
BgL_uvfspollz00_bglt BgL_auxz00_3544;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfspollz00_bglt)BgL_new1210z00_2048))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfspollz00_bglt)BgL_new1210z00_2048))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfspollz00_bglt)BgL_new1210z00_2048))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfspollz00_bglt)BgL_new1210z00_2048))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfspollz00_bglt)BgL_new1210z00_2048))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_3561;
{ /* Llib/uvtypes.scm 77 */
obj_t BgL_classz00_2469;
BgL_classz00_2469 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 77 */
obj_t BgL__ortest_1106z00_2470;
BgL__ortest_1106z00_2470 = 
BGL_CLASS_NIL(BgL_classz00_2469); 
if(
CBOOL(BgL__ortest_1106z00_2470))
{ /* Llib/uvtypes.scm 77 */
BgL_auxz00_3561 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2470)
; }  else 
{ /* Llib/uvtypes.scm 77 */
BgL_auxz00_3561 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2469))
; } } } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvfspollz00_bglt)BgL_new1210z00_2048))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_3561),BUNSPEC); } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvfspollz00_bglt)BgL_new1210z00_2048))))->BgL_cbz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_3544 = 
((BgL_uvfspollz00_bglt)BgL_new1210z00_2048); 
return 
((obj_t)BgL_auxz00_3544);} } 
BGL_FUNCTION_END;
}



/* &lambda2004 */
BgL_uvfspollz00_bglt BGl_z62lambda2004z62zz__libuv_typesz00(obj_t BgL_envz00_2049)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 77 */
{ /* Llib/uvtypes.scm 77 */
BgL_uvfspollz00_bglt BgL_new1209z00_2471;
BgL_new1209z00_2471 = 
((BgL_uvfspollz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvfspollz00_bgl) ))); 
{ /* Llib/uvtypes.scm 77 */
long BgL_arg2005z00_2472;
{ /* Llib/uvtypes.scm 77 */
long BgL_res2254z00_2473;
BgL_res2254z00_2473 = 
BGL_CLASS_INDEX(BGl_UvFsPollz00zz__libuv_typesz00); 
BgL_arg2005z00_2472 = BgL_res2254z00_2473; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1209z00_2471), BgL_arg2005z00_2472); } 
return BgL_new1209z00_2471;} } 
BGL_FUNCTION_END;
}



/* &lambda2001 */
BgL_uvfspollz00_bglt BGl_z62lambda2001z62zz__libuv_typesz00(obj_t BgL_envz00_2050, obj_t BgL_z42builtin1202z42_2051, obj_t BgL_z52onclose1203z52_2052, obj_t BgL_z52gcmarkshead1204z52_2053, obj_t BgL_z52gcmarkstail1205z52_2054, obj_t BgL_closed1206z00_2055, obj_t BgL_loop1207z00_2056, obj_t BgL_cb1208z00_2057)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 77 */
{ /* Llib/uvtypes.scm 77 */
uv_handle_t * BgL_z42builtin1202z42_2474;bool_t BgL_closed1206z00_2477;
BgL_z42builtin1202z42_2474 = 
FOREIGN_TO_COBJ(BgL_z42builtin1202z42_2051); 
BgL_closed1206z00_2477 = 
CBOOL(BgL_closed1206z00_2055); 
{ /* Llib/uvtypes.scm 77 */
BgL_uvfspollz00_bglt BgL_new1273z00_2480;
{ /* Llib/uvtypes.scm 77 */
BgL_uvfspollz00_bglt BgL_new1272z00_2481;
BgL_new1272z00_2481 = 
((BgL_uvfspollz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvfspollz00_bgl) ))); 
{ /* Llib/uvtypes.scm 77 */
long BgL_arg2003z00_2482;
{ /* Llib/uvtypes.scm 77 */
long BgL_res2253z00_2483;
BgL_res2253z00_2483 = 
BGL_CLASS_INDEX(BGl_UvFsPollz00zz__libuv_typesz00); 
BgL_arg2003z00_2482 = BgL_res2253z00_2483; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1272z00_2481), BgL_arg2003z00_2482); } 
BgL_new1273z00_2480 = BgL_new1272z00_2481; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1273z00_2480)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1202z42_2474),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1273z00_2480)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1203z52_2052),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1273z00_2480)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1204z52_2053)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1273z00_2480)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1205z52_2054)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1273z00_2480)))->BgL_closedz00)=((bool_t)BgL_closed1206z00_2477),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1273z00_2480)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1207z00_2056)),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1273z00_2480)))->BgL_cbz00)=((obj_t)
((obj_t)BgL_cb1208z00_2057)),BUNSPEC); 
{ /* Llib/uvtypes.scm 77 */
obj_t BgL_fun2002z00_2484;
BgL_fun2002z00_2484 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvFsPollz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun2002z00_2484)(BgL_fun2002z00_2484, 
((obj_t)BgL_new1273z00_2480), BEOA); } 
return BgL_new1273z00_2480;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1995> */
obj_t BGl_z62zc3anonymousza31995ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2058, obj_t BgL_new1200z00_2059)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 75 */
{ 
BgL_uvfseventz00_bglt BgL_auxz00_3610;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfseventz00_bglt)BgL_new1200z00_2059))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfseventz00_bglt)BgL_new1200z00_2059))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfseventz00_bglt)BgL_new1200z00_2059))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfseventz00_bglt)BgL_new1200z00_2059))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfseventz00_bglt)BgL_new1200z00_2059))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_3627;
{ /* Llib/uvtypes.scm 75 */
obj_t BgL_classz00_2486;
BgL_classz00_2486 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 75 */
obj_t BgL__ortest_1106z00_2487;
BgL__ortest_1106z00_2487 = 
BGL_CLASS_NIL(BgL_classz00_2486); 
if(
CBOOL(BgL__ortest_1106z00_2487))
{ /* Llib/uvtypes.scm 75 */
BgL_auxz00_3627 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2487)
; }  else 
{ /* Llib/uvtypes.scm 75 */
BgL_auxz00_3627 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2486))
; } } } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvfseventz00_bglt)BgL_new1200z00_2059))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_3627),BUNSPEC); } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvfseventz00_bglt)BgL_new1200z00_2059))))->BgL_cbz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_3610 = 
((BgL_uvfseventz00_bglt)BgL_new1200z00_2059); 
return 
((obj_t)BgL_auxz00_3610);} } 
BGL_FUNCTION_END;
}



/* &lambda1993 */
BgL_uvfseventz00_bglt BGl_z62lambda1993z62zz__libuv_typesz00(obj_t BgL_envz00_2060)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 75 */
{ /* Llib/uvtypes.scm 75 */
BgL_uvfseventz00_bglt BgL_new1199z00_2488;
BgL_new1199z00_2488 = 
((BgL_uvfseventz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvfseventz00_bgl) ))); 
{ /* Llib/uvtypes.scm 75 */
long BgL_arg1994z00_2489;
{ /* Llib/uvtypes.scm 75 */
long BgL_res2252z00_2490;
BgL_res2252z00_2490 = 
BGL_CLASS_INDEX(BGl_UvFsEventz00zz__libuv_typesz00); 
BgL_arg1994z00_2489 = BgL_res2252z00_2490; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1199z00_2488), BgL_arg1994z00_2489); } 
return BgL_new1199z00_2488;} } 
BGL_FUNCTION_END;
}



/* &lambda1990 */
BgL_uvfseventz00_bglt BGl_z62lambda1990z62zz__libuv_typesz00(obj_t BgL_envz00_2061, obj_t BgL_z42builtin1192z42_2062, obj_t BgL_z52onclose1193z52_2063, obj_t BgL_z52gcmarkshead1194z52_2064, obj_t BgL_z52gcmarkstail1195z52_2065, obj_t BgL_closed1196z00_2066, obj_t BgL_loop1197z00_2067, obj_t BgL_cb1198z00_2068)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 75 */
{ /* Llib/uvtypes.scm 75 */
uv_handle_t * BgL_z42builtin1192z42_2491;bool_t BgL_closed1196z00_2494;
BgL_z42builtin1192z42_2491 = 
FOREIGN_TO_COBJ(BgL_z42builtin1192z42_2062); 
BgL_closed1196z00_2494 = 
CBOOL(BgL_closed1196z00_2066); 
{ /* Llib/uvtypes.scm 75 */
BgL_uvfseventz00_bglt BgL_new1271z00_2497;
{ /* Llib/uvtypes.scm 75 */
BgL_uvfseventz00_bglt BgL_new1270z00_2498;
BgL_new1270z00_2498 = 
((BgL_uvfseventz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvfseventz00_bgl) ))); 
{ /* Llib/uvtypes.scm 75 */
long BgL_arg1992z00_2499;
{ /* Llib/uvtypes.scm 75 */
long BgL_res2251z00_2500;
BgL_res2251z00_2500 = 
BGL_CLASS_INDEX(BGl_UvFsEventz00zz__libuv_typesz00); 
BgL_arg1992z00_2499 = BgL_res2251z00_2500; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1270z00_2498), BgL_arg1992z00_2499); } 
BgL_new1271z00_2497 = BgL_new1270z00_2498; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1271z00_2497)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1192z42_2491),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1271z00_2497)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1193z52_2063),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1271z00_2497)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1194z52_2064)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1271z00_2497)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1195z52_2065)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1271z00_2497)))->BgL_closedz00)=((bool_t)BgL_closed1196z00_2494),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1271z00_2497)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1197z00_2067)),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1271z00_2497)))->BgL_cbz00)=((obj_t)
((obj_t)BgL_cb1198z00_2068)),BUNSPEC); 
{ /* Llib/uvtypes.scm 75 */
obj_t BgL_fun1991z00_2501;
BgL_fun1991z00_2501 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvFsEventz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1991z00_2501)(BgL_fun1991z00_2501, 
((obj_t)BgL_new1271z00_2497), BEOA); } 
return BgL_new1271z00_2497;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1974> */
obj_t BGl_z62zc3anonymousza31974ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2069, obj_t BgL_new1190z00_2070)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 71 */
{ 
BgL_uvfilez00_bglt BgL_auxz00_3676;
((((BgL_uvfilez00_bglt)COBJECT(
((BgL_uvfilez00_bglt)BgL_new1190z00_2070)))->BgL_fdz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_uvfilez00_bglt)COBJECT(
((BgL_uvfilez00_bglt)BgL_new1190z00_2070)))->BgL_pathz00)=((obj_t)BGl_string2286z00zz__libuv_typesz00),BUNSPEC); 
BgL_auxz00_3676 = 
((BgL_uvfilez00_bglt)BgL_new1190z00_2070); 
return 
((obj_t)BgL_auxz00_3676);} } 
BGL_FUNCTION_END;
}



/* &lambda1972 */
BgL_uvfilez00_bglt BGl_z62lambda1972z62zz__libuv_typesz00(obj_t BgL_envz00_2071)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 71 */
{ /* Llib/uvtypes.scm 71 */
BgL_uvfilez00_bglt BgL_new1189z00_2503;
BgL_new1189z00_2503 = 
((BgL_uvfilez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvfilez00_bgl) ))); 
{ /* Llib/uvtypes.scm 71 */
long BgL_arg1973z00_2504;
{ /* Llib/uvtypes.scm 71 */
long BgL_res2250z00_2505;
BgL_res2250z00_2505 = 
BGL_CLASS_INDEX(BGl_UvFilez00zz__libuv_typesz00); 
BgL_arg1973z00_2504 = BgL_res2250z00_2505; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1189z00_2503), BgL_arg1973z00_2504); } 
return BgL_new1189z00_2503;} } 
BGL_FUNCTION_END;
}



/* &lambda1970 */
BgL_uvfilez00_bglt BGl_z62lambda1970z62zz__libuv_typesz00(obj_t BgL_envz00_2072, obj_t BgL_fd1187z00_2073, obj_t BgL_path1188z00_2074)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 71 */
{ /* Llib/uvtypes.scm 71 */
int BgL_fd1187z00_2506;
BgL_fd1187z00_2506 = 
CINT(BgL_fd1187z00_2073); 
{ /* Llib/uvtypes.scm 71 */
BgL_uvfilez00_bglt BgL_new1269z00_2508;
{ /* Llib/uvtypes.scm 71 */
BgL_uvfilez00_bglt BgL_new1268z00_2509;
BgL_new1268z00_2509 = 
((BgL_uvfilez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvfilez00_bgl) ))); 
{ /* Llib/uvtypes.scm 71 */
long BgL_arg1971z00_2510;
{ /* Llib/uvtypes.scm 71 */
long BgL_res2249z00_2511;
BgL_res2249z00_2511 = 
BGL_CLASS_INDEX(BGl_UvFilez00zz__libuv_typesz00); 
BgL_arg1971z00_2510 = BgL_res2249z00_2511; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1268z00_2509), BgL_arg1971z00_2510); } 
BgL_new1269z00_2508 = BgL_new1268z00_2509; } 
((((BgL_uvfilez00_bglt)COBJECT(BgL_new1269z00_2508))->BgL_fdz00)=((int)BgL_fd1187z00_2506),BUNSPEC); 
((((BgL_uvfilez00_bglt)COBJECT(BgL_new1269z00_2508))->BgL_pathz00)=((obj_t)
((obj_t)BgL_path1188z00_2074)),BUNSPEC); 
return BgL_new1269z00_2508;} } } 
BGL_FUNCTION_END;
}



/* &lambda1984 */
obj_t BGl_z62lambda1984z62zz__libuv_typesz00(obj_t BgL_envz00_2075, obj_t BgL_oz00_2076, obj_t BgL_vz00_2077)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 71 */
return 
((((BgL_uvfilez00_bglt)COBJECT(
((BgL_uvfilez00_bglt)BgL_oz00_2076)))->BgL_pathz00)=((obj_t)
((obj_t)BgL_vz00_2077)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1983 */
obj_t BGl_z62lambda1983z62zz__libuv_typesz00(obj_t BgL_envz00_2078, obj_t BgL_oz00_2079)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 71 */
return 
(((BgL_uvfilez00_bglt)COBJECT(
((BgL_uvfilez00_bglt)BgL_oz00_2079)))->BgL_pathz00);} 
BGL_FUNCTION_END;
}



/* &lambda1979 */
obj_t BGl_z62lambda1979z62zz__libuv_typesz00(obj_t BgL_envz00_2080, obj_t BgL_oz00_2081, obj_t BgL_vz00_2082)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 71 */
{ /* Llib/uvtypes.scm 71 */
int BgL_vz00_2516;
BgL_vz00_2516 = 
CINT(BgL_vz00_2082); 
return 
((((BgL_uvfilez00_bglt)COBJECT(
((BgL_uvfilez00_bglt)BgL_oz00_2081)))->BgL_fdz00)=((int)BgL_vz00_2516),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1978 */
obj_t BGl_z62lambda1978z62zz__libuv_typesz00(obj_t BgL_envz00_2083, obj_t BgL_oz00_2084)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 71 */
return 
BINT(
(((BgL_uvfilez00_bglt)COBJECT(
((BgL_uvfilez00_bglt)BgL_oz00_2084)))->BgL_fdz00));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1959> */
obj_t BGl_z62zc3anonymousza31959ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2085, obj_t BgL_new1185z00_2086)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 68 */
{ 
BgL_uvpollz00_bglt BgL_auxz00_3707;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpollz00_bglt)BgL_new1185z00_2086))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpollz00_bglt)BgL_new1185z00_2086))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpollz00_bglt)BgL_new1185z00_2086))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpollz00_bglt)BgL_new1185z00_2086))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpollz00_bglt)BgL_new1185z00_2086))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_3724;
{ /* Llib/uvtypes.scm 68 */
obj_t BgL_classz00_2519;
BgL_classz00_2519 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 68 */
obj_t BgL__ortest_1106z00_2520;
BgL__ortest_1106z00_2520 = 
BGL_CLASS_NIL(BgL_classz00_2519); 
if(
CBOOL(BgL__ortest_1106z00_2520))
{ /* Llib/uvtypes.scm 68 */
BgL_auxz00_3724 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2520)
; }  else 
{ /* Llib/uvtypes.scm 68 */
BgL_auxz00_3724 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2519))
; } } } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvpollz00_bglt)BgL_new1185z00_2086))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_3724),BUNSPEC); } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvpollz00_bglt)BgL_new1185z00_2086))))->BgL_cbz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_uvpollz00_bglt)COBJECT(
((BgL_uvpollz00_bglt)BgL_new1185z00_2086)))->BgL_fdz00)=((int)
(int)(((long)0))),BUNSPEC); 
BgL_auxz00_3707 = 
((BgL_uvpollz00_bglt)BgL_new1185z00_2086); 
return 
((obj_t)BgL_auxz00_3707);} } 
BGL_FUNCTION_END;
}



/* &lambda1957 */
BgL_uvpollz00_bglt BGl_z62lambda1957z62zz__libuv_typesz00(obj_t BgL_envz00_2087)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 68 */
{ /* Llib/uvtypes.scm 68 */
BgL_uvpollz00_bglt BgL_new1184z00_2521;
BgL_new1184z00_2521 = 
((BgL_uvpollz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvpollz00_bgl) ))); 
{ /* Llib/uvtypes.scm 68 */
long BgL_arg1958z00_2522;
{ /* Llib/uvtypes.scm 68 */
long BgL_res2248z00_2523;
BgL_res2248z00_2523 = 
BGL_CLASS_INDEX(BGl_UvPollz00zz__libuv_typesz00); 
BgL_arg1958z00_2522 = BgL_res2248z00_2523; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1184z00_2521), BgL_arg1958z00_2522); } 
return BgL_new1184z00_2521;} } 
BGL_FUNCTION_END;
}



/* &lambda1954 */
BgL_uvpollz00_bglt BGl_z62lambda1954z62zz__libuv_typesz00(obj_t BgL_envz00_2088, obj_t BgL_z42builtin1176z42_2089, obj_t BgL_z52onclose1177z52_2090, obj_t BgL_z52gcmarkshead1178z52_2091, obj_t BgL_z52gcmarkstail1179z52_2092, obj_t BgL_closed1180z00_2093, obj_t BgL_loop1181z00_2094, obj_t BgL_cb1182z00_2095, obj_t BgL_fd1183z00_2096)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 68 */
{ /* Llib/uvtypes.scm 68 */
uv_handle_t * BgL_z42builtin1176z42_2524;bool_t BgL_closed1180z00_2527;int BgL_fd1183z00_2530;
BgL_z42builtin1176z42_2524 = 
FOREIGN_TO_COBJ(BgL_z42builtin1176z42_2089); 
BgL_closed1180z00_2527 = 
CBOOL(BgL_closed1180z00_2093); 
BgL_fd1183z00_2530 = 
CINT(BgL_fd1183z00_2096); 
{ /* Llib/uvtypes.scm 68 */
BgL_uvpollz00_bglt BgL_new1267z00_2531;
{ /* Llib/uvtypes.scm 68 */
BgL_uvpollz00_bglt BgL_new1266z00_2532;
BgL_new1266z00_2532 = 
((BgL_uvpollz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvpollz00_bgl) ))); 
{ /* Llib/uvtypes.scm 68 */
long BgL_arg1956z00_2533;
{ /* Llib/uvtypes.scm 68 */
long BgL_res2247z00_2534;
BgL_res2247z00_2534 = 
BGL_CLASS_INDEX(BGl_UvPollz00zz__libuv_typesz00); 
BgL_arg1956z00_2533 = BgL_res2247z00_2534; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1266z00_2532), BgL_arg1956z00_2533); } 
BgL_new1267z00_2531 = BgL_new1266z00_2532; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1267z00_2531)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1176z42_2524),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1267z00_2531)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1177z52_2090),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1267z00_2531)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1178z52_2091)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1267z00_2531)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1179z52_2092)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1267z00_2531)))->BgL_closedz00)=((bool_t)BgL_closed1180z00_2527),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1267z00_2531)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1181z00_2094)),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1267z00_2531)))->BgL_cbz00)=((obj_t)
((obj_t)BgL_cb1182z00_2095)),BUNSPEC); 
((((BgL_uvpollz00_bglt)COBJECT(BgL_new1267z00_2531))->BgL_fdz00)=((int)BgL_fd1183z00_2530),BUNSPEC); 
{ /* Llib/uvtypes.scm 68 */
obj_t BgL_fun1955z00_2535;
BgL_fun1955z00_2535 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvPollz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1955z00_2535)(BgL_fun1955z00_2535, 
((obj_t)BgL_new1267z00_2531), BEOA); } 
return BgL_new1267z00_2531;} } } 
BGL_FUNCTION_END;
}



/* &lambda1964 */
obj_t BGl_z62lambda1964z62zz__libuv_typesz00(obj_t BgL_envz00_2097, obj_t BgL_oz00_2098, obj_t BgL_vz00_2099)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 68 */
{ /* Llib/uvtypes.scm 68 */
int BgL_vz00_2537;
BgL_vz00_2537 = 
CINT(BgL_vz00_2099); 
return 
((((BgL_uvpollz00_bglt)COBJECT(
((BgL_uvpollz00_bglt)BgL_oz00_2098)))->BgL_fdz00)=((int)BgL_vz00_2537),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1963 */
obj_t BGl_z62lambda1963z62zz__libuv_typesz00(obj_t BgL_envz00_2100, obj_t BgL_oz00_2101)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 68 */
return 
BINT(
(((BgL_uvpollz00_bglt)COBJECT(
((BgL_uvpollz00_bglt)BgL_oz00_2101)))->BgL_fdz00));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1948> */
obj_t BGl_z62zc3anonymousza31948ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2102, obj_t BgL_new1174z00_2103)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 66 */
{ 
BgL_uvasyncz00_bglt BgL_auxz00_3784;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvasyncz00_bglt)BgL_new1174z00_2103))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvasyncz00_bglt)BgL_new1174z00_2103))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvasyncz00_bglt)BgL_new1174z00_2103))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvasyncz00_bglt)BgL_new1174z00_2103))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvasyncz00_bglt)BgL_new1174z00_2103))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_3801;
{ /* Llib/uvtypes.scm 66 */
obj_t BgL_classz00_2540;
BgL_classz00_2540 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 66 */
obj_t BgL__ortest_1106z00_2541;
BgL__ortest_1106z00_2541 = 
BGL_CLASS_NIL(BgL_classz00_2540); 
if(
CBOOL(BgL__ortest_1106z00_2541))
{ /* Llib/uvtypes.scm 66 */
BgL_auxz00_3801 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2541)
; }  else 
{ /* Llib/uvtypes.scm 66 */
BgL_auxz00_3801 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2540))
; } } } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvasyncz00_bglt)BgL_new1174z00_2103))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_3801),BUNSPEC); } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvasyncz00_bglt)BgL_new1174z00_2103))))->BgL_cbz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_3784 = 
((BgL_uvasyncz00_bglt)BgL_new1174z00_2103); 
return 
((obj_t)BgL_auxz00_3784);} } 
BGL_FUNCTION_END;
}



/* &lambda1946 */
BgL_uvasyncz00_bglt BGl_z62lambda1946z62zz__libuv_typesz00(obj_t BgL_envz00_2104)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 66 */
{ /* Llib/uvtypes.scm 66 */
BgL_uvasyncz00_bglt BgL_new1173z00_2542;
BgL_new1173z00_2542 = 
((BgL_uvasyncz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvasyncz00_bgl) ))); 
{ /* Llib/uvtypes.scm 66 */
long BgL_arg1947z00_2543;
{ /* Llib/uvtypes.scm 66 */
long BgL_res2246z00_2544;
BgL_res2246z00_2544 = 
BGL_CLASS_INDEX(BGl_UvAsyncz00zz__libuv_typesz00); 
BgL_arg1947z00_2543 = BgL_res2246z00_2544; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1173z00_2542), BgL_arg1947z00_2543); } 
return BgL_new1173z00_2542;} } 
BGL_FUNCTION_END;
}



/* &lambda1943 */
BgL_uvasyncz00_bglt BGl_z62lambda1943z62zz__libuv_typesz00(obj_t BgL_envz00_2105, obj_t BgL_z42builtin1166z42_2106, obj_t BgL_z52onclose1167z52_2107, obj_t BgL_z52gcmarkshead1168z52_2108, obj_t BgL_z52gcmarkstail1169z52_2109, obj_t BgL_closed1170z00_2110, obj_t BgL_loop1171z00_2111, obj_t BgL_cb1172z00_2112)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 66 */
{ /* Llib/uvtypes.scm 66 */
uv_handle_t * BgL_z42builtin1166z42_2545;bool_t BgL_closed1170z00_2548;
BgL_z42builtin1166z42_2545 = 
FOREIGN_TO_COBJ(BgL_z42builtin1166z42_2106); 
BgL_closed1170z00_2548 = 
CBOOL(BgL_closed1170z00_2110); 
{ /* Llib/uvtypes.scm 66 */
BgL_uvasyncz00_bglt BgL_new1265z00_2551;
{ /* Llib/uvtypes.scm 66 */
BgL_uvasyncz00_bglt BgL_new1264z00_2552;
BgL_new1264z00_2552 = 
((BgL_uvasyncz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvasyncz00_bgl) ))); 
{ /* Llib/uvtypes.scm 66 */
long BgL_arg1945z00_2553;
{ /* Llib/uvtypes.scm 66 */
long BgL_res2245z00_2554;
BgL_res2245z00_2554 = 
BGL_CLASS_INDEX(BGl_UvAsyncz00zz__libuv_typesz00); 
BgL_arg1945z00_2553 = BgL_res2245z00_2554; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1264z00_2552), BgL_arg1945z00_2553); } 
BgL_new1265z00_2551 = BgL_new1264z00_2552; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1265z00_2551)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1166z42_2545),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1265z00_2551)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1167z52_2107),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1265z00_2551)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1168z52_2108)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1265z00_2551)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1169z52_2109)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1265z00_2551)))->BgL_closedz00)=((bool_t)BgL_closed1170z00_2548),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1265z00_2551)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1171z00_2111)),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1265z00_2551)))->BgL_cbz00)=((obj_t)
((obj_t)BgL_cb1172z00_2112)),BUNSPEC); 
{ /* Llib/uvtypes.scm 66 */
obj_t BgL_fun1944z00_2555;
BgL_fun1944z00_2555 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvAsyncz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1944z00_2555)(BgL_fun1944z00_2555, 
((obj_t)BgL_new1265z00_2551), BEOA); } 
return BgL_new1265z00_2551;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1937> */
obj_t BGl_z62zc3anonymousza31937ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2113, obj_t BgL_new1164z00_2114)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 64 */
{ 
BgL_uvidlez00_bglt BgL_auxz00_3850;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvidlez00_bglt)BgL_new1164z00_2114))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvidlez00_bglt)BgL_new1164z00_2114))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvidlez00_bglt)BgL_new1164z00_2114))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvidlez00_bglt)BgL_new1164z00_2114))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvidlez00_bglt)BgL_new1164z00_2114))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_3867;
{ /* Llib/uvtypes.scm 64 */
obj_t BgL_classz00_2557;
BgL_classz00_2557 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 64 */
obj_t BgL__ortest_1106z00_2558;
BgL__ortest_1106z00_2558 = 
BGL_CLASS_NIL(BgL_classz00_2557); 
if(
CBOOL(BgL__ortest_1106z00_2558))
{ /* Llib/uvtypes.scm 64 */
BgL_auxz00_3867 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2558)
; }  else 
{ /* Llib/uvtypes.scm 64 */
BgL_auxz00_3867 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2557))
; } } } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvidlez00_bglt)BgL_new1164z00_2114))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_3867),BUNSPEC); } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvidlez00_bglt)BgL_new1164z00_2114))))->BgL_cbz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_3850 = 
((BgL_uvidlez00_bglt)BgL_new1164z00_2114); 
return 
((obj_t)BgL_auxz00_3850);} } 
BGL_FUNCTION_END;
}



/* &lambda1935 */
BgL_uvidlez00_bglt BGl_z62lambda1935z62zz__libuv_typesz00(obj_t BgL_envz00_2115)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 64 */
{ /* Llib/uvtypes.scm 64 */
BgL_uvidlez00_bglt BgL_new1163z00_2559;
BgL_new1163z00_2559 = 
((BgL_uvidlez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvidlez00_bgl) ))); 
{ /* Llib/uvtypes.scm 64 */
long BgL_arg1936z00_2560;
{ /* Llib/uvtypes.scm 64 */
long BgL_res2244z00_2561;
BgL_res2244z00_2561 = 
BGL_CLASS_INDEX(BGl_UvIdlez00zz__libuv_typesz00); 
BgL_arg1936z00_2560 = BgL_res2244z00_2561; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1163z00_2559), BgL_arg1936z00_2560); } 
return BgL_new1163z00_2559;} } 
BGL_FUNCTION_END;
}



/* &lambda1932 */
BgL_uvidlez00_bglt BGl_z62lambda1932z62zz__libuv_typesz00(obj_t BgL_envz00_2116, obj_t BgL_z42builtin1156z42_2117, obj_t BgL_z52onclose1157z52_2118, obj_t BgL_z52gcmarkshead1158z52_2119, obj_t BgL_z52gcmarkstail1159z52_2120, obj_t BgL_closed1160z00_2121, obj_t BgL_loop1161z00_2122, obj_t BgL_cb1162z00_2123)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 64 */
{ /* Llib/uvtypes.scm 64 */
uv_handle_t * BgL_z42builtin1156z42_2562;bool_t BgL_closed1160z00_2565;
BgL_z42builtin1156z42_2562 = 
FOREIGN_TO_COBJ(BgL_z42builtin1156z42_2117); 
BgL_closed1160z00_2565 = 
CBOOL(BgL_closed1160z00_2121); 
{ /* Llib/uvtypes.scm 64 */
BgL_uvidlez00_bglt BgL_new1263z00_2568;
{ /* Llib/uvtypes.scm 64 */
BgL_uvidlez00_bglt BgL_new1262z00_2569;
BgL_new1262z00_2569 = 
((BgL_uvidlez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvidlez00_bgl) ))); 
{ /* Llib/uvtypes.scm 64 */
long BgL_arg1934z00_2570;
{ /* Llib/uvtypes.scm 64 */
long BgL_res2243z00_2571;
BgL_res2243z00_2571 = 
BGL_CLASS_INDEX(BGl_UvIdlez00zz__libuv_typesz00); 
BgL_arg1934z00_2570 = BgL_res2243z00_2571; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1262z00_2569), BgL_arg1934z00_2570); } 
BgL_new1263z00_2568 = BgL_new1262z00_2569; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1263z00_2568)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1156z42_2562),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1263z00_2568)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1157z52_2118),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1263z00_2568)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1158z52_2119)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1263z00_2568)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1159z52_2120)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1263z00_2568)))->BgL_closedz00)=((bool_t)BgL_closed1160z00_2565),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1263z00_2568)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1161z00_2122)),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1263z00_2568)))->BgL_cbz00)=((obj_t)
((obj_t)BgL_cb1162z00_2123)),BUNSPEC); 
{ /* Llib/uvtypes.scm 64 */
obj_t BgL_fun1933z00_2572;
BgL_fun1933z00_2572 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvIdlez00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1933z00_2572)(BgL_fun1933z00_2572, 
((obj_t)BgL_new1263z00_2568), BEOA); } 
return BgL_new1263z00_2568;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1912> */
obj_t BGl_z62zc3anonymousza31912ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2124, obj_t BgL_new1154z00_2125)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 60 */
{ 
BgL_uvtimerz00_bglt BgL_auxz00_3916;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtimerz00_bglt)BgL_new1154z00_2125))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtimerz00_bglt)BgL_new1154z00_2125))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtimerz00_bglt)BgL_new1154z00_2125))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtimerz00_bglt)BgL_new1154z00_2125))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtimerz00_bglt)BgL_new1154z00_2125))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_3933;
{ /* Llib/uvtypes.scm 60 */
obj_t BgL_classz00_2574;
BgL_classz00_2574 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 60 */
obj_t BgL__ortest_1106z00_2575;
BgL__ortest_1106z00_2575 = 
BGL_CLASS_NIL(BgL_classz00_2574); 
if(
CBOOL(BgL__ortest_1106z00_2575))
{ /* Llib/uvtypes.scm 60 */
BgL_auxz00_3933 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2575)
; }  else 
{ /* Llib/uvtypes.scm 60 */
BgL_auxz00_3933 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2574))
; } } } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvtimerz00_bglt)BgL_new1154z00_2125))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_3933),BUNSPEC); } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvtimerz00_bglt)BgL_new1154z00_2125))))->BgL_cbz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_uvtimerz00_bglt)COBJECT(
((BgL_uvtimerz00_bglt)BgL_new1154z00_2125)))->BgL_repeatz00)=((uint64_t)
0L),BUNSPEC); 
((((BgL_uvtimerz00_bglt)COBJECT(
((BgL_uvtimerz00_bglt)BgL_new1154z00_2125)))->BgL_refz00)=((bool_t)((bool_t)0)),BUNSPEC); 
BgL_auxz00_3916 = 
((BgL_uvtimerz00_bglt)BgL_new1154z00_2125); 
return 
((obj_t)BgL_auxz00_3916);} } 
BGL_FUNCTION_END;
}



/* &lambda1910 */
BgL_uvtimerz00_bglt BGl_z62lambda1910z62zz__libuv_typesz00(obj_t BgL_envz00_2126)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 60 */
{ /* Llib/uvtypes.scm 60 */
BgL_uvtimerz00_bglt BgL_new1153z00_2576;
BgL_new1153z00_2576 = 
((BgL_uvtimerz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvtimerz00_bgl) ))); 
{ /* Llib/uvtypes.scm 60 */
long BgL_arg1911z00_2577;
{ /* Llib/uvtypes.scm 60 */
long BgL_res2242z00_2578;
BgL_res2242z00_2578 = 
BGL_CLASS_INDEX(BGl_UvTimerz00zz__libuv_typesz00); 
BgL_arg1911z00_2577 = BgL_res2242z00_2578; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1153z00_2576), BgL_arg1911z00_2577); } 
return BgL_new1153z00_2576;} } 
BGL_FUNCTION_END;
}



/* &lambda1907 */
BgL_uvtimerz00_bglt BGl_z62lambda1907z62zz__libuv_typesz00(obj_t BgL_envz00_2127, obj_t BgL_z42builtin1144z42_2128, obj_t BgL_z52onclose1145z52_2129, obj_t BgL_z52gcmarkshead1146z52_2130, obj_t BgL_z52gcmarkstail1147z52_2131, obj_t BgL_closed1148z00_2132, obj_t BgL_loop1149z00_2133, obj_t BgL_cb1150z00_2134, obj_t BgL_repeat1151z00_2135, obj_t BgL_ref1152z00_2136)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 60 */
{ /* Llib/uvtypes.scm 60 */
uv_handle_t * BgL_z42builtin1144z42_2579;bool_t BgL_closed1148z00_2582;uint64_t BgL_repeat1151z00_2585;bool_t BgL_ref1152z00_2586;
BgL_z42builtin1144z42_2579 = 
FOREIGN_TO_COBJ(BgL_z42builtin1144z42_2128); 
BgL_closed1148z00_2582 = 
CBOOL(BgL_closed1148z00_2132); 
BgL_repeat1151z00_2585 = 
BGL_BINT64_TO_INT64(BgL_repeat1151z00_2135); 
BgL_ref1152z00_2586 = 
CBOOL(BgL_ref1152z00_2136); 
{ /* Llib/uvtypes.scm 60 */
BgL_uvtimerz00_bglt BgL_new1261z00_2587;
{ /* Llib/uvtypes.scm 60 */
BgL_uvtimerz00_bglt BgL_new1260z00_2588;
BgL_new1260z00_2588 = 
((BgL_uvtimerz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvtimerz00_bgl) ))); 
{ /* Llib/uvtypes.scm 60 */
long BgL_arg1909z00_2589;
{ /* Llib/uvtypes.scm 60 */
long BgL_res2241z00_2590;
BgL_res2241z00_2590 = 
BGL_CLASS_INDEX(BGl_UvTimerz00zz__libuv_typesz00); 
BgL_arg1909z00_2589 = BgL_res2241z00_2590; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1260z00_2588), BgL_arg1909z00_2589); } 
BgL_new1261z00_2587 = BgL_new1260z00_2588; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1261z00_2587)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1144z42_2579),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1261z00_2587)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1145z52_2129),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1261z00_2587)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1146z52_2130)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1261z00_2587)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1147z52_2131)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1261z00_2587)))->BgL_closedz00)=((bool_t)BgL_closed1148z00_2582),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1261z00_2587)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1149z00_2133)),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1261z00_2587)))->BgL_cbz00)=((obj_t)
((obj_t)BgL_cb1150z00_2134)),BUNSPEC); 
((((BgL_uvtimerz00_bglt)COBJECT(BgL_new1261z00_2587))->BgL_repeatz00)=((uint64_t)BgL_repeat1151z00_2585),BUNSPEC); 
((((BgL_uvtimerz00_bglt)COBJECT(BgL_new1261z00_2587))->BgL_refz00)=((bool_t)BgL_ref1152z00_2586),BUNSPEC); 
{ /* Llib/uvtypes.scm 60 */
obj_t BgL_fun1908z00_2591;
BgL_fun1908z00_2591 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvTimerz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1908z00_2591)(BgL_fun1908z00_2591, 
((obj_t)BgL_new1261z00_2587), BEOA); } 
return BgL_new1261z00_2587;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1926> */
obj_t BGl_z62zc3anonymousza31926ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2137)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 60 */
return 
BBOOL(((bool_t)1));} 
BGL_FUNCTION_END;
}



/* &lambda1925 */
obj_t BGl_z62lambda1925z62zz__libuv_typesz00(obj_t BgL_envz00_2138, obj_t BgL_oz00_2139, obj_t BgL_vz00_2140)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 60 */
{ /* Llib/uvtypes.scm 60 */
bool_t BgL_vz00_2593;
BgL_vz00_2593 = 
CBOOL(BgL_vz00_2140); 
return 
((((BgL_uvtimerz00_bglt)COBJECT(
((BgL_uvtimerz00_bglt)BgL_oz00_2139)))->BgL_refz00)=((bool_t)BgL_vz00_2593),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1924 */
obj_t BGl_z62lambda1924z62zz__libuv_typesz00(obj_t BgL_envz00_2141, obj_t BgL_oz00_2142)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 60 */
return 
BBOOL(
(((BgL_uvtimerz00_bglt)COBJECT(
((BgL_uvtimerz00_bglt)BgL_oz00_2142)))->BgL_refz00));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1919> */
obj_t BGl_z62zc3anonymousza31919ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2143)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 60 */
return 
BGL_UINT64_TO_BUINT64((uint64_t)(0));} 
BGL_FUNCTION_END;
}



/* &lambda1918 */
obj_t BGl_z62lambda1918z62zz__libuv_typesz00(obj_t BgL_envz00_2144, obj_t BgL_oz00_2145, obj_t BgL_vz00_2146)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 60 */
{ /* Llib/uvtypes.scm 60 */
uint64_t BgL_vz00_2596;
BgL_vz00_2596 = 
BGL_BINT64_TO_INT64(BgL_vz00_2146); 
return 
((((BgL_uvtimerz00_bglt)COBJECT(
((BgL_uvtimerz00_bglt)BgL_oz00_2145)))->BgL_repeatz00)=((uint64_t)BgL_vz00_2596),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1917 */
obj_t BGl_z62lambda1917z62zz__libuv_typesz00(obj_t BgL_envz00_2147, obj_t BgL_oz00_2148)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 60 */
{ /* Llib/uvtypes.scm 60 */
uint64_t BgL_tmpz00_4002;
BgL_tmpz00_4002 = 
(((BgL_uvtimerz00_bglt)COBJECT(
((BgL_uvtimerz00_bglt)BgL_oz00_2148)))->BgL_repeatz00); 
return 
BGL_UINT64_TO_BUINT64(BgL_tmpz00_4002);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1891> */
obj_t BGl_z62zc3anonymousza31891ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2149, obj_t BgL_new1142z00_2150)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 56 */
{ 
BgL_uvttyz00_bglt BgL_auxz00_4006;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvttyz00_bglt)BgL_new1142z00_2150))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvttyz00_bglt)BgL_new1142z00_2150))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvttyz00_bglt)BgL_new1142z00_2150))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvttyz00_bglt)BgL_new1142z00_2150))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvttyz00_bglt)BgL_new1142z00_2150))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_4023;
{ /* Llib/uvtypes.scm 56 */
obj_t BgL_classz00_2599;
BgL_classz00_2599 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 56 */
obj_t BgL__ortest_1106z00_2600;
BgL__ortest_1106z00_2600 = 
BGL_CLASS_NIL(BgL_classz00_2599); 
if(
CBOOL(BgL__ortest_1106z00_2600))
{ /* Llib/uvtypes.scm 56 */
BgL_auxz00_4023 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2600)
; }  else 
{ /* Llib/uvtypes.scm 56 */
BgL_auxz00_4023 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2599))
; } } } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvttyz00_bglt)BgL_new1142z00_2150))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_4023),BUNSPEC); } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvttyz00_bglt)BgL_new1142z00_2150))))->BgL_z52allocz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvttyz00_bglt)BgL_new1142z00_2150))))->BgL_z52offsetz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvttyz00_bglt)BgL_new1142z00_2150))))->BgL_z52procaz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvttyz00_bglt)BgL_new1142z00_2150))))->BgL_z52proccz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvttyz00_bglt)BgL_new1142z00_2150))))->BgL_z52callbackz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvttyz00_bglt)COBJECT(
((BgL_uvttyz00_bglt)BgL_new1142z00_2150)))->BgL_fdz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_uvttyz00_bglt)COBJECT(
((BgL_uvttyz00_bglt)BgL_new1142z00_2150)))->BgL_readablez00)=((bool_t)((bool_t)0)),BUNSPEC); 
BgL_auxz00_4006 = 
((BgL_uvttyz00_bglt)BgL_new1142z00_2150); 
return 
((obj_t)BgL_auxz00_4006);} } 
BGL_FUNCTION_END;
}



/* &lambda1889 */
BgL_uvttyz00_bglt BGl_z62lambda1889z62zz__libuv_typesz00(obj_t BgL_envz00_2151)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 56 */
{ /* Llib/uvtypes.scm 56 */
BgL_uvttyz00_bglt BgL_new1141z00_2601;
BgL_new1141z00_2601 = 
((BgL_uvttyz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvttyz00_bgl) ))); 
{ /* Llib/uvtypes.scm 56 */
long BgL_arg1890z00_2602;
{ /* Llib/uvtypes.scm 56 */
long BgL_res2240z00_2603;
BgL_res2240z00_2603 = 
BGL_CLASS_INDEX(BGl_UvTtyz00zz__libuv_typesz00); 
BgL_arg1890z00_2602 = BgL_res2240z00_2603; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1141z00_2601), BgL_arg1890z00_2602); } 
return BgL_new1141z00_2601;} } 
BGL_FUNCTION_END;
}



/* &lambda1886 */
BgL_uvttyz00_bglt BGl_z62lambda1886z62zz__libuv_typesz00(obj_t BgL_envz00_2152, obj_t BgL_z42builtin1128z42_2153, obj_t BgL_z52onclose1129z52_2154, obj_t BgL_z52gcmarkshead1130z52_2155, obj_t BgL_z52gcmarkstail1131z52_2156, obj_t BgL_closed1132z00_2157, obj_t BgL_loop1133z00_2158, obj_t BgL_z52alloc1134z52_2159, obj_t BgL_z52offset1135z52_2160, obj_t BgL_z52proca1136z52_2161, obj_t BgL_z52procc1137z52_2162, obj_t BgL_z52callback1138z52_2163, obj_t BgL_fd1139z00_2164, obj_t BgL_readable1140z00_2165)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 56 */
{ /* Llib/uvtypes.scm 56 */
uv_handle_t * BgL_z42builtin1128z42_2604;bool_t BgL_closed1132z00_2607;int BgL_fd1139z00_2609;bool_t BgL_readable1140z00_2610;
BgL_z42builtin1128z42_2604 = 
FOREIGN_TO_COBJ(BgL_z42builtin1128z42_2153); 
BgL_closed1132z00_2607 = 
CBOOL(BgL_closed1132z00_2157); 
BgL_fd1139z00_2609 = 
CINT(BgL_fd1139z00_2164); 
BgL_readable1140z00_2610 = 
CBOOL(BgL_readable1140z00_2165); 
{ /* Llib/uvtypes.scm 56 */
BgL_uvttyz00_bglt BgL_new1259z00_2611;
{ /* Llib/uvtypes.scm 56 */
BgL_uvttyz00_bglt BgL_new1258z00_2612;
BgL_new1258z00_2612 = 
((BgL_uvttyz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvttyz00_bgl) ))); 
{ /* Llib/uvtypes.scm 56 */
long BgL_arg1888z00_2613;
{ /* Llib/uvtypes.scm 56 */
long BgL_res2239z00_2614;
BgL_res2239z00_2614 = 
BGL_CLASS_INDEX(BGl_UvTtyz00zz__libuv_typesz00); 
BgL_arg1888z00_2613 = BgL_res2239z00_2614; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1258z00_2612), BgL_arg1888z00_2613); } 
BgL_new1259z00_2611 = BgL_new1258z00_2612; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1259z00_2611)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1128z42_2604),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1259z00_2611)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1129z52_2154),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1259z00_2611)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1130z52_2155)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1259z00_2611)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1131z52_2156)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1259z00_2611)))->BgL_closedz00)=((bool_t)BgL_closed1132z00_2607),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1259z00_2611)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1133z00_2158)),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1259z00_2611)))->BgL_z52allocz52)=((obj_t)BgL_z52alloc1134z52_2159),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1259z00_2611)))->BgL_z52offsetz52)=((obj_t)BgL_z52offset1135z52_2160),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1259z00_2611)))->BgL_z52procaz52)=((obj_t)BgL_z52proca1136z52_2161),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1259z00_2611)))->BgL_z52proccz52)=((obj_t)BgL_z52procc1137z52_2162),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1259z00_2611)))->BgL_z52callbackz52)=((obj_t)BgL_z52callback1138z52_2163),BUNSPEC); 
((((BgL_uvttyz00_bglt)COBJECT(BgL_new1259z00_2611))->BgL_fdz00)=((int)BgL_fd1139z00_2609),BUNSPEC); 
((((BgL_uvttyz00_bglt)COBJECT(BgL_new1259z00_2611))->BgL_readablez00)=((bool_t)BgL_readable1140z00_2610),BUNSPEC); 
{ /* Llib/uvtypes.scm 56 */
obj_t BgL_fun1887z00_2615;
BgL_fun1887z00_2615 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvTtyz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1887z00_2615)(BgL_fun1887z00_2615, 
((obj_t)BgL_new1259z00_2611), BEOA); } 
return BgL_new1259z00_2611;} } } 
BGL_FUNCTION_END;
}



/* &lambda1901 */
obj_t BGl_z62lambda1901z62zz__libuv_typesz00(obj_t BgL_envz00_2166, obj_t BgL_oz00_2167, obj_t BgL_vz00_2168)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 56 */
{ /* Llib/uvtypes.scm 56 */
bool_t BgL_vz00_2617;
BgL_vz00_2617 = 
CBOOL(BgL_vz00_2168); 
return 
((((BgL_uvttyz00_bglt)COBJECT(
((BgL_uvttyz00_bglt)BgL_oz00_2167)))->BgL_readablez00)=((bool_t)BgL_vz00_2617),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1900 */
obj_t BGl_z62lambda1900z62zz__libuv_typesz00(obj_t BgL_envz00_2169, obj_t BgL_oz00_2170)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 56 */
return 
BBOOL(
(((BgL_uvttyz00_bglt)COBJECT(
((BgL_uvttyz00_bglt)BgL_oz00_2170)))->BgL_readablez00));} 
BGL_FUNCTION_END;
}



/* &lambda1896 */
obj_t BGl_z62lambda1896z62zz__libuv_typesz00(obj_t BgL_envz00_2171, obj_t BgL_oz00_2172, obj_t BgL_vz00_2173)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 56 */
{ /* Llib/uvtypes.scm 56 */
int BgL_vz00_2620;
BgL_vz00_2620 = 
CINT(BgL_vz00_2173); 
return 
((((BgL_uvttyz00_bglt)COBJECT(
((BgL_uvttyz00_bglt)BgL_oz00_2172)))->BgL_fdz00)=((int)BgL_vz00_2620),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1895 */
obj_t BGl_z62lambda1895z62zz__libuv_typesz00(obj_t BgL_envz00_2174, obj_t BgL_oz00_2175)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 56 */
return 
BINT(
(((BgL_uvttyz00_bglt)COBJECT(
((BgL_uvttyz00_bglt)BgL_oz00_2175)))->BgL_fdz00));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1875> */
obj_t BGl_z62zc3anonymousza31875ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2176, obj_t BgL_new1126z00_2177)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 53 */
{ 
BgL_uvpipez00_bglt BgL_auxz00_4112;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpipez00_bglt)BgL_new1126z00_2177))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpipez00_bglt)BgL_new1126z00_2177))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpipez00_bglt)BgL_new1126z00_2177))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpipez00_bglt)BgL_new1126z00_2177))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpipez00_bglt)BgL_new1126z00_2177))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_4129;
{ /* Llib/uvtypes.scm 53 */
obj_t BgL_classz00_2623;
BgL_classz00_2623 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 53 */
obj_t BgL__ortest_1106z00_2624;
BgL__ortest_1106z00_2624 = 
BGL_CLASS_NIL(BgL_classz00_2623); 
if(
CBOOL(BgL__ortest_1106z00_2624))
{ /* Llib/uvtypes.scm 53 */
BgL_auxz00_4129 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2624)
; }  else 
{ /* Llib/uvtypes.scm 53 */
BgL_auxz00_4129 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2623))
; } } } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvpipez00_bglt)BgL_new1126z00_2177))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_4129),BUNSPEC); } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvpipez00_bglt)BgL_new1126z00_2177))))->BgL_z52allocz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvpipez00_bglt)BgL_new1126z00_2177))))->BgL_z52offsetz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvpipez00_bglt)BgL_new1126z00_2177))))->BgL_z52procaz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvpipez00_bglt)BgL_new1126z00_2177))))->BgL_z52proccz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvpipez00_bglt)BgL_new1126z00_2177))))->BgL_z52callbackz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvpipez00_bglt)COBJECT(
((BgL_uvpipez00_bglt)BgL_new1126z00_2177)))->BgL_ipcz00)=((bool_t)((bool_t)0)),BUNSPEC); 
BgL_auxz00_4112 = 
((BgL_uvpipez00_bglt)BgL_new1126z00_2177); 
return 
((obj_t)BgL_auxz00_4112);} } 
BGL_FUNCTION_END;
}



/* &lambda1873 */
BgL_uvpipez00_bglt BGl_z62lambda1873z62zz__libuv_typesz00(obj_t BgL_envz00_2178)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 53 */
{ /* Llib/uvtypes.scm 53 */
BgL_uvpipez00_bglt BgL_new1125z00_2625;
BgL_new1125z00_2625 = 
((BgL_uvpipez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvpipez00_bgl) ))); 
{ /* Llib/uvtypes.scm 53 */
long BgL_arg1874z00_2626;
{ /* Llib/uvtypes.scm 53 */
long BgL_res2238z00_2627;
BgL_res2238z00_2627 = 
BGL_CLASS_INDEX(BGl_UvPipez00zz__libuv_typesz00); 
BgL_arg1874z00_2626 = BgL_res2238z00_2627; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1125z00_2625), BgL_arg1874z00_2626); } 
return BgL_new1125z00_2625;} } 
BGL_FUNCTION_END;
}



/* &lambda1870 */
BgL_uvpipez00_bglt BGl_z62lambda1870z62zz__libuv_typesz00(obj_t BgL_envz00_2179, obj_t BgL_z42builtin1113z42_2180, obj_t BgL_z52onclose1114z52_2181, obj_t BgL_z52gcmarkshead1115z52_2182, obj_t BgL_z52gcmarkstail1116z52_2183, obj_t BgL_closed1117z00_2184, obj_t BgL_loop1118z00_2185, obj_t BgL_z52alloc1119z52_2186, obj_t BgL_z52offset1120z52_2187, obj_t BgL_z52proca1121z52_2188, obj_t BgL_z52procc1122z52_2189, obj_t BgL_z52callback1123z52_2190, obj_t BgL_ipc1124z00_2191)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 53 */
{ /* Llib/uvtypes.scm 53 */
uv_handle_t * BgL_z42builtin1113z42_2628;bool_t BgL_closed1117z00_2631;bool_t BgL_ipc1124z00_2633;
BgL_z42builtin1113z42_2628 = 
FOREIGN_TO_COBJ(BgL_z42builtin1113z42_2180); 
BgL_closed1117z00_2631 = 
CBOOL(BgL_closed1117z00_2184); 
BgL_ipc1124z00_2633 = 
CBOOL(BgL_ipc1124z00_2191); 
{ /* Llib/uvtypes.scm 53 */
BgL_uvpipez00_bglt BgL_new1257z00_2634;
{ /* Llib/uvtypes.scm 53 */
BgL_uvpipez00_bglt BgL_new1256z00_2635;
BgL_new1256z00_2635 = 
((BgL_uvpipez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvpipez00_bgl) ))); 
{ /* Llib/uvtypes.scm 53 */
long BgL_arg1872z00_2636;
{ /* Llib/uvtypes.scm 53 */
long BgL_res2237z00_2637;
BgL_res2237z00_2637 = 
BGL_CLASS_INDEX(BGl_UvPipez00zz__libuv_typesz00); 
BgL_arg1872z00_2636 = BgL_res2237z00_2637; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1256z00_2635), BgL_arg1872z00_2636); } 
BgL_new1257z00_2634 = BgL_new1256z00_2635; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1257z00_2634)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1113z42_2628),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1257z00_2634)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1114z52_2181),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1257z00_2634)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1115z52_2182)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1257z00_2634)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1116z52_2183)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1257z00_2634)))->BgL_closedz00)=((bool_t)BgL_closed1117z00_2631),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1257z00_2634)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1118z00_2185)),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1257z00_2634)))->BgL_z52allocz52)=((obj_t)BgL_z52alloc1119z52_2186),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1257z00_2634)))->BgL_z52offsetz52)=((obj_t)BgL_z52offset1120z52_2187),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1257z00_2634)))->BgL_z52procaz52)=((obj_t)BgL_z52proca1121z52_2188),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1257z00_2634)))->BgL_z52proccz52)=((obj_t)BgL_z52procc1122z52_2189),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1257z00_2634)))->BgL_z52callbackz52)=((obj_t)BgL_z52callback1123z52_2190),BUNSPEC); 
((((BgL_uvpipez00_bglt)COBJECT(BgL_new1257z00_2634))->BgL_ipcz00)=((bool_t)BgL_ipc1124z00_2633),BUNSPEC); 
{ /* Llib/uvtypes.scm 53 */
obj_t BgL_fun1871z00_2638;
BgL_fun1871z00_2638 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvPipez00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1871z00_2638)(BgL_fun1871z00_2638, 
((obj_t)BgL_new1257z00_2634), BEOA); } 
return BgL_new1257z00_2634;} } } 
BGL_FUNCTION_END;
}



/* &lambda1880 */
obj_t BGl_z62lambda1880z62zz__libuv_typesz00(obj_t BgL_envz00_2192, obj_t BgL_oz00_2193, obj_t BgL_vz00_2194)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 53 */
{ /* Llib/uvtypes.scm 53 */
bool_t BgL_vz00_2640;
BgL_vz00_2640 = 
CBOOL(BgL_vz00_2194); 
return 
((((BgL_uvpipez00_bglt)COBJECT(
((BgL_uvpipez00_bglt)BgL_oz00_2193)))->BgL_ipcz00)=((bool_t)BgL_vz00_2640),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1879 */
obj_t BGl_z62lambda1879z62zz__libuv_typesz00(obj_t BgL_envz00_2195, obj_t BgL_oz00_2196)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 53 */
return 
BBOOL(
(((BgL_uvpipez00_bglt)COBJECT(
((BgL_uvpipez00_bglt)BgL_oz00_2196)))->BgL_ipcz00));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1857> */
obj_t BGl_z62zc3anonymousza31857ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2197, obj_t BgL_new1111z00_2198)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 50 */
{ 
BgL_uvudpz00_bglt BgL_auxz00_4207;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvudpz00_bglt)BgL_new1111z00_2198))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvudpz00_bglt)BgL_new1111z00_2198))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvudpz00_bglt)BgL_new1111z00_2198))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvudpz00_bglt)BgL_new1111z00_2198))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvudpz00_bglt)BgL_new1111z00_2198))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_4224;
{ /* Llib/uvtypes.scm 50 */
obj_t BgL_classz00_2643;
BgL_classz00_2643 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 50 */
obj_t BgL__ortest_1106z00_2644;
BgL__ortest_1106z00_2644 = 
BGL_CLASS_NIL(BgL_classz00_2643); 
if(
CBOOL(BgL__ortest_1106z00_2644))
{ /* Llib/uvtypes.scm 50 */
BgL_auxz00_4224 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2644)
; }  else 
{ /* Llib/uvtypes.scm 50 */
BgL_auxz00_4224 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2643))
; } } } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvudpz00_bglt)BgL_new1111z00_2198))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_4224),BUNSPEC); } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvudpz00_bglt)BgL_new1111z00_2198))))->BgL_z52allocz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvudpz00_bglt)BgL_new1111z00_2198))))->BgL_z52offsetz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvudpz00_bglt)BgL_new1111z00_2198))))->BgL_z52procaz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvudpz00_bglt)BgL_new1111z00_2198))))->BgL_z52proccz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvudpz00_bglt)BgL_new1111z00_2198))))->BgL_z52callbackz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvudpz00_bglt)COBJECT(
((BgL_uvudpz00_bglt)BgL_new1111z00_2198)))->BgL_z52procmz52)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_4207 = 
((BgL_uvudpz00_bglt)BgL_new1111z00_2198); 
return 
((obj_t)BgL_auxz00_4207);} } 
BGL_FUNCTION_END;
}



/* &lambda1855 */
BgL_uvudpz00_bglt BGl_z62lambda1855z62zz__libuv_typesz00(obj_t BgL_envz00_2199)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 50 */
{ /* Llib/uvtypes.scm 50 */
BgL_uvudpz00_bglt BgL_new1110z00_2645;
BgL_new1110z00_2645 = 
((BgL_uvudpz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvudpz00_bgl) ))); 
{ /* Llib/uvtypes.scm 50 */
long BgL_arg1856z00_2646;
{ /* Llib/uvtypes.scm 50 */
long BgL_res2236z00_2647;
BgL_res2236z00_2647 = 
BGL_CLASS_INDEX(BGl_UvUdpz00zz__libuv_typesz00); 
BgL_arg1856z00_2646 = BgL_res2236z00_2647; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1110z00_2645), BgL_arg1856z00_2646); } 
return BgL_new1110z00_2645;} } 
BGL_FUNCTION_END;
}



/* &lambda1852 */
BgL_uvudpz00_bglt BGl_z62lambda1852z62zz__libuv_typesz00(obj_t BgL_envz00_2200, obj_t BgL_z42builtin1098z42_2201, obj_t BgL_z52onclose1099z52_2202, obj_t BgL_z52gcmarkshead1100z52_2203, obj_t BgL_z52gcmarkstail1101z52_2204, obj_t BgL_closed1102z00_2205, obj_t BgL_loop1103z00_2206, obj_t BgL_z52alloc1104z52_2207, obj_t BgL_z52offset1105z52_2208, obj_t BgL_z52proca1106z52_2209, obj_t BgL_z52procc1107z52_2210, obj_t BgL_z52callback1108z52_2211, obj_t BgL_z52procm1109z52_2212)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 50 */
{ /* Llib/uvtypes.scm 50 */
uv_handle_t * BgL_z42builtin1098z42_2648;bool_t BgL_closed1102z00_2651;
BgL_z42builtin1098z42_2648 = 
FOREIGN_TO_COBJ(BgL_z42builtin1098z42_2201); 
BgL_closed1102z00_2651 = 
CBOOL(BgL_closed1102z00_2205); 
{ /* Llib/uvtypes.scm 50 */
BgL_uvudpz00_bglt BgL_new1255z00_2654;
{ /* Llib/uvtypes.scm 50 */
BgL_uvudpz00_bglt BgL_new1254z00_2655;
BgL_new1254z00_2655 = 
((BgL_uvudpz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvudpz00_bgl) ))); 
{ /* Llib/uvtypes.scm 50 */
long BgL_arg1854z00_2656;
{ /* Llib/uvtypes.scm 50 */
long BgL_res2235z00_2657;
BgL_res2235z00_2657 = 
BGL_CLASS_INDEX(BGl_UvUdpz00zz__libuv_typesz00); 
BgL_arg1854z00_2656 = BgL_res2235z00_2657; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1254z00_2655), BgL_arg1854z00_2656); } 
BgL_new1255z00_2654 = BgL_new1254z00_2655; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1255z00_2654)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1098z42_2648),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1255z00_2654)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1099z52_2202),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1255z00_2654)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1100z52_2203)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1255z00_2654)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1101z52_2204)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1255z00_2654)))->BgL_closedz00)=((bool_t)BgL_closed1102z00_2651),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1255z00_2654)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1103z00_2206)),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1255z00_2654)))->BgL_z52allocz52)=((obj_t)BgL_z52alloc1104z52_2207),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1255z00_2654)))->BgL_z52offsetz52)=((obj_t)BgL_z52offset1105z52_2208),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1255z00_2654)))->BgL_z52procaz52)=((obj_t)BgL_z52proca1106z52_2209),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1255z00_2654)))->BgL_z52proccz52)=((obj_t)BgL_z52procc1107z52_2210),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1255z00_2654)))->BgL_z52callbackz52)=((obj_t)BgL_z52callback1108z52_2211),BUNSPEC); 
((((BgL_uvudpz00_bglt)COBJECT(BgL_new1255z00_2654))->BgL_z52procmz52)=((obj_t)
((obj_t)BgL_z52procm1109z52_2212)),BUNSPEC); 
{ /* Llib/uvtypes.scm 50 */
obj_t BgL_fun1853z00_2658;
BgL_fun1853z00_2658 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvUdpz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1853z00_2658)(BgL_fun1853z00_2658, 
((obj_t)BgL_new1255z00_2654), BEOA); } 
return BgL_new1255z00_2654;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1864> */
obj_t BGl_z62zc3anonymousza31864ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2213)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 50 */
return BNIL;} 
BGL_FUNCTION_END;
}



/* &lambda1863 */
obj_t BGl_z62lambda1863z62zz__libuv_typesz00(obj_t BgL_envz00_2214, obj_t BgL_oz00_2215, obj_t BgL_vz00_2216)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 50 */
return 
((((BgL_uvudpz00_bglt)COBJECT(
((BgL_uvudpz00_bglt)BgL_oz00_2215)))->BgL_z52procmz52)=((obj_t)
((obj_t)BgL_vz00_2216)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1862 */
obj_t BGl_z62lambda1862z62zz__libuv_typesz00(obj_t BgL_envz00_2217, obj_t BgL_oz00_2218)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 50 */
return 
(((BgL_uvudpz00_bglt)COBJECT(
((BgL_uvudpz00_bglt)BgL_oz00_2218)))->BgL_z52procmz52);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1846> */
obj_t BGl_z62zc3anonymousza31846ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2219, obj_t BgL_new1096z00_2220)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 48 */
{ 
BgL_uvtcpz00_bglt BgL_auxz00_4301;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1096z00_2220))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1096z00_2220))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1096z00_2220))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1096z00_2220))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1096z00_2220))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_4318;
{ /* Llib/uvtypes.scm 48 */
obj_t BgL_classz00_2663;
BgL_classz00_2663 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 48 */
obj_t BgL__ortest_1106z00_2664;
BgL__ortest_1106z00_2664 = 
BGL_CLASS_NIL(BgL_classz00_2663); 
if(
CBOOL(BgL__ortest_1106z00_2664))
{ /* Llib/uvtypes.scm 48 */
BgL_auxz00_4318 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2664)
; }  else 
{ /* Llib/uvtypes.scm 48 */
BgL_auxz00_4318 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2663))
; } } } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1096z00_2220))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_4318),BUNSPEC); } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1096z00_2220))))->BgL_z52allocz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1096z00_2220))))->BgL_z52offsetz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1096z00_2220))))->BgL_z52procaz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1096z00_2220))))->BgL_z52proccz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1096z00_2220))))->BgL_z52callbackz52)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4301 = 
((BgL_uvtcpz00_bglt)BgL_new1096z00_2220); 
return 
((obj_t)BgL_auxz00_4301);} } 
BGL_FUNCTION_END;
}



/* &lambda1844 */
BgL_uvtcpz00_bglt BGl_z62lambda1844z62zz__libuv_typesz00(obj_t BgL_envz00_2221)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 48 */
{ /* Llib/uvtypes.scm 48 */
BgL_uvtcpz00_bglt BgL_new1095z00_2665;
BgL_new1095z00_2665 = 
((BgL_uvtcpz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvtcpz00_bgl) ))); 
{ /* Llib/uvtypes.scm 48 */
long BgL_arg1845z00_2666;
{ /* Llib/uvtypes.scm 48 */
long BgL_res2234z00_2667;
BgL_res2234z00_2667 = 
BGL_CLASS_INDEX(BGl_UvTcpz00zz__libuv_typesz00); 
BgL_arg1845z00_2666 = BgL_res2234z00_2667; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1095z00_2665), BgL_arg1845z00_2666); } 
return BgL_new1095z00_2665;} } 
BGL_FUNCTION_END;
}



/* &lambda1841 */
BgL_uvtcpz00_bglt BGl_z62lambda1841z62zz__libuv_typesz00(obj_t BgL_envz00_2222, obj_t BgL_z42builtin1084z42_2223, obj_t BgL_z52onclose1085z52_2224, obj_t BgL_z52gcmarkshead1086z52_2225, obj_t BgL_z52gcmarkstail1087z52_2226, obj_t BgL_closed1088z00_2227, obj_t BgL_loop1089z00_2228, obj_t BgL_z52alloc1090z52_2229, obj_t BgL_z52offset1091z52_2230, obj_t BgL_z52proca1092z52_2231, obj_t BgL_z52procc1093z52_2232, obj_t BgL_z52callback1094z52_2233)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 48 */
{ /* Llib/uvtypes.scm 48 */
uv_handle_t * BgL_z42builtin1084z42_2668;bool_t BgL_closed1088z00_2671;
BgL_z42builtin1084z42_2668 = 
FOREIGN_TO_COBJ(BgL_z42builtin1084z42_2223); 
BgL_closed1088z00_2671 = 
CBOOL(BgL_closed1088z00_2227); 
{ /* Llib/uvtypes.scm 48 */
BgL_uvtcpz00_bglt BgL_new1253z00_2673;
{ /* Llib/uvtypes.scm 48 */
BgL_uvtcpz00_bglt BgL_new1252z00_2674;
BgL_new1252z00_2674 = 
((BgL_uvtcpz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvtcpz00_bgl) ))); 
{ /* Llib/uvtypes.scm 48 */
long BgL_arg1843z00_2675;
{ /* Llib/uvtypes.scm 48 */
long BgL_res2233z00_2676;
BgL_res2233z00_2676 = 
BGL_CLASS_INDEX(BGl_UvTcpz00zz__libuv_typesz00); 
BgL_arg1843z00_2675 = BgL_res2233z00_2676; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1252z00_2674), BgL_arg1843z00_2675); } 
BgL_new1253z00_2673 = BgL_new1252z00_2674; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1253z00_2673)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1084z42_2668),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1253z00_2673)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1085z52_2224),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1253z00_2673)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1086z52_2225)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1253z00_2673)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1087z52_2226)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1253z00_2673)))->BgL_closedz00)=((bool_t)BgL_closed1088z00_2671),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1253z00_2673)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1089z00_2228)),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1253z00_2673)))->BgL_z52allocz52)=((obj_t)BgL_z52alloc1090z52_2229),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1253z00_2673)))->BgL_z52offsetz52)=((obj_t)BgL_z52offset1091z52_2230),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1253z00_2673)))->BgL_z52procaz52)=((obj_t)BgL_z52proca1092z52_2231),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1253z00_2673)))->BgL_z52proccz52)=((obj_t)BgL_z52procc1093z52_2232),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1253z00_2673)))->BgL_z52callbackz52)=((obj_t)BgL_z52callback1094z52_2233),BUNSPEC); 
{ /* Llib/uvtypes.scm 48 */
obj_t BgL_fun1842z00_2677;
BgL_fun1842z00_2677 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvTcpz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1842z00_2677)(BgL_fun1842z00_2677, 
((obj_t)BgL_new1253z00_2673), BEOA); } 
return BgL_new1253z00_2673;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1795> */
obj_t BGl_z62zc3anonymousza31795ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2234, obj_t BgL_new1082z00_2235)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 40 */
{ 
BgL_uvstreamz00_bglt BgL_auxz00_4386;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvstreamz00_bglt)BgL_new1082z00_2235))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvstreamz00_bglt)BgL_new1082z00_2235))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvstreamz00_bglt)BgL_new1082z00_2235))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvstreamz00_bglt)BgL_new1082z00_2235))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvstreamz00_bglt)BgL_new1082z00_2235))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_4403;
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_classz00_2679;
BgL_classz00_2679 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL__ortest_1106z00_2680;
BgL__ortest_1106z00_2680 = 
BGL_CLASS_NIL(BgL_classz00_2679); 
if(
CBOOL(BgL__ortest_1106z00_2680))
{ /* Llib/uvtypes.scm 40 */
BgL_auxz00_4403 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2680)
; }  else 
{ /* Llib/uvtypes.scm 40 */
BgL_auxz00_4403 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2679))
; } } } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1082z00_2235)))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_4403),BUNSPEC); } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1082z00_2235)))->BgL_z52allocz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1082z00_2235)))->BgL_z52offsetz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1082z00_2235)))->BgL_z52procaz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1082z00_2235)))->BgL_z52proccz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1082z00_2235)))->BgL_z52callbackz52)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4386 = 
((BgL_uvstreamz00_bglt)BgL_new1082z00_2235); 
return 
((obj_t)BgL_auxz00_4386);} } 
BGL_FUNCTION_END;
}



/* &lambda1793 */
BgL_uvstreamz00_bglt BGl_z62lambda1793z62zz__libuv_typesz00(obj_t BgL_envz00_2236)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 40 */
{ /* Llib/uvtypes.scm 40 */
BgL_uvstreamz00_bglt BgL_new1081z00_2681;
BgL_new1081z00_2681 = 
((BgL_uvstreamz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvstreamz00_bgl) ))); 
{ /* Llib/uvtypes.scm 40 */
long BgL_arg1794z00_2682;
{ /* Llib/uvtypes.scm 40 */
long BgL_res2232z00_2683;
BgL_res2232z00_2683 = 
BGL_CLASS_INDEX(BGl_UvStreamz00zz__libuv_typesz00); 
BgL_arg1794z00_2682 = BgL_res2232z00_2683; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1081z00_2681), BgL_arg1794z00_2682); } 
return BgL_new1081z00_2681;} } 
BGL_FUNCTION_END;
}



/* &lambda1790 */
BgL_uvstreamz00_bglt BGl_z62lambda1790z62zz__libuv_typesz00(obj_t BgL_envz00_2237, obj_t BgL_z42builtin1070z42_2238, obj_t BgL_z52onclose1071z52_2239, obj_t BgL_z52gcmarkshead1072z52_2240, obj_t BgL_z52gcmarkstail1073z52_2241, obj_t BgL_closed1074z00_2242, obj_t BgL_loop1075z00_2243, obj_t BgL_z52alloc1076z52_2244, obj_t BgL_z52offset1077z52_2245, obj_t BgL_z52proca1078z52_2246, obj_t BgL_z52procc1079z52_2247, obj_t BgL_z52callback1080z52_2248)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 40 */
{ /* Llib/uvtypes.scm 40 */
uv_handle_t * BgL_z42builtin1070z42_2684;bool_t BgL_closed1074z00_2687;
BgL_z42builtin1070z42_2684 = 
FOREIGN_TO_COBJ(BgL_z42builtin1070z42_2238); 
BgL_closed1074z00_2687 = 
CBOOL(BgL_closed1074z00_2242); 
{ /* Llib/uvtypes.scm 40 */
BgL_uvstreamz00_bglt BgL_new1251z00_2689;
{ /* Llib/uvtypes.scm 40 */
BgL_uvstreamz00_bglt BgL_new1250z00_2690;
BgL_new1250z00_2690 = 
((BgL_uvstreamz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvstreamz00_bgl) ))); 
{ /* Llib/uvtypes.scm 40 */
long BgL_arg1792z00_2691;
{ /* Llib/uvtypes.scm 40 */
long BgL_res2231z00_2692;
BgL_res2231z00_2692 = 
BGL_CLASS_INDEX(BGl_UvStreamz00zz__libuv_typesz00); 
BgL_arg1792z00_2691 = BgL_res2231z00_2692; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1250z00_2690), BgL_arg1792z00_2691); } 
BgL_new1251z00_2689 = BgL_new1250z00_2690; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1251z00_2689)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1070z42_2684),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1251z00_2689)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1071z52_2239),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1251z00_2689)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1072z52_2240)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1251z00_2689)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1073z52_2241)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1251z00_2689)))->BgL_closedz00)=((bool_t)BgL_closed1074z00_2687),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(BgL_new1251z00_2689))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1075z00_2243)),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(BgL_new1251z00_2689))->BgL_z52allocz52)=((obj_t)BgL_z52alloc1076z52_2244),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(BgL_new1251z00_2689))->BgL_z52offsetz52)=((obj_t)BgL_z52offset1077z52_2245),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(BgL_new1251z00_2689))->BgL_z52procaz52)=((obj_t)BgL_z52proca1078z52_2246),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(BgL_new1251z00_2689))->BgL_z52proccz52)=((obj_t)BgL_z52procc1079z52_2247),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(BgL_new1251z00_2689))->BgL_z52callbackz52)=((obj_t)BgL_z52callback1080z52_2248),BUNSPEC); 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_fun1791z00_2693;
BgL_fun1791z00_2693 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvStreamz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1791z00_2693)(BgL_fun1791z00_2693, 
((obj_t)BgL_new1251z00_2689), BEOA); } 
return BgL_new1251z00_2689;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1835> */
obj_t BGl_z62zc3anonymousza31835ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2249)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 40 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &lambda1834 */
obj_t BGl_z62lambda1834z62zz__libuv_typesz00(obj_t BgL_envz00_2250, obj_t BgL_oz00_2251, obj_t BgL_vz00_2252)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 40 */
return 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2251)))->BgL_z52callbackz52)=((obj_t)BgL_vz00_2252),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1833 */
obj_t BGl_z62lambda1833z62zz__libuv_typesz00(obj_t BgL_envz00_2253, obj_t BgL_oz00_2254)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 40 */
return 
(((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2254)))->BgL_z52callbackz52);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1828> */
obj_t BGl_z62zc3anonymousza31828ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2255)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 40 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &lambda1827 */
obj_t BGl_z62lambda1827z62zz__libuv_typesz00(obj_t BgL_envz00_2256, obj_t BgL_oz00_2257, obj_t BgL_vz00_2258)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 40 */
return 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2257)))->BgL_z52proccz52)=((obj_t)BgL_vz00_2258),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1826 */
obj_t BGl_z62lambda1826z62zz__libuv_typesz00(obj_t BgL_envz00_2259, obj_t BgL_oz00_2260)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 40 */
return 
(((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2260)))->BgL_z52proccz52);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1821> */
obj_t BGl_z62zc3anonymousza31821ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2261)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 40 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &lambda1820 */
obj_t BGl_z62lambda1820z62zz__libuv_typesz00(obj_t BgL_envz00_2262, obj_t BgL_oz00_2263, obj_t BgL_vz00_2264)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 40 */
return 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2263)))->BgL_z52procaz52)=((obj_t)BgL_vz00_2264),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1819 */
obj_t BGl_z62lambda1819z62zz__libuv_typesz00(obj_t BgL_envz00_2265, obj_t BgL_oz00_2266)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 40 */
return 
(((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2266)))->BgL_z52procaz52);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1814> */
obj_t BGl_z62zc3anonymousza31814ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2267)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 40 */
return 
BINT(((long)0));} 
BGL_FUNCTION_END;
}



/* &lambda1813 */
obj_t BGl_z62lambda1813z62zz__libuv_typesz00(obj_t BgL_envz00_2268, obj_t BgL_oz00_2269, obj_t BgL_vz00_2270)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 40 */
return 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2269)))->BgL_z52offsetz52)=((obj_t)BgL_vz00_2270),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1812 */
obj_t BGl_z62lambda1812z62zz__libuv_typesz00(obj_t BgL_envz00_2271, obj_t BgL_oz00_2272)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 40 */
return 
(((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2272)))->BgL_z52offsetz52);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1807> */
obj_t BGl_z62zc3anonymousza31807ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2273)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 40 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &lambda1806 */
obj_t BGl_z62lambda1806z62zz__libuv_typesz00(obj_t BgL_envz00_2274, obj_t BgL_oz00_2275, obj_t BgL_vz00_2276)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 40 */
return 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2275)))->BgL_z52allocz52)=((obj_t)BgL_vz00_2276),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1805 */
obj_t BGl_z62lambda1805z62zz__libuv_typesz00(obj_t BgL_envz00_2277, obj_t BgL_oz00_2278)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 40 */
return 
(((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2278)))->BgL_z52allocz52);} 
BGL_FUNCTION_END;
}



/* &lambda1800 */
obj_t BGl_z62lambda1800z62zz__libuv_typesz00(obj_t BgL_envz00_2279, obj_t BgL_oz00_2280, obj_t BgL_vz00_2281)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 40 */
return 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2280)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_vz00_2281)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1799 */
BgL_uvloopz00_bglt BGl_z62lambda1799z62zz__libuv_typesz00(obj_t BgL_envz00_2282, obj_t BgL_oz00_2283)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 40 */
return 
(((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2283)))->BgL_loopz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1772> */
obj_t BGl_z62zc3anonymousza31772ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2284, obj_t BgL_new1068z00_2285)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 36 */
{ 
BgL_uvwatcherz00_bglt BgL_auxz00_4489;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvwatcherz00_bglt)BgL_new1068z00_2285))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvwatcherz00_bglt)BgL_new1068z00_2285))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvwatcherz00_bglt)BgL_new1068z00_2285))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvwatcherz00_bglt)BgL_new1068z00_2285))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvwatcherz00_bglt)BgL_new1068z00_2285))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_4506;
{ /* Llib/uvtypes.scm 36 */
obj_t BgL_classz00_2708;
BgL_classz00_2708 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 36 */
obj_t BgL__ortest_1106z00_2709;
BgL__ortest_1106z00_2709 = 
BGL_CLASS_NIL(BgL_classz00_2708); 
if(
CBOOL(BgL__ortest_1106z00_2709))
{ /* Llib/uvtypes.scm 36 */
BgL_auxz00_4506 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2709)
; }  else 
{ /* Llib/uvtypes.scm 36 */
BgL_auxz00_4506 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2708))
; } } } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1068z00_2285)))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_4506),BUNSPEC); } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1068z00_2285)))->BgL_cbz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_4489 = 
((BgL_uvwatcherz00_bglt)BgL_new1068z00_2285); 
return 
((obj_t)BgL_auxz00_4489);} } 
BGL_FUNCTION_END;
}



/* &lambda1770 */
BgL_uvwatcherz00_bglt BGl_z62lambda1770z62zz__libuv_typesz00(obj_t BgL_envz00_2286)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 36 */
{ /* Llib/uvtypes.scm 36 */
BgL_uvwatcherz00_bglt BgL_new1067z00_2710;
BgL_new1067z00_2710 = 
((BgL_uvwatcherz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvwatcherz00_bgl) ))); 
{ /* Llib/uvtypes.scm 36 */
long BgL_arg1771z00_2711;
{ /* Llib/uvtypes.scm 36 */
long BgL_res2230z00_2712;
BgL_res2230z00_2712 = 
BGL_CLASS_INDEX(BGl_UvWatcherz00zz__libuv_typesz00); 
BgL_arg1771z00_2711 = BgL_res2230z00_2712; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1067z00_2710), BgL_arg1771z00_2711); } 
return BgL_new1067z00_2710;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1784> */
obj_t BGl_z62zc3anonymousza31784ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2287)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 36 */
return BGl_listzd2envzd2zz__r4_pairs_and_lists_6_3z00;} 
BGL_FUNCTION_END;
}



/* &lambda1783 */
obj_t BGl_z62lambda1783z62zz__libuv_typesz00(obj_t BgL_envz00_2288, obj_t BgL_oz00_2289, obj_t BgL_vz00_2290)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 36 */
return 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_oz00_2289)))->BgL_cbz00)=((obj_t)
((obj_t)BgL_vz00_2290)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1782 */
obj_t BGl_z62lambda1782z62zz__libuv_typesz00(obj_t BgL_envz00_2291, obj_t BgL_oz00_2292)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 36 */
return 
(((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_oz00_2292)))->BgL_cbz00);} 
BGL_FUNCTION_END;
}



/* &lambda1777 */
obj_t BGl_z62lambda1777z62zz__libuv_typesz00(obj_t BgL_envz00_2293, obj_t BgL_oz00_2294, obj_t BgL_vz00_2295)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 36 */
return 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_oz00_2294)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_vz00_2295)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1776 */
BgL_uvloopz00_bglt BGl_z62lambda1776z62zz__libuv_typesz00(obj_t BgL_envz00_2296, obj_t BgL_oz00_2297)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 36 */
return 
(((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_oz00_2297)))->BgL_loopz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1758> */
obj_t BGl_z62zc3anonymousza31758ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2298, obj_t BgL_new1065z00_2299)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 33 */
{ 
BgL_uvloopz00_bglt BgL_auxz00_4533;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvloopz00_bglt)BgL_new1065z00_2299))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvloopz00_bglt)BgL_new1065z00_2299))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvloopz00_bglt)BgL_new1065z00_2299))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvloopz00_bglt)BgL_new1065z00_2299))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvloopz00_bglt)BgL_new1065z00_2299))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_uvloopz00_bglt)COBJECT(
((BgL_uvloopz00_bglt)BgL_new1065z00_2299)))->BgL_z52mutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
BgL_auxz00_4533 = 
((BgL_uvloopz00_bglt)BgL_new1065z00_2299); 
return 
((obj_t)BgL_auxz00_4533);} } 
BGL_FUNCTION_END;
}



/* &lambda1756 */
BgL_uvloopz00_bglt BGl_z62lambda1756z62zz__libuv_typesz00(obj_t BgL_envz00_2300)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 33 */
{ /* Llib/uvtypes.scm 33 */
BgL_uvloopz00_bglt BgL_new1064z00_2720;
BgL_new1064z00_2720 = 
((BgL_uvloopz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvloopz00_bgl) ))); 
{ /* Llib/uvtypes.scm 33 */
long BgL_arg1757z00_2721;
{ /* Llib/uvtypes.scm 33 */
long BgL_res2229z00_2722;
BgL_res2229z00_2722 = 
BGL_CLASS_INDEX(BGl_UvLoopz00zz__libuv_typesz00); 
BgL_arg1757z00_2721 = BgL_res2229z00_2722; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1064z00_2720), BgL_arg1757z00_2721); } 
return BgL_new1064z00_2720;} } 
BGL_FUNCTION_END;
}



/* &lambda1752 */
BgL_uvloopz00_bglt BGl_z62lambda1752z62zz__libuv_typesz00(obj_t BgL_envz00_2301, obj_t BgL_z42builtin1058z42_2302, obj_t BgL_z52onclose1059z52_2303, obj_t BgL_z52gcmarkshead1060z52_2304, obj_t BgL_z52gcmarkstail1061z52_2305, obj_t BgL_closed1062z00_2306, obj_t BgL_z52mutex1063z52_2307)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 33 */
{ /* Llib/uvtypes.scm 33 */
uv_handle_t * BgL_z42builtin1058z42_2723;bool_t BgL_closed1062z00_2726;
BgL_z42builtin1058z42_2723 = 
FOREIGN_TO_COBJ(BgL_z42builtin1058z42_2302); 
BgL_closed1062z00_2726 = 
CBOOL(BgL_closed1062z00_2306); 
{ /* Llib/uvtypes.scm 33 */
BgL_uvloopz00_bglt BgL_new1249z00_2728;
{ /* Llib/uvtypes.scm 33 */
BgL_uvloopz00_bglt BgL_new1248z00_2729;
BgL_new1248z00_2729 = 
((BgL_uvloopz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvloopz00_bgl) ))); 
{ /* Llib/uvtypes.scm 33 */
long BgL_arg1755z00_2730;
{ /* Llib/uvtypes.scm 33 */
long BgL_res2228z00_2731;
BgL_res2228z00_2731 = 
BGL_CLASS_INDEX(BGl_UvLoopz00zz__libuv_typesz00); 
BgL_arg1755z00_2730 = BgL_res2228z00_2731; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1248z00_2729), BgL_arg1755z00_2730); } 
BgL_new1249z00_2728 = BgL_new1248z00_2729; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1249z00_2728)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1058z42_2723),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1249z00_2728)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1059z52_2303),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1249z00_2728)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1060z52_2304)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1249z00_2728)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1061z52_2305)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1249z00_2728)))->BgL_closedz00)=((bool_t)BgL_closed1062z00_2726),BUNSPEC); 
((((BgL_uvloopz00_bglt)COBJECT(BgL_new1249z00_2728))->BgL_z52mutexz52)=((obj_t)
((obj_t)BgL_z52mutex1063z52_2307)),BUNSPEC); 
{ /* Llib/uvtypes.scm 33 */
obj_t BgL_fun1754z00_2732;
BgL_fun1754z00_2732 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvLoopz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1754z00_2732)(BgL_fun1754z00_2732, 
((obj_t)BgL_new1249z00_2728), BEOA); } 
return BgL_new1249z00_2728;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1765> */
obj_t BGl_z62zc3anonymousza31765ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2308)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 33 */
{ /* Llib/uvtypes.scm 34 */

{ /* Llib/uvtypes.scm 34 */
obj_t BgL_namez00_2733;
BgL_namez00_2733 = 
BGl_gensymz00zz__r4_symbols_6_4z00(
CNST_TABLE_REF(((long)20))); 
{ /* Llib/uvtypes.scm 34 */

{ /* Llib/uvtypes.scm 34 */
obj_t BgL_res2227z00_2734;
BgL_res2227z00_2734 = 
bgl_make_mutex(BgL_namez00_2733); 
return BgL_res2227z00_2734;} } } } } 
BGL_FUNCTION_END;
}



/* &lambda1764 */
obj_t BGl_z62lambda1764z62zz__libuv_typesz00(obj_t BgL_envz00_2309, obj_t BgL_oz00_2310, obj_t BgL_vz00_2311)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 33 */
return 
((((BgL_uvloopz00_bglt)COBJECT(
((BgL_uvloopz00_bglt)BgL_oz00_2310)))->BgL_z52mutexz52)=((obj_t)
((obj_t)BgL_vz00_2311)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1763 */
obj_t BGl_z62lambda1763z62zz__libuv_typesz00(obj_t BgL_envz00_2312, obj_t BgL_oz00_2313)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 33 */
return 
(((BgL_uvloopz00_bglt)COBJECT(
((BgL_uvloopz00_bglt)BgL_oz00_2313)))->BgL_z52mutexz52);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1678> */
obj_t BGl_z62zc3anonymousza31678ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2314, obj_t BgL_new1056z00_2315)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 26 */
{ 
BgL_uvhandlez00_bglt BgL_auxz00_4593;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1056z00_2315)))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1056z00_2315)))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1056z00_2315)))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1056z00_2315)))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1056z00_2315)))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
BgL_auxz00_4593 = 
((BgL_uvhandlez00_bglt)BgL_new1056z00_2315); 
return 
((obj_t)BgL_auxz00_4593);} } 
BGL_FUNCTION_END;
}



/* &lambda1676 */
BgL_uvhandlez00_bglt BGl_z62lambda1676z62zz__libuv_typesz00(obj_t BgL_envz00_2316)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 26 */
{ /* Llib/uvtypes.scm 26 */
BgL_uvhandlez00_bglt BgL_new1055z00_2739;
BgL_new1055z00_2739 = 
((BgL_uvhandlez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvhandlez00_bgl) ))); 
{ /* Llib/uvtypes.scm 26 */
long BgL_arg1677z00_2740;
{ /* Llib/uvtypes.scm 26 */
long BgL_res2226z00_2741;
BgL_res2226z00_2741 = 
BGL_CLASS_INDEX(BGl_UvHandlez00zz__libuv_typesz00); 
BgL_arg1677z00_2740 = BgL_res2226z00_2741; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1055z00_2739), BgL_arg1677z00_2740); } 
return BgL_new1055z00_2739;} } 
BGL_FUNCTION_END;
}



/* &lambda1671 */
BgL_uvhandlez00_bglt BGl_z62lambda1671z62zz__libuv_typesz00(obj_t BgL_envz00_2317, obj_t BgL_z42builtin1050z42_2318, obj_t BgL_z52onclose1051z52_2319, obj_t BgL_z52gcmarkshead1052z52_2320, obj_t BgL_z52gcmarkstail1053z52_2321, obj_t BgL_closed1054z00_2322)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 26 */
{ /* Llib/uvtypes.scm 26 */
uv_handle_t * BgL_z42builtin1050z42_2742;bool_t BgL_closed1054z00_2745;
BgL_z42builtin1050z42_2742 = 
FOREIGN_TO_COBJ(BgL_z42builtin1050z42_2318); 
BgL_closed1054z00_2745 = 
CBOOL(BgL_closed1054z00_2322); 
{ /* Llib/uvtypes.scm 26 */
BgL_uvhandlez00_bglt BgL_new1247z00_2746;
{ /* Llib/uvtypes.scm 26 */
BgL_uvhandlez00_bglt BgL_new1246z00_2747;
BgL_new1246z00_2747 = 
((BgL_uvhandlez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvhandlez00_bgl) ))); 
{ /* Llib/uvtypes.scm 26 */
long BgL_arg1675z00_2748;
{ /* Llib/uvtypes.scm 26 */
long BgL_res2225z00_2749;
BgL_res2225z00_2749 = 
BGL_CLASS_INDEX(BGl_UvHandlez00zz__libuv_typesz00); 
BgL_arg1675z00_2748 = BgL_res2225z00_2749; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1246z00_2747), BgL_arg1675z00_2748); } 
BgL_new1247z00_2746 = BgL_new1246z00_2747; } 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_new1247z00_2746))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1050z42_2742),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_new1247z00_2746))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1051z52_2319),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_new1247z00_2746))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1052z52_2320)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_new1247z00_2746))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1053z52_2321)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_new1247z00_2746))->BgL_closedz00)=((bool_t)BgL_closed1054z00_2745),BUNSPEC); 
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_fun1672z00_2750;
BgL_fun1672z00_2750 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvHandlez00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1672z00_2750)(BgL_fun1672z00_2750, 
((obj_t)BgL_new1247z00_2746), BEOA); } 
return BgL_new1247z00_2746;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1743> */
obj_t BGl_z62zc3anonymousza31743ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2323)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 26 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &lambda1742 */
obj_t BGl_z62lambda1742z62zz__libuv_typesz00(obj_t BgL_envz00_2324, obj_t BgL_oz00_2325, obj_t BgL_vz00_2326)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 26 */
{ /* Llib/uvtypes.scm 26 */
bool_t BgL_vz00_2752;
BgL_vz00_2752 = 
CBOOL(BgL_vz00_2326); 
return 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2325)))->BgL_closedz00)=((bool_t)BgL_vz00_2752),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1741 */
obj_t BGl_z62lambda1741z62zz__libuv_typesz00(obj_t BgL_envz00_2327, obj_t BgL_oz00_2328)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 26 */
return 
BBOOL(
(((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2328)))->BgL_closedz00));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1719> */
obj_t BGl_z62zc3anonymousza31719ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2329)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 26 */
return BNIL;} 
BGL_FUNCTION_END;
}



/* &lambda1718 */
obj_t BGl_z62lambda1718z62zz__libuv_typesz00(obj_t BgL_envz00_2330, obj_t BgL_oz00_2331, obj_t BgL_vz00_2332)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 26 */
return 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2331)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_vz00_2332)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1717 */
obj_t BGl_z62lambda1717z62zz__libuv_typesz00(obj_t BgL_envz00_2333, obj_t BgL_oz00_2334)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 26 */
return 
(((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2334)))->BgL_z52gcmarkstailz52);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1707> */
obj_t BGl_z62zc3anonymousza31707ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2335)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 26 */
return BNIL;} 
BGL_FUNCTION_END;
}



/* &lambda1706 */
obj_t BGl_z62lambda1706z62zz__libuv_typesz00(obj_t BgL_envz00_2336, obj_t BgL_oz00_2337, obj_t BgL_vz00_2338)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 26 */
return 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2337)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_vz00_2338)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1705 */
obj_t BGl_z62lambda1705z62zz__libuv_typesz00(obj_t BgL_envz00_2339, obj_t BgL_oz00_2340)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 26 */
return 
(((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2340)))->BgL_z52gcmarksheadz52);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1695> */
obj_t BGl_z62zc3anonymousza31695ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2341)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 26 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &lambda1694 */
obj_t BGl_z62lambda1694z62zz__libuv_typesz00(obj_t BgL_envz00_2342, obj_t BgL_oz00_2343, obj_t BgL_vz00_2344)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 26 */
return 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2343)))->BgL_z52onclosez52)=((obj_t)BgL_vz00_2344),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1693 */
obj_t BGl_z62lambda1693z62zz__libuv_typesz00(obj_t BgL_envz00_2345, obj_t BgL_oz00_2346)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 26 */
return 
(((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2346)))->BgL_z52onclosez52);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1685> */
obj_t BGl_z62zc3anonymousza31685ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2347)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 26 */
return 
void_star_to_obj(0L);} 
BGL_FUNCTION_END;
}



/* &lambda1684 */
obj_t BGl_z62lambda1684z62zz__libuv_typesz00(obj_t BgL_envz00_2348, obj_t BgL_oz00_2349, obj_t BgL_vz00_2350)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 26 */
{ /* Llib/uvtypes.scm 26 */
uv_handle_t * BgL_vz00_2763;
BgL_vz00_2763 = 
FOREIGN_TO_COBJ(BgL_vz00_2350); 
return 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2349)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_vz00_2763),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1683 */
obj_t BGl_z62lambda1683z62zz__libuv_typesz00(obj_t BgL_envz00_2351, obj_t BgL_oz00_2352)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 26 */
return 
void_star_to_obj(
(((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2352)))->BgL_z42builtinz42));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1664> */
obj_t BGl_z62zc3anonymousza31664ze3ze1zz__libuv_typesz00(obj_t BgL_envz00_2353, obj_t BgL_new1048z00_2354)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 23 */
return 
((obj_t)
((BgL_z52uvz52_bglt)BgL_new1048z00_2354));} 
BGL_FUNCTION_END;
}



/* &lambda1659 */
BgL_z52uvz52_bglt BGl_z62lambda1659z62zz__libuv_typesz00(obj_t BgL_envz00_2355)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 23 */
{ /* Llib/uvtypes.scm 23 */
BgL_z52uvz52_bglt BgL_new1047z00_2766;
BgL_new1047z00_2766 = 
((BgL_z52uvz52_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52uvz52_bgl) ))); 
{ /* Llib/uvtypes.scm 23 */
long BgL_arg1663z00_2767;
{ /* Llib/uvtypes.scm 23 */
long BgL_res2224z00_2768;
BgL_res2224z00_2768 = 
BGL_CLASS_INDEX(BGl_z52Uvz52zz__libuv_typesz00); 
BgL_arg1663z00_2767 = BgL_res2224z00_2768; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1047z00_2766), BgL_arg1663z00_2767); } 
return BgL_new1047z00_2766;} } 
BGL_FUNCTION_END;
}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__libuv_typesz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 15 */
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2450z00zz__libuv_typesz00, BGl_z52Uvz52zz__libuv_typesz00, BGl_string2451z00zz__libuv_typesz00);} 
BGL_FUNCTION_END;
}



/* &%uv-init1337 */
obj_t BGl_z62z52uvzd2init1337ze2zz__libuv_typesz00(obj_t BgL_envz00_2359, obj_t BgL_oz00_2360)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 187 */
return 
((obj_t)
((BgL_z52uvz52_bglt)BgL_oz00_2360));} 
BGL_FUNCTION_END;
}



/* %uv-init */
BGL_EXPORTED_DEF obj_t BGl_z52uvzd2initz80zz__libuv_typesz00(BgL_z52uvz52_bglt BgL_oz00_4)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 187 */
{ /* Llib/uvtypes.scm 187 */
obj_t BgL_method1338z00_1200;
{ /* Llib/uvtypes.scm 187 */
obj_t BgL_res2274z00_1672;
{ /* Llib/uvtypes.scm 187 */
long BgL_objzd2classzd2numz00_1629;
{ /* Llib/uvtypes.scm 187 */
long BgL_res2263z00_1632;
BgL_res2263z00_1632 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_4)); 
BgL_objzd2classzd2numz00_1629 = BgL_res2263z00_1632; } 
{ /* Llib/uvtypes.scm 187 */
obj_t BgL_arg1742z00_1630;
BgL_arg1742z00_1630 = 
PROCEDURE_REF(BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, 
(int)(((long)1))); 
{ /* Llib/uvtypes.scm 187 */
int BgL_offsetz00_1634;
BgL_offsetz00_1634 = 
(int)(BgL_objzd2classzd2numz00_1629); 
{ /* Llib/uvtypes.scm 187 */
long BgL_offsetz00_1635;
BgL_offsetz00_1635 = 
(
(long)(BgL_offsetz00_1634)-OBJECT_TYPE); 
{ /* Llib/uvtypes.scm 187 */
long BgL_modz00_1636;
{ /* Llib/uvtypes.scm 187 */
int BgL_arg1744z00_1637;
BgL_arg1744z00_1637 = 
(int)(((long)16)); 
{ /* Llib/uvtypes.scm 187 */
long BgL_res2266z00_1647;
{ /* Llib/uvtypes.scm 187 */
long BgL_tmpz00_4676;
BgL_tmpz00_4676 = 
(long)(BgL_arg1744z00_1637); 
BgL_res2266z00_1647 = 
(BgL_offsetz00_1635/BgL_tmpz00_4676); } 
BgL_modz00_1636 = BgL_res2266z00_1647; } } 
{ /* Llib/uvtypes.scm 187 */
long BgL_restz00_1638;
{ /* Llib/uvtypes.scm 187 */
int BgL_arg1743z00_1639;
BgL_arg1743z00_1639 = 
(int)(((long)16)); 
{ /* Llib/uvtypes.scm 187 */
long BgL_res2273z00_1667;
{ /* Llib/uvtypes.scm 187 */
long BgL_n1z00_1649;long BgL_n2z00_1650;
BgL_n1z00_1649 = BgL_offsetz00_1635; 
BgL_n2z00_1650 = 
(long)(BgL_arg1743z00_1639); 
{ /* Llib/uvtypes.scm 187 */
bool_t BgL_testz00_4681;
{ /* Llib/uvtypes.scm 187 */
long BgL_arg1283z00_1652;
BgL_arg1283z00_1652 = 
(((BgL_n1z00_1649) | (BgL_n2z00_1650)) & -2147483648); 
BgL_testz00_4681 = 
(BgL_arg1283z00_1652==((long)0)); } 
if(BgL_testz00_4681)
{ /* Llib/uvtypes.scm 187 */
int32_t BgL_arg1272z00_1653;
{ /* Llib/uvtypes.scm 187 */
int32_t BgL_arg1278z00_1654;int32_t BgL_arg1279z00_1655;
{ /* Llib/uvtypes.scm 187 */
int32_t BgL_res2269z00_1659;
BgL_res2269z00_1659 = 
(int32_t)(BgL_n1z00_1649); 
BgL_arg1278z00_1654 = BgL_res2269z00_1659; } 
{ /* Llib/uvtypes.scm 187 */
int32_t BgL_res2270z00_1661;
BgL_res2270z00_1661 = 
(int32_t)(BgL_n2z00_1650); 
BgL_arg1279z00_1655 = BgL_res2270z00_1661; } 
BgL_arg1272z00_1653 = 
(BgL_arg1278z00_1654%BgL_arg1279z00_1655); } 
{ /* Llib/uvtypes.scm 187 */
long BgL_res2272z00_1666;
{ /* Llib/uvtypes.scm 187 */
long BgL_arg1409z00_1663;
BgL_arg1409z00_1663 = 
(long)(BgL_arg1272z00_1653); 
{ /* Llib/uvtypes.scm 187 */
long BgL_res2271z00_1665;
BgL_res2271z00_1665 = 
(long)(BgL_arg1409z00_1663); 
BgL_res2272z00_1666 = BgL_res2271z00_1665; } } 
BgL_res2273z00_1667 = BgL_res2272z00_1666; } }  else 
{ /* Llib/uvtypes.scm 187 */
BgL_res2273z00_1667 = 
(BgL_n1z00_1649%BgL_n2z00_1650); } } } 
BgL_restz00_1638 = BgL_res2273z00_1667; } } 
{ /* Llib/uvtypes.scm 187 */

{ /* Llib/uvtypes.scm 187 */
obj_t BgL_bucketz00_1640;
BgL_bucketz00_1640 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_1630),BgL_modz00_1636); 
BgL_res2274z00_1672 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_1640),BgL_restz00_1638); } } } } } } } } 
BgL_method1338z00_1200 = BgL_res2274z00_1672; } 
return 
PROCEDURE_ENTRY(BgL_method1338z00_1200)(BgL_method1338z00_1200, 
((obj_t)BgL_oz00_4), BEOA);} } 
BGL_FUNCTION_END;
}



/* &%uv-init */
obj_t BGl_z62z52uvzd2initze2zz__libuv_typesz00(obj_t BgL_envz00_2356, obj_t BgL_oz00_2357)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 187 */
return 
BGl_z52uvzd2initz80zz__libuv_typesz00(
((BgL_z52uvz52_bglt)BgL_oz00_2357));} 
BGL_FUNCTION_END;
}



/* method-init */
obj_t BGl_methodzd2initzd2zz__libuv_typesz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 15 */
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2printzd2envz00zz__objectz00, BGl_UvHandlez00zz__libuv_typesz00, BGl_proc2452z00zz__libuv_typesz00, BGl_string2453z00zz__libuv_typesz00);} 
BGL_FUNCTION_END;
}



/* &object-print-UvHandl1340 */
obj_t BGl_z62objectzd2printzd2UvHandl1340z62zz__libuv_typesz00(obj_t BgL_envz00_2362, obj_t BgL_objz00_2363, obj_t BgL_portz00_2364, obj_t BgL_printzd2slotzd2_2365)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/uvtypes.scm 193 */
{ 
obj_t BgL_fieldz00_2773;
{ /* Llib/uvtypes.scm 207 */
obj_t BgL_classz00_2779;
{ /* Llib/uvtypes.scm 207 */
long BgL_arg1745z00_2780;
{ /* Llib/uvtypes.scm 207 */
long BgL_arg1746z00_2781;
{ /* Llib/uvtypes.scm 207 */
long BgL_res2277z00_2782;
BgL_res2277z00_2782 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)
((BgL_uvhandlez00_bglt)BgL_objz00_2363))); 
BgL_arg1746z00_2781 = BgL_res2277z00_2782; } 
BgL_arg1745z00_2780 = 
(BgL_arg1746z00_2781-OBJECT_TYPE); } 
BgL_classz00_2779 = 
VECTOR_REF(BGl_za2classesza2z00zz__objectz00,BgL_arg1745z00_2780); } 
{ /* Llib/uvtypes.scm 207 */
obj_t BgL_classzd2namezd2_2783;
BgL_classzd2namezd2_2783 = 
BGl_classzd2namezd2zz__objectz00(BgL_classz00_2779); 
{ /* Llib/uvtypes.scm 208 */
obj_t BgL_fieldsz00_2784;
{ /* Llib/uvtypes.scm 209 */
obj_t BgL_res2279z00_2785;
{ /* Llib/uvtypes.scm 209 */
obj_t BgL_tmpz00_4708;
BgL_tmpz00_4708 = 
((obj_t)BgL_classz00_2779); 
BgL_res2279z00_2785 = 
BGL_CLASS_ALL_FIELDS(BgL_tmpz00_4708); } 
BgL_fieldsz00_2784 = BgL_res2279z00_2785; } 
{ /* Llib/uvtypes.scm 210 */

{ /* Llib/uvtypes.scm 211 */
obj_t BgL_tmpz00_4711;
BgL_tmpz00_4711 = 
((obj_t)BgL_portz00_2364); 
bgl_display_string(BGl_string2455z00zz__libuv_typesz00, BgL_tmpz00_4711); } 
bgl_display_obj(BgL_classzd2namezd2_2783, BgL_portz00_2364); 
{ /* Llib/uvtypes.scm 213 */
obj_t BgL_tmpz00_4715;
BgL_tmpz00_4715 = 
((obj_t)BgL_portz00_2364); 
bgl_display_string(BGl_string2456z00zz__libuv_typesz00, BgL_tmpz00_4715); } 
{ /* Llib/uvtypes.scm 214 */
obj_t BgL_arg2201z00_2786;
{ /* Llib/uvtypes.scm 214 */
int BgL_arg2202z00_2787;
{ /* Llib/uvtypes.scm 214 */
int BgL_res2280z00_2788;
{ /* Llib/uvtypes.scm 182 */
uv_handle_t * BgL_arg1417z00_2789;
BgL_arg1417z00_2789 = 
(((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_objz00_2363)))->BgL_z42builtinz42); 
BgL_res2280z00_2788 = 
(int)(
(long)(BgL_arg1417z00_2789)); } 
BgL_arg2202z00_2787 = BgL_res2280z00_2788; } 
BgL_arg2201z00_2786 = 
BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(
(long)(BgL_arg2202z00_2787), ((long)16)); } 
bgl_display_obj(BgL_arg2201z00_2786, BgL_portz00_2364); } 
{ /* Llib/uvtypes.scm 215 */
obj_t BgL_tmpz00_4725;
BgL_tmpz00_4725 = 
((obj_t)BgL_portz00_2364); 
bgl_display_string(BGl_string2457z00zz__libuv_typesz00, BgL_tmpz00_4725); } 
if(
BGl_nilzf3zf3zz__objectz00(
((BgL_objectz00_bglt)
((BgL_uvhandlez00_bglt)BgL_objz00_2363))))
{ /* Llib/uvtypes.scm 217 */
obj_t BgL_tmpz00_4732;
BgL_tmpz00_4732 = 
((obj_t)BgL_portz00_2364); 
return 
bgl_display_string(BGl_string2458z00zz__libuv_typesz00, BgL_tmpz00_4732);}  else 
{ 
long BgL_iz00_2791;
BgL_iz00_2791 = ((long)0); 
BgL_loopz00_2790:
if(
(BgL_iz00_2791==
VECTOR_LENGTH(BgL_fieldsz00_2784)))
{ /* Llib/uvtypes.scm 220 */
obj_t BgL_tmpz00_4738;
BgL_tmpz00_4738 = 
((obj_t)BgL_portz00_2364); 
return 
bgl_display_char(((unsigned char)'|'), BgL_tmpz00_4738);}  else 
{ /* Llib/uvtypes.scm 219 */
BgL_fieldz00_2773 = 
VECTOR_REF(BgL_fieldsz00_2784,BgL_iz00_2791); 
{ /* Llib/uvtypes.scm 196 */
obj_t BgL_namez00_2774;
BgL_namez00_2774 = 
BGl_classzd2fieldzd2namez00zz__objectz00(BgL_fieldz00_2773); 
{ /* Llib/uvtypes.scm 196 */
obj_t BgL_getzd2valuezd2_2775;
BgL_getzd2valuezd2_2775 = 
BGl_classzd2fieldzd2accessorz00zz__objectz00(BgL_fieldz00_2773); 
{ /* Llib/uvtypes.scm 197 */
obj_t BgL_sz00_2776;
{ /* Llib/uvtypes.scm 198 */
obj_t BgL_res2275z00_2777;
BgL_res2275z00_2777 = 
SYMBOL_TO_STRING(BgL_namez00_2774); 
BgL_sz00_2776 = BgL_res2275z00_2777; } 
{ /* Llib/uvtypes.scm 198 */

if(
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(
BCHAR(
STRING_REF(BgL_sz00_2776, ((long)0))), 
CNST_TABLE_REF(((long)70)))))
{ /* Llib/uvtypes.scm 199 */BFALSE; }  else 
{ /* Llib/uvtypes.scm 199 */
{ /* Llib/uvtypes.scm 200 */
obj_t BgL_tmpz00_4750;
BgL_tmpz00_4750 = 
((obj_t)BgL_portz00_2364); 
bgl_display_string(BGl_string2454z00zz__libuv_typesz00, BgL_tmpz00_4750); } 
bgl_display_obj(BgL_namez00_2774, BgL_portz00_2364); 
{ /* Llib/uvtypes.scm 202 */
obj_t BgL_tmpz00_4754;
BgL_tmpz00_4754 = 
((obj_t)BgL_portz00_2364); 
bgl_display_char(((unsigned char)':'), BgL_tmpz00_4754); } 
{ /* Llib/uvtypes.scm 203 */
obj_t BgL_tmpz00_4757;
BgL_tmpz00_4757 = 
((obj_t)BgL_portz00_2364); 
bgl_display_char(((unsigned char)' '), BgL_tmpz00_4757); } 
{ /* Llib/uvtypes.scm 204 */
obj_t BgL_arg2211z00_2778;
BgL_arg2211z00_2778 = 
PROCEDURE_ENTRY(BgL_getzd2valuezd2_2775)(BgL_getzd2valuezd2_2775, 
((obj_t)
((BgL_uvhandlez00_bglt)BgL_objz00_2363)), BEOA); 
{ /* Llib/uvtypes.scm 204 */
obj_t BgL_tmpz00_4771;
BgL_tmpz00_4771 = 
((obj_t)BgL_printzd2slotzd2_2365); 
PROCEDURE_ENTRY(BgL_tmpz00_4771)(
((obj_t)BgL_printzd2slotzd2_2365), BgL_arg2211z00_2778, BgL_portz00_2364, BEOA); } } 
{ /* Llib/uvtypes.scm 205 */
obj_t BgL_tmpz00_4773;
BgL_tmpz00_4773 = 
((obj_t)BgL_portz00_2364); 
bgl_display_char(((unsigned char)']'), BgL_tmpz00_4773); } } } } } } 
{ 
long BgL_iz00_4777;
BgL_iz00_4777 = 
(BgL_iz00_2791+((long)1)); 
BgL_iz00_2791 = BgL_iz00_4777; 
goto BgL_loopz00_2790;} } } } } } } } } 
BGL_FUNCTION_END;
}

#ifdef __cplusplus
}
#endif
