/*===========================================================================*/
/*   (Llib/midi.scm)                                                         */
/*   Bigloo (4.3f)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 04 Jul 2019 08:10:18 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo4.3f/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -I Llib -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -unsafe -safee -copt -fPIC -copt -IUnix Llib/midi.scm -o objs/midi.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

/* runtime code modification */
#define BGL_SELF_MODIFYING_CODE 0

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_midiscorez00_bgl {
   header_t header;
   obj_t widening;
   long BgL_formatz00;
   long BgL_tempoz00;
   long BgL_ppqz00;
   obj_t BgL_tracksz00;
} *BgL_midiscorez00_bglt;

typedef struct BgL_miditrackz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_z52streamz52;
   struct BgL_midireaderz00_bgl * BgL_z52readerz52;
   obj_t BgL_z52closez52;
   bool_t BgL_z52eotz52;
   uint32_t BgL_z52wtickz52;
   long BgL_z52statusz52;
   int32_t BgL_lenz00;
   long BgL_tempoz00;
   obj_t BgL_ipz00;
   long BgL_startz00;
   long BgL_datastartz00;
   uint32_t BgL_wtickz00;
   long BgL_statusz00;
   bool_t BgL_eotz00;
} *BgL_miditrackz00_bglt;

typedef struct BgL_midireaderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_peekzd2bytezd2;
   obj_t BgL_readzd2bytezd2;
   obj_t BgL_readzd2int16zd2;
   obj_t BgL_readzd2int32zd2;
   obj_t BgL_readzd2intzd2;
   obj_t BgL_readzd2vlqzd2;
   obj_t BgL_readzd2charszd2;
} *BgL_midireaderz00_bglt;

typedef struct BgL_midiplayerz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_errz00;
   obj_t BgL_cdelayz00;
   obj_t BgL_noteoffz00;
   obj_t BgL_noteonz00;
   obj_t BgL_aftertouchz00;
   obj_t BgL_ctrlchangez00;
   obj_t BgL_prgmchangez00;
   obj_t BgL_afterzd2touchzd2;
   obj_t BgL_pitchz00;
   obj_t BgL_sysexz00;
   obj_t BgL_metazd2seqnumzd2;
   obj_t BgL_metazd2textzd2;
   obj_t BgL_metazd2copyrightzd2;
   obj_t BgL_metazd2trackzd2;
   obj_t BgL_metazd2instrumentzd2;
   obj_t BgL_metazd2lyriczd2;
   obj_t BgL_metazd2markerzd2;
   obj_t BgL_metazd2cuezd2;
   obj_t BgL_metazd2prgmnamezd2;
   obj_t BgL_metazd2devnamezd2;
   obj_t BgL_metazd2channprefzd2;
   obj_t BgL_metazd2midiportzd2;
   obj_t BgL_metazd2eotzd2;
   obj_t BgL_metazd2tempozd2;
   obj_t BgL_metazd2smtpezd2;
   obj_t BgL_metazd2timesigzd2;
   obj_t BgL_metazd2keysigzd2;
   obj_t BgL_metazd2seqspeczd2;
} *BgL_midiplayerz00_bglt;

typedef struct BgL_midisinkz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_streamz00;
   obj_t BgL_usleepz00;
   obj_t BgL_writezd2bytezd2;
   obj_t BgL_writezd2stringzd2;
   obj_t BgL_flushz00;
} *BgL_midisinkz00_bglt;


static obj_t BGl_z62lambda2496z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2497z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midizd2controllerzd2namez00zz__multimediazd2midizd2(long);
static obj_t BGl_midizd2readzd2mthdz00zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza32124ze3ze1zz__multimediazd2midizd2(obj_t);
static long BGl_readzd2intzd2zz__multimediazd2midizd2(long, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midisinkzd2initzd2zz__multimediazd2midizd2(BgL_midisinkz00_bglt);
BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
static obj_t BGl_z62midiplayerzd2pitchzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT bool_t bigloo_strcicmp(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32215ze3ze1zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2noteoffzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
static obj_t BGl_z62zc3anonymousza32321ze3ze1zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DEF obj_t BGl_midiscorez00zz__multimediazd2midizd2 = BUNSPEC;
static BgL_midiscorez00_bglt BGl_z62midiscorezd2filezb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2int16zb0zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_setzd2inputzd2portzd2positionz12zc0zz__r4_ports_6_10_1z00(obj_t, long);
static obj_t BGl_z62zc3anonymousza32412ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza31270ze3ze1zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32307ze3ze1zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2ctrlchangezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
static obj_t BGl_z62zc3anonymousza31271ze3ze1zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midizd2programzd2namez00zz__multimediazd2midizd2(long);
static obj_t BGl_objectzd2initzd2zz__multimediazd2midizd2();
static int32_t BGl_readzd2int16zd2zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2int32zb0zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_2zb2zb2zz__r4_numbers_6_5z00(obj_t, obj_t);
static BgL_miditrackz00_bglt BGl_z62miditrackzd2filezb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32236ze3ze1zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DEF obj_t BGl_midireaderz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza32180ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza32342ze3ze1zz__multimediazd2midizd2(obj_t);
static int32_t BGl_readzd2int32zd2zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62readzd2int16zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_miditrackzd2waitzd2eventz00zz__multimediazd2midizd2(BgL_miditrackz00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long);
static obj_t BGl_z62zc3anonymousza32254ze3ze1zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32149ze3ze1zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2ctrlchangezb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62midireaderzd2init1233zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32433ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza32328ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_midizd2controllerzd2namesz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_midizd2readzd2mtrkz00zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62readzd2int32zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__multimediazd2midizd2();
static obj_t BGl_z62zc3anonymousza32523ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza32419ze3ze1zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DEF obj_t BGl_midisinkz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza32363ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza32509ze3ze1zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2cdelayzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2afterzd2touchz00zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32454ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza32187ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza32349ze3ze1zz__multimediazd2midizd2(obj_t);
static BgL_midiscorez00_bglt BGl_z62lambda2107z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62midiscorezd2init1229zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2vlqzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2init1235zb0zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_midiscorez00_bglt BGl_z62lambda2110z62zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2116z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2117z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midireaderzd2initzd2zz__multimediazd2midizd2(BgL_midireaderz00_bglt);
static obj_t BGl_z62lambda2122z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2123z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32384ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza32546ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2129z62zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2130z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2136z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2137z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static long BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2305z62zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_miditrackz00_bglt BGl_z62lambda2144z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2306z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32491ze3ze1zz__multimediazd2midizd2(obj_t);
static BgL_miditrackz00_bglt BGl_z62lambda2147z62zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza32475ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62midisinkzd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiscorezd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t create_struct(obj_t, int);
static obj_t BGl_z62lambda2312z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2313z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2154z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2155z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2319z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32476ze3ze1zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2320z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__multimediazd2midizd2();
static BgL_midireaderz00_bglt BGl_z62lambda2160z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2161z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2326z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2165z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2327z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2166z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2171z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2333z62zz__multimediazd2midizd2(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2aftertouchzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
static obj_t BGl_z62lambda2172z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2334z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31676ze3ze1zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2178z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2179z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62miditrackzd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2afterzd2touchz62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2340z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2341z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static BgL_midisinkz00_bglt BGl_z62lambda2504z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62midizd2programzd2indexz62zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_midisinkz00_bglt BGl_z62lambda2507z62zz__multimediazd2midizd2(obj_t);
static obj_t BGl_midizd2textzd2namesz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_z62lambda2185z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2347z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2intzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2186z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2348z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31677ze3ze1zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2charszb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2514z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2515z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2192z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2354z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2193z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2355z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2199z62zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t c_substring(obj_t, long, long);
static obj_t BGl_z62lambda2521z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2522z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2361z62zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_midireaderz00_bglt BGl_midireaderzd2stringzd2streamz00zz__multimediazd2midizd2;
static obj_t BGl_z62lambda2362z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2528z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2529z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2368z62zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readzd2charszd2zz__r4_input_6_10_2z00(obj_t, obj_t);
static obj_t BGl_z62lambda2369z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2pitchzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
static obj_t BGl_z62lambda2536z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2375z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2537z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2aftertouchzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2376z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32498ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_midizd2notezd2namesz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza32201ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza32112ze3ze1zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2382z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2544z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2383z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2545z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2389z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2390z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2396z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2397z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2noteonzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT bool_t bigloo_strcmp(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2sysexzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32131ze3ze1zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_midizd2notezd2namez00zz__multimediazd2midizd2(long);
static BgL_midisinkz00_bglt BGl_midisinkzd2nullzd2zz__multimediazd2midizd2;
static obj_t BGl_z62zc3anonymousza32222ze3ze1zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2cdelayzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, BgL_miditrackz00_bglt, long, long, long);
static obj_t BGl_requirezd2initializa7ationz75zz__multimediazd2midizd2 = BUNSPEC;
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32208ze3ze1zz__multimediazd2midizd2(obj_t);
BGL_IMPORT obj_t BGl_writezd2stringzd2zz__r4_output_6_10_3z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2prgmchangezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long);
BGL_IMPORT obj_t BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(obj_t);
static BgL_miditrackz00_bglt BGl_z62miditrackzd2stringzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiscorezd2playzd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt);
static obj_t BGl_z62stringzd2streamzd2peekzd2bytezb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__multimediazd2midizd2();
static obj_t BGl_z62zc3anonymousza32314ze3ze1zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DEF obj_t BGl_midiplayerz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_midizd2programzd2namesz00zz__multimediazd2midizd2 = BUNSPEC;
BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
static obj_t BGl_miditrackszd2inputzd2portz00zz__multimediazd2midizd2(obj_t, long, obj_t);
static obj_t BGl_genericzd2initzd2zz__multimediazd2midizd2();
BGL_EXPORTED_DECL obj_t BGl_midizd2programzd2indexz00zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza32243ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza32405ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza31263ze3ze1zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32138ze3ze1zz__multimediazd2midizd2(obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31264ze3ze1zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
static obj_t BGl_z62midiplayerzd2prgmchangezb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(BgL_miditrackz00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, BGL_LONGLONG_T);
static obj_t BGl_z62zc3anonymousza31532ze3ze1zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32156ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza31265ze3ze1zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32229ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza32440ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza31533ze3ze1zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32173ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza32335ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza31266ze3ze1zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_miditrackz00zz__multimediazd2midizd2 = BUNSPEC;
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2ignorezb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL BgL_midiscorez00_bglt BGl_midiscorezd2filezd2zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza32530ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza31267ze3ze1zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readzd2charzd2zz__r4_input_6_10_2z00(obj_t);
static obj_t BGl_z62zc3anonymousza32531ze3ze1zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32426ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza31268ze3ze1zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32370ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza32516ze3ze1zz__multimediazd2midizd2(obj_t);
static bool_t BGl_midiscorezd2play0zd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt);
static bool_t BGl_midiscorezd2play1zd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt);
static obj_t BGl_z62zc3anonymousza31269ze3ze1zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL BgL_miditrackz00_bglt BGl_miditrackzd2filezd2zz__multimediazd2midizd2(obj_t, long, long);
static obj_t BGl_z62zc3anonymousza31553ze3ze1zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32461ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza31554ze3ze1zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32194ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza32356ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62readzd2vlqzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31555ze3ze1zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_IMPORT BGL_LONGLONG_T bgl_current_microseconds();
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2initzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt);
static obj_t BGl_z62zc3anonymousza32447ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza31556ze3ze1zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_midiplayerz00_bglt BGl_midiplayerzd2readzd2zz__multimediazd2midizd2;
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static obj_t BGl_z62zc3anonymousza32391ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62midireaderzd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2200z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static BgL_miditrackz00_bglt BGl_z62miditrackzd2inputzd2portz62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2noteonzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
static obj_t BGl_z62lambda2206z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2207z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32538ze3ze1zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2midizd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__datez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
static obj_t BGl_z62midizd2programzd2namez62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2213z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2214z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32377ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3anonymousza32539ze3ze1zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL BgL_miditrackz00_bglt BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(obj_t, long);
static obj_t BGl_z62lambda2220z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2221z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2227z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32483ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62midiplayerzd2noteoffzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2228z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62midisinkzd2init1237zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2234z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2235z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32484ze3ze1zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32468ze3ze1zz__multimediazd2midizd2(obj_t);
static obj_t BGl_cnstzd2initzd2zz__multimediazd2midizd2();
static obj_t BGl_libraryzd2moduleszd2initz00zz__multimediazd2midizd2();
static obj_t BGl_z62lambda2241z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2403z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2242z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2404z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static BgL_midireaderz00_bglt BGl_z62lambda2249z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62readzd2intzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2410z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2411z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static BgL_midireaderz00_bglt BGl_z62lambda2252z62zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2417z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2418z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_objectz00zz__objectz00;
static obj_t BGl_z62lambda2258z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2259z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62miditrackzd2init1231zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2424z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2263z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2425z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2264z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2268z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32398ze3ze1zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2sysexzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, obj_t);
static obj_t BGl_z62lambda2269z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2bytezb0zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
static obj_t BGl_z62lambda2431z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2432z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2273z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2274z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2438z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2439z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2278z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midizd2notezd2namez62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2279z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2283z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2445z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2284z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2446z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2288z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2289z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiscorezd2initzd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt);
BGL_IMPORT obj_t BGl_callzd2withzd2inputzd2filezd2zz__r4_ports_6_10_1z00(obj_t, obj_t);
static obj_t BGl_z62lambda2452z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2453z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static BgL_midiplayerz00_bglt BGl_z62lambda2295z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2459z62zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_midiplayerz00_bglt BGl_z62lambda2298z62zz__multimediazd2midizd2(obj_t);
static BgL_midireaderz00_bglt BGl_midireaderzd2inputzd2portz00zz__multimediazd2midizd2;
static obj_t BGl_z62lambda2460z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2466z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2467z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2473z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2474z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_miditrackzd2initzd2zz__multimediazd2midizd2(BgL_miditrackz00_bglt);
BGL_EXPORTED_DECL BgL_miditrackz00_bglt BGl_miditrackzd2stringzd2zz__multimediazd2midizd2(obj_t, long);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2ignorezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, obj_t);
static obj_t BGl_z62zc3anonymousza32300ze3ze1zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midizd2controllerzd2namez62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiscorezd2playzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2481z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2482z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2489z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2490z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t __cnst[ 76 ] ;


BGL_IMPORT obj_t BGl_peekzd2bytezd2envz00zz__r4_input_6_10_2z00;
DEFINE_EXPORT_BGL_GENERIC( BGl_miditrackzd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2i3317z00, BGl_z62miditrackzd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3114z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2117za7623318z00, BGl_z62lambda2117z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3115z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2116za7623319z00, BGl_z62lambda2116z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3116z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73320za7, BGl_z62zc3anonymousza32124ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3117z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2123za7623321z00, BGl_z62lambda2123z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3118z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2122za7623322z00, BGl_z62lambda2122z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3119z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73323za7, BGl_z62zc3anonymousza32131ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_GENERIC( BGl_midisinkzd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midisinkza7d2in3324z00, BGl_z62midisinkzd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3120z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2130za7623325z00, BGl_z62lambda2130z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3121z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2129za7623326z00, BGl_z62lambda2129z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3122z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73327za7, BGl_z62zc3anonymousza32138ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3123z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2137za7623328z00, BGl_z62lambda2137z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3124z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2136za7623329z00, BGl_z62lambda2136z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3125z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73330za7, BGl_z62zc3anonymousza32112ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3126z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2110za7623331z00, BGl_z62lambda2110z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3127z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2107za7623332z00, BGl_z62lambda2107z62zz__multimediazd2midizd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3128z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73333za7, BGl_z62zc3anonymousza32156ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3129z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2155za7623334z00, BGl_z62lambda2155z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2ctrlchangezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23335z00, BGl_z62midiplayerzd2ctrlchangezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3130z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2154za7623336z00, BGl_z62lambda2154z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3131z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2161za7623337z00, BGl_z62lambda2161z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3132z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2160za7623338z00, BGl_z62lambda2160z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3133z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2166za7623339z00, BGl_z62lambda2166z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3134z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2165za7623340z00, BGl_z62lambda2165z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3135z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73341za7, BGl_z62zc3anonymousza32173ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3060z00zz__multimediazd2midizd2, BgL_bgl_string3060za700za7za7_3342za7, "midiscore-file", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3136z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2172za7623343z00, BGl_z62lambda2172z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3061z00zz__multimediazd2midizd2, BgL_bgl_string3061za700za7za7_3344za7, "format not supported", 20 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3137z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2171za7623345z00, BGl_z62lambda2171z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3062z00zz__multimediazd2midizd2, BgL_bgl_string3062za700za7za7_3346za7, "midiplayer-file", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3138z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73347za7, BGl_z62zc3anonymousza32180ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3063z00zz__multimediazd2midizd2, BgL_bgl_string3063za700za7za7_3348za7, "bad midi format", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3139z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2179za7623349z00, BGl_z62lambda2179z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3064z00zz__multimediazd2midizd2, BgL_bgl_string3064za700za7za7_3350za7, "/builddir/build/BUILD/bigloo4.3f/api/multimedia/src/Llib/midi.scm", 65 );
DEFINE_STRING( BGl_string3065z00zz__multimediazd2midizd2, BgL_bgl_string3065za700za7za7_3351za7, "&midiscore-file", 15 );
DEFINE_STRING( BGl_string3066z00zz__multimediazd2midizd2, BgL_bgl_string3066za700za7za7_3352za7, "bstring", 7 );
DEFINE_STRING( BGl_string3067z00zz__multimediazd2midizd2, BgL_bgl_string3067za700za7za7_3353za7, "&miditrack-input-port", 21 );
DEFINE_STRING( BGl_string3068z00zz__multimediazd2midizd2, BgL_bgl_string3068za700za7za7_3354za7, "input-port", 10 );
DEFINE_STRING( BGl_string3069z00zz__multimediazd2midizd2, BgL_bgl_string3069za700za7za7_3355za7, "bint", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3301z00zz__multimediazd2midizd2, BgL_bgl_za762midireaderza7d23356z00, BGl_z62midireaderzd2init1233zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3140z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2178za7623357z00, BGl_z62lambda2178z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3303z00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23358z00, BGl_z62midiplayerzd2init1235zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3141z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73359za7, BGl_z62zc3anonymousza32187ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3142z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2186za7623360z00, BGl_z62lambda2186z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3305z00zz__multimediazd2midizd2, BgL_bgl_za762midisinkza7d2in3361z00, BGl_z62midisinkzd2init1237zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3143z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2185za7623362z00, BGl_z62lambda2185z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3144z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73363za7, BGl_z62zc3anonymousza32194ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3145z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2193za7623364z00, BGl_z62lambda2193z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3070z00zz__multimediazd2midizd2, BgL_bgl_string3070za700za7za7_3365za7, "&miditrack-file", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3146z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2192za7623366z00, BGl_z62lambda2192z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3147z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73367za7, BGl_z62zc3anonymousza32201ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3072z00zz__multimediazd2midizd2, BgL_bgl_string3072za700za7za7_3368za7, "&miditrack-string", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3148z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2200za7623369z00, BGl_z62lambda2200z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3073z00zz__multimediazd2midizd2, BgL_bgl_string3073za700za7za7_3370za7, "midiscore-play", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3149z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2199za7623371z00, BGl_z62lambda2199z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3074z00zz__multimediazd2midizd2, BgL_bgl_string3074za700za7za7_3372za7, "&midiscore-play", 15 );
DEFINE_STRING( BGl_string3075z00zz__multimediazd2midizd2, BgL_bgl_string3075za700za7za7_3373za7, "midiscore", 9 );
DEFINE_STRING( BGl_string3076z00zz__multimediazd2midizd2, BgL_bgl_string3076za700za7za7_3374za7, "midiplayer", 10 );
DEFINE_STRING( BGl_string3077z00zz__multimediazd2midizd2, BgL_bgl_string3077za700za7za7_3375za7, "midisink", 8 );
DEFINE_STRING( BGl_string3078z00zz__multimediazd2midizd2, BgL_bgl_string3078za700za7za7_3376za7, "~x:~x", 5 );
DEFINE_STRING( BGl_string3079z00zz__multimediazd2midizd2, BgL_bgl_string3079za700za7za7_3377za7, "midiplay", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3150z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73378za7, BGl_z62zc3anonymousza32208ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3151z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2207za7623379z00, BGl_z62lambda2207z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3152z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2206za7623380z00, BGl_z62lambda2206z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3153z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73381za7, BGl_z62zc3anonymousza32215ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3154z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2214za7623382z00, BGl_z62lambda2214z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3155z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2213za7623383z00, BGl_z62lambda2213z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3080z00zz__multimediazd2midizd2, BgL_bgl_string3080za700za7za7_3384za7, "illegal meta-event", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3156z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73385za7, BGl_z62zc3anonymousza32222ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3081z00zz__multimediazd2midizd2, BgL_bgl_string3081za700za7za7_3386za7, "illegal event", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3157z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2221za7623387z00, BGl_z62lambda2221z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3082z00zz__multimediazd2midizd2, BgL_bgl_string3082za700za7za7_3388za7, "MThd", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3158z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2220za7623389z00, BGl_z62lambda2220z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3083z00zz__multimediazd2midizd2, BgL_bgl_string3083za700za7za7_3390za7, "read-midi-mthd", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3159z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73391za7, BGl_z62zc3anonymousza32229ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3084z00zz__multimediazd2midizd2, BgL_bgl_string3084za700za7za7_3392za7, "invalid number of SMPTE frames per second", 41 );
DEFINE_STRING( BGl_string3085z00zz__multimediazd2midizd2, BgL_bgl_string3085za700za7za7_3393za7, "Bad header", 10 );
DEFINE_STRING( BGl_string3086z00zz__multimediazd2midizd2, BgL_bgl_string3086za700za7za7_3394za7, "MTrk", 4 );
DEFINE_STRING( BGl_string3087z00zz__multimediazd2midizd2, BgL_bgl_string3087za700za7za7_3395za7, "read-midi-mtrk", 14 );
DEFINE_STRING( BGl_string3088z00zz__multimediazd2midizd2, BgL_bgl_string3088za700za7za7_3396za7, "&read-int", 9 );
DEFINE_STRING( BGl_string3089z00zz__multimediazd2midizd2, BgL_bgl_string3089za700za7za7_3397za7, "&string-stream-peek-byte", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_readzd2vlqzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762readza7d2vlqza7b03398za7, BGl_z62readzd2vlqzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3160z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2228za7623399z00, BGl_z62lambda2228z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3161z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2227za7623400z00, BGl_z62lambda2227z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3162z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73401za7, BGl_z62zc3anonymousza32236ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3163z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2235za7623402z00, BGl_z62lambda2235z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3164z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2234za7623403z00, BGl_z62lambda2234z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3165z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73404za7, BGl_z62zc3anonymousza32243ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3090z00zz__multimediazd2midizd2, BgL_bgl_string3090za700za7za7_3405za7, "struct", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3166z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2242za7623406z00, BGl_z62lambda2242z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3091z00zz__multimediazd2midizd2, BgL_bgl_string3091za700za7za7_3407za7, "&string-stream-read-byte", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3167z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2241za7623408z00, BGl_z62lambda2241z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3092z00zz__multimediazd2midizd2, BgL_bgl_string3092za700za7za7_3409za7, "&string-stream-read-int16", 25 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3168z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73410za7, BGl_z62zc3anonymousza32149ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3093z00zz__multimediazd2midizd2, BgL_bgl_string3093za700za7za7_3411za7, "&string-stream-read-int32", 25 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3169z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2147za7623412z00, BGl_z62lambda2147z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3094z00zz__multimediazd2midizd2, BgL_bgl_string3094za700za7za7_3413za7, "&string-stream-read-int", 23 );
DEFINE_STRING( BGl_string3095z00zz__multimediazd2midizd2, BgL_bgl_string3095za700za7za7_3414za7, "&string-stream-read-chars", 25 );
DEFINE_STRING( BGl_string3096z00zz__multimediazd2midizd2, BgL_bgl_string3096za700za7za7_3415za7, "&midiplayer-cdelay", 18 );
DEFINE_STRING( BGl_string3097z00zz__multimediazd2midizd2, BgL_bgl_string3097za700za7za7_3416za7, "miditrack", 9 );
DEFINE_STRING( BGl_string3098z00zz__multimediazd2midizd2, BgL_bgl_string3098za700za7za7_3417za7, "&midiplayer-ignore", 18 );
DEFINE_STRING( BGl_string3099z00zz__multimediazd2midizd2, BgL_bgl_string3099za700za7za7_3418za7, "&midiplayer-noteoff", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3170z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2144za7623419z00, BGl_z62lambda2144z62zz__multimediazd2midizd2, 0L, BUNSPEC, 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3171z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2259za7623420z00, BGl_z62lambda2259z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3172z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2258za7623421z00, BGl_z62lambda2258z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3173z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2264za7623422z00, BGl_z62lambda2264z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3174z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2263za7623423z00, BGl_z62lambda2263z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3175z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2269za7623424z00, BGl_z62lambda2269z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3176z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2268za7623425z00, BGl_z62lambda2268z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3177z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2274za7623426z00, BGl_z62lambda2274z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3178z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2273za7623427z00, BGl_z62lambda2273z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3179z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2279za7623428z00, BGl_z62lambda2279z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2vlqzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3429z00, BGl_z62stringzd2streamzd2readzd2vlqzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3180z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2278za7623430z00, BGl_z62lambda2278z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3181z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2284za7623431z00, BGl_z62lambda2284z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3182z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2283za7623432z00, BGl_z62lambda2283z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3183z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2289za7623433z00, BGl_z62lambda2289z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3184z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2288za7623434z00, BGl_z62lambda2288z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3185z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73435za7, BGl_z62zc3anonymousza32254ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3186z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2252za7623436z00, BGl_z62lambda2252z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3187z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2249za7623437z00, BGl_z62lambda2249z62zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3188z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73438za7, BGl_z62zc3anonymousza32307ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3189z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2306za7623439z00, BGl_z62lambda2306z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiscorezd2playzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiscoreza7d2p3440z00, BGl_z62midiscorezd2playzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3190z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2305za7623441z00, BGl_z62lambda2305z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3191z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73442za7, BGl_z62zc3anonymousza32314ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3192z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2313za7623443z00, BGl_z62lambda2313z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3193z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2312za7623444z00, BGl_z62lambda2312z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3194z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73445za7, BGl_z62zc3anonymousza32321ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3195z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2320za7623446z00, BGl_z62lambda2320z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3196z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2319za7623447z00, BGl_z62lambda2319z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3197z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73448za7, BGl_z62zc3anonymousza32328ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3198z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2327za7623449z00, BGl_z62lambda2327z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3199z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2326za7623450z00, BGl_z62lambda2326z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_readzd2int32zd2envz00zz__multimediazd2midizd2, BgL_bgl_za762readza7d2int32za73451za7, BGl_z62readzd2int32zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3298z00zz__multimediazd2midizd2, BgL_bgl_string3298za700za7za7_3452za7, "midiscore-init1229", 18 );
DEFINE_EXPORT_BGL_GENERIC( BGl_midireaderzd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midireaderza7d23453z00, BGl_z62midireaderzd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_miditrackzd2stringzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2s3454z00, BGl_z62miditrackzd2stringzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midizd2notezd2namezd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiza7d2noteza7d3455za7, BGl_z62midizd2notezd2namez62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2pitchzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23456z00, BGl_z62midiplayerzd2pitchzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2noteonzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23457z00, BGl_z62midiplayerzd2noteonzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_readzd2int16zd2envz00zz__multimediazd2midizd2, BgL_bgl_za762readza7d2int16za73458za7, BGl_z62readzd2int16zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_midiplayerzd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23459z00, BGl_z62midiplayerzd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_errorzd2envzd2zz__errorz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2noteoffzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23460z00, BGl_z62midiplayerzd2noteoffzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_EXPORT_BGL_GENERIC( BGl_midiscorezd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiscoreza7d2i3461z00, BGl_z62midiscorezd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_closezd2inputzd2portzd2envzd2zz__r4_ports_6_10_1z00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_miditrackzd2filezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2f3462z00, BGl_z62miditrackzd2filezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23463z00, BGl_z62midiplayerzd2ignorezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3100z00zz__multimediazd2midizd2, BgL_bgl_string3100za700za7za7_3464za7, "&midiplayer-noteon", 18 );
DEFINE_STRING( BGl_string3101z00zz__multimediazd2midizd2, BgL_bgl_string3101za700za7za7_3465za7, "&midiplayer-aftertouch", 22 );
DEFINE_STRING( BGl_string3102z00zz__multimediazd2midizd2, BgL_bgl_string3102za700za7za7_3466za7, "&midiplayer-ctrlchange", 22 );
DEFINE_STRING( BGl_string3103z00zz__multimediazd2midizd2, BgL_bgl_string3103za700za7za7_3467za7, "&midiplayer-prgmchange", 22 );
DEFINE_STRING( BGl_string3104z00zz__multimediazd2midizd2, BgL_bgl_string3104za700za7za7_3468za7, "&midiplayer-after-touch", 23 );
DEFINE_STRING( BGl_string3105z00zz__multimediazd2midizd2, BgL_bgl_string3105za700za7za7_3469za7, "&midiplayer-pitch", 17 );
DEFINE_STRING( BGl_string3106z00zz__multimediazd2midizd2, BgL_bgl_string3106za700za7za7_3470za7, "&midiplayer-sysex", 17 );
DEFINE_STRING( BGl_string3107z00zz__multimediazd2midizd2, BgL_bgl_string3107za700za7za7_3471za7, "~a[~a]", 6 );
DEFINE_STRING( BGl_string3108z00zz__multimediazd2midizd2, BgL_bgl_string3108za700za7za7_3472za7, "&midi-note-name", 15 );
DEFINE_STRING( BGl_string3109z00zz__multimediazd2midizd2, BgL_bgl_string3109za700za7za7_3473za7, "unknown controller", 18 );
BGL_IMPORT obj_t BGl_readzd2charszd2envz00zz__r4_input_6_10_2z00;
DEFINE_STRING( BGl_string3110z00zz__multimediazd2midizd2, BgL_bgl_string3110za700za7za7_3474za7, "&midi-controller-name", 21 );
DEFINE_STRING( BGl_string3111z00zz__multimediazd2midizd2, BgL_bgl_string3111za700za7za7_3475za7, "unknown program", 15 );
DEFINE_STRING( BGl_string3112z00zz__multimediazd2midizd2, BgL_bgl_string3112za700za7za7_3476za7, "&midi-program-name", 18 );
DEFINE_STRING( BGl_string3113z00zz__multimediazd2midizd2, BgL_bgl_string3113za700za7za7_3477za7, "&midi-program-index", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3200z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73478za7, BGl_z62zc3anonymousza32335ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3201z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2334za7623479z00, BGl_z62lambda2334z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3202z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2333za7623480z00, BGl_z62lambda2333z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3203z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73481za7, BGl_z62zc3anonymousza32342ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3204z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2341za7623482z00, BGl_z62lambda2341z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3205z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2340za7623483z00, BGl_z62lambda2340z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3206z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73484za7, BGl_z62zc3anonymousza32349ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3207z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2348za7623485z00, BGl_z62lambda2348z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3045z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73486za7, BGl_z62zc3anonymousza31263ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3208z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2347za7623487z00, BGl_z62lambda2347z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3046z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73488za7, BGl_z62zc3anonymousza31264ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3209z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73489za7, BGl_z62zc3anonymousza32356ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3047z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73490za7, BGl_z62zc3anonymousza31265ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3048z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73491za7, BGl_z62zc3anonymousza31266ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3049z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73492za7, BGl_z62zc3anonymousza31267ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3210z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2355za7623493z00, BGl_z62lambda2355z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3211z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2354za7623494z00, BGl_z62lambda2354z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3212z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73495za7, BGl_z62zc3anonymousza32363ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3050z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73496za7, BGl_z62zc3anonymousza31268ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string3300z00zz__multimediazd2midizd2, BgL_bgl_string3300za700za7za7_3497za7, "miditrack-init1231", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3213z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2362za7623498z00, BGl_z62lambda2362z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3051z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73499za7, BGl_z62zc3anonymousza31269ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3214z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2361za7623500z00, BGl_z62lambda2361z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3052z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73501za7, BGl_z62zc3anonymousza31270ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STRING( BGl_string3302z00zz__multimediazd2midizd2, BgL_bgl_string3302za700za7za7_3502za7, "midireader-init1233", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3215z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73503za7, BGl_z62zc3anonymousza32370ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3053z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73504za7, BGl_z62zc3anonymousza31271ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3216z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2369za7623505z00, BGl_z62lambda2369z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3054z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73506za7, BGl_z62zc3anonymousza31532ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 8 );
DEFINE_STRING( BGl_string3304z00zz__multimediazd2midizd2, BgL_bgl_string3304za700za7za7_3507za7, "midiplayer-init1235", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3217z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2368za7623508z00, BGl_z62lambda2368z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3055z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73509za7, BGl_z62zc3anonymousza31533ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3218z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73510za7, BGl_z62zc3anonymousza32377ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3056z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73511za7, BGl_z62zc3anonymousza31553ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3306z00zz__multimediazd2midizd2, BgL_bgl_string3306za700za7za7_3512za7, "midisink-init1237", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3219z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2376za7623513z00, BGl_z62lambda2376z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3057z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73514za7, BGl_z62zc3anonymousza31554ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3307z00zz__multimediazd2midizd2, BgL_bgl_string3307za700za7za7_3515za7, "&midiscore-init", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3058z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73516za7, BGl_z62zc3anonymousza31555ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3308z00zz__multimediazd2midizd2, BgL_bgl_string3308za700za7za7_3517za7, "&miditrack-init", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3059z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73518za7, BGl_z62zc3anonymousza31556ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3309z00zz__multimediazd2midizd2, BgL_bgl_string3309za700za7za7_3519za7, "&midireader-init", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3220z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2375za7623520z00, BGl_z62lambda2375z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3221z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73521za7, BGl_z62zc3anonymousza32384ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3222z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2383za7623522z00, BGl_z62lambda2383z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3310z00zz__multimediazd2midizd2, BgL_bgl_string3310za700za7za7_3523za7, "midireader", 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3223z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2382za7623524z00, BGl_z62lambda2382z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3311z00zz__multimediazd2midizd2, BgL_bgl_string3311za700za7za7_3525za7, "&midiplayer-init", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3224z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73526za7, BGl_z62zc3anonymousza32391ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3312z00zz__multimediazd2midizd2, BgL_bgl_string3312za700za7za7_3527za7, "&midisink-init", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3225z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2390za7623528z00, BGl_z62lambda2390z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3313z00zz__multimediazd2midizd2, BgL_bgl_string3313za700za7za7_3529za7, "#() midisink flush write-string write-byte usleep stream midiplayer meta-seqspec meta-keysig meta-timesig meta-smtpe meta-tempo meta-eot meta-midiport meta-channpref meta-devname meta-prgmname meta-cue meta-marker meta-lyric meta-instrument meta-track meta-copyright meta-text meta-seqnum sysex pitch after-touch prgmchange ctrlchange aftertouch noteon noteoff cdelay err midireader read-chars read-vlq read-int read-int32 read-int16 read-byte peek-byte miditrack eot status wtick datastart start ip int32 len %status uint32 %wtick bool %eot procedure %close %reader obj %stream __multimedia-midi midiscore vector tracks ppq tempo long format string-stream #(\"C\" \"C#\" \"D\" \"D#\" \"E\" \"F\" \"F#\" \"G\" \"G#\" \"A\" \"A#\" \"B\") #(\"\" \"Acoustic Grand Piano\" \"Bright Acoustic Piano\" \"Electric Grand Piano\" \"Honky-tonk Piano\" \"Electric Piano 1\" \"Electric Piano 2\" \"Harpsichord\" \"Clavinet\" \"Celesta\" \"Glockenspiel\" \"Music Box\" \"Vibraphone\" \"Marimba\" \"Xylophone\" \"Tubular Bells\" \"Dulcimer"
"\" \"Drawbar Organ\" \"Percussive Organ\" \"Rock Organ\" \"Church Organ\" \"Reed Organ\" \"Accordion\" \"Harmonica\" \"Tango Accordion\" \"Acoustic Guitar (nylon)\" \"Acoustic Guitar (steel)\" \"Electric Guitar (jazz)\" \"Electric Guitar (clean)\" \"Electric Guitar (muted)\" \"Overdriven Guitar\" \"Distortion Guitar\" \"Guitar harmonics\" \"Acoustic Bass\" \"Electric Bass (finger)\" \"Electric Bass (pick)\" \"Fretless Bass\" \"Slap Bass 1\" \"Slap Bass 2\" \"Synth Bass 1\" \"Synth Bass 2\" \"Violin\" \"Viola\" \"Cello\" \"Contrabass\" \"Tremolo Strings\" \"Pizzicato Strings\" \"Orchestral Harp\" \"Timpani\" \"String Ensemble 1\" \"String Ensemble 2\" \"Synth Strings 1\" \"Synth Strings 2\" \"Choir Aahs\" \"Voice Oohs\" \"Synth Voice\" \"Orchestra Hit\" \"Trumpet\" \"Trombone\" \"Tuba\" \"Muted Trumpet\" \"French Horn\" \"Brass Section\" \"Synth Brass 1\" \"Synth Brass 2\" \"Soprano Sax\" \"Alto Sax\" \"Tenor Sax\" \"Baritone Sax\" \"Oboe\" \"English Horn\" \"Bassoon\" \"Clarinet\" \"Piccolo\" \"Flute\" \"Reco"
"rder\" \"Pan Flute\" \"Blown Bottle\" \"Shakuhachi\" \"Whistle\" \"Ocarina\" \"Lead 1 (square)\" \"Lead 2 (sawtooth)\" \"Lead 3 (calliope)\" \"Lead 4 (chiff)\" \"Lead 5 (charang)\" \"Lead 6 (voice)\" \"Lead 7 (fifths)\" \"Lead 8 (bass + lead)\" \"Pad 1 (new age)\" \"Pad 2 (warm)\" \"Pad 3 (polysynth)\" \"Pad 4 (choir)\" \"Pad 5 (bowed)\" \"Pad 6 (metallic)\" \"Pad 7 (halo)\" \"Pad 8 (sweep)\" \"FX 1 (rain)\" \"FX 2 (soundtrack)\" \"FX 3 (crystal)\" \"FX 4 (atmosphere)\" \"FX 5 (brightness)\" \"FX 6 (goblins)\" \"FX 7 (echoes)\" \"FX 8 (sci-fi)\" \"Sitar\" \"Banjo\" \"Shamisen\" \"Koto\" \"Kalimba\" \"Bag pipe\" \"Fiddle\" \"Shanai\" \"Tinkle Bell\" \"Agogo\" \"Steel Drums\" \"Woodblock\" \"Taiko Drum\" \"Melodic Tom\" \"Synth Drum\" \"Reverse Cymbal\" \"Guitar Fret Noise\" \"Breath Noise\" \"Seashore\" \"Bird Tweet\" \"Telephone Ring\" \"Helicopter\" \"Applause\" \"Gunshot\") #(\"Bank Select\" \"Modulation Wheel or Lever\" \"Breath Controller\" \"Undefined\" \"Foot Controller\" \"Portamento Time\" \"Data Entr"
"y MSB\" \"Channel Volume\" \"Balance\" \"Undefined\" \"Pan\" \"Expression Controller\" \"Effect Control 1\" \"Effect Control 2\" \"Undefined\" \"Undefined\" \"General Purpose Controller 1\" \"General Purpose Controller 2\" \"General Purpose Controller 3\" \"General Purpose Controller 4\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"LSB for Control 0\" \"LSB for Control 1\" \"LSB for Control 2\" \"LSB for Control 3\" \"LSB for Control 4\" \"LSB for Control 5\" \"LSB for Control 6\" \"LSB for Control 7\" \"LSB for Control 8\" \"LSB for Control 9\" \"LSB for Control 10\" \"LSB for Control 11\" \"LSB for Control 12\" \"LSB for Control 13\" \"LSB for Control 14\" \"LSB for Control 15\" \"LSB for Control 16\" \"LSB for Control 17\" \"LSB for Control 18\" \"LSB for Control 19\" \"LSB for Control 20\" \"LSB for Control 21\" \"LSB for Control 22\" \"LSB for Control 23\" \"LSB for Control 24\" \""
"LSB for Control 25\" \"LSB for Control 26\" \"LSB for Control 27\" \"LSB for Control 28\" \"LSB for Control 29\" \"LSB for Control 30\" \"LSB for Control 31\" \"Damper Pedal on/off (Sustain)\" \"Portamento On/Off\" \"Sostenuto On/Off\" \"Soft Pedal On/Off\" \"Legato Footswitch\" \"Hold 2\" \"Sound Controller 1 (default: Sound Variation)\" \"Sound Controller 2 (default: Timbre/Harmonic Intens.)\" \"Sound Controller 3 (default: Release Time)\" \"Sound Controller 4 (default: Attack Time)\" \"Sound Controller 5 (default: Brightness)\" \"Sound Controller 6 (default: Decay Time - see MMA RP-021)\" \"Sound Controller 7 (default: Vibrato Rate - see MMA RP-021)\" \"Sound Controller 8 (default: Vibrato Depth - see MMA RP-021)\" \"Sound Controller 9 (default: Vibrato Delay - see MMA RP-021)\" \"Sound Controller 10 (default undefined - see MMA RP-021)\" \"General Purpose Controller 5\" \"General Purpose Controller 6\" \"General Purpose Controller 7\" \"General Purpose Controller 8\" \"Portamento Control\" \"Undefined\" "
"\"Undefined\" \"Undefined\" \"High Resolution Velocity Prefix\" \"Undefined\" \"Undefined\" \"Effects 1 Depth\" \"Effects 2 Depth\" \"Effects 3 Depth\" \"Effects 4 Depth\" \"Effects 5 Depth\" \"Data Increment\" \"Data Decrement\" \"Non-Registered Parameter Number (NRPN)\" \"Non-Registered Parameter Number (NRPN)\" \"Registered Parameter Number (RPN)\" \"Registered Parameter Number (RPN)\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"[Channel Mode Message] All Sound Off\" \"[Channel Mode Message] Reset All Controllers\" \"[Channel Mode Message] Local Control On/Off\" \"[Channel Mode Message] All Notes Off\" \"[Channel Mode Message] Omni Mode Off (+ all notes off)\" \"[Channel Mode Message] Omni Mode On (+ all notes off)\" \"[Channel Mode Message] Mono Mode On (+ poly off, + all notes off)\" \"[Channel Mod"
"e Message] Poly Mode On (+ mono off, +all notes off)\") #(\"\" \"text\" \"copyright\" \"track\" \"instrument\" \"lyric\" \"marker\" \"cue\") ", 5730 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3226z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2389za7623530z00, BGl_z62lambda2389z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3227z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73531za7, BGl_z62zc3anonymousza32398ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3228z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2397za7623532z00, BGl_z62lambda2397z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3229z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2396za7623533z00, BGl_z62lambda2396z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2prgmchangezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23534z00, BGl_z62midiplayerzd2prgmchangezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midizd2controllerzd2namezd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiza7d2contro3535z00, BGl_z62midizd2controllerzd2namez62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3230z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73536za7, BGl_z62zc3anonymousza32405ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3231z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2404za7623537z00, BGl_z62lambda2404z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3232z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2403za7623538z00, BGl_z62lambda2403z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3233z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73539za7, BGl_z62zc3anonymousza32412ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3071z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73540za7, BGl_z62zc3anonymousza31677ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3234z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2411za7623541z00, BGl_z62lambda2411z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3235z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2410za7623542z00, BGl_z62lambda2410z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3236z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73543za7, BGl_z62zc3anonymousza32419ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3237z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2418za7623544z00, BGl_z62lambda2418z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3238z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2417za7623545z00, BGl_z62lambda2417z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3239z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73546za7, BGl_z62zc3anonymousza32426ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2int32zd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3547z00, BGl_z62stringzd2streamzd2readzd2int32zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3240z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2425za7623548z00, BGl_z62lambda2425z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3241z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2424za7623549z00, BGl_z62lambda2424z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3242z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73550za7, BGl_z62zc3anonymousza32433ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3243z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2432za7623551z00, BGl_z62lambda2432z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3244z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2431za7623552z00, BGl_z62lambda2431z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3245z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73553za7, BGl_z62zc3anonymousza32440ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3246z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2439za7623554z00, BGl_z62lambda2439z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3247z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2438za7623555z00, BGl_z62lambda2438z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3248z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73556za7, BGl_z62zc3anonymousza32447ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3249z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2446za7623557z00, BGl_z62lambda2446z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2afterzd2touchzd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23558z00, BGl_z62midiplayerzd2afterzd2touchz62zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3250z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2445za7623559z00, BGl_z62lambda2445z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3251z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73560za7, BGl_z62zc3anonymousza32454ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3252z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2453za7623561z00, BGl_z62lambda2453z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3253z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2452za7623562z00, BGl_z62lambda2452z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3254z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73563za7, BGl_z62zc3anonymousza32461ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3255z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2460za7623564z00, BGl_z62lambda2460z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3256z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2459za7623565z00, BGl_z62lambda2459z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3257z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73566za7, BGl_z62zc3anonymousza32468ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3258z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2467za7623567z00, BGl_z62lambda2467z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3259z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2466za7623568z00, BGl_z62lambda2466z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3260z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73569za7, BGl_z62zc3anonymousza32475ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3261z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2474za7623570z00, BGl_z62lambda2474z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3262z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2473za7623571z00, BGl_z62lambda2473z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3263z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73572za7, BGl_z62zc3anonymousza32483ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3264z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2482za7623573z00, BGl_z62lambda2482z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3265z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2481za7623574z00, BGl_z62lambda2481z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3266z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73575za7, BGl_z62zc3anonymousza32491ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3267z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2490za7623576z00, BGl_z62lambda2490z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3268z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2489za7623577z00, BGl_z62lambda2489z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3269z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73578za7, BGl_z62zc3anonymousza32498ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3270z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2497za7623579z00, BGl_z62lambda2497z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3271z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2496za7623580z00, BGl_z62lambda2496z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3272z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73581za7, BGl_z62zc3anonymousza32300ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3273z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2298za7623582z00, BGl_z62lambda2298z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3274z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2295za7623583z00, BGl_z62lambda2295z62zz__multimediazd2midizd2, 0L, BUNSPEC, 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3275z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73584za7, BGl_z62zc3anonymousza32516ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3276z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2515za7623585z00, BGl_z62lambda2515z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3277z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2514za7623586z00, BGl_z62lambda2514z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3278z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73587za7, BGl_z62zc3anonymousza32523ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3279z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2522za7623588z00, BGl_z62lambda2522z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3280z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2521za7623589z00, BGl_z62lambda2521z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3281z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73590za7, BGl_z62zc3anonymousza32530ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3282z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2529za7623591z00, BGl_z62lambda2529z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3283z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2528za7623592z00, BGl_z62lambda2528z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3284z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73593za7, BGl_z62zc3anonymousza32538ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3285z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2537za7623594z00, BGl_z62lambda2537z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3286z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2536za7623595z00, BGl_z62lambda2536z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3287z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73596za7, BGl_z62zc3anonymousza32546ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3288z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2545za7623597z00, BGl_z62lambda2545z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3289z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2544za7623598z00, BGl_z62lambda2544z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3290z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73599za7, BGl_z62zc3anonymousza32509ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3291z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2507za7623600z00, BGl_z62lambda2507z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3292z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2504za7623601z00, BGl_z62lambda2504z62zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3293z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73602za7, BGl_z62zc3anonymousza32539ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3294z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73603za7, BGl_z62zc3anonymousza32531ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3295z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73604za7, BGl_z62zc3anonymousza32484ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3296z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3anonymousza73605za7, BGl_z62zc3anonymousza32476ze3ze1zz__multimediazd2midizd2, 0L, BUNSPEC, 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3297z00zz__multimediazd2midizd2, BgL_bgl_za762midiscoreza7d2i3606z00, BGl_z62midiscorezd2init1229zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3299z00zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2i3607z00, BGl_z62miditrackzd2init1231zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2int16zd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3608z00, BGl_z62stringzd2streamzd2readzd2int16zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_miditrackzd2inputzd2portzd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2i3609z00, BGl_z62miditrackzd2inputzd2portz62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_readzd2intzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762readza7d2intza7b03610za7, BGl_z62readzd2intzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2bytezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3611z00, BGl_z62stringzd2streamzd2readzd2bytezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_readzd2bytezd2envz00zz__r4_input_6_10_2z00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2intzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3612z00, BGl_z62stringzd2streamzd2readzd2intzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
BGL_IMPORT obj_t BGl_sleepzd2envzd2zz__osz00;
BGL_IMPORT obj_t BGl_flushzd2outputzd2portzd2envzd2zz__r4_ports_6_10_1z00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiscorezd2filezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiscoreza7d2f3613z00, BGl_z62midiscorezd2filezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midizd2programzd2indexzd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiza7d2progra3614z00, BGl_z62midizd2programzd2indexz62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2sysexzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23615z00, BGl_z62midiplayerzd2sysexzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2cdelayzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23616z00, BGl_z62midiplayerzd2cdelayzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midizd2programzd2namezd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiza7d2progra3617z00, BGl_z62midizd2programzd2namez62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2charszd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3618z00, BGl_z62stringzd2streamzd2readzd2charszb0zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2aftertouchzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23619z00, BGl_z62midiplayerzd2aftertouchzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2peekzd2bytezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3620z00, BGl_z62stringzd2streamzd2peekzd2bytezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_midiscorez00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midireaderz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midizd2controllerzd2namesz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midisinkz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midizd2textzd2namesz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midireaderzd2stringzd2streamz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midizd2notezd2namesz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midisinkzd2nullzd2zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midiplayerz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midizd2programzd2namesz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_miditrackz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midiplayerzd2readzd2zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midireaderzd2inputzd2portz00zz__multimediazd2midizd2) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2midizd2(long BgL_checksumz00_4521, char * BgL_fromz00_4522)
{ BGL_FUNCTION_BEGIN;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__multimediazd2midizd2))
{ 
BGl_requirezd2initializa7ationz75zz__multimediazd2midizd2 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__multimediazd2midizd2(); 
BGl_libraryzd2moduleszd2initz00zz__multimediazd2midizd2(); 
BGl_cnstzd2initzd2zz__multimediazd2midizd2(); 
BGl_objectzd2initzd2zz__multimediazd2midizd2(); 
BGl_genericzd2initzd2zz__multimediazd2midizd2(); 
return 
BGl_toplevelzd2initzd2zz__multimediazd2midizd2();}  else 
{ 
return BUNSPEC;} } 
BGL_FUNCTION_END;
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__multimediazd2midizd2()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__datez00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__structurez00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__biglooz00(((long)0), "__multimedia-midi"); 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__multimediazd2midizd2()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 15 */
{ /* Llib/midi.scm 15 */
obj_t BgL_cportz00_4154;
{ /* Llib/midi.scm 15 */
obj_t BgL_stringz00_4162;
BgL_stringz00_4162 = BGl_string3313z00zz__multimediazd2midizd2; 
{ /* Llib/midi.scm 15 */
obj_t BgL_startz00_4163;
BgL_startz00_4163 = 
BINT(((long)0)); 
{ /* Llib/midi.scm 15 */
obj_t BgL_endz00_4164;
BgL_endz00_4164 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_4162))); 
{ /* Llib/midi.scm 15 */

BgL_cportz00_4154 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_4162, BgL_startz00_4163, BgL_endz00_4164); } } } } 
{ 
long BgL_iz00_4155;
BgL_iz00_4155 = ((long)75); 
BgL_loopz00_4156:
if(
(BgL_iz00_4155==((long)-1)))
{ /* Llib/midi.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/midi.scm 15 */
{ /* Llib/midi.scm 15 */
obj_t BgL_arg3315z00_4158;
{ /* Llib/midi.scm 15 */

{ /* Llib/midi.scm 15 */
obj_t BgL_locationz00_4160;
BgL_locationz00_4160 = 
BBOOL(((bool_t)0)); 
{ /* Llib/midi.scm 15 */

BgL_arg3315z00_4158 = 
BGl_readz00zz__readerz00(BgL_cportz00_4154, BgL_locationz00_4160); } } } 
{ /* Llib/midi.scm 15 */
int BgL_tmpz00_4559;
BgL_tmpz00_4559 = 
(int)(BgL_iz00_4155); 
CNST_TABLE_SET(BgL_tmpz00_4559, BgL_arg3315z00_4158); } } 
{ /* Llib/midi.scm 15 */
int BgL_auxz00_4161;
BgL_auxz00_4161 = 
(int)(
(BgL_iz00_4155-((long)1))); 
{ 
long BgL_iz00_4564;
BgL_iz00_4564 = 
(long)(BgL_auxz00_4161); 
BgL_iz00_4155 = BgL_iz00_4564; 
goto BgL_loopz00_4156;} } } } } } 
BGL_FUNCTION_END;
}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__multimediazd2midizd2()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 15 */
return 
bgl_gc_roots_register();} 
BGL_FUNCTION_END;
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__multimediazd2midizd2()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 15 */
{ /* Llib/midi.scm 133 */
BgL_midireaderz00_bglt BgL_new1120z00_143;
{ /* Llib/midi.scm 134 */
BgL_midireaderz00_bglt BgL_new1119z00_145;
BgL_new1119z00_145 = 
((BgL_midireaderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midireaderz00_bgl) ))); 
{ /* Llib/midi.scm 134 */
long BgL_arg1256z00_146;
{ /* Llib/midi.scm 134 */
long BgL_res2553z00_1862;
BgL_res2553z00_1862 = 
BGL_CLASS_INDEX(BGl_midireaderz00zz__multimediazd2midizd2); 
BgL_arg1256z00_146 = BgL_res2553z00_1862; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1119z00_145), BgL_arg1256z00_146); } 
BgL_new1120z00_143 = BgL_new1119z00_145; } 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1120z00_143))->BgL_peekzd2bytezd2)=((obj_t)BGl_peekzd2bytezd2envz00zz__r4_input_6_10_2z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1120z00_143))->BgL_readzd2bytezd2)=((obj_t)BGl_readzd2bytezd2envz00zz__r4_input_6_10_2z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1120z00_143))->BgL_readzd2int16zd2)=((obj_t)BGl_readzd2int16zd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1120z00_143))->BgL_readzd2int32zd2)=((obj_t)BGl_readzd2int32zd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1120z00_143))->BgL_readzd2intzd2)=((obj_t)BGl_readzd2intzd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1120z00_143))->BgL_readzd2vlqzd2)=((obj_t)BGl_readzd2vlqzd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1120z00_143))->BgL_readzd2charszd2)=((obj_t)BGl_readzd2charszd2envz00zz__r4_input_6_10_2z00),BUNSPEC); 
{ /* Llib/midi.scm 133 */
obj_t BgL_fun1239z00_144;
BgL_fun1239z00_144 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midireaderz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1239z00_144)(BgL_fun1239z00_144, 
((obj_t)BgL_new1120z00_143), BEOA); } 
BGl_midireaderzd2inputzd2portz00zz__multimediazd2midizd2 = BgL_new1120z00_143; } 
{ /* Llib/midi.scm 146 */
BgL_midireaderz00_bglt BgL_new1122z00_147;
{ /* Llib/midi.scm 147 */
BgL_midireaderz00_bglt BgL_new1121z00_149;
BgL_new1121z00_149 = 
((BgL_midireaderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midireaderz00_bgl) ))); 
{ /* Llib/midi.scm 147 */
long BgL_arg1258z00_150;
{ /* Llib/midi.scm 147 */
long BgL_res2554z00_1866;
BgL_res2554z00_1866 = 
BGL_CLASS_INDEX(BGl_midireaderz00zz__multimediazd2midizd2); 
BgL_arg1258z00_150 = BgL_res2554z00_1866; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1121z00_149), BgL_arg1258z00_150); } 
BgL_new1122z00_147 = BgL_new1121z00_149; } 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1122z00_147))->BgL_peekzd2bytezd2)=((obj_t)BGl_stringzd2streamzd2peekzd2bytezd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1122z00_147))->BgL_readzd2bytezd2)=((obj_t)BGl_stringzd2streamzd2readzd2bytezd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1122z00_147))->BgL_readzd2int16zd2)=((obj_t)BGl_stringzd2streamzd2readzd2int16zd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1122z00_147))->BgL_readzd2int32zd2)=((obj_t)BGl_stringzd2streamzd2readzd2int32zd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1122z00_147))->BgL_readzd2intzd2)=((obj_t)BGl_stringzd2streamzd2readzd2intzd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1122z00_147))->BgL_readzd2vlqzd2)=((obj_t)BGl_stringzd2streamzd2readzd2vlqzd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1122z00_147))->BgL_readzd2charszd2)=((obj_t)BGl_stringzd2streamzd2readzd2charszd2envz00zz__multimediazd2midizd2),BUNSPEC); 
{ /* Llib/midi.scm 146 */
obj_t BgL_fun1257z00_148;
BgL_fun1257z00_148 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midireaderz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1257z00_148)(BgL_fun1257z00_148, 
((obj_t)BgL_new1122z00_147), BEOA); } 
BGl_midireaderzd2stringzd2streamz00zz__multimediazd2midizd2 = BgL_new1122z00_147; } 
{ /* Llib/midi.scm 159 */
BgL_midiplayerz00_bglt BgL_new1124z00_151;
{ /* Llib/midi.scm 159 */
BgL_midiplayerz00_bglt BgL_new1123z00_264;
BgL_new1123z00_264 = 
((BgL_midiplayerz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiplayerz00_bgl) ))); 
{ /* Llib/midi.scm 159 */
long BgL_arg1552z00_265;
{ /* Llib/midi.scm 159 */
long BgL_res2555z00_1870;
BgL_res2555z00_1870 = 
BGL_CLASS_INDEX(BGl_midiplayerz00zz__multimediazd2midizd2); 
BgL_arg1552z00_265 = BgL_res2555z00_1870; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1123z00_264), BgL_arg1552z00_265); } 
BgL_new1124z00_151 = BgL_new1123z00_264; } 
{ 
obj_t BgL_auxz00_4605;
{ /* Llib/midi.scm 159 */
obj_t BgL_arg1261z00_152;
{ /* Llib/midi.scm 159 */
obj_t BgL_arg1262z00_153;
{ /* Llib/midi.scm 159 */
obj_t BgL_res2556z00_1874;
{ /* Llib/midi.scm 159 */
obj_t BgL_classz00_1873;
BgL_classz00_1873 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2556z00_1874 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1873); } 
BgL_arg1262z00_153 = BgL_res2556z00_1874; } 
BgL_arg1261z00_152 = 
VECTOR_REF(BgL_arg1262z00_153,((long)0)); } 
BgL_auxz00_4605 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1261z00_152); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_errz00)=((obj_t)BgL_auxz00_4605),BUNSPEC); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_cdelayz00)=((obj_t)BGl_proc3045z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_noteoffz00)=((obj_t)BGl_proc3046z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_noteonz00)=((obj_t)BGl_proc3047z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_aftertouchz00)=((obj_t)BGl_proc3048z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_ctrlchangez00)=((obj_t)BGl_proc3049z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_prgmchangez00)=((obj_t)BGl_proc3050z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_afterzd2touchzd2)=((obj_t)BGl_proc3051z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_pitchz00)=((obj_t)BGl_proc3052z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_sysexz00)=((obj_t)BGl_proc3053z00zz__multimediazd2midizd2),BUNSPEC); 
{ 
obj_t BgL_auxz00_4619;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1284z00_214;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1285z00_215;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2557z00_1877;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1876;
BgL_classz00_1876 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2557z00_1877 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1876); } 
BgL_arg1285z00_215 = BgL_res2557z00_1877; } 
BgL_arg1284z00_214 = 
VECTOR_REF(BgL_arg1285z00_215,((long)10)); } 
BgL_auxz00_4619 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1284z00_214); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2seqnumzd2)=((obj_t)BgL_auxz00_4619),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4624;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1290z00_216;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1302z00_217;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2558z00_1880;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1879;
BgL_classz00_1879 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2558z00_1880 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1879); } 
BgL_arg1302z00_217 = BgL_res2558z00_1880; } 
BgL_arg1290z00_216 = 
VECTOR_REF(BgL_arg1302z00_217,((long)11)); } 
BgL_auxz00_4624 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1290z00_216); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2textzd2)=((obj_t)BgL_auxz00_4624),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4629;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1317z00_218;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1318z00_219;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2559z00_1883;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1882;
BgL_classz00_1882 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2559z00_1883 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1882); } 
BgL_arg1318z00_219 = BgL_res2559z00_1883; } 
BgL_arg1317z00_218 = 
VECTOR_REF(BgL_arg1318z00_219,((long)12)); } 
BgL_auxz00_4629 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1317z00_218); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2copyrightzd2)=((obj_t)BgL_auxz00_4629),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4634;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1325z00_220;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1326z00_221;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2560z00_1886;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1885;
BgL_classz00_1885 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2560z00_1886 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1885); } 
BgL_arg1326z00_221 = BgL_res2560z00_1886; } 
BgL_arg1325z00_220 = 
VECTOR_REF(BgL_arg1326z00_221,((long)13)); } 
BgL_auxz00_4634 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1325z00_220); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2trackzd2)=((obj_t)BgL_auxz00_4634),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4639;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1336z00_222;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1337z00_223;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2561z00_1889;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1888;
BgL_classz00_1888 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2561z00_1889 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1888); } 
BgL_arg1337z00_223 = BgL_res2561z00_1889; } 
BgL_arg1336z00_222 = 
VECTOR_REF(BgL_arg1337z00_223,((long)14)); } 
BgL_auxz00_4639 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1336z00_222); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2instrumentzd2)=((obj_t)BgL_auxz00_4639),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4644;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1338z00_224;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1339z00_225;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2562z00_1892;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1891;
BgL_classz00_1891 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2562z00_1892 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1891); } 
BgL_arg1339z00_225 = BgL_res2562z00_1892; } 
BgL_arg1338z00_224 = 
VECTOR_REF(BgL_arg1339z00_225,((long)15)); } 
BgL_auxz00_4644 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1338z00_224); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2lyriczd2)=((obj_t)BgL_auxz00_4644),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4649;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1340z00_226;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1341z00_227;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2563z00_1895;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1894;
BgL_classz00_1894 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2563z00_1895 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1894); } 
BgL_arg1341z00_227 = BgL_res2563z00_1895; } 
BgL_arg1340z00_226 = 
VECTOR_REF(BgL_arg1341z00_227,((long)16)); } 
BgL_auxz00_4649 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1340z00_226); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2markerzd2)=((obj_t)BgL_auxz00_4649),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4654;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1342z00_228;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1343z00_229;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2564z00_1898;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1897;
BgL_classz00_1897 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2564z00_1898 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1897); } 
BgL_arg1343z00_229 = BgL_res2564z00_1898; } 
BgL_arg1342z00_228 = 
VECTOR_REF(BgL_arg1343z00_229,((long)17)); } 
BgL_auxz00_4654 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1342z00_228); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2cuezd2)=((obj_t)BgL_auxz00_4654),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4659;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1373z00_230;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1374z00_231;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2565z00_1901;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1900;
BgL_classz00_1900 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2565z00_1901 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1900); } 
BgL_arg1374z00_231 = BgL_res2565z00_1901; } 
BgL_arg1373z00_230 = 
VECTOR_REF(BgL_arg1374z00_231,((long)18)); } 
BgL_auxz00_4659 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1373z00_230); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2prgmnamezd2)=((obj_t)BgL_auxz00_4659),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4664;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1417z00_232;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1418z00_233;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2566z00_1904;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1903;
BgL_classz00_1903 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2566z00_1904 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1903); } 
BgL_arg1418z00_233 = BgL_res2566z00_1904; } 
BgL_arg1417z00_232 = 
VECTOR_REF(BgL_arg1418z00_233,((long)19)); } 
BgL_auxz00_4664 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1417z00_232); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2devnamezd2)=((obj_t)BgL_auxz00_4664),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4669;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1498z00_234;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1499z00_235;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2567z00_1907;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1906;
BgL_classz00_1906 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2567z00_1907 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1906); } 
BgL_arg1499z00_235 = BgL_res2567z00_1907; } 
BgL_arg1498z00_234 = 
VECTOR_REF(BgL_arg1499z00_235,((long)20)); } 
BgL_auxz00_4669 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1498z00_234); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2channprefzd2)=((obj_t)BgL_auxz00_4669),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4674;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1509z00_236;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1510z00_237;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2568z00_1910;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1909;
BgL_classz00_1909 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2568z00_1910 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1909); } 
BgL_arg1510z00_237 = BgL_res2568z00_1910; } 
BgL_arg1509z00_236 = 
VECTOR_REF(BgL_arg1510z00_237,((long)21)); } 
BgL_auxz00_4674 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1509z00_236); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2midiportzd2)=((obj_t)BgL_auxz00_4674),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4679;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1517z00_238;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1523z00_239;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2569z00_1913;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1912;
BgL_classz00_1912 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2569z00_1913 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1912); } 
BgL_arg1523z00_239 = BgL_res2569z00_1913; } 
BgL_arg1517z00_238 = 
VECTOR_REF(BgL_arg1523z00_239,((long)22)); } 
BgL_auxz00_4679 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1517z00_238); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2eotzd2)=((obj_t)BgL_auxz00_4679),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4684;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1524z00_240;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1531z00_241;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2570z00_1916;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1915;
BgL_classz00_1915 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2570z00_1916 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1915); } 
BgL_arg1531z00_241 = BgL_res2570z00_1916; } 
BgL_arg1524z00_240 = 
VECTOR_REF(BgL_arg1531z00_241,((long)23)); } 
BgL_auxz00_4684 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1524z00_240); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2tempozd2)=((obj_t)BgL_auxz00_4684),BUNSPEC); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2smtpezd2)=((obj_t)BGl_proc3054z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2timesigzd2)=((obj_t)BGl_proc3055z00zz__multimediazd2midizd2),BUNSPEC); 
{ 
obj_t BgL_auxz00_4691;
{ /* Llib/midi.scm 83 */
obj_t BgL_arg1534z00_259;
{ /* Llib/midi.scm 83 */
obj_t BgL_arg1548z00_260;
{ /* Llib/midi.scm 83 */
obj_t BgL_res2571z00_1919;
{ /* Llib/midi.scm 83 */
obj_t BgL_classz00_1918;
BgL_classz00_1918 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2571z00_1919 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1918); } 
BgL_arg1548z00_260 = BgL_res2571z00_1919; } 
BgL_arg1534z00_259 = 
VECTOR_REF(BgL_arg1548z00_260,((long)26)); } 
BgL_auxz00_4691 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1534z00_259); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2keysigzd2)=((obj_t)BgL_auxz00_4691),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4696;
{ /* Llib/midi.scm 83 */
obj_t BgL_arg1549z00_261;
{ /* Llib/midi.scm 83 */
obj_t BgL_arg1550z00_262;
{ /* Llib/midi.scm 83 */
obj_t BgL_res2572z00_1922;
{ /* Llib/midi.scm 83 */
obj_t BgL_classz00_1921;
BgL_classz00_1921 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2572z00_1922 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1921); } 
BgL_arg1550z00_262 = BgL_res2572z00_1922; } 
BgL_arg1549z00_261 = 
VECTOR_REF(BgL_arg1550z00_262,((long)27)); } 
BgL_auxz00_4696 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1549z00_261); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2seqspeczd2)=((obj_t)BgL_auxz00_4696),BUNSPEC); } 
{ /* Llib/midi.scm 159 */
obj_t BgL_fun1551z00_263;
BgL_fun1551z00_263 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midiplayerz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1551z00_263)(BgL_fun1551z00_263, 
((obj_t)BgL_new1124z00_151), BEOA); } 
BGl_midiplayerzd2readzd2zz__multimediazd2midizd2 = BgL_new1124z00_151; } 
{ /* Llib/midi.scm 174 */
BgL_midisinkz00_bglt BgL_new1126z00_266;
{ /* Llib/midi.scm 174 */
BgL_midisinkz00_bglt BgL_new1125z00_278;
BgL_new1125z00_278 = 
((BgL_midisinkz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midisinkz00_bgl) ))); 
{ /* Llib/midi.scm 174 */
long BgL_arg1566z00_279;
{ /* Llib/midi.scm 174 */
long BgL_res2573z00_1925;
BgL_res2573z00_1925 = 
BGL_CLASS_INDEX(BGl_midisinkz00zz__multimediazd2midizd2); 
BgL_arg1566z00_279 = BgL_res2573z00_1925; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1125z00_278), BgL_arg1566z00_279); } 
BgL_new1126z00_266 = BgL_new1125z00_278; } 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1126z00_266))->BgL_streamz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1126z00_266))->BgL_usleepz00)=((obj_t)BGl_proc3056z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1126z00_266))->BgL_writezd2bytezd2)=((obj_t)BGl_proc3057z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1126z00_266))->BgL_writezd2stringzd2)=((obj_t)BGl_proc3058z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1126z00_266))->BgL_flushz00)=((obj_t)BGl_proc3059z00zz__multimediazd2midizd2),BUNSPEC); 
{ /* Llib/midi.scm 174 */
obj_t BgL_fun1557z00_277;
BgL_fun1557z00_277 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midisinkz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1557z00_277)(BgL_fun1557z00_277, 
((obj_t)BgL_new1126z00_266), BEOA); } 
BGl_midisinkzd2nullzd2zz__multimediazd2midizd2 = BgL_new1126z00_266; } 
BGl_midizd2textzd2namesz00zz__multimediazd2midizd2 = 
CNST_TABLE_REF(((long)0)); 
BGl_midizd2controllerzd2namesz00zz__multimediazd2midizd2 = 
CNST_TABLE_REF(((long)1)); 
BGl_midizd2programzd2namesz00zz__multimediazd2midizd2 = 
CNST_TABLE_REF(((long)2)); 
BGl_midizd2notezd2namesz00zz__multimediazd2midizd2 = 
CNST_TABLE_REF(((long)3)); 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* &<anonymous:1556> */
obj_t BGl_z62zc3anonymousza31556ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3051, obj_t BgL_opz00_3052)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 178 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1555> */
obj_t BGl_z62zc3anonymousza31555ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3053, obj_t BgL_opz00_3054, obj_t BgL_bz00_3055)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 177 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1554> */
obj_t BGl_z62zc3anonymousza31554ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3056, obj_t BgL_opz00_3057, obj_t BgL_bz00_3058)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 176 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1553> */
obj_t BGl_z62zc3anonymousza31553ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3059, obj_t BgL_sz00_3060)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 175 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1533> */
obj_t BGl_z62zc3anonymousza31533ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3061, obj_t BgL_mpz00_3062, obj_t BgL_msz00_3063, obj_t BgL_tickz00_3064, obj_t BgL_nnz00_3065, obj_t BgL_ddz00_3066, obj_t BgL_ccz00_3067, obj_t BgL_bbz00_3068)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 83 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1532> */
obj_t BGl_z62zc3anonymousza31532ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3069, obj_t BgL_mpz00_3070, obj_t BgL_msz00_3071, obj_t BgL_tickz00_3072, obj_t BgL_hrz00_3073, obj_t BgL_mmz00_3074, obj_t BgL_sez00_3075, obj_t BgL_frz00_3076, obj_t BgL_ffz00_3077)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 82 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1271> */
obj_t BGl_z62zc3anonymousza31271ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3078, obj_t BgL_mpz00_3079, obj_t BgL_msz00_3080, obj_t BgL_tickz00_3081, obj_t BgL_sz00_3082)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 168 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1270> */
obj_t BGl_z62zc3anonymousza31270ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3083, obj_t BgL_mpz00_3084, obj_t BgL_msz00_3085, obj_t BgL_tickz00_3086, obj_t BgL_xz00_3087, obj_t BgL_yz00_3088, obj_t BgL_za7za7_3089)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 167 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1269> */
obj_t BGl_z62zc3anonymousza31269ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3090, obj_t BgL_mpz00_3091, obj_t BgL_msz00_3092, obj_t BgL_tickz00_3093, obj_t BgL_xz00_3094, obj_t BgL_yz00_3095)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 166 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1268> */
obj_t BGl_z62zc3anonymousza31268ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3096, obj_t BgL_mpz00_3097, obj_t BgL_msz00_3098, obj_t BgL_tickz00_3099, obj_t BgL_xz00_3100, obj_t BgL_yz00_3101)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 165 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1267> */
obj_t BGl_z62zc3anonymousza31267ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3102, obj_t BgL_mpz00_3103, obj_t BgL_msz00_3104, obj_t BgL_tickz00_3105, obj_t BgL_xz00_3106, obj_t BgL_yz00_3107, obj_t BgL_za7za7_3108)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 164 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1266> */
obj_t BGl_z62zc3anonymousza31266ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3109, obj_t BgL_mpz00_3110, obj_t BgL_msz00_3111, obj_t BgL_tickz00_3112, obj_t BgL_xz00_3113, obj_t BgL_yz00_3114, obj_t BgL_za7za7_3115)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 163 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1265> */
obj_t BGl_z62zc3anonymousza31265ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3116, obj_t BgL_mpz00_3117, obj_t BgL_msz00_3118, obj_t BgL_tickz00_3119, obj_t BgL_xz00_3120, obj_t BgL_yz00_3121, obj_t BgL_za7za7_3122)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 162 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1264> */
obj_t BGl_z62zc3anonymousza31264ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3123, obj_t BgL_mpz00_3124, obj_t BgL_msz00_3125, obj_t BgL_tickz00_3126, obj_t BgL_xz00_3127, obj_t BgL_yz00_3128, obj_t BgL_za7za7_3129)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 161 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1263> */
obj_t BGl_z62zc3anonymousza31263ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3130, obj_t BgL_mpz00_3131, obj_t BgL_msz00_3132, obj_t BgL_tickz00_3133, obj_t BgL_trackz00_3134, obj_t BgL_ppqz00_3135, obj_t BgL_dtz00_3136, obj_t BgL_usz00_3137)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 160 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* midiscore-file */
BGL_EXPORTED_DEF BgL_midiscorez00_bglt BGl_midiscorezd2filezd2zz__multimediazd2midizd2(obj_t BgL_filenamez00_13)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 183 */
{ /* Llib/midi.scm 184 */
obj_t BgL_ipz00_296;
{ /* Llib/midi.scm 184 */

BgL_ipz00_296 = 
BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(BgL_filenamez00_13, BTRUE, 
BINT(((long)5000000))); } 
{ /* Llib/midi.scm 185 */
obj_t BgL_sza7za7_297;
BgL_sza7za7_297 = 
BGl_midizd2readzd2mthdz00zz__multimediazd2midizd2(BgL_ipz00_296); 
{ /* Llib/midi.scm 186 */
obj_t BgL_fmtz00_298;obj_t BgL_tckz00_299;obj_t BgL_tempoz00_300;obj_t BgL_ppqz00_301;
{ /* Llib/midi.scm 187 */
int BgL_tmpz00_4744;
BgL_tmpz00_4744 = 
(int)(((long)1)); 
BgL_fmtz00_298 = 
BGL_MVALUES_VAL(BgL_tmpz00_4744); } 
{ /* Llib/midi.scm 187 */
int BgL_tmpz00_4747;
BgL_tmpz00_4747 = 
(int)(((long)2)); 
BgL_tckz00_299 = 
BGL_MVALUES_VAL(BgL_tmpz00_4747); } 
{ /* Llib/midi.scm 187 */
int BgL_tmpz00_4750;
BgL_tmpz00_4750 = 
(int)(((long)3)); 
BgL_tempoz00_300 = 
BGL_MVALUES_VAL(BgL_tmpz00_4750); } 
{ /* Llib/midi.scm 187 */
int BgL_tmpz00_4753;
BgL_tmpz00_4753 = 
(int)(((long)4)); 
BgL_ppqz00_301 = 
BGL_MVALUES_VAL(BgL_tmpz00_4753); } 
{ /* Llib/midi.scm 187 */
obj_t BgL_tracksz00_302;
if(
INTEGERP(BgL_fmtz00_298))
{ /* Llib/midi.scm 187 */
switch( 
(long)CINT(BgL_fmtz00_298)) { case ((long)0) : 

{ /* Llib/midi.scm 188 */
obj_t BgL_v1185z00_310;
BgL_v1185z00_310 = 
create_vector(((long)1)); 
{ /* Llib/midi.scm 188 */
BgL_miditrackz00_bglt BgL_arg1614z00_311;
BgL_arg1614z00_311 = 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_296, 
(long)CINT(BgL_tempoz00_300)); 
VECTOR_SET(BgL_v1185z00_310,((long)0),
((obj_t)BgL_arg1614z00_311)); } 
BgL_tracksz00_302 = BgL_v1185z00_310; } break;case ((long)1) : 

BgL_tracksz00_302 = 
BGl_miditrackszd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_296, 
(long)CINT(BgL_tempoz00_300), BgL_tckz00_299); break;case ((long)2) : 

BgL_tracksz00_302 = 
BGl_errorz00zz__errorz00(BGl_string3060z00zz__multimediazd2midizd2, BGl_string3061z00zz__multimediazd2midizd2, BgL_fmtz00_298); break;
default: 
BgL_tracksz00_302 = 
BGl_errorz00zz__errorz00(BGl_string3062z00zz__multimediazd2midizd2, BGl_string3063z00zz__multimediazd2midizd2, BgL_fmtz00_298); } }  else 
{ /* Llib/midi.scm 187 */
BgL_tracksz00_302 = 
BGl_errorz00zz__errorz00(BGl_string3062z00zz__multimediazd2midizd2, BGl_string3063z00zz__multimediazd2midizd2, BgL_fmtz00_298); } 
{ /* Llib/midi.scm 192 */
BgL_midiscorez00_bglt BgL_new1130z00_303;
{ /* Llib/midi.scm 193 */
BgL_midiscorez00_bglt BgL_new1129z00_305;
BgL_new1129z00_305 = 
((BgL_midiscorez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiscorez00_bgl) ))); 
{ /* Llib/midi.scm 193 */
long BgL_arg1612z00_306;
{ /* Llib/midi.scm 193 */
long BgL_res2574z00_1937;
BgL_res2574z00_1937 = 
BGL_CLASS_INDEX(BGl_midiscorez00zz__multimediazd2midizd2); 
BgL_arg1612z00_306 = BgL_res2574z00_1937; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1129z00_305), BgL_arg1612z00_306); } 
BgL_new1130z00_303 = BgL_new1129z00_305; } 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1130z00_303))->BgL_formatz00)=((long)
(long)CINT(BgL_fmtz00_298)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1130z00_303))->BgL_tempoz00)=((long)
(long)CINT(BgL_tempoz00_300)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1130z00_303))->BgL_ppqz00)=((long)
(long)CINT(BgL_ppqz00_301)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1130z00_303))->BgL_tracksz00)=((obj_t)BgL_tracksz00_302),BUNSPEC); 
{ /* Llib/midi.scm 192 */
obj_t BgL_fun1607z00_304;
BgL_fun1607z00_304 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midiscorez00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1607z00_304)(BgL_fun1607z00_304, 
((obj_t)BgL_new1130z00_303), BEOA); } 
return BgL_new1130z00_303;} } } } } } 
BGL_FUNCTION_END;
}



/* &midiscore-file */
BgL_midiscorez00_bglt BGl_z62midiscorezd2filezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3170, obj_t BgL_filenamez00_3171)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 183 */
{ /* Llib/midi.scm 184 */
obj_t BgL_auxz00_4787;
if(
STRINGP(BgL_filenamez00_3171))
{ /* Llib/midi.scm 184 */
BgL_auxz00_4787 = BgL_filenamez00_3171
; }  else 
{ 
obj_t BgL_auxz00_4790;
BgL_auxz00_4790 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)8489)), BGl_string3065z00zz__multimediazd2midizd2, BGl_string3066z00zz__multimediazd2midizd2, BgL_filenamez00_3171); 
FAILURE(BgL_auxz00_4790,BFALSE,BFALSE);} 
return 
BGl_midiscorezd2filezd2zz__multimediazd2midizd2(BgL_auxz00_4787);} } 
BGL_FUNCTION_END;
}



/* miditrack-input-port */
BGL_EXPORTED_DEF BgL_miditrackz00_bglt BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(obj_t BgL_ipz00_15, long BgL_tempoz00_16)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 211 */
{ /* Llib/midi.scm 212 */
BgL_miditrackz00_bglt BgL_new1134z00_328;
{ /* Llib/midi.scm 213 */
BgL_miditrackz00_bglt BgL_new1133z00_330;
BgL_new1133z00_330 = 
((BgL_miditrackz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_miditrackz00_bgl) ))); 
{ /* Llib/midi.scm 213 */
long BgL_arg1644z00_331;
{ /* Llib/midi.scm 213 */
long BgL_res2575z00_1941;
BgL_res2575z00_1941 = 
BGL_CLASS_INDEX(BGl_miditrackz00zz__multimediazd2midizd2); 
BgL_arg1644z00_331 = BgL_res2575z00_1941; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1133z00_330), BgL_arg1644z00_331); } 
BgL_new1134z00_328 = BgL_new1133z00_330; } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_328))->BgL_z52streamz52)=((obj_t)BgL_ipz00_15),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_328))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)BGl_midireaderzd2inputzd2portz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_328))->BgL_z52closez52)=((obj_t)BGl_closezd2inputzd2portzd2envzd2zz__r4_ports_6_10_1z00),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_328))->BgL_z52eotz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_328))->BgL_z52wtickz52)=((uint32_t)(uint32_t)(0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_328))->BgL_z52statusz52)=((long)((long)0)),BUNSPEC); 
{ 
int32_t BgL_auxz00_4805;
{ /* Llib/midi.scm 216 */
obj_t BgL_tmpz00_4806;
BgL_tmpz00_4806 = 
BGl_midizd2readzd2mtrkz00zz__multimediazd2midizd2(BgL_ipz00_15); 
BgL_auxz00_4805 = 
BGL_BINT32_TO_INT32(BgL_tmpz00_4806); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_328))->BgL_lenz00)=((int32_t)BgL_auxz00_4805),BUNSPEC); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_328))->BgL_tempoz00)=((long)BgL_tempoz00_16),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_328))->BgL_ipz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_328))->BgL_startz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_328))->BgL_datastartz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_328))->BgL_wtickz00)=((uint32_t)(uint32_t)(0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_328))->BgL_statusz00)=((long)((long)-1)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_328))->BgL_eotz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ /* Llib/midi.scm 212 */
obj_t BgL_fun1642z00_329;
BgL_fun1642z00_329 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_miditrackz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1642z00_329)(BgL_fun1642z00_329, 
((obj_t)BgL_new1134z00_328), BEOA); } 
return BgL_new1134z00_328;} } 
BGL_FUNCTION_END;
}



/* &miditrack-input-port */
BgL_miditrackz00_bglt BGl_z62miditrackzd2inputzd2portz62zz__multimediazd2midizd2(obj_t BgL_envz00_3172, obj_t BgL_ipz00_3173, obj_t BgL_tempoz00_3174)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 211 */
{ /* Llib/midi.scm 212 */
long BgL_auxz00_4830;obj_t BgL_auxz00_4823;
{ /* Llib/midi.scm 212 */
obj_t BgL_tmpz00_4831;
if(
INTEGERP(BgL_tempoz00_3174))
{ /* Llib/midi.scm 212 */
BgL_tmpz00_4831 = BgL_tempoz00_3174
; }  else 
{ 
obj_t BgL_auxz00_4834;
BgL_auxz00_4834 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)9695)), BGl_string3067z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_tempoz00_3174); 
FAILURE(BgL_auxz00_4834,BFALSE,BFALSE);} 
BgL_auxz00_4830 = 
(long)CINT(BgL_tmpz00_4831); } 
if(
INPUT_PORTP(BgL_ipz00_3173))
{ /* Llib/midi.scm 212 */
BgL_auxz00_4823 = BgL_ipz00_3173
; }  else 
{ 
obj_t BgL_auxz00_4826;
BgL_auxz00_4826 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)9695)), BGl_string3067z00zz__multimediazd2midizd2, BGl_string3068z00zz__multimediazd2midizd2, BgL_ipz00_3173); 
FAILURE(BgL_auxz00_4826,BFALSE,BFALSE);} 
return 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_auxz00_4823, BgL_auxz00_4830);} } 
BGL_FUNCTION_END;
}



/* miditracks-input-port */
obj_t BGl_miditrackszd2inputzd2portz00zz__multimediazd2midizd2(obj_t BgL_ipz00_17, long BgL_tempoz00_18, obj_t BgL_tnumz00_19)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 222 */
{ 
obj_t BgL_ipz00_358;long BgL_tempoz00_359;
{ /* Llib/midi.scm 241 */
BgL_miditrackz00_bglt BgL_t0z00_334;
BgL_ipz00_358 = BgL_ipz00_17; 
BgL_tempoz00_359 = BgL_tempoz00_18; 
{ /* Llib/midi.scm 225 */
BgL_miditrackz00_bglt BgL_trackz00_361;
BgL_trackz00_361 = 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_358, BgL_tempoz00_359); 
{ /* Llib/midi.scm 227 */
BgL_midireaderz00_bglt BgL_i1136z00_363;
BgL_i1136z00_363 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_361))->BgL_z52readerz52); 
{ 

BgL_zc3anonymousza31668ze3z83_365:
{ /* Llib/midi.scm 229 */
obj_t BgL_fun1670z00_366;
BgL_fun1670z00_366 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1136z00_363))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 229 */
obj_t BgL_arg1669z00_367;
BgL_arg1669z00_367 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_361))->BgL_z52streamz52); 
PROCEDURE_ENTRY(BgL_fun1670z00_366)(BgL_fun1670z00_366, BgL_arg1669z00_367, BEOA); } } 
BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(BgL_trackz00_361, BGl_midiplayerzd2readzd2zz__multimediazd2midizd2, BGl_midisinkzd2nullzd2zz__multimediazd2midizd2, ((long)0), ((long)0), ((long)0), 
LONG_TO_LLONG(((long)0))); 
if(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_361))->BgL_z52eotz52))
{ /* Llib/midi.scm 232 */
BgL_t0z00_334 = BgL_trackz00_361; }  else 
{ /* Llib/midi.scm 232 */
goto BgL_zc3anonymousza31668ze3z83_365;} } } } 
{ /* Llib/midi.scm 243 */
obj_t BgL_filez00_336;
{ /* Llib/midi.scm 243 */
obj_t BgL_res2576z00_1949;
BgL_res2576z00_1949 = 
INPUT_PORT_NAME(BgL_ipz00_17); 
BgL_filez00_336 = BgL_res2576z00_1949; } 
{ /* Llib/midi.scm 244 */
long BgL_g1138z00_337;
{ /* Llib/midi.scm 245 */
long BgL_res2577z00_1951;
BgL_res2577z00_1951 = 
INPUT_PORT_FILEPOS(BgL_ipz00_17); 
BgL_g1138z00_337 = BgL_res2577z00_1951; } 
{ 
long BgL_iz00_340;long BgL_posz00_341;obj_t BgL_tksz00_342;
BgL_iz00_340 = ((long)1); 
BgL_posz00_341 = BgL_g1138z00_337; 
BgL_tksz00_342 = BNIL; 
BgL_zc3anonymousza31645ze3z83_343:
if(
(BgL_iz00_340==
(long)CINT(BgL_tnumz00_19)))
{ /* Llib/midi.scm 248 */
obj_t BgL_arg1648z00_345;
{ /* Llib/midi.scm 248 */
obj_t BgL_arg1649z00_346;
BgL_arg1649z00_346 = 
bgl_reverse_bang(BgL_tksz00_342); 
BgL_arg1648z00_345 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_t0z00_334), BgL_arg1649z00_346); } 
return 
BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg1648z00_345);}  else 
{ /* Llib/midi.scm 249 */
obj_t BgL_ipz00_347;
{ /* Llib/midi.scm 237 */
obj_t BgL_portz00_1955;
{ /* Llib/midi.scm 237 */

BgL_portz00_1955 = 
BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(BgL_filez00_336, BTRUE, 
BINT(((long)5000000))); } 
BGl_setzd2inputzd2portzd2positionz12zc0zz__r4_ports_6_10_1z00(BgL_portz00_1955, BgL_posz00_341); 
BgL_ipz00_347 = BgL_portz00_1955; } 
{ /* Llib/midi.scm 249 */
BgL_miditrackz00_bglt BgL_tz00_348;
BgL_tz00_348 = 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_347, 
(((BgL_miditrackz00_bglt)COBJECT(BgL_t0z00_334))->BgL_tempoz00)); 
{ /* Llib/midi.scm 250 */

{ /* Llib/midi.scm 252 */
long BgL_arg1652z00_350;long BgL_arg1657z00_351;obj_t BgL_arg1658z00_352;
BgL_arg1652z00_350 = 
(BgL_iz00_340+((long)1)); 
{ /* Llib/midi.scm 253 */
long BgL_arg1663z00_353;long BgL_arg1664z00_354;
{ /* Llib/midi.scm 253 */
long BgL_res2580z00_1962;
{ /* Llib/midi.scm 253 */
obj_t BgL_tmpz00_4867;
BgL_tmpz00_4867 = 
((obj_t)BgL_ipz00_347); 
BgL_res2580z00_1962 = 
INPUT_PORT_FILEPOS(BgL_tmpz00_4867); } 
BgL_arg1663z00_353 = BgL_res2580z00_1962; } 
{ /* Llib/midi.scm 253 */
int32_t BgL_arg1665z00_355;
BgL_arg1665z00_355 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_tz00_348))->BgL_lenz00); 
{ /* Llib/midi.scm 253 */
long BgL_res2582z00_1967;
{ /* Llib/midi.scm 253 */
long BgL_arg1409z00_1964;
BgL_arg1409z00_1964 = 
(long)(BgL_arg1665z00_355); 
{ /* Llib/midi.scm 253 */
long BgL_res2581z00_1966;
BgL_res2581z00_1966 = 
(long)(BgL_arg1409z00_1964); 
BgL_res2582z00_1967 = BgL_res2581z00_1966; } } 
BgL_arg1664z00_354 = BgL_res2582z00_1967; } } 
BgL_arg1657z00_351 = 
(BgL_arg1663z00_353+BgL_arg1664z00_354); } 
BgL_arg1658z00_352 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_tz00_348), BgL_tksz00_342); 
{ 
obj_t BgL_tksz00_4878;long BgL_posz00_4877;long BgL_iz00_4876;
BgL_iz00_4876 = BgL_arg1652z00_350; 
BgL_posz00_4877 = BgL_arg1657z00_351; 
BgL_tksz00_4878 = BgL_arg1658z00_352; 
BgL_tksz00_342 = BgL_tksz00_4878; 
BgL_posz00_341 = BgL_posz00_4877; 
BgL_iz00_340 = BgL_iz00_4876; 
goto BgL_zc3anonymousza31645ze3z83_343;} } } } } } } } } } } 
BGL_FUNCTION_END;
}



/* miditrack-file */
BGL_EXPORTED_DEF BgL_miditrackz00_bglt BGl_miditrackzd2filezd2zz__multimediazd2midizd2(obj_t BgL_filenamez00_20, long BgL_offsetz00_21, long BgL_tempoz00_22)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 259 */
{ /* Llib/midi.scm 262 */
obj_t BgL_zc3anonymousza31676ze3z83_3177;
BgL_zc3anonymousza31676ze3z83_3177 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza31676ze3ze1zz__multimediazd2midizd2, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3anonymousza31676ze3z83_3177, 
(int)(((long)0)), 
BINT(BgL_offsetz00_21)); 
PROCEDURE_SET(BgL_zc3anonymousza31676ze3z83_3177, 
(int)(((long)1)), 
BINT(BgL_tempoz00_22)); 
return 
((BgL_miditrackz00_bglt)
BGl_callzd2withzd2inputzd2filezd2zz__r4_ports_6_10_1z00(BgL_filenamez00_20, BgL_zc3anonymousza31676ze3z83_3177));} } 
BGL_FUNCTION_END;
}



/* &miditrack-file */
BgL_miditrackz00_bglt BGl_z62miditrackzd2filezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3178, obj_t BgL_filenamez00_3179, obj_t BgL_offsetz00_3180, obj_t BgL_tempoz00_3181)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 259 */
{ /* Llib/midi.scm 262 */
long BgL_auxz00_4906;long BgL_auxz00_4897;obj_t BgL_auxz00_4890;
{ /* Llib/midi.scm 262 */
obj_t BgL_tmpz00_4907;
if(
INTEGERP(BgL_tempoz00_3181))
{ /* Llib/midi.scm 262 */
BgL_tmpz00_4907 = BgL_tempoz00_3181
; }  else 
{ 
obj_t BgL_auxz00_4910;
BgL_auxz00_4910 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)11501)), BGl_string3070z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_tempoz00_3181); 
FAILURE(BgL_auxz00_4910,BFALSE,BFALSE);} 
BgL_auxz00_4906 = 
(long)CINT(BgL_tmpz00_4907); } 
{ /* Llib/midi.scm 262 */
obj_t BgL_tmpz00_4898;
if(
INTEGERP(BgL_offsetz00_3180))
{ /* Llib/midi.scm 262 */
BgL_tmpz00_4898 = BgL_offsetz00_3180
; }  else 
{ 
obj_t BgL_auxz00_4901;
BgL_auxz00_4901 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)11501)), BGl_string3070z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_offsetz00_3180); 
FAILURE(BgL_auxz00_4901,BFALSE,BFALSE);} 
BgL_auxz00_4897 = 
(long)CINT(BgL_tmpz00_4898); } 
if(
STRINGP(BgL_filenamez00_3179))
{ /* Llib/midi.scm 262 */
BgL_auxz00_4890 = BgL_filenamez00_3179
; }  else 
{ 
obj_t BgL_auxz00_4893;
BgL_auxz00_4893 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)11501)), BGl_string3070z00zz__multimediazd2midizd2, BGl_string3066z00zz__multimediazd2midizd2, BgL_filenamez00_3179); 
FAILURE(BgL_auxz00_4893,BFALSE,BFALSE);} 
return 
BGl_miditrackzd2filezd2zz__multimediazd2midizd2(BgL_auxz00_4890, BgL_auxz00_4897, BgL_auxz00_4906);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1676> */
obj_t BGl_z62zc3anonymousza31676ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3182, obj_t BgL_ipz00_3185)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 261 */
{ /* Llib/midi.scm 262 */
long BgL_offsetz00_3183;long BgL_tempoz00_3184;
BgL_offsetz00_3183 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_3182, 
(int)(((long)0)))); 
BgL_tempoz00_3184 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_3182, 
(int)(((long)1)))); 
{ 
BgL_miditrackz00_bglt BgL_auxz00_4922;
BGl_setzd2inputzd2portzd2positionz12zc0zz__r4_ports_6_10_1z00(BgL_ipz00_3185, BgL_offsetz00_3183); 
BgL_auxz00_4922 = 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_3185, BgL_tempoz00_3184); 
return 
((obj_t)BgL_auxz00_4922);} } } 
BGL_FUNCTION_END;
}



/* miditrack-string */
BGL_EXPORTED_DEF BgL_miditrackz00_bglt BGl_miditrackzd2stringzd2zz__multimediazd2midizd2(obj_t BgL_stringz00_23, long BgL_tempoz00_24)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 268 */
{ /* Llib/midi.scm 269 */
BgL_miditrackz00_bglt BgL_new1142z00_383;
{ /* Llib/midi.scm 270 */
BgL_miditrackz00_bglt BgL_new1141z00_387;
BgL_new1141z00_387 = 
((BgL_miditrackz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_miditrackz00_bgl) ))); 
{ /* Llib/midi.scm 270 */
long BgL_arg1679z00_388;
{ /* Llib/midi.scm 270 */
long BgL_res2584z00_1974;
BgL_res2584z00_1974 = 
BGL_CLASS_INDEX(BGl_miditrackz00zz__multimediazd2midizd2); 
BgL_arg1679z00_388 = BgL_res2584z00_1974; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1141z00_387), BgL_arg1679z00_388); } 
BgL_new1142z00_383 = BgL_new1141z00_387; } 
{ 
obj_t BgL_auxz00_4930;
{ /* Llib/midi.scm 127 */
obj_t BgL_newz00_1977;
BgL_newz00_1977 = 
create_struct(
CNST_TABLE_REF(((long)4)), 
(int)(((long)2))); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_4936;int BgL_tmpz00_4934;
BgL_auxz00_4936 = 
BINT(((long)0)); 
BgL_tmpz00_4934 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_1977, BgL_tmpz00_4934, BgL_auxz00_4936); } 
{ /* Llib/midi.scm 127 */
int BgL_tmpz00_4939;
BgL_tmpz00_4939 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_1977, BgL_tmpz00_4939, BgL_stringz00_23); } 
BgL_auxz00_4930 = BgL_newz00_1977; } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1142z00_383))->BgL_z52streamz52)=((obj_t)BgL_auxz00_4930),BUNSPEC); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1142z00_383))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)BGl_midireaderzd2stringzd2streamz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1142z00_383))->BgL_z52closez52)=((obj_t)BGl_proc3071z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1142z00_383))->BgL_z52eotz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1142z00_383))->BgL_z52wtickz52)=((uint32_t)(uint32_t)(0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1142z00_383))->BgL_z52statusz52)=((long)((long)0)),BUNSPEC); 
{ 
int32_t BgL_auxz00_4948;
{ /* Llib/midi.scm 273 */
long BgL_tmpz00_4949;
BgL_tmpz00_4949 = 
STRING_LENGTH(BgL_stringz00_23); 
BgL_auxz00_4948 = 
(int32_t)(BgL_tmpz00_4949); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1142z00_383))->BgL_lenz00)=((int32_t)BgL_auxz00_4948),BUNSPEC); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1142z00_383))->BgL_tempoz00)=((long)BgL_tempoz00_24),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1142z00_383))->BgL_ipz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1142z00_383))->BgL_startz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1142z00_383))->BgL_datastartz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1142z00_383))->BgL_wtickz00)=((uint32_t)(uint32_t)(0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1142z00_383))->BgL_statusz00)=((long)((long)-1)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1142z00_383))->BgL_eotz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ /* Llib/midi.scm 269 */
obj_t BgL_fun1678z00_386;
BgL_fun1678z00_386 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_miditrackz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1678z00_386)(BgL_fun1678z00_386, 
((obj_t)BgL_new1142z00_383), BEOA); } 
return BgL_new1142z00_383;} } 
BGL_FUNCTION_END;
}



/* &miditrack-string */
BgL_miditrackz00_bglt BGl_z62miditrackzd2stringzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3187, obj_t BgL_stringz00_3188, obj_t BgL_tempoz00_3189)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 268 */
{ /* Llib/midi.scm 269 */
long BgL_auxz00_4973;obj_t BgL_auxz00_4966;
{ /* Llib/midi.scm 269 */
obj_t BgL_tmpz00_4974;
if(
INTEGERP(BgL_tempoz00_3189))
{ /* Llib/midi.scm 269 */
BgL_tmpz00_4974 = BgL_tempoz00_3189
; }  else 
{ 
obj_t BgL_auxz00_4977;
BgL_auxz00_4977 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)11847)), BGl_string3072z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_tempoz00_3189); 
FAILURE(BgL_auxz00_4977,BFALSE,BFALSE);} 
BgL_auxz00_4973 = 
(long)CINT(BgL_tmpz00_4974); } 
if(
STRINGP(BgL_stringz00_3188))
{ /* Llib/midi.scm 269 */
BgL_auxz00_4966 = BgL_stringz00_3188
; }  else 
{ 
obj_t BgL_auxz00_4969;
BgL_auxz00_4969 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)11847)), BGl_string3072z00zz__multimediazd2midizd2, BGl_string3066z00zz__multimediazd2midizd2, BgL_stringz00_3188); 
FAILURE(BgL_auxz00_4969,BFALSE,BFALSE);} 
return 
BGl_miditrackzd2stringzd2zz__multimediazd2midizd2(BgL_auxz00_4966, BgL_auxz00_4973);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1677> */
obj_t BGl_z62zc3anonymousza31677ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3190, obj_t BgL_sz00_3191)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 272 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* midiscore-play */
BGL_EXPORTED_DEF obj_t BGl_midiscorezd2playzd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt BgL_mscorez00_25, BgL_midiplayerz00_bglt BgL_mplayerz00_26, BgL_midisinkz00_bglt BgL_msinkz00_27)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 279 */
{ 

{ /* Llib/midi.scm 281 */
long BgL_aux1145z00_391;
BgL_aux1145z00_391 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_25))->BgL_formatz00); 
switch( BgL_aux1145z00_391) { case ((long)0) : 

return 
BBOOL(
BGl_midiscorezd2play0zd2zz__multimediazd2midizd2(BgL_mscorez00_25, BgL_mplayerz00_26, BgL_msinkz00_27));break;case ((long)1) : 

return 
BBOOL(
BGl_midiscorezd2play1zd2zz__multimediazd2midizd2(BgL_mscorez00_25, BgL_mplayerz00_26, BgL_msinkz00_27));break;
default: 
{ /* Llib/midi.scm 284 */
long BgL_arg1681z00_393;
BgL_arg1681z00_393 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_25))->BgL_formatz00); 
return 
BGl_errorz00zz__errorz00(BGl_string3073z00zz__multimediazd2midizd2, BGl_string3063z00zz__multimediazd2midizd2, 
BINT(BgL_arg1681z00_393));} } } } } 
BGL_FUNCTION_END;
}



/* &midiscore-play */
obj_t BGl_z62midiscorezd2playzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3192, obj_t BgL_mscorez00_3193, obj_t BgL_mplayerz00_3194, obj_t BgL_msinkz00_3195)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 279 */
{ /* Llib/midi.scm 280 */
BgL_midisinkz00_bglt BgL_auxz00_5009;BgL_midiplayerz00_bglt BgL_auxz00_5001;BgL_midiscorez00_bglt BgL_auxz00_4993;
if(
BGl_isazf3zf3zz__objectz00(BgL_msinkz00_3195, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 280 */
BgL_auxz00_5009 = 
((BgL_midisinkz00_bglt)BgL_msinkz00_3195)
; }  else 
{ 
obj_t BgL_auxz00_5013;
BgL_auxz00_5013 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)12346)), BGl_string3074z00zz__multimediazd2midizd2, BGl_string3077z00zz__multimediazd2midizd2, BgL_msinkz00_3195); 
FAILURE(BgL_auxz00_5013,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mplayerz00_3194, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 280 */
BgL_auxz00_5001 = 
((BgL_midiplayerz00_bglt)BgL_mplayerz00_3194)
; }  else 
{ 
obj_t BgL_auxz00_5005;
BgL_auxz00_5005 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)12346)), BGl_string3074z00zz__multimediazd2midizd2, BGl_string3076z00zz__multimediazd2midizd2, BgL_mplayerz00_3194); 
FAILURE(BgL_auxz00_5005,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mscorez00_3193, BGl_midiscorez00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 280 */
BgL_auxz00_4993 = 
((BgL_midiscorez00_bglt)BgL_mscorez00_3193)
; }  else 
{ 
obj_t BgL_auxz00_4997;
BgL_auxz00_4997 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)12346)), BGl_string3074z00zz__multimediazd2midizd2, BGl_string3075z00zz__multimediazd2midizd2, BgL_mscorez00_3193); 
FAILURE(BgL_auxz00_4997,BFALSE,BFALSE);} 
return 
BGl_midiscorezd2playzd2zz__multimediazd2midizd2(BgL_auxz00_4993, BgL_auxz00_5001, BgL_auxz00_5009);} } 
BGL_FUNCTION_END;
}



/* midiscore-play0 */
bool_t BGl_midiscorezd2play0zd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt BgL_mscorez00_28, BgL_midiplayerz00_bglt BgL_mplayerz00_29, BgL_midisinkz00_bglt BgL_msinkz00_30)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 289 */
{ /* Llib/midi.scm 291 */
obj_t BgL_trackz00_395;
BgL_trackz00_395 = 
VECTOR_REF(
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_28))->BgL_tracksz00),((long)0)); 
{ /* Llib/midi.scm 293 */
BgL_midireaderz00_bglt BgL_i1148z00_397;
BgL_i1148z00_397 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_395)))->BgL_z52readerz52); 
{ 
uint32_t BgL_tickz00_399;
BgL_tickz00_399 = (uint32_t)(0); 
BgL_zc3anonymousza31682ze3z83_400:
{ /* Llib/midi.scm 295 */
BGL_LONGLONG_T BgL_t0z00_401;
BgL_t0z00_401 = 
bgl_current_microseconds(); 
{ /* Llib/midi.scm 295 */
obj_t BgL_dtz00_402;
{ /* Llib/midi.scm 296 */
obj_t BgL_fun1693z00_407;
BgL_fun1693z00_407 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1148z00_397))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 296 */
obj_t BgL_arg1692z00_408;
BgL_arg1692z00_408 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_395)))->BgL_z52streamz52); 
BgL_dtz00_402 = 
PROCEDURE_ENTRY(BgL_fun1693z00_407)(BgL_fun1693z00_407, BgL_arg1692z00_408, BEOA); } } 
{ /* Llib/midi.scm 296 */

{ /* Llib/midi.scm 298 */
long BgL_arg1683z00_403;long BgL_arg1689z00_404;
{ /* Llib/midi.scm 298 */
long BgL_res2587z00_1985;
BgL_res2587z00_1985 = 
(long)(BgL_tickz00_399); 
BgL_arg1683z00_403 = BgL_res2587z00_1985; } 
BgL_arg1689z00_404 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_28))->BgL_ppqz00); 
BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(
((BgL_miditrackz00_bglt)BgL_trackz00_395), BgL_mplayerz00_29, BgL_msinkz00_30, BgL_arg1683z00_403, BgL_arg1689z00_404, 
(long)CINT(BgL_dtz00_402), BgL_t0z00_401); } 
if(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_395)))->BgL_z52eotz52))
{ /* Llib/midi.scm 299 */
return ((bool_t)0);}  else 
{ /* Llib/midi.scm 300 */
uint32_t BgL_arg1691z00_406;
BgL_arg1691z00_406 = 
(BgL_tickz00_399+
(uint32_t)(((long)1))); 
{ 
uint32_t BgL_tickz00_5040;
BgL_tickz00_5040 = BgL_arg1691z00_406; 
BgL_tickz00_399 = BgL_tickz00_5040; 
goto BgL_zc3anonymousza31682ze3z83_400;} } } } } } } } } 
BGL_FUNCTION_END;
}



/* midiscore-play1 */
bool_t BGl_midiscorezd2play1zd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt BgL_mscorez00_31, BgL_midiplayerz00_bglt BgL_mplayerz00_32, BgL_midisinkz00_bglt BgL_msinkz00_33)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 305 */
{ /* Llib/midi.scm 307 */
obj_t BgL_v1191z00_412;
BgL_v1191z00_412 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_tracksz00); 
{ /* Llib/midi.scm 307 */

{ 
long BgL_i1190z00_415;
BgL_i1190z00_415 = ((long)0); 
BgL_zc3anonymousza31695ze3z83_416:
if(
(BgL_i1190z00_415<
VECTOR_LENGTH(BgL_v1191z00_412)))
{ /* Llib/midi.scm 307 */
{ /* Llib/midi.scm 308 */
obj_t BgL_trackz00_418;
BgL_trackz00_418 = 
VECTOR_REF(BgL_v1191z00_412,BgL_i1190z00_415); 
if(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_418)))->BgL_z52eotz52))
{ /* Llib/midi.scm 309 */BFALSE; }  else 
{ /* Llib/midi.scm 310 */
BgL_midireaderz00_bglt BgL_i1151z00_421;
BgL_i1151z00_421 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_418)))->BgL_z52readerz52); 
{ /* Llib/midi.scm 311 */
obj_t BgL_dtz00_422;
{ /* Llib/midi.scm 311 */
obj_t BgL_fun1699z00_423;
BgL_fun1699z00_423 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1151z00_421))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 311 */
obj_t BgL_arg1698z00_424;
BgL_arg1698z00_424 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_418)))->BgL_z52streamz52); 
BgL_dtz00_422 = 
PROCEDURE_ENTRY(BgL_fun1699z00_423)(BgL_fun1699z00_423, BgL_arg1698z00_424, BEOA); } } 
{ 
uint32_t BgL_auxz00_5058;
{ /* Llib/midi.scm 312 */
int32_t BgL_res2590z00_1996;
{ /* Llib/midi.scm 312 */
long BgL_xz00_1995;
BgL_xz00_1995 = 
(long)CINT(BgL_dtz00_422); 
BgL_res2590z00_1996 = 
(int32_t)(BgL_xz00_1995); } 
BgL_auxz00_5058 = 
(uint32_t)(BgL_res2590z00_1996); } 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_418)))->BgL_z52wtickz52)=((uint32_t)BgL_auxz00_5058),BUNSPEC); } } } } 
{ 
long BgL_i1190z00_5064;
BgL_i1190z00_5064 = 
(BgL_i1190z00_415+((long)1)); 
BgL_i1190z00_415 = BgL_i1190z00_5064; 
goto BgL_zc3anonymousza31695ze3z83_416;} }  else 
{ /* Llib/midi.scm 307 */((bool_t)0); } } } } 
{ /* Llib/midi.scm 314 */
long BgL_resz00_427;
{ /* Llib/midi.scm 314 */
BgL_miditrackz00_bglt BgL_i1152z00_456;
{ /* Llib/midi.scm 314 */
obj_t BgL_arg1751z00_459;
BgL_arg1751z00_459 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_tracksz00); 
BgL_i1152z00_456 = 
((BgL_miditrackz00_bglt)
VECTOR_REF(BgL_arg1751z00_459,((long)0))); } 
BgL_resz00_427 = 
(
(((BgL_miditrackz00_bglt)COBJECT(BgL_i1152z00_456))->BgL_tempoz00)/
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_ppqz00)); } 
{ 
uint32_t BgL_tickz00_429;
BgL_tickz00_429 = (uint32_t)(0); 
BgL_zc3anonymousza31705ze3z83_430:
{ /* Llib/midi.scm 317 */
BGL_LONGLONG_T BgL_t0z00_431;
BgL_t0z00_431 = 
bgl_current_microseconds(); 
{ /* Llib/midi.scm 317 */
bool_t BgL_eosz00_432;
BgL_eosz00_432 = ((bool_t)1); 
{ /* Llib/midi.scm 318 */

{ /* Llib/midi.scm 319 */
long BgL_g1153z00_433;
{ /* Llib/midi.scm 319 */
long BgL_arg1719z00_446;
BgL_arg1719z00_446 = 
VECTOR_LENGTH(
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_tracksz00)); 
BgL_g1153z00_433 = 
(BgL_arg1719z00_446-((long)1)); } 
{ 
long BgL_iz00_435;
BgL_iz00_435 = BgL_g1153z00_433; 
BgL_zc3anonymousza31706ze3z83_436:
if(
(BgL_iz00_435>((long)0)))
{ /* Llib/midi.scm 320 */
{ /* Llib/midi.scm 321 */
obj_t BgL_trackz00_438;
BgL_trackz00_438 = 
VECTOR_REF(
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_tracksz00),BgL_iz00_435); 
if(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_438)))->BgL_z52eotz52))
{ /* Llib/midi.scm 323 */BFALSE; }  else 
{ /* Llib/midi.scm 323 */
{ /* Llib/midi.scm 325 */
long BgL_arg1712z00_441;
{ /* Llib/midi.scm 325 */
long BgL_res2596z00_2012;
BgL_res2596z00_2012 = 
(long)(BgL_tickz00_429); 
BgL_arg1712z00_441 = BgL_res2596z00_2012; } 
BGl_miditrackzd2waitzd2eventz00zz__multimediazd2midizd2(
((BgL_miditrackz00_bglt)BgL_trackz00_438), BgL_mplayerz00_32, BgL_msinkz00_33, BgL_arg1712z00_441); } 
if(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_438)))->BgL_z52eotz52))
{ /* Llib/midi.scm 326 */BFALSE; }  else 
{ /* Llib/midi.scm 326 */
BgL_eosz00_432 = ((bool_t)0); } } } 
{ 
long BgL_iz00_5089;
BgL_iz00_5089 = 
(BgL_iz00_435-((long)1)); 
BgL_iz00_435 = BgL_iz00_5089; 
goto BgL_zc3anonymousza31706ze3z83_436;} }  else 
{ /* Llib/midi.scm 320 */((bool_t)0); } } } 
if(BgL_eosz00_432)
{ /* Llib/midi.scm 328 */
return ((bool_t)0);}  else 
{ /* Llib/midi.scm 329 */
long BgL_usz00_448;
{ /* Llib/midi.scm 329 */
BGL_LONGLONG_T BgL_arg1747z00_453;
BgL_arg1747z00_453 = 
(
bgl_current_microseconds()-BgL_t0z00_431); 
{ /* Llib/midi.scm 329 */
long BgL_res2600z00_2020;
BgL_res2600z00_2020 = 
LLONG_TO_LONG(BgL_arg1747z00_453); 
BgL_usz00_448 = BgL_res2600z00_2020; } } 
{ /* Llib/midi.scm 331 */
obj_t BgL_fun1738z00_450;
BgL_fun1738z00_450 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msinkz00_33))->BgL_usleepz00); 
{ /* Llib/midi.scm 331 */
long BgL_arg1737z00_451;
BgL_arg1737z00_451 = 
(BgL_resz00_427-BgL_usz00_448); 
PROCEDURE_ENTRY(BgL_fun1738z00_450)(BgL_fun1738z00_450, 
BINT(BgL_arg1737z00_451), BEOA); } } 
{ 
uint32_t BgL_tickz00_5102;
BgL_tickz00_5102 = 
(BgL_tickz00_429+(uint32_t)(1)); 
BgL_tickz00_429 = BgL_tickz00_5102; 
goto BgL_zc3anonymousza31705ze3z83_430;} } } } } } } } 
BGL_FUNCTION_END;
}



/* miditrack-wait-event */
obj_t BGl_miditrackzd2waitzd2eventz00zz__multimediazd2midizd2(BgL_miditrackz00_bglt BgL_trackz00_34, BgL_midiplayerz00_bglt BgL_mplayerz00_35, BgL_midisinkz00_bglt BgL_msinkz00_36, long BgL_tickz00_37)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 337 */
{ /* Llib/midi.scm 340 */
BgL_midireaderz00_bglt BgL_i1157z00_461;
BgL_i1157z00_461 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52readerz52); 
{ /* Llib/midi.scm 341 */
bool_t BgL_testz00_5105;
{ /* Llib/midi.scm 341 */
uint32_t BgL_n2z00_2028;
BgL_n2z00_2028 = 
(uint32_t)(BgL_tickz00_37); 
BgL_testz00_5105 = 
(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52wtickz52)<=BgL_n2z00_2028); } 
if(BgL_testz00_5105)
{ 

BgL_zc3anonymousza31754ze3z83_465:
BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(BgL_trackz00_34, BgL_mplayerz00_35, BgL_msinkz00_36, BgL_tickz00_37, ((long)0), ((long)0), ((BGL_LONGLONG_T)0)); 
if(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52eotz52))
{ /* Llib/midi.scm 344 */
return BFALSE;}  else 
{ /* Llib/midi.scm 345 */
obj_t BgL_dtz00_467;
{ /* Llib/midi.scm 345 */
obj_t BgL_fun1759z00_470;
BgL_fun1759z00_470 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1157z00_461))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 345 */
obj_t BgL_arg1758z00_471;
BgL_arg1758z00_471 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52streamz52); 
BgL_dtz00_467 = 
PROCEDURE_ENTRY(BgL_fun1759z00_470)(BgL_fun1759z00_470, BgL_arg1758z00_471, BEOA); } } 
if(
(
(long)CINT(BgL_dtz00_467)==((long)0)))
{ /* Llib/midi.scm 346 */
goto BgL_zc3anonymousza31754ze3z83_465;}  else 
{ 
uint32_t BgL_auxz00_5121;
{ /* Llib/midi.scm 348 */
int32_t BgL_arg1757z00_469;
{ /* Llib/midi.scm 348 */
int32_t BgL_res2605z00_2033;
{ /* Llib/midi.scm 348 */
long BgL_xz00_2032;
BgL_xz00_2032 = 
(long)CINT(BgL_dtz00_467); 
BgL_res2605z00_2033 = 
(int32_t)(BgL_xz00_2032); } 
BgL_arg1757z00_469 = BgL_res2605z00_2033; } 
{ /* Llib/midi.scm 348 */
uint32_t BgL_za71za7_2034;uint32_t BgL_za72za7_2035;
BgL_za71za7_2034 = 
(uint32_t)(BgL_tickz00_37); 
BgL_za72za7_2035 = 
(uint32_t)(BgL_arg1757z00_469); 
BgL_auxz00_5121 = 
(BgL_za71za7_2034+BgL_za72za7_2035); } } 
return 
((((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52wtickz52)=((uint32_t)BgL_auxz00_5121),BUNSPEC);} } }  else 
{ /* Llib/midi.scm 341 */
return BFALSE;} } } } 
BGL_FUNCTION_END;
}



/* miditrack-play-event */
obj_t BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(BgL_miditrackz00_bglt BgL_trackz00_38, BgL_midiplayerz00_bglt BgL_mplayerz00_39, BgL_midisinkz00_bglt BgL_msinkz00_40, long BgL_tickz00_41, long BgL_ppqz00_42, long BgL_dtz00_43, BGL_LONGLONG_T BgL_t0z00_44)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 353 */
{ /* Llib/midi.scm 357 */
BgL_midireaderz00_bglt BgL_i1159z00_475;
BgL_i1159z00_475 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52readerz52); 
{ /* Llib/midi.scm 372 */
obj_t BgL_statusz00_477;
{ /* Llib/midi.scm 372 */
bool_t BgL_testz00_5129;
{ /* Llib/midi.scm 372 */
obj_t BgL_arg1966z00_711;
{ /* Llib/midi.scm 372 */
obj_t BgL_fun1968z00_712;
BgL_fun1968z00_712 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_peekzd2bytezd2); 
{ /* Llib/midi.scm 372 */
obj_t BgL_arg1967z00_713;
BgL_arg1967z00_713 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1966z00_711 = 
PROCEDURE_ENTRY(BgL_fun1968z00_712)(BgL_fun1968z00_712, BgL_arg1967z00_713, BEOA); } } 
BgL_testz00_5129 = 
(
(long)CINT(BgL_arg1966z00_711)<((long)128)); } 
if(BgL_testz00_5129)
{ /* Llib/midi.scm 372 */
BgL_statusz00_477 = 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52statusz52)); }  else 
{ /* Llib/midi.scm 374 */
obj_t BgL_sz00_708;
{ /* Llib/midi.scm 374 */
obj_t BgL_fun1965z00_709;
BgL_fun1965z00_709 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 374 */
obj_t BgL_arg1964z00_710;
BgL_arg1964z00_710 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_sz00_708 = 
PROCEDURE_ENTRY(BgL_fun1965z00_709)(BgL_fun1965z00_709, BgL_arg1964z00_710, BEOA); } } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52statusz52)=((long)
(long)CINT(BgL_sz00_708)),BUNSPEC); 
BgL_statusz00_477 = BgL_sz00_708; } } 
if(
(
(
(long)CINT(BgL_statusz00_477) >> 
(int)(((long)4)))==((long)8)))
{ /* Llib/midi.scm 380 */
long BgL_kkz00_480;
{ /* Llib/midi.scm 380 */
obj_t BgL_arg1772z00_491;
{ /* Llib/midi.scm 380 */
obj_t BgL_fun1774z00_492;
BgL_fun1774z00_492 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 380 */
obj_t BgL_arg1773z00_493;
BgL_arg1773z00_493 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1772z00_491 = 
PROCEDURE_ENTRY(BgL_fun1774z00_492)(BgL_fun1774z00_492, BgL_arg1773z00_493, BEOA); } } 
BgL_kkz00_480 = 
(((long)127) & 
(long)CINT(BgL_arg1772z00_491)); } 
{ /* Llib/midi.scm 380 */
long BgL_vvz00_481;
{ /* Llib/midi.scm 381 */
obj_t BgL_arg1769z00_488;
{ /* Llib/midi.scm 381 */
obj_t BgL_fun1771z00_489;
BgL_fun1771z00_489 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 381 */
obj_t BgL_arg1770z00_490;
BgL_arg1770z00_490 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1769z00_488 = 
PROCEDURE_ENTRY(BgL_fun1771z00_489)(BgL_fun1771z00_489, BgL_arg1770z00_490, BEOA); } } 
BgL_vvz00_481 = 
(((long)127) & 
(long)CINT(BgL_arg1769z00_488)); } 
{ /* Llib/midi.scm 381 */

{ /* Llib/midi.scm 382 */
obj_t BgL_fun1764z00_482;
BgL_fun1764z00_482 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 383 */
long BgL_arg1763z00_483;
{ /* Llib/midi.scm 383 */
BGL_LONGLONG_T BgL_arg1765z00_484;
BgL_arg1765z00_484 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 383 */
long BgL_res2614z00_2054;
BgL_res2614z00_2054 = 
LLONG_TO_LONG(BgL_arg1765z00_484); 
BgL_arg1763z00_483 = BgL_res2614z00_2054; } } 
PROCEDURE_ENTRY(BgL_fun1764z00_482)(BgL_fun1764z00_482, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1763z00_483), BEOA); } } 
{ /* Llib/midi.scm 384 */
obj_t BgL_fun1768z00_486;
BgL_fun1768z00_486 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_noteoffz00); 
{ /* Llib/midi.scm 384 */
long BgL_arg1767z00_487;
BgL_arg1767z00_487 = 
(
(long)CINT(BgL_statusz00_477) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1768z00_486)(BgL_fun1768z00_486, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1767z00_487), 
BINT(BgL_kkz00_480), 
BINT(BgL_vvz00_481), BEOA); } } } } }  else 
{ /* Llib/midi.scm 378 */
if(
(
(
(long)CINT(BgL_statusz00_477) >> 
(int)(((long)4)))==((long)9)))
{ /* Llib/midi.scm 387 */
long BgL_kkz00_496;
{ /* Llib/midi.scm 387 */
obj_t BgL_arg1786z00_507;
{ /* Llib/midi.scm 387 */
obj_t BgL_fun1788z00_508;
BgL_fun1788z00_508 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 387 */
obj_t BgL_arg1787z00_509;
BgL_arg1787z00_509 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1786z00_507 = 
PROCEDURE_ENTRY(BgL_fun1788z00_508)(BgL_fun1788z00_508, BgL_arg1787z00_509, BEOA); } } 
BgL_kkz00_496 = 
(((long)127) & 
(long)CINT(BgL_arg1786z00_507)); } 
{ /* Llib/midi.scm 387 */
long BgL_vvz00_497;
{ /* Llib/midi.scm 388 */
obj_t BgL_arg1783z00_504;
{ /* Llib/midi.scm 388 */
obj_t BgL_fun1785z00_505;
BgL_fun1785z00_505 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 388 */
obj_t BgL_arg1784z00_506;
BgL_arg1784z00_506 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1783z00_504 = 
PROCEDURE_ENTRY(BgL_fun1785z00_505)(BgL_fun1785z00_505, BgL_arg1784z00_506, BEOA); } } 
BgL_vvz00_497 = 
(((long)127) & 
(long)CINT(BgL_arg1783z00_504)); } 
{ /* Llib/midi.scm 388 */

{ /* Llib/midi.scm 389 */
obj_t BgL_fun1778z00_498;
BgL_fun1778z00_498 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 390 */
long BgL_arg1777z00_499;
{ /* Llib/midi.scm 390 */
BGL_LONGLONG_T BgL_arg1779z00_500;
BgL_arg1779z00_500 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 390 */
long BgL_res2622z00_2072;
BgL_res2622z00_2072 = 
LLONG_TO_LONG(BgL_arg1779z00_500); 
BgL_arg1777z00_499 = BgL_res2622z00_2072; } } 
PROCEDURE_ENTRY(BgL_fun1778z00_498)(BgL_fun1778z00_498, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1777z00_499), BEOA); } } 
{ /* Llib/midi.scm 391 */
obj_t BgL_fun1782z00_502;
BgL_fun1782z00_502 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_noteonz00); 
{ /* Llib/midi.scm 391 */
long BgL_arg1781z00_503;
BgL_arg1781z00_503 = 
(
(long)CINT(BgL_statusz00_477) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1782z00_502)(BgL_fun1782z00_502, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1781z00_503), 
BINT(BgL_kkz00_496), 
BINT(BgL_vvz00_497), BEOA); } } } } }  else 
{ /* Llib/midi.scm 385 */
if(
(
(
(long)CINT(BgL_statusz00_477) >> 
(int)(((long)4)))==((long)10)))
{ /* Llib/midi.scm 394 */
long BgL_ccz00_512;
{ /* Llib/midi.scm 394 */
obj_t BgL_arg1800z00_523;
{ /* Llib/midi.scm 394 */
obj_t BgL_fun1802z00_524;
BgL_fun1802z00_524 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 394 */
obj_t BgL_arg1801z00_525;
BgL_arg1801z00_525 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1800z00_523 = 
PROCEDURE_ENTRY(BgL_fun1802z00_524)(BgL_fun1802z00_524, BgL_arg1801z00_525, BEOA); } } 
BgL_ccz00_512 = 
(((long)127) & 
(long)CINT(BgL_arg1800z00_523)); } 
{ /* Llib/midi.scm 394 */
long BgL_vvz00_513;
{ /* Llib/midi.scm 395 */
obj_t BgL_arg1797z00_520;
{ /* Llib/midi.scm 395 */
obj_t BgL_fun1799z00_521;
BgL_fun1799z00_521 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 395 */
obj_t BgL_arg1798z00_522;
BgL_arg1798z00_522 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1797z00_520 = 
PROCEDURE_ENTRY(BgL_fun1799z00_521)(BgL_fun1799z00_521, BgL_arg1798z00_522, BEOA); } } 
BgL_vvz00_513 = 
(((long)127) & 
(long)CINT(BgL_arg1797z00_520)); } 
{ /* Llib/midi.scm 395 */

{ /* Llib/midi.scm 396 */
obj_t BgL_fun1792z00_514;
BgL_fun1792z00_514 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 397 */
long BgL_arg1791z00_515;
{ /* Llib/midi.scm 397 */
BGL_LONGLONG_T BgL_arg1793z00_516;
BgL_arg1793z00_516 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 397 */
long BgL_res2630z00_2090;
BgL_res2630z00_2090 = 
LLONG_TO_LONG(BgL_arg1793z00_516); 
BgL_arg1791z00_515 = BgL_res2630z00_2090; } } 
PROCEDURE_ENTRY(BgL_fun1792z00_514)(BgL_fun1792z00_514, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1791z00_515), BEOA); } } 
{ /* Llib/midi.scm 398 */
obj_t BgL_fun1796z00_518;
BgL_fun1796z00_518 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_aftertouchz00); 
{ /* Llib/midi.scm 398 */
long BgL_arg1795z00_519;
BgL_arg1795z00_519 = 
(
(long)CINT(BgL_statusz00_477) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1796z00_518)(BgL_fun1796z00_518, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1795z00_519), 
BINT(BgL_ccz00_512), 
BINT(BgL_vvz00_513), BEOA); } } } } }  else 
{ /* Llib/midi.scm 392 */
if(
(
(
(long)CINT(BgL_statusz00_477) >> 
(int)(((long)4)))==((long)11)))
{ /* Llib/midi.scm 401 */
long BgL_ccz00_528;
{ /* Llib/midi.scm 401 */
obj_t BgL_arg1814z00_539;
{ /* Llib/midi.scm 401 */
obj_t BgL_fun1816z00_540;
BgL_fun1816z00_540 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 401 */
obj_t BgL_arg1815z00_541;
BgL_arg1815z00_541 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1814z00_539 = 
PROCEDURE_ENTRY(BgL_fun1816z00_540)(BgL_fun1816z00_540, BgL_arg1815z00_541, BEOA); } } 
BgL_ccz00_528 = 
(((long)127) & 
(long)CINT(BgL_arg1814z00_539)); } 
{ /* Llib/midi.scm 401 */
long BgL_nnz00_529;
{ /* Llib/midi.scm 402 */
obj_t BgL_arg1811z00_536;
{ /* Llib/midi.scm 402 */
obj_t BgL_fun1813z00_537;
BgL_fun1813z00_537 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 402 */
obj_t BgL_arg1812z00_538;
BgL_arg1812z00_538 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1811z00_536 = 
PROCEDURE_ENTRY(BgL_fun1813z00_537)(BgL_fun1813z00_537, BgL_arg1812z00_538, BEOA); } } 
BgL_nnz00_529 = 
(((long)127) & 
(long)CINT(BgL_arg1811z00_536)); } 
{ /* Llib/midi.scm 402 */

{ /* Llib/midi.scm 403 */
obj_t BgL_fun1806z00_530;
BgL_fun1806z00_530 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 404 */
long BgL_arg1805z00_531;
{ /* Llib/midi.scm 404 */
BGL_LONGLONG_T BgL_arg1807z00_532;
BgL_arg1807z00_532 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 404 */
long BgL_res2638z00_2108;
BgL_res2638z00_2108 = 
LLONG_TO_LONG(BgL_arg1807z00_532); 
BgL_arg1805z00_531 = BgL_res2638z00_2108; } } 
PROCEDURE_ENTRY(BgL_fun1806z00_530)(BgL_fun1806z00_530, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1805z00_531), BEOA); } } 
{ /* Llib/midi.scm 405 */
obj_t BgL_fun1810z00_534;
BgL_fun1810z00_534 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_ctrlchangez00); 
{ /* Llib/midi.scm 405 */
long BgL_arg1809z00_535;
BgL_arg1809z00_535 = 
(
(long)CINT(BgL_statusz00_477) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1810z00_534)(BgL_fun1810z00_534, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1809z00_535), 
BINT(BgL_ccz00_528), 
BINT(BgL_nnz00_529), BEOA); } } } } }  else 
{ /* Llib/midi.scm 399 */
if(
(
(
(long)CINT(BgL_statusz00_477) >> 
(int)(((long)4)))==((long)12)))
{ /* Llib/midi.scm 408 */
long BgL_ppz00_544;
{ /* Llib/midi.scm 408 */
obj_t BgL_arg1825z00_551;
{ /* Llib/midi.scm 408 */
obj_t BgL_fun1827z00_552;
BgL_fun1827z00_552 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 408 */
obj_t BgL_arg1826z00_553;
BgL_arg1826z00_553 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1825z00_551 = 
PROCEDURE_ENTRY(BgL_fun1827z00_552)(BgL_fun1827z00_552, BgL_arg1826z00_553, BEOA); } } 
BgL_ppz00_544 = 
(((long)127) & 
(long)CINT(BgL_arg1825z00_551)); } 
{ /* Llib/midi.scm 409 */
obj_t BgL_fun1820z00_545;
BgL_fun1820z00_545 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 410 */
long BgL_arg1819z00_546;
{ /* Llib/midi.scm 410 */
BGL_LONGLONG_T BgL_arg1821z00_547;
BgL_arg1821z00_547 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 410 */
long BgL_res2645z00_2123;
BgL_res2645z00_2123 = 
LLONG_TO_LONG(BgL_arg1821z00_547); 
BgL_arg1819z00_546 = BgL_res2645z00_2123; } } 
PROCEDURE_ENTRY(BgL_fun1820z00_545)(BgL_fun1820z00_545, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1819z00_546), BEOA); } } 
{ /* Llib/midi.scm 411 */
obj_t BgL_fun1824z00_549;
BgL_fun1824z00_549 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_prgmchangez00); 
{ /* Llib/midi.scm 411 */
long BgL_arg1823z00_550;
BgL_arg1823z00_550 = 
(
(long)CINT(BgL_statusz00_477) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1824z00_549)(BgL_fun1824z00_549, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1823z00_550), 
BINT(BgL_ppz00_544), BEOA); } } }  else 
{ /* Llib/midi.scm 406 */
if(
(
(
(long)CINT(BgL_statusz00_477) >> 
(int)(((long)4)))==((long)13)))
{ /* Llib/midi.scm 414 */
long BgL_ppz00_556;
{ /* Llib/midi.scm 414 */
obj_t BgL_arg1836z00_563;
{ /* Llib/midi.scm 414 */
obj_t BgL_fun1838z00_564;
BgL_fun1838z00_564 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 414 */
obj_t BgL_arg1837z00_565;
BgL_arg1837z00_565 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1836z00_563 = 
PROCEDURE_ENTRY(BgL_fun1838z00_564)(BgL_fun1838z00_564, BgL_arg1837z00_565, BEOA); } } 
BgL_ppz00_556 = 
(((long)127) & 
(long)CINT(BgL_arg1836z00_563)); } 
{ /* Llib/midi.scm 415 */
obj_t BgL_fun1831z00_557;
BgL_fun1831z00_557 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 416 */
long BgL_arg1830z00_558;
{ /* Llib/midi.scm 416 */
BGL_LONGLONG_T BgL_arg1832z00_559;
BgL_arg1832z00_559 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 416 */
long BgL_res2652z00_2138;
BgL_res2652z00_2138 = 
LLONG_TO_LONG(BgL_arg1832z00_559); 
BgL_arg1830z00_558 = BgL_res2652z00_2138; } } 
PROCEDURE_ENTRY(BgL_fun1831z00_557)(BgL_fun1831z00_557, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1830z00_558), BEOA); } } 
{ /* Llib/midi.scm 417 */
obj_t BgL_fun1835z00_561;
BgL_fun1835z00_561 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_afterzd2touchzd2); 
{ /* Llib/midi.scm 417 */
long BgL_arg1834z00_562;
BgL_arg1834z00_562 = 
(
(long)CINT(BgL_statusz00_477) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1835z00_561)(BgL_fun1835z00_561, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1834z00_562), 
BINT(BgL_ppz00_556), BEOA); } } }  else 
{ /* Llib/midi.scm 412 */
if(
(
(
(long)CINT(BgL_statusz00_477) >> 
(int)(((long)4)))==((long)14)))
{ /* Llib/midi.scm 420 */
long BgL_ccz00_568;
{ /* Llib/midi.scm 420 */
obj_t BgL_arg1850z00_579;
{ /* Llib/midi.scm 420 */
obj_t BgL_fun1852z00_580;
BgL_fun1852z00_580 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 420 */
obj_t BgL_arg1851z00_581;
BgL_arg1851z00_581 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1850z00_579 = 
PROCEDURE_ENTRY(BgL_fun1852z00_580)(BgL_fun1852z00_580, BgL_arg1851z00_581, BEOA); } } 
BgL_ccz00_568 = 
(((long)127) & 
(long)CINT(BgL_arg1850z00_579)); } 
{ /* Llib/midi.scm 420 */
long BgL_vvz00_569;
{ /* Llib/midi.scm 421 */
obj_t BgL_arg1847z00_576;
{ /* Llib/midi.scm 421 */
obj_t BgL_fun1849z00_577;
BgL_fun1849z00_577 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 421 */
obj_t BgL_arg1848z00_578;
BgL_arg1848z00_578 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1847z00_576 = 
PROCEDURE_ENTRY(BgL_fun1849z00_577)(BgL_fun1849z00_577, BgL_arg1848z00_578, BEOA); } } 
BgL_vvz00_569 = 
(((long)127) & 
(long)CINT(BgL_arg1847z00_576)); } 
{ /* Llib/midi.scm 421 */

{ /* Llib/midi.scm 422 */
obj_t BgL_fun1842z00_570;
BgL_fun1842z00_570 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 423 */
long BgL_arg1841z00_571;
{ /* Llib/midi.scm 423 */
BGL_LONGLONG_T BgL_arg1843z00_572;
BgL_arg1843z00_572 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 423 */
long BgL_res2660z00_2156;
BgL_res2660z00_2156 = 
LLONG_TO_LONG(BgL_arg1843z00_572); 
BgL_arg1841z00_571 = BgL_res2660z00_2156; } } 
PROCEDURE_ENTRY(BgL_fun1842z00_570)(BgL_fun1842z00_570, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1841z00_571), BEOA); } } 
{ /* Llib/midi.scm 424 */
obj_t BgL_fun1846z00_574;
BgL_fun1846z00_574 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_pitchz00); 
{ /* Llib/midi.scm 424 */
long BgL_arg1845z00_575;
BgL_arg1845z00_575 = 
(
(long)CINT(BgL_statusz00_477) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1846z00_574)(BgL_fun1846z00_574, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1845z00_575), 
BINT(BgL_ccz00_568), 
BINT(BgL_vvz00_569), BEOA); } } } } }  else 
{ /* Llib/midi.scm 418 */
if(
(
(long)CINT(BgL_statusz00_477)==((long)255)))
{ /* Llib/midi.scm 427 */
obj_t BgL_cz00_583;
{ /* Llib/midi.scm 427 */
obj_t BgL_fun1939z00_680;
BgL_fun1939z00_680 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 427 */
obj_t BgL_arg1938z00_681;
BgL_arg1938z00_681 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_cz00_583 = 
PROCEDURE_ENTRY(BgL_fun1939z00_680)(BgL_fun1939z00_680, BgL_arg1938z00_681, BEOA); } } 
{ /* Llib/midi.scm 427 */
obj_t BgL_lz00_584;
{ /* Llib/midi.scm 428 */
obj_t BgL_fun1937z00_678;
BgL_fun1937z00_678 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 428 */
obj_t BgL_arg1936z00_679;
BgL_arg1936z00_679 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_lz00_584 = 
PROCEDURE_ENTRY(BgL_fun1937z00_678)(BgL_fun1937z00_678, BgL_arg1936z00_679, BEOA); } } 
{ /* Llib/midi.scm 428 */

{ 

if(
INTEGERP(BgL_cz00_583))
{ /* Llib/midi.scm 429 */
switch( 
(long)CINT(BgL_cz00_583)) { case ((long)0) : 

{ /* Llib/midi.scm 432 */
obj_t BgL_fun1856z00_588;
BgL_fun1856z00_588 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2seqnumzd2); 
{ /* Llib/midi.scm 432 */
int32_t BgL_arg1855z00_589;
BgL_arg1855z00_589 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52)); 
PROCEDURE_ENTRY(BgL_fun1856z00_588)(BgL_fun1856z00_588, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BGL_INT32_TO_BINT32(BgL_arg1855z00_589), BEOA); } } break;case ((long)1) : 

{ /* Llib/midi.scm 435 */
obj_t BgL_fun1859z00_591;
BgL_fun1859z00_591 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2textzd2); 
{ /* Llib/midi.scm 435 */
obj_t BgL_arg1858z00_592;
{ /* Llib/midi.scm 435 */
obj_t BgL_fun1861z00_593;
BgL_fun1861z00_593 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 435 */
obj_t BgL_arg1860z00_594;
BgL_arg1860z00_594 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1858z00_592 = 
PROCEDURE_ENTRY(BgL_fun1861z00_593)(BgL_fun1861z00_593, BgL_lz00_584, BgL_arg1860z00_594, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1859z00_591)(BgL_fun1859z00_591, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1858z00_592, BEOA); } } break;case ((long)2) : 

{ /* Llib/midi.scm 438 */
obj_t BgL_fun1863z00_595;
BgL_fun1863z00_595 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2copyrightzd2); 
{ /* Llib/midi.scm 438 */
obj_t BgL_arg1862z00_596;
{ /* Llib/midi.scm 438 */
obj_t BgL_fun1865z00_597;
BgL_fun1865z00_597 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 438 */
obj_t BgL_arg1864z00_598;
BgL_arg1864z00_598 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1862z00_596 = 
PROCEDURE_ENTRY(BgL_fun1865z00_597)(BgL_fun1865z00_597, BgL_lz00_584, BgL_arg1864z00_598, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1863z00_595)(BgL_fun1863z00_595, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1862z00_596, BEOA); } } break;case ((long)3) : 

{ /* Llib/midi.scm 441 */
obj_t BgL_fun1867z00_599;
BgL_fun1867z00_599 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2trackzd2); 
{ /* Llib/midi.scm 441 */
obj_t BgL_arg1866z00_600;
{ /* Llib/midi.scm 441 */
obj_t BgL_fun1869z00_601;
BgL_fun1869z00_601 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 441 */
obj_t BgL_arg1868z00_602;
BgL_arg1868z00_602 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1866z00_600 = 
PROCEDURE_ENTRY(BgL_fun1869z00_601)(BgL_fun1869z00_601, BgL_lz00_584, BgL_arg1868z00_602, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1867z00_599)(BgL_fun1867z00_599, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1866z00_600, BEOA); } } break;case ((long)4) : 

{ /* Llib/midi.scm 444 */
obj_t BgL_fun1871z00_603;
BgL_fun1871z00_603 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2instrumentzd2); 
{ /* Llib/midi.scm 444 */
obj_t BgL_arg1870z00_604;
{ /* Llib/midi.scm 444 */
obj_t BgL_fun1873z00_605;
BgL_fun1873z00_605 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 444 */
obj_t BgL_arg1872z00_606;
BgL_arg1872z00_606 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1870z00_604 = 
PROCEDURE_ENTRY(BgL_fun1873z00_605)(BgL_fun1873z00_605, BgL_lz00_584, BgL_arg1872z00_606, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1871z00_603)(BgL_fun1871z00_603, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1870z00_604, BEOA); } } break;case ((long)5) : 

{ /* Llib/midi.scm 447 */
obj_t BgL_fun1875z00_607;
BgL_fun1875z00_607 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2lyriczd2); 
{ /* Llib/midi.scm 447 */
obj_t BgL_arg1874z00_608;
{ /* Llib/midi.scm 447 */
obj_t BgL_fun1877z00_609;
BgL_fun1877z00_609 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 447 */
obj_t BgL_arg1876z00_610;
BgL_arg1876z00_610 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1874z00_608 = 
PROCEDURE_ENTRY(BgL_fun1877z00_609)(BgL_fun1877z00_609, BgL_lz00_584, BgL_arg1876z00_610, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1875z00_607)(BgL_fun1875z00_607, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1874z00_608, BEOA); } } break;case ((long)6) : 

{ /* Llib/midi.scm 450 */
obj_t BgL_fun1879z00_611;
BgL_fun1879z00_611 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2markerzd2); 
{ /* Llib/midi.scm 450 */
obj_t BgL_arg1878z00_612;
{ /* Llib/midi.scm 450 */
obj_t BgL_fun1881z00_613;
BgL_fun1881z00_613 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 450 */
obj_t BgL_arg1880z00_614;
BgL_arg1880z00_614 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1878z00_612 = 
PROCEDURE_ENTRY(BgL_fun1881z00_613)(BgL_fun1881z00_613, BgL_lz00_584, BgL_arg1880z00_614, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1879z00_611)(BgL_fun1879z00_611, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1878z00_612, BEOA); } } break;case ((long)7) : 

{ /* Llib/midi.scm 453 */
obj_t BgL_fun1883z00_615;
BgL_fun1883z00_615 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2cuezd2); 
{ /* Llib/midi.scm 453 */
obj_t BgL_arg1882z00_616;
{ /* Llib/midi.scm 453 */
obj_t BgL_fun1885z00_617;
BgL_fun1885z00_617 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 453 */
obj_t BgL_arg1884z00_618;
BgL_arg1884z00_618 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1882z00_616 = 
PROCEDURE_ENTRY(BgL_fun1885z00_617)(BgL_fun1885z00_617, BgL_lz00_584, BgL_arg1884z00_618, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1883z00_615)(BgL_fun1883z00_615, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1882z00_616, BEOA); } } break;case ((long)8) : 

{ /* Llib/midi.scm 456 */
obj_t BgL_fun1887z00_619;
BgL_fun1887z00_619 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2prgmnamezd2); 
{ /* Llib/midi.scm 456 */
obj_t BgL_arg1886z00_620;
{ /* Llib/midi.scm 456 */
obj_t BgL_fun1889z00_621;
BgL_fun1889z00_621 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 456 */
obj_t BgL_arg1888z00_622;
BgL_arg1888z00_622 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1886z00_620 = 
PROCEDURE_ENTRY(BgL_fun1889z00_621)(BgL_fun1889z00_621, BgL_lz00_584, BgL_arg1888z00_622, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1887z00_619)(BgL_fun1887z00_619, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1886z00_620, BEOA); } } break;case ((long)9) : 

{ /* Llib/midi.scm 459 */
obj_t BgL_fun1891z00_623;
BgL_fun1891z00_623 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2devnamezd2); 
{ /* Llib/midi.scm 459 */
obj_t BgL_arg1890z00_624;
{ /* Llib/midi.scm 459 */
obj_t BgL_fun1893z00_625;
BgL_fun1893z00_625 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 459 */
obj_t BgL_arg1892z00_626;
BgL_arg1892z00_626 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1890z00_624 = 
PROCEDURE_ENTRY(BgL_fun1893z00_625)(BgL_fun1893z00_625, BgL_lz00_584, BgL_arg1892z00_626, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1891z00_623)(BgL_fun1891z00_623, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1890z00_624, BEOA); } } break;case ((long)32) : 

{ /* Llib/midi.scm 462 */
obj_t BgL_fun1895z00_627;
BgL_fun1895z00_627 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2channprefzd2); 
{ /* Llib/midi.scm 462 */
obj_t BgL_arg1894z00_628;
{ /* Llib/midi.scm 462 */
obj_t BgL_fun1897z00_629;
BgL_fun1897z00_629 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 462 */
obj_t BgL_arg1896z00_630;
BgL_arg1896z00_630 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1894z00_628 = 
PROCEDURE_ENTRY(BgL_fun1897z00_629)(BgL_fun1897z00_629, BgL_arg1896z00_630, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1895z00_627)(BgL_fun1895z00_627, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1894z00_628, BEOA); } } break;case ((long)33) : 

{ /* Llib/midi.scm 465 */
obj_t BgL_fun1899z00_631;
BgL_fun1899z00_631 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2channprefzd2); 
{ /* Llib/midi.scm 465 */
long BgL_arg1898z00_632;
BgL_arg1898z00_632 = 
BGl_readzd2intzd2zz__multimediazd2midizd2(
(long)CINT(BgL_lz00_584), 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52)); 
PROCEDURE_ENTRY(BgL_fun1899z00_631)(BgL_fun1899z00_631, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1898z00_632), BEOA); } } break;case ((long)47) : 

((((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52eotz52)=((bool_t)((bool_t)1)),BUNSPEC); 
{ /* Llib/midi.scm 469 */
obj_t BgL_fun1901z00_634;
BgL_fun1901z00_634 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2eotzd2); 
PROCEDURE_ENTRY(BgL_fun1901z00_634)(BgL_fun1901z00_634, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BUNSPEC, BEOA); } break;case ((long)81) : 

{ 
long BgL_auxz00_5785;
{ /* Llib/midi.scm 472 */
obj_t BgL_arg1902z00_635;
BgL_arg1902z00_635 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_auxz00_5785 = 
BGl_readzd2intzd2zz__multimediazd2midizd2(
(long)CINT(BgL_lz00_584), BgL_arg1902z00_635); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_tempoz00)=((long)BgL_auxz00_5785),BUNSPEC); } 
{ /* Llib/midi.scm 473 */
obj_t BgL_fun1904z00_636;
BgL_fun1904z00_636 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2tempozd2); 
{ /* Llib/midi.scm 473 */
long BgL_arg1903z00_637;
BgL_arg1903z00_637 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_tempoz00); 
PROCEDURE_ENTRY(BgL_fun1904z00_636)(BgL_fun1904z00_636, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1903z00_637), BEOA); } } break;case ((long)84) : 

{ /* Llib/midi.scm 476 */
obj_t BgL_hrz00_638;
{ /* Llib/midi.scm 476 */
obj_t BgL_fun1915z00_652;
BgL_fun1915z00_652 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 476 */
obj_t BgL_arg1914z00_653;
BgL_arg1914z00_653 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_hrz00_638 = 
PROCEDURE_ENTRY(BgL_fun1915z00_652)(BgL_fun1915z00_652, BgL_arg1914z00_653, BEOA); } } 
{ /* Llib/midi.scm 476 */
obj_t BgL_mmz00_639;
{ /* Llib/midi.scm 477 */
obj_t BgL_fun1913z00_650;
BgL_fun1913z00_650 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 477 */
obj_t BgL_arg1912z00_651;
BgL_arg1912z00_651 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_mmz00_639 = 
PROCEDURE_ENTRY(BgL_fun1913z00_650)(BgL_fun1913z00_650, BgL_arg1912z00_651, BEOA); } } 
{ /* Llib/midi.scm 477 */
obj_t BgL_sez00_640;
{ /* Llib/midi.scm 478 */
obj_t BgL_fun1911z00_648;
BgL_fun1911z00_648 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 478 */
obj_t BgL_arg1910z00_649;
BgL_arg1910z00_649 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_sez00_640 = 
PROCEDURE_ENTRY(BgL_fun1911z00_648)(BgL_fun1911z00_648, BgL_arg1910z00_649, BEOA); } } 
{ /* Llib/midi.scm 478 */
obj_t BgL_frz00_641;
{ /* Llib/midi.scm 479 */
obj_t BgL_fun1909z00_646;
BgL_fun1909z00_646 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 479 */
obj_t BgL_arg1908z00_647;
BgL_arg1908z00_647 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_frz00_641 = 
PROCEDURE_ENTRY(BgL_fun1909z00_646)(BgL_fun1909z00_646, BgL_arg1908z00_647, BEOA); } } 
{ /* Llib/midi.scm 479 */
obj_t BgL_ffz00_642;
{ /* Llib/midi.scm 480 */
obj_t BgL_fun1907z00_644;
BgL_fun1907z00_644 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 480 */
obj_t BgL_arg1906z00_645;
BgL_arg1906z00_645 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_ffz00_642 = 
PROCEDURE_ENTRY(BgL_fun1907z00_644)(BgL_fun1907z00_644, BgL_arg1906z00_645, BEOA); } } 
{ /* Llib/midi.scm 480 */

{ /* Llib/midi.scm 481 */
obj_t BgL_fun1905z00_643;
BgL_fun1905z00_643 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2smtpezd2); 
PROCEDURE_ENTRY(BgL_fun1905z00_643)(BgL_fun1905z00_643, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_hrz00_638, BgL_mmz00_639, BgL_sez00_640, BgL_frz00_641, BgL_ffz00_642, BEOA); } } } } } } } break;case ((long)88) : 

{ /* Llib/midi.scm 484 */
obj_t BgL_nnz00_654;
{ /* Llib/midi.scm 484 */
obj_t BgL_fun1924z00_665;
BgL_fun1924z00_665 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 484 */
obj_t BgL_arg1923z00_666;
BgL_arg1923z00_666 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_nnz00_654 = 
PROCEDURE_ENTRY(BgL_fun1924z00_665)(BgL_fun1924z00_665, BgL_arg1923z00_666, BEOA); } } 
{ /* Llib/midi.scm 484 */
obj_t BgL_ddz00_655;
{ /* Llib/midi.scm 485 */
obj_t BgL_fun1922z00_663;
BgL_fun1922z00_663 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 485 */
obj_t BgL_arg1921z00_664;
BgL_arg1921z00_664 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_ddz00_655 = 
PROCEDURE_ENTRY(BgL_fun1922z00_663)(BgL_fun1922z00_663, BgL_arg1921z00_664, BEOA); } } 
{ /* Llib/midi.scm 485 */
obj_t BgL_ccz00_656;
{ /* Llib/midi.scm 486 */
obj_t BgL_fun1920z00_661;
BgL_fun1920z00_661 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 486 */
obj_t BgL_arg1919z00_662;
BgL_arg1919z00_662 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_ccz00_656 = 
PROCEDURE_ENTRY(BgL_fun1920z00_661)(BgL_fun1920z00_661, BgL_arg1919z00_662, BEOA); } } 
{ /* Llib/midi.scm 486 */
obj_t BgL_bbz00_657;
{ /* Llib/midi.scm 487 */
obj_t BgL_fun1918z00_659;
BgL_fun1918z00_659 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 487 */
obj_t BgL_arg1917z00_660;
BgL_arg1917z00_660 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_bbz00_657 = 
PROCEDURE_ENTRY(BgL_fun1918z00_659)(BgL_fun1918z00_659, BgL_arg1917z00_660, BEOA); } } 
{ /* Llib/midi.scm 487 */

{ /* Llib/midi.scm 488 */
obj_t BgL_fun1916z00_658;
BgL_fun1916z00_658 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2timesigzd2); 
PROCEDURE_ENTRY(BgL_fun1916z00_658)(BgL_fun1916z00_658, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_nnz00_654, BgL_ddz00_655, BgL_ccz00_656, BgL_bbz00_657, BEOA); } } } } } } break;case ((long)89) : 

{ /* Llib/midi.scm 491 */
obj_t BgL_fun1926z00_667;
BgL_fun1926z00_667 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2keysigzd2); 
{ /* Llib/midi.scm 491 */
long BgL_arg1925z00_668;
BgL_arg1925z00_668 = 
BGl_readzd2intzd2zz__multimediazd2midizd2(
(long)CINT(BgL_lz00_584), 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52)); 
PROCEDURE_ENTRY(BgL_fun1926z00_667)(BgL_fun1926z00_667, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1925z00_668), BEOA); } } break;case ((long)127) : 

{ /* Llib/midi.scm 494 */
obj_t BgL_fun1929z00_670;
BgL_fun1929z00_670 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2seqspeczd2); 
{ /* Llib/midi.scm 494 */
obj_t BgL_arg1928z00_671;
{ /* Llib/midi.scm 494 */
obj_t BgL_fun1931z00_672;
BgL_fun1931z00_672 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 494 */
obj_t BgL_arg1930z00_673;
BgL_arg1930z00_673 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1928z00_671 = 
PROCEDURE_ENTRY(BgL_fun1931z00_672)(BgL_fun1931z00_672, BgL_lz00_584, BgL_arg1930z00_673, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1929z00_670)(BgL_fun1929z00_670, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1928z00_671, BEOA); } } break;
default: 
BgL_case_else1161z00_585:
{ /* Llib/midi.scm 496 */
obj_t BgL_fun1933z00_674;
BgL_fun1933z00_674 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_errz00); 
{ /* Llib/midi.scm 497 */
obj_t BgL_arg1932z00_675;
{ /* Llib/midi.scm 497 */
obj_t BgL_list1934z00_676;
{ /* Llib/midi.scm 497 */
obj_t BgL_arg1935z00_677;
BgL_arg1935z00_677 = 
MAKE_YOUNG_PAIR(BgL_cz00_583, BNIL); 
BgL_list1934z00_676 = 
MAKE_YOUNG_PAIR(BgL_statusz00_477, BgL_arg1935z00_677); } 
BgL_arg1932z00_675 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3078z00zz__multimediazd2midizd2, BgL_list1934z00_676); } 
PROCEDURE_ENTRY(BgL_fun1933z00_674)(BgL_fun1933z00_674, BGl_string3079z00zz__multimediazd2midizd2, BGl_string3080z00zz__multimediazd2midizd2, BgL_arg1932z00_675, BEOA); } } } }  else 
{ /* Llib/midi.scm 429 */
goto BgL_case_else1161z00_585;} } } } }  else 
{ /* Llib/midi.scm 498 */
bool_t BgL_testz00_5931;
if(
(
(long)CINT(BgL_statusz00_477)==((long)240)))
{ /* Llib/midi.scm 498 */
BgL_testz00_5931 = ((bool_t)1)
; }  else 
{ /* Llib/midi.scm 498 */
BgL_testz00_5931 = 
(
(long)CINT(BgL_statusz00_477)==((long)247))
; } 
if(BgL_testz00_5931)
{ /* Llib/midi.scm 500 */
obj_t BgL_strz00_684;
{ /* Llib/midi.scm 500 */
obj_t BgL_fun1949z00_690;
BgL_fun1949z00_690 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 500 */
obj_t BgL_arg1947z00_691;obj_t BgL_arg1948z00_692;
{ /* Llib/midi.scm 500 */
obj_t BgL_fun1951z00_693;
BgL_fun1951z00_693 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1159z00_475))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 500 */
obj_t BgL_arg1950z00_694;
BgL_arg1950z00_694 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1947z00_691 = 
PROCEDURE_ENTRY(BgL_fun1951z00_693)(BgL_fun1951z00_693, BgL_arg1950z00_694, BEOA); } } 
BgL_arg1948z00_692 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_strz00_684 = 
PROCEDURE_ENTRY(BgL_fun1949z00_690)(BgL_fun1949z00_690, BgL_arg1947z00_691, BgL_arg1948z00_692, BEOA); } } 
{ /* Llib/midi.scm 501 */
obj_t BgL_fun1943z00_685;
BgL_fun1943z00_685 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 502 */
long BgL_arg1942z00_686;
{ /* Llib/midi.scm 502 */
BGL_LONGLONG_T BgL_arg1944z00_687;
BgL_arg1944z00_687 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 502 */
long BgL_res2667z00_2170;
BgL_res2667z00_2170 = 
LLONG_TO_LONG(BgL_arg1944z00_687); 
BgL_arg1942z00_686 = BgL_res2667z00_2170; } } 
PROCEDURE_ENTRY(BgL_fun1943z00_685)(BgL_fun1943z00_685, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_dtz00_43), 
BINT(BgL_ppqz00_42), 
BINT(BgL_arg1942z00_686), BEOA); } } 
{ /* Llib/midi.scm 503 */
obj_t BgL_fun1946z00_689;
BgL_fun1946z00_689 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_sysexz00); 
PROCEDURE_ENTRY(BgL_fun1946z00_689)(BgL_fun1946z00_689, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_strz00_684, BEOA); } }  else 
{ /* Llib/midi.scm 505 */
obj_t BgL_fun1952z00_695;
BgL_fun1952z00_695 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_errz00); 
PROCEDURE_ENTRY(BgL_fun1952z00_695)(BgL_fun1952z00_695, BGl_string3079z00zz__multimediazd2midizd2, BGl_string3081z00zz__multimediazd2midizd2, BgL_statusz00_477, BEOA); } } } } } } } } } } 
{ /* Llib/midi.scm 507 */
obj_t BgL_fun1970z00_715;
BgL_fun1970z00_715 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msinkz00_40))->BgL_flushz00); 
{ /* Llib/midi.scm 507 */
obj_t BgL_arg1969z00_716;
BgL_arg1969z00_716 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msinkz00_40))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun1970z00_715)(BgL_fun1970z00_715, BgL_arg1969z00_716, BEOA);} } } } 
BGL_FUNCTION_END;
}



/* midi-read-mthd */
obj_t BGl_midizd2readzd2mthdz00zz__multimediazd2midizd2(obj_t BgL_ipz00_45)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 512 */
{ /* Llib/midi.scm 513 */
obj_t BgL_tyz00_717;
BgL_tyz00_717 = 
BGl_readzd2charszd2zz__r4_input_6_10_2z00(
BINT(((long)4)), BgL_ipz00_45); 
if(
bigloo_strcmp(
((obj_t)BgL_tyz00_717), BGl_string3082z00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 516 */
int32_t BgL_sza7za7_719;
BgL_sza7za7_719 = 
BGl_readzd2int32zd2zz__multimediazd2midizd2(BgL_ipz00_45); 
{ /* Llib/midi.scm 516 */
long BgL_fmtz00_720;
{ /* Llib/midi.scm 517 */
int32_t BgL_arg1987z00_765;
BgL_arg1987z00_765 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(BgL_ipz00_45); 
{ /* Llib/midi.scm 517 */
long BgL_res2670z00_2178;
{ /* Llib/midi.scm 517 */
long BgL_arg1409z00_2175;
BgL_arg1409z00_2175 = 
(long)(BgL_arg1987z00_765); 
{ /* Llib/midi.scm 517 */
long BgL_res2669z00_2177;
BgL_res2669z00_2177 = 
(long)(BgL_arg1409z00_2175); 
BgL_res2670z00_2178 = BgL_res2669z00_2177; } } 
BgL_fmtz00_720 = BgL_res2670z00_2178; } } 
{ /* Llib/midi.scm 517 */
long BgL_tckz00_721;
{ /* Llib/midi.scm 518 */
int32_t BgL_arg1986z00_764;
BgL_arg1986z00_764 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(BgL_ipz00_45); 
{ /* Llib/midi.scm 518 */
long BgL_res2672z00_2183;
{ /* Llib/midi.scm 518 */
long BgL_arg1409z00_2180;
BgL_arg1409z00_2180 = 
(long)(BgL_arg1986z00_764); 
{ /* Llib/midi.scm 518 */
long BgL_res2671z00_2182;
BgL_res2671z00_2182 = 
(long)(BgL_arg1409z00_2180); 
BgL_res2672z00_2183 = BgL_res2671z00_2182; } } 
BgL_tckz00_721 = BgL_res2672z00_2183; } } 
{ /* Llib/midi.scm 518 */
long BgL_divz00_722;
{ /* Llib/midi.scm 519 */
int32_t BgL_arg1985z00_763;
BgL_arg1985z00_763 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(BgL_ipz00_45); 
{ /* Llib/midi.scm 519 */
long BgL_res2674z00_2188;
{ /* Llib/midi.scm 519 */
long BgL_arg1409z00_2185;
BgL_arg1409z00_2185 = 
(long)(BgL_arg1985z00_763); 
{ /* Llib/midi.scm 519 */
long BgL_res2673z00_2187;
BgL_res2673z00_2187 = 
(long)(BgL_arg1409z00_2185); 
BgL_res2674z00_2188 = BgL_res2673z00_2187; } } 
BgL_divz00_722 = BgL_res2674z00_2188; } } 
{ /* Llib/midi.scm 519 */

if(
(
(BgL_divz00_722 >> 
(int)(((long)15)))==((long)0)))
{ /* Llib/midi.scm 521 */
long BgL_val4_1198z00_729;
BgL_val4_1198z00_729 = 
(BgL_divz00_722 & ((long)32767)); 
{ /* Llib/midi.scm 521 */
int BgL_res2678z00_2195;
{ /* Llib/midi.scm 521 */
int BgL_tmpz00_6015;
BgL_tmpz00_6015 = 
(int)(((long)5)); 
BgL_res2678z00_2195 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_6015); } BgL_res2678z00_2195; } 
{ /* Llib/midi.scm 521 */
obj_t BgL_auxz00_6020;int BgL_tmpz00_6018;
BgL_auxz00_6020 = 
BINT(BgL_fmtz00_720); 
BgL_tmpz00_6018 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6018, BgL_auxz00_6020); } 
{ /* Llib/midi.scm 521 */
obj_t BgL_auxz00_6025;int BgL_tmpz00_6023;
BgL_auxz00_6025 = 
BINT(BgL_tckz00_721); 
BgL_tmpz00_6023 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6023, BgL_auxz00_6025); } 
{ /* Llib/midi.scm 521 */
obj_t BgL_auxz00_6030;int BgL_tmpz00_6028;
BgL_auxz00_6030 = 
BINT(((long)500000)); 
BgL_tmpz00_6028 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6028, BgL_auxz00_6030); } 
{ /* Llib/midi.scm 521 */
obj_t BgL_auxz00_6035;int BgL_tmpz00_6033;
BgL_auxz00_6035 = 
BINT(BgL_val4_1198z00_729); 
BgL_tmpz00_6033 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6033, BgL_auxz00_6035); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_719);}  else 
{ 

{ /* Llib/midi.scm 522 */
long BgL_aux1165z00_731;
BgL_aux1165z00_731 = 
(((long)128)-
(
(BgL_divz00_722 >> 
(int)(((long)8))) & ((long)127))); 
switch( BgL_aux1165z00_731) { case ((long)24) : 

{ /* Llib/midi.scm 524 */
long BgL_val4_1203z00_737;
BgL_val4_1203z00_737 = 
(((long)12)*
(BgL_divz00_722 & ((long)255))); 
{ /* Llib/midi.scm 524 */
int BgL_res2687z00_2212;
{ /* Llib/midi.scm 524 */
int BgL_tmpz00_6045;
BgL_tmpz00_6045 = 
(int)(((long)5)); 
BgL_res2687z00_2212 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_6045); } BgL_res2687z00_2212; } 
{ /* Llib/midi.scm 524 */
obj_t BgL_auxz00_6050;int BgL_tmpz00_6048;
BgL_auxz00_6050 = 
BINT(BgL_fmtz00_720); 
BgL_tmpz00_6048 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6048, BgL_auxz00_6050); } 
{ /* Llib/midi.scm 524 */
obj_t BgL_auxz00_6055;int BgL_tmpz00_6053;
BgL_auxz00_6055 = 
BINT(BgL_tckz00_721); 
BgL_tmpz00_6053 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6053, BgL_auxz00_6055); } 
{ /* Llib/midi.scm 524 */
obj_t BgL_auxz00_6060;int BgL_tmpz00_6058;
BgL_auxz00_6060 = 
BINT(((long)500000)); 
BgL_tmpz00_6058 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6058, BgL_auxz00_6060); } 
{ /* Llib/midi.scm 524 */
obj_t BgL_auxz00_6065;int BgL_tmpz00_6063;
BgL_auxz00_6065 = 
BINT(BgL_val4_1203z00_737); 
BgL_tmpz00_6063 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6063, BgL_auxz00_6065); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_719);} break;case ((long)25) : 

{ /* Llib/midi.scm 526 */
long BgL_val4_1208z00_743;
BgL_val4_1208z00_743 = 
(((long)10)*
(BgL_divz00_722 & ((long)255))); 
{ /* Llib/midi.scm 526 */
int BgL_res2690z00_2217;
{ /* Llib/midi.scm 526 */
int BgL_tmpz00_6071;
BgL_tmpz00_6071 = 
(int)(((long)5)); 
BgL_res2690z00_2217 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_6071); } BgL_res2690z00_2217; } 
{ /* Llib/midi.scm 526 */
obj_t BgL_auxz00_6076;int BgL_tmpz00_6074;
BgL_auxz00_6076 = 
BINT(BgL_fmtz00_720); 
BgL_tmpz00_6074 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6074, BgL_auxz00_6076); } 
{ /* Llib/midi.scm 526 */
obj_t BgL_auxz00_6081;int BgL_tmpz00_6079;
BgL_auxz00_6081 = 
BINT(BgL_tckz00_721); 
BgL_tmpz00_6079 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6079, BgL_auxz00_6081); } 
{ /* Llib/midi.scm 526 */
obj_t BgL_auxz00_6086;int BgL_tmpz00_6084;
BgL_auxz00_6086 = 
BINT(((long)400000)); 
BgL_tmpz00_6084 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6084, BgL_auxz00_6086); } 
{ /* Llib/midi.scm 526 */
obj_t BgL_auxz00_6091;int BgL_tmpz00_6089;
BgL_auxz00_6091 = 
BINT(BgL_val4_1208z00_743); 
BgL_tmpz00_6089 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6089, BgL_auxz00_6091); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_719);} break;case ((long)29) : 

{ /* Llib/midi.scm 528 */
long BgL_val4_1213z00_749;
BgL_val4_1213z00_749 = 
(((long)2997)*
(BgL_divz00_722 & ((long)255))); 
{ /* Llib/midi.scm 528 */
int BgL_res2693z00_2222;
{ /* Llib/midi.scm 528 */
int BgL_tmpz00_6097;
BgL_tmpz00_6097 = 
(int)(((long)5)); 
BgL_res2693z00_2222 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_6097); } BgL_res2693z00_2222; } 
{ /* Llib/midi.scm 528 */
obj_t BgL_auxz00_6102;int BgL_tmpz00_6100;
BgL_auxz00_6102 = 
BINT(BgL_fmtz00_720); 
BgL_tmpz00_6100 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6100, BgL_auxz00_6102); } 
{ /* Llib/midi.scm 528 */
obj_t BgL_auxz00_6107;int BgL_tmpz00_6105;
BgL_auxz00_6107 = 
BINT(BgL_tckz00_721); 
BgL_tmpz00_6105 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6105, BgL_auxz00_6107); } 
{ /* Llib/midi.scm 528 */
obj_t BgL_auxz00_6112;int BgL_tmpz00_6110;
BgL_auxz00_6112 = 
BINT(((long)100000000)); 
BgL_tmpz00_6110 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6110, BgL_auxz00_6112); } 
{ /* Llib/midi.scm 528 */
obj_t BgL_auxz00_6117;int BgL_tmpz00_6115;
BgL_auxz00_6117 = 
BINT(BgL_val4_1213z00_749); 
BgL_tmpz00_6115 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6115, BgL_auxz00_6117); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_719);} break;case ((long)30) : 

{ /* Llib/midi.scm 530 */
long BgL_val4_1218z00_755;
BgL_val4_1218z00_755 = 
(((long)15)*
(BgL_divz00_722 & ((long)255))); 
{ /* Llib/midi.scm 530 */
int BgL_res2696z00_2227;
{ /* Llib/midi.scm 530 */
int BgL_tmpz00_6123;
BgL_tmpz00_6123 = 
(int)(((long)5)); 
BgL_res2696z00_2227 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_6123); } BgL_res2696z00_2227; } 
{ /* Llib/midi.scm 530 */
obj_t BgL_auxz00_6128;int BgL_tmpz00_6126;
BgL_auxz00_6128 = 
BINT(BgL_fmtz00_720); 
BgL_tmpz00_6126 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6126, BgL_auxz00_6128); } 
{ /* Llib/midi.scm 530 */
obj_t BgL_auxz00_6133;int BgL_tmpz00_6131;
BgL_auxz00_6133 = 
BINT(BgL_tckz00_721); 
BgL_tmpz00_6131 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6131, BgL_auxz00_6133); } 
{ /* Llib/midi.scm 530 */
obj_t BgL_auxz00_6138;int BgL_tmpz00_6136;
BgL_auxz00_6138 = 
BINT(((long)500000)); 
BgL_tmpz00_6136 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6136, BgL_auxz00_6138); } 
{ /* Llib/midi.scm 530 */
obj_t BgL_auxz00_6143;int BgL_tmpz00_6141;
BgL_auxz00_6143 = 
BINT(BgL_val4_1218z00_755); 
BgL_tmpz00_6141 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6141, BgL_auxz00_6143); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_719);} break;
default: 
{ /* Llib/midi.scm 534 */
long BgL_arg1981z00_759;
BgL_arg1981z00_759 = 
(((long)128)-
(
(BgL_divz00_722 >> 
(int)(((long)8))) & ((long)127))); 
return 
BGl_errorz00zz__errorz00(BGl_string3083z00zz__multimediazd2midizd2, BGl_string3084z00zz__multimediazd2midizd2, 
BINT(BgL_arg1981z00_759));} } } } } } } } }  else 
{ /* Llib/midi.scm 514 */
return 
BGl_errorz00zz__errorz00(BGl_string3083z00zz__multimediazd2midizd2, BGl_string3085z00zz__multimediazd2midizd2, BgL_tyz00_717);} } } 
BGL_FUNCTION_END;
}



/* midi-read-mtrk */
obj_t BGl_midizd2readzd2mtrkz00zz__multimediazd2midizd2(obj_t BgL_ipz00_46)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 539 */
{ /* Llib/midi.scm 540 */
obj_t BgL_tyz00_766;
BgL_tyz00_766 = 
BGl_readzd2charszd2zz__r4_input_6_10_2z00(
BINT(((long)4)), BgL_ipz00_46); 
if(
bigloo_strcmp(
((obj_t)BgL_tyz00_766), BGl_string3086z00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 543 */
int32_t BgL_tmpz00_6160;
BgL_tmpz00_6160 = 
BGl_readzd2int32zd2zz__multimediazd2midizd2(BgL_ipz00_46); 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_6160);}  else 
{ /* Llib/midi.scm 541 */
return 
BGl_errorz00zz__errorz00(BGl_string3087z00zz__multimediazd2midizd2, BGl_string3085z00zz__multimediazd2midizd2, BgL_tyz00_766);} } } 
BGL_FUNCTION_END;
}



/* read-int16 */
int32_t BGl_readzd2int16zd2zz__multimediazd2midizd2(obj_t BgL_ipz00_49)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 560 */
{ /* Llib/midi.scm 561 */
obj_t BgL_b1z00_769;
BgL_b1z00_769 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_49); 
{ /* Llib/midi.scm 561 */
obj_t BgL_b0z00_770;
BgL_b0z00_770 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_49); 
{ /* Llib/midi.scm 562 */

{ /* Llib/midi.scm 563 */
int32_t BgL_arg1990z00_771;int32_t BgL_arg1991z00_772;
{ /* Llib/midi.scm 563 */
int32_t BgL_arg1992z00_773;
{ /* Llib/midi.scm 555 */
long BgL_arg1989z00_2238;
BgL_arg1989z00_2238 = 
(
CCHAR(BgL_b1z00_769)); 
{ /* Llib/midi.scm 555 */
int32_t BgL_res2702z00_2242;
BgL_res2702z00_2242 = 
(int32_t)(BgL_arg1989z00_2238); 
BgL_arg1992z00_773 = BgL_res2702z00_2242; } } 
BgL_arg1990z00_771 = 
(BgL_arg1992z00_773 << 
(int)(((long)8))); } 
{ /* Llib/midi.scm 555 */
long BgL_arg1989z00_2245;
BgL_arg1989z00_2245 = 
(
CCHAR(BgL_b0z00_770)); 
{ /* Llib/midi.scm 555 */
int32_t BgL_res2705z00_2249;
BgL_res2705z00_2249 = 
(int32_t)(BgL_arg1989z00_2245); 
BgL_arg1991z00_772 = BgL_res2705z00_2249; } } 
return 
(BgL_arg1990z00_771+BgL_arg1991z00_772);} } } } } 
BGL_FUNCTION_END;
}



/* &read-int16 */
obj_t BGl_z62readzd2int16zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3142, obj_t BgL_ipz00_3143)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 560 */
{ /* Llib/midi.scm 561 */
int32_t BgL_tmpz00_6175;
BgL_tmpz00_6175 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(BgL_ipz00_3143); 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_6175);} } 
BGL_FUNCTION_END;
}



/* read-int32 */
int32_t BGl_readzd2int32zd2zz__multimediazd2midizd2(obj_t BgL_ipz00_50)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 569 */
{ /* Llib/midi.scm 570 */
obj_t BgL_b3z00_774;
BgL_b3z00_774 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_50); 
{ /* Llib/midi.scm 570 */
obj_t BgL_b2z00_775;
BgL_b2z00_775 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_50); 
{ /* Llib/midi.scm 571 */
obj_t BgL_b1z00_776;
BgL_b1z00_776 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_50); 
{ /* Llib/midi.scm 572 */
obj_t BgL_b0z00_777;
BgL_b0z00_777 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_50); 
{ /* Llib/midi.scm 573 */

{ /* Llib/midi.scm 574 */
int32_t BgL_arg1993z00_778;int32_t BgL_arg1994z00_779;
{ /* Llib/midi.scm 574 */
int32_t BgL_arg1995z00_780;
{ /* Llib/midi.scm 555 */
long BgL_arg1989z00_2253;
BgL_arg1989z00_2253 = 
(
CCHAR(BgL_b3z00_774)); 
{ /* Llib/midi.scm 555 */
int32_t BgL_res2708z00_2257;
BgL_res2708z00_2257 = 
(int32_t)(BgL_arg1989z00_2253); 
BgL_arg1995z00_780 = BgL_res2708z00_2257; } } 
BgL_arg1993z00_778 = 
(BgL_arg1995z00_780 << 
(int)(((long)24))); } 
{ /* Llib/midi.scm 575 */
int32_t BgL_arg1996z00_781;int32_t BgL_arg1997z00_782;
{ /* Llib/midi.scm 575 */
int32_t BgL_arg1998z00_783;
{ /* Llib/midi.scm 555 */
long BgL_arg1989z00_2260;
BgL_arg1989z00_2260 = 
(
CCHAR(BgL_b2z00_775)); 
{ /* Llib/midi.scm 555 */
int32_t BgL_res2711z00_2264;
BgL_res2711z00_2264 = 
(int32_t)(BgL_arg1989z00_2260); 
BgL_arg1998z00_783 = BgL_res2711z00_2264; } } 
BgL_arg1996z00_781 = 
(BgL_arg1998z00_783 << 
(int)(((long)16))); } 
{ /* Llib/midi.scm 576 */
int32_t BgL_arg1999z00_784;int32_t BgL_arg2000z00_785;
{ /* Llib/midi.scm 576 */
int32_t BgL_arg2001z00_786;
{ /* Llib/midi.scm 555 */
long BgL_arg1989z00_2267;
BgL_arg1989z00_2267 = 
(
CCHAR(BgL_b1z00_776)); 
{ /* Llib/midi.scm 555 */
int32_t BgL_res2714z00_2271;
BgL_res2714z00_2271 = 
(int32_t)(BgL_arg1989z00_2267); 
BgL_arg2001z00_786 = BgL_res2714z00_2271; } } 
BgL_arg1999z00_784 = 
(BgL_arg2001z00_786 << 
(int)(((long)8))); } 
{ /* Llib/midi.scm 555 */
long BgL_arg1989z00_2274;
BgL_arg1989z00_2274 = 
(
CCHAR(BgL_b0z00_777)); 
{ /* Llib/midi.scm 555 */
int32_t BgL_res2717z00_2278;
BgL_res2717z00_2278 = 
(int32_t)(BgL_arg1989z00_2274); 
BgL_arg2000z00_785 = BgL_res2717z00_2278; } } 
BgL_arg1997z00_782 = 
(BgL_arg1999z00_784+BgL_arg2000z00_785); } 
BgL_arg1994z00_779 = 
(BgL_arg1996z00_781+BgL_arg1997z00_782); } 
return 
(BgL_arg1993z00_778+BgL_arg1994z00_779);} } } } } } } 
BGL_FUNCTION_END;
}



/* &read-int32 */
obj_t BGl_z62readzd2int32zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3144, obj_t BgL_ipz00_3145)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 569 */
{ /* Llib/midi.scm 570 */
int32_t BgL_tmpz00_6203;
BgL_tmpz00_6203 = 
BGl_readzd2int32zd2zz__multimediazd2midizd2(BgL_ipz00_3145); 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_6203);} } 
BGL_FUNCTION_END;
}



/* read-int */
long BGl_readzd2intzd2zz__multimediazd2midizd2(long BgL_lenz00_51, obj_t BgL_ipz00_52)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 582 */
{ /* Llib/midi.scm 583 */
long BgL_g1166z00_787;
{ /* Llib/midi.scm 583 */
obj_t BgL_arg2009z00_799;
BgL_arg2009z00_799 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_52); 
BgL_g1166z00_787 = 
(
CCHAR(BgL_arg2009z00_799)); } 
{ 
long BgL_valz00_789;long BgL_lenz00_790;
BgL_valz00_789 = BgL_g1166z00_787; 
BgL_lenz00_790 = BgL_lenz00_51; 
BgL_zc3anonymousza32002ze3z83_791:
if(
(BgL_lenz00_790==((long)1)))
{ /* Llib/midi.scm 585 */
return BgL_valz00_789;}  else 
{ /* Llib/midi.scm 587 */
long BgL_arg2004z00_793;long BgL_arg2005z00_794;
{ /* Llib/midi.scm 587 */
long BgL_arg2006z00_795;long BgL_arg2007z00_796;
BgL_arg2006z00_795 = 
(BgL_valz00_789 << 
(int)(((long)8))); 
{ /* Llib/midi.scm 587 */
obj_t BgL_arg2008z00_797;
BgL_arg2008z00_797 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_52); 
BgL_arg2007z00_796 = 
(
CCHAR(BgL_arg2008z00_797)); } 
BgL_arg2004z00_793 = 
(BgL_arg2006z00_795+BgL_arg2007z00_796); } 
BgL_arg2005z00_794 = 
(BgL_lenz00_790-((long)1)); 
{ 
long BgL_lenz00_6219;long BgL_valz00_6218;
BgL_valz00_6218 = BgL_arg2004z00_793; 
BgL_lenz00_6219 = BgL_arg2005z00_794; 
BgL_lenz00_790 = BgL_lenz00_6219; 
BgL_valz00_789 = BgL_valz00_6218; 
goto BgL_zc3anonymousza32002ze3z83_791;} } } } } 
BGL_FUNCTION_END;
}



/* &read-int */
obj_t BGl_z62readzd2intzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3146, obj_t BgL_lenz00_3147, obj_t BgL_ipz00_3148)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 582 */
{ /* Llib/midi.scm 583 */
long BgL_tmpz00_6220;
{ /* Llib/midi.scm 583 */
obj_t BgL_auxz00_6230;long BgL_auxz00_6221;
if(
INPUT_PORTP(BgL_ipz00_3148))
{ /* Llib/midi.scm 583 */
BgL_auxz00_6230 = BgL_ipz00_3148
; }  else 
{ 
obj_t BgL_auxz00_6233;
BgL_auxz00_6233 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)24391)), BGl_string3088z00zz__multimediazd2midizd2, BGl_string3068z00zz__multimediazd2midizd2, BgL_ipz00_3148); 
FAILURE(BgL_auxz00_6233,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 583 */
obj_t BgL_tmpz00_6222;
if(
INTEGERP(BgL_lenz00_3147))
{ /* Llib/midi.scm 583 */
BgL_tmpz00_6222 = BgL_lenz00_3147
; }  else 
{ 
obj_t BgL_auxz00_6225;
BgL_auxz00_6225 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)24391)), BGl_string3088z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_lenz00_3147); 
FAILURE(BgL_auxz00_6225,BFALSE,BFALSE);} 
BgL_auxz00_6221 = 
(long)CINT(BgL_tmpz00_6222); } 
BgL_tmpz00_6220 = 
BGl_readzd2intzd2zz__multimediazd2midizd2(BgL_auxz00_6221, BgL_auxz00_6230); } 
return 
BINT(BgL_tmpz00_6220);} } 
BGL_FUNCTION_END;
}



/* &read-vlq */
obj_t BGl_z62readzd2vlqzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3149, obj_t BgL_ipz00_3150)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 593 */
{ /* Llib/midi.scm 595 */
long BgL_tmpz00_6239;
{ 
long BgL_accz00_4168;
BgL_accz00_4168 = ((long)0); 
BgL_loopz00_4167:
{ /* Llib/midi.scm 595 */
long BgL_cz00_4169;
{ /* Llib/midi.scm 595 */
obj_t BgL_arg2015z00_4170;
BgL_arg2015z00_4170 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_3150); 
BgL_cz00_4169 = 
(
CCHAR(BgL_arg2015z00_4170)); } 
if(
(BgL_cz00_4169<=((long)127)))
{ /* Llib/midi.scm 596 */
BgL_tmpz00_6239 = 
(BgL_cz00_4169+BgL_accz00_4168)
; }  else 
{ 
long BgL_accz00_6246;
BgL_accz00_6246 = 
(
(BgL_accz00_4168+
(BgL_cz00_4169 & ((long)127))) << 
(int)(((long)7))); 
BgL_accz00_4168 = BgL_accz00_6246; 
goto BgL_loopz00_4167;} } } 
return 
BINT(BgL_tmpz00_6239);} } 
BGL_FUNCTION_END;
}



/* string-stream-peek-byte */
long BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(obj_t BgL_ipz00_54)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 603 */
return 
(
STRING_REF(
STRUCT_REF(BgL_ipz00_54, 
(int)(((long)0))), 
(long)CINT(
STRUCT_REF(BgL_ipz00_54, 
(int)(((long)1))))));} 
BGL_FUNCTION_END;
}



/* &string-stream-peek-byte */
obj_t BGl_z62stringzd2streamzd2peekzd2bytezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3154, obj_t BgL_ipz00_3155)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 603 */
{ /* Llib/midi.scm 605 */
long BgL_tmpz00_6259;
{ /* Llib/midi.scm 605 */
obj_t BgL_auxz00_6260;
if(
STRUCTP(BgL_ipz00_3155))
{ /* Llib/midi.scm 605 */
BgL_auxz00_6260 = BgL_ipz00_3155
; }  else 
{ 
obj_t BgL_auxz00_6263;
BgL_auxz00_6263 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)25285)), BGl_string3089z00zz__multimediazd2midizd2, BGl_string3090z00zz__multimediazd2midizd2, BgL_ipz00_3155); 
FAILURE(BgL_auxz00_6263,BFALSE,BFALSE);} 
BgL_tmpz00_6259 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_auxz00_6260); } 
return 
BINT(BgL_tmpz00_6259);} } 
BGL_FUNCTION_END;
}



/* &string-stream-read-byte */
obj_t BGl_z62stringzd2streamzd2readzd2bytezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3156, obj_t BgL_ipz00_3157)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 610 */
{ /* Llib/midi.scm 611 */
long BgL_tmpz00_6269;
{ /* Llib/midi.scm 611 */
obj_t BgL_ipz00_4171;
if(
STRUCTP(BgL_ipz00_3157))
{ /* Llib/midi.scm 611 */
BgL_ipz00_4171 = BgL_ipz00_3157; }  else 
{ 
obj_t BgL_auxz00_6272;
BgL_auxz00_6272 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)25610)), BGl_string3091z00zz__multimediazd2midizd2, BGl_string3090z00zz__multimediazd2midizd2, BgL_ipz00_3157); 
FAILURE(BgL_auxz00_6272,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 611 */
long BgL_bz00_4172;
BgL_bz00_4172 = 
(
STRING_REF(
STRUCT_REF(BgL_ipz00_4171, 
(int)(((long)0))), 
(long)CINT(
STRUCT_REF(BgL_ipz00_4171, 
(int)(((long)1)))))); 
{ /* Llib/midi.scm 612 */
long BgL_arg2019z00_4173;
BgL_arg2019z00_4173 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4171, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6289;int BgL_tmpz00_6287;
BgL_auxz00_6289 = 
BINT(BgL_arg2019z00_4173); 
BgL_tmpz00_6287 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4171, BgL_tmpz00_6287, BgL_auxz00_6289); } } 
BgL_tmpz00_6269 = BgL_bz00_4172; } } 
return 
BINT(BgL_tmpz00_6269);} } 
BGL_FUNCTION_END;
}



/* &string-stream-read-int16 */
obj_t BGl_z62stringzd2streamzd2readzd2int16zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3158, obj_t BgL_ipz00_3159)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 618 */
{ /* Llib/midi.scm 619 */
int32_t BgL_tmpz00_6293;
{ /* Llib/midi.scm 619 */
obj_t BgL_ipz00_4174;
if(
STRUCTP(BgL_ipz00_3159))
{ /* Llib/midi.scm 619 */
BgL_ipz00_4174 = BgL_ipz00_3159; }  else 
{ 
obj_t BgL_auxz00_6296;
BgL_auxz00_6296 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)26001)), BGl_string3092z00zz__multimediazd2midizd2, BGl_string3090z00zz__multimediazd2midizd2, BgL_ipz00_3159); 
FAILURE(BgL_auxz00_6296,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 619 */
long BgL_b1z00_4175;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4176;
BgL_bz00_4176 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4174); 
{ /* Llib/midi.scm 612 */
long BgL_arg2019z00_4177;
BgL_arg2019z00_4177 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4174, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6307;int BgL_tmpz00_6305;
BgL_auxz00_6307 = 
BINT(BgL_arg2019z00_4177); 
BgL_tmpz00_6305 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4174, BgL_tmpz00_6305, BgL_auxz00_6307); } } 
BgL_b1z00_4175 = BgL_bz00_4176; } 
{ /* Llib/midi.scm 619 */
long BgL_b0z00_4178;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4179;
BgL_bz00_4179 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4174); 
{ /* Llib/midi.scm 612 */
long BgL_arg2019z00_4180;
BgL_arg2019z00_4180 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4174, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6317;int BgL_tmpz00_6315;
BgL_auxz00_6317 = 
BINT(BgL_arg2019z00_4180); 
BgL_tmpz00_6315 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4174, BgL_tmpz00_6315, BgL_auxz00_6317); } } 
BgL_b0z00_4178 = BgL_bz00_4179; } 
{ /* Llib/midi.scm 620 */

{ /* Llib/midi.scm 621 */
int32_t BgL_arg2021z00_4181;int32_t BgL_arg2022z00_4182;
{ /* Llib/midi.scm 621 */
int32_t BgL_arg2023z00_4183;
{ /* Llib/midi.scm 621 */
int32_t BgL_res2740z00_4184;
BgL_res2740z00_4184 = 
(int32_t)(BgL_b1z00_4175); 
BgL_arg2023z00_4183 = BgL_res2740z00_4184; } 
BgL_arg2021z00_4181 = 
(BgL_arg2023z00_4183 << 
(int)(((long)8))); } 
{ /* Llib/midi.scm 621 */
int32_t BgL_res2742z00_4185;
BgL_res2742z00_4185 = 
(int32_t)(BgL_b0z00_4178); 
BgL_arg2022z00_4182 = BgL_res2742z00_4185; } 
BgL_tmpz00_6293 = 
(BgL_arg2021z00_4181+BgL_arg2022z00_4182); } } } } } 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_6293);} } 
BGL_FUNCTION_END;
}



/* &string-stream-read-int32 */
obj_t BGl_z62stringzd2streamzd2readzd2int32zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3160, obj_t BgL_ipz00_3161)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 626 */
{ /* Llib/midi.scm 627 */
int32_t BgL_tmpz00_6326;
{ /* Llib/midi.scm 627 */
obj_t BgL_ipz00_4186;
if(
STRUCTP(BgL_ipz00_3161))
{ /* Llib/midi.scm 627 */
BgL_ipz00_4186 = BgL_ipz00_3161; }  else 
{ 
obj_t BgL_auxz00_6329;
BgL_auxz00_6329 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)26420)), BGl_string3093z00zz__multimediazd2midizd2, BGl_string3090z00zz__multimediazd2midizd2, BgL_ipz00_3161); 
FAILURE(BgL_auxz00_6329,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 627 */
long BgL_b3z00_4187;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4188;
BgL_bz00_4188 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4186); 
{ /* Llib/midi.scm 612 */
long BgL_arg2019z00_4189;
BgL_arg2019z00_4189 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4186, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6340;int BgL_tmpz00_6338;
BgL_auxz00_6340 = 
BINT(BgL_arg2019z00_4189); 
BgL_tmpz00_6338 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4186, BgL_tmpz00_6338, BgL_auxz00_6340); } } 
BgL_b3z00_4187 = BgL_bz00_4188; } 
{ /* Llib/midi.scm 627 */
long BgL_b2z00_4190;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4191;
BgL_bz00_4191 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4186); 
{ /* Llib/midi.scm 612 */
long BgL_arg2019z00_4192;
BgL_arg2019z00_4192 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4186, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6350;int BgL_tmpz00_6348;
BgL_auxz00_6350 = 
BINT(BgL_arg2019z00_4192); 
BgL_tmpz00_6348 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4186, BgL_tmpz00_6348, BgL_auxz00_6350); } } 
BgL_b2z00_4190 = BgL_bz00_4191; } 
{ /* Llib/midi.scm 628 */
long BgL_b1z00_4193;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4194;
BgL_bz00_4194 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4186); 
{ /* Llib/midi.scm 612 */
long BgL_arg2019z00_4195;
BgL_arg2019z00_4195 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4186, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6360;int BgL_tmpz00_6358;
BgL_auxz00_6360 = 
BINT(BgL_arg2019z00_4195); 
BgL_tmpz00_6358 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4186, BgL_tmpz00_6358, BgL_auxz00_6360); } } 
BgL_b1z00_4193 = BgL_bz00_4194; } 
{ /* Llib/midi.scm 629 */
long BgL_b0z00_4196;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4197;
BgL_bz00_4197 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4186); 
{ /* Llib/midi.scm 612 */
long BgL_arg2019z00_4198;
BgL_arg2019z00_4198 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4186, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6370;int BgL_tmpz00_6368;
BgL_auxz00_6370 = 
BINT(BgL_arg2019z00_4198); 
BgL_tmpz00_6368 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4186, BgL_tmpz00_6368, BgL_auxz00_6370); } } 
BgL_b0z00_4196 = BgL_bz00_4197; } 
{ /* Llib/midi.scm 630 */

{ /* Llib/midi.scm 631 */
int32_t BgL_arg2024z00_4199;int32_t BgL_arg2025z00_4200;
{ /* Llib/midi.scm 631 */
int32_t BgL_arg2026z00_4201;
{ /* Llib/midi.scm 631 */
int32_t BgL_res2748z00_4202;
BgL_res2748z00_4202 = 
(int32_t)(BgL_b3z00_4187); 
BgL_arg2026z00_4201 = BgL_res2748z00_4202; } 
BgL_arg2024z00_4199 = 
(BgL_arg2026z00_4201 << 
(int)(((long)24))); } 
{ /* Llib/midi.scm 632 */
int32_t BgL_arg2027z00_4203;int32_t BgL_arg2028z00_4204;
{ /* Llib/midi.scm 632 */
int32_t BgL_arg2029z00_4205;
{ /* Llib/midi.scm 632 */
int32_t BgL_res2750z00_4206;
BgL_res2750z00_4206 = 
(int32_t)(BgL_b2z00_4190); 
BgL_arg2029z00_4205 = BgL_res2750z00_4206; } 
BgL_arg2027z00_4203 = 
(BgL_arg2029z00_4205 << 
(int)(((long)16))); } 
{ /* Llib/midi.scm 633 */
int32_t BgL_arg2030z00_4207;int32_t BgL_arg2031z00_4208;
{ /* Llib/midi.scm 633 */
int32_t BgL_arg2032z00_4209;
{ /* Llib/midi.scm 633 */
int32_t BgL_res2752z00_4210;
BgL_res2752z00_4210 = 
(int32_t)(BgL_b1z00_4193); 
BgL_arg2032z00_4209 = BgL_res2752z00_4210; } 
BgL_arg2030z00_4207 = 
(BgL_arg2032z00_4209 << 
(int)(((long)8))); } 
{ /* Llib/midi.scm 634 */
int32_t BgL_res2754z00_4211;
BgL_res2754z00_4211 = 
(int32_t)(BgL_b0z00_4196); 
BgL_arg2031z00_4208 = BgL_res2754z00_4211; } 
BgL_arg2028z00_4204 = 
(BgL_arg2030z00_4207+BgL_arg2031z00_4208); } 
BgL_arg2025z00_4200 = 
(BgL_arg2027z00_4203+BgL_arg2028z00_4204); } 
BgL_tmpz00_6326 = 
(BgL_arg2024z00_4199+BgL_arg2025z00_4200); } } } } } } } 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_6326);} } 
BGL_FUNCTION_END;
}



/* &string-stream-read-int */
obj_t BGl_z62stringzd2streamzd2readzd2intzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3162, obj_t BgL_lenz00_3163, obj_t BgL_ipz00_3164)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 639 */
{ /* Llib/midi.scm 640 */
long BgL_tmpz00_6387;
{ /* Llib/midi.scm 640 */
long BgL_lenz00_4212;obj_t BgL_ipz00_4213;
{ /* Llib/midi.scm 640 */
obj_t BgL_tmpz00_6388;
if(
INTEGERP(BgL_lenz00_3163))
{ /* Llib/midi.scm 640 */
BgL_tmpz00_6388 = BgL_lenz00_3163
; }  else 
{ 
obj_t BgL_auxz00_6391;
BgL_auxz00_6391 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)27020)), BGl_string3094z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_lenz00_3163); 
FAILURE(BgL_auxz00_6391,BFALSE,BFALSE);} 
BgL_lenz00_4212 = 
(long)CINT(BgL_tmpz00_6388); } 
if(
STRUCTP(BgL_ipz00_3164))
{ /* Llib/midi.scm 640 */
BgL_ipz00_4213 = BgL_ipz00_3164; }  else 
{ 
obj_t BgL_auxz00_6398;
BgL_auxz00_6398 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)27020)), BGl_string3094z00zz__multimediazd2midizd2, BGl_string3090z00zz__multimediazd2midizd2, BgL_ipz00_3164); 
FAILURE(BgL_auxz00_6398,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 640 */
long BgL_g1168z00_4214;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4215;
BgL_bz00_4215 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4213); 
{ /* Llib/midi.scm 612 */
long BgL_arg2019z00_4216;
BgL_arg2019z00_4216 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4213, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6409;int BgL_tmpz00_6407;
BgL_auxz00_6409 = 
BINT(BgL_arg2019z00_4216); 
BgL_tmpz00_6407 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4213, BgL_tmpz00_6407, BgL_auxz00_6409); } } 
BgL_g1168z00_4214 = BgL_bz00_4215; } 
{ 
long BgL_valz00_4218;long BgL_lenz00_4219;
BgL_valz00_4218 = BgL_g1168z00_4214; 
BgL_lenz00_4219 = BgL_lenz00_4212; 
BgL_loopz00_4217:
if(
(BgL_lenz00_4219==((long)1)))
{ /* Llib/midi.scm 642 */
BgL_tmpz00_6387 = BgL_valz00_4218
; }  else 
{ /* Llib/midi.scm 644 */
long BgL_arg2035z00_4220;long BgL_arg2036z00_4221;
{ /* Llib/midi.scm 644 */
long BgL_arg2037z00_4222;long BgL_arg2038z00_4223;
BgL_arg2037z00_4222 = 
(BgL_valz00_4218 << 
(int)(((long)8))); 
{ /* Llib/midi.scm 611 */
long BgL_bz00_4224;
BgL_bz00_4224 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4213); 
{ /* Llib/midi.scm 612 */
long BgL_arg2019z00_4225;
BgL_arg2019z00_4225 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4213, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6423;int BgL_tmpz00_6421;
BgL_auxz00_6423 = 
BINT(BgL_arg2019z00_4225); 
BgL_tmpz00_6421 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4213, BgL_tmpz00_6421, BgL_auxz00_6423); } } 
BgL_arg2038z00_4223 = BgL_bz00_4224; } 
BgL_arg2035z00_4220 = 
(BgL_arg2037z00_4222+BgL_arg2038z00_4223); } 
BgL_arg2036z00_4221 = 
(BgL_lenz00_4219-((long)1)); 
{ 
long BgL_lenz00_6429;long BgL_valz00_6428;
BgL_valz00_6428 = BgL_arg2035z00_4220; 
BgL_lenz00_6429 = BgL_arg2036z00_4221; 
BgL_lenz00_4219 = BgL_lenz00_6429; 
BgL_valz00_4218 = BgL_valz00_6428; 
goto BgL_loopz00_4217;} } } } } 
return 
BINT(BgL_tmpz00_6387);} } 
BGL_FUNCTION_END;
}



/* &string-stream-read-vlq */
obj_t BGl_z62stringzd2streamzd2readzd2vlqzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3165, obj_t BgL_ipz00_3166)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 650 */
{ /* Llib/midi.scm 652 */
long BgL_tmpz00_6431;
{ 
long BgL_accz00_4227;
BgL_accz00_4227 = ((long)0); 
BgL_loopz00_4226:
{ /* Llib/midi.scm 652 */
long BgL_cz00_4228;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4229;
BgL_bz00_4229 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(
((obj_t)BgL_ipz00_3166)); 
{ /* Llib/midi.scm 612 */
long BgL_arg2019z00_4230;
BgL_arg2019z00_4230 = 
(
(long)CINT(
STRUCT_REF(
((obj_t)BgL_ipz00_3166), 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6443;int BgL_auxz00_6441;obj_t BgL_tmpz00_6439;
BgL_auxz00_6443 = 
BINT(BgL_arg2019z00_4230); 
BgL_auxz00_6441 = 
(int)(((long)1)); 
BgL_tmpz00_6439 = 
((obj_t)BgL_ipz00_3166); 
STRUCT_SET(BgL_tmpz00_6439, BgL_auxz00_6441, BgL_auxz00_6443); } } 
BgL_cz00_4228 = BgL_bz00_4229; } 
if(
(BgL_cz00_4228<=((long)127)))
{ /* Llib/midi.scm 653 */
BgL_tmpz00_6431 = 
(BgL_cz00_4228+BgL_accz00_4227)
; }  else 
{ 
long BgL_accz00_6449;
BgL_accz00_6449 = 
(
(BgL_accz00_4227+
(BgL_cz00_4228 & ((long)127))) << 
(int)(((long)7))); 
BgL_accz00_4227 = BgL_accz00_6449; 
goto BgL_loopz00_4226;} } } 
return 
BINT(BgL_tmpz00_6431);} } 
BGL_FUNCTION_END;
}



/* &string-stream-read-chars */
obj_t BGl_z62stringzd2streamzd2readzd2charszb0zz__multimediazd2midizd2(obj_t BgL_envz00_3167, obj_t BgL_lenz00_3168, obj_t BgL_ipz00_3169)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 660 */
{ /* Llib/midi.scm 661 */
obj_t BgL_ipz00_4231;
if(
STRUCTP(BgL_ipz00_3169))
{ /* Llib/midi.scm 661 */
BgL_ipz00_4231 = BgL_ipz00_3169; }  else 
{ 
obj_t BgL_auxz00_6457;
BgL_auxz00_6457 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)27894)), BGl_string3095z00zz__multimediazd2midizd2, BGl_string3090z00zz__multimediazd2midizd2, BgL_ipz00_3169); 
FAILURE(BgL_auxz00_6457,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 661 */
obj_t BgL_sz00_4232;
{ /* Llib/midi.scm 661 */
obj_t BgL_arg2046z00_4233;obj_t BgL_arg2047z00_4234;obj_t BgL_arg2048z00_4235;
BgL_arg2046z00_4233 = 
STRUCT_REF(BgL_ipz00_4231, 
(int)(((long)0))); 
BgL_arg2047z00_4234 = 
STRUCT_REF(BgL_ipz00_4231, 
(int)(((long)1))); 
BgL_arg2048z00_4235 = 
BGl_2zb2zb2zz__r4_numbers_6_5z00(
STRUCT_REF(BgL_ipz00_4231, 
(int)(((long)1))), BgL_lenz00_3168); 
{ /* Llib/midi.scm 661 */
obj_t BgL_res2770z00_4236;
{ /* Llib/midi.scm 661 */
long BgL_startz00_4237;long BgL_endz00_4238;
BgL_startz00_4237 = 
(long)CINT(BgL_arg2047z00_4234); 
BgL_endz00_4238 = 
(long)CINT(BgL_arg2048z00_4235); 
BgL_res2770z00_4236 = 
c_substring(
((obj_t)BgL_arg2046z00_4233), BgL_startz00_4237, BgL_endz00_4238); } 
BgL_sz00_4232 = BgL_res2770z00_4236; } } 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6474;int BgL_tmpz00_6472;
BgL_auxz00_6474 = 
BGl_2zb2zb2zz__r4_numbers_6_5z00(
STRUCT_REF(BgL_ipz00_4231, 
(int)(((long)1))), BgL_lenz00_3168); 
BgL_tmpz00_6472 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4231, BgL_tmpz00_6472, BgL_auxz00_6474); } 
return BgL_sz00_4232;} } } 
BGL_FUNCTION_END;
}



/* midiplayer-cdelay */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2cdelayzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_68, BgL_midisinkz00_bglt BgL_msz00_69, long BgL_tickz00_70, BgL_miditrackz00_bglt BgL_trackz00_71, long BgL_ppqz00_72, long BgL_dtz00_73, long BgL_usz00_74)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 993 */
if(
(BgL_dtz00_73>((long)0)))
{ /* Llib/midi.scm 998 */
obj_t BgL_fun2052z00_2480;
BgL_fun2052z00_2480 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_69))->BgL_usleepz00); 
{ /* Llib/midi.scm 998 */
long BgL_arg2051z00_2481;
BgL_arg2051z00_2481 = 
(
(
(BgL_dtz00_73*
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_71))->BgL_tempoz00))/BgL_ppqz00_72)-BgL_usz00_74); 
return 
PROCEDURE_ENTRY(BgL_fun2052z00_2480)(BgL_fun2052z00_2480, 
BINT(BgL_arg2051z00_2481), BEOA);} }  else 
{ /* Llib/midi.scm 997 */
return BFALSE;} } 
BGL_FUNCTION_END;
}



/* &midiplayer-cdelay */
obj_t BGl_z62midiplayerzd2cdelayzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3196, obj_t BgL_mpz00_3197, obj_t BgL_msz00_3198, obj_t BgL_tickz00_3199, obj_t BgL_trackz00_3200, obj_t BgL_ppqz00_3201, obj_t BgL_dtz00_3202, obj_t BgL_usz00_3203)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 993 */
{ /* Llib/midi.scm 995 */
long BgL_auxz00_6542;long BgL_auxz00_6533;long BgL_auxz00_6524;BgL_miditrackz00_bglt BgL_auxz00_6516;long BgL_auxz00_6507;BgL_midisinkz00_bglt BgL_auxz00_6499;BgL_midiplayerz00_bglt BgL_auxz00_6491;
{ /* Llib/midi.scm 995 */
obj_t BgL_tmpz00_6543;
if(
INTEGERP(BgL_usz00_3203))
{ /* Llib/midi.scm 995 */
BgL_tmpz00_6543 = BgL_usz00_3203
; }  else 
{ 
obj_t BgL_auxz00_6546;
BgL_auxz00_6546 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3096z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_usz00_3203); 
FAILURE(BgL_auxz00_6546,BFALSE,BFALSE);} 
BgL_auxz00_6542 = 
(long)CINT(BgL_tmpz00_6543); } 
{ /* Llib/midi.scm 995 */
obj_t BgL_tmpz00_6534;
if(
INTEGERP(BgL_dtz00_3202))
{ /* Llib/midi.scm 995 */
BgL_tmpz00_6534 = BgL_dtz00_3202
; }  else 
{ 
obj_t BgL_auxz00_6537;
BgL_auxz00_6537 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3096z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_dtz00_3202); 
FAILURE(BgL_auxz00_6537,BFALSE,BFALSE);} 
BgL_auxz00_6533 = 
(long)CINT(BgL_tmpz00_6534); } 
{ /* Llib/midi.scm 995 */
obj_t BgL_tmpz00_6525;
if(
INTEGERP(BgL_ppqz00_3201))
{ /* Llib/midi.scm 995 */
BgL_tmpz00_6525 = BgL_ppqz00_3201
; }  else 
{ 
obj_t BgL_auxz00_6528;
BgL_auxz00_6528 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3096z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_ppqz00_3201); 
FAILURE(BgL_auxz00_6528,BFALSE,BFALSE);} 
BgL_auxz00_6524 = 
(long)CINT(BgL_tmpz00_6525); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_trackz00_3200, BGl_miditrackz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 995 */
BgL_auxz00_6516 = 
((BgL_miditrackz00_bglt)BgL_trackz00_3200)
; }  else 
{ 
obj_t BgL_auxz00_6520;
BgL_auxz00_6520 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3096z00zz__multimediazd2midizd2, BGl_string3097z00zz__multimediazd2midizd2, BgL_trackz00_3200); 
FAILURE(BgL_auxz00_6520,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 995 */
obj_t BgL_tmpz00_6508;
if(
INTEGERP(BgL_tickz00_3199))
{ /* Llib/midi.scm 995 */
BgL_tmpz00_6508 = BgL_tickz00_3199
; }  else 
{ 
obj_t BgL_auxz00_6511;
BgL_auxz00_6511 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3096z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_tickz00_3199); 
FAILURE(BgL_auxz00_6511,BFALSE,BFALSE);} 
BgL_auxz00_6507 = 
(long)CINT(BgL_tmpz00_6508); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3198, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 995 */
BgL_auxz00_6499 = 
((BgL_midisinkz00_bglt)BgL_msz00_3198)
; }  else 
{ 
obj_t BgL_auxz00_6503;
BgL_auxz00_6503 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3096z00zz__multimediazd2midizd2, BGl_string3077z00zz__multimediazd2midizd2, BgL_msz00_3198); 
FAILURE(BgL_auxz00_6503,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3197, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 995 */
BgL_auxz00_6491 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3197)
; }  else 
{ 
obj_t BgL_auxz00_6495;
BgL_auxz00_6495 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3096z00zz__multimediazd2midizd2, BGl_string3076z00zz__multimediazd2midizd2, BgL_mpz00_3197); 
FAILURE(BgL_auxz00_6495,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2cdelayzd2zz__multimediazd2midizd2(BgL_auxz00_6491, BgL_auxz00_6499, BgL_auxz00_6507, BgL_auxz00_6516, BgL_auxz00_6524, BgL_auxz00_6533, BgL_auxz00_6542);} } 
BGL_FUNCTION_END;
}



/* midiplayer-ignore */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2ignorezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_75, BgL_midisinkz00_bglt BgL_msz00_76, long BgL_tickz00_77, obj_t BgL_objz00_78)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1003 */
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* &midiplayer-ignore */
obj_t BGl_z62midiplayerzd2ignorezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3204, obj_t BgL_mpz00_3205, obj_t BgL_msz00_3206, obj_t BgL_tickz00_3207, obj_t BgL_objz00_3208)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1003 */
{ /* Llib/midi.scm 1003 */
BgL_midiplayerz00_bglt BgL_mpz00_4239;BgL_midisinkz00_bglt BgL_msz00_4240;long BgL_tickz00_4241;
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3205, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1003 */
BgL_mpz00_4239 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3205); }  else 
{ 
obj_t BgL_auxz00_6555;
BgL_auxz00_6555 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)38117)), BGl_string3098z00zz__multimediazd2midizd2, BGl_string3076z00zz__multimediazd2midizd2, BgL_mpz00_3205); 
FAILURE(BgL_auxz00_6555,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3206, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1003 */
BgL_msz00_4240 = 
((BgL_midisinkz00_bglt)BgL_msz00_3206); }  else 
{ 
obj_t BgL_auxz00_6562;
BgL_auxz00_6562 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)38117)), BGl_string3098z00zz__multimediazd2midizd2, BGl_string3077z00zz__multimediazd2midizd2, BgL_msz00_3206); 
FAILURE(BgL_auxz00_6562,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 1003 */
obj_t BgL_tmpz00_6566;
if(
INTEGERP(BgL_tickz00_3207))
{ /* Llib/midi.scm 1003 */
BgL_tmpz00_6566 = BgL_tickz00_3207
; }  else 
{ 
obj_t BgL_auxz00_6569;
BgL_auxz00_6569 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)38117)), BGl_string3098z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_tickz00_3207); 
FAILURE(BgL_auxz00_6569,BFALSE,BFALSE);} 
BgL_tickz00_4241 = 
(long)CINT(BgL_tmpz00_6566); } 
return BUNSPEC;} } 
BGL_FUNCTION_END;
}



/* midiplayer-noteoff */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2noteoffzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_88, BgL_midisinkz00_bglt BgL_msz00_89, long BgL_tickz00_90, long BgL_nnz00_91, long BgL_kkz00_92, long BgL_vvz00_93)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1026 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2062z00_2521;
BgL_fun2062z00_2521 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2060z00_2522;long BgL_arg2061z00_2523;
BgL_arg2060z00_2522 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_streamz00); 
BgL_arg2061z00_2523 = 
(((long)128) | BgL_nnz00_91); 
PROCEDURE_ENTRY(BgL_fun2062z00_2521)(BgL_fun2062z00_2521, BgL_arg2060z00_2522, 
BINT(BgL_arg2061z00_2523), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2064z00_2524;
BgL_fun2064z00_2524 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2063z00_2525;
BgL_arg2063z00_2525 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2064z00_2524)(BgL_fun2064z00_2524, BgL_arg2063z00_2525, 
BINT(BgL_kkz00_92), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2066z00_2526;
BgL_fun2066z00_2526 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2065z00_2527;
BgL_arg2065z00_2527 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2066z00_2526)(BgL_fun2066z00_2526, BgL_arg2065z00_2527, 
BINT(BgL_vvz00_93), BEOA);} } } 
BGL_FUNCTION_END;
}



/* &midiplayer-noteoff */
obj_t BGl_z62midiplayerzd2noteoffzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3209, obj_t BgL_mpz00_3210, obj_t BgL_msz00_3211, obj_t BgL_tickz00_3212, obj_t BgL_nnz00_3213, obj_t BgL_kkz00_3214, obj_t BgL_vvz00_3215)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1026 */
{ /* Llib/midi.scm 1028 */
long BgL_auxz00_6642;long BgL_auxz00_6633;long BgL_auxz00_6624;long BgL_auxz00_6615;BgL_midisinkz00_bglt BgL_auxz00_6607;BgL_midiplayerz00_bglt BgL_auxz00_6599;
{ /* Llib/midi.scm 1028 */
obj_t BgL_tmpz00_6643;
if(
INTEGERP(BgL_vvz00_3215))
{ /* Llib/midi.scm 1028 */
BgL_tmpz00_6643 = BgL_vvz00_3215
; }  else 
{ 
obj_t BgL_auxz00_6646;
BgL_auxz00_6646 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string3099z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_vvz00_3215); 
FAILURE(BgL_auxz00_6646,BFALSE,BFALSE);} 
BgL_auxz00_6642 = 
(long)CINT(BgL_tmpz00_6643); } 
{ /* Llib/midi.scm 1028 */
obj_t BgL_tmpz00_6634;
if(
INTEGERP(BgL_kkz00_3214))
{ /* Llib/midi.scm 1028 */
BgL_tmpz00_6634 = BgL_kkz00_3214
; }  else 
{ 
obj_t BgL_auxz00_6637;
BgL_auxz00_6637 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string3099z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_kkz00_3214); 
FAILURE(BgL_auxz00_6637,BFALSE,BFALSE);} 
BgL_auxz00_6633 = 
(long)CINT(BgL_tmpz00_6634); } 
{ /* Llib/midi.scm 1028 */
obj_t BgL_tmpz00_6625;
if(
INTEGERP(BgL_nnz00_3213))
{ /* Llib/midi.scm 1028 */
BgL_tmpz00_6625 = BgL_nnz00_3213
; }  else 
{ 
obj_t BgL_auxz00_6628;
BgL_auxz00_6628 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string3099z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_nnz00_3213); 
FAILURE(BgL_auxz00_6628,BFALSE,BFALSE);} 
BgL_auxz00_6624 = 
(long)CINT(BgL_tmpz00_6625); } 
{ /* Llib/midi.scm 1028 */
obj_t BgL_tmpz00_6616;
if(
INTEGERP(BgL_tickz00_3212))
{ /* Llib/midi.scm 1028 */
BgL_tmpz00_6616 = BgL_tickz00_3212
; }  else 
{ 
obj_t BgL_auxz00_6619;
BgL_auxz00_6619 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string3099z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_tickz00_3212); 
FAILURE(BgL_auxz00_6619,BFALSE,BFALSE);} 
BgL_auxz00_6615 = 
(long)CINT(BgL_tmpz00_6616); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3211, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1028 */
BgL_auxz00_6607 = 
((BgL_midisinkz00_bglt)BgL_msz00_3211)
; }  else 
{ 
obj_t BgL_auxz00_6611;
BgL_auxz00_6611 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string3099z00zz__multimediazd2midizd2, BGl_string3077z00zz__multimediazd2midizd2, BgL_msz00_3211); 
FAILURE(BgL_auxz00_6611,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3210, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1028 */
BgL_auxz00_6599 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3210)
; }  else 
{ 
obj_t BgL_auxz00_6603;
BgL_auxz00_6603 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string3099z00zz__multimediazd2midizd2, BGl_string3076z00zz__multimediazd2midizd2, BgL_mpz00_3210); 
FAILURE(BgL_auxz00_6603,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2noteoffzd2zz__multimediazd2midizd2(BgL_auxz00_6599, BgL_auxz00_6607, BgL_auxz00_6615, BgL_auxz00_6624, BgL_auxz00_6633, BgL_auxz00_6642);} } 
BGL_FUNCTION_END;
}



/* midiplayer-noteon */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2noteonzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_94, BgL_midisinkz00_bglt BgL_msz00_95, long BgL_tickz00_96, long BgL_nnz00_97, long BgL_kkz00_98, long BgL_vvz00_99)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1033 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2062z00_2535;
BgL_fun2062z00_2535 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2060z00_2536;long BgL_arg2061z00_2537;
BgL_arg2060z00_2536 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_streamz00); 
BgL_arg2061z00_2537 = 
(((long)144) | BgL_nnz00_97); 
PROCEDURE_ENTRY(BgL_fun2062z00_2535)(BgL_fun2062z00_2535, BgL_arg2060z00_2536, 
BINT(BgL_arg2061z00_2537), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2064z00_2538;
BgL_fun2064z00_2538 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2063z00_2539;
BgL_arg2063z00_2539 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2064z00_2538)(BgL_fun2064z00_2538, BgL_arg2063z00_2539, 
BINT(BgL_kkz00_98), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2066z00_2540;
BgL_fun2066z00_2540 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2065z00_2541;
BgL_arg2065z00_2541 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2066z00_2540)(BgL_fun2066z00_2540, BgL_arg2065z00_2541, 
BINT(BgL_vvz00_99), BEOA);} } } 
BGL_FUNCTION_END;
}



/* &midiplayer-noteon */
obj_t BGl_z62midiplayerzd2noteonzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3216, obj_t BgL_mpz00_3217, obj_t BgL_msz00_3218, obj_t BgL_tickz00_3219, obj_t BgL_nnz00_3220, obj_t BgL_kkz00_3221, obj_t BgL_vvz00_3222)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1033 */
{ /* Llib/midi.scm 1035 */
long BgL_auxz00_6720;long BgL_auxz00_6711;long BgL_auxz00_6702;long BgL_auxz00_6693;BgL_midisinkz00_bglt BgL_auxz00_6685;BgL_midiplayerz00_bglt BgL_auxz00_6677;
{ /* Llib/midi.scm 1035 */
obj_t BgL_tmpz00_6721;
if(
INTEGERP(BgL_vvz00_3222))
{ /* Llib/midi.scm 1035 */
BgL_tmpz00_6721 = BgL_vvz00_3222
; }  else 
{ 
obj_t BgL_auxz00_6724;
BgL_auxz00_6724 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string3100z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_vvz00_3222); 
FAILURE(BgL_auxz00_6724,BFALSE,BFALSE);} 
BgL_auxz00_6720 = 
(long)CINT(BgL_tmpz00_6721); } 
{ /* Llib/midi.scm 1035 */
obj_t BgL_tmpz00_6712;
if(
INTEGERP(BgL_kkz00_3221))
{ /* Llib/midi.scm 1035 */
BgL_tmpz00_6712 = BgL_kkz00_3221
; }  else 
{ 
obj_t BgL_auxz00_6715;
BgL_auxz00_6715 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string3100z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_kkz00_3221); 
FAILURE(BgL_auxz00_6715,BFALSE,BFALSE);} 
BgL_auxz00_6711 = 
(long)CINT(BgL_tmpz00_6712); } 
{ /* Llib/midi.scm 1035 */
obj_t BgL_tmpz00_6703;
if(
INTEGERP(BgL_nnz00_3220))
{ /* Llib/midi.scm 1035 */
BgL_tmpz00_6703 = BgL_nnz00_3220
; }  else 
{ 
obj_t BgL_auxz00_6706;
BgL_auxz00_6706 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string3100z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_nnz00_3220); 
FAILURE(BgL_auxz00_6706,BFALSE,BFALSE);} 
BgL_auxz00_6702 = 
(long)CINT(BgL_tmpz00_6703); } 
{ /* Llib/midi.scm 1035 */
obj_t BgL_tmpz00_6694;
if(
INTEGERP(BgL_tickz00_3219))
{ /* Llib/midi.scm 1035 */
BgL_tmpz00_6694 = BgL_tickz00_3219
; }  else 
{ 
obj_t BgL_auxz00_6697;
BgL_auxz00_6697 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string3100z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_tickz00_3219); 
FAILURE(BgL_auxz00_6697,BFALSE,BFALSE);} 
BgL_auxz00_6693 = 
(long)CINT(BgL_tmpz00_6694); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3218, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1035 */
BgL_auxz00_6685 = 
((BgL_midisinkz00_bglt)BgL_msz00_3218)
; }  else 
{ 
obj_t BgL_auxz00_6689;
BgL_auxz00_6689 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string3100z00zz__multimediazd2midizd2, BGl_string3077z00zz__multimediazd2midizd2, BgL_msz00_3218); 
FAILURE(BgL_auxz00_6689,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3217, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1035 */
BgL_auxz00_6677 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3217)
; }  else 
{ 
obj_t BgL_auxz00_6681;
BgL_auxz00_6681 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string3100z00zz__multimediazd2midizd2, BGl_string3076z00zz__multimediazd2midizd2, BgL_mpz00_3217); 
FAILURE(BgL_auxz00_6681,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2noteonzd2zz__multimediazd2midizd2(BgL_auxz00_6677, BgL_auxz00_6685, BgL_auxz00_6693, BgL_auxz00_6702, BgL_auxz00_6711, BgL_auxz00_6720);} } 
BGL_FUNCTION_END;
}



/* midiplayer-aftertouch */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2aftertouchzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_100, BgL_midisinkz00_bglt BgL_msz00_101, long BgL_tickz00_102, long BgL_nnz00_103, long BgL_kkz00_104, long BgL_vvz00_105)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1040 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2062z00_2549;
BgL_fun2062z00_2549 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2060z00_2550;long BgL_arg2061z00_2551;
BgL_arg2060z00_2550 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_streamz00); 
BgL_arg2061z00_2551 = 
(((long)160) | BgL_nnz00_103); 
PROCEDURE_ENTRY(BgL_fun2062z00_2549)(BgL_fun2062z00_2549, BgL_arg2060z00_2550, 
BINT(BgL_arg2061z00_2551), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2064z00_2552;
BgL_fun2064z00_2552 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2063z00_2553;
BgL_arg2063z00_2553 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2064z00_2552)(BgL_fun2064z00_2552, BgL_arg2063z00_2553, 
BINT(BgL_kkz00_104), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2066z00_2554;
BgL_fun2066z00_2554 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2065z00_2555;
BgL_arg2065z00_2555 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2066z00_2554)(BgL_fun2066z00_2554, BgL_arg2065z00_2555, 
BINT(BgL_vvz00_105), BEOA);} } } 
BGL_FUNCTION_END;
}



/* &midiplayer-aftertouch */
obj_t BGl_z62midiplayerzd2aftertouchzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3223, obj_t BgL_mpz00_3224, obj_t BgL_msz00_3225, obj_t BgL_tickz00_3226, obj_t BgL_nnz00_3227, obj_t BgL_kkz00_3228, obj_t BgL_vvz00_3229)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1040 */
{ /* Llib/midi.scm 1042 */
long BgL_auxz00_6798;long BgL_auxz00_6789;long BgL_auxz00_6780;long BgL_auxz00_6771;BgL_midisinkz00_bglt BgL_auxz00_6763;BgL_midiplayerz00_bglt BgL_auxz00_6755;
{ /* Llib/midi.scm 1042 */
obj_t BgL_tmpz00_6799;
if(
INTEGERP(BgL_vvz00_3229))
{ /* Llib/midi.scm 1042 */
BgL_tmpz00_6799 = BgL_vvz00_3229
; }  else 
{ 
obj_t BgL_auxz00_6802;
BgL_auxz00_6802 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string3101z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_vvz00_3229); 
FAILURE(BgL_auxz00_6802,BFALSE,BFALSE);} 
BgL_auxz00_6798 = 
(long)CINT(BgL_tmpz00_6799); } 
{ /* Llib/midi.scm 1042 */
obj_t BgL_tmpz00_6790;
if(
INTEGERP(BgL_kkz00_3228))
{ /* Llib/midi.scm 1042 */
BgL_tmpz00_6790 = BgL_kkz00_3228
; }  else 
{ 
obj_t BgL_auxz00_6793;
BgL_auxz00_6793 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string3101z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_kkz00_3228); 
FAILURE(BgL_auxz00_6793,BFALSE,BFALSE);} 
BgL_auxz00_6789 = 
(long)CINT(BgL_tmpz00_6790); } 
{ /* Llib/midi.scm 1042 */
obj_t BgL_tmpz00_6781;
if(
INTEGERP(BgL_nnz00_3227))
{ /* Llib/midi.scm 1042 */
BgL_tmpz00_6781 = BgL_nnz00_3227
; }  else 
{ 
obj_t BgL_auxz00_6784;
BgL_auxz00_6784 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string3101z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_nnz00_3227); 
FAILURE(BgL_auxz00_6784,BFALSE,BFALSE);} 
BgL_auxz00_6780 = 
(long)CINT(BgL_tmpz00_6781); } 
{ /* Llib/midi.scm 1042 */
obj_t BgL_tmpz00_6772;
if(
INTEGERP(BgL_tickz00_3226))
{ /* Llib/midi.scm 1042 */
BgL_tmpz00_6772 = BgL_tickz00_3226
; }  else 
{ 
obj_t BgL_auxz00_6775;
BgL_auxz00_6775 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string3101z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_tickz00_3226); 
FAILURE(BgL_auxz00_6775,BFALSE,BFALSE);} 
BgL_auxz00_6771 = 
(long)CINT(BgL_tmpz00_6772); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3225, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1042 */
BgL_auxz00_6763 = 
((BgL_midisinkz00_bglt)BgL_msz00_3225)
; }  else 
{ 
obj_t BgL_auxz00_6767;
BgL_auxz00_6767 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string3101z00zz__multimediazd2midizd2, BGl_string3077z00zz__multimediazd2midizd2, BgL_msz00_3225); 
FAILURE(BgL_auxz00_6767,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3224, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1042 */
BgL_auxz00_6755 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3224)
; }  else 
{ 
obj_t BgL_auxz00_6759;
BgL_auxz00_6759 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string3101z00zz__multimediazd2midizd2, BGl_string3076z00zz__multimediazd2midizd2, BgL_mpz00_3224); 
FAILURE(BgL_auxz00_6759,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2aftertouchzd2zz__multimediazd2midizd2(BgL_auxz00_6755, BgL_auxz00_6763, BgL_auxz00_6771, BgL_auxz00_6780, BgL_auxz00_6789, BgL_auxz00_6798);} } 
BGL_FUNCTION_END;
}



/* midiplayer-ctrlchange */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2ctrlchangezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_106, BgL_midisinkz00_bglt BgL_msz00_107, long BgL_tickz00_108, long BgL_nnz00_109, long BgL_kkz00_110, long BgL_vvz00_111)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1047 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2062z00_2563;
BgL_fun2062z00_2563 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2060z00_2564;long BgL_arg2061z00_2565;
BgL_arg2060z00_2564 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_streamz00); 
BgL_arg2061z00_2565 = 
(((long)176) | BgL_nnz00_109); 
PROCEDURE_ENTRY(BgL_fun2062z00_2563)(BgL_fun2062z00_2563, BgL_arg2060z00_2564, 
BINT(BgL_arg2061z00_2565), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2064z00_2566;
BgL_fun2064z00_2566 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2063z00_2567;
BgL_arg2063z00_2567 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2064z00_2566)(BgL_fun2064z00_2566, BgL_arg2063z00_2567, 
BINT(BgL_kkz00_110), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2066z00_2568;
BgL_fun2066z00_2568 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2065z00_2569;
BgL_arg2065z00_2569 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2066z00_2568)(BgL_fun2066z00_2568, BgL_arg2065z00_2569, 
BINT(BgL_vvz00_111), BEOA);} } } 
BGL_FUNCTION_END;
}



/* &midiplayer-ctrlchange */
obj_t BGl_z62midiplayerzd2ctrlchangezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3230, obj_t BgL_mpz00_3231, obj_t BgL_msz00_3232, obj_t BgL_tickz00_3233, obj_t BgL_nnz00_3234, obj_t BgL_kkz00_3235, obj_t BgL_vvz00_3236)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1047 */
{ /* Llib/midi.scm 1049 */
long BgL_auxz00_6876;long BgL_auxz00_6867;long BgL_auxz00_6858;long BgL_auxz00_6849;BgL_midisinkz00_bglt BgL_auxz00_6841;BgL_midiplayerz00_bglt BgL_auxz00_6833;
{ /* Llib/midi.scm 1049 */
obj_t BgL_tmpz00_6877;
if(
INTEGERP(BgL_vvz00_3236))
{ /* Llib/midi.scm 1049 */
BgL_tmpz00_6877 = BgL_vvz00_3236
; }  else 
{ 
obj_t BgL_auxz00_6880;
BgL_auxz00_6880 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string3102z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_vvz00_3236); 
FAILURE(BgL_auxz00_6880,BFALSE,BFALSE);} 
BgL_auxz00_6876 = 
(long)CINT(BgL_tmpz00_6877); } 
{ /* Llib/midi.scm 1049 */
obj_t BgL_tmpz00_6868;
if(
INTEGERP(BgL_kkz00_3235))
{ /* Llib/midi.scm 1049 */
BgL_tmpz00_6868 = BgL_kkz00_3235
; }  else 
{ 
obj_t BgL_auxz00_6871;
BgL_auxz00_6871 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string3102z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_kkz00_3235); 
FAILURE(BgL_auxz00_6871,BFALSE,BFALSE);} 
BgL_auxz00_6867 = 
(long)CINT(BgL_tmpz00_6868); } 
{ /* Llib/midi.scm 1049 */
obj_t BgL_tmpz00_6859;
if(
INTEGERP(BgL_nnz00_3234))
{ /* Llib/midi.scm 1049 */
BgL_tmpz00_6859 = BgL_nnz00_3234
; }  else 
{ 
obj_t BgL_auxz00_6862;
BgL_auxz00_6862 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string3102z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_nnz00_3234); 
FAILURE(BgL_auxz00_6862,BFALSE,BFALSE);} 
BgL_auxz00_6858 = 
(long)CINT(BgL_tmpz00_6859); } 
{ /* Llib/midi.scm 1049 */
obj_t BgL_tmpz00_6850;
if(
INTEGERP(BgL_tickz00_3233))
{ /* Llib/midi.scm 1049 */
BgL_tmpz00_6850 = BgL_tickz00_3233
; }  else 
{ 
obj_t BgL_auxz00_6853;
BgL_auxz00_6853 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string3102z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_tickz00_3233); 
FAILURE(BgL_auxz00_6853,BFALSE,BFALSE);} 
BgL_auxz00_6849 = 
(long)CINT(BgL_tmpz00_6850); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3232, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1049 */
BgL_auxz00_6841 = 
((BgL_midisinkz00_bglt)BgL_msz00_3232)
; }  else 
{ 
obj_t BgL_auxz00_6845;
BgL_auxz00_6845 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string3102z00zz__multimediazd2midizd2, BGl_string3077z00zz__multimediazd2midizd2, BgL_msz00_3232); 
FAILURE(BgL_auxz00_6845,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3231, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1049 */
BgL_auxz00_6833 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3231)
; }  else 
{ 
obj_t BgL_auxz00_6837;
BgL_auxz00_6837 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string3102z00zz__multimediazd2midizd2, BGl_string3076z00zz__multimediazd2midizd2, BgL_mpz00_3231); 
FAILURE(BgL_auxz00_6837,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2ctrlchangezd2zz__multimediazd2midizd2(BgL_auxz00_6833, BgL_auxz00_6841, BgL_auxz00_6849, BgL_auxz00_6858, BgL_auxz00_6867, BgL_auxz00_6876);} } 
BGL_FUNCTION_END;
}



/* midiplayer-prgmchange */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2prgmchangezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_112, BgL_midisinkz00_bglt BgL_msz00_113, long BgL_tickz00_114, long BgL_nnz00_115, long BgL_ppz00_116)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1054 */
{ /* Llib/midi.scm 1011 */
obj_t BgL_fun2057z00_2576;
BgL_fun2057z00_2576 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_113))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1011 */
obj_t BgL_arg2055z00_2577;long BgL_arg2056z00_2578;
BgL_arg2055z00_2577 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_113))->BgL_streamz00); 
BgL_arg2056z00_2578 = 
(((long)192) | BgL_nnz00_115); 
PROCEDURE_ENTRY(BgL_fun2057z00_2576)(BgL_fun2057z00_2576, BgL_arg2055z00_2577, 
BINT(BgL_arg2056z00_2578), BEOA); } } 
{ /* Llib/midi.scm 1012 */
obj_t BgL_fun2059z00_2579;
BgL_fun2059z00_2579 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_113))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1012 */
obj_t BgL_arg2058z00_2580;
BgL_arg2058z00_2580 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_113))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2059z00_2579)(BgL_fun2059z00_2579, BgL_arg2058z00_2580, 
BINT(BgL_ppz00_116), BEOA);} } } 
BGL_FUNCTION_END;
}



/* &midiplayer-prgmchange */
obj_t BGl_z62midiplayerzd2prgmchangezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3237, obj_t BgL_mpz00_3238, obj_t BgL_msz00_3239, obj_t BgL_tickz00_3240, obj_t BgL_nnz00_3241, obj_t BgL_ppz00_3242)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1054 */
{ /* Llib/midi.scm 1056 */
long BgL_auxz00_6937;long BgL_auxz00_6928;long BgL_auxz00_6919;BgL_midisinkz00_bglt BgL_auxz00_6911;BgL_midiplayerz00_bglt BgL_auxz00_6903;
{ /* Llib/midi.scm 1056 */
obj_t BgL_tmpz00_6938;
if(
INTEGERP(BgL_ppz00_3242))
{ /* Llib/midi.scm 1056 */
BgL_tmpz00_6938 = BgL_ppz00_3242
; }  else 
{ 
obj_t BgL_auxz00_6941;
BgL_auxz00_6941 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string3103z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_ppz00_3242); 
FAILURE(BgL_auxz00_6941,BFALSE,BFALSE);} 
BgL_auxz00_6937 = 
(long)CINT(BgL_tmpz00_6938); } 
{ /* Llib/midi.scm 1056 */
obj_t BgL_tmpz00_6929;
if(
INTEGERP(BgL_nnz00_3241))
{ /* Llib/midi.scm 1056 */
BgL_tmpz00_6929 = BgL_nnz00_3241
; }  else 
{ 
obj_t BgL_auxz00_6932;
BgL_auxz00_6932 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string3103z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_nnz00_3241); 
FAILURE(BgL_auxz00_6932,BFALSE,BFALSE);} 
BgL_auxz00_6928 = 
(long)CINT(BgL_tmpz00_6929); } 
{ /* Llib/midi.scm 1056 */
obj_t BgL_tmpz00_6920;
if(
INTEGERP(BgL_tickz00_3240))
{ /* Llib/midi.scm 1056 */
BgL_tmpz00_6920 = BgL_tickz00_3240
; }  else 
{ 
obj_t BgL_auxz00_6923;
BgL_auxz00_6923 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string3103z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_tickz00_3240); 
FAILURE(BgL_auxz00_6923,BFALSE,BFALSE);} 
BgL_auxz00_6919 = 
(long)CINT(BgL_tmpz00_6920); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3239, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1056 */
BgL_auxz00_6911 = 
((BgL_midisinkz00_bglt)BgL_msz00_3239)
; }  else 
{ 
obj_t BgL_auxz00_6915;
BgL_auxz00_6915 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string3103z00zz__multimediazd2midizd2, BGl_string3077z00zz__multimediazd2midizd2, BgL_msz00_3239); 
FAILURE(BgL_auxz00_6915,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3238, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1056 */
BgL_auxz00_6903 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3238)
; }  else 
{ 
obj_t BgL_auxz00_6907;
BgL_auxz00_6907 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string3103z00zz__multimediazd2midizd2, BGl_string3076z00zz__multimediazd2midizd2, BgL_mpz00_3238); 
FAILURE(BgL_auxz00_6907,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2prgmchangezd2zz__multimediazd2midizd2(BgL_auxz00_6903, BgL_auxz00_6911, BgL_auxz00_6919, BgL_auxz00_6928, BgL_auxz00_6937);} } 
BGL_FUNCTION_END;
}



/* midiplayer-after-touch */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2afterzd2touchz00zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_117, BgL_midisinkz00_bglt BgL_msz00_118, long BgL_tickz00_119, long BgL_nnz00_120, long BgL_ppz00_121)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1061 */
{ /* Llib/midi.scm 1011 */
obj_t BgL_fun2057z00_2587;
BgL_fun2057z00_2587 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_118))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1011 */
obj_t BgL_arg2055z00_2588;long BgL_arg2056z00_2589;
BgL_arg2055z00_2588 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_118))->BgL_streamz00); 
BgL_arg2056z00_2589 = 
(((long)208) | BgL_nnz00_120); 
PROCEDURE_ENTRY(BgL_fun2057z00_2587)(BgL_fun2057z00_2587, BgL_arg2055z00_2588, 
BINT(BgL_arg2056z00_2589), BEOA); } } 
{ /* Llib/midi.scm 1012 */
obj_t BgL_fun2059z00_2590;
BgL_fun2059z00_2590 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_118))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1012 */
obj_t BgL_arg2058z00_2591;
BgL_arg2058z00_2591 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_118))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2059z00_2590)(BgL_fun2059z00_2590, BgL_arg2058z00_2591, 
BINT(BgL_ppz00_121), BEOA);} } } 
BGL_FUNCTION_END;
}



/* &midiplayer-after-touch */
obj_t BGl_z62midiplayerzd2afterzd2touchz62zz__multimediazd2midizd2(obj_t BgL_envz00_3243, obj_t BgL_mpz00_3244, obj_t BgL_msz00_3245, obj_t BgL_tickz00_3246, obj_t BgL_nnz00_3247, obj_t BgL_ppz00_3248)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1061 */
{ /* Llib/midi.scm 1063 */
long BgL_auxz00_6998;long BgL_auxz00_6989;long BgL_auxz00_6980;BgL_midisinkz00_bglt BgL_auxz00_6972;BgL_midiplayerz00_bglt BgL_auxz00_6964;
{ /* Llib/midi.scm 1063 */
obj_t BgL_tmpz00_6999;
if(
INTEGERP(BgL_ppz00_3248))
{ /* Llib/midi.scm 1063 */
BgL_tmpz00_6999 = BgL_ppz00_3248
; }  else 
{ 
obj_t BgL_auxz00_7002;
BgL_auxz00_7002 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string3104z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_ppz00_3248); 
FAILURE(BgL_auxz00_7002,BFALSE,BFALSE);} 
BgL_auxz00_6998 = 
(long)CINT(BgL_tmpz00_6999); } 
{ /* Llib/midi.scm 1063 */
obj_t BgL_tmpz00_6990;
if(
INTEGERP(BgL_nnz00_3247))
{ /* Llib/midi.scm 1063 */
BgL_tmpz00_6990 = BgL_nnz00_3247
; }  else 
{ 
obj_t BgL_auxz00_6993;
BgL_auxz00_6993 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string3104z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_nnz00_3247); 
FAILURE(BgL_auxz00_6993,BFALSE,BFALSE);} 
BgL_auxz00_6989 = 
(long)CINT(BgL_tmpz00_6990); } 
{ /* Llib/midi.scm 1063 */
obj_t BgL_tmpz00_6981;
if(
INTEGERP(BgL_tickz00_3246))
{ /* Llib/midi.scm 1063 */
BgL_tmpz00_6981 = BgL_tickz00_3246
; }  else 
{ 
obj_t BgL_auxz00_6984;
BgL_auxz00_6984 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string3104z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_tickz00_3246); 
FAILURE(BgL_auxz00_6984,BFALSE,BFALSE);} 
BgL_auxz00_6980 = 
(long)CINT(BgL_tmpz00_6981); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3245, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1063 */
BgL_auxz00_6972 = 
((BgL_midisinkz00_bglt)BgL_msz00_3245)
; }  else 
{ 
obj_t BgL_auxz00_6976;
BgL_auxz00_6976 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string3104z00zz__multimediazd2midizd2, BGl_string3077z00zz__multimediazd2midizd2, BgL_msz00_3245); 
FAILURE(BgL_auxz00_6976,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3244, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1063 */
BgL_auxz00_6964 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3244)
; }  else 
{ 
obj_t BgL_auxz00_6968;
BgL_auxz00_6968 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string3104z00zz__multimediazd2midizd2, BGl_string3076z00zz__multimediazd2midizd2, BgL_mpz00_3244); 
FAILURE(BgL_auxz00_6968,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2afterzd2touchz00zz__multimediazd2midizd2(BgL_auxz00_6964, BgL_auxz00_6972, BgL_auxz00_6980, BgL_auxz00_6989, BgL_auxz00_6998);} } 
BGL_FUNCTION_END;
}



/* midiplayer-pitch */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2pitchzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_122, BgL_midisinkz00_bglt BgL_msz00_123, long BgL_tickz00_124, long BgL_nnz00_125, long BgL_ccz00_126, long BgL_vvz00_127)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1068 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2062z00_2599;
BgL_fun2062z00_2599 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2060z00_2600;long BgL_arg2061z00_2601;
BgL_arg2060z00_2600 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_streamz00); 
BgL_arg2061z00_2601 = 
(((long)224) | BgL_nnz00_125); 
PROCEDURE_ENTRY(BgL_fun2062z00_2599)(BgL_fun2062z00_2599, BgL_arg2060z00_2600, 
BINT(BgL_arg2061z00_2601), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2064z00_2602;
BgL_fun2064z00_2602 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2063z00_2603;
BgL_arg2063z00_2603 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2064z00_2602)(BgL_fun2064z00_2602, BgL_arg2063z00_2603, 
BINT(BgL_ccz00_126), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2066z00_2604;
BgL_fun2066z00_2604 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2065z00_2605;
BgL_arg2065z00_2605 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2066z00_2604)(BgL_fun2066z00_2604, BgL_arg2065z00_2605, 
BINT(BgL_vvz00_127), BEOA);} } } 
BGL_FUNCTION_END;
}



/* &midiplayer-pitch */
obj_t BGl_z62midiplayerzd2pitchzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3249, obj_t BgL_mpz00_3250, obj_t BgL_msz00_3251, obj_t BgL_tickz00_3252, obj_t BgL_nnz00_3253, obj_t BgL_ccz00_3254, obj_t BgL_vvz00_3255)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1068 */
{ /* Llib/midi.scm 1070 */
long BgL_auxz00_7076;long BgL_auxz00_7067;long BgL_auxz00_7058;long BgL_auxz00_7049;BgL_midisinkz00_bglt BgL_auxz00_7041;BgL_midiplayerz00_bglt BgL_auxz00_7033;
{ /* Llib/midi.scm 1070 */
obj_t BgL_tmpz00_7077;
if(
INTEGERP(BgL_vvz00_3255))
{ /* Llib/midi.scm 1070 */
BgL_tmpz00_7077 = BgL_vvz00_3255
; }  else 
{ 
obj_t BgL_auxz00_7080;
BgL_auxz00_7080 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string3105z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_vvz00_3255); 
FAILURE(BgL_auxz00_7080,BFALSE,BFALSE);} 
BgL_auxz00_7076 = 
(long)CINT(BgL_tmpz00_7077); } 
{ /* Llib/midi.scm 1070 */
obj_t BgL_tmpz00_7068;
if(
INTEGERP(BgL_ccz00_3254))
{ /* Llib/midi.scm 1070 */
BgL_tmpz00_7068 = BgL_ccz00_3254
; }  else 
{ 
obj_t BgL_auxz00_7071;
BgL_auxz00_7071 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string3105z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_ccz00_3254); 
FAILURE(BgL_auxz00_7071,BFALSE,BFALSE);} 
BgL_auxz00_7067 = 
(long)CINT(BgL_tmpz00_7068); } 
{ /* Llib/midi.scm 1070 */
obj_t BgL_tmpz00_7059;
if(
INTEGERP(BgL_nnz00_3253))
{ /* Llib/midi.scm 1070 */
BgL_tmpz00_7059 = BgL_nnz00_3253
; }  else 
{ 
obj_t BgL_auxz00_7062;
BgL_auxz00_7062 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string3105z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_nnz00_3253); 
FAILURE(BgL_auxz00_7062,BFALSE,BFALSE);} 
BgL_auxz00_7058 = 
(long)CINT(BgL_tmpz00_7059); } 
{ /* Llib/midi.scm 1070 */
obj_t BgL_tmpz00_7050;
if(
INTEGERP(BgL_tickz00_3252))
{ /* Llib/midi.scm 1070 */
BgL_tmpz00_7050 = BgL_tickz00_3252
; }  else 
{ 
obj_t BgL_auxz00_7053;
BgL_auxz00_7053 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string3105z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_tickz00_3252); 
FAILURE(BgL_auxz00_7053,BFALSE,BFALSE);} 
BgL_auxz00_7049 = 
(long)CINT(BgL_tmpz00_7050); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3251, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1070 */
BgL_auxz00_7041 = 
((BgL_midisinkz00_bglt)BgL_msz00_3251)
; }  else 
{ 
obj_t BgL_auxz00_7045;
BgL_auxz00_7045 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string3105z00zz__multimediazd2midizd2, BGl_string3077z00zz__multimediazd2midizd2, BgL_msz00_3251); 
FAILURE(BgL_auxz00_7045,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3250, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1070 */
BgL_auxz00_7033 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3250)
; }  else 
{ 
obj_t BgL_auxz00_7037;
BgL_auxz00_7037 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string3105z00zz__multimediazd2midizd2, BGl_string3076z00zz__multimediazd2midizd2, BgL_mpz00_3250); 
FAILURE(BgL_auxz00_7037,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2pitchzd2zz__multimediazd2midizd2(BgL_auxz00_7033, BgL_auxz00_7041, BgL_auxz00_7049, BgL_auxz00_7058, BgL_auxz00_7067, BgL_auxz00_7076);} } 
BGL_FUNCTION_END;
}



/* midiplayer-sysex */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2sysexzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_128, BgL_midisinkz00_bglt BgL_msz00_129, long BgL_tickz00_130, obj_t BgL_dataz00_131)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1075 */
{ /* Llib/midi.scm 1077 */
obj_t BgL_fun2068z00_2609;
BgL_fun2068z00_2609 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_129))->BgL_writezd2stringzd2); 
{ /* Llib/midi.scm 1077 */
obj_t BgL_arg2067z00_2610;
BgL_arg2067z00_2610 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_129))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2068z00_2609)(BgL_fun2068z00_2609, BgL_arg2067z00_2610, BEOA);} } } 
BGL_FUNCTION_END;
}



/* &midiplayer-sysex */
obj_t BGl_z62midiplayerzd2sysexzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3256, obj_t BgL_mpz00_3257, obj_t BgL_msz00_3258, obj_t BgL_tickz00_3259, obj_t BgL_dataz00_3260)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1075 */
{ /* Llib/midi.scm 1076 */
obj_t BgL_auxz00_7117;long BgL_auxz00_7108;BgL_midisinkz00_bglt BgL_auxz00_7100;BgL_midiplayerz00_bglt BgL_auxz00_7092;
if(
STRINGP(BgL_dataz00_3260))
{ /* Llib/midi.scm 1076 */
BgL_auxz00_7117 = BgL_dataz00_3260
; }  else 
{ 
obj_t BgL_auxz00_7120;
BgL_auxz00_7120 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)41881)), BGl_string3106z00zz__multimediazd2midizd2, BGl_string3066z00zz__multimediazd2midizd2, BgL_dataz00_3260); 
FAILURE(BgL_auxz00_7120,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 1076 */
obj_t BgL_tmpz00_7109;
if(
INTEGERP(BgL_tickz00_3259))
{ /* Llib/midi.scm 1076 */
BgL_tmpz00_7109 = BgL_tickz00_3259
; }  else 
{ 
obj_t BgL_auxz00_7112;
BgL_auxz00_7112 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)41881)), BGl_string3106z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_tickz00_3259); 
FAILURE(BgL_auxz00_7112,BFALSE,BFALSE);} 
BgL_auxz00_7108 = 
(long)CINT(BgL_tmpz00_7109); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3258, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1076 */
BgL_auxz00_7100 = 
((BgL_midisinkz00_bglt)BgL_msz00_3258)
; }  else 
{ 
obj_t BgL_auxz00_7104;
BgL_auxz00_7104 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)41881)), BGl_string3106z00zz__multimediazd2midizd2, BGl_string3077z00zz__multimediazd2midizd2, BgL_msz00_3258); 
FAILURE(BgL_auxz00_7104,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3257, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1076 */
BgL_auxz00_7092 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3257)
; }  else 
{ 
obj_t BgL_auxz00_7096;
BgL_auxz00_7096 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)41881)), BGl_string3106z00zz__multimediazd2midizd2, BGl_string3076z00zz__multimediazd2midizd2, BgL_mpz00_3257); 
FAILURE(BgL_auxz00_7096,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2sysexzd2zz__multimediazd2midizd2(BgL_auxz00_7092, BgL_auxz00_7100, BgL_auxz00_7108, BgL_auxz00_7117);} } 
BGL_FUNCTION_END;
}



/* midi-note-name */
BGL_EXPORTED_DEF obj_t BGl_midizd2notezd2namez00zz__multimediazd2midizd2(long BgL_kkz00_132)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1082 */
{ /* Llib/midi.scm 1083 */
long BgL_notez00_885;long BgL_octavez00_886;
{ /* Llib/midi.scm 1083 */
long BgL_arg2072z00_890;
{ /* Llib/midi.scm 1083 */
obj_t BgL_vectorz00_2611;
BgL_vectorz00_2611 = 
CNST_TABLE_REF(((long)3)); 
BgL_arg2072z00_890 = 
VECTOR_LENGTH(BgL_vectorz00_2611); } 
{ /* Llib/midi.scm 1083 */
long BgL_res2789z00_2630;
{ /* Llib/midi.scm 1083 */
long BgL_n1z00_2612;long BgL_n2z00_2613;
BgL_n1z00_2612 = BgL_kkz00_132; 
BgL_n2z00_2613 = BgL_arg2072z00_890; 
{ /* Llib/midi.scm 1083 */
bool_t BgL_testz00_7127;
{ /* Llib/midi.scm 1083 */
long BgL_arg1283z00_2615;
BgL_arg1283z00_2615 = 
(((BgL_n1z00_2612) | (BgL_n2z00_2613)) & -2147483648); 
BgL_testz00_7127 = 
(BgL_arg1283z00_2615==((long)0)); } 
if(BgL_testz00_7127)
{ /* Llib/midi.scm 1083 */
int32_t BgL_arg1272z00_2616;
{ /* Llib/midi.scm 1083 */
int32_t BgL_arg1278z00_2617;int32_t BgL_arg1279z00_2618;
{ /* Llib/midi.scm 1083 */
int32_t BgL_res2785z00_2622;
BgL_res2785z00_2622 = 
(int32_t)(BgL_n1z00_2612); 
BgL_arg1278z00_2617 = BgL_res2785z00_2622; } 
{ /* Llib/midi.scm 1083 */
int32_t BgL_res2786z00_2624;
BgL_res2786z00_2624 = 
(int32_t)(BgL_n2z00_2613); 
BgL_arg1279z00_2618 = BgL_res2786z00_2624; } 
BgL_arg1272z00_2616 = 
(BgL_arg1278z00_2617%BgL_arg1279z00_2618); } 
{ /* Llib/midi.scm 1083 */
long BgL_res2788z00_2629;
{ /* Llib/midi.scm 1083 */
long BgL_arg1409z00_2626;
BgL_arg1409z00_2626 = 
(long)(BgL_arg1272z00_2616); 
{ /* Llib/midi.scm 1083 */
long BgL_res2787z00_2628;
BgL_res2787z00_2628 = 
(long)(BgL_arg1409z00_2626); 
BgL_res2788z00_2629 = BgL_res2787z00_2628; } } 
BgL_res2789z00_2630 = BgL_res2788z00_2629; } }  else 
{ /* Llib/midi.scm 1083 */
BgL_res2789z00_2630 = 
(BgL_n1z00_2612%BgL_n2z00_2613); } } } 
BgL_notez00_885 = BgL_res2789z00_2630; } } 
{ /* Llib/midi.scm 1084 */
long BgL_arg2073z00_891;
{ /* Llib/midi.scm 1084 */
obj_t BgL_vectorz00_2631;
BgL_vectorz00_2631 = 
CNST_TABLE_REF(((long)3)); 
BgL_arg2073z00_891 = 
VECTOR_LENGTH(BgL_vectorz00_2631); } 
BgL_octavez00_886 = 
(BgL_kkz00_132/BgL_arg2073z00_891); } 
{ /* Llib/midi.scm 1085 */
obj_t BgL_arg2069z00_887;
{ /* Llib/midi.scm 1085 */
obj_t BgL_vectorz00_2635;
BgL_vectorz00_2635 = 
CNST_TABLE_REF(((long)3)); 
BgL_arg2069z00_887 = 
VECTOR_REF(BgL_vectorz00_2635,BgL_notez00_885); } 
{ /* Llib/midi.scm 1085 */
obj_t BgL_list2070z00_888;
{ /* Llib/midi.scm 1085 */
obj_t BgL_arg2071z00_889;
BgL_arg2071z00_889 = 
MAKE_YOUNG_PAIR(
BINT(BgL_octavez00_886), BNIL); 
BgL_list2070z00_888 = 
MAKE_YOUNG_PAIR(BgL_arg2069z00_887, BgL_arg2071z00_889); } 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3107z00zz__multimediazd2midizd2, BgL_list2070z00_888);} } } } 
BGL_FUNCTION_END;
}



/* &midi-note-name */
obj_t BGl_z62midizd2notezd2namez62zz__multimediazd2midizd2(obj_t BgL_envz00_3261, obj_t BgL_kkz00_3262)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1082 */
{ /* Llib/midi.scm 1083 */
long BgL_auxz00_7145;
{ /* Llib/midi.scm 1083 */
obj_t BgL_tmpz00_7146;
if(
INTEGERP(BgL_kkz00_3262))
{ /* Llib/midi.scm 1083 */
BgL_tmpz00_7146 = BgL_kkz00_3262
; }  else 
{ 
obj_t BgL_auxz00_7149;
BgL_auxz00_7149 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)42219)), BGl_string3108z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_kkz00_3262); 
FAILURE(BgL_auxz00_7149,BFALSE,BFALSE);} 
BgL_auxz00_7145 = 
(long)CINT(BgL_tmpz00_7146); } 
return 
BGl_midizd2notezd2namez00zz__multimediazd2midizd2(BgL_auxz00_7145);} } 
BGL_FUNCTION_END;
}



/* midi-controller-name */
BGL_EXPORTED_DEF obj_t BGl_midizd2controllerzd2namez00zz__multimediazd2midizd2(long BgL_ccz00_133)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1090 */
{ /* Llib/midi.scm 1091 */
bool_t BgL_testz00_7155;
{ /* Llib/midi.scm 1091 */
long BgL_arg2076z00_2638;
{ /* Llib/midi.scm 1091 */
obj_t BgL_vectorz00_2639;
BgL_vectorz00_2639 = 
CNST_TABLE_REF(((long)1)); 
BgL_arg2076z00_2638 = 
VECTOR_LENGTH(BgL_vectorz00_2639); } 
BgL_testz00_7155 = 
(BgL_ccz00_133<BgL_arg2076z00_2638); } 
if(BgL_testz00_7155)
{ /* Llib/midi.scm 1092 */
obj_t BgL_vectorz00_2643;
BgL_vectorz00_2643 = 
CNST_TABLE_REF(((long)1)); 
return 
VECTOR_REF(BgL_vectorz00_2643,BgL_ccz00_133);}  else 
{ /* Llib/midi.scm 1091 */
return BGl_string3109z00zz__multimediazd2midizd2;} } } 
BGL_FUNCTION_END;
}



/* &midi-controller-name */
obj_t BGl_z62midizd2controllerzd2namez62zz__multimediazd2midizd2(obj_t BgL_envz00_3263, obj_t BgL_ccz00_3264)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1090 */
{ /* Llib/midi.scm 1091 */
long BgL_auxz00_7161;
{ /* Llib/midi.scm 1091 */
obj_t BgL_tmpz00_7162;
if(
INTEGERP(BgL_ccz00_3264))
{ /* Llib/midi.scm 1091 */
BgL_tmpz00_7162 = BgL_ccz00_3264
; }  else 
{ 
obj_t BgL_auxz00_7165;
BgL_auxz00_7165 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)42667)), BGl_string3110z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_ccz00_3264); 
FAILURE(BgL_auxz00_7165,BFALSE,BFALSE);} 
BgL_auxz00_7161 = 
(long)CINT(BgL_tmpz00_7162); } 
return 
BGl_midizd2controllerzd2namez00zz__multimediazd2midizd2(BgL_auxz00_7161);} } 
BGL_FUNCTION_END;
}



/* midi-program-name */
BGL_EXPORTED_DEF obj_t BGl_midizd2programzd2namez00zz__multimediazd2midizd2(long BgL_ppz00_134)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1098 */
{ /* Llib/midi.scm 1099 */
bool_t BgL_testz00_7171;
{ /* Llib/midi.scm 1099 */
long BgL_arg2079z00_2646;
{ /* Llib/midi.scm 1099 */
obj_t BgL_vectorz00_2647;
BgL_vectorz00_2647 = 
CNST_TABLE_REF(((long)2)); 
BgL_arg2079z00_2646 = 
VECTOR_LENGTH(BgL_vectorz00_2647); } 
BgL_testz00_7171 = 
(BgL_ppz00_134<BgL_arg2079z00_2646); } 
if(BgL_testz00_7171)
{ /* Llib/midi.scm 1100 */
obj_t BgL_vectorz00_2651;
BgL_vectorz00_2651 = 
CNST_TABLE_REF(((long)2)); 
return 
VECTOR_REF(BgL_vectorz00_2651,BgL_ppz00_134);}  else 
{ /* Llib/midi.scm 1099 */
return BGl_string3111z00zz__multimediazd2midizd2;} } } 
BGL_FUNCTION_END;
}



/* &midi-program-name */
obj_t BGl_z62midizd2programzd2namez62zz__multimediazd2midizd2(obj_t BgL_envz00_3265, obj_t BgL_ppz00_3266)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1098 */
{ /* Llib/midi.scm 1099 */
long BgL_auxz00_7177;
{ /* Llib/midi.scm 1099 */
obj_t BgL_tmpz00_7178;
if(
INTEGERP(BgL_ppz00_3266))
{ /* Llib/midi.scm 1099 */
BgL_tmpz00_7178 = BgL_ppz00_3266
; }  else 
{ 
obj_t BgL_auxz00_7181;
BgL_auxz00_7181 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)43056)), BGl_string3112z00zz__multimediazd2midizd2, BGl_string3069z00zz__multimediazd2midizd2, BgL_ppz00_3266); 
FAILURE(BgL_auxz00_7181,BFALSE,BFALSE);} 
BgL_auxz00_7177 = 
(long)CINT(BgL_tmpz00_7178); } 
return 
BGl_midizd2programzd2namez00zz__multimediazd2midizd2(BgL_auxz00_7177);} } 
BGL_FUNCTION_END;
}



/* midi-program-index */
BGL_EXPORTED_DEF obj_t BGl_midizd2programzd2indexz00zz__multimediazd2midizd2(obj_t BgL_prgmz00_135)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1106 */
{ /* Llib/midi.scm 1107 */
long BgL_g1174z00_898;
{ /* Llib/midi.scm 1107 */
long BgL_arg2086z00_908;
{ /* Llib/midi.scm 1107 */
obj_t BgL_vectorz00_2653;
BgL_vectorz00_2653 = 
CNST_TABLE_REF(((long)2)); 
BgL_arg2086z00_908 = 
VECTOR_LENGTH(BgL_vectorz00_2653); } 
BgL_g1174z00_898 = 
(BgL_arg2086z00_908-((long)1)); } 
{ 
long BgL_iz00_900;
BgL_iz00_900 = BgL_g1174z00_898; 
BgL_zc3anonymousza32080ze3z83_901:
if(
(BgL_iz00_900>=((long)0)))
{ /* Llib/midi.scm 1109 */
bool_t BgL_testz00_7192;
{ /* Llib/midi.scm 1109 */
obj_t BgL_arg2085z00_906;
{ /* Llib/midi.scm 1109 */
obj_t BgL_vectorz00_2658;
BgL_vectorz00_2658 = 
CNST_TABLE_REF(((long)2)); 
BgL_arg2085z00_906 = 
VECTOR_REF(BgL_vectorz00_2658,BgL_iz00_900); } 
BgL_testz00_7192 = 
bigloo_strcicmp(BgL_arg2085z00_906, BgL_prgmz00_135); } 
if(BgL_testz00_7192)
{ /* Llib/midi.scm 1109 */
return 
BINT(BgL_iz00_900);}  else 
{ 
long BgL_iz00_7197;
BgL_iz00_7197 = 
(BgL_iz00_900-((long)1)); 
BgL_iz00_900 = BgL_iz00_7197; 
goto BgL_zc3anonymousza32080ze3z83_901;} }  else 
{ /* Llib/midi.scm 1108 */
return BFALSE;} } } } 
BGL_FUNCTION_END;
}



/* &midi-program-index */
obj_t BGl_z62midizd2programzd2indexz62zz__multimediazd2midizd2(obj_t BgL_envz00_3267, obj_t BgL_prgmz00_3268)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 1106 */
{ /* Llib/midi.scm 1107 */
obj_t BgL_auxz00_7199;
if(
STRINGP(BgL_prgmz00_3268))
{ /* Llib/midi.scm 1107 */
BgL_auxz00_7199 = BgL_prgmz00_3268
; }  else 
{ 
obj_t BgL_auxz00_7202;
BgL_auxz00_7202 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)43433)), BGl_string3113z00zz__multimediazd2midizd2, BGl_string3066z00zz__multimediazd2midizd2, BgL_prgmz00_3268); 
FAILURE(BgL_auxz00_7202,BFALSE,BFALSE);} 
return 
BGl_midizd2programzd2indexz00zz__multimediazd2midizd2(BgL_auxz00_7199);} } 
BGL_FUNCTION_END;
}



/* object-init */
obj_t BGl_objectzd2initzd2zz__multimediazd2midizd2()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 15 */
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2105z00_933;obj_t BgL_arg2106z00_934;
{ /* Llib/midi.scm 17 */
obj_t BgL_v1219z00_949;
BgL_v1219z00_949 = 
create_vector(((long)4)); 
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2113z00_950;
BgL_arg2113z00_950 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)5)), BGl_proc3115z00zz__multimediazd2midizd2, BGl_proc3114z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1219z00_949,((long)0),BgL_arg2113z00_950); } 
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2118z00_960;
BgL_arg2118z00_960 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)7)), BGl_proc3118z00zz__multimediazd2midizd2, BGl_proc3117z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3116z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1219z00_949,((long)1),BgL_arg2118z00_960); } 
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2125z00_973;
BgL_arg2125z00_973 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)8)), BGl_proc3121z00zz__multimediazd2midizd2, BGl_proc3120z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3119z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1219z00_949,((long)2),BgL_arg2125z00_973); } 
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2132z00_986;
BgL_arg2132z00_986 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)9)), BGl_proc3124z00zz__multimediazd2midizd2, BGl_proc3123z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3122z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)10))); 
VECTOR_SET(BgL_v1219z00_949,((long)3),BgL_arg2132z00_986); } 
BgL_arg2105z00_933 = BgL_v1219z00_949; } 
{ /* Llib/midi.scm 17 */
obj_t BgL_v1220z00_999;
BgL_v1220z00_999 = 
create_vector(((long)0)); 
BgL_arg2106z00_934 = BgL_v1220z00_999; } 
BGl_midiscorez00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)11)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)5450), BGl_proc3127z00zz__multimediazd2midizd2, BGl_proc3126z00zz__multimediazd2midizd2, BGl_midiscorezd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3125z00zz__multimediazd2midizd2, BFALSE, BgL_arg2105z00_933, BgL_arg2106z00_934); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2142z00_1006;obj_t BgL_arg2143z00_1007;
{ /* Llib/midi.scm 24 */
obj_t BgL_v1221z00_1032;
BgL_v1221z00_1032 = 
create_vector(((long)14)); 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2150z00_1033;
BgL_arg2150z00_1033 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)13)), BGl_proc3130z00zz__multimediazd2midizd2, BGl_proc3129z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3128z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1221z00_1032,((long)0),BgL_arg2150z00_1033); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2157z00_1046;
BgL_arg2157z00_1046 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)15)), BGl_proc3132z00zz__multimediazd2midizd2, BGl_proc3131z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_midireaderz00zz__multimediazd2midizd2); 
VECTOR_SET(BgL_v1221z00_1032,((long)1),BgL_arg2157z00_1046); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2162z00_1056;
BgL_arg2162z00_1056 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)16)), BGl_proc3134z00zz__multimediazd2midizd2, BGl_proc3133z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1221z00_1032,((long)2),BgL_arg2162z00_1056); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2167z00_1066;
BgL_arg2167z00_1066 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)18)), BGl_proc3137z00zz__multimediazd2midizd2, BGl_proc3136z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3135z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)19))); 
VECTOR_SET(BgL_v1221z00_1032,((long)3),BgL_arg2167z00_1066); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2174z00_1079;
BgL_arg2174z00_1079 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)20)), BGl_proc3140z00zz__multimediazd2midizd2, BGl_proc3139z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3138z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)21))); 
VECTOR_SET(BgL_v1221z00_1032,((long)4),BgL_arg2174z00_1079); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2181z00_1092;
BgL_arg2181z00_1092 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)22)), BGl_proc3143z00zz__multimediazd2midizd2, BGl_proc3142z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3141z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1221z00_1032,((long)5),BgL_arg2181z00_1092); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2188z00_1105;
BgL_arg2188z00_1105 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)23)), BGl_proc3146z00zz__multimediazd2midizd2, BGl_proc3145z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3144z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)24))); 
VECTOR_SET(BgL_v1221z00_1032,((long)6),BgL_arg2188z00_1105); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2195z00_1118;
BgL_arg2195z00_1118 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)7)), BGl_proc3149z00zz__multimediazd2midizd2, BGl_proc3148z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3147z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1221z00_1032,((long)7),BgL_arg2195z00_1118); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2202z00_1131;
BgL_arg2202z00_1131 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)25)), BGl_proc3152z00zz__multimediazd2midizd2, BGl_proc3151z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3150z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1221z00_1032,((long)8),BgL_arg2202z00_1131); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2209z00_1144;
BgL_arg2209z00_1144 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)26)), BGl_proc3155z00zz__multimediazd2midizd2, BGl_proc3154z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3153z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1221z00_1032,((long)9),BgL_arg2209z00_1144); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2216z00_1157;
BgL_arg2216z00_1157 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)27)), BGl_proc3158z00zz__multimediazd2midizd2, BGl_proc3157z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3156z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1221z00_1032,((long)10),BgL_arg2216z00_1157); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2223z00_1170;
BgL_arg2223z00_1170 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)28)), BGl_proc3161z00zz__multimediazd2midizd2, BGl_proc3160z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3159z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)21))); 
VECTOR_SET(BgL_v1221z00_1032,((long)11),BgL_arg2223z00_1170); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2230z00_1183;
BgL_arg2230z00_1183 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)29)), BGl_proc3164z00zz__multimediazd2midizd2, BGl_proc3163z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3162z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1221z00_1032,((long)12),BgL_arg2230z00_1183); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2237z00_1196;
BgL_arg2237z00_1196 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)30)), BGl_proc3167z00zz__multimediazd2midizd2, BGl_proc3166z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3165z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)19))); 
VECTOR_SET(BgL_v1221z00_1032,((long)13),BgL_arg2237z00_1196); } 
BgL_arg2142z00_1006 = BgL_v1221z00_1032; } 
{ /* Llib/midi.scm 24 */
obj_t BgL_v1222z00_1209;
BgL_v1222z00_1209 = 
create_vector(((long)0)); 
BgL_arg2143z00_1007 = BgL_v1222z00_1209; } 
BGl_miditrackz00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)31)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)26896), BGl_proc3170z00zz__multimediazd2midizd2, BGl_proc3169z00zz__multimediazd2midizd2, BGl_miditrackzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3168z00zz__multimediazd2midizd2, BFALSE, BgL_arg2142z00_1006, BgL_arg2143z00_1007); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2247z00_1216;obj_t BgL_arg2248z00_1217;
{ /* Llib/midi.scm 42 */
obj_t BgL_v1223z00_1235;
BgL_v1223z00_1235 = 
create_vector(((long)7)); 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2255z00_1236;
BgL_arg2255z00_1236 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)32)), BGl_proc3172z00zz__multimediazd2midizd2, BGl_proc3171z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1223z00_1235,((long)0),BgL_arg2255z00_1236); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2260z00_1246;
BgL_arg2260z00_1246 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)33)), BGl_proc3174z00zz__multimediazd2midizd2, BGl_proc3173z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1223z00_1235,((long)1),BgL_arg2260z00_1246); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2265z00_1256;
BgL_arg2265z00_1256 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)34)), BGl_proc3176z00zz__multimediazd2midizd2, BGl_proc3175z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1223z00_1235,((long)2),BgL_arg2265z00_1256); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2270z00_1266;
BgL_arg2270z00_1266 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)35)), BGl_proc3178z00zz__multimediazd2midizd2, BGl_proc3177z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1223z00_1235,((long)3),BgL_arg2270z00_1266); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2275z00_1276;
BgL_arg2275z00_1276 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)36)), BGl_proc3180z00zz__multimediazd2midizd2, BGl_proc3179z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1223z00_1235,((long)4),BgL_arg2275z00_1276); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2280z00_1286;
BgL_arg2280z00_1286 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)37)), BGl_proc3182z00zz__multimediazd2midizd2, BGl_proc3181z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1223z00_1235,((long)5),BgL_arg2280z00_1286); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2285z00_1296;
BgL_arg2285z00_1296 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)38)), BGl_proc3184z00zz__multimediazd2midizd2, BGl_proc3183z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1223z00_1235,((long)6),BgL_arg2285z00_1296); } 
BgL_arg2247z00_1216 = BgL_v1223z00_1235; } 
{ /* Llib/midi.scm 42 */
obj_t BgL_v1224z00_1306;
BgL_v1224z00_1306 = 
create_vector(((long)0)); 
BgL_arg2248z00_1217 = BgL_v1224z00_1306; } 
BGl_midireaderz00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)39)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)53877), BGl_proc3187z00zz__multimediazd2midizd2, BGl_proc3186z00zz__multimediazd2midizd2, BGl_midireaderzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3185z00zz__multimediazd2midizd2, BFALSE, BgL_arg2247z00_1216, BgL_arg2248z00_1217); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2293z00_1313;obj_t BgL_arg2294z00_1314;
{ /* Llib/midi.scm 52 */
obj_t BgL_v1225z00_1353;
BgL_v1225z00_1353 = 
create_vector(((long)28)); 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2301z00_1354;
BgL_arg2301z00_1354 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)40)), BGl_proc3190z00zz__multimediazd2midizd2, BGl_proc3189z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3188z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)0),BgL_arg2301z00_1354); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2308z00_1367;
BgL_arg2308z00_1367 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)41)), BGl_proc3193z00zz__multimediazd2midizd2, BGl_proc3192z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3191z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)1),BgL_arg2308z00_1367); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2315z00_1380;
BgL_arg2315z00_1380 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)42)), BGl_proc3196z00zz__multimediazd2midizd2, BGl_proc3195z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3194z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)2),BgL_arg2315z00_1380); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2322z00_1393;
BgL_arg2322z00_1393 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)43)), BGl_proc3199z00zz__multimediazd2midizd2, BGl_proc3198z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3197z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)3),BgL_arg2322z00_1393); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2329z00_1406;
BgL_arg2329z00_1406 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)44)), BGl_proc3202z00zz__multimediazd2midizd2, BGl_proc3201z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3200z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)4),BgL_arg2329z00_1406); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2336z00_1419;
BgL_arg2336z00_1419 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)45)), BGl_proc3205z00zz__multimediazd2midizd2, BGl_proc3204z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3203z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)5),BgL_arg2336z00_1419); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2343z00_1432;
BgL_arg2343z00_1432 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)46)), BGl_proc3208z00zz__multimediazd2midizd2, BGl_proc3207z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3206z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)6),BgL_arg2343z00_1432); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2350z00_1445;
BgL_arg2350z00_1445 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)47)), BGl_proc3211z00zz__multimediazd2midizd2, BGl_proc3210z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3209z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)7),BgL_arg2350z00_1445); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2357z00_1458;
BgL_arg2357z00_1458 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)48)), BGl_proc3214z00zz__multimediazd2midizd2, BGl_proc3213z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3212z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)8),BgL_arg2357z00_1458); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2364z00_1471;
BgL_arg2364z00_1471 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)49)), BGl_proc3217z00zz__multimediazd2midizd2, BGl_proc3216z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3215z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)9),BgL_arg2364z00_1471); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2371z00_1484;
BgL_arg2371z00_1484 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)50)), BGl_proc3220z00zz__multimediazd2midizd2, BGl_proc3219z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3218z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)10),BgL_arg2371z00_1484); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2378z00_1497;
BgL_arg2378z00_1497 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)51)), BGl_proc3223z00zz__multimediazd2midizd2, BGl_proc3222z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3221z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)11),BgL_arg2378z00_1497); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2385z00_1510;
BgL_arg2385z00_1510 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)52)), BGl_proc3226z00zz__multimediazd2midizd2, BGl_proc3225z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3224z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)12),BgL_arg2385z00_1510); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2392z00_1523;
BgL_arg2392z00_1523 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)53)), BGl_proc3229z00zz__multimediazd2midizd2, BGl_proc3228z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3227z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)13),BgL_arg2392z00_1523); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2399z00_1536;
BgL_arg2399z00_1536 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)54)), BGl_proc3232z00zz__multimediazd2midizd2, BGl_proc3231z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3230z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)14),BgL_arg2399z00_1536); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2406z00_1549;
BgL_arg2406z00_1549 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)55)), BGl_proc3235z00zz__multimediazd2midizd2, BGl_proc3234z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3233z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)15),BgL_arg2406z00_1549); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2413z00_1562;
BgL_arg2413z00_1562 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)56)), BGl_proc3238z00zz__multimediazd2midizd2, BGl_proc3237z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3236z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)16),BgL_arg2413z00_1562); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2420z00_1575;
BgL_arg2420z00_1575 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)57)), BGl_proc3241z00zz__multimediazd2midizd2, BGl_proc3240z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3239z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)17),BgL_arg2420z00_1575); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2427z00_1588;
BgL_arg2427z00_1588 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)58)), BGl_proc3244z00zz__multimediazd2midizd2, BGl_proc3243z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3242z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)18),BgL_arg2427z00_1588); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2434z00_1601;
BgL_arg2434z00_1601 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc3247z00zz__multimediazd2midizd2, BGl_proc3246z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3245z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)19),BgL_arg2434z00_1601); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2441z00_1614;
BgL_arg2441z00_1614 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)60)), BGl_proc3250z00zz__multimediazd2midizd2, BGl_proc3249z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3248z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)20),BgL_arg2441z00_1614); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2448z00_1627;
BgL_arg2448z00_1627 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)61)), BGl_proc3253z00zz__multimediazd2midizd2, BGl_proc3252z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3251z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)21),BgL_arg2448z00_1627); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2455z00_1640;
BgL_arg2455z00_1640 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)62)), BGl_proc3256z00zz__multimediazd2midizd2, BGl_proc3255z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3254z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)22),BgL_arg2455z00_1640); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2462z00_1653;
BgL_arg2462z00_1653 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)63)), BGl_proc3259z00zz__multimediazd2midizd2, BGl_proc3258z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3257z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)23),BgL_arg2462z00_1653); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2469z00_1666;
BgL_arg2469z00_1666 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)64)), BGl_proc3262z00zz__multimediazd2midizd2, BGl_proc3261z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3260z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)24),BgL_arg2469z00_1666); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2477z00_1688;
BgL_arg2477z00_1688 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)65)), BGl_proc3265z00zz__multimediazd2midizd2, BGl_proc3264z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3263z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)25),BgL_arg2477z00_1688); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2485z00_1709;
BgL_arg2485z00_1709 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)66)), BGl_proc3268z00zz__multimediazd2midizd2, BGl_proc3267z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3266z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)26),BgL_arg2485z00_1709); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2492z00_1722;
BgL_arg2492z00_1722 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)67)), BGl_proc3271z00zz__multimediazd2midizd2, BGl_proc3270z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3269z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1353,((long)27),BgL_arg2492z00_1722); } 
BgL_arg2293z00_1313 = BgL_v1225z00_1353; } 
{ /* Llib/midi.scm 52 */
obj_t BgL_v1226z00_1735;
BgL_v1226z00_1735 = 
create_vector(((long)0)); 
BgL_arg2294z00_1314 = BgL_v1226z00_1735; } 
BGl_midiplayerz00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)68)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)52705), BGl_proc3274z00zz__multimediazd2midizd2, BGl_proc3273z00zz__multimediazd2midizd2, BGl_midiplayerzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3272z00zz__multimediazd2midizd2, BFALSE, BgL_arg2293z00_1313, BgL_arg2294z00_1314); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2502z00_1742;obj_t BgL_arg2503z00_1743;
{ /* Llib/midi.scm 87 */
obj_t BgL_v1227z00_1759;
BgL_v1227z00_1759 = 
create_vector(((long)5)); 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2510z00_1760;
BgL_arg2510z00_1760 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)69)), BGl_proc3277z00zz__multimediazd2midizd2, BGl_proc3276z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3275z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1227z00_1759,((long)0),BgL_arg2510z00_1760); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2517z00_1773;
BgL_arg2517z00_1773 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)70)), BGl_proc3280z00zz__multimediazd2midizd2, BGl_proc3279z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3278z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1759,((long)1),BgL_arg2517z00_1773); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2524z00_1786;
BgL_arg2524z00_1786 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)71)), BGl_proc3283z00zz__multimediazd2midizd2, BGl_proc3282z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3281z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1759,((long)2),BgL_arg2524z00_1786); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2532z00_1802;
BgL_arg2532z00_1802 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)72)), BGl_proc3286z00zz__multimediazd2midizd2, BGl_proc3285z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3284z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1759,((long)3),BgL_arg2532z00_1802); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2540z00_1818;
BgL_arg2540z00_1818 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)73)), BGl_proc3289z00zz__multimediazd2midizd2, BGl_proc3288z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3287z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1759,((long)4),BgL_arg2540z00_1818); } 
BgL_arg2502z00_1742 = BgL_v1227z00_1759; } 
{ /* Llib/midi.scm 87 */
obj_t BgL_v1228z00_1831;
BgL_v1228z00_1831 = 
create_vector(((long)0)); 
BgL_arg2503z00_1743 = BgL_v1228z00_1831; } 
return ( 
BGl_midisinkz00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)74)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)13783), BGl_proc3292z00zz__multimediazd2midizd2, BGl_proc3291z00zz__multimediazd2midizd2, BGl_midisinkzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3290z00zz__multimediazd2midizd2, BFALSE, BgL_arg2502z00_1742, BgL_arg2503z00_1743), BUNSPEC) ;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2509> */
obj_t BGl_z62zc3anonymousza32509ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3463, obj_t BgL_new1118z00_3464)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 87 */
{ 
BgL_midisinkz00_bglt BgL_auxz00_7463;
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1118z00_3464)))->BgL_streamz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1118z00_3464)))->BgL_usleepz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1118z00_3464)))->BgL_writezd2bytezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1118z00_3464)))->BgL_writezd2stringzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1118z00_3464)))->BgL_flushz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_7463 = 
((BgL_midisinkz00_bglt)BgL_new1118z00_3464); 
return 
((obj_t)BgL_auxz00_7463);} } 
BGL_FUNCTION_END;
}



/* &lambda2507 */
BgL_midisinkz00_bglt BGl_z62lambda2507z62zz__multimediazd2midizd2(obj_t BgL_envz00_3465)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 87 */
{ /* Llib/midi.scm 87 */
BgL_midisinkz00_bglt BgL_new1117z00_4243;
BgL_new1117z00_4243 = 
((BgL_midisinkz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midisinkz00_bgl) ))); 
{ /* Llib/midi.scm 87 */
long BgL_arg2508z00_4244;
{ /* Llib/midi.scm 87 */
long BgL_res2808z00_4245;
BgL_res2808z00_4245 = 
BGL_CLASS_INDEX(BGl_midisinkz00zz__multimediazd2midizd2); 
BgL_arg2508z00_4244 = BgL_res2808z00_4245; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1117z00_4243), BgL_arg2508z00_4244); } 
return BgL_new1117z00_4243;} } 
BGL_FUNCTION_END;
}



/* &lambda2504 */
BgL_midisinkz00_bglt BGl_z62lambda2504z62zz__multimediazd2midizd2(obj_t BgL_envz00_3466, obj_t BgL_stream1112z00_3467, obj_t BgL_usleep1113z00_3468, obj_t BgL_writezd2byte1114zd2_3469, obj_t BgL_writezd2string1115zd2_3470, obj_t BgL_flush1116z00_3471)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 87 */
{ /* Llib/midi.scm 87 */
BgL_midisinkz00_bglt BgL_new1184z00_4250;
{ /* Llib/midi.scm 87 */
BgL_midisinkz00_bglt BgL_new1183z00_4251;
BgL_new1183z00_4251 = 
((BgL_midisinkz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midisinkz00_bgl) ))); 
{ /* Llib/midi.scm 87 */
long BgL_arg2506z00_4252;
{ /* Llib/midi.scm 87 */
long BgL_res2807z00_4253;
BgL_res2807z00_4253 = 
BGL_CLASS_INDEX(BGl_midisinkz00zz__multimediazd2midizd2); 
BgL_arg2506z00_4252 = BgL_res2807z00_4253; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1183z00_4251), BgL_arg2506z00_4252); } 
BgL_new1184z00_4250 = BgL_new1183z00_4251; } 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1184z00_4250))->BgL_streamz00)=((obj_t)BgL_stream1112z00_3467),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1184z00_4250))->BgL_usleepz00)=((obj_t)
((obj_t)BgL_usleep1113z00_3468)),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1184z00_4250))->BgL_writezd2bytezd2)=((obj_t)
((obj_t)BgL_writezd2byte1114zd2_3469)),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1184z00_4250))->BgL_writezd2stringzd2)=((obj_t)
((obj_t)BgL_writezd2string1115zd2_3470)),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1184z00_4250))->BgL_flushz00)=((obj_t)
((obj_t)BgL_flush1116z00_3471)),BUNSPEC); 
{ /* Llib/midi.scm 87 */
obj_t BgL_fun2505z00_4254;
BgL_fun2505z00_4254 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midisinkz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2505z00_4254)(BgL_fun2505z00_4254, 
((obj_t)BgL_new1184z00_4250), BEOA); } 
return BgL_new1184z00_4250;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2546> */
obj_t BGl_z62zc3anonymousza32546ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3472)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 87 */
return BGl_flushzd2outputzd2portzd2envzd2zz__r4_ports_6_10_1z00;} 
BGL_FUNCTION_END;
}



/* &lambda2545 */
obj_t BGl_z62lambda2545z62zz__multimediazd2midizd2(obj_t BgL_envz00_3473, obj_t BgL_oz00_3474, obj_t BgL_vz00_3475)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3474)))->BgL_flushz00)=((obj_t)
((obj_t)BgL_vz00_3475)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2544 */
obj_t BGl_z62lambda2544z62zz__multimediazd2midizd2(obj_t BgL_envz00_3476, obj_t BgL_oz00_3477)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3477)))->BgL_flushz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2538> */
obj_t BGl_z62zc3anonymousza32538ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3478)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 87 */
return BGl_proc3293z00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2537 */
obj_t BGl_z62lambda2537z62zz__multimediazd2midizd2(obj_t BgL_envz00_3479, obj_t BgL_oz00_3480, obj_t BgL_vz00_3481)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3480)))->BgL_writezd2stringzd2)=((obj_t)
((obj_t)BgL_vz00_3481)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2536 */
obj_t BGl_z62lambda2536z62zz__multimediazd2midizd2(obj_t BgL_envz00_3482, obj_t BgL_oz00_3483)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3483)))->BgL_writezd2stringzd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2539> */
obj_t BGl_z62zc3anonymousza32539ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3484, obj_t BgL_opz00_3485, obj_t BgL_sz00_3486)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 92 */
return 
BGl_writezd2stringzd2zz__r4_output_6_10_3z00(BgL_sz00_3486, BgL_opz00_3485);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2530> */
obj_t BGl_z62zc3anonymousza32530ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3487)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 87 */
return BGl_proc3294z00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2529 */
obj_t BGl_z62lambda2529z62zz__multimediazd2midizd2(obj_t BgL_envz00_3488, obj_t BgL_oz00_3489, obj_t BgL_vz00_3490)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3489)))->BgL_writezd2bytezd2)=((obj_t)
((obj_t)BgL_vz00_3490)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2528 */
obj_t BGl_z62lambda2528z62zz__multimediazd2midizd2(obj_t BgL_envz00_3491, obj_t BgL_oz00_3492)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3492)))->BgL_writezd2bytezd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2531> */
obj_t BGl_z62zc3anonymousza32531ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3493, obj_t BgL_opz00_3494, obj_t BgL_bz00_3495)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 91 */
{ /* Llib/midi.scm 91 */
unsigned char BgL_bytez00_4264;
BgL_bytez00_4264 = 
(unsigned char)CINT(BgL_bz00_3495); 
{ /* Llib/midi.scm 91 */
obj_t BgL_tmpz00_7516;
BgL_tmpz00_7516 = 
((obj_t)BgL_opz00_3494); 
return 
bgl_display_char(BgL_bytez00_4264, BgL_tmpz00_7516);} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2523> */
obj_t BGl_z62zc3anonymousza32523ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3496)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 87 */
return BGl_sleepzd2envzd2zz__osz00;} 
BGL_FUNCTION_END;
}



/* &lambda2522 */
obj_t BGl_z62lambda2522z62zz__multimediazd2midizd2(obj_t BgL_envz00_3497, obj_t BgL_oz00_3498, obj_t BgL_vz00_3499)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3498)))->BgL_usleepz00)=((obj_t)
((obj_t)BgL_vz00_3499)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2521 */
obj_t BGl_z62lambda2521z62zz__multimediazd2midizd2(obj_t BgL_envz00_3500, obj_t BgL_oz00_3501)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3501)))->BgL_usleepz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2516> */
obj_t BGl_z62zc3anonymousza32516ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3502)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 87 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &lambda2515 */
obj_t BGl_z62lambda2515z62zz__multimediazd2midizd2(obj_t BgL_envz00_3503, obj_t BgL_oz00_3504, obj_t BgL_vz00_3505)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3504)))->BgL_streamz00)=((obj_t)BgL_vz00_3505),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2514 */
obj_t BGl_z62lambda2514z62zz__multimediazd2midizd2(obj_t BgL_envz00_3506, obj_t BgL_oz00_3507)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3507)))->BgL_streamz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2300> */
obj_t BGl_z62zc3anonymousza32300ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3508, obj_t BgL_new1110z00_3509)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
{ 
BgL_midiplayerz00_bglt BgL_auxz00_7529;
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_errz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_cdelayz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_noteoffz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_noteonz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_aftertouchz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_ctrlchangez00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_prgmchangez00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_afterzd2touchzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_pitchz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_sysexz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_metazd2seqnumzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_metazd2textzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_metazd2copyrightzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_metazd2trackzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_metazd2instrumentzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_metazd2lyriczd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_metazd2markerzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_metazd2cuezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_metazd2prgmnamezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_metazd2devnamezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_metazd2channprefzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_metazd2midiportzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_metazd2eotzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_metazd2tempozd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_metazd2smtpezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_metazd2timesigzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_metazd2keysigzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509)))->BgL_metazd2seqspeczd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_7529 = 
((BgL_midiplayerz00_bglt)BgL_new1110z00_3509); 
return 
((obj_t)BgL_auxz00_7529);} } 
BGL_FUNCTION_END;
}



/* &lambda2298 */
BgL_midiplayerz00_bglt BGl_z62lambda2298z62zz__multimediazd2midizd2(obj_t BgL_envz00_3510)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
{ /* Llib/midi.scm 52 */
BgL_midiplayerz00_bglt BgL_new1109z00_4271;
BgL_new1109z00_4271 = 
((BgL_midiplayerz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiplayerz00_bgl) ))); 
{ /* Llib/midi.scm 52 */
long BgL_arg2299z00_4272;
{ /* Llib/midi.scm 52 */
long BgL_res2806z00_4273;
BgL_res2806z00_4273 = 
BGL_CLASS_INDEX(BGl_midiplayerz00zz__multimediazd2midizd2); 
BgL_arg2299z00_4272 = BgL_res2806z00_4273; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1109z00_4271), BgL_arg2299z00_4272); } 
return BgL_new1109z00_4271;} } 
BGL_FUNCTION_END;
}



/* &lambda2295 */
BgL_midiplayerz00_bglt BGl_z62lambda2295z62zz__multimediazd2midizd2(obj_t BgL_envz00_3511, obj_t BgL_err1081z00_3512, obj_t BgL_cdelay1082z00_3513, obj_t BgL_noteoff1083z00_3514, obj_t BgL_noteon1084z00_3515, obj_t BgL_aftertouch1085z00_3516, obj_t BgL_ctrlchange1086z00_3517, obj_t BgL_prgmchange1087z00_3518, obj_t BgL_afterzd2touch1088zd2_3519, obj_t BgL_pitch1089z00_3520, obj_t BgL_sysex1090z00_3521, obj_t BgL_metazd2seqnum1091zd2_3522, obj_t BgL_metazd2text1092zd2_3523, obj_t BgL_metazd2copyright1093zd2_3524, obj_t BgL_metazd2track1094zd2_3525, obj_t BgL_metazd2instrument1095zd2_3526, obj_t BgL_metazd2lyric1096zd2_3527, obj_t BgL_metazd2marker1097zd2_3528, obj_t BgL_metazd2cue1098zd2_3529, obj_t BgL_metazd2prgmname1099zd2_3530, obj_t BgL_metazd2devname1100zd2_3531, obj_t BgL_metazd2channpref1101zd2_3532, obj_t BgL_metazd2midiport1102zd2_3533, obj_t BgL_metazd2eot1103zd2_3534, obj_t BgL_metazd2tempo1104zd2_3535, obj_t BgL_metazd2smtpe1105zd2_3536, obj_t BgL_metazd2timesig1106zd2_3537, obj_t BgL_metazd2keysig1107zd2_3538, obj_t BgL_metazd2seqspec1108zd2_3539)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
{ /* Llib/midi.scm 52 */
BgL_midiplayerz00_bglt BgL_new1182z00_4302;
{ /* Llib/midi.scm 52 */
BgL_midiplayerz00_bglt BgL_new1181z00_4303;
BgL_new1181z00_4303 = 
((BgL_midiplayerz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiplayerz00_bgl) ))); 
{ /* Llib/midi.scm 52 */
long BgL_arg2297z00_4304;
{ /* Llib/midi.scm 52 */
long BgL_res2805z00_4305;
BgL_res2805z00_4305 = 
BGL_CLASS_INDEX(BGl_midiplayerz00zz__multimediazd2midizd2); 
BgL_arg2297z00_4304 = BgL_res2805z00_4305; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1181z00_4303), BgL_arg2297z00_4304); } 
BgL_new1182z00_4302 = BgL_new1181z00_4303; } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_errz00)=((obj_t)
((obj_t)BgL_err1081z00_3512)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_cdelayz00)=((obj_t)
((obj_t)BgL_cdelay1082z00_3513)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_noteoffz00)=((obj_t)
((obj_t)BgL_noteoff1083z00_3514)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_noteonz00)=((obj_t)
((obj_t)BgL_noteon1084z00_3515)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_aftertouchz00)=((obj_t)
((obj_t)BgL_aftertouch1085z00_3516)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_ctrlchangez00)=((obj_t)
((obj_t)BgL_ctrlchange1086z00_3517)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_prgmchangez00)=((obj_t)
((obj_t)BgL_prgmchange1087z00_3518)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_afterzd2touchzd2)=((obj_t)
((obj_t)BgL_afterzd2touch1088zd2_3519)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_pitchz00)=((obj_t)
((obj_t)BgL_pitch1089z00_3520)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_sysexz00)=((obj_t)
((obj_t)BgL_sysex1090z00_3521)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_metazd2seqnumzd2)=((obj_t)
((obj_t)BgL_metazd2seqnum1091zd2_3522)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_metazd2textzd2)=((obj_t)
((obj_t)BgL_metazd2text1092zd2_3523)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_metazd2copyrightzd2)=((obj_t)
((obj_t)BgL_metazd2copyright1093zd2_3524)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_metazd2trackzd2)=((obj_t)
((obj_t)BgL_metazd2track1094zd2_3525)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_metazd2instrumentzd2)=((obj_t)
((obj_t)BgL_metazd2instrument1095zd2_3526)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_metazd2lyriczd2)=((obj_t)
((obj_t)BgL_metazd2lyric1096zd2_3527)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_metazd2markerzd2)=((obj_t)
((obj_t)BgL_metazd2marker1097zd2_3528)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_metazd2cuezd2)=((obj_t)
((obj_t)BgL_metazd2cue1098zd2_3529)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_metazd2prgmnamezd2)=((obj_t)
((obj_t)BgL_metazd2prgmname1099zd2_3530)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_metazd2devnamezd2)=((obj_t)
((obj_t)BgL_metazd2devname1100zd2_3531)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_metazd2channprefzd2)=((obj_t)
((obj_t)BgL_metazd2channpref1101zd2_3532)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_metazd2midiportzd2)=((obj_t)
((obj_t)BgL_metazd2midiport1102zd2_3533)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_metazd2eotzd2)=((obj_t)
((obj_t)BgL_metazd2eot1103zd2_3534)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_metazd2tempozd2)=((obj_t)
((obj_t)BgL_metazd2tempo1104zd2_3535)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_metazd2smtpezd2)=((obj_t)
((obj_t)BgL_metazd2smtpe1105zd2_3536)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_metazd2timesigzd2)=((obj_t)
((obj_t)BgL_metazd2timesig1106zd2_3537)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_metazd2keysigzd2)=((obj_t)
((obj_t)BgL_metazd2keysig1107zd2_3538)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4302))->BgL_metazd2seqspeczd2)=((obj_t)
((obj_t)BgL_metazd2seqspec1108zd2_3539)),BUNSPEC); 
{ /* Llib/midi.scm 52 */
obj_t BgL_fun2296z00_4306;
BgL_fun2296z00_4306 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midiplayerz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2296z00_4306)(BgL_fun2296z00_4306, 
((obj_t)BgL_new1182z00_4302), BEOA); } 
return BgL_new1182z00_4302;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2498> */
obj_t BGl_z62zc3anonymousza32498ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3540)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2497 */
obj_t BGl_z62lambda2497z62zz__multimediazd2midizd2(obj_t BgL_envz00_3541, obj_t BgL_oz00_3542, obj_t BgL_vz00_3543)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3542)))->BgL_metazd2seqspeczd2)=((obj_t)
((obj_t)BgL_vz00_3543)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2496 */
obj_t BGl_z62lambda2496z62zz__multimediazd2midizd2(obj_t BgL_envz00_3544, obj_t BgL_oz00_3545)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3545)))->BgL_metazd2seqspeczd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2491> */
obj_t BGl_z62zc3anonymousza32491ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3546)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2490 */
obj_t BGl_z62lambda2490z62zz__multimediazd2midizd2(obj_t BgL_envz00_3547, obj_t BgL_oz00_3548, obj_t BgL_vz00_3549)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3548)))->BgL_metazd2keysigzd2)=((obj_t)
((obj_t)BgL_vz00_3549)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2489 */
obj_t BGl_z62lambda2489z62zz__multimediazd2midizd2(obj_t BgL_envz00_3550, obj_t BgL_oz00_3551)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3551)))->BgL_metazd2keysigzd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2483> */
obj_t BGl_z62zc3anonymousza32483ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3552)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_proc3295z00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2482 */
obj_t BGl_z62lambda2482z62zz__multimediazd2midizd2(obj_t BgL_envz00_3553, obj_t BgL_oz00_3554, obj_t BgL_vz00_3555)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3554)))->BgL_metazd2timesigzd2)=((obj_t)
((obj_t)BgL_vz00_3555)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2481 */
obj_t BGl_z62lambda2481z62zz__multimediazd2midizd2(obj_t BgL_envz00_3556, obj_t BgL_oz00_3557)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3557)))->BgL_metazd2timesigzd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2484> */
obj_t BGl_z62zc3anonymousza32484ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3558, obj_t BgL_mpz00_3559, obj_t BgL_msz00_3560, obj_t BgL_tickz00_3561, obj_t BgL_nnz00_3562, obj_t BgL_ddz00_3563, obj_t BgL_ccz00_3564, obj_t BgL_bbz00_3565)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 83 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2475> */
obj_t BGl_z62zc3anonymousza32475ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3566)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_proc3296z00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2474 */
obj_t BGl_z62lambda2474z62zz__multimediazd2midizd2(obj_t BgL_envz00_3567, obj_t BgL_oz00_3568, obj_t BgL_vz00_3569)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3568)))->BgL_metazd2smtpezd2)=((obj_t)
((obj_t)BgL_vz00_3569)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2473 */
obj_t BGl_z62lambda2473z62zz__multimediazd2midizd2(obj_t BgL_envz00_3570, obj_t BgL_oz00_3571)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3571)))->BgL_metazd2smtpezd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2476> */
obj_t BGl_z62zc3anonymousza32476ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3572, obj_t BgL_mpz00_3573, obj_t BgL_msz00_3574, obj_t BgL_tickz00_3575, obj_t BgL_hrz00_3576, obj_t BgL_mmz00_3577, obj_t BgL_sez00_3578, obj_t BgL_frz00_3579, obj_t BgL_ffz00_3580)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 82 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2468> */
obj_t BGl_z62zc3anonymousza32468ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3581)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2467 */
obj_t BGl_z62lambda2467z62zz__multimediazd2midizd2(obj_t BgL_envz00_3582, obj_t BgL_oz00_3583, obj_t BgL_vz00_3584)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3583)))->BgL_metazd2tempozd2)=((obj_t)
((obj_t)BgL_vz00_3584)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2466 */
obj_t BGl_z62lambda2466z62zz__multimediazd2midizd2(obj_t BgL_envz00_3585, obj_t BgL_oz00_3586)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3586)))->BgL_metazd2tempozd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2461> */
obj_t BGl_z62zc3anonymousza32461ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3587)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2460 */
obj_t BGl_z62lambda2460z62zz__multimediazd2midizd2(obj_t BgL_envz00_3588, obj_t BgL_oz00_3589, obj_t BgL_vz00_3590)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3589)))->BgL_metazd2eotzd2)=((obj_t)
((obj_t)BgL_vz00_3590)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2459 */
obj_t BGl_z62lambda2459z62zz__multimediazd2midizd2(obj_t BgL_envz00_3591, obj_t BgL_oz00_3592)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3592)))->BgL_metazd2eotzd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2454> */
obj_t BGl_z62zc3anonymousza32454ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3593)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2453 */
obj_t BGl_z62lambda2453z62zz__multimediazd2midizd2(obj_t BgL_envz00_3594, obj_t BgL_oz00_3595, obj_t BgL_vz00_3596)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3595)))->BgL_metazd2midiportzd2)=((obj_t)
((obj_t)BgL_vz00_3596)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2452 */
obj_t BGl_z62lambda2452z62zz__multimediazd2midizd2(obj_t BgL_envz00_3597, obj_t BgL_oz00_3598)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3598)))->BgL_metazd2midiportzd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2447> */
obj_t BGl_z62zc3anonymousza32447ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3599)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2446 */
obj_t BGl_z62lambda2446z62zz__multimediazd2midizd2(obj_t BgL_envz00_3600, obj_t BgL_oz00_3601, obj_t BgL_vz00_3602)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3601)))->BgL_metazd2channprefzd2)=((obj_t)
((obj_t)BgL_vz00_3602)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2445 */
obj_t BGl_z62lambda2445z62zz__multimediazd2midizd2(obj_t BgL_envz00_3603, obj_t BgL_oz00_3604)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3604)))->BgL_metazd2channprefzd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2440> */
obj_t BGl_z62zc3anonymousza32440ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3605)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2439 */
obj_t BGl_z62lambda2439z62zz__multimediazd2midizd2(obj_t BgL_envz00_3606, obj_t BgL_oz00_3607, obj_t BgL_vz00_3608)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3607)))->BgL_metazd2devnamezd2)=((obj_t)
((obj_t)BgL_vz00_3608)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2438 */
obj_t BGl_z62lambda2438z62zz__multimediazd2midizd2(obj_t BgL_envz00_3609, obj_t BgL_oz00_3610)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3610)))->BgL_metazd2devnamezd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2433> */
obj_t BGl_z62zc3anonymousza32433ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3611)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2432 */
obj_t BGl_z62lambda2432z62zz__multimediazd2midizd2(obj_t BgL_envz00_3612, obj_t BgL_oz00_3613, obj_t BgL_vz00_3614)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3613)))->BgL_metazd2prgmnamezd2)=((obj_t)
((obj_t)BgL_vz00_3614)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2431 */
obj_t BGl_z62lambda2431z62zz__multimediazd2midizd2(obj_t BgL_envz00_3615, obj_t BgL_oz00_3616)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3616)))->BgL_metazd2prgmnamezd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2426> */
obj_t BGl_z62zc3anonymousza32426ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3617)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2425 */
obj_t BGl_z62lambda2425z62zz__multimediazd2midizd2(obj_t BgL_envz00_3618, obj_t BgL_oz00_3619, obj_t BgL_vz00_3620)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3619)))->BgL_metazd2cuezd2)=((obj_t)
((obj_t)BgL_vz00_3620)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2424 */
obj_t BGl_z62lambda2424z62zz__multimediazd2midizd2(obj_t BgL_envz00_3621, obj_t BgL_oz00_3622)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3622)))->BgL_metazd2cuezd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2419> */
obj_t BGl_z62zc3anonymousza32419ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3623)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2418 */
obj_t BGl_z62lambda2418z62zz__multimediazd2midizd2(obj_t BgL_envz00_3624, obj_t BgL_oz00_3625, obj_t BgL_vz00_3626)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3625)))->BgL_metazd2markerzd2)=((obj_t)
((obj_t)BgL_vz00_3626)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2417 */
obj_t BGl_z62lambda2417z62zz__multimediazd2midizd2(obj_t BgL_envz00_3627, obj_t BgL_oz00_3628)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3628)))->BgL_metazd2markerzd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2412> */
obj_t BGl_z62zc3anonymousza32412ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3629)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2411 */
obj_t BGl_z62lambda2411z62zz__multimediazd2midizd2(obj_t BgL_envz00_3630, obj_t BgL_oz00_3631, obj_t BgL_vz00_3632)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3631)))->BgL_metazd2lyriczd2)=((obj_t)
((obj_t)BgL_vz00_3632)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2410 */
obj_t BGl_z62lambda2410z62zz__multimediazd2midizd2(obj_t BgL_envz00_3633, obj_t BgL_oz00_3634)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3634)))->BgL_metazd2lyriczd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2405> */
obj_t BGl_z62zc3anonymousza32405ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3635)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2404 */
obj_t BGl_z62lambda2404z62zz__multimediazd2midizd2(obj_t BgL_envz00_3636, obj_t BgL_oz00_3637, obj_t BgL_vz00_3638)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3637)))->BgL_metazd2instrumentzd2)=((obj_t)
((obj_t)BgL_vz00_3638)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2403 */
obj_t BGl_z62lambda2403z62zz__multimediazd2midizd2(obj_t BgL_envz00_3639, obj_t BgL_oz00_3640)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3640)))->BgL_metazd2instrumentzd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2398> */
obj_t BGl_z62zc3anonymousza32398ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3641)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2397 */
obj_t BGl_z62lambda2397z62zz__multimediazd2midizd2(obj_t BgL_envz00_3642, obj_t BgL_oz00_3643, obj_t BgL_vz00_3644)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3643)))->BgL_metazd2trackzd2)=((obj_t)
((obj_t)BgL_vz00_3644)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2396 */
obj_t BGl_z62lambda2396z62zz__multimediazd2midizd2(obj_t BgL_envz00_3645, obj_t BgL_oz00_3646)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3646)))->BgL_metazd2trackzd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2391> */
obj_t BGl_z62zc3anonymousza32391ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3647)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2390 */
obj_t BGl_z62lambda2390z62zz__multimediazd2midizd2(obj_t BgL_envz00_3648, obj_t BgL_oz00_3649, obj_t BgL_vz00_3650)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3649)))->BgL_metazd2copyrightzd2)=((obj_t)
((obj_t)BgL_vz00_3650)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2389 */
obj_t BGl_z62lambda2389z62zz__multimediazd2midizd2(obj_t BgL_envz00_3651, obj_t BgL_oz00_3652)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3652)))->BgL_metazd2copyrightzd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2384> */
obj_t BGl_z62zc3anonymousza32384ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3653)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2383 */
obj_t BGl_z62lambda2383z62zz__multimediazd2midizd2(obj_t BgL_envz00_3654, obj_t BgL_oz00_3655, obj_t BgL_vz00_3656)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3655)))->BgL_metazd2textzd2)=((obj_t)
((obj_t)BgL_vz00_3656)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2382 */
obj_t BGl_z62lambda2382z62zz__multimediazd2midizd2(obj_t BgL_envz00_3657, obj_t BgL_oz00_3658)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3658)))->BgL_metazd2textzd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2377> */
obj_t BGl_z62zc3anonymousza32377ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3659)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2376 */
obj_t BGl_z62lambda2376z62zz__multimediazd2midizd2(obj_t BgL_envz00_3660, obj_t BgL_oz00_3661, obj_t BgL_vz00_3662)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3661)))->BgL_metazd2seqnumzd2)=((obj_t)
((obj_t)BgL_vz00_3662)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2375 */
obj_t BGl_z62lambda2375z62zz__multimediazd2midizd2(obj_t BgL_envz00_3663, obj_t BgL_oz00_3664)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3664)))->BgL_metazd2seqnumzd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2370> */
obj_t BGl_z62zc3anonymousza32370ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3665)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2sysexzd2envz00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2369 */
obj_t BGl_z62lambda2369z62zz__multimediazd2midizd2(obj_t BgL_envz00_3666, obj_t BgL_oz00_3667, obj_t BgL_vz00_3668)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3667)))->BgL_sysexz00)=((obj_t)
((obj_t)BgL_vz00_3668)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2368 */
obj_t BGl_z62lambda2368z62zz__multimediazd2midizd2(obj_t BgL_envz00_3669, obj_t BgL_oz00_3670)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3670)))->BgL_sysexz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2363> */
obj_t BGl_z62zc3anonymousza32363ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3671)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2pitchzd2envz00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2362 */
obj_t BGl_z62lambda2362z62zz__multimediazd2midizd2(obj_t BgL_envz00_3672, obj_t BgL_oz00_3673, obj_t BgL_vz00_3674)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3673)))->BgL_pitchz00)=((obj_t)
((obj_t)BgL_vz00_3674)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2361 */
obj_t BGl_z62lambda2361z62zz__multimediazd2midizd2(obj_t BgL_envz00_3675, obj_t BgL_oz00_3676)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3676)))->BgL_pitchz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2356> */
obj_t BGl_z62zc3anonymousza32356ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3677)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2afterzd2touchzd2envzd2zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2355 */
obj_t BGl_z62lambda2355z62zz__multimediazd2midizd2(obj_t BgL_envz00_3678, obj_t BgL_oz00_3679, obj_t BgL_vz00_3680)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3679)))->BgL_afterzd2touchzd2)=((obj_t)
((obj_t)BgL_vz00_3680)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2354 */
obj_t BGl_z62lambda2354z62zz__multimediazd2midizd2(obj_t BgL_envz00_3681, obj_t BgL_oz00_3682)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3682)))->BgL_afterzd2touchzd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2349> */
obj_t BGl_z62zc3anonymousza32349ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3683)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2prgmchangezd2envz00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2348 */
obj_t BGl_z62lambda2348z62zz__multimediazd2midizd2(obj_t BgL_envz00_3684, obj_t BgL_oz00_3685, obj_t BgL_vz00_3686)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3685)))->BgL_prgmchangez00)=((obj_t)
((obj_t)BgL_vz00_3686)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2347 */
obj_t BGl_z62lambda2347z62zz__multimediazd2midizd2(obj_t BgL_envz00_3687, obj_t BgL_oz00_3688)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3688)))->BgL_prgmchangez00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2342> */
obj_t BGl_z62zc3anonymousza32342ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3689)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ctrlchangezd2envz00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2341 */
obj_t BGl_z62lambda2341z62zz__multimediazd2midizd2(obj_t BgL_envz00_3690, obj_t BgL_oz00_3691, obj_t BgL_vz00_3692)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3691)))->BgL_ctrlchangez00)=((obj_t)
((obj_t)BgL_vz00_3692)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2340 */
obj_t BGl_z62lambda2340z62zz__multimediazd2midizd2(obj_t BgL_envz00_3693, obj_t BgL_oz00_3694)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3694)))->BgL_ctrlchangez00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2335> */
obj_t BGl_z62zc3anonymousza32335ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3695)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2aftertouchzd2envz00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2334 */
obj_t BGl_z62lambda2334z62zz__multimediazd2midizd2(obj_t BgL_envz00_3696, obj_t BgL_oz00_3697, obj_t BgL_vz00_3698)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3697)))->BgL_aftertouchz00)=((obj_t)
((obj_t)BgL_vz00_3698)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2333 */
obj_t BGl_z62lambda2333z62zz__multimediazd2midizd2(obj_t BgL_envz00_3699, obj_t BgL_oz00_3700)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3700)))->BgL_aftertouchz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2328> */
obj_t BGl_z62zc3anonymousza32328ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3701)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2noteonzd2envz00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2327 */
obj_t BGl_z62lambda2327z62zz__multimediazd2midizd2(obj_t BgL_envz00_3702, obj_t BgL_oz00_3703, obj_t BgL_vz00_3704)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3703)))->BgL_noteonz00)=((obj_t)
((obj_t)BgL_vz00_3704)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2326 */
obj_t BGl_z62lambda2326z62zz__multimediazd2midizd2(obj_t BgL_envz00_3705, obj_t BgL_oz00_3706)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3706)))->BgL_noteonz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2321> */
obj_t BGl_z62zc3anonymousza32321ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3707)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2noteoffzd2envz00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2320 */
obj_t BGl_z62lambda2320z62zz__multimediazd2midizd2(obj_t BgL_envz00_3708, obj_t BgL_oz00_3709, obj_t BgL_vz00_3710)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3709)))->BgL_noteoffz00)=((obj_t)
((obj_t)BgL_vz00_3710)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2319 */
obj_t BGl_z62lambda2319z62zz__multimediazd2midizd2(obj_t BgL_envz00_3711, obj_t BgL_oz00_3712)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3712)))->BgL_noteoffz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2314> */
obj_t BGl_z62zc3anonymousza32314ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3713)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2cdelayzd2envz00zz__multimediazd2midizd2;} 
BGL_FUNCTION_END;
}



/* &lambda2313 */
obj_t BGl_z62lambda2313z62zz__multimediazd2midizd2(obj_t BgL_envz00_3714, obj_t BgL_oz00_3715, obj_t BgL_vz00_3716)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3715)))->BgL_cdelayz00)=((obj_t)
((obj_t)BgL_vz00_3716)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2312 */
obj_t BGl_z62lambda2312z62zz__multimediazd2midizd2(obj_t BgL_envz00_3717, obj_t BgL_oz00_3718)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3718)))->BgL_cdelayz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2307> */
obj_t BGl_z62zc3anonymousza32307ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3719)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return BGl_errorzd2envzd2zz__errorz00;} 
BGL_FUNCTION_END;
}



/* &lambda2306 */
obj_t BGl_z62lambda2306z62zz__multimediazd2midizd2(obj_t BgL_envz00_3720, obj_t BgL_oz00_3721, obj_t BgL_vz00_3722)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3721)))->BgL_errz00)=((obj_t)
((obj_t)BgL_vz00_3722)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2305 */
obj_t BGl_z62lambda2305z62zz__multimediazd2midizd2(obj_t BgL_envz00_3723, obj_t BgL_oz00_3724)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3724)))->BgL_errz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2254> */
obj_t BGl_z62zc3anonymousza32254ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3725, obj_t BgL_new1079z00_3726)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 42 */
{ 
BgL_midireaderz00_bglt BgL_auxz00_7800;
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1079z00_3726)))->BgL_peekzd2bytezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1079z00_3726)))->BgL_readzd2bytezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1079z00_3726)))->BgL_readzd2int16zd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1079z00_3726)))->BgL_readzd2int32zd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1079z00_3726)))->BgL_readzd2intzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1079z00_3726)))->BgL_readzd2vlqzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1079z00_3726)))->BgL_readzd2charszd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_7800 = 
((BgL_midireaderz00_bglt)BgL_new1079z00_3726); 
return 
((obj_t)BgL_auxz00_7800);} } 
BGL_FUNCTION_END;
}



/* &lambda2252 */
BgL_midireaderz00_bglt BGl_z62lambda2252z62zz__multimediazd2midizd2(obj_t BgL_envz00_3727)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 42 */
{ /* Llib/midi.scm 42 */
BgL_midireaderz00_bglt BgL_new1078z00_4392;
BgL_new1078z00_4392 = 
((BgL_midireaderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midireaderz00_bgl) ))); 
{ /* Llib/midi.scm 42 */
long BgL_arg2253z00_4393;
{ /* Llib/midi.scm 42 */
long BgL_res2804z00_4394;
BgL_res2804z00_4394 = 
BGL_CLASS_INDEX(BGl_midireaderz00zz__multimediazd2midizd2); 
BgL_arg2253z00_4393 = BgL_res2804z00_4394; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1078z00_4392), BgL_arg2253z00_4393); } 
return BgL_new1078z00_4392;} } 
BGL_FUNCTION_END;
}



/* &lambda2249 */
BgL_midireaderz00_bglt BGl_z62lambda2249z62zz__multimediazd2midizd2(obj_t BgL_envz00_3728, obj_t BgL_peekzd2byte1071zd2_3729, obj_t BgL_readzd2byte1072zd2_3730, obj_t BgL_readzd2int161073zd2_3731, obj_t BgL_readzd2int321074zd2_3732, obj_t BgL_readzd2int1075zd2_3733, obj_t BgL_readzd2vlq1076zd2_3734, obj_t BgL_readzd2chars1077zd2_3735)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 42 */
{ /* Llib/midi.scm 42 */
BgL_midireaderz00_bglt BgL_new1180z00_4402;
{ /* Llib/midi.scm 42 */
BgL_midireaderz00_bglt BgL_new1179z00_4403;
BgL_new1179z00_4403 = 
((BgL_midireaderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midireaderz00_bgl) ))); 
{ /* Llib/midi.scm 42 */
long BgL_arg2251z00_4404;
{ /* Llib/midi.scm 42 */
long BgL_res2803z00_4405;
BgL_res2803z00_4405 = 
BGL_CLASS_INDEX(BGl_midireaderz00zz__multimediazd2midizd2); 
BgL_arg2251z00_4404 = BgL_res2803z00_4405; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1179z00_4403), BgL_arg2251z00_4404); } 
BgL_new1180z00_4402 = BgL_new1179z00_4403; } 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1180z00_4402))->BgL_peekzd2bytezd2)=((obj_t)
((obj_t)BgL_peekzd2byte1071zd2_3729)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1180z00_4402))->BgL_readzd2bytezd2)=((obj_t)
((obj_t)BgL_readzd2byte1072zd2_3730)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1180z00_4402))->BgL_readzd2int16zd2)=((obj_t)
((obj_t)BgL_readzd2int161073zd2_3731)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1180z00_4402))->BgL_readzd2int32zd2)=((obj_t)
((obj_t)BgL_readzd2int321074zd2_3732)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1180z00_4402))->BgL_readzd2intzd2)=((obj_t)
((obj_t)BgL_readzd2int1075zd2_3733)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1180z00_4402))->BgL_readzd2vlqzd2)=((obj_t)
((obj_t)BgL_readzd2vlq1076zd2_3734)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1180z00_4402))->BgL_readzd2charszd2)=((obj_t)
((obj_t)BgL_readzd2chars1077zd2_3735)),BUNSPEC); 
{ /* Llib/midi.scm 42 */
obj_t BgL_fun2250z00_4406;
BgL_fun2250z00_4406 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midireaderz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2250z00_4406)(BgL_fun2250z00_4406, 
((obj_t)BgL_new1180z00_4402), BEOA); } 
return BgL_new1180z00_4402;} } 
BGL_FUNCTION_END;
}



/* &lambda2289 */
obj_t BGl_z62lambda2289z62zz__multimediazd2midizd2(obj_t BgL_envz00_3736, obj_t BgL_oz00_3737, obj_t BgL_vz00_3738)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3737)))->BgL_readzd2charszd2)=((obj_t)
((obj_t)BgL_vz00_3738)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2288 */
obj_t BGl_z62lambda2288z62zz__multimediazd2midizd2(obj_t BgL_envz00_3739, obj_t BgL_oz00_3740)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3740)))->BgL_readzd2charszd2);} 
BGL_FUNCTION_END;
}



/* &lambda2284 */
obj_t BGl_z62lambda2284z62zz__multimediazd2midizd2(obj_t BgL_envz00_3741, obj_t BgL_oz00_3742, obj_t BgL_vz00_3743)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3742)))->BgL_readzd2vlqzd2)=((obj_t)
((obj_t)BgL_vz00_3743)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2283 */
obj_t BGl_z62lambda2283z62zz__multimediazd2midizd2(obj_t BgL_envz00_3744, obj_t BgL_oz00_3745)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3745)))->BgL_readzd2vlqzd2);} 
BGL_FUNCTION_END;
}



/* &lambda2279 */
obj_t BGl_z62lambda2279z62zz__multimediazd2midizd2(obj_t BgL_envz00_3746, obj_t BgL_oz00_3747, obj_t BgL_vz00_3748)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3747)))->BgL_readzd2intzd2)=((obj_t)
((obj_t)BgL_vz00_3748)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2278 */
obj_t BGl_z62lambda2278z62zz__multimediazd2midizd2(obj_t BgL_envz00_3749, obj_t BgL_oz00_3750)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3750)))->BgL_readzd2intzd2);} 
BGL_FUNCTION_END;
}



/* &lambda2274 */
obj_t BGl_z62lambda2274z62zz__multimediazd2midizd2(obj_t BgL_envz00_3751, obj_t BgL_oz00_3752, obj_t BgL_vz00_3753)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3752)))->BgL_readzd2int32zd2)=((obj_t)
((obj_t)BgL_vz00_3753)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2273 */
obj_t BGl_z62lambda2273z62zz__multimediazd2midizd2(obj_t BgL_envz00_3754, obj_t BgL_oz00_3755)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3755)))->BgL_readzd2int32zd2);} 
BGL_FUNCTION_END;
}



/* &lambda2269 */
obj_t BGl_z62lambda2269z62zz__multimediazd2midizd2(obj_t BgL_envz00_3756, obj_t BgL_oz00_3757, obj_t BgL_vz00_3758)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3757)))->BgL_readzd2int16zd2)=((obj_t)
((obj_t)BgL_vz00_3758)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2268 */
obj_t BGl_z62lambda2268z62zz__multimediazd2midizd2(obj_t BgL_envz00_3759, obj_t BgL_oz00_3760)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3760)))->BgL_readzd2int16zd2);} 
BGL_FUNCTION_END;
}



/* &lambda2264 */
obj_t BGl_z62lambda2264z62zz__multimediazd2midizd2(obj_t BgL_envz00_3761, obj_t BgL_oz00_3762, obj_t BgL_vz00_3763)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3762)))->BgL_readzd2bytezd2)=((obj_t)
((obj_t)BgL_vz00_3763)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2263 */
obj_t BGl_z62lambda2263z62zz__multimediazd2midizd2(obj_t BgL_envz00_3764, obj_t BgL_oz00_3765)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3765)))->BgL_readzd2bytezd2);} 
BGL_FUNCTION_END;
}



/* &lambda2259 */
obj_t BGl_z62lambda2259z62zz__multimediazd2midizd2(obj_t BgL_envz00_3766, obj_t BgL_oz00_3767, obj_t BgL_vz00_3768)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3767)))->BgL_peekzd2bytezd2)=((obj_t)
((obj_t)BgL_vz00_3768)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2258 */
obj_t BGl_z62lambda2258z62zz__multimediazd2midizd2(obj_t BgL_envz00_3769, obj_t BgL_oz00_3770)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3770)))->BgL_peekzd2bytezd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2149> */
obj_t BGl_z62zc3anonymousza32149ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3771, obj_t BgL_new1069z00_3772)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
{ 
BgL_miditrackz00_bglt BgL_auxz00_7880;
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3772)))->BgL_z52streamz52)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_midireaderz00_bglt BgL_auxz00_7883;
{ /* Llib/midi.scm 24 */
obj_t BgL_classz00_4429;
BgL_classz00_4429 = BGl_midireaderz00zz__multimediazd2midizd2; 
{ /* Llib/midi.scm 24 */
obj_t BgL__ortest_1106z00_4430;
BgL__ortest_1106z00_4430 = 
BGL_CLASS_NIL(BgL_classz00_4429); 
if(
CBOOL(BgL__ortest_1106z00_4430))
{ /* Llib/midi.scm 24 */
BgL_auxz00_7883 = 
((BgL_midireaderz00_bglt)BgL__ortest_1106z00_4430)
; }  else 
{ /* Llib/midi.scm 24 */
BgL_auxz00_7883 = 
((BgL_midireaderz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4429))
; } } } 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3772)))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)BgL_auxz00_7883),BUNSPEC); } 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3772)))->BgL_z52closez52)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3772)))->BgL_z52eotz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3772)))->BgL_z52wtickz52)=((uint32_t)
0L),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3772)))->BgL_z52statusz52)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3772)))->BgL_lenz00)=((int32_t)
0L),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3772)))->BgL_tempoz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3772)))->BgL_ipz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3772)))->BgL_startz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3772)))->BgL_datastartz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3772)))->BgL_wtickz00)=((uint32_t)
0L),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3772)))->BgL_statusz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3772)))->BgL_eotz00)=((bool_t)((bool_t)0)),BUNSPEC); 
BgL_auxz00_7880 = 
((BgL_miditrackz00_bglt)BgL_new1069z00_3772); 
return 
((obj_t)BgL_auxz00_7880);} } 
BGL_FUNCTION_END;
}



/* &lambda2147 */
BgL_miditrackz00_bglt BGl_z62lambda2147z62zz__multimediazd2midizd2(obj_t BgL_envz00_3773)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
BgL_miditrackz00_bglt BgL_new1068z00_4431;
BgL_new1068z00_4431 = 
((BgL_miditrackz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_miditrackz00_bgl) ))); 
{ /* Llib/midi.scm 24 */
long BgL_arg2148z00_4432;
{ /* Llib/midi.scm 24 */
long BgL_res2802z00_4433;
BgL_res2802z00_4433 = 
BGL_CLASS_INDEX(BGl_miditrackz00zz__multimediazd2midizd2); 
BgL_arg2148z00_4432 = BgL_res2802z00_4433; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1068z00_4431), BgL_arg2148z00_4432); } 
return BgL_new1068z00_4431;} } 
BGL_FUNCTION_END;
}



/* &lambda2144 */
BgL_miditrackz00_bglt BGl_z62lambda2144z62zz__multimediazd2midizd2(obj_t BgL_envz00_3774, obj_t BgL_z52stream1054z52_3775, obj_t BgL_z52reader1055z52_3776, obj_t BgL_z52close1056z52_3777, obj_t BgL_z52eot1057z52_3778, obj_t BgL_z52wtick1058z52_3779, obj_t BgL_z52status1059z52_3780, obj_t BgL_len1060z00_3781, obj_t BgL_tempo1061z00_3782, obj_t BgL_ip1062z00_3783, obj_t BgL_start1063z00_3784, obj_t BgL_datastart1064z00_3785, obj_t BgL_wtick1065z00_3786, obj_t BgL_status1066z00_3787, obj_t BgL_eot1067z00_3788)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
bool_t BgL_z52eot1057z52_4436;uint32_t BgL_z52wtick1058z52_4437;long BgL_z52status1059z52_4438;int32_t BgL_len1060z00_4439;long BgL_tempo1061z00_4440;long BgL_start1063z00_4441;long BgL_datastart1064z00_4442;uint32_t BgL_wtick1065z00_4443;long BgL_status1066z00_4444;bool_t BgL_eot1067z00_4445;
BgL_z52eot1057z52_4436 = 
CBOOL(BgL_z52eot1057z52_3778); 
BgL_z52wtick1058z52_4437 = 
BGL_BUINT32_TO_UINT32(BgL_z52wtick1058z52_3779); 
BgL_z52status1059z52_4438 = 
(long)CINT(BgL_z52status1059z52_3780); 
BgL_len1060z00_4439 = 
BGL_BINT32_TO_INT32(BgL_len1060z00_3781); 
BgL_tempo1061z00_4440 = 
(long)CINT(BgL_tempo1061z00_3782); 
BgL_start1063z00_4441 = 
(long)CINT(BgL_start1063z00_3784); 
BgL_datastart1064z00_4442 = 
(long)CINT(BgL_datastart1064z00_3785); 
BgL_wtick1065z00_4443 = 
BGL_BUINT32_TO_UINT32(BgL_wtick1065z00_3786); 
BgL_status1066z00_4444 = 
(long)CINT(BgL_status1066z00_3787); 
BgL_eot1067z00_4445 = 
CBOOL(BgL_eot1067z00_3788); 
{ /* Llib/midi.scm 24 */
BgL_miditrackz00_bglt BgL_new1178z00_4446;
{ /* Llib/midi.scm 24 */
BgL_miditrackz00_bglt BgL_new1177z00_4447;
BgL_new1177z00_4447 = 
((BgL_miditrackz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_miditrackz00_bgl) ))); 
{ /* Llib/midi.scm 24 */
long BgL_arg2146z00_4448;
{ /* Llib/midi.scm 24 */
long BgL_res2801z00_4449;
BgL_res2801z00_4449 = 
BGL_CLASS_INDEX(BGl_miditrackz00zz__multimediazd2midizd2); 
BgL_arg2146z00_4448 = BgL_res2801z00_4449; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1177z00_4447), BgL_arg2146z00_4448); } 
BgL_new1178z00_4446 = BgL_new1177z00_4447; } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4446))->BgL_z52streamz52)=((obj_t)BgL_z52stream1054z52_3775),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4446))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)
((BgL_midireaderz00_bglt)BgL_z52reader1055z52_3776)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4446))->BgL_z52closez52)=((obj_t)
((obj_t)BgL_z52close1056z52_3777)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4446))->BgL_z52eotz52)=((bool_t)BgL_z52eot1057z52_4436),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4446))->BgL_z52wtickz52)=((uint32_t)BgL_z52wtick1058z52_4437),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4446))->BgL_z52statusz52)=((long)BgL_z52status1059z52_4438),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4446))->BgL_lenz00)=((int32_t)BgL_len1060z00_4439),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4446))->BgL_tempoz00)=((long)BgL_tempo1061z00_4440),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4446))->BgL_ipz00)=((obj_t)BgL_ip1062z00_3783),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4446))->BgL_startz00)=((long)BgL_start1063z00_4441),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4446))->BgL_datastartz00)=((long)BgL_datastart1064z00_4442),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4446))->BgL_wtickz00)=((uint32_t)BgL_wtick1065z00_4443),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4446))->BgL_statusz00)=((long)BgL_status1066z00_4444),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4446))->BgL_eotz00)=((bool_t)BgL_eot1067z00_4445),BUNSPEC); 
{ /* Llib/midi.scm 24 */
obj_t BgL_fun2145z00_4450;
BgL_fun2145z00_4450 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_miditrackz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2145z00_4450)(BgL_fun2145z00_4450, 
((obj_t)BgL_new1178z00_4446), BEOA); } 
return BgL_new1178z00_4446;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2243> */
obj_t BGl_z62zc3anonymousza32243ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3789)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &lambda2242 */
obj_t BGl_z62lambda2242z62zz__multimediazd2midizd2(obj_t BgL_envz00_3790, obj_t BgL_oz00_3791, obj_t BgL_vz00_3792)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
bool_t BgL_vz00_4452;
BgL_vz00_4452 = 
CBOOL(BgL_vz00_3792); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3791)))->BgL_eotz00)=((bool_t)BgL_vz00_4452),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2241 */
obj_t BGl_z62lambda2241z62zz__multimediazd2midizd2(obj_t BgL_envz00_3793, obj_t BgL_oz00_3794)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
BBOOL(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3794)))->BgL_eotz00));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2236> */
obj_t BGl_z62zc3anonymousza32236ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3795)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
BINT(((long)-1));} 
BGL_FUNCTION_END;
}



/* &lambda2235 */
obj_t BGl_z62lambda2235z62zz__multimediazd2midizd2(obj_t BgL_envz00_3796, obj_t BgL_oz00_3797, obj_t BgL_vz00_3798)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4455;
BgL_vz00_4455 = 
(long)CINT(BgL_vz00_3798); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3797)))->BgL_statusz00)=((long)BgL_vz00_4455),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2234 */
obj_t BGl_z62lambda2234z62zz__multimediazd2midizd2(obj_t BgL_envz00_3799, obj_t BgL_oz00_3800)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3800)))->BgL_statusz00));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2229> */
obj_t BGl_z62zc3anonymousza32229ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3801)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
BGL_UINT32_TO_BUINT32((uint32_t)(0));} 
BGL_FUNCTION_END;
}



/* &lambda2228 */
obj_t BGl_z62lambda2228z62zz__multimediazd2midizd2(obj_t BgL_envz00_3802, obj_t BgL_oz00_3803, obj_t BgL_vz00_3804)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
uint32_t BgL_vz00_4458;
BgL_vz00_4458 = 
BGL_BUINT32_TO_UINT32(BgL_vz00_3804); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3803)))->BgL_wtickz00)=((uint32_t)BgL_vz00_4458),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2227 */
obj_t BGl_z62lambda2227z62zz__multimediazd2midizd2(obj_t BgL_envz00_3805, obj_t BgL_oz00_3806)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
uint32_t BgL_tmpz00_7979;
BgL_tmpz00_7979 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3806)))->BgL_wtickz00); 
return 
BGL_UINT32_TO_BUINT32(BgL_tmpz00_7979);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2222> */
obj_t BGl_z62zc3anonymousza32222ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3807)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
BINT(((long)0));} 
BGL_FUNCTION_END;
}



/* &lambda2221 */
obj_t BGl_z62lambda2221z62zz__multimediazd2midizd2(obj_t BgL_envz00_3808, obj_t BgL_oz00_3809, obj_t BgL_vz00_3810)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4461;
BgL_vz00_4461 = 
(long)CINT(BgL_vz00_3810); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3809)))->BgL_datastartz00)=((long)BgL_vz00_4461),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2220 */
obj_t BGl_z62lambda2220z62zz__multimediazd2midizd2(obj_t BgL_envz00_3811, obj_t BgL_oz00_3812)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3812)))->BgL_datastartz00));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2215> */
obj_t BGl_z62zc3anonymousza32215ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3813)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
BINT(((long)0));} 
BGL_FUNCTION_END;
}



/* &lambda2214 */
obj_t BGl_z62lambda2214z62zz__multimediazd2midizd2(obj_t BgL_envz00_3814, obj_t BgL_oz00_3815, obj_t BgL_vz00_3816)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4464;
BgL_vz00_4464 = 
(long)CINT(BgL_vz00_3816); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3815)))->BgL_startz00)=((long)BgL_vz00_4464),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2213 */
obj_t BGl_z62lambda2213z62zz__multimediazd2midizd2(obj_t BgL_envz00_3817, obj_t BgL_oz00_3818)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3818)))->BgL_startz00));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2208> */
obj_t BGl_z62zc3anonymousza32208ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3819)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &lambda2207 */
obj_t BGl_z62lambda2207z62zz__multimediazd2midizd2(obj_t BgL_envz00_3820, obj_t BgL_oz00_3821, obj_t BgL_vz00_3822)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3821)))->BgL_ipz00)=((obj_t)BgL_vz00_3822),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2206 */
obj_t BGl_z62lambda2206z62zz__multimediazd2midizd2(obj_t BgL_envz00_3823, obj_t BgL_oz00_3824)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3824)))->BgL_ipz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2201> */
obj_t BGl_z62zc3anonymousza32201ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3825)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
BINT(((long)500000));} 
BGL_FUNCTION_END;
}



/* &lambda2200 */
obj_t BGl_z62lambda2200z62zz__multimediazd2midizd2(obj_t BgL_envz00_3826, obj_t BgL_oz00_3827, obj_t BgL_vz00_3828)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4469;
BgL_vz00_4469 = 
(long)CINT(BgL_vz00_3828); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3827)))->BgL_tempoz00)=((long)BgL_vz00_4469),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2199 */
obj_t BGl_z62lambda2199z62zz__multimediazd2midizd2(obj_t BgL_envz00_3829, obj_t BgL_oz00_3830)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3830)))->BgL_tempoz00));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2194> */
obj_t BGl_z62zc3anonymousza32194ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3831)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
BINT(((long)0));} 
BGL_FUNCTION_END;
}



/* &lambda2193 */
obj_t BGl_z62lambda2193z62zz__multimediazd2midizd2(obj_t BgL_envz00_3832, obj_t BgL_oz00_3833, obj_t BgL_vz00_3834)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
int32_t BgL_vz00_4472;
BgL_vz00_4472 = 
BGL_BINT32_TO_INT32(BgL_vz00_3834); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3833)))->BgL_lenz00)=((int32_t)BgL_vz00_4472),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2192 */
obj_t BGl_z62lambda2192z62zz__multimediazd2midizd2(obj_t BgL_envz00_3835, obj_t BgL_oz00_3836)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
int32_t BgL_tmpz00_8013;
BgL_tmpz00_8013 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3836)))->BgL_lenz00); 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_8013);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2187> */
obj_t BGl_z62zc3anonymousza32187ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3837)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
BINT(((long)0));} 
BGL_FUNCTION_END;
}



/* &lambda2186 */
obj_t BGl_z62lambda2186z62zz__multimediazd2midizd2(obj_t BgL_envz00_3838, obj_t BgL_oz00_3839, obj_t BgL_vz00_3840)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4475;
BgL_vz00_4475 = 
(long)CINT(BgL_vz00_3840); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3839)))->BgL_z52statusz52)=((long)BgL_vz00_4475),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2185 */
obj_t BGl_z62lambda2185z62zz__multimediazd2midizd2(obj_t BgL_envz00_3841, obj_t BgL_oz00_3842)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3842)))->BgL_z52statusz52));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2180> */
obj_t BGl_z62zc3anonymousza32180ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3843)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
BGL_UINT32_TO_BUINT32((uint32_t)(0));} 
BGL_FUNCTION_END;
}



/* &lambda2179 */
obj_t BGl_z62lambda2179z62zz__multimediazd2midizd2(obj_t BgL_envz00_3844, obj_t BgL_oz00_3845, obj_t BgL_vz00_3846)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
uint32_t BgL_vz00_4478;
BgL_vz00_4478 = 
BGL_BUINT32_TO_UINT32(BgL_vz00_3846); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3845)))->BgL_z52wtickz52)=((uint32_t)BgL_vz00_4478),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2178 */
obj_t BGl_z62lambda2178z62zz__multimediazd2midizd2(obj_t BgL_envz00_3847, obj_t BgL_oz00_3848)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
uint32_t BgL_tmpz00_8028;
BgL_tmpz00_8028 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3848)))->BgL_z52wtickz52); 
return 
BGL_UINT32_TO_BUINT32(BgL_tmpz00_8028);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2173> */
obj_t BGl_z62zc3anonymousza32173ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3849)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &lambda2172 */
obj_t BGl_z62lambda2172z62zz__multimediazd2midizd2(obj_t BgL_envz00_3850, obj_t BgL_oz00_3851, obj_t BgL_vz00_3852)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
bool_t BgL_vz00_4481;
BgL_vz00_4481 = 
CBOOL(BgL_vz00_3852); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3851)))->BgL_z52eotz52)=((bool_t)BgL_vz00_4481),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2171 */
obj_t BGl_z62lambda2171z62zz__multimediazd2midizd2(obj_t BgL_envz00_3853, obj_t BgL_oz00_3854)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
BBOOL(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3854)))->BgL_z52eotz52));} 
BGL_FUNCTION_END;
}



/* &lambda2166 */
obj_t BGl_z62lambda2166z62zz__multimediazd2midizd2(obj_t BgL_envz00_3855, obj_t BgL_oz00_3856, obj_t BgL_vz00_3857)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3856)))->BgL_z52closez52)=((obj_t)
((obj_t)BgL_vz00_3857)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2165 */
obj_t BGl_z62lambda2165z62zz__multimediazd2midizd2(obj_t BgL_envz00_3858, obj_t BgL_oz00_3859)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3859)))->BgL_z52closez52);} 
BGL_FUNCTION_END;
}



/* &lambda2161 */
obj_t BGl_z62lambda2161z62zz__multimediazd2midizd2(obj_t BgL_envz00_3860, obj_t BgL_oz00_3861, obj_t BgL_vz00_3862)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3861)))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)
((BgL_midireaderz00_bglt)BgL_vz00_3862)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2160 */
BgL_midireaderz00_bglt BGl_z62lambda2160z62zz__multimediazd2midizd2(obj_t BgL_envz00_3863, obj_t BgL_oz00_3864)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3864)))->BgL_z52readerz52);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2156> */
obj_t BGl_z62zc3anonymousza32156ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3865)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &lambda2155 */
obj_t BGl_z62lambda2155z62zz__multimediazd2midizd2(obj_t BgL_envz00_3866, obj_t BgL_oz00_3867, obj_t BgL_vz00_3868)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3867)))->BgL_z52streamz52)=((obj_t)BgL_vz00_3868),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2154 */
obj_t BGl_z62lambda2154z62zz__multimediazd2midizd2(obj_t BgL_envz00_3869, obj_t BgL_oz00_3870)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 24 */
return 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3870)))->BgL_z52streamz52);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2112> */
obj_t BGl_z62zc3anonymousza32112ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3871, obj_t BgL_new1052z00_3872)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 17 */
{ 
BgL_midiscorez00_bglt BgL_auxz00_8054;
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_new1052z00_3872)))->BgL_formatz00)=((long)((long)0)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_new1052z00_3872)))->BgL_tempoz00)=((long)((long)0)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_new1052z00_3872)))->BgL_ppqz00)=((long)((long)0)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_new1052z00_3872)))->BgL_tracksz00)=((obj_t)
CNST_TABLE_REF(((long)75))),BUNSPEC); 
BgL_auxz00_8054 = 
((BgL_midiscorez00_bglt)BgL_new1052z00_3872); 
return 
((obj_t)BgL_auxz00_8054);} } 
BGL_FUNCTION_END;
}



/* &lambda2110 */
BgL_midiscorez00_bglt BGl_z62lambda2110z62zz__multimediazd2midizd2(obj_t BgL_envz00_3873)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
BgL_midiscorez00_bglt BgL_new1051z00_4492;
BgL_new1051z00_4492 = 
((BgL_midiscorez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiscorez00_bgl) ))); 
{ /* Llib/midi.scm 17 */
long BgL_arg2111z00_4493;
{ /* Llib/midi.scm 17 */
long BgL_res2800z00_4494;
BgL_res2800z00_4494 = 
BGL_CLASS_INDEX(BGl_midiscorez00zz__multimediazd2midizd2); 
BgL_arg2111z00_4493 = BgL_res2800z00_4494; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1051z00_4492), BgL_arg2111z00_4493); } 
return BgL_new1051z00_4492;} } 
BGL_FUNCTION_END;
}



/* &lambda2107 */
BgL_midiscorez00_bglt BGl_z62lambda2107z62zz__multimediazd2midizd2(obj_t BgL_envz00_3874, obj_t BgL_format1047z00_3875, obj_t BgL_tempo1048z00_3876, obj_t BgL_ppq1049z00_3877, obj_t BgL_tracks1050z00_3878)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
long BgL_format1047z00_4495;long BgL_tempo1048z00_4496;long BgL_ppq1049z00_4497;
BgL_format1047z00_4495 = 
(long)CINT(BgL_format1047z00_3875); 
BgL_tempo1048z00_4496 = 
(long)CINT(BgL_tempo1048z00_3876); 
BgL_ppq1049z00_4497 = 
(long)CINT(BgL_ppq1049z00_3877); 
{ /* Llib/midi.scm 17 */
BgL_midiscorez00_bglt BgL_new1176z00_4499;
{ /* Llib/midi.scm 17 */
BgL_midiscorez00_bglt BgL_new1175z00_4500;
BgL_new1175z00_4500 = 
((BgL_midiscorez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiscorez00_bgl) ))); 
{ /* Llib/midi.scm 17 */
long BgL_arg2109z00_4501;
{ /* Llib/midi.scm 17 */
long BgL_res2799z00_4502;
BgL_res2799z00_4502 = 
BGL_CLASS_INDEX(BGl_midiscorez00zz__multimediazd2midizd2); 
BgL_arg2109z00_4501 = BgL_res2799z00_4502; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1175z00_4500), BgL_arg2109z00_4501); } 
BgL_new1176z00_4499 = BgL_new1175z00_4500; } 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1176z00_4499))->BgL_formatz00)=((long)BgL_format1047z00_4495),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1176z00_4499))->BgL_tempoz00)=((long)BgL_tempo1048z00_4496),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1176z00_4499))->BgL_ppqz00)=((long)BgL_ppq1049z00_4497),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1176z00_4499))->BgL_tracksz00)=((obj_t)
((obj_t)BgL_tracks1050z00_3878)),BUNSPEC); 
{ /* Llib/midi.scm 17 */
obj_t BgL_fun2108z00_4503;
BgL_fun2108z00_4503 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midiscorez00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2108z00_4503)(BgL_fun2108z00_4503, 
((obj_t)BgL_new1176z00_4499), BEOA); } 
return BgL_new1176z00_4499;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2138> */
obj_t BGl_z62zc3anonymousza32138ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3879)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 17 */
return 
CNST_TABLE_REF(((long)75));} 
BGL_FUNCTION_END;
}



/* &lambda2137 */
obj_t BGl_z62lambda2137z62zz__multimediazd2midizd2(obj_t BgL_envz00_3880, obj_t BgL_oz00_3881, obj_t BgL_vz00_3882)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 17 */
return 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3881)))->BgL_tracksz00)=((obj_t)
((obj_t)BgL_vz00_3882)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2136 */
obj_t BGl_z62lambda2136z62zz__multimediazd2midizd2(obj_t BgL_envz00_3883, obj_t BgL_oz00_3884)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 17 */
return 
(((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3884)))->BgL_tracksz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2131> */
obj_t BGl_z62zc3anonymousza32131ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3885)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 17 */
return 
BINT(((long)96));} 
BGL_FUNCTION_END;
}



/* &lambda2130 */
obj_t BGl_z62lambda2130z62zz__multimediazd2midizd2(obj_t BgL_envz00_3886, obj_t BgL_oz00_3887, obj_t BgL_vz00_3888)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
long BgL_vz00_4508;
BgL_vz00_4508 = 
(long)CINT(BgL_vz00_3888); 
return 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3887)))->BgL_ppqz00)=((long)BgL_vz00_4508),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2129 */
obj_t BGl_z62lambda2129z62zz__multimediazd2midizd2(obj_t BgL_envz00_3889, obj_t BgL_oz00_3890)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 17 */
return 
BINT(
(((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3890)))->BgL_ppqz00));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2124> */
obj_t BGl_z62zc3anonymousza32124ze3ze1zz__multimediazd2midizd2(obj_t BgL_envz00_3891)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 17 */
return 
BINT(((long)500000));} 
BGL_FUNCTION_END;
}



/* &lambda2123 */
obj_t BGl_z62lambda2123z62zz__multimediazd2midizd2(obj_t BgL_envz00_3892, obj_t BgL_oz00_3893, obj_t BgL_vz00_3894)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
long BgL_vz00_4511;
BgL_vz00_4511 = 
(long)CINT(BgL_vz00_3894); 
return 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3893)))->BgL_tempoz00)=((long)BgL_vz00_4511),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2122 */
obj_t BGl_z62lambda2122z62zz__multimediazd2midizd2(obj_t BgL_envz00_3895, obj_t BgL_oz00_3896)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 17 */
return 
BINT(
(((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3896)))->BgL_tempoz00));} 
BGL_FUNCTION_END;
}



/* &lambda2117 */
obj_t BGl_z62lambda2117z62zz__multimediazd2midizd2(obj_t BgL_envz00_3897, obj_t BgL_oz00_3898, obj_t BgL_vz00_3899)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
long BgL_vz00_4514;
BgL_vz00_4514 = 
(long)CINT(BgL_vz00_3899); 
return 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3898)))->BgL_formatz00)=((long)BgL_vz00_4514),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2116 */
obj_t BGl_z62lambda2116z62zz__multimediazd2midizd2(obj_t BgL_envz00_3900, obj_t BgL_oz00_3901)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 17 */
return 
BINT(
(((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3901)))->BgL_formatz00));} 
BGL_FUNCTION_END;
}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__multimediazd2midizd2()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 15 */
BGl_registerzd2genericz12zc0zz__objectz00(BGl_midiscorezd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3297z00zz__multimediazd2midizd2, BGl_midiscorez00zz__multimediazd2midizd2, BGl_string3298z00zz__multimediazd2midizd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_miditrackzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3299z00zz__multimediazd2midizd2, BGl_miditrackz00zz__multimediazd2midizd2, BGl_string3300z00zz__multimediazd2midizd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_midireaderzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3301z00zz__multimediazd2midizd2, BGl_midireaderz00zz__multimediazd2midizd2, BGl_string3302z00zz__multimediazd2midizd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_midiplayerzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3303z00zz__multimediazd2midizd2, BGl_midiplayerz00zz__multimediazd2midizd2, BGl_string3304z00zz__multimediazd2midizd2); 
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_midisinkzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3305z00zz__multimediazd2midizd2, BGl_midisinkz00zz__multimediazd2midizd2, BGl_string3306z00zz__multimediazd2midizd2);} 
BGL_FUNCTION_END;
}



/* &midisink-init1237 */
obj_t BGl_z62midisinkzd2init1237zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3917, obj_t BgL_msinkz00_3918)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 987 */
return 
((obj_t)
((BgL_midisinkz00_bglt)BgL_msinkz00_3918));} 
BGL_FUNCTION_END;
}



/* &midiplayer-init1235 */
obj_t BGl_z62midiplayerzd2init1235zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3919, obj_t BgL_mplayerz00_3920)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 981 */
return 
((obj_t)
((BgL_midiplayerz00_bglt)BgL_mplayerz00_3920));} 
BGL_FUNCTION_END;
}



/* &midireader-init1233 */
obj_t BGl_z62midireaderzd2init1233zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3921, obj_t BgL_mreaderz00_3922)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 975 */
return 
((obj_t)
((BgL_midireaderz00_bglt)BgL_mreaderz00_3922));} 
BGL_FUNCTION_END;
}



/* &miditrack-init1231 */
obj_t BGl_z62miditrackzd2init1231zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3923, obj_t BgL_mtrackz00_3924)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 969 */
return 
((obj_t)
((BgL_miditrackz00_bglt)BgL_mtrackz00_3924));} 
BGL_FUNCTION_END;
}



/* &midiscore-init1229 */
obj_t BGl_z62midiscorezd2init1229zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3925, obj_t BgL_mscorez00_3926)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 963 */
return 
((obj_t)
((BgL_midiscorez00_bglt)BgL_mscorez00_3926));} 
BGL_FUNCTION_END;
}



/* midiscore-init */
BGL_EXPORTED_DEF obj_t BGl_midiscorezd2initzd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt BgL_mscorez00_63)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 963 */
{ /* Llib/midi.scm 963 */
obj_t BgL_method1230z00_1855;
{ /* Llib/midi.scm 963 */
obj_t BgL_res2820z00_2855;
{ /* Llib/midi.scm 963 */
long BgL_objzd2classzd2numz00_2812;
{ /* Llib/midi.scm 963 */
long BgL_res2809z00_2815;
BgL_res2809z00_2815 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_mscorez00_63)); 
BgL_objzd2classzd2numz00_2812 = BgL_res2809z00_2815; } 
{ /* Llib/midi.scm 963 */
obj_t BgL_arg1742z00_2813;
BgL_arg1742z00_2813 = 
PROCEDURE_REF(BGl_midiscorezd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 963 */
int BgL_offsetz00_2817;
BgL_offsetz00_2817 = 
(int)(BgL_objzd2classzd2numz00_2812); 
{ /* Llib/midi.scm 963 */
long BgL_offsetz00_2818;
BgL_offsetz00_2818 = 
(
(long)(BgL_offsetz00_2817)-OBJECT_TYPE); 
{ /* Llib/midi.scm 963 */
long BgL_modz00_2819;
{ /* Llib/midi.scm 963 */
int BgL_arg1744z00_2820;
BgL_arg1744z00_2820 = 
(int)(((long)16)); 
{ /* Llib/midi.scm 963 */
long BgL_res2812z00_2830;
{ /* Llib/midi.scm 963 */
long BgL_tmpz00_8137;
BgL_tmpz00_8137 = 
(long)(BgL_arg1744z00_2820); 
BgL_res2812z00_2830 = 
(BgL_offsetz00_2818/BgL_tmpz00_8137); } 
BgL_modz00_2819 = BgL_res2812z00_2830; } } 
{ /* Llib/midi.scm 963 */
long BgL_restz00_2821;
{ /* Llib/midi.scm 963 */
int BgL_arg1743z00_2822;
BgL_arg1743z00_2822 = 
(int)(((long)16)); 
{ /* Llib/midi.scm 963 */
long BgL_res2819z00_2850;
{ /* Llib/midi.scm 963 */
long BgL_n1z00_2832;long BgL_n2z00_2833;
BgL_n1z00_2832 = BgL_offsetz00_2818; 
BgL_n2z00_2833 = 
(long)(BgL_arg1743z00_2822); 
{ /* Llib/midi.scm 963 */
bool_t BgL_testz00_8142;
{ /* Llib/midi.scm 963 */
long BgL_arg1283z00_2835;
BgL_arg1283z00_2835 = 
(((BgL_n1z00_2832) | (BgL_n2z00_2833)) & -2147483648); 
BgL_testz00_8142 = 
(BgL_arg1283z00_2835==((long)0)); } 
if(BgL_testz00_8142)
{ /* Llib/midi.scm 963 */
int32_t BgL_arg1272z00_2836;
{ /* Llib/midi.scm 963 */
int32_t BgL_arg1278z00_2837;int32_t BgL_arg1279z00_2838;
{ /* Llib/midi.scm 963 */
int32_t BgL_res2815z00_2842;
BgL_res2815z00_2842 = 
(int32_t)(BgL_n1z00_2832); 
BgL_arg1278z00_2837 = BgL_res2815z00_2842; } 
{ /* Llib/midi.scm 963 */
int32_t BgL_res2816z00_2844;
BgL_res2816z00_2844 = 
(int32_t)(BgL_n2z00_2833); 
BgL_arg1279z00_2838 = BgL_res2816z00_2844; } 
BgL_arg1272z00_2836 = 
(BgL_arg1278z00_2837%BgL_arg1279z00_2838); } 
{ /* Llib/midi.scm 963 */
long BgL_res2818z00_2849;
{ /* Llib/midi.scm 963 */
long BgL_arg1409z00_2846;
BgL_arg1409z00_2846 = 
(long)(BgL_arg1272z00_2836); 
{ /* Llib/midi.scm 963 */
long BgL_res2817z00_2848;
BgL_res2817z00_2848 = 
(long)(BgL_arg1409z00_2846); 
BgL_res2818z00_2849 = BgL_res2817z00_2848; } } 
BgL_res2819z00_2850 = BgL_res2818z00_2849; } }  else 
{ /* Llib/midi.scm 963 */
BgL_res2819z00_2850 = 
(BgL_n1z00_2832%BgL_n2z00_2833); } } } 
BgL_restz00_2821 = BgL_res2819z00_2850; } } 
{ /* Llib/midi.scm 963 */

{ /* Llib/midi.scm 963 */
obj_t BgL_bucketz00_2823;
BgL_bucketz00_2823 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_2813),BgL_modz00_2819); 
BgL_res2820z00_2855 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2823),BgL_restz00_2821); } } } } } } } } 
BgL_method1230z00_1855 = BgL_res2820z00_2855; } 
return 
PROCEDURE_ENTRY(BgL_method1230z00_1855)(BgL_method1230z00_1855, 
((obj_t)BgL_mscorez00_63), BEOA);} } 
BGL_FUNCTION_END;
}



/* &midiscore-init */
obj_t BGl_z62midiscorezd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3902, obj_t BgL_mscorez00_3903)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 963 */
{ /* Llib/midi.scm 963 */
BgL_midiscorez00_bglt BgL_auxz00_8160;
if(
BGl_isazf3zf3zz__objectz00(BgL_mscorez00_3903, BGl_midiscorez00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 963 */
BgL_auxz00_8160 = 
((BgL_midiscorez00_bglt)BgL_mscorez00_3903)
; }  else 
{ 
obj_t BgL_auxz00_8164;
BgL_auxz00_8164 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)36209)), BGl_string3307z00zz__multimediazd2midizd2, BGl_string3075z00zz__multimediazd2midizd2, BgL_mscorez00_3903); 
FAILURE(BgL_auxz00_8164,BFALSE,BFALSE);} 
return 
BGl_midiscorezd2initzd2zz__multimediazd2midizd2(BgL_auxz00_8160);} } 
BGL_FUNCTION_END;
}



/* miditrack-init */
BGL_EXPORTED_DEF obj_t BGl_miditrackzd2initzd2zz__multimediazd2midizd2(BgL_miditrackz00_bglt BgL_mtrackz00_64)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 969 */
{ /* Llib/midi.scm 969 */
obj_t BgL_method1232z00_1856;
{ /* Llib/midi.scm 969 */
obj_t BgL_res2832z00_2900;
{ /* Llib/midi.scm 969 */
long BgL_objzd2classzd2numz00_2857;
{ /* Llib/midi.scm 969 */
long BgL_res2821z00_2860;
BgL_res2821z00_2860 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_mtrackz00_64)); 
BgL_objzd2classzd2numz00_2857 = BgL_res2821z00_2860; } 
{ /* Llib/midi.scm 969 */
obj_t BgL_arg1742z00_2858;
BgL_arg1742z00_2858 = 
PROCEDURE_REF(BGl_miditrackzd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 969 */
int BgL_offsetz00_2862;
BgL_offsetz00_2862 = 
(int)(BgL_objzd2classzd2numz00_2857); 
{ /* Llib/midi.scm 969 */
long BgL_offsetz00_2863;
BgL_offsetz00_2863 = 
(
(long)(BgL_offsetz00_2862)-OBJECT_TYPE); 
{ /* Llib/midi.scm 969 */
long BgL_modz00_2864;
{ /* Llib/midi.scm 969 */
int BgL_arg1744z00_2865;
BgL_arg1744z00_2865 = 
(int)(((long)16)); 
{ /* Llib/midi.scm 969 */
long BgL_res2824z00_2875;
{ /* Llib/midi.scm 969 */
long BgL_tmpz00_8177;
BgL_tmpz00_8177 = 
(long)(BgL_arg1744z00_2865); 
BgL_res2824z00_2875 = 
(BgL_offsetz00_2863/BgL_tmpz00_8177); } 
BgL_modz00_2864 = BgL_res2824z00_2875; } } 
{ /* Llib/midi.scm 969 */
long BgL_restz00_2866;
{ /* Llib/midi.scm 969 */
int BgL_arg1743z00_2867;
BgL_arg1743z00_2867 = 
(int)(((long)16)); 
{ /* Llib/midi.scm 969 */
long BgL_res2831z00_2895;
{ /* Llib/midi.scm 969 */
long BgL_n1z00_2877;long BgL_n2z00_2878;
BgL_n1z00_2877 = BgL_offsetz00_2863; 
BgL_n2z00_2878 = 
(long)(BgL_arg1743z00_2867); 
{ /* Llib/midi.scm 969 */
bool_t BgL_testz00_8182;
{ /* Llib/midi.scm 969 */
long BgL_arg1283z00_2880;
BgL_arg1283z00_2880 = 
(((BgL_n1z00_2877) | (BgL_n2z00_2878)) & -2147483648); 
BgL_testz00_8182 = 
(BgL_arg1283z00_2880==((long)0)); } 
if(BgL_testz00_8182)
{ /* Llib/midi.scm 969 */
int32_t BgL_arg1272z00_2881;
{ /* Llib/midi.scm 969 */
int32_t BgL_arg1278z00_2882;int32_t BgL_arg1279z00_2883;
{ /* Llib/midi.scm 969 */
int32_t BgL_res2827z00_2887;
BgL_res2827z00_2887 = 
(int32_t)(BgL_n1z00_2877); 
BgL_arg1278z00_2882 = BgL_res2827z00_2887; } 
{ /* Llib/midi.scm 969 */
int32_t BgL_res2828z00_2889;
BgL_res2828z00_2889 = 
(int32_t)(BgL_n2z00_2878); 
BgL_arg1279z00_2883 = BgL_res2828z00_2889; } 
BgL_arg1272z00_2881 = 
(BgL_arg1278z00_2882%BgL_arg1279z00_2883); } 
{ /* Llib/midi.scm 969 */
long BgL_res2830z00_2894;
{ /* Llib/midi.scm 969 */
long BgL_arg1409z00_2891;
BgL_arg1409z00_2891 = 
(long)(BgL_arg1272z00_2881); 
{ /* Llib/midi.scm 969 */
long BgL_res2829z00_2893;
BgL_res2829z00_2893 = 
(long)(BgL_arg1409z00_2891); 
BgL_res2830z00_2894 = BgL_res2829z00_2893; } } 
BgL_res2831z00_2895 = BgL_res2830z00_2894; } }  else 
{ /* Llib/midi.scm 969 */
BgL_res2831z00_2895 = 
(BgL_n1z00_2877%BgL_n2z00_2878); } } } 
BgL_restz00_2866 = BgL_res2831z00_2895; } } 
{ /* Llib/midi.scm 969 */

{ /* Llib/midi.scm 969 */
obj_t BgL_bucketz00_2868;
BgL_bucketz00_2868 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_2858),BgL_modz00_2864); 
BgL_res2832z00_2900 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2868),BgL_restz00_2866); } } } } } } } } 
BgL_method1232z00_1856 = BgL_res2832z00_2900; } 
return 
PROCEDURE_ENTRY(BgL_method1232z00_1856)(BgL_method1232z00_1856, 
((obj_t)BgL_mtrackz00_64), BEOA);} } 
BGL_FUNCTION_END;
}



/* &miditrack-init */
obj_t BGl_z62miditrackzd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3904, obj_t BgL_mtrackz00_3905)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 969 */
{ /* Llib/midi.scm 969 */
BgL_miditrackz00_bglt BgL_auxz00_8200;
if(
BGl_isazf3zf3zz__objectz00(BgL_mtrackz00_3905, BGl_miditrackz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 969 */
BgL_auxz00_8200 = 
((BgL_miditrackz00_bglt)BgL_mtrackz00_3905)
; }  else 
{ 
obj_t BgL_auxz00_8204;
BgL_auxz00_8204 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)36494)), BGl_string3308z00zz__multimediazd2midizd2, BGl_string3097z00zz__multimediazd2midizd2, BgL_mtrackz00_3905); 
FAILURE(BgL_auxz00_8204,BFALSE,BFALSE);} 
return 
BGl_miditrackzd2initzd2zz__multimediazd2midizd2(BgL_auxz00_8200);} } 
BGL_FUNCTION_END;
}



/* midireader-init */
BGL_EXPORTED_DEF obj_t BGl_midireaderzd2initzd2zz__multimediazd2midizd2(BgL_midireaderz00_bglt BgL_mreaderz00_65)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 975 */
{ /* Llib/midi.scm 975 */
obj_t BgL_method1234z00_1857;
{ /* Llib/midi.scm 975 */
obj_t BgL_res2844z00_2945;
{ /* Llib/midi.scm 975 */
long BgL_objzd2classzd2numz00_2902;
{ /* Llib/midi.scm 975 */
long BgL_res2833z00_2905;
BgL_res2833z00_2905 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_mreaderz00_65)); 
BgL_objzd2classzd2numz00_2902 = BgL_res2833z00_2905; } 
{ /* Llib/midi.scm 975 */
obj_t BgL_arg1742z00_2903;
BgL_arg1742z00_2903 = 
PROCEDURE_REF(BGl_midireaderzd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 975 */
int BgL_offsetz00_2907;
BgL_offsetz00_2907 = 
(int)(BgL_objzd2classzd2numz00_2902); 
{ /* Llib/midi.scm 975 */
long BgL_offsetz00_2908;
BgL_offsetz00_2908 = 
(
(long)(BgL_offsetz00_2907)-OBJECT_TYPE); 
{ /* Llib/midi.scm 975 */
long BgL_modz00_2909;
{ /* Llib/midi.scm 975 */
int BgL_arg1744z00_2910;
BgL_arg1744z00_2910 = 
(int)(((long)16)); 
{ /* Llib/midi.scm 975 */
long BgL_res2836z00_2920;
{ /* Llib/midi.scm 975 */
long BgL_tmpz00_8217;
BgL_tmpz00_8217 = 
(long)(BgL_arg1744z00_2910); 
BgL_res2836z00_2920 = 
(BgL_offsetz00_2908/BgL_tmpz00_8217); } 
BgL_modz00_2909 = BgL_res2836z00_2920; } } 
{ /* Llib/midi.scm 975 */
long BgL_restz00_2911;
{ /* Llib/midi.scm 975 */
int BgL_arg1743z00_2912;
BgL_arg1743z00_2912 = 
(int)(((long)16)); 
{ /* Llib/midi.scm 975 */
long BgL_res2843z00_2940;
{ /* Llib/midi.scm 975 */
long BgL_n1z00_2922;long BgL_n2z00_2923;
BgL_n1z00_2922 = BgL_offsetz00_2908; 
BgL_n2z00_2923 = 
(long)(BgL_arg1743z00_2912); 
{ /* Llib/midi.scm 975 */
bool_t BgL_testz00_8222;
{ /* Llib/midi.scm 975 */
long BgL_arg1283z00_2925;
BgL_arg1283z00_2925 = 
(((BgL_n1z00_2922) | (BgL_n2z00_2923)) & -2147483648); 
BgL_testz00_8222 = 
(BgL_arg1283z00_2925==((long)0)); } 
if(BgL_testz00_8222)
{ /* Llib/midi.scm 975 */
int32_t BgL_arg1272z00_2926;
{ /* Llib/midi.scm 975 */
int32_t BgL_arg1278z00_2927;int32_t BgL_arg1279z00_2928;
{ /* Llib/midi.scm 975 */
int32_t BgL_res2839z00_2932;
BgL_res2839z00_2932 = 
(int32_t)(BgL_n1z00_2922); 
BgL_arg1278z00_2927 = BgL_res2839z00_2932; } 
{ /* Llib/midi.scm 975 */
int32_t BgL_res2840z00_2934;
BgL_res2840z00_2934 = 
(int32_t)(BgL_n2z00_2923); 
BgL_arg1279z00_2928 = BgL_res2840z00_2934; } 
BgL_arg1272z00_2926 = 
(BgL_arg1278z00_2927%BgL_arg1279z00_2928); } 
{ /* Llib/midi.scm 975 */
long BgL_res2842z00_2939;
{ /* Llib/midi.scm 975 */
long BgL_arg1409z00_2936;
BgL_arg1409z00_2936 = 
(long)(BgL_arg1272z00_2926); 
{ /* Llib/midi.scm 975 */
long BgL_res2841z00_2938;
BgL_res2841z00_2938 = 
(long)(BgL_arg1409z00_2936); 
BgL_res2842z00_2939 = BgL_res2841z00_2938; } } 
BgL_res2843z00_2940 = BgL_res2842z00_2939; } }  else 
{ /* Llib/midi.scm 975 */
BgL_res2843z00_2940 = 
(BgL_n1z00_2922%BgL_n2z00_2923); } } } 
BgL_restz00_2911 = BgL_res2843z00_2940; } } 
{ /* Llib/midi.scm 975 */

{ /* Llib/midi.scm 975 */
obj_t BgL_bucketz00_2913;
BgL_bucketz00_2913 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_2903),BgL_modz00_2909); 
BgL_res2844z00_2945 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2913),BgL_restz00_2911); } } } } } } } } 
BgL_method1234z00_1857 = BgL_res2844z00_2945; } 
return 
PROCEDURE_ENTRY(BgL_method1234z00_1857)(BgL_method1234z00_1857, 
((obj_t)BgL_mreaderz00_65), BEOA);} } 
BGL_FUNCTION_END;
}



/* &midireader-init */
obj_t BGl_z62midireaderzd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3906, obj_t BgL_mreaderz00_3907)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 975 */
{ /* Llib/midi.scm 975 */
BgL_midireaderz00_bglt BgL_auxz00_8240;
if(
BGl_isazf3zf3zz__objectz00(BgL_mreaderz00_3907, BGl_midireaderz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 975 */
BgL_auxz00_8240 = 
((BgL_midireaderz00_bglt)BgL_mreaderz00_3907)
; }  else 
{ 
obj_t BgL_auxz00_8244;
BgL_auxz00_8244 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)36779)), BGl_string3309z00zz__multimediazd2midizd2, BGl_string3310z00zz__multimediazd2midizd2, BgL_mreaderz00_3907); 
FAILURE(BgL_auxz00_8244,BFALSE,BFALSE);} 
return 
BGl_midireaderzd2initzd2zz__multimediazd2midizd2(BgL_auxz00_8240);} } 
BGL_FUNCTION_END;
}



/* midiplayer-init */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2initzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mplayerz00_66)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 981 */
{ /* Llib/midi.scm 981 */
obj_t BgL_method1236z00_1858;
{ /* Llib/midi.scm 981 */
obj_t BgL_res2856z00_2990;
{ /* Llib/midi.scm 981 */
long BgL_objzd2classzd2numz00_2947;
{ /* Llib/midi.scm 981 */
long BgL_res2845z00_2950;
BgL_res2845z00_2950 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_mplayerz00_66)); 
BgL_objzd2classzd2numz00_2947 = BgL_res2845z00_2950; } 
{ /* Llib/midi.scm 981 */
obj_t BgL_arg1742z00_2948;
BgL_arg1742z00_2948 = 
PROCEDURE_REF(BGl_midiplayerzd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 981 */
int BgL_offsetz00_2952;
BgL_offsetz00_2952 = 
(int)(BgL_objzd2classzd2numz00_2947); 
{ /* Llib/midi.scm 981 */
long BgL_offsetz00_2953;
BgL_offsetz00_2953 = 
(
(long)(BgL_offsetz00_2952)-OBJECT_TYPE); 
{ /* Llib/midi.scm 981 */
long BgL_modz00_2954;
{ /* Llib/midi.scm 981 */
int BgL_arg1744z00_2955;
BgL_arg1744z00_2955 = 
(int)(((long)16)); 
{ /* Llib/midi.scm 981 */
long BgL_res2848z00_2965;
{ /* Llib/midi.scm 981 */
long BgL_tmpz00_8257;
BgL_tmpz00_8257 = 
(long)(BgL_arg1744z00_2955); 
BgL_res2848z00_2965 = 
(BgL_offsetz00_2953/BgL_tmpz00_8257); } 
BgL_modz00_2954 = BgL_res2848z00_2965; } } 
{ /* Llib/midi.scm 981 */
long BgL_restz00_2956;
{ /* Llib/midi.scm 981 */
int BgL_arg1743z00_2957;
BgL_arg1743z00_2957 = 
(int)(((long)16)); 
{ /* Llib/midi.scm 981 */
long BgL_res2855z00_2985;
{ /* Llib/midi.scm 981 */
long BgL_n1z00_2967;long BgL_n2z00_2968;
BgL_n1z00_2967 = BgL_offsetz00_2953; 
BgL_n2z00_2968 = 
(long)(BgL_arg1743z00_2957); 
{ /* Llib/midi.scm 981 */
bool_t BgL_testz00_8262;
{ /* Llib/midi.scm 981 */
long BgL_arg1283z00_2970;
BgL_arg1283z00_2970 = 
(((BgL_n1z00_2967) | (BgL_n2z00_2968)) & -2147483648); 
BgL_testz00_8262 = 
(BgL_arg1283z00_2970==((long)0)); } 
if(BgL_testz00_8262)
{ /* Llib/midi.scm 981 */
int32_t BgL_arg1272z00_2971;
{ /* Llib/midi.scm 981 */
int32_t BgL_arg1278z00_2972;int32_t BgL_arg1279z00_2973;
{ /* Llib/midi.scm 981 */
int32_t BgL_res2851z00_2977;
BgL_res2851z00_2977 = 
(int32_t)(BgL_n1z00_2967); 
BgL_arg1278z00_2972 = BgL_res2851z00_2977; } 
{ /* Llib/midi.scm 981 */
int32_t BgL_res2852z00_2979;
BgL_res2852z00_2979 = 
(int32_t)(BgL_n2z00_2968); 
BgL_arg1279z00_2973 = BgL_res2852z00_2979; } 
BgL_arg1272z00_2971 = 
(BgL_arg1278z00_2972%BgL_arg1279z00_2973); } 
{ /* Llib/midi.scm 981 */
long BgL_res2854z00_2984;
{ /* Llib/midi.scm 981 */
long BgL_arg1409z00_2981;
BgL_arg1409z00_2981 = 
(long)(BgL_arg1272z00_2971); 
{ /* Llib/midi.scm 981 */
long BgL_res2853z00_2983;
BgL_res2853z00_2983 = 
(long)(BgL_arg1409z00_2981); 
BgL_res2854z00_2984 = BgL_res2853z00_2983; } } 
BgL_res2855z00_2985 = BgL_res2854z00_2984; } }  else 
{ /* Llib/midi.scm 981 */
BgL_res2855z00_2985 = 
(BgL_n1z00_2967%BgL_n2z00_2968); } } } 
BgL_restz00_2956 = BgL_res2855z00_2985; } } 
{ /* Llib/midi.scm 981 */

{ /* Llib/midi.scm 981 */
obj_t BgL_bucketz00_2958;
BgL_bucketz00_2958 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_2948),BgL_modz00_2954); 
BgL_res2856z00_2990 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2958),BgL_restz00_2956); } } } } } } } } 
BgL_method1236z00_1858 = BgL_res2856z00_2990; } 
return 
PROCEDURE_ENTRY(BgL_method1236z00_1858)(BgL_method1236z00_1858, 
((obj_t)BgL_mplayerz00_66), BEOA);} } 
BGL_FUNCTION_END;
}



/* &midiplayer-init */
obj_t BGl_z62midiplayerzd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3908, obj_t BgL_mplayerz00_3909)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 981 */
{ /* Llib/midi.scm 981 */
BgL_midiplayerz00_bglt BgL_auxz00_8280;
if(
BGl_isazf3zf3zz__objectz00(BgL_mplayerz00_3909, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 981 */
BgL_auxz00_8280 = 
((BgL_midiplayerz00_bglt)BgL_mplayerz00_3909)
; }  else 
{ 
obj_t BgL_auxz00_8284;
BgL_auxz00_8284 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)37068)), BGl_string3311z00zz__multimediazd2midizd2, BGl_string3076z00zz__multimediazd2midizd2, BgL_mplayerz00_3909); 
FAILURE(BgL_auxz00_8284,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2initzd2zz__multimediazd2midizd2(BgL_auxz00_8280);} } 
BGL_FUNCTION_END;
}



/* midisink-init */
BGL_EXPORTED_DEF obj_t BGl_midisinkzd2initzd2zz__multimediazd2midizd2(BgL_midisinkz00_bglt BgL_msinkz00_67)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 987 */
{ /* Llib/midi.scm 987 */
obj_t BgL_method1238z00_1859;
{ /* Llib/midi.scm 987 */
obj_t BgL_res2868z00_3035;
{ /* Llib/midi.scm 987 */
long BgL_objzd2classzd2numz00_2992;
{ /* Llib/midi.scm 987 */
long BgL_res2857z00_2995;
BgL_res2857z00_2995 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_msinkz00_67)); 
BgL_objzd2classzd2numz00_2992 = BgL_res2857z00_2995; } 
{ /* Llib/midi.scm 987 */
obj_t BgL_arg1742z00_2993;
BgL_arg1742z00_2993 = 
PROCEDURE_REF(BGl_midisinkzd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 987 */
int BgL_offsetz00_2997;
BgL_offsetz00_2997 = 
(int)(BgL_objzd2classzd2numz00_2992); 
{ /* Llib/midi.scm 987 */
long BgL_offsetz00_2998;
BgL_offsetz00_2998 = 
(
(long)(BgL_offsetz00_2997)-OBJECT_TYPE); 
{ /* Llib/midi.scm 987 */
long BgL_modz00_2999;
{ /* Llib/midi.scm 987 */
int BgL_arg1744z00_3000;
BgL_arg1744z00_3000 = 
(int)(((long)16)); 
{ /* Llib/midi.scm 987 */
long BgL_res2860z00_3010;
{ /* Llib/midi.scm 987 */
long BgL_tmpz00_8297;
BgL_tmpz00_8297 = 
(long)(BgL_arg1744z00_3000); 
BgL_res2860z00_3010 = 
(BgL_offsetz00_2998/BgL_tmpz00_8297); } 
BgL_modz00_2999 = BgL_res2860z00_3010; } } 
{ /* Llib/midi.scm 987 */
long BgL_restz00_3001;
{ /* Llib/midi.scm 987 */
int BgL_arg1743z00_3002;
BgL_arg1743z00_3002 = 
(int)(((long)16)); 
{ /* Llib/midi.scm 987 */
long BgL_res2867z00_3030;
{ /* Llib/midi.scm 987 */
long BgL_n1z00_3012;long BgL_n2z00_3013;
BgL_n1z00_3012 = BgL_offsetz00_2998; 
BgL_n2z00_3013 = 
(long)(BgL_arg1743z00_3002); 
{ /* Llib/midi.scm 987 */
bool_t BgL_testz00_8302;
{ /* Llib/midi.scm 987 */
long BgL_arg1283z00_3015;
BgL_arg1283z00_3015 = 
(((BgL_n1z00_3012) | (BgL_n2z00_3013)) & -2147483648); 
BgL_testz00_8302 = 
(BgL_arg1283z00_3015==((long)0)); } 
if(BgL_testz00_8302)
{ /* Llib/midi.scm 987 */
int32_t BgL_arg1272z00_3016;
{ /* Llib/midi.scm 987 */
int32_t BgL_arg1278z00_3017;int32_t BgL_arg1279z00_3018;
{ /* Llib/midi.scm 987 */
int32_t BgL_res2863z00_3022;
BgL_res2863z00_3022 = 
(int32_t)(BgL_n1z00_3012); 
BgL_arg1278z00_3017 = BgL_res2863z00_3022; } 
{ /* Llib/midi.scm 987 */
int32_t BgL_res2864z00_3024;
BgL_res2864z00_3024 = 
(int32_t)(BgL_n2z00_3013); 
BgL_arg1279z00_3018 = BgL_res2864z00_3024; } 
BgL_arg1272z00_3016 = 
(BgL_arg1278z00_3017%BgL_arg1279z00_3018); } 
{ /* Llib/midi.scm 987 */
long BgL_res2866z00_3029;
{ /* Llib/midi.scm 987 */
long BgL_arg1409z00_3026;
BgL_arg1409z00_3026 = 
(long)(BgL_arg1272z00_3016); 
{ /* Llib/midi.scm 987 */
long BgL_res2865z00_3028;
BgL_res2865z00_3028 = 
(long)(BgL_arg1409z00_3026); 
BgL_res2866z00_3029 = BgL_res2865z00_3028; } } 
BgL_res2867z00_3030 = BgL_res2866z00_3029; } }  else 
{ /* Llib/midi.scm 987 */
BgL_res2867z00_3030 = 
(BgL_n1z00_3012%BgL_n2z00_3013); } } } 
BgL_restz00_3001 = BgL_res2867z00_3030; } } 
{ /* Llib/midi.scm 987 */

{ /* Llib/midi.scm 987 */
obj_t BgL_bucketz00_3003;
BgL_bucketz00_3003 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_2993),BgL_modz00_2999); 
BgL_res2868z00_3035 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3003),BgL_restz00_3001); } } } } } } } } 
BgL_method1238z00_1859 = BgL_res2868z00_3035; } 
return 
PROCEDURE_ENTRY(BgL_method1238z00_1859)(BgL_method1238z00_1859, 
((obj_t)BgL_msinkz00_67), BEOA);} } 
BGL_FUNCTION_END;
}



/* &midisink-init */
obj_t BGl_z62midisinkzd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3910, obj_t BgL_msinkz00_3911)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 987 */
{ /* Llib/midi.scm 987 */
BgL_midisinkz00_bglt BgL_auxz00_8320;
if(
BGl_isazf3zf3zz__objectz00(BgL_msinkz00_3911, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 987 */
BgL_auxz00_8320 = 
((BgL_midisinkz00_bglt)BgL_msinkz00_3911)
; }  else 
{ 
obj_t BgL_auxz00_8324;
BgL_auxz00_8324 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3064z00zz__multimediazd2midizd2, 
BINT(((long)37357)), BGl_string3312z00zz__multimediazd2midizd2, BGl_string3077z00zz__multimediazd2midizd2, BgL_msinkz00_3911); 
FAILURE(BgL_auxz00_8324,BFALSE,BFALSE);} 
return 
BGl_midisinkzd2initzd2zz__multimediazd2midizd2(BgL_auxz00_8320);} } 
BGL_FUNCTION_END;
}



/* method-init */
obj_t BGl_methodzd2initzd2zz__multimediazd2midizd2()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/midi.scm 15 */
return BUNSPEC;} 
BGL_FUNCTION_END;
}

#ifdef __cplusplus
}
#endif
