/*===========================================================================*/
/*   (Llib/mpd.scm)                                                          */
/*   Bigloo (4.3f)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 04 Jul 2019 08:10:18 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo4.3f/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -I Llib -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -unsafe -safee -copt -fPIC -copt -IUnix Llib/mpd.scm -o objs/mpd.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

/* runtime code modification */
#define BGL_SELF_MODIFYING_CODE 0

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_musicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
} *BgL_musicz00_bglt;

typedef struct BgL_musicstatusz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_statez00;
   obj_t BgL_volumez00;
   bool_t BgL_repeatz00;
   bool_t BgL_randomz00;
   int BgL_playlistidz00;
   int BgL_playlistlengthz00;
   int BgL_xfadez00;
   int BgL_songz00;
   int BgL_songidz00;
   obj_t BgL_songposz00;
   int BgL_songlengthz00;
   int BgL_bitratez00;
   int BgL_khza7za7;
   obj_t BgL_errz00;
   int BgL_bufferingz00;
} *BgL_musicstatusz00_bglt;

typedef struct BgL_musictagz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_titlez00;
   obj_t BgL_artistz00;
   obj_t BgL_interpretz00;
   obj_t BgL_albumz00;
   int BgL_trackz00;
   int BgL_yearz00;
   obj_t BgL_genrez00;
   obj_t BgL_commentz00;
   obj_t BgL_ufidz00;
   obj_t BgL_copyrightz00;
   obj_t BgL_picturez00;
} *BgL_musictagz00_bglt;

typedef struct BgL_musicinfoz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_formatz00;
   long BgL_sampleratez00;
   int BgL_channelsz00;
   int BgL_bpsz00;
   long BgL_durationz00;
} *BgL_musicinfoz00_bglt;

typedef struct BgL_mpdzd2databasezd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_directoriesz00;
   obj_t BgL_suffixesz00;
   obj_t BgL_z52basez52;
   obj_t BgL_z52artistsz52;
   obj_t BgL_z52albumsz52;
   obj_t BgL_z52genresz52;
   obj_t BgL_z52nartistsz52;
   int BgL_z52nalbumsz52;
   int BgL_z52nsongsz52;
   obj_t BgL_z52uptimez52;
   obj_t BgL_z52dbzd2updatez80;
} *BgL_mpdzd2databasezd2_bglt;


static obj_t BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2getzd2albumzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
BGL_IMPORT obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2killzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_directory_to_list(char *);
extern obj_t BGl_musiczd2nextzd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_currentsongzd2infozd2zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, int, obj_t, obj_t);
BGL_IMPORT obj_t BGl_raisez00zz__errorz00(obj_t);
static obj_t BGl_z62mpdzd2swapidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2listallzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT bool_t bigloo_strcicmp(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32304ze3ze1zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2crossfadezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
BGL_IMPORT bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32038ze3ze1zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2repeatzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_assocz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listgen1357z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listalbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listgen1359z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2deletezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32039ze3ze1zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2databasezd2listgen1361z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32161ze3ze1zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
BGL_IMPORT obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_mpdzd2databasezd2directorieszd2scanzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listgenrez62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listallz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__multimediazd2mpdzd2();
BGL_IMPORT obj_t BGl_stringzd2skipzd2zz__r4_strings_6_7z00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_2zd2zd2zz__r4_numbers_6_5z00(obj_t, obj_t);
static obj_t BGl_zc3exitza32035ze3ze70z64zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32325ze3ze1zz__multimediazd2mpdzd2(obj_t);
BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2getgenreartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
BGL_IMPORT obj_t BGl_dirnamez00zz__osz00(obj_t);
BGL_IMPORT obj_t BGl_stringzd2containszd2zz__r4_strings_6_7z00(obj_t, obj_t, int);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listallz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2 = BUNSPEC;
BGL_IMPORT obj_t bstring_to_symbol(obj_t);
BGL_IMPORT obj_t BGl_fprintfz00zz__r4_output_6_10_3z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2seekzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32360ze3ze1zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2ti1375zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getzd2albumzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listgenreartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
static obj_t BGl_z62mpdzd2statuszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2addzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdz00zz__multimediazd2mpdzd2(BgL_musicz00_bglt, obj_t, obj_t, BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_methodzd2initzd2zz__multimediazd2mpdzd2();
static obj_t BGl_z62mpdzd2playzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2pausezd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62mpdzd2currentsongzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2deleteidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_directoryzd2ze3sortzd2listze3zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62zc3anonymousza32346ze3ze1zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2databasezd2getarti1382z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_currentsongzd2cachezd2plistz00zz__multimediazd2mpdzd2 = BUNSPEC;
static obj_t BGl_z62zc3anonymousza32079ze3ze1zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getarti1387z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getgenr1379z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listalbumz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2ar1369zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32291ze3ze1zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getgenr1384z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2shufflezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2getartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32381ze3ze1zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2previouszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_currentsongzd2cachezd2infoz00zz__multimediazd2mpdzd2 = BUNSPEC;
static bool_t BGl_directoryzd2scanze70z35zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_mpdzd2listzd2beginz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, BgL_musicz00_bglt, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32560ze3ze1zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32188ze3ze1zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2urlhandlerszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2filezd2ze3pathz31zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
extern BgL_musicstatusz00_bglt BGl_musiczd2statuszd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62zc3anonymousza32367ze3ze1zz__multimediazd2mpdzd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2findzd2artistzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listalb1353z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2playlistzd2getz00zz__multimediazd2musiczd2(BgL_musicz00_bglt);
BGL_IMPORT obj_t BGl_filezd2namezd2ze3listze3zz__osz00(obj_t);
BGL_IMPORT obj_t BGl_makezd2hashtablezd2zz__hashz00(obj_t);
static obj_t BGl_z62mpdzd2stopzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2savezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_getinfofilez00zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2findzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT bool_t fexists(char *);
static BgL_mpdzd2databasezd2_bglt BGl_z62lambda2302z62zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2playlistinfozb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32637ze3ze1zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2309z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getzd2alb1391zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2310z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2findzd2genrezd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readzd2linezd2zz__r4_input_6_10_2z00(obj_t);
static obj_t BGl_z62lambda2316z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2317z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2volumezd2setz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
BGL_IMPORT long bgl_list_length(obj_t);
static obj_t BGl_z62mpdzd2databasezd2listartistz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__multimediazd2mpdzd2();
static obj_t BGl_z62lambda2323z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2324z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listgenrealbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
static obj_t BGl_z62lambda2330z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2331z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2337z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2338z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
extern obj_t BGl_filezd2musictagzd2zz__multimediazd2id3zd2(obj_t);
extern obj_t BGl_musiczd2volumezd2getz00zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62lambda2344z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2345z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
extern obj_t BGl_musictagz00zz__multimediazd2id3zd2;
static obj_t BGl_z62mpdzd2databasezd2getartistz62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2351z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2352z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2randomzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2metazd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62mpdzd2outputszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2358z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2359z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_zc3exitza32022ze3ze70z64zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2searchzd21371zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t c_substring(obj_t, long, long);
static obj_t BGl_z62mpdzd2commandszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2searchzd21373zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = BUNSPEC;
static obj_t BGl_z62lambda2365z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2366z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2seekidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
static obj_t BGl_z62mpdzd2rmzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2372z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2373z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2379z62zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2findzd2titlezd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
static obj_t BGl_loopze70ze7zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
static bool_t BGl_loopze71ze7zz__multimediazd2mpdzd2(obj_t, BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, obj_t);
static bool_t BGl_loopze72ze7zz__multimediazd2mpdzd2(obj_t, BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, obj_t);
static obj_t BGl_loopze73ze7zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, bool_t, obj_t);
static bool_t BGl_loopze74ze7zz__multimediazd2mpdzd2(obj_t, BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, obj_t);
static obj_t BGl_loopze75ze7zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_IMPORT long bgl_date_to_seconds(obj_t);
static obj_t BGl_z62lambda2380z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_getzd2linezd2argzd2symbolzd2nthz00zz__multimediazd2mpdzd2(obj_t, long);
extern obj_t BGl_musiczd2seekzd2zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t, obj_t);
BGL_IMPORT obj_t BGl_stringzd2downcasez12zc0zz__r4_strings_6_7z00(obj_t);
static obj_t BGl_z62mpdzd2statszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2statsz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2movezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2findzd2albumzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
extern obj_t BGl_musiczd2playzd2zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
static obj_t BGl_z62mpdzd2plchangeszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32025ze3ze1zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2pausezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2playlistzd2clearz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt);
BGL_IMPORT bool_t bigloo_strcmp(obj_t, obj_t);
static obj_t BGl_z62mpdzd2closezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32026ze3ze1zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2lsinfozb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2volumezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2playlistzd2addz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2getgenrez00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt);
static obj_t BGl_z62zc3anonymousza32311ze3ze1zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2databasezd2filezd2ze3pathz53zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32117ze3ze1zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__multimediazd2mpdzd2 = BUNSPEC;
BGL_IMPORT obj_t BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(obj_t);
BGL_IMPORT bool_t BGl_stringzd2suffixzf3z21zz__r4_strings_6_7z00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2lsinfoz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2notcommandszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_filezd2musicinfozd2zz__multimediazd2id3zd2(obj_t);
static obj_t BGl_z62zc3anonymousza32151ze3ze1zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2playlistidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2initz121345z70zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_IMPORT obj_t bgl_seconds_to_date(long);
static obj_t BGl_toplevelzd2initzd2zz__multimediazd2mpdzd2();
static obj_t BGl_z62mpdzd2listallinfozb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31988ze3ze1zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getartistalbumz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getgenrez62zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2setvolzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2stopzd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62mpdzd2databasezd2findzd2genrezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2updatezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__multimediazd2mpdzd2();
BGL_IMPORT obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
static obj_t BGl_z62zc3anonymousza32332ze3ze1zz__multimediazd2mpdzd2(obj_t);
BGL_IMPORT obj_t BGl_filterzd2mapzd2zz__r4_control_features_6_9z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_listzd2ze3stringz31zz__r4_strings_6_7z00(obj_t);
static obj_t BGl_z62mpdzd2clearerrorzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern bool_t BGl_musiczd2closedzf3z21zz__multimediazd2musiczd2(BgL_musicz00_bglt);
BGL_IMPORT obj_t BGl_hashtablezd2mapzd2zz__hashz00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2artistzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
static obj_t BGl_mpdzd2ze3filez31zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32318ze3ze1zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62zc3anonymousza32156ze3ze1zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(obj_t, long);
static obj_t BGl_z62mpdzd2tagtypeszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_makezd2filezd2namez00zz__osz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, bool_t);
BGL_IMPORT obj_t BGl_basenamez00zz__osz00(obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2passwordzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2swapzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2statsz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2filezd2ze3p1347z53zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32353ze3ze1zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2listzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2titlezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2moveidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2searchzd2artistzd2titlez00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, obj_t);
static bool_t BGl_filezd2systemzd2rootzf3zf3zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62zc3anonymousza32339ze3ze1zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2albumzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listartistalbumz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2plconangesposidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t string_append(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2searchzd2artistzd2albumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2prevzd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
BGL_IMPORT long bgl_current_seconds();
static obj_t BGl_z62mpdzd2nextzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32089ze3ze1zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_executezd2commandzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, BgL_musicz00_bglt, obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2playlistzd2deletez12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, int);
BGL_IMPORT obj_t BGl_callzd2withzd2outputzd2stringzd2zz__r4_ports_6_10_1z00(obj_t);
static obj_t BGl_z62mpdzd2databasezd2lsinfo1365z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getgenreartistz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl__mpdz00zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_substringz00zz__r4_strings_6_7z00(obj_t, long, long);
static long BGl_cmdnz00zz__multimediazd2mpdzd2;
BGL_IMPORT obj_t BGl_makezd2datezd2zz__datez00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2initz12z70zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32374ze3ze1zz__multimediazd2mpdzd2(obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
BGL_IMPORT bool_t bigloo_string_lt(obj_t, obj_t);
static obj_t BGl_z62mpdzd2pingzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_directoryzd2imagezd2zz__multimediazd2mpdzd2(obj_t);
BGL_IMPORT obj_t bgl_list_ref(obj_t, long);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2mpdzd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2id3zd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__datez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__hashz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
static obj_t BGl_z62mpdzd2databasezd2searchzd2artistzd2titlez62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_sortz00zz__r4_vectors_6_8z00(obj_t, obj_t);
static long BGl_currentsongzd2cachezd2numz00zz__multimediazd2mpdzd2;
extern obj_t BGl_musicz00zz__multimediazd2musiczd2;
static obj_t BGl_z62mpdzd2databasezd2searchzd2artistzd2albumz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__multimediazd2mpdzd2();
static obj_t BGl_libraryzd2moduleszd2initz00zz__multimediazd2mpdzd2();
BGL_IMPORT obj_t BGl_stringzd2indexzd2zz__r4_strings_6_7z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2al1367zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__multimediazd2mpdzd2();
static bool_t BGl_findzd2genreze70z35zz__multimediazd2mpdzd2(obj_t, obj_t, BgL_mpdzd2databasezd2_bglt, obj_t);
extern obj_t BGl_musicinfoz00zz__multimediazd2id3zd2;
BGL_IMPORT obj_t BGl_prefixz00zz__osz00(obj_t);
static bool_t BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(obj_t);
BGL_IMPORT obj_t BGl_z62iozd2errorzb0zz__objectz00;
BGL_IMPORT obj_t BGl_makezd2filezd2pathz00zz__osz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2searchzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_IMPORT bool_t bigloo_strcmp_at(obj_t, obj_t, long);
BGL_IMPORT obj_t BGl_objectz00zz__objectz00;
static obj_t BGl_z62mpdzd2databasezd2stats1349z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2playidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listgenreartistz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2clearzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2ge1377zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listart1355z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(obj_t);
static bool_t BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_IMPORT bool_t bgl_directoryp(char *);
extern int BGl_musiczd2songzd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62mpdzd2databasezd2listart1363z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_hashtablezd2putz12zc0zz__hashz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listall1351z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT long bgl_last_modification_time(char *);
static BgL_mpdzd2databasezd2_bglt BGl_z62lambda2299z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listgenrez00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_playlistinfoz00zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, int);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2getartistalbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2initz12z12zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt);
static obj_t BGl_z62mpdzd2playlistzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2addidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static bool_t BGl_findzd2titleze70z35zz__multimediazd2mpdzd2(obj_t, obj_t, BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_getzd2linezd2commandz00zz__multimediazd2mpdzd2(obj_t);
BGL_IMPORT int BGl_stringzd2naturalzd2compare3z00zz__r4_strings_6_7z00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listgenrealbumz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listartistalbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
static obj_t __cnst[ 96 ] ;


DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2getgenrezd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3523z00, BGl_z62mpdzd2databasezd2getgenrez62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2seekidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2seekidza73524za7, BGl_z62mpdzd2seekidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2playzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2playza7b03525za7, BGl_z62mpdzd2playzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2rmzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2rmza7b0za7za73526za7, BGl_z62mpdzd2rmzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2findzd2artistzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3527z00, BGl_z62mpdzd2databasezd2findzd2artistzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2statszd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3528z00, BGl_z62mpdzd2databasezd2statsz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2updatezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2updateza73529za7, BGl_z62mpdzd2updatezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2getgenreartistzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3530z00, BGl_z62mpdzd2databasezd2getgenreartistz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3400z00zz__multimediazd2mpdzd2, BgL_bgl_string3400za700za7za7_3531za7, "No such file", 12 );
DEFINE_STRING( BGl_string3405z00zz__multimediazd2mpdzd2, BgL_bgl_string3405za700za7za7_3532za7, "~a-~2,0d-~2,0dT~2,0d:~2,0d:~2,0dZ", 33 );
DEFINE_STRING( BGl_string3406z00zz__multimediazd2mpdzd2, BgL_bgl_string3406za700za7za7_3533za7, "unknown", 7 );
DEFINE_STRING( BGl_string3407z00zz__multimediazd2mpdzd2, BgL_bgl_string3407za700za7za7_3534za7, "Unknown Disc", 12 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2getartistzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3535z00, BGl_z62mpdzd2databasezd2getartistz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2seekzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2seekza7b03536za7, BGl_z62mpdzd2seekzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2pingzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2pingza7b03537za7, BGl_z62mpdzd2pingzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2nextzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2nextza7b03538za7, BGl_z62mpdzd2nextzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string3446z00zz__multimediazd2mpdzd2, BgL_bgl_string3446za700za7za7_3539za7, "mpd-database-init!1345", 22 );
DEFINE_STRING( BGl_string3448z00zz__multimediazd2mpdzd2, BgL_bgl_string3448za700za7za7_3540za7, "mpd-database-file->p1347", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2stopzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2stopza7b03541za7, BGl_z62mpdzd2stopzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2previouszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2previou3542z00, BGl_z62mpdzd2previouszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string3450z00zz__multimediazd2mpdzd2, BgL_bgl_string3450za700za7za7_3543za7, "mpd-database-stats1349", 22 );
DEFINE_STRING( BGl_string3452z00zz__multimediazd2mpdzd2, BgL_bgl_string3452za700za7za7_3544za7, "mpd-database-listall1351", 24 );
DEFINE_STRING( BGl_string3454z00zz__multimediazd2mpdzd2, BgL_bgl_string3454za700za7za7_3545za7, "mpd-database-listalb1353", 24 );
DEFINE_STRING( BGl_string3456z00zz__multimediazd2mpdzd2, BgL_bgl_string3456za700za7za7_3546za7, "mpd-database-listart1355", 24 );
DEFINE_STRING( BGl_string3458z00zz__multimediazd2mpdzd2, BgL_bgl_string3458za700za7za7_3547za7, "mpd-database-listgen1357", 24 );
DEFINE_STRING( BGl_string3460z00zz__multimediazd2mpdzd2, BgL_bgl_string3460za700za7za7_3548za7, "mpd-database-listgen1359", 24 );
DEFINE_STRING( BGl_string3462z00zz__multimediazd2mpdzd2, BgL_bgl_string3462za700za7za7_3549za7, "mpd-database-listgen1361", 24 );
DEFINE_STRING( BGl_string3464z00zz__multimediazd2mpdzd2, BgL_bgl_string3464za700za7za7_3550za7, "mpd-database-listart1363", 24 );
DEFINE_STRING( BGl_string3466z00zz__multimediazd2mpdzd2, BgL_bgl_string3466za700za7za7_3551za7, "mpd-database-lsinfo1365", 23 );
DEFINE_STRING( BGl_string3468z00zz__multimediazd2mpdzd2, BgL_bgl_string3468za700za7za7_3552za7, "mpd-database-find-al1367", 24 );
DEFINE_STRING( BGl_string3470z00zz__multimediazd2mpdzd2, BgL_bgl_string3470za700za7za7_3553za7, "mpd-database-find-ar1369", 24 );
DEFINE_STRING( BGl_string3472z00zz__multimediazd2mpdzd2, BgL_bgl_string3472za700za7za7_3554za7, "mpd-database-search-1371", 24 );
DEFINE_STRING( BGl_string3474z00zz__multimediazd2mpdzd2, BgL_bgl_string3474za700za7za7_3555za7, "mpd-database-search-1373", 24 );
DEFINE_STRING( BGl_string3476z00zz__multimediazd2mpdzd2, BgL_bgl_string3476za700za7za7_3556za7, "mpd-database-find-ti1375", 24 );
DEFINE_STRING( BGl_string3478z00zz__multimediazd2mpdzd2, BgL_bgl_string3478za700za7za7_3557za7, "mpd-database-find-ge1377", 24 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listgenrezd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3558z00, BGl_z62mpdzd2databasezd2listgenrez62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2playlistzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2playlis3559z00, BGl_z62mpdzd2playlistzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string3480z00zz__multimediazd2mpdzd2, BgL_bgl_string3480za700za7za7_3560za7, "mpd-database-getgenr1379", 24 );
DEFINE_STRING( BGl_string3482z00zz__multimediazd2mpdzd2, BgL_bgl_string3482za700za7za7_3561za7, "mpd-database-getarti1382", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3396z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3anonymousza73562za7, BGl_z62zc3anonymousza32079ze3ze1zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3484z00zz__multimediazd2mpdzd2, BgL_bgl_string3484za700za7za7_3563za7, "mpd-database-getgenr1384", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3398z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3anonymousza73564za7, BGl_z62zc3anonymousza32089ze3ze1zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3486z00zz__multimediazd2mpdzd2, BgL_bgl_string3486za700za7za7_3565za7, "mpd-database-getarti1387", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3399z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3anonymousza73566za7, BGl_z62zc3anonymousza32117ze3ze1zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3488z00zz__multimediazd2mpdzd2, BgL_bgl_string3488za700za7za7_3567za7, "mpd-database-get-alb1391", 24 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2filezd2ze3pathzd2envze3zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3568z00, BGl_z62mpdzd2databasezd2filezd2ze3pathz53zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3490z00zz__multimediazd2mpdzd2, BgL_bgl_string3490za700za7za7_3569za7, "directory: ", 11 );
DEFINE_STRING( BGl_string3491z00zz__multimediazd2mpdzd2, BgL_bgl_string3491za700za7za7_3570za7, "lsinfo", 6 );
DEFINE_STRING( BGl_string3492z00zz__multimediazd2mpdzd2, BgL_bgl_string3492za700za7za7_3571za7, "Genre: ", 7 );
DEFINE_STRING( BGl_string3493z00zz__multimediazd2mpdzd2, BgL_bgl_string3493za700za7za7_3572za7, "artists: ~a\nalbums: ~a\nsongs: ~a\nuptime: ~a\nplaytime: ~a\ndb_playtime: 10000000\ndb_update: ~a\n", 93 );
DEFINE_STRING( BGl_string3495z00zz__multimediazd2mpdzd2, BgL_bgl_string3495za700za7za7_3573za7, "&mpd-database-init!", 19 );
DEFINE_STRING( BGl_string3496z00zz__multimediazd2mpdzd2, BgL_bgl_string3496za700za7za7_3574za7, "&mpd-database-file->path", 24 );
DEFINE_STRING( BGl_string3497z00zz__multimediazd2mpdzd2, BgL_bgl_string3497za700za7za7_3575za7, "bstring", 7 );
DEFINE_STRING( BGl_string3498z00zz__multimediazd2mpdzd2, BgL_bgl_string3498za700za7za7_3576za7, "&mpd-database-stats", 19 );
DEFINE_STRING( BGl_string3499z00zz__multimediazd2mpdzd2, BgL_bgl_string3499za700za7za7_3577za7, "&mpd-database-listall", 21 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2moveidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2moveidza73578za7, BGl_z62mpdzd2moveidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2killzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2killza7b03579za7, BGl_z62mpdzd2killzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2shufflezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2shuffle3580z00, BGl_z62mpdzd2shufflezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2closezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2closeza7b3581za7, BGl_z62mpdzd2closezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2deleteidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2deletei3582z00, BGl_z62mpdzd2deleteidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2volumezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2volumeza73583za7, BGl_z62mpdzd2volumezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2addzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2addza7b0za73584z00, BGl_z62mpdzd2addzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_LLONG( BGl_llong3494z00zz__multimediazd2mpdzd2, BgL_bgl_llong3494za700za7za7__3585za7, ((BGL_LONGLONG_T)0) );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listalbumzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3586z00, BGl_z62mpdzd2databasezd2listalbumz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2getzd2albumzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3587z00, BGl_z62mpdzd2databasezd2getzd2albumzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2urlhandlerszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2urlhand3588z00, BGl_z62mpdzd2urlhandlerszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2playidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2playidza73589za7, BGl_z62mpdzd2playidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2movezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2moveza7b03590za7, BGl_z62mpdzd2movezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2playlistidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2playlis3591z00, BGl_z62mpdzd2playlistidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2repeatzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2repeatza73592za7, BGl_z62mpdzd2repeatzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2listallinfozd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2listall3593z00, BGl_z62mpdzd2listallinfozb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2lsinfozd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2lsinfoza73594za7, BGl_z62mpdzd2lsinfozb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2searchzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2searchza73595za7, BGl_z62mpdzd2searchzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2deletezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2deleteza73596za7, BGl_z62mpdzd2deletezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2listallzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2listall3597z00, BGl_z62mpdzd2listallzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2notcommandszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2notcomm3598z00, BGl_z62mpdzd2notcommandszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2clearerrorzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2clearer3599z00, BGl_z62mpdzd2clearerrorzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3401z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3anonymousza73600za7, BGl_z62zc3anonymousza32151ze3ze1zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3402z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3anonymousza73601za7, BGl_z62zc3anonymousza32156ze3ze1zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3403z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3anonymousza73602za7, BGl_z62zc3anonymousza32161ze3ze1zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3404z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3anonymousza73603za7, BGl_z62zc3anonymousza32188ze3ze1zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3408z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3anonymousza73604za7, BGl_z62zc3anonymousza32291ze3ze1zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3409z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3anonymousza73605za7, BGl_z62zc3anonymousza32311ze3ze1zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3337z00zz__multimediazd2mpdzd2, BgL_bgl_string3337za700za7za7_3606za7, "", 0 );
DEFINE_STRING( BGl_string3338z00zz__multimediazd2mpdzd2, BgL_bgl_string3338za700za7za7_3607za7, "wrong number of arguments: [4..5] expected, provided", 52 );
DEFINE_STRING( BGl_string3339z00zz__multimediazd2mpdzd2, BgL_bgl_string3339za700za7za7_3608za7, "Illegal keyword argument", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3410z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2310za7623609z00, BGl_z62lambda2310z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3411z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2309za7623610z00, BGl_z62lambda2309z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3412z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3anonymousza73611za7, BGl_z62zc3anonymousza32318ze3ze1zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3500z00zz__multimediazd2mpdzd2, BgL_bgl_string3500za700za7za7_3612za7, "&mpd-database-listalbum", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3413z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2317za7623613z00, BGl_z62lambda2317z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3501z00zz__multimediazd2mpdzd2, BgL_bgl_string3501za700za7za7_3614za7, "&mpd-database-listartistalbum", 29 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3414z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2316za7623615z00, BGl_z62lambda2316z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3502z00zz__multimediazd2mpdzd2, BgL_bgl_string3502za700za7za7_3616za7, "&mpd-database-listgenrealbum", 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3415z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3anonymousza73617za7, BGl_z62zc3anonymousza32325ze3ze1zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3340z00zz__multimediazd2mpdzd2, BgL_bgl_string3340za700za7za7_3618za7, "/builddir/build/BUILD/bigloo4.3f/api/multimedia/src/Llib/mpd.scm", 64 );
DEFINE_STRING( BGl_string3503z00zz__multimediazd2mpdzd2, BgL_bgl_string3503za700za7za7_3619za7, "&mpd-database-listgenreartist", 29 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3416z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2324za7623620z00, BGl_z62lambda2324z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3341z00zz__multimediazd2mpdzd2, BgL_bgl_string3341za700za7za7_3621za7, "_mpd", 4 );
DEFINE_STRING( BGl_string3504z00zz__multimediazd2mpdzd2, BgL_bgl_string3504za700za7za7_3622za7, "&mpd-database-listgenre", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3417z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2323za7623623z00, BGl_z62lambda2323z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3342z00zz__multimediazd2mpdzd2, BgL_bgl_string3342za700za7za7_3624za7, "bint", 4 );
DEFINE_STRING( BGl_string3505z00zz__multimediazd2mpdzd2, BgL_bgl_string3505za700za7za7_3625za7, "&mpd-database-listartist", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3418z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3anonymousza73626za7, BGl_z62zc3anonymousza32332ze3ze1zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3343z00zz__multimediazd2mpdzd2, BgL_bgl_string3343za700za7za7_3627za7, "music", 5 );
DEFINE_STRING( BGl_string3506z00zz__multimediazd2mpdzd2, BgL_bgl_string3506za700za7za7_3628za7, "&mpd-database-lsinfo", 20 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3419z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2331za7623629z00, BGl_z62lambda2331z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3344z00zz__multimediazd2mpdzd2, BgL_bgl_string3344za700za7za7_3630za7, "input-port", 10 );
DEFINE_STRING( BGl_string3507z00zz__multimediazd2mpdzd2, BgL_bgl_string3507za700za7za7_3631za7, "&mpd-database-find-album", 24 );
DEFINE_STRING( BGl_string3345z00zz__multimediazd2mpdzd2, BgL_bgl_string3345za700za7za7_3632za7, "output-port", 11 );
DEFINE_STRING( BGl_string3508z00zz__multimediazd2mpdzd2, BgL_bgl_string3508za700za7za7_3633za7, "&mpd-database-find-artist", 25 );
DEFINE_STRING( BGl_string3346z00zz__multimediazd2mpdzd2, BgL_bgl_string3346za700za7za7_3634za7, "mpd-database", 12 );
DEFINE_STRING( BGl_string3509z00zz__multimediazd2mpdzd2, BgL_bgl_string3509za700za7za7_3635za7, "&mpd-database-search-artist-album", 33 );
DEFINE_STRING( BGl_string3347z00zz__multimediazd2mpdzd2, BgL_bgl_string3347za700za7za7_3636za7, "OK MPD 0.16.0", 13 );
DEFINE_STRING( BGl_string3348z00zz__multimediazd2mpdzd2, BgL_bgl_string3348za700za7za7_3637za7, "OK\n", 3 );
BGL_IMPORT obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_STRING( BGl_string3349z00zz__multimediazd2mpdzd2, BgL_bgl_string3349za700za7za7_3638za7, "ACK [", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3420z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2330za7623639z00, BGl_z62lambda2330z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3421z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3anonymousza73640za7, BGl_z62zc3anonymousza32339ze3ze1zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2currentsongzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2current3641z00, BGl_z62mpdzd2currentsongzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3422z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2338za7623642z00, BGl_z62lambda2338z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3510z00zz__multimediazd2mpdzd2, BgL_bgl_string3510za700za7za7_3643za7, "&mpd-database-search-artist-title", 33 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3423z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2337za7623644z00, BGl_z62lambda2337z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3511z00zz__multimediazd2mpdzd2, BgL_bgl_string3511za700za7za7_3645za7, "&mpd-database-find-title", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3424z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3anonymousza73646za7, BGl_z62zc3anonymousza32346ze3ze1zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3512z00zz__multimediazd2mpdzd2, BgL_bgl_string3512za700za7za7_3647za7, "&mpd-database-find-genre", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3425z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2345za7623648z00, BGl_z62lambda2345z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3350z00zz__multimediazd2mpdzd2, BgL_bgl_string3350za700za7za7_3649za7, "5@0", 3 );
DEFINE_STRING( BGl_string3513z00zz__multimediazd2mpdzd2, BgL_bgl_string3513za700za7za7_3650za7, "&mpd-database-getgenre", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3426z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2344za7623651z00, BGl_z62lambda2344z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3351z00zz__multimediazd2mpdzd2, BgL_bgl_string3351za700za7za7_3652za7, "] {", 3 );
DEFINE_STRING( BGl_string3514z00zz__multimediazd2mpdzd2, BgL_bgl_string3514za700za7za7_3653za7, "&mpd-database-getartist", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3427z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3anonymousza73654za7, BGl_z62zc3anonymousza32353ze3ze1zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3352z00zz__multimediazd2mpdzd2, BgL_bgl_string3352za700za7za7_3655za7, "} ", 2 );
DEFINE_STRING( BGl_string3515z00zz__multimediazd2mpdzd2, BgL_bgl_string3515za700za7za7_3656za7, "&mpd-database-getgenreartist", 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3428z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2352za7623657z00, BGl_z62lambda2352z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3353z00zz__multimediazd2mpdzd2, BgL_bgl_string3353za700za7za7_3658za7, "\n", 1 );
DEFINE_STRING( BGl_string3516z00zz__multimediazd2mpdzd2, BgL_bgl_string3516za700za7za7_3659za7, "&mpd-database-getartistalbum", 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3429z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2351za7623660z00, BGl_z62lambda2351z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3354z00zz__multimediazd2mpdzd2, BgL_bgl_string3354za700za7za7_3661za7, "unknown command \"~a\"", 20 );
DEFINE_STRING( BGl_string3517z00zz__multimediazd2mpdzd2, BgL_bgl_string3517za700za7za7_3662za7, "&mpd-database-get-album", 23 );
DEFINE_STRING( BGl_string3355z00zz__multimediazd2mpdzd2, BgL_bgl_string3355za700za7za7_3663za7, "list_OK\n", 8 );
DEFINE_STRING( BGl_string3518z00zz__multimediazd2mpdzd2, BgL_bgl_string3518za700za7za7_3664za7, "__multimedia-mpd", 16 );
DEFINE_STRING( BGl_string3356z00zz__multimediazd2mpdzd2, BgL_bgl_string3356za700za7za7_3665za7, "handler: ", 9 );
DEFINE_STRING( BGl_string3519z00zz__multimediazd2mpdzd2, BgL_bgl_string3519za700za7za7_3666za7, ":album (\"mp3\" \"flac\" \"ogg\" \"wav\") __multimedia-mpd mpd-database %db-update %uptime %nsongs int %nalbums obj %nartists %genres %albums %artists bstring %base suffixes pair-nil directories :Image :Time :Last-Modified :file :Genre :Date :Track :Album :Title :Artist (\"jpg\" \"JPG\" \"png\" \"gif\" \"GIF\") any genre disc album title artist (\"Artist\" \"Album\" \"Title\" \"Track\" \"Name\" \"Genre\" \"Date\" \"Composer\" \"Performer\" \"Disc\") (\"http://\" \"file://\") command_list_end command_list_ok_begin command_list_begin blank ok :log (:log) mpd outputs update swapid swap shuffle save rm repeat random password moveid move crossfade addid notcommands commands search find kill plconangesposid lsinfo listallinfo list listall stats close clearerror setvol volume previous next pause stop seekid seek playid play currentsong clear deleteid delete add plchanges playlistid playlistinfo playlist status tagtypes urlhandlers ping ", 901 );
DEFINE_STRING( BGl_string3357z00zz__multimediazd2mpdzd2, BgL_bgl_string3357za700za7za7_3667za7, "tagtype: ", 9 );
DEFINE_STRING( BGl_string3358z00zz__multimediazd2mpdzd2, BgL_bgl_string3358za700za7za7_3668za7, "volume: ", 8 );
DEFINE_STRING( BGl_string3359z00zz__multimediazd2mpdzd2, BgL_bgl_string3359za700za7za7_3669za7, "state: ", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2commandszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2command3670z00, BGl_z62mpdzd2commandszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3430z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3anonymousza73671za7, BGl_z62zc3anonymousza32360ze3ze1zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3431z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2359za7623672z00, BGl_z62lambda2359z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3432z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2358za7623673z00, BGl_z62lambda2358z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3433z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3anonymousza73674za7, BGl_z62zc3anonymousza32367ze3ze1zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3434z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2366za7623675z00, BGl_z62lambda2366z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3435z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2365za7623676z00, BGl_z62lambda2365z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3360z00zz__multimediazd2mpdzd2, BgL_bgl_string3360za700za7za7_3677za7, "playlist: ", 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3436z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3anonymousza73678za7, BGl_z62zc3anonymousza32374ze3ze1zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3361z00zz__multimediazd2mpdzd2, BgL_bgl_string3361za700za7za7_3679za7, "playlistlength: ", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3437z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2373za7623680z00, BGl_z62lambda2373z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3362z00zz__multimediazd2mpdzd2, BgL_bgl_string3362za700za7za7_3681za7, "song: ", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3438z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2372za7623682z00, BGl_z62lambda2372z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3363z00zz__multimediazd2mpdzd2, BgL_bgl_string3363za700za7za7_3683za7, "songid: ", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3439z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3anonymousza73684za7, BGl_z62zc3anonymousza32381ze3ze1zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3364z00zz__multimediazd2mpdzd2, BgL_bgl_string3364za700za7za7_3685za7, "bitrate: ", 9 );
DEFINE_STRING( BGl_string3365z00zz__multimediazd2mpdzd2, BgL_bgl_string3365za700za7za7_3686za7, "audio: ", 7 );
DEFINE_STRING( BGl_string3366z00zz__multimediazd2mpdzd2, BgL_bgl_string3366za700za7za7_3687za7, ":16:2\n", 6 );
DEFINE_STRING( BGl_string3367z00zz__multimediazd2mpdzd2, BgL_bgl_string3367za700za7za7_3688za7, "time: ", 6 );
DEFINE_STRING( BGl_string3368z00zz__multimediazd2mpdzd2, BgL_bgl_string3368za700za7za7_3689za7, ":", 1 );
DEFINE_STRING( BGl_string3369z00zz__multimediazd2mpdzd2, BgL_bgl_string3369za700za7za7_3690za7, "repeat: 1\n", 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3440z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2380za7623691z00, BGl_z62lambda2380z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3441z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2379za7623692z00, BGl_z62lambda2379z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3442z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3anonymousza73693za7, BGl_z62zc3anonymousza32304ze3ze1zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3443z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2302za7623694z00, BGl_z62lambda2302z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3444z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2299za7623695z00, BGl_z62lambda2299z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3445z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3696z00, BGl_z62mpdzd2databasezd2initz121345z70zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3370z00zz__multimediazd2mpdzd2, BgL_bgl_string3370za700za7za7_3697za7, "repeat: 0\n", 10 );
DEFINE_STRING( BGl_string3371z00zz__multimediazd2mpdzd2, BgL_bgl_string3371za700za7za7_3698za7, "random: 1\n", 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3447z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3699z00, BGl_z62mpdzd2databasezd2filezd2ze3p1347z53zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3372z00zz__multimediazd2mpdzd2, BgL_bgl_string3372za700za7za7_3700za7, "random: 0\n", 10 );
DEFINE_STRING( BGl_string3373z00zz__multimediazd2mpdzd2, BgL_bgl_string3373za700za7za7_3701za7, "xfade: ", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3449z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3702z00, BGl_z62mpdzd2databasezd2stats1349z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3374z00zz__multimediazd2mpdzd2, BgL_bgl_string3374za700za7za7_3703za7, ": ", 2 );
DEFINE_STRING( BGl_string3375z00zz__multimediazd2mpdzd2, BgL_bgl_string3375za700za7za7_3704za7, "http://", 7 );
DEFINE_STRING( BGl_string3376z00zz__multimediazd2mpdzd2, BgL_bgl_string3376za700za7za7_3705za7, "add", 3 );
DEFINE_STRING( BGl_string3377z00zz__multimediazd2mpdzd2, BgL_bgl_string3377za700za7za7_3706za7, "illegal uri \"~a\"", 16 );
DEFINE_STRING( BGl_string3378z00zz__multimediazd2mpdzd2, BgL_bgl_string3378za700za7za7_3707za7, "file: ", 6 );
DEFINE_STRING( BGl_string3379z00zz__multimediazd2mpdzd2, BgL_bgl_string3379za700za7za7_3708za7, "Pos: ", 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2searchzd2artistzd2albumzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3709z00, BGl_z62mpdzd2databasezd2searchzd2artistzd2albumz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2crossfadezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2crossfa3710z00, BGl_z62mpdzd2crossfadezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3451z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3711z00, BGl_z62mpdzd2databasezd2listall1351z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3453z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3712z00, BGl_z62mpdzd2databasezd2listalb1353z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3455z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3713z00, BGl_z62mpdzd2databasezd2listart1355z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3380z00zz__multimediazd2mpdzd2, BgL_bgl_string3380za700za7za7_3714za7, "Id: ", 4 );
DEFINE_STRING( BGl_string3381z00zz__multimediazd2mpdzd2, BgL_bgl_string3381za700za7za7_3715za7, "Artist: ", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3457z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3716z00, BGl_z62mpdzd2databasezd2listgen1357z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3382z00zz__multimediazd2mpdzd2, BgL_bgl_string3382za700za7za7_3717za7, "Title: ", 7 );
DEFINE_STRING( BGl_string3383z00zz__multimediazd2mpdzd2, BgL_bgl_string3383za700za7za7_3718za7, "Album: ", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3459z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3719z00, BGl_z62mpdzd2databasezd2listgen1359z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3384z00zz__multimediazd2mpdzd2, BgL_bgl_string3384za700za7za7_3720za7, "50@0", 4 );
DEFINE_STRING( BGl_string3385z00zz__multimediazd2mpdzd2, BgL_bgl_string3385za700za7za7_3721za7, "next", 4 );
DEFINE_STRING( BGl_string3386z00zz__multimediazd2mpdzd2, BgL_bgl_string3386za700za7za7_3722za7, "No more song", 12 );
DEFINE_STRING( BGl_string3387z00zz__multimediazd2mpdzd2, BgL_bgl_string3387za700za7za7_3723za7, "previous", 8 );
DEFINE_STRING( BGl_string3388z00zz__multimediazd2mpdzd2, BgL_bgl_string3388za700za7za7_3724za7, "No previous song", 16 );
DEFINE_STRING( BGl_string3389z00zz__multimediazd2mpdzd2, BgL_bgl_string3389za700za7za7_3725za7, "artist", 6 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_mpdzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl__mpdza700za7za7__multi3726za7, opt_generic_entry, BGl__mpdz00zz__multimediazd2mpdzd2, BFALSE, -1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2setvolzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2setvolza73727za7, BGl_z62mpdzd2setvolzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3461z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3728z00, BGl_z62mpdzd2databasezd2listgen1361z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3463z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3729z00, BGl_z62mpdzd2databasezd2listart1363z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listgenrealbumzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3730z00, BGl_z62mpdzd2databasezd2listgenrealbumz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3465z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3731z00, BGl_z62mpdzd2databasezd2lsinfo1365z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3390z00zz__multimediazd2mpdzd2, BgL_bgl_string3390za700za7za7_3732za7, "genre", 5 );
DEFINE_STRING( BGl_string3391z00zz__multimediazd2mpdzd2, BgL_bgl_string3391za700za7za7_3733za7, "unknown list type \"~a\"", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3467z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3734z00, BGl_z62mpdzd2databasezd2findzd2al1367zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3392z00zz__multimediazd2mpdzd2, BgL_bgl_string3392za700za7za7_3735za7, "ACK [2@0] {list} too few arguments for \"list\"", 45 );
DEFINE_STRING( BGl_string3393z00zz__multimediazd2mpdzd2, BgL_bgl_string3393za700za7za7_3736za7, "cpos: ", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3469z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3737z00, BGl_z62mpdzd2databasezd2findzd2ar1369zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3394z00zz__multimediazd2mpdzd2, BgL_bgl_string3394za700za7za7_3738za7, "unknown find type \"~a\"", 22 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listartistalbumzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3739z00, BGl_z62mpdzd2databasezd2listartistalbumz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3395z00zz__multimediazd2mpdzd2, BgL_bgl_string3395za700za7za7_3740za7, "unknown search type \"~a\"", 24 );
DEFINE_STRING( BGl_string3397z00zz__multimediazd2mpdzd2, BgL_bgl_string3397za700za7za7_3741za7, "command: ", 9 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3471z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3742z00, BGl_z62mpdzd2databasezd2searchzd21371zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3473z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3743z00, BGl_z62mpdzd2databasezd2searchzd21373zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3475z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3744z00, BGl_z62mpdzd2databasezd2findzd2ti1375zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2statuszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2statusza73745za7, BGl_z62mpdzd2statuszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3477z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3746z00, BGl_z62mpdzd2databasezd2findzd2ge1377zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3479z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3747z00, BGl_z62mpdzd2databasezd2getgenr1379z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2clearzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2clearza7b3748za7, BGl_z62mpdzd2clearzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2searchzd2artistzd2titlezd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3749z00, BGl_z62mpdzd2databasezd2searchzd2artistzd2titlez62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2savezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2saveza7b03750za7, BGl_z62mpdzd2savezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3481z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3751z00, BGl_z62mpdzd2databasezd2getarti1382z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2findzd2genrezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3752z00, BGl_z62mpdzd2databasezd2findzd2genrezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3483z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3753z00, BGl_z62mpdzd2databasezd2getgenr1384z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3485z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3754z00, BGl_z62mpdzd2databasezd2getarti1387z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3487z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3755z00, BGl_z62mpdzd2databasezd2getzd2alb1391zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3489z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3anonymousza73756za7, BGl_z62zc3anonymousza32560ze3ze1zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2plconangesposidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2plconan3757z00, BGl_z62mpdzd2plconangesposidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listartistzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3758z00, BGl_z62mpdzd2databasezd2listartistz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2addidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2addidza7b3759za7, BGl_z62mpdzd2addidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2initz12zd2envzc0zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3760z00, BGl_z62mpdzd2databasezd2initz12z70zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2pausezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2pauseza7b3761za7, BGl_z62mpdzd2pausezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2randomzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2randomza73762za7, BGl_z62mpdzd2randomzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2statszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2statsza7b3763za7, BGl_z62mpdzd2statszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2lsinfozd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3764z00, BGl_z62mpdzd2databasezd2lsinfoz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2plchangeszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2plchang3765z00, BGl_z62mpdzd2plchangeszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2tagtypeszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2tagtype3766z00, BGl_z62mpdzd2tagtypeszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2swapidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2swapidza73767za7, BGl_z62mpdzd2swapidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2swapzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2swapza7b03768za7, BGl_z62mpdzd2swapzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2findzd2albumzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3769z00, BGl_z62mpdzd2databasezd2findzd2albumzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2findzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2findza7b03770za7, BGl_z62mpdzd2findzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2outputszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2outputs3771z00, BGl_z62mpdzd2outputszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listgenreartistzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3772z00, BGl_z62mpdzd2databasezd2listgenreartistz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2findzd2titlezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3773z00, BGl_z62mpdzd2databasezd2findzd2titlezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listallzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3774z00, BGl_z62mpdzd2databasezd2listallz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2getartistalbumzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3775z00, BGl_z62mpdzd2databasezd2getartistalbumz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2listzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2listza7b03776za7, BGl_z62mpdzd2listzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2playlistinfozd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2playlis3777z00, BGl_z62mpdzd2playlistinfozb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2passwordzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2passwor3778z00, BGl_z62mpdzd2passwordzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2) );
ADD_ROOT( (void *)(&BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2) );
ADD_ROOT( (void *)(&BGl_currentsongzd2cachezd2plistz00zz__multimediazd2mpdzd2) );
ADD_ROOT( (void *)(&BGl_currentsongzd2cachezd2infoz00zz__multimediazd2mpdzd2) );
ADD_ROOT( (void *)(&BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__multimediazd2mpdzd2) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2mpdzd2(long BgL_checksumz00_6040, char * BgL_fromz00_6041)
{ BGL_FUNCTION_BEGIN;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__multimediazd2mpdzd2))
{ 
BGl_requirezd2initializa7ationz75zz__multimediazd2mpdzd2 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__multimediazd2mpdzd2(); 
BGl_libraryzd2moduleszd2initz00zz__multimediazd2mpdzd2(); 
BGl_cnstzd2initzd2zz__multimediazd2mpdzd2(); 
BGl_importedzd2moduleszd2initz00zz__multimediazd2mpdzd2(); 
BGl_objectzd2initzd2zz__multimediazd2mpdzd2(); 
BGl_genericzd2initzd2zz__multimediazd2mpdzd2(); 
return 
BGl_toplevelzd2initzd2zz__multimediazd2mpdzd2();}  else 
{ 
return BUNSPEC;} } 
BGL_FUNCTION_END;
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__multimediazd2mpdzd2()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__hashz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__datez00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "__multimedia-mpd"); 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__multimediazd2mpdzd2()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 15 */
{ /* Llib/mpd.scm 15 */
obj_t BgL_cportz00_5552;
{ /* Llib/mpd.scm 15 */
obj_t BgL_stringz00_5560;
BgL_stringz00_5560 = BGl_string3519z00zz__multimediazd2mpdzd2; 
{ /* Llib/mpd.scm 15 */
obj_t BgL_startz00_5561;
BgL_startz00_5561 = 
BINT(((long)0)); 
{ /* Llib/mpd.scm 15 */
obj_t BgL_endz00_5562;
BgL_endz00_5562 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_5560))); 
{ /* Llib/mpd.scm 15 */

BgL_cportz00_5552 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_5560, BgL_startz00_5561, BgL_endz00_5562); } } } } 
{ 
long BgL_iz00_5553;
BgL_iz00_5553 = ((long)95); 
BgL_loopz00_5554:
if(
(BgL_iz00_5553==((long)-1)))
{ /* Llib/mpd.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/mpd.scm 15 */
{ /* Llib/mpd.scm 15 */
obj_t BgL_arg3521z00_5556;
{ /* Llib/mpd.scm 15 */

{ /* Llib/mpd.scm 15 */
obj_t BgL_locationz00_5558;
BgL_locationz00_5558 = 
BBOOL(((bool_t)0)); 
{ /* Llib/mpd.scm 15 */

BgL_arg3521z00_5556 = 
BGl_readz00zz__readerz00(BgL_cportz00_5552, BgL_locationz00_5558); } } } 
{ /* Llib/mpd.scm 15 */
int BgL_tmpz00_6081;
BgL_tmpz00_6081 = 
(int)(BgL_iz00_5553); 
CNST_TABLE_SET(BgL_tmpz00_6081, BgL_arg3521z00_5556); } } 
{ /* Llib/mpd.scm 15 */
int BgL_auxz00_5559;
BgL_auxz00_5559 = 
(int)(
(BgL_iz00_5553-((long)1))); 
{ 
long BgL_iz00_6086;
BgL_iz00_6086 = 
(long)(BgL_auxz00_5559); 
BgL_iz00_5553 = BgL_iz00_6086; 
goto BgL_loopz00_5554;} } } } } } 
BGL_FUNCTION_END;
}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__multimediazd2mpdzd2()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 15 */
return 
bgl_gc_roots_register();} 
BGL_FUNCTION_END;
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__multimediazd2mpdzd2()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 15 */
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = BNIL; 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = BNIL; 
BGl_cmdnz00zz__multimediazd2mpdzd2 = ((long)0); 
{ /* Llib/mpd.scm 338 */
obj_t BgL_arg1417z00_419;
{ /* Llib/mpd.scm 338 */
obj_t BgL_arg1418z00_420;
BgL_arg1418z00_420 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)0)), BGl_mpdzd2pingzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 338 */
obj_t BgL_list1419z00_421;
BgL_list1419z00_421 = 
MAKE_YOUNG_PAIR(BgL_arg1418z00_420, BNIL); 
BgL_arg1417z00_419 = BgL_list1419z00_421; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1417z00_419); } 
{ /* Llib/mpd.scm 344 */
obj_t BgL_arg1498z00_422;
{ /* Llib/mpd.scm 344 */
obj_t BgL_arg1499z00_423;
BgL_arg1499z00_423 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)1)), BGl_mpdzd2urlhandlerszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 344 */
obj_t BgL_list1500z00_424;
BgL_list1500z00_424 = 
MAKE_YOUNG_PAIR(BgL_arg1499z00_423, BNIL); 
BgL_arg1498z00_422 = BgL_list1500z00_424; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1498z00_422); } 
{ /* Llib/mpd.scm 354 */
obj_t BgL_arg1509z00_425;
{ /* Llib/mpd.scm 354 */
obj_t BgL_arg1510z00_426;
BgL_arg1510z00_426 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)2)), BGl_mpdzd2tagtypeszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 354 */
obj_t BgL_list1511z00_427;
BgL_list1511z00_427 = 
MAKE_YOUNG_PAIR(BgL_arg1510z00_426, BNIL); 
BgL_arg1509z00_425 = BgL_list1511z00_427; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1509z00_425); } 
{ /* Llib/mpd.scm 371 */
obj_t BgL_arg1517z00_428;
{ /* Llib/mpd.scm 371 */
obj_t BgL_arg1523z00_429;
BgL_arg1523z00_429 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)3)), BGl_mpdzd2statuszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 371 */
obj_t BgL_list1524z00_430;
BgL_list1524z00_430 = 
MAKE_YOUNG_PAIR(BgL_arg1523z00_429, BNIL); 
BgL_arg1517z00_428 = BgL_list1524z00_430; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1517z00_428); } 
{ /* Llib/mpd.scm 406 */
obj_t BgL_arg1531z00_431;
{ /* Llib/mpd.scm 406 */
obj_t BgL_arg1533z00_432;
BgL_arg1533z00_432 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)4)), BGl_mpdzd2playlistzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 406 */
obj_t BgL_list1534z00_433;
BgL_list1534z00_433 = 
MAKE_YOUNG_PAIR(BgL_arg1533z00_432, BNIL); 
BgL_arg1531z00_431 = BgL_list1534z00_433; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1531z00_431); } 
{ /* Llib/mpd.scm 447 */
obj_t BgL_arg1548z00_434;
{ /* Llib/mpd.scm 447 */
obj_t BgL_arg1549z00_435;
BgL_arg1549z00_435 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)5)), BGl_mpdzd2playlistinfozd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 447 */
obj_t BgL_list1550z00_436;
BgL_list1550z00_436 = 
MAKE_YOUNG_PAIR(BgL_arg1549z00_435, BNIL); 
BgL_arg1548z00_434 = BgL_list1550z00_436; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1548z00_434); } 
{ /* Llib/mpd.scm 453 */
obj_t BgL_arg1551z00_437;
{ /* Llib/mpd.scm 453 */
obj_t BgL_arg1552z00_438;
BgL_arg1552z00_438 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)6)), BGl_mpdzd2playlistidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 453 */
obj_t BgL_list1553z00_439;
BgL_list1553z00_439 = 
MAKE_YOUNG_PAIR(BgL_arg1552z00_438, BNIL); 
BgL_arg1551z00_437 = BgL_list1553z00_439; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1551z00_437); } 
{ /* Llib/mpd.scm 459 */
obj_t BgL_arg1566z00_440;
{ /* Llib/mpd.scm 459 */
obj_t BgL_arg1567z00_441;
BgL_arg1567z00_441 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)7)), BGl_mpdzd2plchangeszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 459 */
obj_t BgL_list1568z00_442;
BgL_list1568z00_442 = 
MAKE_YOUNG_PAIR(BgL_arg1567z00_441, BNIL); 
BgL_arg1566z00_440 = BgL_list1568z00_442; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1566z00_440); } 
{ /* Llib/mpd.scm 477 */
obj_t BgL_arg1569z00_443;
{ /* Llib/mpd.scm 477 */
obj_t BgL_arg1581z00_444;
BgL_arg1581z00_444 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)8)), BGl_mpdzd2addzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 477 */
obj_t BgL_list1582z00_445;
BgL_list1582z00_445 = 
MAKE_YOUNG_PAIR(BgL_arg1581z00_444, BNIL); 
BgL_arg1569z00_443 = BgL_list1582z00_445; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1569z00_443); } 
{ /* Llib/mpd.scm 493 */
obj_t BgL_arg1583z00_446;
{ /* Llib/mpd.scm 493 */
obj_t BgL_arg1602z00_447;
BgL_arg1602z00_447 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)9)), BGl_mpdzd2deletezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 493 */
obj_t BgL_list1603z00_448;
BgL_list1603z00_448 = 
MAKE_YOUNG_PAIR(BgL_arg1602z00_447, BNIL); 
BgL_arg1583z00_446 = BgL_list1603z00_448; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1583z00_446); } 
{ /* Llib/mpd.scm 500 */
obj_t BgL_arg1606z00_449;
{ /* Llib/mpd.scm 500 */
obj_t BgL_arg1612z00_450;
BgL_arg1612z00_450 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)10)), BGl_mpdzd2deleteidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 500 */
obj_t BgL_list1613z00_451;
BgL_list1613z00_451 = 
MAKE_YOUNG_PAIR(BgL_arg1612z00_450, BNIL); 
BgL_arg1606z00_449 = BgL_list1613z00_451; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1606z00_449); } 
{ /* Llib/mpd.scm 507 */
obj_t BgL_arg1614z00_452;
{ /* Llib/mpd.scm 507 */
obj_t BgL_arg1615z00_453;
BgL_arg1615z00_453 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)11)), BGl_mpdzd2clearzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 507 */
obj_t BgL_list1616z00_454;
BgL_list1616z00_454 = 
MAKE_YOUNG_PAIR(BgL_arg1615z00_453, BNIL); 
BgL_arg1614z00_452 = BgL_list1616z00_454; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1614z00_452); } 
BGl_currentsongzd2cachezd2plistz00zz__multimediazd2mpdzd2 = BFALSE; 
BGl_currentsongzd2cachezd2numz00zz__multimediazd2mpdzd2 = ((long)-1); 
BGl_currentsongzd2cachezd2infoz00zz__multimediazd2mpdzd2 = BGl_string3337z00zz__multimediazd2mpdzd2; 
{ /* Llib/mpd.scm 579 */
obj_t BgL_arg1619z00_455;
{ /* Llib/mpd.scm 579 */
obj_t BgL_arg1641z00_456;
BgL_arg1641z00_456 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)12)), BGl_mpdzd2currentsongzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 579 */
obj_t BgL_list1642z00_457;
BgL_list1642z00_457 = 
MAKE_YOUNG_PAIR(BgL_arg1641z00_456, BNIL); 
BgL_arg1619z00_455 = BgL_list1642z00_457; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1619z00_455); } 
{ /* Llib/mpd.scm 589 */
obj_t BgL_arg1644z00_458;
{ /* Llib/mpd.scm 589 */
obj_t BgL_arg1648z00_459;
BgL_arg1648z00_459 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)13)), BGl_mpdzd2playzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 589 */
obj_t BgL_list1649z00_460;
BgL_list1649z00_460 = 
MAKE_YOUNG_PAIR(BgL_arg1648z00_459, BNIL); 
BgL_arg1644z00_458 = BgL_list1649z00_460; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1644z00_458); } 
{ /* Llib/mpd.scm 598 */
obj_t BgL_arg1652z00_461;
{ /* Llib/mpd.scm 598 */
obj_t BgL_arg1657z00_462;
BgL_arg1657z00_462 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)14)), BGl_mpdzd2playidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 598 */
obj_t BgL_list1658z00_463;
BgL_list1658z00_463 = 
MAKE_YOUNG_PAIR(BgL_arg1657z00_462, BNIL); 
BgL_arg1652z00_461 = BgL_list1658z00_463; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1652z00_461); } 
{ /* Llib/mpd.scm 607 */
obj_t BgL_arg1663z00_464;
{ /* Llib/mpd.scm 607 */
obj_t BgL_arg1664z00_465;
BgL_arg1664z00_465 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)15)), BGl_mpdzd2seekzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 607 */
obj_t BgL_list1665z00_466;
BgL_list1665z00_466 = 
MAKE_YOUNG_PAIR(BgL_arg1664z00_465, BNIL); 
BgL_arg1663z00_464 = BgL_list1665z00_466; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1663z00_464); } 
{ /* Llib/mpd.scm 614 */
obj_t BgL_arg1666z00_467;
{ /* Llib/mpd.scm 614 */
obj_t BgL_arg1667z00_468;
BgL_arg1667z00_468 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)16)), BGl_mpdzd2seekidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 614 */
obj_t BgL_list1668z00_469;
BgL_list1668z00_469 = 
MAKE_YOUNG_PAIR(BgL_arg1667z00_468, BNIL); 
BgL_arg1666z00_467 = BgL_list1668z00_469; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1666z00_467); } 
{ /* Llib/mpd.scm 621 */
obj_t BgL_arg1669z00_470;
{ /* Llib/mpd.scm 621 */
obj_t BgL_arg1670z00_471;
BgL_arg1670z00_471 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)17)), BGl_mpdzd2stopzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 621 */
obj_t BgL_list1671z00_472;
BgL_list1671z00_472 = 
MAKE_YOUNG_PAIR(BgL_arg1670z00_471, BNIL); 
BgL_arg1669z00_470 = BgL_list1671z00_472; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1669z00_470); } 
{ /* Llib/mpd.scm 628 */
obj_t BgL_arg1672z00_473;
{ /* Llib/mpd.scm 628 */
obj_t BgL_arg1675z00_474;
BgL_arg1675z00_474 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)18)), BGl_mpdzd2pausezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 628 */
obj_t BgL_list1676z00_475;
BgL_list1676z00_475 = 
MAKE_YOUNG_PAIR(BgL_arg1675z00_474, BNIL); 
BgL_arg1672z00_473 = BgL_list1676z00_475; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1672z00_473); } 
{ /* Llib/mpd.scm 635 */
obj_t BgL_arg1677z00_476;
{ /* Llib/mpd.scm 635 */
obj_t BgL_arg1678z00_477;
BgL_arg1678z00_477 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)19)), BGl_mpdzd2nextzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 635 */
obj_t BgL_list1679z00_478;
BgL_list1679z00_478 = 
MAKE_YOUNG_PAIR(BgL_arg1678z00_477, BNIL); 
BgL_arg1677z00_476 = BgL_list1679z00_478; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1677z00_476); } 
{ /* Llib/mpd.scm 648 */
obj_t BgL_arg1680z00_479;
{ /* Llib/mpd.scm 648 */
obj_t BgL_arg1681z00_480;
BgL_arg1681z00_480 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)20)), BGl_mpdzd2previouszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 648 */
obj_t BgL_list1682z00_481;
BgL_list1682z00_481 = 
MAKE_YOUNG_PAIR(BgL_arg1681z00_480, BNIL); 
BgL_arg1680z00_479 = BgL_list1682z00_481; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1680z00_479); } 
{ /* Llib/mpd.scm 661 */
obj_t BgL_arg1683z00_482;
{ /* Llib/mpd.scm 661 */
obj_t BgL_arg1689z00_483;
BgL_arg1689z00_483 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)21)), BGl_mpdzd2volumezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 661 */
obj_t BgL_list1690z00_484;
BgL_list1690z00_484 = 
MAKE_YOUNG_PAIR(BgL_arg1689z00_483, BNIL); 
BgL_arg1683z00_482 = BgL_list1690z00_484; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1683z00_482); } 
{ /* Llib/mpd.scm 684 */
obj_t BgL_arg1691z00_485;
{ /* Llib/mpd.scm 684 */
obj_t BgL_arg1692z00_486;
BgL_arg1692z00_486 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)22)), BGl_mpdzd2setvolzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 684 */
obj_t BgL_list1693z00_487;
BgL_list1693z00_487 = 
MAKE_YOUNG_PAIR(BgL_arg1692z00_486, BNIL); 
BgL_arg1691z00_485 = BgL_list1693z00_487; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1691z00_485); } 
{ /* Llib/mpd.scm 690 */
obj_t BgL_arg1694z00_488;
{ /* Llib/mpd.scm 690 */
obj_t BgL_arg1696z00_489;
BgL_arg1696z00_489 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)23)), BGl_mpdzd2clearerrorzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 690 */
obj_t BgL_list1697z00_490;
BgL_list1697z00_490 = 
MAKE_YOUNG_PAIR(BgL_arg1696z00_489, BNIL); 
BgL_arg1694z00_488 = BgL_list1697z00_490; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1694z00_488); } 
{ /* Llib/mpd.scm 696 */
obj_t BgL_arg1698z00_491;
{ /* Llib/mpd.scm 696 */
obj_t BgL_arg1704z00_492;
BgL_arg1704z00_492 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)24)), BGl_mpdzd2closezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 696 */
obj_t BgL_list1705z00_493;
BgL_list1705z00_493 = 
MAKE_YOUNG_PAIR(BgL_arg1704z00_492, BNIL); 
BgL_arg1698z00_491 = BgL_list1705z00_493; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1698z00_491); } 
{ /* Llib/mpd.scm 702 */
obj_t BgL_arg1708z00_494;
{ /* Llib/mpd.scm 702 */
obj_t BgL_arg1712z00_495;
BgL_arg1712z00_495 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)25)), BGl_mpdzd2statszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 702 */
obj_t BgL_list1713z00_496;
BgL_list1713z00_496 = 
MAKE_YOUNG_PAIR(BgL_arg1712z00_495, BNIL); 
BgL_arg1708z00_494 = BgL_list1713z00_496; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1708z00_494); } 
{ /* Llib/mpd.scm 709 */
obj_t BgL_arg1715z00_497;
{ /* Llib/mpd.scm 709 */
obj_t BgL_arg1716z00_498;
BgL_arg1716z00_498 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)26)), BGl_mpdzd2listallzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 709 */
obj_t BgL_list1717z00_499;
BgL_list1717z00_499 = 
MAKE_YOUNG_PAIR(BgL_arg1716z00_498, BNIL); 
BgL_arg1715z00_497 = BgL_list1717z00_499; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1715z00_497); } 
{ /* Llib/mpd.scm 716 */
obj_t BgL_arg1719z00_500;
{ /* Llib/mpd.scm 716 */
obj_t BgL_arg1725z00_501;
BgL_arg1725z00_501 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)27)), BGl_mpdzd2listzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 716 */
obj_t BgL_list1726z00_502;
BgL_list1726z00_502 = 
MAKE_YOUNG_PAIR(BgL_arg1725z00_501, BNIL); 
BgL_arg1719z00_500 = BgL_list1726z00_502; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1719z00_500); } 
{ /* Llib/mpd.scm 745 */
obj_t BgL_arg1737z00_503;
{ /* Llib/mpd.scm 745 */
obj_t BgL_arg1738z00_504;
BgL_arg1738z00_504 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)28)), BGl_mpdzd2listallinfozd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 745 */
obj_t BgL_list1739z00_505;
BgL_list1739z00_505 = 
MAKE_YOUNG_PAIR(BgL_arg1738z00_504, BNIL); 
BgL_arg1737z00_503 = BgL_list1739z00_505; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1737z00_503); } 
{ /* Llib/mpd.scm 752 */
obj_t BgL_arg1740z00_506;
{ /* Llib/mpd.scm 752 */
obj_t BgL_arg1747z00_507;
BgL_arg1747z00_507 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)29)), BGl_mpdzd2lsinfozd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 752 */
obj_t BgL_list1748z00_508;
BgL_list1748z00_508 = 
MAKE_YOUNG_PAIR(BgL_arg1747z00_507, BNIL); 
BgL_arg1740z00_506 = BgL_list1748z00_508; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1740z00_506); } 
{ /* Llib/mpd.scm 759 */
obj_t BgL_arg1749z00_509;
{ /* Llib/mpd.scm 759 */
obj_t BgL_arg1750z00_510;
BgL_arg1750z00_510 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)30)), BGl_mpdzd2plconangesposidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 759 */
obj_t BgL_list1751z00_511;
BgL_list1751z00_511 = 
MAKE_YOUNG_PAIR(BgL_arg1750z00_510, BNIL); 
BgL_arg1749z00_509 = BgL_list1751z00_511; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1749z00_509); } 
{ /* Llib/mpd.scm 771 */
obj_t BgL_arg1752z00_512;
{ /* Llib/mpd.scm 771 */
obj_t BgL_arg1753z00_513;
BgL_arg1753z00_513 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)31)), BGl_mpdzd2killzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 771 */
obj_t BgL_list1754z00_514;
BgL_list1754z00_514 = 
MAKE_YOUNG_PAIR(BgL_arg1753z00_513, BNIL); 
BgL_arg1752z00_512 = BgL_list1754z00_514; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1752z00_512); } 
{ /* Llib/mpd.scm 777 */
obj_t BgL_arg1755z00_515;
{ /* Llib/mpd.scm 777 */
obj_t BgL_arg1756z00_516;
BgL_arg1756z00_516 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)32)), BGl_mpdzd2findzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 777 */
obj_t BgL_list1757z00_517;
BgL_list1757z00_517 = 
MAKE_YOUNG_PAIR(BgL_arg1756z00_516, BNIL); 
BgL_arg1755z00_515 = BgL_list1757z00_517; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1755z00_515); } 
{ /* Llib/mpd.scm 797 */
obj_t BgL_arg1758z00_518;
{ /* Llib/mpd.scm 797 */
obj_t BgL_arg1759z00_519;
BgL_arg1759z00_519 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)33)), BGl_mpdzd2searchzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 797 */
obj_t BgL_list1760z00_520;
BgL_list1760z00_520 = 
MAKE_YOUNG_PAIR(BgL_arg1759z00_519, BNIL); 
BgL_arg1758z00_518 = BgL_list1760z00_520; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1758z00_518); } 
{ /* Llib/mpd.scm 825 */
obj_t BgL_arg1761z00_521;
{ /* Llib/mpd.scm 825 */
obj_t BgL_arg1762z00_522;
BgL_arg1762z00_522 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)34)), BGl_mpdzd2commandszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 825 */
obj_t BgL_list1763z00_523;
BgL_list1763z00_523 = 
MAKE_YOUNG_PAIR(BgL_arg1762z00_522, BNIL); 
BgL_arg1761z00_521 = BgL_list1763z00_523; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1761z00_521); } 
{ /* Llib/mpd.scm 839 */
obj_t BgL_arg1764z00_524;
{ /* Llib/mpd.scm 839 */
obj_t BgL_arg1765z00_525;
BgL_arg1765z00_525 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)35)), BGl_mpdzd2notcommandszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 839 */
obj_t BgL_list1766z00_526;
BgL_list1766z00_526 = 
MAKE_YOUNG_PAIR(BgL_arg1765z00_525, BNIL); 
BgL_arg1764z00_524 = BgL_list1766z00_526; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1764z00_524); } 
{ /* Llib/mpd.scm 853 */
obj_t BgL_arg1767z00_527;
{ /* Llib/mpd.scm 853 */
obj_t BgL_arg1768z00_528;
BgL_arg1768z00_528 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)36)), BGl_mpdzd2addidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 853 */
obj_t BgL_list1769z00_529;
BgL_list1769z00_529 = 
MAKE_YOUNG_PAIR(BgL_arg1768z00_528, BNIL); 
BgL_arg1767z00_527 = BgL_list1769z00_529; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1767z00_527); } 
{ /* Llib/mpd.scm 858 */
obj_t BgL_arg1770z00_530;
{ /* Llib/mpd.scm 858 */
obj_t BgL_arg1771z00_531;
BgL_arg1771z00_531 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)37)), BGl_mpdzd2crossfadezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 858 */
obj_t BgL_list1772z00_532;
BgL_list1772z00_532 = 
MAKE_YOUNG_PAIR(BgL_arg1771z00_531, BNIL); 
BgL_arg1770z00_530 = BgL_list1772z00_532; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1770z00_530); } 
{ /* Llib/mpd.scm 863 */
obj_t BgL_arg1773z00_533;
{ /* Llib/mpd.scm 863 */
obj_t BgL_arg1774z00_534;
BgL_arg1774z00_534 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)38)), BGl_mpdzd2movezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 863 */
obj_t BgL_list1775z00_535;
BgL_list1775z00_535 = 
MAKE_YOUNG_PAIR(BgL_arg1774z00_534, BNIL); 
BgL_arg1773z00_533 = BgL_list1775z00_535; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1773z00_533); } 
{ /* Llib/mpd.scm 868 */
obj_t BgL_arg1776z00_536;
{ /* Llib/mpd.scm 868 */
obj_t BgL_arg1777z00_537;
BgL_arg1777z00_537 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)39)), BGl_mpdzd2moveidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 868 */
obj_t BgL_list1778z00_538;
BgL_list1778z00_538 = 
MAKE_YOUNG_PAIR(BgL_arg1777z00_537, BNIL); 
BgL_arg1776z00_536 = BgL_list1778z00_538; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1776z00_536); } 
{ /* Llib/mpd.scm 873 */
obj_t BgL_arg1779z00_539;
{ /* Llib/mpd.scm 873 */
obj_t BgL_arg1780z00_540;
BgL_arg1780z00_540 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)40)), BGl_mpdzd2passwordzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 873 */
obj_t BgL_list1781z00_541;
BgL_list1781z00_541 = 
MAKE_YOUNG_PAIR(BgL_arg1780z00_540, BNIL); 
BgL_arg1779z00_539 = BgL_list1781z00_541; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1779z00_539); } 
{ /* Llib/mpd.scm 878 */
obj_t BgL_arg1782z00_542;
{ /* Llib/mpd.scm 878 */
obj_t BgL_arg1783z00_543;
BgL_arg1783z00_543 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)41)), BGl_mpdzd2randomzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 878 */
obj_t BgL_list1784z00_544;
BgL_list1784z00_544 = 
MAKE_YOUNG_PAIR(BgL_arg1783z00_543, BNIL); 
BgL_arg1782z00_542 = BgL_list1784z00_544; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1782z00_542); } 
{ /* Llib/mpd.scm 883 */
obj_t BgL_arg1785z00_545;
{ /* Llib/mpd.scm 883 */
obj_t BgL_arg1786z00_546;
BgL_arg1786z00_546 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)42)), BGl_mpdzd2repeatzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 883 */
obj_t BgL_list1787z00_547;
BgL_list1787z00_547 = 
MAKE_YOUNG_PAIR(BgL_arg1786z00_546, BNIL); 
BgL_arg1785z00_545 = BgL_list1787z00_547; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1785z00_545); } 
{ /* Llib/mpd.scm 888 */
obj_t BgL_arg1788z00_548;
{ /* Llib/mpd.scm 888 */
obj_t BgL_arg1789z00_549;
BgL_arg1789z00_549 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)43)), BGl_mpdzd2rmzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 888 */
obj_t BgL_list1790z00_550;
BgL_list1790z00_550 = 
MAKE_YOUNG_PAIR(BgL_arg1789z00_549, BNIL); 
BgL_arg1788z00_548 = BgL_list1790z00_550; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1788z00_548); } 
{ /* Llib/mpd.scm 893 */
obj_t BgL_arg1791z00_551;
{ /* Llib/mpd.scm 893 */
obj_t BgL_arg1792z00_552;
BgL_arg1792z00_552 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)44)), BGl_mpdzd2savezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 893 */
obj_t BgL_list1793z00_553;
BgL_list1793z00_553 = 
MAKE_YOUNG_PAIR(BgL_arg1792z00_552, BNIL); 
BgL_arg1791z00_551 = BgL_list1793z00_553; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1791z00_551); } 
{ /* Llib/mpd.scm 898 */
obj_t BgL_arg1794z00_554;
{ /* Llib/mpd.scm 898 */
obj_t BgL_arg1795z00_555;
BgL_arg1795z00_555 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)45)), BGl_mpdzd2shufflezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 898 */
obj_t BgL_list1796z00_556;
BgL_list1796z00_556 = 
MAKE_YOUNG_PAIR(BgL_arg1795z00_555, BNIL); 
BgL_arg1794z00_554 = BgL_list1796z00_556; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1794z00_554); } 
{ /* Llib/mpd.scm 903 */
obj_t BgL_arg1797z00_557;
{ /* Llib/mpd.scm 903 */
obj_t BgL_arg1798z00_558;
BgL_arg1798z00_558 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)46)), BGl_mpdzd2swapzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 903 */
obj_t BgL_list1799z00_559;
BgL_list1799z00_559 = 
MAKE_YOUNG_PAIR(BgL_arg1798z00_558, BNIL); 
BgL_arg1797z00_557 = BgL_list1799z00_559; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1797z00_557); } 
{ /* Llib/mpd.scm 908 */
obj_t BgL_arg1800z00_560;
{ /* Llib/mpd.scm 908 */
obj_t BgL_arg1801z00_561;
BgL_arg1801z00_561 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)47)), BGl_mpdzd2swapidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 908 */
obj_t BgL_list1802z00_562;
BgL_list1802z00_562 = 
MAKE_YOUNG_PAIR(BgL_arg1801z00_561, BNIL); 
BgL_arg1800z00_560 = BgL_list1802z00_562; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1800z00_560); } 
{ /* Llib/mpd.scm 913 */
obj_t BgL_arg1803z00_563;
{ /* Llib/mpd.scm 913 */
obj_t BgL_arg1804z00_564;
BgL_arg1804z00_564 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)48)), BGl_mpdzd2updatezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 913 */
obj_t BgL_list1805z00_565;
BgL_list1805z00_565 = 
MAKE_YOUNG_PAIR(BgL_arg1804z00_564, BNIL); 
BgL_arg1803z00_563 = BgL_list1805z00_565; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1803z00_563); } 
{ /* Llib/mpd.scm 918 */
obj_t BgL_arg1806z00_566;
{ /* Llib/mpd.scm 918 */
obj_t BgL_arg1807z00_567;
BgL_arg1807z00_567 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)49)), BGl_mpdzd2outputszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 918 */
obj_t BgL_list1808z00_568;
BgL_list1808z00_568 = 
MAKE_YOUNG_PAIR(BgL_arg1807z00_567, BNIL); 
BgL_arg1806z00_566 = BgL_list1808z00_568; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1806z00_566); } 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* get-line-command */
obj_t BGl_getzd2linezd2commandz00zz__multimediazd2mpdzd2(obj_t BgL_linez00_6)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 161 */
{ /* Llib/mpd.scm 162 */
obj_t BgL_iz00_579;
BgL_iz00_579 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_6, 
BCHAR(((unsigned char)' ')), 
BINT(((long)0))); 
if(
CBOOL(BgL_iz00_579))
{ /* Llib/mpd.scm 164 */
obj_t BgL_arg1812z00_580;
{ /* Llib/mpd.scm 164 */
obj_t BgL_res2706z00_2458;
{ /* Llib/mpd.scm 164 */
long BgL_endz00_2457;
BgL_endz00_2457 = 
(long)CINT(BgL_iz00_579); 
BgL_res2706z00_2458 = 
c_substring(
((obj_t)BgL_linez00_6), ((long)0), BgL_endz00_2457); } 
BgL_arg1812z00_580 = BgL_res2706z00_2458; } 
return 
bstring_to_symbol(BgL_arg1812z00_580);}  else 
{ /* Llib/mpd.scm 165 */
obj_t BgL_res2708z00_2462;
BgL_res2708z00_2462 = 
bstring_to_symbol(
((obj_t)BgL_linez00_6)); 
return BgL_res2708z00_2462;} } } 
BGL_FUNCTION_END;
}



/* get-line-arg-string-nth */
obj_t BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(obj_t BgL_linez00_7, long BgL_numz00_8)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 170 */
{ 
obj_t BgL_iz00_594;long BgL_lenz00_595;
{ /* Llib/mpd.scm 182 */
obj_t BgL_i0z00_582;long BgL_lenz00_583;
{ /* Llib/mpd.scm 155 */
obj_t BgL_jz00_2494;
BgL_jz00_2494 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_7, 
BCHAR(((unsigned char)' ')), 
BINT(((long)0))); 
if(
CBOOL(BgL_jz00_2494))
{ /* Llib/mpd.scm 156 */
obj_t BgL__ortest_1078z00_2495;
BgL__ortest_1078z00_2495 = 
BGl_stringzd2skipzd2zz__r4_strings_6_7z00(BgL_linez00_7, 
BCHAR(((unsigned char)' ')), BgL_jz00_2494); 
if(
CBOOL(BgL__ortest_1078z00_2495))
{ /* Llib/mpd.scm 156 */
BgL_i0z00_582 = BgL__ortest_1078z00_2495; }  else 
{ /* Llib/mpd.scm 156 */
BgL_i0z00_582 = BgL_jz00_2494; } }  else 
{ /* Llib/mpd.scm 156 */
BgL_i0z00_582 = BFALSE; } } 
BgL_lenz00_583 = 
STRING_LENGTH(
((obj_t)BgL_linez00_7)); 
if(
CBOOL(BgL_i0z00_582))
{ /* Llib/mpd.scm 185 */
long BgL_g1084z00_584;
BgL_g1084z00_584 = 
(BgL_numz00_8-((long)1)); 
{ 
long BgL_nz00_586;obj_t BgL_iz00_587;
BgL_nz00_586 = BgL_g1084z00_584; 
BgL_iz00_587 = BgL_i0z00_582; 
BgL_zc3anonymousza31813ze3z83_588:
if(
CBOOL(BgL_iz00_587))
{ /* Llib/mpd.scm 188 */
if(
(BgL_nz00_586==((long)0)))
{ /* Llib/mpd.scm 190 */
if(
CBOOL(BgL_iz00_587))
{ /* Llib/mpd.scm 191 */
BgL_iz00_594 = BgL_iz00_587; 
BgL_lenz00_595 = BgL_lenz00_583; 
if(
(
(long)CINT(BgL_iz00_594)<BgL_lenz00_595))
{ /* Llib/mpd.scm 172 */
if(
(((unsigned char)'"')==
STRING_REF(
((obj_t)BgL_linez00_7), 
(long)CINT(BgL_iz00_594))))
{ /* Llib/mpd.scm 174 */
obj_t BgL_jz00_600;
{ /* Llib/mpd.scm 174 */
long BgL_arg1824z00_603;
BgL_arg1824z00_603 = 
(
(long)CINT(BgL_iz00_594)+((long)1)); 
BgL_jz00_600 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_7, 
BCHAR(((unsigned char)'"')), 
BINT(BgL_arg1824z00_603)); } 
if(
CBOOL(BgL_jz00_600))
{ /* Llib/mpd.scm 176 */
long BgL_arg1822z00_601;
BgL_arg1822z00_601 = 
(
(long)CINT(BgL_iz00_594)+((long)1)); 
{ /* Llib/mpd.scm 176 */
obj_t BgL_res2714z00_2479;
{ /* Llib/mpd.scm 176 */
long BgL_endz00_2478;
BgL_endz00_2478 = 
(long)CINT(BgL_jz00_600); 
BgL_res2714z00_2479 = 
c_substring(
((obj_t)BgL_linez00_7), BgL_arg1822z00_601, BgL_endz00_2478); } 
return BgL_res2714z00_2479;} }  else 
{ /* Llib/mpd.scm 177 */
long BgL_arg1823z00_602;
BgL_arg1823z00_602 = 
(
(long)CINT(BgL_iz00_594)+((long)1)); 
{ /* Llib/mpd.scm 177 */
obj_t BgL_res2716z00_2485;
BgL_res2716z00_2485 = 
c_substring(
((obj_t)BgL_linez00_7), BgL_arg1823z00_602, BgL_lenz00_595); 
return BgL_res2716z00_2485;} } }  else 
{ /* Llib/mpd.scm 178 */
obj_t BgL_jz00_604;
BgL_jz00_604 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_7, 
BCHAR(((unsigned char)' ')), BgL_iz00_594); 
if(
CBOOL(BgL_jz00_604))
{ /* Llib/mpd.scm 180 */
obj_t BgL_res2717z00_2489;
{ /* Llib/mpd.scm 180 */
long BgL_startz00_2487;long BgL_endz00_2488;
BgL_startz00_2487 = 
(long)CINT(BgL_iz00_594); 
BgL_endz00_2488 = 
(long)CINT(BgL_jz00_604); 
BgL_res2717z00_2489 = 
c_substring(
((obj_t)BgL_linez00_7), BgL_startz00_2487, BgL_endz00_2488); } 
return BgL_res2717z00_2489;}  else 
{ /* Llib/mpd.scm 181 */
obj_t BgL_res2718z00_2493;
{ /* Llib/mpd.scm 181 */
long BgL_startz00_2491;
BgL_startz00_2491 = 
(long)CINT(BgL_iz00_594); 
BgL_res2718z00_2493 = 
c_substring(
((obj_t)BgL_linez00_7), BgL_startz00_2491, BgL_lenz00_595); } 
return BgL_res2718z00_2493;} } }  else 
{ /* Llib/mpd.scm 172 */
return BFALSE;} }  else 
{ /* Llib/mpd.scm 191 */
return BFALSE;} }  else 
{ /* Llib/mpd.scm 190 */
if(
(
(long)CINT(BgL_iz00_587)<BgL_lenz00_583))
{ /* Llib/mpd.scm 193 */
long BgL_arg1816z00_591;obj_t BgL_arg1817z00_592;
BgL_arg1816z00_591 = 
(BgL_nz00_586-((long)1)); 
{ /* Llib/mpd.scm 155 */
obj_t BgL_jz00_2507;
BgL_jz00_2507 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_7, 
BCHAR(((unsigned char)' ')), BgL_iz00_587); 
if(
CBOOL(BgL_jz00_2507))
{ /* Llib/mpd.scm 156 */
obj_t BgL__ortest_1078z00_2508;
BgL__ortest_1078z00_2508 = 
BGl_stringzd2skipzd2zz__r4_strings_6_7z00(BgL_linez00_7, 
BCHAR(((unsigned char)' ')), BgL_jz00_2507); 
if(
CBOOL(BgL__ortest_1078z00_2508))
{ /* Llib/mpd.scm 156 */
BgL_arg1817z00_592 = BgL__ortest_1078z00_2508; }  else 
{ /* Llib/mpd.scm 156 */
BgL_arg1817z00_592 = BgL_jz00_2507; } }  else 
{ /* Llib/mpd.scm 156 */
BgL_arg1817z00_592 = BFALSE; } } 
{ 
obj_t BgL_iz00_6368;long BgL_nz00_6367;
BgL_nz00_6367 = BgL_arg1816z00_591; 
BgL_iz00_6368 = BgL_arg1817z00_592; 
BgL_iz00_587 = BgL_iz00_6368; 
BgL_nz00_586 = BgL_nz00_6367; 
goto BgL_zc3anonymousza31813ze3z83_588;} }  else 
{ /* Llib/mpd.scm 192 */
return BFALSE;} } }  else 
{ /* Llib/mpd.scm 188 */
return BFALSE;} } }  else 
{ /* Llib/mpd.scm 184 */
return BFALSE;} } } } 
BGL_FUNCTION_END;
}



/* get-line-arg-symbol-nth */
obj_t BGl_getzd2linezd2argzd2symbolzd2nthz00zz__multimediazd2mpdzd2(obj_t BgL_linez00_9, long BgL_numz00_10)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 198 */
{ 
obj_t BgL_iz00_620;long BgL_lenz00_621;
{ /* Llib/mpd.scm 205 */
obj_t BgL_i0z00_608;long BgL_lenz00_609;
{ /* Llib/mpd.scm 155 */
obj_t BgL_jz00_2524;
BgL_jz00_2524 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_9, 
BCHAR(((unsigned char)' ')), 
BINT(((long)0))); 
if(
CBOOL(BgL_jz00_2524))
{ /* Llib/mpd.scm 156 */
obj_t BgL__ortest_1078z00_2525;
BgL__ortest_1078z00_2525 = 
BGl_stringzd2skipzd2zz__r4_strings_6_7z00(BgL_linez00_9, 
BCHAR(((unsigned char)' ')), BgL_jz00_2524); 
if(
CBOOL(BgL__ortest_1078z00_2525))
{ /* Llib/mpd.scm 156 */
BgL_i0z00_608 = BgL__ortest_1078z00_2525; }  else 
{ /* Llib/mpd.scm 156 */
BgL_i0z00_608 = BgL_jz00_2524; } }  else 
{ /* Llib/mpd.scm 156 */
BgL_i0z00_608 = BFALSE; } } 
BgL_lenz00_609 = 
STRING_LENGTH(
((obj_t)BgL_linez00_9)); 
if(
CBOOL(BgL_i0z00_608))
{ /* Llib/mpd.scm 208 */
long BgL_g1085z00_610;
BgL_g1085z00_610 = 
(BgL_numz00_10-((long)1)); 
{ 
long BgL_nz00_612;obj_t BgL_iz00_613;
BgL_nz00_612 = BgL_g1085z00_610; 
BgL_iz00_613 = BgL_i0z00_608; 
BgL_zc3anonymousza31826ze3z83_614:
if(
CBOOL(BgL_iz00_613))
{ /* Llib/mpd.scm 211 */
if(
(BgL_nz00_612==((long)0)))
{ /* Llib/mpd.scm 213 */
BgL_iz00_620 = BgL_iz00_613; 
BgL_lenz00_621 = BgL_lenz00_609; 
if(
(
(long)CINT(BgL_iz00_620)<BgL_lenz00_621))
{ /* Llib/mpd.scm 201 */
obj_t BgL_jz00_624;
BgL_jz00_624 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_9, 
BCHAR(((unsigned char)' ')), BgL_iz00_620); 
if(
CBOOL(BgL_jz00_624))
{ /* Llib/mpd.scm 203 */
obj_t BgL_arg1833z00_625;
{ /* Llib/mpd.scm 203 */
obj_t BgL_arg1834z00_626;
{ /* Llib/mpd.scm 203 */
obj_t BgL_res2725z00_2515;
{ /* Llib/mpd.scm 203 */
long BgL_startz00_2513;long BgL_endz00_2514;
BgL_startz00_2513 = 
(long)CINT(BgL_iz00_620); 
BgL_endz00_2514 = 
(long)CINT(BgL_jz00_624); 
BgL_res2725z00_2515 = 
c_substring(
((obj_t)BgL_linez00_9), BgL_startz00_2513, BgL_endz00_2514); } 
BgL_arg1834z00_626 = BgL_res2725z00_2515; } 
BgL_arg1833z00_625 = 
BGl_stringzd2downcasez12zc0zz__r4_strings_6_7z00(BgL_arg1834z00_626); } 
return 
bstring_to_symbol(BgL_arg1833z00_625);}  else 
{ /* Llib/mpd.scm 204 */
obj_t BgL_arg1835z00_627;
{ /* Llib/mpd.scm 204 */
obj_t BgL_arg1836z00_628;
{ /* Llib/mpd.scm 204 */
obj_t BgL_res2727z00_2521;
{ /* Llib/mpd.scm 204 */
long BgL_startz00_2519;
BgL_startz00_2519 = 
(long)CINT(BgL_iz00_620); 
BgL_res2727z00_2521 = 
c_substring(
((obj_t)BgL_linez00_9), BgL_startz00_2519, BgL_lenz00_621); } 
BgL_arg1836z00_628 = BgL_res2727z00_2521; } 
BgL_arg1835z00_627 = 
BGl_stringzd2downcasez12zc0zz__r4_strings_6_7z00(BgL_arg1836z00_628); } 
return 
bstring_to_symbol(BgL_arg1835z00_627);} }  else 
{ /* Llib/mpd.scm 200 */
return BFALSE;} }  else 
{ /* Llib/mpd.scm 213 */
if(
(
(long)CINT(BgL_iz00_613)<BgL_lenz00_609))
{ /* Llib/mpd.scm 216 */
long BgL_arg1829z00_617;obj_t BgL_arg1830z00_618;
BgL_arg1829z00_617 = 
(BgL_nz00_612-((long)1)); 
{ /* Llib/mpd.scm 155 */
obj_t BgL_jz00_2537;
BgL_jz00_2537 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_9, 
BCHAR(((unsigned char)' ')), BgL_iz00_613); 
if(
CBOOL(BgL_jz00_2537))
{ /* Llib/mpd.scm 156 */
obj_t BgL__ortest_1078z00_2538;
BgL__ortest_1078z00_2538 = 
BGl_stringzd2skipzd2zz__r4_strings_6_7z00(BgL_linez00_9, 
BCHAR(((unsigned char)' ')), BgL_jz00_2537); 
if(
CBOOL(BgL__ortest_1078z00_2538))
{ /* Llib/mpd.scm 156 */
BgL_arg1830z00_618 = BgL__ortest_1078z00_2538; }  else 
{ /* Llib/mpd.scm 156 */
BgL_arg1830z00_618 = BgL_jz00_2537; } }  else 
{ /* Llib/mpd.scm 156 */
BgL_arg1830z00_618 = BFALSE; } } 
{ 
obj_t BgL_iz00_6418;long BgL_nz00_6417;
BgL_nz00_6417 = BgL_arg1829z00_617; 
BgL_iz00_6418 = BgL_arg1830z00_618; 
BgL_iz00_613 = BgL_iz00_6418; 
BgL_nz00_612 = BgL_nz00_6417; 
goto BgL_zc3anonymousza31826ze3z83_614;} }  else 
{ /* Llib/mpd.scm 215 */
return BFALSE;} } }  else 
{ /* Llib/mpd.scm 211 */
return BFALSE;} } }  else 
{ /* Llib/mpd.scm 207 */
return BFALSE;} } } } 
BGL_FUNCTION_END;
}



/* _mpd */
obj_t BGl__mpdz00zz__multimediazd2mpdzd2(obj_t BgL_envz00_19, obj_t BgL_opt1320z00_18)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 230 */
{ 
obj_t BgL_k1z00_633;long BgL_iz00_634;
{ /* Llib/mpd.scm 230 */
obj_t BgL_g1326z00_636;obj_t BgL_g1327z00_637;obj_t BgL_g1328z00_638;obj_t BgL_g1329z00_639;
BgL_g1326z00_636 = 
VECTOR_REF(BgL_opt1320z00_18,((long)0)); 
BgL_g1327z00_637 = 
VECTOR_REF(BgL_opt1320z00_18,((long)1)); 
BgL_g1328z00_638 = 
VECTOR_REF(BgL_opt1320z00_18,((long)2)); 
BgL_g1329z00_639 = 
VECTOR_REF(BgL_opt1320z00_18,((long)3)); 
{ /* Llib/mpd.scm 230 */
obj_t BgL_logz00_640;
BgL_logz00_640 = BFALSE; 
{ /* Llib/mpd.scm 230 */

{ 
long BgL_iz00_641;
BgL_iz00_641 = ((long)4); 
BgL_check1323z00_642:
if(
(BgL_iz00_641==
VECTOR_LENGTH(BgL_opt1320z00_18)))
{ /* Llib/mpd.scm 230 */BNIL; }  else 
{ /* Llib/mpd.scm 230 */
bool_t BgL_testz00_6426;
{ /* Llib/mpd.scm 230 */
obj_t BgL_arg1843z00_648;
BgL_arg1843z00_648 = 
VECTOR_REF(BgL_opt1320z00_18,BgL_iz00_641); 
BgL_testz00_6426 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1843z00_648, 
CNST_TABLE_REF(((long)51)))); } 
if(BgL_testz00_6426)
{ 
long BgL_iz00_6431;
BgL_iz00_6431 = 
(BgL_iz00_641+((long)2)); 
BgL_iz00_641 = BgL_iz00_6431; 
goto BgL_check1323z00_642;}  else 
{ /* Llib/mpd.scm 230 */
obj_t BgL_arg1842z00_647;
BgL_arg1842z00_647 = 
VECTOR_REF(BgL_opt1320z00_18,BgL_iz00_641); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)50)), BGl_string3339z00zz__multimediazd2mpdzd2, BgL_arg1842z00_647); } } } 
{ /* Llib/mpd.scm 230 */
obj_t BgL_index1325z00_649;
BgL_k1z00_633 = 
CNST_TABLE_REF(((long)52)); 
BgL_iz00_634 = ((long)4); 
BgL_search1322z00_635:
if(
(BgL_iz00_634==
VECTOR_LENGTH(BgL_opt1320z00_18)))
{ /* Llib/mpd.scm 230 */
BgL_index1325z00_649 = 
BINT(((long)-1)); }  else 
{ /* Llib/mpd.scm 230 */
if(
(BgL_iz00_634==
(
VECTOR_LENGTH(BgL_opt1320z00_18)-((long)1))))
{ /* Llib/mpd.scm 230 */
BgL_index1325z00_649 = 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)50)), BGl_string3338z00zz__multimediazd2mpdzd2, 
BINT(
VECTOR_LENGTH(BgL_opt1320z00_18))); }  else 
{ /* Llib/mpd.scm 230 */
obj_t BgL_vz00_660;
BgL_vz00_660 = 
VECTOR_REF(BgL_opt1320z00_18,BgL_iz00_634); 
if(
(BgL_vz00_660==BgL_k1z00_633))
{ /* Llib/mpd.scm 230 */
BgL_index1325z00_649 = 
BINT(
(BgL_iz00_634+((long)1))); }  else 
{ 
long BgL_iz00_6453;
BgL_iz00_6453 = 
(BgL_iz00_634+((long)2)); 
BgL_iz00_634 = BgL_iz00_6453; 
goto BgL_search1322z00_635;} } } 
{ /* Llib/mpd.scm 230 */
bool_t BgL_testz00_6456;
{ /* Llib/mpd.scm 230 */
long BgL_n1z00_2564;
{ /* Llib/mpd.scm 230 */
obj_t BgL_tmpz00_6457;
if(
INTEGERP(BgL_index1325z00_649))
{ /* Llib/mpd.scm 230 */
BgL_tmpz00_6457 = BgL_index1325z00_649
; }  else 
{ 
obj_t BgL_auxz00_6460;
BgL_auxz00_6460 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)9602)), BGl_string3341z00zz__multimediazd2mpdzd2, BGl_string3342z00zz__multimediazd2mpdzd2, BgL_index1325z00_649); 
FAILURE(BgL_auxz00_6460,BFALSE,BFALSE);} 
BgL_n1z00_2564 = 
(long)CINT(BgL_tmpz00_6457); } 
BgL_testz00_6456 = 
(BgL_n1z00_2564>=((long)0)); } 
if(BgL_testz00_6456)
{ 
long BgL_auxz00_6466;
{ /* Llib/mpd.scm 230 */
obj_t BgL_tmpz00_6467;
if(
INTEGERP(BgL_index1325z00_649))
{ /* Llib/mpd.scm 230 */
BgL_tmpz00_6467 = BgL_index1325z00_649
; }  else 
{ 
obj_t BgL_auxz00_6470;
BgL_auxz00_6470 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)9602)), BGl_string3341z00zz__multimediazd2mpdzd2, BGl_string3342z00zz__multimediazd2mpdzd2, BgL_index1325z00_649); 
FAILURE(BgL_auxz00_6470,BFALSE,BFALSE);} 
BgL_auxz00_6466 = 
(long)CINT(BgL_tmpz00_6467); } 
BgL_logz00_640 = 
VECTOR_REF(BgL_opt1320z00_18,BgL_auxz00_6466); }  else 
{ /* Llib/mpd.scm 230 */BFALSE; } } } 
{ /* Llib/mpd.scm 230 */
obj_t BgL_arg1845z00_651;obj_t BgL_arg1846z00_652;obj_t BgL_arg1847z00_653;obj_t BgL_arg1848z00_654;
BgL_arg1845z00_651 = 
VECTOR_REF(BgL_opt1320z00_18,((long)0)); 
BgL_arg1846z00_652 = 
VECTOR_REF(BgL_opt1320z00_18,((long)1)); 
BgL_arg1847z00_653 = 
VECTOR_REF(BgL_opt1320z00_18,((long)2)); 
BgL_arg1848z00_654 = 
VECTOR_REF(BgL_opt1320z00_18,((long)3)); 
{ /* Llib/mpd.scm 230 */
obj_t BgL_logz00_655;
BgL_logz00_655 = BgL_logz00_640; 
{ /* Llib/mpd.scm 230 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_6502;obj_t BgL_auxz00_6495;obj_t BgL_auxz00_6488;BgL_musicz00_bglt BgL_auxz00_6480;
if(
BGl_isazf3zf3zz__objectz00(BgL_arg1848z00_654, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 230 */
BgL_auxz00_6502 = 
((BgL_mpdzd2databasezd2_bglt)BgL_arg1848z00_654)
; }  else 
{ 
obj_t BgL_auxz00_6506;
BgL_auxz00_6506 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)9602)), BGl_string3341z00zz__multimediazd2mpdzd2, BGl_string3346z00zz__multimediazd2mpdzd2, BgL_arg1848z00_654); 
FAILURE(BgL_auxz00_6506,BFALSE,BFALSE);} 
if(
OUTPUT_PORTP(BgL_arg1847z00_653))
{ /* Llib/mpd.scm 230 */
BgL_auxz00_6495 = BgL_arg1847z00_653
; }  else 
{ 
obj_t BgL_auxz00_6498;
BgL_auxz00_6498 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)9602)), BGl_string3341z00zz__multimediazd2mpdzd2, BGl_string3345z00zz__multimediazd2mpdzd2, BgL_arg1847z00_653); 
FAILURE(BgL_auxz00_6498,BFALSE,BFALSE);} 
if(
INPUT_PORTP(BgL_arg1846z00_652))
{ /* Llib/mpd.scm 230 */
BgL_auxz00_6488 = BgL_arg1846z00_652
; }  else 
{ 
obj_t BgL_auxz00_6491;
BgL_auxz00_6491 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)9602)), BGl_string3341z00zz__multimediazd2mpdzd2, BGl_string3344z00zz__multimediazd2mpdzd2, BgL_arg1846z00_652); 
FAILURE(BgL_auxz00_6491,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_arg1845z00_651, BGl_musicz00zz__multimediazd2musiczd2))
{ /* Llib/mpd.scm 230 */
BgL_auxz00_6480 = 
((BgL_musicz00_bglt)BgL_arg1845z00_651)
; }  else 
{ 
obj_t BgL_auxz00_6484;
BgL_auxz00_6484 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)9602)), BGl_string3341z00zz__multimediazd2mpdzd2, BGl_string3343z00zz__multimediazd2mpdzd2, BgL_arg1845z00_651); 
FAILURE(BgL_auxz00_6484,BFALSE,BFALSE);} 
return 
BGl_mpdz00zz__multimediazd2mpdzd2(BgL_auxz00_6480, BgL_auxz00_6488, BgL_auxz00_6495, BgL_auxz00_6502, BgL_logz00_655);} } } } } } } } 
BGL_FUNCTION_END;
}



/* mpd */
BGL_EXPORTED_DEF obj_t BGl_mpdz00zz__multimediazd2mpdzd2(BgL_musicz00_bglt BgL_backendz00_13, obj_t BgL_ipz00_14, obj_t BgL_opz00_15, BgL_mpdzd2databasezd2_bglt BgL_dbz00_16, obj_t BgL_logz00_17)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 230 */
bgl_display_obj(BGl_string3347z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_display_char(((unsigned char)10), BgL_opz00_15); 
bgl_flush_output_port(BgL_opz00_15); 
{ 

BgL_zc3anonymousza31857ze3z83_666:
if(
BGl_musiczd2closedzf3z21zz__multimediazd2musiczd2(BgL_backendz00_13))
{ /* Llib/mpd.scm 237 */
return BFALSE;}  else 
{ /* Llib/mpd.scm 238 */
obj_t BgL_linez00_668;
BgL_linez00_668 = 
BGl_readzd2linezd2zz__r4_input_6_10_2z00(BgL_ipz00_14); 
BGl_cmdnz00zz__multimediazd2mpdzd2 = 
(((long)1)+BGl_cmdnz00zz__multimediazd2mpdzd2); 
if(
CBOOL(BgL_logz00_17))
{ /* Llib/mpd.scm 240 */
PROCEDURE_ENTRY(BgL_logz00_17)(BgL_logz00_17, BgL_linez00_668, BEOA); }  else 
{ /* Llib/mpd.scm 240 */BFALSE; } 
{ /* Llib/mpd.scm 241 */
bool_t BgL_testz00_6524;
{ /* Llib/mpd.scm 241 */
bool_t BgL_res2744z00_2570;
BgL_res2744z00_2570 = 
EOF_OBJECTP(BgL_linez00_668); 
BgL_testz00_6524 = BgL_res2744z00_2570; } 
if(BgL_testz00_6524)
{ /* Llib/mpd.scm 241 */
return BFALSE;}  else 
{ /* Llib/mpd.scm 242 */
obj_t BgL_vz00_670;
BgL_vz00_670 = 
BGl_executezd2commandzd2zz__multimediazd2mpdzd2(BgL_dbz00_16, BgL_backendz00_13, BgL_ipz00_14, BgL_opz00_15, BgL_linez00_668); 
if(
(BgL_vz00_670==
CNST_TABLE_REF(((long)53))))
{ /* Llib/mpd.scm 243 */
bgl_display_string(BGl_string3348z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_flush_output_port(BgL_opz00_15); 
bgl_flush_output_port(BgL_opz00_15); 
goto BgL_zc3anonymousza31857ze3z83_666;}  else 
{ /* Llib/mpd.scm 243 */
bool_t BgL_testz00_6533;
{ /* Llib/mpd.scm 243 */
bool_t BgL__ortest_1087z00_678;
BgL__ortest_1087z00_678 = 
(BgL_vz00_670==
CNST_TABLE_REF(((long)24))); 
if(BgL__ortest_1087z00_678)
{ /* Llib/mpd.scm 243 */
BgL_testz00_6533 = BgL__ortest_1087z00_678
; }  else 
{ /* Llib/mpd.scm 243 */
BgL_testz00_6533 = 
(BgL_vz00_670==
CNST_TABLE_REF(((long)31)))
; } } 
if(BgL_testz00_6533)
{ /* Llib/mpd.scm 243 */
return 
bgl_flush_output_port(BgL_opz00_15);}  else 
{ /* Llib/mpd.scm 243 */
if(
(BgL_vz00_670==
CNST_TABLE_REF(((long)54))))
{ /* Llib/mpd.scm 243 */
goto BgL_zc3anonymousza31857ze3z83_666;}  else 
{ /* Llib/mpd.scm 243 */
bgl_display_string(BGl_string3349z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_display_obj(BGl_string3350z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_display_string(BGl_string3351z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_display_obj(BGl_string3337z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_display_string(BGl_string3352z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_display_obj(BgL_vz00_670, BgL_opz00_15); 
bgl_display_string(BGl_string3353z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_flush_output_port(BgL_opz00_15); 
CNST_TABLE_REF(((long)54)); 
goto BgL_zc3anonymousza31857ze3z83_666;} } } } } } } } 
BGL_FUNCTION_END;
}



/* execute-command */
obj_t BGl_executezd2commandzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_dbz00_20, BgL_musicz00_bglt BgL_backendz00_21, obj_t BgL_ipz00_22, obj_t BgL_opz00_23, obj_t BgL_linez00_24)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 259 */
{ /* Llib/mpd.scm 260 */
obj_t BgL_cmdz00_680;
BgL_cmdz00_680 = 
BGl_getzd2linezd2commandz00zz__multimediazd2mpdzd2(BgL_linez00_24); 
{ /* Llib/mpd.scm 262 */
bool_t BgL_testz00_6553;
if(
(BgL_cmdz00_680==
CNST_TABLE_REF(((long)55))))
{ /* Llib/mpd.scm 262 */
BgL_testz00_6553 = ((bool_t)1)
; }  else 
{ /* Llib/mpd.scm 262 */
BgL_testz00_6553 = 
(BgL_cmdz00_680==
CNST_TABLE_REF(((long)56)))
; } 
if(BgL_testz00_6553)
{ /* Llib/mpd.scm 262 */
return 
BGl_mpdzd2listzd2beginz00zz__multimediazd2mpdzd2(BgL_dbz00_20, BgL_backendz00_21, BgL_ipz00_22, BgL_opz00_23, BgL_cmdz00_680);}  else 
{ /* Llib/mpd.scm 265 */
obj_t BgL_g1088z00_683;
BgL_g1088z00_683 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_cmdz00_680, BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2); 
if(
CBOOL(BgL_g1088z00_683))
{ /* Llib/mpd.scm 267 */
obj_t BgL_fun1865z00_686;
BgL_fun1865z00_686 = 
CDR(
((obj_t)BgL_g1088z00_683)); 
return 
PROCEDURE_ENTRY(BgL_fun1865z00_686)(BgL_fun1865z00_686, 
((obj_t)BgL_dbz00_20), 
((obj_t)BgL_backendz00_21), BgL_linez00_24, BgL_ipz00_22, BgL_opz00_23, BEOA);}  else 
{ /* Llib/mpd.scm 268 */
obj_t BgL_g1091z00_687;
BgL_g1091z00_687 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_cmdz00_680, BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2); 
if(
CBOOL(BgL_g1091z00_687))
{ /* Llib/mpd.scm 270 */
obj_t BgL_fun1866z00_690;
BgL_fun1866z00_690 = 
CDR(
((obj_t)BgL_g1091z00_687)); 
return 
PROCEDURE_ENTRY(BgL_fun1866z00_690)(BgL_fun1866z00_690, 
((obj_t)BgL_dbz00_20), 
((obj_t)BgL_backendz00_21), BgL_linez00_24, BgL_ipz00_22, BgL_opz00_23, BEOA);}  else 
{ /* Llib/mpd.scm 268 */
if(
(
STRING_LENGTH(BgL_linez00_24)>((long)0)))
{ /* Llib/mpd.scm 273 */
obj_t BgL_list1869z00_693;
BgL_list1869z00_693 = 
MAKE_YOUNG_PAIR(BgL_linez00_24, BNIL); 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3354z00zz__multimediazd2mpdzd2, BgL_list1869z00_693);}  else 
{ /* Llib/mpd.scm 272 */
return 
CNST_TABLE_REF(((long)54));} } } } } } } 
BGL_FUNCTION_END;
}



/* mpd-list-begin */
obj_t BGl_mpdzd2listzd2beginz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_dbz00_25, BgL_musicz00_bglt BgL_backendz00_26, obj_t BgL_ipz00_27, obj_t BgL_opz00_28, obj_t BgL_cmdz00_29)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 279 */
{ 
obj_t BgL_linesz00_698;
BgL_linesz00_698 = BNIL; 
BgL_zc3anonymousza31871ze3z83_699:
{ /* Llib/mpd.scm 281 */
obj_t BgL_linez00_700;
BgL_linez00_700 = 
BGl_readzd2linezd2zz__r4_input_6_10_2z00(BgL_ipz00_27); 
{ /* Llib/mpd.scm 282 */
bool_t BgL_testz00_6597;
{ /* Llib/mpd.scm 282 */
bool_t BgL_res2749z00_2595;
BgL_res2749z00_2595 = 
EOF_OBJECTP(BgL_linez00_700); 
BgL_testz00_6597 = BgL_res2749z00_2595; } 
if(BgL_testz00_6597)
{ /* Llib/mpd.scm 282 */
return BFALSE;}  else 
{ /* Llib/mpd.scm 283 */
obj_t BgL_cz00_702;
BgL_cz00_702 = 
BGl_getzd2linezd2commandz00zz__multimediazd2mpdzd2(BgL_linez00_700); 
if(
(BgL_cz00_702==
CNST_TABLE_REF(((long)57))))
{ /* Llib/mpd.scm 284 */
if(
(BgL_cmdz00_29==
CNST_TABLE_REF(((long)55))))
{ /* Llib/mpd.scm 287 */
obj_t BgL_g1094z00_705;
BgL_g1094z00_705 = 
bgl_reverse_bang(BgL_linesz00_698); 
{ 
obj_t BgL_lsz00_707;
BgL_lsz00_707 = BgL_g1094z00_705; 
BgL_zc3anonymousza31875ze3z83_708:
if(
NULLP(BgL_lsz00_707))
{ /* Llib/mpd.scm 288 */
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 290 */
obj_t BgL_lz00_710;
BgL_lz00_710 = 
CAR(
((obj_t)BgL_lsz00_707)); 
{ /* Llib/mpd.scm 290 */
obj_t BgL_vz00_711;
BgL_vz00_711 = 
BGl_executezd2commandzd2zz__multimediazd2mpdzd2(BgL_dbz00_25, BgL_backendz00_26, BgL_ipz00_27, BgL_opz00_28, BgL_lz00_710); 
{ /* Llib/mpd.scm 291 */

if(
(BgL_vz00_711==
CNST_TABLE_REF(((long)53))))
{ /* Llib/mpd.scm 293 */
obj_t BgL_arg1878z00_713;
BgL_arg1878z00_713 = 
CDR(
((obj_t)BgL_lsz00_707)); 
{ 
obj_t BgL_lsz00_6618;
BgL_lsz00_6618 = BgL_arg1878z00_713; 
BgL_lsz00_707 = BgL_lsz00_6618; 
goto BgL_zc3anonymousza31875ze3z83_708;} }  else 
{ /* Llib/mpd.scm 292 */
return BgL_vz00_711;} } } } } }  else 
{ /* Llib/mpd.scm 286 */
if(
(BgL_cmdz00_29==
CNST_TABLE_REF(((long)56))))
{ /* Llib/mpd.scm 296 */
obj_t BgL_g1095z00_716;
BgL_g1095z00_716 = 
bgl_reverse_bang(BgL_linesz00_698); 
{ 
obj_t BgL_lsz00_718;
BgL_lsz00_718 = BgL_g1095z00_716; 
BgL_zc3anonymousza31880ze3z83_719:
if(
NULLP(BgL_lsz00_718))
{ /* Llib/mpd.scm 297 */
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 299 */
obj_t BgL_lz00_721;
BgL_lz00_721 = 
CAR(
((obj_t)BgL_lsz00_718)); 
{ /* Llib/mpd.scm 299 */
obj_t BgL_vz00_722;
BgL_vz00_722 = 
BGl_executezd2commandzd2zz__multimediazd2mpdzd2(BgL_dbz00_25, BgL_backendz00_26, BgL_ipz00_27, BgL_opz00_28, BgL_lz00_721); 
{ /* Llib/mpd.scm 300 */

if(
(BgL_vz00_722==
CNST_TABLE_REF(((long)53))))
{ /* Llib/mpd.scm 301 */
bgl_display_string(BGl_string3355z00zz__multimediazd2mpdzd2, BgL_opz00_28); 
{ /* Llib/mpd.scm 304 */
obj_t BgL_arg1883z00_724;
BgL_arg1883z00_724 = 
CDR(
((obj_t)BgL_lsz00_718)); 
{ 
obj_t BgL_lsz00_6635;
BgL_lsz00_6635 = BgL_arg1883z00_724; 
BgL_lsz00_718 = BgL_lsz00_6635; 
goto BgL_zc3anonymousza31880ze3z83_719;} } }  else 
{ /* Llib/mpd.scm 301 */
return BgL_vz00_722;} } } } } }  else 
{ /* Llib/mpd.scm 295 */
return BFALSE;} } }  else 
{ /* Llib/mpd.scm 306 */
obj_t BgL_arg1884z00_726;
BgL_arg1884z00_726 = 
MAKE_YOUNG_PAIR(BgL_linez00_700, BgL_linesz00_698); 
{ 
obj_t BgL_linesz00_6637;
BgL_linesz00_6637 = BgL_arg1884z00_726; 
BgL_linesz00_698 = BgL_linesz00_6637; 
goto BgL_zc3anonymousza31871ze3z83_699;} } } } } } } 
BGL_FUNCTION_END;
}



/* &mpd-ping */
obj_t BGl_z62mpdzd2pingzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4709, obj_t BgL_dbz00_4710, obj_t BgL_backendz00_4711, obj_t BgL_linez00_4712, obj_t BgL_ipz00_4713, obj_t BgL_opz00_4714)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 338 */
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* &mpd-urlhandlers */
obj_t BGl_z62mpdzd2urlhandlerszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4715, obj_t BgL_dbz00_4716, obj_t BgL_backendz00_4717, obj_t BgL_linez00_4718, obj_t BgL_ipz00_4719, obj_t BgL_opz00_4720)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 344 */
{ /* Llib/mpd.scm 345 */
bool_t BgL_tmpz00_6639;
{ /* Llib/mpd.scm 345 */
obj_t BgL_g1180z00_5565;
BgL_g1180z00_5565 = 
CNST_TABLE_REF(((long)58)); 
{ 
obj_t BgL_l1178z00_5567;
BgL_l1178z00_5567 = BgL_g1180z00_5565; 
BgL_zc3anonymousza31902ze3z83_5566:
if(
PAIRP(BgL_l1178z00_5567))
{ /* Llib/mpd.scm 349 */
{ /* Llib/mpd.scm 346 */
obj_t BgL_handlerz00_5568;
BgL_handlerz00_5568 = 
CAR(BgL_l1178z00_5567); 
{ /* Llib/mpd.scm 346 */
obj_t BgL_tmpz00_6644;
BgL_tmpz00_6644 = 
((obj_t)BgL_opz00_4720); 
bgl_display_string(BGl_string3356z00zz__multimediazd2mpdzd2, BgL_tmpz00_6644); } 
bgl_display_obj(BgL_handlerz00_5568, BgL_opz00_4720); 
{ /* Llib/mpd.scm 348 */
obj_t BgL_tmpz00_6648;
BgL_tmpz00_6648 = 
((obj_t)BgL_opz00_4720); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6648); } } 
{ 
obj_t BgL_l1178z00_6651;
BgL_l1178z00_6651 = 
CDR(BgL_l1178z00_5567); 
BgL_l1178z00_5567 = BgL_l1178z00_6651; 
goto BgL_zc3anonymousza31902ze3z83_5566;} }  else 
{ /* Llib/mpd.scm 349 */
BgL_tmpz00_6639 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_6639);} } 
BGL_FUNCTION_END;
}



/* &mpd-tagtypes */
obj_t BGl_z62mpdzd2tagtypeszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4721, obj_t BgL_dbz00_4722, obj_t BgL_backendz00_4723, obj_t BgL_linez00_4724, obj_t BgL_ipz00_4725, obj_t BgL_opz00_4726)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 354 */
{ /* Llib/mpd.scm 355 */
bool_t BgL_tmpz00_6654;
{ /* Llib/mpd.scm 355 */
obj_t BgL_g1183z00_5569;
BgL_g1183z00_5569 = 
CNST_TABLE_REF(((long)59)); 
{ 
obj_t BgL_l1181z00_5571;
BgL_l1181z00_5571 = BgL_g1183z00_5569; 
BgL_zc3anonymousza31905ze3z83_5570:
if(
PAIRP(BgL_l1181z00_5571))
{ /* Llib/mpd.scm 359 */
{ /* Llib/mpd.scm 356 */
obj_t BgL_tagz00_5572;
BgL_tagz00_5572 = 
CAR(BgL_l1181z00_5571); 
{ /* Llib/mpd.scm 356 */
obj_t BgL_tmpz00_6659;
BgL_tmpz00_6659 = 
((obj_t)BgL_opz00_4726); 
bgl_display_string(BGl_string3357z00zz__multimediazd2mpdzd2, BgL_tmpz00_6659); } 
bgl_display_obj(BgL_tagz00_5572, BgL_opz00_4726); 
{ /* Llib/mpd.scm 358 */
obj_t BgL_tmpz00_6663;
BgL_tmpz00_6663 = 
((obj_t)BgL_opz00_4726); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6663); } } 
{ 
obj_t BgL_l1181z00_6666;
BgL_l1181z00_6666 = 
CDR(BgL_l1181z00_5571); 
BgL_l1181z00_5571 = BgL_l1181z00_6666; 
goto BgL_zc3anonymousza31905ze3z83_5570;} }  else 
{ /* Llib/mpd.scm 359 */
BgL_tmpz00_6654 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_6654);} } 
BGL_FUNCTION_END;
}



/* &mpd-status */
obj_t BGl_z62mpdzd2statuszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4727, obj_t BgL_dbz00_4728, obj_t BgL_backendz00_4729, obj_t BgL_linez00_4730, obj_t BgL_ipz00_4731, obj_t BgL_opz00_4732)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 371 */
{ /* Llib/mpd.scm 372 */
BgL_musicstatusz00_bglt BgL_statusz00_5573;
BgL_statusz00_5573 = 
BGl_musiczd2statuszd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4729)); 
{ /* Llib/mpd.scm 376 */
obj_t BgL_volz00_5574;
{ /* Llib/mpd.scm 376 */
bool_t BgL_testz00_6671;
{ /* Llib/mpd.scm 376 */
obj_t BgL_tmpz00_6672;
BgL_tmpz00_6672 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5573))->BgL_volumez00); 
BgL_testz00_6671 = 
VECTORP(BgL_tmpz00_6672); } 
if(BgL_testz00_6671)
{ /* Llib/mpd.scm 376 */
obj_t BgL_arg1910z00_5575;
BgL_arg1910z00_5575 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5573))->BgL_volumez00); 
BgL_volz00_5574 = 
VECTOR_REF(
((obj_t)BgL_arg1910z00_5575),((long)0)); }  else 
{ /* Llib/mpd.scm 376 */
BgL_volz00_5574 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5573))->BgL_volumez00); } } 
{ /* Llib/mpd.scm 377 */
obj_t BgL_tmpz00_6679;
BgL_tmpz00_6679 = 
((obj_t)BgL_opz00_4732); 
bgl_display_string(BGl_string3358z00zz__multimediazd2mpdzd2, BgL_tmpz00_6679); } 
bgl_display_obj(BgL_volz00_5574, BgL_opz00_4732); 
{ /* Llib/mpd.scm 377 */
obj_t BgL_tmpz00_6683;
BgL_tmpz00_6683 = 
((obj_t)BgL_opz00_4732); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6683); } } 
{ /* Llib/mpd.scm 378 */
obj_t BgL_tmpz00_6686;
BgL_tmpz00_6686 = 
((obj_t)BgL_opz00_4732); 
bgl_display_string(BGl_string3359z00zz__multimediazd2mpdzd2, BgL_tmpz00_6686); } 
bgl_display_obj(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5573))->BgL_statez00), BgL_opz00_4732); 
{ /* Llib/mpd.scm 378 */
obj_t BgL_tmpz00_6691;
BgL_tmpz00_6691 = 
((obj_t)BgL_opz00_4732); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6691); } 
{ /* Llib/mpd.scm 379 */
obj_t BgL_tmpz00_6694;
BgL_tmpz00_6694 = 
((obj_t)BgL_opz00_4732); 
bgl_display_string(BGl_string3360z00zz__multimediazd2mpdzd2, BgL_tmpz00_6694); } 
{ /* Llib/mpd.scm 379 */
int BgL_arg1913z00_5576;
BgL_arg1913z00_5576 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5573))->BgL_playlistidz00); 
bgl_display_obj(
BINT(BgL_arg1913z00_5576), BgL_opz00_4732); } 
{ /* Llib/mpd.scm 379 */
obj_t BgL_tmpz00_6700;
BgL_tmpz00_6700 = 
((obj_t)BgL_opz00_4732); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6700); } 
{ /* Llib/mpd.scm 380 */
obj_t BgL_tmpz00_6703;
BgL_tmpz00_6703 = 
((obj_t)BgL_opz00_4732); 
bgl_display_string(BGl_string3361z00zz__multimediazd2mpdzd2, BgL_tmpz00_6703); } 
{ /* Llib/mpd.scm 380 */
int BgL_arg1914z00_5577;
BgL_arg1914z00_5577 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5573))->BgL_playlistlengthz00); 
bgl_display_obj(
BINT(BgL_arg1914z00_5577), BgL_opz00_4732); } 
{ /* Llib/mpd.scm 380 */
obj_t BgL_tmpz00_6709;
BgL_tmpz00_6709 = 
((obj_t)BgL_opz00_4732); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6709); } 
if(
(
(long)(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5573))->BgL_songz00))>=((long)0)))
{ /* Llib/mpd.scm 381 */
{ /* Llib/mpd.scm 382 */
obj_t BgL_tmpz00_6716;
BgL_tmpz00_6716 = 
((obj_t)BgL_opz00_4732); 
bgl_display_string(BGl_string3362z00zz__multimediazd2mpdzd2, BgL_tmpz00_6716); } 
{ /* Llib/mpd.scm 382 */
int BgL_arg1917z00_5578;
BgL_arg1917z00_5578 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5573))->BgL_songz00); 
bgl_display_obj(
BINT(BgL_arg1917z00_5578), BgL_opz00_4732); } 
{ /* Llib/mpd.scm 382 */
obj_t BgL_tmpz00_6722;
BgL_tmpz00_6722 = 
((obj_t)BgL_opz00_4732); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6722); } 
{ /* Llib/mpd.scm 383 */
obj_t BgL_tmpz00_6725;
BgL_tmpz00_6725 = 
((obj_t)BgL_opz00_4732); 
bgl_display_string(BGl_string3363z00zz__multimediazd2mpdzd2, BgL_tmpz00_6725); } 
{ /* Llib/mpd.scm 383 */
int BgL_arg1918z00_5579;
BgL_arg1918z00_5579 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5573))->BgL_songidz00); 
bgl_display_obj(
BINT(BgL_arg1918z00_5579), BgL_opz00_4732); } 
{ /* Llib/mpd.scm 383 */
obj_t BgL_tmpz00_6731;
BgL_tmpz00_6731 = 
((obj_t)BgL_opz00_4732); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6731); } 
{ /* Llib/mpd.scm 384 */
obj_t BgL_tmpz00_6734;
BgL_tmpz00_6734 = 
((obj_t)BgL_opz00_4732); 
bgl_display_string(BGl_string3364z00zz__multimediazd2mpdzd2, BgL_tmpz00_6734); } 
{ /* Llib/mpd.scm 384 */
int BgL_arg1919z00_5580;
BgL_arg1919z00_5580 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5573))->BgL_bitratez00); 
bgl_display_obj(
BINT(BgL_arg1919z00_5580), BgL_opz00_4732); } 
{ /* Llib/mpd.scm 384 */
obj_t BgL_tmpz00_6740;
BgL_tmpz00_6740 = 
((obj_t)BgL_opz00_4732); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6740); } 
{ /* Llib/mpd.scm 385 */
obj_t BgL_tmpz00_6743;
BgL_tmpz00_6743 = 
((obj_t)BgL_opz00_4732); 
bgl_display_string(BGl_string3365z00zz__multimediazd2mpdzd2, BgL_tmpz00_6743); } 
{ /* Llib/mpd.scm 386 */
int BgL_arg1920z00_5581;
BgL_arg1920z00_5581 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5573))->BgL_khza7za7); 
bgl_display_obj(
BINT(BgL_arg1920z00_5581), BgL_opz00_4732); } 
{ /* Llib/mpd.scm 387 */
obj_t BgL_tmpz00_6749;
BgL_tmpz00_6749 = 
((obj_t)BgL_opz00_4732); 
bgl_display_string(BGl_string3366z00zz__multimediazd2mpdzd2, BgL_tmpz00_6749); } }  else 
{ /* Llib/mpd.scm 381 */BFALSE; } 
{ /* Llib/mpd.scm 388 */
bool_t BgL_testz00_6752;
if(
(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5573))->BgL_statez00)==
CNST_TABLE_REF(((long)13))))
{ /* Llib/mpd.scm 388 */
BgL_testz00_6752 = ((bool_t)1)
; }  else 
{ /* Llib/mpd.scm 388 */
BgL_testz00_6752 = 
(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5573))->BgL_statez00)==
CNST_TABLE_REF(((long)18)))
; } 
if(BgL_testz00_6752)
{ /* Llib/mpd.scm 388 */
{ /* Llib/mpd.scm 389 */
obj_t BgL_tmpz00_6760;
BgL_tmpz00_6760 = 
((obj_t)BgL_opz00_4732); 
bgl_display_string(BGl_string3367z00zz__multimediazd2mpdzd2, BgL_tmpz00_6760); } 
bgl_display_obj(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5573))->BgL_songposz00), BgL_opz00_4732); 
{ /* Llib/mpd.scm 391 */
obj_t BgL_tmpz00_6765;
BgL_tmpz00_6765 = 
((obj_t)BgL_opz00_4732); 
bgl_display_string(BGl_string3368z00zz__multimediazd2mpdzd2, BgL_tmpz00_6765); } 
{ /* Llib/mpd.scm 392 */
int BgL_arg1928z00_5582;
BgL_arg1928z00_5582 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5573))->BgL_songlengthz00); 
bgl_display_obj(
BINT(BgL_arg1928z00_5582), BgL_opz00_4732); } 
{ /* Llib/mpd.scm 393 */
obj_t BgL_tmpz00_6771;
BgL_tmpz00_6771 = 
((obj_t)BgL_opz00_4732); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6771); } }  else 
{ /* Llib/mpd.scm 388 */BFALSE; } } 
if(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5573))->BgL_repeatz00))
{ /* Llib/mpd.scm 395 */
obj_t BgL_tmpz00_6776;
BgL_tmpz00_6776 = 
((obj_t)BgL_opz00_4732); 
bgl_display_string(BGl_string3369z00zz__multimediazd2mpdzd2, BgL_tmpz00_6776); }  else 
{ /* Llib/mpd.scm 396 */
obj_t BgL_tmpz00_6779;
BgL_tmpz00_6779 = 
((obj_t)BgL_opz00_4732); 
bgl_display_string(BGl_string3370z00zz__multimediazd2mpdzd2, BgL_tmpz00_6779); } 
if(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5573))->BgL_randomz00))
{ /* Llib/mpd.scm 398 */
obj_t BgL_tmpz00_6784;
BgL_tmpz00_6784 = 
((obj_t)BgL_opz00_4732); 
bgl_display_string(BGl_string3371z00zz__multimediazd2mpdzd2, BgL_tmpz00_6784); }  else 
{ /* Llib/mpd.scm 399 */
obj_t BgL_tmpz00_6787;
BgL_tmpz00_6787 = 
((obj_t)BgL_opz00_4732); 
bgl_display_string(BGl_string3372z00zz__multimediazd2mpdzd2, BgL_tmpz00_6787); } 
{ /* Llib/mpd.scm 400 */
obj_t BgL_tmpz00_6790;
BgL_tmpz00_6790 = 
((obj_t)BgL_opz00_4732); 
bgl_display_string(BGl_string3373z00zz__multimediazd2mpdzd2, BgL_tmpz00_6790); } 
{ /* Llib/mpd.scm 400 */
int BgL_arg1933z00_5583;
BgL_arg1933z00_5583 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5573))->BgL_xfadez00); 
bgl_display_obj(
BINT(BgL_arg1933z00_5583), BgL_opz00_4732); } 
{ /* Llib/mpd.scm 400 */
obj_t BgL_tmpz00_6796;
BgL_tmpz00_6796 = 
((obj_t)BgL_opz00_4732); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6796); } } 
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* &mpd-playlist */
obj_t BGl_z62mpdzd2playlistzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4733, obj_t BgL_dbz00_4734, obj_t BgL_backendz00_4735, obj_t BgL_linez00_4736, obj_t BgL_ipz00_4737, obj_t BgL_opz00_4738)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 406 */
{ /* Llib/mpd.scm 407 */
obj_t BgL_g1101z00_5584;
BgL_g1101z00_5584 = 
BGl_musiczd2playlistzd2getz00zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4735)); 
{ 
obj_t BgL_plistz00_5586;long BgL_numz00_5587;
BgL_plistz00_5586 = BgL_g1101z00_5584; 
BgL_numz00_5587 = ((long)0); 
BgL_loopz00_5585:
if(
PAIRP(BgL_plistz00_5586))
{ /* Llib/mpd.scm 409 */
bgl_display_obj(
BINT(BgL_numz00_5587), BgL_opz00_4738); 
{ /* Llib/mpd.scm 411 */
obj_t BgL_tmpz00_6806;
BgL_tmpz00_6806 = 
((obj_t)BgL_opz00_4738); 
bgl_display_string(BGl_string3368z00zz__multimediazd2mpdzd2, BgL_tmpz00_6806); } 
bgl_display_obj(
CAR(BgL_plistz00_5586), BgL_opz00_4738); 
{ /* Llib/mpd.scm 413 */
obj_t BgL_tmpz00_6811;
BgL_tmpz00_6811 = 
((obj_t)BgL_opz00_4738); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6811); } 
{ 
long BgL_numz00_6816;obj_t BgL_plistz00_6814;
BgL_plistz00_6814 = 
CDR(BgL_plistz00_5586); 
BgL_numz00_6816 = 
(((long)1)+BgL_numz00_5587); 
BgL_numz00_5587 = BgL_numz00_6816; 
BgL_plistz00_5586 = BgL_plistz00_6814; 
goto BgL_loopz00_5585;} }  else 
{ /* Llib/mpd.scm 409 */((bool_t)0); } } } 
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* playlistinfo */
obj_t BGl_playlistinfoz00zz__multimediazd2mpdzd2(obj_t BgL_dbz00_71, obj_t BgL_backendz00_72, obj_t BgL_linez00_73, obj_t BgL_ipz00_74, obj_t BgL_opz00_75, int BgL_numz00_76)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 432 */
{ /* Llib/mpd.scm 434 */
obj_t BgL_plistz00_867;
BgL_plistz00_867 = 
BGl_musiczd2playlistzd2getz00zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_72)); 
{ /* Llib/mpd.scm 435 */
bool_t BgL_testz00_6821;
if(
(
(long)(BgL_numz00_76)>=((long)0)))
{ /* Llib/mpd.scm 435 */
BgL_testz00_6821 = 
(
(long)(BgL_numz00_76)<
bgl_list_length(BgL_plistz00_867))
; }  else 
{ /* Llib/mpd.scm 435 */
BgL_testz00_6821 = ((bool_t)0)
; } 
if(BgL_testz00_6821)
{ /* Llib/mpd.scm 436 */
obj_t BgL_arg1967z00_871;
BgL_arg1967z00_871 = 
bgl_list_ref(BgL_plistz00_867, 
(long)(BgL_numz00_76)); 
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1187z00_2813;
BgL_g1187z00_2813 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(BgL_dbz00_71, BgL_arg1967z00_871, BFALSE, BFALSE, BFALSE); 
{ 
obj_t BgL_l1185z00_2815;
BgL_l1185z00_2815 = BgL_g1187z00_2813; 
BgL_zc3anonymousza31958ze3z83_2814:
if(
PAIRP(BgL_l1185z00_2815))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_2817;
BgL_kz00_2817 = 
CAR(BgL_l1185z00_2815); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1960z00_2818;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1961z00_2819;
BgL_arg1961z00_2819 = 
CAR(
((obj_t)BgL_kz00_2817)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2784z00_2826;
BgL_res2784z00_2826 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1961z00_2819)); 
BgL_arg1960z00_2818 = BgL_res2784z00_2826; } } 
bgl_display_obj(BgL_arg1960z00_2818, BgL_opz00_75); } 
{ /* Llib/mpd.scm 424 */
obj_t BgL_tmpz00_6839;
BgL_tmpz00_6839 = 
((obj_t)BgL_opz00_75); 
bgl_display_string(BGl_string3374z00zz__multimediazd2mpdzd2, BgL_tmpz00_6839); } 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1962z00_2820;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_2832;
BgL_pairz00_2832 = 
CDR(
((obj_t)BgL_kz00_2817)); 
BgL_arg1962z00_2820 = 
CAR(BgL_pairz00_2832); } 
bgl_display_obj(BgL_arg1962z00_2820, BgL_opz00_75); } 
{ /* Llib/mpd.scm 426 */
obj_t BgL_tmpz00_6846;
BgL_tmpz00_6846 = 
((obj_t)BgL_opz00_75); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6846); } } 
{ 
obj_t BgL_l1185z00_6849;
BgL_l1185z00_6849 = 
CDR(BgL_l1185z00_2815); 
BgL_l1185z00_2815 = BgL_l1185z00_6849; 
goto BgL_zc3anonymousza31958ze3z83_2814;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } } }  else 
{ 
obj_t BgL_plistz00_876;long BgL_numz00_877;
BgL_plistz00_876 = BgL_plistz00_867; 
BgL_numz00_877 = ((long)0); 
BgL_zc3anonymousza31968ze3z83_878:
if(
PAIRP(BgL_plistz00_876))
{ /* Llib/mpd.scm 439 */
{ /* Llib/mpd.scm 440 */
obj_t BgL_arg1970z00_880;
BgL_arg1970z00_880 = 
CAR(BgL_plistz00_876); 
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1187z00_2837;
BgL_g1187z00_2837 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(BgL_dbz00_71, BgL_arg1970z00_880, BFALSE, BFALSE, BFALSE); 
{ 
obj_t BgL_l1185z00_2839;
BgL_l1185z00_2839 = BgL_g1187z00_2837; 
BgL_zc3anonymousza31958ze3z83_2838:
if(
PAIRP(BgL_l1185z00_2839))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_2841;
BgL_kz00_2841 = 
CAR(BgL_l1185z00_2839); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1960z00_2842;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1961z00_2843;
BgL_arg1961z00_2843 = 
CAR(
((obj_t)BgL_kz00_2841)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2787z00_2850;
BgL_res2787z00_2850 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1961z00_2843)); 
BgL_arg1960z00_2842 = BgL_res2787z00_2850; } } 
bgl_display_obj(BgL_arg1960z00_2842, BgL_opz00_75); } 
{ /* Llib/mpd.scm 424 */
obj_t BgL_tmpz00_6863;
BgL_tmpz00_6863 = 
((obj_t)BgL_opz00_75); 
bgl_display_string(BGl_string3374z00zz__multimediazd2mpdzd2, BgL_tmpz00_6863); } 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1962z00_2844;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_2856;
BgL_pairz00_2856 = 
CDR(
((obj_t)BgL_kz00_2841)); 
BgL_arg1962z00_2844 = 
CAR(BgL_pairz00_2856); } 
bgl_display_obj(BgL_arg1962z00_2844, BgL_opz00_75); } 
{ /* Llib/mpd.scm 426 */
obj_t BgL_tmpz00_6870;
BgL_tmpz00_6870 = 
((obj_t)BgL_opz00_75); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6870); } } 
{ 
obj_t BgL_l1185z00_6873;
BgL_l1185z00_6873 = 
CDR(BgL_l1185z00_2839); 
BgL_l1185z00_2839 = BgL_l1185z00_6873; 
goto BgL_zc3anonymousza31958ze3z83_2838;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } } } 
{ 
long BgL_numz00_6877;obj_t BgL_plistz00_6875;
BgL_plistz00_6875 = 
CDR(BgL_plistz00_876); 
BgL_numz00_6877 = 
(((long)1)+BgL_numz00_877); 
BgL_numz00_877 = BgL_numz00_6877; 
BgL_plistz00_876 = BgL_plistz00_6875; 
goto BgL_zc3anonymousza31968ze3z83_878;} }  else 
{ /* Llib/mpd.scm 439 */((bool_t)0); } } } } 
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* &mpd-playlistinfo */
obj_t BGl_z62mpdzd2playlistinfozb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4739, obj_t BgL_dbz00_4740, obj_t BgL_backendz00_4741, obj_t BgL_linez00_4742, obj_t BgL_ipz00_4743, obj_t BgL_opz00_4744)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 447 */
{ /* Llib/mpd.scm 447 */
obj_t BgL_numz00_5588;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5589;
BgL_strz00_5589 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4742, ((long)1)); 
if(
STRINGP(BgL_strz00_5589))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6883;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6884;
BgL_tmpz00_6884 = 
BSTRING_TO_STRING(BgL_strz00_5589); 
BgL_tmpz00_6883 = 
BGL_STRTOL(BgL_tmpz00_6884, ((long)0), ((long)10)); } 
BgL_numz00_5588 = 
BINT(BgL_tmpz00_6883); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5588 = BFALSE; } } 
{ /* Llib/mpd.scm 448 */
obj_t BgL_arg1974z00_5590;
if(
CBOOL(BgL_numz00_5588))
{ /* Llib/mpd.scm 448 */
BgL_arg1974z00_5590 = BgL_numz00_5588; }  else 
{ /* Llib/mpd.scm 448 */
BgL_arg1974z00_5590 = 
BINT(((long)0)); } 
return 
BGl_playlistinfoz00zz__multimediazd2mpdzd2(BgL_dbz00_4740, BgL_backendz00_4741, BgL_linez00_4742, BgL_ipz00_4743, BgL_opz00_4744, 
CINT(BgL_arg1974z00_5590));} } } 
BGL_FUNCTION_END;
}



/* &mpd-playlistid */
obj_t BGl_z62mpdzd2playlistidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4745, obj_t BgL_dbz00_4746, obj_t BgL_backendz00_4747, obj_t BgL_linez00_4748, obj_t BgL_ipz00_4749, obj_t BgL_opz00_4750)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 453 */
{ /* Llib/mpd.scm 453 */
obj_t BgL_numz00_5591;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5592;
BgL_strz00_5592 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4748, ((long)1)); 
if(
STRINGP(BgL_strz00_5592))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6896;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6897;
BgL_tmpz00_6897 = 
BSTRING_TO_STRING(BgL_strz00_5592); 
BgL_tmpz00_6896 = 
BGL_STRTOL(BgL_tmpz00_6897, ((long)0), ((long)10)); } 
BgL_numz00_5591 = 
BINT(BgL_tmpz00_6896); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5591 = BFALSE; } } 
{ /* Llib/mpd.scm 454 */
obj_t BgL_arg1975z00_5593;
if(
CBOOL(BgL_numz00_5591))
{ /* Llib/mpd.scm 454 */
BgL_arg1975z00_5593 = BgL_numz00_5591; }  else 
{ /* Llib/mpd.scm 454 */
BgL_arg1975z00_5593 = 
BINT(((long)0)); } 
return 
BGl_playlistinfoz00zz__multimediazd2mpdzd2(BgL_dbz00_4746, BgL_backendz00_4747, BgL_linez00_4748, BgL_ipz00_4749, BgL_opz00_4750, 
CINT(BgL_arg1975z00_5593));} } } 
BGL_FUNCTION_END;
}



/* &mpd-plchanges */
obj_t BGl_z62mpdzd2plchangeszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4751, obj_t BgL_dbz00_4752, obj_t BgL_backendz00_4753, obj_t BgL_linez00_4754, obj_t BgL_ipz00_4755, obj_t BgL_opz00_4756)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 459 */
{ /* Llib/mpd.scm 459 */
obj_t BgL_numz00_5594;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5595;
BgL_strz00_5595 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4754, ((long)1)); 
if(
STRINGP(BgL_strz00_5595))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6909;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6910;
BgL_tmpz00_6910 = 
BSTRING_TO_STRING(BgL_strz00_5595); 
BgL_tmpz00_6909 = 
BGL_STRTOL(BgL_tmpz00_6910, ((long)0), ((long)10)); } 
BgL_numz00_5594 = 
BINT(BgL_tmpz00_6909); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5594 = BFALSE; } } 
{ /* Llib/mpd.scm 460 */
BgL_musicstatusz00_bglt BgL_statusz00_5596;
BgL_statusz00_5596 = 
BGl_musiczd2statuszd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4753)); 
if(
(
(long)CINT(BgL_numz00_5594)<
(long)(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5596))->BgL_playlistidz00))))
{ /* Llib/mpd.scm 462 */
return 
BGl_playlistinfoz00zz__multimediazd2mpdzd2(BgL_dbz00_4752, BgL_backendz00_4753, BgL_linez00_4754, BgL_ipz00_4755, BgL_opz00_4756, 
(int)(((long)0)));}  else 
{ /* Llib/mpd.scm 462 */
return 
CNST_TABLE_REF(((long)53));} } } } 
BGL_FUNCTION_END;
}



/* &mpd-add */
obj_t BGl_z62mpdzd2addzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4757, obj_t BgL_dbz00_4758, obj_t BgL_backendz00_4759, obj_t BgL_linez00_4760, obj_t BgL_ipz00_4761, obj_t BgL_opz00_4762)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 477 */
{ /* Llib/mpd.scm 477 */
obj_t BgL_uriz00_5597;
BgL_uriz00_5597 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4760, ((long)1)); 
if(
CBOOL(BgL_uriz00_5597))
{ /* Llib/mpd.scm 479 */
obj_t BgL_pathz00_5598;
if(
bigloo_strcmp_at(BgL_uriz00_5597, BGl_string3375z00zz__multimediazd2mpdzd2, ((long)0)))
{ /* Llib/mpd.scm 470 */
BgL_pathz00_5598 = BgL_uriz00_5597; }  else 
{ /* Llib/mpd.scm 470 */
BgL_pathz00_5598 = 
BGl_mpdzd2ze3filez31zz__multimediazd2mpdzd2(BgL_uriz00_5597, BgL_dbz00_4758, BgL_opz00_4762, BGl_string3376z00zz__multimediazd2mpdzd2); } 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pathz00_5598)))
{ /* Llib/mpd.scm 481 */
obj_t BgL_g1190z00_5599;
BgL_g1190z00_5599 = 
BGl_directoryzd2ze3sortzd2listze3zz__multimediazd2mpdzd2(BgL_pathz00_5598); 
{ 
obj_t BgL_l1188z00_5601;
{ /* Llib/mpd.scm 485 */
bool_t BgL_tmpz00_6934;
BgL_l1188z00_5601 = BgL_g1190z00_5599; 
BgL_zc3anonymousza31981ze3z83_5600:
if(
PAIRP(BgL_l1188z00_5601))
{ /* Llib/mpd.scm 485 */
{ /* Llib/mpd.scm 482 */
obj_t BgL_fz00_5602;
BgL_fz00_5602 = 
CAR(BgL_l1188z00_5601); 
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_fz00_5602, BgL_dbz00_4758))
{ /* Llib/mpd.scm 484 */
obj_t BgL_arg1984z00_5603;
BgL_arg1984z00_5603 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_pathz00_5598, BgL_fz00_5602); 
BGl_musiczd2playlistzd2addz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4759), BgL_arg1984z00_5603); }  else 
{ /* Llib/mpd.scm 482 */BFALSE; } } 
{ 
obj_t BgL_l1188z00_6943;
BgL_l1188z00_6943 = 
CDR(BgL_l1188z00_5601); 
BgL_l1188z00_5601 = BgL_l1188z00_6943; 
goto BgL_zc3anonymousza31981ze3z83_5600;} }  else 
{ /* Llib/mpd.scm 485 */
BgL_tmpz00_6934 = ((bool_t)1)
; } 
BBOOL(BgL_tmpz00_6934); } } }  else 
{ /* Llib/mpd.scm 480 */
BGl_musiczd2playlistzd2addz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4759), BgL_pathz00_5598); } 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 488 */
obj_t BgL_list1986z00_5604;
BgL_list1986z00_5604 = 
MAKE_YOUNG_PAIR(BgL_uriz00_5597, BNIL); 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3377z00zz__multimediazd2mpdzd2, BgL_list1986z00_5604);} } } 
BGL_FUNCTION_END;
}



/* &mpd-delete */
obj_t BGl_z62mpdzd2deletezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4763, obj_t BgL_dbz00_4764, obj_t BgL_backendz00_4765, obj_t BgL_linez00_4766, obj_t BgL_ipz00_4767, obj_t BgL_opz00_4768)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 493 */
{ /* Llib/mpd.scm 493 */
obj_t BgL_numz00_5605;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5606;
BgL_strz00_5606 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4766, ((long)1)); 
if(
STRINGP(BgL_strz00_5606))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6954;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6955;
BgL_tmpz00_6955 = 
BSTRING_TO_STRING(BgL_strz00_5606); 
BgL_tmpz00_6954 = 
BGL_STRTOL(BgL_tmpz00_6955, ((long)0), ((long)10)); } 
BgL_numz00_5605 = 
BINT(BgL_tmpz00_6954); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5605 = BFALSE; } } 
BGl_musiczd2playlistzd2deletez12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4765), 
CINT(BgL_numz00_5605)); 
return 
CNST_TABLE_REF(((long)53));} } 
BGL_FUNCTION_END;
}



/* &mpd-deleteid */
obj_t BGl_z62mpdzd2deleteidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4769, obj_t BgL_dbz00_4770, obj_t BgL_backendz00_4771, obj_t BgL_linez00_4772, obj_t BgL_ipz00_4773, obj_t BgL_opz00_4774)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 500 */
{ /* Llib/mpd.scm 500 */
obj_t BgL_numz00_5607;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5608;
BgL_strz00_5608 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4772, ((long)1)); 
if(
STRINGP(BgL_strz00_5608))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6966;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6967;
BgL_tmpz00_6967 = 
BSTRING_TO_STRING(BgL_strz00_5608); 
BgL_tmpz00_6966 = 
BGL_STRTOL(BgL_tmpz00_6967, ((long)0), ((long)10)); } 
BgL_numz00_5607 = 
BINT(BgL_tmpz00_6966); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5607 = BFALSE; } } 
BGl_musiczd2playlistzd2deletez12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4771), 
CINT(BgL_numz00_5607)); 
{ /* Llib/mpd.scm 312 */
obj_t BgL_tmpz00_6974;
BgL_tmpz00_6974 = 
((obj_t)BgL_opz00_4774); 
bgl_display_string(BGl_string3348z00zz__multimediazd2mpdzd2, BgL_tmpz00_6974); } 
{ /* Llib/mpd.scm 313 */
obj_t BgL_tmpz00_6977;
BgL_tmpz00_6977 = 
((obj_t)BgL_opz00_4774); 
return 
bgl_flush_output_port(BgL_tmpz00_6977);} } } 
BGL_FUNCTION_END;
}



/* &mpd-clear */
obj_t BGl_z62mpdzd2clearzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4775, obj_t BgL_dbz00_4776, obj_t BgL_backendz00_4777, obj_t BgL_linez00_4778, obj_t BgL_ipz00_4779, obj_t BgL_opz00_4780)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 507 */
BGl_musiczd2playlistzd2clearz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4777)); 
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* currentsong-info */
obj_t BGl_currentsongzd2infozd2zz__multimediazd2mpdzd2(obj_t BgL_dbz00_116, obj_t BgL_backendz00_117, obj_t BgL_plistz00_118, int BgL_numz00_119, obj_t BgL_linez00_120, obj_t BgL_ipz00_121)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 514 */
{ /* Llib/mpd.scm 549 */
obj_t BgL_filez00_919;
BgL_filez00_919 = 
bgl_list_ref(BgL_plistz00_118, 
(long)(BgL_numz00_119)); 
{ /* Llib/mpd.scm 549 */
obj_t BgL_pathz00_920;
if(
bigloo_strcmp_at(BgL_filez00_919, BGl_string3375z00zz__multimediazd2mpdzd2, ((long)0)))
{ /* Llib/mpd.scm 1021 */
BgL_pathz00_920 = BgL_filez00_919; }  else 
{ /* Llib/mpd.scm 1021 */
BgL_pathz00_920 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_filez00_919, BgL_dbz00_116); } 
{ /* Llib/mpd.scm 550 */

{ /* Llib/mpd.scm 553 */
obj_t BgL_zc3anonymousza31988ze3z83_5009;
BgL_zc3anonymousza31988ze3z83_5009 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza31988ze3ze1zz__multimediazd2mpdzd2, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3anonymousza31988ze3z83_5009, 
(int)(((long)0)), BgL_backendz00_117); 
PROCEDURE_SET(BgL_zc3anonymousza31988ze3z83_5009, 
(int)(((long)1)), BgL_dbz00_116); 
PROCEDURE_SET(BgL_zc3anonymousza31988ze3z83_5009, 
(int)(((long)2)), BgL_linez00_120); 
PROCEDURE_SET(BgL_zc3anonymousza31988ze3z83_5009, 
(int)(((long)3)), BgL_ipz00_121); 
PROCEDURE_SET(BgL_zc3anonymousza31988ze3z83_5009, 
(int)(((long)4)), BgL_filez00_919); 
PROCEDURE_SET(BgL_zc3anonymousza31988ze3z83_5009, 
(int)(((long)5)), BgL_pathz00_920); 
return 
BGl_callzd2withzd2outputzd2stringzd2zz__r4_ports_6_10_1z00(BgL_zc3anonymousza31988ze3z83_5009);} } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1988> */
obj_t BGl_z62zc3anonymousza31988ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5010, obj_t BgL_opz00_5017)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 552 */
{ /* Llib/mpd.scm 553 */
obj_t BgL_backendz00_5011;obj_t BgL_dbz00_5012;obj_t BgL_linez00_5013;obj_t BgL_ipz00_5014;obj_t BgL_filez00_5015;obj_t BgL_pathz00_5016;
BgL_backendz00_5011 = 
PROCEDURE_REF(BgL_envz00_5010, 
(int)(((long)0))); 
BgL_dbz00_5012 = 
PROCEDURE_REF(BgL_envz00_5010, 
(int)(((long)1))); 
BgL_linez00_5013 = 
PROCEDURE_REF(BgL_envz00_5010, 
(int)(((long)2))); 
BgL_ipz00_5014 = 
PROCEDURE_REF(BgL_envz00_5010, 
(int)(((long)3))); 
BgL_filez00_5015 = 
PROCEDURE_REF(BgL_envz00_5010, 
(int)(((long)4))); 
BgL_pathz00_5016 = 
PROCEDURE_REF(BgL_envz00_5010, 
(int)(((long)5))); 
{ 
obj_t BgL_opz00_5610;obj_t BgL_filez00_5611;obj_t BgL_pathz00_5612;
if(
fexists(
BSTRING_TO_STRING(BgL_filez00_5015)))
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1187z00_5623;
BgL_g1187z00_5623 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(BgL_dbz00_5012, BgL_filez00_5015, BFALSE, BFALSE, BFALSE); 
{ 
obj_t BgL_l1185z00_5625;
{ /* Llib/mpd.scm 427 */
bool_t BgL_tmpz00_7020;
BgL_l1185z00_5625 = BgL_g1187z00_5623; 
BgL_zc3anonymousza31958ze3z83_5624:
if(
PAIRP(BgL_l1185z00_5625))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_5626;
BgL_kz00_5626 = 
CAR(BgL_l1185z00_5625); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1960z00_5627;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1961z00_5628;
BgL_arg1961z00_5628 = 
CAR(
((obj_t)BgL_kz00_5626)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2803z00_5629;
BgL_res2803z00_5629 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1961z00_5628)); 
BgL_arg1960z00_5627 = BgL_res2803z00_5629; } } 
bgl_display_obj(BgL_arg1960z00_5627, BgL_opz00_5017); } 
{ /* Llib/mpd.scm 424 */
obj_t BgL_tmpz00_7029;
BgL_tmpz00_7029 = 
((obj_t)BgL_opz00_5017); 
bgl_display_string(BGl_string3374z00zz__multimediazd2mpdzd2, BgL_tmpz00_7029); } 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1962z00_5630;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_5631;
BgL_pairz00_5631 = 
CDR(
((obj_t)BgL_kz00_5626)); 
BgL_arg1962z00_5630 = 
CAR(BgL_pairz00_5631); } 
bgl_display_obj(BgL_arg1962z00_5630, BgL_opz00_5017); } 
{ /* Llib/mpd.scm 426 */
obj_t BgL_tmpz00_7036;
BgL_tmpz00_7036 = 
((obj_t)BgL_opz00_5017); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7036); } } 
{ 
obj_t BgL_l1185z00_7039;
BgL_l1185z00_7039 = 
CDR(BgL_l1185z00_5625); 
BgL_l1185z00_5625 = BgL_l1185z00_7039; 
goto BgL_zc3anonymousza31958ze3z83_5624;} }  else 
{ /* Llib/mpd.scm 427 */
BgL_tmpz00_7020 = ((bool_t)1)
; } 
return 
BBOOL(BgL_tmpz00_7020);} } }  else 
{ /* Llib/mpd.scm 553 */
BgL_opz00_5610 = BgL_opz00_5017; 
BgL_filez00_5611 = BgL_filez00_5015; 
BgL_pathz00_5612 = BgL_pathz00_5016; 
{ /* Llib/mpd.scm 518 */
obj_t BgL_metaz00_5613;
BgL_metaz00_5613 = 
BGl_musiczd2metazd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_5011)); 
if(
NULLP(BgL_metaz00_5613))
{ /* Llib/mpd.scm 520 */
int BgL_arg1992z00_5614;
BgL_arg1992z00_5614 = 
BGl_musiczd2songzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_5011)); 
return 
BGl_playlistinfoz00zz__multimediazd2mpdzd2(BgL_dbz00_5012, BgL_backendz00_5011, BgL_linez00_5013, BgL_ipz00_5014, BgL_opz00_5610, BgL_arg1992z00_5614);}  else 
{ /* Llib/mpd.scm 521 */
int BgL_numz00_5615;obj_t BgL_dirz00_5616;
BgL_numz00_5615 = 
BGl_musiczd2songzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_5011)); 
BgL_dirz00_5616 = 
BGl_dirnamez00zz__osz00(BgL_filez00_5611); 
{ /* Llib/mpd.scm 523 */
obj_t BgL_tmpz00_7052;
BgL_tmpz00_7052 = 
((obj_t)BgL_opz00_5610); 
bgl_display_string(BGl_string3378z00zz__multimediazd2mpdzd2, BgL_tmpz00_7052); } 
bgl_display_obj(BgL_pathz00_5612, BgL_opz00_5610); 
{ /* Llib/mpd.scm 525 */
obj_t BgL_tmpz00_7056;
BgL_tmpz00_7056 = 
((obj_t)BgL_opz00_5610); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7056); } 
{ /* Llib/mpd.scm 527 */
obj_t BgL_tmpz00_7059;
BgL_tmpz00_7059 = 
((obj_t)BgL_opz00_5610); 
bgl_display_string(BGl_string3379z00zz__multimediazd2mpdzd2, BgL_tmpz00_7059); } 
bgl_display_obj(
BINT(BgL_numz00_5615), BgL_opz00_5610); 
{ /* Llib/mpd.scm 529 */
obj_t BgL_tmpz00_7064;
BgL_tmpz00_7064 = 
((obj_t)BgL_opz00_5610); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7064); } 
{ /* Llib/mpd.scm 530 */
obj_t BgL_tmpz00_7067;
BgL_tmpz00_7067 = 
((obj_t)BgL_opz00_5610); 
bgl_display_string(BGl_string3380z00zz__multimediazd2mpdzd2, BgL_tmpz00_7067); } 
bgl_display_obj(
BINT(BgL_numz00_5615), BgL_opz00_5610); 
{ /* Llib/mpd.scm 532 */
obj_t BgL_tmpz00_7072;
BgL_tmpz00_7072 = 
((obj_t)BgL_opz00_5610); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7072); } 
{ /* Llib/mpd.scm 533 */
obj_t BgL_caz00_5617;
BgL_caz00_5617 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
CNST_TABLE_REF(((long)60)), BgL_metaz00_5613); 
{ /* Llib/mpd.scm 533 */
obj_t BgL_ctz00_5618;
BgL_ctz00_5618 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
CNST_TABLE_REF(((long)61)), BgL_metaz00_5613); 
{ /* Llib/mpd.scm 534 */
obj_t BgL_cbz00_5619;
BgL_cbz00_5619 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
CNST_TABLE_REF(((long)62)), BgL_metaz00_5613); 
{ /* Llib/mpd.scm 535 */
obj_t BgL_az00_5620;
if(
PAIRP(BgL_caz00_5617))
{ /* Llib/mpd.scm 536 */
BgL_az00_5620 = 
CDR(BgL_caz00_5617); }  else 
{ /* Llib/mpd.scm 536 */
BgL_az00_5620 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_5616))); } 
{ /* Llib/mpd.scm 536 */
obj_t BgL_tz00_5621;
if(
PAIRP(BgL_ctz00_5618))
{ /* Llib/mpd.scm 539 */
BgL_tz00_5621 = 
CDR(BgL_ctz00_5618); }  else 
{ /* Llib/mpd.scm 539 */
BgL_tz00_5621 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(BgL_filez00_5611)); } 
{ /* Llib/mpd.scm 539 */
obj_t BgL_bz00_5622;
if(
PAIRP(BgL_cbz00_5619))
{ /* Llib/mpd.scm 542 */
BgL_bz00_5622 = 
CDR(BgL_cbz00_5619); }  else 
{ /* Llib/mpd.scm 542 */
BgL_bz00_5622 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(BgL_dirz00_5616)); } 
{ /* Llib/mpd.scm 542 */

{ /* Llib/mpd.scm 545 */
obj_t BgL_tmpz00_7097;
BgL_tmpz00_7097 = 
((obj_t)BgL_opz00_5610); 
bgl_display_string(BGl_string3381z00zz__multimediazd2mpdzd2, BgL_tmpz00_7097); } 
bgl_display_obj(BgL_az00_5620, BgL_opz00_5610); 
{ /* Llib/mpd.scm 545 */
obj_t BgL_tmpz00_7101;
BgL_tmpz00_7101 = 
((obj_t)BgL_opz00_5610); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7101); } 
{ /* Llib/mpd.scm 546 */
obj_t BgL_tmpz00_7104;
BgL_tmpz00_7104 = 
((obj_t)BgL_opz00_5610); 
bgl_display_string(BGl_string3382z00zz__multimediazd2mpdzd2, BgL_tmpz00_7104); } 
bgl_display_obj(BgL_tz00_5621, BgL_opz00_5610); 
{ /* Llib/mpd.scm 546 */
obj_t BgL_tmpz00_7108;
BgL_tmpz00_7108 = 
((obj_t)BgL_opz00_5610); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7108); } 
{ /* Llib/mpd.scm 547 */
obj_t BgL_tmpz00_7111;
BgL_tmpz00_7111 = 
((obj_t)BgL_opz00_5610); 
bgl_display_string(BGl_string3383z00zz__multimediazd2mpdzd2, BgL_tmpz00_7111); } 
bgl_display_obj(BgL_bz00_5622, BgL_opz00_5610); 
{ /* Llib/mpd.scm 547 */
obj_t BgL_tmpz00_7115;
BgL_tmpz00_7115 = 
((obj_t)BgL_opz00_5610); 
return 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7115);} } } } } } } } } } } } } } 
BGL_FUNCTION_END;
}



/* &mpd-currentsong */
obj_t BGl_z62mpdzd2currentsongzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4781, obj_t BgL_dbz00_4782, obj_t BgL_backendz00_4783, obj_t BgL_linez00_4784, obj_t BgL_ipz00_4785, obj_t BgL_opz00_4786)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 579 */
{ /* Llib/mpd.scm 580 */
obj_t BgL_plistz00_5632;int BgL_numz00_5633;
BgL_plistz00_5632 = 
BGl_musiczd2playlistzd2getz00zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4783)); 
BgL_numz00_5633 = 
BGl_musiczd2songzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4783)); 
{ /* Llib/mpd.scm 582 */
bool_t BgL_testz00_7122;
if(
(
(long)(BgL_numz00_5633)>=((long)0)))
{ /* Llib/mpd.scm 582 */
BgL_testz00_7122 = 
(
(long)(BgL_numz00_5633)<
bgl_list_length(BgL_plistz00_5632))
; }  else 
{ /* Llib/mpd.scm 582 */
BgL_testz00_7122 = ((bool_t)0)
; } 
if(BgL_testz00_7122)
{ /* Llib/mpd.scm 568 */
bool_t BgL_testz00_7129;
if(
(BgL_plistz00_5632==BGl_currentsongzd2cachezd2plistz00zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 568 */
BgL_testz00_7129 = 
(BGl_currentsongzd2cachezd2numz00zz__multimediazd2mpdzd2==
(long)(BgL_numz00_5633))
; }  else 
{ /* Llib/mpd.scm 568 */
BgL_testz00_7129 = ((bool_t)0)
; } 
if(BgL_testz00_7129)
{ /* Llib/mpd.scm 568 */
bgl_display_obj(BGl_currentsongzd2cachezd2infoz00zz__multimediazd2mpdzd2, BgL_opz00_4786); }  else 
{ /* Llib/mpd.scm 570 */
obj_t BgL_infoz00_5634;
BgL_infoz00_5634 = 
BGl_currentsongzd2infozd2zz__multimediazd2mpdzd2(BgL_dbz00_4782, BgL_backendz00_4783, BgL_plistz00_5632, BgL_numz00_5633, BgL_linez00_4784, BgL_ipz00_4785); 
BGl_currentsongzd2cachezd2plistz00zz__multimediazd2mpdzd2 = BgL_plistz00_5632; 
BGl_currentsongzd2cachezd2numz00zz__multimediazd2mpdzd2 = 
(long)(BgL_numz00_5633); 
BGl_currentsongzd2cachezd2infoz00zz__multimediazd2mpdzd2 = BgL_infoz00_5634; 
bgl_display_obj(BgL_infoz00_5634, BgL_opz00_4786); } }  else 
{ /* Llib/mpd.scm 582 */BFALSE; } } 
return 
CNST_TABLE_REF(((long)53));} } 
BGL_FUNCTION_END;
}



/* &mpd-play */
obj_t BGl_z62mpdzd2playzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4787, obj_t BgL_dbz00_4788, obj_t BgL_backendz00_4789, obj_t BgL_linez00_4790, obj_t BgL_ipz00_4791, obj_t BgL_opz00_4792)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 589 */
{ /* Llib/mpd.scm 589 */
obj_t BgL_numz00_5635;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5636;
BgL_strz00_5636 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4790, ((long)1)); 
if(
STRINGP(BgL_strz00_5636))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7142;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7143;
BgL_tmpz00_7143 = 
BSTRING_TO_STRING(BgL_strz00_5636); 
BgL_tmpz00_7142 = 
BGL_STRTOL(BgL_tmpz00_7143, ((long)0), ((long)10)); } 
BgL_numz00_5635 = 
BINT(BgL_tmpz00_7142); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5635 = BFALSE; } } 
{ /* Llib/mpd.scm 590 */
bool_t BgL_testz00_7147;
if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_numz00_5635))
{ /* Llib/mpd.scm 590 */
BgL_testz00_7147 = 
(
(long)CINT(BgL_numz00_5635)>=((long)0))
; }  else 
{ /* Llib/mpd.scm 590 */
BgL_testz00_7147 = ((bool_t)0)
; } 
if(BgL_testz00_7147)
{ /* Llib/mpd.scm 591 */
obj_t BgL_list2008z00_5637;
BgL_list2008z00_5637 = 
MAKE_YOUNG_PAIR(BgL_numz00_5635, BNIL); 
BGl_musiczd2playzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4789), BgL_list2008z00_5637); }  else 
{ /* Llib/mpd.scm 590 */
BGl_musiczd2playzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4789), BNIL); } } 
return 
CNST_TABLE_REF(((long)53));} } 
BGL_FUNCTION_END;
}



/* &mpd-playid */
obj_t BGl_z62mpdzd2playidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4793, obj_t BgL_dbz00_4794, obj_t BgL_backendz00_4795, obj_t BgL_linez00_4796, obj_t BgL_ipz00_4797, obj_t BgL_opz00_4798)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 598 */
{ /* Llib/mpd.scm 598 */
obj_t BgL_numz00_5638;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5639;
BgL_strz00_5639 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4796, ((long)1)); 
if(
STRINGP(BgL_strz00_5639))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7161;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7162;
BgL_tmpz00_7162 = 
BSTRING_TO_STRING(BgL_strz00_5639); 
BgL_tmpz00_7161 = 
BGL_STRTOL(BgL_tmpz00_7162, ((long)0), ((long)10)); } 
BgL_numz00_5638 = 
BINT(BgL_tmpz00_7161); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5638 = BFALSE; } } 
{ /* Llib/mpd.scm 599 */
bool_t BgL_testz00_7166;
if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_numz00_5638))
{ /* Llib/mpd.scm 599 */
BgL_testz00_7166 = 
(
(long)CINT(BgL_numz00_5638)>=((long)0))
; }  else 
{ /* Llib/mpd.scm 599 */
BgL_testz00_7166 = ((bool_t)0)
; } 
if(BgL_testz00_7166)
{ /* Llib/mpd.scm 600 */
obj_t BgL_list2012z00_5640;
BgL_list2012z00_5640 = 
MAKE_YOUNG_PAIR(BgL_numz00_5638, BNIL); 
BGl_musiczd2playzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4795), BgL_list2012z00_5640); }  else 
{ /* Llib/mpd.scm 599 */
BGl_musiczd2playzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4795), BNIL); } } 
return 
CNST_TABLE_REF(((long)53));} } 
BGL_FUNCTION_END;
}



/* &mpd-seek */
obj_t BGl_z62mpdzd2seekzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4799, obj_t BgL_dbz00_4800, obj_t BgL_backendz00_4801, obj_t BgL_linez00_4802, obj_t BgL_ipz00_4803, obj_t BgL_opz00_4804)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 607 */
{ /* Llib/mpd.scm 607 */
obj_t BgL_num1z00_5641;obj_t BgL_num2z00_5642;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5643;
BgL_strz00_5643 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4802, ((long)1)); 
if(
STRINGP(BgL_strz00_5643))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7180;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7181;
BgL_tmpz00_7181 = 
BSTRING_TO_STRING(BgL_strz00_5643); 
BgL_tmpz00_7180 = 
BGL_STRTOL(BgL_tmpz00_7181, ((long)0), ((long)10)); } 
BgL_num1z00_5641 = 
BINT(BgL_tmpz00_7180); }  else 
{ /* Llib/mpd.scm 223 */
BgL_num1z00_5641 = BFALSE; } } 
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5644;
BgL_strz00_5644 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4802, ((long)2)); 
if(
STRINGP(BgL_strz00_5644))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7188;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7189;
BgL_tmpz00_7189 = 
BSTRING_TO_STRING(BgL_strz00_5644); 
BgL_tmpz00_7188 = 
BGL_STRTOL(BgL_tmpz00_7189, ((long)0), ((long)10)); } 
BgL_num2z00_5642 = 
BINT(BgL_tmpz00_7188); }  else 
{ /* Llib/mpd.scm 223 */
BgL_num2z00_5642 = BFALSE; } } 
{ /* Llib/mpd.scm 608 */
obj_t BgL_list2014z00_5645;
BgL_list2014z00_5645 = 
MAKE_YOUNG_PAIR(BgL_num1z00_5641, BNIL); 
BGl_musiczd2seekzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4801), BgL_num2z00_5642, BgL_list2014z00_5645); } 
return 
CNST_TABLE_REF(((long)53));} } 
BGL_FUNCTION_END;
}



/* &mpd-seekid */
obj_t BGl_z62mpdzd2seekidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4805, obj_t BgL_dbz00_4806, obj_t BgL_backendz00_4807, obj_t BgL_linez00_4808, obj_t BgL_ipz00_4809, obj_t BgL_opz00_4810)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 614 */
{ /* Llib/mpd.scm 614 */
obj_t BgL_num1z00_5646;obj_t BgL_num2z00_5647;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5648;
BgL_strz00_5648 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4808, ((long)1)); 
if(
STRINGP(BgL_strz00_5648))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7200;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7201;
BgL_tmpz00_7201 = 
BSTRING_TO_STRING(BgL_strz00_5648); 
BgL_tmpz00_7200 = 
BGL_STRTOL(BgL_tmpz00_7201, ((long)0), ((long)10)); } 
BgL_num1z00_5646 = 
BINT(BgL_tmpz00_7200); }  else 
{ /* Llib/mpd.scm 223 */
BgL_num1z00_5646 = BFALSE; } } 
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5649;
BgL_strz00_5649 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4808, ((long)2)); 
if(
STRINGP(BgL_strz00_5649))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7208;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7209;
BgL_tmpz00_7209 = 
BSTRING_TO_STRING(BgL_strz00_5649); 
BgL_tmpz00_7208 = 
BGL_STRTOL(BgL_tmpz00_7209, ((long)0), ((long)10)); } 
BgL_num2z00_5647 = 
BINT(BgL_tmpz00_7208); }  else 
{ /* Llib/mpd.scm 223 */
BgL_num2z00_5647 = BFALSE; } } 
{ /* Llib/mpd.scm 615 */
obj_t BgL_list2015z00_5650;
BgL_list2015z00_5650 = 
MAKE_YOUNG_PAIR(BgL_num1z00_5646, BNIL); 
BGl_musiczd2seekzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4807), BgL_num2z00_5647, BgL_list2015z00_5650); } 
return 
CNST_TABLE_REF(((long)53));} } 
BGL_FUNCTION_END;
}



/* &mpd-stop */
obj_t BGl_z62mpdzd2stopzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4811, obj_t BgL_dbz00_4812, obj_t BgL_backendz00_4813, obj_t BgL_linez00_4814, obj_t BgL_ipz00_4815, obj_t BgL_opz00_4816)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 621 */
BGl_musiczd2stopzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4813)); 
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* &mpd-pause */
obj_t BGl_z62mpdzd2pausezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4817, obj_t BgL_dbz00_4818, obj_t BgL_backendz00_4819, obj_t BgL_linez00_4820, obj_t BgL_ipz00_4821, obj_t BgL_opz00_4822)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 628 */
BGl_musiczd2pausezd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4819)); 
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* <exit:2022>~0 */
obj_t BGl_zc3exitza32022ze3ze70z64zz__multimediazd2mpdzd2(obj_t BgL_backendz00_5414, obj_t BgL_res1111z00_5413)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 636 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1117z00_1005;
if( SET_EXIT(BgL_an_exit1117z00_1005) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  bgl_restore_signal_handlers();
#endif

BgL_an_exit1117z00_1005 = 
(void *)jmpbuf; 
{ /* Llib/mpd.scm 636 */

PUSH_EXIT(BgL_an_exit1117z00_1005, ((long)1)); 
{ /* Llib/mpd.scm 636 */
obj_t BgL_an_exitd1118z00_1006;
BgL_an_exitd1118z00_1006 = 
((obj_t)(&exitd)); 
{ /* Llib/mpd.scm 636 */
bool_t BgL_res1120z00_1009;
{ /* Llib/mpd.scm 636 */
obj_t BgL_ohs1109z00_1010;
BgL_ohs1109z00_1010 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Llib/mpd.scm 636 */
obj_t BgL_exitd1114z00_1011;
BgL_exitd1114z00_1011 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3anonymousza32026ze3z83_5019;
BgL_zc3anonymousza32026ze3z83_5019 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32026ze3ze1zz__multimediazd2mpdzd2, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza32026ze3z83_5019, 
(int)(((long)0)), BgL_ohs1109z00_1010); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1114z00_1011, BgL_zc3anonymousza32026ze3z83_5019); 
{ /* Llib/mpd.scm 636 */
bool_t BgL_tmp1116z00_1013;
{ /* Llib/mpd.scm 636 */
obj_t BgL_arg2023z00_1014;
{ /* Llib/mpd.scm 636 */
obj_t BgL_zc3anonymousza32025ze3z83_5018;
BgL_zc3anonymousza32025ze3z83_5018 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32025ze3ze1zz__multimediazd2mpdzd2, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3anonymousza32025ze3z83_5018, 
(int)(((long)0)), 
((obj_t)BgL_res1111z00_5413)); 
PROCEDURE_SET(BgL_zc3anonymousza32025ze3z83_5018, 
(int)(((long)1)), BgL_an_exitd1118z00_1006); 
BgL_arg2023z00_1014 = 
MAKE_YOUNG_PAIR(BgL_zc3anonymousza32025ze3z83_5018, BgL_ohs1109z00_1010); } 
BGL_ERROR_HANDLER_SET(BgL_arg2023z00_1014); BUNSPEC; } 
{ /* Llib/mpd.scm 636 */
obj_t BgL_auxz00_5028;
BGl_musiczd2nextzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_5414)); 
BgL_auxz00_5028 = 
CNST_TABLE_REF(((long)53)); 
CELL_SET(BgL_res1111z00_5413, BgL_auxz00_5028); } 
BgL_tmp1116z00_1013 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1114z00_1011); 
BGL_ERROR_HANDLER_SET(BgL_ohs1109z00_1010); BUNSPEC; 
BgL_res1120z00_1009 = BgL_tmp1116z00_1013; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1120z00_1009);} } } 
} } 
BGL_FUNCTION_END;
}



/* &mpd-next */
obj_t BGl_z62mpdzd2nextzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4823, obj_t BgL_dbz00_4824, obj_t BgL_backendz00_4825, obj_t BgL_linez00_4826, obj_t BgL_ipz00_4827, obj_t BgL_opz00_4828)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 635 */
{ /* Llib/mpd.scm 636 */
obj_t BgL_res1111z00_5651;
BgL_res1111z00_5651 = 
MAKE_CELL(BUNSPEC); 
{ 
obj_t BgL_ez00_5653;
if(
CBOOL(
BGl_zc3exitza32022ze3ze70z64zz__multimediazd2mpdzd2(BgL_backendz00_4825, BgL_res1111z00_5651)))
{ /* Llib/mpd.scm 636 */
BgL_ez00_5653 = 
CELL_REF(BgL_res1111z00_5651); 
if(
BGl_isazf3zf3zz__objectz00(BgL_ez00_5653, BGl_z62iozd2errorzb0zz__objectz00))
{ /* Llib/mpd.scm 638 */
{ /* Llib/mpd.scm 325 */
obj_t BgL_tmpz00_7255;
BgL_tmpz00_7255 = 
((obj_t)BgL_opz00_4828); 
bgl_display_string(BGl_string3349z00zz__multimediazd2mpdzd2, BgL_tmpz00_7255); } 
bgl_display_obj(BGl_string3384z00zz__multimediazd2mpdzd2, BgL_opz00_4828); 
{ /* Llib/mpd.scm 327 */
obj_t BgL_tmpz00_7259;
BgL_tmpz00_7259 = 
((obj_t)BgL_opz00_4828); 
bgl_display_string(BGl_string3351z00zz__multimediazd2mpdzd2, BgL_tmpz00_7259); } 
bgl_display_obj(BGl_string3385z00zz__multimediazd2mpdzd2, BgL_opz00_4828); 
{ /* Llib/mpd.scm 329 */
obj_t BgL_tmpz00_7263;
BgL_tmpz00_7263 = 
((obj_t)BgL_opz00_4828); 
bgl_display_string(BGl_string3352z00zz__multimediazd2mpdzd2, BgL_tmpz00_7263); } 
bgl_display_obj(BGl_string3386z00zz__multimediazd2mpdzd2, BgL_opz00_4828); 
{ /* Llib/mpd.scm 331 */
obj_t BgL_tmpz00_7267;
BgL_tmpz00_7267 = 
((obj_t)BgL_opz00_4828); 
bgl_display_string(BGl_string3353z00zz__multimediazd2mpdzd2, BgL_tmpz00_7267); } 
{ /* Llib/mpd.scm 332 */
obj_t BgL_tmpz00_7270;
BgL_tmpz00_7270 = 
((obj_t)BgL_opz00_4828); 
bgl_flush_output_port(BgL_tmpz00_7270); } 
return 
CNST_TABLE_REF(((long)54));}  else 
{ /* Llib/mpd.scm 638 */
return 
BGl_raisez00zz__errorz00(BgL_ez00_5653);} }  else 
{ /* Llib/mpd.scm 636 */
return 
CELL_REF(BgL_res1111z00_5651);} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2025> */
obj_t BGl_z62zc3anonymousza32025ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5020, obj_t BgL_ez00_5023)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 636 */
{ /* Llib/mpd.scm 636 */
obj_t BgL_res1111z00_5021;obj_t BgL_an_exitd1118z00_5022;
BgL_res1111z00_5021 = 
PROCEDURE_REF(BgL_envz00_5020, 
(int)(((long)0))); 
BgL_an_exitd1118z00_5022 = 
PROCEDURE_REF(BgL_envz00_5020, 
(int)(((long)1))); 
CELL_SET(BgL_res1111z00_5021, BgL_ez00_5023); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1118z00_5022, BTRUE);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2026> */
obj_t BGl_z62zc3anonymousza32026ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5025)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 636 */
{ 
obj_t BgL_ohs1109z00_5026;
BgL_ohs1109z00_5026 = 
PROCEDURE_REF(BgL_envz00_5025, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1109z00_5026); 
return BUNSPEC;} } 
BGL_FUNCTION_END;
}



/* <exit:2035>~0 */
obj_t BGl_zc3exitza32035ze3ze70z64zz__multimediazd2mpdzd2(obj_t BgL_backendz00_5412, obj_t BgL_res1123z00_5411)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 649 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1129z00_1048;
if( SET_EXIT(BgL_an_exit1129z00_1048) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  bgl_restore_signal_handlers();
#endif

BgL_an_exit1129z00_1048 = 
(void *)jmpbuf; 
{ /* Llib/mpd.scm 649 */

PUSH_EXIT(BgL_an_exit1129z00_1048, ((long)1)); 
{ /* Llib/mpd.scm 649 */
obj_t BgL_an_exitd1130z00_1049;
BgL_an_exitd1130z00_1049 = 
((obj_t)(&exitd)); 
{ /* Llib/mpd.scm 649 */
bool_t BgL_res1132z00_1052;
{ /* Llib/mpd.scm 649 */
obj_t BgL_ohs1121z00_1053;
BgL_ohs1121z00_1053 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Llib/mpd.scm 649 */
obj_t BgL_exitd1126z00_1054;
BgL_exitd1126z00_1054 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3anonymousza32039ze3z83_5031;
BgL_zc3anonymousza32039ze3z83_5031 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32039ze3ze1zz__multimediazd2mpdzd2, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza32039ze3z83_5031, 
(int)(((long)0)), BgL_ohs1121z00_1053); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1126z00_1054, BgL_zc3anonymousza32039ze3z83_5031); 
{ /* Llib/mpd.scm 649 */
bool_t BgL_tmp1128z00_1056;
{ /* Llib/mpd.scm 649 */
obj_t BgL_arg2036z00_1057;
{ /* Llib/mpd.scm 649 */
obj_t BgL_zc3anonymousza32038ze3z83_5030;
BgL_zc3anonymousza32038ze3z83_5030 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32038ze3ze1zz__multimediazd2mpdzd2, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3anonymousza32038ze3z83_5030, 
(int)(((long)0)), 
((obj_t)BgL_res1123z00_5411)); 
PROCEDURE_SET(BgL_zc3anonymousza32038ze3z83_5030, 
(int)(((long)1)), BgL_an_exitd1130z00_1049); 
BgL_arg2036z00_1057 = 
MAKE_YOUNG_PAIR(BgL_zc3anonymousza32038ze3z83_5030, BgL_ohs1121z00_1053); } 
BGL_ERROR_HANDLER_SET(BgL_arg2036z00_1057); BUNSPEC; } 
{ /* Llib/mpd.scm 649 */
obj_t BgL_auxz00_5040;
BGl_musiczd2prevzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_5412)); 
BgL_auxz00_5040 = 
CNST_TABLE_REF(((long)53)); 
CELL_SET(BgL_res1123z00_5411, BgL_auxz00_5040); } 
BgL_tmp1128z00_1056 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1126z00_1054); 
BGL_ERROR_HANDLER_SET(BgL_ohs1121z00_1053); BUNSPEC; 
BgL_res1132z00_1052 = BgL_tmp1128z00_1056; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1132z00_1052);} } } 
} } 
BGL_FUNCTION_END;
}



/* &mpd-previous */
obj_t BGl_z62mpdzd2previouszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4829, obj_t BgL_dbz00_4830, obj_t BgL_backendz00_4831, obj_t BgL_linez00_4832, obj_t BgL_ipz00_4833, obj_t BgL_opz00_4834)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 648 */
{ /* Llib/mpd.scm 649 */
obj_t BgL_res1123z00_5654;
BgL_res1123z00_5654 = 
MAKE_CELL(BUNSPEC); 
{ 
obj_t BgL_ez00_5656;
if(
CBOOL(
BGl_zc3exitza32035ze3ze70z64zz__multimediazd2mpdzd2(BgL_backendz00_4831, BgL_res1123z00_5654)))
{ /* Llib/mpd.scm 649 */
BgL_ez00_5656 = 
CELL_REF(BgL_res1123z00_5654); 
if(
BGl_isazf3zf3zz__objectz00(BgL_ez00_5656, BGl_z62iozd2errorzb0zz__objectz00))
{ /* Llib/mpd.scm 651 */
{ /* Llib/mpd.scm 325 */
obj_t BgL_tmpz00_7315;
BgL_tmpz00_7315 = 
((obj_t)BgL_opz00_4834); 
bgl_display_string(BGl_string3349z00zz__multimediazd2mpdzd2, BgL_tmpz00_7315); } 
bgl_display_obj(BGl_string3384z00zz__multimediazd2mpdzd2, BgL_opz00_4834); 
{ /* Llib/mpd.scm 327 */
obj_t BgL_tmpz00_7319;
BgL_tmpz00_7319 = 
((obj_t)BgL_opz00_4834); 
bgl_display_string(BGl_string3351z00zz__multimediazd2mpdzd2, BgL_tmpz00_7319); } 
bgl_display_obj(BGl_string3387z00zz__multimediazd2mpdzd2, BgL_opz00_4834); 
{ /* Llib/mpd.scm 329 */
obj_t BgL_tmpz00_7323;
BgL_tmpz00_7323 = 
((obj_t)BgL_opz00_4834); 
bgl_display_string(BGl_string3352z00zz__multimediazd2mpdzd2, BgL_tmpz00_7323); } 
bgl_display_obj(BGl_string3388z00zz__multimediazd2mpdzd2, BgL_opz00_4834); 
{ /* Llib/mpd.scm 331 */
obj_t BgL_tmpz00_7327;
BgL_tmpz00_7327 = 
((obj_t)BgL_opz00_4834); 
bgl_display_string(BGl_string3353z00zz__multimediazd2mpdzd2, BgL_tmpz00_7327); } 
{ /* Llib/mpd.scm 332 */
obj_t BgL_tmpz00_7330;
BgL_tmpz00_7330 = 
((obj_t)BgL_opz00_4834); 
bgl_flush_output_port(BgL_tmpz00_7330); } 
return 
CNST_TABLE_REF(((long)54));}  else 
{ /* Llib/mpd.scm 651 */
return 
BGl_raisez00zz__errorz00(BgL_ez00_5656);} }  else 
{ /* Llib/mpd.scm 649 */
return 
CELL_REF(BgL_res1123z00_5654);} } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2038> */
obj_t BGl_z62zc3anonymousza32038ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5032, obj_t BgL_ez00_5035)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 649 */
{ /* Llib/mpd.scm 649 */
obj_t BgL_res1123z00_5033;obj_t BgL_an_exitd1130z00_5034;
BgL_res1123z00_5033 = 
PROCEDURE_REF(BgL_envz00_5032, 
(int)(((long)0))); 
BgL_an_exitd1130z00_5034 = 
PROCEDURE_REF(BgL_envz00_5032, 
(int)(((long)1))); 
CELL_SET(BgL_res1123z00_5033, BgL_ez00_5035); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1130z00_5034, BTRUE);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2039> */
obj_t BGl_z62zc3anonymousza32039ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5037)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 649 */
{ 
obj_t BgL_ohs1121z00_5038;
BgL_ohs1121z00_5038 = 
PROCEDURE_REF(BgL_envz00_5037, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1121z00_5038); 
return BUNSPEC;} } 
BGL_FUNCTION_END;
}



/* &mpd-volume */
obj_t BGl_z62mpdzd2volumezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4835, obj_t BgL_dbz00_4836, obj_t BgL_backendz00_4837, obj_t BgL_linez00_4838, obj_t BgL_ipz00_4839, obj_t BgL_opz00_4840)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 661 */
{ /* Llib/mpd.scm 661 */
obj_t BgL_intz00_5657;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5658;
BgL_strz00_5658 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4838, ((long)1)); 
if(
STRINGP(BgL_strz00_5658))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7346;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7347;
BgL_tmpz00_7347 = 
BSTRING_TO_STRING(BgL_strz00_5658); 
BgL_tmpz00_7346 = 
BGL_STRTOL(BgL_tmpz00_7347, ((long)0), ((long)10)); } 
BgL_intz00_5657 = 
BINT(BgL_tmpz00_7346); }  else 
{ /* Llib/mpd.scm 223 */
BgL_intz00_5657 = BFALSE; } } 
if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_intz00_5657))
{ /* Llib/mpd.scm 662 */
BGl_musiczd2volumezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4837), BgL_intz00_5657); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 662 */
{ /* Llib/mpd.scm 670 */
obj_t BgL_arg2043z00_5659;
BgL_arg2043z00_5659 = 
BGl_musiczd2volumezd2getz00zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4837)); 
bgl_display_obj(BgL_arg2043z00_5659, BgL_opz00_4840); } 
{ /* Llib/mpd.scm 671 */
obj_t BgL_tmpz00_7359;
BgL_tmpz00_7359 = 
((obj_t)BgL_opz00_4840); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7359); } 
return 
CNST_TABLE_REF(((long)53));} } } 
BGL_FUNCTION_END;
}



/* &mpd-setvol */
obj_t BGl_z62mpdzd2setvolzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4841, obj_t BgL_dbz00_4842, obj_t BgL_backendz00_4843, obj_t BgL_linez00_4844, obj_t BgL_ipz00_4845, obj_t BgL_opz00_4846)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 684 */
{ /* Llib/mpd.scm 684 */
obj_t BgL_intz00_5660;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5661;
BgL_strz00_5661 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4844, ((long)1)); 
if(
STRINGP(BgL_strz00_5661))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7366;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7367;
BgL_tmpz00_7367 = 
BSTRING_TO_STRING(BgL_strz00_5661); 
BgL_tmpz00_7366 = 
BGL_STRTOL(BgL_tmpz00_7367, ((long)0), ((long)10)); } 
BgL_intz00_5660 = 
BINT(BgL_tmpz00_7366); }  else 
{ /* Llib/mpd.scm 223 */
BgL_intz00_5660 = BFALSE; } } 
BGl_musiczd2volumezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4843), BgL_intz00_5660); 
return 
CNST_TABLE_REF(((long)53));} } 
BGL_FUNCTION_END;
}



/* &mpd-clearerror */
obj_t BGl_z62mpdzd2clearerrorzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4847, obj_t BgL_dbz00_4848, obj_t BgL_backendz00_4849, obj_t BgL_linez00_4850, obj_t BgL_ipz00_4851, obj_t BgL_opz00_4852)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 690 */
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* &mpd-close */
obj_t BGl_z62mpdzd2closezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4853, obj_t BgL_dbz00_4854, obj_t BgL_backendz00_4855, obj_t BgL_linez00_4856, obj_t BgL_ipz00_4857, obj_t BgL_opz00_4858)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 696 */
return 
CNST_TABLE_REF(((long)24));} 
BGL_FUNCTION_END;
}



/* &mpd-stats */
obj_t BGl_z62mpdzd2statszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4859, obj_t BgL_dbz00_4860, obj_t BgL_backendz00_4861, obj_t BgL_linez00_4862, obj_t BgL_ipz00_4863, obj_t BgL_opz00_4864)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 702 */
BGl_mpdzd2databasezd2statsz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4860), BgL_backendz00_4861, BgL_opz00_4864); 
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* &mpd-listall */
obj_t BGl_z62mpdzd2listallzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4865, obj_t BgL_dbz00_4866, obj_t BgL_backendz00_4867, obj_t BgL_linez00_4868, obj_t BgL_ipz00_4869, obj_t BgL_opz00_4870)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 709 */
BGl_mpdzd2databasezd2listallz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4866), BgL_opz00_4870); 
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* &mpd-list */
obj_t BGl_z62mpdzd2listzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4871, obj_t BgL_dbz00_4872, obj_t BgL_backendz00_4873, obj_t BgL_linez00_4874, obj_t BgL_ipz00_4875, obj_t BgL_opz00_4876)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 716 */
{ /* Llib/mpd.scm 716 */
obj_t BgL_symz00_5662;obj_t BgL_string2z00_5663;obj_t BgL_string3z00_5664;
BgL_symz00_5662 = 
BGl_getzd2linezd2argzd2symbolzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4874, ((long)1)); 
BgL_string2z00_5663 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4874, ((long)2)); 
BgL_string3z00_5664 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4874, ((long)3)); 
if(
(BgL_symz00_5662==
CNST_TABLE_REF(((long)62))))
{ /* Llib/mpd.scm 717 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(BgL_string2z00_5663, BGl_string3389z00zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 720 */
BGl_mpdzd2databasezd2listartistalbumz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4872), BgL_opz00_4876, BgL_string3z00_5664); }  else 
{ /* Llib/mpd.scm 720 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(BgL_string2z00_5663, BGl_string3390z00zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 722 */
BGl_mpdzd2databasezd2listgenrealbumz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4872), BgL_opz00_4876, BgL_string3z00_5664); }  else 
{ /* Llib/mpd.scm 722 */
BGl_mpdzd2databasezd2listartistalbumz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4872), BgL_opz00_4876, BgL_string2z00_5663); } } 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 717 */
if(
(BgL_symz00_5662==
CNST_TABLE_REF(((long)60))))
{ /* Llib/mpd.scm 717 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(BgL_string2z00_5663, BGl_string3390z00zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 728 */
BGl_mpdzd2databasezd2listgenreartistz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4872), BgL_opz00_4876, BgL_string3z00_5664); }  else 
{ /* Llib/mpd.scm 728 */
BGl_mpdzd2databasezd2listartistz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4872), BgL_opz00_4876); } 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 717 */
if(
(BgL_symz00_5662==
CNST_TABLE_REF(((long)63))))
{ /* Llib/mpd.scm 717 */
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 717 */
if(
(BgL_symz00_5662==
CNST_TABLE_REF(((long)64))))
{ /* Llib/mpd.scm 717 */
BGl_mpdzd2databasezd2listgenrez00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4872), BgL_opz00_4876); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 717 */
if(
CBOOL(BgL_symz00_5662))
{ /* Llib/mpd.scm 740 */
obj_t BgL_list2051z00_5665;
BgL_list2051z00_5665 = 
MAKE_YOUNG_PAIR(BgL_symz00_5662, BNIL); 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3391z00zz__multimediazd2mpdzd2, BgL_list2051z00_5665);}  else 
{ /* Llib/mpd.scm 738 */
return BGl_string3392z00zz__multimediazd2mpdzd2;} } } } } } } 
BGL_FUNCTION_END;
}



/* &mpd-listallinfo */
obj_t BGl_z62mpdzd2listallinfozb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4877, obj_t BgL_dbz00_4878, obj_t BgL_backendz00_4879, obj_t BgL_linez00_4880, obj_t BgL_ipz00_4881, obj_t BgL_opz00_4882)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 745 */
{ /* Llib/mpd.scm 745 */
obj_t BgL_dirz00_5666;
BgL_dirz00_5666 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4880, ((long)1)); 
{ /* Llib/mpd.scm 746 */
obj_t BgL_arg2052z00_5667;
if(
CBOOL(BgL_dirz00_5666))
{ /* Llib/mpd.scm 746 */
BgL_arg2052z00_5667 = BgL_dirz00_5666; }  else 
{ /* Llib/mpd.scm 746 */
obj_t BgL_list2054z00_5668;
BgL_list2054z00_5668 = 
MAKE_YOUNG_PAIR(
BCHAR(FILE_SEPARATOR), BNIL); 
BgL_arg2052z00_5667 = 
BGl_listzd2ze3stringz31zz__r4_strings_6_7z00(BgL_list2054z00_5668); } 
BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4878), BgL_opz00_4882, BgL_arg2052z00_5667, ((bool_t)1)); } 
return 
CNST_TABLE_REF(((long)53));} } 
BGL_FUNCTION_END;
}



/* &mpd-lsinfo */
obj_t BGl_z62mpdzd2lsinfozb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4883, obj_t BgL_dbz00_4884, obj_t BgL_backendz00_4885, obj_t BgL_linez00_4886, obj_t BgL_ipz00_4887, obj_t BgL_opz00_4888)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 752 */
{ /* Llib/mpd.scm 752 */
obj_t BgL_dirz00_5669;
BgL_dirz00_5669 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4886, ((long)1)); 
{ /* Llib/mpd.scm 753 */
obj_t BgL_arg2055z00_5670;
if(
CBOOL(BgL_dirz00_5669))
{ /* Llib/mpd.scm 753 */
BgL_arg2055z00_5670 = BgL_dirz00_5669; }  else 
{ /* Llib/mpd.scm 753 */
obj_t BgL_list2057z00_5671;
BgL_list2057z00_5671 = 
MAKE_YOUNG_PAIR(
BCHAR(FILE_SEPARATOR), BNIL); 
BgL_arg2055z00_5670 = 
BGl_listzd2ze3stringz31zz__r4_strings_6_7z00(BgL_list2057z00_5671); } 
BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4884), BgL_opz00_4888, BgL_arg2055z00_5670, ((bool_t)0)); } 
return 
CNST_TABLE_REF(((long)53));} } 
BGL_FUNCTION_END;
}



/* &mpd-plconangesposid */
obj_t BGl_z62mpdzd2plconangesposidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4889, obj_t BgL_dbz00_4890, obj_t BgL_backendz00_4891, obj_t BgL_linez00_4892, obj_t BgL_ipz00_4893, obj_t BgL_opz00_4894)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 759 */
{ /* Llib/mpd.scm 759 */
obj_t BgL_intz00_5672;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5673;
BgL_strz00_5673 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4892, ((long)1)); 
if(
STRINGP(BgL_strz00_5673))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7444;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7445;
BgL_tmpz00_7445 = 
BSTRING_TO_STRING(BgL_strz00_5673); 
BgL_tmpz00_7444 = 
BGL_STRTOL(BgL_tmpz00_7445, ((long)0), ((long)10)); } 
BgL_intz00_5672 = 
BINT(BgL_tmpz00_7444); }  else 
{ /* Llib/mpd.scm 223 */
BgL_intz00_5672 = BFALSE; } } 
{ /* Llib/mpd.scm 760 */
long BgL_numz00_5674;
BgL_numz00_5674 = ((long)0); 
{ /* Llib/mpd.scm 761 */
obj_t BgL_g1198z00_5675;
BgL_g1198z00_5675 = 
BGl_musiczd2playlistzd2getz00zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4891)); 
{ 
obj_t BgL_l1196z00_5677;
BgL_l1196z00_5677 = BgL_g1198z00_5675; 
BgL_zc3anonymousza32058ze3z83_5676:
if(
PAIRP(BgL_l1196z00_5677))
{ /* Llib/mpd.scm 765 */
{ /* Llib/mpd.scm 762 */
obj_t BgL_tmpz00_7453;
BgL_tmpz00_7453 = 
((obj_t)BgL_opz00_4894); 
bgl_display_string(BGl_string3393z00zz__multimediazd2mpdzd2, BgL_tmpz00_7453); } 
bgl_display_obj(
BINT(BgL_numz00_5674), BgL_opz00_4894); 
{ /* Llib/mpd.scm 762 */
obj_t BgL_tmpz00_7458;
BgL_tmpz00_7458 = 
((obj_t)BgL_opz00_4894); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7458); } 
{ /* Llib/mpd.scm 763 */
obj_t BgL_tmpz00_7461;
BgL_tmpz00_7461 = 
((obj_t)BgL_opz00_4894); 
bgl_display_string(BGl_string3380z00zz__multimediazd2mpdzd2, BgL_tmpz00_7461); } 
bgl_display_obj(
BINT(BgL_numz00_5674), BgL_opz00_4894); 
{ /* Llib/mpd.scm 763 */
obj_t BgL_tmpz00_7466;
BgL_tmpz00_7466 = 
((obj_t)BgL_opz00_4894); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7466); } 
BgL_numz00_5674 = 
(BgL_numz00_5674+((long)1)); 
{ 
obj_t BgL_l1196z00_7470;
BgL_l1196z00_7470 = 
CDR(BgL_l1196z00_5677); 
BgL_l1196z00_5677 = BgL_l1196z00_7470; 
goto BgL_zc3anonymousza32058ze3z83_5676;} }  else 
{ /* Llib/mpd.scm 765 */((bool_t)1); } } } } 
return 
CNST_TABLE_REF(((long)53));} } 
BGL_FUNCTION_END;
}



/* &mpd-kill */
obj_t BGl_z62mpdzd2killzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4895, obj_t BgL_dbz00_4896, obj_t BgL_backendz00_4897, obj_t BgL_linez00_4898, obj_t BgL_ipz00_4899, obj_t BgL_opz00_4900)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 771 */
return 
CNST_TABLE_REF(((long)31));} 
BGL_FUNCTION_END;
}



/* &mpd-find */
obj_t BGl_z62mpdzd2findzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4901, obj_t BgL_dbz00_4902, obj_t BgL_backendz00_4903, obj_t BgL_linez00_4904, obj_t BgL_ipz00_4905, obj_t BgL_opz00_4906)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 777 */
{ /* Llib/mpd.scm 777 */
obj_t BgL_symbolz00_5678;obj_t BgL_string2z00_5679;
BgL_symbolz00_5678 = 
BGl_getzd2linezd2argzd2symbolzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4904, ((long)1)); 
BgL_string2z00_5679 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4904, ((long)2)); 
if(
(BgL_symbolz00_5678==
CNST_TABLE_REF(((long)62))))
{ /* Llib/mpd.scm 778 */
BGl_mpdzd2databasezd2findzd2albumzd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4902), BgL_opz00_4906, BgL_string2z00_5679); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 778 */
if(
(BgL_symbolz00_5678==
CNST_TABLE_REF(((long)60))))
{ /* Llib/mpd.scm 778 */
BGl_mpdzd2databasezd2findzd2artistzd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4902), BgL_opz00_4906, BgL_string2z00_5679); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 778 */
if(
(BgL_symbolz00_5678==
CNST_TABLE_REF(((long)61))))
{ /* Llib/mpd.scm 778 */
BGl_mpdzd2databasezd2findzd2titlezd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4902), BgL_opz00_4906, BgL_string2z00_5679); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 778 */
if(
(BgL_symbolz00_5678==
CNST_TABLE_REF(((long)64))))
{ /* Llib/mpd.scm 778 */
BGl_mpdzd2databasezd2findzd2genrezd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4902), BgL_opz00_4906, BgL_string2z00_5679); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 792 */
obj_t BgL_list2065z00_5680;
BgL_list2065z00_5680 = 
MAKE_YOUNG_PAIR(BgL_symbolz00_5678, BNIL); 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3394z00zz__multimediazd2mpdzd2, BgL_list2065z00_5680);} } } } } } 
BGL_FUNCTION_END;
}



/* &mpd-search */
obj_t BGl_z62mpdzd2searchzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4907, obj_t BgL_dbz00_4908, obj_t BgL_backendz00_4909, obj_t BgL_linez00_4910, obj_t BgL_ipz00_4911, obj_t BgL_opz00_4912)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 797 */
{ /* Llib/mpd.scm 797 */
obj_t BgL_symbol1z00_5681;obj_t BgL_string2z00_5682;obj_t BgL_symbol3z00_5683;obj_t BgL_string4z00_5684;
BgL_symbol1z00_5681 = 
BGl_getzd2linezd2argzd2symbolzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4910, ((long)1)); 
BgL_string2z00_5682 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4910, ((long)2)); 
BgL_symbol3z00_5683 = 
BGl_getzd2linezd2argzd2symbolzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4910, ((long)3)); 
BgL_string4z00_5684 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4910, ((long)4)); 
if(
(BgL_symbol1z00_5681==
CNST_TABLE_REF(((long)62))))
{ /* Llib/mpd.scm 798 */
BGl_mpdzd2databasezd2findzd2albumzd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4908), BgL_opz00_4912, BgL_string2z00_5682); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 798 */
if(
(BgL_symbol1z00_5681==
CNST_TABLE_REF(((long)60))))
{ /* Llib/mpd.scm 798 */
if(
(BgL_symbol3z00_5683==
CNST_TABLE_REF(((long)62))))
{ /* Llib/mpd.scm 803 */
BGl_mpdzd2databasezd2searchzd2artistzd2albumz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4908), BgL_opz00_4912, BgL_string2z00_5682, BgL_string4z00_5684); }  else 
{ /* Llib/mpd.scm 803 */
if(
(BgL_symbol3z00_5683==
CNST_TABLE_REF(((long)61))))
{ /* Llib/mpd.scm 803 */
BGl_mpdzd2databasezd2searchzd2artistzd2titlez00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4908), BgL_opz00_4912, BgL_string2z00_5682, BgL_string4z00_5684); }  else 
{ /* Llib/mpd.scm 803 */
BGl_mpdzd2databasezd2findzd2artistzd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4908), BgL_opz00_4912, BgL_string2z00_5682); } } 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 798 */
if(
(BgL_symbol1z00_5681==
CNST_TABLE_REF(((long)61))))
{ /* Llib/mpd.scm 798 */
BGl_mpdzd2databasezd2findzd2titlezd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4908), BgL_opz00_4912, BgL_string2z00_5682); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 798 */
if(
(BgL_symbol1z00_5681==
CNST_TABLE_REF(((long)64))))
{ /* Llib/mpd.scm 798 */
BGl_mpdzd2databasezd2findzd2genrezd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4908), BgL_opz00_4912, BgL_string2z00_5682); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 798 */
if(
(BgL_symbol1z00_5681==
CNST_TABLE_REF(((long)65))))
{ /* Llib/mpd.scm 798 */
BGl_mpdzd2databasezd2listallz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4908), BgL_opz00_4912); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 820 */
obj_t BgL_list2073z00_5685;
BgL_list2073z00_5685 = 
MAKE_YOUNG_PAIR(BgL_symbol1z00_5681, BNIL); 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3395z00zz__multimediazd2mpdzd2, BgL_list2073z00_5685);} } } } } } } 
BGL_FUNCTION_END;
}



/* &mpd-commands */
obj_t BGl_z62mpdzd2commandszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4913, obj_t BgL_dbz00_4914, obj_t BgL_backendz00_4915, obj_t BgL_linez00_4916, obj_t BgL_ipz00_4917, obj_t BgL_opz00_4918)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 825 */
{ /* Llib/mpd.scm 826 */
obj_t BgL_g1201z00_5686;
BgL_g1201z00_5686 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3396z00zz__multimediazd2mpdzd2, BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2); 
{ 
obj_t BgL_l1199z00_5689;
BgL_l1199z00_5689 = BgL_g1201z00_5686; 
BgL_zc3anonymousza32074ze3z83_5688:
if(
PAIRP(BgL_l1199z00_5689))
{ /* Llib/mpd.scm 830 */
{ /* Llib/mpd.scm 827 */
obj_t BgL_cz00_5690;
BgL_cz00_5690 = 
CAR(BgL_l1199z00_5689); 
{ /* Llib/mpd.scm 827 */
obj_t BgL_tmpz00_7552;
BgL_tmpz00_7552 = 
((obj_t)BgL_opz00_4918); 
bgl_display_string(BGl_string3397z00zz__multimediazd2mpdzd2, BgL_tmpz00_7552); } 
{ /* Llib/mpd.scm 828 */
obj_t BgL_arg2076z00_5691;
BgL_arg2076z00_5691 = 
CAR(
((obj_t)BgL_cz00_5690)); 
bgl_display_obj(BgL_arg2076z00_5691, BgL_opz00_4918); } 
{ /* Llib/mpd.scm 829 */
obj_t BgL_tmpz00_7558;
BgL_tmpz00_7558 = 
((obj_t)BgL_opz00_4918); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7558); } } 
{ 
obj_t BgL_l1199z00_7561;
BgL_l1199z00_7561 = 
CDR(BgL_l1199z00_5689); 
BgL_l1199z00_5689 = BgL_l1199z00_7561; 
goto BgL_zc3anonymousza32074ze3z83_5688;} }  else 
{ /* Llib/mpd.scm 830 */((bool_t)1); } } } 
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2079> */
obj_t BGl_z62zc3anonymousza32079ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5043, obj_t BgL_c1z00_5044, obj_t BgL_c2z00_5045)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 830 */
{ /* Llib/mpd.scm 831 */
bool_t BgL_tmpz00_7564;
{ /* Llib/mpd.scm 831 */
obj_t BgL_arg2080z00_5692;obj_t BgL_arg2081z00_5693;
{ /* Llib/mpd.scm 831 */
obj_t BgL_arg2082z00_5694;
BgL_arg2082z00_5694 = 
CAR(
((obj_t)BgL_c1z00_5044)); 
{ /* Llib/mpd.scm 831 */
obj_t BgL_res2838z00_5695;
{ /* Llib/mpd.scm 831 */
obj_t BgL_arg1419z00_5696;
BgL_arg1419z00_5696 = 
SYMBOL_TO_STRING(
((obj_t)BgL_arg2082z00_5694)); 
BgL_res2838z00_5695 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1419z00_5696); } 
BgL_arg2080z00_5692 = BgL_res2838z00_5695; } } 
{ /* Llib/mpd.scm 832 */
obj_t BgL_arg2083z00_5697;
BgL_arg2083z00_5697 = 
CAR(
((obj_t)BgL_c2z00_5045)); 
{ /* Llib/mpd.scm 832 */
obj_t BgL_res2839z00_5698;
{ /* Llib/mpd.scm 832 */
obj_t BgL_arg1419z00_5699;
BgL_arg1419z00_5699 = 
SYMBOL_TO_STRING(
((obj_t)BgL_arg2083z00_5697)); 
BgL_res2839z00_5698 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1419z00_5699); } 
BgL_arg2081z00_5693 = BgL_res2839z00_5698; } } 
BgL_tmpz00_7564 = 
bigloo_string_lt(BgL_arg2080z00_5692, BgL_arg2081z00_5693); } 
return 
BBOOL(BgL_tmpz00_7564);} } 
BGL_FUNCTION_END;
}



/* &mpd-notcommands */
obj_t BGl_z62mpdzd2notcommandszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4919, obj_t BgL_dbz00_4920, obj_t BgL_backendz00_4921, obj_t BgL_linez00_4922, obj_t BgL_ipz00_4923, obj_t BgL_opz00_4924)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 839 */
{ /* Llib/mpd.scm 840 */
obj_t BgL_g1204z00_5700;
BgL_g1204z00_5700 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3398z00zz__multimediazd2mpdzd2, BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2); 
{ 
obj_t BgL_l1202z00_5703;
BgL_l1202z00_5703 = BgL_g1204z00_5700; 
BgL_zc3anonymousza32084ze3z83_5702:
if(
PAIRP(BgL_l1202z00_5703))
{ /* Llib/mpd.scm 844 */
{ /* Llib/mpd.scm 841 */
obj_t BgL_cz00_5704;
BgL_cz00_5704 = 
CAR(BgL_l1202z00_5703); 
{ /* Llib/mpd.scm 841 */
obj_t BgL_tmpz00_7581;
BgL_tmpz00_7581 = 
((obj_t)BgL_opz00_4924); 
bgl_display_string(BGl_string3397z00zz__multimediazd2mpdzd2, BgL_tmpz00_7581); } 
{ /* Llib/mpd.scm 842 */
obj_t BgL_arg2086z00_5705;
BgL_arg2086z00_5705 = 
CAR(
((obj_t)BgL_cz00_5704)); 
bgl_display_obj(BgL_arg2086z00_5705, BgL_opz00_4924); } 
{ /* Llib/mpd.scm 843 */
obj_t BgL_tmpz00_7587;
BgL_tmpz00_7587 = 
((obj_t)BgL_opz00_4924); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7587); } } 
{ 
obj_t BgL_l1202z00_7590;
BgL_l1202z00_7590 = 
CDR(BgL_l1202z00_5703); 
BgL_l1202z00_5703 = BgL_l1202z00_7590; 
goto BgL_zc3anonymousza32084ze3z83_5702;} }  else 
{ /* Llib/mpd.scm 844 */((bool_t)1); } } } 
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2089> */
obj_t BGl_z62zc3anonymousza32089ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5047, obj_t BgL_c1z00_5048, obj_t BgL_c2z00_5049)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 844 */
{ /* Llib/mpd.scm 845 */
bool_t BgL_tmpz00_7593;
{ /* Llib/mpd.scm 845 */
obj_t BgL_arg2090z00_5706;obj_t BgL_arg2091z00_5707;
{ /* Llib/mpd.scm 845 */
obj_t BgL_arg2092z00_5708;
BgL_arg2092z00_5708 = 
CAR(
((obj_t)BgL_c1z00_5048)); 
{ /* Llib/mpd.scm 845 */
obj_t BgL_res2842z00_5709;
{ /* Llib/mpd.scm 845 */
obj_t BgL_arg1419z00_5710;
BgL_arg1419z00_5710 = 
SYMBOL_TO_STRING(
((obj_t)BgL_arg2092z00_5708)); 
BgL_res2842z00_5709 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1419z00_5710); } 
BgL_arg2090z00_5706 = BgL_res2842z00_5709; } } 
{ /* Llib/mpd.scm 846 */
obj_t BgL_arg2093z00_5711;
BgL_arg2093z00_5711 = 
CAR(
((obj_t)BgL_c2z00_5049)); 
{ /* Llib/mpd.scm 846 */
obj_t BgL_res2843z00_5712;
{ /* Llib/mpd.scm 846 */
obj_t BgL_arg1419z00_5713;
BgL_arg1419z00_5713 = 
SYMBOL_TO_STRING(
((obj_t)BgL_arg2093z00_5711)); 
BgL_res2843z00_5712 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1419z00_5713); } 
BgL_arg2091z00_5707 = BgL_res2843z00_5712; } } 
BgL_tmpz00_7593 = 
bigloo_string_lt(BgL_arg2090z00_5706, BgL_arg2091z00_5707); } 
return 
BBOOL(BgL_tmpz00_7593);} } 
BGL_FUNCTION_END;
}



/* &mpd-addid */
obj_t BGl_z62mpdzd2addidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4925, obj_t BgL_dbz00_4926, obj_t BgL_backendz00_4927, obj_t BgL_linez00_4928, obj_t BgL_ipz00_4929, obj_t BgL_opz00_4930)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 853 */
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* &mpd-crossfade */
obj_t BGl_z62mpdzd2crossfadezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4931, obj_t BgL_dbz00_4932, obj_t BgL_backendz00_4933, obj_t BgL_linez00_4934, obj_t BgL_ipz00_4935, obj_t BgL_opz00_4936)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 858 */
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* &mpd-move */
obj_t BGl_z62mpdzd2movezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4937, obj_t BgL_dbz00_4938, obj_t BgL_backendz00_4939, obj_t BgL_linez00_4940, obj_t BgL_ipz00_4941, obj_t BgL_opz00_4942)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 863 */
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* &mpd-moveid */
obj_t BGl_z62mpdzd2moveidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4943, obj_t BgL_dbz00_4944, obj_t BgL_backendz00_4945, obj_t BgL_linez00_4946, obj_t BgL_ipz00_4947, obj_t BgL_opz00_4948)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 868 */
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* &mpd-password */
obj_t BGl_z62mpdzd2passwordzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4949, obj_t BgL_dbz00_4950, obj_t BgL_backendz00_4951, obj_t BgL_linez00_4952, obj_t BgL_ipz00_4953, obj_t BgL_opz00_4954)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 873 */
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* &mpd-random */
obj_t BGl_z62mpdzd2randomzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4955, obj_t BgL_dbz00_4956, obj_t BgL_backendz00_4957, obj_t BgL_linez00_4958, obj_t BgL_ipz00_4959, obj_t BgL_opz00_4960)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 878 */
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* &mpd-repeat */
obj_t BGl_z62mpdzd2repeatzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4961, obj_t BgL_dbz00_4962, obj_t BgL_backendz00_4963, obj_t BgL_linez00_4964, obj_t BgL_ipz00_4965, obj_t BgL_opz00_4966)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 883 */
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* &mpd-rm */
obj_t BGl_z62mpdzd2rmzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4967, obj_t BgL_dbz00_4968, obj_t BgL_backendz00_4969, obj_t BgL_linez00_4970, obj_t BgL_ipz00_4971, obj_t BgL_opz00_4972)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 888 */
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* &mpd-save */
obj_t BGl_z62mpdzd2savezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4973, obj_t BgL_dbz00_4974, obj_t BgL_backendz00_4975, obj_t BgL_linez00_4976, obj_t BgL_ipz00_4977, obj_t BgL_opz00_4978)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 893 */
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* &mpd-shuffle */
obj_t BGl_z62mpdzd2shufflezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4979, obj_t BgL_dbz00_4980, obj_t BgL_backendz00_4981, obj_t BgL_linez00_4982, obj_t BgL_ipz00_4983, obj_t BgL_opz00_4984)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 898 */
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* &mpd-swap */
obj_t BGl_z62mpdzd2swapzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4985, obj_t BgL_dbz00_4986, obj_t BgL_backendz00_4987, obj_t BgL_linez00_4988, obj_t BgL_ipz00_4989, obj_t BgL_opz00_4990)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 903 */
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* &mpd-swapid */
obj_t BGl_z62mpdzd2swapidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4991, obj_t BgL_dbz00_4992, obj_t BgL_backendz00_4993, obj_t BgL_linez00_4994, obj_t BgL_ipz00_4995, obj_t BgL_opz00_4996)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 908 */
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* &mpd-update */
obj_t BGl_z62mpdzd2updatezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4997, obj_t BgL_dbz00_4998, obj_t BgL_backendz00_4999, obj_t BgL_linez00_5000, obj_t BgL_ipz00_5001, obj_t BgL_opz00_5002)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 913 */
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* &mpd-outputs */
obj_t BGl_z62mpdzd2outputszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5003, obj_t BgL_dbz00_5004, obj_t BgL_backendz00_5005, obj_t BgL_linez00_5006, obj_t BgL_ipz00_5007, obj_t BgL_opz00_5008)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 918 */
return 
CNST_TABLE_REF(((long)53));} 
BGL_FUNCTION_END;
}



/* loop~5 */
obj_t BGl_loopze75ze7zz__multimediazd2mpdzd2(obj_t BgL_l1z00_1167, obj_t BgL_l2z00_1168)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 924 */
{ /* Llib/mpd.scm 927 */
bool_t BgL_testz00_7620;
if(
NULLP(BgL_l1z00_1167))
{ /* Llib/mpd.scm 927 */
BgL_testz00_7620 = ((bool_t)1)
; }  else 
{ /* Llib/mpd.scm 927 */
BgL_testz00_7620 = 
NULLP(BgL_l2z00_1168)
; } 
if(BgL_testz00_7620)
{ /* Llib/mpd.scm 927 */
return BNIL;}  else 
{ /* Llib/mpd.scm 929 */
bool_t BgL_testz00_7624;
{ /* Llib/mpd.scm 929 */
obj_t BgL_string1z00_3148;obj_t BgL_string2z00_3149;
BgL_string1z00_3148 = 
CAR(
((obj_t)BgL_l1z00_1167)); 
BgL_string2z00_3149 = 
CAR(
((obj_t)BgL_l2z00_1168)); 
BgL_testz00_7624 = 
bigloo_strcmp(BgL_string1z00_3148, BgL_string2z00_3149); } 
if(BgL_testz00_7624)
{ /* Llib/mpd.scm 930 */
obj_t BgL_arg2101z00_1175;obj_t BgL_arg2102z00_1176;
BgL_arg2101z00_1175 = 
CAR(
((obj_t)BgL_l1z00_1167)); 
{ /* Llib/mpd.scm 930 */
obj_t BgL_arg2103z00_1177;obj_t BgL_arg2104z00_1178;
BgL_arg2103z00_1177 = 
CDR(
((obj_t)BgL_l1z00_1167)); 
BgL_arg2104z00_1178 = 
CDR(
((obj_t)BgL_l2z00_1168)); 
BgL_arg2102z00_1176 = 
BGl_loopze75ze7zz__multimediazd2mpdzd2(BgL_arg2103z00_1177, BgL_arg2104z00_1178); } 
return 
MAKE_YOUNG_PAIR(BgL_arg2101z00_1175, BgL_arg2102z00_1176);}  else 
{ /* Llib/mpd.scm 929 */
return BNIL;} } } } 
BGL_FUNCTION_END;
}



/* file-system-root? */
bool_t BGl_filezd2systemzd2rootzf3zf3zz__multimediazd2mpdzd2(obj_t BgL_dirz00_330)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 949 */
if(
(
STRING_LENGTH(BgL_dirz00_330)==((long)1)))
{ /* Llib/mpd.scm 950 */
return 
(
STRING_REF(BgL_dirz00_330, ((long)0))==
(unsigned char)(FILE_SEPARATOR));}  else 
{ /* Llib/mpd.scm 950 */
return ((bool_t)0);} } 
BGL_FUNCTION_END;
}



/* directory->sort-list */
obj_t BGl_directoryzd2ze3sortzd2listze3zz__multimediazd2mpdzd2(obj_t BgL_dirz00_332)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 988 */
return 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3399z00zz__multimediazd2mpdzd2, 
bgl_directory_to_list(
BSTRING_TO_STRING(BgL_dirz00_332)));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2117> */
obj_t BGl_z62zc3anonymousza32117ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5051, obj_t BgL_s1z00_5052, obj_t BgL_s2z00_5053)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 989 */
{ /* Llib/mpd.scm 990 */
bool_t BgL_tmpz00_7647;
{ /* Llib/mpd.scm 990 */
int BgL_arg2118z00_5714;
{ /* Llib/mpd.scm 990 */

BgL_arg2118z00_5714 = 
BGl_stringzd2naturalzd2compare3z00zz__r4_strings_6_7z00(BgL_s1z00_5052, BgL_s2z00_5053, 
BINT(((long)0)), 
BINT(((long)0))); } 
BgL_tmpz00_7647 = 
(
(long)(BgL_arg2118z00_5714)<((long)0)); } 
return 
BBOOL(BgL_tmpz00_7647);} } 
BGL_FUNCTION_END;
}



/* mpd->file */
obj_t BGl_mpdzd2ze3filez31zz__multimediazd2mpdzd2(obj_t BgL_filez00_333, obj_t BgL_dbz00_334, obj_t BgL_opz00_335, obj_t BgL_cmdz00_336)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 996 */
{ /* Llib/mpd.scm 998 */
obj_t BgL_fz00_1220;
{ /* Llib/mpd.scm 998 */
obj_t BgL_g1207z00_1224;
BgL_g1207z00_1224 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_334)))->BgL_directoriesz00); 
{ 
obj_t BgL_l1205z00_1226;
BgL_l1205z00_1226 = BgL_g1207z00_1224; 
BgL_zc3anonymousza32120ze3z83_1227:
if(
NULLP(BgL_l1205z00_1226))
{ /* Llib/mpd.scm 998 */
BgL_fz00_1220 = BFALSE; }  else 
{ /* Llib/mpd.scm 999 */
obj_t BgL__ortest_1208z00_1229;
{ /* Llib/mpd.scm 999 */
obj_t BgL_dirz00_1231;
BgL_dirz00_1231 = 
CAR(
((obj_t)BgL_l1205z00_1226)); 
{ /* Llib/mpd.scm 999 */
obj_t BgL_pz00_1232;
BgL_pz00_1232 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_1231, BgL_filez00_333); 
if(
fexists(
BSTRING_TO_STRING(BgL_pz00_1232)))
{ /* Llib/mpd.scm 1000 */
BgL__ortest_1208z00_1229 = BgL_pz00_1232; }  else 
{ /* Llib/mpd.scm 1000 */
BgL__ortest_1208z00_1229 = BFALSE; } } } 
if(
CBOOL(BgL__ortest_1208z00_1229))
{ /* Llib/mpd.scm 998 */
BgL_fz00_1220 = BgL__ortest_1208z00_1229; }  else 
{ /* Llib/mpd.scm 998 */
obj_t BgL_arg2122z00_1230;
BgL_arg2122z00_1230 = 
CDR(
((obj_t)BgL_l1205z00_1226)); 
{ 
obj_t BgL_l1205z00_7668;
BgL_l1205z00_7668 = BgL_arg2122z00_1230; 
BgL_l1205z00_1226 = BgL_l1205z00_7668; 
goto BgL_zc3anonymousza32120ze3z83_1227;} } } } } 
if(
STRINGP(BgL_fz00_1220))
{ /* Llib/mpd.scm 1003 */
return BgL_fz00_1220;}  else 
{ /* Llib/mpd.scm 1003 */
{ /* Llib/mpd.scm 325 */
obj_t BgL_tmpz00_7671;
BgL_tmpz00_7671 = 
((obj_t)BgL_opz00_335); 
bgl_display_string(BGl_string3349z00zz__multimediazd2mpdzd2, BgL_tmpz00_7671); } 
bgl_display_obj(BGl_string3384z00zz__multimediazd2mpdzd2, BgL_opz00_335); 
{ /* Llib/mpd.scm 327 */
obj_t BgL_tmpz00_7675;
BgL_tmpz00_7675 = 
((obj_t)BgL_opz00_335); 
bgl_display_string(BGl_string3351z00zz__multimediazd2mpdzd2, BgL_tmpz00_7675); } 
bgl_display_obj(BgL_cmdz00_336, BgL_opz00_335); 
{ /* Llib/mpd.scm 329 */
obj_t BgL_tmpz00_7679;
BgL_tmpz00_7679 = 
((obj_t)BgL_opz00_335); 
bgl_display_string(BGl_string3352z00zz__multimediazd2mpdzd2, BgL_tmpz00_7679); } 
bgl_display_obj(BGl_string3400z00zz__multimediazd2mpdzd2, BgL_opz00_335); 
{ /* Llib/mpd.scm 331 */
obj_t BgL_tmpz00_7683;
BgL_tmpz00_7683 = 
((obj_t)BgL_opz00_335); 
bgl_display_string(BGl_string3353z00zz__multimediazd2mpdzd2, BgL_tmpz00_7683); } 
{ /* Llib/mpd.scm 332 */
obj_t BgL_tmpz00_7686;
BgL_tmpz00_7686 = 
((obj_t)BgL_opz00_335); 
bgl_flush_output_port(BgL_tmpz00_7686); } 
return 
CNST_TABLE_REF(((long)54));} } } 
BGL_FUNCTION_END;
}



/* file->mpd */
obj_t BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(obj_t BgL_filez00_337, obj_t BgL_dbz00_338)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1010 */
{ /* Llib/mpd.scm 1012 */
long BgL_blenz00_1236;
BgL_blenz00_1236 = 
STRING_LENGTH(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_338)))->BgL_z52basez52)); 
if(
(
STRING_LENGTH(
((obj_t)BgL_filez00_337))>BgL_blenz00_1236))
{ /* Llib/mpd.scm 1014 */
long BgL_arg2126z00_1239;
BgL_arg2126z00_1239 = 
(BgL_blenz00_1236+((long)1)); 
{ /* Llib/mpd.scm 1014 */
long BgL_endz00_1242;
BgL_endz00_1242 = 
STRING_LENGTH(
((obj_t)BgL_filez00_337)); 
{ /* Llib/mpd.scm 1014 */

return 
BGl_substringz00zz__r4_strings_6_7z00(BgL_filez00_337, BgL_arg2126z00_1239, BgL_endz00_1242);} } }  else 
{ /* Llib/mpd.scm 1013 */
return BGl_string3337z00zz__multimediazd2mpdzd2;} } } 
BGL_FUNCTION_END;
}



/* image-file? */
bool_t BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(obj_t BgL_fz00_341)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1028 */
{ 
obj_t BgL_l1209z00_1248;
BgL_l1209z00_1248 = 
CNST_TABLE_REF(((long)66)); 
BgL_zc3anonymousza32130ze3z83_1249:
if(
NULLP(BgL_l1209z00_1248))
{ /* Llib/mpd.scm 1029 */
return ((bool_t)0);}  else 
{ /* Llib/mpd.scm 1029 */
bool_t BgL__ortest_1212z00_1251;
{ /* Llib/mpd.scm 1029 */

BgL__ortest_1212z00_1251 = 
BGl_stringzd2suffixzf3z21zz__r4_strings_6_7z00(
CAR(
((obj_t)BgL_l1209z00_1248)), BgL_fz00_341, BFALSE, BFALSE, BFALSE, BFALSE); } 
if(BgL__ortest_1212z00_1251)
{ /* Llib/mpd.scm 1029 */
return BgL__ortest_1212z00_1251;}  else 
{ 
obj_t BgL_l1209z00_7707;
BgL_l1209z00_7707 = 
CDR(
((obj_t)BgL_l1209z00_1248)); 
BgL_l1209z00_1248 = BgL_l1209z00_7707; 
goto BgL_zc3anonymousza32130ze3z83_1249;} } } } 
BGL_FUNCTION_END;
}



/* directory-image */
obj_t BGl_directoryzd2imagezd2zz__multimediazd2mpdzd2(obj_t BgL_dirz00_342)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1034 */
{ /* Llib/mpd.scm 1035 */
obj_t BgL_fz00_1261;
{ /* Llib/mpd.scm 1035 */
obj_t BgL_g1215z00_1263;
BgL_g1215z00_1263 = 
bgl_directory_to_list(
BSTRING_TO_STRING(BgL_dirz00_342)); 
{ 
obj_t BgL_list1214z00_1265;
BgL_list1214z00_1265 = BgL_g1215z00_1263; 
BgL_zc3anonymousza32134ze3z83_1266:
if(
PAIRP(BgL_list1214z00_1265))
{ /* Llib/mpd.scm 1035 */
if(
BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(
CAR(BgL_list1214z00_1265)))
{ /* Llib/mpd.scm 1035 */
BgL_fz00_1261 = 
CAR(BgL_list1214z00_1265); }  else 
{ 
obj_t BgL_list1214z00_7719;
BgL_list1214z00_7719 = 
CDR(BgL_list1214z00_1265); 
BgL_list1214z00_1265 = BgL_list1214z00_7719; 
goto BgL_zc3anonymousza32134ze3z83_1266;} }  else 
{ /* Llib/mpd.scm 1035 */
BgL_fz00_1261 = BFALSE; } } } 
if(
STRINGP(BgL_fz00_1261))
{ /* Llib/mpd.scm 1036 */
return 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_342, BgL_fz00_1261);}  else 
{ /* Llib/mpd.scm 1036 */
return BFALSE;} } } 
BGL_FUNCTION_END;
}



/* music-file? */
bool_t BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(obj_t BgL_fz00_343, obj_t BgL_dbz00_344)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1042 */
{ 
obj_t BgL_l1216z00_1276;
BgL_l1216z00_1276 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_344)))->BgL_suffixesz00); 
BgL_zc3anonymousza32140ze3z83_1277:
if(
NULLP(BgL_l1216z00_1276))
{ /* Llib/mpd.scm 1044 */
return ((bool_t)0);}  else 
{ /* Llib/mpd.scm 1044 */
bool_t BgL__ortest_1219z00_1279;
{ /* Llib/mpd.scm 1044 */

BgL__ortest_1219z00_1279 = 
BGl_stringzd2suffixzf3z21zz__r4_strings_6_7z00(
CAR(
((obj_t)BgL_l1216z00_1276)), BgL_fz00_343, BFALSE, BFALSE, BFALSE, BFALSE); } 
if(BgL__ortest_1219z00_1279)
{ /* Llib/mpd.scm 1044 */
return BgL__ortest_1219z00_1279;}  else 
{ 
obj_t BgL_l1216z00_7730;
BgL_l1216z00_7730 = 
CDR(
((obj_t)BgL_l1216z00_1276)); 
BgL_l1216z00_1276 = BgL_l1216z00_7730; 
goto BgL_zc3anonymousza32140ze3z83_1277;} } } } 
BGL_FUNCTION_END;
}



/* mpd-database-directories-scan */
obj_t BGl_mpdzd2databasezd2directorieszd2scanzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_dbz00_347, obj_t BgL_directoriesz00_348)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1055 */
{ /* Llib/mpd.scm 1055 */
obj_t BgL_nsongsz00_5409;
{ /* Llib/mpd.scm 1055 */
obj_t BgL_cellvalz00_7735;
BgL_cellvalz00_7735 = 
BINT(((long)0)); 
BgL_nsongsz00_5409 = 
MAKE_CELL(BgL_cellvalz00_7735); } 
{ /* Llib/mpd.scm 1057 */
obj_t BgL_artistsz00_1295;
BgL_artistsz00_1295 = 
BGl_makezd2hashtablezd2zz__hashz00(BNIL); 
{ /* Llib/mpd.scm 1058 */
obj_t BgL_albumsz00_1296;
BgL_albumsz00_1296 = 
BGl_makezd2hashtablezd2zz__hashz00(BNIL); 
{ /* Llib/mpd.scm 1059 */
obj_t BgL_genresz00_1297;
BgL_genresz00_1297 = 
BGl_makezd2hashtablezd2zz__hashz00(BNIL); 
{ 
obj_t BgL_l1223z00_1300;
BgL_l1223z00_1300 = BgL_directoriesz00_348; 
BgL_zc3anonymousza32146ze3z83_1301:
if(
PAIRP(BgL_l1223z00_1300))
{ /* Llib/mpd.scm 1082 */
{ /* Llib/mpd.scm 1082 */
obj_t BgL_dz00_1303;
BgL_dz00_1303 = 
CAR(BgL_l1223z00_1300); 
BGl_directoryzd2scanze70z35zz__multimediazd2mpdzd2(BgL_dbz00_347, BgL_genresz00_1297, BgL_albumsz00_1296, BgL_artistsz00_1295, BgL_nsongsz00_5409, BgL_dz00_1303, BgL_dz00_1303); } 
{ 
obj_t BgL_l1223z00_7744;
BgL_l1223z00_7744 = 
CDR(BgL_l1223z00_1300); 
BgL_l1223z00_1300 = BgL_l1223z00_7744; 
goto BgL_zc3anonymousza32146ze3z83_1301;} }  else 
{ /* Llib/mpd.scm 1082 */((bool_t)1); } } 
{ /* Llib/mpd.scm 1084 */
obj_t BgL_val0_1225z00_1306;obj_t BgL_val1_1226z00_1307;obj_t BgL_val2_1227z00_1308;long BgL_val3_1228z00_1309;
BgL_val0_1225z00_1306 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3401z00zz__multimediazd2mpdzd2, 
BGl_hashtablezd2mapzd2zz__hashz00(BgL_artistsz00_1295, BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00)); 
BgL_val1_1226z00_1307 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3402z00zz__multimediazd2mpdzd2, 
BGl_hashtablezd2mapzd2zz__hashz00(BgL_albumsz00_1296, BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00)); 
BgL_val2_1227z00_1308 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3403z00zz__multimediazd2mpdzd2, 
BGl_hashtablezd2mapzd2zz__hashz00(BgL_genresz00_1297, BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00)); 
BgL_val3_1228z00_1309 = 
(long)CINT(
CELL_REF(BgL_nsongsz00_5409)); 
{ /* Llib/mpd.scm 1084 */
int BgL_res2873z00_3241;
{ /* Llib/mpd.scm 1084 */
int BgL_tmpz00_7753;
BgL_tmpz00_7753 = 
(int)(((long)4)); 
BgL_res2873z00_3241 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_7753); } BgL_res2873z00_3241; } 
{ /* Llib/mpd.scm 1084 */
int BgL_tmpz00_7756;
BgL_tmpz00_7756 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_7756, BgL_val1_1226z00_1307); } 
{ /* Llib/mpd.scm 1084 */
int BgL_tmpz00_7759;
BgL_tmpz00_7759 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_7759, BgL_val2_1227z00_1308); } 
{ /* Llib/mpd.scm 1084 */
obj_t BgL_auxz00_7764;int BgL_tmpz00_7762;
BgL_auxz00_7764 = 
BINT(BgL_val3_1228z00_1309); 
BgL_tmpz00_7762 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_7762, BgL_auxz00_7764); } 
return BgL_val0_1225z00_1306;} } } } } } 
BGL_FUNCTION_END;
}



/* directory-scan~0 */
bool_t BGl_directoryzd2scanze70z35zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_dbz00_5407, obj_t BgL_genresz00_5406, obj_t BgL_albumsz00_5405, obj_t BgL_artistsz00_5404, obj_t BgL_nsongsz00_5403, obj_t BgL_dirz00_1334, obj_t BgL_repoz00_1335)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1080 */
{ /* Llib/mpd.scm 1063 */
obj_t BgL_albumz00_1337;
BgL_albumz00_1337 = 
BGl_basenamez00zz__osz00(BgL_dirz00_1334); 
{ /* Llib/mpd.scm 1063 */
obj_t BgL_dir2z00_1338;
BgL_dir2z00_1338 = 
BGl_dirnamez00zz__osz00(BgL_dirz00_1334); 
{ /* Llib/mpd.scm 1064 */
obj_t BgL_artistz00_1339;
BgL_artistz00_1339 = 
BGl_basenamez00zz__osz00(BgL_dir2z00_1338); 
{ /* Llib/mpd.scm 1065 */
obj_t BgL_dir3z00_1340;
BgL_dir3z00_1340 = 
BGl_dirnamez00zz__osz00(BgL_dir2z00_1338); 
{ /* Llib/mpd.scm 1066 */
obj_t BgL_genrez00_1341;
BgL_genrez00_1341 = 
BGl_basenamez00zz__osz00(BgL_dir3z00_1340); 
{ /* Llib/mpd.scm 1067 */
bool_t BgL_addz00_1342;
BgL_addz00_1342 = ((bool_t)0); 
{ /* Llib/mpd.scm 1068 */

{ /* Llib/mpd.scm 1069 */
obj_t BgL_g1222z00_1343;
BgL_g1222z00_1343 = 
BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(BgL_dirz00_1334); 
{ 
obj_t BgL_l1220z00_1345;
BgL_l1220z00_1345 = BgL_g1222z00_1343; 
BgL_zc3anonymousza32165ze3z83_1346:
if(
PAIRP(BgL_l1220z00_1345))
{ /* Llib/mpd.scm 1080 */
{ /* Llib/mpd.scm 1071 */
obj_t BgL_pz00_1348;
BgL_pz00_1348 = 
CAR(BgL_l1220z00_1345); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_1348)))
{ /* Llib/mpd.scm 1071 */
BBOOL(
BGl_directoryzd2scanze70z35zz__multimediazd2mpdzd2(BgL_dbz00_5407, BgL_genresz00_5406, BgL_albumsz00_5405, BgL_artistsz00_5404, BgL_nsongsz00_5403, BgL_pz00_1348, BgL_repoz00_1335)); }  else 
{ /* Llib/mpd.scm 1071 */
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_pz00_1348, 
((obj_t)BgL_dbz00_5407)))
{ /* Llib/mpd.scm 1073 */
{ /* Llib/mpd.scm 1074 */
obj_t BgL_auxz00_5408;
BgL_auxz00_5408 = 
ADDFX(
CELL_REF(BgL_nsongsz00_5403), 
BINT(((long)1))); 
CELL_SET(BgL_nsongsz00_5403, BgL_auxz00_5408); } 
if(BgL_addz00_1342)
{ /* Llib/mpd.scm 1075 */BFALSE; }  else 
{ /* Llib/mpd.scm 1075 */
BgL_addz00_1342 = ((bool_t)1); 
BGl_hashtablezd2putz12zc0zz__hashz00(BgL_artistsz00_5404, BgL_artistz00_1339, BgL_dir2z00_1338); 
BGl_hashtablezd2putz12zc0zz__hashz00(BgL_albumsz00_5405, BgL_albumz00_1337, BgL_dirz00_1334); 
BGl_hashtablezd2putz12zc0zz__hashz00(BgL_genresz00_5406, BgL_genrez00_1341, BgL_dir3z00_1340); } }  else 
{ /* Llib/mpd.scm 1073 */BFALSE; } } } 
{ 
obj_t BgL_l1220z00_7790;
BgL_l1220z00_7790 = 
CDR(BgL_l1220z00_1345); 
BgL_l1220z00_1345 = BgL_l1220z00_7790; 
goto BgL_zc3anonymousza32165ze3z83_1346;} }  else 
{ /* Llib/mpd.scm 1080 */
return ((bool_t)1);} } } } } } } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2161> */
obj_t BGl_z62zc3anonymousza32161ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5057, obj_t BgL_e1z00_5058, obj_t BgL_e2z00_5059)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1088 */
{ /* Llib/mpd.scm 1088 */
bool_t BgL_tmpz00_7792;
{ /* Llib/mpd.scm 1088 */
obj_t BgL_string1z00_5715;obj_t BgL_string2z00_5716;
BgL_string1z00_5715 = 
CAR(
((obj_t)BgL_e1z00_5058)); 
BgL_string2z00_5716 = 
CAR(
((obj_t)BgL_e2z00_5059)); 
BgL_tmpz00_7792 = 
bigloo_string_lt(BgL_string1z00_5715, BgL_string2z00_5716); } 
return 
BBOOL(BgL_tmpz00_7792);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2156> */
obj_t BGl_z62zc3anonymousza32156ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5060, obj_t BgL_e1z00_5061, obj_t BgL_e2z00_5062)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1086 */
{ /* Llib/mpd.scm 1086 */
bool_t BgL_tmpz00_7799;
{ /* Llib/mpd.scm 1086 */
obj_t BgL_string1z00_5717;obj_t BgL_string2z00_5718;
BgL_string1z00_5717 = 
CAR(
((obj_t)BgL_e1z00_5061)); 
BgL_string2z00_5718 = 
CAR(
((obj_t)BgL_e2z00_5062)); 
BgL_tmpz00_7799 = 
bigloo_string_lt(BgL_string1z00_5717, BgL_string2z00_5718); } 
return 
BBOOL(BgL_tmpz00_7799);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2151> */
obj_t BGl_z62zc3anonymousza32151ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5063, obj_t BgL_e1z00_5064, obj_t BgL_e2z00_5065)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1084 */
{ /* Llib/mpd.scm 1084 */
bool_t BgL_tmpz00_7806;
{ /* Llib/mpd.scm 1084 */
obj_t BgL_string1z00_5719;obj_t BgL_string2z00_5720;
BgL_string1z00_5719 = 
CAR(
((obj_t)BgL_e1z00_5064)); 
BgL_string2z00_5720 = 
CAR(
((obj_t)BgL_e2z00_5065)); 
BgL_tmpz00_7806 = 
bigloo_string_lt(BgL_string1z00_5719, BgL_string2z00_5720); } 
return 
BBOOL(BgL_tmpz00_7806);} } 
BGL_FUNCTION_END;
}



/* loop~4 */
bool_t BGl_loopze74ze7zz__multimediazd2mpdzd2(obj_t BgL_opz00_5402, BgL_mpdzd2databasezd2_bglt BgL_dbz00_5401, obj_t BgL_albumz00_5400, obj_t BgL_artistz00_5399, obj_t BgL_dirz00_1358)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1270 */
{ /* Llib/mpd.scm 1271 */
obj_t BgL_artistz00_1360;
if(
CBOOL(BgL_artistz00_5399))
{ /* Llib/mpd.scm 1271 */
BgL_artistz00_1360 = BgL_artistz00_5399; }  else 
{ /* Llib/mpd.scm 1271 */
BgL_artistz00_1360 = 
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_1358)); } 
{ /* Llib/mpd.scm 1271 */
obj_t BgL_albumz00_1361;
if(
CBOOL(BgL_albumz00_5400))
{ /* Llib/mpd.scm 1272 */
BgL_albumz00_1361 = BgL_albumz00_5400; }  else 
{ /* Llib/mpd.scm 1272 */
BgL_albumz00_1361 = 
BGl_basenamez00zz__osz00(BgL_dirz00_1358); } 
{ /* Llib/mpd.scm 1272 */
obj_t BgL_filesz00_1362;
BgL_filesz00_1362 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3404z00zz__multimediazd2mpdzd2, 
bgl_directory_to_list(
BSTRING_TO_STRING(BgL_dirz00_1358))); 
{ /* Llib/mpd.scm 1273 */
obj_t BgL_imgz00_1363;
{ /* Llib/mpd.scm 1276 */
obj_t BgL_fz00_1377;
{ 
obj_t BgL_list1271z00_1380;
BgL_list1271z00_1380 = BgL_filesz00_1362; 
BgL_zc3anonymousza32180ze3z83_1381:
if(
PAIRP(BgL_list1271z00_1380))
{ /* Llib/mpd.scm 1276 */
if(
BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(
CAR(BgL_list1271z00_1380)))
{ /* Llib/mpd.scm 1276 */
BgL_fz00_1377 = 
CAR(BgL_list1271z00_1380); }  else 
{ 
obj_t BgL_list1271z00_7829;
BgL_list1271z00_7829 = 
CDR(BgL_list1271z00_1380); 
BgL_list1271z00_1380 = BgL_list1271z00_7829; 
goto BgL_zc3anonymousza32180ze3z83_1381;} }  else 
{ /* Llib/mpd.scm 1276 */
BgL_fz00_1377 = BFALSE; } } 
if(
STRINGP(BgL_fz00_1377))
{ /* Llib/mpd.scm 1277 */
BgL_imgz00_1363 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_1358, BgL_fz00_1377); }  else 
{ /* Llib/mpd.scm 1277 */
BgL_imgz00_1363 = BFALSE; } } 
{ /* Llib/mpd.scm 1276 */

{ 
obj_t BgL_l1272z00_1365;
BgL_l1272z00_1365 = BgL_filesz00_1362; 
BgL_zc3anonymousza32174ze3z83_1366:
if(
PAIRP(BgL_l1272z00_1365))
{ /* Llib/mpd.scm 1279 */
{ /* Llib/mpd.scm 1280 */
obj_t BgL_fz00_1368;
BgL_fz00_1368 = 
CAR(BgL_l1272z00_1365); 
{ /* Llib/mpd.scm 1280 */
obj_t BgL_pz00_1369;
BgL_pz00_1369 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_1358, BgL_fz00_1368); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_1369)))
{ /* Llib/mpd.scm 1282 */
BGl_loopze74ze7zz__multimediazd2mpdzd2(BgL_opz00_5402, BgL_dbz00_5401, BgL_albumz00_5400, BgL_artistz00_5399, BgL_pz00_1369); }  else 
{ /* Llib/mpd.scm 1282 */
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_pz00_1369, 
((obj_t)BgL_dbz00_5401)))
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1187z00_3259;
BgL_g1187z00_3259 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)BgL_dbz00_5401), BgL_pz00_1369, BgL_artistz00_1360, BgL_albumz00_1361, BgL_imgz00_1363); 
{ 
obj_t BgL_l1185z00_3261;
BgL_l1185z00_3261 = BgL_g1187z00_3259; 
BgL_zc3anonymousza31958ze3z83_3260:
if(
PAIRP(BgL_l1185z00_3261))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_3263;
BgL_kz00_3263 = 
CAR(BgL_l1185z00_3261); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1960z00_3264;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1961z00_3265;
BgL_arg1961z00_3265 = 
CAR(
((obj_t)BgL_kz00_3263)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2880z00_3272;
BgL_res2880z00_3272 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1961z00_3265)); 
BgL_arg1960z00_3264 = BgL_res2880z00_3272; } } 
bgl_display_obj(BgL_arg1960z00_3264, BgL_opz00_5402); } 
bgl_display_string(BGl_string3374z00zz__multimediazd2mpdzd2, BgL_opz00_5402); 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1962z00_3266;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_3278;
BgL_pairz00_3278 = 
CDR(
((obj_t)BgL_kz00_3263)); 
BgL_arg1962z00_3266 = 
CAR(BgL_pairz00_3278); } 
bgl_display_obj(BgL_arg1962z00_3266, BgL_opz00_5402); } 
bgl_display_char(((unsigned char)10), BgL_opz00_5402); } 
{ 
obj_t BgL_l1185z00_7861;
BgL_l1185z00_7861 = 
CDR(BgL_l1185z00_3261); 
BgL_l1185z00_3261 = BgL_l1185z00_7861; 
goto BgL_zc3anonymousza31958ze3z83_3260;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } }  else 
{ /* Llib/mpd.scm 1284 */((bool_t)0); } } } } 
{ 
obj_t BgL_l1272z00_7863;
BgL_l1272z00_7863 = 
CDR(BgL_l1272z00_1365); 
BgL_l1272z00_1365 = BgL_l1272z00_7863; 
goto BgL_zc3anonymousza32174ze3z83_1366;} }  else 
{ /* Llib/mpd.scm 1279 */
return ((bool_t)1);} } } } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2188> */
obj_t BGl_z62zc3anonymousza32188ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5070, obj_t BgL_s1z00_5071, obj_t BgL_s2z00_5072)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1273 */
{ /* Llib/mpd.scm 1274 */
bool_t BgL_tmpz00_7865;
{ /* Llib/mpd.scm 1274 */
int BgL_arg2189z00_5721;
{ /* Llib/mpd.scm 1274 */

BgL_arg2189z00_5721 = 
BGl_stringzd2naturalzd2compare3z00zz__r4_strings_6_7z00(BgL_s1z00_5071, BgL_s2z00_5072, 
BINT(((long)0)), 
BINT(((long)0))); } 
BgL_tmpz00_7865 = 
(
(long)(BgL_arg2189z00_5721)<((long)0)); } 
return 
BBOOL(BgL_tmpz00_7865);} } 
BGL_FUNCTION_END;
}



/* getinfofile */
obj_t BGl_getinfofilez00zz__multimediazd2mpdzd2(obj_t BgL_dbz00_406, obj_t BgL_filez00_407, obj_t BgL_artistz00_408, obj_t BgL_albumz00_409, obj_t BgL_imagez00_410)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1444 */
{ 
obj_t BgL_filez00_1492;BgL_musictagz00_bglt BgL_tagz00_1493;obj_t BgL_filez00_1472;obj_t BgL_dtz00_1458;
{ /* Llib/mpd.scm 1477 */
bool_t BgL_testz00_7872;
if(
fexists(
BSTRING_TO_STRING(BgL_filez00_407)))
{ /* Llib/mpd.scm 1477 */
BgL_testz00_7872 = 
bgl_directoryp(
BSTRING_TO_STRING(BgL_filez00_407))
; }  else 
{ /* Llib/mpd.scm 1477 */
BgL_testz00_7872 = ((bool_t)1)
; } 
if(BgL_testz00_7872)
{ /* Llib/mpd.scm 1478 */
obj_t BgL_arg2194z00_1425;
{ /* Llib/mpd.scm 1478 */
obj_t BgL_arg2195z00_1426;
{ /* Llib/mpd.scm 1478 */
obj_t BgL_arg2196z00_1427;
if(
bigloo_strcmp_at(BgL_filez00_407, BGl_string3375z00zz__multimediazd2mpdzd2, ((long)0)))
{ /* Llib/mpd.scm 1021 */
BgL_arg2196z00_1427 = BgL_filez00_407; }  else 
{ /* Llib/mpd.scm 1021 */
BgL_arg2196z00_1427 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_filez00_407, BgL_dbz00_406); } 
BgL_arg2195z00_1426 = 
MAKE_YOUNG_PAIR(BgL_arg2196z00_1427, BNIL); } 
BgL_arg2194z00_1425 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)73)), BgL_arg2195z00_1426); } 
return 
MAKE_YOUNG_PAIR(BgL_arg2194z00_1425, BNIL);}  else 
{ /* Llib/mpd.scm 1479 */
obj_t BgL_tagz00_1428;obj_t BgL_infoz00_1429;obj_t BgL_dtz00_1430;obj_t BgL_imgz00_1431;
BgL_tagz00_1428 = 
BGl_filezd2musictagzd2zz__multimediazd2id3zd2(BgL_filez00_407); 
BgL_infoz00_1429 = 
BGl_filezd2musicinfozd2zz__multimediazd2id3zd2(BgL_filez00_407); 
BgL_dtz00_1430 = 
bgl_seconds_to_date(
bgl_last_modification_time(
BSTRING_TO_STRING(BgL_filez00_407))); 
if(
STRINGP(BgL_imagez00_410))
{ /* Llib/mpd.scm 1482 */
BgL_imgz00_1431 = 
BGl_directoryzd2imagezd2zz__multimediazd2mpdzd2(
BGl_dirnamez00zz__osz00(BgL_filez00_407)); }  else 
{ /* Llib/mpd.scm 1482 */
BgL_imgz00_1431 = BFALSE; } 
{ /* Llib/mpd.scm 1483 */
obj_t BgL_arg2197z00_1432;obj_t BgL_arg2198z00_1433;
{ /* Llib/mpd.scm 1483 */
obj_t BgL_arg2199z00_1434;
{ /* Llib/mpd.scm 1483 */
obj_t BgL_arg2200z00_1435;
if(
bigloo_strcmp_at(BgL_filez00_407, BGl_string3375z00zz__multimediazd2mpdzd2, ((long)0)))
{ /* Llib/mpd.scm 1021 */
BgL_arg2200z00_1435 = BgL_filez00_407; }  else 
{ /* Llib/mpd.scm 1021 */
BgL_arg2200z00_1435 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_filez00_407, BgL_dbz00_406); } 
BgL_arg2199z00_1434 = 
MAKE_YOUNG_PAIR(BgL_arg2200z00_1435, BNIL); } 
BgL_arg2197z00_1432 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)73)), BgL_arg2199z00_1434); } 
{ /* Llib/mpd.scm 1484 */
obj_t BgL_arg2201z00_1436;obj_t BgL_arg2202z00_1437;
{ /* Llib/mpd.scm 1484 */
obj_t BgL_arg2203z00_1438;
{ /* Llib/mpd.scm 1484 */
obj_t BgL_tmpz00_7900;
BgL_dtz00_1458 = BgL_dtz00_1430; 
{ /* Llib/mpd.scm 1448 */
int BgL_arg2222z00_1460;int BgL_arg2223z00_1461;int BgL_arg2224z00_1462;int BgL_arg2225z00_1463;int BgL_arg2226z00_1464;int BgL_arg2227z00_1465;
{ /* Llib/mpd.scm 1448 */
int BgL_res2881z00_3283;
BgL_res2881z00_3283 = 
BGL_DATE_YEAR(BgL_dtz00_1458); 
BgL_arg2222z00_1460 = BgL_res2881z00_3283; } 
{ /* Llib/mpd.scm 1448 */
int BgL_res2882z00_3285;
BgL_res2882z00_3285 = 
BGL_DATE_MONTH(BgL_dtz00_1458); 
BgL_arg2223z00_1461 = BgL_res2882z00_3285; } 
{ /* Llib/mpd.scm 1448 */
int BgL_res2883z00_3287;
BgL_res2883z00_3287 = 
BGL_DATE_DAY(BgL_dtz00_1458); 
BgL_arg2224z00_1462 = BgL_res2883z00_3287; } 
{ /* Llib/mpd.scm 1449 */
int BgL_res2884z00_3289;
BgL_res2884z00_3289 = 
BGL_DATE_HOUR(BgL_dtz00_1458); 
BgL_arg2225z00_1463 = BgL_res2884z00_3289; } 
{ /* Llib/mpd.scm 1449 */
int BgL_res2885z00_3291;
BgL_res2885z00_3291 = 
BGL_DATE_MINUTE(BgL_dtz00_1458); 
BgL_arg2226z00_1464 = BgL_res2885z00_3291; } 
{ /* Llib/mpd.scm 1449 */
int BgL_res2886z00_3293;
BgL_res2886z00_3293 = 
BGL_DATE_SECOND(BgL_dtz00_1458); 
BgL_arg2227z00_1465 = BgL_res2886z00_3293; } 
{ /* Llib/mpd.scm 1447 */
obj_t BgL_list2228z00_1466;
{ /* Llib/mpd.scm 1447 */
obj_t BgL_arg2229z00_1467;
{ /* Llib/mpd.scm 1447 */
obj_t BgL_arg2230z00_1468;
{ /* Llib/mpd.scm 1447 */
obj_t BgL_arg2231z00_1469;
{ /* Llib/mpd.scm 1447 */
obj_t BgL_arg2232z00_1470;
{ /* Llib/mpd.scm 1447 */
obj_t BgL_arg2233z00_1471;
BgL_arg2233z00_1471 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2227z00_1465), BNIL); 
BgL_arg2232z00_1470 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2226z00_1464), BgL_arg2233z00_1471); } 
BgL_arg2231z00_1469 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2225z00_1463), BgL_arg2232z00_1470); } 
BgL_arg2230z00_1468 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2224z00_1462), BgL_arg2231z00_1469); } 
BgL_arg2229z00_1467 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2223z00_1461), BgL_arg2230z00_1468); } 
BgL_list2228z00_1466 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2222z00_1460), BgL_arg2229z00_1467); } 
BgL_tmpz00_7900 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3405z00zz__multimediazd2mpdzd2, BgL_list2228z00_1466); } } 
BgL_arg2203z00_1438 = 
MAKE_YOUNG_PAIR(BgL_tmpz00_7900, BNIL); } 
BgL_arg2201z00_1436 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)74)), BgL_arg2203z00_1438); } 
{ /* Llib/mpd.scm 1485 */
obj_t BgL_arg2205z00_1440;obj_t BgL_arg2206z00_1441;
if(
BGl_isazf3zf3zz__objectz00(BgL_infoz00_1429, BGl_musicinfoz00zz__multimediazd2id3zd2))
{ /* Llib/mpd.scm 1487 */
obj_t BgL_arg2208z00_1444;
{ /* Llib/mpd.scm 1487 */
obj_t BgL_arg2209z00_1445;
{ /* Llib/mpd.scm 1487 */
long BgL_arg2210z00_1446;
BgL_arg2210z00_1446 = 
(((BgL_musicinfoz00_bglt)COBJECT(
((BgL_musicinfoz00_bglt)BgL_infoz00_1429)))->BgL_durationz00); 
BgL_arg2209z00_1445 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2210z00_1446), BNIL); } 
BgL_arg2208z00_1444 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)75)), BgL_arg2209z00_1445); } 
BgL_arg2205z00_1440 = 
MAKE_YOUNG_PAIR(BgL_arg2208z00_1444, BNIL); }  else 
{ /* Llib/mpd.scm 1485 */
BgL_arg2205z00_1440 = BNIL; } 
{ /* Llib/mpd.scm 1489 */
obj_t BgL_arg2211z00_1447;obj_t BgL_arg2212z00_1448;
if(
BGl_isazf3zf3zz__objectz00(BgL_tagz00_1428, BGl_musictagz00zz__multimediazd2id3zd2))
{ /* Llib/mpd.scm 1489 */
BgL_filez00_1492 = BgL_filez00_407; 
BgL_tagz00_1493 = 
((BgL_musictagz00_bglt)BgL_tagz00_1428); 
{ /* Llib/mpd.scm 1461 */
obj_t BgL_dirz00_1496;
BgL_dirz00_1496 = 
BGl_dirnamez00zz__osz00(BgL_filez00_1492); 
{ /* Llib/mpd.scm 1461 */
obj_t BgL_atz00_1497;
if(
CBOOL(BgL_artistz00_408))
{ /* Llib/mpd.scm 1462 */
BgL_atz00_1497 = BgL_artistz00_408; }  else 
{ /* Llib/mpd.scm 1462 */
if(
bigloo_strcicmp(
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1493))->BgL_artistz00), BGl_string3406z00zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1463 */
BgL_atz00_1497 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_1496))); }  else 
{ /* Llib/mpd.scm 1463 */
BgL_atz00_1497 = 
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1493))->BgL_artistz00); } } 
{ /* Llib/mpd.scm 1462 */
obj_t BgL_alz00_1498;
if(
CBOOL(BgL_albumz00_409))
{ /* Llib/mpd.scm 1466 */
BgL_alz00_1498 = BgL_albumz00_409; }  else 
{ /* Llib/mpd.scm 1466 */
if(
bigloo_strcicmp(
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1493))->BgL_albumz00), BGl_string3407z00zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1467 */
BgL_alz00_1498 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(BgL_dirz00_1496)); }  else 
{ /* Llib/mpd.scm 1467 */
BgL_alz00_1498 = 
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1493))->BgL_albumz00); } } 
{ /* Llib/mpd.scm 1466 */

{ /* Llib/mpd.scm 1470 */
obj_t BgL_arg2251z00_1499;obj_t BgL_arg2252z00_1500;
{ /* Llib/mpd.scm 1470 */
obj_t BgL_arg2253z00_1501;
BgL_arg2253z00_1501 = 
MAKE_YOUNG_PAIR(BgL_atz00_1497, BNIL); 
BgL_arg2251z00_1499 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)67)), BgL_arg2253z00_1501); } 
{ /* Llib/mpd.scm 1471 */
obj_t BgL_arg2254z00_1502;obj_t BgL_arg2255z00_1503;
{ /* Llib/mpd.scm 1471 */
obj_t BgL_arg2256z00_1504;
BgL_arg2256z00_1504 = 
MAKE_YOUNG_PAIR(
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1493))->BgL_titlez00), BNIL); 
BgL_arg2254z00_1502 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)68)), BgL_arg2256z00_1504); } 
{ /* Llib/mpd.scm 1472 */
obj_t BgL_arg2258z00_1506;obj_t BgL_arg2259z00_1507;
{ /* Llib/mpd.scm 1472 */
obj_t BgL_arg2260z00_1508;
BgL_arg2260z00_1508 = 
MAKE_YOUNG_PAIR(BgL_alz00_1498, BNIL); 
BgL_arg2258z00_1506 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)69)), BgL_arg2260z00_1508); } 
{ /* Llib/mpd.scm 1473 */
obj_t BgL_arg2261z00_1509;obj_t BgL_arg2262z00_1510;
{ /* Llib/mpd.scm 1473 */
obj_t BgL_arg2263z00_1511;
{ /* Llib/mpd.scm 1473 */
int BgL_arg2264z00_1512;
BgL_arg2264z00_1512 = 
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1493))->BgL_trackz00); 
BgL_arg2263z00_1511 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2264z00_1512), BNIL); } 
BgL_arg2261z00_1509 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)70)), BgL_arg2263z00_1511); } 
{ /* Llib/mpd.scm 1474 */
obj_t BgL_arg2265z00_1513;obj_t BgL_arg2266z00_1514;
{ /* Llib/mpd.scm 1474 */
obj_t BgL_arg2267z00_1515;
{ /* Llib/mpd.scm 1474 */
int BgL_arg2268z00_1516;
BgL_arg2268z00_1516 = 
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1493))->BgL_yearz00); 
BgL_arg2267z00_1515 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2268z00_1516), BNIL); } 
BgL_arg2265z00_1513 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)71)), BgL_arg2267z00_1515); } 
{ /* Llib/mpd.scm 1475 */
obj_t BgL_arg2269z00_1517;
{ /* Llib/mpd.scm 1475 */
obj_t BgL_arg2270z00_1518;
BgL_arg2270z00_1518 = 
MAKE_YOUNG_PAIR(
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1493))->BgL_genrez00), BNIL); 
BgL_arg2269z00_1517 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)72)), BgL_arg2270z00_1518); } 
BgL_arg2266z00_1514 = 
MAKE_YOUNG_PAIR(BgL_arg2269z00_1517, BNIL); } 
BgL_arg2262z00_1510 = 
MAKE_YOUNG_PAIR(BgL_arg2265z00_1513, BgL_arg2266z00_1514); } 
BgL_arg2259z00_1507 = 
MAKE_YOUNG_PAIR(BgL_arg2261z00_1509, BgL_arg2262z00_1510); } 
BgL_arg2255z00_1503 = 
MAKE_YOUNG_PAIR(BgL_arg2258z00_1506, BgL_arg2259z00_1507); } 
BgL_arg2252z00_1500 = 
MAKE_YOUNG_PAIR(BgL_arg2254z00_1502, BgL_arg2255z00_1503); } 
BgL_arg2211z00_1447 = 
MAKE_YOUNG_PAIR(BgL_arg2251z00_1499, BgL_arg2252z00_1500); } } } } } }  else 
{ /* Llib/mpd.scm 1489 */
BgL_filez00_1472 = BgL_filez00_407; 
{ /* Llib/mpd.scm 1452 */
obj_t BgL_dirz00_1474;
BgL_dirz00_1474 = 
BGl_dirnamez00zz__osz00(BgL_filez00_1472); 
{ /* Llib/mpd.scm 1453 */
obj_t BgL_arg2235z00_1475;obj_t BgL_arg2236z00_1476;
{ /* Llib/mpd.scm 1453 */
obj_t BgL_arg2237z00_1477;
{ /* Llib/mpd.scm 1453 */
obj_t BgL_arg2238z00_1478;
if(
CBOOL(BgL_artistz00_408))
{ /* Llib/mpd.scm 1453 */
BgL_arg2238z00_1478 = BgL_artistz00_408; }  else 
{ /* Llib/mpd.scm 1453 */
BgL_arg2238z00_1478 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_1474))); } 
BgL_arg2237z00_1477 = 
MAKE_YOUNG_PAIR(BgL_arg2238z00_1478, BNIL); } 
BgL_arg2235z00_1475 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)67)), BgL_arg2237z00_1477); } 
{ /* Llib/mpd.scm 1454 */
obj_t BgL_arg2241z00_1482;obj_t BgL_arg2242z00_1483;
{ /* Llib/mpd.scm 1454 */
obj_t BgL_arg2243z00_1484;
BgL_arg2243z00_1484 = 
MAKE_YOUNG_PAIR(
BGl_prefixz00zz__osz00(
BGl_basenamez00zz__osz00(BgL_filez00_1472)), BNIL); 
BgL_arg2241z00_1482 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)68)), BgL_arg2243z00_1484); } 
{ /* Llib/mpd.scm 1455 */
obj_t BgL_arg2246z00_1487;
{ /* Llib/mpd.scm 1455 */
obj_t BgL_arg2247z00_1488;
{ /* Llib/mpd.scm 1455 */
obj_t BgL_arg2248z00_1489;
if(
CBOOL(BgL_albumz00_409))
{ /* Llib/mpd.scm 1455 */
BgL_arg2248z00_1489 = BgL_albumz00_409; }  else 
{ /* Llib/mpd.scm 1455 */
BgL_arg2248z00_1489 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(BgL_dirz00_1474)); } 
BgL_arg2247z00_1488 = 
MAKE_YOUNG_PAIR(BgL_arg2248z00_1489, BNIL); } 
BgL_arg2246z00_1487 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)69)), BgL_arg2247z00_1488); } 
BgL_arg2242z00_1483 = 
MAKE_YOUNG_PAIR(BgL_arg2246z00_1487, BNIL); } 
BgL_arg2236z00_1476 = 
MAKE_YOUNG_PAIR(BgL_arg2241z00_1482, BgL_arg2242z00_1483); } 
BgL_arg2211z00_1447 = 
MAKE_YOUNG_PAIR(BgL_arg2235z00_1475, BgL_arg2236z00_1476); } } } 
{ /* Llib/mpd.scm 1492 */
obj_t BgL_arg2214z00_1450;
if(
STRINGP(BgL_imgz00_1431))
{ /* Llib/mpd.scm 1493 */
obj_t BgL_arg2216z00_1452;
{ /* Llib/mpd.scm 1493 */
obj_t BgL_arg2217z00_1453;
BgL_arg2217z00_1453 = 
MAKE_YOUNG_PAIR(BgL_imgz00_1431, BNIL); 
BgL_arg2216z00_1452 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)76)), BgL_arg2217z00_1453); } 
BgL_arg2214z00_1450 = 
MAKE_YOUNG_PAIR(BgL_arg2216z00_1452, BNIL); }  else 
{ /* Llib/mpd.scm 1492 */
BgL_arg2214z00_1450 = BNIL; } 
BgL_arg2212z00_1448 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg2214z00_1450, BNIL); } 
BgL_arg2206z00_1441 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg2211z00_1447, BgL_arg2212z00_1448); } 
BgL_arg2202z00_1437 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg2205z00_1440, BgL_arg2206z00_1441); } 
BgL_arg2198z00_1433 = 
MAKE_YOUNG_PAIR(BgL_arg2201z00_1436, BgL_arg2202z00_1437); } 
return 
MAKE_YOUNG_PAIR(BgL_arg2197z00_1432, BgL_arg2198z00_1433);} } } } } 
BGL_FUNCTION_END;
}



/* loop~3 */
obj_t BGl_loopze73ze7zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_dbz00_5398, obj_t BgL_albumz00_5397, bool_t BgL_artistz00_5396, obj_t BgL_dirz00_1535)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1500 */
{ /* Llib/mpd.scm 1501 */
obj_t BgL_artistz00_1537;obj_t BgL_albumz00_1538;
if(BgL_artistz00_5396)
{ /* Llib/mpd.scm 1501 */
BgL_artistz00_1537 = 
BBOOL(BgL_artistz00_5396); }  else 
{ /* Llib/mpd.scm 1501 */
BgL_artistz00_1537 = 
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_1535)); } 
if(
CBOOL(BgL_albumz00_5397))
{ /* Llib/mpd.scm 1502 */
BgL_albumz00_1538 = BgL_albumz00_5397; }  else 
{ /* Llib/mpd.scm 1502 */
BgL_albumz00_1538 = 
BGl_basenamez00zz__osz00(BgL_dirz00_1535); } 
{ /* Llib/mpd.scm 1503 */
obj_t BgL_l1313z00_1539;
BgL_l1313z00_1539 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3408z00zz__multimediazd2mpdzd2, 
bgl_directory_to_list(
BSTRING_TO_STRING(BgL_dirz00_1535))); 
if(
NULLP(BgL_l1313z00_1539))
{ /* Llib/mpd.scm 1503 */
return BNIL;}  else 
{ /* Llib/mpd.scm 1503 */
obj_t BgL_head1315z00_1541;
{ /* Llib/mpd.scm 1503 */
obj_t BgL_res2897z00_3321;
BgL_res2897z00_3321 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1315z00_1541 = BgL_res2897z00_3321; } 
{ 
obj_t BgL_l1313z00_1543;obj_t BgL_tail1316z00_1544;
BgL_l1313z00_1543 = BgL_l1313z00_1539; 
BgL_tail1316z00_1544 = BgL_head1315z00_1541; 
BgL_zc3anonymousza32283ze3z83_1545:
if(
NULLP(BgL_l1313z00_1543))
{ /* Llib/mpd.scm 1503 */
return 
CDR(BgL_head1315z00_1541);}  else 
{ /* Llib/mpd.scm 1503 */
obj_t BgL_newtail1317z00_1547;
{ /* Llib/mpd.scm 1503 */
obj_t BgL_arg2286z00_1549;
{ /* Llib/mpd.scm 1503 */
obj_t BgL_fz00_1550;
BgL_fz00_1550 = 
CAR(
((obj_t)BgL_l1313z00_1543)); 
{ /* Llib/mpd.scm 1504 */
obj_t BgL_pz00_1551;
BgL_pz00_1551 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_1535, BgL_fz00_1550); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_1551)))
{ /* Llib/mpd.scm 1506 */
BgL_arg2286z00_1549 = 
BGl_loopze73ze7zz__multimediazd2mpdzd2(BgL_dbz00_5398, BgL_albumz00_5397, BgL_artistz00_5396, BgL_pz00_1551); }  else 
{ /* Llib/mpd.scm 1506 */
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_pz00_1551, 
((obj_t)BgL_dbz00_5398)))
{ /* Llib/mpd.scm 1509 */

BgL_arg2286z00_1549 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)BgL_dbz00_5398), BgL_pz00_1551, BgL_artistz00_1537, BgL_albumz00_1538, BFALSE); }  else 
{ /* Llib/mpd.scm 1508 */
BgL_arg2286z00_1549 = BFALSE; } } } } 
{ /* Llib/mpd.scm 1503 */
obj_t BgL_res2900z00_3327;
BgL_res2900z00_3327 = 
MAKE_YOUNG_PAIR(BgL_arg2286z00_1549, BNIL); 
BgL_newtail1317z00_1547 = BgL_res2900z00_3327; } } 
SET_CDR(BgL_tail1316z00_1544, BgL_newtail1317z00_1547); 
{ /* Llib/mpd.scm 1503 */
obj_t BgL_arg2285z00_1548;
BgL_arg2285z00_1548 = 
CDR(
((obj_t)BgL_l1313z00_1543)); 
{ 
obj_t BgL_tail1316z00_8051;obj_t BgL_l1313z00_8050;
BgL_l1313z00_8050 = BgL_arg2285z00_1548; 
BgL_tail1316z00_8051 = BgL_newtail1317z00_1547; 
BgL_tail1316z00_1544 = BgL_tail1316z00_8051; 
BgL_l1313z00_1543 = BgL_l1313z00_8050; 
goto BgL_zc3anonymousza32283ze3z83_1545;} } } } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2291> */
obj_t BGl_z62zc3anonymousza32291ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5074, obj_t BgL_s1z00_5075, obj_t BgL_s2z00_5076)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1510 */
{ /* Llib/mpd.scm 1511 */
bool_t BgL_tmpz00_8052;
{ /* Llib/mpd.scm 1511 */
int BgL_arg2292z00_5722;
{ /* Llib/mpd.scm 1511 */

BgL_arg2292z00_5722 = 
BGl_stringzd2naturalzd2compare3z00zz__r4_strings_6_7z00(BgL_s1z00_5075, BgL_s2z00_5076, 
BINT(((long)0)), 
BINT(((long)0))); } 
BgL_tmpz00_8052 = 
(
(long)(BgL_arg2292z00_5722)<((long)0)); } 
return 
BBOOL(BgL_tmpz00_8052);} } 
BGL_FUNCTION_END;
}



/* object-init */
obj_t BGl_objectzd2initzd2zz__multimediazd2mpdzd2()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 15 */
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2297z00_1578;obj_t BgL_arg2298z00_1579;
{ /* Llib/mpd.scm 20 */
obj_t BgL_v1318z00_1601;
BgL_v1318z00_1601 = 
create_vector(((long)11)); 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2305z00_1602;
BgL_arg2305z00_1602 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)77)), BGl_proc3411z00zz__multimediazd2mpdzd2, BGl_proc3410z00zz__multimediazd2mpdzd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3409z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)78))); 
VECTOR_SET(BgL_v1318z00_1601,((long)0),BgL_arg2305z00_1602); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2312z00_1615;
BgL_arg2312z00_1615 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)79)), BGl_proc3414z00zz__multimediazd2mpdzd2, BGl_proc3413z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3412z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)78))); 
VECTOR_SET(BgL_v1318z00_1601,((long)1),BgL_arg2312z00_1615); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2319z00_1628;
BgL_arg2319z00_1628 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)80)), BGl_proc3417z00zz__multimediazd2mpdzd2, BGl_proc3416z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3415z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)81))); 
VECTOR_SET(BgL_v1318z00_1601,((long)2),BgL_arg2319z00_1628); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2326z00_1641;
BgL_arg2326z00_1641 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)82)), BGl_proc3420z00zz__multimediazd2mpdzd2, BGl_proc3419z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3418z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)78))); 
VECTOR_SET(BgL_v1318z00_1601,((long)3),BgL_arg2326z00_1641); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2333z00_1654;
BgL_arg2333z00_1654 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)83)), BGl_proc3423z00zz__multimediazd2mpdzd2, BGl_proc3422z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3421z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)78))); 
VECTOR_SET(BgL_v1318z00_1601,((long)4),BgL_arg2333z00_1654); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2340z00_1667;
BgL_arg2340z00_1667 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)84)), BGl_proc3426z00zz__multimediazd2mpdzd2, BGl_proc3425z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3424z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)78))); 
VECTOR_SET(BgL_v1318z00_1601,((long)5),BgL_arg2340z00_1667); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2347z00_1680;
BgL_arg2347z00_1680 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)85)), BGl_proc3429z00zz__multimediazd2mpdzd2, BGl_proc3428z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3427z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)86))); 
VECTOR_SET(BgL_v1318z00_1601,((long)6),BgL_arg2347z00_1680); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2354z00_1693;
BgL_arg2354z00_1693 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)87)), BGl_proc3432z00zz__multimediazd2mpdzd2, BGl_proc3431z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3430z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)88))); 
VECTOR_SET(BgL_v1318z00_1601,((long)7),BgL_arg2354z00_1693); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2361z00_1706;
BgL_arg2361z00_1706 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)89)), BGl_proc3435z00zz__multimediazd2mpdzd2, BGl_proc3434z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3433z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)88))); 
VECTOR_SET(BgL_v1318z00_1601,((long)8),BgL_arg2361z00_1706); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2368z00_1719;
BgL_arg2368z00_1719 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)90)), BGl_proc3438z00zz__multimediazd2mpdzd2, BGl_proc3437z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3436z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)86))); 
VECTOR_SET(BgL_v1318z00_1601,((long)9),BgL_arg2368z00_1719); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2375z00_1732;
BgL_arg2375z00_1732 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)91)), BGl_proc3441z00zz__multimediazd2mpdzd2, BGl_proc3440z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3439z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)86))); 
VECTOR_SET(BgL_v1318z00_1601,((long)10),BgL_arg2375z00_1732); } 
BgL_arg2297z00_1578 = BgL_v1318z00_1601; } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_v1319z00_1745;
BgL_v1319z00_1745 = 
create_vector(((long)0)); 
BgL_arg2298z00_1579 = BgL_v1319z00_1745; } 
return ( 
BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)92)), 
CNST_TABLE_REF(((long)93)), BGl_objectz00zz__objectz00, ((long)35653), BGl_proc3444z00zz__multimediazd2mpdzd2, BGl_proc3443z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2initz12zd2envzc0zz__multimediazd2mpdzd2, BGl_proc3442z00zz__multimediazd2mpdzd2, BFALSE, BgL_arg2297z00_1578, BgL_arg2298z00_1579), BUNSPEC) ;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2304> */
obj_t BGl_z62zc3anonymousza32304ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5113, obj_t BgL_new1065z00_5114)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
{ 
BgL_mpdzd2databasezd2_bglt BgL_auxz00_8108;
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1065z00_5114)))->BgL_directoriesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1065z00_5114)))->BgL_suffixesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1065z00_5114)))->BgL_z52basez52)=((obj_t)BGl_string3337z00zz__multimediazd2mpdzd2),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1065z00_5114)))->BgL_z52artistsz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1065z00_5114)))->BgL_z52albumsz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1065z00_5114)))->BgL_z52genresz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1065z00_5114)))->BgL_z52nartistsz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1065z00_5114)))->BgL_z52nalbumsz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1065z00_5114)))->BgL_z52nsongsz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1065z00_5114)))->BgL_z52uptimez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1065z00_5114)))->BgL_z52dbzd2updatez80)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_8108 = 
((BgL_mpdzd2databasezd2_bglt)BgL_new1065z00_5114); 
return 
((obj_t)BgL_auxz00_8108);} } 
BGL_FUNCTION_END;
}



/* &lambda2302 */
BgL_mpdzd2databasezd2_bglt BGl_z62lambda2302z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5115)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
{ /* Llib/mpd.scm 20 */
BgL_mpdzd2databasezd2_bglt BgL_new1064z00_5724;
BgL_new1064z00_5724 = 
((BgL_mpdzd2databasezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_mpdzd2databasezd2_bgl) ))); 
{ /* Llib/mpd.scm 20 */
long BgL_arg2303z00_5725;
{ /* Llib/mpd.scm 20 */
long BgL_res2902z00_5726;
BgL_res2902z00_5726 = 
BGL_CLASS_INDEX(BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2); 
BgL_arg2303z00_5725 = BgL_res2902z00_5726; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1064z00_5724), BgL_arg2303z00_5725); } 
return BgL_new1064z00_5724;} } 
BGL_FUNCTION_END;
}



/* &lambda2299 */
BgL_mpdzd2databasezd2_bglt BGl_z62lambda2299z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5116, obj_t BgL_directories1053z00_5117, obj_t BgL_suffixes1054z00_5118, obj_t BgL_z52base1055z52_5119, obj_t BgL_z52artists1056z52_5120, obj_t BgL_z52albums1057z52_5121, obj_t BgL_z52genres1058z52_5122, obj_t BgL_z52nartists1059z52_5123, obj_t BgL_z52nalbums1060z52_5124, obj_t BgL_z52nsongs1061z52_5125, obj_t BgL_z52uptime1062z52_5126, obj_t BgL_z52dbzd2update1063z80_5127)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
{ /* Llib/mpd.scm 20 */
int BgL_z52nalbums1060z52_5733;int BgL_z52nsongs1061z52_5734;
BgL_z52nalbums1060z52_5733 = 
CINT(BgL_z52nalbums1060z52_5124); 
BgL_z52nsongs1061z52_5734 = 
CINT(BgL_z52nsongs1061z52_5125); 
{ /* Llib/mpd.scm 20 */
BgL_mpdzd2databasezd2_bglt BgL_new1175z00_5735;
{ /* Llib/mpd.scm 20 */
BgL_mpdzd2databasezd2_bglt BgL_new1174z00_5736;
BgL_new1174z00_5736 = 
((BgL_mpdzd2databasezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_mpdzd2databasezd2_bgl) ))); 
{ /* Llib/mpd.scm 20 */
long BgL_arg2301z00_5737;
{ /* Llib/mpd.scm 20 */
long BgL_res2901z00_5738;
BgL_res2901z00_5738 = 
BGL_CLASS_INDEX(BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2); 
BgL_arg2301z00_5737 = BgL_res2901z00_5738; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1174z00_5736), BgL_arg2301z00_5737); } 
BgL_new1175z00_5735 = BgL_new1174z00_5736; } 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1175z00_5735))->BgL_directoriesz00)=((obj_t)
((obj_t)BgL_directories1053z00_5117)),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1175z00_5735))->BgL_suffixesz00)=((obj_t)
((obj_t)BgL_suffixes1054z00_5118)),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1175z00_5735))->BgL_z52basez52)=((obj_t)
((obj_t)BgL_z52base1055z52_5119)),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1175z00_5735))->BgL_z52artistsz52)=((obj_t)
((obj_t)BgL_z52artists1056z52_5120)),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1175z00_5735))->BgL_z52albumsz52)=((obj_t)
((obj_t)BgL_z52albums1057z52_5121)),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1175z00_5735))->BgL_z52genresz52)=((obj_t)
((obj_t)BgL_z52genres1058z52_5122)),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1175z00_5735))->BgL_z52nartistsz52)=((obj_t)BgL_z52nartists1059z52_5123),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1175z00_5735))->BgL_z52nalbumsz52)=((int)BgL_z52nalbums1060z52_5733),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1175z00_5735))->BgL_z52nsongsz52)=((int)BgL_z52nsongs1061z52_5734),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1175z00_5735))->BgL_z52uptimez52)=((obj_t)BgL_z52uptime1062z52_5126),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1175z00_5735))->BgL_z52dbzd2updatez80)=((obj_t)BgL_z52dbzd2update1063z80_5127),BUNSPEC); 
{ /* Llib/mpd.scm 20 */
obj_t BgL_fun2300z00_5739;
BgL_fun2300z00_5739 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2); 
PROCEDURE_ENTRY(BgL_fun2300z00_5739)(BgL_fun2300z00_5739, 
((obj_t)BgL_new1175z00_5735), BEOA); } 
return BgL_new1175z00_5735;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2381> */
obj_t BGl_z62zc3anonymousza32381ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5128)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* &lambda2380 */
obj_t BGl_z62lambda2380z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5129, obj_t BgL_oz00_5130, obj_t BgL_vz00_5131)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5130)))->BgL_z52dbzd2updatez80)=((obj_t)BgL_vz00_5131),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2379 */
obj_t BGl_z62lambda2379z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5132, obj_t BgL_oz00_5133)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5133)))->BgL_z52dbzd2updatez80);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2374> */
obj_t BGl_z62zc3anonymousza32374ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5134)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* &lambda2373 */
obj_t BGl_z62lambda2373z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5135, obj_t BgL_oz00_5136, obj_t BgL_vz00_5137)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5136)))->BgL_z52uptimez52)=((obj_t)BgL_vz00_5137),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2372 */
obj_t BGl_z62lambda2372z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5138, obj_t BgL_oz00_5139)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5139)))->BgL_z52uptimez52);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2367> */
obj_t BGl_z62zc3anonymousza32367ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5140)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return 
BINT(((long)0));} 
BGL_FUNCTION_END;
}



/* &lambda2366 */
obj_t BGl_z62lambda2366z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5141, obj_t BgL_oz00_5142, obj_t BgL_vz00_5143)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
{ /* Llib/mpd.scm 20 */
int BgL_vz00_5745;
BgL_vz00_5745 = 
CINT(BgL_vz00_5143); 
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5142)))->BgL_z52nsongsz52)=((int)BgL_vz00_5745),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2365 */
obj_t BGl_z62lambda2365z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5144, obj_t BgL_oz00_5145)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return 
BINT(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5145)))->BgL_z52nsongsz52));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2360> */
obj_t BGl_z62zc3anonymousza32360ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5146)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return 
BINT(((long)0));} 
BGL_FUNCTION_END;
}



/* &lambda2359 */
obj_t BGl_z62lambda2359z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5147, obj_t BgL_oz00_5148, obj_t BgL_vz00_5149)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
{ /* Llib/mpd.scm 20 */
int BgL_vz00_5748;
BgL_vz00_5748 = 
CINT(BgL_vz00_5149); 
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5148)))->BgL_z52nalbumsz52)=((int)BgL_vz00_5748),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2358 */
obj_t BGl_z62lambda2358z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5150, obj_t BgL_oz00_5151)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return 
BINT(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5151)))->BgL_z52nalbumsz52));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2353> */
obj_t BGl_z62zc3anonymousza32353ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5152)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return 
BINT(((long)0));} 
BGL_FUNCTION_END;
}



/* &lambda2352 */
obj_t BGl_z62lambda2352z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5153, obj_t BgL_oz00_5154, obj_t BgL_vz00_5155)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5154)))->BgL_z52nartistsz52)=((obj_t)BgL_vz00_5155),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2351 */
obj_t BGl_z62lambda2351z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5156, obj_t BgL_oz00_5157)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5157)))->BgL_z52nartistsz52);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2346> */
obj_t BGl_z62zc3anonymousza32346ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5158)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return BNIL;} 
BGL_FUNCTION_END;
}



/* &lambda2345 */
obj_t BGl_z62lambda2345z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5159, obj_t BgL_oz00_5160, obj_t BgL_vz00_5161)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5160)))->BgL_z52genresz52)=((obj_t)
((obj_t)BgL_vz00_5161)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2344 */
obj_t BGl_z62lambda2344z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5162, obj_t BgL_oz00_5163)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5163)))->BgL_z52genresz52);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2339> */
obj_t BGl_z62zc3anonymousza32339ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5164)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return BNIL;} 
BGL_FUNCTION_END;
}



/* &lambda2338 */
obj_t BGl_z62lambda2338z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5165, obj_t BgL_oz00_5166, obj_t BgL_vz00_5167)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5166)))->BgL_z52albumsz52)=((obj_t)
((obj_t)BgL_vz00_5167)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2337 */
obj_t BGl_z62lambda2337z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5168, obj_t BgL_oz00_5169)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5169)))->BgL_z52albumsz52);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2332> */
obj_t BGl_z62zc3anonymousza32332ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5170)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return BNIL;} 
BGL_FUNCTION_END;
}



/* &lambda2331 */
obj_t BGl_z62lambda2331z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5171, obj_t BgL_oz00_5172, obj_t BgL_vz00_5173)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5172)))->BgL_z52artistsz52)=((obj_t)
((obj_t)BgL_vz00_5173)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2330 */
obj_t BGl_z62lambda2330z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5174, obj_t BgL_oz00_5175)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5175)))->BgL_z52artistsz52);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2325> */
obj_t BGl_z62zc3anonymousza32325ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5176)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return BGl_string3343z00zz__multimediazd2mpdzd2;} 
BGL_FUNCTION_END;
}



/* &lambda2324 */
obj_t BGl_z62lambda2324z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5177, obj_t BgL_oz00_5178, obj_t BgL_vz00_5179)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5178)))->BgL_z52basez52)=((obj_t)
((obj_t)BgL_vz00_5179)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2323 */
obj_t BGl_z62lambda2323z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5180, obj_t BgL_oz00_5181)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5181)))->BgL_z52basez52);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2318> */
obj_t BGl_z62zc3anonymousza32318ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5182)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return 
CNST_TABLE_REF(((long)94));} 
BGL_FUNCTION_END;
}



/* &lambda2317 */
obj_t BGl_z62lambda2317z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5183, obj_t BgL_oz00_5184, obj_t BgL_vz00_5185)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5184)))->BgL_suffixesz00)=((obj_t)
((obj_t)BgL_vz00_5185)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2316 */
obj_t BGl_z62lambda2316z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5186, obj_t BgL_oz00_5187)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5187)))->BgL_suffixesz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2311> */
obj_t BGl_z62zc3anonymousza32311ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5188)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return BNIL;} 
BGL_FUNCTION_END;
}



/* &lambda2310 */
obj_t BGl_z62lambda2310z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5189, obj_t BgL_oz00_5190, obj_t BgL_vz00_5191)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5190)))->BgL_directoriesz00)=((obj_t)
((obj_t)BgL_vz00_5191)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2309 */
obj_t BGl_z62lambda2309z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5192, obj_t BgL_oz00_5193)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5193)))->BgL_directoriesz00);} 
BGL_FUNCTION_END;
}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__multimediazd2mpdzd2()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 15 */
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2initz12zd2envzc0zz__multimediazd2mpdzd2, BGl_proc3445z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3446z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2filezd2ze3pathzd2envze3zz__multimediazd2mpdzd2, BGl_proc3447z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3448z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2statszd2envzd2zz__multimediazd2mpdzd2, BGl_proc3449z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3450z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listallzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3451z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3452z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listalbumzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3453z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3454z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listartistalbumzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3455z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3456z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listgenrealbumzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3457z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3458z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listgenreartistzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3459z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3460z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listgenrezd2envzd2zz__multimediazd2mpdzd2, BGl_proc3461z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3462z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listartistzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3463z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3464z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2lsinfozd2envzd2zz__multimediazd2mpdzd2, BGl_proc3465z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3466z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2findzd2albumzd2envz00zz__multimediazd2mpdzd2, BGl_proc3467z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3468z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2findzd2artistzd2envz00zz__multimediazd2mpdzd2, BGl_proc3469z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3470z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2searchzd2artistzd2albumzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3471z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3472z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2searchzd2artistzd2titlezd2envzd2zz__multimediazd2mpdzd2, BGl_proc3473z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3474z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2findzd2titlezd2envz00zz__multimediazd2mpdzd2, BGl_proc3475z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3476z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2findzd2genrezd2envz00zz__multimediazd2mpdzd2, BGl_proc3477z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3478z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2getgenrezd2envzd2zz__multimediazd2mpdzd2, BGl_proc3479z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3480z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2getartistzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3481z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3482z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2getgenreartistzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3483z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3484z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2getartistalbumzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3485z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3486z00zz__multimediazd2mpdzd2); 
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2getzd2albumzd2envz00zz__multimediazd2mpdzd2, BGl_proc3487z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3488z00zz__multimediazd2mpdzd2);} 
BGL_FUNCTION_END;
}



/* &mpd-database-get-alb1391 */
obj_t BGl_z62mpdzd2databasezd2getzd2alb1391zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5220, obj_t BgL_oz00_5221, obj_t BgL_albumz00_5222)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1517 */
{ /* Llib/mpd.scm 1519 */
obj_t BgL_cz00_5774;
BgL_cz00_5774 = 
BGl_assocz00zz__r4_pairs_and_lists_6_3z00(BgL_albumz00_5222, 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5221)))->BgL_z52albumsz52)); 
if(
PAIRP(BgL_cz00_5774))
{ /* Llib/mpd.scm 1521 */
obj_t BgL_dirz00_5776;
BgL_dirz00_5776 = 
CDR(BgL_cz00_5774); 
return 
BGl_loopze73ze7zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5221), BgL_albumz00_5222, ((bool_t)0), BgL_dirz00_5776);}  else 
{ /* Llib/mpd.scm 1520 */
return BFALSE;} } } 
BGL_FUNCTION_END;
}



/* &mpd-database-getarti1387 */
obj_t BGl_z62mpdzd2databasezd2getarti1387z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5223, obj_t BgL_oz00_5224, obj_t BgL_artistz00_5225)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1431 */
if(
STRINGP(BgL_artistz00_5225))
{ /* Llib/mpd.scm 1434 */
obj_t BgL_arg2635z00_5779;
BgL_arg2635z00_5779 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5224)))->BgL_z52albumsz52); 
{ /* Llib/mpd.scm 1435 */
obj_t BgL_zc3anonymousza32637ze3z83_5780;
BgL_zc3anonymousza32637ze3z83_5780 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32637ze3ze1zz__multimediazd2mpdzd2, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza32637ze3z83_5780, 
(int)(((long)0)), BgL_artistz00_5225); 
{ /* Llib/mpd.scm 1434 */
obj_t BgL_list2636z00_5781;
BgL_list2636z00_5781 = 
MAKE_YOUNG_PAIR(BgL_arg2635z00_5779, BNIL); 
return 
BGl_filterzd2mapzd2zz__r4_control_features_6_9z00(BgL_zc3anonymousza32637ze3z83_5780, BgL_list2636z00_5781);} } }  else 
{ /* Llib/mpd.scm 1439 */
obj_t BgL_l1307z00_5782;
BgL_l1307z00_5782 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5224)))->BgL_z52albumsz52); 
if(
NULLP(BgL_l1307z00_5782))
{ /* Llib/mpd.scm 1439 */
return BNIL;}  else 
{ /* Llib/mpd.scm 1439 */
obj_t BgL_head1309z00_5783;
{ /* Llib/mpd.scm 1439 */
obj_t BgL_res2981z00_5784;
BgL_res2981z00_5784 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1309z00_5783 = BgL_res2981z00_5784; } 
{ 
obj_t BgL_l1307z00_5786;obj_t BgL_tail1310z00_5787;
BgL_l1307z00_5786 = BgL_l1307z00_5782; 
BgL_tail1310z00_5787 = BgL_head1309z00_5783; 
BgL_zc3anonymousza32646ze3z83_5785:
if(
NULLP(BgL_l1307z00_5786))
{ /* Llib/mpd.scm 1439 */
return 
CDR(BgL_head1309z00_5783);}  else 
{ /* Llib/mpd.scm 1439 */
obj_t BgL_newtail1311z00_5788;
{ /* Llib/mpd.scm 1439 */
obj_t BgL_arg2649z00_5789;
{ /* Llib/mpd.scm 1439 */
obj_t BgL_az00_5790;
BgL_az00_5790 = 
CAR(
((obj_t)BgL_l1307z00_5786)); 
{ /* Llib/mpd.scm 1439 */
obj_t BgL_arg2650z00_5791;
{ /* Llib/mpd.scm 1439 */
obj_t BgL_arg2651z00_5792;
BgL_arg2651z00_5792 = 
CAR(
((obj_t)BgL_az00_5790)); 
BgL_arg2650z00_5791 = 
MAKE_YOUNG_PAIR(BgL_arg2651z00_5792, BNIL); } 
BgL_arg2649z00_5789 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)95)), BgL_arg2650z00_5791); } } 
{ /* Llib/mpd.scm 1439 */
obj_t BgL_res2983z00_5793;
BgL_res2983z00_5793 = 
MAKE_YOUNG_PAIR(BgL_arg2649z00_5789, BNIL); 
BgL_newtail1311z00_5788 = BgL_res2983z00_5793; } } 
SET_CDR(BgL_tail1310z00_5787, BgL_newtail1311z00_5788); 
{ /* Llib/mpd.scm 1439 */
obj_t BgL_arg2648z00_5794;
BgL_arg2648z00_5794 = 
CDR(
((obj_t)BgL_l1307z00_5786)); 
{ 
obj_t BgL_tail1310z00_8287;obj_t BgL_l1307z00_8286;
BgL_l1307z00_8286 = BgL_arg2648z00_5794; 
BgL_tail1310z00_8287 = BgL_newtail1311z00_5788; 
BgL_tail1310z00_5787 = BgL_tail1310z00_8287; 
BgL_l1307z00_5786 = BgL_l1307z00_8286; 
goto BgL_zc3anonymousza32646ze3z83_5785;} } } } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2637> */
obj_t BGl_z62zc3anonymousza32637ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5226, obj_t BgL_cz00_5228)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1434 */
{ /* Llib/mpd.scm 1435 */
obj_t BgL_artistz00_5227;
BgL_artistz00_5227 = 
PROCEDURE_REF(BgL_envz00_5226, 
(int)(((long)0))); 
{ /* Llib/mpd.scm 1435 */
obj_t BgL_dirz00_5795;
BgL_dirz00_5795 = 
CDR(
((obj_t)BgL_cz00_5228)); 
{ /* Llib/mpd.scm 1436 */
bool_t BgL_testz00_8292;
{ /* Llib/mpd.scm 1436 */
obj_t BgL_arg2643z00_5796;
BgL_arg2643z00_5796 = 
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_5795)); 
BgL_testz00_8292 = 
bigloo_strcmp(BgL_arg2643z00_5796, 
((obj_t)BgL_artistz00_5227)); } 
if(BgL_testz00_8292)
{ /* Llib/mpd.scm 1437 */
obj_t BgL_arg2641z00_5797;
{ /* Llib/mpd.scm 1437 */
obj_t BgL_arg2642z00_5798;
BgL_arg2642z00_5798 = 
CAR(
((obj_t)BgL_cz00_5228)); 
BgL_arg2641z00_5797 = 
MAKE_YOUNG_PAIR(BgL_arg2642z00_5798, BNIL); } 
return 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)95)), BgL_arg2641z00_5797);}  else 
{ /* Llib/mpd.scm 1436 */
return BFALSE;} } } } } 
BGL_FUNCTION_END;
}



/* &mpd-database-getgenr1384 */
obj_t BGl_z62mpdzd2databasezd2getgenr1384z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5229, obj_t BgL_oz00_5230, obj_t BgL_genrez00_5231)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1421 */
{ /* Llib/mpd.scm 1423 */
obj_t BgL_hook1305z00_5800;
BgL_hook1305z00_5800 = 
MAKE_YOUNG_PAIR(BFALSE, BNIL); 
{ /* Llib/mpd.scm 1423 */
obj_t BgL_g1306z00_5801;
BgL_g1306z00_5801 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5230)))->BgL_z52artistsz52); 
{ 
obj_t BgL_l1302z00_5803;obj_t BgL_h1303z00_5804;
BgL_l1302z00_5803 = BgL_g1306z00_5801; 
BgL_h1303z00_5804 = BgL_hook1305z00_5800; 
BgL_zc3anonymousza32622ze3z83_5802:
if(
NULLP(BgL_l1302z00_5803))
{ /* Llib/mpd.scm 1423 */
return 
CDR(BgL_hook1305z00_5800);}  else 
{ /* Llib/mpd.scm 1423 */
bool_t BgL_testz00_8308;
{ /* Llib/mpd.scm 1424 */
obj_t BgL_cz00_5805;
BgL_cz00_5805 = 
CAR(
((obj_t)BgL_l1302z00_5803)); 
{ /* Llib/mpd.scm 1424 */
obj_t BgL_dirz00_5806;
BgL_dirz00_5806 = 
CDR(
((obj_t)BgL_cz00_5805)); 
{ /* Llib/mpd.scm 1425 */
obj_t BgL_arg2630z00_5807;
BgL_arg2630z00_5807 = 
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_5806)); 
BgL_testz00_8308 = 
bigloo_strcmp(BgL_arg2630z00_5807, 
((obj_t)BgL_genrez00_5231)); } } } 
if(BgL_testz00_8308)
{ /* Llib/mpd.scm 1423 */
obj_t BgL_nh1304z00_5808;
{ /* Llib/mpd.scm 1423 */
obj_t BgL_arg2628z00_5809;
BgL_arg2628z00_5809 = 
CAR(
((obj_t)BgL_l1302z00_5803)); 
{ /* Llib/mpd.scm 1423 */
obj_t BgL_res2977z00_5810;
BgL_res2977z00_5810 = 
MAKE_YOUNG_PAIR(BgL_arg2628z00_5809, BNIL); 
BgL_nh1304z00_5808 = BgL_res2977z00_5810; } } 
SET_CDR(BgL_h1303z00_5804, BgL_nh1304z00_5808); 
{ /* Llib/mpd.scm 1423 */
obj_t BgL_arg2627z00_5811;
BgL_arg2627z00_5811 = 
CDR(
((obj_t)BgL_l1302z00_5803)); 
{ 
obj_t BgL_h1303z00_8324;obj_t BgL_l1302z00_8323;
BgL_l1302z00_8323 = BgL_arg2627z00_5811; 
BgL_h1303z00_8324 = BgL_nh1304z00_5808; 
BgL_h1303z00_5804 = BgL_h1303z00_8324; 
BgL_l1302z00_5803 = BgL_l1302z00_8323; 
goto BgL_zc3anonymousza32622ze3z83_5802;} } }  else 
{ /* Llib/mpd.scm 1423 */
obj_t BgL_arg2629z00_5812;
BgL_arg2629z00_5812 = 
CDR(
((obj_t)BgL_l1302z00_5803)); 
{ 
obj_t BgL_l1302z00_8327;
BgL_l1302z00_8327 = BgL_arg2629z00_5812; 
BgL_l1302z00_5803 = BgL_l1302z00_8327; 
goto BgL_zc3anonymousza32622ze3z83_5802;} } } } } } } 
BGL_FUNCTION_END;
}



/* &mpd-database-getarti1382 */
obj_t BGl_z62mpdzd2databasezd2getarti1382z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5232, obj_t BgL_oz00_5233)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1414 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5233)))->BgL_z52artistsz52);} 
BGL_FUNCTION_END;
}



/* &mpd-database-getgenr1379 */
obj_t BGl_z62mpdzd2databasezd2getgenr1379z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5234, obj_t BgL_oz00_5235)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1407 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5235)))->BgL_z52genresz52);} 
BGL_FUNCTION_END;
}



/* &mpd-database-find-ge1377 */
obj_t BGl_z62mpdzd2databasezd2findzd2ge1377zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5236, obj_t BgL_oz00_5237, obj_t BgL_opz00_5238, obj_t BgL_genrez00_5239)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1389 */
{ /* Llib/mpd.scm 1393 */
bool_t BgL_tmpz00_8332;
{ /* Llib/mpd.scm 1402 */
obj_t BgL_g1299z00_5817;
BgL_g1299z00_5817 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5237)))->BgL_directoriesz00); 
{ 
obj_t BgL_l1297z00_5819;
BgL_l1297z00_5819 = BgL_g1299z00_5817; 
BgL_zc3anonymousza32604ze3z83_5818:
if(
NULLP(BgL_l1297z00_5819))
{ /* Llib/mpd.scm 1402 */
BgL_tmpz00_8332 = ((bool_t)0)
; }  else 
{ /* Llib/mpd.scm 1402 */
bool_t BgL__ortest_1300z00_5820;
{ /* Llib/mpd.scm 1402 */
obj_t BgL_arg2607z00_5821;
BgL_arg2607z00_5821 = 
CAR(
((obj_t)BgL_l1297z00_5819)); 
BgL__ortest_1300z00_5820 = 
BGl_findzd2genreze70z35zz__multimediazd2mpdzd2(BgL_genrez00_5239, 
((obj_t)BgL_opz00_5238), 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5237), BgL_arg2607z00_5821); } 
if(BgL__ortest_1300z00_5820)
{ /* Llib/mpd.scm 1402 */
BgL_tmpz00_8332 = BgL__ortest_1300z00_5820
; }  else 
{ /* Llib/mpd.scm 1402 */
obj_t BgL_arg2606z00_5822;
BgL_arg2606z00_5822 = 
CDR(
((obj_t)BgL_l1297z00_5819)); 
{ 
obj_t BgL_l1297z00_8345;
BgL_l1297z00_8345 = BgL_arg2606z00_5822; 
BgL_l1297z00_5819 = BgL_l1297z00_8345; 
goto BgL_zc3anonymousza32604ze3z83_5818;} } } } } 
return 
BBOOL(BgL_tmpz00_8332);} } 
BGL_FUNCTION_END;
}



/* find-genre~0 */
bool_t BGl_findzd2genreze70z35zz__multimediazd2mpdzd2(obj_t BgL_genrez00_5395, obj_t BgL_opz00_5394, BgL_mpdzd2databasezd2_bglt BgL_oz00_5393, obj_t BgL_dirz00_2277)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1399 */
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_dirz00_2277)))
{ /* Llib/mpd.scm 1394 */
obj_t BgL_g1295z00_2280;
BgL_g1295z00_2280 = 
BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(BgL_dirz00_2277); 
{ 
obj_t BgL_l1293z00_2282;
BgL_l1293z00_2282 = BgL_g1295z00_2280; 
BgL_zc3anonymousza32610ze3z83_2283:
if(
NULLP(BgL_l1293z00_2282))
{ /* Llib/mpd.scm 1394 */
return ((bool_t)0);}  else 
{ /* Llib/mpd.scm 1394 */
bool_t BgL__ortest_1296z00_2285;
{ /* Llib/mpd.scm 1394 */
obj_t BgL_arg2613z00_2287;
BgL_arg2613z00_2287 = 
CAR(
((obj_t)BgL_l1293z00_2282)); 
BgL__ortest_1296z00_2285 = 
BGl_findzd2genreze70z35zz__multimediazd2mpdzd2(BgL_genrez00_5395, BgL_opz00_5394, BgL_oz00_5393, BgL_arg2613z00_2287); } 
if(BgL__ortest_1296z00_2285)
{ /* Llib/mpd.scm 1394 */
return BgL__ortest_1296z00_2285;}  else 
{ /* Llib/mpd.scm 1394 */
obj_t BgL_arg2612z00_2286;
BgL_arg2612z00_2286 = 
CDR(
((obj_t)BgL_l1293z00_2282)); 
{ 
obj_t BgL_l1293z00_8359;
BgL_l1293z00_8359 = BgL_arg2612z00_2286; 
BgL_l1293z00_2282 = BgL_l1293z00_8359; 
goto BgL_zc3anonymousza32610ze3z83_2283;} } } } }  else 
{ /* Llib/mpd.scm 1395 */
bool_t BgL_testz00_8360;
{ /* Llib/mpd.scm 1395 */
obj_t BgL_arg2617z00_2295;
BgL_arg2617z00_2295 = 
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_2277)); 
BgL_testz00_8360 = 
bigloo_strcmp(BgL_arg2617z00_2295, 
((obj_t)BgL_genrez00_5395)); } 
if(BgL_testz00_8360)
{ /* Llib/mpd.scm 1395 */
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1187z00_3663;
BgL_g1187z00_3663 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)BgL_oz00_5393), BgL_dirz00_2277, BFALSE, BFALSE, BFALSE); 
{ 
obj_t BgL_l1185z00_3665;
BgL_l1185z00_3665 = BgL_g1187z00_3663; 
BgL_zc3anonymousza31958ze3z83_3664:
if(
PAIRP(BgL_l1185z00_3665))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_3667;
BgL_kz00_3667 = 
CAR(BgL_l1185z00_3665); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1960z00_3668;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1961z00_3669;
BgL_arg1961z00_3669 = 
CAR(
((obj_t)BgL_kz00_3667)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2973z00_3676;
BgL_res2973z00_3676 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1961z00_3669)); 
BgL_arg1960z00_3668 = BgL_res2973z00_3676; } } 
bgl_display_obj(BgL_arg1960z00_3668, BgL_opz00_5394); } 
bgl_display_string(BGl_string3374z00zz__multimediazd2mpdzd2, BgL_opz00_5394); 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1962z00_3670;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_3682;
BgL_pairz00_3682 = 
CDR(
((obj_t)BgL_kz00_3667)); 
BgL_arg1962z00_3670 = 
CAR(BgL_pairz00_3682); } 
bgl_display_obj(BgL_arg1962z00_3670, BgL_opz00_5394); } 
bgl_display_char(((unsigned char)10), BgL_opz00_5394); } 
{ 
obj_t BgL_l1185z00_8381;
BgL_l1185z00_8381 = 
CDR(BgL_l1185z00_3665); 
BgL_l1185z00_3665 = BgL_l1185z00_8381; 
goto BgL_zc3anonymousza31958ze3z83_3664;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } } 
return ((bool_t)1);}  else 
{ /* Llib/mpd.scm 1395 */
return ((bool_t)0);} } } 
BGL_FUNCTION_END;
}



/* &mpd-database-find-ti1375 */
obj_t BGl_z62mpdzd2databasezd2findzd2ti1375zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5240, obj_t BgL_oz00_5241, obj_t BgL_opz00_5242, obj_t BgL_titlez00_5243)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1371 */
{ /* Llib/mpd.scm 1375 */
bool_t BgL_tmpz00_8383;
{ /* Llib/mpd.scm 1384 */
obj_t BgL_g1291z00_5825;
BgL_g1291z00_5825 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5241)))->BgL_directoriesz00); 
{ 
obj_t BgL_l1289z00_5827;
BgL_l1289z00_5827 = BgL_g1291z00_5825; 
BgL_zc3anonymousza32588ze3z83_5826:
if(
NULLP(BgL_l1289z00_5827))
{ /* Llib/mpd.scm 1384 */
BgL_tmpz00_8383 = ((bool_t)0)
; }  else 
{ /* Llib/mpd.scm 1384 */
bool_t BgL__ortest_1292z00_5828;
{ /* Llib/mpd.scm 1384 */
obj_t BgL_arg2591z00_5829;
BgL_arg2591z00_5829 = 
CAR(
((obj_t)BgL_l1289z00_5827)); 
BgL__ortest_1292z00_5828 = 
BGl_findzd2titleze70z35zz__multimediazd2mpdzd2(BgL_titlez00_5243, 
((obj_t)BgL_opz00_5242), 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5241), BgL_arg2591z00_5829); } 
if(BgL__ortest_1292z00_5828)
{ /* Llib/mpd.scm 1384 */
BgL_tmpz00_8383 = BgL__ortest_1292z00_5828
; }  else 
{ /* Llib/mpd.scm 1384 */
obj_t BgL_arg2590z00_5830;
BgL_arg2590z00_5830 = 
CDR(
((obj_t)BgL_l1289z00_5827)); 
{ 
obj_t BgL_l1289z00_8396;
BgL_l1289z00_8396 = BgL_arg2590z00_5830; 
BgL_l1289z00_5827 = BgL_l1289z00_8396; 
goto BgL_zc3anonymousza32588ze3z83_5826;} } } } } 
return 
BBOOL(BgL_tmpz00_8383);} } 
BGL_FUNCTION_END;
}



/* find-title~0 */
bool_t BGl_findzd2titleze70z35zz__multimediazd2mpdzd2(obj_t BgL_titlez00_5392, obj_t BgL_opz00_5391, BgL_mpdzd2databasezd2_bglt BgL_oz00_5390, obj_t BgL_dirz00_2239)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1381 */
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_dirz00_2239)))
{ /* Llib/mpd.scm 1376 */
obj_t BgL_g1287z00_2242;
BgL_g1287z00_2242 = 
BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(BgL_dirz00_2239); 
{ 
obj_t BgL_l1285z00_2244;
BgL_l1285z00_2244 = BgL_g1287z00_2242; 
BgL_zc3anonymousza32594ze3z83_2245:
if(
NULLP(BgL_l1285z00_2244))
{ /* Llib/mpd.scm 1376 */
return ((bool_t)0);}  else 
{ /* Llib/mpd.scm 1376 */
bool_t BgL__ortest_1288z00_2247;
{ /* Llib/mpd.scm 1376 */
obj_t BgL_arg2597z00_2249;
BgL_arg2597z00_2249 = 
CAR(
((obj_t)BgL_l1285z00_2244)); 
BgL__ortest_1288z00_2247 = 
BGl_findzd2titleze70z35zz__multimediazd2mpdzd2(BgL_titlez00_5392, BgL_opz00_5391, BgL_oz00_5390, BgL_arg2597z00_2249); } 
if(BgL__ortest_1288z00_2247)
{ /* Llib/mpd.scm 1376 */
return BgL__ortest_1288z00_2247;}  else 
{ /* Llib/mpd.scm 1376 */
obj_t BgL_arg2596z00_2248;
BgL_arg2596z00_2248 = 
CDR(
((obj_t)BgL_l1285z00_2244)); 
{ 
obj_t BgL_l1285z00_8410;
BgL_l1285z00_8410 = BgL_arg2596z00_2248; 
BgL_l1285z00_2244 = BgL_l1285z00_8410; 
goto BgL_zc3anonymousza32594ze3z83_2245;} } } } }  else 
{ /* Llib/mpd.scm 1377 */
bool_t BgL_testz00_8411;
{ /* Llib/mpd.scm 1377 */
obj_t BgL_arg2601z00_2257;
BgL_arg2601z00_2257 = 
BGl_prefixz00zz__osz00(
BGl_basenamez00zz__osz00(BgL_dirz00_2239)); 
BgL_testz00_8411 = 
bigloo_strcmp(BgL_arg2601z00_2257, 
((obj_t)BgL_titlez00_5392)); } 
if(BgL_testz00_8411)
{ /* Llib/mpd.scm 1377 */
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1187z00_3630;
BgL_g1187z00_3630 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)BgL_oz00_5390), BgL_dirz00_2239, BFALSE, BFALSE, BFALSE); 
{ 
obj_t BgL_l1185z00_3632;
BgL_l1185z00_3632 = BgL_g1187z00_3630; 
BgL_zc3anonymousza31958ze3z83_3631:
if(
PAIRP(BgL_l1185z00_3632))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_3634;
BgL_kz00_3634 = 
CAR(BgL_l1185z00_3632); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1960z00_3635;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1961z00_3636;
BgL_arg1961z00_3636 = 
CAR(
((obj_t)BgL_kz00_3634)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2967z00_3643;
BgL_res2967z00_3643 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1961z00_3636)); 
BgL_arg1960z00_3635 = BgL_res2967z00_3643; } } 
bgl_display_obj(BgL_arg1960z00_3635, BgL_opz00_5391); } 
bgl_display_string(BGl_string3374z00zz__multimediazd2mpdzd2, BgL_opz00_5391); 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1962z00_3637;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_3649;
BgL_pairz00_3649 = 
CDR(
((obj_t)BgL_kz00_3634)); 
BgL_arg1962z00_3637 = 
CAR(BgL_pairz00_3649); } 
bgl_display_obj(BgL_arg1962z00_3637, BgL_opz00_5391); } 
bgl_display_char(((unsigned char)10), BgL_opz00_5391); } 
{ 
obj_t BgL_l1185z00_8432;
BgL_l1185z00_8432 = 
CDR(BgL_l1185z00_3632); 
BgL_l1185z00_3632 = BgL_l1185z00_8432; 
goto BgL_zc3anonymousza31958ze3z83_3631;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } } 
return ((bool_t)1);}  else 
{ /* Llib/mpd.scm 1377 */
return ((bool_t)0);} } } 
BGL_FUNCTION_END;
}



/* &mpd-database-search-1373 */
obj_t BGl_z62mpdzd2databasezd2searchzd21373zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5244, obj_t BgL_oz00_5245, obj_t BgL_opz00_5246, obj_t BgL_artistz00_5247, obj_t BgL_titlez00_5248)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1345 */
{ /* Llib/mpd.scm 1349 */
bool_t BgL_tmpz00_8434;
{ 
BgL_mpdzd2databasezd2_bglt BgL_dbz00_5834;obj_t BgL_dirz00_5835;obj_t BgL_opz00_5836;
{ /* Llib/mpd.scm 1364 */
obj_t BgL_cz00_5837;
BgL_cz00_5837 = 
BGl_assocz00zz__r4_pairs_and_lists_6_3z00(BgL_artistz00_5247, 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5245)))->BgL_z52artistsz52)); 
if(
PAIRP(BgL_cz00_5837))
{ /* Llib/mpd.scm 1365 */
BgL_dbz00_5834 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5245); 
BgL_dirz00_5835 = 
CDR(BgL_cz00_5837); 
BgL_opz00_5836 = 
((obj_t)BgL_opz00_5246); 
BgL_tmpz00_8434 = 
BGl_loopze72ze7zz__multimediazd2mpdzd2(BgL_opz00_5836, BgL_dbz00_5834, BgL_artistz00_5247, BgL_titlez00_5248, BgL_dirz00_5835); }  else 
{ /* Llib/mpd.scm 1365 */
BgL_tmpz00_8434 = ((bool_t)0)
; } } } 
return 
BBOOL(BgL_tmpz00_8434);} } 
BGL_FUNCTION_END;
}



/* loop~2 */
bool_t BGl_loopze72ze7zz__multimediazd2mpdzd2(obj_t BgL_opz00_5389, BgL_mpdzd2databasezd2_bglt BgL_dbz00_5388, obj_t BgL_artistz00_5387, obj_t BgL_titlez00_5386, obj_t BgL_dirz00_2190)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1348 */
{ /* Llib/mpd.scm 1349 */
obj_t BgL_filesz00_2192;
BgL_filesz00_2192 = 
BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(BgL_dirz00_2190); 
{ /* Llib/mpd.scm 1349 */
obj_t BgL_imgz00_2193;
{ 
obj_t BgL_list1282z00_2212;
BgL_list1282z00_2212 = BgL_filesz00_2192; 
BgL_zc3anonymousza32581ze3z83_2213:
if(
PAIRP(BgL_list1282z00_2212))
{ /* Llib/mpd.scm 1350 */
if(
BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(
CAR(BgL_list1282z00_2212)))
{ /* Llib/mpd.scm 1350 */
BgL_imgz00_2193 = 
CAR(BgL_list1282z00_2212); }  else 
{ 
obj_t BgL_list1282z00_8452;
BgL_list1282z00_8452 = 
CDR(BgL_list1282z00_2212); 
BgL_list1282z00_2212 = BgL_list1282z00_8452; 
goto BgL_zc3anonymousza32581ze3z83_2213;} }  else 
{ /* Llib/mpd.scm 1350 */
BgL_imgz00_2193 = BFALSE; } } 
{ /* Llib/mpd.scm 1350 */

{ 
obj_t BgL_l1283z00_2195;
BgL_l1283z00_2195 = BgL_filesz00_2192; 
BgL_zc3anonymousza32573ze3z83_2196:
if(
PAIRP(BgL_l1283z00_2195))
{ /* Llib/mpd.scm 1351 */
{ /* Llib/mpd.scm 1352 */
obj_t BgL_fz00_2198;
BgL_fz00_2198 = 
CAR(BgL_l1283z00_2195); 
{ /* Llib/mpd.scm 1352 */
obj_t BgL_pz00_2199;
BgL_pz00_2199 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_2190, BgL_fz00_2198); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_2199)))
{ /* Llib/mpd.scm 1354 */
BGl_loopze72ze7zz__multimediazd2mpdzd2(BgL_opz00_5389, BgL_dbz00_5388, BgL_artistz00_5387, BgL_titlez00_5386, BgL_pz00_2199); }  else 
{ /* Llib/mpd.scm 1356 */
bool_t BgL_testz00_8462;
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_pz00_2199, 
((obj_t)BgL_dbz00_5388)))
{ /* Llib/mpd.scm 1356 */
obj_t BgL_arg2579z00_2208;
BgL_arg2579z00_2208 = 
BGl_prefixz00zz__osz00(BgL_fz00_2198); 
BgL_testz00_8462 = 
bigloo_strcmp(
((obj_t)BgL_titlez00_5386), BgL_arg2579z00_2208); }  else 
{ /* Llib/mpd.scm 1356 */
BgL_testz00_8462 = ((bool_t)0)
; } 
if(BgL_testz00_8462)
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1187z00_3597;
BgL_g1187z00_3597 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)BgL_dbz00_5388), BgL_pz00_2199, BgL_artistz00_5387, BgL_titlez00_5386, BgL_imgz00_2193); 
{ 
obj_t BgL_l1185z00_3599;
BgL_l1185z00_3599 = BgL_g1187z00_3597; 
BgL_zc3anonymousza31958ze3z83_3598:
if(
PAIRP(BgL_l1185z00_3599))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_3601;
BgL_kz00_3601 = 
CAR(BgL_l1185z00_3599); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1960z00_3602;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1961z00_3603;
BgL_arg1961z00_3603 = 
CAR(
((obj_t)BgL_kz00_3601)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2961z00_3610;
BgL_res2961z00_3610 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1961z00_3603)); 
BgL_arg1960z00_3602 = BgL_res2961z00_3610; } } 
bgl_display_obj(BgL_arg1960z00_3602, BgL_opz00_5389); } 
bgl_display_string(BGl_string3374z00zz__multimediazd2mpdzd2, BgL_opz00_5389); 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1962z00_3604;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_3616;
BgL_pairz00_3616 = 
CDR(
((obj_t)BgL_kz00_3601)); 
BgL_arg1962z00_3604 = 
CAR(BgL_pairz00_3616); } 
bgl_display_obj(BgL_arg1962z00_3604, BgL_opz00_5389); } 
bgl_display_char(((unsigned char)10), BgL_opz00_5389); } 
{ 
obj_t BgL_l1185z00_8485;
BgL_l1185z00_8485 = 
CDR(BgL_l1185z00_3599); 
BgL_l1185z00_3599 = BgL_l1185z00_8485; 
goto BgL_zc3anonymousza31958ze3z83_3598;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } }  else 
{ /* Llib/mpd.scm 1356 */((bool_t)0); } } } } 
{ 
obj_t BgL_l1283z00_8487;
BgL_l1283z00_8487 = 
CDR(BgL_l1283z00_2195); 
BgL_l1283z00_2195 = BgL_l1283z00_8487; 
goto BgL_zc3anonymousza32573ze3z83_2196;} }  else 
{ /* Llib/mpd.scm 1351 */
return ((bool_t)1);} } } } } } 
BGL_FUNCTION_END;
}



/* &mpd-database-search-1371 */
obj_t BGl_z62mpdzd2databasezd2searchzd21371zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5249, obj_t BgL_oz00_5250, obj_t BgL_opz00_5251, obj_t BgL_artistz00_5252, obj_t BgL_albumz00_5253)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1312 */
{ /* Llib/mpd.scm 1315 */
bool_t BgL_tmpz00_8489;
{ 
BgL_mpdzd2databasezd2_bglt BgL_dbz00_5841;obj_t BgL_dirz00_5842;obj_t BgL_opz00_5843;
{ /* Llib/mpd.scm 1338 */
obj_t BgL_cz00_5844;
BgL_cz00_5844 = 
BGl_assocz00zz__r4_pairs_and_lists_6_3z00(BgL_artistz00_5252, 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5250)))->BgL_z52artistsz52)); 
if(
PAIRP(BgL_cz00_5844))
{ /* Llib/mpd.scm 1339 */
BgL_dbz00_5841 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5250); 
BgL_dirz00_5842 = 
CDR(BgL_cz00_5844); 
BgL_opz00_5843 = 
((obj_t)BgL_opz00_5251); 
BgL_tmpz00_8489 = 
BGl_loopze71ze7zz__multimediazd2mpdzd2(BgL_opz00_5843, BgL_dbz00_5841, BgL_artistz00_5252, BgL_albumz00_5253, BgL_dirz00_5842); }  else 
{ /* Llib/mpd.scm 1339 */
BgL_tmpz00_8489 = ((bool_t)0)
; } } } 
return 
BBOOL(BgL_tmpz00_8489);} } 
BGL_FUNCTION_END;
}



/* loop~1 */
bool_t BGl_loopze71ze7zz__multimediazd2mpdzd2(obj_t BgL_opz00_5385, BgL_mpdzd2databasezd2_bglt BgL_dbz00_5384, obj_t BgL_artistz00_5383, obj_t BgL_albumz00_5382, obj_t BgL_dirz00_2119)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1314 */
{ /* Llib/mpd.scm 1315 */
bool_t BgL_testz00_8500;
{ /* Llib/mpd.scm 1315 */
obj_t BgL_arg2566z00_2169;
BgL_arg2566z00_2169 = 
BGl_basenamez00zz__osz00(BgL_dirz00_2119); 
BgL_testz00_8500 = 
bigloo_strcmp(BgL_arg2566z00_2169, 
((obj_t)BgL_albumz00_5382)); } 
if(BgL_testz00_8500)
{ /* Llib/mpd.scm 1316 */
obj_t BgL_filesz00_2123;
BgL_filesz00_2123 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3489z00zz__multimediazd2mpdzd2, 
bgl_directory_to_list(
BSTRING_TO_STRING(BgL_dirz00_2119))); 
{ /* Llib/mpd.scm 1316 */
obj_t BgL_imgz00_2124;
{ /* Llib/mpd.scm 1319 */
obj_t BgL_fz00_2138;
{ 
obj_t BgL_list1275z00_2141;
BgL_list1275z00_2141 = BgL_filesz00_2123; 
BgL_zc3anonymousza32552ze3z83_2142:
if(
PAIRP(BgL_list1275z00_2141))
{ /* Llib/mpd.scm 1319 */
if(
BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(
CAR(BgL_list1275z00_2141)))
{ /* Llib/mpd.scm 1319 */
BgL_fz00_2138 = 
CAR(BgL_list1275z00_2141); }  else 
{ 
obj_t BgL_list1275z00_8513;
BgL_list1275z00_8513 = 
CDR(BgL_list1275z00_2141); 
BgL_list1275z00_2141 = BgL_list1275z00_8513; 
goto BgL_zc3anonymousza32552ze3z83_2142;} }  else 
{ /* Llib/mpd.scm 1319 */
BgL_fz00_2138 = BFALSE; } } 
if(
STRINGP(BgL_fz00_2138))
{ /* Llib/mpd.scm 1320 */
BgL_imgz00_2124 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_2119, BgL_fz00_2138); }  else 
{ /* Llib/mpd.scm 1320 */
BgL_imgz00_2124 = BFALSE; } } 
{ /* Llib/mpd.scm 1319 */

{ 
obj_t BgL_l1276z00_2126;
BgL_l1276z00_2126 = BgL_filesz00_2123; 
BgL_zc3anonymousza32546ze3z83_2127:
if(
PAIRP(BgL_l1276z00_2126))
{ /* Llib/mpd.scm 1322 */
{ /* Llib/mpd.scm 1323 */
obj_t BgL_fz00_2129;
BgL_fz00_2129 = 
CAR(BgL_l1276z00_2126); 
{ /* Llib/mpd.scm 1323 */
obj_t BgL_pz00_2130;
BgL_pz00_2130 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_2119, BgL_fz00_2129); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_2130)))
{ /* Llib/mpd.scm 1325 */
BGl_loopze71ze7zz__multimediazd2mpdzd2(BgL_opz00_5385, BgL_dbz00_5384, BgL_artistz00_5383, BgL_albumz00_5382, BgL_pz00_2130); }  else 
{ /* Llib/mpd.scm 1325 */
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_pz00_2130, 
((obj_t)BgL_dbz00_5384)))
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1187z00_3556;
BgL_g1187z00_3556 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)BgL_dbz00_5384), BgL_pz00_2130, BgL_artistz00_5383, BgL_albumz00_5382, BgL_imgz00_2124); 
{ 
obj_t BgL_l1185z00_3558;
BgL_l1185z00_3558 = BgL_g1187z00_3556; 
BgL_zc3anonymousza31958ze3z83_3557:
if(
PAIRP(BgL_l1185z00_3558))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_3560;
BgL_kz00_3560 = 
CAR(BgL_l1185z00_3558); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1960z00_3561;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1961z00_3562;
BgL_arg1961z00_3562 = 
CAR(
((obj_t)BgL_kz00_3560)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2952z00_3569;
BgL_res2952z00_3569 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1961z00_3562)); 
BgL_arg1960z00_3561 = BgL_res2952z00_3569; } } 
bgl_display_obj(BgL_arg1960z00_3561, BgL_opz00_5385); } 
bgl_display_string(BGl_string3374z00zz__multimediazd2mpdzd2, BgL_opz00_5385); 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1962z00_3563;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_3575;
BgL_pairz00_3575 = 
CDR(
((obj_t)BgL_kz00_3560)); 
BgL_arg1962z00_3563 = 
CAR(BgL_pairz00_3575); } 
bgl_display_obj(BgL_arg1962z00_3563, BgL_opz00_5385); } 
bgl_display_char(((unsigned char)10), BgL_opz00_5385); } 
{ 
obj_t BgL_l1185z00_8545;
BgL_l1185z00_8545 = 
CDR(BgL_l1185z00_3558); 
BgL_l1185z00_3558 = BgL_l1185z00_8545; 
goto BgL_zc3anonymousza31958ze3z83_3557;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } }  else 
{ /* Llib/mpd.scm 1327 */((bool_t)0); } } } } 
{ 
obj_t BgL_l1276z00_8547;
BgL_l1276z00_8547 = 
CDR(BgL_l1276z00_2126); 
BgL_l1276z00_2126 = BgL_l1276z00_8547; 
goto BgL_zc3anonymousza32546ze3z83_2127;} }  else 
{ /* Llib/mpd.scm 1322 */
return ((bool_t)1);} } } } }  else 
{ /* Llib/mpd.scm 1333 */
obj_t BgL_g1280z00_2160;
BgL_g1280z00_2160 = 
BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(BgL_dirz00_2119); 
{ 
obj_t BgL_l1278z00_2162;
BgL_l1278z00_2162 = BgL_g1280z00_2160; 
BgL_zc3anonymousza32562ze3z83_2163:
if(
PAIRP(BgL_l1278z00_2162))
{ /* Llib/mpd.scm 1336 */
{ /* Llib/mpd.scm 1334 */
obj_t BgL_pz00_2165;
BgL_pz00_2165 = 
CAR(BgL_l1278z00_2162); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_2165)))
{ /* Llib/mpd.scm 1334 */
BGl_loopze71ze7zz__multimediazd2mpdzd2(BgL_opz00_5385, BgL_dbz00_5384, BgL_artistz00_5383, BgL_albumz00_5382, BgL_pz00_2165); }  else 
{ /* Llib/mpd.scm 1334 */((bool_t)0); } } 
{ 
obj_t BgL_l1278z00_8557;
BgL_l1278z00_8557 = 
CDR(BgL_l1278z00_2162); 
BgL_l1278z00_2162 = BgL_l1278z00_8557; 
goto BgL_zc3anonymousza32562ze3z83_2163;} }  else 
{ /* Llib/mpd.scm 1336 */
return ((bool_t)1);} } } } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2560> */
obj_t BGl_z62zc3anonymousza32560ze3ze1zz__multimediazd2mpdzd2(obj_t BgL_envz00_5254, obj_t BgL_s1z00_5255, obj_t BgL_s2z00_5256)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1316 */
{ /* Llib/mpd.scm 1317 */
bool_t BgL_tmpz00_8559;
{ /* Llib/mpd.scm 1317 */
int BgL_arg2561z00_5845;
{ /* Llib/mpd.scm 1317 */

BgL_arg2561z00_5845 = 
BGl_stringzd2naturalzd2compare3z00zz__r4_strings_6_7z00(BgL_s1z00_5255, BgL_s2z00_5256, 
BINT(((long)0)), 
BINT(((long)0))); } 
BgL_tmpz00_8559 = 
(
(long)(BgL_arg2561z00_5845)<((long)0)); } 
return 
BBOOL(BgL_tmpz00_8559);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-find-ar1369 */
obj_t BGl_z62mpdzd2databasezd2findzd2ar1369zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5257, obj_t BgL_oz00_5258, obj_t BgL_opz00_5259, obj_t BgL_artistz00_5260)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1303 */
{ /* Llib/mpd.scm 1304 */
bool_t BgL_tmpz00_8566;
{ /* Llib/mpd.scm 1305 */
obj_t BgL_cz00_5851;
BgL_cz00_5851 = 
BGl_assocz00zz__r4_pairs_and_lists_6_3z00(BgL_artistz00_5260, 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5258)))->BgL_z52artistsz52)); 
if(
PAIRP(BgL_cz00_5851))
{ /* Llib/mpd.scm 1307 */
obj_t BgL_dirz00_5853;
BgL_dirz00_5853 = 
CDR(BgL_cz00_5851); 
BgL_tmpz00_8566 = 
BGl_loopze74ze7zz__multimediazd2mpdzd2(
((obj_t)BgL_opz00_5259), 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5258), BFALSE, BgL_artistz00_5260, BgL_dirz00_5853); }  else 
{ /* Llib/mpd.scm 1306 */
BgL_tmpz00_8566 = ((bool_t)0)
; } } 
return 
BBOOL(BgL_tmpz00_8566);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-find-al1367 */
obj_t BGl_z62mpdzd2databasezd2findzd2al1367zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5261, obj_t BgL_oz00_5262, obj_t BgL_opz00_5263, obj_t BgL_albumz00_5264)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1294 */
{ /* Llib/mpd.scm 1295 */
bool_t BgL_tmpz00_8577;
{ /* Llib/mpd.scm 1296 */
obj_t BgL_cz00_5860;
BgL_cz00_5860 = 
BGl_assocz00zz__r4_pairs_and_lists_6_3z00(BgL_albumz00_5264, 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5262)))->BgL_z52albumsz52)); 
if(
PAIRP(BgL_cz00_5860))
{ /* Llib/mpd.scm 1298 */
obj_t BgL_dirz00_5862;
BgL_dirz00_5862 = 
CDR(BgL_cz00_5860); 
BgL_tmpz00_8577 = 
BGl_loopze74ze7zz__multimediazd2mpdzd2(
((obj_t)BgL_opz00_5263), 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5262), BgL_albumz00_5264, BFALSE, BgL_dirz00_5862); }  else 
{ /* Llib/mpd.scm 1297 */
BgL_tmpz00_8577 = ((bool_t)0)
; } } 
return 
BBOOL(BgL_tmpz00_8577);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-lsinfo1365 */
obj_t BGl_z62mpdzd2databasezd2lsinfo1365z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5265, obj_t BgL_oz00_5266, obj_t BgL_opz00_5267, obj_t BgL_dirz00_5268, obj_t BgL_recz00_5269)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1233 */
{ /* Llib/mpd.scm 1234 */
bool_t BgL_tmpz00_8588;
{ /* Llib/mpd.scm 1234 */
bool_t BgL_recz00_5867;
BgL_recz00_5867 = 
CBOOL(BgL_recz00_5269); 
{ /* Llib/mpd.scm 1235 */
bool_t BgL_testz00_8590;
if(
BGl_filezd2systemzd2rootzf3zf3zz__multimediazd2mpdzd2(
((obj_t)BgL_dirz00_5268)))
{ /* Llib/mpd.scm 1235 */
BgL_testz00_8590 = ((bool_t)1)
; }  else 
{ /* Llib/mpd.scm 1235 */
BgL_testz00_8590 = 
bigloo_strcmp(
((obj_t)BgL_dirz00_5268), 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5266)))->BgL_z52basez52))
; } 
if(BgL_testz00_8590)
{ /* Llib/mpd.scm 1236 */
obj_t BgL_g1265z00_5868;
BgL_g1265z00_5868 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5266)))->BgL_directoriesz00); 
{ 
obj_t BgL_l1263z00_5870;
BgL_l1263z00_5870 = BgL_g1265z00_5868; 
BgL_zc3anonymousza32510ze3z83_5869:
if(
PAIRP(BgL_l1263z00_5870))
{ /* Llib/mpd.scm 1236 */
{ /* Llib/mpd.scm 1237 */
obj_t BgL_dirz00_5871;
BgL_dirz00_5871 = 
CAR(BgL_l1263z00_5870); 
{ /* Llib/mpd.scm 1237 */
obj_t BgL_g1262z00_5872;
BgL_g1262z00_5872 = 
BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(BgL_dirz00_5871); 
{ 
obj_t BgL_l1260z00_5874;
BgL_l1260z00_5874 = BgL_g1262z00_5872; 
BgL_zc3anonymousza32512ze3z83_5873:
if(
PAIRP(BgL_l1260z00_5874))
{ /* Llib/mpd.scm 1244 */
{ /* Llib/mpd.scm 1238 */
obj_t BgL_dirz00_5875;
BgL_dirz00_5875 = 
CAR(BgL_l1260z00_5874); 
{ /* Llib/mpd.scm 1238 */
obj_t BgL_mdz00_5876;
BgL_mdz00_5876 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_dirz00_5875, 
((obj_t)
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5266))); 
{ /* Llib/mpd.scm 1239 */
obj_t BgL_tmpz00_8610;
BgL_tmpz00_8610 = 
((obj_t)BgL_opz00_5267); 
bgl_display_string(BGl_string3490z00zz__multimediazd2mpdzd2, BgL_tmpz00_8610); } 
bgl_display_obj(BgL_mdz00_5876, 
((obj_t)BgL_opz00_5267)); 
{ /* Llib/mpd.scm 1241 */
obj_t BgL_tmpz00_8615;
BgL_tmpz00_8615 = 
((obj_t)BgL_opz00_5267); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8615); } 
if(BgL_recz00_5867)
{ /* Llib/mpd.scm 1242 */
BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5266), 
((obj_t)BgL_opz00_5267), BgL_mdz00_5876, BgL_recz00_5867); }  else 
{ /* Llib/mpd.scm 1242 */BFALSE; } } } 
{ 
obj_t BgL_l1260z00_8622;
BgL_l1260z00_8622 = 
CDR(BgL_l1260z00_5874); 
BgL_l1260z00_5874 = BgL_l1260z00_8622; 
goto BgL_zc3anonymousza32512ze3z83_5873;} }  else 
{ /* Llib/mpd.scm 1244 */((bool_t)1); } } } } 
{ 
obj_t BgL_l1263z00_8624;
BgL_l1263z00_8624 = 
CDR(BgL_l1263z00_5870); 
BgL_l1263z00_5870 = BgL_l1263z00_8624; 
goto BgL_zc3anonymousza32510ze3z83_5869;} }  else 
{ /* Llib/mpd.scm 1236 */
BgL_tmpz00_8588 = ((bool_t)1)
; } } }  else 
{ /* Llib/mpd.scm 1246 */
obj_t BgL_pathz00_5877;
BgL_pathz00_5877 = 
BGl_mpdzd2ze3filez31zz__multimediazd2mpdzd2(
((obj_t)BgL_dirz00_5268), 
((obj_t)
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5266)), 
((obj_t)BgL_opz00_5267), BGl_string3491z00zz__multimediazd2mpdzd2); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pathz00_5877)))
{ /* Llib/mpd.scm 1248 */
obj_t BgL_filesz00_5878;
BgL_filesz00_5878 = 
BGl_directoryzd2ze3sortzd2listze3zz__multimediazd2mpdzd2(BgL_pathz00_5877); 
{ /* Llib/mpd.scm 1248 */
obj_t BgL_imgz00_5879;
{ /* Llib/mpd.scm 1249 */
obj_t BgL_fz00_5880;
{ 
obj_t BgL_list1267z00_5882;
BgL_list1267z00_5882 = BgL_filesz00_5878; 
BgL_zc3anonymousza32523ze3z83_5881:
if(
PAIRP(BgL_list1267z00_5882))
{ /* Llib/mpd.scm 1249 */
if(
BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(
CAR(BgL_list1267z00_5882)))
{ /* Llib/mpd.scm 1249 */
BgL_fz00_5880 = 
CAR(BgL_list1267z00_5882); }  else 
{ 
obj_t BgL_list1267z00_8641;
BgL_list1267z00_8641 = 
CDR(BgL_list1267z00_5882); 
BgL_list1267z00_5882 = BgL_list1267z00_8641; 
goto BgL_zc3anonymousza32523ze3z83_5881;} }  else 
{ /* Llib/mpd.scm 1249 */
BgL_fz00_5880 = BFALSE; } } 
if(
STRINGP(BgL_fz00_5880))
{ /* Llib/mpd.scm 1250 */
BgL_imgz00_5879 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_pathz00_5877, BgL_fz00_5880); }  else 
{ /* Llib/mpd.scm 1250 */
BgL_imgz00_5879 = BFALSE; } } 
{ /* Llib/mpd.scm 1249 */

{ 
obj_t BgL_l1268z00_5884;
BgL_l1268z00_5884 = BgL_filesz00_5878; 
BgL_zc3anonymousza32517ze3z83_5883:
if(
PAIRP(BgL_l1268z00_5884))
{ /* Llib/mpd.scm 1252 */
{ /* Llib/mpd.scm 1253 */
obj_t BgL_fz00_5885;
BgL_fz00_5885 = 
CAR(BgL_l1268z00_5884); 
{ /* Llib/mpd.scm 1253 */
obj_t BgL_pz00_5886;
BgL_pz00_5886 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_pathz00_5877, BgL_fz00_5885); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_5886)))
{ /* Llib/mpd.scm 1256 */
obj_t BgL_mdz00_5887;
BgL_mdz00_5887 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_pz00_5886, 
((obj_t)
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5266))); 
{ /* Llib/mpd.scm 1257 */
obj_t BgL_tmpz00_8656;
BgL_tmpz00_8656 = 
((obj_t)BgL_opz00_5267); 
bgl_display_string(BGl_string3490z00zz__multimediazd2mpdzd2, BgL_tmpz00_8656); } 
bgl_display_obj(BgL_mdz00_5887, 
((obj_t)BgL_opz00_5267)); 
{ /* Llib/mpd.scm 1259 */
obj_t BgL_tmpz00_8661;
BgL_tmpz00_8661 = 
((obj_t)BgL_opz00_5267); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8661); } 
if(BgL_recz00_5867)
{ /* Llib/mpd.scm 1260 */
BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5266), 
((obj_t)BgL_opz00_5267), BgL_mdz00_5887, BgL_recz00_5867); }  else 
{ /* Llib/mpd.scm 1260 */BFALSE; } }  else 
{ /* Llib/mpd.scm 1255 */
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_fz00_5885, 
((obj_t)
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5266))))
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1187z00_5888;
BgL_g1187z00_5888 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5266)), BgL_pz00_5886, BFALSE, BFALSE, BgL_imgz00_5879); 
{ 
obj_t BgL_l1185z00_5890;
{ /* Llib/mpd.scm 427 */
bool_t BgL_tmpz00_8675;
BgL_l1185z00_5890 = BgL_g1187z00_5888; 
BgL_zc3anonymousza31958ze3z83_5889:
if(
PAIRP(BgL_l1185z00_5890))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_5891;
BgL_kz00_5891 = 
CAR(BgL_l1185z00_5890); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1960z00_5892;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1961z00_5893;
BgL_arg1961z00_5893 = 
CAR(
((obj_t)BgL_kz00_5891)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2942z00_5894;
BgL_res2942z00_5894 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1961z00_5893)); 
BgL_arg1960z00_5892 = BgL_res2942z00_5894; } } 
bgl_display_obj(BgL_arg1960z00_5892, 
((obj_t)BgL_opz00_5267)); } 
{ /* Llib/mpd.scm 424 */
obj_t BgL_tmpz00_8685;
BgL_tmpz00_8685 = 
((obj_t)BgL_opz00_5267); 
bgl_display_string(BGl_string3374z00zz__multimediazd2mpdzd2, BgL_tmpz00_8685); } 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1962z00_5895;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_5896;
BgL_pairz00_5896 = 
CDR(
((obj_t)BgL_kz00_5891)); 
BgL_arg1962z00_5895 = 
CAR(BgL_pairz00_5896); } 
bgl_display_obj(BgL_arg1962z00_5895, 
((obj_t)BgL_opz00_5267)); } 
{ /* Llib/mpd.scm 426 */
obj_t BgL_tmpz00_8693;
BgL_tmpz00_8693 = 
((obj_t)BgL_opz00_5267); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8693); } } 
{ 
obj_t BgL_l1185z00_8696;
BgL_l1185z00_8696 = 
CDR(BgL_l1185z00_5890); 
BgL_l1185z00_5890 = BgL_l1185z00_8696; 
goto BgL_zc3anonymousza31958ze3z83_5889;} }  else 
{ /* Llib/mpd.scm 427 */
BgL_tmpz00_8675 = ((bool_t)1)
; } 
BBOOL(BgL_tmpz00_8675); } } }  else 
{ /* Llib/mpd.scm 1262 */BFALSE; } } } } 
{ 
obj_t BgL_l1268z00_8699;
BgL_l1268z00_8699 = 
CDR(BgL_l1268z00_5884); 
BgL_l1268z00_5884 = BgL_l1268z00_8699; 
goto BgL_zc3anonymousza32517ze3z83_5883;} }  else 
{ /* Llib/mpd.scm 1252 */
BgL_tmpz00_8588 = ((bool_t)1)
; } } } } }  else 
{ /* Llib/mpd.scm 1247 */
BgL_tmpz00_8588 = ((bool_t)0)
; } } } } 
return 
BBOOL(BgL_tmpz00_8588);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-listart1363 */
obj_t BGl_z62mpdzd2databasezd2listart1363z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5270, obj_t BgL_oz00_5271, obj_t BgL_opz00_5272)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1223 */
{ /* Llib/mpd.scm 1224 */
bool_t BgL_tmpz00_8702;
{ /* Llib/mpd.scm 1224 */
obj_t BgL_g1259z00_5899;
BgL_g1259z00_5899 = 
BGl_mpdzd2databasezd2getartistz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5271)); 
{ 
obj_t BgL_l1257z00_5901;
BgL_l1257z00_5901 = BgL_g1259z00_5899; 
BgL_zc3anonymousza32502ze3z83_5900:
if(
PAIRP(BgL_l1257z00_5901))
{ /* Llib/mpd.scm 1228 */
{ /* Llib/mpd.scm 1225 */
obj_t BgL_az00_5902;
BgL_az00_5902 = 
CAR(BgL_l1257z00_5901); 
{ /* Llib/mpd.scm 1225 */
obj_t BgL_tmpz00_8708;
BgL_tmpz00_8708 = 
((obj_t)BgL_opz00_5272); 
bgl_display_string(BGl_string3381z00zz__multimediazd2mpdzd2, BgL_tmpz00_8708); } 
{ /* Llib/mpd.scm 1226 */
obj_t BgL_arg2504z00_5903;
BgL_arg2504z00_5903 = 
CAR(
((obj_t)BgL_az00_5902)); 
bgl_display_obj(BgL_arg2504z00_5903, 
((obj_t)BgL_opz00_5272)); } 
{ /* Llib/mpd.scm 1227 */
obj_t BgL_tmpz00_8715;
BgL_tmpz00_8715 = 
((obj_t)BgL_opz00_5272); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8715); } } 
{ 
obj_t BgL_l1257z00_8718;
BgL_l1257z00_8718 = 
CDR(BgL_l1257z00_5901); 
BgL_l1257z00_5901 = BgL_l1257z00_8718; 
goto BgL_zc3anonymousza32502ze3z83_5900;} }  else 
{ /* Llib/mpd.scm 1228 */
BgL_tmpz00_8702 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8702);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-listgen1361 */
obj_t BGl_z62mpdzd2databasezd2listgen1361z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5273, obj_t BgL_oz00_5274, obj_t BgL_opz00_5275)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1213 */
{ /* Llib/mpd.scm 1214 */
bool_t BgL_tmpz00_8721;
{ /* Llib/mpd.scm 1214 */
obj_t BgL_g1256z00_5906;
BgL_g1256z00_5906 = 
BGl_mpdzd2databasezd2getgenrez00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5274)); 
{ 
obj_t BgL_l1254z00_5908;
BgL_l1254z00_5908 = BgL_g1256z00_5906; 
BgL_zc3anonymousza32497ze3z83_5907:
if(
PAIRP(BgL_l1254z00_5908))
{ /* Llib/mpd.scm 1218 */
{ /* Llib/mpd.scm 1215 */
obj_t BgL_az00_5909;
BgL_az00_5909 = 
CAR(BgL_l1254z00_5908); 
{ /* Llib/mpd.scm 1215 */
obj_t BgL_tmpz00_8727;
BgL_tmpz00_8727 = 
((obj_t)BgL_opz00_5275); 
bgl_display_string(BGl_string3492z00zz__multimediazd2mpdzd2, BgL_tmpz00_8727); } 
{ /* Llib/mpd.scm 1216 */
obj_t BgL_arg2499z00_5910;
BgL_arg2499z00_5910 = 
CAR(
((obj_t)BgL_az00_5909)); 
bgl_display_obj(BgL_arg2499z00_5910, 
((obj_t)BgL_opz00_5275)); } 
{ /* Llib/mpd.scm 1217 */
obj_t BgL_tmpz00_8734;
BgL_tmpz00_8734 = 
((obj_t)BgL_opz00_5275); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8734); } } 
{ 
obj_t BgL_l1254z00_8737;
BgL_l1254z00_8737 = 
CDR(BgL_l1254z00_5908); 
BgL_l1254z00_5908 = BgL_l1254z00_8737; 
goto BgL_zc3anonymousza32497ze3z83_5907;} }  else 
{ /* Llib/mpd.scm 1218 */
BgL_tmpz00_8721 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8721);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-listgen1359 */
obj_t BGl_z62mpdzd2databasezd2listgen1359z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5276, obj_t BgL_oz00_5277, obj_t BgL_opz00_5278, obj_t BgL_genrez00_5279)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1203 */
{ /* Llib/mpd.scm 1204 */
bool_t BgL_tmpz00_8740;
{ /* Llib/mpd.scm 1204 */
obj_t BgL_g1253z00_5913;
BgL_g1253z00_5913 = 
BGl_mpdzd2databasezd2getgenreartistz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5277), BgL_genrez00_5279); 
{ 
obj_t BgL_l1251z00_5915;
BgL_l1251z00_5915 = BgL_g1253z00_5913; 
BgL_zc3anonymousza32492ze3z83_5914:
if(
PAIRP(BgL_l1251z00_5915))
{ /* Llib/mpd.scm 1208 */
{ /* Llib/mpd.scm 1205 */
obj_t BgL_az00_5916;
BgL_az00_5916 = 
CAR(BgL_l1251z00_5915); 
{ /* Llib/mpd.scm 1205 */
obj_t BgL_tmpz00_8746;
BgL_tmpz00_8746 = 
((obj_t)BgL_opz00_5278); 
bgl_display_string(BGl_string3381z00zz__multimediazd2mpdzd2, BgL_tmpz00_8746); } 
{ /* Llib/mpd.scm 1206 */
obj_t BgL_arg2494z00_5917;
BgL_arg2494z00_5917 = 
CAR(
((obj_t)BgL_az00_5916)); 
bgl_display_obj(BgL_arg2494z00_5917, 
((obj_t)BgL_opz00_5278)); } 
{ /* Llib/mpd.scm 1207 */
obj_t BgL_tmpz00_8753;
BgL_tmpz00_8753 = 
((obj_t)BgL_opz00_5278); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8753); } } 
{ 
obj_t BgL_l1251z00_8756;
BgL_l1251z00_8756 = 
CDR(BgL_l1251z00_5915); 
BgL_l1251z00_5915 = BgL_l1251z00_8756; 
goto BgL_zc3anonymousza32492ze3z83_5914;} }  else 
{ /* Llib/mpd.scm 1208 */
BgL_tmpz00_8740 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8740);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-listgen1357 */
obj_t BGl_z62mpdzd2databasezd2listgen1357z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5280, obj_t BgL_oz00_5281, obj_t BgL_opz00_5282, obj_t BgL_genrez00_5283)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1189 */
{ /* Llib/mpd.scm 1190 */
bool_t BgL_tmpz00_8759;
{ /* Llib/mpd.scm 1190 */
obj_t BgL_g1250z00_5920;
{ /* Llib/mpd.scm 1194 */
obj_t BgL_hook1246z00_5921;
BgL_hook1246z00_5921 = 
MAKE_YOUNG_PAIR(BFALSE, BNIL); 
{ /* Llib/mpd.scm 1197 */
obj_t BgL_g1247z00_5922;
BgL_g1247z00_5922 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5281)))->BgL_z52albumsz52); 
{ 
obj_t BgL_l1243z00_5924;obj_t BgL_h1244z00_5925;
BgL_l1243z00_5924 = BgL_g1247z00_5922; 
BgL_h1244z00_5925 = BgL_hook1246z00_5921; 
BgL_zc3anonymousza32479ze3z83_5923:
if(
NULLP(BgL_l1243z00_5924))
{ /* Llib/mpd.scm 1197 */
BgL_g1250z00_5920 = 
CDR(BgL_hook1246z00_5921); }  else 
{ /* Llib/mpd.scm 1197 */
bool_t BgL_testz00_8766;
{ /* Llib/mpd.scm 1195 */
obj_t BgL_cz00_5926;
BgL_cz00_5926 = 
CAR(
((obj_t)BgL_l1243z00_5924)); 
{ /* Llib/mpd.scm 1195 */
obj_t BgL_dirz00_5927;
BgL_dirz00_5927 = 
CDR(
((obj_t)BgL_cz00_5926)); 
{ /* Llib/mpd.scm 1196 */
obj_t BgL_arg2488z00_5928;
BgL_arg2488z00_5928 = 
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_5927))); 
BgL_testz00_8766 = 
bigloo_strcmp(BgL_arg2488z00_5928, 
((obj_t)BgL_genrez00_5283)); } } } 
if(BgL_testz00_8766)
{ /* Llib/mpd.scm 1197 */
obj_t BgL_nh1245z00_5929;
{ /* Llib/mpd.scm 1197 */
obj_t BgL_arg2486z00_5930;
BgL_arg2486z00_5930 = 
CAR(
((obj_t)BgL_l1243z00_5924)); 
{ /* Llib/mpd.scm 1197 */
obj_t BgL_res2928z00_5931;
BgL_res2928z00_5931 = 
MAKE_YOUNG_PAIR(BgL_arg2486z00_5930, BNIL); 
BgL_nh1245z00_5929 = BgL_res2928z00_5931; } } 
SET_CDR(BgL_h1244z00_5925, BgL_nh1245z00_5929); 
{ /* Llib/mpd.scm 1197 */
obj_t BgL_arg2485z00_5932;
BgL_arg2485z00_5932 = 
CDR(
((obj_t)BgL_l1243z00_5924)); 
{ 
obj_t BgL_h1244z00_8783;obj_t BgL_l1243z00_8782;
BgL_l1243z00_8782 = BgL_arg2485z00_5932; 
BgL_h1244z00_8783 = BgL_nh1245z00_5929; 
BgL_h1244z00_5925 = BgL_h1244z00_8783; 
BgL_l1243z00_5924 = BgL_l1243z00_8782; 
goto BgL_zc3anonymousza32479ze3z83_5923;} } }  else 
{ /* Llib/mpd.scm 1197 */
obj_t BgL_arg2487z00_5933;
BgL_arg2487z00_5933 = 
CDR(
((obj_t)BgL_l1243z00_5924)); 
{ 
obj_t BgL_l1243z00_8786;
BgL_l1243z00_8786 = BgL_arg2487z00_5933; 
BgL_l1243z00_5924 = BgL_l1243z00_8786; 
goto BgL_zc3anonymousza32479ze3z83_5923;} } } } } } 
{ 
obj_t BgL_l1248z00_5935;
BgL_l1248z00_5935 = BgL_g1250z00_5920; 
BgL_zc3anonymousza32475ze3z83_5934:
if(
PAIRP(BgL_l1248z00_5935))
{ /* Llib/mpd.scm 1194 */
{ /* Llib/mpd.scm 1191 */
obj_t BgL_az00_5936;
BgL_az00_5936 = 
CAR(BgL_l1248z00_5935); 
{ /* Llib/mpd.scm 1191 */
obj_t BgL_tmpz00_8790;
BgL_tmpz00_8790 = 
((obj_t)BgL_opz00_5282); 
bgl_display_string(BGl_string3383z00zz__multimediazd2mpdzd2, BgL_tmpz00_8790); } 
{ /* Llib/mpd.scm 1192 */
obj_t BgL_arg2477z00_5937;
BgL_arg2477z00_5937 = 
CAR(
((obj_t)BgL_az00_5936)); 
bgl_display_obj(BgL_arg2477z00_5937, 
((obj_t)BgL_opz00_5282)); } 
{ /* Llib/mpd.scm 1193 */
obj_t BgL_tmpz00_8797;
BgL_tmpz00_8797 = 
((obj_t)BgL_opz00_5282); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8797); } } 
{ 
obj_t BgL_l1248z00_8800;
BgL_l1248z00_8800 = 
CDR(BgL_l1248z00_5935); 
BgL_l1248z00_5935 = BgL_l1248z00_8800; 
goto BgL_zc3anonymousza32475ze3z83_5934;} }  else 
{ /* Llib/mpd.scm 1194 */
BgL_tmpz00_8759 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8759);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-listart1355 */
obj_t BGl_z62mpdzd2databasezd2listart1355z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5284, obj_t BgL_oz00_5285, obj_t BgL_opz00_5286, obj_t BgL_artistz00_5287)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1179 */
{ /* Llib/mpd.scm 1180 */
bool_t BgL_tmpz00_8803;
{ /* Llib/mpd.scm 1180 */
obj_t BgL_g1241z00_5940;
BgL_g1241z00_5940 = 
BGl_mpdzd2databasezd2getartistalbumz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5285), BgL_artistz00_5287); 
{ 
obj_t BgL_l1239z00_5942;
BgL_l1239z00_5942 = BgL_g1241z00_5940; 
BgL_zc3anonymousza32470ze3z83_5941:
if(
PAIRP(BgL_l1239z00_5942))
{ /* Llib/mpd.scm 1184 */
{ /* Llib/mpd.scm 1181 */
obj_t BgL_az00_5943;
BgL_az00_5943 = 
CAR(BgL_l1239z00_5942); 
{ /* Llib/mpd.scm 1181 */
obj_t BgL_tmpz00_8809;
BgL_tmpz00_8809 = 
((obj_t)BgL_opz00_5286); 
bgl_display_string(BGl_string3383z00zz__multimediazd2mpdzd2, BgL_tmpz00_8809); } 
{ /* Llib/mpd.scm 1182 */
obj_t BgL_arg2472z00_5944;
{ /* Llib/mpd.scm 1182 */
obj_t BgL_pairz00_5945;
BgL_pairz00_5945 = 
CDR(
((obj_t)BgL_az00_5943)); 
BgL_arg2472z00_5944 = 
CAR(BgL_pairz00_5945); } 
bgl_display_obj(BgL_arg2472z00_5944, 
((obj_t)BgL_opz00_5286)); } 
{ /* Llib/mpd.scm 1183 */
obj_t BgL_tmpz00_8817;
BgL_tmpz00_8817 = 
((obj_t)BgL_opz00_5286); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8817); } } 
{ 
obj_t BgL_l1239z00_8820;
BgL_l1239z00_8820 = 
CDR(BgL_l1239z00_5942); 
BgL_l1239z00_5942 = BgL_l1239z00_8820; 
goto BgL_zc3anonymousza32470ze3z83_5941;} }  else 
{ /* Llib/mpd.scm 1184 */
BgL_tmpz00_8803 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8803);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-listalb1353 */
obj_t BGl_z62mpdzd2databasezd2listalb1353z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5288, obj_t BgL_oz00_5289, obj_t BgL_opz00_5290)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1168 */
{ /* Llib/mpd.scm 1169 */
bool_t BgL_tmpz00_8823;
{ /* Llib/mpd.scm 1169 */
obj_t BgL_g1238z00_5948;
BgL_g1238z00_5948 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5289)))->BgL_z52albumsz52); 
{ 
obj_t BgL_l1236z00_5950;
BgL_l1236z00_5950 = BgL_g1238z00_5948; 
BgL_zc3anonymousza32465ze3z83_5949:
if(
PAIRP(BgL_l1236z00_5950))
{ /* Llib/mpd.scm 1173 */
{ /* Llib/mpd.scm 1170 */
obj_t BgL_az00_5951;
BgL_az00_5951 = 
CAR(BgL_l1236z00_5950); 
{ /* Llib/mpd.scm 1170 */
obj_t BgL_tmpz00_8829;
BgL_tmpz00_8829 = 
((obj_t)BgL_opz00_5290); 
bgl_display_string(BGl_string3383z00zz__multimediazd2mpdzd2, BgL_tmpz00_8829); } 
{ /* Llib/mpd.scm 1171 */
obj_t BgL_arg2467z00_5952;
BgL_arg2467z00_5952 = 
CAR(
((obj_t)BgL_az00_5951)); 
bgl_display_obj(BgL_arg2467z00_5952, 
((obj_t)BgL_opz00_5290)); } 
{ /* Llib/mpd.scm 1172 */
obj_t BgL_tmpz00_8836;
BgL_tmpz00_8836 = 
((obj_t)BgL_opz00_5290); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8836); } } 
{ 
obj_t BgL_l1236z00_8839;
BgL_l1236z00_8839 = 
CDR(BgL_l1236z00_5950); 
BgL_l1236z00_5950 = BgL_l1236z00_8839; 
goto BgL_zc3anonymousza32465ze3z83_5949;} }  else 
{ /* Llib/mpd.scm 1173 */
BgL_tmpz00_8823 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8823);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-listall1351 */
obj_t BGl_z62mpdzd2databasezd2listall1351z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5291, obj_t BgL_oz00_5292, obj_t BgL_opz00_5293)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1142 */
{ /* Llib/mpd.scm 1146 */
bool_t BgL_tmpz00_8842;
{ /* Llib/mpd.scm 1160 */
obj_t BgL_tmpz00_8843;
BgL_tmpz00_8843 = 
((obj_t)BgL_opz00_5293); 
bgl_display_string(BGl_string3490z00zz__multimediazd2mpdzd2, BgL_tmpz00_8843); } 
bgl_display_obj(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5292)))->BgL_z52basez52), 
((obj_t)BgL_opz00_5293)); 
{ /* Llib/mpd.scm 1162 */
obj_t BgL_tmpz00_8850;
BgL_tmpz00_8850 = 
((obj_t)BgL_opz00_5293); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8850); } 
{ /* Llib/mpd.scm 1163 */
obj_t BgL_g1235z00_5958;
BgL_g1235z00_5958 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5292)))->BgL_directoriesz00); 
{ 
obj_t BgL_l1233z00_5960;
BgL_l1233z00_5960 = BgL_g1235z00_5958; 
BgL_zc3anonymousza32451ze3z83_5959:
if(
PAIRP(BgL_l1233z00_5960))
{ /* Llib/mpd.scm 1163 */
{ /* Llib/mpd.scm 1163 */
obj_t BgL_pathz00_5963;
BgL_pathz00_5963 = 
CAR(BgL_l1233z00_5960); 
BGl_loopze70ze7zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5292), 
((obj_t)BgL_opz00_5293), BgL_pathz00_5963); } 
{ 
obj_t BgL_l1233z00_8861;
BgL_l1233z00_8861 = 
CDR(BgL_l1233z00_5960); 
BgL_l1233z00_5960 = BgL_l1233z00_8861; 
goto BgL_zc3anonymousza32451ze3z83_5959;} }  else 
{ /* Llib/mpd.scm 1163 */
BgL_tmpz00_8842 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8842);} } 
BGL_FUNCTION_END;
}



/* loop~0 */
obj_t BGl_loopze70ze7zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_5379, obj_t BgL_opz00_5378, obj_t BgL_pathz00_1892)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1145 */
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pathz00_1892)))
{ /* Llib/mpd.scm 1146 */
bgl_display_string(BGl_string3490z00zz__multimediazd2mpdzd2, BgL_opz00_5378); 
{ /* Llib/mpd.scm 1149 */
obj_t BgL_arg2458z00_1895;
BgL_arg2458z00_1895 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_pathz00_1892, 
((obj_t)BgL_oz00_5379)); 
bgl_display_obj(BgL_arg2458z00_1895, BgL_opz00_5378); } 
bgl_display_char(((unsigned char)10), BgL_opz00_5378); 
{ /* Llib/mpd.scm 1151 */
obj_t BgL_g1232z00_1896;
BgL_g1232z00_1896 = 
BGl_directoryzd2ze3sortzd2listze3zz__multimediazd2mpdzd2(BgL_pathz00_1892); 
{ 
obj_t BgL_l1229z00_1898;
{ /* Llib/mpd.scm 1153 */
bool_t BgL_tmpz00_8873;
BgL_l1229z00_1898 = BgL_g1232z00_1896; 
BgL_zc3anonymousza32459ze3z83_1899:
if(
PAIRP(BgL_l1229z00_1898))
{ /* Llib/mpd.scm 1153 */
{ /* Llib/mpd.scm 1152 */
obj_t BgL_fz00_1901;
BgL_fz00_1901 = 
CAR(BgL_l1229z00_1898); 
BGl_loopze70ze7zz__multimediazd2mpdzd2(BgL_oz00_5379, BgL_opz00_5378, 
BGl_makezd2filezd2namez00zz__osz00(BgL_pathz00_1892, BgL_fz00_1901)); } 
{ 
obj_t BgL_l1229z00_8879;
BgL_l1229z00_8879 = 
CDR(BgL_l1229z00_1898); 
BgL_l1229z00_1898 = BgL_l1229z00_8879; 
goto BgL_zc3anonymousza32459ze3z83_1899;} }  else 
{ /* Llib/mpd.scm 1153 */
BgL_tmpz00_8873 = ((bool_t)1)
; } 
return 
BBOOL(BgL_tmpz00_8873);} } } }  else 
{ /* Llib/mpd.scm 1146 */
bgl_display_string(BGl_string3378z00zz__multimediazd2mpdzd2, BgL_opz00_5378); 
{ /* Llib/mpd.scm 1156 */
obj_t BgL_arg2463z00_1905;
BgL_arg2463z00_1905 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_pathz00_1892, 
((obj_t)BgL_oz00_5379)); 
bgl_display_obj(BgL_arg2463z00_1905, BgL_opz00_5378); } 
return 
bgl_display_char(((unsigned char)10), BgL_opz00_5378);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-stats1349 */
obj_t BGl_z62mpdzd2databasezd2stats1349z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5294, obj_t BgL_oz00_5295, obj_t BgL_backendz00_5296, obj_t BgL_opz00_5297)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1108 */
{ 

{ /* Llib/mpd.scm 1125 */
obj_t BgL_arg2424z00_5971;int BgL_arg2425z00_5972;int BgL_arg2426z00_5973;long BgL_arg2427z00_5974;obj_t BgL_arg2428z00_5975;long BgL_arg2429z00_5976;
BgL_arg2424z00_5971 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5295)))->BgL_z52nartistsz52); 
BgL_arg2425z00_5972 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5295)))->BgL_z52nalbumsz52); 
BgL_arg2426z00_5973 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5295)))->BgL_z52nsongsz52); 
{ /* Llib/mpd.scm 1135 */
long BgL_arg2436z00_5977;
{ /* Llib/mpd.scm 1135 */
long BgL_arg2437z00_5978;obj_t BgL_arg2438z00_5979;
BgL_arg2437z00_5978 = 
bgl_current_seconds(); 
BgL_arg2438z00_5979 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5295)))->BgL_z52uptimez52); 
{ /* Llib/mpd.scm 1135 */
long BgL_res2916z00_5980;
{ /* Llib/mpd.scm 1135 */
long BgL_za72za7_5981;
BgL_za72za7_5981 = 
BELONG_TO_LONG(BgL_arg2438z00_5979); 
{ /* Llib/mpd.scm 1135 */
long BgL_tmpz00_8897;
BgL_tmpz00_8897 = 
(BgL_arg2437z00_5978-BgL_za72za7_5981); 
BgL_res2916z00_5980 = 
(long)(BgL_tmpz00_8897); } } 
BgL_arg2436z00_5977 = BgL_res2916z00_5980; } } 
{ /* Llib/mpd.scm 1135 */
long BgL_res2917z00_5982;
BgL_res2917z00_5982 = 
(long)(BgL_arg2436z00_5977); 
BgL_arg2427z00_5974 = BgL_res2917z00_5982; } } 
{ /* Llib/mpd.scm 1111 */
obj_t BgL_plistz00_5966;int BgL_numz00_5967;
BgL_plistz00_5966 = 
BGl_musiczd2playlistzd2getz00zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_5296)); 
BgL_numz00_5967 = 
BGl_musiczd2songzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_5296)); 
{ /* Llib/mpd.scm 1113 */
bool_t BgL_testz00_8905;
if(
(
(long)(BgL_numz00_5967)>=((long)0)))
{ /* Llib/mpd.scm 1113 */
BgL_testz00_8905 = 
(
(long)(BgL_numz00_5967)<
bgl_list_length(BgL_plistz00_5966))
; }  else 
{ /* Llib/mpd.scm 1113 */
BgL_testz00_8905 = ((bool_t)0)
; } 
if(BgL_testz00_8905)
{ /* Llib/mpd.scm 1114 */
obj_t BgL_filez00_5968;
BgL_filez00_5968 = 
bgl_list_ref(BgL_plistz00_5966, 
(long)(BgL_numz00_5967)); 
{ /* Llib/mpd.scm 1114 */
obj_t BgL_pathz00_5969;
if(
bigloo_strcmp_at(BgL_filez00_5968, BGl_string3375z00zz__multimediazd2mpdzd2, ((long)0)))
{ /* Llib/mpd.scm 1021 */
BgL_pathz00_5969 = BgL_filez00_5968; }  else 
{ /* Llib/mpd.scm 1021 */
BgL_pathz00_5969 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_filez00_5968, 
((obj_t)
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5295))); } 
{ /* Llib/mpd.scm 1115 */

if(
fexists(
BSTRING_TO_STRING(BgL_filez00_5968)))
{ /* Llib/mpd.scm 1117 */
obj_t BgL_infoz00_5970;
BgL_infoz00_5970 = 
BGl_filezd2musicinfozd2zz__multimediazd2id3zd2(BgL_filez00_5968); 
if(
BGl_isazf3zf3zz__objectz00(BgL_infoz00_5970, BGl_musicinfoz00zz__multimediazd2id3zd2))
{ /* Llib/mpd.scm 1118 */
BgL_arg2428z00_5975 = 
BINT(
(((BgL_musicinfoz00_bglt)COBJECT(
((BgL_musicinfoz00_bglt)BgL_infoz00_5970)))->BgL_durationz00)); }  else 
{ /* Llib/mpd.scm 1118 */
BgL_arg2428z00_5975 = 
BINT(((long)1000000)); } }  else 
{ /* Llib/mpd.scm 1116 */
BgL_arg2428z00_5975 = 
BINT(((long)1000000)); } } } }  else 
{ /* Llib/mpd.scm 1113 */
BgL_arg2428z00_5975 = BFALSE; } } } 
{ /* Llib/mpd.scm 1137 */
long BgL_arg2439z00_5983;
{ /* Llib/mpd.scm 1137 */
long BgL_arg2440z00_5984;obj_t BgL_arg2441z00_5985;
BgL_arg2440z00_5984 = 
bgl_current_seconds(); 
BgL_arg2441z00_5985 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5295)))->BgL_z52dbzd2updatez80); 
{ /* Llib/mpd.scm 1137 */
long BgL_res2919z00_5986;
{ /* Llib/mpd.scm 1137 */
long BgL_za72za7_5987;
BgL_za72za7_5987 = 
BELONG_TO_LONG(BgL_arg2441z00_5985); 
{ /* Llib/mpd.scm 1137 */
long BgL_tmpz00_8934;
BgL_tmpz00_8934 = 
(BgL_arg2440z00_5984-BgL_za72za7_5987); 
BgL_res2919z00_5986 = 
(long)(BgL_tmpz00_8934); } } 
BgL_arg2439z00_5983 = BgL_res2919z00_5986; } } 
{ /* Llib/mpd.scm 1137 */
long BgL_res2920z00_5988;
BgL_res2920z00_5988 = 
(long)(BgL_arg2439z00_5983); 
BgL_arg2429z00_5976 = BgL_res2920z00_5988; } } 
{ /* Llib/mpd.scm 1125 */
obj_t BgL_list2430z00_5989;
{ /* Llib/mpd.scm 1125 */
obj_t BgL_arg2431z00_5990;
{ /* Llib/mpd.scm 1125 */
obj_t BgL_arg2432z00_5991;
{ /* Llib/mpd.scm 1125 */
obj_t BgL_arg2433z00_5992;
{ /* Llib/mpd.scm 1125 */
obj_t BgL_arg2434z00_5993;
{ /* Llib/mpd.scm 1125 */
obj_t BgL_arg2435z00_5994;
BgL_arg2435z00_5994 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2429z00_5976), BNIL); 
BgL_arg2434z00_5993 = 
MAKE_YOUNG_PAIR(BgL_arg2428z00_5975, BgL_arg2435z00_5994); } 
BgL_arg2433z00_5992 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2427z00_5974), BgL_arg2434z00_5993); } 
BgL_arg2432z00_5991 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2426z00_5973), BgL_arg2433z00_5992); } 
BgL_arg2431z00_5990 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2425z00_5972), BgL_arg2432z00_5991); } 
BgL_list2430z00_5989 = 
MAKE_YOUNG_PAIR(BgL_arg2424z00_5971, BgL_arg2431z00_5990); } 
return 
BGl_fprintfz00zz__r4_output_6_10_3z00(BgL_opz00_5297, BGl_string3493z00zz__multimediazd2mpdzd2, BgL_list2430z00_5989);} } } } 
BGL_FUNCTION_END;
}



/* &mpd-database-file->p1347 */
obj_t BGl_z62mpdzd2databasezd2filezd2ze3p1347z53zz__multimediazd2mpdzd2(obj_t BgL_envz00_5298, obj_t BgL_oz00_5299, obj_t BgL_filez00_5300)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1095 */
if(
NULLP(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5299)))->BgL_directoriesz00)))
{ /* Llib/mpd.scm 1097 */
return 
((obj_t)BgL_filez00_5300);}  else 
{ /* Llib/mpd.scm 1099 */
obj_t BgL_dirz00_5997;
{ /* Llib/mpd.scm 1099 */
obj_t BgL_arg2421z00_5998;
BgL_arg2421z00_5998 = 
BGl_filezd2namezd2ze3listze3zz__osz00(
((obj_t)BgL_filez00_5300)); 
BgL_dirz00_5997 = 
CAR(
((obj_t)BgL_arg2421z00_5998)); } 
{ /* Llib/mpd.scm 1099 */
obj_t BgL_nz00_5999;
{ /* Llib/mpd.scm 1100 */
obj_t BgL_arg2419z00_6000;
BgL_arg2419z00_6000 = 
CAR(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5299)))->BgL_directoriesz00)); 
{ /* Llib/mpd.scm 1100 */

BgL_nz00_5999 = 
BGl_stringzd2containszd2zz__r4_strings_6_7z00(BgL_arg2419z00_6000, BgL_dirz00_5997, 
(int)(((long)0))); } } 
{ /* Llib/mpd.scm 1100 */

if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_nz00_5999))
{ /* Llib/mpd.scm 1102 */
obj_t BgL_arg2416z00_6001;
{ /* Llib/mpd.scm 1102 */
obj_t BgL_arg2417z00_6002;
BgL_arg2417z00_6002 = 
CAR(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5299)))->BgL_directoriesz00)); 
{ /* Llib/mpd.scm 1102 */
obj_t BgL_res2911z00_6003;
{ /* Llib/mpd.scm 1102 */
long BgL_endz00_6004;
BgL_endz00_6004 = 
(long)CINT(BgL_nz00_5999); 
BgL_res2911z00_6003 = 
c_substring(
((obj_t)BgL_arg2417z00_6002), ((long)0), BgL_endz00_6004); } 
BgL_arg2416z00_6001 = BgL_res2911z00_6003; } } 
return 
string_append(BgL_arg2416z00_6001, 
((obj_t)BgL_filez00_5300));}  else 
{ /* Llib/mpd.scm 1101 */
return 
((obj_t)BgL_filez00_5300);} } } } } 
BGL_FUNCTION_END;
}



/* &mpd-database-init!1345 */
obj_t BGl_z62mpdzd2databasezd2initz121345z70zz__multimediazd2mpdzd2(obj_t BgL_envz00_5301, obj_t BgL_oz00_5302)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 956 */
{ 
BgL_mpdzd2databasezd2_bglt BgL_auxz00_8974;
if(
NULLP(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5302)))->BgL_directoriesz00)))
{ /* Llib/mpd.scm 962 */BFALSE; }  else 
{ /* Llib/mpd.scm 962 */
if(
NULLP(
CDR(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5302)))->BgL_directoriesz00))))
{ 
obj_t BgL_auxz00_8984;
{ /* Llib/mpd.scm 964 */
obj_t BgL_pairz00_6008;
BgL_pairz00_6008 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5302)))->BgL_directoriesz00); 
BgL_auxz00_8984 = 
CAR(BgL_pairz00_6008); } 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5302)))->BgL_z52basez52)=((obj_t)BgL_auxz00_8984),BUNSPEC); }  else 
{ /* Llib/mpd.scm 965 */
obj_t BgL_g1139z00_6009;obj_t BgL_g1141z00_6010;
BgL_g1139z00_6009 = 
CDR(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5302)))->BgL_directoriesz00)); 
BgL_g1141z00_6010 = 
BGl_filezd2namezd2ze3listze3zz__osz00(
CAR(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5302)))->BgL_directoriesz00))); 
{ 
obj_t BgL_dirsz00_6012;obj_t BgL_lz00_6013;
BgL_dirsz00_6012 = BgL_g1139z00_6009; 
BgL_lz00_6013 = BgL_g1141z00_6010; 
BgL_loopz00_6011:
if(
NULLP(BgL_dirsz00_6012))
{ 
obj_t BgL_auxz00_8999;
{ /* Llib/mpd.scm 968 */
obj_t BgL_runner2393z00_6014;
BgL_runner2393z00_6014 = BgL_lz00_6013; 
{ /* Llib/mpd.scm 968 */
obj_t BgL_aux2391z00_6015;
{ /* Llib/mpd.scm 968 */
obj_t BgL_pairz00_6016;
BgL_pairz00_6016 = BgL_runner2393z00_6014; 
BgL_aux2391z00_6015 = 
CAR(BgL_pairz00_6016); } 
{ /* Llib/mpd.scm 968 */
obj_t BgL_pairz00_6017;
BgL_pairz00_6017 = BgL_runner2393z00_6014; 
BgL_runner2393z00_6014 = 
CDR(BgL_pairz00_6017); } 
{ /* Llib/mpd.scm 968 */
obj_t BgL_aux2392z00_6018;
{ /* Llib/mpd.scm 968 */
obj_t BgL_pairz00_6019;
BgL_pairz00_6019 = BgL_runner2393z00_6014; 
BgL_aux2392z00_6018 = 
CAR(BgL_pairz00_6019); } 
{ /* Llib/mpd.scm 968 */
obj_t BgL_pairz00_6020;
BgL_pairz00_6020 = BgL_runner2393z00_6014; 
BgL_runner2393z00_6014 = 
CDR(BgL_pairz00_6020); } 
BgL_auxz00_8999 = 
BGl_makezd2filezd2pathz00zz__osz00(BgL_aux2391z00_6015, BgL_aux2392z00_6018, BgL_runner2393z00_6014); } } } 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5302)))->BgL_z52basez52)=((obj_t)BgL_auxz00_8999),BUNSPEC); }  else 
{ /* Llib/mpd.scm 969 */
obj_t BgL_nlz00_6021;
BgL_nlz00_6021 = 
BGl_filezd2namezd2ze3listze3zz__osz00(
BGl_dirnamez00zz__osz00(
CAR(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5302)))->BgL_directoriesz00)))); 
{ /* Llib/mpd.scm 970 */
obj_t BgL_arg2394z00_6022;obj_t BgL_arg2395z00_6023;
BgL_arg2394z00_6022 = 
CDR(
((obj_t)BgL_dirsz00_6012)); 
BgL_arg2395z00_6023 = 
BGl_loopze75ze7zz__multimediazd2mpdzd2(BgL_lz00_6013, BgL_nlz00_6021); 
{ 
obj_t BgL_lz00_9016;obj_t BgL_dirsz00_9015;
BgL_dirsz00_9015 = BgL_arg2394z00_6022; 
BgL_lz00_9016 = BgL_arg2395z00_6023; 
BgL_lz00_6013 = BgL_lz00_9016; 
BgL_dirsz00_6012 = BgL_dirsz00_9015; 
goto BgL_loopz00_6011;} } } } } } 
{ 
obj_t BgL_auxz00_9017;
{ /* Llib/mpd.scm 972 */
long BgL_arg2405z00_6026;long BgL_arg2406z00_6027;
{ /* Llib/mpd.scm 972 */
long BgL_res2906z00_6028;
BgL_res2906z00_6028 = 
bgl_current_seconds(); 
BgL_arg2405z00_6026 = BgL_res2906z00_6028; } 
{ /* Llib/mpd.scm 972 */
obj_t BgL_arg2407z00_6029;
BgL_arg2407z00_6029 = 
BGl_makezd2datezd2zz__datez00(
BINT(((long)1)), 
BINT(((long)-1)), 
BINT(((long)0)), 
BINT(((long)0)), 
BINT(((long)1)), BGl_llong3494z00zz__multimediazd2mpdzd2, 
BINT(((long)0)), BFALSE, 
BINT(((long)1970))); 
{ /* Llib/mpd.scm 972 */
long BgL_res2907z00_6030;
BgL_res2907z00_6030 = 
bgl_date_to_seconds(
((obj_t)BgL_arg2407z00_6029)); 
BgL_arg2406z00_6027 = BgL_res2907z00_6030; } } 
BgL_auxz00_9017 = 
BGl_2zd2zd2zz__r4_numbers_6_5z00(
make_belong(BgL_arg2405z00_6026), 
make_belong(BgL_arg2406z00_6027)); } 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5302)))->BgL_z52dbzd2updatez80)=((obj_t)BgL_auxz00_9017),BUNSPEC); } 
{ 
obj_t BgL_auxz00_9034;
{ /* Llib/mpd.scm 973 */
long BgL_arg2408z00_6031;long BgL_arg2409z00_6032;
{ /* Llib/mpd.scm 973 */
long BgL_res2908z00_6033;
BgL_res2908z00_6033 = 
bgl_current_seconds(); 
BgL_arg2408z00_6031 = BgL_res2908z00_6033; } 
{ /* Llib/mpd.scm 973 */
obj_t BgL_arg2410z00_6034;
BgL_arg2410z00_6034 = 
BGl_makezd2datezd2zz__datez00(
BINT(((long)1)), 
BINT(((long)-1)), 
BINT(((long)0)), 
BINT(((long)0)), 
BINT(((long)1)), BGl_llong3494z00zz__multimediazd2mpdzd2, 
BINT(((long)0)), BFALSE, 
BINT(((long)1970))); 
{ /* Llib/mpd.scm 973 */
long BgL_res2909z00_6035;
BgL_res2909z00_6035 = 
bgl_date_to_seconds(
((obj_t)BgL_arg2410z00_6034)); 
BgL_arg2409z00_6032 = BgL_res2909z00_6035; } } 
BgL_auxz00_9034 = 
BGl_2zd2zd2zz__r4_numbers_6_5z00(
make_belong(BgL_arg2408z00_6031), 
make_belong(BgL_arg2409z00_6032)); } 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5302)))->BgL_z52uptimez52)=((obj_t)BgL_auxz00_9034),BUNSPEC); } 
{ /* Llib/mpd.scm 975 */
obj_t BgL_artistsz00_6036;
BgL_artistsz00_6036 = 
BGl_mpdzd2databasezd2directorieszd2scanzd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5302), 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5302)))->BgL_directoriesz00)); 
{ /* Llib/mpd.scm 976 */
obj_t BgL_albumsz00_6037;obj_t BgL_genresz00_6038;obj_t BgL_nsongz00_6039;
{ /* Llib/mpd.scm 977 */
int BgL_tmpz00_9055;
BgL_tmpz00_9055 = 
(int)(((long)1)); 
BgL_albumsz00_6037 = 
BGL_MVALUES_VAL(BgL_tmpz00_9055); } 
{ /* Llib/mpd.scm 977 */
int BgL_tmpz00_9058;
BgL_tmpz00_9058 = 
(int)(((long)2)); 
BgL_genresz00_6038 = 
BGL_MVALUES_VAL(BgL_tmpz00_9058); } 
{ /* Llib/mpd.scm 977 */
int BgL_tmpz00_9061;
BgL_tmpz00_9061 = 
(int)(((long)3)); 
BgL_nsongz00_6039 = 
BGL_MVALUES_VAL(BgL_tmpz00_9061); } 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5302)))->BgL_z52artistsz52)=((obj_t)BgL_artistsz00_6036),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5302)))->BgL_z52nartistsz52)=((obj_t)
BINT(
bgl_list_length(BgL_artistsz00_6036))),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5302)))->BgL_z52albumsz52)=((obj_t)BgL_albumsz00_6037),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5302)))->BgL_z52genresz52)=((obj_t)BgL_genresz00_6038),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5302)))->BgL_z52nalbumsz52)=((int)
(int)(
bgl_list_length(BgL_albumsz00_6037))),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5302)))->BgL_z52nsongsz52)=((int)
CINT(BgL_nsongz00_6039)),BUNSPEC); } } 
BgL_auxz00_8974 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5302); 
return 
((obj_t)BgL_auxz00_8974);} } 
BGL_FUNCTION_END;
}



/* mpd-database-init! */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2initz12z12zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_331)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 956 */
{ /* Llib/mpd.scm 956 */
obj_t BgL_method1346z00_2382;
{ /* Llib/mpd.scm 956 */
obj_t BgL_res2996z00_3763;
{ /* Llib/mpd.scm 956 */
long BgL_objzd2classzd2numz00_3720;
{ /* Llib/mpd.scm 956 */
long BgL_res2985z00_3723;
BgL_res2985z00_3723 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_331)); 
BgL_objzd2classzd2numz00_3720 = BgL_res2985z00_3723; } 
{ /* Llib/mpd.scm 956 */
obj_t BgL_arg1742z00_3721;
BgL_arg1742z00_3721 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2initz12zd2envzc0zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 956 */
int BgL_offsetz00_3725;
BgL_offsetz00_3725 = 
(int)(BgL_objzd2classzd2numz00_3720); 
{ /* Llib/mpd.scm 956 */
long BgL_offsetz00_3726;
BgL_offsetz00_3726 = 
(
(long)(BgL_offsetz00_3725)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 956 */
long BgL_modz00_3727;
{ /* Llib/mpd.scm 956 */
int BgL_arg1744z00_3728;
BgL_arg1744z00_3728 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 956 */
long BgL_res2988z00_3738;
{ /* Llib/mpd.scm 956 */
long BgL_tmpz00_9091;
BgL_tmpz00_9091 = 
(long)(BgL_arg1744z00_3728); 
BgL_res2988z00_3738 = 
(BgL_offsetz00_3726/BgL_tmpz00_9091); } 
BgL_modz00_3727 = BgL_res2988z00_3738; } } 
{ /* Llib/mpd.scm 956 */
long BgL_restz00_3729;
{ /* Llib/mpd.scm 956 */
int BgL_arg1743z00_3730;
BgL_arg1743z00_3730 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 956 */
long BgL_res2995z00_3758;
{ /* Llib/mpd.scm 956 */
long BgL_n1z00_3740;long BgL_n2z00_3741;
BgL_n1z00_3740 = BgL_offsetz00_3726; 
BgL_n2z00_3741 = 
(long)(BgL_arg1743z00_3730); 
{ /* Llib/mpd.scm 956 */
bool_t BgL_testz00_9096;
{ /* Llib/mpd.scm 956 */
long BgL_arg1283z00_3743;
BgL_arg1283z00_3743 = 
(((BgL_n1z00_3740) | (BgL_n2z00_3741)) & -2147483648); 
BgL_testz00_9096 = 
(BgL_arg1283z00_3743==((long)0)); } 
if(BgL_testz00_9096)
{ /* Llib/mpd.scm 956 */
int32_t BgL_arg1272z00_3744;
{ /* Llib/mpd.scm 956 */
int32_t BgL_arg1278z00_3745;int32_t BgL_arg1279z00_3746;
{ /* Llib/mpd.scm 956 */
int32_t BgL_res2991z00_3750;
BgL_res2991z00_3750 = 
(int32_t)(BgL_n1z00_3740); 
BgL_arg1278z00_3745 = BgL_res2991z00_3750; } 
{ /* Llib/mpd.scm 956 */
int32_t BgL_res2992z00_3752;
BgL_res2992z00_3752 = 
(int32_t)(BgL_n2z00_3741); 
BgL_arg1279z00_3746 = BgL_res2992z00_3752; } 
BgL_arg1272z00_3744 = 
(BgL_arg1278z00_3745%BgL_arg1279z00_3746); } 
{ /* Llib/mpd.scm 956 */
long BgL_res2994z00_3757;
{ /* Llib/mpd.scm 956 */
long BgL_arg1409z00_3754;
BgL_arg1409z00_3754 = 
(long)(BgL_arg1272z00_3744); 
{ /* Llib/mpd.scm 956 */
long BgL_res2993z00_3756;
BgL_res2993z00_3756 = 
(long)(BgL_arg1409z00_3754); 
BgL_res2994z00_3757 = BgL_res2993z00_3756; } } 
BgL_res2995z00_3758 = BgL_res2994z00_3757; } }  else 
{ /* Llib/mpd.scm 956 */
BgL_res2995z00_3758 = 
(BgL_n1z00_3740%BgL_n2z00_3741); } } } 
BgL_restz00_3729 = BgL_res2995z00_3758; } } 
{ /* Llib/mpd.scm 956 */

{ /* Llib/mpd.scm 956 */
obj_t BgL_bucketz00_3731;
BgL_bucketz00_3731 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3721),BgL_modz00_3727); 
BgL_res2996z00_3763 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3731),BgL_restz00_3729); } } } } } } } } 
BgL_method1346z00_2382 = BgL_res2996z00_3763; } 
return 
PROCEDURE_ENTRY(BgL_method1346z00_2382)(BgL_method1346z00_2382, 
((obj_t)BgL_oz00_331), BEOA);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-init! */
obj_t BGl_z62mpdzd2databasezd2initz12z70zz__multimediazd2mpdzd2(obj_t BgL_envz00_5194, obj_t BgL_oz00_5195)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 956 */
{ /* Llib/mpd.scm 956 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_9114;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5195, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 956 */
BgL_auxz00_9114 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5195)
; }  else 
{ 
obj_t BgL_auxz00_9118;
BgL_auxz00_9118 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)37998)), BGl_string3495z00zz__multimediazd2mpdzd2, BGl_string3346z00zz__multimediazd2mpdzd2, BgL_oz00_5195); 
FAILURE(BgL_auxz00_9118,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2initz12z12zz__multimediazd2mpdzd2(BgL_auxz00_9114);} } 
BGL_FUNCTION_END;
}



/* mpd-database-file->path */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2filezd2ze3pathz31zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_349, obj_t BgL_filez00_350)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1095 */
{ /* Llib/mpd.scm 1095 */
obj_t BgL_method1348z00_2383;
{ /* Llib/mpd.scm 1095 */
obj_t BgL_res3008z00_3808;
{ /* Llib/mpd.scm 1095 */
long BgL_objzd2classzd2numz00_3765;
{ /* Llib/mpd.scm 1095 */
long BgL_res2997z00_3768;
BgL_res2997z00_3768 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_349)); 
BgL_objzd2classzd2numz00_3765 = BgL_res2997z00_3768; } 
{ /* Llib/mpd.scm 1095 */
obj_t BgL_arg1742z00_3766;
BgL_arg1742z00_3766 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2filezd2ze3pathzd2envze3zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1095 */
int BgL_offsetz00_3770;
BgL_offsetz00_3770 = 
(int)(BgL_objzd2classzd2numz00_3765); 
{ /* Llib/mpd.scm 1095 */
long BgL_offsetz00_3771;
BgL_offsetz00_3771 = 
(
(long)(BgL_offsetz00_3770)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1095 */
long BgL_modz00_3772;
{ /* Llib/mpd.scm 1095 */
int BgL_arg1744z00_3773;
BgL_arg1744z00_3773 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1095 */
long BgL_res3000z00_3783;
{ /* Llib/mpd.scm 1095 */
long BgL_tmpz00_9131;
BgL_tmpz00_9131 = 
(long)(BgL_arg1744z00_3773); 
BgL_res3000z00_3783 = 
(BgL_offsetz00_3771/BgL_tmpz00_9131); } 
BgL_modz00_3772 = BgL_res3000z00_3783; } } 
{ /* Llib/mpd.scm 1095 */
long BgL_restz00_3774;
{ /* Llib/mpd.scm 1095 */
int BgL_arg1743z00_3775;
BgL_arg1743z00_3775 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1095 */
long BgL_res3007z00_3803;
{ /* Llib/mpd.scm 1095 */
long BgL_n1z00_3785;long BgL_n2z00_3786;
BgL_n1z00_3785 = BgL_offsetz00_3771; 
BgL_n2z00_3786 = 
(long)(BgL_arg1743z00_3775); 
{ /* Llib/mpd.scm 1095 */
bool_t BgL_testz00_9136;
{ /* Llib/mpd.scm 1095 */
long BgL_arg1283z00_3788;
BgL_arg1283z00_3788 = 
(((BgL_n1z00_3785) | (BgL_n2z00_3786)) & -2147483648); 
BgL_testz00_9136 = 
(BgL_arg1283z00_3788==((long)0)); } 
if(BgL_testz00_9136)
{ /* Llib/mpd.scm 1095 */
int32_t BgL_arg1272z00_3789;
{ /* Llib/mpd.scm 1095 */
int32_t BgL_arg1278z00_3790;int32_t BgL_arg1279z00_3791;
{ /* Llib/mpd.scm 1095 */
int32_t BgL_res3003z00_3795;
BgL_res3003z00_3795 = 
(int32_t)(BgL_n1z00_3785); 
BgL_arg1278z00_3790 = BgL_res3003z00_3795; } 
{ /* Llib/mpd.scm 1095 */
int32_t BgL_res3004z00_3797;
BgL_res3004z00_3797 = 
(int32_t)(BgL_n2z00_3786); 
BgL_arg1279z00_3791 = BgL_res3004z00_3797; } 
BgL_arg1272z00_3789 = 
(BgL_arg1278z00_3790%BgL_arg1279z00_3791); } 
{ /* Llib/mpd.scm 1095 */
long BgL_res3006z00_3802;
{ /* Llib/mpd.scm 1095 */
long BgL_arg1409z00_3799;
BgL_arg1409z00_3799 = 
(long)(BgL_arg1272z00_3789); 
{ /* Llib/mpd.scm 1095 */
long BgL_res3005z00_3801;
BgL_res3005z00_3801 = 
(long)(BgL_arg1409z00_3799); 
BgL_res3006z00_3802 = BgL_res3005z00_3801; } } 
BgL_res3007z00_3803 = BgL_res3006z00_3802; } }  else 
{ /* Llib/mpd.scm 1095 */
BgL_res3007z00_3803 = 
(BgL_n1z00_3785%BgL_n2z00_3786); } } } 
BgL_restz00_3774 = BgL_res3007z00_3803; } } 
{ /* Llib/mpd.scm 1095 */

{ /* Llib/mpd.scm 1095 */
obj_t BgL_bucketz00_3776;
BgL_bucketz00_3776 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3766),BgL_modz00_3772); 
BgL_res3008z00_3808 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3776),BgL_restz00_3774); } } } } } } } } 
BgL_method1348z00_2383 = BgL_res3008z00_3808; } 
return 
PROCEDURE_ENTRY(BgL_method1348z00_2383)(BgL_method1348z00_2383, 
((obj_t)BgL_oz00_349), BgL_filez00_350, BEOA);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-file->path */
obj_t BGl_z62mpdzd2databasezd2filezd2ze3pathz53zz__multimediazd2mpdzd2(obj_t BgL_envz00_5303, obj_t BgL_oz00_5304, obj_t BgL_filez00_5305)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1095 */
{ /* Llib/mpd.scm 1095 */
obj_t BgL_auxz00_9163;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9155;
if(
STRINGP(BgL_filez00_5305))
{ /* Llib/mpd.scm 1095 */
BgL_auxz00_9163 = BgL_filez00_5305
; }  else 
{ 
obj_t BgL_auxz00_9166;
BgL_auxz00_9166 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)43641)), BGl_string3496z00zz__multimediazd2mpdzd2, BGl_string3497z00zz__multimediazd2mpdzd2, BgL_filez00_5305); 
FAILURE(BgL_auxz00_9166,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5304, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1095 */
BgL_auxz00_9155 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5304)
; }  else 
{ 
obj_t BgL_auxz00_9159;
BgL_auxz00_9159 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)43641)), BGl_string3496z00zz__multimediazd2mpdzd2, BGl_string3346z00zz__multimediazd2mpdzd2, BgL_oz00_5304); 
FAILURE(BgL_auxz00_9159,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2filezd2ze3pathz31zz__multimediazd2mpdzd2(BgL_auxz00_9155, BgL_auxz00_9163);} } 
BGL_FUNCTION_END;
}



/* mpd-database-stats */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2statsz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_351, obj_t BgL_backendz00_352, obj_t BgL_opz00_353)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1108 */
{ /* Llib/mpd.scm 1108 */
obj_t BgL_method1350z00_2384;
{ /* Llib/mpd.scm 1108 */
obj_t BgL_res3020z00_3853;
{ /* Llib/mpd.scm 1108 */
long BgL_objzd2classzd2numz00_3810;
{ /* Llib/mpd.scm 1108 */
long BgL_res3009z00_3813;
BgL_res3009z00_3813 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_351)); 
BgL_objzd2classzd2numz00_3810 = BgL_res3009z00_3813; } 
{ /* Llib/mpd.scm 1108 */
obj_t BgL_arg1742z00_3811;
BgL_arg1742z00_3811 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2statszd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1108 */
int BgL_offsetz00_3815;
BgL_offsetz00_3815 = 
(int)(BgL_objzd2classzd2numz00_3810); 
{ /* Llib/mpd.scm 1108 */
long BgL_offsetz00_3816;
BgL_offsetz00_3816 = 
(
(long)(BgL_offsetz00_3815)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1108 */
long BgL_modz00_3817;
{ /* Llib/mpd.scm 1108 */
int BgL_arg1744z00_3818;
BgL_arg1744z00_3818 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1108 */
long BgL_res3012z00_3828;
{ /* Llib/mpd.scm 1108 */
long BgL_tmpz00_9179;
BgL_tmpz00_9179 = 
(long)(BgL_arg1744z00_3818); 
BgL_res3012z00_3828 = 
(BgL_offsetz00_3816/BgL_tmpz00_9179); } 
BgL_modz00_3817 = BgL_res3012z00_3828; } } 
{ /* Llib/mpd.scm 1108 */
long BgL_restz00_3819;
{ /* Llib/mpd.scm 1108 */
int BgL_arg1743z00_3820;
BgL_arg1743z00_3820 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1108 */
long BgL_res3019z00_3848;
{ /* Llib/mpd.scm 1108 */
long BgL_n1z00_3830;long BgL_n2z00_3831;
BgL_n1z00_3830 = BgL_offsetz00_3816; 
BgL_n2z00_3831 = 
(long)(BgL_arg1743z00_3820); 
{ /* Llib/mpd.scm 1108 */
bool_t BgL_testz00_9184;
{ /* Llib/mpd.scm 1108 */
long BgL_arg1283z00_3833;
BgL_arg1283z00_3833 = 
(((BgL_n1z00_3830) | (BgL_n2z00_3831)) & -2147483648); 
BgL_testz00_9184 = 
(BgL_arg1283z00_3833==((long)0)); } 
if(BgL_testz00_9184)
{ /* Llib/mpd.scm 1108 */
int32_t BgL_arg1272z00_3834;
{ /* Llib/mpd.scm 1108 */
int32_t BgL_arg1278z00_3835;int32_t BgL_arg1279z00_3836;
{ /* Llib/mpd.scm 1108 */
int32_t BgL_res3015z00_3840;
BgL_res3015z00_3840 = 
(int32_t)(BgL_n1z00_3830); 
BgL_arg1278z00_3835 = BgL_res3015z00_3840; } 
{ /* Llib/mpd.scm 1108 */
int32_t BgL_res3016z00_3842;
BgL_res3016z00_3842 = 
(int32_t)(BgL_n2z00_3831); 
BgL_arg1279z00_3836 = BgL_res3016z00_3842; } 
BgL_arg1272z00_3834 = 
(BgL_arg1278z00_3835%BgL_arg1279z00_3836); } 
{ /* Llib/mpd.scm 1108 */
long BgL_res3018z00_3847;
{ /* Llib/mpd.scm 1108 */
long BgL_arg1409z00_3844;
BgL_arg1409z00_3844 = 
(long)(BgL_arg1272z00_3834); 
{ /* Llib/mpd.scm 1108 */
long BgL_res3017z00_3846;
BgL_res3017z00_3846 = 
(long)(BgL_arg1409z00_3844); 
BgL_res3018z00_3847 = BgL_res3017z00_3846; } } 
BgL_res3019z00_3848 = BgL_res3018z00_3847; } }  else 
{ /* Llib/mpd.scm 1108 */
BgL_res3019z00_3848 = 
(BgL_n1z00_3830%BgL_n2z00_3831); } } } 
BgL_restz00_3819 = BgL_res3019z00_3848; } } 
{ /* Llib/mpd.scm 1108 */

{ /* Llib/mpd.scm 1108 */
obj_t BgL_bucketz00_3821;
BgL_bucketz00_3821 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3811),BgL_modz00_3817); 
BgL_res3020z00_3853 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3821),BgL_restz00_3819); } } } } } } } } 
BgL_method1350z00_2384 = BgL_res3020z00_3853; } 
return 
PROCEDURE_ENTRY(BgL_method1350z00_2384)(BgL_method1350z00_2384, 
((obj_t)BgL_oz00_351), BgL_backendz00_352, BgL_opz00_353, BEOA);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-stats */
obj_t BGl_z62mpdzd2databasezd2statsz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5306, obj_t BgL_oz00_5307, obj_t BgL_backendz00_5308, obj_t BgL_opz00_5309)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1108 */
{ /* Llib/mpd.scm 1108 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_9204;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5307, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1108 */
BgL_auxz00_9204 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5307)
; }  else 
{ 
obj_t BgL_auxz00_9208;
BgL_auxz00_9208 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)44204)), BGl_string3498z00zz__multimediazd2mpdzd2, BGl_string3346z00zz__multimediazd2mpdzd2, BgL_oz00_5307); 
FAILURE(BgL_auxz00_9208,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2statsz00zz__multimediazd2mpdzd2(BgL_auxz00_9204, BgL_backendz00_5308, BgL_opz00_5309);} } 
BGL_FUNCTION_END;
}



/* mpd-database-listall */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listallz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_354, obj_t BgL_opz00_355)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1142 */
{ /* Llib/mpd.scm 1142 */
obj_t BgL_method1352z00_2385;
{ /* Llib/mpd.scm 1142 */
obj_t BgL_res3032z00_3898;
{ /* Llib/mpd.scm 1142 */
long BgL_objzd2classzd2numz00_3855;
{ /* Llib/mpd.scm 1142 */
long BgL_res3021z00_3858;
BgL_res3021z00_3858 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_354)); 
BgL_objzd2classzd2numz00_3855 = BgL_res3021z00_3858; } 
{ /* Llib/mpd.scm 1142 */
obj_t BgL_arg1742z00_3856;
BgL_arg1742z00_3856 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listallzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1142 */
int BgL_offsetz00_3860;
BgL_offsetz00_3860 = 
(int)(BgL_objzd2classzd2numz00_3855); 
{ /* Llib/mpd.scm 1142 */
long BgL_offsetz00_3861;
BgL_offsetz00_3861 = 
(
(long)(BgL_offsetz00_3860)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1142 */
long BgL_modz00_3862;
{ /* Llib/mpd.scm 1142 */
int BgL_arg1744z00_3863;
BgL_arg1744z00_3863 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1142 */
long BgL_res3024z00_3873;
{ /* Llib/mpd.scm 1142 */
long BgL_tmpz00_9221;
BgL_tmpz00_9221 = 
(long)(BgL_arg1744z00_3863); 
BgL_res3024z00_3873 = 
(BgL_offsetz00_3861/BgL_tmpz00_9221); } 
BgL_modz00_3862 = BgL_res3024z00_3873; } } 
{ /* Llib/mpd.scm 1142 */
long BgL_restz00_3864;
{ /* Llib/mpd.scm 1142 */
int BgL_arg1743z00_3865;
BgL_arg1743z00_3865 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1142 */
long BgL_res3031z00_3893;
{ /* Llib/mpd.scm 1142 */
long BgL_n1z00_3875;long BgL_n2z00_3876;
BgL_n1z00_3875 = BgL_offsetz00_3861; 
BgL_n2z00_3876 = 
(long)(BgL_arg1743z00_3865); 
{ /* Llib/mpd.scm 1142 */
bool_t BgL_testz00_9226;
{ /* Llib/mpd.scm 1142 */
long BgL_arg1283z00_3878;
BgL_arg1283z00_3878 = 
(((BgL_n1z00_3875) | (BgL_n2z00_3876)) & -2147483648); 
BgL_testz00_9226 = 
(BgL_arg1283z00_3878==((long)0)); } 
if(BgL_testz00_9226)
{ /* Llib/mpd.scm 1142 */
int32_t BgL_arg1272z00_3879;
{ /* Llib/mpd.scm 1142 */
int32_t BgL_arg1278z00_3880;int32_t BgL_arg1279z00_3881;
{ /* Llib/mpd.scm 1142 */
int32_t BgL_res3027z00_3885;
BgL_res3027z00_3885 = 
(int32_t)(BgL_n1z00_3875); 
BgL_arg1278z00_3880 = BgL_res3027z00_3885; } 
{ /* Llib/mpd.scm 1142 */
int32_t BgL_res3028z00_3887;
BgL_res3028z00_3887 = 
(int32_t)(BgL_n2z00_3876); 
BgL_arg1279z00_3881 = BgL_res3028z00_3887; } 
BgL_arg1272z00_3879 = 
(BgL_arg1278z00_3880%BgL_arg1279z00_3881); } 
{ /* Llib/mpd.scm 1142 */
long BgL_res3030z00_3892;
{ /* Llib/mpd.scm 1142 */
long BgL_arg1409z00_3889;
BgL_arg1409z00_3889 = 
(long)(BgL_arg1272z00_3879); 
{ /* Llib/mpd.scm 1142 */
long BgL_res3029z00_3891;
BgL_res3029z00_3891 = 
(long)(BgL_arg1409z00_3889); 
BgL_res3030z00_3892 = BgL_res3029z00_3891; } } 
BgL_res3031z00_3893 = BgL_res3030z00_3892; } }  else 
{ /* Llib/mpd.scm 1142 */
BgL_res3031z00_3893 = 
(BgL_n1z00_3875%BgL_n2z00_3876); } } } 
BgL_restz00_3864 = BgL_res3031z00_3893; } } 
{ /* Llib/mpd.scm 1142 */

{ /* Llib/mpd.scm 1142 */
obj_t BgL_bucketz00_3866;
BgL_bucketz00_3866 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3856),BgL_modz00_3862); 
BgL_res3032z00_3898 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3866),BgL_restz00_3864); } } } } } } } } 
BgL_method1352z00_2385 = BgL_res3032z00_3898; } 
return 
PROCEDURE_ENTRY(BgL_method1352z00_2385)(BgL_method1352z00_2385, 
((obj_t)BgL_oz00_354), BgL_opz00_355, BEOA);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-listall */
obj_t BGl_z62mpdzd2databasezd2listallz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5310, obj_t BgL_oz00_5311, obj_t BgL_opz00_5312)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1142 */
{ /* Llib/mpd.scm 1142 */
obj_t BgL_auxz00_9253;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9245;
if(
OUTPUT_PORTP(BgL_opz00_5312))
{ /* Llib/mpd.scm 1142 */
BgL_auxz00_9253 = BgL_opz00_5312
; }  else 
{ 
obj_t BgL_auxz00_9256;
BgL_auxz00_9256 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)45279)), BGl_string3499z00zz__multimediazd2mpdzd2, BGl_string3345z00zz__multimediazd2mpdzd2, BgL_opz00_5312); 
FAILURE(BgL_auxz00_9256,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5311, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1142 */
BgL_auxz00_9245 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5311)
; }  else 
{ 
obj_t BgL_auxz00_9249;
BgL_auxz00_9249 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)45279)), BGl_string3499z00zz__multimediazd2mpdzd2, BGl_string3346z00zz__multimediazd2mpdzd2, BgL_oz00_5311); 
FAILURE(BgL_auxz00_9249,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listallz00zz__multimediazd2mpdzd2(BgL_auxz00_9245, BgL_auxz00_9253);} } 
BGL_FUNCTION_END;
}



/* mpd-database-listalbum */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listalbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_356, obj_t BgL_opz00_357)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1168 */
{ /* Llib/mpd.scm 1168 */
obj_t BgL_method1354z00_2386;
{ /* Llib/mpd.scm 1168 */
obj_t BgL_res3044z00_3943;
{ /* Llib/mpd.scm 1168 */
long BgL_objzd2classzd2numz00_3900;
{ /* Llib/mpd.scm 1168 */
long BgL_res3033z00_3903;
BgL_res3033z00_3903 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_356)); 
BgL_objzd2classzd2numz00_3900 = BgL_res3033z00_3903; } 
{ /* Llib/mpd.scm 1168 */
obj_t BgL_arg1742z00_3901;
BgL_arg1742z00_3901 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listalbumzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1168 */
int BgL_offsetz00_3905;
BgL_offsetz00_3905 = 
(int)(BgL_objzd2classzd2numz00_3900); 
{ /* Llib/mpd.scm 1168 */
long BgL_offsetz00_3906;
BgL_offsetz00_3906 = 
(
(long)(BgL_offsetz00_3905)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1168 */
long BgL_modz00_3907;
{ /* Llib/mpd.scm 1168 */
int BgL_arg1744z00_3908;
BgL_arg1744z00_3908 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1168 */
long BgL_res3036z00_3918;
{ /* Llib/mpd.scm 1168 */
long BgL_tmpz00_9269;
BgL_tmpz00_9269 = 
(long)(BgL_arg1744z00_3908); 
BgL_res3036z00_3918 = 
(BgL_offsetz00_3906/BgL_tmpz00_9269); } 
BgL_modz00_3907 = BgL_res3036z00_3918; } } 
{ /* Llib/mpd.scm 1168 */
long BgL_restz00_3909;
{ /* Llib/mpd.scm 1168 */
int BgL_arg1743z00_3910;
BgL_arg1743z00_3910 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1168 */
long BgL_res3043z00_3938;
{ /* Llib/mpd.scm 1168 */
long BgL_n1z00_3920;long BgL_n2z00_3921;
BgL_n1z00_3920 = BgL_offsetz00_3906; 
BgL_n2z00_3921 = 
(long)(BgL_arg1743z00_3910); 
{ /* Llib/mpd.scm 1168 */
bool_t BgL_testz00_9274;
{ /* Llib/mpd.scm 1168 */
long BgL_arg1283z00_3923;
BgL_arg1283z00_3923 = 
(((BgL_n1z00_3920) | (BgL_n2z00_3921)) & -2147483648); 
BgL_testz00_9274 = 
(BgL_arg1283z00_3923==((long)0)); } 
if(BgL_testz00_9274)
{ /* Llib/mpd.scm 1168 */
int32_t BgL_arg1272z00_3924;
{ /* Llib/mpd.scm 1168 */
int32_t BgL_arg1278z00_3925;int32_t BgL_arg1279z00_3926;
{ /* Llib/mpd.scm 1168 */
int32_t BgL_res3039z00_3930;
BgL_res3039z00_3930 = 
(int32_t)(BgL_n1z00_3920); 
BgL_arg1278z00_3925 = BgL_res3039z00_3930; } 
{ /* Llib/mpd.scm 1168 */
int32_t BgL_res3040z00_3932;
BgL_res3040z00_3932 = 
(int32_t)(BgL_n2z00_3921); 
BgL_arg1279z00_3926 = BgL_res3040z00_3932; } 
BgL_arg1272z00_3924 = 
(BgL_arg1278z00_3925%BgL_arg1279z00_3926); } 
{ /* Llib/mpd.scm 1168 */
long BgL_res3042z00_3937;
{ /* Llib/mpd.scm 1168 */
long BgL_arg1409z00_3934;
BgL_arg1409z00_3934 = 
(long)(BgL_arg1272z00_3924); 
{ /* Llib/mpd.scm 1168 */
long BgL_res3041z00_3936;
BgL_res3041z00_3936 = 
(long)(BgL_arg1409z00_3934); 
BgL_res3042z00_3937 = BgL_res3041z00_3936; } } 
BgL_res3043z00_3938 = BgL_res3042z00_3937; } }  else 
{ /* Llib/mpd.scm 1168 */
BgL_res3043z00_3938 = 
(BgL_n1z00_3920%BgL_n2z00_3921); } } } 
BgL_restz00_3909 = BgL_res3043z00_3938; } } 
{ /* Llib/mpd.scm 1168 */

{ /* Llib/mpd.scm 1168 */
obj_t BgL_bucketz00_3911;
BgL_bucketz00_3911 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3901),BgL_modz00_3907); 
BgL_res3044z00_3943 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3911),BgL_restz00_3909); } } } } } } } } 
BgL_method1354z00_2386 = BgL_res3044z00_3943; } 
return 
PROCEDURE_ENTRY(BgL_method1354z00_2386)(BgL_method1354z00_2386, 
((obj_t)BgL_oz00_356), BgL_opz00_357, BEOA);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-listalbum */
obj_t BGl_z62mpdzd2databasezd2listalbumz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5313, obj_t BgL_oz00_5314, obj_t BgL_opz00_5315)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1168 */
{ /* Llib/mpd.scm 1168 */
obj_t BgL_auxz00_9301;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9293;
if(
OUTPUT_PORTP(BgL_opz00_5315))
{ /* Llib/mpd.scm 1168 */
BgL_auxz00_9301 = BgL_opz00_5315
; }  else 
{ 
obj_t BgL_auxz00_9304;
BgL_auxz00_9304 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)46110)), BGl_string3500z00zz__multimediazd2mpdzd2, BGl_string3345z00zz__multimediazd2mpdzd2, BgL_opz00_5315); 
FAILURE(BgL_auxz00_9304,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5314, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1168 */
BgL_auxz00_9293 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5314)
; }  else 
{ 
obj_t BgL_auxz00_9297;
BgL_auxz00_9297 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)46110)), BGl_string3500z00zz__multimediazd2mpdzd2, BGl_string3346z00zz__multimediazd2mpdzd2, BgL_oz00_5314); 
FAILURE(BgL_auxz00_9297,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listalbumz00zz__multimediazd2mpdzd2(BgL_auxz00_9293, BgL_auxz00_9301);} } 
BGL_FUNCTION_END;
}



/* mpd-database-listartistalbum */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listartistalbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_358, obj_t BgL_opz00_359, obj_t BgL_artistz00_360)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1179 */
{ /* Llib/mpd.scm 1179 */
obj_t BgL_method1356z00_2387;
{ /* Llib/mpd.scm 1179 */
obj_t BgL_res3056z00_3988;
{ /* Llib/mpd.scm 1179 */
long BgL_objzd2classzd2numz00_3945;
{ /* Llib/mpd.scm 1179 */
long BgL_res3045z00_3948;
BgL_res3045z00_3948 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_358)); 
BgL_objzd2classzd2numz00_3945 = BgL_res3045z00_3948; } 
{ /* Llib/mpd.scm 1179 */
obj_t BgL_arg1742z00_3946;
BgL_arg1742z00_3946 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listartistalbumzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1179 */
int BgL_offsetz00_3950;
BgL_offsetz00_3950 = 
(int)(BgL_objzd2classzd2numz00_3945); 
{ /* Llib/mpd.scm 1179 */
long BgL_offsetz00_3951;
BgL_offsetz00_3951 = 
(
(long)(BgL_offsetz00_3950)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1179 */
long BgL_modz00_3952;
{ /* Llib/mpd.scm 1179 */
int BgL_arg1744z00_3953;
BgL_arg1744z00_3953 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1179 */
long BgL_res3048z00_3963;
{ /* Llib/mpd.scm 1179 */
long BgL_tmpz00_9317;
BgL_tmpz00_9317 = 
(long)(BgL_arg1744z00_3953); 
BgL_res3048z00_3963 = 
(BgL_offsetz00_3951/BgL_tmpz00_9317); } 
BgL_modz00_3952 = BgL_res3048z00_3963; } } 
{ /* Llib/mpd.scm 1179 */
long BgL_restz00_3954;
{ /* Llib/mpd.scm 1179 */
int BgL_arg1743z00_3955;
BgL_arg1743z00_3955 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1179 */
long BgL_res3055z00_3983;
{ /* Llib/mpd.scm 1179 */
long BgL_n1z00_3965;long BgL_n2z00_3966;
BgL_n1z00_3965 = BgL_offsetz00_3951; 
BgL_n2z00_3966 = 
(long)(BgL_arg1743z00_3955); 
{ /* Llib/mpd.scm 1179 */
bool_t BgL_testz00_9322;
{ /* Llib/mpd.scm 1179 */
long BgL_arg1283z00_3968;
BgL_arg1283z00_3968 = 
(((BgL_n1z00_3965) | (BgL_n2z00_3966)) & -2147483648); 
BgL_testz00_9322 = 
(BgL_arg1283z00_3968==((long)0)); } 
if(BgL_testz00_9322)
{ /* Llib/mpd.scm 1179 */
int32_t BgL_arg1272z00_3969;
{ /* Llib/mpd.scm 1179 */
int32_t BgL_arg1278z00_3970;int32_t BgL_arg1279z00_3971;
{ /* Llib/mpd.scm 1179 */
int32_t BgL_res3051z00_3975;
BgL_res3051z00_3975 = 
(int32_t)(BgL_n1z00_3965); 
BgL_arg1278z00_3970 = BgL_res3051z00_3975; } 
{ /* Llib/mpd.scm 1179 */
int32_t BgL_res3052z00_3977;
BgL_res3052z00_3977 = 
(int32_t)(BgL_n2z00_3966); 
BgL_arg1279z00_3971 = BgL_res3052z00_3977; } 
BgL_arg1272z00_3969 = 
(BgL_arg1278z00_3970%BgL_arg1279z00_3971); } 
{ /* Llib/mpd.scm 1179 */
long BgL_res3054z00_3982;
{ /* Llib/mpd.scm 1179 */
long BgL_arg1409z00_3979;
BgL_arg1409z00_3979 = 
(long)(BgL_arg1272z00_3969); 
{ /* Llib/mpd.scm 1179 */
long BgL_res3053z00_3981;
BgL_res3053z00_3981 = 
(long)(BgL_arg1409z00_3979); 
BgL_res3054z00_3982 = BgL_res3053z00_3981; } } 
BgL_res3055z00_3983 = BgL_res3054z00_3982; } }  else 
{ /* Llib/mpd.scm 1179 */
BgL_res3055z00_3983 = 
(BgL_n1z00_3965%BgL_n2z00_3966); } } } 
BgL_restz00_3954 = BgL_res3055z00_3983; } } 
{ /* Llib/mpd.scm 1179 */

{ /* Llib/mpd.scm 1179 */
obj_t BgL_bucketz00_3956;
BgL_bucketz00_3956 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3946),BgL_modz00_3952); 
BgL_res3056z00_3988 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3956),BgL_restz00_3954); } } } } } } } } 
BgL_method1356z00_2387 = BgL_res3056z00_3988; } 
return 
PROCEDURE_ENTRY(BgL_method1356z00_2387)(BgL_method1356z00_2387, 
((obj_t)BgL_oz00_358), BgL_opz00_359, BgL_artistz00_360, BEOA);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-listartistalbum */
obj_t BGl_z62mpdzd2databasezd2listartistalbumz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5316, obj_t BgL_oz00_5317, obj_t BgL_opz00_5318, obj_t BgL_artistz00_5319)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1179 */
{ /* Llib/mpd.scm 1179 */
obj_t BgL_auxz00_9350;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9342;
if(
OUTPUT_PORTP(BgL_opz00_5318))
{ /* Llib/mpd.scm 1179 */
BgL_auxz00_9350 = BgL_opz00_5318
; }  else 
{ 
obj_t BgL_auxz00_9353;
BgL_auxz00_9353 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)46540)), BGl_string3501z00zz__multimediazd2mpdzd2, BGl_string3345z00zz__multimediazd2mpdzd2, BgL_opz00_5318); 
FAILURE(BgL_auxz00_9353,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5317, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1179 */
BgL_auxz00_9342 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5317)
; }  else 
{ 
obj_t BgL_auxz00_9346;
BgL_auxz00_9346 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)46540)), BGl_string3501z00zz__multimediazd2mpdzd2, BGl_string3346z00zz__multimediazd2mpdzd2, BgL_oz00_5317); 
FAILURE(BgL_auxz00_9346,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listartistalbumz00zz__multimediazd2mpdzd2(BgL_auxz00_9342, BgL_auxz00_9350, BgL_artistz00_5319);} } 
BGL_FUNCTION_END;
}



/* mpd-database-listgenrealbum */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listgenrealbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_361, obj_t BgL_opz00_362, obj_t BgL_genrez00_363)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1189 */
{ /* Llib/mpd.scm 1189 */
obj_t BgL_method1358z00_2388;
{ /* Llib/mpd.scm 1189 */
obj_t BgL_res3068z00_4033;
{ /* Llib/mpd.scm 1189 */
long BgL_objzd2classzd2numz00_3990;
{ /* Llib/mpd.scm 1189 */
long BgL_res3057z00_3993;
BgL_res3057z00_3993 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_361)); 
BgL_objzd2classzd2numz00_3990 = BgL_res3057z00_3993; } 
{ /* Llib/mpd.scm 1189 */
obj_t BgL_arg1742z00_3991;
BgL_arg1742z00_3991 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listgenrealbumzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1189 */
int BgL_offsetz00_3995;
BgL_offsetz00_3995 = 
(int)(BgL_objzd2classzd2numz00_3990); 
{ /* Llib/mpd.scm 1189 */
long BgL_offsetz00_3996;
BgL_offsetz00_3996 = 
(
(long)(BgL_offsetz00_3995)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1189 */
long BgL_modz00_3997;
{ /* Llib/mpd.scm 1189 */
int BgL_arg1744z00_3998;
BgL_arg1744z00_3998 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1189 */
long BgL_res3060z00_4008;
{ /* Llib/mpd.scm 1189 */
long BgL_tmpz00_9366;
BgL_tmpz00_9366 = 
(long)(BgL_arg1744z00_3998); 
BgL_res3060z00_4008 = 
(BgL_offsetz00_3996/BgL_tmpz00_9366); } 
BgL_modz00_3997 = BgL_res3060z00_4008; } } 
{ /* Llib/mpd.scm 1189 */
long BgL_restz00_3999;
{ /* Llib/mpd.scm 1189 */
int BgL_arg1743z00_4000;
BgL_arg1743z00_4000 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1189 */
long BgL_res3067z00_4028;
{ /* Llib/mpd.scm 1189 */
long BgL_n1z00_4010;long BgL_n2z00_4011;
BgL_n1z00_4010 = BgL_offsetz00_3996; 
BgL_n2z00_4011 = 
(long)(BgL_arg1743z00_4000); 
{ /* Llib/mpd.scm 1189 */
bool_t BgL_testz00_9371;
{ /* Llib/mpd.scm 1189 */
long BgL_arg1283z00_4013;
BgL_arg1283z00_4013 = 
(((BgL_n1z00_4010) | (BgL_n2z00_4011)) & -2147483648); 
BgL_testz00_9371 = 
(BgL_arg1283z00_4013==((long)0)); } 
if(BgL_testz00_9371)
{ /* Llib/mpd.scm 1189 */
int32_t BgL_arg1272z00_4014;
{ /* Llib/mpd.scm 1189 */
int32_t BgL_arg1278z00_4015;int32_t BgL_arg1279z00_4016;
{ /* Llib/mpd.scm 1189 */
int32_t BgL_res3063z00_4020;
BgL_res3063z00_4020 = 
(int32_t)(BgL_n1z00_4010); 
BgL_arg1278z00_4015 = BgL_res3063z00_4020; } 
{ /* Llib/mpd.scm 1189 */
int32_t BgL_res3064z00_4022;
BgL_res3064z00_4022 = 
(int32_t)(BgL_n2z00_4011); 
BgL_arg1279z00_4016 = BgL_res3064z00_4022; } 
BgL_arg1272z00_4014 = 
(BgL_arg1278z00_4015%BgL_arg1279z00_4016); } 
{ /* Llib/mpd.scm 1189 */
long BgL_res3066z00_4027;
{ /* Llib/mpd.scm 1189 */
long BgL_arg1409z00_4024;
BgL_arg1409z00_4024 = 
(long)(BgL_arg1272z00_4014); 
{ /* Llib/mpd.scm 1189 */
long BgL_res3065z00_4026;
BgL_res3065z00_4026 = 
(long)(BgL_arg1409z00_4024); 
BgL_res3066z00_4027 = BgL_res3065z00_4026; } } 
BgL_res3067z00_4028 = BgL_res3066z00_4027; } }  else 
{ /* Llib/mpd.scm 1189 */
BgL_res3067z00_4028 = 
(BgL_n1z00_4010%BgL_n2z00_4011); } } } 
BgL_restz00_3999 = BgL_res3067z00_4028; } } 
{ /* Llib/mpd.scm 1189 */

{ /* Llib/mpd.scm 1189 */
obj_t BgL_bucketz00_4001;
BgL_bucketz00_4001 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3991),BgL_modz00_3997); 
BgL_res3068z00_4033 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4001),BgL_restz00_3999); } } } } } } } } 
BgL_method1358z00_2388 = BgL_res3068z00_4033; } 
return 
PROCEDURE_ENTRY(BgL_method1358z00_2388)(BgL_method1358z00_2388, 
((obj_t)BgL_oz00_361), BgL_opz00_362, BgL_genrez00_363, BEOA);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-listgenrealbum */
obj_t BGl_z62mpdzd2databasezd2listgenrealbumz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5320, obj_t BgL_oz00_5321, obj_t BgL_opz00_5322, obj_t BgL_genrez00_5323)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1189 */
{ /* Llib/mpd.scm 1189 */
obj_t BgL_auxz00_9399;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9391;
if(
OUTPUT_PORTP(BgL_opz00_5322))
{ /* Llib/mpd.scm 1189 */
BgL_auxz00_9399 = BgL_opz00_5322
; }  else 
{ 
obj_t BgL_auxz00_9402;
BgL_auxz00_9402 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)46973)), BGl_string3502z00zz__multimediazd2mpdzd2, BGl_string3345z00zz__multimediazd2mpdzd2, BgL_opz00_5322); 
FAILURE(BgL_auxz00_9402,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5321, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1189 */
BgL_auxz00_9391 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5321)
; }  else 
{ 
obj_t BgL_auxz00_9395;
BgL_auxz00_9395 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)46973)), BGl_string3502z00zz__multimediazd2mpdzd2, BGl_string3346z00zz__multimediazd2mpdzd2, BgL_oz00_5321); 
FAILURE(BgL_auxz00_9395,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listgenrealbumz00zz__multimediazd2mpdzd2(BgL_auxz00_9391, BgL_auxz00_9399, BgL_genrez00_5323);} } 
BGL_FUNCTION_END;
}



/* mpd-database-listgenreartist */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listgenreartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_364, obj_t BgL_opz00_365, obj_t BgL_genrez00_366)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1203 */
{ /* Llib/mpd.scm 1203 */
obj_t BgL_method1360z00_2389;
{ /* Llib/mpd.scm 1203 */
obj_t BgL_res3080z00_4078;
{ /* Llib/mpd.scm 1203 */
long BgL_objzd2classzd2numz00_4035;
{ /* Llib/mpd.scm 1203 */
long BgL_res3069z00_4038;
BgL_res3069z00_4038 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_364)); 
BgL_objzd2classzd2numz00_4035 = BgL_res3069z00_4038; } 
{ /* Llib/mpd.scm 1203 */
obj_t BgL_arg1742z00_4036;
BgL_arg1742z00_4036 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listgenreartistzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1203 */
int BgL_offsetz00_4040;
BgL_offsetz00_4040 = 
(int)(BgL_objzd2classzd2numz00_4035); 
{ /* Llib/mpd.scm 1203 */
long BgL_offsetz00_4041;
BgL_offsetz00_4041 = 
(
(long)(BgL_offsetz00_4040)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1203 */
long BgL_modz00_4042;
{ /* Llib/mpd.scm 1203 */
int BgL_arg1744z00_4043;
BgL_arg1744z00_4043 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1203 */
long BgL_res3072z00_4053;
{ /* Llib/mpd.scm 1203 */
long BgL_tmpz00_9415;
BgL_tmpz00_9415 = 
(long)(BgL_arg1744z00_4043); 
BgL_res3072z00_4053 = 
(BgL_offsetz00_4041/BgL_tmpz00_9415); } 
BgL_modz00_4042 = BgL_res3072z00_4053; } } 
{ /* Llib/mpd.scm 1203 */
long BgL_restz00_4044;
{ /* Llib/mpd.scm 1203 */
int BgL_arg1743z00_4045;
BgL_arg1743z00_4045 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1203 */
long BgL_res3079z00_4073;
{ /* Llib/mpd.scm 1203 */
long BgL_n1z00_4055;long BgL_n2z00_4056;
BgL_n1z00_4055 = BgL_offsetz00_4041; 
BgL_n2z00_4056 = 
(long)(BgL_arg1743z00_4045); 
{ /* Llib/mpd.scm 1203 */
bool_t BgL_testz00_9420;
{ /* Llib/mpd.scm 1203 */
long BgL_arg1283z00_4058;
BgL_arg1283z00_4058 = 
(((BgL_n1z00_4055) | (BgL_n2z00_4056)) & -2147483648); 
BgL_testz00_9420 = 
(BgL_arg1283z00_4058==((long)0)); } 
if(BgL_testz00_9420)
{ /* Llib/mpd.scm 1203 */
int32_t BgL_arg1272z00_4059;
{ /* Llib/mpd.scm 1203 */
int32_t BgL_arg1278z00_4060;int32_t BgL_arg1279z00_4061;
{ /* Llib/mpd.scm 1203 */
int32_t BgL_res3075z00_4065;
BgL_res3075z00_4065 = 
(int32_t)(BgL_n1z00_4055); 
BgL_arg1278z00_4060 = BgL_res3075z00_4065; } 
{ /* Llib/mpd.scm 1203 */
int32_t BgL_res3076z00_4067;
BgL_res3076z00_4067 = 
(int32_t)(BgL_n2z00_4056); 
BgL_arg1279z00_4061 = BgL_res3076z00_4067; } 
BgL_arg1272z00_4059 = 
(BgL_arg1278z00_4060%BgL_arg1279z00_4061); } 
{ /* Llib/mpd.scm 1203 */
long BgL_res3078z00_4072;
{ /* Llib/mpd.scm 1203 */
long BgL_arg1409z00_4069;
BgL_arg1409z00_4069 = 
(long)(BgL_arg1272z00_4059); 
{ /* Llib/mpd.scm 1203 */
long BgL_res3077z00_4071;
BgL_res3077z00_4071 = 
(long)(BgL_arg1409z00_4069); 
BgL_res3078z00_4072 = BgL_res3077z00_4071; } } 
BgL_res3079z00_4073 = BgL_res3078z00_4072; } }  else 
{ /* Llib/mpd.scm 1203 */
BgL_res3079z00_4073 = 
(BgL_n1z00_4055%BgL_n2z00_4056); } } } 
BgL_restz00_4044 = BgL_res3079z00_4073; } } 
{ /* Llib/mpd.scm 1203 */

{ /* Llib/mpd.scm 1203 */
obj_t BgL_bucketz00_4046;
BgL_bucketz00_4046 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4036),BgL_modz00_4042); 
BgL_res3080z00_4078 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4046),BgL_restz00_4044); } } } } } } } } 
BgL_method1360z00_2389 = BgL_res3080z00_4078; } 
return 
PROCEDURE_ENTRY(BgL_method1360z00_2389)(BgL_method1360z00_2389, 
((obj_t)BgL_oz00_364), BgL_opz00_365, BgL_genrez00_366, BEOA);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-listgenreartist */
obj_t BGl_z62mpdzd2databasezd2listgenreartistz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5324, obj_t BgL_oz00_5325, obj_t BgL_opz00_5326, obj_t BgL_genrez00_5327)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1203 */
{ /* Llib/mpd.scm 1203 */
obj_t BgL_auxz00_9448;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9440;
if(
OUTPUT_PORTP(BgL_opz00_5326))
{ /* Llib/mpd.scm 1203 */
BgL_auxz00_9448 = BgL_opz00_5326
; }  else 
{ 
obj_t BgL_auxz00_9451;
BgL_auxz00_9451 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)47524)), BGl_string3503z00zz__multimediazd2mpdzd2, BGl_string3345z00zz__multimediazd2mpdzd2, BgL_opz00_5326); 
FAILURE(BgL_auxz00_9451,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5325, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1203 */
BgL_auxz00_9440 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5325)
; }  else 
{ 
obj_t BgL_auxz00_9444;
BgL_auxz00_9444 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)47524)), BGl_string3503z00zz__multimediazd2mpdzd2, BGl_string3346z00zz__multimediazd2mpdzd2, BgL_oz00_5325); 
FAILURE(BgL_auxz00_9444,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listgenreartistz00zz__multimediazd2mpdzd2(BgL_auxz00_9440, BgL_auxz00_9448, BgL_genrez00_5327);} } 
BGL_FUNCTION_END;
}



/* mpd-database-listgenre */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listgenrez00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_367, obj_t BgL_opz00_368)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1213 */
{ /* Llib/mpd.scm 1213 */
obj_t BgL_method1362z00_2390;
{ /* Llib/mpd.scm 1213 */
obj_t BgL_res3092z00_4123;
{ /* Llib/mpd.scm 1213 */
long BgL_objzd2classzd2numz00_4080;
{ /* Llib/mpd.scm 1213 */
long BgL_res3081z00_4083;
BgL_res3081z00_4083 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_367)); 
BgL_objzd2classzd2numz00_4080 = BgL_res3081z00_4083; } 
{ /* Llib/mpd.scm 1213 */
obj_t BgL_arg1742z00_4081;
BgL_arg1742z00_4081 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listgenrezd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1213 */
int BgL_offsetz00_4085;
BgL_offsetz00_4085 = 
(int)(BgL_objzd2classzd2numz00_4080); 
{ /* Llib/mpd.scm 1213 */
long BgL_offsetz00_4086;
BgL_offsetz00_4086 = 
(
(long)(BgL_offsetz00_4085)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1213 */
long BgL_modz00_4087;
{ /* Llib/mpd.scm 1213 */
int BgL_arg1744z00_4088;
BgL_arg1744z00_4088 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1213 */
long BgL_res3084z00_4098;
{ /* Llib/mpd.scm 1213 */
long BgL_tmpz00_9464;
BgL_tmpz00_9464 = 
(long)(BgL_arg1744z00_4088); 
BgL_res3084z00_4098 = 
(BgL_offsetz00_4086/BgL_tmpz00_9464); } 
BgL_modz00_4087 = BgL_res3084z00_4098; } } 
{ /* Llib/mpd.scm 1213 */
long BgL_restz00_4089;
{ /* Llib/mpd.scm 1213 */
int BgL_arg1743z00_4090;
BgL_arg1743z00_4090 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1213 */
long BgL_res3091z00_4118;
{ /* Llib/mpd.scm 1213 */
long BgL_n1z00_4100;long BgL_n2z00_4101;
BgL_n1z00_4100 = BgL_offsetz00_4086; 
BgL_n2z00_4101 = 
(long)(BgL_arg1743z00_4090); 
{ /* Llib/mpd.scm 1213 */
bool_t BgL_testz00_9469;
{ /* Llib/mpd.scm 1213 */
long BgL_arg1283z00_4103;
BgL_arg1283z00_4103 = 
(((BgL_n1z00_4100) | (BgL_n2z00_4101)) & -2147483648); 
BgL_testz00_9469 = 
(BgL_arg1283z00_4103==((long)0)); } 
if(BgL_testz00_9469)
{ /* Llib/mpd.scm 1213 */
int32_t BgL_arg1272z00_4104;
{ /* Llib/mpd.scm 1213 */
int32_t BgL_arg1278z00_4105;int32_t BgL_arg1279z00_4106;
{ /* Llib/mpd.scm 1213 */
int32_t BgL_res3087z00_4110;
BgL_res3087z00_4110 = 
(int32_t)(BgL_n1z00_4100); 
BgL_arg1278z00_4105 = BgL_res3087z00_4110; } 
{ /* Llib/mpd.scm 1213 */
int32_t BgL_res3088z00_4112;
BgL_res3088z00_4112 = 
(int32_t)(BgL_n2z00_4101); 
BgL_arg1279z00_4106 = BgL_res3088z00_4112; } 
BgL_arg1272z00_4104 = 
(BgL_arg1278z00_4105%BgL_arg1279z00_4106); } 
{ /* Llib/mpd.scm 1213 */
long BgL_res3090z00_4117;
{ /* Llib/mpd.scm 1213 */
long BgL_arg1409z00_4114;
BgL_arg1409z00_4114 = 
(long)(BgL_arg1272z00_4104); 
{ /* Llib/mpd.scm 1213 */
long BgL_res3089z00_4116;
BgL_res3089z00_4116 = 
(long)(BgL_arg1409z00_4114); 
BgL_res3090z00_4117 = BgL_res3089z00_4116; } } 
BgL_res3091z00_4118 = BgL_res3090z00_4117; } }  else 
{ /* Llib/mpd.scm 1213 */
BgL_res3091z00_4118 = 
(BgL_n1z00_4100%BgL_n2z00_4101); } } } 
BgL_restz00_4089 = BgL_res3091z00_4118; } } 
{ /* Llib/mpd.scm 1213 */

{ /* Llib/mpd.scm 1213 */
obj_t BgL_bucketz00_4091;
BgL_bucketz00_4091 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4081),BgL_modz00_4087); 
BgL_res3092z00_4123 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4091),BgL_restz00_4089); } } } } } } } } 
BgL_method1362z00_2390 = BgL_res3092z00_4123; } 
return 
PROCEDURE_ENTRY(BgL_method1362z00_2390)(BgL_method1362z00_2390, 
((obj_t)BgL_oz00_367), BgL_opz00_368, BEOA);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-listgenre */
obj_t BGl_z62mpdzd2databasezd2listgenrez62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5328, obj_t BgL_oz00_5329, obj_t BgL_opz00_5330)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1213 */
{ /* Llib/mpd.scm 1213 */
obj_t BgL_auxz00_9496;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9488;
if(
OUTPUT_PORTP(BgL_opz00_5330))
{ /* Llib/mpd.scm 1213 */
BgL_auxz00_9496 = BgL_opz00_5330
; }  else 
{ 
obj_t BgL_auxz00_9499;
BgL_auxz00_9499 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)47955)), BGl_string3504z00zz__multimediazd2mpdzd2, BGl_string3345z00zz__multimediazd2mpdzd2, BgL_opz00_5330); 
FAILURE(BgL_auxz00_9499,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5329, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1213 */
BgL_auxz00_9488 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5329)
; }  else 
{ 
obj_t BgL_auxz00_9492;
BgL_auxz00_9492 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)47955)), BGl_string3504z00zz__multimediazd2mpdzd2, BGl_string3346z00zz__multimediazd2mpdzd2, BgL_oz00_5329); 
FAILURE(BgL_auxz00_9492,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listgenrez00zz__multimediazd2mpdzd2(BgL_auxz00_9488, BgL_auxz00_9496);} } 
BGL_FUNCTION_END;
}



/* mpd-database-listartist */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_369, obj_t BgL_opz00_370)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1223 */
{ /* Llib/mpd.scm 1223 */
obj_t BgL_method1364z00_2391;
{ /* Llib/mpd.scm 1223 */
obj_t BgL_res3104z00_4168;
{ /* Llib/mpd.scm 1223 */
long BgL_objzd2classzd2numz00_4125;
{ /* Llib/mpd.scm 1223 */
long BgL_res3093z00_4128;
BgL_res3093z00_4128 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_369)); 
BgL_objzd2classzd2numz00_4125 = BgL_res3093z00_4128; } 
{ /* Llib/mpd.scm 1223 */
obj_t BgL_arg1742z00_4126;
BgL_arg1742z00_4126 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listartistzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1223 */
int BgL_offsetz00_4130;
BgL_offsetz00_4130 = 
(int)(BgL_objzd2classzd2numz00_4125); 
{ /* Llib/mpd.scm 1223 */
long BgL_offsetz00_4131;
BgL_offsetz00_4131 = 
(
(long)(BgL_offsetz00_4130)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1223 */
long BgL_modz00_4132;
{ /* Llib/mpd.scm 1223 */
int BgL_arg1744z00_4133;
BgL_arg1744z00_4133 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1223 */
long BgL_res3096z00_4143;
{ /* Llib/mpd.scm 1223 */
long BgL_tmpz00_9512;
BgL_tmpz00_9512 = 
(long)(BgL_arg1744z00_4133); 
BgL_res3096z00_4143 = 
(BgL_offsetz00_4131/BgL_tmpz00_9512); } 
BgL_modz00_4132 = BgL_res3096z00_4143; } } 
{ /* Llib/mpd.scm 1223 */
long BgL_restz00_4134;
{ /* Llib/mpd.scm 1223 */
int BgL_arg1743z00_4135;
BgL_arg1743z00_4135 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1223 */
long BgL_res3103z00_4163;
{ /* Llib/mpd.scm 1223 */
long BgL_n1z00_4145;long BgL_n2z00_4146;
BgL_n1z00_4145 = BgL_offsetz00_4131; 
BgL_n2z00_4146 = 
(long)(BgL_arg1743z00_4135); 
{ /* Llib/mpd.scm 1223 */
bool_t BgL_testz00_9517;
{ /* Llib/mpd.scm 1223 */
long BgL_arg1283z00_4148;
BgL_arg1283z00_4148 = 
(((BgL_n1z00_4145) | (BgL_n2z00_4146)) & -2147483648); 
BgL_testz00_9517 = 
(BgL_arg1283z00_4148==((long)0)); } 
if(BgL_testz00_9517)
{ /* Llib/mpd.scm 1223 */
int32_t BgL_arg1272z00_4149;
{ /* Llib/mpd.scm 1223 */
int32_t BgL_arg1278z00_4150;int32_t BgL_arg1279z00_4151;
{ /* Llib/mpd.scm 1223 */
int32_t BgL_res3099z00_4155;
BgL_res3099z00_4155 = 
(int32_t)(BgL_n1z00_4145); 
BgL_arg1278z00_4150 = BgL_res3099z00_4155; } 
{ /* Llib/mpd.scm 1223 */
int32_t BgL_res3100z00_4157;
BgL_res3100z00_4157 = 
(int32_t)(BgL_n2z00_4146); 
BgL_arg1279z00_4151 = BgL_res3100z00_4157; } 
BgL_arg1272z00_4149 = 
(BgL_arg1278z00_4150%BgL_arg1279z00_4151); } 
{ /* Llib/mpd.scm 1223 */
long BgL_res3102z00_4162;
{ /* Llib/mpd.scm 1223 */
long BgL_arg1409z00_4159;
BgL_arg1409z00_4159 = 
(long)(BgL_arg1272z00_4149); 
{ /* Llib/mpd.scm 1223 */
long BgL_res3101z00_4161;
BgL_res3101z00_4161 = 
(long)(BgL_arg1409z00_4159); 
BgL_res3102z00_4162 = BgL_res3101z00_4161; } } 
BgL_res3103z00_4163 = BgL_res3102z00_4162; } }  else 
{ /* Llib/mpd.scm 1223 */
BgL_res3103z00_4163 = 
(BgL_n1z00_4145%BgL_n2z00_4146); } } } 
BgL_restz00_4134 = BgL_res3103z00_4163; } } 
{ /* Llib/mpd.scm 1223 */

{ /* Llib/mpd.scm 1223 */
obj_t BgL_bucketz00_4136;
BgL_bucketz00_4136 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4126),BgL_modz00_4132); 
BgL_res3104z00_4168 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4136),BgL_restz00_4134); } } } } } } } } 
BgL_method1364z00_2391 = BgL_res3104z00_4168; } 
return 
PROCEDURE_ENTRY(BgL_method1364z00_2391)(BgL_method1364z00_2391, 
((obj_t)BgL_oz00_369), BgL_opz00_370, BEOA);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-listartist */
obj_t BGl_z62mpdzd2databasezd2listartistz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5331, obj_t BgL_oz00_5332, obj_t BgL_opz00_5333)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1223 */
{ /* Llib/mpd.scm 1223 */
obj_t BgL_auxz00_9544;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9536;
if(
OUTPUT_PORTP(BgL_opz00_5333))
{ /* Llib/mpd.scm 1223 */
BgL_auxz00_9544 = BgL_opz00_5333
; }  else 
{ 
obj_t BgL_auxz00_9547;
BgL_auxz00_9547 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)48361)), BGl_string3505z00zz__multimediazd2mpdzd2, BGl_string3345z00zz__multimediazd2mpdzd2, BgL_opz00_5333); 
FAILURE(BgL_auxz00_9547,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5332, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1223 */
BgL_auxz00_9536 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5332)
; }  else 
{ 
obj_t BgL_auxz00_9540;
BgL_auxz00_9540 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)48361)), BGl_string3505z00zz__multimediazd2mpdzd2, BGl_string3346z00zz__multimediazd2mpdzd2, BgL_oz00_5332); 
FAILURE(BgL_auxz00_9540,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listartistz00zz__multimediazd2mpdzd2(BgL_auxz00_9536, BgL_auxz00_9544);} } 
BGL_FUNCTION_END;
}



/* mpd-database-lsinfo */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_371, obj_t BgL_opz00_372, obj_t BgL_dirz00_373, bool_t BgL_recz00_374)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1233 */
{ /* Llib/mpd.scm 1233 */
obj_t BgL_method1366z00_2392;
{ /* Llib/mpd.scm 1233 */
obj_t BgL_res3116z00_4213;
{ /* Llib/mpd.scm 1233 */
long BgL_objzd2classzd2numz00_4170;
{ /* Llib/mpd.scm 1233 */
long BgL_res3105z00_4173;
BgL_res3105z00_4173 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_371)); 
BgL_objzd2classzd2numz00_4170 = BgL_res3105z00_4173; } 
{ /* Llib/mpd.scm 1233 */
obj_t BgL_arg1742z00_4171;
BgL_arg1742z00_4171 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2lsinfozd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1233 */
int BgL_offsetz00_4175;
BgL_offsetz00_4175 = 
(int)(BgL_objzd2classzd2numz00_4170); 
{ /* Llib/mpd.scm 1233 */
long BgL_offsetz00_4176;
BgL_offsetz00_4176 = 
(
(long)(BgL_offsetz00_4175)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1233 */
long BgL_modz00_4177;
{ /* Llib/mpd.scm 1233 */
int BgL_arg1744z00_4178;
BgL_arg1744z00_4178 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1233 */
long BgL_res3108z00_4188;
{ /* Llib/mpd.scm 1233 */
long BgL_tmpz00_9560;
BgL_tmpz00_9560 = 
(long)(BgL_arg1744z00_4178); 
BgL_res3108z00_4188 = 
(BgL_offsetz00_4176/BgL_tmpz00_9560); } 
BgL_modz00_4177 = BgL_res3108z00_4188; } } 
{ /* Llib/mpd.scm 1233 */
long BgL_restz00_4179;
{ /* Llib/mpd.scm 1233 */
int BgL_arg1743z00_4180;
BgL_arg1743z00_4180 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1233 */
long BgL_res3115z00_4208;
{ /* Llib/mpd.scm 1233 */
long BgL_n1z00_4190;long BgL_n2z00_4191;
BgL_n1z00_4190 = BgL_offsetz00_4176; 
BgL_n2z00_4191 = 
(long)(BgL_arg1743z00_4180); 
{ /* Llib/mpd.scm 1233 */
bool_t BgL_testz00_9565;
{ /* Llib/mpd.scm 1233 */
long BgL_arg1283z00_4193;
BgL_arg1283z00_4193 = 
(((BgL_n1z00_4190) | (BgL_n2z00_4191)) & -2147483648); 
BgL_testz00_9565 = 
(BgL_arg1283z00_4193==((long)0)); } 
if(BgL_testz00_9565)
{ /* Llib/mpd.scm 1233 */
int32_t BgL_arg1272z00_4194;
{ /* Llib/mpd.scm 1233 */
int32_t BgL_arg1278z00_4195;int32_t BgL_arg1279z00_4196;
{ /* Llib/mpd.scm 1233 */
int32_t BgL_res3111z00_4200;
BgL_res3111z00_4200 = 
(int32_t)(BgL_n1z00_4190); 
BgL_arg1278z00_4195 = BgL_res3111z00_4200; } 
{ /* Llib/mpd.scm 1233 */
int32_t BgL_res3112z00_4202;
BgL_res3112z00_4202 = 
(int32_t)(BgL_n2z00_4191); 
BgL_arg1279z00_4196 = BgL_res3112z00_4202; } 
BgL_arg1272z00_4194 = 
(BgL_arg1278z00_4195%BgL_arg1279z00_4196); } 
{ /* Llib/mpd.scm 1233 */
long BgL_res3114z00_4207;
{ /* Llib/mpd.scm 1233 */
long BgL_arg1409z00_4204;
BgL_arg1409z00_4204 = 
(long)(BgL_arg1272z00_4194); 
{ /* Llib/mpd.scm 1233 */
long BgL_res3113z00_4206;
BgL_res3113z00_4206 = 
(long)(BgL_arg1409z00_4204); 
BgL_res3114z00_4207 = BgL_res3113z00_4206; } } 
BgL_res3115z00_4208 = BgL_res3114z00_4207; } }  else 
{ /* Llib/mpd.scm 1233 */
BgL_res3115z00_4208 = 
(BgL_n1z00_4190%BgL_n2z00_4191); } } } 
BgL_restz00_4179 = BgL_res3115z00_4208; } } 
{ /* Llib/mpd.scm 1233 */

{ /* Llib/mpd.scm 1233 */
obj_t BgL_bucketz00_4181;
BgL_bucketz00_4181 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4171),BgL_modz00_4177); 
BgL_res3116z00_4213 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4181),BgL_restz00_4179); } } } } } } } } 
BgL_method1366z00_2392 = BgL_res3116z00_4213; } 
return 
PROCEDURE_ENTRY(BgL_method1366z00_2392)(BgL_method1366z00_2392, 
((obj_t)BgL_oz00_371), BgL_opz00_372, BgL_dirz00_373, 
BBOOL(BgL_recz00_374), BEOA);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-lsinfo */
obj_t BGl_z62mpdzd2databasezd2lsinfoz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5334, obj_t BgL_oz00_5335, obj_t BgL_opz00_5336, obj_t BgL_dirz00_5337, obj_t BgL_recz00_5338)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1233 */
{ /* Llib/mpd.scm 1233 */
obj_t BgL_auxz00_9602;obj_t BgL_auxz00_9595;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9587;
if(
STRINGP(BgL_dirz00_5337))
{ /* Llib/mpd.scm 1233 */
BgL_auxz00_9602 = BgL_dirz00_5337
; }  else 
{ 
obj_t BgL_auxz00_9605;
BgL_auxz00_9605 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)48770)), BGl_string3506z00zz__multimediazd2mpdzd2, BGl_string3497z00zz__multimediazd2mpdzd2, BgL_dirz00_5337); 
FAILURE(BgL_auxz00_9605,BFALSE,BFALSE);} 
if(
OUTPUT_PORTP(BgL_opz00_5336))
{ /* Llib/mpd.scm 1233 */
BgL_auxz00_9595 = BgL_opz00_5336
; }  else 
{ 
obj_t BgL_auxz00_9598;
BgL_auxz00_9598 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)48770)), BGl_string3506z00zz__multimediazd2mpdzd2, BGl_string3345z00zz__multimediazd2mpdzd2, BgL_opz00_5336); 
FAILURE(BgL_auxz00_9598,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5335, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1233 */
BgL_auxz00_9587 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5335)
; }  else 
{ 
obj_t BgL_auxz00_9591;
BgL_auxz00_9591 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)48770)), BGl_string3506z00zz__multimediazd2mpdzd2, BGl_string3346z00zz__multimediazd2mpdzd2, BgL_oz00_5335); 
FAILURE(BgL_auxz00_9591,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(BgL_auxz00_9587, BgL_auxz00_9595, BgL_auxz00_9602, 
CBOOL(BgL_recz00_5338));} } 
BGL_FUNCTION_END;
}



/* mpd-database-find-album */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2findzd2albumzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_380, obj_t BgL_opz00_381, obj_t BgL_albumz00_382)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1294 */
{ /* Llib/mpd.scm 1294 */
obj_t BgL_method1368z00_2393;
{ /* Llib/mpd.scm 1294 */
obj_t BgL_res3128z00_4258;
{ /* Llib/mpd.scm 1294 */
long BgL_objzd2classzd2numz00_4215;
{ /* Llib/mpd.scm 1294 */
long BgL_res3117z00_4218;
BgL_res3117z00_4218 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_380)); 
BgL_objzd2classzd2numz00_4215 = BgL_res3117z00_4218; } 
{ /* Llib/mpd.scm 1294 */
obj_t BgL_arg1742z00_4216;
BgL_arg1742z00_4216 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2findzd2albumzd2envz00zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1294 */
int BgL_offsetz00_4220;
BgL_offsetz00_4220 = 
(int)(BgL_objzd2classzd2numz00_4215); 
{ /* Llib/mpd.scm 1294 */
long BgL_offsetz00_4221;
BgL_offsetz00_4221 = 
(
(long)(BgL_offsetz00_4220)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1294 */
long BgL_modz00_4222;
{ /* Llib/mpd.scm 1294 */
int BgL_arg1744z00_4223;
BgL_arg1744z00_4223 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1294 */
long BgL_res3120z00_4233;
{ /* Llib/mpd.scm 1294 */
long BgL_tmpz00_9619;
BgL_tmpz00_9619 = 
(long)(BgL_arg1744z00_4223); 
BgL_res3120z00_4233 = 
(BgL_offsetz00_4221/BgL_tmpz00_9619); } 
BgL_modz00_4222 = BgL_res3120z00_4233; } } 
{ /* Llib/mpd.scm 1294 */
long BgL_restz00_4224;
{ /* Llib/mpd.scm 1294 */
int BgL_arg1743z00_4225;
BgL_arg1743z00_4225 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1294 */
long BgL_res3127z00_4253;
{ /* Llib/mpd.scm 1294 */
long BgL_n1z00_4235;long BgL_n2z00_4236;
BgL_n1z00_4235 = BgL_offsetz00_4221; 
BgL_n2z00_4236 = 
(long)(BgL_arg1743z00_4225); 
{ /* Llib/mpd.scm 1294 */
bool_t BgL_testz00_9624;
{ /* Llib/mpd.scm 1294 */
long BgL_arg1283z00_4238;
BgL_arg1283z00_4238 = 
(((BgL_n1z00_4235) | (BgL_n2z00_4236)) & -2147483648); 
BgL_testz00_9624 = 
(BgL_arg1283z00_4238==((long)0)); } 
if(BgL_testz00_9624)
{ /* Llib/mpd.scm 1294 */
int32_t BgL_arg1272z00_4239;
{ /* Llib/mpd.scm 1294 */
int32_t BgL_arg1278z00_4240;int32_t BgL_arg1279z00_4241;
{ /* Llib/mpd.scm 1294 */
int32_t BgL_res3123z00_4245;
BgL_res3123z00_4245 = 
(int32_t)(BgL_n1z00_4235); 
BgL_arg1278z00_4240 = BgL_res3123z00_4245; } 
{ /* Llib/mpd.scm 1294 */
int32_t BgL_res3124z00_4247;
BgL_res3124z00_4247 = 
(int32_t)(BgL_n2z00_4236); 
BgL_arg1279z00_4241 = BgL_res3124z00_4247; } 
BgL_arg1272z00_4239 = 
(BgL_arg1278z00_4240%BgL_arg1279z00_4241); } 
{ /* Llib/mpd.scm 1294 */
long BgL_res3126z00_4252;
{ /* Llib/mpd.scm 1294 */
long BgL_arg1409z00_4249;
BgL_arg1409z00_4249 = 
(long)(BgL_arg1272z00_4239); 
{ /* Llib/mpd.scm 1294 */
long BgL_res3125z00_4251;
BgL_res3125z00_4251 = 
(long)(BgL_arg1409z00_4249); 
BgL_res3126z00_4252 = BgL_res3125z00_4251; } } 
BgL_res3127z00_4253 = BgL_res3126z00_4252; } }  else 
{ /* Llib/mpd.scm 1294 */
BgL_res3127z00_4253 = 
(BgL_n1z00_4235%BgL_n2z00_4236); } } } 
BgL_restz00_4224 = BgL_res3127z00_4253; } } 
{ /* Llib/mpd.scm 1294 */

{ /* Llib/mpd.scm 1294 */
obj_t BgL_bucketz00_4226;
BgL_bucketz00_4226 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4216),BgL_modz00_4222); 
BgL_res3128z00_4258 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4226),BgL_restz00_4224); } } } } } } } } 
BgL_method1368z00_2393 = BgL_res3128z00_4258; } 
return 
PROCEDURE_ENTRY(BgL_method1368z00_2393)(BgL_method1368z00_2393, 
((obj_t)BgL_oz00_380), BgL_opz00_381, BgL_albumz00_382, BEOA);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-find-album */
obj_t BGl_z62mpdzd2databasezd2findzd2albumzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5339, obj_t BgL_oz00_5340, obj_t BgL_opz00_5341, obj_t BgL_albumz00_5342)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1294 */
{ /* Llib/mpd.scm 1294 */
obj_t BgL_auxz00_9652;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9644;
if(
OUTPUT_PORTP(BgL_opz00_5341))
{ /* Llib/mpd.scm 1294 */
BgL_auxz00_9652 = BgL_opz00_5341
; }  else 
{ 
obj_t BgL_auxz00_9655;
BgL_auxz00_9655 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)50979)), BGl_string3507z00zz__multimediazd2mpdzd2, BGl_string3345z00zz__multimediazd2mpdzd2, BgL_opz00_5341); 
FAILURE(BgL_auxz00_9655,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5340, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1294 */
BgL_auxz00_9644 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5340)
; }  else 
{ 
obj_t BgL_auxz00_9648;
BgL_auxz00_9648 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)50979)), BGl_string3507z00zz__multimediazd2mpdzd2, BGl_string3346z00zz__multimediazd2mpdzd2, BgL_oz00_5340); 
FAILURE(BgL_auxz00_9648,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2findzd2albumzd2zz__multimediazd2mpdzd2(BgL_auxz00_9644, BgL_auxz00_9652, BgL_albumz00_5342);} } 
BGL_FUNCTION_END;
}



/* mpd-database-find-artist */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2findzd2artistzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_383, obj_t BgL_opz00_384, obj_t BgL_artistz00_385)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1303 */
{ /* Llib/mpd.scm 1303 */
obj_t BgL_method1370z00_2394;
{ /* Llib/mpd.scm 1303 */
obj_t BgL_res3140z00_4303;
{ /* Llib/mpd.scm 1303 */
long BgL_objzd2classzd2numz00_4260;
{ /* Llib/mpd.scm 1303 */
long BgL_res3129z00_4263;
BgL_res3129z00_4263 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_383)); 
BgL_objzd2classzd2numz00_4260 = BgL_res3129z00_4263; } 
{ /* Llib/mpd.scm 1303 */
obj_t BgL_arg1742z00_4261;
BgL_arg1742z00_4261 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2findzd2artistzd2envz00zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1303 */
int BgL_offsetz00_4265;
BgL_offsetz00_4265 = 
(int)(BgL_objzd2classzd2numz00_4260); 
{ /* Llib/mpd.scm 1303 */
long BgL_offsetz00_4266;
BgL_offsetz00_4266 = 
(
(long)(BgL_offsetz00_4265)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1303 */
long BgL_modz00_4267;
{ /* Llib/mpd.scm 1303 */
int BgL_arg1744z00_4268;
BgL_arg1744z00_4268 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1303 */
long BgL_res3132z00_4278;
{ /* Llib/mpd.scm 1303 */
long BgL_tmpz00_9668;
BgL_tmpz00_9668 = 
(long)(BgL_arg1744z00_4268); 
BgL_res3132z00_4278 = 
(BgL_offsetz00_4266/BgL_tmpz00_9668); } 
BgL_modz00_4267 = BgL_res3132z00_4278; } } 
{ /* Llib/mpd.scm 1303 */
long BgL_restz00_4269;
{ /* Llib/mpd.scm 1303 */
int BgL_arg1743z00_4270;
BgL_arg1743z00_4270 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1303 */
long BgL_res3139z00_4298;
{ /* Llib/mpd.scm 1303 */
long BgL_n1z00_4280;long BgL_n2z00_4281;
BgL_n1z00_4280 = BgL_offsetz00_4266; 
BgL_n2z00_4281 = 
(long)(BgL_arg1743z00_4270); 
{ /* Llib/mpd.scm 1303 */
bool_t BgL_testz00_9673;
{ /* Llib/mpd.scm 1303 */
long BgL_arg1283z00_4283;
BgL_arg1283z00_4283 = 
(((BgL_n1z00_4280) | (BgL_n2z00_4281)) & -2147483648); 
BgL_testz00_9673 = 
(BgL_arg1283z00_4283==((long)0)); } 
if(BgL_testz00_9673)
{ /* Llib/mpd.scm 1303 */
int32_t BgL_arg1272z00_4284;
{ /* Llib/mpd.scm 1303 */
int32_t BgL_arg1278z00_4285;int32_t BgL_arg1279z00_4286;
{ /* Llib/mpd.scm 1303 */
int32_t BgL_res3135z00_4290;
BgL_res3135z00_4290 = 
(int32_t)(BgL_n1z00_4280); 
BgL_arg1278z00_4285 = BgL_res3135z00_4290; } 
{ /* Llib/mpd.scm 1303 */
int32_t BgL_res3136z00_4292;
BgL_res3136z00_4292 = 
(int32_t)(BgL_n2z00_4281); 
BgL_arg1279z00_4286 = BgL_res3136z00_4292; } 
BgL_arg1272z00_4284 = 
(BgL_arg1278z00_4285%BgL_arg1279z00_4286); } 
{ /* Llib/mpd.scm 1303 */
long BgL_res3138z00_4297;
{ /* Llib/mpd.scm 1303 */
long BgL_arg1409z00_4294;
BgL_arg1409z00_4294 = 
(long)(BgL_arg1272z00_4284); 
{ /* Llib/mpd.scm 1303 */
long BgL_res3137z00_4296;
BgL_res3137z00_4296 = 
(long)(BgL_arg1409z00_4294); 
BgL_res3138z00_4297 = BgL_res3137z00_4296; } } 
BgL_res3139z00_4298 = BgL_res3138z00_4297; } }  else 
{ /* Llib/mpd.scm 1303 */
BgL_res3139z00_4298 = 
(BgL_n1z00_4280%BgL_n2z00_4281); } } } 
BgL_restz00_4269 = BgL_res3139z00_4298; } } 
{ /* Llib/mpd.scm 1303 */

{ /* Llib/mpd.scm 1303 */
obj_t BgL_bucketz00_4271;
BgL_bucketz00_4271 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4261),BgL_modz00_4267); 
BgL_res3140z00_4303 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4271),BgL_restz00_4269); } } } } } } } } 
BgL_method1370z00_2394 = BgL_res3140z00_4303; } 
return 
PROCEDURE_ENTRY(BgL_method1370z00_2394)(BgL_method1370z00_2394, 
((obj_t)BgL_oz00_383), BgL_opz00_384, BgL_artistz00_385, BEOA);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-find-artist */
obj_t BGl_z62mpdzd2databasezd2findzd2artistzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5343, obj_t BgL_oz00_5344, obj_t BgL_opz00_5345, obj_t BgL_artistz00_5346)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1303 */
{ /* Llib/mpd.scm 1303 */
obj_t BgL_auxz00_9701;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9693;
if(
OUTPUT_PORTP(BgL_opz00_5345))
{ /* Llib/mpd.scm 1303 */
BgL_auxz00_9701 = BgL_opz00_5345
; }  else 
{ 
obj_t BgL_auxz00_9704;
BgL_auxz00_9704 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)51417)), BGl_string3508z00zz__multimediazd2mpdzd2, BGl_string3345z00zz__multimediazd2mpdzd2, BgL_opz00_5345); 
FAILURE(BgL_auxz00_9704,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5344, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1303 */
BgL_auxz00_9693 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5344)
; }  else 
{ 
obj_t BgL_auxz00_9697;
BgL_auxz00_9697 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)51417)), BGl_string3508z00zz__multimediazd2mpdzd2, BGl_string3346z00zz__multimediazd2mpdzd2, BgL_oz00_5344); 
FAILURE(BgL_auxz00_9697,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2findzd2artistzd2zz__multimediazd2mpdzd2(BgL_auxz00_9693, BgL_auxz00_9701, BgL_artistz00_5346);} } 
BGL_FUNCTION_END;
}



/* mpd-database-search-artist-album */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2searchzd2artistzd2albumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_386, obj_t BgL_opz00_387, obj_t BgL_artistz00_388, obj_t BgL_albumz00_389)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1312 */
{ /* Llib/mpd.scm 1312 */
obj_t BgL_method1372z00_2395;
{ /* Llib/mpd.scm 1312 */
obj_t BgL_res3152z00_4348;
{ /* Llib/mpd.scm 1312 */
long BgL_objzd2classzd2numz00_4305;
{ /* Llib/mpd.scm 1312 */
long BgL_res3141z00_4308;
BgL_res3141z00_4308 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_386)); 
BgL_objzd2classzd2numz00_4305 = BgL_res3141z00_4308; } 
{ /* Llib/mpd.scm 1312 */
obj_t BgL_arg1742z00_4306;
BgL_arg1742z00_4306 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2searchzd2artistzd2albumzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1312 */
int BgL_offsetz00_4310;
BgL_offsetz00_4310 = 
(int)(BgL_objzd2classzd2numz00_4305); 
{ /* Llib/mpd.scm 1312 */
long BgL_offsetz00_4311;
BgL_offsetz00_4311 = 
(
(long)(BgL_offsetz00_4310)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1312 */
long BgL_modz00_4312;
{ /* Llib/mpd.scm 1312 */
int BgL_arg1744z00_4313;
BgL_arg1744z00_4313 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1312 */
long BgL_res3144z00_4323;
{ /* Llib/mpd.scm 1312 */
long BgL_tmpz00_9717;
BgL_tmpz00_9717 = 
(long)(BgL_arg1744z00_4313); 
BgL_res3144z00_4323 = 
(BgL_offsetz00_4311/BgL_tmpz00_9717); } 
BgL_modz00_4312 = BgL_res3144z00_4323; } } 
{ /* Llib/mpd.scm 1312 */
long BgL_restz00_4314;
{ /* Llib/mpd.scm 1312 */
int BgL_arg1743z00_4315;
BgL_arg1743z00_4315 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1312 */
long BgL_res3151z00_4343;
{ /* Llib/mpd.scm 1312 */
long BgL_n1z00_4325;long BgL_n2z00_4326;
BgL_n1z00_4325 = BgL_offsetz00_4311; 
BgL_n2z00_4326 = 
(long)(BgL_arg1743z00_4315); 
{ /* Llib/mpd.scm 1312 */
bool_t BgL_testz00_9722;
{ /* Llib/mpd.scm 1312 */
long BgL_arg1283z00_4328;
BgL_arg1283z00_4328 = 
(((BgL_n1z00_4325) | (BgL_n2z00_4326)) & -2147483648); 
BgL_testz00_9722 = 
(BgL_arg1283z00_4328==((long)0)); } 
if(BgL_testz00_9722)
{ /* Llib/mpd.scm 1312 */
int32_t BgL_arg1272z00_4329;
{ /* Llib/mpd.scm 1312 */
int32_t BgL_arg1278z00_4330;int32_t BgL_arg1279z00_4331;
{ /* Llib/mpd.scm 1312 */
int32_t BgL_res3147z00_4335;
BgL_res3147z00_4335 = 
(int32_t)(BgL_n1z00_4325); 
BgL_arg1278z00_4330 = BgL_res3147z00_4335; } 
{ /* Llib/mpd.scm 1312 */
int32_t BgL_res3148z00_4337;
BgL_res3148z00_4337 = 
(int32_t)(BgL_n2z00_4326); 
BgL_arg1279z00_4331 = BgL_res3148z00_4337; } 
BgL_arg1272z00_4329 = 
(BgL_arg1278z00_4330%BgL_arg1279z00_4331); } 
{ /* Llib/mpd.scm 1312 */
long BgL_res3150z00_4342;
{ /* Llib/mpd.scm 1312 */
long BgL_arg1409z00_4339;
BgL_arg1409z00_4339 = 
(long)(BgL_arg1272z00_4329); 
{ /* Llib/mpd.scm 1312 */
long BgL_res3149z00_4341;
BgL_res3149z00_4341 = 
(long)(BgL_arg1409z00_4339); 
BgL_res3150z00_4342 = BgL_res3149z00_4341; } } 
BgL_res3151z00_4343 = BgL_res3150z00_4342; } }  else 
{ /* Llib/mpd.scm 1312 */
BgL_res3151z00_4343 = 
(BgL_n1z00_4325%BgL_n2z00_4326); } } } 
BgL_restz00_4314 = BgL_res3151z00_4343; } } 
{ /* Llib/mpd.scm 1312 */

{ /* Llib/mpd.scm 1312 */
obj_t BgL_bucketz00_4316;
BgL_bucketz00_4316 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4306),BgL_modz00_4312); 
BgL_res3152z00_4348 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4316),BgL_restz00_4314); } } } } } } } } 
BgL_method1372z00_2395 = BgL_res3152z00_4348; } 
return 
PROCEDURE_ENTRY(BgL_method1372z00_2395)(BgL_method1372z00_2395, 
((obj_t)BgL_oz00_386), BgL_opz00_387, BgL_artistz00_388, BgL_albumz00_389, BEOA);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-search-artist-album */
obj_t BGl_z62mpdzd2databasezd2searchzd2artistzd2albumz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5347, obj_t BgL_oz00_5348, obj_t BgL_opz00_5349, obj_t BgL_artistz00_5350, obj_t BgL_albumz00_5351)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1312 */
{ /* Llib/mpd.scm 1312 */
obj_t BgL_auxz00_9751;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9743;
if(
OUTPUT_PORTP(BgL_opz00_5349))
{ /* Llib/mpd.scm 1312 */
BgL_auxz00_9751 = BgL_opz00_5349
; }  else 
{ 
obj_t BgL_auxz00_9754;
BgL_auxz00_9754 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)51861)), BGl_string3509z00zz__multimediazd2mpdzd2, BGl_string3345z00zz__multimediazd2mpdzd2, BgL_opz00_5349); 
FAILURE(BgL_auxz00_9754,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5348, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1312 */
BgL_auxz00_9743 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5348)
; }  else 
{ 
obj_t BgL_auxz00_9747;
BgL_auxz00_9747 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)51861)), BGl_string3509z00zz__multimediazd2mpdzd2, BGl_string3346z00zz__multimediazd2mpdzd2, BgL_oz00_5348); 
FAILURE(BgL_auxz00_9747,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2searchzd2artistzd2albumz00zz__multimediazd2mpdzd2(BgL_auxz00_9743, BgL_auxz00_9751, BgL_artistz00_5350, BgL_albumz00_5351);} } 
BGL_FUNCTION_END;
}



/* mpd-database-search-artist-title */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2searchzd2artistzd2titlez00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_390, obj_t BgL_opz00_391, obj_t BgL_artistz00_392, obj_t BgL_titlez00_393)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1345 */
{ /* Llib/mpd.scm 1345 */
obj_t BgL_method1374z00_2396;
{ /* Llib/mpd.scm 1345 */
obj_t BgL_res3164z00_4393;
{ /* Llib/mpd.scm 1345 */
long BgL_objzd2classzd2numz00_4350;
{ /* Llib/mpd.scm 1345 */
long BgL_res3153z00_4353;
BgL_res3153z00_4353 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_390)); 
BgL_objzd2classzd2numz00_4350 = BgL_res3153z00_4353; } 
{ /* Llib/mpd.scm 1345 */
obj_t BgL_arg1742z00_4351;
BgL_arg1742z00_4351 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2searchzd2artistzd2titlezd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1345 */
int BgL_offsetz00_4355;
BgL_offsetz00_4355 = 
(int)(BgL_objzd2classzd2numz00_4350); 
{ /* Llib/mpd.scm 1345 */
long BgL_offsetz00_4356;
BgL_offsetz00_4356 = 
(
(long)(BgL_offsetz00_4355)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1345 */
long BgL_modz00_4357;
{ /* Llib/mpd.scm 1345 */
int BgL_arg1744z00_4358;
BgL_arg1744z00_4358 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1345 */
long BgL_res3156z00_4368;
{ /* Llib/mpd.scm 1345 */
long BgL_tmpz00_9767;
BgL_tmpz00_9767 = 
(long)(BgL_arg1744z00_4358); 
BgL_res3156z00_4368 = 
(BgL_offsetz00_4356/BgL_tmpz00_9767); } 
BgL_modz00_4357 = BgL_res3156z00_4368; } } 
{ /* Llib/mpd.scm 1345 */
long BgL_restz00_4359;
{ /* Llib/mpd.scm 1345 */
int BgL_arg1743z00_4360;
BgL_arg1743z00_4360 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1345 */
long BgL_res3163z00_4388;
{ /* Llib/mpd.scm 1345 */
long BgL_n1z00_4370;long BgL_n2z00_4371;
BgL_n1z00_4370 = BgL_offsetz00_4356; 
BgL_n2z00_4371 = 
(long)(BgL_arg1743z00_4360); 
{ /* Llib/mpd.scm 1345 */
bool_t BgL_testz00_9772;
{ /* Llib/mpd.scm 1345 */
long BgL_arg1283z00_4373;
BgL_arg1283z00_4373 = 
(((BgL_n1z00_4370) | (BgL_n2z00_4371)) & -2147483648); 
BgL_testz00_9772 = 
(BgL_arg1283z00_4373==((long)0)); } 
if(BgL_testz00_9772)
{ /* Llib/mpd.scm 1345 */
int32_t BgL_arg1272z00_4374;
{ /* Llib/mpd.scm 1345 */
int32_t BgL_arg1278z00_4375;int32_t BgL_arg1279z00_4376;
{ /* Llib/mpd.scm 1345 */
int32_t BgL_res3159z00_4380;
BgL_res3159z00_4380 = 
(int32_t)(BgL_n1z00_4370); 
BgL_arg1278z00_4375 = BgL_res3159z00_4380; } 
{ /* Llib/mpd.scm 1345 */
int32_t BgL_res3160z00_4382;
BgL_res3160z00_4382 = 
(int32_t)(BgL_n2z00_4371); 
BgL_arg1279z00_4376 = BgL_res3160z00_4382; } 
BgL_arg1272z00_4374 = 
(BgL_arg1278z00_4375%BgL_arg1279z00_4376); } 
{ /* Llib/mpd.scm 1345 */
long BgL_res3162z00_4387;
{ /* Llib/mpd.scm 1345 */
long BgL_arg1409z00_4384;
BgL_arg1409z00_4384 = 
(long)(BgL_arg1272z00_4374); 
{ /* Llib/mpd.scm 1345 */
long BgL_res3161z00_4386;
BgL_res3161z00_4386 = 
(long)(BgL_arg1409z00_4384); 
BgL_res3162z00_4387 = BgL_res3161z00_4386; } } 
BgL_res3163z00_4388 = BgL_res3162z00_4387; } }  else 
{ /* Llib/mpd.scm 1345 */
BgL_res3163z00_4388 = 
(BgL_n1z00_4370%BgL_n2z00_4371); } } } 
BgL_restz00_4359 = BgL_res3163z00_4388; } } 
{ /* Llib/mpd.scm 1345 */

{ /* Llib/mpd.scm 1345 */
obj_t BgL_bucketz00_4361;
BgL_bucketz00_4361 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4351),BgL_modz00_4357); 
BgL_res3164z00_4393 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4361),BgL_restz00_4359); } } } } } } } } 
BgL_method1374z00_2396 = BgL_res3164z00_4393; } 
return 
PROCEDURE_ENTRY(BgL_method1374z00_2396)(BgL_method1374z00_2396, 
((obj_t)BgL_oz00_390), BgL_opz00_391, BgL_artistz00_392, BgL_titlez00_393, BEOA);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-search-artist-title */
obj_t BGl_z62mpdzd2databasezd2searchzd2artistzd2titlez62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5352, obj_t BgL_oz00_5353, obj_t BgL_opz00_5354, obj_t BgL_artistz00_5355, obj_t BgL_titlez00_5356)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1345 */
{ /* Llib/mpd.scm 1345 */
obj_t BgL_auxz00_9801;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9793;
if(
OUTPUT_PORTP(BgL_opz00_5354))
{ /* Llib/mpd.scm 1345 */
BgL_auxz00_9801 = BgL_opz00_5354
; }  else 
{ 
obj_t BgL_auxz00_9804;
BgL_auxz00_9804 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)53036)), BGl_string3510z00zz__multimediazd2mpdzd2, BGl_string3345z00zz__multimediazd2mpdzd2, BgL_opz00_5354); 
FAILURE(BgL_auxz00_9804,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5353, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1345 */
BgL_auxz00_9793 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5353)
; }  else 
{ 
obj_t BgL_auxz00_9797;
BgL_auxz00_9797 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)53036)), BGl_string3510z00zz__multimediazd2mpdzd2, BGl_string3346z00zz__multimediazd2mpdzd2, BgL_oz00_5353); 
FAILURE(BgL_auxz00_9797,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2searchzd2artistzd2titlez00zz__multimediazd2mpdzd2(BgL_auxz00_9793, BgL_auxz00_9801, BgL_artistz00_5355, BgL_titlez00_5356);} } 
BGL_FUNCTION_END;
}



/* mpd-database-find-title */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2findzd2titlezd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_394, obj_t BgL_opz00_395, obj_t BgL_titlez00_396)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1371 */
{ /* Llib/mpd.scm 1371 */
obj_t BgL_method1376z00_2397;
{ /* Llib/mpd.scm 1371 */
obj_t BgL_res3176z00_4438;
{ /* Llib/mpd.scm 1371 */
long BgL_objzd2classzd2numz00_4395;
{ /* Llib/mpd.scm 1371 */
long BgL_res3165z00_4398;
BgL_res3165z00_4398 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_394)); 
BgL_objzd2classzd2numz00_4395 = BgL_res3165z00_4398; } 
{ /* Llib/mpd.scm 1371 */
obj_t BgL_arg1742z00_4396;
BgL_arg1742z00_4396 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2findzd2titlezd2envz00zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1371 */
int BgL_offsetz00_4400;
BgL_offsetz00_4400 = 
(int)(BgL_objzd2classzd2numz00_4395); 
{ /* Llib/mpd.scm 1371 */
long BgL_offsetz00_4401;
BgL_offsetz00_4401 = 
(
(long)(BgL_offsetz00_4400)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1371 */
long BgL_modz00_4402;
{ /* Llib/mpd.scm 1371 */
int BgL_arg1744z00_4403;
BgL_arg1744z00_4403 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1371 */
long BgL_res3168z00_4413;
{ /* Llib/mpd.scm 1371 */
long BgL_tmpz00_9817;
BgL_tmpz00_9817 = 
(long)(BgL_arg1744z00_4403); 
BgL_res3168z00_4413 = 
(BgL_offsetz00_4401/BgL_tmpz00_9817); } 
BgL_modz00_4402 = BgL_res3168z00_4413; } } 
{ /* Llib/mpd.scm 1371 */
long BgL_restz00_4404;
{ /* Llib/mpd.scm 1371 */
int BgL_arg1743z00_4405;
BgL_arg1743z00_4405 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1371 */
long BgL_res3175z00_4433;
{ /* Llib/mpd.scm 1371 */
long BgL_n1z00_4415;long BgL_n2z00_4416;
BgL_n1z00_4415 = BgL_offsetz00_4401; 
BgL_n2z00_4416 = 
(long)(BgL_arg1743z00_4405); 
{ /* Llib/mpd.scm 1371 */
bool_t BgL_testz00_9822;
{ /* Llib/mpd.scm 1371 */
long BgL_arg1283z00_4418;
BgL_arg1283z00_4418 = 
(((BgL_n1z00_4415) | (BgL_n2z00_4416)) & -2147483648); 
BgL_testz00_9822 = 
(BgL_arg1283z00_4418==((long)0)); } 
if(BgL_testz00_9822)
{ /* Llib/mpd.scm 1371 */
int32_t BgL_arg1272z00_4419;
{ /* Llib/mpd.scm 1371 */
int32_t BgL_arg1278z00_4420;int32_t BgL_arg1279z00_4421;
{ /* Llib/mpd.scm 1371 */
int32_t BgL_res3171z00_4425;
BgL_res3171z00_4425 = 
(int32_t)(BgL_n1z00_4415); 
BgL_arg1278z00_4420 = BgL_res3171z00_4425; } 
{ /* Llib/mpd.scm 1371 */
int32_t BgL_res3172z00_4427;
BgL_res3172z00_4427 = 
(int32_t)(BgL_n2z00_4416); 
BgL_arg1279z00_4421 = BgL_res3172z00_4427; } 
BgL_arg1272z00_4419 = 
(BgL_arg1278z00_4420%BgL_arg1279z00_4421); } 
{ /* Llib/mpd.scm 1371 */
long BgL_res3174z00_4432;
{ /* Llib/mpd.scm 1371 */
long BgL_arg1409z00_4429;
BgL_arg1409z00_4429 = 
(long)(BgL_arg1272z00_4419); 
{ /* Llib/mpd.scm 1371 */
long BgL_res3173z00_4431;
BgL_res3173z00_4431 = 
(long)(BgL_arg1409z00_4429); 
BgL_res3174z00_4432 = BgL_res3173z00_4431; } } 
BgL_res3175z00_4433 = BgL_res3174z00_4432; } }  else 
{ /* Llib/mpd.scm 1371 */
BgL_res3175z00_4433 = 
(BgL_n1z00_4415%BgL_n2z00_4416); } } } 
BgL_restz00_4404 = BgL_res3175z00_4433; } } 
{ /* Llib/mpd.scm 1371 */

{ /* Llib/mpd.scm 1371 */
obj_t BgL_bucketz00_4406;
BgL_bucketz00_4406 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4396),BgL_modz00_4402); 
BgL_res3176z00_4438 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4406),BgL_restz00_4404); } } } } } } } } 
BgL_method1376z00_2397 = BgL_res3176z00_4438; } 
return 
PROCEDURE_ENTRY(BgL_method1376z00_2397)(BgL_method1376z00_2397, 
((obj_t)BgL_oz00_394), BgL_opz00_395, BgL_titlez00_396, BEOA);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-find-title */
obj_t BGl_z62mpdzd2databasezd2findzd2titlezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5357, obj_t BgL_oz00_5358, obj_t BgL_opz00_5359, obj_t BgL_titlez00_5360)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1371 */
{ /* Llib/mpd.scm 1371 */
obj_t BgL_auxz00_9850;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9842;
if(
OUTPUT_PORTP(BgL_opz00_5359))
{ /* Llib/mpd.scm 1371 */
BgL_auxz00_9850 = BgL_opz00_5359
; }  else 
{ 
obj_t BgL_auxz00_9853;
BgL_auxz00_9853 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)53940)), BGl_string3511z00zz__multimediazd2mpdzd2, BGl_string3345z00zz__multimediazd2mpdzd2, BgL_opz00_5359); 
FAILURE(BgL_auxz00_9853,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5358, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1371 */
BgL_auxz00_9842 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5358)
; }  else 
{ 
obj_t BgL_auxz00_9846;
BgL_auxz00_9846 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)53940)), BGl_string3511z00zz__multimediazd2mpdzd2, BGl_string3346z00zz__multimediazd2mpdzd2, BgL_oz00_5358); 
FAILURE(BgL_auxz00_9846,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2findzd2titlezd2zz__multimediazd2mpdzd2(BgL_auxz00_9842, BgL_auxz00_9850, BgL_titlez00_5360);} } 
BGL_FUNCTION_END;
}



/* mpd-database-find-genre */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2findzd2genrezd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_397, obj_t BgL_opz00_398, obj_t BgL_genrez00_399)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1389 */
{ /* Llib/mpd.scm 1389 */
obj_t BgL_method1378z00_2398;
{ /* Llib/mpd.scm 1389 */
obj_t BgL_res3188z00_4483;
{ /* Llib/mpd.scm 1389 */
long BgL_objzd2classzd2numz00_4440;
{ /* Llib/mpd.scm 1389 */
long BgL_res3177z00_4443;
BgL_res3177z00_4443 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_397)); 
BgL_objzd2classzd2numz00_4440 = BgL_res3177z00_4443; } 
{ /* Llib/mpd.scm 1389 */
obj_t BgL_arg1742z00_4441;
BgL_arg1742z00_4441 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2findzd2genrezd2envz00zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1389 */
int BgL_offsetz00_4445;
BgL_offsetz00_4445 = 
(int)(BgL_objzd2classzd2numz00_4440); 
{ /* Llib/mpd.scm 1389 */
long BgL_offsetz00_4446;
BgL_offsetz00_4446 = 
(
(long)(BgL_offsetz00_4445)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1389 */
long BgL_modz00_4447;
{ /* Llib/mpd.scm 1389 */
int BgL_arg1744z00_4448;
BgL_arg1744z00_4448 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1389 */
long BgL_res3180z00_4458;
{ /* Llib/mpd.scm 1389 */
long BgL_tmpz00_9866;
BgL_tmpz00_9866 = 
(long)(BgL_arg1744z00_4448); 
BgL_res3180z00_4458 = 
(BgL_offsetz00_4446/BgL_tmpz00_9866); } 
BgL_modz00_4447 = BgL_res3180z00_4458; } } 
{ /* Llib/mpd.scm 1389 */
long BgL_restz00_4449;
{ /* Llib/mpd.scm 1389 */
int BgL_arg1743z00_4450;
BgL_arg1743z00_4450 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1389 */
long BgL_res3187z00_4478;
{ /* Llib/mpd.scm 1389 */
long BgL_n1z00_4460;long BgL_n2z00_4461;
BgL_n1z00_4460 = BgL_offsetz00_4446; 
BgL_n2z00_4461 = 
(long)(BgL_arg1743z00_4450); 
{ /* Llib/mpd.scm 1389 */
bool_t BgL_testz00_9871;
{ /* Llib/mpd.scm 1389 */
long BgL_arg1283z00_4463;
BgL_arg1283z00_4463 = 
(((BgL_n1z00_4460) | (BgL_n2z00_4461)) & -2147483648); 
BgL_testz00_9871 = 
(BgL_arg1283z00_4463==((long)0)); } 
if(BgL_testz00_9871)
{ /* Llib/mpd.scm 1389 */
int32_t BgL_arg1272z00_4464;
{ /* Llib/mpd.scm 1389 */
int32_t BgL_arg1278z00_4465;int32_t BgL_arg1279z00_4466;
{ /* Llib/mpd.scm 1389 */
int32_t BgL_res3183z00_4470;
BgL_res3183z00_4470 = 
(int32_t)(BgL_n1z00_4460); 
BgL_arg1278z00_4465 = BgL_res3183z00_4470; } 
{ /* Llib/mpd.scm 1389 */
int32_t BgL_res3184z00_4472;
BgL_res3184z00_4472 = 
(int32_t)(BgL_n2z00_4461); 
BgL_arg1279z00_4466 = BgL_res3184z00_4472; } 
BgL_arg1272z00_4464 = 
(BgL_arg1278z00_4465%BgL_arg1279z00_4466); } 
{ /* Llib/mpd.scm 1389 */
long BgL_res3186z00_4477;
{ /* Llib/mpd.scm 1389 */
long BgL_arg1409z00_4474;
BgL_arg1409z00_4474 = 
(long)(BgL_arg1272z00_4464); 
{ /* Llib/mpd.scm 1389 */
long BgL_res3185z00_4476;
BgL_res3185z00_4476 = 
(long)(BgL_arg1409z00_4474); 
BgL_res3186z00_4477 = BgL_res3185z00_4476; } } 
BgL_res3187z00_4478 = BgL_res3186z00_4477; } }  else 
{ /* Llib/mpd.scm 1389 */
BgL_res3187z00_4478 = 
(BgL_n1z00_4460%BgL_n2z00_4461); } } } 
BgL_restz00_4449 = BgL_res3187z00_4478; } } 
{ /* Llib/mpd.scm 1389 */

{ /* Llib/mpd.scm 1389 */
obj_t BgL_bucketz00_4451;
BgL_bucketz00_4451 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4441),BgL_modz00_4447); 
BgL_res3188z00_4483 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4451),BgL_restz00_4449); } } } } } } } } 
BgL_method1378z00_2398 = BgL_res3188z00_4483; } 
return 
PROCEDURE_ENTRY(BgL_method1378z00_2398)(BgL_method1378z00_2398, 
((obj_t)BgL_oz00_397), BgL_opz00_398, BgL_genrez00_399, BEOA);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-find-genre */
obj_t BGl_z62mpdzd2databasezd2findzd2genrezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5361, obj_t BgL_oz00_5362, obj_t BgL_opz00_5363, obj_t BgL_genrez00_5364)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1389 */
{ /* Llib/mpd.scm 1389 */
obj_t BgL_auxz00_9899;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9891;
if(
OUTPUT_PORTP(BgL_opz00_5363))
{ /* Llib/mpd.scm 1389 */
BgL_auxz00_9899 = BgL_opz00_5363
; }  else 
{ 
obj_t BgL_auxz00_9902;
BgL_auxz00_9902 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)54520)), BGl_string3512z00zz__multimediazd2mpdzd2, BGl_string3345z00zz__multimediazd2mpdzd2, BgL_opz00_5363); 
FAILURE(BgL_auxz00_9902,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5362, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1389 */
BgL_auxz00_9891 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5362)
; }  else 
{ 
obj_t BgL_auxz00_9895;
BgL_auxz00_9895 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)54520)), BGl_string3512z00zz__multimediazd2mpdzd2, BGl_string3346z00zz__multimediazd2mpdzd2, BgL_oz00_5362); 
FAILURE(BgL_auxz00_9895,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2findzd2genrezd2zz__multimediazd2mpdzd2(BgL_auxz00_9891, BgL_auxz00_9899, BgL_genrez00_5364);} } 
BGL_FUNCTION_END;
}



/* mpd-database-getgenre */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2getgenrez00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_400)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1407 */
{ /* Llib/mpd.scm 1407 */
obj_t BgL_method1381z00_2399;
{ /* Llib/mpd.scm 1407 */
obj_t BgL_res3200z00_4528;
{ /* Llib/mpd.scm 1407 */
long BgL_objzd2classzd2numz00_4485;
{ /* Llib/mpd.scm 1407 */
long BgL_res3189z00_4488;
BgL_res3189z00_4488 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_400)); 
BgL_objzd2classzd2numz00_4485 = BgL_res3189z00_4488; } 
{ /* Llib/mpd.scm 1407 */
obj_t BgL_arg1742z00_4486;
BgL_arg1742z00_4486 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2getgenrezd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1407 */
int BgL_offsetz00_4490;
BgL_offsetz00_4490 = 
(int)(BgL_objzd2classzd2numz00_4485); 
{ /* Llib/mpd.scm 1407 */
long BgL_offsetz00_4491;
BgL_offsetz00_4491 = 
(
(long)(BgL_offsetz00_4490)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1407 */
long BgL_modz00_4492;
{ /* Llib/mpd.scm 1407 */
int BgL_arg1744z00_4493;
BgL_arg1744z00_4493 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1407 */
long BgL_res3192z00_4503;
{ /* Llib/mpd.scm 1407 */
long BgL_tmpz00_9915;
BgL_tmpz00_9915 = 
(long)(BgL_arg1744z00_4493); 
BgL_res3192z00_4503 = 
(BgL_offsetz00_4491/BgL_tmpz00_9915); } 
BgL_modz00_4492 = BgL_res3192z00_4503; } } 
{ /* Llib/mpd.scm 1407 */
long BgL_restz00_4494;
{ /* Llib/mpd.scm 1407 */
int BgL_arg1743z00_4495;
BgL_arg1743z00_4495 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1407 */
long BgL_res3199z00_4523;
{ /* Llib/mpd.scm 1407 */
long BgL_n1z00_4505;long BgL_n2z00_4506;
BgL_n1z00_4505 = BgL_offsetz00_4491; 
BgL_n2z00_4506 = 
(long)(BgL_arg1743z00_4495); 
{ /* Llib/mpd.scm 1407 */
bool_t BgL_testz00_9920;
{ /* Llib/mpd.scm 1407 */
long BgL_arg1283z00_4508;
BgL_arg1283z00_4508 = 
(((BgL_n1z00_4505) | (BgL_n2z00_4506)) & -2147483648); 
BgL_testz00_9920 = 
(BgL_arg1283z00_4508==((long)0)); } 
if(BgL_testz00_9920)
{ /* Llib/mpd.scm 1407 */
int32_t BgL_arg1272z00_4509;
{ /* Llib/mpd.scm 1407 */
int32_t BgL_arg1278z00_4510;int32_t BgL_arg1279z00_4511;
{ /* Llib/mpd.scm 1407 */
int32_t BgL_res3195z00_4515;
BgL_res3195z00_4515 = 
(int32_t)(BgL_n1z00_4505); 
BgL_arg1278z00_4510 = BgL_res3195z00_4515; } 
{ /* Llib/mpd.scm 1407 */
int32_t BgL_res3196z00_4517;
BgL_res3196z00_4517 = 
(int32_t)(BgL_n2z00_4506); 
BgL_arg1279z00_4511 = BgL_res3196z00_4517; } 
BgL_arg1272z00_4509 = 
(BgL_arg1278z00_4510%BgL_arg1279z00_4511); } 
{ /* Llib/mpd.scm 1407 */
long BgL_res3198z00_4522;
{ /* Llib/mpd.scm 1407 */
long BgL_arg1409z00_4519;
BgL_arg1409z00_4519 = 
(long)(BgL_arg1272z00_4509); 
{ /* Llib/mpd.scm 1407 */
long BgL_res3197z00_4521;
BgL_res3197z00_4521 = 
(long)(BgL_arg1409z00_4519); 
BgL_res3198z00_4522 = BgL_res3197z00_4521; } } 
BgL_res3199z00_4523 = BgL_res3198z00_4522; } }  else 
{ /* Llib/mpd.scm 1407 */
BgL_res3199z00_4523 = 
(BgL_n1z00_4505%BgL_n2z00_4506); } } } 
BgL_restz00_4494 = BgL_res3199z00_4523; } } 
{ /* Llib/mpd.scm 1407 */

{ /* Llib/mpd.scm 1407 */
obj_t BgL_bucketz00_4496;
BgL_bucketz00_4496 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4486),BgL_modz00_4492); 
BgL_res3200z00_4528 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4496),BgL_restz00_4494); } } } } } } } } 
BgL_method1381z00_2399 = BgL_res3200z00_4528; } 
return 
PROCEDURE_ENTRY(BgL_method1381z00_2399)(BgL_method1381z00_2399, 
((obj_t)BgL_oz00_400), BEOA);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-getgenre */
obj_t BGl_z62mpdzd2databasezd2getgenrez62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5365, obj_t BgL_oz00_5366)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1407 */
{ /* Llib/mpd.scm 1407 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_9938;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5366, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1407 */
BgL_auxz00_9938 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5366)
; }  else 
{ 
obj_t BgL_auxz00_9942;
BgL_auxz00_9942 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)55101)), BGl_string3513z00zz__multimediazd2mpdzd2, BGl_string3346z00zz__multimediazd2mpdzd2, BgL_oz00_5366); 
FAILURE(BgL_auxz00_9942,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2getgenrez00zz__multimediazd2mpdzd2(BgL_auxz00_9938);} } 
BGL_FUNCTION_END;
}



/* mpd-database-getartist */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2getartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_401)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1414 */
{ /* Llib/mpd.scm 1414 */
obj_t BgL_method1383z00_2400;
{ /* Llib/mpd.scm 1414 */
obj_t BgL_res3212z00_4573;
{ /* Llib/mpd.scm 1414 */
long BgL_objzd2classzd2numz00_4530;
{ /* Llib/mpd.scm 1414 */
long BgL_res3201z00_4533;
BgL_res3201z00_4533 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_401)); 
BgL_objzd2classzd2numz00_4530 = BgL_res3201z00_4533; } 
{ /* Llib/mpd.scm 1414 */
obj_t BgL_arg1742z00_4531;
BgL_arg1742z00_4531 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2getartistzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1414 */
int BgL_offsetz00_4535;
BgL_offsetz00_4535 = 
(int)(BgL_objzd2classzd2numz00_4530); 
{ /* Llib/mpd.scm 1414 */
long BgL_offsetz00_4536;
BgL_offsetz00_4536 = 
(
(long)(BgL_offsetz00_4535)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1414 */
long BgL_modz00_4537;
{ /* Llib/mpd.scm 1414 */
int BgL_arg1744z00_4538;
BgL_arg1744z00_4538 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1414 */
long BgL_res3204z00_4548;
{ /* Llib/mpd.scm 1414 */
long BgL_tmpz00_9955;
BgL_tmpz00_9955 = 
(long)(BgL_arg1744z00_4538); 
BgL_res3204z00_4548 = 
(BgL_offsetz00_4536/BgL_tmpz00_9955); } 
BgL_modz00_4537 = BgL_res3204z00_4548; } } 
{ /* Llib/mpd.scm 1414 */
long BgL_restz00_4539;
{ /* Llib/mpd.scm 1414 */
int BgL_arg1743z00_4540;
BgL_arg1743z00_4540 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1414 */
long BgL_res3211z00_4568;
{ /* Llib/mpd.scm 1414 */
long BgL_n1z00_4550;long BgL_n2z00_4551;
BgL_n1z00_4550 = BgL_offsetz00_4536; 
BgL_n2z00_4551 = 
(long)(BgL_arg1743z00_4540); 
{ /* Llib/mpd.scm 1414 */
bool_t BgL_testz00_9960;
{ /* Llib/mpd.scm 1414 */
long BgL_arg1283z00_4553;
BgL_arg1283z00_4553 = 
(((BgL_n1z00_4550) | (BgL_n2z00_4551)) & -2147483648); 
BgL_testz00_9960 = 
(BgL_arg1283z00_4553==((long)0)); } 
if(BgL_testz00_9960)
{ /* Llib/mpd.scm 1414 */
int32_t BgL_arg1272z00_4554;
{ /* Llib/mpd.scm 1414 */
int32_t BgL_arg1278z00_4555;int32_t BgL_arg1279z00_4556;
{ /* Llib/mpd.scm 1414 */
int32_t BgL_res3207z00_4560;
BgL_res3207z00_4560 = 
(int32_t)(BgL_n1z00_4550); 
BgL_arg1278z00_4555 = BgL_res3207z00_4560; } 
{ /* Llib/mpd.scm 1414 */
int32_t BgL_res3208z00_4562;
BgL_res3208z00_4562 = 
(int32_t)(BgL_n2z00_4551); 
BgL_arg1279z00_4556 = BgL_res3208z00_4562; } 
BgL_arg1272z00_4554 = 
(BgL_arg1278z00_4555%BgL_arg1279z00_4556); } 
{ /* Llib/mpd.scm 1414 */
long BgL_res3210z00_4567;
{ /* Llib/mpd.scm 1414 */
long BgL_arg1409z00_4564;
BgL_arg1409z00_4564 = 
(long)(BgL_arg1272z00_4554); 
{ /* Llib/mpd.scm 1414 */
long BgL_res3209z00_4566;
BgL_res3209z00_4566 = 
(long)(BgL_arg1409z00_4564); 
BgL_res3210z00_4567 = BgL_res3209z00_4566; } } 
BgL_res3211z00_4568 = BgL_res3210z00_4567; } }  else 
{ /* Llib/mpd.scm 1414 */
BgL_res3211z00_4568 = 
(BgL_n1z00_4550%BgL_n2z00_4551); } } } 
BgL_restz00_4539 = BgL_res3211z00_4568; } } 
{ /* Llib/mpd.scm 1414 */

{ /* Llib/mpd.scm 1414 */
obj_t BgL_bucketz00_4541;
BgL_bucketz00_4541 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4531),BgL_modz00_4537); 
BgL_res3212z00_4573 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4541),BgL_restz00_4539); } } } } } } } } 
BgL_method1383z00_2400 = BgL_res3212z00_4573; } 
return 
PROCEDURE_ENTRY(BgL_method1383z00_2400)(BgL_method1383z00_2400, 
((obj_t)BgL_oz00_401), BEOA);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-getartist */
obj_t BGl_z62mpdzd2databasezd2getartistz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5367, obj_t BgL_oz00_5368)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1414 */
{ /* Llib/mpd.scm 1414 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_9978;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5368, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1414 */
BgL_auxz00_9978 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5368)
; }  else 
{ 
obj_t BgL_auxz00_9982;
BgL_auxz00_9982 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)55438)), BGl_string3514z00zz__multimediazd2mpdzd2, BGl_string3346z00zz__multimediazd2mpdzd2, BgL_oz00_5368); 
FAILURE(BgL_auxz00_9982,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2getartistz00zz__multimediazd2mpdzd2(BgL_auxz00_9978);} } 
BGL_FUNCTION_END;
}



/* mpd-database-getgenreartist */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2getgenreartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_402, obj_t BgL_genrez00_403)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1421 */
{ /* Llib/mpd.scm 1421 */
obj_t BgL_method1386z00_2401;
{ /* Llib/mpd.scm 1421 */
obj_t BgL_res3224z00_4618;
{ /* Llib/mpd.scm 1421 */
long BgL_objzd2classzd2numz00_4575;
{ /* Llib/mpd.scm 1421 */
long BgL_res3213z00_4578;
BgL_res3213z00_4578 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_402)); 
BgL_objzd2classzd2numz00_4575 = BgL_res3213z00_4578; } 
{ /* Llib/mpd.scm 1421 */
obj_t BgL_arg1742z00_4576;
BgL_arg1742z00_4576 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2getgenreartistzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1421 */
int BgL_offsetz00_4580;
BgL_offsetz00_4580 = 
(int)(BgL_objzd2classzd2numz00_4575); 
{ /* Llib/mpd.scm 1421 */
long BgL_offsetz00_4581;
BgL_offsetz00_4581 = 
(
(long)(BgL_offsetz00_4580)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1421 */
long BgL_modz00_4582;
{ /* Llib/mpd.scm 1421 */
int BgL_arg1744z00_4583;
BgL_arg1744z00_4583 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1421 */
long BgL_res3216z00_4593;
{ /* Llib/mpd.scm 1421 */
long BgL_tmpz00_9995;
BgL_tmpz00_9995 = 
(long)(BgL_arg1744z00_4583); 
BgL_res3216z00_4593 = 
(BgL_offsetz00_4581/BgL_tmpz00_9995); } 
BgL_modz00_4582 = BgL_res3216z00_4593; } } 
{ /* Llib/mpd.scm 1421 */
long BgL_restz00_4584;
{ /* Llib/mpd.scm 1421 */
int BgL_arg1743z00_4585;
BgL_arg1743z00_4585 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1421 */
long BgL_res3223z00_4613;
{ /* Llib/mpd.scm 1421 */
long BgL_n1z00_4595;long BgL_n2z00_4596;
BgL_n1z00_4595 = BgL_offsetz00_4581; 
BgL_n2z00_4596 = 
(long)(BgL_arg1743z00_4585); 
{ /* Llib/mpd.scm 1421 */
bool_t BgL_testz00_10000;
{ /* Llib/mpd.scm 1421 */
long BgL_arg1283z00_4598;
BgL_arg1283z00_4598 = 
(((BgL_n1z00_4595) | (BgL_n2z00_4596)) & -2147483648); 
BgL_testz00_10000 = 
(BgL_arg1283z00_4598==((long)0)); } 
if(BgL_testz00_10000)
{ /* Llib/mpd.scm 1421 */
int32_t BgL_arg1272z00_4599;
{ /* Llib/mpd.scm 1421 */
int32_t BgL_arg1278z00_4600;int32_t BgL_arg1279z00_4601;
{ /* Llib/mpd.scm 1421 */
int32_t BgL_res3219z00_4605;
BgL_res3219z00_4605 = 
(int32_t)(BgL_n1z00_4595); 
BgL_arg1278z00_4600 = BgL_res3219z00_4605; } 
{ /* Llib/mpd.scm 1421 */
int32_t BgL_res3220z00_4607;
BgL_res3220z00_4607 = 
(int32_t)(BgL_n2z00_4596); 
BgL_arg1279z00_4601 = BgL_res3220z00_4607; } 
BgL_arg1272z00_4599 = 
(BgL_arg1278z00_4600%BgL_arg1279z00_4601); } 
{ /* Llib/mpd.scm 1421 */
long BgL_res3222z00_4612;
{ /* Llib/mpd.scm 1421 */
long BgL_arg1409z00_4609;
BgL_arg1409z00_4609 = 
(long)(BgL_arg1272z00_4599); 
{ /* Llib/mpd.scm 1421 */
long BgL_res3221z00_4611;
BgL_res3221z00_4611 = 
(long)(BgL_arg1409z00_4609); 
BgL_res3222z00_4612 = BgL_res3221z00_4611; } } 
BgL_res3223z00_4613 = BgL_res3222z00_4612; } }  else 
{ /* Llib/mpd.scm 1421 */
BgL_res3223z00_4613 = 
(BgL_n1z00_4595%BgL_n2z00_4596); } } } 
BgL_restz00_4584 = BgL_res3223z00_4613; } } 
{ /* Llib/mpd.scm 1421 */

{ /* Llib/mpd.scm 1421 */
obj_t BgL_bucketz00_4586;
BgL_bucketz00_4586 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4576),BgL_modz00_4582); 
BgL_res3224z00_4618 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4586),BgL_restz00_4584); } } } } } } } } 
BgL_method1386z00_2401 = BgL_res3224z00_4618; } 
return 
PROCEDURE_ENTRY(BgL_method1386z00_2401)(BgL_method1386z00_2401, 
((obj_t)BgL_oz00_402), BgL_genrez00_403, BEOA);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-getgenreartist */
obj_t BGl_z62mpdzd2databasezd2getgenreartistz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5369, obj_t BgL_oz00_5370, obj_t BgL_genrez00_5371)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1421 */
{ /* Llib/mpd.scm 1421 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_10019;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5370, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1421 */
BgL_auxz00_10019 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5370)
; }  else 
{ 
obj_t BgL_auxz00_10023;
BgL_auxz00_10023 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)55778)), BGl_string3515z00zz__multimediazd2mpdzd2, BGl_string3346z00zz__multimediazd2mpdzd2, BgL_oz00_5370); 
FAILURE(BgL_auxz00_10023,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2getgenreartistz00zz__multimediazd2mpdzd2(BgL_auxz00_10019, BgL_genrez00_5371);} } 
BGL_FUNCTION_END;
}



/* mpd-database-getartistalbum */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2getartistalbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_404, obj_t BgL_artistz00_405)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1431 */
{ /* Llib/mpd.scm 1431 */
obj_t BgL_method1388z00_2402;
{ /* Llib/mpd.scm 1431 */
obj_t BgL_res3236z00_4663;
{ /* Llib/mpd.scm 1431 */
long BgL_objzd2classzd2numz00_4620;
{ /* Llib/mpd.scm 1431 */
long BgL_res3225z00_4623;
BgL_res3225z00_4623 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_404)); 
BgL_objzd2classzd2numz00_4620 = BgL_res3225z00_4623; } 
{ /* Llib/mpd.scm 1431 */
obj_t BgL_arg1742z00_4621;
BgL_arg1742z00_4621 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2getartistalbumzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1431 */
int BgL_offsetz00_4625;
BgL_offsetz00_4625 = 
(int)(BgL_objzd2classzd2numz00_4620); 
{ /* Llib/mpd.scm 1431 */
long BgL_offsetz00_4626;
BgL_offsetz00_4626 = 
(
(long)(BgL_offsetz00_4625)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1431 */
long BgL_modz00_4627;
{ /* Llib/mpd.scm 1431 */
int BgL_arg1744z00_4628;
BgL_arg1744z00_4628 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1431 */
long BgL_res3228z00_4638;
{ /* Llib/mpd.scm 1431 */
long BgL_tmpz00_10036;
BgL_tmpz00_10036 = 
(long)(BgL_arg1744z00_4628); 
BgL_res3228z00_4638 = 
(BgL_offsetz00_4626/BgL_tmpz00_10036); } 
BgL_modz00_4627 = BgL_res3228z00_4638; } } 
{ /* Llib/mpd.scm 1431 */
long BgL_restz00_4629;
{ /* Llib/mpd.scm 1431 */
int BgL_arg1743z00_4630;
BgL_arg1743z00_4630 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1431 */
long BgL_res3235z00_4658;
{ /* Llib/mpd.scm 1431 */
long BgL_n1z00_4640;long BgL_n2z00_4641;
BgL_n1z00_4640 = BgL_offsetz00_4626; 
BgL_n2z00_4641 = 
(long)(BgL_arg1743z00_4630); 
{ /* Llib/mpd.scm 1431 */
bool_t BgL_testz00_10041;
{ /* Llib/mpd.scm 1431 */
long BgL_arg1283z00_4643;
BgL_arg1283z00_4643 = 
(((BgL_n1z00_4640) | (BgL_n2z00_4641)) & -2147483648); 
BgL_testz00_10041 = 
(BgL_arg1283z00_4643==((long)0)); } 
if(BgL_testz00_10041)
{ /* Llib/mpd.scm 1431 */
int32_t BgL_arg1272z00_4644;
{ /* Llib/mpd.scm 1431 */
int32_t BgL_arg1278z00_4645;int32_t BgL_arg1279z00_4646;
{ /* Llib/mpd.scm 1431 */
int32_t BgL_res3231z00_4650;
BgL_res3231z00_4650 = 
(int32_t)(BgL_n1z00_4640); 
BgL_arg1278z00_4645 = BgL_res3231z00_4650; } 
{ /* Llib/mpd.scm 1431 */
int32_t BgL_res3232z00_4652;
BgL_res3232z00_4652 = 
(int32_t)(BgL_n2z00_4641); 
BgL_arg1279z00_4646 = BgL_res3232z00_4652; } 
BgL_arg1272z00_4644 = 
(BgL_arg1278z00_4645%BgL_arg1279z00_4646); } 
{ /* Llib/mpd.scm 1431 */
long BgL_res3234z00_4657;
{ /* Llib/mpd.scm 1431 */
long BgL_arg1409z00_4654;
BgL_arg1409z00_4654 = 
(long)(BgL_arg1272z00_4644); 
{ /* Llib/mpd.scm 1431 */
long BgL_res3233z00_4656;
BgL_res3233z00_4656 = 
(long)(BgL_arg1409z00_4654); 
BgL_res3234z00_4657 = BgL_res3233z00_4656; } } 
BgL_res3235z00_4658 = BgL_res3234z00_4657; } }  else 
{ /* Llib/mpd.scm 1431 */
BgL_res3235z00_4658 = 
(BgL_n1z00_4640%BgL_n2z00_4641); } } } 
BgL_restz00_4629 = BgL_res3235z00_4658; } } 
{ /* Llib/mpd.scm 1431 */

{ /* Llib/mpd.scm 1431 */
obj_t BgL_bucketz00_4631;
BgL_bucketz00_4631 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4621),BgL_modz00_4627); 
BgL_res3236z00_4663 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4631),BgL_restz00_4629); } } } } } } } } 
BgL_method1388z00_2402 = BgL_res3236z00_4663; } 
return 
PROCEDURE_ENTRY(BgL_method1388z00_2402)(BgL_method1388z00_2402, 
((obj_t)BgL_oz00_404), BgL_artistz00_405, BEOA);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-getartistalbum */
obj_t BGl_z62mpdzd2databasezd2getartistalbumz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5372, obj_t BgL_oz00_5373, obj_t BgL_artistz00_5374)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1431 */
{ /* Llib/mpd.scm 1431 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_10060;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5373, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1431 */
BgL_auxz00_10060 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5373)
; }  else 
{ 
obj_t BgL_auxz00_10064;
BgL_auxz00_10064 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)56226)), BGl_string3516z00zz__multimediazd2mpdzd2, BGl_string3346z00zz__multimediazd2mpdzd2, BgL_oz00_5373); 
FAILURE(BgL_auxz00_10064,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2getartistalbumz00zz__multimediazd2mpdzd2(BgL_auxz00_10060, BgL_artistz00_5374);} } 
BGL_FUNCTION_END;
}



/* mpd-database-get-album */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2getzd2albumzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_417, obj_t BgL_albumz00_418)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1517 */
{ /* Llib/mpd.scm 1517 */
obj_t BgL_method1392z00_2403;
{ /* Llib/mpd.scm 1517 */
obj_t BgL_res3248z00_4708;
{ /* Llib/mpd.scm 1517 */
long BgL_objzd2classzd2numz00_4665;
{ /* Llib/mpd.scm 1517 */
long BgL_res3237z00_4668;
BgL_res3237z00_4668 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_417)); 
BgL_objzd2classzd2numz00_4665 = BgL_res3237z00_4668; } 
{ /* Llib/mpd.scm 1517 */
obj_t BgL_arg1742z00_4666;
BgL_arg1742z00_4666 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2getzd2albumzd2envz00zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1517 */
int BgL_offsetz00_4670;
BgL_offsetz00_4670 = 
(int)(BgL_objzd2classzd2numz00_4665); 
{ /* Llib/mpd.scm 1517 */
long BgL_offsetz00_4671;
BgL_offsetz00_4671 = 
(
(long)(BgL_offsetz00_4670)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1517 */
long BgL_modz00_4672;
{ /* Llib/mpd.scm 1517 */
int BgL_arg1744z00_4673;
BgL_arg1744z00_4673 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1517 */
long BgL_res3240z00_4683;
{ /* Llib/mpd.scm 1517 */
long BgL_tmpz00_10077;
BgL_tmpz00_10077 = 
(long)(BgL_arg1744z00_4673); 
BgL_res3240z00_4683 = 
(BgL_offsetz00_4671/BgL_tmpz00_10077); } 
BgL_modz00_4672 = BgL_res3240z00_4683; } } 
{ /* Llib/mpd.scm 1517 */
long BgL_restz00_4674;
{ /* Llib/mpd.scm 1517 */
int BgL_arg1743z00_4675;
BgL_arg1743z00_4675 = 
(int)(((long)16)); 
{ /* Llib/mpd.scm 1517 */
long BgL_res3247z00_4703;
{ /* Llib/mpd.scm 1517 */
long BgL_n1z00_4685;long BgL_n2z00_4686;
BgL_n1z00_4685 = BgL_offsetz00_4671; 
BgL_n2z00_4686 = 
(long)(BgL_arg1743z00_4675); 
{ /* Llib/mpd.scm 1517 */
bool_t BgL_testz00_10082;
{ /* Llib/mpd.scm 1517 */
long BgL_arg1283z00_4688;
BgL_arg1283z00_4688 = 
(((BgL_n1z00_4685) | (BgL_n2z00_4686)) & -2147483648); 
BgL_testz00_10082 = 
(BgL_arg1283z00_4688==((long)0)); } 
if(BgL_testz00_10082)
{ /* Llib/mpd.scm 1517 */
int32_t BgL_arg1272z00_4689;
{ /* Llib/mpd.scm 1517 */
int32_t BgL_arg1278z00_4690;int32_t BgL_arg1279z00_4691;
{ /* Llib/mpd.scm 1517 */
int32_t BgL_res3243z00_4695;
BgL_res3243z00_4695 = 
(int32_t)(BgL_n1z00_4685); 
BgL_arg1278z00_4690 = BgL_res3243z00_4695; } 
{ /* Llib/mpd.scm 1517 */
int32_t BgL_res3244z00_4697;
BgL_res3244z00_4697 = 
(int32_t)(BgL_n2z00_4686); 
BgL_arg1279z00_4691 = BgL_res3244z00_4697; } 
BgL_arg1272z00_4689 = 
(BgL_arg1278z00_4690%BgL_arg1279z00_4691); } 
{ /* Llib/mpd.scm 1517 */
long BgL_res3246z00_4702;
{ /* Llib/mpd.scm 1517 */
long BgL_arg1409z00_4699;
BgL_arg1409z00_4699 = 
(long)(BgL_arg1272z00_4689); 
{ /* Llib/mpd.scm 1517 */
long BgL_res3245z00_4701;
BgL_res3245z00_4701 = 
(long)(BgL_arg1409z00_4699); 
BgL_res3246z00_4702 = BgL_res3245z00_4701; } } 
BgL_res3247z00_4703 = BgL_res3246z00_4702; } }  else 
{ /* Llib/mpd.scm 1517 */
BgL_res3247z00_4703 = 
(BgL_n1z00_4685%BgL_n2z00_4686); } } } 
BgL_restz00_4674 = BgL_res3247z00_4703; } } 
{ /* Llib/mpd.scm 1517 */

{ /* Llib/mpd.scm 1517 */
obj_t BgL_bucketz00_4676;
BgL_bucketz00_4676 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4666),BgL_modz00_4672); 
BgL_res3248z00_4708 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4676),BgL_restz00_4674); } } } } } } } } 
BgL_method1392z00_2403 = BgL_res3248z00_4708; } 
return 
PROCEDURE_ENTRY(BgL_method1392z00_2403)(BgL_method1392z00_2403, 
((obj_t)BgL_oz00_417), BgL_albumz00_418, BEOA);} } 
BGL_FUNCTION_END;
}



/* &mpd-database-get-album */
obj_t BGl_z62mpdzd2databasezd2getzd2albumzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5375, obj_t BgL_oz00_5376, obj_t BgL_albumz00_5377)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 1517 */
{ /* Llib/mpd.scm 1517 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_10101;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5376, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1517 */
BgL_auxz00_10101 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5376)
; }  else 
{ 
obj_t BgL_auxz00_10105;
BgL_auxz00_10105 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3340z00zz__multimediazd2mpdzd2, 
BINT(((long)59323)), BGl_string3517z00zz__multimediazd2mpdzd2, BGl_string3346z00zz__multimediazd2mpdzd2, BgL_oz00_5376); 
FAILURE(BgL_auxz00_10105,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2getzd2albumzd2zz__multimediazd2mpdzd2(BgL_auxz00_10101, BgL_albumz00_5377);} } 
BGL_FUNCTION_END;
}



/* method-init */
obj_t BGl_methodzd2initzd2zz__multimediazd2mpdzd2()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 15 */
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__multimediazd2mpdzd2()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/mpd.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)95358739), 
BSTRING_TO_STRING(BGl_string3518z00zz__multimediazd2mpdzd2)); 
return 
BGl_modulezd2initializa7ationz75zz__multimediazd2id3zd2(((long)299260312), 
BSTRING_TO_STRING(BGl_string3518z00zz__multimediazd2mpdzd2));} 
BGL_FUNCTION_END;
}

#ifdef __cplusplus
}
#endif
