/*===========================================================================*/
/*   (Llib/ssl.scm)                                                          */
/*   Bigloo (4.3f)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 04 Jul 2019 08:10:18 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo4.3f/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -I Llib -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -unsafe -safee -copt -I. -copt -fPIC -copt -IC Llib/ssl.scm -o objs/ssl.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

/* runtime code modification */
#define BGL_SELF_MODIFYING_CODE 0

#include <bigloo.h>
#include <bglssl.h>
#include <ssl_debug.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_certificatez00_bgl {
   header_t header;
   obj_t widening;
   void * BgL_z42nativez42;
} *BgL_certificatez00_bglt;

typedef struct BgL_privatezd2keyzd2_bgl {
   header_t header;
   obj_t widening;
   void * BgL_z42nativez42;
} *BgL_privatezd2keyzd2_bglt;

typedef struct BgL_securezd2contextzd2_bgl {
   header_t header;
   obj_t widening;
   void * BgL_z42nativez42;
   void * BgL_z42cazd2storez90;
   obj_t BgL_methodz00;
} *BgL_securezd2contextzd2_bglt;

typedef struct BgL_sslzd2connectionzd2_bgl {
   header_t header;
   obj_t widening;
   void * BgL_z42nativez42;
   void * BgL_z42biozd2readz90;
   void * BgL_z42biozd2writez90;
   void * BgL_z42nextzd2sessionz90;
   struct BgL_securezd2contextzd2_bgl * BgL_ctxz00;
   bool_t BgL_isserverz00;
   bool_t BgL_requestzd2certzd2;
   obj_t BgL_serverzd2namezd2;
   bool_t BgL_rejectzd2unauthoriza7edz75;
   obj_t BgL_infozd2callbackzd2;
   obj_t BgL_snizd2contextzd2callbackz00;
   obj_t BgL_newsessionzd2callbackzd2;
   obj_t BgL_selectedzd2npnzd2protosz00;
   obj_t BgL_npnzd2protoszd2;
   obj_t BgL_errz00;
   bool_t BgL_receivedzd2shutdownzd2;
   bool_t BgL_sentzd2shutdownzd2;
} *BgL_sslzd2connectionzd2_bglt;

typedef struct BgL_dhz00_bgl {
   header_t header;
   obj_t widening;
   void * BgL_z42nativez42;
   void * BgL_z52pz52;
   void * BgL_z52qz52;
   void * BgL_z52gz52;
   void * BgL_z52pubz52;
   void * BgL_z52privz52;
} *BgL_dhz00_bglt;

typedef struct BgL_sslzd2hashzd2_bgl {
   header_t header;
   obj_t widening;
   void * BgL_z42mdz42;
   void * BgL_z42mdzd2ctxz90;
   obj_t BgL_typez00;
} *BgL_sslzd2hashzd2_bglt;

typedef struct BgL_sslzd2hmaczd2_bgl {
   header_t header;
   obj_t widening;
   void * BgL_z42mdz42;
   void * BgL_z42mdzd2ctxz90;
} *BgL_sslzd2hmaczd2_bglt;

typedef struct BgL_sslzd2signzd2_bgl {
   header_t header;
   obj_t widening;
   void * BgL_z42mdz42;
   void * BgL_z42mdzd2ctxz90;
} *BgL_sslzd2signzd2_bglt;

typedef struct BgL_sslzd2verifyzd2_bgl {
   header_t header;
   obj_t widening;
   void * BgL_z42mdz42;
   void * BgL_z42mdzd2ctxz90;
} *BgL_sslzd2verifyzd2_bglt;

typedef struct BgL_sslzd2cipherzd2_bgl {
   header_t header;
   obj_t widening;
   void * BgL_z42cipherz42;
   void * BgL_z42cipherzd2ctxz90;
} *BgL_sslzd2cipherzd2_bglt;


static BgL_privatezd2keyzd2_bglt BGl_z62lambda1767z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2hashzd2digest1322z62zz__ssl_sslz00(obj_t, obj_t);
static BgL_privatezd2keyzd2_bglt BGl_z62lambda1769z62zz__ssl_sslz00(obj_t);
static obj_t BGl_z62dhzd2generatezd2keyz62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2clearzd2inzb0zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32019ze3ze1zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2cipherzd2updatez12z70zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t bgl_pkcs5_pbkdf2_hmac_sha1(obj_t, obj_t, int, int);
static obj_t BGl_z62lambda1930z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1931z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1775z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1776z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static BgL_dhz00_bglt BGl_z62lambda1938z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2setzd2s1288zb0zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_certificatez00zz__ssl_sslz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
static BgL_dhz00_bglt BGl_z62lambda1941z62zz__ssl_sslz00(obj_t);
static BgL_securezd2contextzd2_bglt BGl_z62lambda1782z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t bgl_make_ssl_server_socket(obj_t, int, int, obj_t, obj_t, obj_t, obj_t, int, bool_t);
static BgL_securezd2contextzd2_bglt BGl_z62lambda1785z62zz__ssl_sslz00(obj_t);
static obj_t BGl_z62lambda1948z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1949z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_bnzd2newzd2zz__ssl_sslz00();
static obj_t BGl_z62sslzd2verifyzd2init1336z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32126ze3ze1zz__ssl_sslz00(obj_t);
static obj_t BGl_sanityzd2argszd2checksz00zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2hashzd2digestz00zz__ssl_sslz00(BgL_sslzd2hashzd2_bglt);
static obj_t BGl_z62sslzd2signzd2initz62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2setzd2sessionzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt, obj_t);
static obj_t BGl_z62lambda1792z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31994ze3ze1zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1793z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1955z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1956z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31978ze3ze1zz__ssl_sslz00(obj_t);
static obj_t BGl_z62sslzd2getzd2ciphersz62zz__ssl_sslz00(obj_t);
static obj_t BGl_z62lambda1799z62zz__ssl_sslz00(obj_t, obj_t);
extern bool_t bgl_ssl_ctx_add_ca_cert(BgL_securezd2contextzd2_bglt, obj_t, long, long);
static obj_t BGl_z62zc3anonymousza32070ze3ze1zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32143ze3ze1zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_search1227ze70ze7zz__ssl_sslz00(long, obj_t, obj_t, long);
extern obj_t bgl_ssl_sign_sign(BgL_sslzd2signzd2_bglt, obj_t, long, long);
static obj_t BGl_z62sslzd2connectionzd2shutd1272z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1962z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1963z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31995ze3ze1zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1969z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62dhzd2generatezd2key1316z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl__clientzd2socketzd2usezd2sslz12zc0zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_dhzd2generatezd2parameterszd2exzd2zz__ssl_sslz00(BgL_dhz00_bglt, int, obj_t);
static obj_t BGl_z62lambda1970z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1976z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1977z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62securezd2contextzd2setzd2o1264zb0zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2clearzd2errorz62zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_dhzd2checkzd2zz__ssl_sslz00(BgL_dhz00_bglt);
static obj_t BGl_z62lambda1983z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1984z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2getzd2peerzd2certificatez62zz__ssl_sslz00(obj_t, obj_t);
extern bool_t bgl_ssl_ctx_set_key(BgL_securezd2contextzd2_bglt, obj_t, long, long, obj_t);
static obj_t BGl_z62zc3anonymousza32057ze3ze1zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_privatezd2keyzd2zz__ssl_sslz00 = BUNSPEC;
extern obj_t bgl_ssl_error_string();
static obj_t BGl_z62sslzd2connectionzd2loadzd2sessionzb0zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62securezd2contextzd2setzd2sessionzd2idzd2contextz12za2zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__ssl_sslz00();
BGL_EXPORTED_DECL bool_t BGl_securezd2contextzd2addzd2crlz12zc0zz__ssl_sslz00(BgL_securezd2contextzd2_bglt, obj_t, long, long);
static obj_t BGl_z62sslzd2connectionzd2read1274z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_pkcs5zd2pbkdf2zd2hmaczd2sha1zd2zz__ssl_sslz00(obj_t, obj_t, int, int);
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2zz__ssl_sslz00 = BUNSPEC;
static obj_t BGl_z62sslzd2connectionzd2verif1296z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32074ze3ze1zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31999ze3ze1zz__ssl_sslz00(obj_t, obj_t);
extern bool_t bgl_cipher_set_auto_padding(BgL_sslzd2cipherzd2_bglt, bool_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2hashzd2initz00zz__ssl_sslz00(BgL_sslzd2hashzd2_bglt);
BGL_EXPORTED_DECL bool_t BGl_sslzd2verifyzd2finalz00zz__ssl_sslz00(BgL_sslzd2verifyzd2_bglt, obj_t, long, long, obj_t, long, long);
BGL_EXPORTED_DECL BgL_certificatez00_bglt BGl_readzd2certificatezd2zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DECL bool_t BGl_sslzd2randzd2statusz00zz__ssl_sslz00();
static obj_t BGl_z62sslzd2hashzd2init1318z62zz__ssl_sslz00(obj_t, obj_t);
extern obj_t bgl_cipher_final(BgL_sslzd2cipherzd2_bglt);
static obj_t BGl_z62sslzd2connectionzd2getzd2currentzd2cipherz62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62bnzd2bin2bnzb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62evpzd2getzd2hashesz62zz__ssl_sslz00(obj_t);
BGL_IMPORT obj_t bstring_to_symbol(obj_t);
static obj_t BGl_z62sslzd2verifyzd2updatez12z70zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2writez62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32181ze3ze1zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DECL obj_t bgl_make_certificate(void *);
static obj_t BGl_z62securezd2contextzd2setzd2ciphersz12za2zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2randzd2pseudozd2byteszd2zz__ssl_sslz00(int);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
extern obj_t bgl_ssl_hmac_digest(BgL_sslzd2hmaczd2_bglt);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2getzd2sessionzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62sslzd2signzd2sign1334z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62securezd2contextzd2initz62zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_dhzd2checkzd2pubzd2keyzd2zz__ssl_sslz00(BgL_dhz00_bglt, obj_t);
static obj_t BGl_z62securezd2contextzd2loadzd21260zb0zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__ssl_sslz00();
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2writez00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt, obj_t, long, long);
static obj_t BGl_z62zc3anonymousza32167ze3ze1zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL int BGl_sslzd2opzd2cipherzd2serverzd2preferencez00zz__ssl_sslz00();
static obj_t BGl_z62sslzd2connectionzd2clearzd2pendingzb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2opzd2cipherzd2serverzd2preferencez62zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DECL bool_t BGl_securezd2contextzd2addzd2cazd2certz12z12zz__ssl_sslz00(BgL_securezd2contextzd2_bglt, obj_t, long, long);
static obj_t BGl_z62sslzd2cipherzd2updatez121346z70zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2enczd2pendingzb0zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_bnzd2bin2bnzd2zz__ssl_sslz00(obj_t);
BGL_IMPORT obj_t make_string(long, unsigned char);
BGL_EXPORTED_DECL bool_t BGl_sslzd2socketzf3z21zz__ssl_sslz00(obj_t);
static obj_t BGl_z62securezd2contextzd2close1240z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32096ze3ze1zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_makezd2sslzd2serverzd2socketzd2zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DECL BgL_privatezd2keyzd2_bglt BGl_readzd2privatezd2keyz00zz__ssl_sslz00(obj_t);
static obj_t BGl_z62sslzd2randzd2pseudozd2byteszb0zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2cipherzd2updatez12z12zz__ssl_sslz00(BgL_sslzd2cipherzd2_bglt, obj_t, long, long);
static obj_t BGl__makezd2sslzd2clientzd2socketzd2zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_make_private_key(void *);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
extern long bgl_ssl_connection_clear_in(BgL_sslzd2connectionzd2_bglt, char *, long, long);
extern bool_t bgl_load_pkcs12(BgL_securezd2contextzd2_bglt, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2shutdownz00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62sslzd2verifyzd2initz62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62bnzd2bn2binzb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2hashzd2updatez121320z70zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t bgl_ssl_load_pem(obj_t);
static obj_t BGl_z62sslzd2signzd2updatez12z70zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2102z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda2103z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2hmaczd2updatez12z70zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31904ze3ze1zz__ssl_sslz00(obj_t);
static obj_t BGl_z62certificatezd2issuerzb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda2108z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda2109z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL bool_t BGl_sslzd2cipherzd2setzd2autozd2paddingz00zz__ssl_sslz00(BgL_sslzd2cipherzd2_bglt, bool_t);
static obj_t BGl_z62sslzd2cipherzd2initivz62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern void bgl_dh_pqg_set(void *, void *, void *, void *);
static obj_t BGl_z62bnzd2freezb0zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_dhzd2computezd2keyz00zz__ssl_sslz00(BgL_dhz00_bglt, obj_t);
static obj_t BGl_z62dhzd2checkzd2pubzd2key1312zb0zz__ssl_sslz00(obj_t, obj_t, obj_t);
static BgL_sslzd2hmaczd2_bglt BGl_z62lambda2115z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static BgL_sslzd2hmaczd2_bglt BGl_z62lambda2117z62zz__ssl_sslz00(obj_t);
static obj_t BGl_z62pkcs5zd2pbkdf2zd2hmaczd2sha1zb0zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern bool_t bgl_ssl_sign_init(BgL_sslzd2signzd2_bglt, obj_t);
extern bool_t bgl_ssl_hash_update(BgL_sslzd2hashzd2_bglt, obj_t, long, long);
static obj_t BGl_z62sslzd2hmaczd2updatez121326z70zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t bgl_ssl_get_ciphers();
BGL_EXPORTED_DECL int BGl_bnzd2numzd2bytesz00zz__ssl_sslz00(obj_t);
static obj_t BGl_z62lambda2124z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda2125z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31833ze3ze1zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_securezd2contextzd2initz00zz__ssl_sslz00(BgL_securezd2contextzd2_bglt);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2clearzd2outzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt, obj_t, long, long);
static obj_t BGl_z62lambda2131z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda2132z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62securezd2contextzd2setzd2c1256zb0zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_sslzd2signzd2_bglt BGl_z62lambda2139z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_bnzd2bn2binzd2zz__ssl_sslz00(obj_t);
extern int bgl_ssl_connection_set_session(BgL_sslzd2connectionzd2_bglt, obj_t);
static obj_t BGl_z62securezd2contextzd2setzd2s1258zb0zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_sslzd2signzd2_bglt BGl_z62lambda2141z62zz__ssl_sslz00(obj_t);
static obj_t BGl_z62securezd2contextzd2setzd2c1262zb0zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31819ze3ze1zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda2148z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda2149z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2cipherzd2initz62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2start1268z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62dhzd2siza7e1306z17zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32000ze3ze1zz__ssl_sslz00(obj_t, obj_t, obj_t);
extern obj_t bgl_ssl_connection_get_peer_certificate(BgL_sslzd2connectionzd2_bglt);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2getzd2negotiatedzd2protocolz00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62sslzd2socketzf3z43zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62dhzd2generatezd2paramete1308z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2getzd2p1298zb0zz__ssl_sslz00(obj_t, obj_t);
extern int bgl_ssl_connection_load_session(BgL_sslzd2connectionzd2_bglt, obj_t);
BGL_IMPORT obj_t BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31925ze3ze1zz__ssl_sslz00(obj_t);
static obj_t BGl_z62lambda2155z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda2156z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
extern bool_t bgl_ssl_ctx_add_root_certs(BgL_securezd2contextzd2_bglt);
static obj_t BGl_z62evpzd2getzd2ciphersz62zz__ssl_sslz00(obj_t);
BGL_IMPORT bool_t BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__ssl_sslz00();
static obj_t BGl_z62securezd2contextzd2setzd2optionsz12za2zz__ssl_sslz00(obj_t, obj_t, obj_t);
static BgL_sslzd2verifyzd2_bglt BGl_z62lambda2163z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static BgL_sslzd2verifyzd2_bglt BGl_z62lambda2165z62zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2hmaczd2initz00zz__ssl_sslz00(BgL_sslzd2hmaczd2_bglt, obj_t, obj_t);
static obj_t BGl_z62securezd2contextzd2addzd2crlz12za2zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2verifyzd2updatez12z12zz__ssl_sslz00(BgL_sslzd2verifyzd2_bglt, obj_t, long, long);
static obj_t BGl_z62lambda2172z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31943ze3ze1zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda2173z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2179z62zz__ssl_sslz00(obj_t, obj_t);
extern obj_t bgl_ssl_connection_get_current_cipher(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62sslzd2connectionzd2clear1278z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62makezd2sslzd2serverzd2socketzb0zz__ssl_sslz00(obj_t, obj_t);
extern void * bgl_bn_bin2bn(char *, int);
extern char * bgl_ssl_version();
static obj_t BGl_z62sslzd2cipherzd2initiv1344z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern long bgl_ssl_connection_clear_out(BgL_sslzd2connectionzd2_bglt, char *, long, long);
static obj_t BGl_z62lambda2180z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2clear1280z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31871ze3ze1zz__ssl_sslz00(obj_t);
static BgL_sslzd2cipherzd2_bglt BGl_z62lambda2187z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2clear1286z62zz__ssl_sslz00(obj_t, obj_t);
static BgL_sslzd2cipherzd2_bglt BGl_z62lambda2189z62zz__ssl_sslz00(obj_t);
BGL_IMPORT obj_t void_star_to_obj(void *);
static obj_t BGl_z62zc3anonymousza32004ze3ze1zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2cipherzd2finalz62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda2196z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda2197z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL bool_t BGl_sslzd2connectionzd2reusedzf3zf3zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62zc3anonymousza32005ze3ze1zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2hmaczd2digestz00zz__ssl_sslz00(BgL_sslzd2hmaczd2_bglt);
static obj_t BGl_z62certificatezd2subjectzb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1800z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
extern obj_t bgl_ssl_connection_get_session(BgL_sslzd2connectionzd2_bglt);
BGL_IMPORT obj_t blit_string(obj_t, long, obj_t, long, long);
static obj_t BGl_z62zc3anonymousza31890ze3ze1zz__ssl_sslz00(obj_t);
static obj_t BGl_z62lambda1806z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1807z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2hashzd2initz62zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL bool_t BGl_securezd2contextzd2setzd2sessionzd2idzd2contextz12zc0zz__ssl_sslz00(BgL_securezd2contextzd2_bglt, obj_t, long, long);
extern int bgl_ssl_connection_start(BgL_sslzd2connectionzd2_bglt);
static BgL_sslzd2connectionzd2_bglt BGl_z62lambda1814z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31964ze3ze1zz__ssl_sslz00(obj_t);
static BgL_sslzd2connectionzd2_bglt BGl_z62lambda1817z62zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_sslzd2hashzd2zz__ssl_sslz00 = BUNSPEC;
static obj_t BGl_z62sslzd2connectionzd2enczd2p1284zb0zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL bool_t BGl_securezd2contextzd2setzd2certz12zc0zz__ssl_sslz00(BgL_securezd2contextzd2_bglt, obj_t, long, long);
extern bool_t bgl_ssl_verify_final(BgL_sslzd2verifyzd2_bglt, obj_t, long, long, obj_t, long, long);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2clearzd2pendingzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62lambda1824z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1825z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31787ze3ze1zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_certificatezd2issuerzd2zz__ssl_sslz00(BgL_certificatez00_bglt);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2loadzd2sessionzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt, obj_t);
static obj_t BGl_z62zc3anonymousza32009ze3ze1zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1831z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1832z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1838z62zz__ssl_sslz00(obj_t, obj_t);
extern bool_t bgl_ssl_verify_init(BgL_sslzd2verifyzd2_bglt, obj_t);
static obj_t BGl_z62lambda1839z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2randzd2bytesz00zz__ssl_sslz00(int);
static obj_t BGl_z62lambda1845z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1846z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL bool_t BGl_dhzd2generatezd2keyz00zz__ssl_sslz00(BgL_dhz00_bglt);
static obj_t BGl_z62sslzd2connectionzd2shutdownz62zz__ssl_sslz00(obj_t, obj_t);
extern bool_t bgl_ssl_cipher_initiv(BgL_sslzd2cipherzd2_bglt, obj_t, obj_t, long, long, obj_t, long, long, bool_t);
extern obj_t bgl_ssl_ctx_init(BgL_securezd2contextzd2_bglt);
static obj_t BGl_z62securezd2contextzd2closez62zz__ssl_sslz00(obj_t, obj_t);
extern obj_t bgl_ssl_load_private_key(obj_t);
static obj_t BGl_z62bnzd2numzd2bytesz62zz__ssl_sslz00(obj_t, obj_t);
extern obj_t bgl_dh_check_pub_key(void *, void *);
BGL_EXPORTED_DECL bool_t BGl_sslzd2randzd2pollz00zz__ssl_sslz00();
static obj_t BGl_z62sslzd2connectionzd2reuse1300z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2cipherzd2init1342z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32043ze3ze1zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32205ze3ze1zz__ssl_sslz00(obj_t);
static obj_t BGl_z62securezd2contextzd2loadzd2pkcs12zb0zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2signzd2signz00zz__ssl_sslz00(BgL_sslzd2signzd2_bglt, obj_t, long, long);
static obj_t BGl_z62dhzd2generatezd2parameterszd2exzb0zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t);
static BgL_securezd2contextzd2_bglt BGl_z62lambda1851z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1852z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
extern int bgl_ssl_connection_close(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62lambda1856z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1857z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_bnzd2freezd2zz__ssl_sslz00(obj_t);
static obj_t BGl_z62sslzd2connectionzd2getzd2c1292zb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32133ze3ze1zz__ssl_sslz00(obj_t);
static obj_t BGl_z62sslzd2connectionzd2getzd2s1290zb0zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL bool_t BGl_securezd2contextzd2setzd2ciphersz12zc0zz__ssl_sslz00(BgL_securezd2contextzd2_bglt, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__ssl_sslz00 = BUNSPEC;
static obj_t BGl_z62lambda1862z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1863z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31985ze3ze1zz__ssl_sslz00(obj_t);
static obj_t BGl_z62sslzd2cipherzd2setzd2autozd21348z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_securezd2contextzd2closez00zz__ssl_sslz00(BgL_securezd2contextzd2_bglt);
static obj_t BGl_z62lambda1869z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32150ze3ze1zz__ssl_sslz00(obj_t);
static obj_t BGl_z62zc3anonymousza32061ze3ze1zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32029ze3ze1zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_sslzd2signzd2zz__ssl_sslz00 = BUNSPEC;
extern bool_t bgl_ssl_ctx_set_cert(BgL_securezd2contextzd2_bglt, obj_t, long, long);
static obj_t BGl_z62sslzd2hashzd2digestz62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1870z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_sslzd2hmaczd2zz__ssl_sslz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2hashzd2updatez12z70zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2getzd2ciphersz00zz__ssl_sslz00();
static obj_t BGl_z62lambda1875z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31897ze3ze1zz__ssl_sslz00(obj_t);
static obj_t BGl_z62lambda1876z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_certificatezd2subjectzd2zz__ssl_sslz00(BgL_certificatez00_bglt);
static obj_t BGl_z62zc3anonymousza32119ze3ze1zz__ssl_sslz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1881z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1882z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1888z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1889z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
extern bool_t bgl_ssl_cipher_init(BgL_sslzd2cipherzd2_bglt, obj_t, obj_t, long, long, bool_t);
static obj_t BGl_z62sslzd2connectionzd2reusedzf3z91zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__ssl_sslz00();
static obj_t BGl_z62sslzd2connectionzd2verifyzd2errorzb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32047ze3ze1zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62dhzd2initzb0zz__ssl_sslz00(obj_t, obj_t);
extern obj_t bgl_evp_get_ciphers();
BGL_EXPORTED_DECL obj_t BGl_sslzd2cipherzd2initivz00zz__ssl_sslz00(BgL_sslzd2cipherzd2_bglt, obj_t, obj_t, long, long, obj_t, long, long, bool_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2clearzd2errorz00zz__ssl_sslz00();
static obj_t BGl_z62sslzd2signzd2init1330z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1895z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2setzd2sessionzb0zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1896z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2write1276z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31989ze3ze1zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__ssl_sslz00();
static obj_t BGl_z62sslzd2connectionzd2getzd2n1302zb0zz__ssl_sslz00(obj_t, obj_t);
extern bool_t bgl_ssl_ctx_add_crl(BgL_securezd2contextzd2_bglt, obj_t, long, long);
static obj_t BGl_z62sslzd2connectionzd2init1266z62zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL char * BGl_sslzd2versionzd2zz__ssl_sslz00();
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
extern void * bgl_dh_public_key(void *);
static obj_t BGl_z62securezd2contextzd2addzd2rootzd2certsz12z70zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2initz62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2readz62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL bool_t BGl_securezd2contextzd2setzd2keyz12zc0zz__ssl_sslz00(BgL_securezd2contextzd2_bglt, obj_t, long, long, obj_t);
BGL_EXPORTED_DECL obj_t BGl_readzd2pemzd2filez00zz__ssl_sslz00(obj_t);
static obj_t BGl_z62sslzd2randzd2statusz62zz__ssl_sslz00(obj_t);
static obj_t BGl_z62sslzd2connectionzd2initzd2finishedzf3z43zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2clearzd2outzb0zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern void * bgl_dh_private_key(void *);
static obj_t BGl_z62zc3anonymousza32157ze3ze1zz__ssl_sslz00(obj_t);
static obj_t BGl_z62dhzd2siza7ez17zz__ssl_sslz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2signzd2updatez12z12zz__ssl_sslz00(BgL_sslzd2signzd2_bglt, obj_t, long, long);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2enczd2pendingzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
BGL_EXPORTED_DECL obj_t BGl_sslzd2hmaczd2updatez12z12zz__ssl_sslz00(BgL_sslzd2hmaczd2_bglt, obj_t, long, long);
static obj_t BGl_z62zc3anonymousza31801ze3ze1zz__ssl_sslz00(obj_t);
static obj_t BGl_z62zc3anonymousza32174ze3ze1zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DECL bool_t BGl_bnzd2setzd2wordz00zz__ssl_sslz00(obj_t, int);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
extern obj_t bgl_dh_check(void *);
static obj_t BGl_z62sslzd2hmaczd2initz62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t);
extern bool_t bgl_ssl_hash_init(BgL_sslzd2hashzd2_bglt);
static obj_t BGl_z62zc3anonymousza32191ze3ze1zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62dhzd2computezd2keyz62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2hmaczd2init1324z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62bnzd2newzb0zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DECL bool_t BGl_securezd2contextzd2addzd2rootzd2certsz12z12zz__ssl_sslz00(BgL_securezd2contextzd2_bglt);
extern obj_t bgl_ssl_certificate_issuer(obj_t);
static obj_t BGl_z62sslzd2connectionzd2getzd2sessionzb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2hmaczd2digest1328z62zz__ssl_sslz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_dssslzd2getzd2keyzd2restzd2argz00zz__dssslz00(obj_t, obj_t);
extern void bgl_dh_pub_priv_key_set(void *, void *, void *);
static obj_t BGl_z62sslzd2connectionzd2startz62zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2getzd2peerzd2certificatez00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62sslzd2versionzb0zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DECL bool_t BGl_securezd2contextzd2setzd2optionsz12zc0zz__ssl_sslz00(BgL_securezd2contextzd2_bglt, int);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2initz00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62sslzd2verifyzd2finalz62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2signzd2initz00zz__ssl_sslz00(BgL_sslzd2signzd2_bglt, obj_t);
static BgL_certificatez00_bglt BGl_z62readzd2certificatezb0zz__ssl_sslz00(obj_t, obj_t);
extern obj_t bgl_ssl_connection_get_negotiated_protocol(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62zc3anonymousza32089ze3ze1zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2readz00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt, obj_t, long, long);
extern obj_t bgl_ssl_connection_shutdown(BgL_sslzd2connectionzd2_bglt);
BGL_EXPORTED_DECL obj_t BGl_evpzd2getzd2hashesz00zz__ssl_sslz00();
BGL_EXPORTED_DECL int BGl_sslzd2connectionzd2startz00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62securezd2contextzd2init1238z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31911ze3ze1zz__ssl_sslz00(obj_t);
extern obj_t bgl_cipher_update(BgL_sslzd2cipherzd2_bglt, obj_t, long, long);
BGL_EXPORTED_DEF obj_t BGl_sslzd2verifyzd2zz__ssl_sslz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_callzd2virtualzd2setterz00zz__objectz00(BgL_objectz00_bglt, int, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2verifyzd2initz00zz__ssl_sslz00(BgL_sslzd2verifyzd2_bglt, obj_t);
BGL_IMPORT bool_t BGl_pairzd2orzd2nullzf3zf3zz__r4_pairs_and_lists_6_3z00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2clearzd2inzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt, obj_t, long, long);
static obj_t BGl_z62dhzd2checkzd2pubzd2keyzb0zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static obj_t BGl_z62zc3anonymousza31840ze3ze1zz__ssl_sslz00(obj_t);
static obj_t BGl_z62zc3anonymousza31808ze3ze1zz__ssl_sslz00(obj_t);
static obj_t BGl_z62z52privatezd2keyzd2z42nativez72zz__ssl_sslz00(obj_t, obj_t);
extern obj_t bgl_ssl_hash_digest(BgL_sslzd2hashzd2_bglt);
extern obj_t bgl_ssl_connection_init(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62sslzd2connectionzd2closez62zz__ssl_sslz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_applyz00zz__r4_control_features_6_9z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2203z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda2204z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_clientzd2socketzd2usezd2sslz12zc0zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2signzd2updatez121332z70zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32198ze3ze1zz__ssl_sslz00(obj_t);
static obj_t BGl_z62bnzd2setzd2wordz62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__ssl_sslz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__socketz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
static obj_t BGl_z62securezd2contextzd2setzd2k1248zb0zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_callzd2virtualzd2getterz00zz__objectz00(BgL_objectz00_bglt, int);
BGL_EXPORTED_DECL void * bgl_private_key_native(obj_t);
extern obj_t bgl_ssl_connection_verify_error(BgL_sslzd2connectionzd2_bglt);
BGL_EXPORTED_DECL obj_t BGl_sslzd2cipherzd2finalz00zz__ssl_sslz00(BgL_sslzd2cipherzd2_bglt);
BGL_EXPORTED_DECL int BGl_sslzd2connectionzd2closez00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62securezd2contextzd2setzd2certz12za2zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31826ze3ze1zz__ssl_sslz00(obj_t);
static obj_t BGl_z62dhzd2init1304zb0zz__ssl_sslz00(obj_t, obj_t);
static BgL_privatezd2keyzd2_bglt BGl_z62readzd2privatezd2keyz62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62securezd2contextzd2addzd2cazd2certz12z70zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62dhzd2check1310zb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2randzd2pollz62zz__ssl_sslz00(obj_t);
BGL_IMPORT obj_t BGl_z52socketzd2initz12z92zz__socketz00();
static obj_t BGl_z62zc3anonymousza31932ze3ze1zz__ssl_sslz00(obj_t);
static obj_t BGl_z62zc3anonymousza31681ze3ze1zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2signzd2signz62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t bgl_ssl_load_certificate(obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2cipherzd2initz00zz__ssl_sslz00(BgL_sslzd2cipherzd2_bglt, obj_t, obj_t, long, long, bool_t);
static obj_t BGl_sslzd2protocolszd2ze3integerze3zz__ssl_sslz00(obj_t);
extern obj_t bgl_ssl_certificate_subject(obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2initzd2finishedzf3z21zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
extern obj_t bgl_client_socket_use_ssl(obj_t, int, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31771ze3ze1zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_evpzd2getzd2ciphersz00zz__ssl_sslz00();
extern bool_t bgl_ssl_ctx_set_session_id_context(BgL_securezd2contextzd2_bglt, obj_t, long, long);
static obj_t BGl_cnstzd2initzd2zz__ssl_sslz00();
static obj_t BGl_z62z52makezd2certificateze2zz__ssl_sslz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_getzd2portzd2bufferz00zz__r4_ports_6_10_1z00(obj_t, obj_t, int);
static obj_t BGl_libraryzd2moduleszd2initz00zz__ssl_sslz00();
extern long bgl_ssl_connection_read(BgL_sslzd2connectionzd2_bglt, char *, long, long);
static obj_t BGl_search1212ze70ze7zz__ssl_sslz00(long, obj_t, obj_t, long);
static obj_t BGl_z62zc3anonymousza31950ze3ze1zz__ssl_sslz00(obj_t);
static BgL_sslzd2hashzd2_bglt BGl_z62lambda2084z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31756ze3ze1zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31918ze3ze1zz__ssl_sslz00(obj_t);
static BgL_sslzd2hashzd2_bglt BGl_z62lambda2087z62zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_sslzd2cipherzd2zz__ssl_sslz00 = BUNSPEC;
static obj_t BGl_z62securezd2contextzd2addzd2r1242zb0zz__ssl_sslz00(obj_t, obj_t);
extern obj_t bgl_ssl_ctx_close(BgL_securezd2contextzd2_bglt);
static obj_t BGl_z62zc3anonymousza32010ze3ze1zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2094z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda2095z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_objectz00zz__objectz00;
static obj_t BGl_z62dhzd2computezd2key1314z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2loadzd21294zb0zz__ssl_sslz00(obj_t, obj_t, obj_t);
extern obj_t bgl_evp_get_hashes();
static obj_t BGl__securezd2contextzd2setzd2keyz12zc0zz__ssl_sslz00(obj_t, obj_t);
extern bool_t bgl_ssl_verify_update(BgL_sslzd2verifyzd2_bglt, obj_t, long, long);
extern bool_t bgl_ssl_connection_init_finishedp(BgL_sslzd2connectionzd2_bglt);
extern long bgl_ssl_connection_write(BgL_sslzd2connectionzd2_bglt, char *, long, long);
static obj_t BGl_z62sslzd2connectionzd2initzd21282zb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31847ze3ze1zz__ssl_sslz00(obj_t);
static obj_t BGl_z62sslzd2cipherzd2setzd2autozd2paddingz62zz__ssl_sslz00(obj_t, obj_t, obj_t);
extern obj_t bgl_make_ssl_client_socket(obj_t, int, int, int, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL int BGl_dhzd2siza7ez75zz__ssl_sslz00(BgL_dhz00_bglt);
static obj_t BGl_z62zc3anonymousza31864ze3ze1zz__ssl_sslz00(obj_t);
static obj_t BGl_z62sslzd2verifyzd2final1340z62zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_securezd2contextzd2zz__ssl_sslz00 = BUNSPEC;
static obj_t BGl_z62sslzd2randzd2bytesz62zz__ssl_sslz00(obj_t, obj_t);
extern bool_t bgl_ssl_hmac_init(BgL_sslzd2hmaczd2_bglt, obj_t, obj_t);
static obj_t BGl_z62sslzd2connectionzd2close1270z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62securezd2contextzd2addzd2c1244zb0zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62securezd2contextzd2addzd2c1246zb0zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT long default_io_bufsiz;
extern int bgl_ssl_connection_clear_pending(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62z52makezd2privatezd2keyz30zz__ssl_sslz00(obj_t, obj_t);
extern int bgl_ssl_connection_enc_pending(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62sslzd2hmaczd2digestz62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31971ze3ze1zz__ssl_sslz00(obj_t);
static obj_t BGl_z62sslzd2verifyzd2updatez121338z70zz__ssl_sslz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62dhzd2checkzb0zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62readzd2pemzd2filez62zz__ssl_sslz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mapz00zz__r4_control_features_6_9z00(obj_t, obj_t);
static obj_t BGl_z62z52certificatezd2z42nativeza0zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2verifyzd2errorzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62zc3anonymousza32104ze3ze1zz__ssl_sslz00(obj_t);
static obj_t BGl_z62zc3anonymousza32015ze3ze1zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_dhz00zz__ssl_sslz00 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_sslzd2hashzd2updatez12z12zz__ssl_sslz00(BgL_sslzd2hashzd2_bglt, obj_t, long, long);
BGL_EXPORTED_DECL obj_t BGl_sslzd2connectionzd2getzd2currentzd2cipherz00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt);
static obj_t BGl_z62zc3anonymousza31883ze3ze1zz__ssl_sslz00(obj_t);
static obj_t BGl_z62zc3anonymousza31794ze3ze1zz__ssl_sslz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_makezd2sslzd2clientzd2socketzd2zz__ssl_sslz00(obj_t, int, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern void * bgl_dh_g(void *);
extern void * bgl_dh_p(void *);
extern void * bgl_dh_p(void *);
static obj_t BGl_z62lambda1902z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1903z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31957ze3ze1zz__ssl_sslz00(obj_t);
static obj_t BGl_z62lambda1909z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62sslzd2cipherzd2final1350z62zz__ssl_sslz00(obj_t, obj_t);
BGL_EXPORTED_DECL void * bgl_certificate_native(obj_t);
BGL_EXPORTED_DECL bool_t BGl_securezd2contextzd2loadzd2pkcs12zd2zz__ssl_sslz00(BgL_securezd2contextzd2_bglt, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza32033ze3ze1zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1910z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static BgL_certificatez00_bglt BGl_z62lambda1752z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31990ze3ze1zz__ssl_sslz00(obj_t, obj_t, obj_t);
static BgL_certificatez00_bglt BGl_z62lambda1754z62zz__ssl_sslz00(obj_t);
static obj_t BGl_z62lambda1916z62zz__ssl_sslz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_stringzd2downcasezd2zz__r4_strings_6_7z00(obj_t);
static obj_t BGl_z62lambda1917z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
extern bool_t bgl_ssl_sign_update(BgL_sslzd2signzd2_bglt, obj_t, long, long);
extern bool_t bgl_ssl_socketp(obj_t);
extern bool_t bgl_ssl_hmac_update(BgL_sslzd2hmaczd2_bglt, obj_t, long, long);
static obj_t BGl_z62sslzd2connectionzd2getzd2negotiatedzd2protocolz62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1760z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1761z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1923z62zz__ssl_sslz00(obj_t, obj_t);
static obj_t BGl_z62lambda1924z62zz__ssl_sslz00(obj_t, obj_t, obj_t);
static obj_t __cnst[ 90 ] ;


DEFINE_EXPORT_BGL_GENERIC( BGl_dhzd2checkzd2envz00zz__ssl_sslz00, BgL_bgl_za762dhza7d2checkza7b03800za7, BGl_z62dhzd2checkzb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_listzd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_certificatezd2subjectzd2envz00zz__ssl_sslz00, BgL_bgl_za762certificateza7d3801z00, BGl_z62certificatezd2subjectzb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sslzd2opzd2cipherzd2serverzd2preferencezd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2opza7d2ci3802za7, BGl_z62sslzd2opzd2cipherzd2serverzd2preferencez62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
BGL_IMPORT obj_t BGl_stringzd2appendzd2envz00zz__r4_strings_6_7z00;
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2reusedzf3zd2envz21zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3803z00, BGl_z62sslzd2connectionzd2reusedzf3z91zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2setzd2sessionzd2envz00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3804z00, BGl_z62sslzd2connectionzd2setzd2sessionzb0zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2writezd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3805z00, BGl_z62sslzd2connectionzd2writez62zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3404z00zz__ssl_sslz00, BgL_bgl_string3404za700za7za7_3806za7, "Invalid certificate", 19 );
DEFINE_STRING( BGl_string3405z00zz__ssl_sslz00, BgL_bgl_string3405za700za7za7_3807za7, "Invalid private key", 19 );
DEFINE_STATIC_BGL_GENERIC( BGl_dhzd2initzd2envz00zz__ssl_sslz00, BgL_bgl_za762dhza7d2initza7b0za73808z00, BGl_z62dhzd2initzb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3406z00zz__ssl_sslz00, BgL_bgl_string3406za700za7za7_3809za7, "Invalid CA list", 15 );
DEFINE_STRING( BGl_string3407z00zz__ssl_sslz00, BgL_bgl_string3407za700za7za7_3810za7, "Invalid accepted-certs", 22 );
DEFINE_EXPORT_BGL_GENERIC( BGl_securezd2contextzd2addzd2rootzd2certsz12zd2envzc0zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont3811z00, BGl_z62securezd2contextzd2addzd2rootzd2certsz12z70zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3408z00zz__ssl_sslz00, BgL_bgl_string3408za700za7za7_3812za7, "pkey and cert must be both #f or both set", 41 );
DEFINE_STRING( BGl_string3409z00zz__ssl_sslz00, BgL_bgl_string3409za700za7za7_3813za7, "Illegal keyword argument", 24 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sslzd2socketzf3zd2envzf3zz__ssl_sslz00, BgL_bgl_za762sslza7d2socketza73814za7, BGl_z62sslzd2socketzf3z43zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3410z00zz__ssl_sslz00, BgL_bgl_string3410za700za7za7_3815za7, "/builddir/build/BUILD/bigloo4.3f/api/ssl/src/Llib/ssl.scm", 57 );
DEFINE_STRING( BGl_string3411z00zz__ssl_sslz00, BgL_bgl_string3411za700za7za7_3816za7, "_make-ssl-client-socket", 23 );
DEFINE_STRING( BGl_string3412z00zz__ssl_sslz00, BgL_bgl_string3412za700za7za7_3817za7, "bint", 4 );
DEFINE_STRING( BGl_string3413z00zz__ssl_sslz00, BgL_bgl_string3413za700za7za7_3818za7, "bstring", 7 );
DEFINE_STRING( BGl_string3414z00zz__ssl_sslz00, BgL_bgl_string3414za700za7za7_3819za7, "pair-nil", 8 );
DEFINE_STRING( BGl_string3415z00zz__ssl_sslz00, BgL_bgl_string3415za700za7za7_3820za7, "wrong number of arguments: [2..10] expected, provided", 53 );
DEFINE_STRING( BGl_string3416z00zz__ssl_sslz00, BgL_bgl_string3416za700za7za7_3821za7, "_client-socket-use-ssl!", 23 );
DEFINE_STRING( BGl_string3417z00zz__ssl_sslz00, BgL_bgl_string3417za700za7za7_3822za7, "socket", 6 );
DEFINE_STRING( BGl_string3418z00zz__ssl_sslz00, BgL_bgl_string3418za700za7za7_3823za7, "wrong number of arguments: [1..6] expected, provided", 52 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_makezd2sslzd2serverzd2socketzd2envz00zz__ssl_sslz00, BgL_bgl_za762makeza7d2sslza7d23824za7, va_generic_entry, BGl_z62makezd2sslzd2serverzd2socketzb0zz__ssl_sslz00, BUNSPEC, -1 );
DEFINE_STRING( BGl_string3420z00zz__ssl_sslz00, BgL_bgl_string3420za700za7za7_3825za7, "Illegal extra key arguments: ", 29 );
DEFINE_STRING( BGl_string3421z00zz__ssl_sslz00, BgL_bgl_string3421za700za7za7_3826za7, "dsssl-get-key-arg", 17 );
DEFINE_STRING( BGl_string3422z00zz__ssl_sslz00, BgL_bgl_string3422za700za7za7_3827za7, "~a ", 3 );
DEFINE_STRING( BGl_string3423z00zz__ssl_sslz00, BgL_bgl_string3423za700za7za7_3828za7, "ssl", 3 );
DEFINE_STRING( BGl_string3424z00zz__ssl_sslz00, BgL_bgl_string3424za700za7za7_3829za7, "Unknown protocols", 17 );
DEFINE_STRING( BGl_string3425z00zz__ssl_sslz00, BgL_bgl_string3425za700za7za7_3830za7, "&read-private-key", 17 );
DEFINE_STRING( BGl_string3426z00zz__ssl_sslz00, BgL_bgl_string3426za700za7za7_3831za7, "&read-certificate", 17 );
DEFINE_STRING( BGl_string3427z00zz__ssl_sslz00, BgL_bgl_string3427za700za7za7_3832za7, "&read-pem-file", 14 );
DEFINE_STRING( BGl_string3428z00zz__ssl_sslz00, BgL_bgl_string3428za700za7za7_3833za7, "&ssl-rand-bytes", 15 );
DEFINE_STRING( BGl_string3429z00zz__ssl_sslz00, BgL_bgl_string3429za700za7za7_3834za7, "&ssl-rand-pseudo-bytes", 22 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2verifyzd2updatez12zd2envzc0zz__ssl_sslz00, BgL_bgl_za762sslza7d2verifyza73835za7, BGl_z62sslzd2verifyzd2updatez12z70zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3500z00zz__ssl_sslz00, BgL_bgl_za762lambda1895za7623836z00, BGl_z62lambda1895z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3501z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73837za7, BGl_z62zc3anonymousza31904ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3502z00zz__ssl_sslz00, BgL_bgl_za762lambda1903za7623838z00, BGl_z62lambda1903z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3503z00zz__ssl_sslz00, BgL_bgl_za762lambda1902za7623839z00, BGl_z62lambda1902z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3504z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73840za7, BGl_z62zc3anonymousza31911ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3505z00zz__ssl_sslz00, BgL_bgl_za762lambda1910za7623841z00, BGl_z62lambda1910z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3430z00zz__ssl_sslz00, BgL_bgl_string3430za700za7za7_3842za7, "&certificate-subject", 20 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3506z00zz__ssl_sslz00, BgL_bgl_za762lambda1909za7623843z00, BGl_z62lambda1909z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3431z00zz__ssl_sslz00, BgL_bgl_string3431za700za7za7_3844za7, "certificate", 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3507z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73845za7, BGl_z62zc3anonymousza31918ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3432z00zz__ssl_sslz00, BgL_bgl_string3432za700za7za7_3846za7, "&certificate-issuer", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3508z00zz__ssl_sslz00, BgL_bgl_za762lambda1917za7623847z00, BGl_z62lambda1917z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3433z00zz__ssl_sslz00, BgL_bgl_string3433za700za7za7_3848za7, "&%make-certificate", 18 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52privatezd2keyzd2z42nativezd2envzc2zz__ssl_sslz00, BgL_bgl_za762za752privateza7d23849za7, BGl_z62z52privatezd2keyzd2z42nativez72zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3509z00zz__ssl_sslz00, BgL_bgl_za762lambda1916za7623850z00, BGl_z62lambda1916z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3434z00zz__ssl_sslz00, BgL_bgl_string3434za700za7za7_3851za7, "void*", 5 );
DEFINE_STRING( BGl_string3435z00zz__ssl_sslz00, BgL_bgl_string3435za700za7za7_3852za7, "&%make-private-key", 18 );
DEFINE_STRING( BGl_string3436z00zz__ssl_sslz00, BgL_bgl_string3436za700za7za7_3853za7, "_secure-context-set-key!", 24 );
DEFINE_STRING( BGl_string3437z00zz__ssl_sslz00, BgL_bgl_string3437za700za7za7_3854za7, "vector", 6 );
DEFINE_STRING( BGl_string3438z00zz__ssl_sslz00, BgL_bgl_string3438za700za7za7_3855za7, "secure-context", 14 );
DEFINE_STRING( BGl_string3439z00zz__ssl_sslz00, BgL_bgl_string3439za700za7za7_3856za7, "&bn-bin2bn", 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3510z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73857za7, BGl_z62zc3anonymousza31925ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3511z00zz__ssl_sslz00, BgL_bgl_za762lambda1924za7623858z00, BGl_z62lambda1924z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3512z00zz__ssl_sslz00, BgL_bgl_za762lambda1923za7623859z00, BGl_z62lambda1923z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3513z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73860za7, BGl_z62zc3anonymousza31932ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3514z00zz__ssl_sslz00, BgL_bgl_za762lambda1931za7623861z00, BGl_z62lambda1931z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3515z00zz__ssl_sslz00, BgL_bgl_za762lambda1930za7623862z00, BGl_z62lambda1930z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3440z00zz__ssl_sslz00, BgL_bgl_string3440za700za7za7_3863za7, "&bn-bn2bin", 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3516z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73864za7, BGl_z62zc3anonymousza31819ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3441z00zz__ssl_sslz00, BgL_bgl_string3441za700za7za7_3865za7, "foreign", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3517z00zz__ssl_sslz00, BgL_bgl_za762lambda1817za7623866z00, BGl_z62lambda1817z62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3442z00zz__ssl_sslz00, BgL_bgl_string3442za700za7za7_3867za7, "&bn-num-bytes", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3518z00zz__ssl_sslz00, BgL_bgl_za762lambda1814za7623868z00, BGl_z62lambda1814z62zz__ssl_sslz00, 0L, BUNSPEC, 17 );
DEFINE_STRING( BGl_string3443z00zz__ssl_sslz00, BgL_bgl_string3443za700za7za7_3869za7, "&bn-free", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3519z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73870za7, BGl_z62zc3anonymousza31950ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3444z00zz__ssl_sslz00, BgL_bgl_string3444za700za7za7_3871za7, "&bn-set-word", 12 );
DEFINE_STRING( BGl_string3607z00zz__ssl_sslz00, BgL_bgl_string3607za700za7za7_3872za7, "", 0 );
DEFINE_STRING( BGl_string3445z00zz__ssl_sslz00, BgL_bgl_string3445za700za7za7_3873za7, "&pkcs5-pbkdf2-hmac-sha1", 23 );
DEFINE_STRING( BGl_string3608z00zz__ssl_sslz00, BgL_bgl_string3608za700za7za7_3874za7, "default", 7 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_bnzd2bin2bnzd2envz00zz__ssl_sslz00, BgL_bgl_za762bnza7d2bin2bnza7b3875za7, BGl_z62bnzd2bin2bnzb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3520z00zz__ssl_sslz00, BgL_bgl_za762lambda1949za7623876z00, BGl_z62lambda1949z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3521z00zz__ssl_sslz00, BgL_bgl_za762lambda1948za7623877z00, BGl_z62lambda1948z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3522z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73878za7, BGl_z62zc3anonymousza31957ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3610z00zz__ssl_sslz00, BgL_bgl_string3610za700za7za7_3879za7, "secure-context-init1238", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3523z00zz__ssl_sslz00, BgL_bgl_za762lambda1956za7623880z00, BGl_z62lambda1956z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3524z00zz__ssl_sslz00, BgL_bgl_za762lambda1955za7623881z00, BGl_z62lambda1955z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3612z00zz__ssl_sslz00, BgL_bgl_string3612za700za7za7_3882za7, "secure-context-close1240", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3525z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73883za7, BGl_z62zc3anonymousza31964ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3526z00zz__ssl_sslz00, BgL_bgl_za762lambda1963za7623884z00, BGl_z62lambda1963z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3614z00zz__ssl_sslz00, BgL_bgl_string3614za700za7za7_3885za7, "secure-context-add-r1242", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3527z00zz__ssl_sslz00, BgL_bgl_za762lambda1962za7623886z00, BGl_z62lambda1962z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3528z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73887za7, BGl_z62zc3anonymousza31971ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3616z00zz__ssl_sslz00, BgL_bgl_string3616za700za7za7_3888za7, "secure-context-add-c1244", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3529z00zz__ssl_sslz00, BgL_bgl_za762lambda1970za7623889z00, BGl_z62lambda1970z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3618z00zz__ssl_sslz00, BgL_bgl_string3618za700za7za7_3890za7, "secure-context-add-c1246", 24 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2signzd2updatez12zd2envzc0zz__ssl_sslz00, BgL_bgl_za762sslza7d2signza7d23891za7, BGl_z62sslzd2signzd2updatez12z70zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3530z00zz__ssl_sslz00, BgL_bgl_za762lambda1969za7623892z00, BGl_z62lambda1969z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3531z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73893za7, BGl_z62zc3anonymousza31978ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3532z00zz__ssl_sslz00, BgL_bgl_za762lambda1977za7623894z00, BGl_z62lambda1977z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3620z00zz__ssl_sslz00, BgL_bgl_string3620za700za7za7_3895za7, "secure-context-set-k1248", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3533z00zz__ssl_sslz00, BgL_bgl_za762lambda1976za7623896z00, BGl_z62lambda1976z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3534z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73897za7, BGl_z62zc3anonymousza31985ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3622z00zz__ssl_sslz00, BgL_bgl_string3622za700za7za7_3898za7, "secure-context-set-c1256", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3535z00zz__ssl_sslz00, BgL_bgl_za762lambda1984za7623899z00, BGl_z62lambda1984z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3536z00zz__ssl_sslz00, BgL_bgl_za762lambda1983za7623900z00, BGl_z62lambda1983z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_clientzd2socketzd2usezd2sslz12zd2envz12zz__ssl_sslz00, BgL_bgl__clientza7d2socket3901za7, opt_generic_entry, BGl__clientzd2socketzd2usezd2sslz12zc0zz__ssl_sslz00, BFALSE, -1 );
DEFINE_STRING( BGl_string3624z00zz__ssl_sslz00, BgL_bgl_string3624za700za7za7_3902za7, "secure-context-set-s1258", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3537z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73903za7, BGl_z62zc3anonymousza31990ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2initzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3904z00, BGl_z62sslzd2connectionzd2initz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3538z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73905za7, BGl_z62zc3anonymousza31989ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3626z00zz__ssl_sslz00, BgL_bgl_string3626za700za7za7_3906za7, "secure-context-load-1260", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3539z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73907za7, BGl_z62zc3anonymousza31995ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3628z00zz__ssl_sslz00, BgL_bgl_string3628za700za7za7_3908za7, "secure-context-set-c1262", 24 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2hmaczd2digestzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2hmacza7d23909za7, BGl_z62sslzd2hmaczd2digestz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3701z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2verifyza73910za7, BGl_z62sslzd2verifyzd2init1336z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3540z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73911za7, BGl_z62zc3anonymousza31994ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3703z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2verifyza73912za7, BGl_z62sslzd2verifyzd2updatez121338z70zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3541z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73913za7, BGl_z62zc3anonymousza32000ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3542z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73914za7, BGl_z62zc3anonymousza31999ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3705z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2verifyza73915za7, BGl_z62sslzd2verifyzd2final1340z62zz__ssl_sslz00, 0L, BUNSPEC, 7 );
DEFINE_STRING( BGl_string3630z00zz__ssl_sslz00, BgL_bgl_string3630za700za7za7_3916za7, "secure-context-set-o1264", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3543z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73917za7, BGl_z62zc3anonymousza32005ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3544z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73918za7, BGl_z62zc3anonymousza32004ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3707z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2cipherza73919za7, BGl_z62sslzd2cipherzd2init1342z62zz__ssl_sslz00, 0L, BUNSPEC, 6 );
DEFINE_STRING( BGl_string3632z00zz__ssl_sslz00, BgL_bgl_string3632za700za7za7_3920za7, "ssl-connection-init1266", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3545z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73921za7, BGl_z62zc3anonymousza32010ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3546z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73922za7, BGl_z62zc3anonymousza32009ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3709z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2cipherza73923za7, BGl_z62sslzd2cipherzd2initiv1344z62zz__ssl_sslz00, 0L, BUNSPEC, 9 );
DEFINE_STRING( BGl_string3634z00zz__ssl_sslz00, BgL_bgl_string3634za700za7za7_3924za7, "ssl-connection-start1268", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3547z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73925za7, BGl_z62zc3anonymousza32015ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3548z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73926za7, BGl_z62zc3anonymousza32019ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3636z00zz__ssl_sslz00, BgL_bgl_string3636za700za7za7_3927za7, "ssl-connection-close1270", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3549z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73928za7, BGl_z62zc3anonymousza32029ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3638z00zz__ssl_sslz00, BgL_bgl_string3638za700za7za7_3929za7, "ssl-connection-shutd1272", 24 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2shutdownzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3930z00, BGl_z62sslzd2connectionzd2shutdownz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3711z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2cipherza73931za7, BGl_z62sslzd2cipherzd2updatez121346z70zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3550z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73932za7, BGl_z62zc3anonymousza32033ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3713z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2cipherza73933za7, BGl_z62sslzd2cipherzd2setzd2autozd21348z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3551z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73934za7, BGl_z62zc3anonymousza32043ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3552z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73935za7, BGl_z62zc3anonymousza32047ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3715z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2cipherza73936za7, BGl_z62sslzd2cipherzd2final1350z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3640z00zz__ssl_sslz00, BgL_bgl_string3640za700za7za7_3937za7, "ssl-connection-read1274", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3553z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73938za7, BGl_z62zc3anonymousza32057ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3554z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73939za7, BGl_z62zc3anonymousza32061ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3642z00zz__ssl_sslz00, BgL_bgl_string3642za700za7za7_3940za7, "ssl-connection-write1276", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3555z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73941za7, BGl_z62zc3anonymousza32070ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3556z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73942za7, BGl_z62zc3anonymousza32074ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3644z00zz__ssl_sslz00, BgL_bgl_string3644za700za7za7_3943za7, "ssl-connection-clear1278", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3557z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73944za7, BGl_z62zc3anonymousza31943ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3558z00zz__ssl_sslz00, BgL_bgl_za762lambda1941za7623945z00, BGl_z62lambda1941z62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3646z00zz__ssl_sslz00, BgL_bgl_string3646za700za7za7_3946za7, "ssl-connection-clear1280", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3559z00zz__ssl_sslz00, BgL_bgl_za762lambda1938za7623947z00, BGl_z62lambda1938z62zz__ssl_sslz00, 0L, BUNSPEC, 6 );
DEFINE_STRING( BGl_string3648z00zz__ssl_sslz00, BgL_bgl_string3648za700za7za7_3948za7, "ssl-connection-init-1282", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3560z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73949za7, BGl_z62zc3anonymousza32096ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3561z00zz__ssl_sslz00, BgL_bgl_za762lambda2095za7623950z00, BGl_z62lambda2095z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3562z00zz__ssl_sslz00, BgL_bgl_za762lambda2094za7623951z00, BGl_z62lambda2094z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3650z00zz__ssl_sslz00, BgL_bgl_string3650za700za7za7_3952za7, "ssl-connection-enc-p1284", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3563z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73953za7, BGl_z62zc3anonymousza32104ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3564z00zz__ssl_sslz00, BgL_bgl_za762lambda2103za7623954z00, BGl_z62lambda2103z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3652z00zz__ssl_sslz00, BgL_bgl_string3652za700za7za7_3955za7, "ssl-connection-clear1286", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3565z00zz__ssl_sslz00, BgL_bgl_za762lambda2102za7623956z00, BGl_z62lambda2102z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3566z00zz__ssl_sslz00, BgL_bgl_za762lambda2109za7623957z00, BGl_z62lambda2109z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3654z00zz__ssl_sslz00, BgL_bgl_string3654za700za7za7_3958za7, "ssl-connection-set-s1288", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3567z00zz__ssl_sslz00, BgL_bgl_za762lambda2108za7623959z00, BGl_z62lambda2108z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3568z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73960za7, BGl_z62zc3anonymousza32089ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3656z00zz__ssl_sslz00, BgL_bgl_string3656za700za7za7_3961za7, "ssl-connection-get-s1290", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3569z00zz__ssl_sslz00, BgL_bgl_za762lambda2087za7623962z00, BGl_z62lambda2087z62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2clearzd2pendingzd2envz00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3963z00, BGl_z62sslzd2connectionzd2clearzd2pendingzb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3658z00zz__ssl_sslz00, BgL_bgl_string3658za700za7za7_3964za7, "ssl-connection-get-c1292", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3570z00zz__ssl_sslz00, BgL_bgl_za762lambda2084za7623965z00, BGl_z62lambda2084z62zz__ssl_sslz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3571z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73966za7, BGl_z62zc3anonymousza32126ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3572z00zz__ssl_sslz00, BgL_bgl_za762lambda2125za7623967z00, BGl_z62lambda2125z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3660z00zz__ssl_sslz00, BgL_bgl_string3660za700za7za7_3968za7, "ssl-connection-load-1294", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3573z00zz__ssl_sslz00, BgL_bgl_za762lambda2124za7623969z00, BGl_z62lambda2124z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3574z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73970za7, BGl_z62zc3anonymousza32133ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2signzd2initzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2signza7d23971za7, BGl_z62sslzd2signzd2initz62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3662z00zz__ssl_sslz00, BgL_bgl_string3662za700za7za7_3972za7, "ssl-connection-verif1296", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3575z00zz__ssl_sslz00, BgL_bgl_za762lambda2132za7623973z00, BGl_z62lambda2132z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_bnzd2setzd2wordzd2envzd2zz__ssl_sslz00, BgL_bgl_za762bnza7d2setza7d2wo3974za7, BGl_z62bnzd2setzd2wordz62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3576z00zz__ssl_sslz00, BgL_bgl_za762lambda2131za7623975z00, BGl_z62lambda2131z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3664z00zz__ssl_sslz00, BgL_bgl_string3664za700za7za7_3976za7, "ssl-connection-get-p1298", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3577z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73977za7, BGl_z62zc3anonymousza32119ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3578z00zz__ssl_sslz00, BgL_bgl_za762lambda2117za7623978z00, BGl_z62lambda2117z62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3666z00zz__ssl_sslz00, BgL_bgl_string3666za700za7za7_3979za7, "ssl-connection-reuse1300", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3579z00zz__ssl_sslz00, BgL_bgl_za762lambda2115za7623980z00, BGl_z62lambda2115z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3668z00zz__ssl_sslz00, BgL_bgl_string3668za700za7za7_3981za7, "ssl-connection-get-n1302", 24 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_evpzd2getzd2hasheszd2envzd2zz__ssl_sslz00, BgL_bgl_za762evpza7d2getza7d2h3982za7, BGl_z62evpzd2getzd2hashesz62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2clearzd2outzd2envz00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect3983z00, BGl_z62sslzd2connectionzd2clearzd2outzb0zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3580z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73984za7, BGl_z62zc3anonymousza32150ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3581z00zz__ssl_sslz00, BgL_bgl_za762lambda2149za7623985z00, BGl_z62lambda2149z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3582z00zz__ssl_sslz00, BgL_bgl_za762lambda2148za7623986z00, BGl_z62lambda2148z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3670z00zz__ssl_sslz00, BgL_bgl_string3670za700za7za7_3987za7, "dh-init1304", 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3583z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73988za7, BGl_z62zc3anonymousza32157ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3584z00zz__ssl_sslz00, BgL_bgl_za762lambda2156za7623989z00, BGl_z62lambda2156z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3672z00zz__ssl_sslz00, BgL_bgl_string3672za700za7za7_3990za7, "dh-size1306", 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3585z00zz__ssl_sslz00, BgL_bgl_za762lambda2155za7623991z00, BGl_z62lambda2155z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3586z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73992za7, BGl_z62zc3anonymousza32143ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3674z00zz__ssl_sslz00, BgL_bgl_string3674za700za7za7_3993za7, "dh-generate-paramete1308", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3587z00zz__ssl_sslz00, BgL_bgl_za762lambda2141za7623994z00, BGl_z62lambda2141z62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3588z00zz__ssl_sslz00, BgL_bgl_za762lambda2139za7623995z00, BGl_z62lambda2139z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3676z00zz__ssl_sslz00, BgL_bgl_string3676za700za7za7_3996za7, "dh-check1310", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3589z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza73997za7, BGl_z62zc3anonymousza32174ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_bnzd2bn2binzd2envz00zz__ssl_sslz00, BgL_bgl_za762bnza7d2bn2binza7b3998za7, BGl_z62bnzd2bn2binzb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3678z00zz__ssl_sslz00, BgL_bgl_string3678za700za7za7_3999za7, "dh-check-pub-key1312", 20 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2verifyzd2finalzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2verifyza74000za7, BGl_z62sslzd2verifyzd2finalz62zz__ssl_sslz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3590z00zz__ssl_sslz00, BgL_bgl_za762lambda2173za7624001z00, BGl_z62lambda2173z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3591z00zz__ssl_sslz00, BgL_bgl_za762lambda2172za7624002z00, BGl_z62lambda2172z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3592z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza74003za7, BGl_z62zc3anonymousza32181ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3680z00zz__ssl_sslz00, BgL_bgl_string3680za700za7za7_4004za7, "dh-compute-key1314", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3593z00zz__ssl_sslz00, BgL_bgl_za762lambda2180za7624005z00, BGl_z62lambda2180z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3594z00zz__ssl_sslz00, BgL_bgl_za762lambda2179za7624006z00, BGl_z62lambda2179z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3682z00zz__ssl_sslz00, BgL_bgl_string3682za700za7za7_4007za7, "dh-generate-key1316", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3595z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza74008za7, BGl_z62zc3anonymousza32167ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3596z00zz__ssl_sslz00, BgL_bgl_za762lambda2165za7624009z00, BGl_z62lambda2165z62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3684z00zz__ssl_sslz00, BgL_bgl_string3684za700za7za7_4010za7, "ssl-hash-init1318", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3597z00zz__ssl_sslz00, BgL_bgl_za762lambda2163za7624011z00, BGl_z62lambda2163z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3598z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza74012za7, BGl_z62zc3anonymousza32198ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3686z00zz__ssl_sslz00, BgL_bgl_string3686za700za7za7_4013za7, "ssl-hash-update!1320", 20 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3599z00zz__ssl_sslz00, BgL_bgl_za762lambda2197za7624014z00, BGl_z62lambda2197z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3688z00zz__ssl_sslz00, BgL_bgl_string3688za700za7za7_4015za7, "ssl-hash-digest1322", 19 );
DEFINE_STRING( BGl_string3690z00zz__ssl_sslz00, BgL_bgl_string3690za700za7za7_4016za7, "ssl-hmac-init1324", 17 );
DEFINE_STRING( BGl_string3692z00zz__ssl_sslz00, BgL_bgl_string3692za700za7za7_4017za7, "ssl-hmac-update!1326", 20 );
DEFINE_STRING( BGl_string3694z00zz__ssl_sslz00, BgL_bgl_string3694za700za7za7_4018za7, "ssl-hmac-digest1328", 19 );
DEFINE_STRING( BGl_string3696z00zz__ssl_sslz00, BgL_bgl_string3696za700za7za7_4019za7, "ssl-sign-init1330", 17 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_readzd2privatezd2keyzd2envzd2zz__ssl_sslz00, BgL_bgl_za762readza7d2privat4020z00, BGl_z62readzd2privatezd2keyz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3698z00zz__ssl_sslz00, BgL_bgl_string3698za700za7za7_4021za7, "ssl-sign-update!1332", 20 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_pkcs5zd2pbkdf2zd2hmaczd2sha1zd2envz00zz__ssl_sslz00, BgL_bgl_za762pkcs5za7d2pbkdf4022z00, BGl_z62pkcs5zd2pbkdf2zd2hmaczd2sha1zb0zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2cipherzd2finalzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2cipherza74023za7, BGl_z62sslzd2cipherzd2finalz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_readzd2certificatezd2envz00zz__ssl_sslz00, BgL_bgl_za762readza7d2certif4024z00, BGl_z62readzd2certificatezb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_makezd2sslzd2clientzd2socketzd2envz00zz__ssl_sslz00, BgL_bgl__makeza7d2sslza7d2cl4025z00, opt_generic_entry, BGl__makezd2sslzd2clientzd2socketzd2zz__ssl_sslz00, BFALSE, -1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2enczd2pendingzd2envz00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4026z00, BGl_z62sslzd2connectionzd2enczd2pendingzb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sslzd2versionzd2envz00zz__ssl_sslz00, BgL_bgl_za762sslza7d2version4027z00, BGl_z62sslzd2versionzb0zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2cipherzd2updatez12zd2envzc0zz__ssl_sslz00, BgL_bgl_za762sslza7d2cipherza74028za7, BGl_z62sslzd2cipherzd2updatez12z70zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2hmaczd2initzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2hmacza7d24029za7, BGl_z62sslzd2hmaczd2initz62zz__ssl_sslz00, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_GENERIC( BGl_securezd2contextzd2initzd2envzd2zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4030z00, BGl_z62securezd2contextzd2initz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2closezd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4031z00, BGl_z62sslzd2connectionzd2closez62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_securezd2contextzd2addzd2cazd2certz12zd2envzc0zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4032z00, BGl_z62securezd2contextzd2addzd2cazd2certz12z70zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52certificatezd2z42nativezd2envz10zz__ssl_sslz00, BgL_bgl_za762za752certificat4033z00, BGl_z62z52certificatezd2z42nativeza0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2getzd2sessionzd2envz00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4034z00, BGl_z62sslzd2connectionzd2getzd2sessionzb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_securezd2contextzd2addzd2crlz12zd2envz12zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4035z00, BGl_z62securezd2contextzd2addzd2crlz12za2zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sslzd2randzd2byteszd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2randza7d24036za7, BGl_z62sslzd2randzd2bytesz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sslzd2randzd2pollzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2randza7d24037za7, BGl_z62sslzd2randzd2pollz62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_GENERIC( BGl_dhzd2generatezd2parameterszd2exzd2envz00zz__ssl_sslz00, BgL_bgl_za762dhza7d2generate4038z00, BGl_z62dhzd2generatezd2parameterszd2exzb0zz__ssl_sslz00, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_GENERIC( BGl_dhzd2computezd2keyzd2envzd2zz__ssl_sslz00, BgL_bgl_za762dhza7d2computeza74039za7, BGl_z62dhzd2computezd2keyz62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_evpzd2getzd2cipherszd2envzd2zz__ssl_sslz00, BgL_bgl_za762evpza7d2getza7d2c4040za7, BGl_z62evpzd2getzd2ciphersz62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2getzd2peerzd2certificatezd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4041z00, BGl_z62sslzd2connectionzd2getzd2peerzd2certificatez62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2hashzd2digestzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2hashza7d24042za7, BGl_z62sslzd2hashzd2digestz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2verifyzd2initzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2verifyza74043za7, BGl_z62sslzd2verifyzd2initz62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2cipherzd2setzd2autozd2paddingzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2cipherza74044za7, BGl_z62sslzd2cipherzd2setzd2autozd2paddingz62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2getzd2negotiatedzd2protocolzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4045z00, BGl_z62sslzd2connectionzd2getzd2negotiatedzd2protocolz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_readzd2pemzd2filezd2envzd2zz__ssl_sslz00, BgL_bgl_za762readza7d2pemza7d24046za7, BGl_z62readzd2pemzd2filez62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_dhzd2generatezd2keyzd2envzd2zz__ssl_sslz00, BgL_bgl_za762dhza7d2generate4047z00, BGl_z62dhzd2generatezd2keyz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_dhzd2siza7ezd2envza7zz__ssl_sslz00, BgL_bgl_za762dhza7d2siza7a7eza714048z00, BGl_z62dhzd2siza7ez17zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_certificatezd2issuerzd2envz00zz__ssl_sslz00, BgL_bgl_za762certificateza7d4049z00, BGl_z62certificatezd2issuerzb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3419z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza74050za7, BGl_z62zc3anonymousza31681ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sslzd2getzd2cipherszd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2getza7d2c4051za7, BGl_z62sslzd2getzd2ciphersz62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_GENERIC( BGl_securezd2contextzd2setzd2keyz12zd2envz12zz__ssl_sslz00, BgL_bgl__secureza7d2contex4052za7, opt_generic_entry, BGl__securezd2contextzd2setzd2keyz12zc0zz__ssl_sslz00, BFALSE, -1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2clearzd2inzd2envz00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4053z00, BGl_z62sslzd2connectionzd2clearzd2inzb0zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2hashzd2updatez12zd2envzc0zz__ssl_sslz00, BgL_bgl_za762sslza7d2hashza7d24054za7, BGl_z62sslzd2hashzd2updatez12z70zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2getzd2currentzd2cipherzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4055z00, BGl_z62sslzd2connectionzd2getzd2currentzd2cipherz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2cipherzd2initivzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2cipherza74056za7, BGl_z62sslzd2cipherzd2initivz62zz__ssl_sslz00, 0L, BUNSPEC, 9 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2initzd2finishedzf3zd2envzf3zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4057z00, BGl_z62sslzd2connectionzd2initzd2finishedzf3z43zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3600z00zz__ssl_sslz00, BgL_bgl_za762lambda2196za7624058z00, BGl_z62lambda2196z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3601z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza74059za7, BGl_z62zc3anonymousza32205ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3602z00zz__ssl_sslz00, BgL_bgl_za762lambda2204za7624060z00, BGl_z62lambda2204z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3603z00zz__ssl_sslz00, BgL_bgl_za762lambda2203za7624061z00, BGl_z62lambda2203z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3604z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza74062za7, BGl_z62zc3anonymousza32191ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3605z00zz__ssl_sslz00, BgL_bgl_za762lambda2189za7624063z00, BGl_z62lambda2189z62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3606z00zz__ssl_sslz00, BgL_bgl_za762lambda2187za7624064z00, BGl_z62lambda2187z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3446z00zz__ssl_sslz00, BgL_bgl_za762lambda1761za7624065z00, BGl_z62lambda1761z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3609z00zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4066z00, BGl_z62securezd2contextzd2init1238z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3447z00zz__ssl_sslz00, BgL_bgl_za762lambda1760za7624067z00, BGl_z62lambda1760z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3448z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza74068za7, BGl_z62zc3anonymousza31756ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3449z00zz__ssl_sslz00, BgL_bgl_za762lambda1754za7624069z00, BGl_z62lambda1754z62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3611z00zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4070z00, BGl_z62securezd2contextzd2close1240z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2hmaczd2updatez12zd2envzc0zz__ssl_sslz00, BgL_bgl_za762sslza7d2hmacza7d24071za7, BGl_z62sslzd2hmaczd2updatez12z70zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3450z00zz__ssl_sslz00, BgL_bgl_za762lambda1752za7624072z00, BGl_z62lambda1752z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3700z00zz__ssl_sslz00, BgL_bgl_string3700za700za7za7_4073za7, "ssl-sign-sign1334", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3613z00zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4074z00, BGl_z62securezd2contextzd2addzd2r1242zb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3451z00zz__ssl_sslz00, BgL_bgl_za762lambda1776za7624075z00, BGl_z62lambda1776z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3452z00zz__ssl_sslz00, BgL_bgl_za762lambda1775za7624076z00, BGl_z62lambda1775z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3702z00zz__ssl_sslz00, BgL_bgl_string3702za700za7za7_4077za7, "ssl-verify-init1336", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3615z00zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4078z00, BGl_z62securezd2contextzd2addzd2c1244zb0zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3453z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza74079za7, BGl_z62zc3anonymousza31771ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3454z00zz__ssl_sslz00, BgL_bgl_za762lambda1769za7624080z00, BGl_z62lambda1769z62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3704z00zz__ssl_sslz00, BgL_bgl_string3704za700za7za7_4081za7, "ssl-verify-update!1338", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3617z00zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4082z00, BGl_z62securezd2contextzd2addzd2c1246zb0zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3455z00zz__ssl_sslz00, BgL_bgl_za762lambda1767za7624083z00, BGl_z62lambda1767z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3456z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza74084za7, BGl_z62zc3anonymousza31794ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3706z00zz__ssl_sslz00, BgL_bgl_string3706za700za7za7_4085za7, "ssl-verify-final1340", 20 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3619z00zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4086z00, BGl_z62securezd2contextzd2setzd2k1248zb0zz__ssl_sslz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3457z00zz__ssl_sslz00, BgL_bgl_za762lambda1793za7624087z00, BGl_z62lambda1793z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3458z00zz__ssl_sslz00, BgL_bgl_za762lambda1792za7624088z00, BGl_z62lambda1792z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3708z00zz__ssl_sslz00, BgL_bgl_string3708za700za7za7_4089za7, "ssl-cipher-init1342", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3459z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza74090za7, BGl_z62zc3anonymousza31801ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2readzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4091z00, BGl_z62sslzd2connectionzd2readz62zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_GENERIC( BGl_dhzd2checkzd2pubzd2keyzd2envz00zz__ssl_sslz00, BgL_bgl_za762dhza7d2checkza7d24092za7, BGl_z62dhzd2checkzd2pubzd2keyzb0zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3621z00zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4093z00, BGl_z62securezd2contextzd2setzd2c1256zb0zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3460z00zz__ssl_sslz00, BgL_bgl_za762lambda1800za7624094z00, BGl_z62lambda1800z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3710z00zz__ssl_sslz00, BgL_bgl_string3710za700za7za7_4095za7, "ssl-cipher-initiv1344", 21 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3623z00zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4096z00, BGl_z62securezd2contextzd2setzd2s1258zb0zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3461z00zz__ssl_sslz00, BgL_bgl_za762lambda1799za7624097z00, BGl_z62lambda1799z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3462z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza74098za7, BGl_z62zc3anonymousza31808ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3712z00zz__ssl_sslz00, BgL_bgl_string3712za700za7za7_4099za7, "ssl-cipher-update!1346", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3625z00zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4100z00, BGl_z62securezd2contextzd2loadzd21260zb0zz__ssl_sslz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3463z00zz__ssl_sslz00, BgL_bgl_za762lambda1807za7624101z00, BGl_z62lambda1807z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3464z00zz__ssl_sslz00, BgL_bgl_za762lambda1806za7624102z00, BGl_z62lambda1806z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3714z00zz__ssl_sslz00, BgL_bgl_string3714za700za7za7_4103za7, "ssl-cipher-set-auto-1348", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3627z00zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4104z00, BGl_z62securezd2contextzd2setzd2c1262zb0zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3465z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza74105za7, BGl_z62zc3anonymousza31787ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3466z00zz__ssl_sslz00, BgL_bgl_za762lambda1785za7624106z00, BGl_z62lambda1785z62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3716z00zz__ssl_sslz00, BgL_bgl_string3716za700za7za7_4107za7, "ssl-cipher-final1350", 20 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3629z00zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4108z00, BGl_z62securezd2contextzd2setzd2o1264zb0zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3467z00zz__ssl_sslz00, BgL_bgl_za762lambda1782za7624109z00, BGl_z62lambda1782z62zz__ssl_sslz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3717z00zz__ssl_sslz00, BgL_bgl_string3717za700za7za7_4110za7, "ssl-cipher-update!", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3468z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza74111za7, BGl_z62zc3anonymousza31826ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3718z00zz__ssl_sslz00, BgL_bgl_string3718za700za7za7_4112za7, "cannot update", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3469z00zz__ssl_sslz00, BgL_bgl_za762lambda1825za7624113z00, BGl_z62lambda1825z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3719z00zz__ssl_sslz00, BgL_bgl_string3719za700za7za7_4114za7, "ssl-cipher-initiv", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3631z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4115z00, BGl_z62sslzd2connectionzd2init1266z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3470z00zz__ssl_sslz00, BgL_bgl_za762lambda1824za7624116z00, BGl_z62lambda1824z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3720z00zz__ssl_sslz00, BgL_bgl_string3720za700za7za7_4117za7, "ssl-cipher-init", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3633z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4118z00, BGl_z62sslzd2connectionzd2start1268z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3471z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza74119za7, BGl_z62zc3anonymousza31833ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3721z00zz__ssl_sslz00, BgL_bgl_string3721za700za7za7_4120za7, "ssl-verify-update!", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3472z00zz__ssl_sslz00, BgL_bgl_za762lambda1832za7624121z00, BGl_z62lambda1832z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3722z00zz__ssl_sslz00, BgL_bgl_string3722za700za7za7_4122za7, "ssl-verify", 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3635z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4123z00, BGl_z62sslzd2connectionzd2close1270z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3473z00zz__ssl_sslz00, BgL_bgl_za762lambda1831za7624124z00, BGl_z62lambda1831z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3723z00zz__ssl_sslz00, BgL_bgl_string3723za700za7za7_4125za7, "Verify method not supported", 27 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3474z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza74126za7, BGl_z62zc3anonymousza31840ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3724z00zz__ssl_sslz00, BgL_bgl_string3724za700za7za7_4127za7, "ssl-sign-sign", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3637z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4128z00, BGl_z62sslzd2connectionzd2shutd1272z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3475z00zz__ssl_sslz00, BgL_bgl_za762lambda1839za7624129z00, BGl_z62lambda1839z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3725z00zz__ssl_sslz00, BgL_bgl_string3725za700za7za7_4130za7, "cannot sign", 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3476z00zz__ssl_sslz00, BgL_bgl_za762lambda1838za7624131z00, BGl_z62lambda1838z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3726z00zz__ssl_sslz00, BgL_bgl_string3726za700za7za7_4132za7, "ssl-sign-update!", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3639z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4133z00, BGl_z62sslzd2connectionzd2read1274z62zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3477z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza74134za7, BGl_z62zc3anonymousza31847ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3727z00zz__ssl_sslz00, BgL_bgl_string3727za700za7za7_4135za7, "ssl-sign", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3478z00zz__ssl_sslz00, BgL_bgl_za762lambda1846za7624136z00, BGl_z62lambda1846z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3728z00zz__ssl_sslz00, BgL_bgl_string3728za700za7za7_4137za7, "Sign method not supported", 25 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3479z00zz__ssl_sslz00, BgL_bgl_za762lambda1845za7624138z00, BGl_z62lambda1845z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3729z00zz__ssl_sslz00, BgL_bgl_string3729za700za7za7_4139za7, "ssl-hmac-digest", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3641z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4140z00, BGl_z62sslzd2connectionzd2write1276z62zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3480z00zz__ssl_sslz00, BgL_bgl_za762lambda1852za7624141z00, BGl_z62lambda1852z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3730z00zz__ssl_sslz00, BgL_bgl_string3730za700za7za7_4142za7, "cannot digest", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3643z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4143z00, BGl_z62sslzd2connectionzd2clear1278z62zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3481z00zz__ssl_sslz00, BgL_bgl_za762lambda1851za7624144z00, BGl_z62lambda1851z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3731z00zz__ssl_sslz00, BgL_bgl_string3731za700za7za7_4145za7, "ssl-hmac-update!", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3482z00zz__ssl_sslz00, BgL_bgl_za762lambda1857za7624146z00, BGl_z62lambda1857z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3732z00zz__ssl_sslz00, BgL_bgl_string3732za700za7za7_4147za7, "ssl-hmac", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3645z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4148z00, BGl_z62sslzd2connectionzd2clear1280z62zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3483z00zz__ssl_sslz00, BgL_bgl_za762lambda1856za7624149z00, BGl_z62lambda1856z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3733z00zz__ssl_sslz00, BgL_bgl_string3733za700za7za7_4150za7, "Digest method not supported", 27 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3484z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza74151za7, BGl_z62zc3anonymousza31864ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3734z00zz__ssl_sslz00, BgL_bgl_string3734za700za7za7_4152za7, "ssl-hash-digest", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3647z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4153z00, BGl_z62sslzd2connectionzd2initzd21282zb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3485z00zz__ssl_sslz00, BgL_bgl_za762lambda1863za7624154z00, BGl_z62lambda1863z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3735z00zz__ssl_sslz00, BgL_bgl_string3735za700za7za7_4155za7, "ssl-hash-update!", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3486z00zz__ssl_sslz00, BgL_bgl_za762lambda1862za7624156z00, BGl_z62lambda1862z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3736z00zz__ssl_sslz00, BgL_bgl_string3736za700za7za7_4157za7, "ssl-hash", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3649z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4158z00, BGl_z62sslzd2connectionzd2enczd2p1284zb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3487z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza74159za7, BGl_z62zc3anonymousza31871ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3737z00zz__ssl_sslz00, BgL_bgl_string3737za700za7za7_4160za7, "dh-generate-parameters-ex", 25 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3488z00zz__ssl_sslz00, BgL_bgl_za762lambda1870za7624161z00, BGl_z62lambda1870z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3738z00zz__ssl_sslz00, BgL_bgl_string3738za700za7za7_4162za7, "Illegal generator", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3489z00zz__ssl_sslz00, BgL_bgl_za762lambda1869za7624163z00, BGl_z62lambda1869z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3739z00zz__ssl_sslz00, BgL_bgl_string3739za700za7za7_4164za7, "&secure-context-init", 20 );
DEFINE_EXPORT_BGL_GENERIC( BGl_securezd2contextzd2closezd2envzd2zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4165z00, BGl_z62securezd2contextzd2closez62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3651z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4166z00, BGl_z62sslzd2connectionzd2clear1286z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2loadzd2sessionzd2envz00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4167z00, BGl_z62sslzd2connectionzd2loadzd2sessionzb0zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3490z00zz__ssl_sslz00, BgL_bgl_za762lambda1876za7624168z00, BGl_z62lambda1876z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3740z00zz__ssl_sslz00, BgL_bgl_string3740za700za7za7_4169za7, "&secure-context-close", 21 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3653z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4170z00, BGl_z62sslzd2connectionzd2setzd2s1288zb0zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3491z00zz__ssl_sslz00, BgL_bgl_za762lambda1875za7624171z00, BGl_z62lambda1875z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3741z00zz__ssl_sslz00, BgL_bgl_string3741za700za7za7_4172za7, "&secure-context-add-root-certs!", 31 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3492z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza74173za7, BGl_z62zc3anonymousza31883ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3742z00zz__ssl_sslz00, BgL_bgl_string3742za700za7za7_4174za7, "&secure-context-add-ca-cert!", 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3655z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4175z00, BGl_z62sslzd2connectionzd2getzd2s1290zb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3493z00zz__ssl_sslz00, BgL_bgl_za762lambda1882za7624176z00, BGl_z62lambda1882z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3743z00zz__ssl_sslz00, BgL_bgl_string3743za700za7za7_4177za7, "&secure-context-add-crl!", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3494z00zz__ssl_sslz00, BgL_bgl_za762lambda1881za7624178z00, BGl_z62lambda1881z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3744z00zz__ssl_sslz00, BgL_bgl_string3744za700za7za7_4179za7, "&secure-context-set-cert!", 25 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3657z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4180z00, BGl_z62sslzd2connectionzd2getzd2c1292zb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3495z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza74181za7, BGl_z62zc3anonymousza31890ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3745z00zz__ssl_sslz00, BgL_bgl_string3745za700za7za7_4182za7, "&secure-context-set-session-id-context!", 39 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3496z00zz__ssl_sslz00, BgL_bgl_za762lambda1889za7624183z00, BGl_z62lambda1889z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3746z00zz__ssl_sslz00, BgL_bgl_string3746za700za7za7_4184za7, "&secure-context-load-pkcs12", 27 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3659z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4185z00, BGl_z62sslzd2connectionzd2loadzd21294zb0zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3497z00zz__ssl_sslz00, BgL_bgl_za762lambda1888za7624186z00, BGl_z62lambda1888z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3747z00zz__ssl_sslz00, BgL_bgl_string3747za700za7za7_4187za7, "&secure-context-set-ciphers!", 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3498z00zz__ssl_sslz00, BgL_bgl_za762za7c3anonymousza74188za7, BGl_z62zc3anonymousza31897ze3ze1zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3748z00zz__ssl_sslz00, BgL_bgl_string3748za700za7za7_4189za7, "&secure-context-set-options!", 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3499z00zz__ssl_sslz00, BgL_bgl_za762lambda1896za7624190z00, BGl_z62lambda1896z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3749z00zz__ssl_sslz00, BgL_bgl_string3749za700za7za7_4191za7, "&ssl-connection-init", 20 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52makezd2privatezd2keyzd2envz80zz__ssl_sslz00, BgL_bgl_za762za752makeza7d2pri4192za7, BGl_z62z52makezd2privatezd2keyz30zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3661z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4193z00, BGl_z62sslzd2connectionzd2verif1296z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3750z00zz__ssl_sslz00, BgL_bgl_string3750za700za7za7_4194za7, "ssl-connection", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3663z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4195z00, BGl_z62sslzd2connectionzd2getzd2p1298zb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3751z00zz__ssl_sslz00, BgL_bgl_string3751za700za7za7_4196za7, "&ssl-connection-start", 21 );
DEFINE_STRING( BGl_string3752z00zz__ssl_sslz00, BgL_bgl_string3752za700za7za7_4197za7, "&ssl-connection-close", 21 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3665z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4198z00, BGl_z62sslzd2connectionzd2reuse1300z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3753z00zz__ssl_sslz00, BgL_bgl_string3753za700za7za7_4199za7, "&ssl-connection-shutdown", 24 );
DEFINE_STRING( BGl_string3754z00zz__ssl_sslz00, BgL_bgl_string3754za700za7za7_4200za7, "&ssl-connection-read", 20 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3667z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4201z00, BGl_z62sslzd2connectionzd2getzd2n1302zb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3755z00zz__ssl_sslz00, BgL_bgl_string3755za700za7za7_4202za7, "&ssl-connection-write", 21 );
DEFINE_STRING( BGl_string3756z00zz__ssl_sslz00, BgL_bgl_string3756za700za7za7_4203za7, "&ssl-connection-clear-in", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3669z00zz__ssl_sslz00, BgL_bgl_za762dhza7d2init13044204z00, BGl_z62dhzd2init1304zb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3757z00zz__ssl_sslz00, BgL_bgl_string3757za700za7za7_4205za7, "&ssl-connection-clear-out", 25 );
DEFINE_STRING( BGl_string3758z00zz__ssl_sslz00, BgL_bgl_string3758za700za7za7_4206za7, "&ssl-connection-init-finished?", 30 );
DEFINE_STRING( BGl_string3759z00zz__ssl_sslz00, BgL_bgl_string3759za700za7za7_4207za7, "&ssl-connection-enc-pending", 27 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3671z00zz__ssl_sslz00, BgL_bgl_za762dhza7d2siza7a7e134208za7, BGl_z62dhzd2siza7e1306z17zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3760z00zz__ssl_sslz00, BgL_bgl_string3760za700za7za7_4209za7, "&ssl-connection-clear-pending", 29 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3673z00zz__ssl_sslz00, BgL_bgl_za762dhza7d2generate4210z00, BGl_z62dhzd2generatezd2paramete1308z62zz__ssl_sslz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3761z00zz__ssl_sslz00, BgL_bgl_string3761za700za7za7_4211za7, "&ssl-connection-set-session", 27 );
DEFINE_STRING( BGl_string3762z00zz__ssl_sslz00, BgL_bgl_string3762za700za7za7_4212za7, "&ssl-connection-get-session", 27 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3675z00zz__ssl_sslz00, BgL_bgl_za762dhza7d2check1314213z00, BGl_z62dhzd2check1310zb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3763z00zz__ssl_sslz00, BgL_bgl_string3763za700za7za7_4214za7, "&ssl-connection-get-current-cipher", 34 );
DEFINE_STRING( BGl_string3764z00zz__ssl_sslz00, BgL_bgl_string3764za700za7za7_4215za7, "&ssl-connection-load-session", 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3677z00zz__ssl_sslz00, BgL_bgl_za762dhza7d2checkza7d24216za7, BGl_z62dhzd2checkzd2pubzd2key1312zb0zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3765z00zz__ssl_sslz00, BgL_bgl_string3765za700za7za7_4217za7, "&ssl-connection-verify-error", 28 );
DEFINE_STRING( BGl_string3766z00zz__ssl_sslz00, BgL_bgl_string3766za700za7za7_4218za7, "&ssl-connection-get-peer-certificate", 36 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3679z00zz__ssl_sslz00, BgL_bgl_za762dhza7d2computeza74219za7, BGl_z62dhzd2computezd2key1314z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3767z00zz__ssl_sslz00, BgL_bgl_string3767za700za7za7_4220za7, "&ssl-connection-reused?", 23 );
DEFINE_STRING( BGl_string3768z00zz__ssl_sslz00, BgL_bgl_string3768za700za7za7_4221za7, "&ssl-connection-get-negotiated-protocol", 39 );
DEFINE_STRING( BGl_string3769z00zz__ssl_sslz00, BgL_bgl_string3769za700za7za7_4222za7, "&dh-init", 8 );
DEFINE_EXPORT_BGL_GENERIC( BGl_securezd2contextzd2setzd2certz12zd2envz12zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4223z00, BGl_z62securezd2contextzd2setzd2certz12za2zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3681z00zz__ssl_sslz00, BgL_bgl_za762dhza7d2generate4224z00, BGl_z62dhzd2generatezd2key1316z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3770z00zz__ssl_sslz00, BgL_bgl_string3770za700za7za7_4225za7, "dh", 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3683z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2hashza7d24226za7, BGl_z62sslzd2hashzd2init1318z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3771z00zz__ssl_sslz00, BgL_bgl_string3771za700za7za7_4227za7, "&dh-size", 8 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52makezd2certificatezd2envz52zz__ssl_sslz00, BgL_bgl_za762za752makeza7d2cer4228za7, BGl_z62z52makezd2certificateze2zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3772z00zz__ssl_sslz00, BgL_bgl_string3772za700za7za7_4229za7, "&dh-generate-parameters-ex", 26 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3685z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2hashza7d24230za7, BGl_z62sslzd2hashzd2updatez121320z70zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3773z00zz__ssl_sslz00, BgL_bgl_string3773za700za7za7_4231za7, "symbol", 6 );
DEFINE_STRING( BGl_string3774z00zz__ssl_sslz00, BgL_bgl_string3774za700za7za7_4232za7, "&dh-check", 9 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3687z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2hashza7d24233za7, BGl_z62sslzd2hashzd2digest1322z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3775z00zz__ssl_sslz00, BgL_bgl_string3775za700za7za7_4234za7, "&dh-check-pub-key", 17 );
DEFINE_STRING( BGl_string3776z00zz__ssl_sslz00, BgL_bgl_string3776za700za7za7_4235za7, "&dh-compute-key", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3689z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2hmacza7d24236za7, BGl_z62sslzd2hmaczd2init1324z62zz__ssl_sslz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3777z00zz__ssl_sslz00, BgL_bgl_string3777za700za7za7_4237za7, "&dh-generate-key", 16 );
DEFINE_STRING( BGl_string3778z00zz__ssl_sslz00, BgL_bgl_string3778za700za7za7_4238za7, "&ssl-hash-init", 14 );
DEFINE_STRING( BGl_string3779z00zz__ssl_sslz00, BgL_bgl_string3779za700za7za7_4239za7, "&ssl-hash-update!", 17 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_bnzd2numzd2byteszd2envzd2zz__ssl_sslz00, BgL_bgl_za762bnza7d2numza7d2by4240za7, BGl_z62bnzd2numzd2bytesz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3691z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2hmacza7d24241za7, BGl_z62sslzd2hmaczd2updatez121326z70zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3780z00zz__ssl_sslz00, BgL_bgl_string3780za700za7za7_4242za7, "&ssl-hash-digest", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3693z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2hmacza7d24243za7, BGl_z62sslzd2hmaczd2digest1328z62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3781z00zz__ssl_sslz00, BgL_bgl_string3781za700za7za7_4244za7, "&ssl-hmac-init", 14 );
DEFINE_STRING( BGl_string3782z00zz__ssl_sslz00, BgL_bgl_string3782za700za7za7_4245za7, "&ssl-hmac-update!", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3695z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2signza7d24246za7, BGl_z62sslzd2signzd2init1330z62zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3783z00zz__ssl_sslz00, BgL_bgl_string3783za700za7za7_4247za7, "&ssl-hmac-digest", 16 );
DEFINE_STRING( BGl_string3784z00zz__ssl_sslz00, BgL_bgl_string3784za700za7za7_4248za7, "&ssl-sign-init", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3697z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2signza7d24249za7, BGl_z62sslzd2signzd2updatez121332z70zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3785z00zz__ssl_sslz00, BgL_bgl_string3785za700za7za7_4250za7, "&ssl-sign-update!", 17 );
DEFINE_STRING( BGl_string3786z00zz__ssl_sslz00, BgL_bgl_string3786za700za7za7_4251za7, "&ssl-sign-sign", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3699z00zz__ssl_sslz00, BgL_bgl_za762sslza7d2signza7d24252za7, BGl_z62sslzd2signzd2sign1334z62zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3787z00zz__ssl_sslz00, BgL_bgl_string3787za700za7za7_4253za7, "&ssl-verify-init", 16 );
DEFINE_STRING( BGl_string3788z00zz__ssl_sslz00, BgL_bgl_string3788za700za7za7_4254za7, "&ssl-verify-update!", 19 );
DEFINE_STRING( BGl_string3789z00zz__ssl_sslz00, BgL_bgl_string3789za700za7za7_4255za7, "&ssl-verify-final", 17 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2startzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4256z00, BGl_z62sslzd2connectionzd2startz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3790z00zz__ssl_sslz00, BgL_bgl_string3790za700za7za7_4257za7, "&ssl-cipher-init", 16 );
DEFINE_STRING( BGl_string3791z00zz__ssl_sslz00, BgL_bgl_string3791za700za7za7_4258za7, "ssl-cipher", 10 );
DEFINE_STRING( BGl_string3792z00zz__ssl_sslz00, BgL_bgl_string3792za700za7za7_4259za7, "&ssl-cipher-initiv", 18 );
DEFINE_STRING( BGl_string3793z00zz__ssl_sslz00, BgL_bgl_string3793za700za7za7_4260za7, "&ssl-cipher-update!", 19 );
DEFINE_STRING( BGl_string3794z00zz__ssl_sslz00, BgL_bgl_string3794za700za7za7_4261za7, "&ssl-cipher-set-auto-padding", 28 );
DEFINE_STRING( BGl_string3795z00zz__ssl_sslz00, BgL_bgl_string3795za700za7za7_4262za7, "&ssl-cipher-final", 17 );
DEFINE_STRING( BGl_string3796z00zz__ssl_sslz00, BgL_bgl_string3796za700za7za7_4263za7, "DH-GENERATOR-2 ssl-cipher $ssl-cipher-ctx $cipher-ctx $ssl-cipher $cipher ssl-verify ssl-sign ssl-hmac $ssl-hmac-ctx ssl-hash type $ssl-evp-md-ctx $md-ctx $ssl-evp-md $md dh public-key g q p %priv %pub %g %q $bignum %p $dh ssl-connection sent-shutdown received-shutdown err npn-protos selected-npn-protos procedure newsession-callback sni-context-callback info-callback reject-unauthorized obj server-name request-cert bool isserver ctx $ssl-session $next-session $bio-write $bio $bio-read $ssl secure-context bstring method $X509-store $ca-store $ssl-ctx private-key $private-key __ssl_ssl certificate $certificate $native dtlsv1 dtls tlsv1_2 tlsv1_1 tlsv1 tls ssl sslv3 sslv2 make-ssl-server-socket :ipv6 :backlog :name (:ipv6 :backlog :accepted-certs :CAs :pkey :cert :protocol :name) client-socket-use-ssl! (:CAs :accepted-certs :cert :pkey :protocol) :timeout :protocol :pkey :outbuf :inbuf :cert :accepted-certs :CAs make-ssl-client-socket (:CAs :accepted-certs :cert :inbuf :outbuf :pkey :protocol :timeout) sslv23 ", 1022 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2hashzd2initzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2hashza7d24264za7, BGl_z62sslzd2hashzd2initz62zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2signzd2signzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2signza7d24265za7, BGl_z62sslzd2signzd2signz62zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sslzd2clearzd2errorzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2clearza7d4266za7, BGl_z62sslzd2clearzd2errorz62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_GENERIC( BGl_securezd2contextzd2setzd2ciphersz12zd2envz12zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4267z00, BGl_z62securezd2contextzd2setzd2ciphersz12za2zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_securezd2contextzd2loadzd2pkcs12zd2envz00zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4268z00, BGl_z62securezd2contextzd2loadzd2pkcs12zb0zz__ssl_sslz00, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2connectionzd2verifyzd2errorzd2envz00zz__ssl_sslz00, BgL_bgl_za762sslza7d2connect4269z00, BGl_z62sslzd2connectionzd2verifyzd2errorzb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_securezd2contextzd2setzd2sessionzd2idzd2contextz12zd2envz12zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4270z00, BGl_z62securezd2contextzd2setzd2sessionzd2idzd2contextz12za2zz__ssl_sslz00, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sslzd2randzd2statuszd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2randza7d24271za7, BGl_z62sslzd2randzd2statusz62zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_bnzd2freezd2envz00zz__ssl_sslz00, BgL_bgl_za762bnza7d2freeza7b0za74272z00, BGl_z62bnzd2freezb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sslzd2randzd2pseudozd2byteszd2envz00zz__ssl_sslz00, BgL_bgl_za762sslza7d2randza7d24273za7, BGl_z62sslzd2randzd2pseudozd2byteszb0zz__ssl_sslz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_bnzd2newzd2envz00zz__ssl_sslz00, BgL_bgl_za762bnza7d2newza7b0za7za74274za7, BGl_z62bnzd2newzb0zz__ssl_sslz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_GENERIC( BGl_securezd2contextzd2setzd2optionsz12zd2envz12zz__ssl_sslz00, BgL_bgl_za762secureza7d2cont4275z00, BGl_z62securezd2contextzd2setzd2optionsz12za2zz__ssl_sslz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sslzd2cipherzd2initzd2envzd2zz__ssl_sslz00, BgL_bgl_za762sslza7d2cipherza74276za7, BGl_z62sslzd2cipherzd2initz62zz__ssl_sslz00, 0L, BUNSPEC, 6 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_certificatez00zz__ssl_sslz00) );
ADD_ROOT( (void *)(&BGl_privatezd2keyzd2zz__ssl_sslz00) );
ADD_ROOT( (void *)(&BGl_sslzd2connectionzd2zz__ssl_sslz00) );
ADD_ROOT( (void *)(&BGl_sslzd2hashzd2zz__ssl_sslz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__ssl_sslz00) );
ADD_ROOT( (void *)(&BGl_sslzd2signzd2zz__ssl_sslz00) );
ADD_ROOT( (void *)(&BGl_sslzd2hmaczd2zz__ssl_sslz00) );
ADD_ROOT( (void *)(&BGl_sslzd2verifyzd2zz__ssl_sslz00) );
ADD_ROOT( (void *)(&BGl_sslzd2cipherzd2zz__ssl_sslz00) );
ADD_ROOT( (void *)(&BGl_securezd2contextzd2zz__ssl_sslz00) );
ADD_ROOT( (void *)(&BGl_dhz00zz__ssl_sslz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__ssl_sslz00(long BgL_checksumz00_6532, char * BgL_fromz00_6533)
{ BGL_FUNCTION_BEGIN;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__ssl_sslz00))
{ 
BGl_requirezd2initializa7ationz75zz__ssl_sslz00 = 
BBOOL(((bool_t)0)); 
BGL_GC_INIT(); 
BGl_gczd2rootszd2initz00zz__ssl_sslz00(); 
BGl_libraryzd2moduleszd2initz00zz__ssl_sslz00(); 
BGl_cnstzd2initzd2zz__ssl_sslz00(); 
BGl_objectzd2initzd2zz__ssl_sslz00(); 
BGl_genericzd2initzd2zz__ssl_sslz00(); 
return 
BGl_toplevelzd2initzd2zz__ssl_sslz00();}  else 
{ 
return BUNSPEC;} } 
BGL_FUNCTION_END;
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__ssl_sslz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 15 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__dssslz00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__socketz00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__ssl_ssl"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__ssl_ssl"); 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__ssl_sslz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 15 */
{ /* Llib/ssl.scm 15 */
obj_t BgL_cportz00_6085;
{ /* Llib/ssl.scm 15 */
obj_t BgL_stringz00_6093;
BgL_stringz00_6093 = BGl_string3796z00zz__ssl_sslz00; 
{ /* Llib/ssl.scm 15 */
obj_t BgL_startz00_6094;
BgL_startz00_6094 = 
BINT(((long)0)); 
{ /* Llib/ssl.scm 15 */
obj_t BgL_endz00_6095;
BgL_endz00_6095 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_6093))); 
{ /* Llib/ssl.scm 15 */

BgL_cportz00_6085 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_6093, BgL_startz00_6094, BgL_endz00_6095); } } } } 
{ 
long BgL_iz00_6086;
BgL_iz00_6086 = ((long)89); 
BgL_loopz00_6087:
if(
(BgL_iz00_6086==((long)-1)))
{ /* Llib/ssl.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/ssl.scm 15 */
{ /* Llib/ssl.scm 15 */
obj_t BgL_arg3798z00_6089;
{ /* Llib/ssl.scm 15 */

{ /* Llib/ssl.scm 15 */
obj_t BgL_locationz00_6091;
BgL_locationz00_6091 = 
BBOOL(((bool_t)0)); 
{ /* Llib/ssl.scm 15 */

BgL_arg3798z00_6089 = 
BGl_readz00zz__readerz00(BgL_cportz00_6085, BgL_locationz00_6091); } } } 
{ /* Llib/ssl.scm 15 */
int BgL_tmpz00_6567;
BgL_tmpz00_6567 = 
(int)(BgL_iz00_6086); 
CNST_TABLE_SET(BgL_tmpz00_6567, BgL_arg3798z00_6089); } } 
{ /* Llib/ssl.scm 15 */
int BgL_auxz00_6092;
BgL_auxz00_6092 = 
(int)(
(BgL_iz00_6086-((long)1))); 
{ 
long BgL_iz00_6572;
BgL_iz00_6572 = 
(long)(BgL_auxz00_6092); 
BgL_iz00_6086 = BgL_iz00_6572; 
goto BgL_loopz00_6087;} } } } } } 
BGL_FUNCTION_END;
}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__ssl_sslz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 15 */
return 
bgl_gc_roots_register();} 
BGL_FUNCTION_END;
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__ssl_sslz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 15 */
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* ssl-version */
BGL_EXPORTED_DEF char * BGl_sslzd2versionzd2zz__ssl_sslz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 568 */
return 
bgl_ssl_version();} 
BGL_FUNCTION_END;
}



/* &ssl-version */
obj_t BGl_z62sslzd2versionzb0zz__ssl_sslz00(obj_t BgL_envz00_4580)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 568 */
return 
string_to_bstring(
BGl_sslzd2versionzd2zz__ssl_sslz00());} 
BGL_FUNCTION_END;
}



/* ssl-clear-error */
BGL_EXPORTED_DEF obj_t BGl_sslzd2clearzd2errorz00zz__ssl_sslz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 576 */
ERR_clear_error(); BUNSPEC; 
return BTRUE;} 
BGL_FUNCTION_END;
}



/* &ssl-clear-error */
obj_t BGl_z62sslzd2clearzd2errorz62zz__ssl_sslz00(obj_t BgL_envz00_4581)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 576 */
return 
BGl_sslzd2clearzd2errorz00zz__ssl_sslz00();} 
BGL_FUNCTION_END;
}



/* sanity-args-checks */
obj_t BGl_sanityzd2argszd2checksz00zz__ssl_sslz00(obj_t BgL_funcz00_3, obj_t BgL_certz00_4, obj_t BgL_pkeyz00_5, obj_t BgL_casz00_6, obj_t BgL_acceptedzd2certszd2_7)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 584 */
{ /* Llib/ssl.scm 585 */
bool_t BgL_testz00_6580;
if(
CBOOL(BgL_certz00_4))
{ /* Llib/ssl.scm 585 */
BgL_testz00_6580 = 
BGl_isazf3zf3zz__objectz00(BgL_certz00_4, BGl_certificatez00zz__ssl_sslz00)
; }  else 
{ /* Llib/ssl.scm 585 */
BgL_testz00_6580 = ((bool_t)1)
; } 
if(BgL_testz00_6580)
{ /* Llib/ssl.scm 585 */BFALSE; }  else 
{ /* Llib/ssl.scm 585 */
BGl_errorz00zz__errorz00(BgL_funcz00_3, BGl_string3404z00zz__ssl_sslz00, BgL_certz00_4); } } 
{ /* Llib/ssl.scm 587 */
bool_t BgL_testz00_6585;
if(
CBOOL(BgL_pkeyz00_5))
{ /* Llib/ssl.scm 587 */
BgL_testz00_6585 = 
BGl_isazf3zf3zz__objectz00(BgL_pkeyz00_5, BGl_privatezd2keyzd2zz__ssl_sslz00)
; }  else 
{ /* Llib/ssl.scm 587 */
BgL_testz00_6585 = ((bool_t)1)
; } 
if(BgL_testz00_6585)
{ /* Llib/ssl.scm 587 */BFALSE; }  else 
{ /* Llib/ssl.scm 587 */
BGl_errorz00zz__errorz00(BgL_funcz00_3, BGl_string3405z00zz__ssl_sslz00, BgL_pkeyz00_5); } } 
{ /* Llib/ssl.scm 589 */
bool_t BgL_testz00_6590;
if(
BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_casz00_6))
{ 
obj_t BgL_l1179z00_211;
BgL_l1179z00_211 = BgL_casz00_6; 
BgL_zc3anonymousza31420ze3z83_212:
if(
NULLP(BgL_l1179z00_211))
{ /* Llib/ssl.scm 589 */
BgL_testz00_6590 = ((bool_t)1)
; }  else 
{ /* Llib/ssl.scm 589 */
bool_t BgL_testz00_6595;
{ /* Llib/ssl.scm 589 */
obj_t BgL_cz00_217;
BgL_cz00_217 = 
CAR(
((obj_t)BgL_l1179z00_211)); 
BgL_testz00_6595 = 
BGl_isazf3zf3zz__objectz00(BgL_cz00_217, BGl_certificatez00zz__ssl_sslz00); } 
if(BgL_testz00_6595)
{ 
obj_t BgL_l1179z00_6599;
BgL_l1179z00_6599 = 
CDR(
((obj_t)BgL_l1179z00_211)); 
BgL_l1179z00_211 = BgL_l1179z00_6599; 
goto BgL_zc3anonymousza31420ze3z83_212;}  else 
{ /* Llib/ssl.scm 589 */
BgL_testz00_6590 = ((bool_t)0)
; } } }  else 
{ /* Llib/ssl.scm 589 */
BgL_testz00_6590 = ((bool_t)0)
; } 
if(BgL_testz00_6590)
{ /* Llib/ssl.scm 589 */BFALSE; }  else 
{ /* Llib/ssl.scm 589 */
BGl_errorz00zz__errorz00(BgL_funcz00_3, BGl_string3406z00zz__ssl_sslz00, BgL_casz00_6); } } 
{ /* Llib/ssl.scm 591 */
bool_t BgL_testz00_6603;
if(
CBOOL(BgL_acceptedzd2certszd2_7))
{ /* Llib/ssl.scm 591 */
if(
BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_acceptedzd2certszd2_7))
{ 
obj_t BgL_l1182z00_232;
BgL_l1182z00_232 = BgL_acceptedzd2certszd2_7; 
BgL_zc3anonymousza31512ze3z83_233:
if(
NULLP(BgL_l1182z00_232))
{ /* Llib/ssl.scm 593 */
BgL_testz00_6603 = ((bool_t)1)
; }  else 
{ /* Llib/ssl.scm 593 */
bool_t BgL_testz00_6610;
{ /* Llib/ssl.scm 593 */
obj_t BgL_cz00_238;
BgL_cz00_238 = 
CAR(
((obj_t)BgL_l1182z00_232)); 
BgL_testz00_6610 = 
BGl_isazf3zf3zz__objectz00(BgL_cz00_238, BGl_certificatez00zz__ssl_sslz00); } 
if(BgL_testz00_6610)
{ 
obj_t BgL_l1182z00_6614;
BgL_l1182z00_6614 = 
CDR(
((obj_t)BgL_l1182z00_232)); 
BgL_l1182z00_232 = BgL_l1182z00_6614; 
goto BgL_zc3anonymousza31512ze3z83_233;}  else 
{ /* Llib/ssl.scm 593 */
BgL_testz00_6603 = ((bool_t)0)
; } } }  else 
{ /* Llib/ssl.scm 592 */
BgL_testz00_6603 = ((bool_t)0)
; } }  else 
{ /* Llib/ssl.scm 591 */
BgL_testz00_6603 = ((bool_t)1)
; } 
if(BgL_testz00_6603)
{ /* Llib/ssl.scm 591 */BFALSE; }  else 
{ /* Llib/ssl.scm 591 */
BGl_errorz00zz__errorz00(BgL_funcz00_3, BGl_string3407z00zz__ssl_sslz00, BgL_acceptedzd2certszd2_7); } } 
{ /* Llib/ssl.scm 595 */
bool_t BgL_testz00_6618;
{ /* Llib/ssl.scm 595 */
bool_t BgL_testz00_6619;
if(
BGl_isazf3zf3zz__objectz00(BgL_certz00_4, BGl_certificatez00zz__ssl_sslz00))
{ /* Llib/ssl.scm 595 */
if(
BGl_isazf3zf3zz__objectz00(BgL_pkeyz00_5, BGl_privatezd2keyzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 595 */
BgL_testz00_6619 = ((bool_t)0)
; }  else 
{ /* Llib/ssl.scm 595 */
BgL_testz00_6619 = ((bool_t)1)
; } }  else 
{ /* Llib/ssl.scm 595 */
BgL_testz00_6619 = ((bool_t)0)
; } 
if(BgL_testz00_6619)
{ /* Llib/ssl.scm 595 */
BgL_testz00_6618 = ((bool_t)1)
; }  else 
{ /* Llib/ssl.scm 595 */
if(
BGl_isazf3zf3zz__objectz00(BgL_pkeyz00_5, BGl_privatezd2keyzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 596 */
if(
BGl_isazf3zf3zz__objectz00(BgL_certz00_4, BGl_certificatez00zz__ssl_sslz00))
{ /* Llib/ssl.scm 596 */
BgL_testz00_6618 = ((bool_t)0)
; }  else 
{ /* Llib/ssl.scm 596 */
BgL_testz00_6618 = ((bool_t)1)
; } }  else 
{ /* Llib/ssl.scm 596 */
BgL_testz00_6618 = ((bool_t)0)
; } } } 
if(BgL_testz00_6618)
{ /* Llib/ssl.scm 599 */
obj_t BgL_arg1523z00_248;
{ /* Llib/ssl.scm 599 */
obj_t BgL_list1524z00_249;
{ /* Llib/ssl.scm 599 */
obj_t BgL_arg1531z00_250;
BgL_arg1531z00_250 = 
MAKE_YOUNG_PAIR(BgL_certz00_4, BNIL); 
BgL_list1524z00_249 = 
MAKE_YOUNG_PAIR(BgL_pkeyz00_5, BgL_arg1531z00_250); } 
BgL_arg1523z00_248 = BgL_list1524z00_249; } 
return 
BGl_errorz00zz__errorz00(BgL_funcz00_3, BGl_string3408z00zz__ssl_sslz00, BgL_arg1523z00_248);}  else 
{ /* Llib/ssl.scm 595 */
return BFALSE;} } } 
BGL_FUNCTION_END;
}



/* _make-ssl-client-socket */
obj_t BGl__makezd2sslzd2clientzd2socketzd2zz__ssl_sslz00(obj_t BgL_envz00_19, obj_t BgL_opt1210z00_18)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 604 */
{ /* Llib/ssl.scm 604 */
obj_t BgL_g1223z00_260;obj_t BgL_g1224z00_261;
BgL_g1223z00_260 = 
VECTOR_REF(BgL_opt1210z00_18,((long)0)); 
BgL_g1224z00_261 = 
VECTOR_REF(BgL_opt1210z00_18,((long)1)); 
{ /* Llib/ssl.scm 610 */
obj_t BgL_casz00_262;
BgL_casz00_262 = BNIL; 
{ /* Llib/ssl.scm 604 */
obj_t BgL_acceptedzd2certszd2_263;
BgL_acceptedzd2certszd2_263 = BFALSE; 
{ /* Llib/ssl.scm 604 */
obj_t BgL_certz00_264;
BgL_certz00_264 = BFALSE; 
{ /* Llib/ssl.scm 604 */
obj_t BgL_inbufz00_265;
BgL_inbufz00_265 = BTRUE; 
{ /* Llib/ssl.scm 604 */
obj_t BgL_outbufz00_266;
BgL_outbufz00_266 = BTRUE; 
{ /* Llib/ssl.scm 604 */
obj_t BgL_pkeyz00_267;
BgL_pkeyz00_267 = BFALSE; 
{ /* Llib/ssl.scm 608 */
obj_t BgL_protocolz00_268;
BgL_protocolz00_268 = 
CNST_TABLE_REF(((long)0)); 
{ /* Llib/ssl.scm 604 */
obj_t BgL_timeoutz00_269;
BgL_timeoutz00_269 = 
BINT(((long)0)); 
{ /* Llib/ssl.scm 604 */

{ 
long BgL_iz00_270;
BgL_iz00_270 = ((long)2); 
BgL_check1213z00_271:
if(
(BgL_iz00_270==
VECTOR_LENGTH(BgL_opt1210z00_18)))
{ /* Llib/ssl.scm 604 */BNIL; }  else 
{ /* Llib/ssl.scm 604 */
bool_t BgL_testz00_6638;
{ /* Llib/ssl.scm 604 */
obj_t BgL_arg1550z00_277;
BgL_arg1550z00_277 = 
VECTOR_REF(BgL_opt1210z00_18,BgL_iz00_270); 
BgL_testz00_6638 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1550z00_277, 
CNST_TABLE_REF(((long)1)))); } 
if(BgL_testz00_6638)
{ 
long BgL_iz00_6643;
BgL_iz00_6643 = 
(BgL_iz00_270+((long)2)); 
BgL_iz00_270 = BgL_iz00_6643; 
goto BgL_check1213z00_271;}  else 
{ /* Llib/ssl.scm 604 */
obj_t BgL_arg1549z00_276;
BgL_arg1549z00_276 = 
VECTOR_REF(BgL_opt1210z00_18,BgL_iz00_270); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)2)), BGl_string3409z00zz__ssl_sslz00, BgL_arg1549z00_276); } } } 
{ /* Llib/ssl.scm 604 */
obj_t BgL_index1215z00_278;
BgL_index1215z00_278 = 
BGl_search1212ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1210z00_18), BgL_opt1210z00_18, 
CNST_TABLE_REF(((long)3)), ((long)2)); 
{ /* Llib/ssl.scm 604 */
bool_t BgL_testz00_6651;
{ /* Llib/ssl.scm 604 */
long BgL_n1z00_1792;
{ /* Llib/ssl.scm 604 */
obj_t BgL_tmpz00_6652;
if(
INTEGERP(BgL_index1215z00_278))
{ /* Llib/ssl.scm 604 */
BgL_tmpz00_6652 = BgL_index1215z00_278
; }  else 
{ 
obj_t BgL_auxz00_6655;
BgL_auxz00_6655 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)24675)), BGl_string3411z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1215z00_278); 
FAILURE(BgL_auxz00_6655,BFALSE,BFALSE);} 
BgL_n1z00_1792 = 
(long)CINT(BgL_tmpz00_6652); } 
BgL_testz00_6651 = 
(BgL_n1z00_1792>=((long)0)); } 
if(BgL_testz00_6651)
{ 
long BgL_auxz00_6661;
{ /* Llib/ssl.scm 604 */
obj_t BgL_tmpz00_6662;
if(
INTEGERP(BgL_index1215z00_278))
{ /* Llib/ssl.scm 604 */
BgL_tmpz00_6662 = BgL_index1215z00_278
; }  else 
{ 
obj_t BgL_auxz00_6665;
BgL_auxz00_6665 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)24675)), BGl_string3411z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1215z00_278); 
FAILURE(BgL_auxz00_6665,BFALSE,BFALSE);} 
BgL_auxz00_6661 = 
(long)CINT(BgL_tmpz00_6662); } 
BgL_casz00_262 = 
VECTOR_REF(BgL_opt1210z00_18,BgL_auxz00_6661); }  else 
{ /* Llib/ssl.scm 604 */BFALSE; } } } 
{ /* Llib/ssl.scm 604 */
obj_t BgL_index1216z00_280;
BgL_index1216z00_280 = 
BGl_search1212ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1210z00_18), BgL_opt1210z00_18, 
CNST_TABLE_REF(((long)4)), ((long)2)); 
{ /* Llib/ssl.scm 604 */
bool_t BgL_testz00_6674;
{ /* Llib/ssl.scm 604 */
long BgL_n1z00_1794;
{ /* Llib/ssl.scm 604 */
obj_t BgL_tmpz00_6675;
if(
INTEGERP(BgL_index1216z00_280))
{ /* Llib/ssl.scm 604 */
BgL_tmpz00_6675 = BgL_index1216z00_280
; }  else 
{ 
obj_t BgL_auxz00_6678;
BgL_auxz00_6678 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)24675)), BGl_string3411z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1216z00_280); 
FAILURE(BgL_auxz00_6678,BFALSE,BFALSE);} 
BgL_n1z00_1794 = 
(long)CINT(BgL_tmpz00_6675); } 
BgL_testz00_6674 = 
(BgL_n1z00_1794>=((long)0)); } 
if(BgL_testz00_6674)
{ 
long BgL_auxz00_6684;
{ /* Llib/ssl.scm 604 */
obj_t BgL_tmpz00_6685;
if(
INTEGERP(BgL_index1216z00_280))
{ /* Llib/ssl.scm 604 */
BgL_tmpz00_6685 = BgL_index1216z00_280
; }  else 
{ 
obj_t BgL_auxz00_6688;
BgL_auxz00_6688 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)24675)), BGl_string3411z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1216z00_280); 
FAILURE(BgL_auxz00_6688,BFALSE,BFALSE);} 
BgL_auxz00_6684 = 
(long)CINT(BgL_tmpz00_6685); } 
BgL_acceptedzd2certszd2_263 = 
VECTOR_REF(BgL_opt1210z00_18,BgL_auxz00_6684); }  else 
{ /* Llib/ssl.scm 604 */BFALSE; } } } 
{ /* Llib/ssl.scm 604 */
obj_t BgL_index1217z00_282;
BgL_index1217z00_282 = 
BGl_search1212ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1210z00_18), BgL_opt1210z00_18, 
CNST_TABLE_REF(((long)5)), ((long)2)); 
{ /* Llib/ssl.scm 604 */
bool_t BgL_testz00_6697;
{ /* Llib/ssl.scm 604 */
long BgL_n1z00_1796;
{ /* Llib/ssl.scm 604 */
obj_t BgL_tmpz00_6698;
if(
INTEGERP(BgL_index1217z00_282))
{ /* Llib/ssl.scm 604 */
BgL_tmpz00_6698 = BgL_index1217z00_282
; }  else 
{ 
obj_t BgL_auxz00_6701;
BgL_auxz00_6701 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)24675)), BGl_string3411z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1217z00_282); 
FAILURE(BgL_auxz00_6701,BFALSE,BFALSE);} 
BgL_n1z00_1796 = 
(long)CINT(BgL_tmpz00_6698); } 
BgL_testz00_6697 = 
(BgL_n1z00_1796>=((long)0)); } 
if(BgL_testz00_6697)
{ 
long BgL_auxz00_6707;
{ /* Llib/ssl.scm 604 */
obj_t BgL_tmpz00_6708;
if(
INTEGERP(BgL_index1217z00_282))
{ /* Llib/ssl.scm 604 */
BgL_tmpz00_6708 = BgL_index1217z00_282
; }  else 
{ 
obj_t BgL_auxz00_6711;
BgL_auxz00_6711 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)24675)), BGl_string3411z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1217z00_282); 
FAILURE(BgL_auxz00_6711,BFALSE,BFALSE);} 
BgL_auxz00_6707 = 
(long)CINT(BgL_tmpz00_6708); } 
BgL_certz00_264 = 
VECTOR_REF(BgL_opt1210z00_18,BgL_auxz00_6707); }  else 
{ /* Llib/ssl.scm 604 */BFALSE; } } } 
{ /* Llib/ssl.scm 604 */
obj_t BgL_index1218z00_284;
BgL_index1218z00_284 = 
BGl_search1212ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1210z00_18), BgL_opt1210z00_18, 
CNST_TABLE_REF(((long)6)), ((long)2)); 
{ /* Llib/ssl.scm 604 */
bool_t BgL_testz00_6720;
{ /* Llib/ssl.scm 604 */
long BgL_n1z00_1798;
{ /* Llib/ssl.scm 604 */
obj_t BgL_tmpz00_6721;
if(
INTEGERP(BgL_index1218z00_284))
{ /* Llib/ssl.scm 604 */
BgL_tmpz00_6721 = BgL_index1218z00_284
; }  else 
{ 
obj_t BgL_auxz00_6724;
BgL_auxz00_6724 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)24675)), BGl_string3411z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1218z00_284); 
FAILURE(BgL_auxz00_6724,BFALSE,BFALSE);} 
BgL_n1z00_1798 = 
(long)CINT(BgL_tmpz00_6721); } 
BgL_testz00_6720 = 
(BgL_n1z00_1798>=((long)0)); } 
if(BgL_testz00_6720)
{ 
long BgL_auxz00_6730;
{ /* Llib/ssl.scm 604 */
obj_t BgL_tmpz00_6731;
if(
INTEGERP(BgL_index1218z00_284))
{ /* Llib/ssl.scm 604 */
BgL_tmpz00_6731 = BgL_index1218z00_284
; }  else 
{ 
obj_t BgL_auxz00_6734;
BgL_auxz00_6734 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)24675)), BGl_string3411z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1218z00_284); 
FAILURE(BgL_auxz00_6734,BFALSE,BFALSE);} 
BgL_auxz00_6730 = 
(long)CINT(BgL_tmpz00_6731); } 
BgL_inbufz00_265 = 
VECTOR_REF(BgL_opt1210z00_18,BgL_auxz00_6730); }  else 
{ /* Llib/ssl.scm 604 */BFALSE; } } } 
{ /* Llib/ssl.scm 604 */
obj_t BgL_index1219z00_286;
BgL_index1219z00_286 = 
BGl_search1212ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1210z00_18), BgL_opt1210z00_18, 
CNST_TABLE_REF(((long)7)), ((long)2)); 
{ /* Llib/ssl.scm 604 */
bool_t BgL_testz00_6743;
{ /* Llib/ssl.scm 604 */
long BgL_n1z00_1800;
{ /* Llib/ssl.scm 604 */
obj_t BgL_tmpz00_6744;
if(
INTEGERP(BgL_index1219z00_286))
{ /* Llib/ssl.scm 604 */
BgL_tmpz00_6744 = BgL_index1219z00_286
; }  else 
{ 
obj_t BgL_auxz00_6747;
BgL_auxz00_6747 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)24675)), BGl_string3411z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1219z00_286); 
FAILURE(BgL_auxz00_6747,BFALSE,BFALSE);} 
BgL_n1z00_1800 = 
(long)CINT(BgL_tmpz00_6744); } 
BgL_testz00_6743 = 
(BgL_n1z00_1800>=((long)0)); } 
if(BgL_testz00_6743)
{ 
long BgL_auxz00_6753;
{ /* Llib/ssl.scm 604 */
obj_t BgL_tmpz00_6754;
if(
INTEGERP(BgL_index1219z00_286))
{ /* Llib/ssl.scm 604 */
BgL_tmpz00_6754 = BgL_index1219z00_286
; }  else 
{ 
obj_t BgL_auxz00_6757;
BgL_auxz00_6757 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)24675)), BGl_string3411z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1219z00_286); 
FAILURE(BgL_auxz00_6757,BFALSE,BFALSE);} 
BgL_auxz00_6753 = 
(long)CINT(BgL_tmpz00_6754); } 
BgL_outbufz00_266 = 
VECTOR_REF(BgL_opt1210z00_18,BgL_auxz00_6753); }  else 
{ /* Llib/ssl.scm 604 */BFALSE; } } } 
{ /* Llib/ssl.scm 604 */
obj_t BgL_index1220z00_288;
BgL_index1220z00_288 = 
BGl_search1212ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1210z00_18), BgL_opt1210z00_18, 
CNST_TABLE_REF(((long)8)), ((long)2)); 
{ /* Llib/ssl.scm 604 */
bool_t BgL_testz00_6766;
{ /* Llib/ssl.scm 604 */
long BgL_n1z00_1802;
{ /* Llib/ssl.scm 604 */
obj_t BgL_tmpz00_6767;
if(
INTEGERP(BgL_index1220z00_288))
{ /* Llib/ssl.scm 604 */
BgL_tmpz00_6767 = BgL_index1220z00_288
; }  else 
{ 
obj_t BgL_auxz00_6770;
BgL_auxz00_6770 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)24675)), BGl_string3411z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1220z00_288); 
FAILURE(BgL_auxz00_6770,BFALSE,BFALSE);} 
BgL_n1z00_1802 = 
(long)CINT(BgL_tmpz00_6767); } 
BgL_testz00_6766 = 
(BgL_n1z00_1802>=((long)0)); } 
if(BgL_testz00_6766)
{ 
long BgL_auxz00_6776;
{ /* Llib/ssl.scm 604 */
obj_t BgL_tmpz00_6777;
if(
INTEGERP(BgL_index1220z00_288))
{ /* Llib/ssl.scm 604 */
BgL_tmpz00_6777 = BgL_index1220z00_288
; }  else 
{ 
obj_t BgL_auxz00_6780;
BgL_auxz00_6780 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)24675)), BGl_string3411z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1220z00_288); 
FAILURE(BgL_auxz00_6780,BFALSE,BFALSE);} 
BgL_auxz00_6776 = 
(long)CINT(BgL_tmpz00_6777); } 
BgL_pkeyz00_267 = 
VECTOR_REF(BgL_opt1210z00_18,BgL_auxz00_6776); }  else 
{ /* Llib/ssl.scm 604 */BFALSE; } } } 
{ /* Llib/ssl.scm 604 */
obj_t BgL_index1221z00_290;
BgL_index1221z00_290 = 
BGl_search1212ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1210z00_18), BgL_opt1210z00_18, 
CNST_TABLE_REF(((long)9)), ((long)2)); 
{ /* Llib/ssl.scm 604 */
bool_t BgL_testz00_6789;
{ /* Llib/ssl.scm 604 */
long BgL_n1z00_1804;
{ /* Llib/ssl.scm 604 */
obj_t BgL_tmpz00_6790;
if(
INTEGERP(BgL_index1221z00_290))
{ /* Llib/ssl.scm 604 */
BgL_tmpz00_6790 = BgL_index1221z00_290
; }  else 
{ 
obj_t BgL_auxz00_6793;
BgL_auxz00_6793 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)24675)), BGl_string3411z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1221z00_290); 
FAILURE(BgL_auxz00_6793,BFALSE,BFALSE);} 
BgL_n1z00_1804 = 
(long)CINT(BgL_tmpz00_6790); } 
BgL_testz00_6789 = 
(BgL_n1z00_1804>=((long)0)); } 
if(BgL_testz00_6789)
{ 
long BgL_auxz00_6799;
{ /* Llib/ssl.scm 604 */
obj_t BgL_tmpz00_6800;
if(
INTEGERP(BgL_index1221z00_290))
{ /* Llib/ssl.scm 604 */
BgL_tmpz00_6800 = BgL_index1221z00_290
; }  else 
{ 
obj_t BgL_auxz00_6803;
BgL_auxz00_6803 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)24675)), BGl_string3411z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1221z00_290); 
FAILURE(BgL_auxz00_6803,BFALSE,BFALSE);} 
BgL_auxz00_6799 = 
(long)CINT(BgL_tmpz00_6800); } 
BgL_protocolz00_268 = 
VECTOR_REF(BgL_opt1210z00_18,BgL_auxz00_6799); }  else 
{ /* Llib/ssl.scm 604 */BFALSE; } } } 
{ /* Llib/ssl.scm 604 */
obj_t BgL_index1222z00_292;
BgL_index1222z00_292 = 
BGl_search1212ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1210z00_18), BgL_opt1210z00_18, 
CNST_TABLE_REF(((long)10)), ((long)2)); 
{ /* Llib/ssl.scm 604 */
bool_t BgL_testz00_6812;
{ /* Llib/ssl.scm 604 */
long BgL_n1z00_1806;
{ /* Llib/ssl.scm 604 */
obj_t BgL_tmpz00_6813;
if(
INTEGERP(BgL_index1222z00_292))
{ /* Llib/ssl.scm 604 */
BgL_tmpz00_6813 = BgL_index1222z00_292
; }  else 
{ 
obj_t BgL_auxz00_6816;
BgL_auxz00_6816 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)24675)), BGl_string3411z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1222z00_292); 
FAILURE(BgL_auxz00_6816,BFALSE,BFALSE);} 
BgL_n1z00_1806 = 
(long)CINT(BgL_tmpz00_6813); } 
BgL_testz00_6812 = 
(BgL_n1z00_1806>=((long)0)); } 
if(BgL_testz00_6812)
{ 
long BgL_auxz00_6822;
{ /* Llib/ssl.scm 604 */
obj_t BgL_tmpz00_6823;
if(
INTEGERP(BgL_index1222z00_292))
{ /* Llib/ssl.scm 604 */
BgL_tmpz00_6823 = BgL_index1222z00_292
; }  else 
{ 
obj_t BgL_auxz00_6826;
BgL_auxz00_6826 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)24675)), BGl_string3411z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1222z00_292); 
FAILURE(BgL_auxz00_6826,BFALSE,BFALSE);} 
BgL_auxz00_6822 = 
(long)CINT(BgL_tmpz00_6823); } 
BgL_timeoutz00_269 = 
VECTOR_REF(BgL_opt1210z00_18,BgL_auxz00_6822); }  else 
{ /* Llib/ssl.scm 604 */BFALSE; } } } 
{ /* Llib/ssl.scm 604 */
obj_t BgL_arg1566z00_294;obj_t BgL_arg1567z00_295;
BgL_arg1566z00_294 = 
VECTOR_REF(BgL_opt1210z00_18,((long)0)); 
BgL_arg1567z00_295 = 
VECTOR_REF(BgL_opt1210z00_18,((long)1)); 
{ /* Llib/ssl.scm 604 */
obj_t BgL_casz00_296;
BgL_casz00_296 = BgL_casz00_262; 
{ /* Llib/ssl.scm 604 */
obj_t BgL_acceptedzd2certszd2_297;
BgL_acceptedzd2certszd2_297 = BgL_acceptedzd2certszd2_263; 
{ /* Llib/ssl.scm 604 */
obj_t BgL_certz00_298;
BgL_certz00_298 = BgL_certz00_264; 
{ /* Llib/ssl.scm 604 */
obj_t BgL_inbufz00_299;
BgL_inbufz00_299 = BgL_inbufz00_265; 
{ /* Llib/ssl.scm 604 */
obj_t BgL_outbufz00_300;
BgL_outbufz00_300 = BgL_outbufz00_266; 
{ /* Llib/ssl.scm 604 */
obj_t BgL_pkeyz00_301;
BgL_pkeyz00_301 = BgL_pkeyz00_267; 
{ /* Llib/ssl.scm 604 */
obj_t BgL_protocolz00_302;
BgL_protocolz00_302 = BgL_protocolz00_268; 
{ /* Llib/ssl.scm 604 */
obj_t BgL_timeoutz00_303;
BgL_timeoutz00_303 = BgL_timeoutz00_269; 
{ /* Llib/ssl.scm 604 */
obj_t BgL_hostnamez00_1808;int BgL_portz00_1809;
if(
STRINGP(BgL_arg1566z00_294))
{ /* Llib/ssl.scm 604 */
BgL_hostnamez00_1808 = BgL_arg1566z00_294; }  else 
{ 
obj_t BgL_auxz00_6836;
BgL_auxz00_6836 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)24675)), BGl_string3411z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_arg1566z00_294); 
FAILURE(BgL_auxz00_6836,BFALSE,BFALSE);} 
{ /* Llib/ssl.scm 604 */
obj_t BgL_tmpz00_6840;
if(
INTEGERP(BgL_arg1567z00_295))
{ /* Llib/ssl.scm 604 */
BgL_tmpz00_6840 = BgL_arg1567z00_295
; }  else 
{ 
obj_t BgL_auxz00_6843;
BgL_auxz00_6843 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)24675)), BGl_string3411z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_arg1567z00_295); 
FAILURE(BgL_auxz00_6843,BFALSE,BFALSE);} 
BgL_portz00_1809 = 
CINT(BgL_tmpz00_6840); } 
BGl_sanityzd2argszd2checksz00zz__ssl_sslz00(
CNST_TABLE_REF(((long)2)), BgL_certz00_298, BgL_pkeyz00_301, BgL_casz00_296, BgL_acceptedzd2certszd2_297); 
BGl_z52socketzd2initz12z92zz__socketz00(); 
{ /* Llib/ssl.scm 614 */
obj_t BgL_arg1603z00_1810;obj_t BgL_arg1606z00_1811;obj_t BgL_arg1612z00_1812;
BgL_arg1603z00_1810 = 
BGl_sslzd2protocolszd2ze3integerze3zz__ssl_sslz00(BgL_protocolz00_302); 
BgL_arg1606z00_1811 = 
BGl_getzd2portzd2bufferz00zz__r4_ports_6_10_1z00(
CNST_TABLE_REF(((long)2)), BgL_inbufz00_299, 
(int)(default_io_bufsiz)); 
BgL_arg1612z00_1812 = 
BGl_getzd2portzd2bufferz00zz__r4_ports_6_10_1z00(
CNST_TABLE_REF(((long)2)), BgL_outbufz00_300, 
(int)(default_io_bufsiz)); 
{ /* Llib/ssl.scm 613 */
obj_t BgL_auxz00_6876;int BgL_auxz00_6867;int BgL_tmpz00_6858;
if(
BGl_pairzd2orzd2nullzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_casz00_296))
{ /* Llib/ssl.scm 616 */
BgL_auxz00_6876 = BgL_casz00_296
; }  else 
{ 
obj_t BgL_auxz00_6879;
BgL_auxz00_6879 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)25064)), BGl_string3411z00zz__ssl_sslz00, BGl_string3414z00zz__ssl_sslz00, BgL_casz00_296); 
FAILURE(BgL_auxz00_6879,BFALSE,BFALSE);} 
{ /* Llib/ssl.scm 614 */
obj_t BgL_tmpz00_6868;
if(
INTEGERP(BgL_arg1603z00_1810))
{ /* Llib/ssl.scm 614 */
BgL_tmpz00_6868 = BgL_arg1603z00_1810
; }  else 
{ 
obj_t BgL_auxz00_6871;
BgL_auxz00_6871 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)25040)), BGl_string3411z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_arg1603z00_1810); 
FAILURE(BgL_auxz00_6871,BFALSE,BFALSE);} 
BgL_auxz00_6867 = 
CINT(BgL_tmpz00_6868); } 
{ /* Llib/ssl.scm 613 */
obj_t BgL_tmpz00_6859;
if(
INTEGERP(BgL_timeoutz00_303))
{ /* Llib/ssl.scm 613 */
BgL_tmpz00_6859 = BgL_timeoutz00_303
; }  else 
{ 
obj_t BgL_auxz00_6862;
BgL_auxz00_6862 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)24994)), BGl_string3411z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_timeoutz00_303); 
FAILURE(BgL_auxz00_6862,BFALSE,BFALSE);} 
BgL_tmpz00_6858 = 
CINT(BgL_tmpz00_6859); } 
return 
bgl_make_ssl_client_socket(BgL_hostnamez00_1808, BgL_portz00_1809, BgL_tmpz00_6858, BgL_auxz00_6867, BgL_certz00_298, BgL_pkeyz00_301, BgL_auxz00_6876, BgL_acceptedzd2certszd2_297, BgL_arg1606z00_1811, BgL_arg1612z00_1812);} } } } } } } } } } } } } } } } } } } } } } } 
BGL_FUNCTION_END;
}



/* search1212~0 */
obj_t BGl_search1212ze70ze7zz__ssl_sslz00(long BgL_l1211z00_5586, obj_t BgL_opt1210z00_5585, obj_t BgL_k1z00_257, long BgL_iz00_258)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 604 */
BGl_search1212ze70ze7zz__ssl_sslz00:
if(
(BgL_iz00_258==BgL_l1211z00_5586))
{ /* Llib/ssl.scm 604 */
return 
BINT(((long)-1));}  else 
{ /* Llib/ssl.scm 604 */
if(
(BgL_iz00_258==
(BgL_l1211z00_5586-((long)1))))
{ /* Llib/ssl.scm 604 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)2)), BGl_string3415z00zz__ssl_sslz00, 
BINT(
VECTOR_LENGTH(BgL_opt1210z00_5585)));}  else 
{ /* Llib/ssl.scm 604 */
obj_t BgL_vz00_308;
BgL_vz00_308 = 
VECTOR_REF(BgL_opt1210z00_5585,BgL_iz00_258); 
if(
(BgL_vz00_308==BgL_k1z00_257))
{ /* Llib/ssl.scm 604 */
return 
BINT(
(BgL_iz00_258+((long)1)));}  else 
{ 
long BgL_iz00_6899;
BgL_iz00_6899 = 
(BgL_iz00_258+((long)2)); 
BgL_iz00_258 = BgL_iz00_6899; 
goto BGl_search1212ze70ze7zz__ssl_sslz00;} } } } 
BGL_FUNCTION_END;
}



/* make-ssl-client-socket */
BGL_EXPORTED_DEF obj_t BGl_makezd2sslzd2clientzd2socketzd2zz__ssl_sslz00(obj_t BgL_hostnamez00_8, int BgL_portz00_9, obj_t BgL_casz00_10, obj_t BgL_acceptedzd2certszd2_11, obj_t BgL_certz00_12, obj_t BgL_inbufz00_13, obj_t BgL_outbufz00_14, obj_t BgL_pkeyz00_15, obj_t BgL_protocolz00_16, obj_t BgL_timeoutz00_17)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 604 */
BGl_sanityzd2argszd2checksz00zz__ssl_sslz00(
CNST_TABLE_REF(((long)2)), BgL_certz00_12, BgL_pkeyz00_15, BgL_casz00_10, BgL_acceptedzd2certszd2_11); 
BGl_z52socketzd2initz12z92zz__socketz00(); 
{ /* Llib/ssl.scm 614 */
obj_t BgL_arg1603z00_1813;obj_t BgL_arg1606z00_1814;obj_t BgL_arg1612z00_1815;
BgL_arg1603z00_1813 = 
BGl_sslzd2protocolszd2ze3integerze3zz__ssl_sslz00(BgL_protocolz00_16); 
BgL_arg1606z00_1814 = 
BGl_getzd2portzd2bufferz00zz__r4_ports_6_10_1z00(
CNST_TABLE_REF(((long)2)), BgL_inbufz00_13, 
(int)(default_io_bufsiz)); 
BgL_arg1612z00_1815 = 
BGl_getzd2portzd2bufferz00zz__r4_ports_6_10_1z00(
CNST_TABLE_REF(((long)2)), BgL_outbufz00_14, 
(int)(default_io_bufsiz)); 
return 
bgl_make_ssl_client_socket(BgL_hostnamez00_8, BgL_portz00_9, 
CINT(BgL_timeoutz00_17), 
CINT(BgL_arg1603z00_1813), BgL_certz00_12, BgL_pkeyz00_15, BgL_casz00_10, BgL_acceptedzd2certszd2_11, BgL_arg1606z00_1814, BgL_arg1612z00_1815);} } 
BGL_FUNCTION_END;
}



/* _client-socket-use-ssl! */
obj_t BGl__clientzd2socketzd2usezd2sslz12zc0zz__ssl_sslz00(obj_t BgL_envz00_27, obj_t BgL_opt1225z00_26)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 627 */
{ /* Llib/ssl.scm 627 */
obj_t BgL_g1235z00_319;
BgL_g1235z00_319 = 
VECTOR_REF(BgL_opt1225z00_26,((long)0)); 
{ /* Llib/ssl.scm 630 */
obj_t BgL_casz00_320;
BgL_casz00_320 = BNIL; 
{ /* Llib/ssl.scm 627 */
obj_t BgL_acceptedzd2certszd2_321;
BgL_acceptedzd2certszd2_321 = BFALSE; 
{ /* Llib/ssl.scm 627 */
obj_t BgL_certz00_322;
BgL_certz00_322 = BFALSE; 
{ /* Llib/ssl.scm 627 */
obj_t BgL_pkeyz00_323;
BgL_pkeyz00_323 = BFALSE; 
{ /* Llib/ssl.scm 628 */
obj_t BgL_protocolz00_324;
BgL_protocolz00_324 = 
CNST_TABLE_REF(((long)0)); 
{ /* Llib/ssl.scm 627 */

{ 
long BgL_iz00_325;
BgL_iz00_325 = ((long)1); 
BgL_check1228z00_326:
if(
(BgL_iz00_325==
VECTOR_LENGTH(BgL_opt1225z00_26)))
{ /* Llib/ssl.scm 627 */BNIL; }  else 
{ /* Llib/ssl.scm 627 */
bool_t BgL_testz00_6919;
{ /* Llib/ssl.scm 627 */
obj_t BgL_arg1644z00_332;
BgL_arg1644z00_332 = 
VECTOR_REF(BgL_opt1225z00_26,BgL_iz00_325); 
BgL_testz00_6919 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1644z00_332, 
CNST_TABLE_REF(((long)11)))); } 
if(BgL_testz00_6919)
{ 
long BgL_iz00_6924;
BgL_iz00_6924 = 
(BgL_iz00_325+((long)2)); 
BgL_iz00_325 = BgL_iz00_6924; 
goto BgL_check1228z00_326;}  else 
{ /* Llib/ssl.scm 627 */
obj_t BgL_arg1641z00_331;
BgL_arg1641z00_331 = 
VECTOR_REF(BgL_opt1225z00_26,BgL_iz00_325); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)12)), BGl_string3409z00zz__ssl_sslz00, BgL_arg1641z00_331); } } } 
{ /* Llib/ssl.scm 627 */
obj_t BgL_index1230z00_333;
BgL_index1230z00_333 = 
BGl_search1227ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1225z00_26), BgL_opt1225z00_26, 
CNST_TABLE_REF(((long)3)), ((long)1)); 
{ /* Llib/ssl.scm 627 */
bool_t BgL_testz00_6932;
{ /* Llib/ssl.scm 627 */
long BgL_n1z00_1838;
{ /* Llib/ssl.scm 627 */
obj_t BgL_tmpz00_6933;
if(
INTEGERP(BgL_index1230z00_333))
{ /* Llib/ssl.scm 627 */
BgL_tmpz00_6933 = BgL_index1230z00_333
; }  else 
{ 
obj_t BgL_auxz00_6936;
BgL_auxz00_6936 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)25465)), BGl_string3416z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1230z00_333); 
FAILURE(BgL_auxz00_6936,BFALSE,BFALSE);} 
BgL_n1z00_1838 = 
(long)CINT(BgL_tmpz00_6933); } 
BgL_testz00_6932 = 
(BgL_n1z00_1838>=((long)0)); } 
if(BgL_testz00_6932)
{ 
long BgL_auxz00_6942;
{ /* Llib/ssl.scm 627 */
obj_t BgL_tmpz00_6943;
if(
INTEGERP(BgL_index1230z00_333))
{ /* Llib/ssl.scm 627 */
BgL_tmpz00_6943 = BgL_index1230z00_333
; }  else 
{ 
obj_t BgL_auxz00_6946;
BgL_auxz00_6946 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)25465)), BGl_string3416z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1230z00_333); 
FAILURE(BgL_auxz00_6946,BFALSE,BFALSE);} 
BgL_auxz00_6942 = 
(long)CINT(BgL_tmpz00_6943); } 
BgL_casz00_320 = 
VECTOR_REF(BgL_opt1225z00_26,BgL_auxz00_6942); }  else 
{ /* Llib/ssl.scm 627 */BFALSE; } } } 
{ /* Llib/ssl.scm 627 */
obj_t BgL_index1231z00_335;
BgL_index1231z00_335 = 
BGl_search1227ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1225z00_26), BgL_opt1225z00_26, 
CNST_TABLE_REF(((long)4)), ((long)1)); 
{ /* Llib/ssl.scm 627 */
bool_t BgL_testz00_6955;
{ /* Llib/ssl.scm 627 */
long BgL_n1z00_1840;
{ /* Llib/ssl.scm 627 */
obj_t BgL_tmpz00_6956;
if(
INTEGERP(BgL_index1231z00_335))
{ /* Llib/ssl.scm 627 */
BgL_tmpz00_6956 = BgL_index1231z00_335
; }  else 
{ 
obj_t BgL_auxz00_6959;
BgL_auxz00_6959 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)25465)), BGl_string3416z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1231z00_335); 
FAILURE(BgL_auxz00_6959,BFALSE,BFALSE);} 
BgL_n1z00_1840 = 
(long)CINT(BgL_tmpz00_6956); } 
BgL_testz00_6955 = 
(BgL_n1z00_1840>=((long)0)); } 
if(BgL_testz00_6955)
{ 
long BgL_auxz00_6965;
{ /* Llib/ssl.scm 627 */
obj_t BgL_tmpz00_6966;
if(
INTEGERP(BgL_index1231z00_335))
{ /* Llib/ssl.scm 627 */
BgL_tmpz00_6966 = BgL_index1231z00_335
; }  else 
{ 
obj_t BgL_auxz00_6969;
BgL_auxz00_6969 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)25465)), BGl_string3416z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1231z00_335); 
FAILURE(BgL_auxz00_6969,BFALSE,BFALSE);} 
BgL_auxz00_6965 = 
(long)CINT(BgL_tmpz00_6966); } 
BgL_acceptedzd2certszd2_321 = 
VECTOR_REF(BgL_opt1225z00_26,BgL_auxz00_6965); }  else 
{ /* Llib/ssl.scm 627 */BFALSE; } } } 
{ /* Llib/ssl.scm 627 */
obj_t BgL_index1232z00_337;
BgL_index1232z00_337 = 
BGl_search1227ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1225z00_26), BgL_opt1225z00_26, 
CNST_TABLE_REF(((long)5)), ((long)1)); 
{ /* Llib/ssl.scm 627 */
bool_t BgL_testz00_6978;
{ /* Llib/ssl.scm 627 */
long BgL_n1z00_1842;
{ /* Llib/ssl.scm 627 */
obj_t BgL_tmpz00_6979;
if(
INTEGERP(BgL_index1232z00_337))
{ /* Llib/ssl.scm 627 */
BgL_tmpz00_6979 = BgL_index1232z00_337
; }  else 
{ 
obj_t BgL_auxz00_6982;
BgL_auxz00_6982 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)25465)), BGl_string3416z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1232z00_337); 
FAILURE(BgL_auxz00_6982,BFALSE,BFALSE);} 
BgL_n1z00_1842 = 
(long)CINT(BgL_tmpz00_6979); } 
BgL_testz00_6978 = 
(BgL_n1z00_1842>=((long)0)); } 
if(BgL_testz00_6978)
{ 
long BgL_auxz00_6988;
{ /* Llib/ssl.scm 627 */
obj_t BgL_tmpz00_6989;
if(
INTEGERP(BgL_index1232z00_337))
{ /* Llib/ssl.scm 627 */
BgL_tmpz00_6989 = BgL_index1232z00_337
; }  else 
{ 
obj_t BgL_auxz00_6992;
BgL_auxz00_6992 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)25465)), BGl_string3416z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1232z00_337); 
FAILURE(BgL_auxz00_6992,BFALSE,BFALSE);} 
BgL_auxz00_6988 = 
(long)CINT(BgL_tmpz00_6989); } 
BgL_certz00_322 = 
VECTOR_REF(BgL_opt1225z00_26,BgL_auxz00_6988); }  else 
{ /* Llib/ssl.scm 627 */BFALSE; } } } 
{ /* Llib/ssl.scm 627 */
obj_t BgL_index1233z00_339;
BgL_index1233z00_339 = 
BGl_search1227ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1225z00_26), BgL_opt1225z00_26, 
CNST_TABLE_REF(((long)8)), ((long)1)); 
{ /* Llib/ssl.scm 627 */
bool_t BgL_testz00_7001;
{ /* Llib/ssl.scm 627 */
long BgL_n1z00_1844;
{ /* Llib/ssl.scm 627 */
obj_t BgL_tmpz00_7002;
if(
INTEGERP(BgL_index1233z00_339))
{ /* Llib/ssl.scm 627 */
BgL_tmpz00_7002 = BgL_index1233z00_339
; }  else 
{ 
obj_t BgL_auxz00_7005;
BgL_auxz00_7005 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)25465)), BGl_string3416z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1233z00_339); 
FAILURE(BgL_auxz00_7005,BFALSE,BFALSE);} 
BgL_n1z00_1844 = 
(long)CINT(BgL_tmpz00_7002); } 
BgL_testz00_7001 = 
(BgL_n1z00_1844>=((long)0)); } 
if(BgL_testz00_7001)
{ 
long BgL_auxz00_7011;
{ /* Llib/ssl.scm 627 */
obj_t BgL_tmpz00_7012;
if(
INTEGERP(BgL_index1233z00_339))
{ /* Llib/ssl.scm 627 */
BgL_tmpz00_7012 = BgL_index1233z00_339
; }  else 
{ 
obj_t BgL_auxz00_7015;
BgL_auxz00_7015 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)25465)), BGl_string3416z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1233z00_339); 
FAILURE(BgL_auxz00_7015,BFALSE,BFALSE);} 
BgL_auxz00_7011 = 
(long)CINT(BgL_tmpz00_7012); } 
BgL_pkeyz00_323 = 
VECTOR_REF(BgL_opt1225z00_26,BgL_auxz00_7011); }  else 
{ /* Llib/ssl.scm 627 */BFALSE; } } } 
{ /* Llib/ssl.scm 627 */
obj_t BgL_index1234z00_341;
BgL_index1234z00_341 = 
BGl_search1227ze70ze7zz__ssl_sslz00(
VECTOR_LENGTH(BgL_opt1225z00_26), BgL_opt1225z00_26, 
CNST_TABLE_REF(((long)9)), ((long)1)); 
{ /* Llib/ssl.scm 627 */
bool_t BgL_testz00_7024;
{ /* Llib/ssl.scm 627 */
long BgL_n1z00_1846;
{ /* Llib/ssl.scm 627 */
obj_t BgL_tmpz00_7025;
if(
INTEGERP(BgL_index1234z00_341))
{ /* Llib/ssl.scm 627 */
BgL_tmpz00_7025 = BgL_index1234z00_341
; }  else 
{ 
obj_t BgL_auxz00_7028;
BgL_auxz00_7028 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)25465)), BGl_string3416z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1234z00_341); 
FAILURE(BgL_auxz00_7028,BFALSE,BFALSE);} 
BgL_n1z00_1846 = 
(long)CINT(BgL_tmpz00_7025); } 
BgL_testz00_7024 = 
(BgL_n1z00_1846>=((long)0)); } 
if(BgL_testz00_7024)
{ 
long BgL_auxz00_7034;
{ /* Llib/ssl.scm 627 */
obj_t BgL_tmpz00_7035;
if(
INTEGERP(BgL_index1234z00_341))
{ /* Llib/ssl.scm 627 */
BgL_tmpz00_7035 = BgL_index1234z00_341
; }  else 
{ 
obj_t BgL_auxz00_7038;
BgL_auxz00_7038 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)25465)), BGl_string3416z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_index1234z00_341); 
FAILURE(BgL_auxz00_7038,BFALSE,BFALSE);} 
BgL_auxz00_7034 = 
(long)CINT(BgL_tmpz00_7035); } 
BgL_protocolz00_324 = 
VECTOR_REF(BgL_opt1225z00_26,BgL_auxz00_7034); }  else 
{ /* Llib/ssl.scm 627 */BFALSE; } } } 
{ /* Llib/ssl.scm 627 */
obj_t BgL_arg1652z00_343;
BgL_arg1652z00_343 = 
VECTOR_REF(BgL_opt1225z00_26,((long)0)); 
{ /* Llib/ssl.scm 627 */
obj_t BgL_casz00_344;
BgL_casz00_344 = BgL_casz00_320; 
{ /* Llib/ssl.scm 627 */
obj_t BgL_acceptedzd2certszd2_345;
BgL_acceptedzd2certszd2_345 = BgL_acceptedzd2certszd2_321; 
{ /* Llib/ssl.scm 627 */
obj_t BgL_certz00_346;
BgL_certz00_346 = BgL_certz00_322; 
{ /* Llib/ssl.scm 627 */
obj_t BgL_pkeyz00_347;
BgL_pkeyz00_347 = BgL_pkeyz00_323; 
{ /* Llib/ssl.scm 627 */
obj_t BgL_protocolz00_348;
BgL_protocolz00_348 = BgL_protocolz00_324; 
{ /* Llib/ssl.scm 627 */
obj_t BgL_sz00_1848;
if(
SOCKETP(BgL_arg1652z00_343))
{ /* Llib/ssl.scm 627 */
BgL_sz00_1848 = BgL_arg1652z00_343; }  else 
{ 
obj_t BgL_auxz00_7047;
BgL_auxz00_7047 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)25465)), BGl_string3416z00zz__ssl_sslz00, BGl_string3417z00zz__ssl_sslz00, BgL_arg1652z00_343); 
FAILURE(BgL_auxz00_7047,BFALSE,BFALSE);} 
BGl_sanityzd2argszd2checksz00zz__ssl_sslz00(
CNST_TABLE_REF(((long)12)), BgL_certz00_346, BgL_pkeyz00_347, BgL_casz00_344, BgL_acceptedzd2certszd2_345); 
BGl_z52socketzd2initz12z92zz__socketz00(); 
{ /* Llib/ssl.scm 634 */
obj_t BgL_arg1667z00_1849;
BgL_arg1667z00_1849 = 
BGl_sslzd2protocolszd2ze3integerze3zz__ssl_sslz00(BgL_protocolz00_348); 
{ /* Llib/ssl.scm 633 */
obj_t BgL_auxz00_7064;int BgL_tmpz00_7055;
if(
BGl_pairzd2orzd2nullzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_casz00_344))
{ /* Llib/ssl.scm 636 */
BgL_auxz00_7064 = BgL_casz00_344
; }  else 
{ 
obj_t BgL_auxz00_7067;
BgL_auxz00_7067 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)25779)), BGl_string3416z00zz__ssl_sslz00, BGl_string3414z00zz__ssl_sslz00, BgL_casz00_344); 
FAILURE(BgL_auxz00_7067,BFALSE,BFALSE);} 
{ /* Llib/ssl.scm 634 */
obj_t BgL_tmpz00_7056;
if(
INTEGERP(BgL_arg1667z00_1849))
{ /* Llib/ssl.scm 634 */
BgL_tmpz00_7056 = BgL_arg1667z00_1849
; }  else 
{ 
obj_t BgL_auxz00_7059;
BgL_auxz00_7059 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)25755)), BGl_string3416z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_arg1667z00_1849); 
FAILURE(BgL_auxz00_7059,BFALSE,BFALSE);} 
BgL_tmpz00_7055 = 
CINT(BgL_tmpz00_7056); } 
return 
bgl_client_socket_use_ssl(BgL_sz00_1848, BgL_tmpz00_7055, BgL_certz00_346, BgL_pkeyz00_347, BgL_auxz00_7064, BgL_acceptedzd2certszd2_345);} } } } } } } } } } } } } } } } } 
BGL_FUNCTION_END;
}



/* search1227~0 */
obj_t BGl_search1227ze70ze7zz__ssl_sslz00(long BgL_l1226z00_5584, obj_t BgL_opt1225z00_5583, obj_t BgL_k1z00_316, long BgL_iz00_317)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 627 */
BGl_search1227ze70ze7zz__ssl_sslz00:
if(
(BgL_iz00_317==BgL_l1226z00_5584))
{ /* Llib/ssl.scm 627 */
return 
BINT(((long)-1));}  else 
{ /* Llib/ssl.scm 627 */
if(
(BgL_iz00_317==
(BgL_l1226z00_5584-((long)1))))
{ /* Llib/ssl.scm 627 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)12)), BGl_string3418z00zz__ssl_sslz00, 
BINT(
VECTOR_LENGTH(BgL_opt1225z00_5583)));}  else 
{ /* Llib/ssl.scm 627 */
obj_t BgL_vz00_353;
BgL_vz00_353 = 
VECTOR_REF(BgL_opt1225z00_5583,BgL_iz00_317); 
if(
(BgL_vz00_353==BgL_k1z00_316))
{ /* Llib/ssl.scm 627 */
return 
BINT(
(BgL_iz00_317+((long)1)));}  else 
{ 
long BgL_iz00_7087;
BgL_iz00_7087 = 
(BgL_iz00_317+((long)2)); 
BgL_iz00_317 = BgL_iz00_7087; 
goto BGl_search1227ze70ze7zz__ssl_sslz00;} } } } 
BGL_FUNCTION_END;
}



/* client-socket-use-ssl! */
BGL_EXPORTED_DEF obj_t BGl_clientzd2socketzd2usezd2sslz12zc0zz__ssl_sslz00(obj_t BgL_sz00_20, obj_t BgL_casz00_21, obj_t BgL_acceptedzd2certszd2_22, obj_t BgL_certz00_23, obj_t BgL_pkeyz00_24, obj_t BgL_protocolz00_25)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 627 */
BGl_sanityzd2argszd2checksz00zz__ssl_sslz00(
CNST_TABLE_REF(((long)12)), BgL_certz00_23, BgL_pkeyz00_24, BgL_casz00_21, BgL_acceptedzd2certszd2_22); 
BGl_z52socketzd2initz12z92zz__socketz00(); 
{ /* Llib/ssl.scm 634 */
obj_t BgL_arg1667z00_1850;
BgL_arg1667z00_1850 = 
BGl_sslzd2protocolszd2ze3integerze3zz__ssl_sslz00(BgL_protocolz00_25); 
return 
bgl_client_socket_use_ssl(BgL_sz00_20, 
CINT(BgL_arg1667z00_1850), BgL_certz00_23, BgL_pkeyz00_24, BgL_casz00_21, BgL_acceptedzd2certszd2_22);} } 
BGL_FUNCTION_END;
}



/* ssl-socket? */
BGL_EXPORTED_DEF bool_t BGl_sslzd2socketzf3z21zz__ssl_sslz00(obj_t BgL_objz00_28)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 641 */
return 
bgl_ssl_socketp(BgL_objz00_28);} 
BGL_FUNCTION_END;
}



/* &ssl-socket? */
obj_t BGl_z62sslzd2socketzf3z43zz__ssl_sslz00(obj_t BgL_envz00_4582, obj_t BgL_objz00_4583)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 641 */
return 
BBOOL(
BGl_sslzd2socketzf3z21zz__ssl_sslz00(BgL_objz00_4583));} 
BGL_FUNCTION_END;
}



/* make-ssl-server-socket */
BGL_EXPORTED_DEF obj_t BGl_makezd2sslzd2serverzd2socketzd2zz__ssl_sslz00(obj_t BgL_portz00_29)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 649 */
{ /* Llib/ssl.scm 334 */
obj_t BgL_dsssl1236z00_358;
BgL_dsssl1236z00_358 = BgL_portz00_29; 
{ /* Llib/ssl.scm 334 */
obj_t BgL_portz00_359;
{ /* Llib/ssl.scm 334 */
bool_t BgL_testz00_7098;
if(
NULLP(BgL_dsssl1236z00_358))
{ /* Llib/ssl.scm 334 */
BgL_testz00_7098 = ((bool_t)1)
; }  else 
{ /* Llib/ssl.scm 334 */
BgL_testz00_7098 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(
CAR(BgL_dsssl1236z00_358), 
CNST_TABLE_REF(((long)13))))
; } 
if(BgL_testz00_7098)
{ /* Llib/ssl.scm 334 */
BgL_portz00_359 = 
BINT(((long)0)); }  else 
{ /* Llib/ssl.scm 334 */
obj_t BgL_tmp1237z00_385;
BgL_tmp1237z00_385 = 
CAR(BgL_dsssl1236z00_358); 
BgL_dsssl1236z00_358 = 
CDR(BgL_dsssl1236z00_358); 
BgL_portz00_359 = BgL_tmp1237z00_385; } } 
{ /* Llib/ssl.scm 334 */
obj_t BgL_namez00_360;
BgL_namez00_360 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_dsssl1236z00_358, 
CNST_TABLE_REF(((long)14)), BFALSE); 
{ /* Llib/ssl.scm 334 */
obj_t BgL_protocolz00_361;
BgL_protocolz00_361 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_dsssl1236z00_358, 
CNST_TABLE_REF(((long)9)), 
CNST_TABLE_REF(((long)0))); 
{ /* Llib/ssl.scm 334 */
obj_t BgL_certz00_362;
BgL_certz00_362 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_dsssl1236z00_358, 
CNST_TABLE_REF(((long)5)), BFALSE); 
{ /* Llib/ssl.scm 334 */
obj_t BgL_pkeyz00_363;
BgL_pkeyz00_363 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_dsssl1236z00_358, 
CNST_TABLE_REF(((long)8)), BFALSE); 
{ /* Llib/ssl.scm 334 */
obj_t BgL_casz00_364;
BgL_casz00_364 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_dsssl1236z00_358, 
CNST_TABLE_REF(((long)3)), BNIL); 
{ /* Llib/ssl.scm 334 */
obj_t BgL_acceptedzd2certszd2_365;
BgL_acceptedzd2certszd2_365 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_dsssl1236z00_358, 
CNST_TABLE_REF(((long)4)), BFALSE); 
{ /* Llib/ssl.scm 334 */
obj_t BgL_backlogz00_366;
BgL_backlogz00_366 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_dsssl1236z00_358, 
CNST_TABLE_REF(((long)15)), 
BINT(((long)5))); 
{ /* Llib/ssl.scm 334 */
obj_t BgL_ipv6z00_367;
BgL_ipv6z00_367 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_dsssl1236z00_358, 
CNST_TABLE_REF(((long)16)), BFALSE); 
if(
NULLP(
BGl_dssslzd2getzd2keyzd2restzd2argz00zz__dssslz00(BgL_dsssl1236z00_358, 
CNST_TABLE_REF(((long)13)))))
{ /* Llib/ssl.scm 334 */
BGl_sanityzd2argszd2checksz00zz__ssl_sslz00(
CNST_TABLE_REF(((long)17)), BgL_certz00_362, BgL_pkeyz00_363, BgL_casz00_364, BgL_acceptedzd2certszd2_365); 
BGl_z52socketzd2initz12z92zz__socketz00(); 
{ /* Llib/ssl.scm 657 */
obj_t BgL_arg1672z00_370;
BgL_arg1672z00_370 = 
BGl_sslzd2protocolszd2ze3integerze3zz__ssl_sslz00(BgL_protocolz00_361); 
return 
bgl_make_ssl_server_socket(BgL_namez00_360, 
CINT(BgL_portz00_359), 
CINT(BgL_arg1672z00_370), BgL_certz00_362, BgL_pkeyz00_363, BgL_casz00_364, BgL_acceptedzd2certszd2_365, 
CINT(BgL_backlogz00_366), 
CBOOL(BgL_ipv6z00_367));} }  else 
{ /* Llib/ssl.scm 334 */
obj_t BgL_arg1675z00_371;
{ /* Llib/ssl.scm 334 */
obj_t BgL_arg1676z00_372;
{ /* Llib/ssl.scm 334 */
obj_t BgL_arg1679z00_375;
BgL_arg1679z00_375 = 
BGl_dssslzd2getzd2keyzd2restzd2argz00zz__dssslz00(BgL_dsssl1236z00_358, 
CNST_TABLE_REF(((long)13))); 
{ /* Llib/ssl.scm 334 */
obj_t BgL_list1680z00_376;
BgL_list1680z00_376 = 
MAKE_YOUNG_PAIR(BgL_arg1679z00_375, BNIL); 
BgL_arg1676z00_372 = 
BGl_mapz00zz__r4_control_features_6_9z00(BGl_proc3419z00zz__ssl_sslz00, BgL_list1680z00_376); } } 
{ /* Llib/ssl.scm 334 */
obj_t BgL_list1677z00_373;
BgL_list1677z00_373 = 
MAKE_YOUNG_PAIR(BgL_arg1676z00_372, BNIL); 
BgL_arg1675z00_371 = 
BGl_applyz00zz__r4_control_features_6_9z00(BGl_stringzd2appendzd2envz00zz__r4_strings_6_7z00, BGl_string3420z00zz__ssl_sslz00, BgL_list1677z00_373); } } 
return 
BGl_errorz00zz__errorz00(BGl_string3421z00zz__ssl_sslz00, BgL_arg1675z00_371, BgL_dsssl1236z00_358);} } } } } } } } } } } } 
BGL_FUNCTION_END;
}



/* &make-ssl-server-socket */
obj_t BGl_z62makezd2sslzd2serverzd2socketzb0zz__ssl_sslz00(obj_t BgL_envz00_4585, obj_t BgL_portz00_4586)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 649 */
return 
BGl_makezd2sslzd2serverzd2socketzd2zz__ssl_sslz00(BgL_portz00_4586);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1681> */
obj_t BGl_z62zc3anonymousza31681ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4587, obj_t BgL_vz00_4588)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 334 */
{ /* Llib/ssl.scm 334 */
obj_t BgL_list1682z00_6098;
BgL_list1682z00_6098 = 
MAKE_YOUNG_PAIR(BgL_vz00_4588, BNIL); 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3422z00zz__ssl_sslz00, BgL_list1682z00_6098);} } 
BGL_FUNCTION_END;
}



/* ssl-protocols->integer */
obj_t BGl_sslzd2protocolszd2ze3integerze3zz__ssl_sslz00(obj_t BgL_protocolz00_30)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 664 */
{ /* Llib/ssl.scm 665 */
obj_t BgL_casezd2valuezd2_388;
{ /* Llib/ssl.scm 665 */
obj_t BgL_arg1704z00_402;
{ /* Llib/ssl.scm 665 */
obj_t BgL_arg1705z00_403;
{ /* Llib/ssl.scm 665 */
obj_t BgL_res2328z00_1859;
BgL_res2328z00_1859 = 
SYMBOL_TO_STRING(
((obj_t)BgL_protocolz00_30)); 
BgL_arg1705z00_403 = BgL_res2328z00_1859; } 
BgL_arg1704z00_402 = 
BGl_stringzd2downcasezd2zz__r4_strings_6_7z00(BgL_arg1705z00_403); } 
BgL_casezd2valuezd2_388 = 
bstring_to_symbol(BgL_arg1704z00_402); } 
if(
(BgL_casezd2valuezd2_388==
CNST_TABLE_REF(((long)18))))
{ /* Llib/ssl.scm 665 */
return 
BINT(BGLSSL_SSLV2);}  else 
{ /* Llib/ssl.scm 665 */
if(
(BgL_casezd2valuezd2_388==
CNST_TABLE_REF(((long)19))))
{ /* Llib/ssl.scm 665 */
return 
BINT(BGLSSL_SSLV3);}  else 
{ /* Llib/ssl.scm 665 */
bool_t BgL_testz00_7161;
{ /* Llib/ssl.scm 665 */
bool_t BgL__ortest_1122z00_401;
BgL__ortest_1122z00_401 = 
(BgL_casezd2valuezd2_388==
CNST_TABLE_REF(((long)20))); 
if(BgL__ortest_1122z00_401)
{ /* Llib/ssl.scm 665 */
BgL_testz00_7161 = BgL__ortest_1122z00_401
; }  else 
{ /* Llib/ssl.scm 665 */
BgL_testz00_7161 = 
(BgL_casezd2valuezd2_388==
CNST_TABLE_REF(((long)0)))
; } } 
if(BgL_testz00_7161)
{ /* Llib/ssl.scm 665 */
return 
BINT(BGLSSL_SSLV23);}  else 
{ /* Llib/ssl.scm 665 */
bool_t BgL_testz00_7168;
{ /* Llib/ssl.scm 665 */
bool_t BgL__ortest_1123z00_400;
BgL__ortest_1123z00_400 = 
(BgL_casezd2valuezd2_388==
CNST_TABLE_REF(((long)21))); 
if(BgL__ortest_1123z00_400)
{ /* Llib/ssl.scm 665 */
BgL_testz00_7168 = BgL__ortest_1123z00_400
; }  else 
{ /* Llib/ssl.scm 665 */
BgL_testz00_7168 = 
(BgL_casezd2valuezd2_388==
CNST_TABLE_REF(((long)22)))
; } } 
if(BgL_testz00_7168)
{ /* Llib/ssl.scm 665 */
return 
BINT(BGLSSL_TLSV1);}  else 
{ /* Llib/ssl.scm 665 */
if(
(BgL_casezd2valuezd2_388==
CNST_TABLE_REF(((long)23))))
{ /* Llib/ssl.scm 665 */
return 
BINT(BGLSSL_TLSV1_1);}  else 
{ /* Llib/ssl.scm 665 */
if(
(BgL_casezd2valuezd2_388==
CNST_TABLE_REF(((long)24))))
{ /* Llib/ssl.scm 665 */
return 
BINT(BGLSSL_TLSV1_2);}  else 
{ /* Llib/ssl.scm 665 */
bool_t BgL_testz00_7183;
{ /* Llib/ssl.scm 665 */
bool_t BgL__ortest_1124z00_399;
BgL__ortest_1124z00_399 = 
(BgL_casezd2valuezd2_388==
CNST_TABLE_REF(((long)25))); 
if(BgL__ortest_1124z00_399)
{ /* Llib/ssl.scm 665 */
BgL_testz00_7183 = BgL__ortest_1124z00_399
; }  else 
{ /* Llib/ssl.scm 665 */
BgL_testz00_7183 = 
(BgL_casezd2valuezd2_388==
CNST_TABLE_REF(((long)26)))
; } } 
if(BgL_testz00_7183)
{ /* Llib/ssl.scm 665 */
return 
BINT(BGLSSL_DTLSV1);}  else 
{ /* Llib/ssl.scm 665 */
return 
BGl_errorz00zz__errorz00(BGl_string3423z00zz__ssl_sslz00, BGl_string3424z00zz__ssl_sslz00, BgL_protocolz00_30);} } } } } } } } } 
BGL_FUNCTION_END;
}



/* read-private-key */
BGL_EXPORTED_DEF BgL_privatezd2keyzd2_bglt BGl_readzd2privatezd2keyz00zz__ssl_sslz00(obj_t BgL_filez00_31)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 678 */
return 
((BgL_privatezd2keyzd2_bglt)
bgl_ssl_load_private_key(BgL_filez00_31));} 
BGL_FUNCTION_END;
}



/* &read-private-key */
BgL_privatezd2keyzd2_bglt BGl_z62readzd2privatezd2keyz62zz__ssl_sslz00(obj_t BgL_envz00_4591, obj_t BgL_filez00_4592)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 678 */
{ /* Llib/ssl.scm 679 */
obj_t BgL_auxz00_7193;
if(
STRINGP(BgL_filez00_4592))
{ /* Llib/ssl.scm 679 */
BgL_auxz00_7193 = BgL_filez00_4592
; }  else 
{ 
obj_t BgL_auxz00_7196;
BgL_auxz00_7196 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)27747)), BGl_string3425z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_filez00_4592); 
FAILURE(BgL_auxz00_7196,BFALSE,BFALSE);} 
return 
BGl_readzd2privatezd2keyz00zz__ssl_sslz00(BgL_auxz00_7193);} } 
BGL_FUNCTION_END;
}



/* read-certificate */
BGL_EXPORTED_DEF BgL_certificatez00_bglt BGl_readzd2certificatezd2zz__ssl_sslz00(obj_t BgL_filez00_32)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 684 */
return 
((BgL_certificatez00_bglt)
bgl_ssl_load_certificate(BgL_filez00_32));} 
BGL_FUNCTION_END;
}



/* &read-certificate */
BgL_certificatez00_bglt BGl_z62readzd2certificatezb0zz__ssl_sslz00(obj_t BgL_envz00_4593, obj_t BgL_filez00_4594)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 684 */
{ /* Llib/ssl.scm 685 */
obj_t BgL_auxz00_7203;
if(
STRINGP(BgL_filez00_4594))
{ /* Llib/ssl.scm 685 */
BgL_auxz00_7203 = BgL_filez00_4594
; }  else 
{ 
obj_t BgL_auxz00_7206;
BgL_auxz00_7206 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)28053)), BGl_string3426z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_filez00_4594); 
FAILURE(BgL_auxz00_7206,BFALSE,BFALSE);} 
return 
BGl_readzd2certificatezd2zz__ssl_sslz00(BgL_auxz00_7203);} } 
BGL_FUNCTION_END;
}



/* read-pem-file */
BGL_EXPORTED_DEF obj_t BGl_readzd2pemzd2filez00zz__ssl_sslz00(obj_t BgL_filez00_33)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 690 */
return 
bgl_ssl_load_pem(BgL_filez00_33);} 
BGL_FUNCTION_END;
}



/* &read-pem-file */
obj_t BGl_z62readzd2pemzd2filez62zz__ssl_sslz00(obj_t BgL_envz00_4595, obj_t BgL_filez00_4596)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 690 */
{ /* Llib/ssl.scm 691 */
obj_t BgL_auxz00_7212;
if(
STRINGP(BgL_filez00_4596))
{ /* Llib/ssl.scm 691 */
BgL_auxz00_7212 = BgL_filez00_4596
; }  else 
{ 
obj_t BgL_auxz00_7215;
BgL_auxz00_7215 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)28353)), BGl_string3427z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_filez00_4596); 
FAILURE(BgL_auxz00_7215,BFALSE,BFALSE);} 
return 
BGl_readzd2pemzd2filez00zz__ssl_sslz00(BgL_auxz00_7212);} } 
BGL_FUNCTION_END;
}



/* ssl-rand-status */
BGL_EXPORTED_DEF bool_t BGl_sslzd2randzd2statusz00zz__ssl_sslz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 696 */
return 
RAND_status();} 
BGL_FUNCTION_END;
}



/* &ssl-rand-status */
obj_t BGl_z62sslzd2randzd2statusz62zz__ssl_sslz00(obj_t BgL_envz00_4597)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 696 */
return 
BBOOL(
BGl_sslzd2randzd2statusz00zz__ssl_sslz00());} 
BGL_FUNCTION_END;
}



/* ssl-rand-poll */
BGL_EXPORTED_DEF bool_t BGl_sslzd2randzd2pollz00zz__ssl_sslz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 704 */
return 
RAND_poll();} 
BGL_FUNCTION_END;
}



/* &ssl-rand-poll */
obj_t BGl_z62sslzd2randzd2pollz62zz__ssl_sslz00(obj_t BgL_envz00_4598)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 704 */
return 
BBOOL(
BGl_sslzd2randzd2pollz00zz__ssl_sslz00());} 
BGL_FUNCTION_END;
}



/* ssl-rand-bytes */
BGL_EXPORTED_DEF obj_t BGl_sslzd2randzd2bytesz00zz__ssl_sslz00(int BgL_sza7za7_34)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 712 */
{ /* Llib/ssl.scm 713 */
obj_t BgL_strz00_1870;
{ /* Llib/ssl.scm 713 */

BgL_strz00_1870 = 
make_string(
(long)(BgL_sza7za7_34), ((unsigned char)' ')); } 
{ /* Llib/ssl.scm 716 */
char * BgL_tmpz00_7228;
BgL_tmpz00_7228 = 
BSTRING_TO_STRING(BgL_strz00_1870); 
RAND_bytes(BgL_tmpz00_7228, BgL_sza7za7_34); } 
return BgL_strz00_1870;} } 
BGL_FUNCTION_END;
}



/* &ssl-rand-bytes */
obj_t BGl_z62sslzd2randzd2bytesz62zz__ssl_sslz00(obj_t BgL_envz00_4599, obj_t BgL_sza7za7_4600)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 712 */
{ /* Llib/ssl.scm 713 */
int BgL_auxz00_7231;
{ /* Llib/ssl.scm 713 */
obj_t BgL_tmpz00_7232;
if(
INTEGERP(BgL_sza7za7_4600))
{ /* Llib/ssl.scm 713 */
BgL_tmpz00_7232 = BgL_sza7za7_4600
; }  else 
{ 
obj_t BgL_auxz00_7235;
BgL_auxz00_7235 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)29276)), BGl_string3428z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_sza7za7_4600); 
FAILURE(BgL_auxz00_7235,BFALSE,BFALSE);} 
BgL_auxz00_7231 = 
CINT(BgL_tmpz00_7232); } 
return 
BGl_sslzd2randzd2bytesz00zz__ssl_sslz00(BgL_auxz00_7231);} } 
BGL_FUNCTION_END;
}



/* ssl-rand-pseudo-bytes */
BGL_EXPORTED_DEF obj_t BGl_sslzd2randzd2pseudozd2byteszd2zz__ssl_sslz00(int BgL_sza7za7_35)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 729 */
{ /* Llib/ssl.scm 730 */
obj_t BgL_strz00_1875;
{ /* Llib/ssl.scm 730 */

BgL_strz00_1875 = 
make_string(
(long)(BgL_sza7za7_35), ((unsigned char)' ')); } 
{ /* Llib/ssl.scm 733 */
char * BgL_tmpz00_7243;
BgL_tmpz00_7243 = 
BSTRING_TO_STRING(BgL_strz00_1875); 
RAND_pseudo_bytes(BgL_tmpz00_7243, BgL_sza7za7_35); } 
return BgL_strz00_1875;} } 
BGL_FUNCTION_END;
}



/* &ssl-rand-pseudo-bytes */
obj_t BGl_z62sslzd2randzd2pseudozd2byteszb0zz__ssl_sslz00(obj_t BgL_envz00_4601, obj_t BgL_sza7za7_4602)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 729 */
{ /* Llib/ssl.scm 730 */
int BgL_auxz00_7246;
{ /* Llib/ssl.scm 730 */
obj_t BgL_tmpz00_7247;
if(
INTEGERP(BgL_sza7za7_4602))
{ /* Llib/ssl.scm 730 */
BgL_tmpz00_7247 = BgL_sza7za7_4602
; }  else 
{ 
obj_t BgL_auxz00_7250;
BgL_auxz00_7250 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)29794)), BGl_string3429z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_sza7za7_4602); 
FAILURE(BgL_auxz00_7250,BFALSE,BFALSE);} 
BgL_auxz00_7246 = 
CINT(BgL_tmpz00_7247); } 
return 
BGl_sslzd2randzd2pseudozd2byteszd2zz__ssl_sslz00(BgL_auxz00_7246);} } 
BGL_FUNCTION_END;
}



/* certificate-subject */
BGL_EXPORTED_DEF obj_t BGl_certificatezd2subjectzd2zz__ssl_sslz00(BgL_certificatez00_bglt BgL_certz00_36)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 746 */
return 
bgl_ssl_certificate_subject(
((obj_t)BgL_certz00_36));} 
BGL_FUNCTION_END;
}



/* &certificate-subject */
obj_t BGl_z62certificatezd2subjectzb0zz__ssl_sslz00(obj_t BgL_envz00_4603, obj_t BgL_certz00_4604)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 746 */
{ /* Llib/ssl.scm 747 */
BgL_certificatez00_bglt BgL_auxz00_7258;
if(
BGl_isazf3zf3zz__objectz00(BgL_certz00_4604, BGl_certificatez00zz__ssl_sslz00))
{ /* Llib/ssl.scm 747 */
BgL_auxz00_7258 = 
((BgL_certificatez00_bglt)BgL_certz00_4604)
; }  else 
{ 
obj_t BgL_auxz00_7262;
BgL_auxz00_7262 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)30343)), BGl_string3430z00zz__ssl_sslz00, BGl_string3431z00zz__ssl_sslz00, BgL_certz00_4604); 
FAILURE(BgL_auxz00_7262,BFALSE,BFALSE);} 
return 
BGl_certificatezd2subjectzd2zz__ssl_sslz00(BgL_auxz00_7258);} } 
BGL_FUNCTION_END;
}



/* certificate-issuer */
BGL_EXPORTED_DEF obj_t BGl_certificatezd2issuerzd2zz__ssl_sslz00(BgL_certificatez00_bglt BgL_certz00_37)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 752 */
return 
bgl_ssl_certificate_issuer(
((obj_t)BgL_certz00_37));} 
BGL_FUNCTION_END;
}



/* &certificate-issuer */
obj_t BGl_z62certificatezd2issuerzb0zz__ssl_sslz00(obj_t BgL_envz00_4605, obj_t BgL_certz00_4606)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 752 */
{ /* Llib/ssl.scm 753 */
BgL_certificatez00_bglt BgL_auxz00_7269;
if(
BGl_isazf3zf3zz__objectz00(BgL_certz00_4606, BGl_certificatez00zz__ssl_sslz00))
{ /* Llib/ssl.scm 753 */
BgL_auxz00_7269 = 
((BgL_certificatez00_bglt)BgL_certz00_4606)
; }  else 
{ 
obj_t BgL_auxz00_7273;
BgL_auxz00_7273 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)30661)), BGl_string3432z00zz__ssl_sslz00, BGl_string3431z00zz__ssl_sslz00, BgL_certz00_4606); 
FAILURE(BgL_auxz00_7273,BFALSE,BFALSE);} 
return 
BGl_certificatezd2issuerzd2zz__ssl_sslz00(BgL_auxz00_7269);} } 
BGL_FUNCTION_END;
}



/* %make-certificate */
BGL_EXPORTED_DEF obj_t bgl_make_certificate(void * BgL_certz00_38)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 758 */
{ /* Llib/ssl.scm 759 */
BgL_certificatez00_bglt BgL_new1126z00_410;
{ /* Llib/ssl.scm 760 */
BgL_certificatez00_bglt BgL_new1125z00_411;
BgL_new1125z00_411 = 
((BgL_certificatez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_certificatez00_bgl) ))); 
{ /* Llib/ssl.scm 760 */
long BgL_arg1708z00_412;
{ /* Llib/ssl.scm 760 */
long BgL_res2336z00_1881;
BgL_res2336z00_1881 = 
BGL_CLASS_INDEX(BGl_certificatez00zz__ssl_sslz00); 
BgL_arg1708z00_412 = BgL_res2336z00_1881; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1125z00_411), BgL_arg1708z00_412); } 
BgL_new1126z00_410 = BgL_new1125z00_411; } 
((((BgL_certificatez00_bglt)COBJECT(BgL_new1126z00_410))->BgL_z42nativez42)=((void *)BgL_certz00_38),BUNSPEC); 
return 
((obj_t)BgL_new1126z00_410);} } 
BGL_FUNCTION_END;
}



/* &%make-certificate */
obj_t BGl_z62z52makezd2certificateze2zz__ssl_sslz00(obj_t BgL_envz00_4607, obj_t BgL_certz00_4608)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 758 */
{ /* Llib/ssl.scm 759 */
void * BgL_auxz00_7284;
if(
FOREIGNP(BgL_certz00_4608))
{ /* Llib/ssl.scm 759 */
BgL_auxz00_7284 = 
FOREIGN_TO_COBJ(BgL_certz00_4608)
; }  else 
{ 
obj_t BgL_auxz00_7288;
BgL_auxz00_7288 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)30948)), BGl_string3433z00zz__ssl_sslz00, BGl_string3434z00zz__ssl_sslz00, BgL_certz00_4608); 
FAILURE(BgL_auxz00_7288,BFALSE,BFALSE);} 
return 
bgl_make_certificate(BgL_auxz00_7284);} } 
BGL_FUNCTION_END;
}



/* %make-private-key */
BGL_EXPORTED_DEF obj_t bgl_make_private_key(void * BgL_pkeyz00_39)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 765 */
{ /* Llib/ssl.scm 766 */
BgL_privatezd2keyzd2_bglt BgL_new1128z00_413;
{ /* Llib/ssl.scm 767 */
BgL_privatezd2keyzd2_bglt BgL_new1127z00_414;
BgL_new1127z00_414 = 
((BgL_privatezd2keyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_privatezd2keyzd2_bgl) ))); 
{ /* Llib/ssl.scm 767 */
long BgL_arg1712z00_415;
{ /* Llib/ssl.scm 767 */
long BgL_res2337z00_1885;
BgL_res2337z00_1885 = 
BGL_CLASS_INDEX(BGl_privatezd2keyzd2zz__ssl_sslz00); 
BgL_arg1712z00_415 = BgL_res2337z00_1885; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1127z00_414), BgL_arg1712z00_415); } 
BgL_new1128z00_413 = BgL_new1127z00_414; } 
((((BgL_privatezd2keyzd2_bglt)COBJECT(BgL_new1128z00_413))->BgL_z42nativez42)=((void *)BgL_pkeyz00_39),BUNSPEC); 
return 
((obj_t)BgL_new1128z00_413);} } 
BGL_FUNCTION_END;
}



/* &%make-private-key */
obj_t BGl_z62z52makezd2privatezd2keyz30zz__ssl_sslz00(obj_t BgL_envz00_4609, obj_t BgL_pkeyz00_4610)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 765 */
{ /* Llib/ssl.scm 766 */
void * BgL_auxz00_7299;
if(
FOREIGNP(BgL_pkeyz00_4610))
{ /* Llib/ssl.scm 766 */
BgL_auxz00_7299 = 
FOREIGN_TO_COBJ(BgL_pkeyz00_4610)
; }  else 
{ 
obj_t BgL_auxz00_7303;
BgL_auxz00_7303 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)31256)), BGl_string3435z00zz__ssl_sslz00, BGl_string3434z00zz__ssl_sslz00, BgL_pkeyz00_4610); 
FAILURE(BgL_auxz00_7303,BFALSE,BFALSE);} 
return 
bgl_make_private_key(BgL_auxz00_7299);} } 
BGL_FUNCTION_END;
}



/* %certificate-$native */
BGL_EXPORTED_DEF void * bgl_certificate_native(obj_t BgL_certz00_40)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 772 */
return 
(((BgL_certificatez00_bglt)COBJECT(
((BgL_certificatez00_bglt)BgL_certz00_40)))->BgL_z42nativez42);} 
BGL_FUNCTION_END;
}



/* &%certificate-$native */
obj_t BGl_z62z52certificatezd2z42nativeza0zz__ssl_sslz00(obj_t BgL_envz00_4611, obj_t BgL_certz00_4612)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 772 */
return 
void_star_to_obj(
bgl_certificate_native(BgL_certz00_4612));} 
BGL_FUNCTION_END;
}



/* %private-key-$native */
BGL_EXPORTED_DEF void * bgl_private_key_native(obj_t BgL_pkeyz00_41)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 779 */
return 
(((BgL_privatezd2keyzd2_bglt)COBJECT(
((BgL_privatezd2keyzd2_bglt)BgL_pkeyz00_41)))->BgL_z42nativez42);} 
BGL_FUNCTION_END;
}



/* &%private-key-$native */
obj_t BGl_z62z52privatezd2keyzd2z42nativez72zz__ssl_sslz00(obj_t BgL_envz00_4613, obj_t BgL_pkeyz00_4614)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 779 */
return 
void_star_to_obj(
bgl_private_key_native(BgL_pkeyz00_4614));} 
BGL_FUNCTION_END;
}



/* _secure-context-set-key! */
obj_t BGl__securezd2contextzd2setzd2keyz12zc0zz__ssl_sslz00(obj_t BgL_envz00_59, obj_t BgL_optz00_58)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 836 */
{ /* Llib/ssl.scm 836 */
obj_t BgL_g1250z00_418;obj_t BgL_g1251z00_419;obj_t BgL_g1252z00_420;obj_t BgL_g1253z00_421;
{ 
obj_t BgL_auxz00_7316;
if(
VECTORP(BgL_optz00_58))
{ /* Llib/ssl.scm 836 */
BgL_auxz00_7316 = BgL_optz00_58
; }  else 
{ 
obj_t BgL_auxz00_7319;
BgL_auxz00_7319 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)34176)), BGl_string3436z00zz__ssl_sslz00, BGl_string3437z00zz__ssl_sslz00, BgL_optz00_58); 
FAILURE(BgL_auxz00_7319,BFALSE,BFALSE);} 
BgL_g1250z00_418 = 
VECTOR_REF(BgL_auxz00_7316,((long)0)); } 
{ 
obj_t BgL_auxz00_7324;
if(
VECTORP(BgL_optz00_58))
{ /* Llib/ssl.scm 836 */
BgL_auxz00_7324 = BgL_optz00_58
; }  else 
{ 
obj_t BgL_auxz00_7327;
BgL_auxz00_7327 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)34176)), BGl_string3436z00zz__ssl_sslz00, BGl_string3437z00zz__ssl_sslz00, BgL_optz00_58); 
FAILURE(BgL_auxz00_7327,BFALSE,BFALSE);} 
BgL_g1251z00_419 = 
VECTOR_REF(BgL_auxz00_7324,((long)1)); } 
{ 
obj_t BgL_auxz00_7332;
if(
VECTORP(BgL_optz00_58))
{ /* Llib/ssl.scm 836 */
BgL_auxz00_7332 = BgL_optz00_58
; }  else 
{ 
obj_t BgL_auxz00_7335;
BgL_auxz00_7335 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)34176)), BGl_string3436z00zz__ssl_sslz00, BGl_string3437z00zz__ssl_sslz00, BgL_optz00_58); 
FAILURE(BgL_auxz00_7335,BFALSE,BFALSE);} 
BgL_g1252z00_420 = 
VECTOR_REF(BgL_auxz00_7332,((long)2)); } 
{ 
obj_t BgL_auxz00_7340;
if(
VECTORP(BgL_optz00_58))
{ /* Llib/ssl.scm 836 */
BgL_auxz00_7340 = BgL_optz00_58
; }  else 
{ 
obj_t BgL_auxz00_7343;
BgL_auxz00_7343 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)34176)), BGl_string3436z00zz__ssl_sslz00, BGl_string3437z00zz__ssl_sslz00, BgL_optz00_58); 
FAILURE(BgL_auxz00_7343,BFALSE,BFALSE);} 
BgL_g1253z00_421 = 
VECTOR_REF(BgL_auxz00_7340,((long)3)); } 
{ /* Llib/ssl.scm 836 */
long BgL_aux1255z00_423;
{ 
obj_t BgL_auxz00_7348;
if(
VECTORP(BgL_optz00_58))
{ /* Llib/ssl.scm 836 */
BgL_auxz00_7348 = BgL_optz00_58
; }  else 
{ 
obj_t BgL_auxz00_7351;
BgL_auxz00_7351 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)34176)), BGl_string3436z00zz__ssl_sslz00, BGl_string3437z00zz__ssl_sslz00, BgL_optz00_58); 
FAILURE(BgL_auxz00_7351,BFALSE,BFALSE);} 
BgL_aux1255z00_423 = 
VECTOR_LENGTH(BgL_auxz00_7348); } 
switch( BgL_aux1255z00_423) { case ((long)4) : 

{ /* Llib/ssl.scm 836 */

{ /* Llib/ssl.scm 836 */
bool_t BgL_tmpz00_7356;
{ /* Llib/ssl.scm 836 */
long BgL_auxz00_7381;long BgL_auxz00_7372;obj_t BgL_auxz00_7365;BgL_securezd2contextzd2_bglt BgL_auxz00_7357;
{ /* Llib/ssl.scm 836 */
obj_t BgL_tmpz00_7382;
if(
INTEGERP(BgL_g1253z00_421))
{ /* Llib/ssl.scm 836 */
BgL_tmpz00_7382 = BgL_g1253z00_421
; }  else 
{ 
obj_t BgL_auxz00_7385;
BgL_auxz00_7385 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)34176)), BGl_string3436z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_g1253z00_421); 
FAILURE(BgL_auxz00_7385,BFALSE,BFALSE);} 
BgL_auxz00_7381 = 
(long)CINT(BgL_tmpz00_7382); } 
{ /* Llib/ssl.scm 836 */
obj_t BgL_tmpz00_7373;
if(
INTEGERP(BgL_g1252z00_420))
{ /* Llib/ssl.scm 836 */
BgL_tmpz00_7373 = BgL_g1252z00_420
; }  else 
{ 
obj_t BgL_auxz00_7376;
BgL_auxz00_7376 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)34176)), BGl_string3436z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_g1252z00_420); 
FAILURE(BgL_auxz00_7376,BFALSE,BFALSE);} 
BgL_auxz00_7372 = 
(long)CINT(BgL_tmpz00_7373); } 
if(
STRINGP(BgL_g1251z00_419))
{ /* Llib/ssl.scm 836 */
BgL_auxz00_7365 = BgL_g1251z00_419
; }  else 
{ 
obj_t BgL_auxz00_7368;
BgL_auxz00_7368 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)34176)), BGl_string3436z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_g1251z00_419); 
FAILURE(BgL_auxz00_7368,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_g1250z00_418, BGl_securezd2contextzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 836 */
BgL_auxz00_7357 = 
((BgL_securezd2contextzd2_bglt)BgL_g1250z00_418)
; }  else 
{ 
obj_t BgL_auxz00_7361;
BgL_auxz00_7361 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)34176)), BGl_string3436z00zz__ssl_sslz00, BGl_string3438z00zz__ssl_sslz00, BgL_g1250z00_418); 
FAILURE(BgL_auxz00_7361,BFALSE,BFALSE);} 
BgL_tmpz00_7356 = 
BGl_securezd2contextzd2setzd2keyz12zc0zz__ssl_sslz00(BgL_auxz00_7357, BgL_auxz00_7365, BgL_auxz00_7372, BgL_auxz00_7381, BFALSE); } 
return 
BBOOL(BgL_tmpz00_7356);} } break;case ((long)5) : 

{ /* Llib/ssl.scm 836 */
obj_t BgL_passphrasez00_426;
{ 
obj_t BgL_auxz00_7392;
if(
VECTORP(BgL_optz00_58))
{ /* Llib/ssl.scm 836 */
BgL_auxz00_7392 = BgL_optz00_58
; }  else 
{ 
obj_t BgL_auxz00_7395;
BgL_auxz00_7395 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)34176)), BGl_string3436z00zz__ssl_sslz00, BGl_string3437z00zz__ssl_sslz00, BgL_optz00_58); 
FAILURE(BgL_auxz00_7395,BFALSE,BFALSE);} 
BgL_passphrasez00_426 = 
VECTOR_REF(BgL_auxz00_7392,((long)4)); } 
{ /* Llib/ssl.scm 836 */

{ /* Llib/ssl.scm 836 */
bool_t BgL_tmpz00_7400;
{ /* Llib/ssl.scm 836 */
long BgL_auxz00_7425;long BgL_auxz00_7416;obj_t BgL_auxz00_7409;BgL_securezd2contextzd2_bglt BgL_auxz00_7401;
{ /* Llib/ssl.scm 836 */
obj_t BgL_tmpz00_7426;
if(
INTEGERP(BgL_g1253z00_421))
{ /* Llib/ssl.scm 836 */
BgL_tmpz00_7426 = BgL_g1253z00_421
; }  else 
{ 
obj_t BgL_auxz00_7429;
BgL_auxz00_7429 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)34176)), BGl_string3436z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_g1253z00_421); 
FAILURE(BgL_auxz00_7429,BFALSE,BFALSE);} 
BgL_auxz00_7425 = 
(long)CINT(BgL_tmpz00_7426); } 
{ /* Llib/ssl.scm 836 */
obj_t BgL_tmpz00_7417;
if(
INTEGERP(BgL_g1252z00_420))
{ /* Llib/ssl.scm 836 */
BgL_tmpz00_7417 = BgL_g1252z00_420
; }  else 
{ 
obj_t BgL_auxz00_7420;
BgL_auxz00_7420 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)34176)), BGl_string3436z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_g1252z00_420); 
FAILURE(BgL_auxz00_7420,BFALSE,BFALSE);} 
BgL_auxz00_7416 = 
(long)CINT(BgL_tmpz00_7417); } 
if(
STRINGP(BgL_g1251z00_419))
{ /* Llib/ssl.scm 836 */
BgL_auxz00_7409 = BgL_g1251z00_419
; }  else 
{ 
obj_t BgL_auxz00_7412;
BgL_auxz00_7412 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)34176)), BGl_string3436z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_g1251z00_419); 
FAILURE(BgL_auxz00_7412,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_g1250z00_418, BGl_securezd2contextzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 836 */
BgL_auxz00_7401 = 
((BgL_securezd2contextzd2_bglt)BgL_g1250z00_418)
; }  else 
{ 
obj_t BgL_auxz00_7405;
BgL_auxz00_7405 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)34176)), BGl_string3436z00zz__ssl_sslz00, BGl_string3438z00zz__ssl_sslz00, BgL_g1250z00_418); 
FAILURE(BgL_auxz00_7405,BFALSE,BFALSE);} 
BgL_tmpz00_7400 = 
BGl_securezd2contextzd2setzd2keyz12zc0zz__ssl_sslz00(BgL_auxz00_7401, BgL_auxz00_7409, BgL_auxz00_7416, BgL_auxz00_7425, BgL_passphrasez00_426); } 
return 
BBOOL(BgL_tmpz00_7400);} } } break;
default: 
return BUNSPEC;} } } } 
BGL_FUNCTION_END;
}



/* bn-bin2bn */
BGL_EXPORTED_DEF obj_t BGl_bnzd2bin2bnzd2zz__ssl_sslz00(obj_t BgL_stringz00_178)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1390 */
{ /* Llib/ssl.scm 1392 */
void * BgL_arg1715z00_1890;
{ /* Llib/ssl.scm 1392 */
long BgL_arg1716z00_1891;
BgL_arg1716z00_1891 = 
STRING_LENGTH(BgL_stringz00_178); 
BgL_arg1715z00_1890 = 
bgl_bn_bin2bn(
BSTRING_TO_STRING(BgL_stringz00_178), 
(int)(BgL_arg1716z00_1891)); } 
return 
void_star_to_obj(BgL_arg1715z00_1890);} } 
BGL_FUNCTION_END;
}



/* &bn-bin2bn */
obj_t BGl_z62bnzd2bin2bnzb0zz__ssl_sslz00(obj_t BgL_envz00_4615, obj_t BgL_stringz00_4616)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1390 */
{ /* Llib/ssl.scm 1392 */
obj_t BgL_auxz00_7442;
if(
STRINGP(BgL_stringz00_4616))
{ /* Llib/ssl.scm 1392 */
BgL_auxz00_7442 = BgL_stringz00_4616
; }  else 
{ 
obj_t BgL_auxz00_7445;
BgL_auxz00_7445 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)56102)), BGl_string3439z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_stringz00_4616); 
FAILURE(BgL_auxz00_7445,BFALSE,BFALSE);} 
return 
BGl_bnzd2bin2bnzd2zz__ssl_sslz00(BgL_auxz00_7442);} } 
BGL_FUNCTION_END;
}



/* bn-bn2bin */
BGL_EXPORTED_DEF obj_t BGl_bnzd2bn2binzd2zz__ssl_sslz00(obj_t BgL_bnz00_179)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1398 */
{ /* Llib/ssl.scm 1401 */
int BgL_sza7za7_429;
{ /* Llib/ssl.scm 1401 */
int BgL_res2339z00_1896;
{ /* Llib/ssl.scm 1412 */
void * BgL_arg1725z00_1895;
BgL_arg1725z00_1895 = 
(BIGNUM *)FOREIGN_TO_COBJ(BgL_bnz00_179); 
BgL_res2339z00_1896 = 
BN_num_bytes(BgL_arg1725z00_1895); } 
BgL_sza7za7_429 = BgL_res2339z00_1896; } 
{ /* Llib/ssl.scm 1401 */
obj_t BgL_stz00_430;
{ /* Llib/ssl.scm 1402 */

BgL_stz00_430 = 
make_string(
(long)(BgL_sza7za7_429), ((unsigned char)' ')); } 
{ /* Llib/ssl.scm 1402 */

{ /* Llib/ssl.scm 1403 */
void * BgL_arg1719z00_431;
BgL_arg1719z00_431 = 
(BIGNUM *)FOREIGN_TO_COBJ(BgL_bnz00_179); 
{ /* Llib/ssl.scm 1403 */
char * BgL_tmpz00_7455;
BgL_tmpz00_7455 = 
BSTRING_TO_STRING(BgL_stz00_430); 
BN_bn2bin(BgL_arg1719z00_431, BgL_tmpz00_7455); } } 
return BgL_stz00_430;} } } } 
BGL_FUNCTION_END;
}



/* &bn-bn2bin */
obj_t BGl_z62bnzd2bn2binzb0zz__ssl_sslz00(obj_t BgL_envz00_4617, obj_t BgL_bnz00_4618)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1398 */
{ /* Llib/ssl.scm 1401 */
obj_t BgL_auxz00_7458;
if(
FOREIGNP(BgL_bnz00_4618))
{ /* Llib/ssl.scm 1401 */
BgL_auxz00_7458 = BgL_bnz00_4618
; }  else 
{ 
obj_t BgL_auxz00_7461;
BgL_auxz00_7461 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)56440)), BGl_string3440z00zz__ssl_sslz00, BGl_string3441z00zz__ssl_sslz00, BgL_bnz00_4618); 
FAILURE(BgL_auxz00_7461,BFALSE,BFALSE);} 
return 
BGl_bnzd2bn2binzd2zz__ssl_sslz00(BgL_auxz00_7458);} } 
BGL_FUNCTION_END;
}



/* bn-num-bytes */
BGL_EXPORTED_DEF int BGl_bnzd2numzd2bytesz00zz__ssl_sslz00(obj_t BgL_bnz00_180)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1410 */
{ /* Llib/ssl.scm 1412 */
void * BgL_arg1725z00_1899;
BgL_arg1725z00_1899 = 
(BIGNUM *)FOREIGN_TO_COBJ(BgL_bnz00_180); 
return 
BN_num_bytes(BgL_arg1725z00_1899);} } 
BGL_FUNCTION_END;
}



/* &bn-num-bytes */
obj_t BGl_z62bnzd2numzd2bytesz62zz__ssl_sslz00(obj_t BgL_envz00_4619, obj_t BgL_bnz00_4620)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1410 */
{ /* Llib/ssl.scm 1412 */
int BgL_tmpz00_7468;
{ /* Llib/ssl.scm 1412 */
obj_t BgL_auxz00_7469;
if(
FOREIGNP(BgL_bnz00_4620))
{ /* Llib/ssl.scm 1412 */
BgL_auxz00_7469 = BgL_bnz00_4620
; }  else 
{ 
obj_t BgL_auxz00_7472;
BgL_auxz00_7472 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)56862)), BGl_string3442z00zz__ssl_sslz00, BGl_string3441z00zz__ssl_sslz00, BgL_bnz00_4620); 
FAILURE(BgL_auxz00_7472,BFALSE,BFALSE);} 
BgL_tmpz00_7468 = 
BGl_bnzd2numzd2bytesz00zz__ssl_sslz00(BgL_auxz00_7469); } 
return 
BINT(BgL_tmpz00_7468);} } 
BGL_FUNCTION_END;
}



/* bn-free */
BGL_EXPORTED_DEF obj_t BGl_bnzd2freezd2zz__ssl_sslz00(obj_t BgL_bnz00_181)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1418 */
{ /* Llib/ssl.scm 1420 */
void * BgL_arg1737z00_1900;
BgL_arg1737z00_1900 = 
(BIGNUM *)FOREIGN_TO_COBJ(BgL_bnz00_181); 
BN_free(BgL_arg1737z00_1900); BUNSPEC; } 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* &bn-free */
obj_t BGl_z62bnzd2freezb0zz__ssl_sslz00(obj_t BgL_envz00_4621, obj_t BgL_bnz00_4622)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1418 */
{ /* Llib/ssl.scm 1420 */
obj_t BgL_auxz00_7480;
if(
FOREIGNP(BgL_bnz00_4622))
{ /* Llib/ssl.scm 1420 */
BgL_auxz00_7480 = BgL_bnz00_4622
; }  else 
{ 
obj_t BgL_auxz00_7483;
BgL_auxz00_7483 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)57207)), BGl_string3443z00zz__ssl_sslz00, BGl_string3441z00zz__ssl_sslz00, BgL_bnz00_4622); 
FAILURE(BgL_auxz00_7483,BFALSE,BFALSE);} 
return 
BGl_bnzd2freezd2zz__ssl_sslz00(BgL_auxz00_7480);} } 
BGL_FUNCTION_END;
}



/* bn-new */
BGL_EXPORTED_DEF obj_t BGl_bnzd2newzd2zz__ssl_sslz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1426 */
{ /* Llib/ssl.scm 1428 */
void * BgL_arg1738z00_1901;
BgL_arg1738z00_1901 = 
BN_new(); 
return 
void_star_to_obj(BgL_arg1738z00_1901);} } 
BGL_FUNCTION_END;
}



/* &bn-new */
obj_t BGl_z62bnzd2newzb0zz__ssl_sslz00(obj_t BgL_envz00_4623)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1426 */
return 
BGl_bnzd2newzd2zz__ssl_sslz00();} 
BGL_FUNCTION_END;
}



/* bn-set-word */
BGL_EXPORTED_DEF bool_t BGl_bnzd2setzd2wordz00zz__ssl_sslz00(obj_t BgL_bnz00_182, int BgL_wz00_183)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1434 */
{ /* Llib/ssl.scm 1436 */
void * BgL_arg1740z00_1902;
BgL_arg1740z00_1902 = 
(BIGNUM *)FOREIGN_TO_COBJ(BgL_bnz00_182); 
return 
BN_set_word(BgL_arg1740z00_1902, BgL_wz00_183);} } 
BGL_FUNCTION_END;
}



/* &bn-set-word */
obj_t BGl_z62bnzd2setzd2wordz62zz__ssl_sslz00(obj_t BgL_envz00_4624, obj_t BgL_bnz00_4625, obj_t BgL_wz00_4626)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1434 */
{ /* Llib/ssl.scm 1436 */
bool_t BgL_tmpz00_7493;
{ /* Llib/ssl.scm 1436 */
int BgL_auxz00_7501;obj_t BgL_auxz00_7494;
{ /* Llib/ssl.scm 1436 */
obj_t BgL_tmpz00_7502;
if(
INTEGERP(BgL_wz00_4626))
{ /* Llib/ssl.scm 1436 */
BgL_tmpz00_7502 = BgL_wz00_4626
; }  else 
{ 
obj_t BgL_auxz00_7505;
BgL_auxz00_7505 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)57841)), BGl_string3444z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_wz00_4626); 
FAILURE(BgL_auxz00_7505,BFALSE,BFALSE);} 
BgL_auxz00_7501 = 
CINT(BgL_tmpz00_7502); } 
if(
FOREIGNP(BgL_bnz00_4625))
{ /* Llib/ssl.scm 1436 */
BgL_auxz00_7494 = BgL_bnz00_4625
; }  else 
{ 
obj_t BgL_auxz00_7497;
BgL_auxz00_7497 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)57841)), BGl_string3444z00zz__ssl_sslz00, BGl_string3441z00zz__ssl_sslz00, BgL_bnz00_4625); 
FAILURE(BgL_auxz00_7497,BFALSE,BFALSE);} 
BgL_tmpz00_7493 = 
BGl_bnzd2setzd2wordz00zz__ssl_sslz00(BgL_auxz00_7494, BgL_auxz00_7501); } 
return 
BBOOL(BgL_tmpz00_7493);} } 
BGL_FUNCTION_END;
}



/* ssl-get-ciphers */
BGL_EXPORTED_DEF obj_t BGl_sslzd2getzd2ciphersz00zz__ssl_sslz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1442 */
return 
bgl_ssl_get_ciphers();} 
BGL_FUNCTION_END;
}



/* &ssl-get-ciphers */
obj_t BGl_z62sslzd2getzd2ciphersz62zz__ssl_sslz00(obj_t BgL_envz00_4627)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1442 */
return 
BGl_sslzd2getzd2ciphersz00zz__ssl_sslz00();} 
BGL_FUNCTION_END;
}



/* evp-get-ciphers */
BGL_EXPORTED_DEF obj_t BGl_evpzd2getzd2ciphersz00zz__ssl_sslz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1450 */
return 
bgl_evp_get_ciphers();} 
BGL_FUNCTION_END;
}



/* &evp-get-ciphers */
obj_t BGl_z62evpzd2getzd2ciphersz62zz__ssl_sslz00(obj_t BgL_envz00_4628)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1450 */
return 
BGl_evpzd2getzd2ciphersz00zz__ssl_sslz00();} 
BGL_FUNCTION_END;
}



/* evp-get-hashes */
BGL_EXPORTED_DEF obj_t BGl_evpzd2getzd2hashesz00zz__ssl_sslz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1458 */
return 
bgl_evp_get_hashes();} 
BGL_FUNCTION_END;
}



/* &evp-get-hashes */
obj_t BGl_z62evpzd2getzd2hashesz62zz__ssl_sslz00(obj_t BgL_envz00_4629)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1458 */
return 
BGl_evpzd2getzd2hashesz00zz__ssl_sslz00();} 
BGL_FUNCTION_END;
}



/* pkcs5-pbkdf2-hmac-sha1 */
BGL_EXPORTED_DEF obj_t BGl_pkcs5zd2pbkdf2zd2hmaczd2sha1zd2zz__ssl_sslz00(obj_t BgL_passz00_184, obj_t BgL_saltz00_185, int BgL_iterz00_186, int BgL_keylenz00_187)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1466 */
return 
bgl_pkcs5_pbkdf2_hmac_sha1(BgL_passz00_184, BgL_saltz00_185, BgL_iterz00_186, BgL_keylenz00_187);} 
BGL_FUNCTION_END;
}



/* &pkcs5-pbkdf2-hmac-sha1 */
obj_t BGl_z62pkcs5zd2pbkdf2zd2hmaczd2sha1zb0zz__ssl_sslz00(obj_t BgL_envz00_4630, obj_t BgL_passz00_4631, obj_t BgL_saltz00_4632, obj_t BgL_iterz00_4633, obj_t BgL_keylenz00_4634)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1466 */
{ /* Llib/ssl.scm 1469 */
int BgL_auxz00_7542;int BgL_auxz00_7533;obj_t BgL_auxz00_7526;obj_t BgL_auxz00_7519;
{ /* Llib/ssl.scm 1469 */
obj_t BgL_tmpz00_7543;
if(
INTEGERP(BgL_keylenz00_4634))
{ /* Llib/ssl.scm 1469 */
BgL_tmpz00_7543 = BgL_keylenz00_4634
; }  else 
{ 
obj_t BgL_auxz00_7546;
BgL_auxz00_7546 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)59178)), BGl_string3445z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_keylenz00_4634); 
FAILURE(BgL_auxz00_7546,BFALSE,BFALSE);} 
BgL_auxz00_7542 = 
CINT(BgL_tmpz00_7543); } 
{ /* Llib/ssl.scm 1469 */
obj_t BgL_tmpz00_7534;
if(
INTEGERP(BgL_iterz00_4633))
{ /* Llib/ssl.scm 1469 */
BgL_tmpz00_7534 = BgL_iterz00_4633
; }  else 
{ 
obj_t BgL_auxz00_7537;
BgL_auxz00_7537 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)59178)), BGl_string3445z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_iterz00_4633); 
FAILURE(BgL_auxz00_7537,BFALSE,BFALSE);} 
BgL_auxz00_7533 = 
CINT(BgL_tmpz00_7534); } 
if(
STRINGP(BgL_saltz00_4632))
{ /* Llib/ssl.scm 1469 */
BgL_auxz00_7526 = BgL_saltz00_4632
; }  else 
{ 
obj_t BgL_auxz00_7529;
BgL_auxz00_7529 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)59178)), BGl_string3445z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_saltz00_4632); 
FAILURE(BgL_auxz00_7529,BFALSE,BFALSE);} 
if(
STRINGP(BgL_passz00_4631))
{ /* Llib/ssl.scm 1469 */
BgL_auxz00_7519 = BgL_passz00_4631
; }  else 
{ 
obj_t BgL_auxz00_7522;
BgL_auxz00_7522 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)59178)), BGl_string3445z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_passz00_4631); 
FAILURE(BgL_auxz00_7522,BFALSE,BFALSE);} 
return 
BGl_pkcs5zd2pbkdf2zd2hmaczd2sha1zd2zz__ssl_sslz00(BgL_auxz00_7519, BgL_auxz00_7526, BgL_auxz00_7533, BgL_auxz00_7542);} } 
BGL_FUNCTION_END;
}



/* ssl-op-cipher-server-preference */
BGL_EXPORTED_DEF int BGl_sslzd2opzd2cipherzd2serverzd2preferencez00zz__ssl_sslz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1476 */
return SSL_OP_CIPHER_SERVER_PREFERENCE;} 
BGL_FUNCTION_END;
}



/* &ssl-op-cipher-server-preference */
obj_t BGl_z62sslzd2opzd2cipherzd2serverzd2preferencez62zz__ssl_sslz00(obj_t BgL_envz00_4635)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1476 */
return 
BINT(
BGl_sslzd2opzd2cipherzd2serverzd2preferencez00zz__ssl_sslz00());} 
BGL_FUNCTION_END;
}



/* object-init */
obj_t BGl_objectzd2initzd2zz__ssl_sslz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 15 */
{ /* Llib/ssl.scm 297 */
obj_t BgL_arg1750z00_441;obj_t BgL_arg1751z00_442;
{ /* Llib/ssl.scm 297 */
obj_t BgL_v1190z00_453;
BgL_v1190z00_453 = 
create_vector(((long)1)); 
{ /* Llib/ssl.scm 297 */
obj_t BgL_arg1757z00_454;
BgL_arg1757z00_454 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)27)), BGl_proc3447z00zz__ssl_sslz00, BGl_proc3446z00zz__ssl_sslz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)28))); 
VECTOR_SET(BgL_v1190z00_453,((long)0),BgL_arg1757z00_454); } 
BgL_arg1750z00_441 = BgL_v1190z00_453; } 
{ /* Llib/ssl.scm 297 */
obj_t BgL_v1191z00_464;
BgL_v1191z00_464 = 
create_vector(((long)0)); 
BgL_arg1751z00_442 = BgL_v1191z00_464; } 
BGl_certificatez00zz__ssl_sslz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)29)), 
CNST_TABLE_REF(((long)30)), BGl_objectz00zz__objectz00, ((long)36719), BGl_proc3450z00zz__ssl_sslz00, BGl_proc3449z00zz__ssl_sslz00, BFALSE, BGl_proc3448z00zz__ssl_sslz00, BFALSE, BgL_arg1750z00_441, BgL_arg1751z00_442); } 
{ /* Llib/ssl.scm 300 */
obj_t BgL_arg1765z00_471;obj_t BgL_arg1766z00_472;
{ /* Llib/ssl.scm 300 */
obj_t BgL_v1192z00_483;
BgL_v1192z00_483 = 
create_vector(((long)1)); 
{ /* Llib/ssl.scm 300 */
obj_t BgL_arg1772z00_484;
BgL_arg1772z00_484 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)27)), BGl_proc3452z00zz__ssl_sslz00, BGl_proc3451z00zz__ssl_sslz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)31))); 
VECTOR_SET(BgL_v1192z00_483,((long)0),BgL_arg1772z00_484); } 
BgL_arg1765z00_471 = BgL_v1192z00_483; } 
{ /* Llib/ssl.scm 300 */
obj_t BgL_v1193z00_494;
BgL_v1193z00_494 = 
create_vector(((long)0)); 
BgL_arg1766z00_472 = BgL_v1193z00_494; } 
BGl_privatezd2keyzd2zz__ssl_sslz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)32)), 
CNST_TABLE_REF(((long)30)), BGl_objectz00zz__objectz00, ((long)36583), BGl_proc3455z00zz__ssl_sslz00, BGl_proc3454z00zz__ssl_sslz00, BFALSE, BGl_proc3453z00zz__ssl_sslz00, BFALSE, BgL_arg1765z00_471, BgL_arg1766z00_472); } 
{ /* Llib/ssl.scm 403 */
obj_t BgL_arg1780z00_501;obj_t BgL_arg1781z00_502;
{ /* Llib/ssl.scm 403 */
obj_t BgL_v1194z00_516;
BgL_v1194z00_516 = 
create_vector(((long)3)); 
{ /* Llib/ssl.scm 403 */
obj_t BgL_arg1788z00_517;
BgL_arg1788z00_517 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)27)), BGl_proc3458z00zz__ssl_sslz00, BGl_proc3457z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3456z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)33))); 
VECTOR_SET(BgL_v1194z00_516,((long)0),BgL_arg1788z00_517); } 
{ /* Llib/ssl.scm 403 */
obj_t BgL_arg1795z00_530;
BgL_arg1795z00_530 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)34)), BGl_proc3461z00zz__ssl_sslz00, BGl_proc3460z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3459z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)35))); 
VECTOR_SET(BgL_v1194z00_516,((long)1),BgL_arg1795z00_530); } 
{ /* Llib/ssl.scm 403 */
obj_t BgL_arg1802z00_543;
BgL_arg1802z00_543 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)36)), BGl_proc3464z00zz__ssl_sslz00, BGl_proc3463z00zz__ssl_sslz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3462z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)37))); 
VECTOR_SET(BgL_v1194z00_516,((long)2),BgL_arg1802z00_543); } 
BgL_arg1780z00_501 = BgL_v1194z00_516; } 
{ /* Llib/ssl.scm 403 */
obj_t BgL_v1195z00_556;
BgL_v1195z00_556 = 
create_vector(((long)0)); 
BgL_arg1781z00_502 = BgL_v1195z00_556; } 
BGl_securezd2contextzd2zz__ssl_sslz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)38)), 
CNST_TABLE_REF(((long)30)), BGl_objectz00zz__objectz00, ((long)52075), BGl_proc3467z00zz__ssl_sslz00, BGl_proc3466z00zz__ssl_sslz00, BGl_securezd2contextzd2initzd2envzd2zz__ssl_sslz00, BGl_proc3465z00zz__ssl_sslz00, BFALSE, BgL_arg1780z00_501, BgL_arg1781z00_502); } 
{ /* Llib/ssl.scm 409 */
obj_t BgL_arg1812z00_563;obj_t BgL_arg1813z00_564;
{ /* Llib/ssl.scm 409 */
obj_t BgL_v1196z00_592;
BgL_v1196z00_592 = 
create_vector(((long)17)); 
{ /* Llib/ssl.scm 409 */
obj_t BgL_arg1820z00_593;
BgL_arg1820z00_593 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)27)), BGl_proc3470z00zz__ssl_sslz00, BGl_proc3469z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3468z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)39))); 
VECTOR_SET(BgL_v1196z00_592,((long)0),BgL_arg1820z00_593); } 
{ /* Llib/ssl.scm 409 */
obj_t BgL_arg1827z00_606;
BgL_arg1827z00_606 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)40)), BGl_proc3473z00zz__ssl_sslz00, BGl_proc3472z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3471z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)41))); 
VECTOR_SET(BgL_v1196z00_592,((long)1),BgL_arg1827z00_606); } 
{ /* Llib/ssl.scm 409 */
obj_t BgL_arg1834z00_619;
BgL_arg1834z00_619 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)42)), BGl_proc3476z00zz__ssl_sslz00, BGl_proc3475z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3474z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)41))); 
VECTOR_SET(BgL_v1196z00_592,((long)2),BgL_arg1834z00_619); } 
{ /* Llib/ssl.scm 409 */
obj_t BgL_arg1841z00_632;
BgL_arg1841z00_632 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)43)), BGl_proc3479z00zz__ssl_sslz00, BGl_proc3478z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3477z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)44))); 
VECTOR_SET(BgL_v1196z00_592,((long)3),BgL_arg1841z00_632); } 
{ /* Llib/ssl.scm 409 */
obj_t BgL_arg1848z00_645;
BgL_arg1848z00_645 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)45)), BGl_proc3481z00zz__ssl_sslz00, BGl_proc3480z00zz__ssl_sslz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_securezd2contextzd2zz__ssl_sslz00); 
VECTOR_SET(BgL_v1196z00_592,((long)4),BgL_arg1848z00_645); } 
{ /* Llib/ssl.scm 409 */
obj_t BgL_arg1853z00_655;
BgL_arg1853z00_655 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)46)), BGl_proc3483z00zz__ssl_sslz00, BGl_proc3482z00zz__ssl_sslz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)47))); 
VECTOR_SET(BgL_v1196z00_592,((long)5),BgL_arg1853z00_655); } 
{ /* Llib/ssl.scm 409 */
obj_t BgL_arg1858z00_665;
BgL_arg1858z00_665 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)48)), BGl_proc3486z00zz__ssl_sslz00, BGl_proc3485z00zz__ssl_sslz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3484z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)47))); 
VECTOR_SET(BgL_v1196z00_592,((long)6),BgL_arg1858z00_665); } 
{ /* Llib/ssl.scm 409 */
obj_t BgL_arg1865z00_678;
BgL_arg1865z00_678 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)49)), BGl_proc3489z00zz__ssl_sslz00, BGl_proc3488z00zz__ssl_sslz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3487z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)50))); 
VECTOR_SET(BgL_v1196z00_592,((long)7),BgL_arg1865z00_678); } 
{ /* Llib/ssl.scm 409 */
obj_t BgL_arg1872z00_691;
BgL_arg1872z00_691 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)51)), BGl_proc3491z00zz__ssl_sslz00, BGl_proc3490z00zz__ssl_sslz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)47))); 
VECTOR_SET(BgL_v1196z00_592,((long)8),BgL_arg1872z00_691); } 
{ /* Llib/ssl.scm 409 */
obj_t BgL_arg1877z00_701;
BgL_arg1877z00_701 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)52)), BGl_proc3494z00zz__ssl_sslz00, BGl_proc3493z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3492z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)50))); 
VECTOR_SET(BgL_v1196z00_592,((long)9),BgL_arg1877z00_701); } 
{ /* Llib/ssl.scm 409 */
obj_t BgL_arg1884z00_714;
BgL_arg1884z00_714 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)53)), BGl_proc3497z00zz__ssl_sslz00, BGl_proc3496z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3495z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)50))); 
VECTOR_SET(BgL_v1196z00_592,((long)10),BgL_arg1884z00_714); } 
{ /* Llib/ssl.scm 409 */
obj_t BgL_arg1891z00_727;
BgL_arg1891z00_727 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)54)), BGl_proc3500z00zz__ssl_sslz00, BGl_proc3499z00zz__ssl_sslz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3498z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)55))); 
VECTOR_SET(BgL_v1196z00_592,((long)11),BgL_arg1891z00_727); } 
{ /* Llib/ssl.scm 409 */
obj_t BgL_arg1898z00_740;
BgL_arg1898z00_740 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)56)), BGl_proc3503z00zz__ssl_sslz00, BGl_proc3502z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3501z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)50))); 
VECTOR_SET(BgL_v1196z00_592,((long)12),BgL_arg1898z00_740); } 
{ /* Llib/ssl.scm 409 */
obj_t BgL_arg1905z00_753;
BgL_arg1905z00_753 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)57)), BGl_proc3506z00zz__ssl_sslz00, BGl_proc3505z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3504z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)50))); 
VECTOR_SET(BgL_v1196z00_592,((long)13),BgL_arg1905z00_753); } 
{ /* Llib/ssl.scm 409 */
obj_t BgL_arg1912z00_766;
BgL_arg1912z00_766 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)58)), BGl_proc3509z00zz__ssl_sslz00, BGl_proc3508z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3507z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)50))); 
VECTOR_SET(BgL_v1196z00_592,((long)14),BgL_arg1912z00_766); } 
{ /* Llib/ssl.scm 409 */
obj_t BgL_arg1919z00_779;
BgL_arg1919z00_779 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc3512z00zz__ssl_sslz00, BGl_proc3511z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3510z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)47))); 
VECTOR_SET(BgL_v1196z00_592,((long)15),BgL_arg1919z00_779); } 
{ /* Llib/ssl.scm 409 */
obj_t BgL_arg1926z00_792;
BgL_arg1926z00_792 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)60)), BGl_proc3515z00zz__ssl_sslz00, BGl_proc3514z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3513z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)47))); 
VECTOR_SET(BgL_v1196z00_592,((long)16),BgL_arg1926z00_792); } 
BgL_arg1812z00_563 = BgL_v1196z00_592; } 
{ /* Llib/ssl.scm 409 */
obj_t BgL_v1197z00_805;
BgL_v1197z00_805 = 
create_vector(((long)0)); 
BgL_arg1813z00_564 = BgL_v1197z00_805; } 
BGl_sslzd2connectionzd2zz__ssl_sslz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)61)), 
CNST_TABLE_REF(((long)30)), BGl_objectz00zz__objectz00, ((long)46618), BGl_proc3518z00zz__ssl_sslz00, BGl_proc3517z00zz__ssl_sslz00, BGl_sslzd2connectionzd2initzd2envzd2zz__ssl_sslz00, BGl_proc3516z00zz__ssl_sslz00, BFALSE, BgL_arg1812z00_563, BgL_arg1813z00_564); } 
{ /* Llib/ssl.scm 429 */
obj_t BgL_arg1936z00_812;obj_t BgL_arg1937z00_813;
{ /* Llib/ssl.scm 429 */
obj_t BgL_v1198z00_830;
BgL_v1198z00_830 = 
create_vector(((long)11)); 
{ /* Llib/ssl.scm 429 */
obj_t BgL_arg1944z00_831;
BgL_arg1944z00_831 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)27)), BGl_proc3521z00zz__ssl_sslz00, BGl_proc3520z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3519z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)62))); 
VECTOR_SET(BgL_v1198z00_830,((long)0),BgL_arg1944z00_831); } 
{ /* Llib/ssl.scm 429 */
obj_t BgL_arg1951z00_844;
BgL_arg1951z00_844 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)63)), BGl_proc3524z00zz__ssl_sslz00, BGl_proc3523z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3522z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)64))); 
VECTOR_SET(BgL_v1198z00_830,((long)1),BgL_arg1951z00_844); } 
{ /* Llib/ssl.scm 429 */
obj_t BgL_arg1958z00_857;
BgL_arg1958z00_857 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)65)), BGl_proc3527z00zz__ssl_sslz00, BGl_proc3526z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3525z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)64))); 
VECTOR_SET(BgL_v1198z00_830,((long)2),BgL_arg1958z00_857); } 
{ /* Llib/ssl.scm 429 */
obj_t BgL_arg1965z00_870;
BgL_arg1965z00_870 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)66)), BGl_proc3530z00zz__ssl_sslz00, BGl_proc3529z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3528z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)64))); 
VECTOR_SET(BgL_v1198z00_830,((long)3),BgL_arg1965z00_870); } 
{ /* Llib/ssl.scm 429 */
obj_t BgL_arg1972z00_883;
BgL_arg1972z00_883 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)67)), BGl_proc3533z00zz__ssl_sslz00, BGl_proc3532z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3531z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)64))); 
VECTOR_SET(BgL_v1198z00_830,((long)4),BgL_arg1972z00_883); } 
{ /* Llib/ssl.scm 429 */
obj_t BgL_arg1979z00_896;
BgL_arg1979z00_896 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)68)), BGl_proc3536z00zz__ssl_sslz00, BGl_proc3535z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3534z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)64))); 
VECTOR_SET(BgL_v1198z00_830,((long)5),BgL_arg1979z00_896); } 
{ /* Llib/ssl.scm 429 */
obj_t BgL_arg1986z00_909;
BgL_arg1986z00_909 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)69)), BGl_proc3538z00zz__ssl_sslz00, BGl_proc3537z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)50))); 
VECTOR_SET(BgL_v1198z00_830,((long)6),BgL_arg1986z00_909); } 
{ /* Llib/ssl.scm 429 */
obj_t BgL_arg1991z00_919;
BgL_arg1991z00_919 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)70)), BGl_proc3540z00zz__ssl_sslz00, BGl_proc3539z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)50))); 
VECTOR_SET(BgL_v1198z00_830,((long)7),BgL_arg1991z00_919); } 
{ /* Llib/ssl.scm 429 */
obj_t BgL_arg1996z00_929;
BgL_arg1996z00_929 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)71)), BGl_proc3542z00zz__ssl_sslz00, BGl_proc3541z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)50))); 
VECTOR_SET(BgL_v1198z00_830,((long)8),BgL_arg1996z00_929); } 
{ /* Llib/ssl.scm 429 */
obj_t BgL_arg2001z00_939;
BgL_arg2001z00_939 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)32)), BGl_proc3544z00zz__ssl_sslz00, BGl_proc3543z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)50))); 
VECTOR_SET(BgL_v1198z00_830,((long)9),BgL_arg2001z00_939); } 
{ /* Llib/ssl.scm 429 */
obj_t BgL_arg2006z00_949;
BgL_arg2006z00_949 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)72)), BGl_proc3546z00zz__ssl_sslz00, BGl_proc3545z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)50))); 
VECTOR_SET(BgL_v1198z00_830,((long)10),BgL_arg2006z00_949); } 
BgL_arg1936z00_812 = BgL_v1198z00_830; } 
{ /* Llib/ssl.scm 429 */
obj_t BgL_v1199z00_959;
BgL_v1199z00_959 = 
create_vector(((long)5)); 
{ /* Llib/ssl.scm 439 */
obj_t BgL_arg2011z00_960;
{ /* Llib/ssl.scm 439 */
obj_t BgL_arg2012z00_961;
BgL_arg2012z00_961 = 
MAKE_YOUNG_PAIR(BGl_proc3547z00zz__ssl_sslz00, BGl_proc3548z00zz__ssl_sslz00); 
BgL_arg2011z00_960 = 
MAKE_YOUNG_PAIR(
BINT(((long)0)), BgL_arg2012z00_961); } 
VECTOR_SET(BgL_v1199z00_959,((long)0),BgL_arg2011z00_960); } 
{ /* Llib/ssl.scm 448 */
obj_t BgL_arg2025z00_988;
{ /* Llib/ssl.scm 448 */
obj_t BgL_arg2026z00_989;
BgL_arg2026z00_989 = 
MAKE_YOUNG_PAIR(BGl_proc3549z00zz__ssl_sslz00, BGl_proc3550z00zz__ssl_sslz00); 
BgL_arg2025z00_988 = 
MAKE_YOUNG_PAIR(
BINT(((long)1)), BgL_arg2026z00_989); } 
VECTOR_SET(BgL_v1199z00_959,((long)1),BgL_arg2025z00_988); } 
{ /* Llib/ssl.scm 457 */
obj_t BgL_arg2039z00_1016;
{ /* Llib/ssl.scm 457 */
obj_t BgL_arg2040z00_1017;
BgL_arg2040z00_1017 = 
MAKE_YOUNG_PAIR(BGl_proc3551z00zz__ssl_sslz00, BGl_proc3552z00zz__ssl_sslz00); 
BgL_arg2039z00_1016 = 
MAKE_YOUNG_PAIR(
BINT(((long)2)), BgL_arg2040z00_1017); } 
VECTOR_SET(BgL_v1199z00_959,((long)2),BgL_arg2039z00_1016); } 
{ /* Llib/ssl.scm 467 */
obj_t BgL_arg2053z00_1045;
{ /* Llib/ssl.scm 467 */
obj_t BgL_arg2054z00_1046;
BgL_arg2054z00_1046 = 
MAKE_YOUNG_PAIR(BGl_proc3553z00zz__ssl_sslz00, BGl_proc3554z00zz__ssl_sslz00); 
BgL_arg2053z00_1045 = 
MAKE_YOUNG_PAIR(
BINT(((long)3)), BgL_arg2054z00_1046); } 
VECTOR_SET(BgL_v1199z00_959,((long)3),BgL_arg2053z00_1045); } 
{ /* Llib/ssl.scm 476 */
obj_t BgL_arg2066z00_1072;
{ /* Llib/ssl.scm 476 */
obj_t BgL_arg2067z00_1073;
BgL_arg2067z00_1073 = 
MAKE_YOUNG_PAIR(BGl_proc3555z00zz__ssl_sslz00, BGl_proc3556z00zz__ssl_sslz00); 
BgL_arg2066z00_1072 = 
MAKE_YOUNG_PAIR(
BINT(((long)4)), BgL_arg2067z00_1073); } 
VECTOR_SET(BgL_v1199z00_959,((long)4),BgL_arg2066z00_1072); } 
BgL_arg1937z00_813 = BgL_v1199z00_959; } 
BGl_dhz00zz__ssl_sslz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)73)), 
CNST_TABLE_REF(((long)30)), BGl_objectz00zz__objectz00, ((long)13004), BGl_proc3559z00zz__ssl_sslz00, BGl_proc3558z00zz__ssl_sslz00, BGl_dhzd2initzd2envz00zz__ssl_sslz00, BGl_proc3557z00zz__ssl_sslz00, BFALSE, BgL_arg1936z00_812, BgL_arg1937z00_813); } 
{ /* Llib/ssl.scm 484 */
obj_t BgL_arg2082z00_1105;obj_t BgL_arg2083z00_1106;
{ /* Llib/ssl.scm 484 */
obj_t BgL_v1200z00_1120;
BgL_v1200z00_1120 = 
create_vector(((long)3)); 
{ /* Llib/ssl.scm 484 */
obj_t BgL_arg2090z00_1121;
BgL_arg2090z00_1121 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)74)), BGl_proc3562z00zz__ssl_sslz00, BGl_proc3561z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3560z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)75))); 
VECTOR_SET(BgL_v1200z00_1120,((long)0),BgL_arg2090z00_1121); } 
{ /* Llib/ssl.scm 484 */
obj_t BgL_arg2098z00_1134;
BgL_arg2098z00_1134 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)76)), BGl_proc3565z00zz__ssl_sslz00, BGl_proc3564z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3563z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)77))); 
VECTOR_SET(BgL_v1200z00_1120,((long)1),BgL_arg2098z00_1134); } 
{ /* Llib/ssl.scm 484 */
obj_t BgL_arg2105z00_1147;
BgL_arg2105z00_1147 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)78)), BGl_proc3567z00zz__ssl_sslz00, BGl_proc3566z00zz__ssl_sslz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)37))); 
VECTOR_SET(BgL_v1200z00_1120,((long)2),BgL_arg2105z00_1147); } 
BgL_arg2082z00_1105 = BgL_v1200z00_1120; } 
{ /* Llib/ssl.scm 484 */
obj_t BgL_v1201z00_1157;
BgL_v1201z00_1157 = 
create_vector(((long)0)); 
BgL_arg2083z00_1106 = BgL_v1201z00_1157; } 
BGl_sslzd2hashzd2zz__ssl_sslz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)79)), 
CNST_TABLE_REF(((long)30)), BGl_objectz00zz__objectz00, ((long)4072), BGl_proc3570z00zz__ssl_sslz00, BGl_proc3569z00zz__ssl_sslz00, BGl_sslzd2hashzd2initzd2envzd2zz__ssl_sslz00, BGl_proc3568z00zz__ssl_sslz00, BFALSE, BgL_arg2082z00_1105, BgL_arg2083z00_1106); } 
{ /* Llib/ssl.scm 494 */
obj_t BgL_arg2113z00_1164;obj_t BgL_arg2114z00_1165;
{ /* Llib/ssl.scm 494 */
obj_t BgL_v1202z00_1177;
BgL_v1202z00_1177 = 
create_vector(((long)2)); 
{ /* Llib/ssl.scm 494 */
obj_t BgL_arg2120z00_1178;
BgL_arg2120z00_1178 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)74)), BGl_proc3573z00zz__ssl_sslz00, BGl_proc3572z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3571z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)75))); 
VECTOR_SET(BgL_v1202z00_1177,((long)0),BgL_arg2120z00_1178); } 
{ /* Llib/ssl.scm 494 */
obj_t BgL_arg2127z00_1191;
BgL_arg2127z00_1191 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)76)), BGl_proc3576z00zz__ssl_sslz00, BGl_proc3575z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3574z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)80))); 
VECTOR_SET(BgL_v1202z00_1177,((long)1),BgL_arg2127z00_1191); } 
BgL_arg2113z00_1164 = BgL_v1202z00_1177; } 
{ /* Llib/ssl.scm 494 */
obj_t BgL_v1203z00_1204;
BgL_v1203z00_1204 = 
create_vector(((long)0)); 
BgL_arg2114z00_1165 = BgL_v1203z00_1204; } 
BGl_sslzd2hmaczd2zz__ssl_sslz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)81)), 
CNST_TABLE_REF(((long)30)), BGl_objectz00zz__objectz00, ((long)62191), BGl_proc3579z00zz__ssl_sslz00, BGl_proc3578z00zz__ssl_sslz00, BFALSE, BGl_proc3577z00zz__ssl_sslz00, BFALSE, BgL_arg2113z00_1164, BgL_arg2114z00_1165); } 
{ /* Llib/ssl.scm 502 */
obj_t BgL_arg2137z00_1211;obj_t BgL_arg2138z00_1212;
{ /* Llib/ssl.scm 502 */
obj_t BgL_v1204z00_1224;
BgL_v1204z00_1224 = 
create_vector(((long)2)); 
{ /* Llib/ssl.scm 502 */
obj_t BgL_arg2144z00_1225;
BgL_arg2144z00_1225 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)74)), BGl_proc3582z00zz__ssl_sslz00, BGl_proc3581z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3580z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)75))); 
VECTOR_SET(BgL_v1204z00_1224,((long)0),BgL_arg2144z00_1225); } 
{ /* Llib/ssl.scm 502 */
obj_t BgL_arg2151z00_1238;
BgL_arg2151z00_1238 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)76)), BGl_proc3585z00zz__ssl_sslz00, BGl_proc3584z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3583z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)80))); 
VECTOR_SET(BgL_v1204z00_1224,((long)1),BgL_arg2151z00_1238); } 
BgL_arg2137z00_1211 = BgL_v1204z00_1224; } 
{ /* Llib/ssl.scm 502 */
obj_t BgL_v1205z00_1251;
BgL_v1205z00_1251 = 
create_vector(((long)0)); 
BgL_arg2138z00_1212 = BgL_v1205z00_1251; } 
BGl_sslzd2signzd2zz__ssl_sslz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)82)), 
CNST_TABLE_REF(((long)30)), BGl_objectz00zz__objectz00, ((long)64231), BGl_proc3588z00zz__ssl_sslz00, BGl_proc3587z00zz__ssl_sslz00, BFALSE, BGl_proc3586z00zz__ssl_sslz00, BFALSE, BgL_arg2137z00_1211, BgL_arg2138z00_1212); } 
{ /* Llib/ssl.scm 510 */
obj_t BgL_arg2161z00_1258;obj_t BgL_arg2162z00_1259;
{ /* Llib/ssl.scm 510 */
obj_t BgL_v1206z00_1271;
BgL_v1206z00_1271 = 
create_vector(((long)2)); 
{ /* Llib/ssl.scm 510 */
obj_t BgL_arg2168z00_1272;
BgL_arg2168z00_1272 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)74)), BGl_proc3591z00zz__ssl_sslz00, BGl_proc3590z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3589z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)75))); 
VECTOR_SET(BgL_v1206z00_1271,((long)0),BgL_arg2168z00_1272); } 
{ /* Llib/ssl.scm 510 */
obj_t BgL_arg2175z00_1285;
BgL_arg2175z00_1285 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)76)), BGl_proc3594z00zz__ssl_sslz00, BGl_proc3593z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3592z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)80))); 
VECTOR_SET(BgL_v1206z00_1271,((long)1),BgL_arg2175z00_1285); } 
BgL_arg2161z00_1258 = BgL_v1206z00_1271; } 
{ /* Llib/ssl.scm 510 */
obj_t BgL_v1207z00_1298;
BgL_v1207z00_1298 = 
create_vector(((long)0)); 
BgL_arg2162z00_1259 = BgL_v1207z00_1298; } 
BGl_sslzd2verifyzd2zz__ssl_sslz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)83)), 
CNST_TABLE_REF(((long)30)), BGl_objectz00zz__objectz00, ((long)31563), BGl_proc3597z00zz__ssl_sslz00, BGl_proc3596z00zz__ssl_sslz00, BFALSE, BGl_proc3595z00zz__ssl_sslz00, BFALSE, BgL_arg2161z00_1258, BgL_arg2162z00_1259); } 
{ /* Llib/ssl.scm 518 */
obj_t BgL_arg2185z00_1305;obj_t BgL_arg2186z00_1306;
{ /* Llib/ssl.scm 518 */
obj_t BgL_v1208z00_1318;
BgL_v1208z00_1318 = 
create_vector(((long)2)); 
{ /* Llib/ssl.scm 518 */
obj_t BgL_arg2192z00_1319;
BgL_arg2192z00_1319 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)84)), BGl_proc3600z00zz__ssl_sslz00, BGl_proc3599z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3598z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)85))); 
VECTOR_SET(BgL_v1208z00_1318,((long)0),BgL_arg2192z00_1319); } 
{ /* Llib/ssl.scm 518 */
obj_t BgL_arg2199z00_1332;
BgL_arg2199z00_1332 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)86)), BGl_proc3603z00zz__ssl_sslz00, BGl_proc3602z00zz__ssl_sslz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3601z00zz__ssl_sslz00, 
CNST_TABLE_REF(((long)87))); 
VECTOR_SET(BgL_v1208z00_1318,((long)1),BgL_arg2199z00_1332); } 
BgL_arg2185z00_1305 = BgL_v1208z00_1318; } 
{ /* Llib/ssl.scm 518 */
obj_t BgL_v1209z00_1345;
BgL_v1209z00_1345 = 
create_vector(((long)0)); 
BgL_arg2186z00_1306 = BgL_v1209z00_1345; } 
return ( 
BGl_sslzd2cipherzd2zz__ssl_sslz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)88)), 
CNST_TABLE_REF(((long)30)), BGl_objectz00zz__objectz00, ((long)23017), BGl_proc3606z00zz__ssl_sslz00, BGl_proc3605z00zz__ssl_sslz00, BFALSE, BGl_proc3604z00zz__ssl_sslz00, BFALSE, BgL_arg2185z00_1305, BgL_arg2186z00_1306), BUNSPEC) ;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2191> */
obj_t BGl_z62zc3anonymousza32191ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4802, obj_t BgL_new1115z00_4803)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 518 */
{ 
BgL_sslzd2cipherzd2_bglt BgL_auxz00_7799;
((((BgL_sslzd2cipherzd2_bglt)COBJECT(
((BgL_sslzd2cipherzd2_bglt)BgL_new1115z00_4803)))->BgL_z42cipherz42)=((void *)
0L),BUNSPEC); 
((((BgL_sslzd2cipherzd2_bglt)COBJECT(
((BgL_sslzd2cipherzd2_bglt)BgL_new1115z00_4803)))->BgL_z42cipherzd2ctxz90)=((void *)
0L),BUNSPEC); 
BgL_auxz00_7799 = 
((BgL_sslzd2cipherzd2_bglt)BgL_new1115z00_4803); 
return 
((obj_t)BgL_auxz00_7799);} } 
BGL_FUNCTION_END;
}



/* &lambda2189 */
BgL_sslzd2cipherzd2_bglt BGl_z62lambda2189z62zz__ssl_sslz00(obj_t BgL_envz00_4804)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 518 */
{ /* Llib/ssl.scm 518 */
BgL_sslzd2cipherzd2_bglt BgL_new1114z00_6100;
BgL_new1114z00_6100 = 
((BgL_sslzd2cipherzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sslzd2cipherzd2_bgl) ))); 
{ /* Llib/ssl.scm 518 */
long BgL_arg2190z00_6101;
{ /* Llib/ssl.scm 518 */
long BgL_res2360z00_6102;
BgL_res2360z00_6102 = 
BGL_CLASS_INDEX(BGl_sslzd2cipherzd2zz__ssl_sslz00); 
BgL_arg2190z00_6101 = BgL_res2360z00_6102; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1114z00_6100), BgL_arg2190z00_6101); } 
return BgL_new1114z00_6100;} } 
BGL_FUNCTION_END;
}



/* &lambda2187 */
BgL_sslzd2cipherzd2_bglt BGl_z62lambda2187z62zz__ssl_sslz00(obj_t BgL_envz00_4805, obj_t BgL_z42cipher1112z42_4806, obj_t BgL_z42cipherzd2ctx1113z90_4807)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 518 */
{ /* Llib/ssl.scm 518 */
void * BgL_z42cipher1112z42_6103;void * BgL_z42cipherzd2ctx1113z90_6104;
BgL_z42cipher1112z42_6103 = 
FOREIGN_TO_COBJ(BgL_z42cipher1112z42_4806); 
BgL_z42cipherzd2ctx1113z90_6104 = 
FOREIGN_TO_COBJ(BgL_z42cipherzd2ctx1113z90_4807); 
{ /* Llib/ssl.scm 518 */
BgL_sslzd2cipherzd2_bglt BgL_new1178z00_6105;
{ /* Llib/ssl.scm 518 */
BgL_sslzd2cipherzd2_bglt BgL_new1177z00_6106;
BgL_new1177z00_6106 = 
((BgL_sslzd2cipherzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sslzd2cipherzd2_bgl) ))); 
{ /* Llib/ssl.scm 518 */
long BgL_arg2188z00_6107;
{ /* Llib/ssl.scm 518 */
long BgL_res2359z00_6108;
BgL_res2359z00_6108 = 
BGL_CLASS_INDEX(BGl_sslzd2cipherzd2zz__ssl_sslz00); 
BgL_arg2188z00_6107 = BgL_res2359z00_6108; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1177z00_6106), BgL_arg2188z00_6107); } 
BgL_new1178z00_6105 = BgL_new1177z00_6106; } 
((((BgL_sslzd2cipherzd2_bglt)COBJECT(BgL_new1178z00_6105))->BgL_z42cipherz42)=((void *)BgL_z42cipher1112z42_6103),BUNSPEC); 
((((BgL_sslzd2cipherzd2_bglt)COBJECT(BgL_new1178z00_6105))->BgL_z42cipherzd2ctxz90)=((void *)BgL_z42cipherzd2ctx1113z90_6104),BUNSPEC); 
return BgL_new1178z00_6105;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2205> */
obj_t BGl_z62zc3anonymousza32205ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4808)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 518 */
return 
void_star_to_obj(0L);} 
BGL_FUNCTION_END;
}



/* &lambda2204 */
obj_t BGl_z62lambda2204z62zz__ssl_sslz00(obj_t BgL_envz00_4809, obj_t BgL_oz00_4810, obj_t BgL_vz00_4811)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 518 */
{ /* Llib/ssl.scm 518 */
void * BgL_vz00_6110;
BgL_vz00_6110 = 
FOREIGN_TO_COBJ(BgL_vz00_4811); 
return 
((((BgL_sslzd2cipherzd2_bglt)COBJECT(
((BgL_sslzd2cipherzd2_bglt)BgL_oz00_4810)))->BgL_z42cipherzd2ctxz90)=((void *)BgL_vz00_6110),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2203 */
obj_t BGl_z62lambda2203z62zz__ssl_sslz00(obj_t BgL_envz00_4812, obj_t BgL_oz00_4813)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 518 */
return 
void_star_to_obj(
(((BgL_sslzd2cipherzd2_bglt)COBJECT(
((BgL_sslzd2cipherzd2_bglt)BgL_oz00_4813)))->BgL_z42cipherzd2ctxz90));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2198> */
obj_t BGl_z62zc3anonymousza32198ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4814)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 518 */
return 
void_star_to_obj(0L);} 
BGL_FUNCTION_END;
}



/* &lambda2197 */
obj_t BGl_z62lambda2197z62zz__ssl_sslz00(obj_t BgL_envz00_4815, obj_t BgL_oz00_4816, obj_t BgL_vz00_4817)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 518 */
{ /* Llib/ssl.scm 518 */
void * BgL_vz00_6113;
BgL_vz00_6113 = 
FOREIGN_TO_COBJ(BgL_vz00_4817); 
return 
((((BgL_sslzd2cipherzd2_bglt)COBJECT(
((BgL_sslzd2cipherzd2_bglt)BgL_oz00_4816)))->BgL_z42cipherz42)=((void *)BgL_vz00_6113),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2196 */
obj_t BGl_z62lambda2196z62zz__ssl_sslz00(obj_t BgL_envz00_4818, obj_t BgL_oz00_4819)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 518 */
return 
void_star_to_obj(
(((BgL_sslzd2cipherzd2_bglt)COBJECT(
((BgL_sslzd2cipherzd2_bglt)BgL_oz00_4819)))->BgL_z42cipherz42));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2167> */
obj_t BGl_z62zc3anonymousza32167ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4820, obj_t BgL_new1110z00_4821)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 510 */
{ 
BgL_sslzd2verifyzd2_bglt BgL_auxz00_7834;
((((BgL_sslzd2verifyzd2_bglt)COBJECT(
((BgL_sslzd2verifyzd2_bglt)BgL_new1110z00_4821)))->BgL_z42mdz42)=((void *)
0L),BUNSPEC); 
((((BgL_sslzd2verifyzd2_bglt)COBJECT(
((BgL_sslzd2verifyzd2_bglt)BgL_new1110z00_4821)))->BgL_z42mdzd2ctxz90)=((void *)
0L),BUNSPEC); 
BgL_auxz00_7834 = 
((BgL_sslzd2verifyzd2_bglt)BgL_new1110z00_4821); 
return 
((obj_t)BgL_auxz00_7834);} } 
BGL_FUNCTION_END;
}



/* &lambda2165 */
BgL_sslzd2verifyzd2_bglt BGl_z62lambda2165z62zz__ssl_sslz00(obj_t BgL_envz00_4822)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 510 */
{ /* Llib/ssl.scm 510 */
BgL_sslzd2verifyzd2_bglt BgL_new1109z00_6116;
BgL_new1109z00_6116 = 
((BgL_sslzd2verifyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sslzd2verifyzd2_bgl) ))); 
{ /* Llib/ssl.scm 510 */
long BgL_arg2166z00_6117;
{ /* Llib/ssl.scm 510 */
long BgL_res2358z00_6118;
BgL_res2358z00_6118 = 
BGL_CLASS_INDEX(BGl_sslzd2verifyzd2zz__ssl_sslz00); 
BgL_arg2166z00_6117 = BgL_res2358z00_6118; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1109z00_6116), BgL_arg2166z00_6117); } 
return BgL_new1109z00_6116;} } 
BGL_FUNCTION_END;
}



/* &lambda2163 */
BgL_sslzd2verifyzd2_bglt BGl_z62lambda2163z62zz__ssl_sslz00(obj_t BgL_envz00_4823, obj_t BgL_z42md1107z42_4824, obj_t BgL_z42mdzd2ctx1108z90_4825)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 510 */
{ /* Llib/ssl.scm 510 */
void * BgL_z42md1107z42_6119;void * BgL_z42mdzd2ctx1108z90_6120;
BgL_z42md1107z42_6119 = 
FOREIGN_TO_COBJ(BgL_z42md1107z42_4824); 
BgL_z42mdzd2ctx1108z90_6120 = 
FOREIGN_TO_COBJ(BgL_z42mdzd2ctx1108z90_4825); 
{ /* Llib/ssl.scm 510 */
BgL_sslzd2verifyzd2_bglt BgL_new1176z00_6121;
{ /* Llib/ssl.scm 510 */
BgL_sslzd2verifyzd2_bglt BgL_new1175z00_6122;
BgL_new1175z00_6122 = 
((BgL_sslzd2verifyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sslzd2verifyzd2_bgl) ))); 
{ /* Llib/ssl.scm 510 */
long BgL_arg2164z00_6123;
{ /* Llib/ssl.scm 510 */
long BgL_res2357z00_6124;
BgL_res2357z00_6124 = 
BGL_CLASS_INDEX(BGl_sslzd2verifyzd2zz__ssl_sslz00); 
BgL_arg2164z00_6123 = BgL_res2357z00_6124; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1175z00_6122), BgL_arg2164z00_6123); } 
BgL_new1176z00_6121 = BgL_new1175z00_6122; } 
((((BgL_sslzd2verifyzd2_bglt)COBJECT(BgL_new1176z00_6121))->BgL_z42mdz42)=((void *)BgL_z42md1107z42_6119),BUNSPEC); 
((((BgL_sslzd2verifyzd2_bglt)COBJECT(BgL_new1176z00_6121))->BgL_z42mdzd2ctxz90)=((void *)BgL_z42mdzd2ctx1108z90_6120),BUNSPEC); 
return BgL_new1176z00_6121;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2181> */
obj_t BGl_z62zc3anonymousza32181ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4826)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 510 */
return 
void_star_to_obj(0L);} 
BGL_FUNCTION_END;
}



/* &lambda2180 */
obj_t BGl_z62lambda2180z62zz__ssl_sslz00(obj_t BgL_envz00_4827, obj_t BgL_oz00_4828, obj_t BgL_vz00_4829)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 510 */
{ /* Llib/ssl.scm 510 */
void * BgL_vz00_6126;
BgL_vz00_6126 = 
FOREIGN_TO_COBJ(BgL_vz00_4829); 
return 
((((BgL_sslzd2verifyzd2_bglt)COBJECT(
((BgL_sslzd2verifyzd2_bglt)BgL_oz00_4828)))->BgL_z42mdzd2ctxz90)=((void *)BgL_vz00_6126),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2179 */
obj_t BGl_z62lambda2179z62zz__ssl_sslz00(obj_t BgL_envz00_4830, obj_t BgL_oz00_4831)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 510 */
return 
void_star_to_obj(
(((BgL_sslzd2verifyzd2_bglt)COBJECT(
((BgL_sslzd2verifyzd2_bglt)BgL_oz00_4831)))->BgL_z42mdzd2ctxz90));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2174> */
obj_t BGl_z62zc3anonymousza32174ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4832)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 510 */
return 
void_star_to_obj(0L);} 
BGL_FUNCTION_END;
}



/* &lambda2173 */
obj_t BGl_z62lambda2173z62zz__ssl_sslz00(obj_t BgL_envz00_4833, obj_t BgL_oz00_4834, obj_t BgL_vz00_4835)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 510 */
{ /* Llib/ssl.scm 510 */
void * BgL_vz00_6129;
BgL_vz00_6129 = 
FOREIGN_TO_COBJ(BgL_vz00_4835); 
return 
((((BgL_sslzd2verifyzd2_bglt)COBJECT(
((BgL_sslzd2verifyzd2_bglt)BgL_oz00_4834)))->BgL_z42mdz42)=((void *)BgL_vz00_6129),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2172 */
obj_t BGl_z62lambda2172z62zz__ssl_sslz00(obj_t BgL_envz00_4836, obj_t BgL_oz00_4837)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 510 */
return 
void_star_to_obj(
(((BgL_sslzd2verifyzd2_bglt)COBJECT(
((BgL_sslzd2verifyzd2_bglt)BgL_oz00_4837)))->BgL_z42mdz42));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2143> */
obj_t BGl_z62zc3anonymousza32143ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4838, obj_t BgL_new1105z00_4839)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 502 */
{ 
BgL_sslzd2signzd2_bglt BgL_auxz00_7869;
((((BgL_sslzd2signzd2_bglt)COBJECT(
((BgL_sslzd2signzd2_bglt)BgL_new1105z00_4839)))->BgL_z42mdz42)=((void *)
0L),BUNSPEC); 
((((BgL_sslzd2signzd2_bglt)COBJECT(
((BgL_sslzd2signzd2_bglt)BgL_new1105z00_4839)))->BgL_z42mdzd2ctxz90)=((void *)
0L),BUNSPEC); 
BgL_auxz00_7869 = 
((BgL_sslzd2signzd2_bglt)BgL_new1105z00_4839); 
return 
((obj_t)BgL_auxz00_7869);} } 
BGL_FUNCTION_END;
}



/* &lambda2141 */
BgL_sslzd2signzd2_bglt BGl_z62lambda2141z62zz__ssl_sslz00(obj_t BgL_envz00_4840)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 502 */
{ /* Llib/ssl.scm 502 */
BgL_sslzd2signzd2_bglt BgL_new1104z00_6132;
BgL_new1104z00_6132 = 
((BgL_sslzd2signzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sslzd2signzd2_bgl) ))); 
{ /* Llib/ssl.scm 502 */
long BgL_arg2142z00_6133;
{ /* Llib/ssl.scm 502 */
long BgL_res2356z00_6134;
BgL_res2356z00_6134 = 
BGL_CLASS_INDEX(BGl_sslzd2signzd2zz__ssl_sslz00); 
BgL_arg2142z00_6133 = BgL_res2356z00_6134; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1104z00_6132), BgL_arg2142z00_6133); } 
return BgL_new1104z00_6132;} } 
BGL_FUNCTION_END;
}



/* &lambda2139 */
BgL_sslzd2signzd2_bglt BGl_z62lambda2139z62zz__ssl_sslz00(obj_t BgL_envz00_4841, obj_t BgL_z42md1102z42_4842, obj_t BgL_z42mdzd2ctx1103z90_4843)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 502 */
{ /* Llib/ssl.scm 502 */
void * BgL_z42md1102z42_6135;void * BgL_z42mdzd2ctx1103z90_6136;
BgL_z42md1102z42_6135 = 
FOREIGN_TO_COBJ(BgL_z42md1102z42_4842); 
BgL_z42mdzd2ctx1103z90_6136 = 
FOREIGN_TO_COBJ(BgL_z42mdzd2ctx1103z90_4843); 
{ /* Llib/ssl.scm 502 */
BgL_sslzd2signzd2_bglt BgL_new1174z00_6137;
{ /* Llib/ssl.scm 502 */
BgL_sslzd2signzd2_bglt BgL_new1173z00_6138;
BgL_new1173z00_6138 = 
((BgL_sslzd2signzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sslzd2signzd2_bgl) ))); 
{ /* Llib/ssl.scm 502 */
long BgL_arg2140z00_6139;
{ /* Llib/ssl.scm 502 */
long BgL_res2355z00_6140;
BgL_res2355z00_6140 = 
BGL_CLASS_INDEX(BGl_sslzd2signzd2zz__ssl_sslz00); 
BgL_arg2140z00_6139 = BgL_res2355z00_6140; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1173z00_6138), BgL_arg2140z00_6139); } 
BgL_new1174z00_6137 = BgL_new1173z00_6138; } 
((((BgL_sslzd2signzd2_bglt)COBJECT(BgL_new1174z00_6137))->BgL_z42mdz42)=((void *)BgL_z42md1102z42_6135),BUNSPEC); 
((((BgL_sslzd2signzd2_bglt)COBJECT(BgL_new1174z00_6137))->BgL_z42mdzd2ctxz90)=((void *)BgL_z42mdzd2ctx1103z90_6136),BUNSPEC); 
return BgL_new1174z00_6137;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2157> */
obj_t BGl_z62zc3anonymousza32157ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4844)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 502 */
return 
void_star_to_obj(0L);} 
BGL_FUNCTION_END;
}



/* &lambda2156 */
obj_t BGl_z62lambda2156z62zz__ssl_sslz00(obj_t BgL_envz00_4845, obj_t BgL_oz00_4846, obj_t BgL_vz00_4847)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 502 */
{ /* Llib/ssl.scm 502 */
void * BgL_vz00_6142;
BgL_vz00_6142 = 
FOREIGN_TO_COBJ(BgL_vz00_4847); 
return 
((((BgL_sslzd2signzd2_bglt)COBJECT(
((BgL_sslzd2signzd2_bglt)BgL_oz00_4846)))->BgL_z42mdzd2ctxz90)=((void *)BgL_vz00_6142),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2155 */
obj_t BGl_z62lambda2155z62zz__ssl_sslz00(obj_t BgL_envz00_4848, obj_t BgL_oz00_4849)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 502 */
return 
void_star_to_obj(
(((BgL_sslzd2signzd2_bglt)COBJECT(
((BgL_sslzd2signzd2_bglt)BgL_oz00_4849)))->BgL_z42mdzd2ctxz90));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2150> */
obj_t BGl_z62zc3anonymousza32150ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4850)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 502 */
return 
void_star_to_obj(0L);} 
BGL_FUNCTION_END;
}



/* &lambda2149 */
obj_t BGl_z62lambda2149z62zz__ssl_sslz00(obj_t BgL_envz00_4851, obj_t BgL_oz00_4852, obj_t BgL_vz00_4853)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 502 */
{ /* Llib/ssl.scm 502 */
void * BgL_vz00_6145;
BgL_vz00_6145 = 
FOREIGN_TO_COBJ(BgL_vz00_4853); 
return 
((((BgL_sslzd2signzd2_bglt)COBJECT(
((BgL_sslzd2signzd2_bglt)BgL_oz00_4852)))->BgL_z42mdz42)=((void *)BgL_vz00_6145),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2148 */
obj_t BGl_z62lambda2148z62zz__ssl_sslz00(obj_t BgL_envz00_4854, obj_t BgL_oz00_4855)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 502 */
return 
void_star_to_obj(
(((BgL_sslzd2signzd2_bglt)COBJECT(
((BgL_sslzd2signzd2_bglt)BgL_oz00_4855)))->BgL_z42mdz42));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2119> */
obj_t BGl_z62zc3anonymousza32119ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4856, obj_t BgL_new1100z00_4857)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 494 */
{ 
BgL_sslzd2hmaczd2_bglt BgL_auxz00_7904;
((((BgL_sslzd2hmaczd2_bglt)COBJECT(
((BgL_sslzd2hmaczd2_bglt)BgL_new1100z00_4857)))->BgL_z42mdz42)=((void *)
0L),BUNSPEC); 
((((BgL_sslzd2hmaczd2_bglt)COBJECT(
((BgL_sslzd2hmaczd2_bglt)BgL_new1100z00_4857)))->BgL_z42mdzd2ctxz90)=((void *)
0L),BUNSPEC); 
BgL_auxz00_7904 = 
((BgL_sslzd2hmaczd2_bglt)BgL_new1100z00_4857); 
return 
((obj_t)BgL_auxz00_7904);} } 
BGL_FUNCTION_END;
}



/* &lambda2117 */
BgL_sslzd2hmaczd2_bglt BGl_z62lambda2117z62zz__ssl_sslz00(obj_t BgL_envz00_4858)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 494 */
{ /* Llib/ssl.scm 494 */
BgL_sslzd2hmaczd2_bglt BgL_new1099z00_6148;
BgL_new1099z00_6148 = 
((BgL_sslzd2hmaczd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sslzd2hmaczd2_bgl) ))); 
{ /* Llib/ssl.scm 494 */
long BgL_arg2118z00_6149;
{ /* Llib/ssl.scm 494 */
long BgL_res2354z00_6150;
BgL_res2354z00_6150 = 
BGL_CLASS_INDEX(BGl_sslzd2hmaczd2zz__ssl_sslz00); 
BgL_arg2118z00_6149 = BgL_res2354z00_6150; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1099z00_6148), BgL_arg2118z00_6149); } 
return BgL_new1099z00_6148;} } 
BGL_FUNCTION_END;
}



/* &lambda2115 */
BgL_sslzd2hmaczd2_bglt BGl_z62lambda2115z62zz__ssl_sslz00(obj_t BgL_envz00_4859, obj_t BgL_z42md1097z42_4860, obj_t BgL_z42mdzd2ctx1098z90_4861)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 494 */
{ /* Llib/ssl.scm 494 */
void * BgL_z42md1097z42_6151;void * BgL_z42mdzd2ctx1098z90_6152;
BgL_z42md1097z42_6151 = 
FOREIGN_TO_COBJ(BgL_z42md1097z42_4860); 
BgL_z42mdzd2ctx1098z90_6152 = 
FOREIGN_TO_COBJ(BgL_z42mdzd2ctx1098z90_4861); 
{ /* Llib/ssl.scm 494 */
BgL_sslzd2hmaczd2_bglt BgL_new1172z00_6153;
{ /* Llib/ssl.scm 494 */
BgL_sslzd2hmaczd2_bglt BgL_new1171z00_6154;
BgL_new1171z00_6154 = 
((BgL_sslzd2hmaczd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sslzd2hmaczd2_bgl) ))); 
{ /* Llib/ssl.scm 494 */
long BgL_arg2116z00_6155;
{ /* Llib/ssl.scm 494 */
long BgL_res2353z00_6156;
BgL_res2353z00_6156 = 
BGL_CLASS_INDEX(BGl_sslzd2hmaczd2zz__ssl_sslz00); 
BgL_arg2116z00_6155 = BgL_res2353z00_6156; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1171z00_6154), BgL_arg2116z00_6155); } 
BgL_new1172z00_6153 = BgL_new1171z00_6154; } 
((((BgL_sslzd2hmaczd2_bglt)COBJECT(BgL_new1172z00_6153))->BgL_z42mdz42)=((void *)BgL_z42md1097z42_6151),BUNSPEC); 
((((BgL_sslzd2hmaczd2_bglt)COBJECT(BgL_new1172z00_6153))->BgL_z42mdzd2ctxz90)=((void *)BgL_z42mdzd2ctx1098z90_6152),BUNSPEC); 
return BgL_new1172z00_6153;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2133> */
obj_t BGl_z62zc3anonymousza32133ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4862)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 494 */
return 
void_star_to_obj(0L);} 
BGL_FUNCTION_END;
}



/* &lambda2132 */
obj_t BGl_z62lambda2132z62zz__ssl_sslz00(obj_t BgL_envz00_4863, obj_t BgL_oz00_4864, obj_t BgL_vz00_4865)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 494 */
{ /* Llib/ssl.scm 494 */
void * BgL_vz00_6158;
BgL_vz00_6158 = 
FOREIGN_TO_COBJ(BgL_vz00_4865); 
return 
((((BgL_sslzd2hmaczd2_bglt)COBJECT(
((BgL_sslzd2hmaczd2_bglt)BgL_oz00_4864)))->BgL_z42mdzd2ctxz90)=((void *)BgL_vz00_6158),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2131 */
obj_t BGl_z62lambda2131z62zz__ssl_sslz00(obj_t BgL_envz00_4866, obj_t BgL_oz00_4867)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 494 */
return 
void_star_to_obj(
(((BgL_sslzd2hmaczd2_bglt)COBJECT(
((BgL_sslzd2hmaczd2_bglt)BgL_oz00_4867)))->BgL_z42mdzd2ctxz90));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2126> */
obj_t BGl_z62zc3anonymousza32126ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4868)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 494 */
return 
void_star_to_obj(0L);} 
BGL_FUNCTION_END;
}



/* &lambda2125 */
obj_t BGl_z62lambda2125z62zz__ssl_sslz00(obj_t BgL_envz00_4869, obj_t BgL_oz00_4870, obj_t BgL_vz00_4871)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 494 */
{ /* Llib/ssl.scm 494 */
void * BgL_vz00_6161;
BgL_vz00_6161 = 
FOREIGN_TO_COBJ(BgL_vz00_4871); 
return 
((((BgL_sslzd2hmaczd2_bglt)COBJECT(
((BgL_sslzd2hmaczd2_bglt)BgL_oz00_4870)))->BgL_z42mdz42)=((void *)BgL_vz00_6161),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2124 */
obj_t BGl_z62lambda2124z62zz__ssl_sslz00(obj_t BgL_envz00_4872, obj_t BgL_oz00_4873)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 494 */
return 
void_star_to_obj(
(((BgL_sslzd2hmaczd2_bglt)COBJECT(
((BgL_sslzd2hmaczd2_bglt)BgL_oz00_4873)))->BgL_z42mdz42));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2089> */
obj_t BGl_z62zc3anonymousza32089ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4874, obj_t BgL_new1095z00_4875)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 484 */
{ 
BgL_sslzd2hashzd2_bglt BgL_auxz00_7939;
((((BgL_sslzd2hashzd2_bglt)COBJECT(
((BgL_sslzd2hashzd2_bglt)BgL_new1095z00_4875)))->BgL_z42mdz42)=((void *)
0L),BUNSPEC); 
((((BgL_sslzd2hashzd2_bglt)COBJECT(
((BgL_sslzd2hashzd2_bglt)BgL_new1095z00_4875)))->BgL_z42mdzd2ctxz90)=((void *)
0L),BUNSPEC); 
((((BgL_sslzd2hashzd2_bglt)COBJECT(
((BgL_sslzd2hashzd2_bglt)BgL_new1095z00_4875)))->BgL_typez00)=((obj_t)BGl_string3607z00zz__ssl_sslz00),BUNSPEC); 
BgL_auxz00_7939 = 
((BgL_sslzd2hashzd2_bglt)BgL_new1095z00_4875); 
return 
((obj_t)BgL_auxz00_7939);} } 
BGL_FUNCTION_END;
}



/* &lambda2087 */
BgL_sslzd2hashzd2_bglt BGl_z62lambda2087z62zz__ssl_sslz00(obj_t BgL_envz00_4876)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 484 */
{ /* Llib/ssl.scm 484 */
BgL_sslzd2hashzd2_bglt BgL_new1094z00_6164;
BgL_new1094z00_6164 = 
((BgL_sslzd2hashzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sslzd2hashzd2_bgl) ))); 
{ /* Llib/ssl.scm 484 */
long BgL_arg2088z00_6165;
{ /* Llib/ssl.scm 484 */
long BgL_res2352z00_6166;
BgL_res2352z00_6166 = 
BGL_CLASS_INDEX(BGl_sslzd2hashzd2zz__ssl_sslz00); 
BgL_arg2088z00_6165 = BgL_res2352z00_6166; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1094z00_6164), BgL_arg2088z00_6165); } 
return BgL_new1094z00_6164;} } 
BGL_FUNCTION_END;
}



/* &lambda2084 */
BgL_sslzd2hashzd2_bglt BGl_z62lambda2084z62zz__ssl_sslz00(obj_t BgL_envz00_4877, obj_t BgL_z42md1091z42_4878, obj_t BgL_z42mdzd2ctx1092z90_4879, obj_t BgL_type1093z00_4880)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 484 */
{ /* Llib/ssl.scm 484 */
void * BgL_z42md1091z42_6167;void * BgL_z42mdzd2ctx1092z90_6168;
BgL_z42md1091z42_6167 = 
FOREIGN_TO_COBJ(BgL_z42md1091z42_4878); 
BgL_z42mdzd2ctx1092z90_6168 = 
FOREIGN_TO_COBJ(BgL_z42mdzd2ctx1092z90_4879); 
{ /* Llib/ssl.scm 484 */
BgL_sslzd2hashzd2_bglt BgL_new1170z00_6170;
{ /* Llib/ssl.scm 484 */
BgL_sslzd2hashzd2_bglt BgL_new1169z00_6171;
BgL_new1169z00_6171 = 
((BgL_sslzd2hashzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sslzd2hashzd2_bgl) ))); 
{ /* Llib/ssl.scm 484 */
long BgL_arg2086z00_6172;
{ /* Llib/ssl.scm 484 */
long BgL_res2351z00_6173;
BgL_res2351z00_6173 = 
BGL_CLASS_INDEX(BGl_sslzd2hashzd2zz__ssl_sslz00); 
BgL_arg2086z00_6172 = BgL_res2351z00_6173; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1169z00_6171), BgL_arg2086z00_6172); } 
BgL_new1170z00_6170 = BgL_new1169z00_6171; } 
((((BgL_sslzd2hashzd2_bglt)COBJECT(BgL_new1170z00_6170))->BgL_z42mdz42)=((void *)BgL_z42md1091z42_6167),BUNSPEC); 
((((BgL_sslzd2hashzd2_bglt)COBJECT(BgL_new1170z00_6170))->BgL_z42mdzd2ctxz90)=((void *)BgL_z42mdzd2ctx1092z90_6168),BUNSPEC); 
((((BgL_sslzd2hashzd2_bglt)COBJECT(BgL_new1170z00_6170))->BgL_typez00)=((obj_t)
((obj_t)BgL_type1093z00_4880)),BUNSPEC); 
{ /* Llib/ssl.scm 484 */
obj_t BgL_fun2085z00_6174;
BgL_fun2085z00_6174 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_sslzd2hashzd2zz__ssl_sslz00); 
PROCEDURE_ENTRY(BgL_fun2085z00_6174)(BgL_fun2085z00_6174, 
((obj_t)BgL_new1170z00_6170), BEOA); } 
return BgL_new1170z00_6170;} } } 
BGL_FUNCTION_END;
}



/* &lambda2109 */
obj_t BGl_z62lambda2109z62zz__ssl_sslz00(obj_t BgL_envz00_4881, obj_t BgL_oz00_4882, obj_t BgL_vz00_4883)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 484 */
return 
((((BgL_sslzd2hashzd2_bglt)COBJECT(
((BgL_sslzd2hashzd2_bglt)BgL_oz00_4882)))->BgL_typez00)=((obj_t)
((obj_t)BgL_vz00_4883)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda2108 */
obj_t BGl_z62lambda2108z62zz__ssl_sslz00(obj_t BgL_envz00_4884, obj_t BgL_oz00_4885)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 484 */
return 
(((BgL_sslzd2hashzd2_bglt)COBJECT(
((BgL_sslzd2hashzd2_bglt)BgL_oz00_4885)))->BgL_typez00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2104> */
obj_t BGl_z62zc3anonymousza32104ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4886)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 484 */
return 
void_star_to_obj(0L);} 
BGL_FUNCTION_END;
}



/* &lambda2103 */
obj_t BGl_z62lambda2103z62zz__ssl_sslz00(obj_t BgL_envz00_4887, obj_t BgL_oz00_4888, obj_t BgL_vz00_4889)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 484 */
{ /* Llib/ssl.scm 484 */
void * BgL_vz00_6179;
BgL_vz00_6179 = 
FOREIGN_TO_COBJ(BgL_vz00_4889); 
return 
((((BgL_sslzd2hashzd2_bglt)COBJECT(
((BgL_sslzd2hashzd2_bglt)BgL_oz00_4888)))->BgL_z42mdzd2ctxz90)=((void *)BgL_vz00_6179),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2102 */
obj_t BGl_z62lambda2102z62zz__ssl_sslz00(obj_t BgL_envz00_4890, obj_t BgL_oz00_4891)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 484 */
return 
void_star_to_obj(
(((BgL_sslzd2hashzd2_bglt)COBJECT(
((BgL_sslzd2hashzd2_bglt)BgL_oz00_4891)))->BgL_z42mdzd2ctxz90));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2096> */
obj_t BGl_z62zc3anonymousza32096ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4892)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 484 */
return 
void_star_to_obj(0L);} 
BGL_FUNCTION_END;
}



/* &lambda2095 */
obj_t BGl_z62lambda2095z62zz__ssl_sslz00(obj_t BgL_envz00_4893, obj_t BgL_oz00_4894, obj_t BgL_vz00_4895)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 484 */
{ /* Llib/ssl.scm 484 */
void * BgL_vz00_6182;
BgL_vz00_6182 = 
FOREIGN_TO_COBJ(BgL_vz00_4895); 
return 
((((BgL_sslzd2hashzd2_bglt)COBJECT(
((BgL_sslzd2hashzd2_bglt)BgL_oz00_4894)))->BgL_z42mdz42)=((void *)BgL_vz00_6182),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda2094 */
obj_t BGl_z62lambda2094z62zz__ssl_sslz00(obj_t BgL_envz00_4896, obj_t BgL_oz00_4897)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 484 */
return 
void_star_to_obj(
(((BgL_sslzd2hashzd2_bglt)COBJECT(
((BgL_sslzd2hashzd2_bglt)BgL_oz00_4897)))->BgL_z42mdz42));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1943> */
obj_t BGl_z62zc3anonymousza31943ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4898, obj_t BgL_new1089z00_4899)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
{ 
BgL_dhz00_bglt BgL_auxz00_7989;
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_new1089z00_4899)))->BgL_z42nativez42)=((void *)
0L),BUNSPEC); 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_new1089z00_4899)))->BgL_z52pz52)=((void *)
0L),BUNSPEC); 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_new1089z00_4899)))->BgL_z52qz52)=((void *)
0L),BUNSPEC); 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_new1089z00_4899)))->BgL_z52gz52)=((void *)
0L),BUNSPEC); 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_new1089z00_4899)))->BgL_z52pubz52)=((void *)
0L),BUNSPEC); 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_new1089z00_4899)))->BgL_z52privz52)=((void *)
0L),BUNSPEC); 
BgL_auxz00_7989 = 
((BgL_dhz00_bglt)BgL_new1089z00_4899); 
return 
((obj_t)BgL_auxz00_7989);} } 
BGL_FUNCTION_END;
}



/* &lambda1941 */
BgL_dhz00_bglt BGl_z62lambda1941z62zz__ssl_sslz00(obj_t BgL_envz00_4900)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
{ /* Llib/ssl.scm 429 */
BgL_dhz00_bglt BgL_new1088z00_6185;
BgL_new1088z00_6185 = 
((BgL_dhz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_dhz00_bgl) ))); 
{ /* Llib/ssl.scm 429 */
long BgL_arg1942z00_6186;
{ /* Llib/ssl.scm 429 */
long BgL_res2350z00_6187;
BgL_res2350z00_6187 = 
BGL_CLASS_INDEX(BGl_dhz00zz__ssl_sslz00); 
BgL_arg1942z00_6186 = BgL_res2350z00_6187; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1088z00_6185), BgL_arg1942z00_6186); } 
return BgL_new1088z00_6185;} } 
BGL_FUNCTION_END;
}



/* &lambda1938 */
BgL_dhz00_bglt BGl_z62lambda1938z62zz__ssl_sslz00(obj_t BgL_envz00_4901, obj_t BgL_z42native1082z42_4902, obj_t BgL_z52p1083z52_4903, obj_t BgL_z52q1084z52_4904, obj_t BgL_z52g1085z52_4905, obj_t BgL_z52pub1086z52_4906, obj_t BgL_z52priv1087z52_4907)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
{ /* Llib/ssl.scm 429 */
void * BgL_z42native1082z42_6188;void * BgL_z52p1083z52_6189;void * BgL_z52q1084z52_6190;void * BgL_z52g1085z52_6191;void * BgL_z52pub1086z52_6192;void * BgL_z52priv1087z52_6193;
BgL_z42native1082z42_6188 = 
FOREIGN_TO_COBJ(BgL_z42native1082z42_4902); 
BgL_z52p1083z52_6189 = 
FOREIGN_TO_COBJ(BgL_z52p1083z52_4903); 
BgL_z52q1084z52_6190 = 
FOREIGN_TO_COBJ(BgL_z52q1084z52_4904); 
BgL_z52g1085z52_6191 = 
FOREIGN_TO_COBJ(BgL_z52g1085z52_4905); 
BgL_z52pub1086z52_6192 = 
FOREIGN_TO_COBJ(BgL_z52pub1086z52_4906); 
BgL_z52priv1087z52_6193 = 
FOREIGN_TO_COBJ(BgL_z52priv1087z52_4907); 
{ /* Llib/ssl.scm 429 */
BgL_dhz00_bglt BgL_new1157z00_6194;
{ /* Llib/ssl.scm 429 */
BgL_dhz00_bglt BgL_new1156z00_6195;
BgL_new1156z00_6195 = 
((BgL_dhz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_dhz00_bgl) ))); 
{ /* Llib/ssl.scm 429 */
long BgL_arg1940z00_6196;
{ /* Llib/ssl.scm 429 */
long BgL_res2349z00_6197;
BgL_res2349z00_6197 = 
BGL_CLASS_INDEX(BGl_dhz00zz__ssl_sslz00); 
BgL_arg1940z00_6196 = BgL_res2349z00_6197; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1156z00_6195), BgL_arg1940z00_6196); } 
BgL_new1157z00_6194 = BgL_new1156z00_6195; } 
((((BgL_dhz00_bglt)COBJECT(BgL_new1157z00_6194))->BgL_z42nativez42)=((void *)BgL_z42native1082z42_6188),BUNSPEC); 
((((BgL_dhz00_bglt)COBJECT(BgL_new1157z00_6194))->BgL_z52pz52)=((void *)BgL_z52p1083z52_6189),BUNSPEC); 
((((BgL_dhz00_bglt)COBJECT(BgL_new1157z00_6194))->BgL_z52qz52)=((void *)BgL_z52q1084z52_6190),BUNSPEC); 
((((BgL_dhz00_bglt)COBJECT(BgL_new1157z00_6194))->BgL_z52gz52)=((void *)BgL_z52g1085z52_6191),BUNSPEC); 
((((BgL_dhz00_bglt)COBJECT(BgL_new1157z00_6194))->BgL_z52pubz52)=((void *)BgL_z52pub1086z52_6192),BUNSPEC); 
((((BgL_dhz00_bglt)COBJECT(BgL_new1157z00_6194))->BgL_z52privz52)=((void *)BgL_z52priv1087z52_6193),BUNSPEC); 
{ /* Llib/ssl.scm 429 */
obj_t BgL_fun1939z00_6198;
BgL_fun1939z00_6198 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_dhz00zz__ssl_sslz00); 
PROCEDURE_ENTRY(BgL_fun1939z00_6198)(BgL_fun1939z00_6198, 
((obj_t)BgL_new1157z00_6194), BEOA); } 
return BgL_new1157z00_6194;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:2074> */
obj_t BGl_z62zc3anonymousza32074ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4908, obj_t BgL_oz00_4909, obj_t BgL_vz00_4910)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 474 */
{ 
void * BgL_auxz00_8036;
{ /* Llib/ssl.scm 480 */
obj_t BgL_tmpz00_8038;
BgL_tmpz00_8038 = 
((obj_t)BgL_vz00_4910); 
BgL_auxz00_8036 = 
(BIGNUM *)FOREIGN_TO_COBJ(BgL_tmpz00_8038); } 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4909)))->BgL_z52pubz52)=((void *)BgL_auxz00_8036),BUNSPEC); } 
{ /* Llib/ssl.scm 481 */
void * BgL_arg2075z00_6199;void * BgL_arg2076z00_6200;void * BgL_arg2077z00_6201;
BgL_arg2075z00_6199 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4909)))->BgL_z42nativez42); 
BgL_arg2076z00_6200 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4909)))->BgL_z52pubz52); 
BgL_arg2077z00_6201 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4909)))->BgL_z52privz52); 
bgl_dh_pub_priv_key_set(BgL_arg2075z00_6199, BgL_arg2076z00_6200, BgL_arg2077z00_6201); BUNSPEC; } 
return 
((obj_t)BgL_vz00_4910);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2070> */
obj_t BGl_z62zc3anonymousza32070ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4911, obj_t BgL_oz00_4912)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 474 */
{ /* Llib/ssl.scm 477 */
void * BgL_arg2071z00_6202;
{ /* Llib/ssl.scm 477 */
void * BgL_arg2072z00_6203;
BgL_arg2072z00_6203 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4912)))->BgL_z42nativez42); 
BgL_arg2071z00_6202 = 
bgl_dh_public_key(BgL_arg2072z00_6203); } 
return 
void_star_to_obj(BgL_arg2071z00_6202);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2061> */
obj_t BGl_z62zc3anonymousza32061ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4913, obj_t BgL_oz00_4914, obj_t BgL_vz00_4915)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 465 */
{ 
void * BgL_auxz00_8054;
{ /* Llib/ssl.scm 471 */
obj_t BgL_tmpz00_8056;
BgL_tmpz00_8056 = 
((obj_t)BgL_vz00_4915); 
BgL_auxz00_8054 = 
(BIGNUM *)FOREIGN_TO_COBJ(BgL_tmpz00_8056); } 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4914)))->BgL_z52privz52)=((void *)BgL_auxz00_8054),BUNSPEC); } 
{ /* Llib/ssl.scm 472 */
void * BgL_arg2062z00_6204;void * BgL_arg2063z00_6205;void * BgL_arg2064z00_6206;
BgL_arg2062z00_6204 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4914)))->BgL_z42nativez42); 
BgL_arg2063z00_6205 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4914)))->BgL_z52pubz52); 
BgL_arg2064z00_6206 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4914)))->BgL_z52privz52); 
bgl_dh_pub_priv_key_set(BgL_arg2062z00_6204, BgL_arg2063z00_6205, BgL_arg2064z00_6206); BUNSPEC; } 
return 
((obj_t)BgL_vz00_4915);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2057> */
obj_t BGl_z62zc3anonymousza32057ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4916, obj_t BgL_oz00_4917)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 465 */
{ /* Llib/ssl.scm 468 */
void * BgL_arg2058z00_6207;
{ /* Llib/ssl.scm 468 */
void * BgL_arg2059z00_6208;
BgL_arg2059z00_6208 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4917)))->BgL_z42nativez42); 
BgL_arg2058z00_6207 = 
bgl_dh_private_key(BgL_arg2059z00_6208); } 
return 
void_star_to_obj(BgL_arg2058z00_6207);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2047> */
obj_t BGl_z62zc3anonymousza32047ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4918, obj_t BgL_oz00_4919, obj_t BgL_vz00_4920)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 455 */
{ 
void * BgL_auxz00_8072;
{ /* Llib/ssl.scm 462 */
obj_t BgL_tmpz00_8074;
BgL_tmpz00_8074 = 
((obj_t)BgL_vz00_4920); 
BgL_auxz00_8072 = 
(BIGNUM *)FOREIGN_TO_COBJ(BgL_tmpz00_8074); } 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4919)))->BgL_z52gz52)=((void *)BgL_auxz00_8072),BUNSPEC); } 
{ /* Llib/ssl.scm 463 */
void * BgL_arg2048z00_6209;void * BgL_arg2049z00_6210;void * BgL_arg2050z00_6211;void * BgL_arg2051z00_6212;
BgL_arg2048z00_6209 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4919)))->BgL_z42nativez42); 
BgL_arg2049z00_6210 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4919)))->BgL_z52pz52); 
BgL_arg2050z00_6211 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4919)))->BgL_z52qz52); 
BgL_arg2051z00_6212 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4919)))->BgL_z52gz52); 
bgl_dh_pqg_set(BgL_arg2048z00_6209, BgL_arg2049z00_6210, BgL_arg2050z00_6211, BgL_arg2051z00_6212); BUNSPEC; } 
return 
((obj_t)BgL_vz00_4920);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2043> */
obj_t BGl_z62zc3anonymousza32043ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4921, obj_t BgL_oz00_4922)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 455 */
{ /* Llib/ssl.scm 458 */
void * BgL_arg2044z00_6213;
{ /* Llib/ssl.scm 458 */
void * BgL_arg2045z00_6214;
BgL_arg2045z00_6214 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4922)))->BgL_z42nativez42); 
BgL_arg2044z00_6213 = 
bgl_dh_g(BgL_arg2045z00_6214); } 
return 
void_star_to_obj(BgL_arg2044z00_6213);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2033> */
obj_t BGl_z62zc3anonymousza32033ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4923, obj_t BgL_oz00_4924, obj_t BgL_vz00_4925)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 446 */
{ 
void * BgL_auxz00_8092;
{ /* Llib/ssl.scm 452 */
obj_t BgL_tmpz00_8094;
BgL_tmpz00_8094 = 
((obj_t)BgL_vz00_4925); 
BgL_auxz00_8092 = 
(BIGNUM *)FOREIGN_TO_COBJ(BgL_tmpz00_8094); } 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4924)))->BgL_z52qz52)=((void *)BgL_auxz00_8092),BUNSPEC); } 
{ /* Llib/ssl.scm 453 */
void * BgL_arg2034z00_6215;void * BgL_arg2035z00_6216;void * BgL_arg2036z00_6217;void * BgL_arg2037z00_6218;
BgL_arg2034z00_6215 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4924)))->BgL_z42nativez42); 
BgL_arg2035z00_6216 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4924)))->BgL_z52pz52); 
BgL_arg2036z00_6217 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4924)))->BgL_z52qz52); 
BgL_arg2037z00_6218 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4924)))->BgL_z52gz52); 
bgl_dh_pqg_set(BgL_arg2034z00_6215, BgL_arg2035z00_6216, BgL_arg2036z00_6217, BgL_arg2037z00_6218); BUNSPEC; } 
return 
((obj_t)BgL_vz00_4925);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2029> */
obj_t BGl_z62zc3anonymousza32029ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4926, obj_t BgL_oz00_4927)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 446 */
{ /* Llib/ssl.scm 449 */
void * BgL_arg2030z00_6219;
{ /* Llib/ssl.scm 449 */
void * BgL_arg2031z00_6220;
BgL_arg2031z00_6220 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4927)))->BgL_z42nativez42); 
BgL_arg2030z00_6219 = 
bgl_dh_p(BgL_arg2031z00_6220); } 
return 
void_star_to_obj(BgL_arg2030z00_6219);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2019> */
obj_t BGl_z62zc3anonymousza32019ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4928, obj_t BgL_oz00_4929, obj_t BgL_vz00_4930)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 437 */
{ 
void * BgL_auxz00_8112;
{ /* Llib/ssl.scm 443 */
obj_t BgL_tmpz00_8114;
BgL_tmpz00_8114 = 
((obj_t)BgL_vz00_4930); 
BgL_auxz00_8112 = 
(BIGNUM *)FOREIGN_TO_COBJ(BgL_tmpz00_8114); } 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4929)))->BgL_z52pz52)=((void *)BgL_auxz00_8112),BUNSPEC); } 
{ /* Llib/ssl.scm 444 */
void * BgL_arg2020z00_6221;void * BgL_arg2021z00_6222;void * BgL_arg2022z00_6223;void * BgL_arg2023z00_6224;
BgL_arg2020z00_6221 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4929)))->BgL_z42nativez42); 
BgL_arg2021z00_6222 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4929)))->BgL_z52pz52); 
BgL_arg2022z00_6223 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4929)))->BgL_z52qz52); 
BgL_arg2023z00_6224 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4929)))->BgL_z52gz52); 
bgl_dh_pqg_set(BgL_arg2020z00_6221, BgL_arg2021z00_6222, BgL_arg2022z00_6223, BgL_arg2023z00_6224); BUNSPEC; } 
return 
((obj_t)BgL_vz00_4930);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2015> */
obj_t BGl_z62zc3anonymousza32015ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4931, obj_t BgL_oz00_4932)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 437 */
{ /* Llib/ssl.scm 440 */
void * BgL_arg2016z00_6225;
{ /* Llib/ssl.scm 440 */
void * BgL_arg2017z00_6226;
BgL_arg2017z00_6226 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4932)))->BgL_z42nativez42); 
BgL_arg2016z00_6225 = 
bgl_dh_p(BgL_arg2017z00_6226); } 
return 
void_star_to_obj(BgL_arg2016z00_6225);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:2010> */
obj_t BGl_z62zc3anonymousza32010ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4933, obj_t BgL_oz00_4934, obj_t BgL_vz00_4935)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_4934), 
(int)(((long)4)), BgL_vz00_4935);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2009> */
obj_t BGl_z62zc3anonymousza32009ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4936, obj_t BgL_oz00_4937)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_4937), 
(int)(((long)4)));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2005> */
obj_t BGl_z62zc3anonymousza32005ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4938, obj_t BgL_oz00_4939, obj_t BgL_vz00_4940)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_4939), 
(int)(((long)3)), BgL_vz00_4940);} 
BGL_FUNCTION_END;
}



/* &<anonymous:2004> */
obj_t BGl_z62zc3anonymousza32004ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4941, obj_t BgL_oz00_4942)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_4942), 
(int)(((long)3)));} 
BGL_FUNCTION_END;
}



/* &<anonymous:2000> */
obj_t BGl_z62zc3anonymousza32000ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4943, obj_t BgL_oz00_4944, obj_t BgL_vz00_4945)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_4944), 
(int)(((long)2)), BgL_vz00_4945);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1999> */
obj_t BGl_z62zc3anonymousza31999ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4946, obj_t BgL_oz00_4947)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_4947), 
(int)(((long)2)));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1995> */
obj_t BGl_z62zc3anonymousza31995ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4948, obj_t BgL_oz00_4949, obj_t BgL_vz00_4950)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_4949), 
(int)(((long)1)), BgL_vz00_4950);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1994> */
obj_t BGl_z62zc3anonymousza31994ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4951, obj_t BgL_oz00_4952)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_4952), 
(int)(((long)1)));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1990> */
obj_t BGl_z62zc3anonymousza31990ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4953, obj_t BgL_oz00_4954, obj_t BgL_vz00_4955)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_4954), 
(int)(((long)0)), BgL_vz00_4955);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1989> */
obj_t BGl_z62zc3anonymousza31989ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4956, obj_t BgL_oz00_4957)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_4957), 
(int)(((long)0)));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1985> */
obj_t BGl_z62zc3anonymousza31985ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4958)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
return 
void_star_to_obj(((BIGNUM *)0L));} 
BGL_FUNCTION_END;
}



/* &lambda1984 */
obj_t BGl_z62lambda1984z62zz__ssl_sslz00(obj_t BgL_envz00_4959, obj_t BgL_oz00_4960, obj_t BgL_vz00_4961)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
{ /* Llib/ssl.scm 429 */
void * BgL_vz00_6228;
BgL_vz00_6228 = 
FOREIGN_TO_COBJ(BgL_vz00_4961); 
return 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4960)))->BgL_z52privz52)=((void *)BgL_vz00_6228),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1983 */
obj_t BGl_z62lambda1983z62zz__ssl_sslz00(obj_t BgL_envz00_4962, obj_t BgL_oz00_4963)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
return 
void_star_to_obj(
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4963)))->BgL_z52privz52));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1978> */
obj_t BGl_z62zc3anonymousza31978ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4964)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
return 
void_star_to_obj(((BIGNUM *)0L));} 
BGL_FUNCTION_END;
}



/* &lambda1977 */
obj_t BGl_z62lambda1977z62zz__ssl_sslz00(obj_t BgL_envz00_4965, obj_t BgL_oz00_4966, obj_t BgL_vz00_4967)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
{ /* Llib/ssl.scm 429 */
void * BgL_vz00_6231;
BgL_vz00_6231 = 
FOREIGN_TO_COBJ(BgL_vz00_4967); 
return 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4966)))->BgL_z52pubz52)=((void *)BgL_vz00_6231),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1976 */
obj_t BGl_z62lambda1976z62zz__ssl_sslz00(obj_t BgL_envz00_4968, obj_t BgL_oz00_4969)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
return 
void_star_to_obj(
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4969)))->BgL_z52pubz52));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1971> */
obj_t BGl_z62zc3anonymousza31971ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4970)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
return 
void_star_to_obj(((BIGNUM *)0L));} 
BGL_FUNCTION_END;
}



/* &lambda1970 */
obj_t BGl_z62lambda1970z62zz__ssl_sslz00(obj_t BgL_envz00_4971, obj_t BgL_oz00_4972, obj_t BgL_vz00_4973)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
{ /* Llib/ssl.scm 429 */
void * BgL_vz00_6234;
BgL_vz00_6234 = 
FOREIGN_TO_COBJ(BgL_vz00_4973); 
return 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4972)))->BgL_z52gz52)=((void *)BgL_vz00_6234),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1969 */
obj_t BGl_z62lambda1969z62zz__ssl_sslz00(obj_t BgL_envz00_4974, obj_t BgL_oz00_4975)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
return 
void_star_to_obj(
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4975)))->BgL_z52gz52));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1964> */
obj_t BGl_z62zc3anonymousza31964ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4976)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
return 
void_star_to_obj(((BIGNUM *)0L));} 
BGL_FUNCTION_END;
}



/* &lambda1963 */
obj_t BGl_z62lambda1963z62zz__ssl_sslz00(obj_t BgL_envz00_4977, obj_t BgL_oz00_4978, obj_t BgL_vz00_4979)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
{ /* Llib/ssl.scm 429 */
void * BgL_vz00_6237;
BgL_vz00_6237 = 
FOREIGN_TO_COBJ(BgL_vz00_4979); 
return 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4978)))->BgL_z52qz52)=((void *)BgL_vz00_6237),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1962 */
obj_t BGl_z62lambda1962z62zz__ssl_sslz00(obj_t BgL_envz00_4980, obj_t BgL_oz00_4981)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
return 
void_star_to_obj(
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4981)))->BgL_z52qz52));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1957> */
obj_t BGl_z62zc3anonymousza31957ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4982)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
return 
void_star_to_obj(((BIGNUM *)0L));} 
BGL_FUNCTION_END;
}



/* &lambda1956 */
obj_t BGl_z62lambda1956z62zz__ssl_sslz00(obj_t BgL_envz00_4983, obj_t BgL_oz00_4984, obj_t BgL_vz00_4985)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
{ /* Llib/ssl.scm 429 */
void * BgL_vz00_6240;
BgL_vz00_6240 = 
FOREIGN_TO_COBJ(BgL_vz00_4985); 
return 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4984)))->BgL_z52pz52)=((void *)BgL_vz00_6240),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1955 */
obj_t BGl_z62lambda1955z62zz__ssl_sslz00(obj_t BgL_envz00_4986, obj_t BgL_oz00_4987)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
return 
void_star_to_obj(
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4987)))->BgL_z52pz52));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1950> */
obj_t BGl_z62zc3anonymousza31950ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4988)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
return 
void_star_to_obj(0L);} 
BGL_FUNCTION_END;
}



/* &lambda1949 */
obj_t BGl_z62lambda1949z62zz__ssl_sslz00(obj_t BgL_envz00_4989, obj_t BgL_oz00_4990, obj_t BgL_vz00_4991)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
{ /* Llib/ssl.scm 429 */
void * BgL_vz00_6243;
BgL_vz00_6243 = 
FOREIGN_TO_COBJ(BgL_vz00_4991); 
return 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4990)))->BgL_z42nativez42)=((void *)BgL_vz00_6243),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1948 */
obj_t BGl_z62lambda1948z62zz__ssl_sslz00(obj_t BgL_envz00_4992, obj_t BgL_oz00_4993)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 429 */
return 
void_star_to_obj(
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_oz00_4993)))->BgL_z42nativez42));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1819> */
obj_t BGl_z62zc3anonymousza31819ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_4994, obj_t BgL_new1080z00_4995)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
{ 
BgL_sslzd2connectionzd2_bglt BgL_auxz00_8204;
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1080z00_4995)))->BgL_z42nativez42)=((void *)
0L),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1080z00_4995)))->BgL_z42biozd2readz90)=((void *)
0L),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1080z00_4995)))->BgL_z42biozd2writez90)=((void *)
0L),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1080z00_4995)))->BgL_z42nextzd2sessionz90)=((void *)
0L),BUNSPEC); 
{ 
BgL_securezd2contextzd2_bglt BgL_auxz00_8217;
{ /* Llib/ssl.scm 409 */
obj_t BgL_classz00_6246;
BgL_classz00_6246 = BGl_securezd2contextzd2zz__ssl_sslz00; 
{ /* Llib/ssl.scm 409 */
obj_t BgL__ortest_1106z00_6247;
BgL__ortest_1106z00_6247 = 
BGL_CLASS_NIL(BgL_classz00_6246); 
if(
CBOOL(BgL__ortest_1106z00_6247))
{ /* Llib/ssl.scm 409 */
BgL_auxz00_8217 = 
((BgL_securezd2contextzd2_bglt)BgL__ortest_1106z00_6247)
; }  else 
{ /* Llib/ssl.scm 409 */
BgL_auxz00_8217 = 
((BgL_securezd2contextzd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_6246))
; } } } 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1080z00_4995)))->BgL_ctxz00)=((BgL_securezd2contextzd2_bglt)BgL_auxz00_8217),BUNSPEC); } 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1080z00_4995)))->BgL_isserverz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1080z00_4995)))->BgL_requestzd2certzd2)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1080z00_4995)))->BgL_serverzd2namezd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1080z00_4995)))->BgL_rejectzd2unauthoriza7edz75)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1080z00_4995)))->BgL_infozd2callbackzd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1080z00_4995)))->BgL_snizd2contextzd2callbackz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1080z00_4995)))->BgL_newsessionzd2callbackzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1080z00_4995)))->BgL_selectedzd2npnzd2protosz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1080z00_4995)))->BgL_npnzd2protoszd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1080z00_4995)))->BgL_errz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1080z00_4995)))->BgL_receivedzd2shutdownzd2)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_new1080z00_4995)))->BgL_sentzd2shutdownzd2)=((bool_t)((bool_t)0)),BUNSPEC); 
BgL_auxz00_8204 = 
((BgL_sslzd2connectionzd2_bglt)BgL_new1080z00_4995); 
return 
((obj_t)BgL_auxz00_8204);} } 
BGL_FUNCTION_END;
}



/* &lambda1817 */
BgL_sslzd2connectionzd2_bglt BGl_z62lambda1817z62zz__ssl_sslz00(obj_t BgL_envz00_4996)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
{ /* Llib/ssl.scm 409 */
BgL_sslzd2connectionzd2_bglt BgL_new1079z00_6248;
BgL_new1079z00_6248 = 
((BgL_sslzd2connectionzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sslzd2connectionzd2_bgl) ))); 
{ /* Llib/ssl.scm 409 */
long BgL_arg1818z00_6249;
{ /* Llib/ssl.scm 409 */
long BgL_res2348z00_6250;
BgL_res2348z00_6250 = 
BGL_CLASS_INDEX(BGl_sslzd2connectionzd2zz__ssl_sslz00); 
BgL_arg1818z00_6249 = BgL_res2348z00_6250; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1079z00_6248), BgL_arg1818z00_6249); } 
return BgL_new1079z00_6248;} } 
BGL_FUNCTION_END;
}



/* &lambda1814 */
BgL_sslzd2connectionzd2_bglt BGl_z62lambda1814z62zz__ssl_sslz00(obj_t BgL_envz00_4997, obj_t BgL_z42native1062z42_4998, obj_t BgL_z42biozd2read1063z90_4999, obj_t BgL_z42biozd2write1064z90_5000, obj_t BgL_z42nextzd2session1065z90_5001, obj_t BgL_ctx1066z00_5002, obj_t BgL_isserver1067z00_5003, obj_t BgL_requestzd2cert1068zd2_5004, obj_t BgL_serverzd2name1069zd2_5005, obj_t BgL_rejectzd2unauthoriza7ed1070z75_5006, obj_t BgL_infozd2callback1071zd2_5007, obj_t BgL_snizd2contextzd2callback1072z00_5008, obj_t BgL_newsessionzd2callback1073zd2_5009, obj_t BgL_selectedzd2npnzd2protos1074z00_5010, obj_t BgL_npnzd2protos1075zd2_5011, obj_t BgL_err1076z00_5012, obj_t BgL_receivedzd2shutdown1077zd2_5013, obj_t BgL_sentzd2shutdown1078zd2_5014)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
{ /* Llib/ssl.scm 409 */
void * BgL_z42native1062z42_6251;void * BgL_z42biozd2read1063z90_6252;void * BgL_z42biozd2write1064z90_6253;void * BgL_z42nextzd2session1065z90_6254;bool_t BgL_isserver1067z00_6256;bool_t BgL_requestzd2cert1068zd2_6257;bool_t BgL_rejectzd2unauthoriza7ed1070z75_6258;bool_t BgL_receivedzd2shutdown1077zd2_6260;bool_t BgL_sentzd2shutdown1078zd2_6261;
BgL_z42native1062z42_6251 = 
FOREIGN_TO_COBJ(BgL_z42native1062z42_4998); 
BgL_z42biozd2read1063z90_6252 = 
FOREIGN_TO_COBJ(BgL_z42biozd2read1063z90_4999); 
BgL_z42biozd2write1064z90_6253 = 
FOREIGN_TO_COBJ(BgL_z42biozd2write1064z90_5000); 
BgL_z42nextzd2session1065z90_6254 = 
FOREIGN_TO_COBJ(BgL_z42nextzd2session1065z90_5001); 
BgL_isserver1067z00_6256 = 
CBOOL(BgL_isserver1067z00_5003); 
BgL_requestzd2cert1068zd2_6257 = 
CBOOL(BgL_requestzd2cert1068zd2_5004); 
BgL_rejectzd2unauthoriza7ed1070z75_6258 = 
CBOOL(BgL_rejectzd2unauthoriza7ed1070z75_5006); 
BgL_receivedzd2shutdown1077zd2_6260 = 
CBOOL(BgL_receivedzd2shutdown1077zd2_5013); 
BgL_sentzd2shutdown1078zd2_6261 = 
CBOOL(BgL_sentzd2shutdown1078zd2_5014); 
{ /* Llib/ssl.scm 409 */
BgL_sslzd2connectionzd2_bglt BgL_new1155z00_6262;
{ /* Llib/ssl.scm 409 */
BgL_sslzd2connectionzd2_bglt BgL_new1154z00_6263;
BgL_new1154z00_6263 = 
((BgL_sslzd2connectionzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sslzd2connectionzd2_bgl) ))); 
{ /* Llib/ssl.scm 409 */
long BgL_arg1816z00_6264;
{ /* Llib/ssl.scm 409 */
long BgL_res2347z00_6265;
BgL_res2347z00_6265 = 
BGL_CLASS_INDEX(BGl_sslzd2connectionzd2zz__ssl_sslz00); 
BgL_arg1816z00_6264 = BgL_res2347z00_6265; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1154z00_6263), BgL_arg1816z00_6264); } 
BgL_new1155z00_6262 = BgL_new1154z00_6263; } 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1155z00_6262))->BgL_z42nativez42)=((void *)BgL_z42native1062z42_6251),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1155z00_6262))->BgL_z42biozd2readz90)=((void *)BgL_z42biozd2read1063z90_6252),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1155z00_6262))->BgL_z42biozd2writez90)=((void *)BgL_z42biozd2write1064z90_6253),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1155z00_6262))->BgL_z42nextzd2sessionz90)=((void *)BgL_z42nextzd2session1065z90_6254),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1155z00_6262))->BgL_ctxz00)=((BgL_securezd2contextzd2_bglt)
((BgL_securezd2contextzd2_bglt)BgL_ctx1066z00_5002)),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1155z00_6262))->BgL_isserverz00)=((bool_t)BgL_isserver1067z00_6256),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1155z00_6262))->BgL_requestzd2certzd2)=((bool_t)BgL_requestzd2cert1068zd2_6257),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1155z00_6262))->BgL_serverzd2namezd2)=((obj_t)BgL_serverzd2name1069zd2_5005),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1155z00_6262))->BgL_rejectzd2unauthoriza7edz75)=((bool_t)BgL_rejectzd2unauthoriza7ed1070z75_6258),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1155z00_6262))->BgL_infozd2callbackzd2)=((obj_t)BgL_infozd2callback1071zd2_5007),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1155z00_6262))->BgL_snizd2contextzd2callbackz00)=((obj_t)BgL_snizd2contextzd2callback1072z00_5008),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1155z00_6262))->BgL_newsessionzd2callbackzd2)=((obj_t)
((obj_t)BgL_newsessionzd2callback1073zd2_5009)),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1155z00_6262))->BgL_selectedzd2npnzd2protosz00)=((obj_t)BgL_selectedzd2npnzd2protos1074z00_5010),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1155z00_6262))->BgL_npnzd2protoszd2)=((obj_t)BgL_npnzd2protos1075zd2_5011),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1155z00_6262))->BgL_errz00)=((obj_t)BgL_err1076z00_5012),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1155z00_6262))->BgL_receivedzd2shutdownzd2)=((bool_t)BgL_receivedzd2shutdown1077zd2_6260),BUNSPEC); 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(BgL_new1155z00_6262))->BgL_sentzd2shutdownzd2)=((bool_t)BgL_sentzd2shutdown1078zd2_6261),BUNSPEC); 
{ /* Llib/ssl.scm 409 */
obj_t BgL_fun1815z00_6266;
BgL_fun1815z00_6266 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_sslzd2connectionzd2zz__ssl_sslz00); 
PROCEDURE_ENTRY(BgL_fun1815z00_6266)(BgL_fun1815z00_6266, 
((obj_t)BgL_new1155z00_6262), BEOA); } 
return BgL_new1155z00_6262;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1932> */
obj_t BGl_z62zc3anonymousza31932ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_5015)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &lambda1931 */
obj_t BGl_z62lambda1931z62zz__ssl_sslz00(obj_t BgL_envz00_5016, obj_t BgL_oz00_5017, obj_t BgL_vz00_5018)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
{ /* Llib/ssl.scm 409 */
bool_t BgL_vz00_6268;
BgL_vz00_6268 = 
CBOOL(BgL_vz00_5018); 
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5017)))->BgL_sentzd2shutdownzd2)=((bool_t)BgL_vz00_6268),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1930 */
obj_t BGl_z62lambda1930z62zz__ssl_sslz00(obj_t BgL_envz00_5019, obj_t BgL_oz00_5020)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
BBOOL(
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5020)))->BgL_sentzd2shutdownzd2));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1925> */
obj_t BGl_z62zc3anonymousza31925ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_5021)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &lambda1924 */
obj_t BGl_z62lambda1924z62zz__ssl_sslz00(obj_t BgL_envz00_5022, obj_t BgL_oz00_5023, obj_t BgL_vz00_5024)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
{ /* Llib/ssl.scm 409 */
bool_t BgL_vz00_6271;
BgL_vz00_6271 = 
CBOOL(BgL_vz00_5024); 
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5023)))->BgL_receivedzd2shutdownzd2)=((bool_t)BgL_vz00_6271),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1923 */
obj_t BGl_z62lambda1923z62zz__ssl_sslz00(obj_t BgL_envz00_5025, obj_t BgL_oz00_5026)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
BBOOL(
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5026)))->BgL_receivedzd2shutdownzd2));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1918> */
obj_t BGl_z62zc3anonymousza31918ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_5027)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &lambda1917 */
obj_t BGl_z62lambda1917z62zz__ssl_sslz00(obj_t BgL_envz00_5028, obj_t BgL_oz00_5029, obj_t BgL_vz00_5030)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5029)))->BgL_errz00)=((obj_t)BgL_vz00_5030),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1916 */
obj_t BGl_z62lambda1916z62zz__ssl_sslz00(obj_t BgL_envz00_5031, obj_t BgL_oz00_5032)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5032)))->BgL_errz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1911> */
obj_t BGl_z62zc3anonymousza31911ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_5033)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* &lambda1910 */
obj_t BGl_z62lambda1910z62zz__ssl_sslz00(obj_t BgL_envz00_5034, obj_t BgL_oz00_5035, obj_t BgL_vz00_5036)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5035)))->BgL_npnzd2protoszd2)=((obj_t)BgL_vz00_5036),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1909 */
obj_t BGl_z62lambda1909z62zz__ssl_sslz00(obj_t BgL_envz00_5037, obj_t BgL_oz00_5038)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5038)))->BgL_npnzd2protoszd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1904> */
obj_t BGl_z62zc3anonymousza31904ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_5039)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* &lambda1903 */
obj_t BGl_z62lambda1903z62zz__ssl_sslz00(obj_t BgL_envz00_5040, obj_t BgL_oz00_5041, obj_t BgL_vz00_5042)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5041)))->BgL_selectedzd2npnzd2protosz00)=((obj_t)BgL_vz00_5042),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1902 */
obj_t BGl_z62lambda1902z62zz__ssl_sslz00(obj_t BgL_envz00_5043, obj_t BgL_oz00_5044)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5044)))->BgL_selectedzd2npnzd2protosz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1897> */
obj_t BGl_z62zc3anonymousza31897ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_5045)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return BGl_listzd2envzd2zz__r4_pairs_and_lists_6_3z00;} 
BGL_FUNCTION_END;
}



/* &lambda1896 */
obj_t BGl_z62lambda1896z62zz__ssl_sslz00(obj_t BgL_envz00_5046, obj_t BgL_oz00_5047, obj_t BgL_vz00_5048)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5047)))->BgL_newsessionzd2callbackzd2)=((obj_t)
((obj_t)BgL_vz00_5048)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1895 */
obj_t BGl_z62lambda1895z62zz__ssl_sslz00(obj_t BgL_envz00_5049, obj_t BgL_oz00_5050)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5050)))->BgL_newsessionzd2callbackzd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1890> */
obj_t BGl_z62zc3anonymousza31890ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_5051)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &lambda1889 */
obj_t BGl_z62lambda1889z62zz__ssl_sslz00(obj_t BgL_envz00_5052, obj_t BgL_oz00_5053, obj_t BgL_vz00_5054)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5053)))->BgL_snizd2contextzd2callbackz00)=((obj_t)BgL_vz00_5054),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1888 */
obj_t BGl_z62lambda1888z62zz__ssl_sslz00(obj_t BgL_envz00_5055, obj_t BgL_oz00_5056)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5056)))->BgL_snizd2contextzd2callbackz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1883> */
obj_t BGl_z62zc3anonymousza31883ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_5057)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &lambda1882 */
obj_t BGl_z62lambda1882z62zz__ssl_sslz00(obj_t BgL_envz00_5058, obj_t BgL_oz00_5059, obj_t BgL_vz00_5060)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5059)))->BgL_infozd2callbackzd2)=((obj_t)BgL_vz00_5060),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1881 */
obj_t BGl_z62lambda1881z62zz__ssl_sslz00(obj_t BgL_envz00_5061, obj_t BgL_oz00_5062)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5062)))->BgL_infozd2callbackzd2);} 
BGL_FUNCTION_END;
}



/* &lambda1876 */
obj_t BGl_z62lambda1876z62zz__ssl_sslz00(obj_t BgL_envz00_5063, obj_t BgL_oz00_5064, obj_t BgL_vz00_5065)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
{ /* Llib/ssl.scm 409 */
bool_t BgL_vz00_6287;
BgL_vz00_6287 = 
CBOOL(BgL_vz00_5065); 
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5064)))->BgL_rejectzd2unauthoriza7edz75)=((bool_t)BgL_vz00_6287),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1875 */
obj_t BGl_z62lambda1875z62zz__ssl_sslz00(obj_t BgL_envz00_5066, obj_t BgL_oz00_5067)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
BBOOL(
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5067)))->BgL_rejectzd2unauthoriza7edz75));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1871> */
obj_t BGl_z62zc3anonymousza31871ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_5068)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &lambda1870 */
obj_t BGl_z62lambda1870z62zz__ssl_sslz00(obj_t BgL_envz00_5069, obj_t BgL_oz00_5070, obj_t BgL_vz00_5071)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5070)))->BgL_serverzd2namezd2)=((obj_t)BgL_vz00_5071),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1869 */
obj_t BGl_z62lambda1869z62zz__ssl_sslz00(obj_t BgL_envz00_5072, obj_t BgL_oz00_5073)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5073)))->BgL_serverzd2namezd2);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1864> */
obj_t BGl_z62zc3anonymousza31864ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_5074)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &lambda1863 */
obj_t BGl_z62lambda1863z62zz__ssl_sslz00(obj_t BgL_envz00_5075, obj_t BgL_oz00_5076, obj_t BgL_vz00_5077)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
{ /* Llib/ssl.scm 409 */
bool_t BgL_vz00_6292;
BgL_vz00_6292 = 
CBOOL(BgL_vz00_5077); 
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5076)))->BgL_requestzd2certzd2)=((bool_t)BgL_vz00_6292),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1862 */
obj_t BGl_z62lambda1862z62zz__ssl_sslz00(obj_t BgL_envz00_5078, obj_t BgL_oz00_5079)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
BBOOL(
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5079)))->BgL_requestzd2certzd2));} 
BGL_FUNCTION_END;
}



/* &lambda1857 */
obj_t BGl_z62lambda1857z62zz__ssl_sslz00(obj_t BgL_envz00_5080, obj_t BgL_oz00_5081, obj_t BgL_vz00_5082)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
{ /* Llib/ssl.scm 409 */
bool_t BgL_vz00_6295;
BgL_vz00_6295 = 
CBOOL(BgL_vz00_5082); 
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5081)))->BgL_isserverz00)=((bool_t)BgL_vz00_6295),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1856 */
obj_t BGl_z62lambda1856z62zz__ssl_sslz00(obj_t BgL_envz00_5083, obj_t BgL_oz00_5084)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
BBOOL(
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5084)))->BgL_isserverz00));} 
BGL_FUNCTION_END;
}



/* &lambda1852 */
obj_t BGl_z62lambda1852z62zz__ssl_sslz00(obj_t BgL_envz00_5085, obj_t BgL_oz00_5086, obj_t BgL_vz00_5087)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5086)))->BgL_ctxz00)=((BgL_securezd2contextzd2_bglt)
((BgL_securezd2contextzd2_bglt)BgL_vz00_5087)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1851 */
BgL_securezd2contextzd2_bglt BGl_z62lambda1851z62zz__ssl_sslz00(obj_t BgL_envz00_5088, obj_t BgL_oz00_5089)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5089)))->BgL_ctxz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1847> */
obj_t BGl_z62zc3anonymousza31847ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_5090)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
void_star_to_obj(0L);} 
BGL_FUNCTION_END;
}



/* &lambda1846 */
obj_t BGl_z62lambda1846z62zz__ssl_sslz00(obj_t BgL_envz00_5091, obj_t BgL_oz00_5092, obj_t BgL_vz00_5093)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
{ /* Llib/ssl.scm 409 */
void * BgL_vz00_6301;
BgL_vz00_6301 = 
FOREIGN_TO_COBJ(BgL_vz00_5093); 
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5092)))->BgL_z42nextzd2sessionz90)=((void *)BgL_vz00_6301),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1845 */
obj_t BGl_z62lambda1845z62zz__ssl_sslz00(obj_t BgL_envz00_5094, obj_t BgL_oz00_5095)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
void_star_to_obj(
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5095)))->BgL_z42nextzd2sessionz90));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1840> */
obj_t BGl_z62zc3anonymousza31840ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_5096)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
void_star_to_obj(0L);} 
BGL_FUNCTION_END;
}



/* &lambda1839 */
obj_t BGl_z62lambda1839z62zz__ssl_sslz00(obj_t BgL_envz00_5097, obj_t BgL_oz00_5098, obj_t BgL_vz00_5099)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
{ /* Llib/ssl.scm 409 */
void * BgL_vz00_6304;
BgL_vz00_6304 = 
FOREIGN_TO_COBJ(BgL_vz00_5099); 
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5098)))->BgL_z42biozd2writez90)=((void *)BgL_vz00_6304),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1838 */
obj_t BGl_z62lambda1838z62zz__ssl_sslz00(obj_t BgL_envz00_5100, obj_t BgL_oz00_5101)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
void_star_to_obj(
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5101)))->BgL_z42biozd2writez90));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1833> */
obj_t BGl_z62zc3anonymousza31833ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_5102)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
void_star_to_obj(0L);} 
BGL_FUNCTION_END;
}



/* &lambda1832 */
obj_t BGl_z62lambda1832z62zz__ssl_sslz00(obj_t BgL_envz00_5103, obj_t BgL_oz00_5104, obj_t BgL_vz00_5105)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
{ /* Llib/ssl.scm 409 */
void * BgL_vz00_6307;
BgL_vz00_6307 = 
FOREIGN_TO_COBJ(BgL_vz00_5105); 
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5104)))->BgL_z42biozd2readz90)=((void *)BgL_vz00_6307),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1831 */
obj_t BGl_z62lambda1831z62zz__ssl_sslz00(obj_t BgL_envz00_5106, obj_t BgL_oz00_5107)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
void_star_to_obj(
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5107)))->BgL_z42biozd2readz90));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1826> */
obj_t BGl_z62zc3anonymousza31826ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_5108)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
void_star_to_obj(0L);} 
BGL_FUNCTION_END;
}



/* &lambda1825 */
obj_t BGl_z62lambda1825z62zz__ssl_sslz00(obj_t BgL_envz00_5109, obj_t BgL_oz00_5110, obj_t BgL_vz00_5111)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
{ /* Llib/ssl.scm 409 */
void * BgL_vz00_6310;
BgL_vz00_6310 = 
FOREIGN_TO_COBJ(BgL_vz00_5111); 
return 
((((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5110)))->BgL_z42nativez42)=((void *)BgL_vz00_6310),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1824 */
obj_t BGl_z62lambda1824z62zz__ssl_sslz00(obj_t BgL_envz00_5112, obj_t BgL_oz00_5113)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 409 */
return 
void_star_to_obj(
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_oz00_5113)))->BgL_z42nativez42));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1787> */
obj_t BGl_z62zc3anonymousza31787ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_5114, obj_t BgL_new1060z00_5115)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 403 */
{ 
BgL_securezd2contextzd2_bglt BgL_auxz00_8393;
((((BgL_securezd2contextzd2_bglt)COBJECT(
((BgL_securezd2contextzd2_bglt)BgL_new1060z00_5115)))->BgL_z42nativez42)=((void *)
0L),BUNSPEC); 
((((BgL_securezd2contextzd2_bglt)COBJECT(
((BgL_securezd2contextzd2_bglt)BgL_new1060z00_5115)))->BgL_z42cazd2storez90)=((void *)
0L),BUNSPEC); 
((((BgL_securezd2contextzd2_bglt)COBJECT(
((BgL_securezd2contextzd2_bglt)BgL_new1060z00_5115)))->BgL_methodz00)=((obj_t)BGl_string3607z00zz__ssl_sslz00),BUNSPEC); 
BgL_auxz00_8393 = 
((BgL_securezd2contextzd2_bglt)BgL_new1060z00_5115); 
return 
((obj_t)BgL_auxz00_8393);} } 
BGL_FUNCTION_END;
}



/* &lambda1785 */
BgL_securezd2contextzd2_bglt BGl_z62lambda1785z62zz__ssl_sslz00(obj_t BgL_envz00_5116)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 403 */
{ /* Llib/ssl.scm 403 */
BgL_securezd2contextzd2_bglt BgL_new1058z00_6313;
BgL_new1058z00_6313 = 
((BgL_securezd2contextzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_securezd2contextzd2_bgl) ))); 
{ /* Llib/ssl.scm 403 */
long BgL_arg1786z00_6314;
{ /* Llib/ssl.scm 403 */
long BgL_res2346z00_6315;
BgL_res2346z00_6315 = 
BGL_CLASS_INDEX(BGl_securezd2contextzd2zz__ssl_sslz00); 
BgL_arg1786z00_6314 = BgL_res2346z00_6315; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1058z00_6313), BgL_arg1786z00_6314); } 
return BgL_new1058z00_6313;} } 
BGL_FUNCTION_END;
}



/* &lambda1782 */
BgL_securezd2contextzd2_bglt BGl_z62lambda1782z62zz__ssl_sslz00(obj_t BgL_envz00_5117, obj_t BgL_z42native1055z42_5118, obj_t BgL_z42cazd2store1056z90_5119, obj_t BgL_method1057z00_5120)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 403 */
{ /* Llib/ssl.scm 403 */
void * BgL_z42native1055z42_6316;void * BgL_z42cazd2store1056z90_6317;
BgL_z42native1055z42_6316 = 
FOREIGN_TO_COBJ(BgL_z42native1055z42_5118); 
BgL_z42cazd2store1056z90_6317 = 
FOREIGN_TO_COBJ(BgL_z42cazd2store1056z90_5119); 
{ /* Llib/ssl.scm 403 */
BgL_securezd2contextzd2_bglt BgL_new1153z00_6319;
{ /* Llib/ssl.scm 403 */
BgL_securezd2contextzd2_bglt BgL_new1152z00_6320;
BgL_new1152z00_6320 = 
((BgL_securezd2contextzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_securezd2contextzd2_bgl) ))); 
{ /* Llib/ssl.scm 403 */
long BgL_arg1784z00_6321;
{ /* Llib/ssl.scm 403 */
long BgL_res2345z00_6322;
BgL_res2345z00_6322 = 
BGL_CLASS_INDEX(BGl_securezd2contextzd2zz__ssl_sslz00); 
BgL_arg1784z00_6321 = BgL_res2345z00_6322; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1152z00_6320), BgL_arg1784z00_6321); } 
BgL_new1153z00_6319 = BgL_new1152z00_6320; } 
((((BgL_securezd2contextzd2_bglt)COBJECT(BgL_new1153z00_6319))->BgL_z42nativez42)=((void *)BgL_z42native1055z42_6316),BUNSPEC); 
((((BgL_securezd2contextzd2_bglt)COBJECT(BgL_new1153z00_6319))->BgL_z42cazd2storez90)=((void *)BgL_z42cazd2store1056z90_6317),BUNSPEC); 
((((BgL_securezd2contextzd2_bglt)COBJECT(BgL_new1153z00_6319))->BgL_methodz00)=((obj_t)
((obj_t)BgL_method1057z00_5120)),BUNSPEC); 
{ /* Llib/ssl.scm 403 */
obj_t BgL_fun1783z00_6323;
BgL_fun1783z00_6323 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_securezd2contextzd2zz__ssl_sslz00); 
PROCEDURE_ENTRY(BgL_fun1783z00_6323)(BgL_fun1783z00_6323, 
((obj_t)BgL_new1153z00_6319), BEOA); } 
return BgL_new1153z00_6319;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1808> */
obj_t BGl_z62zc3anonymousza31808ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_5121)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 403 */
return BGl_string3608z00zz__ssl_sslz00;} 
BGL_FUNCTION_END;
}



/* &lambda1807 */
obj_t BGl_z62lambda1807z62zz__ssl_sslz00(obj_t BgL_envz00_5122, obj_t BgL_oz00_5123, obj_t BgL_vz00_5124)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 403 */
return 
((((BgL_securezd2contextzd2_bglt)COBJECT(
((BgL_securezd2contextzd2_bglt)BgL_oz00_5123)))->BgL_methodz00)=((obj_t)
((obj_t)BgL_vz00_5124)),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &lambda1806 */
obj_t BGl_z62lambda1806z62zz__ssl_sslz00(obj_t BgL_envz00_5125, obj_t BgL_oz00_5126)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 403 */
return 
(((BgL_securezd2contextzd2_bglt)COBJECT(
((BgL_securezd2contextzd2_bglt)BgL_oz00_5126)))->BgL_methodz00);} 
BGL_FUNCTION_END;
}



/* &<anonymous:1801> */
obj_t BGl_z62zc3anonymousza31801ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_5127)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 403 */
return 
void_star_to_obj(0L);} 
BGL_FUNCTION_END;
}



/* &lambda1800 */
obj_t BGl_z62lambda1800z62zz__ssl_sslz00(obj_t BgL_envz00_5128, obj_t BgL_oz00_5129, obj_t BgL_vz00_5130)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 403 */
{ /* Llib/ssl.scm 403 */
void * BgL_vz00_6328;
BgL_vz00_6328 = 
FOREIGN_TO_COBJ(BgL_vz00_5130); 
return 
((((BgL_securezd2contextzd2_bglt)COBJECT(
((BgL_securezd2contextzd2_bglt)BgL_oz00_5129)))->BgL_z42cazd2storez90)=((void *)BgL_vz00_6328),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1799 */
obj_t BGl_z62lambda1799z62zz__ssl_sslz00(obj_t BgL_envz00_5131, obj_t BgL_oz00_5132)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 403 */
return 
void_star_to_obj(
(((BgL_securezd2contextzd2_bglt)COBJECT(
((BgL_securezd2contextzd2_bglt)BgL_oz00_5132)))->BgL_z42cazd2storez90));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1794> */
obj_t BGl_z62zc3anonymousza31794ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_5133)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 403 */
return 
void_star_to_obj(0L);} 
BGL_FUNCTION_END;
}



/* &lambda1793 */
obj_t BGl_z62lambda1793z62zz__ssl_sslz00(obj_t BgL_envz00_5134, obj_t BgL_oz00_5135, obj_t BgL_vz00_5136)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 403 */
{ /* Llib/ssl.scm 403 */
void * BgL_vz00_6331;
BgL_vz00_6331 = 
FOREIGN_TO_COBJ(BgL_vz00_5136); 
return 
((((BgL_securezd2contextzd2_bglt)COBJECT(
((BgL_securezd2contextzd2_bglt)BgL_oz00_5135)))->BgL_z42nativez42)=((void *)BgL_vz00_6331),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1792 */
obj_t BGl_z62lambda1792z62zz__ssl_sslz00(obj_t BgL_envz00_5137, obj_t BgL_oz00_5138)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 403 */
return 
void_star_to_obj(
(((BgL_securezd2contextzd2_bglt)COBJECT(
((BgL_securezd2contextzd2_bglt)BgL_oz00_5138)))->BgL_z42nativez42));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1771> */
obj_t BGl_z62zc3anonymousza31771ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_5139, obj_t BgL_new1053z00_5140)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 300 */
{ 
BgL_privatezd2keyzd2_bglt BgL_auxz00_8443;
((((BgL_privatezd2keyzd2_bglt)COBJECT(
((BgL_privatezd2keyzd2_bglt)BgL_new1053z00_5140)))->BgL_z42nativez42)=((void *)
0L),BUNSPEC); 
BgL_auxz00_8443 = 
((BgL_privatezd2keyzd2_bglt)BgL_new1053z00_5140); 
return 
((obj_t)BgL_auxz00_8443);} } 
BGL_FUNCTION_END;
}



/* &lambda1769 */
BgL_privatezd2keyzd2_bglt BGl_z62lambda1769z62zz__ssl_sslz00(obj_t BgL_envz00_5141)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 300 */
{ /* Llib/ssl.scm 300 */
BgL_privatezd2keyzd2_bglt BgL_new1052z00_6334;
BgL_new1052z00_6334 = 
((BgL_privatezd2keyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_privatezd2keyzd2_bgl) ))); 
{ /* Llib/ssl.scm 300 */
long BgL_arg1770z00_6335;
{ /* Llib/ssl.scm 300 */
long BgL_res2344z00_6336;
BgL_res2344z00_6336 = 
BGL_CLASS_INDEX(BGl_privatezd2keyzd2zz__ssl_sslz00); 
BgL_arg1770z00_6335 = BgL_res2344z00_6336; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1052z00_6334), BgL_arg1770z00_6335); } 
return BgL_new1052z00_6334;} } 
BGL_FUNCTION_END;
}



/* &lambda1767 */
BgL_privatezd2keyzd2_bglt BGl_z62lambda1767z62zz__ssl_sslz00(obj_t BgL_envz00_5142, obj_t BgL_z42native1051z42_5143)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 300 */
{ /* Llib/ssl.scm 300 */
void * BgL_z42native1051z42_6337;
BgL_z42native1051z42_6337 = 
FOREIGN_TO_COBJ(BgL_z42native1051z42_5143); 
{ /* Llib/ssl.scm 300 */
BgL_privatezd2keyzd2_bglt BgL_new1151z00_6338;
{ /* Llib/ssl.scm 300 */
BgL_privatezd2keyzd2_bglt BgL_new1150z00_6339;
BgL_new1150z00_6339 = 
((BgL_privatezd2keyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_privatezd2keyzd2_bgl) ))); 
{ /* Llib/ssl.scm 300 */
long BgL_arg1768z00_6340;
{ /* Llib/ssl.scm 300 */
long BgL_res2343z00_6341;
BgL_res2343z00_6341 = 
BGL_CLASS_INDEX(BGl_privatezd2keyzd2zz__ssl_sslz00); 
BgL_arg1768z00_6340 = BgL_res2343z00_6341; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1150z00_6339), BgL_arg1768z00_6340); } 
BgL_new1151z00_6338 = BgL_new1150z00_6339; } 
((((BgL_privatezd2keyzd2_bglt)COBJECT(BgL_new1151z00_6338))->BgL_z42nativez42)=((void *)BgL_z42native1051z42_6337),BUNSPEC); 
return BgL_new1151z00_6338;} } } 
BGL_FUNCTION_END;
}



/* &lambda1776 */
obj_t BGl_z62lambda1776z62zz__ssl_sslz00(obj_t BgL_envz00_5144, obj_t BgL_oz00_5145, obj_t BgL_vz00_5146)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 300 */
{ /* Llib/ssl.scm 300 */
void * BgL_vz00_6343;
BgL_vz00_6343 = 
FOREIGN_TO_COBJ(BgL_vz00_5146); 
return 
((((BgL_privatezd2keyzd2_bglt)COBJECT(
((BgL_privatezd2keyzd2_bglt)BgL_oz00_5145)))->BgL_z42nativez42)=((void *)BgL_vz00_6343),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1775 */
obj_t BGl_z62lambda1775z62zz__ssl_sslz00(obj_t BgL_envz00_5147, obj_t BgL_oz00_5148)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 300 */
return 
void_star_to_obj(
(((BgL_privatezd2keyzd2_bglt)COBJECT(
((BgL_privatezd2keyzd2_bglt)BgL_oz00_5148)))->BgL_z42nativez42));} 
BGL_FUNCTION_END;
}



/* &<anonymous:1756> */
obj_t BGl_z62zc3anonymousza31756ze3ze1zz__ssl_sslz00(obj_t BgL_envz00_5149, obj_t BgL_new1049z00_5150)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 297 */
{ 
BgL_certificatez00_bglt BgL_auxz00_8465;
((((BgL_certificatez00_bglt)COBJECT(
((BgL_certificatez00_bglt)BgL_new1049z00_5150)))->BgL_z42nativez42)=((void *)
0L),BUNSPEC); 
BgL_auxz00_8465 = 
((BgL_certificatez00_bglt)BgL_new1049z00_5150); 
return 
((obj_t)BgL_auxz00_8465);} } 
BGL_FUNCTION_END;
}



/* &lambda1754 */
BgL_certificatez00_bglt BGl_z62lambda1754z62zz__ssl_sslz00(obj_t BgL_envz00_5151)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 297 */
{ /* Llib/ssl.scm 297 */
BgL_certificatez00_bglt BgL_new1048z00_6346;
BgL_new1048z00_6346 = 
((BgL_certificatez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_certificatez00_bgl) ))); 
{ /* Llib/ssl.scm 297 */
long BgL_arg1755z00_6347;
{ /* Llib/ssl.scm 297 */
long BgL_res2342z00_6348;
BgL_res2342z00_6348 = 
BGL_CLASS_INDEX(BGl_certificatez00zz__ssl_sslz00); 
BgL_arg1755z00_6347 = BgL_res2342z00_6348; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1048z00_6346), BgL_arg1755z00_6347); } 
return BgL_new1048z00_6346;} } 
BGL_FUNCTION_END;
}



/* &lambda1752 */
BgL_certificatez00_bglt BGl_z62lambda1752z62zz__ssl_sslz00(obj_t BgL_envz00_5152, obj_t BgL_z42native1047z42_5153)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 297 */
{ /* Llib/ssl.scm 297 */
void * BgL_z42native1047z42_6349;
BgL_z42native1047z42_6349 = 
FOREIGN_TO_COBJ(BgL_z42native1047z42_5153); 
{ /* Llib/ssl.scm 297 */
BgL_certificatez00_bglt BgL_new1149z00_6350;
{ /* Llib/ssl.scm 297 */
BgL_certificatez00_bglt BgL_new1148z00_6351;
BgL_new1148z00_6351 = 
((BgL_certificatez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_certificatez00_bgl) ))); 
{ /* Llib/ssl.scm 297 */
long BgL_arg1753z00_6352;
{ /* Llib/ssl.scm 297 */
long BgL_res2341z00_6353;
BgL_res2341z00_6353 = 
BGL_CLASS_INDEX(BGl_certificatez00zz__ssl_sslz00); 
BgL_arg1753z00_6352 = BgL_res2341z00_6353; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1148z00_6351), BgL_arg1753z00_6352); } 
BgL_new1149z00_6350 = BgL_new1148z00_6351; } 
((((BgL_certificatez00_bglt)COBJECT(BgL_new1149z00_6350))->BgL_z42nativez42)=((void *)BgL_z42native1047z42_6349),BUNSPEC); 
return BgL_new1149z00_6350;} } } 
BGL_FUNCTION_END;
}



/* &lambda1761 */
obj_t BGl_z62lambda1761z62zz__ssl_sslz00(obj_t BgL_envz00_5154, obj_t BgL_oz00_5155, obj_t BgL_vz00_5156)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 297 */
{ /* Llib/ssl.scm 297 */
void * BgL_vz00_6355;
BgL_vz00_6355 = 
FOREIGN_TO_COBJ(BgL_vz00_5156); 
return 
((((BgL_certificatez00_bglt)COBJECT(
((BgL_certificatez00_bglt)BgL_oz00_5155)))->BgL_z42nativez42)=((void *)BgL_vz00_6355),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1760 */
obj_t BGl_z62lambda1760z62zz__ssl_sslz00(obj_t BgL_envz00_5157, obj_t BgL_oz00_5158)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 297 */
return 
void_star_to_obj(
(((BgL_certificatez00_bglt)COBJECT(
((BgL_certificatez00_bglt)BgL_oz00_5158)))->BgL_z42nativez42));} 
BGL_FUNCTION_END;
}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__ssl_sslz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 15 */
BGl_registerzd2genericz12zc0zz__objectz00(BGl_securezd2contextzd2initzd2envzd2zz__ssl_sslz00, BGl_proc3609z00zz__ssl_sslz00, BGl_securezd2contextzd2zz__ssl_sslz00, BGl_string3610z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_securezd2contextzd2closezd2envzd2zz__ssl_sslz00, BGl_proc3611z00zz__ssl_sslz00, BGl_securezd2contextzd2zz__ssl_sslz00, BGl_string3612z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_securezd2contextzd2addzd2rootzd2certsz12zd2envzc0zz__ssl_sslz00, BGl_proc3613z00zz__ssl_sslz00, BGl_securezd2contextzd2zz__ssl_sslz00, BGl_string3614z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_securezd2contextzd2addzd2cazd2certz12zd2envzc0zz__ssl_sslz00, BGl_proc3615z00zz__ssl_sslz00, BGl_securezd2contextzd2zz__ssl_sslz00, BGl_string3616z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_securezd2contextzd2addzd2crlz12zd2envz12zz__ssl_sslz00, BGl_proc3617z00zz__ssl_sslz00, BGl_securezd2contextzd2zz__ssl_sslz00, BGl_string3618z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_securezd2contextzd2setzd2keyz12zd2envz12zz__ssl_sslz00, BGl_proc3619z00zz__ssl_sslz00, BGl_securezd2contextzd2zz__ssl_sslz00, BGl_string3620z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_securezd2contextzd2setzd2certz12zd2envz12zz__ssl_sslz00, BGl_proc3621z00zz__ssl_sslz00, BGl_securezd2contextzd2zz__ssl_sslz00, BGl_string3622z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_securezd2contextzd2setzd2sessionzd2idzd2contextz12zd2envz12zz__ssl_sslz00, BGl_proc3623z00zz__ssl_sslz00, BGl_securezd2contextzd2zz__ssl_sslz00, BGl_string3624z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_securezd2contextzd2loadzd2pkcs12zd2envz00zz__ssl_sslz00, BGl_proc3625z00zz__ssl_sslz00, BGl_securezd2contextzd2zz__ssl_sslz00, BGl_string3626z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_securezd2contextzd2setzd2ciphersz12zd2envz12zz__ssl_sslz00, BGl_proc3627z00zz__ssl_sslz00, BGl_securezd2contextzd2zz__ssl_sslz00, BGl_string3628z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_securezd2contextzd2setzd2optionsz12zd2envz12zz__ssl_sslz00, BGl_proc3629z00zz__ssl_sslz00, BGl_securezd2contextzd2zz__ssl_sslz00, BGl_string3630z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2initzd2envzd2zz__ssl_sslz00, BGl_proc3631z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3632z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2startzd2envzd2zz__ssl_sslz00, BGl_proc3633z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3634z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2closezd2envzd2zz__ssl_sslz00, BGl_proc3635z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3636z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2shutdownzd2envzd2zz__ssl_sslz00, BGl_proc3637z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3638z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2readzd2envzd2zz__ssl_sslz00, BGl_proc3639z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3640z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2writezd2envzd2zz__ssl_sslz00, BGl_proc3641z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3642z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2clearzd2inzd2envz00zz__ssl_sslz00, BGl_proc3643z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3644z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2clearzd2outzd2envz00zz__ssl_sslz00, BGl_proc3645z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3646z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2initzd2finishedzf3zd2envzf3zz__ssl_sslz00, BGl_proc3647z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3648z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2enczd2pendingzd2envz00zz__ssl_sslz00, BGl_proc3649z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3650z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2clearzd2pendingzd2envz00zz__ssl_sslz00, BGl_proc3651z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3652z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2setzd2sessionzd2envz00zz__ssl_sslz00, BGl_proc3653z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3654z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2getzd2sessionzd2envz00zz__ssl_sslz00, BGl_proc3655z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3656z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2getzd2currentzd2cipherzd2envzd2zz__ssl_sslz00, BGl_proc3657z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3658z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2loadzd2sessionzd2envz00zz__ssl_sslz00, BGl_proc3659z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3660z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2verifyzd2errorzd2envz00zz__ssl_sslz00, BGl_proc3661z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3662z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2getzd2peerzd2certificatezd2envzd2zz__ssl_sslz00, BGl_proc3663z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3664z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2reusedzf3zd2envz21zz__ssl_sslz00, BGl_proc3665z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3666z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2connectionzd2getzd2negotiatedzd2protocolzd2envzd2zz__ssl_sslz00, BGl_proc3667z00zz__ssl_sslz00, BGl_sslzd2connectionzd2zz__ssl_sslz00, BGl_string3668z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_dhzd2initzd2envz00zz__ssl_sslz00, BGl_proc3669z00zz__ssl_sslz00, BGl_dhz00zz__ssl_sslz00, BGl_string3670z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_dhzd2siza7ezd2envza7zz__ssl_sslz00, BGl_proc3671z00zz__ssl_sslz00, BGl_dhz00zz__ssl_sslz00, BGl_string3672z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_dhzd2generatezd2parameterszd2exzd2envz00zz__ssl_sslz00, BGl_proc3673z00zz__ssl_sslz00, BGl_dhz00zz__ssl_sslz00, BGl_string3674z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_dhzd2checkzd2envz00zz__ssl_sslz00, BGl_proc3675z00zz__ssl_sslz00, BGl_dhz00zz__ssl_sslz00, BGl_string3676z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_dhzd2checkzd2pubzd2keyzd2envz00zz__ssl_sslz00, BGl_proc3677z00zz__ssl_sslz00, BGl_dhz00zz__ssl_sslz00, BGl_string3678z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_dhzd2computezd2keyzd2envzd2zz__ssl_sslz00, BGl_proc3679z00zz__ssl_sslz00, BGl_dhz00zz__ssl_sslz00, BGl_string3680z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_dhzd2generatezd2keyzd2envzd2zz__ssl_sslz00, BGl_proc3681z00zz__ssl_sslz00, BGl_dhz00zz__ssl_sslz00, BGl_string3682z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2hashzd2initzd2envzd2zz__ssl_sslz00, BGl_proc3683z00zz__ssl_sslz00, BGl_sslzd2hashzd2zz__ssl_sslz00, BGl_string3684z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2hashzd2updatez12zd2envzc0zz__ssl_sslz00, BGl_proc3685z00zz__ssl_sslz00, BGl_sslzd2hashzd2zz__ssl_sslz00, BGl_string3686z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2hashzd2digestzd2envzd2zz__ssl_sslz00, BGl_proc3687z00zz__ssl_sslz00, BGl_sslzd2hashzd2zz__ssl_sslz00, BGl_string3688z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2hmaczd2initzd2envzd2zz__ssl_sslz00, BGl_proc3689z00zz__ssl_sslz00, BGl_sslzd2hmaczd2zz__ssl_sslz00, BGl_string3690z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2hmaczd2updatez12zd2envzc0zz__ssl_sslz00, BGl_proc3691z00zz__ssl_sslz00, BGl_sslzd2hmaczd2zz__ssl_sslz00, BGl_string3692z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2hmaczd2digestzd2envzd2zz__ssl_sslz00, BGl_proc3693z00zz__ssl_sslz00, BGl_sslzd2hmaczd2zz__ssl_sslz00, BGl_string3694z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2signzd2initzd2envzd2zz__ssl_sslz00, BGl_proc3695z00zz__ssl_sslz00, BGl_sslzd2signzd2zz__ssl_sslz00, BGl_string3696z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2signzd2updatez12zd2envzc0zz__ssl_sslz00, BGl_proc3697z00zz__ssl_sslz00, BGl_sslzd2signzd2zz__ssl_sslz00, BGl_string3698z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2signzd2signzd2envzd2zz__ssl_sslz00, BGl_proc3699z00zz__ssl_sslz00, BGl_sslzd2signzd2zz__ssl_sslz00, BGl_string3700z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2verifyzd2initzd2envzd2zz__ssl_sslz00, BGl_proc3701z00zz__ssl_sslz00, BGl_sslzd2verifyzd2zz__ssl_sslz00, BGl_string3702z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2verifyzd2updatez12zd2envzc0zz__ssl_sslz00, BGl_proc3703z00zz__ssl_sslz00, BGl_sslzd2verifyzd2zz__ssl_sslz00, BGl_string3704z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2verifyzd2finalzd2envzd2zz__ssl_sslz00, BGl_proc3705z00zz__ssl_sslz00, BGl_sslzd2verifyzd2zz__ssl_sslz00, BGl_string3706z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2cipherzd2initzd2envzd2zz__ssl_sslz00, BGl_proc3707z00zz__ssl_sslz00, BGl_sslzd2cipherzd2zz__ssl_sslz00, BGl_string3708z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2cipherzd2initivzd2envzd2zz__ssl_sslz00, BGl_proc3709z00zz__ssl_sslz00, BGl_sslzd2cipherzd2zz__ssl_sslz00, BGl_string3710z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2cipherzd2updatez12zd2envzc0zz__ssl_sslz00, BGl_proc3711z00zz__ssl_sslz00, BGl_sslzd2cipherzd2zz__ssl_sslz00, BGl_string3712z00zz__ssl_sslz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2cipherzd2setzd2autozd2paddingzd2envzd2zz__ssl_sslz00, BGl_proc3713z00zz__ssl_sslz00, BGl_sslzd2cipherzd2zz__ssl_sslz00, BGl_string3714z00zz__ssl_sslz00); 
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sslzd2cipherzd2finalzd2envzd2zz__ssl_sslz00, BGl_proc3715z00zz__ssl_sslz00, BGl_sslzd2cipherzd2zz__ssl_sslz00, BGl_string3716z00zz__ssl_sslz00);} 
BGL_FUNCTION_END;
}



/* &ssl-cipher-final1350 */
obj_t BGl_z62sslzd2cipherzd2final1350z62zz__ssl_sslz00(obj_t BgL_envz00_5221, obj_t BgL_sslzd2cipherzd2_5222)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1380 */
return 
bgl_cipher_final(
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_5222));} 
BGL_FUNCTION_END;
}



/* &ssl-cipher-set-auto-1348 */
obj_t BGl_z62sslzd2cipherzd2setzd2autozd21348z62zz__ssl_sslz00(obj_t BgL_envz00_5223, obj_t BgL_sslzd2cipherzd2_5224, obj_t BgL_autozd2paddingzd2_5225)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1370 */
{ /* Llib/ssl.scm 1373 */
bool_t BgL_tmpz00_8543;
{ /* Llib/ssl.scm 1373 */
bool_t BgL_autozd2paddingzd2_6359;
BgL_autozd2paddingzd2_6359 = 
CBOOL(BgL_autozd2paddingzd2_5225); 
BgL_tmpz00_8543 = 
bgl_cipher_set_auto_padding(
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_5224), BgL_autozd2paddingzd2_6359); } 
return 
BBOOL(BgL_tmpz00_8543);} } 
BGL_FUNCTION_END;
}



/* &ssl-cipher-update!1346 */
obj_t BGl_z62sslzd2cipherzd2updatez121346z70zz__ssl_sslz00(obj_t BgL_envz00_5226, obj_t BgL_sslzd2cipherzd2_5227, obj_t BgL_dataz00_5228, obj_t BgL_offsetz00_5229, obj_t BgL_lenz00_5230)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1359 */
{ /* Llib/ssl.scm 1362 */
long BgL_offsetz00_6362;long BgL_lenz00_6363;
BgL_offsetz00_6362 = 
(long)CINT(BgL_offsetz00_5229); 
BgL_lenz00_6363 = 
(long)CINT(BgL_lenz00_5230); 
{ /* Llib/ssl.scm 1362 */
obj_t BgL__ortest_1147z00_6364;
BgL__ortest_1147z00_6364 = 
bgl_cipher_update(
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_5227), 
((obj_t)BgL_dataz00_5228), BgL_offsetz00_6362, BgL_lenz00_6363); 
if(
CBOOL(BgL__ortest_1147z00_6364))
{ /* Llib/ssl.scm 1362 */
return BgL__ortest_1147z00_6364;}  else 
{ /* Llib/ssl.scm 1362 */
return 
BGl_errorz00zz__errorz00(BGl_string3717z00zz__ssl_sslz00, BGl_string3718z00zz__ssl_sslz00, 
((obj_t)
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_5227)));} } } } 
BGL_FUNCTION_END;
}



/* &ssl-cipher-initiv1344 */
obj_t BGl_z62sslzd2cipherzd2initiv1344z62zz__ssl_sslz00(obj_t BgL_envz00_5231, obj_t BgL_sslzd2cipherzd2_5232, obj_t BgL_cipherz00_5233, obj_t BgL_keyz00_5234, obj_t BgL_offsetz00_5235, obj_t BgL_lenz00_5236, obj_t BgL_ivz00_5237, obj_t BgL_ivoffsetz00_5238, obj_t BgL_ivlenz00_5239, obj_t BgL_encz00_5240)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1342 */
{ /* Llib/ssl.scm 1348 */
long BgL_offsetz00_6368;long BgL_lenz00_6369;long BgL_ivoffsetz00_6371;long BgL_ivlenz00_6372;bool_t BgL_encz00_6373;
BgL_offsetz00_6368 = 
(long)CINT(BgL_offsetz00_5235); 
BgL_lenz00_6369 = 
(long)CINT(BgL_lenz00_5236); 
BgL_ivoffsetz00_6371 = 
(long)CINT(BgL_ivoffsetz00_5238); 
BgL_ivlenz00_6372 = 
(long)CINT(BgL_ivlenz00_5239); 
BgL_encz00_6373 = 
CBOOL(BgL_encz00_5240); 
if(
bgl_ssl_cipher_initiv(
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_5232), 
((obj_t)BgL_cipherz00_5233), 
((obj_t)BgL_keyz00_5234), BgL_offsetz00_6368, BgL_lenz00_6369, 
((obj_t)BgL_ivz00_5237), BgL_ivoffsetz00_6371, BgL_ivlenz00_6372, BgL_encz00_6373))
{ /* Llib/ssl.scm 1348 */
return BFALSE;}  else 
{ /* Llib/ssl.scm 1352 */
obj_t BgL_arg2292z00_6374;
BgL_arg2292z00_6374 = 
bgl_ssl_error_string(); 
return 
BGl_errorz00zz__errorz00(BGl_string3719z00zz__ssl_sslz00, BgL_arg2292z00_6374, 
((obj_t)
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_5232)));} } } 
BGL_FUNCTION_END;
}



/* &ssl-cipher-init1342 */
obj_t BGl_z62sslzd2cipherzd2init1342z62zz__ssl_sslz00(obj_t BgL_envz00_5241, obj_t BgL_sslzd2cipherzd2_5242, obj_t BgL_cipherz00_5243, obj_t BgL_keyz00_5244, obj_t BgL_offsetz00_5245, obj_t BgL_lenz00_5246, obj_t BgL_encz00_5247)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1328 */
{ 
BgL_sslzd2cipherzd2_bglt BgL_auxz00_8573;
{ /* Llib/ssl.scm 1333 */
long BgL_offsetz00_6378;long BgL_lenz00_6379;bool_t BgL_encz00_6380;
BgL_offsetz00_6378 = 
(long)CINT(BgL_offsetz00_5245); 
BgL_lenz00_6379 = 
(long)CINT(BgL_lenz00_5246); 
BgL_encz00_6380 = 
CBOOL(BgL_encz00_5247); 
if(
bgl_ssl_cipher_init(
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_5242), 
((obj_t)BgL_cipherz00_5243), 
((obj_t)BgL_keyz00_5244), BgL_offsetz00_6378, BgL_lenz00_6379, BgL_encz00_6380))
{ /* Llib/ssl.scm 1333 */BFALSE; }  else 
{ /* Llib/ssl.scm 1333 */
BGl_errorz00zz__errorz00(BGl_string3720z00zz__ssl_sslz00, 
bgl_ssl_error_string(), 
((obj_t)BgL_cipherz00_5243)); } 
BgL_auxz00_8573 = 
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_5242); } 
return 
((obj_t)BgL_auxz00_8573);} } 
BGL_FUNCTION_END;
}



/* &ssl-verify-final1340 */
obj_t BGl_z62sslzd2verifyzd2final1340z62zz__ssl_sslz00(obj_t BgL_envz00_5248, obj_t BgL_sslzd2verifyzd2_5249, obj_t BgL_keyz00_5250, obj_t BgL_koffsetz00_5251, obj_t BgL_klenz00_5252, obj_t BgL_sigz00_5253, obj_t BgL_soffsetz00_5254, obj_t BgL_slenz00_5255)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1314 */
{ /* Llib/ssl.scm 1319 */
bool_t BgL_tmpz00_8587;
{ /* Llib/ssl.scm 1319 */
long BgL_koffsetz00_6383;long BgL_klenz00_6384;long BgL_soffsetz00_6386;long BgL_slenz00_6387;
BgL_koffsetz00_6383 = 
(long)CINT(BgL_koffsetz00_5251); 
BgL_klenz00_6384 = 
(long)CINT(BgL_klenz00_5252); 
BgL_soffsetz00_6386 = 
(long)CINT(BgL_soffsetz00_5254); 
BgL_slenz00_6387 = 
(long)CINT(BgL_slenz00_5255); 
BgL_tmpz00_8587 = 
bgl_ssl_verify_final(
((BgL_sslzd2verifyzd2_bglt)BgL_sslzd2verifyzd2_5249), 
((obj_t)BgL_keyz00_5250), BgL_koffsetz00_6383, BgL_klenz00_6384, 
((obj_t)BgL_sigz00_5253), BgL_soffsetz00_6386, BgL_slenz00_6387); } 
return 
BBOOL(BgL_tmpz00_8587);} } 
BGL_FUNCTION_END;
}



/* &ssl-verify-update!1338 */
obj_t BGl_z62sslzd2verifyzd2updatez121338z70zz__ssl_sslz00(obj_t BgL_envz00_5256, obj_t BgL_sslzd2verifyzd2_5257, obj_t BgL_dataz00_5258, obj_t BgL_offsetz00_5259, obj_t BgL_lenz00_5260)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1302 */
{ 
BgL_sslzd2verifyzd2_bglt BgL_auxz00_8597;
{ /* Llib/ssl.scm 1305 */
long BgL_offsetz00_6390;long BgL_lenz00_6391;
BgL_offsetz00_6390 = 
(long)CINT(BgL_offsetz00_5259); 
BgL_lenz00_6391 = 
(long)CINT(BgL_lenz00_5260); 
if(
bgl_ssl_verify_update(
((BgL_sslzd2verifyzd2_bglt)BgL_sslzd2verifyzd2_5257), 
((obj_t)BgL_dataz00_5258), BgL_offsetz00_6390, BgL_lenz00_6391))
{ /* Llib/ssl.scm 1305 */BFALSE; }  else 
{ /* Llib/ssl.scm 1305 */
BGl_errorz00zz__errorz00(BGl_string3721z00zz__ssl_sslz00, BGl_string3718z00zz__ssl_sslz00, 
((obj_t)
((BgL_sslzd2verifyzd2_bglt)BgL_sslzd2verifyzd2_5257))); } 
BgL_auxz00_8597 = 
((BgL_sslzd2verifyzd2_bglt)BgL_sslzd2verifyzd2_5257); } 
return 
((obj_t)BgL_auxz00_8597);} } 
BGL_FUNCTION_END;
}



/* &ssl-verify-init1336 */
obj_t BGl_z62sslzd2verifyzd2init1336z62zz__ssl_sslz00(obj_t BgL_envz00_5261, obj_t BgL_sslzd2verifyzd2_5262, obj_t BgL_verifyz00_5263)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1290 */
{ 
BgL_sslzd2verifyzd2_bglt BgL_auxz00_8609;
if(
bgl_ssl_verify_init(
((BgL_sslzd2verifyzd2_bglt)BgL_sslzd2verifyzd2_5262), 
((obj_t)BgL_verifyz00_5263)))
{ /* Llib/ssl.scm 1293 */BFALSE; }  else 
{ /* Llib/ssl.scm 1293 */
BGl_errorz00zz__errorz00(BGl_string3722z00zz__ssl_sslz00, BGl_string3723z00zz__ssl_sslz00, 
((obj_t)
((BgL_sslzd2verifyzd2_bglt)BgL_sslzd2verifyzd2_5262))); } 
BgL_auxz00_8609 = 
((BgL_sslzd2verifyzd2_bglt)BgL_sslzd2verifyzd2_5262); 
return 
((obj_t)BgL_auxz00_8609);} } 
BGL_FUNCTION_END;
}



/* &ssl-sign-sign1334 */
obj_t BGl_z62sslzd2signzd2sign1334z62zz__ssl_sslz00(obj_t BgL_envz00_5264, obj_t BgL_sslzd2signzd2_5265, obj_t BgL_keyz00_5266, obj_t BgL_offsetz00_5267, obj_t BgL_lenz00_5268)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1279 */
{ /* Llib/ssl.scm 1282 */
long BgL_offsetz00_6396;long BgL_lenz00_6397;
BgL_offsetz00_6396 = 
(long)CINT(BgL_offsetz00_5267); 
BgL_lenz00_6397 = 
(long)CINT(BgL_lenz00_5268); 
{ /* Llib/ssl.scm 1282 */
obj_t BgL_rz00_6398;
BgL_rz00_6398 = 
bgl_ssl_sign_sign(
((BgL_sslzd2signzd2_bglt)BgL_sslzd2signzd2_5265), 
((obj_t)BgL_keyz00_5266), BgL_offsetz00_6396, BgL_lenz00_6397); 
if(
CBOOL(BgL_rz00_6398))
{ /* Llib/ssl.scm 1283 */
return BgL_rz00_6398;}  else 
{ /* Llib/ssl.scm 1283 */
return 
BGl_errorz00zz__errorz00(BGl_string3724z00zz__ssl_sslz00, BGl_string3725z00zz__ssl_sslz00, 
((obj_t)
((BgL_sslzd2signzd2_bglt)BgL_sslzd2signzd2_5265)));} } } } 
BGL_FUNCTION_END;
}



/* &ssl-sign-update!1332 */
obj_t BGl_z62sslzd2signzd2updatez121332z70zz__ssl_sslz00(obj_t BgL_envz00_5269, obj_t BgL_sslzd2signzd2_5270, obj_t BgL_dataz00_5271, obj_t BgL_offsetz00_5272, obj_t BgL_lenz00_5273)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1267 */
{ 
BgL_sslzd2signzd2_bglt BgL_auxz00_8629;
{ /* Llib/ssl.scm 1270 */
long BgL_offsetz00_6401;long BgL_lenz00_6402;
BgL_offsetz00_6401 = 
(long)CINT(BgL_offsetz00_5272); 
BgL_lenz00_6402 = 
(long)CINT(BgL_lenz00_5273); 
if(
bgl_ssl_sign_update(
((BgL_sslzd2signzd2_bglt)BgL_sslzd2signzd2_5270), 
((obj_t)BgL_dataz00_5271), BgL_offsetz00_6401, BgL_lenz00_6402))
{ /* Llib/ssl.scm 1270 */BFALSE; }  else 
{ /* Llib/ssl.scm 1270 */
BGl_errorz00zz__errorz00(BGl_string3726z00zz__ssl_sslz00, BGl_string3718z00zz__ssl_sslz00, 
((obj_t)
((BgL_sslzd2signzd2_bglt)BgL_sslzd2signzd2_5270))); } 
BgL_auxz00_8629 = 
((BgL_sslzd2signzd2_bglt)BgL_sslzd2signzd2_5270); } 
return 
((obj_t)BgL_auxz00_8629);} } 
BGL_FUNCTION_END;
}



/* &ssl-sign-init1330 */
obj_t BGl_z62sslzd2signzd2init1330z62zz__ssl_sslz00(obj_t BgL_envz00_5274, obj_t BgL_sslzd2signzd2_5275, obj_t BgL_signz00_5276)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1255 */
{ 
BgL_sslzd2signzd2_bglt BgL_auxz00_8641;
if(
bgl_ssl_sign_init(
((BgL_sslzd2signzd2_bglt)BgL_sslzd2signzd2_5275), 
((obj_t)BgL_signz00_5276)))
{ /* Llib/ssl.scm 1258 */BFALSE; }  else 
{ /* Llib/ssl.scm 1258 */
BGl_errorz00zz__errorz00(BGl_string3727z00zz__ssl_sslz00, BGl_string3728z00zz__ssl_sslz00, 
((obj_t)
((BgL_sslzd2signzd2_bglt)BgL_sslzd2signzd2_5275))); } 
BgL_auxz00_8641 = 
((BgL_sslzd2signzd2_bglt)BgL_sslzd2signzd2_5275); 
return 
((obj_t)BgL_auxz00_8641);} } 
BGL_FUNCTION_END;
}



/* &ssl-hmac-digest1328 */
obj_t BGl_z62sslzd2hmaczd2digest1328z62zz__ssl_sslz00(obj_t BgL_envz00_5277, obj_t BgL_sslzd2hmaczd2_5278)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1244 */
{ /* Llib/ssl.scm 1247 */
obj_t BgL_rz00_6406;
BgL_rz00_6406 = 
bgl_ssl_hmac_digest(
((BgL_sslzd2hmaczd2_bglt)BgL_sslzd2hmaczd2_5278)); 
if(
CBOOL(BgL_rz00_6406))
{ /* Llib/ssl.scm 1248 */
return BgL_rz00_6406;}  else 
{ /* Llib/ssl.scm 1248 */
return 
BGl_errorz00zz__errorz00(BGl_string3729z00zz__ssl_sslz00, BGl_string3730z00zz__ssl_sslz00, 
((obj_t)
((BgL_sslzd2hmaczd2_bglt)BgL_sslzd2hmaczd2_5278)));} } } 
BGL_FUNCTION_END;
}



/* &ssl-hmac-update!1326 */
obj_t BGl_z62sslzd2hmaczd2updatez121326z70zz__ssl_sslz00(obj_t BgL_envz00_5279, obj_t BgL_sslzd2hmaczd2_5280, obj_t BgL_dataz00_5281, obj_t BgL_offsetz00_5282, obj_t BgL_lenz00_5283)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1232 */
{ 
BgL_sslzd2hmaczd2_bglt BgL_auxz00_8658;
{ /* Llib/ssl.scm 1235 */
long BgL_offsetz00_6409;long BgL_lenz00_6410;
BgL_offsetz00_6409 = 
(long)CINT(BgL_offsetz00_5282); 
BgL_lenz00_6410 = 
(long)CINT(BgL_lenz00_5283); 
if(
bgl_ssl_hmac_update(
((BgL_sslzd2hmaczd2_bglt)BgL_sslzd2hmaczd2_5280), 
((obj_t)BgL_dataz00_5281), BgL_offsetz00_6409, BgL_lenz00_6410))
{ /* Llib/ssl.scm 1235 */BFALSE; }  else 
{ /* Llib/ssl.scm 1235 */
BGl_errorz00zz__errorz00(BGl_string3731z00zz__ssl_sslz00, BGl_string3718z00zz__ssl_sslz00, 
((obj_t)
((BgL_sslzd2hmaczd2_bglt)BgL_sslzd2hmaczd2_5280))); } 
BgL_auxz00_8658 = 
((BgL_sslzd2hmaczd2_bglt)BgL_sslzd2hmaczd2_5280); } 
return 
((obj_t)BgL_auxz00_8658);} } 
BGL_FUNCTION_END;
}



/* &ssl-hmac-init1324 */
obj_t BGl_z62sslzd2hmaczd2init1324z62zz__ssl_sslz00(obj_t BgL_envz00_5284, obj_t BgL_sslzd2hmaczd2_5285, obj_t BgL_hmacz00_5286, obj_t BgL_keyz00_5287)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1220 */
if(
bgl_ssl_hmac_init(
((BgL_sslzd2hmaczd2_bglt)BgL_sslzd2hmaczd2_5285), 
((obj_t)BgL_hmacz00_5286), 
((obj_t)BgL_keyz00_5287)))
{ /* Llib/ssl.scm 1223 */
return BFALSE;}  else 
{ /* Llib/ssl.scm 1223 */
BGl_errorz00zz__errorz00(BGl_string3732z00zz__ssl_sslz00, BGl_string3733z00zz__ssl_sslz00, 
((obj_t)
((BgL_sslzd2hmaczd2_bglt)BgL_sslzd2hmaczd2_5285))); 
return 
((obj_t)
((BgL_sslzd2hmaczd2_bglt)BgL_sslzd2hmaczd2_5285));} } 
BGL_FUNCTION_END;
}



/* &ssl-hash-digest1322 */
obj_t BGl_z62sslzd2hashzd2digest1322z62zz__ssl_sslz00(obj_t BgL_envz00_5288, obj_t BgL_sslzd2hashzd2_5289)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1209 */
{ /* Llib/ssl.scm 1212 */
obj_t BgL_rz00_6415;
BgL_rz00_6415 = 
bgl_ssl_hash_digest(
((BgL_sslzd2hashzd2_bglt)BgL_sslzd2hashzd2_5289)); 
if(
CBOOL(BgL_rz00_6415))
{ /* Llib/ssl.scm 1213 */
return BgL_rz00_6415;}  else 
{ /* Llib/ssl.scm 1213 */
return 
BGl_errorz00zz__errorz00(BGl_string3734z00zz__ssl_sslz00, BGl_string3730z00zz__ssl_sslz00, 
((obj_t)
((BgL_sslzd2hashzd2_bglt)BgL_sslzd2hashzd2_5289)));} } } 
BGL_FUNCTION_END;
}



/* &ssl-hash-update!1320 */
obj_t BGl_z62sslzd2hashzd2updatez121320z70zz__ssl_sslz00(obj_t BgL_envz00_5290, obj_t BgL_sslzd2hashzd2_5291, obj_t BgL_dataz00_5292, obj_t BgL_offsetz00_5293, obj_t BgL_lenz00_5294)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1197 */
{ 
BgL_sslzd2hashzd2_bglt BgL_auxz00_8687;
{ /* Llib/ssl.scm 1200 */
long BgL_offsetz00_6418;long BgL_lenz00_6419;
BgL_offsetz00_6418 = 
(long)CINT(BgL_offsetz00_5293); 
BgL_lenz00_6419 = 
(long)CINT(BgL_lenz00_5294); 
if(
bgl_ssl_hash_update(
((BgL_sslzd2hashzd2_bglt)BgL_sslzd2hashzd2_5291), 
((obj_t)BgL_dataz00_5292), BgL_offsetz00_6418, BgL_lenz00_6419))
{ /* Llib/ssl.scm 1200 */BFALSE; }  else 
{ /* Llib/ssl.scm 1200 */
BGl_errorz00zz__errorz00(BGl_string3735z00zz__ssl_sslz00, BGl_string3718z00zz__ssl_sslz00, 
((obj_t)
((BgL_sslzd2hashzd2_bglt)BgL_sslzd2hashzd2_5291))); } 
BgL_auxz00_8687 = 
((BgL_sslzd2hashzd2_bglt)BgL_sslzd2hashzd2_5291); } 
return 
((obj_t)BgL_auxz00_8687);} } 
BGL_FUNCTION_END;
}



/* &ssl-hash-init1318 */
obj_t BGl_z62sslzd2hashzd2init1318z62zz__ssl_sslz00(obj_t BgL_envz00_5295, obj_t BgL_sslzd2hashzd2_5296)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1185 */
{ 
BgL_sslzd2hashzd2_bglt BgL_auxz00_8699;
if(
bgl_ssl_hash_init(
((BgL_sslzd2hashzd2_bglt)BgL_sslzd2hashzd2_5296)))
{ /* Llib/ssl.scm 1188 */BFALSE; }  else 
{ /* Llib/ssl.scm 1188 */
BGl_errorz00zz__errorz00(BGl_string3736z00zz__ssl_sslz00, BGl_string3733z00zz__ssl_sslz00, 
((obj_t)
((BgL_sslzd2hashzd2_bglt)BgL_sslzd2hashzd2_5296))); } 
BgL_auxz00_8699 = 
((BgL_sslzd2hashzd2_bglt)BgL_sslzd2hashzd2_5296); 
return 
((obj_t)BgL_auxz00_8699);} } 
BGL_FUNCTION_END;
}



/* &dh-generate-key1316 */
obj_t BGl_z62dhzd2generatezd2key1316z62zz__ssl_sslz00(obj_t BgL_envz00_5297, obj_t BgL_dhz00_5298)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1174 */
{ /* Llib/ssl.scm 1177 */
bool_t BgL_tmpz00_8708;
{ /* Llib/ssl.scm 1178 */
bool_t BgL_testz00_8709;
{ /* Llib/ssl.scm 1178 */
int BgL_arg2265z00_6422;
{ /* Llib/ssl.scm 1178 */
void * BgL_tmpz00_8710;
BgL_tmpz00_8710 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_dhz00_5298)))->BgL_z42nativez42); 
BgL_arg2265z00_6422 = 
DH_generate_key(BgL_tmpz00_8710); } 
BgL_testz00_8709 = 
(
(long)(BgL_arg2265z00_6422)==((long)0)); } 
if(BgL_testz00_8709)
{ /* Llib/ssl.scm 1178 */
BgL_tmpz00_8708 = ((bool_t)0)
; }  else 
{ /* Llib/ssl.scm 1178 */
BgL_tmpz00_8708 = ((bool_t)1)
; } } 
return 
BBOOL(BgL_tmpz00_8708);} } 
BGL_FUNCTION_END;
}



/* &dh-compute-key1314 */
obj_t BGl_z62dhzd2computezd2key1314z62zz__ssl_sslz00(obj_t BgL_envz00_5299, obj_t BgL_dhz00_5300, obj_t BgL_keyz00_5301)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1148 */
{ /* Llib/ssl.scm 1152 */
int BgL_siza7eza7_6425;
BgL_siza7eza7_6425 = 
BGl_dhzd2siza7ez75zz__ssl_sslz00(
((BgL_dhz00_bglt)BgL_dhz00_5300)); 
{ /* Llib/ssl.scm 1152 */
obj_t BgL_strz00_6426;
{ /* Llib/ssl.scm 1153 */

BgL_strz00_6426 = 
make_string(
(long)(BgL_siza7eza7_6425), ((unsigned char)' ')); } 
{ /* Llib/ssl.scm 1153 */

{ /* Llib/ssl.scm 1154 */
int BgL_sza7za7_6427;
{ /* Llib/ssl.scm 1154 */
void * BgL_arg2259z00_6428;void * BgL_arg2260z00_6429;
{ /* Llib/ssl.scm 1154 */
obj_t BgL_tmpz00_8721;
BgL_tmpz00_8721 = 
((obj_t)BgL_keyz00_5301); 
BgL_arg2259z00_6428 = 
(BIGNUM *)FOREIGN_TO_COBJ(BgL_tmpz00_8721); } 
BgL_arg2260z00_6429 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_dhz00_5300)))->BgL_z42nativez42); 
{ /* Llib/ssl.scm 1154 */
char * BgL_tmpz00_8726;
BgL_tmpz00_8726 = 
BSTRING_TO_STRING(BgL_strz00_6426); 
BgL_sza7za7_6427 = 
DH_compute_key(BgL_tmpz00_8726, BgL_arg2259z00_6428, BgL_arg2260z00_6429); } } 
if(
(
(long)(BgL_sza7za7_6427)==((long)-1)))
{ /* Llib/ssl.scm 1156 */
return BFALSE;}  else 
{ /* Llib/ssl.scm 1156 */
if(
(
(long)(BgL_sza7za7_6427)==
STRING_LENGTH(BgL_strz00_6426)))
{ /* Llib/ssl.scm 1158 */
return BgL_strz00_6426;}  else 
{ /* Llib/ssl.scm 1158 */
blit_string(BgL_strz00_6426, ((long)0), BgL_strz00_6426, 
(
(long)(BgL_siza7eza7_6425)-
(long)(BgL_sza7za7_6427)), 
(long)(BgL_sza7za7_6427)); 
{ /* Llib/ssl.scm 1162 */
long BgL_g1142z00_6431;
BgL_g1142z00_6431 = 
(
(long)(BgL_siza7eza7_6425)-
(long)(BgL_sza7za7_6427)); 
{ 
long BgL_iz00_6433;
BgL_iz00_6433 = BgL_g1142z00_6431; 
BgL_loopz00_6432:
if(
(BgL_iz00_6433>((long)0)))
{ /* Llib/ssl.scm 1164 */
long BgL_niz00_6434;
BgL_niz00_6434 = 
(BgL_iz00_6433-((long)1)); 
STRING_SET(BgL_strz00_6426, BgL_niz00_6434, ((unsigned char)'\000')); 
{ 
long BgL_iz00_8748;
BgL_iz00_8748 = BgL_niz00_6434; 
BgL_iz00_6433 = BgL_iz00_8748; 
goto BgL_loopz00_6432;} }  else 
{ /* Llib/ssl.scm 1163 */((bool_t)0); } } } 
return BgL_strz00_6426;} } } } } } } 
BGL_FUNCTION_END;
}



/* &dh-check-pub-key1312 */
obj_t BGl_z62dhzd2checkzd2pubzd2key1312zb0zz__ssl_sslz00(obj_t BgL_envz00_5302, obj_t BgL_dhz00_5303, obj_t BgL_keyz00_5304)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1137 */
{ /* Llib/ssl.scm 1141 */
void * BgL_arg2249z00_6437;void * BgL_arg2250z00_6438;
BgL_arg2249z00_6437 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_dhz00_5303)))->BgL_z42nativez42); 
{ /* Llib/ssl.scm 1141 */
obj_t BgL_tmpz00_8751;
BgL_tmpz00_8751 = 
((obj_t)BgL_keyz00_5304); 
BgL_arg2250z00_6438 = 
(BIGNUM *)FOREIGN_TO_COBJ(BgL_tmpz00_8751); } 
return 
bgl_dh_check_pub_key(BgL_arg2249z00_6437, BgL_arg2250z00_6438);} } 
BGL_FUNCTION_END;
}



/* &dh-check1310 */
obj_t BGl_z62dhzd2check1310zb0zz__ssl_sslz00(obj_t BgL_envz00_5305, obj_t BgL_dhz00_5306)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1126 */
return 
bgl_dh_check(
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_dhz00_5306)))->BgL_z42nativez42));} 
BGL_FUNCTION_END;
}



/* &dh-generate-paramete1308 */
obj_t BGl_z62dhzd2generatezd2paramete1308z62zz__ssl_sslz00(obj_t BgL_envz00_5307, obj_t BgL_dhz00_5308, obj_t BgL_lenz00_5309, obj_t BgL_generatorz00_5310)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1110 */
{ /* Llib/ssl.scm 1113 */
int BgL_tmpz00_8758;
{ /* Llib/ssl.scm 1113 */
int BgL_lenz00_6441;
BgL_lenz00_6441 = 
CINT(BgL_lenz00_5309); 
{ /* Llib/ssl.scm 1114 */
void * BgL_arg2243z00_6443;obj_t BgL_arg2244z00_6444;
BgL_arg2243z00_6443 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_dhz00_5308)))->BgL_z42nativez42); 
if(
(
((obj_t)BgL_generatorz00_5310)==
CNST_TABLE_REF(((long)89))))
{ /* Llib/ssl.scm 1115 */
BgL_arg2244z00_6444 = 
BINT(DH_GENERATOR_2); }  else 
{ /* Llib/ssl.scm 1115 */
BgL_arg2244z00_6444 = 
BGl_errorz00zz__errorz00(BGl_string3737z00zz__ssl_sslz00, BGl_string3738z00zz__ssl_sslz00, 
((obj_t)BgL_generatorz00_5310)); } 
{ /* Llib/ssl.scm 1114 */
int BgL_tmpz00_8769;
BgL_tmpz00_8769 = 
CINT(BgL_arg2244z00_6444); 
BgL_tmpz00_8758 = 
DH_generate_parameters_ex(BgL_arg2243z00_6443, BgL_lenz00_6441, BgL_tmpz00_8769, ((long)0)); } } } 
return 
BINT(BgL_tmpz00_8758);} } 
BGL_FUNCTION_END;
}



/* &dh-size1306 */
obj_t BGl_z62dhzd2siza7e1306z17zz__ssl_sslz00(obj_t BgL_envz00_5311, obj_t BgL_dhz00_5312)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1102 */
{ /* Llib/ssl.scm 1104 */
int BgL_tmpz00_8773;
{ /* Llib/ssl.scm 1104 */
void * BgL_tmpz00_8774;
BgL_tmpz00_8774 = 
(((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_dhz00_5312)))->BgL_z42nativez42); 
BgL_tmpz00_8773 = 
DH_size(BgL_tmpz00_8774); } 
return 
BINT(BgL_tmpz00_8773);} } 
BGL_FUNCTION_END;
}



/* &dh-init1304 */
obj_t BGl_z62dhzd2init1304zb0zz__ssl_sslz00(obj_t BgL_envz00_5313, obj_t BgL_dhz00_5314)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1091 */
return 
((((BgL_dhz00_bglt)COBJECT(
((BgL_dhz00_bglt)BgL_dhz00_5314)))->BgL_z42nativez42)=((void *)
DH_new()),BUNSPEC);} 
BGL_FUNCTION_END;
}



/* &ssl-connection-get-n1302 */
obj_t BGl_z62sslzd2connectionzd2getzd2n1302zb0zz__ssl_sslz00(obj_t BgL_envz00_5315, obj_t BgL_sslz00_5316)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1081 */
return 
bgl_ssl_connection_get_negotiated_protocol(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5316));} 
BGL_FUNCTION_END;
}



/* &ssl-connection-reuse1300 */
obj_t BGl_z62sslzd2connectionzd2reuse1300z62zz__ssl_sslz00(obj_t BgL_envz00_5317, obj_t BgL_sslz00_5318)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1070 */
{ /* Llib/ssl.scm 1073 */
bool_t BgL_tmpz00_8784;
{ /* Llib/ssl.scm 1074 */
void * BgL_tmpz00_8785;
BgL_tmpz00_8785 = 
(((BgL_sslzd2connectionzd2_bglt)COBJECT(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5318)))->BgL_z42nativez42); 
BgL_tmpz00_8784 = 
SSL_session_reused(BgL_tmpz00_8785); } 
return 
BBOOL(BgL_tmpz00_8784);} } 
BGL_FUNCTION_END;
}



/* &ssl-connection-get-p1298 */
obj_t BGl_z62sslzd2connectionzd2getzd2p1298zb0zz__ssl_sslz00(obj_t BgL_envz00_5319, obj_t BgL_sslz00_5320)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1060 */
return 
bgl_ssl_connection_get_peer_certificate(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5320));} 
BGL_FUNCTION_END;
}



/* &ssl-connection-verif1296 */
obj_t BGl_z62sslzd2connectionzd2verif1296z62zz__ssl_sslz00(obj_t BgL_envz00_5321, obj_t BgL_sslz00_5322)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1050 */
return 
bgl_ssl_connection_verify_error(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5322));} 
BGL_FUNCTION_END;
}



/* &ssl-connection-load-1294 */
obj_t BGl_z62sslzd2connectionzd2loadzd21294zb0zz__ssl_sslz00(obj_t BgL_envz00_5323, obj_t BgL_sslz00_5324, obj_t BgL_bufz00_5325)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1040 */
return 
BINT(
bgl_ssl_connection_load_session(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5324), 
((obj_t)BgL_bufz00_5325)));} 
BGL_FUNCTION_END;
}



/* &ssl-connection-get-c1292 */
obj_t BGl_z62sslzd2connectionzd2getzd2c1292zb0zz__ssl_sslz00(obj_t BgL_envz00_5326, obj_t BgL_sslz00_5327)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1030 */
return 
bgl_ssl_connection_get_current_cipher(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5327));} 
BGL_FUNCTION_END;
}



/* &ssl-connection-get-s1290 */
obj_t BGl_z62sslzd2connectionzd2getzd2s1290zb0zz__ssl_sslz00(obj_t BgL_envz00_5328, obj_t BgL_sslz00_5329)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1020 */
return 
bgl_ssl_connection_get_session(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5329));} 
BGL_FUNCTION_END;
}



/* &ssl-connection-set-s1288 */
obj_t BGl_z62sslzd2connectionzd2setzd2s1288zb0zz__ssl_sslz00(obj_t BgL_envz00_5330, obj_t BgL_sslz00_5331, obj_t BgL_bufz00_5332)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1010 */
return 
BINT(
bgl_ssl_connection_set_session(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5331), 
((obj_t)BgL_bufz00_5332)));} 
BGL_FUNCTION_END;
}



/* &ssl-connection-clear1286 */
obj_t BGl_z62sslzd2connectionzd2clear1286z62zz__ssl_sslz00(obj_t BgL_envz00_5333, obj_t BgL_sslz00_5334)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1000 */
return 
BINT(
bgl_ssl_connection_clear_pending(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5334)));} 
BGL_FUNCTION_END;
}



/* &ssl-connection-enc-p1284 */
obj_t BGl_z62sslzd2connectionzd2enczd2p1284zb0zz__ssl_sslz00(obj_t BgL_envz00_5335, obj_t BgL_sslz00_5336)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 990 */
return 
BINT(
bgl_ssl_connection_enc_pending(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5336)));} 
BGL_FUNCTION_END;
}



/* &ssl-connection-init-1282 */
obj_t BGl_z62sslzd2connectionzd2initzd21282zb0zz__ssl_sslz00(obj_t BgL_envz00_5337, obj_t BgL_sslz00_5338)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 980 */
return 
BBOOL(
bgl_ssl_connection_init_finishedp(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5338)));} 
BGL_FUNCTION_END;
}



/* &ssl-connection-clear1280 */
obj_t BGl_z62sslzd2connectionzd2clear1280z62zz__ssl_sslz00(obj_t BgL_envz00_5339, obj_t BgL_sslz00_5340, obj_t BgL_bufferz00_5341, obj_t BgL_offsetz00_5342, obj_t BgL_lenz00_5343)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 970 */
{ /* Llib/ssl.scm 973 */
long BgL_tmpz00_8815;
{ /* Llib/ssl.scm 973 */
long BgL_offsetz00_6462;long BgL_lenz00_6463;
BgL_offsetz00_6462 = 
(long)CINT(BgL_offsetz00_5342); 
BgL_lenz00_6463 = 
(long)CINT(BgL_lenz00_5343); 
BgL_tmpz00_8815 = 
bgl_ssl_connection_clear_out(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5340), 
BSTRING_TO_STRING(
((obj_t)BgL_bufferz00_5341)), BgL_offsetz00_6462, BgL_lenz00_6463); } 
return 
BINT(BgL_tmpz00_8815);} } 
BGL_FUNCTION_END;
}



/* &ssl-connection-clear1278 */
obj_t BGl_z62sslzd2connectionzd2clear1278z62zz__ssl_sslz00(obj_t BgL_envz00_5344, obj_t BgL_sslz00_5345, obj_t BgL_bufferz00_5346, obj_t BgL_offsetz00_5347, obj_t BgL_lenz00_5348)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 960 */
{ /* Llib/ssl.scm 963 */
long BgL_tmpz00_8823;
{ /* Llib/ssl.scm 963 */
long BgL_offsetz00_6466;long BgL_lenz00_6467;
BgL_offsetz00_6466 = 
(long)CINT(BgL_offsetz00_5347); 
BgL_lenz00_6467 = 
(long)CINT(BgL_lenz00_5348); 
BgL_tmpz00_8823 = 
bgl_ssl_connection_clear_in(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5345), 
BSTRING_TO_STRING(
((obj_t)BgL_bufferz00_5346)), BgL_offsetz00_6466, BgL_lenz00_6467); } 
return 
BINT(BgL_tmpz00_8823);} } 
BGL_FUNCTION_END;
}



/* &ssl-connection-write1276 */
obj_t BGl_z62sslzd2connectionzd2write1276z62zz__ssl_sslz00(obj_t BgL_envz00_5349, obj_t BgL_sslz00_5350, obj_t BgL_bufferz00_5351, obj_t BgL_offsetz00_5352, obj_t BgL_lenz00_5353)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 950 */
{ /* Llib/ssl.scm 953 */
long BgL_tmpz00_8831;
{ /* Llib/ssl.scm 953 */
long BgL_offsetz00_6470;long BgL_lenz00_6471;
BgL_offsetz00_6470 = 
(long)CINT(BgL_offsetz00_5352); 
BgL_lenz00_6471 = 
(long)CINT(BgL_lenz00_5353); 
BgL_tmpz00_8831 = 
bgl_ssl_connection_write(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5350), 
BSTRING_TO_STRING(
((obj_t)BgL_bufferz00_5351)), BgL_offsetz00_6470, BgL_lenz00_6471); } 
return 
BINT(BgL_tmpz00_8831);} } 
BGL_FUNCTION_END;
}



/* &ssl-connection-read1274 */
obj_t BGl_z62sslzd2connectionzd2read1274z62zz__ssl_sslz00(obj_t BgL_envz00_5354, obj_t BgL_sslz00_5355, obj_t BgL_bufferz00_5356, obj_t BgL_offsetz00_5357, obj_t BgL_lenz00_5358)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 940 */
{ /* Llib/ssl.scm 943 */
long BgL_tmpz00_8839;
{ /* Llib/ssl.scm 943 */
long BgL_offsetz00_6474;long BgL_lenz00_6475;
BgL_offsetz00_6474 = 
(long)CINT(BgL_offsetz00_5357); 
BgL_lenz00_6475 = 
(long)CINT(BgL_lenz00_5358); 
BgL_tmpz00_8839 = 
bgl_ssl_connection_read(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5355), 
BSTRING_TO_STRING(
((obj_t)BgL_bufferz00_5356)), BgL_offsetz00_6474, BgL_lenz00_6475); } 
return 
BINT(BgL_tmpz00_8839);} } 
BGL_FUNCTION_END;
}



/* &ssl-connection-shutd1272 */
obj_t BGl_z62sslzd2connectionzd2shutd1272z62zz__ssl_sslz00(obj_t BgL_envz00_5359, obj_t BgL_sslz00_5360)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 930 */
return 
bgl_ssl_connection_shutdown(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5360));} 
BGL_FUNCTION_END;
}



/* &ssl-connection-close1270 */
obj_t BGl_z62sslzd2connectionzd2close1270z62zz__ssl_sslz00(obj_t BgL_envz00_5361, obj_t BgL_sslz00_5362)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 920 */
return 
BINT(
bgl_ssl_connection_close(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5362)));} 
BGL_FUNCTION_END;
}



/* &ssl-connection-start1268 */
obj_t BGl_z62sslzd2connectionzd2start1268z62zz__ssl_sslz00(obj_t BgL_envz00_5363, obj_t BgL_sslz00_5364)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 910 */
return 
BINT(
bgl_ssl_connection_start(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5364)));} 
BGL_FUNCTION_END;
}



/* &ssl-connection-init1266 */
obj_t BGl_z62sslzd2connectionzd2init1266z62zz__ssl_sslz00(obj_t BgL_envz00_5365, obj_t BgL_sslz00_5366)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 900 */
return 
bgl_ssl_connection_init(
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5366));} 
BGL_FUNCTION_END;
}



/* &secure-context-set-o1264 */
obj_t BGl_z62securezd2contextzd2setzd2o1264zb0zz__ssl_sslz00(obj_t BgL_envz00_5367, obj_t BgL_scz00_5368, obj_t BgL_optionsz00_5369)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 888 */
{ /* Llib/ssl.scm 891 */
bool_t BgL_tmpz00_8857;
{ /* Llib/ssl.scm 891 */
int BgL_optionsz00_6481;
BgL_optionsz00_6481 = 
CINT(BgL_optionsz00_5369); 
{ /* Llib/ssl.scm 892 */
void * BgL_arg2218z00_6482;
BgL_arg2218z00_6482 = 
(((BgL_securezd2contextzd2_bglt)COBJECT(
((BgL_securezd2contextzd2_bglt)BgL_scz00_5368)))->BgL_z42nativez42); 
SSL_CTX_set_options(BgL_arg2218z00_6482, BgL_optionsz00_6481); BUNSPEC; } 
BgL_tmpz00_8857 = ((bool_t)1); } 
return 
BBOOL(BgL_tmpz00_8857);} } 
BGL_FUNCTION_END;
}



/* &secure-context-set-c1262 */
obj_t BGl_z62securezd2contextzd2setzd2c1262zb0zz__ssl_sslz00(obj_t BgL_envz00_5370, obj_t BgL_scz00_5371, obj_t BgL_ciphersz00_5372)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 876 */
{ /* Llib/ssl.scm 879 */
bool_t BgL_tmpz00_8863;
{ /* Llib/ssl.scm 880 */
char * BgL_auxz00_8867;void * BgL_tmpz00_8864;
BgL_auxz00_8867 = 
BSTRING_TO_STRING(
((obj_t)BgL_ciphersz00_5372)); 
BgL_tmpz00_8864 = 
(((BgL_securezd2contextzd2_bglt)COBJECT(
((BgL_securezd2contextzd2_bglt)BgL_scz00_5371)))->BgL_z42nativez42); 
SSL_CTX_set_cipher_list(BgL_tmpz00_8864, BgL_auxz00_8867); } 
BgL_tmpz00_8863 = ((bool_t)1); 
return 
BBOOL(BgL_tmpz00_8863);} } 
BGL_FUNCTION_END;
}



/* &secure-context-load-1260 */
obj_t BGl_z62securezd2contextzd2loadzd21260zb0zz__ssl_sslz00(obj_t BgL_envz00_5373, obj_t BgL_scz00_5374, obj_t BgL_pfxz00_5375, obj_t BgL_passz00_5376)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 866 */
return 
BBOOL(
bgl_load_pkcs12(
((BgL_securezd2contextzd2_bglt)BgL_scz00_5374), 
((obj_t)BgL_pfxz00_5375), BgL_passz00_5376));} 
BGL_FUNCTION_END;
}



/* &secure-context-set-s1258 */
obj_t BGl_z62securezd2contextzd2setzd2s1258zb0zz__ssl_sslz00(obj_t BgL_envz00_5377, obj_t BgL_scz00_5378, obj_t BgL_sicz00_5379, obj_t BgL_offsetz00_5380, obj_t BgL_lenz00_5381)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 856 */
{ /* Llib/ssl.scm 859 */
bool_t BgL_tmpz00_8876;
{ /* Llib/ssl.scm 859 */
long BgL_offsetz00_6489;long BgL_lenz00_6490;
BgL_offsetz00_6489 = 
(long)CINT(BgL_offsetz00_5380); 
BgL_lenz00_6490 = 
(long)CINT(BgL_lenz00_5381); 
BgL_tmpz00_8876 = 
bgl_ssl_ctx_set_session_id_context(
((BgL_securezd2contextzd2_bglt)BgL_scz00_5378), 
((obj_t)BgL_sicz00_5379), BgL_offsetz00_6489, BgL_lenz00_6490); } 
return 
BBOOL(BgL_tmpz00_8876);} } 
BGL_FUNCTION_END;
}



/* &secure-context-set-c1256 */
obj_t BGl_z62securezd2contextzd2setzd2c1256zb0zz__ssl_sslz00(obj_t BgL_envz00_5382, obj_t BgL_scz00_5383, obj_t BgL_certz00_5384, obj_t BgL_offsetz00_5385, obj_t BgL_lenz00_5386)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 846 */
{ /* Llib/ssl.scm 849 */
bool_t BgL_tmpz00_8883;
{ /* Llib/ssl.scm 849 */
long BgL_offsetz00_6493;long BgL_lenz00_6494;
BgL_offsetz00_6493 = 
(long)CINT(BgL_offsetz00_5385); 
BgL_lenz00_6494 = 
(long)CINT(BgL_lenz00_5386); 
BgL_tmpz00_8883 = 
bgl_ssl_ctx_set_cert(
((BgL_securezd2contextzd2_bglt)BgL_scz00_5383), 
((obj_t)BgL_certz00_5384), BgL_offsetz00_6493, BgL_lenz00_6494); } 
return 
BBOOL(BgL_tmpz00_8883);} } 
BGL_FUNCTION_END;
}



/* &secure-context-set-k1248 */
obj_t BGl_z62securezd2contextzd2setzd2k1248zb0zz__ssl_sslz00(obj_t BgL_envz00_5387, obj_t BgL_scz00_5388, obj_t BgL_certz00_5389, obj_t BgL_offsetz00_5390, obj_t BgL_lenz00_5391, obj_t BgL_passphrasez00_5392)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 836 */
return 
BBOOL(
bgl_ssl_ctx_set_key(
((BgL_securezd2contextzd2_bglt)BgL_scz00_5388), BgL_certz00_5389, 
(long)CINT(BgL_offsetz00_5390), 
(long)CINT(BgL_lenz00_5391), BgL_passphrasez00_5392));} 
BGL_FUNCTION_END;
}



/* &secure-context-add-c1246 */
obj_t BGl_z62securezd2contextzd2addzd2c1246zb0zz__ssl_sslz00(obj_t BgL_envz00_5393, obj_t BgL_scz00_5394, obj_t BgL_certz00_5395, obj_t BgL_offsetz00_5396, obj_t BgL_lenz00_5397)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 826 */
{ /* Llib/ssl.scm 829 */
bool_t BgL_tmpz00_8895;
{ /* Llib/ssl.scm 829 */
long BgL_offsetz00_6497;long BgL_lenz00_6498;
BgL_offsetz00_6497 = 
(long)CINT(BgL_offsetz00_5396); 
BgL_lenz00_6498 = 
(long)CINT(BgL_lenz00_5397); 
BgL_tmpz00_8895 = 
bgl_ssl_ctx_add_crl(
((BgL_securezd2contextzd2_bglt)BgL_scz00_5394), 
((obj_t)BgL_certz00_5395), BgL_offsetz00_6497, BgL_lenz00_6498); } 
return 
BBOOL(BgL_tmpz00_8895);} } 
BGL_FUNCTION_END;
}



/* &secure-context-add-c1244 */
obj_t BGl_z62securezd2contextzd2addzd2c1244zb0zz__ssl_sslz00(obj_t BgL_envz00_5398, obj_t BgL_scz00_5399, obj_t BgL_certz00_5400, obj_t BgL_offsetz00_5401, obj_t BgL_lenz00_5402)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 816 */
{ /* Llib/ssl.scm 819 */
bool_t BgL_tmpz00_8902;
{ /* Llib/ssl.scm 819 */
long BgL_offsetz00_6501;long BgL_lenz00_6502;
BgL_offsetz00_6501 = 
(long)CINT(BgL_offsetz00_5401); 
BgL_lenz00_6502 = 
(long)CINT(BgL_lenz00_5402); 
BgL_tmpz00_8902 = 
bgl_ssl_ctx_add_ca_cert(
((BgL_securezd2contextzd2_bglt)BgL_scz00_5399), 
((obj_t)BgL_certz00_5400), BgL_offsetz00_6501, BgL_lenz00_6502); } 
return 
BBOOL(BgL_tmpz00_8902);} } 
BGL_FUNCTION_END;
}



/* &secure-context-add-r1242 */
obj_t BGl_z62securezd2contextzd2addzd2r1242zb0zz__ssl_sslz00(obj_t BgL_envz00_5403, obj_t BgL_scz00_5404)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 806 */
return 
BBOOL(
bgl_ssl_ctx_add_root_certs(
((BgL_securezd2contextzd2_bglt)BgL_scz00_5404)));} 
BGL_FUNCTION_END;
}



/* &secure-context-close1240 */
obj_t BGl_z62securezd2contextzd2close1240z62zz__ssl_sslz00(obj_t BgL_envz00_5405, obj_t BgL_scz00_5406)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 796 */
return 
bgl_ssl_ctx_close(
((BgL_securezd2contextzd2_bglt)BgL_scz00_5406));} 
BGL_FUNCTION_END;
}



/* &secure-context-init1238 */
obj_t BGl_z62securezd2contextzd2init1238z62zz__ssl_sslz00(obj_t BgL_envz00_5407, obj_t BgL_scz00_5408)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 786 */
return 
bgl_ssl_ctx_init(
((BgL_securezd2contextzd2_bglt)BgL_scz00_5408));} 
BGL_FUNCTION_END;
}



/* secure-context-init */
BGL_EXPORTED_DEF obj_t BGl_securezd2contextzd2initz00zz__ssl_sslz00(BgL_securezd2contextzd2_bglt BgL_scz00_42)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 786 */
{ /* Llib/ssl.scm 786 */
obj_t BgL_method1239z00_1709;
{ /* Llib/ssl.scm 786 */
obj_t BgL_res2382z00_2194;
{ /* Llib/ssl.scm 786 */
long BgL_objzd2classzd2numz00_2151;
{ /* Llib/ssl.scm 786 */
long BgL_res2371z00_2154;
BgL_res2371z00_2154 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_scz00_42)); 
BgL_objzd2classzd2numz00_2151 = BgL_res2371z00_2154; } 
{ /* Llib/ssl.scm 786 */
obj_t BgL_arg1742z00_2152;
BgL_arg1742z00_2152 = 
PROCEDURE_REF(BGl_securezd2contextzd2initzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 786 */
int BgL_offsetz00_2156;
BgL_offsetz00_2156 = 
(int)(BgL_objzd2classzd2numz00_2151); 
{ /* Llib/ssl.scm 786 */
long BgL_offsetz00_2157;
BgL_offsetz00_2157 = 
(
(long)(BgL_offsetz00_2156)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 786 */
long BgL_modz00_2158;
{ /* Llib/ssl.scm 786 */
int BgL_arg1744z00_2159;
BgL_arg1744z00_2159 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 786 */
long BgL_res2374z00_2169;
{ /* Llib/ssl.scm 786 */
long BgL_tmpz00_8924;
BgL_tmpz00_8924 = 
(long)(BgL_arg1744z00_2159); 
BgL_res2374z00_2169 = 
(BgL_offsetz00_2157/BgL_tmpz00_8924); } 
BgL_modz00_2158 = BgL_res2374z00_2169; } } 
{ /* Llib/ssl.scm 786 */
long BgL_restz00_2160;
{ /* Llib/ssl.scm 786 */
int BgL_arg1743z00_2161;
BgL_arg1743z00_2161 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 786 */
long BgL_res2381z00_2189;
{ /* Llib/ssl.scm 786 */
long BgL_n1z00_2171;long BgL_n2z00_2172;
BgL_n1z00_2171 = BgL_offsetz00_2157; 
BgL_n2z00_2172 = 
(long)(BgL_arg1743z00_2161); 
{ /* Llib/ssl.scm 786 */
bool_t BgL_testz00_8929;
{ /* Llib/ssl.scm 786 */
long BgL_arg1283z00_2174;
BgL_arg1283z00_2174 = 
(((BgL_n1z00_2171) | (BgL_n2z00_2172)) & -2147483648); 
BgL_testz00_8929 = 
(BgL_arg1283z00_2174==((long)0)); } 
if(BgL_testz00_8929)
{ /* Llib/ssl.scm 786 */
int32_t BgL_arg1272z00_2175;
{ /* Llib/ssl.scm 786 */
int32_t BgL_arg1278z00_2176;int32_t BgL_arg1279z00_2177;
{ /* Llib/ssl.scm 786 */
int32_t BgL_res2377z00_2181;
BgL_res2377z00_2181 = 
(int32_t)(BgL_n1z00_2171); 
BgL_arg1278z00_2176 = BgL_res2377z00_2181; } 
{ /* Llib/ssl.scm 786 */
int32_t BgL_res2378z00_2183;
BgL_res2378z00_2183 = 
(int32_t)(BgL_n2z00_2172); 
BgL_arg1279z00_2177 = BgL_res2378z00_2183; } 
BgL_arg1272z00_2175 = 
(BgL_arg1278z00_2176%BgL_arg1279z00_2177); } 
{ /* Llib/ssl.scm 786 */
long BgL_res2380z00_2188;
{ /* Llib/ssl.scm 786 */
long BgL_arg1409z00_2185;
BgL_arg1409z00_2185 = 
(long)(BgL_arg1272z00_2175); 
{ /* Llib/ssl.scm 786 */
long BgL_res2379z00_2187;
BgL_res2379z00_2187 = 
(long)(BgL_arg1409z00_2185); 
BgL_res2380z00_2188 = BgL_res2379z00_2187; } } 
BgL_res2381z00_2189 = BgL_res2380z00_2188; } }  else 
{ /* Llib/ssl.scm 786 */
BgL_res2381z00_2189 = 
(BgL_n1z00_2171%BgL_n2z00_2172); } } } 
BgL_restz00_2160 = BgL_res2381z00_2189; } } 
{ /* Llib/ssl.scm 786 */

{ /* Llib/ssl.scm 786 */
obj_t BgL_bucketz00_2162;
BgL_bucketz00_2162 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_2152),BgL_modz00_2158); 
BgL_res2382z00_2194 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2162),BgL_restz00_2160); } } } } } } } } 
BgL_method1239z00_1709 = BgL_res2382z00_2194; } 
return 
PROCEDURE_ENTRY(BgL_method1239z00_1709)(BgL_method1239z00_1709, 
((obj_t)BgL_scz00_42), BEOA);} } 
BGL_FUNCTION_END;
}



/* &secure-context-init */
obj_t BGl_z62securezd2contextzd2initz62zz__ssl_sslz00(obj_t BgL_envz00_5159, obj_t BgL_scz00_5160)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 786 */
{ /* Llib/ssl.scm 786 */
BgL_securezd2contextzd2_bglt BgL_auxz00_8947;
if(
BGl_isazf3zf3zz__objectz00(BgL_scz00_5160, BGl_securezd2contextzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 786 */
BgL_auxz00_8947 = 
((BgL_securezd2contextzd2_bglt)BgL_scz00_5160)
; }  else 
{ 
obj_t BgL_auxz00_8951;
BgL_auxz00_8951 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)32166)), BGl_string3739z00zz__ssl_sslz00, BGl_string3438z00zz__ssl_sslz00, BgL_scz00_5160); 
FAILURE(BgL_auxz00_8951,BFALSE,BFALSE);} 
return 
BGl_securezd2contextzd2initz00zz__ssl_sslz00(BgL_auxz00_8947);} } 
BGL_FUNCTION_END;
}



/* secure-context-close */
BGL_EXPORTED_DEF obj_t BGl_securezd2contextzd2closez00zz__ssl_sslz00(BgL_securezd2contextzd2_bglt BgL_scz00_43)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 796 */
{ /* Llib/ssl.scm 796 */
obj_t BgL_method1241z00_1710;
{ /* Llib/ssl.scm 796 */
obj_t BgL_res2394z00_2239;
{ /* Llib/ssl.scm 796 */
long BgL_objzd2classzd2numz00_2196;
{ /* Llib/ssl.scm 796 */
long BgL_res2383z00_2199;
BgL_res2383z00_2199 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_scz00_43)); 
BgL_objzd2classzd2numz00_2196 = BgL_res2383z00_2199; } 
{ /* Llib/ssl.scm 796 */
obj_t BgL_arg1742z00_2197;
BgL_arg1742z00_2197 = 
PROCEDURE_REF(BGl_securezd2contextzd2closezd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 796 */
int BgL_offsetz00_2201;
BgL_offsetz00_2201 = 
(int)(BgL_objzd2classzd2numz00_2196); 
{ /* Llib/ssl.scm 796 */
long BgL_offsetz00_2202;
BgL_offsetz00_2202 = 
(
(long)(BgL_offsetz00_2201)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 796 */
long BgL_modz00_2203;
{ /* Llib/ssl.scm 796 */
int BgL_arg1744z00_2204;
BgL_arg1744z00_2204 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 796 */
long BgL_res2386z00_2214;
{ /* Llib/ssl.scm 796 */
long BgL_tmpz00_8964;
BgL_tmpz00_8964 = 
(long)(BgL_arg1744z00_2204); 
BgL_res2386z00_2214 = 
(BgL_offsetz00_2202/BgL_tmpz00_8964); } 
BgL_modz00_2203 = BgL_res2386z00_2214; } } 
{ /* Llib/ssl.scm 796 */
long BgL_restz00_2205;
{ /* Llib/ssl.scm 796 */
int BgL_arg1743z00_2206;
BgL_arg1743z00_2206 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 796 */
long BgL_res2393z00_2234;
{ /* Llib/ssl.scm 796 */
long BgL_n1z00_2216;long BgL_n2z00_2217;
BgL_n1z00_2216 = BgL_offsetz00_2202; 
BgL_n2z00_2217 = 
(long)(BgL_arg1743z00_2206); 
{ /* Llib/ssl.scm 796 */
bool_t BgL_testz00_8969;
{ /* Llib/ssl.scm 796 */
long BgL_arg1283z00_2219;
BgL_arg1283z00_2219 = 
(((BgL_n1z00_2216) | (BgL_n2z00_2217)) & -2147483648); 
BgL_testz00_8969 = 
(BgL_arg1283z00_2219==((long)0)); } 
if(BgL_testz00_8969)
{ /* Llib/ssl.scm 796 */
int32_t BgL_arg1272z00_2220;
{ /* Llib/ssl.scm 796 */
int32_t BgL_arg1278z00_2221;int32_t BgL_arg1279z00_2222;
{ /* Llib/ssl.scm 796 */
int32_t BgL_res2389z00_2226;
BgL_res2389z00_2226 = 
(int32_t)(BgL_n1z00_2216); 
BgL_arg1278z00_2221 = BgL_res2389z00_2226; } 
{ /* Llib/ssl.scm 796 */
int32_t BgL_res2390z00_2228;
BgL_res2390z00_2228 = 
(int32_t)(BgL_n2z00_2217); 
BgL_arg1279z00_2222 = BgL_res2390z00_2228; } 
BgL_arg1272z00_2220 = 
(BgL_arg1278z00_2221%BgL_arg1279z00_2222); } 
{ /* Llib/ssl.scm 796 */
long BgL_res2392z00_2233;
{ /* Llib/ssl.scm 796 */
long BgL_arg1409z00_2230;
BgL_arg1409z00_2230 = 
(long)(BgL_arg1272z00_2220); 
{ /* Llib/ssl.scm 796 */
long BgL_res2391z00_2232;
BgL_res2391z00_2232 = 
(long)(BgL_arg1409z00_2230); 
BgL_res2392z00_2233 = BgL_res2391z00_2232; } } 
BgL_res2393z00_2234 = BgL_res2392z00_2233; } }  else 
{ /* Llib/ssl.scm 796 */
BgL_res2393z00_2234 = 
(BgL_n1z00_2216%BgL_n2z00_2217); } } } 
BgL_restz00_2205 = BgL_res2393z00_2234; } } 
{ /* Llib/ssl.scm 796 */

{ /* Llib/ssl.scm 796 */
obj_t BgL_bucketz00_2207;
BgL_bucketz00_2207 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_2197),BgL_modz00_2203); 
BgL_res2394z00_2239 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2207),BgL_restz00_2205); } } } } } } } } 
BgL_method1241z00_1710 = BgL_res2394z00_2239; } 
return 
PROCEDURE_ENTRY(BgL_method1241z00_1710)(BgL_method1241z00_1710, 
((obj_t)BgL_scz00_43), BEOA);} } 
BGL_FUNCTION_END;
}



/* &secure-context-close */
obj_t BGl_z62securezd2contextzd2closez62zz__ssl_sslz00(obj_t BgL_envz00_5409, obj_t BgL_scz00_5410)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 796 */
{ /* Llib/ssl.scm 796 */
BgL_securezd2contextzd2_bglt BgL_auxz00_8987;
if(
BGl_isazf3zf3zz__objectz00(BgL_scz00_5410, BGl_securezd2contextzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 796 */
BgL_auxz00_8987 = 
((BgL_securezd2contextzd2_bglt)BgL_scz00_5410)
; }  else 
{ 
obj_t BgL_auxz00_8991;
BgL_auxz00_8991 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)32542)), BGl_string3740z00zz__ssl_sslz00, BGl_string3438z00zz__ssl_sslz00, BgL_scz00_5410); 
FAILURE(BgL_auxz00_8991,BFALSE,BFALSE);} 
return 
BGl_securezd2contextzd2closez00zz__ssl_sslz00(BgL_auxz00_8987);} } 
BGL_FUNCTION_END;
}



/* secure-context-add-root-certs! */
BGL_EXPORTED_DEF bool_t BGl_securezd2contextzd2addzd2rootzd2certsz12z12zz__ssl_sslz00(BgL_securezd2contextzd2_bglt BgL_scz00_44)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 806 */
{ /* Llib/ssl.scm 806 */
obj_t BgL_method1243z00_1711;
{ /* Llib/ssl.scm 806 */
obj_t BgL_res2406z00_2284;
{ /* Llib/ssl.scm 806 */
long BgL_objzd2classzd2numz00_2241;
{ /* Llib/ssl.scm 806 */
long BgL_res2395z00_2244;
BgL_res2395z00_2244 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_scz00_44)); 
BgL_objzd2classzd2numz00_2241 = BgL_res2395z00_2244; } 
{ /* Llib/ssl.scm 806 */
obj_t BgL_arg1742z00_2242;
BgL_arg1742z00_2242 = 
PROCEDURE_REF(BGl_securezd2contextzd2addzd2rootzd2certsz12zd2envzc0zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 806 */
int BgL_offsetz00_2246;
BgL_offsetz00_2246 = 
(int)(BgL_objzd2classzd2numz00_2241); 
{ /* Llib/ssl.scm 806 */
long BgL_offsetz00_2247;
BgL_offsetz00_2247 = 
(
(long)(BgL_offsetz00_2246)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 806 */
long BgL_modz00_2248;
{ /* Llib/ssl.scm 806 */
int BgL_arg1744z00_2249;
BgL_arg1744z00_2249 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 806 */
long BgL_res2398z00_2259;
{ /* Llib/ssl.scm 806 */
long BgL_tmpz00_9004;
BgL_tmpz00_9004 = 
(long)(BgL_arg1744z00_2249); 
BgL_res2398z00_2259 = 
(BgL_offsetz00_2247/BgL_tmpz00_9004); } 
BgL_modz00_2248 = BgL_res2398z00_2259; } } 
{ /* Llib/ssl.scm 806 */
long BgL_restz00_2250;
{ /* Llib/ssl.scm 806 */
int BgL_arg1743z00_2251;
BgL_arg1743z00_2251 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 806 */
long BgL_res2405z00_2279;
{ /* Llib/ssl.scm 806 */
long BgL_n1z00_2261;long BgL_n2z00_2262;
BgL_n1z00_2261 = BgL_offsetz00_2247; 
BgL_n2z00_2262 = 
(long)(BgL_arg1743z00_2251); 
{ /* Llib/ssl.scm 806 */
bool_t BgL_testz00_9009;
{ /* Llib/ssl.scm 806 */
long BgL_arg1283z00_2264;
BgL_arg1283z00_2264 = 
(((BgL_n1z00_2261) | (BgL_n2z00_2262)) & -2147483648); 
BgL_testz00_9009 = 
(BgL_arg1283z00_2264==((long)0)); } 
if(BgL_testz00_9009)
{ /* Llib/ssl.scm 806 */
int32_t BgL_arg1272z00_2265;
{ /* Llib/ssl.scm 806 */
int32_t BgL_arg1278z00_2266;int32_t BgL_arg1279z00_2267;
{ /* Llib/ssl.scm 806 */
int32_t BgL_res2401z00_2271;
BgL_res2401z00_2271 = 
(int32_t)(BgL_n1z00_2261); 
BgL_arg1278z00_2266 = BgL_res2401z00_2271; } 
{ /* Llib/ssl.scm 806 */
int32_t BgL_res2402z00_2273;
BgL_res2402z00_2273 = 
(int32_t)(BgL_n2z00_2262); 
BgL_arg1279z00_2267 = BgL_res2402z00_2273; } 
BgL_arg1272z00_2265 = 
(BgL_arg1278z00_2266%BgL_arg1279z00_2267); } 
{ /* Llib/ssl.scm 806 */
long BgL_res2404z00_2278;
{ /* Llib/ssl.scm 806 */
long BgL_arg1409z00_2275;
BgL_arg1409z00_2275 = 
(long)(BgL_arg1272z00_2265); 
{ /* Llib/ssl.scm 806 */
long BgL_res2403z00_2277;
BgL_res2403z00_2277 = 
(long)(BgL_arg1409z00_2275); 
BgL_res2404z00_2278 = BgL_res2403z00_2277; } } 
BgL_res2405z00_2279 = BgL_res2404z00_2278; } }  else 
{ /* Llib/ssl.scm 806 */
BgL_res2405z00_2279 = 
(BgL_n1z00_2261%BgL_n2z00_2262); } } } 
BgL_restz00_2250 = BgL_res2405z00_2279; } } 
{ /* Llib/ssl.scm 806 */

{ /* Llib/ssl.scm 806 */
obj_t BgL_bucketz00_2252;
BgL_bucketz00_2252 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_2242),BgL_modz00_2248); 
BgL_res2406z00_2284 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2252),BgL_restz00_2250); } } } } } } } } 
BgL_method1243z00_1711 = BgL_res2406z00_2284; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1243z00_1711)(BgL_method1243z00_1711, 
((obj_t)BgL_scz00_44), BEOA));} } 
BGL_FUNCTION_END;
}



/* &secure-context-add-root-certs! */
obj_t BGl_z62securezd2contextzd2addzd2rootzd2certsz12z70zz__ssl_sslz00(obj_t BgL_envz00_5411, obj_t BgL_scz00_5412)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 806 */
{ /* Llib/ssl.scm 806 */
bool_t BgL_tmpz00_9028;
{ /* Llib/ssl.scm 806 */
BgL_securezd2contextzd2_bglt BgL_auxz00_9029;
if(
BGl_isazf3zf3zz__objectz00(BgL_scz00_5412, BGl_securezd2contextzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 806 */
BgL_auxz00_9029 = 
((BgL_securezd2contextzd2_bglt)BgL_scz00_5412)
; }  else 
{ 
obj_t BgL_auxz00_9033;
BgL_auxz00_9033 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)32920)), BGl_string3741z00zz__ssl_sslz00, BGl_string3438z00zz__ssl_sslz00, BgL_scz00_5412); 
FAILURE(BgL_auxz00_9033,BFALSE,BFALSE);} 
BgL_tmpz00_9028 = 
BGl_securezd2contextzd2addzd2rootzd2certsz12z12zz__ssl_sslz00(BgL_auxz00_9029); } 
return 
BBOOL(BgL_tmpz00_9028);} } 
BGL_FUNCTION_END;
}



/* secure-context-add-ca-cert! */
BGL_EXPORTED_DEF bool_t BGl_securezd2contextzd2addzd2cazd2certz12z12zz__ssl_sslz00(BgL_securezd2contextzd2_bglt BgL_scz00_45, obj_t BgL_certz00_46, long BgL_offsetz00_47, long BgL_lenz00_48)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 816 */
{ /* Llib/ssl.scm 816 */
obj_t BgL_method1245z00_1712;
{ /* Llib/ssl.scm 816 */
obj_t BgL_res2418z00_2329;
{ /* Llib/ssl.scm 816 */
long BgL_objzd2classzd2numz00_2286;
{ /* Llib/ssl.scm 816 */
long BgL_res2407z00_2289;
BgL_res2407z00_2289 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_scz00_45)); 
BgL_objzd2classzd2numz00_2286 = BgL_res2407z00_2289; } 
{ /* Llib/ssl.scm 816 */
obj_t BgL_arg1742z00_2287;
BgL_arg1742z00_2287 = 
PROCEDURE_REF(BGl_securezd2contextzd2addzd2cazd2certz12zd2envzc0zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 816 */
int BgL_offsetz00_2291;
BgL_offsetz00_2291 = 
(int)(BgL_objzd2classzd2numz00_2286); 
{ /* Llib/ssl.scm 816 */
long BgL_offsetz00_2292;
BgL_offsetz00_2292 = 
(
(long)(BgL_offsetz00_2291)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 816 */
long BgL_modz00_2293;
{ /* Llib/ssl.scm 816 */
int BgL_arg1744z00_2294;
BgL_arg1744z00_2294 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 816 */
long BgL_res2410z00_2304;
{ /* Llib/ssl.scm 816 */
long BgL_tmpz00_9047;
BgL_tmpz00_9047 = 
(long)(BgL_arg1744z00_2294); 
BgL_res2410z00_2304 = 
(BgL_offsetz00_2292/BgL_tmpz00_9047); } 
BgL_modz00_2293 = BgL_res2410z00_2304; } } 
{ /* Llib/ssl.scm 816 */
long BgL_restz00_2295;
{ /* Llib/ssl.scm 816 */
int BgL_arg1743z00_2296;
BgL_arg1743z00_2296 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 816 */
long BgL_res2417z00_2324;
{ /* Llib/ssl.scm 816 */
long BgL_n1z00_2306;long BgL_n2z00_2307;
BgL_n1z00_2306 = BgL_offsetz00_2292; 
BgL_n2z00_2307 = 
(long)(BgL_arg1743z00_2296); 
{ /* Llib/ssl.scm 816 */
bool_t BgL_testz00_9052;
{ /* Llib/ssl.scm 816 */
long BgL_arg1283z00_2309;
BgL_arg1283z00_2309 = 
(((BgL_n1z00_2306) | (BgL_n2z00_2307)) & -2147483648); 
BgL_testz00_9052 = 
(BgL_arg1283z00_2309==((long)0)); } 
if(BgL_testz00_9052)
{ /* Llib/ssl.scm 816 */
int32_t BgL_arg1272z00_2310;
{ /* Llib/ssl.scm 816 */
int32_t BgL_arg1278z00_2311;int32_t BgL_arg1279z00_2312;
{ /* Llib/ssl.scm 816 */
int32_t BgL_res2413z00_2316;
BgL_res2413z00_2316 = 
(int32_t)(BgL_n1z00_2306); 
BgL_arg1278z00_2311 = BgL_res2413z00_2316; } 
{ /* Llib/ssl.scm 816 */
int32_t BgL_res2414z00_2318;
BgL_res2414z00_2318 = 
(int32_t)(BgL_n2z00_2307); 
BgL_arg1279z00_2312 = BgL_res2414z00_2318; } 
BgL_arg1272z00_2310 = 
(BgL_arg1278z00_2311%BgL_arg1279z00_2312); } 
{ /* Llib/ssl.scm 816 */
long BgL_res2416z00_2323;
{ /* Llib/ssl.scm 816 */
long BgL_arg1409z00_2320;
BgL_arg1409z00_2320 = 
(long)(BgL_arg1272z00_2310); 
{ /* Llib/ssl.scm 816 */
long BgL_res2415z00_2322;
BgL_res2415z00_2322 = 
(long)(BgL_arg1409z00_2320); 
BgL_res2416z00_2323 = BgL_res2415z00_2322; } } 
BgL_res2417z00_2324 = BgL_res2416z00_2323; } }  else 
{ /* Llib/ssl.scm 816 */
BgL_res2417z00_2324 = 
(BgL_n1z00_2306%BgL_n2z00_2307); } } } 
BgL_restz00_2295 = BgL_res2417z00_2324; } } 
{ /* Llib/ssl.scm 816 */

{ /* Llib/ssl.scm 816 */
obj_t BgL_bucketz00_2297;
BgL_bucketz00_2297 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_2287),BgL_modz00_2293); 
BgL_res2418z00_2329 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2297),BgL_restz00_2295); } } } } } } } } 
BgL_method1245z00_1712 = BgL_res2418z00_2329; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1245z00_1712)(BgL_method1245z00_1712, 
((obj_t)BgL_scz00_45), BgL_certz00_46, 
BINT(BgL_offsetz00_47), 
BINT(BgL_lenz00_48), BEOA));} } 
BGL_FUNCTION_END;
}



/* &secure-context-add-ca-cert! */
obj_t BGl_z62securezd2contextzd2addzd2cazd2certz12z70zz__ssl_sslz00(obj_t BgL_envz00_5413, obj_t BgL_scz00_5414, obj_t BgL_certz00_5415, obj_t BgL_offsetz00_5416, obj_t BgL_lenz00_5417)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 816 */
{ /* Llib/ssl.scm 816 */
bool_t BgL_tmpz00_9076;
{ /* Llib/ssl.scm 816 */
long BgL_auxz00_9101;long BgL_auxz00_9092;obj_t BgL_auxz00_9085;BgL_securezd2contextzd2_bglt BgL_auxz00_9077;
{ /* Llib/ssl.scm 816 */
obj_t BgL_tmpz00_9102;
if(
INTEGERP(BgL_lenz00_5417))
{ /* Llib/ssl.scm 816 */
BgL_tmpz00_9102 = BgL_lenz00_5417
; }  else 
{ 
obj_t BgL_auxz00_9105;
BgL_auxz00_9105 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)33317)), BGl_string3742z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_lenz00_5417); 
FAILURE(BgL_auxz00_9105,BFALSE,BFALSE);} 
BgL_auxz00_9101 = 
(long)CINT(BgL_tmpz00_9102); } 
{ /* Llib/ssl.scm 816 */
obj_t BgL_tmpz00_9093;
if(
INTEGERP(BgL_offsetz00_5416))
{ /* Llib/ssl.scm 816 */
BgL_tmpz00_9093 = BgL_offsetz00_5416
; }  else 
{ 
obj_t BgL_auxz00_9096;
BgL_auxz00_9096 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)33317)), BGl_string3742z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_offsetz00_5416); 
FAILURE(BgL_auxz00_9096,BFALSE,BFALSE);} 
BgL_auxz00_9092 = 
(long)CINT(BgL_tmpz00_9093); } 
if(
STRINGP(BgL_certz00_5415))
{ /* Llib/ssl.scm 816 */
BgL_auxz00_9085 = BgL_certz00_5415
; }  else 
{ 
obj_t BgL_auxz00_9088;
BgL_auxz00_9088 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)33317)), BGl_string3742z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_certz00_5415); 
FAILURE(BgL_auxz00_9088,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_scz00_5414, BGl_securezd2contextzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 816 */
BgL_auxz00_9077 = 
((BgL_securezd2contextzd2_bglt)BgL_scz00_5414)
; }  else 
{ 
obj_t BgL_auxz00_9081;
BgL_auxz00_9081 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)33317)), BGl_string3742z00zz__ssl_sslz00, BGl_string3438z00zz__ssl_sslz00, BgL_scz00_5414); 
FAILURE(BgL_auxz00_9081,BFALSE,BFALSE);} 
BgL_tmpz00_9076 = 
BGl_securezd2contextzd2addzd2cazd2certz12z12zz__ssl_sslz00(BgL_auxz00_9077, BgL_auxz00_9085, BgL_auxz00_9092, BgL_auxz00_9101); } 
return 
BBOOL(BgL_tmpz00_9076);} } 
BGL_FUNCTION_END;
}



/* secure-context-add-crl! */
BGL_EXPORTED_DEF bool_t BGl_securezd2contextzd2addzd2crlz12zc0zz__ssl_sslz00(BgL_securezd2contextzd2_bglt BgL_scz00_49, obj_t BgL_certz00_50, long BgL_offsetz00_51, long BgL_lenz00_52)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 826 */
{ /* Llib/ssl.scm 826 */
obj_t BgL_method1247z00_1713;
{ /* Llib/ssl.scm 826 */
obj_t BgL_res2430z00_2374;
{ /* Llib/ssl.scm 826 */
long BgL_objzd2classzd2numz00_2331;
{ /* Llib/ssl.scm 826 */
long BgL_res2419z00_2334;
BgL_res2419z00_2334 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_scz00_49)); 
BgL_objzd2classzd2numz00_2331 = BgL_res2419z00_2334; } 
{ /* Llib/ssl.scm 826 */
obj_t BgL_arg1742z00_2332;
BgL_arg1742z00_2332 = 
PROCEDURE_REF(BGl_securezd2contextzd2addzd2crlz12zd2envz12zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 826 */
int BgL_offsetz00_2336;
BgL_offsetz00_2336 = 
(int)(BgL_objzd2classzd2numz00_2331); 
{ /* Llib/ssl.scm 826 */
long BgL_offsetz00_2337;
BgL_offsetz00_2337 = 
(
(long)(BgL_offsetz00_2336)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 826 */
long BgL_modz00_2338;
{ /* Llib/ssl.scm 826 */
int BgL_arg1744z00_2339;
BgL_arg1744z00_2339 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 826 */
long BgL_res2422z00_2349;
{ /* Llib/ssl.scm 826 */
long BgL_tmpz00_9120;
BgL_tmpz00_9120 = 
(long)(BgL_arg1744z00_2339); 
BgL_res2422z00_2349 = 
(BgL_offsetz00_2337/BgL_tmpz00_9120); } 
BgL_modz00_2338 = BgL_res2422z00_2349; } } 
{ /* Llib/ssl.scm 826 */
long BgL_restz00_2340;
{ /* Llib/ssl.scm 826 */
int BgL_arg1743z00_2341;
BgL_arg1743z00_2341 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 826 */
long BgL_res2429z00_2369;
{ /* Llib/ssl.scm 826 */
long BgL_n1z00_2351;long BgL_n2z00_2352;
BgL_n1z00_2351 = BgL_offsetz00_2337; 
BgL_n2z00_2352 = 
(long)(BgL_arg1743z00_2341); 
{ /* Llib/ssl.scm 826 */
bool_t BgL_testz00_9125;
{ /* Llib/ssl.scm 826 */
long BgL_arg1283z00_2354;
BgL_arg1283z00_2354 = 
(((BgL_n1z00_2351) | (BgL_n2z00_2352)) & -2147483648); 
BgL_testz00_9125 = 
(BgL_arg1283z00_2354==((long)0)); } 
if(BgL_testz00_9125)
{ /* Llib/ssl.scm 826 */
int32_t BgL_arg1272z00_2355;
{ /* Llib/ssl.scm 826 */
int32_t BgL_arg1278z00_2356;int32_t BgL_arg1279z00_2357;
{ /* Llib/ssl.scm 826 */
int32_t BgL_res2425z00_2361;
BgL_res2425z00_2361 = 
(int32_t)(BgL_n1z00_2351); 
BgL_arg1278z00_2356 = BgL_res2425z00_2361; } 
{ /* Llib/ssl.scm 826 */
int32_t BgL_res2426z00_2363;
BgL_res2426z00_2363 = 
(int32_t)(BgL_n2z00_2352); 
BgL_arg1279z00_2357 = BgL_res2426z00_2363; } 
BgL_arg1272z00_2355 = 
(BgL_arg1278z00_2356%BgL_arg1279z00_2357); } 
{ /* Llib/ssl.scm 826 */
long BgL_res2428z00_2368;
{ /* Llib/ssl.scm 826 */
long BgL_arg1409z00_2365;
BgL_arg1409z00_2365 = 
(long)(BgL_arg1272z00_2355); 
{ /* Llib/ssl.scm 826 */
long BgL_res2427z00_2367;
BgL_res2427z00_2367 = 
(long)(BgL_arg1409z00_2365); 
BgL_res2428z00_2368 = BgL_res2427z00_2367; } } 
BgL_res2429z00_2369 = BgL_res2428z00_2368; } }  else 
{ /* Llib/ssl.scm 826 */
BgL_res2429z00_2369 = 
(BgL_n1z00_2351%BgL_n2z00_2352); } } } 
BgL_restz00_2340 = BgL_res2429z00_2369; } } 
{ /* Llib/ssl.scm 826 */

{ /* Llib/ssl.scm 826 */
obj_t BgL_bucketz00_2342;
BgL_bucketz00_2342 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_2332),BgL_modz00_2338); 
BgL_res2430z00_2374 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2342),BgL_restz00_2340); } } } } } } } } 
BgL_method1247z00_1713 = BgL_res2430z00_2374; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1247z00_1713)(BgL_method1247z00_1713, 
((obj_t)BgL_scz00_49), BgL_certz00_50, 
BINT(BgL_offsetz00_51), 
BINT(BgL_lenz00_52), BEOA));} } 
BGL_FUNCTION_END;
}



/* &secure-context-add-crl! */
obj_t BGl_z62securezd2contextzd2addzd2crlz12za2zz__ssl_sslz00(obj_t BgL_envz00_5418, obj_t BgL_scz00_5419, obj_t BgL_certz00_5420, obj_t BgL_offsetz00_5421, obj_t BgL_lenz00_5422)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 826 */
{ /* Llib/ssl.scm 826 */
bool_t BgL_tmpz00_9149;
{ /* Llib/ssl.scm 826 */
long BgL_auxz00_9174;long BgL_auxz00_9165;obj_t BgL_auxz00_9158;BgL_securezd2contextzd2_bglt BgL_auxz00_9150;
{ /* Llib/ssl.scm 826 */
obj_t BgL_tmpz00_9175;
if(
INTEGERP(BgL_lenz00_5422))
{ /* Llib/ssl.scm 826 */
BgL_tmpz00_9175 = BgL_lenz00_5422
; }  else 
{ 
obj_t BgL_auxz00_9178;
BgL_auxz00_9178 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)33740)), BGl_string3743z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_lenz00_5422); 
FAILURE(BgL_auxz00_9178,BFALSE,BFALSE);} 
BgL_auxz00_9174 = 
(long)CINT(BgL_tmpz00_9175); } 
{ /* Llib/ssl.scm 826 */
obj_t BgL_tmpz00_9166;
if(
INTEGERP(BgL_offsetz00_5421))
{ /* Llib/ssl.scm 826 */
BgL_tmpz00_9166 = BgL_offsetz00_5421
; }  else 
{ 
obj_t BgL_auxz00_9169;
BgL_auxz00_9169 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)33740)), BGl_string3743z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_offsetz00_5421); 
FAILURE(BgL_auxz00_9169,BFALSE,BFALSE);} 
BgL_auxz00_9165 = 
(long)CINT(BgL_tmpz00_9166); } 
if(
STRINGP(BgL_certz00_5420))
{ /* Llib/ssl.scm 826 */
BgL_auxz00_9158 = BgL_certz00_5420
; }  else 
{ 
obj_t BgL_auxz00_9161;
BgL_auxz00_9161 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)33740)), BGl_string3743z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_certz00_5420); 
FAILURE(BgL_auxz00_9161,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_scz00_5419, BGl_securezd2contextzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 826 */
BgL_auxz00_9150 = 
((BgL_securezd2contextzd2_bglt)BgL_scz00_5419)
; }  else 
{ 
obj_t BgL_auxz00_9154;
BgL_auxz00_9154 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)33740)), BGl_string3743z00zz__ssl_sslz00, BGl_string3438z00zz__ssl_sslz00, BgL_scz00_5419); 
FAILURE(BgL_auxz00_9154,BFALSE,BFALSE);} 
BgL_tmpz00_9149 = 
BGl_securezd2contextzd2addzd2crlz12zc0zz__ssl_sslz00(BgL_auxz00_9150, BgL_auxz00_9158, BgL_auxz00_9165, BgL_auxz00_9174); } 
return 
BBOOL(BgL_tmpz00_9149);} } 
BGL_FUNCTION_END;
}



/* secure-context-set-key! */
BGL_EXPORTED_DEF bool_t BGl_securezd2contextzd2setzd2keyz12zc0zz__ssl_sslz00(BgL_securezd2contextzd2_bglt BgL_scz00_53, obj_t BgL_certz00_54, long BgL_offsetz00_55, long BgL_lenz00_56, obj_t BgL_passphrasez00_57)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 836 */
{ /* Llib/ssl.scm 351 */
obj_t BgL_method1249z00_1714;
{ /* Llib/ssl.scm 351 */
obj_t BgL_res2442z00_2419;
{ /* Llib/ssl.scm 351 */
long BgL_objzd2classzd2numz00_2376;
{ /* Llib/ssl.scm 351 */
long BgL_res2431z00_2379;
BgL_res2431z00_2379 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_scz00_53)); 
BgL_objzd2classzd2numz00_2376 = BgL_res2431z00_2379; } 
{ /* Llib/ssl.scm 351 */
obj_t BgL_arg1742z00_2377;
BgL_arg1742z00_2377 = 
PROCEDURE_REF(BGl_securezd2contextzd2setzd2keyz12zd2envz12zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 351 */
int BgL_offsetz00_2381;
BgL_offsetz00_2381 = 
(int)(BgL_objzd2classzd2numz00_2376); 
{ /* Llib/ssl.scm 351 */
long BgL_offsetz00_2382;
BgL_offsetz00_2382 = 
(
(long)(BgL_offsetz00_2381)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 351 */
long BgL_modz00_2383;
{ /* Llib/ssl.scm 351 */
int BgL_arg1744z00_2384;
BgL_arg1744z00_2384 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 351 */
long BgL_res2434z00_2394;
{ /* Llib/ssl.scm 351 */
long BgL_tmpz00_9193;
BgL_tmpz00_9193 = 
(long)(BgL_arg1744z00_2384); 
BgL_res2434z00_2394 = 
(BgL_offsetz00_2382/BgL_tmpz00_9193); } 
BgL_modz00_2383 = BgL_res2434z00_2394; } } 
{ /* Llib/ssl.scm 351 */
long BgL_restz00_2385;
{ /* Llib/ssl.scm 351 */
int BgL_arg1743z00_2386;
BgL_arg1743z00_2386 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 351 */
long BgL_res2441z00_2414;
{ /* Llib/ssl.scm 351 */
long BgL_n1z00_2396;long BgL_n2z00_2397;
BgL_n1z00_2396 = BgL_offsetz00_2382; 
BgL_n2z00_2397 = 
(long)(BgL_arg1743z00_2386); 
{ /* Llib/ssl.scm 351 */
bool_t BgL_testz00_9198;
{ /* Llib/ssl.scm 351 */
long BgL_arg1283z00_2399;
BgL_arg1283z00_2399 = 
(((BgL_n1z00_2396) | (BgL_n2z00_2397)) & -2147483648); 
BgL_testz00_9198 = 
(BgL_arg1283z00_2399==((long)0)); } 
if(BgL_testz00_9198)
{ /* Llib/ssl.scm 351 */
int32_t BgL_arg1272z00_2400;
{ /* Llib/ssl.scm 351 */
int32_t BgL_arg1278z00_2401;int32_t BgL_arg1279z00_2402;
{ /* Llib/ssl.scm 351 */
int32_t BgL_res2437z00_2406;
BgL_res2437z00_2406 = 
(int32_t)(BgL_n1z00_2396); 
BgL_arg1278z00_2401 = BgL_res2437z00_2406; } 
{ /* Llib/ssl.scm 351 */
int32_t BgL_res2438z00_2408;
BgL_res2438z00_2408 = 
(int32_t)(BgL_n2z00_2397); 
BgL_arg1279z00_2402 = BgL_res2438z00_2408; } 
BgL_arg1272z00_2400 = 
(BgL_arg1278z00_2401%BgL_arg1279z00_2402); } 
{ /* Llib/ssl.scm 351 */
long BgL_res2440z00_2413;
{ /* Llib/ssl.scm 351 */
long BgL_arg1409z00_2410;
BgL_arg1409z00_2410 = 
(long)(BgL_arg1272z00_2400); 
{ /* Llib/ssl.scm 351 */
long BgL_res2439z00_2412;
BgL_res2439z00_2412 = 
(long)(BgL_arg1409z00_2410); 
BgL_res2440z00_2413 = BgL_res2439z00_2412; } } 
BgL_res2441z00_2414 = BgL_res2440z00_2413; } }  else 
{ /* Llib/ssl.scm 351 */
BgL_res2441z00_2414 = 
(BgL_n1z00_2396%BgL_n2z00_2397); } } } 
BgL_restz00_2385 = BgL_res2441z00_2414; } } 
{ /* Llib/ssl.scm 351 */

{ /* Llib/ssl.scm 351 */
obj_t BgL_bucketz00_2387;
BgL_bucketz00_2387 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_2377),BgL_modz00_2383); 
BgL_res2442z00_2419 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2387),BgL_restz00_2385); } } } } } } } } 
BgL_method1249z00_1714 = BgL_res2442z00_2419; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1249z00_1714)(BgL_method1249z00_1714, 
((obj_t)BgL_scz00_53), BgL_certz00_54, 
BINT(BgL_offsetz00_55), 
BINT(BgL_lenz00_56), BgL_passphrasez00_57, BEOA));} } 
BGL_FUNCTION_END;
}



/* secure-context-set-cert! */
BGL_EXPORTED_DEF bool_t BGl_securezd2contextzd2setzd2certz12zc0zz__ssl_sslz00(BgL_securezd2contextzd2_bglt BgL_scz00_60, obj_t BgL_certz00_61, long BgL_offsetz00_62, long BgL_lenz00_63)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 846 */
{ /* Llib/ssl.scm 846 */
obj_t BgL_method1257z00_1715;
{ /* Llib/ssl.scm 846 */
obj_t BgL_res2454z00_2464;
{ /* Llib/ssl.scm 846 */
long BgL_objzd2classzd2numz00_2421;
{ /* Llib/ssl.scm 846 */
long BgL_res2443z00_2424;
BgL_res2443z00_2424 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_scz00_60)); 
BgL_objzd2classzd2numz00_2421 = BgL_res2443z00_2424; } 
{ /* Llib/ssl.scm 846 */
obj_t BgL_arg1742z00_2422;
BgL_arg1742z00_2422 = 
PROCEDURE_REF(BGl_securezd2contextzd2setzd2certz12zd2envz12zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 846 */
int BgL_offsetz00_2426;
BgL_offsetz00_2426 = 
(int)(BgL_objzd2classzd2numz00_2421); 
{ /* Llib/ssl.scm 846 */
long BgL_offsetz00_2427;
BgL_offsetz00_2427 = 
(
(long)(BgL_offsetz00_2426)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 846 */
long BgL_modz00_2428;
{ /* Llib/ssl.scm 846 */
int BgL_arg1744z00_2429;
BgL_arg1744z00_2429 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 846 */
long BgL_res2446z00_2439;
{ /* Llib/ssl.scm 846 */
long BgL_tmpz00_9231;
BgL_tmpz00_9231 = 
(long)(BgL_arg1744z00_2429); 
BgL_res2446z00_2439 = 
(BgL_offsetz00_2427/BgL_tmpz00_9231); } 
BgL_modz00_2428 = BgL_res2446z00_2439; } } 
{ /* Llib/ssl.scm 846 */
long BgL_restz00_2430;
{ /* Llib/ssl.scm 846 */
int BgL_arg1743z00_2431;
BgL_arg1743z00_2431 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 846 */
long BgL_res2453z00_2459;
{ /* Llib/ssl.scm 846 */
long BgL_n1z00_2441;long BgL_n2z00_2442;
BgL_n1z00_2441 = BgL_offsetz00_2427; 
BgL_n2z00_2442 = 
(long)(BgL_arg1743z00_2431); 
{ /* Llib/ssl.scm 846 */
bool_t BgL_testz00_9236;
{ /* Llib/ssl.scm 846 */
long BgL_arg1283z00_2444;
BgL_arg1283z00_2444 = 
(((BgL_n1z00_2441) | (BgL_n2z00_2442)) & -2147483648); 
BgL_testz00_9236 = 
(BgL_arg1283z00_2444==((long)0)); } 
if(BgL_testz00_9236)
{ /* Llib/ssl.scm 846 */
int32_t BgL_arg1272z00_2445;
{ /* Llib/ssl.scm 846 */
int32_t BgL_arg1278z00_2446;int32_t BgL_arg1279z00_2447;
{ /* Llib/ssl.scm 846 */
int32_t BgL_res2449z00_2451;
BgL_res2449z00_2451 = 
(int32_t)(BgL_n1z00_2441); 
BgL_arg1278z00_2446 = BgL_res2449z00_2451; } 
{ /* Llib/ssl.scm 846 */
int32_t BgL_res2450z00_2453;
BgL_res2450z00_2453 = 
(int32_t)(BgL_n2z00_2442); 
BgL_arg1279z00_2447 = BgL_res2450z00_2453; } 
BgL_arg1272z00_2445 = 
(BgL_arg1278z00_2446%BgL_arg1279z00_2447); } 
{ /* Llib/ssl.scm 846 */
long BgL_res2452z00_2458;
{ /* Llib/ssl.scm 846 */
long BgL_arg1409z00_2455;
BgL_arg1409z00_2455 = 
(long)(BgL_arg1272z00_2445); 
{ /* Llib/ssl.scm 846 */
long BgL_res2451z00_2457;
BgL_res2451z00_2457 = 
(long)(BgL_arg1409z00_2455); 
BgL_res2452z00_2458 = BgL_res2451z00_2457; } } 
BgL_res2453z00_2459 = BgL_res2452z00_2458; } }  else 
{ /* Llib/ssl.scm 846 */
BgL_res2453z00_2459 = 
(BgL_n1z00_2441%BgL_n2z00_2442); } } } 
BgL_restz00_2430 = BgL_res2453z00_2459; } } 
{ /* Llib/ssl.scm 846 */

{ /* Llib/ssl.scm 846 */
obj_t BgL_bucketz00_2432;
BgL_bucketz00_2432 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_2422),BgL_modz00_2428); 
BgL_res2454z00_2464 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2432),BgL_restz00_2430); } } } } } } } } 
BgL_method1257z00_1715 = BgL_res2454z00_2464; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1257z00_1715)(BgL_method1257z00_1715, 
((obj_t)BgL_scz00_60), BgL_certz00_61, 
BINT(BgL_offsetz00_62), 
BINT(BgL_lenz00_63), BEOA));} } 
BGL_FUNCTION_END;
}



/* &secure-context-set-cert! */
obj_t BGl_z62securezd2contextzd2setzd2certz12za2zz__ssl_sslz00(obj_t BgL_envz00_5423, obj_t BgL_scz00_5424, obj_t BgL_certz00_5425, obj_t BgL_offsetz00_5426, obj_t BgL_lenz00_5427)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 846 */
{ /* Llib/ssl.scm 846 */
bool_t BgL_tmpz00_9260;
{ /* Llib/ssl.scm 846 */
long BgL_auxz00_9285;long BgL_auxz00_9276;obj_t BgL_auxz00_9269;BgL_securezd2contextzd2_bglt BgL_auxz00_9261;
{ /* Llib/ssl.scm 846 */
obj_t BgL_tmpz00_9286;
if(
INTEGERP(BgL_lenz00_5427))
{ /* Llib/ssl.scm 846 */
BgL_tmpz00_9286 = BgL_lenz00_5427
; }  else 
{ 
obj_t BgL_auxz00_9289;
BgL_auxz00_9289 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)34624)), BGl_string3744z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_lenz00_5427); 
FAILURE(BgL_auxz00_9289,BFALSE,BFALSE);} 
BgL_auxz00_9285 = 
(long)CINT(BgL_tmpz00_9286); } 
{ /* Llib/ssl.scm 846 */
obj_t BgL_tmpz00_9277;
if(
INTEGERP(BgL_offsetz00_5426))
{ /* Llib/ssl.scm 846 */
BgL_tmpz00_9277 = BgL_offsetz00_5426
; }  else 
{ 
obj_t BgL_auxz00_9280;
BgL_auxz00_9280 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)34624)), BGl_string3744z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_offsetz00_5426); 
FAILURE(BgL_auxz00_9280,BFALSE,BFALSE);} 
BgL_auxz00_9276 = 
(long)CINT(BgL_tmpz00_9277); } 
if(
STRINGP(BgL_certz00_5425))
{ /* Llib/ssl.scm 846 */
BgL_auxz00_9269 = BgL_certz00_5425
; }  else 
{ 
obj_t BgL_auxz00_9272;
BgL_auxz00_9272 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)34624)), BGl_string3744z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_certz00_5425); 
FAILURE(BgL_auxz00_9272,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_scz00_5424, BGl_securezd2contextzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 846 */
BgL_auxz00_9261 = 
((BgL_securezd2contextzd2_bglt)BgL_scz00_5424)
; }  else 
{ 
obj_t BgL_auxz00_9265;
BgL_auxz00_9265 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)34624)), BGl_string3744z00zz__ssl_sslz00, BGl_string3438z00zz__ssl_sslz00, BgL_scz00_5424); 
FAILURE(BgL_auxz00_9265,BFALSE,BFALSE);} 
BgL_tmpz00_9260 = 
BGl_securezd2contextzd2setzd2certz12zc0zz__ssl_sslz00(BgL_auxz00_9261, BgL_auxz00_9269, BgL_auxz00_9276, BgL_auxz00_9285); } 
return 
BBOOL(BgL_tmpz00_9260);} } 
BGL_FUNCTION_END;
}



/* secure-context-set-session-id-context! */
BGL_EXPORTED_DEF bool_t BGl_securezd2contextzd2setzd2sessionzd2idzd2contextz12zc0zz__ssl_sslz00(BgL_securezd2contextzd2_bglt BgL_scz00_64, obj_t BgL_sicz00_65, long BgL_offsetz00_66, long BgL_lenz00_67)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 856 */
{ /* Llib/ssl.scm 856 */
obj_t BgL_method1259z00_1716;
{ /* Llib/ssl.scm 856 */
obj_t BgL_res2466z00_2509;
{ /* Llib/ssl.scm 856 */
long BgL_objzd2classzd2numz00_2466;
{ /* Llib/ssl.scm 856 */
long BgL_res2455z00_2469;
BgL_res2455z00_2469 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_scz00_64)); 
BgL_objzd2classzd2numz00_2466 = BgL_res2455z00_2469; } 
{ /* Llib/ssl.scm 856 */
obj_t BgL_arg1742z00_2467;
BgL_arg1742z00_2467 = 
PROCEDURE_REF(BGl_securezd2contextzd2setzd2sessionzd2idzd2contextz12zd2envz12zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 856 */
int BgL_offsetz00_2471;
BgL_offsetz00_2471 = 
(int)(BgL_objzd2classzd2numz00_2466); 
{ /* Llib/ssl.scm 856 */
long BgL_offsetz00_2472;
BgL_offsetz00_2472 = 
(
(long)(BgL_offsetz00_2471)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 856 */
long BgL_modz00_2473;
{ /* Llib/ssl.scm 856 */
int BgL_arg1744z00_2474;
BgL_arg1744z00_2474 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 856 */
long BgL_res2458z00_2484;
{ /* Llib/ssl.scm 856 */
long BgL_tmpz00_9304;
BgL_tmpz00_9304 = 
(long)(BgL_arg1744z00_2474); 
BgL_res2458z00_2484 = 
(BgL_offsetz00_2472/BgL_tmpz00_9304); } 
BgL_modz00_2473 = BgL_res2458z00_2484; } } 
{ /* Llib/ssl.scm 856 */
long BgL_restz00_2475;
{ /* Llib/ssl.scm 856 */
int BgL_arg1743z00_2476;
BgL_arg1743z00_2476 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 856 */
long BgL_res2465z00_2504;
{ /* Llib/ssl.scm 856 */
long BgL_n1z00_2486;long BgL_n2z00_2487;
BgL_n1z00_2486 = BgL_offsetz00_2472; 
BgL_n2z00_2487 = 
(long)(BgL_arg1743z00_2476); 
{ /* Llib/ssl.scm 856 */
bool_t BgL_testz00_9309;
{ /* Llib/ssl.scm 856 */
long BgL_arg1283z00_2489;
BgL_arg1283z00_2489 = 
(((BgL_n1z00_2486) | (BgL_n2z00_2487)) & -2147483648); 
BgL_testz00_9309 = 
(BgL_arg1283z00_2489==((long)0)); } 
if(BgL_testz00_9309)
{ /* Llib/ssl.scm 856 */
int32_t BgL_arg1272z00_2490;
{ /* Llib/ssl.scm 856 */
int32_t BgL_arg1278z00_2491;int32_t BgL_arg1279z00_2492;
{ /* Llib/ssl.scm 856 */
int32_t BgL_res2461z00_2496;
BgL_res2461z00_2496 = 
(int32_t)(BgL_n1z00_2486); 
BgL_arg1278z00_2491 = BgL_res2461z00_2496; } 
{ /* Llib/ssl.scm 856 */
int32_t BgL_res2462z00_2498;
BgL_res2462z00_2498 = 
(int32_t)(BgL_n2z00_2487); 
BgL_arg1279z00_2492 = BgL_res2462z00_2498; } 
BgL_arg1272z00_2490 = 
(BgL_arg1278z00_2491%BgL_arg1279z00_2492); } 
{ /* Llib/ssl.scm 856 */
long BgL_res2464z00_2503;
{ /* Llib/ssl.scm 856 */
long BgL_arg1409z00_2500;
BgL_arg1409z00_2500 = 
(long)(BgL_arg1272z00_2490); 
{ /* Llib/ssl.scm 856 */
long BgL_res2463z00_2502;
BgL_res2463z00_2502 = 
(long)(BgL_arg1409z00_2500); 
BgL_res2464z00_2503 = BgL_res2463z00_2502; } } 
BgL_res2465z00_2504 = BgL_res2464z00_2503; } }  else 
{ /* Llib/ssl.scm 856 */
BgL_res2465z00_2504 = 
(BgL_n1z00_2486%BgL_n2z00_2487); } } } 
BgL_restz00_2475 = BgL_res2465z00_2504; } } 
{ /* Llib/ssl.scm 856 */

{ /* Llib/ssl.scm 856 */
obj_t BgL_bucketz00_2477;
BgL_bucketz00_2477 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_2467),BgL_modz00_2473); 
BgL_res2466z00_2509 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2477),BgL_restz00_2475); } } } } } } } } 
BgL_method1259z00_1716 = BgL_res2466z00_2509; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1259z00_1716)(BgL_method1259z00_1716, 
((obj_t)BgL_scz00_64), BgL_sicz00_65, 
BINT(BgL_offsetz00_66), 
BINT(BgL_lenz00_67), BEOA));} } 
BGL_FUNCTION_END;
}



/* &secure-context-set-session-id-context! */
obj_t BGl_z62securezd2contextzd2setzd2sessionzd2idzd2contextz12za2zz__ssl_sslz00(obj_t BgL_envz00_5428, obj_t BgL_scz00_5429, obj_t BgL_sicz00_5430, obj_t BgL_offsetz00_5431, obj_t BgL_lenz00_5432)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 856 */
{ /* Llib/ssl.scm 856 */
bool_t BgL_tmpz00_9333;
{ /* Llib/ssl.scm 856 */
long BgL_auxz00_9358;long BgL_auxz00_9349;obj_t BgL_auxz00_9342;BgL_securezd2contextzd2_bglt BgL_auxz00_9334;
{ /* Llib/ssl.scm 856 */
obj_t BgL_tmpz00_9359;
if(
INTEGERP(BgL_lenz00_5432))
{ /* Llib/ssl.scm 856 */
BgL_tmpz00_9359 = BgL_lenz00_5432
; }  else 
{ 
obj_t BgL_auxz00_9362;
BgL_auxz00_9362 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)35041)), BGl_string3745z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_lenz00_5432); 
FAILURE(BgL_auxz00_9362,BFALSE,BFALSE);} 
BgL_auxz00_9358 = 
(long)CINT(BgL_tmpz00_9359); } 
{ /* Llib/ssl.scm 856 */
obj_t BgL_tmpz00_9350;
if(
INTEGERP(BgL_offsetz00_5431))
{ /* Llib/ssl.scm 856 */
BgL_tmpz00_9350 = BgL_offsetz00_5431
; }  else 
{ 
obj_t BgL_auxz00_9353;
BgL_auxz00_9353 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)35041)), BGl_string3745z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_offsetz00_5431); 
FAILURE(BgL_auxz00_9353,BFALSE,BFALSE);} 
BgL_auxz00_9349 = 
(long)CINT(BgL_tmpz00_9350); } 
if(
STRINGP(BgL_sicz00_5430))
{ /* Llib/ssl.scm 856 */
BgL_auxz00_9342 = BgL_sicz00_5430
; }  else 
{ 
obj_t BgL_auxz00_9345;
BgL_auxz00_9345 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)35041)), BGl_string3745z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_sicz00_5430); 
FAILURE(BgL_auxz00_9345,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_scz00_5429, BGl_securezd2contextzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 856 */
BgL_auxz00_9334 = 
((BgL_securezd2contextzd2_bglt)BgL_scz00_5429)
; }  else 
{ 
obj_t BgL_auxz00_9338;
BgL_auxz00_9338 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)35041)), BGl_string3745z00zz__ssl_sslz00, BGl_string3438z00zz__ssl_sslz00, BgL_scz00_5429); 
FAILURE(BgL_auxz00_9338,BFALSE,BFALSE);} 
BgL_tmpz00_9333 = 
BGl_securezd2contextzd2setzd2sessionzd2idzd2contextz12zc0zz__ssl_sslz00(BgL_auxz00_9334, BgL_auxz00_9342, BgL_auxz00_9349, BgL_auxz00_9358); } 
return 
BBOOL(BgL_tmpz00_9333);} } 
BGL_FUNCTION_END;
}



/* secure-context-load-pkcs12 */
BGL_EXPORTED_DEF bool_t BGl_securezd2contextzd2loadzd2pkcs12zd2zz__ssl_sslz00(BgL_securezd2contextzd2_bglt BgL_scz00_68, obj_t BgL_pfxz00_69, obj_t BgL_passz00_70)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 866 */
{ /* Llib/ssl.scm 866 */
obj_t BgL_method1261z00_1717;
{ /* Llib/ssl.scm 866 */
obj_t BgL_res2478z00_2554;
{ /* Llib/ssl.scm 866 */
long BgL_objzd2classzd2numz00_2511;
{ /* Llib/ssl.scm 866 */
long BgL_res2467z00_2514;
BgL_res2467z00_2514 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_scz00_68)); 
BgL_objzd2classzd2numz00_2511 = BgL_res2467z00_2514; } 
{ /* Llib/ssl.scm 866 */
obj_t BgL_arg1742z00_2512;
BgL_arg1742z00_2512 = 
PROCEDURE_REF(BGl_securezd2contextzd2loadzd2pkcs12zd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 866 */
int BgL_offsetz00_2516;
BgL_offsetz00_2516 = 
(int)(BgL_objzd2classzd2numz00_2511); 
{ /* Llib/ssl.scm 866 */
long BgL_offsetz00_2517;
BgL_offsetz00_2517 = 
(
(long)(BgL_offsetz00_2516)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 866 */
long BgL_modz00_2518;
{ /* Llib/ssl.scm 866 */
int BgL_arg1744z00_2519;
BgL_arg1744z00_2519 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 866 */
long BgL_res2470z00_2529;
{ /* Llib/ssl.scm 866 */
long BgL_tmpz00_9377;
BgL_tmpz00_9377 = 
(long)(BgL_arg1744z00_2519); 
BgL_res2470z00_2529 = 
(BgL_offsetz00_2517/BgL_tmpz00_9377); } 
BgL_modz00_2518 = BgL_res2470z00_2529; } } 
{ /* Llib/ssl.scm 866 */
long BgL_restz00_2520;
{ /* Llib/ssl.scm 866 */
int BgL_arg1743z00_2521;
BgL_arg1743z00_2521 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 866 */
long BgL_res2477z00_2549;
{ /* Llib/ssl.scm 866 */
long BgL_n1z00_2531;long BgL_n2z00_2532;
BgL_n1z00_2531 = BgL_offsetz00_2517; 
BgL_n2z00_2532 = 
(long)(BgL_arg1743z00_2521); 
{ /* Llib/ssl.scm 866 */
bool_t BgL_testz00_9382;
{ /* Llib/ssl.scm 866 */
long BgL_arg1283z00_2534;
BgL_arg1283z00_2534 = 
(((BgL_n1z00_2531) | (BgL_n2z00_2532)) & -2147483648); 
BgL_testz00_9382 = 
(BgL_arg1283z00_2534==((long)0)); } 
if(BgL_testz00_9382)
{ /* Llib/ssl.scm 866 */
int32_t BgL_arg1272z00_2535;
{ /* Llib/ssl.scm 866 */
int32_t BgL_arg1278z00_2536;int32_t BgL_arg1279z00_2537;
{ /* Llib/ssl.scm 866 */
int32_t BgL_res2473z00_2541;
BgL_res2473z00_2541 = 
(int32_t)(BgL_n1z00_2531); 
BgL_arg1278z00_2536 = BgL_res2473z00_2541; } 
{ /* Llib/ssl.scm 866 */
int32_t BgL_res2474z00_2543;
BgL_res2474z00_2543 = 
(int32_t)(BgL_n2z00_2532); 
BgL_arg1279z00_2537 = BgL_res2474z00_2543; } 
BgL_arg1272z00_2535 = 
(BgL_arg1278z00_2536%BgL_arg1279z00_2537); } 
{ /* Llib/ssl.scm 866 */
long BgL_res2476z00_2548;
{ /* Llib/ssl.scm 866 */
long BgL_arg1409z00_2545;
BgL_arg1409z00_2545 = 
(long)(BgL_arg1272z00_2535); 
{ /* Llib/ssl.scm 866 */
long BgL_res2475z00_2547;
BgL_res2475z00_2547 = 
(long)(BgL_arg1409z00_2545); 
BgL_res2476z00_2548 = BgL_res2475z00_2547; } } 
BgL_res2477z00_2549 = BgL_res2476z00_2548; } }  else 
{ /* Llib/ssl.scm 866 */
BgL_res2477z00_2549 = 
(BgL_n1z00_2531%BgL_n2z00_2532); } } } 
BgL_restz00_2520 = BgL_res2477z00_2549; } } 
{ /* Llib/ssl.scm 866 */

{ /* Llib/ssl.scm 866 */
obj_t BgL_bucketz00_2522;
BgL_bucketz00_2522 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_2512),BgL_modz00_2518); 
BgL_res2478z00_2554 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2522),BgL_restz00_2520); } } } } } } } } 
BgL_method1261z00_1717 = BgL_res2478z00_2554; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1261z00_1717)(BgL_method1261z00_1717, 
((obj_t)BgL_scz00_68), BgL_pfxz00_69, BgL_passz00_70, BEOA));} } 
BGL_FUNCTION_END;
}



/* &secure-context-load-pkcs12 */
obj_t BGl_z62securezd2contextzd2loadzd2pkcs12zb0zz__ssl_sslz00(obj_t BgL_envz00_5433, obj_t BgL_scz00_5434, obj_t BgL_pfxz00_5435, obj_t BgL_passz00_5436)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 866 */
{ /* Llib/ssl.scm 866 */
bool_t BgL_tmpz00_9403;
{ /* Llib/ssl.scm 866 */
obj_t BgL_auxz00_9412;BgL_securezd2contextzd2_bglt BgL_auxz00_9404;
if(
STRINGP(BgL_pfxz00_5435))
{ /* Llib/ssl.scm 866 */
BgL_auxz00_9412 = BgL_pfxz00_5435
; }  else 
{ 
obj_t BgL_auxz00_9415;
BgL_auxz00_9415 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)35484)), BGl_string3746z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_pfxz00_5435); 
FAILURE(BgL_auxz00_9415,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_scz00_5434, BGl_securezd2contextzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 866 */
BgL_auxz00_9404 = 
((BgL_securezd2contextzd2_bglt)BgL_scz00_5434)
; }  else 
{ 
obj_t BgL_auxz00_9408;
BgL_auxz00_9408 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)35484)), BGl_string3746z00zz__ssl_sslz00, BGl_string3438z00zz__ssl_sslz00, BgL_scz00_5434); 
FAILURE(BgL_auxz00_9408,BFALSE,BFALSE);} 
BgL_tmpz00_9403 = 
BGl_securezd2contextzd2loadzd2pkcs12zd2zz__ssl_sslz00(BgL_auxz00_9404, BgL_auxz00_9412, BgL_passz00_5436); } 
return 
BBOOL(BgL_tmpz00_9403);} } 
BGL_FUNCTION_END;
}



/* secure-context-set-ciphers! */
BGL_EXPORTED_DEF bool_t BGl_securezd2contextzd2setzd2ciphersz12zc0zz__ssl_sslz00(BgL_securezd2contextzd2_bglt BgL_scz00_71, obj_t BgL_ciphersz00_72)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 876 */
{ /* Llib/ssl.scm 876 */
obj_t BgL_method1263z00_1718;
{ /* Llib/ssl.scm 876 */
obj_t BgL_res2490z00_2599;
{ /* Llib/ssl.scm 876 */
long BgL_objzd2classzd2numz00_2556;
{ /* Llib/ssl.scm 876 */
long BgL_res2479z00_2559;
BgL_res2479z00_2559 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_scz00_71)); 
BgL_objzd2classzd2numz00_2556 = BgL_res2479z00_2559; } 
{ /* Llib/ssl.scm 876 */
obj_t BgL_arg1742z00_2557;
BgL_arg1742z00_2557 = 
PROCEDURE_REF(BGl_securezd2contextzd2setzd2ciphersz12zd2envz12zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 876 */
int BgL_offsetz00_2561;
BgL_offsetz00_2561 = 
(int)(BgL_objzd2classzd2numz00_2556); 
{ /* Llib/ssl.scm 876 */
long BgL_offsetz00_2562;
BgL_offsetz00_2562 = 
(
(long)(BgL_offsetz00_2561)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 876 */
long BgL_modz00_2563;
{ /* Llib/ssl.scm 876 */
int BgL_arg1744z00_2564;
BgL_arg1744z00_2564 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 876 */
long BgL_res2482z00_2574;
{ /* Llib/ssl.scm 876 */
long BgL_tmpz00_9429;
BgL_tmpz00_9429 = 
(long)(BgL_arg1744z00_2564); 
BgL_res2482z00_2574 = 
(BgL_offsetz00_2562/BgL_tmpz00_9429); } 
BgL_modz00_2563 = BgL_res2482z00_2574; } } 
{ /* Llib/ssl.scm 876 */
long BgL_restz00_2565;
{ /* Llib/ssl.scm 876 */
int BgL_arg1743z00_2566;
BgL_arg1743z00_2566 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 876 */
long BgL_res2489z00_2594;
{ /* Llib/ssl.scm 876 */
long BgL_n1z00_2576;long BgL_n2z00_2577;
BgL_n1z00_2576 = BgL_offsetz00_2562; 
BgL_n2z00_2577 = 
(long)(BgL_arg1743z00_2566); 
{ /* Llib/ssl.scm 876 */
bool_t BgL_testz00_9434;
{ /* Llib/ssl.scm 876 */
long BgL_arg1283z00_2579;
BgL_arg1283z00_2579 = 
(((BgL_n1z00_2576) | (BgL_n2z00_2577)) & -2147483648); 
BgL_testz00_9434 = 
(BgL_arg1283z00_2579==((long)0)); } 
if(BgL_testz00_9434)
{ /* Llib/ssl.scm 876 */
int32_t BgL_arg1272z00_2580;
{ /* Llib/ssl.scm 876 */
int32_t BgL_arg1278z00_2581;int32_t BgL_arg1279z00_2582;
{ /* Llib/ssl.scm 876 */
int32_t BgL_res2485z00_2586;
BgL_res2485z00_2586 = 
(int32_t)(BgL_n1z00_2576); 
BgL_arg1278z00_2581 = BgL_res2485z00_2586; } 
{ /* Llib/ssl.scm 876 */
int32_t BgL_res2486z00_2588;
BgL_res2486z00_2588 = 
(int32_t)(BgL_n2z00_2577); 
BgL_arg1279z00_2582 = BgL_res2486z00_2588; } 
BgL_arg1272z00_2580 = 
(BgL_arg1278z00_2581%BgL_arg1279z00_2582); } 
{ /* Llib/ssl.scm 876 */
long BgL_res2488z00_2593;
{ /* Llib/ssl.scm 876 */
long BgL_arg1409z00_2590;
BgL_arg1409z00_2590 = 
(long)(BgL_arg1272z00_2580); 
{ /* Llib/ssl.scm 876 */
long BgL_res2487z00_2592;
BgL_res2487z00_2592 = 
(long)(BgL_arg1409z00_2590); 
BgL_res2488z00_2593 = BgL_res2487z00_2592; } } 
BgL_res2489z00_2594 = BgL_res2488z00_2593; } }  else 
{ /* Llib/ssl.scm 876 */
BgL_res2489z00_2594 = 
(BgL_n1z00_2576%BgL_n2z00_2577); } } } 
BgL_restz00_2565 = BgL_res2489z00_2594; } } 
{ /* Llib/ssl.scm 876 */

{ /* Llib/ssl.scm 876 */
obj_t BgL_bucketz00_2567;
BgL_bucketz00_2567 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_2557),BgL_modz00_2563); 
BgL_res2490z00_2599 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2567),BgL_restz00_2565); } } } } } } } } 
BgL_method1263z00_1718 = BgL_res2490z00_2599; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1263z00_1718)(BgL_method1263z00_1718, 
((obj_t)BgL_scz00_71), BgL_ciphersz00_72, BEOA));} } 
BGL_FUNCTION_END;
}



/* &secure-context-set-ciphers! */
obj_t BGl_z62securezd2contextzd2setzd2ciphersz12za2zz__ssl_sslz00(obj_t BgL_envz00_5437, obj_t BgL_scz00_5438, obj_t BgL_ciphersz00_5439)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 876 */
{ /* Llib/ssl.scm 876 */
bool_t BgL_tmpz00_9454;
{ /* Llib/ssl.scm 876 */
obj_t BgL_auxz00_9463;BgL_securezd2contextzd2_bglt BgL_auxz00_9455;
if(
STRINGP(BgL_ciphersz00_5439))
{ /* Llib/ssl.scm 876 */
BgL_auxz00_9463 = BgL_ciphersz00_5439
; }  else 
{ 
obj_t BgL_auxz00_9466;
BgL_auxz00_9466 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)35891)), BGl_string3747z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_ciphersz00_5439); 
FAILURE(BgL_auxz00_9466,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_scz00_5438, BGl_securezd2contextzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 876 */
BgL_auxz00_9455 = 
((BgL_securezd2contextzd2_bglt)BgL_scz00_5438)
; }  else 
{ 
obj_t BgL_auxz00_9459;
BgL_auxz00_9459 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)35891)), BGl_string3747z00zz__ssl_sslz00, BGl_string3438z00zz__ssl_sslz00, BgL_scz00_5438); 
FAILURE(BgL_auxz00_9459,BFALSE,BFALSE);} 
BgL_tmpz00_9454 = 
BGl_securezd2contextzd2setzd2ciphersz12zc0zz__ssl_sslz00(BgL_auxz00_9455, BgL_auxz00_9463); } 
return 
BBOOL(BgL_tmpz00_9454);} } 
BGL_FUNCTION_END;
}



/* secure-context-set-options! */
BGL_EXPORTED_DEF bool_t BGl_securezd2contextzd2setzd2optionsz12zc0zz__ssl_sslz00(BgL_securezd2contextzd2_bglt BgL_scz00_73, int BgL_optionsz00_74)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 888 */
{ /* Llib/ssl.scm 888 */
obj_t BgL_method1265z00_1719;
{ /* Llib/ssl.scm 888 */
obj_t BgL_res2502z00_2644;
{ /* Llib/ssl.scm 888 */
long BgL_objzd2classzd2numz00_2601;
{ /* Llib/ssl.scm 888 */
long BgL_res2491z00_2604;
BgL_res2491z00_2604 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_scz00_73)); 
BgL_objzd2classzd2numz00_2601 = BgL_res2491z00_2604; } 
{ /* Llib/ssl.scm 888 */
obj_t BgL_arg1742z00_2602;
BgL_arg1742z00_2602 = 
PROCEDURE_REF(BGl_securezd2contextzd2setzd2optionsz12zd2envz12zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 888 */
int BgL_offsetz00_2606;
BgL_offsetz00_2606 = 
(int)(BgL_objzd2classzd2numz00_2601); 
{ /* Llib/ssl.scm 888 */
long BgL_offsetz00_2607;
BgL_offsetz00_2607 = 
(
(long)(BgL_offsetz00_2606)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 888 */
long BgL_modz00_2608;
{ /* Llib/ssl.scm 888 */
int BgL_arg1744z00_2609;
BgL_arg1744z00_2609 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 888 */
long BgL_res2494z00_2619;
{ /* Llib/ssl.scm 888 */
long BgL_tmpz00_9480;
BgL_tmpz00_9480 = 
(long)(BgL_arg1744z00_2609); 
BgL_res2494z00_2619 = 
(BgL_offsetz00_2607/BgL_tmpz00_9480); } 
BgL_modz00_2608 = BgL_res2494z00_2619; } } 
{ /* Llib/ssl.scm 888 */
long BgL_restz00_2610;
{ /* Llib/ssl.scm 888 */
int BgL_arg1743z00_2611;
BgL_arg1743z00_2611 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 888 */
long BgL_res2501z00_2639;
{ /* Llib/ssl.scm 888 */
long BgL_n1z00_2621;long BgL_n2z00_2622;
BgL_n1z00_2621 = BgL_offsetz00_2607; 
BgL_n2z00_2622 = 
(long)(BgL_arg1743z00_2611); 
{ /* Llib/ssl.scm 888 */
bool_t BgL_testz00_9485;
{ /* Llib/ssl.scm 888 */
long BgL_arg1283z00_2624;
BgL_arg1283z00_2624 = 
(((BgL_n1z00_2621) | (BgL_n2z00_2622)) & -2147483648); 
BgL_testz00_9485 = 
(BgL_arg1283z00_2624==((long)0)); } 
if(BgL_testz00_9485)
{ /* Llib/ssl.scm 888 */
int32_t BgL_arg1272z00_2625;
{ /* Llib/ssl.scm 888 */
int32_t BgL_arg1278z00_2626;int32_t BgL_arg1279z00_2627;
{ /* Llib/ssl.scm 888 */
int32_t BgL_res2497z00_2631;
BgL_res2497z00_2631 = 
(int32_t)(BgL_n1z00_2621); 
BgL_arg1278z00_2626 = BgL_res2497z00_2631; } 
{ /* Llib/ssl.scm 888 */
int32_t BgL_res2498z00_2633;
BgL_res2498z00_2633 = 
(int32_t)(BgL_n2z00_2622); 
BgL_arg1279z00_2627 = BgL_res2498z00_2633; } 
BgL_arg1272z00_2625 = 
(BgL_arg1278z00_2626%BgL_arg1279z00_2627); } 
{ /* Llib/ssl.scm 888 */
long BgL_res2500z00_2638;
{ /* Llib/ssl.scm 888 */
long BgL_arg1409z00_2635;
BgL_arg1409z00_2635 = 
(long)(BgL_arg1272z00_2625); 
{ /* Llib/ssl.scm 888 */
long BgL_res2499z00_2637;
BgL_res2499z00_2637 = 
(long)(BgL_arg1409z00_2635); 
BgL_res2500z00_2638 = BgL_res2499z00_2637; } } 
BgL_res2501z00_2639 = BgL_res2500z00_2638; } }  else 
{ /* Llib/ssl.scm 888 */
BgL_res2501z00_2639 = 
(BgL_n1z00_2621%BgL_n2z00_2622); } } } 
BgL_restz00_2610 = BgL_res2501z00_2639; } } 
{ /* Llib/ssl.scm 888 */

{ /* Llib/ssl.scm 888 */
obj_t BgL_bucketz00_2612;
BgL_bucketz00_2612 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_2602),BgL_modz00_2608); 
BgL_res2502z00_2644 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2612),BgL_restz00_2610); } } } } } } } } 
BgL_method1265z00_1719 = BgL_res2502z00_2644; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1265z00_1719)(BgL_method1265z00_1719, 
((obj_t)BgL_scz00_73), 
BINT(BgL_optionsz00_74), BEOA));} } 
BGL_FUNCTION_END;
}



/* &secure-context-set-options! */
obj_t BGl_z62securezd2contextzd2setzd2optionsz12za2zz__ssl_sslz00(obj_t BgL_envz00_5440, obj_t BgL_scz00_5441, obj_t BgL_optionsz00_5442)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 888 */
{ /* Llib/ssl.scm 888 */
bool_t BgL_tmpz00_9506;
{ /* Llib/ssl.scm 888 */
int BgL_auxz00_9515;BgL_securezd2contextzd2_bglt BgL_auxz00_9507;
{ /* Llib/ssl.scm 888 */
obj_t BgL_tmpz00_9516;
if(
INTEGERP(BgL_optionsz00_5442))
{ /* Llib/ssl.scm 888 */
BgL_tmpz00_9516 = BgL_optionsz00_5442
; }  else 
{ 
obj_t BgL_auxz00_9519;
BgL_auxz00_9519 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)36351)), BGl_string3748z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_optionsz00_5442); 
FAILURE(BgL_auxz00_9519,BFALSE,BFALSE);} 
BgL_auxz00_9515 = 
CINT(BgL_tmpz00_9516); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_scz00_5441, BGl_securezd2contextzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 888 */
BgL_auxz00_9507 = 
((BgL_securezd2contextzd2_bglt)BgL_scz00_5441)
; }  else 
{ 
obj_t BgL_auxz00_9511;
BgL_auxz00_9511 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)36351)), BGl_string3748z00zz__ssl_sslz00, BGl_string3438z00zz__ssl_sslz00, BgL_scz00_5441); 
FAILURE(BgL_auxz00_9511,BFALSE,BFALSE);} 
BgL_tmpz00_9506 = 
BGl_securezd2contextzd2setzd2optionsz12zc0zz__ssl_sslz00(BgL_auxz00_9507, BgL_auxz00_9515); } 
return 
BBOOL(BgL_tmpz00_9506);} } 
BGL_FUNCTION_END;
}



/* ssl-connection-init */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2initz00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_75)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 900 */
{ /* Llib/ssl.scm 900 */
obj_t BgL_method1267z00_1720;
{ /* Llib/ssl.scm 900 */
obj_t BgL_res2514z00_2689;
{ /* Llib/ssl.scm 900 */
long BgL_objzd2classzd2numz00_2646;
{ /* Llib/ssl.scm 900 */
long BgL_res2503z00_2649;
BgL_res2503z00_2649 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_75)); 
BgL_objzd2classzd2numz00_2646 = BgL_res2503z00_2649; } 
{ /* Llib/ssl.scm 900 */
obj_t BgL_arg1742z00_2647;
BgL_arg1742z00_2647 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2initzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 900 */
int BgL_offsetz00_2651;
BgL_offsetz00_2651 = 
(int)(BgL_objzd2classzd2numz00_2646); 
{ /* Llib/ssl.scm 900 */
long BgL_offsetz00_2652;
BgL_offsetz00_2652 = 
(
(long)(BgL_offsetz00_2651)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 900 */
long BgL_modz00_2653;
{ /* Llib/ssl.scm 900 */
int BgL_arg1744z00_2654;
BgL_arg1744z00_2654 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 900 */
long BgL_res2506z00_2664;
{ /* Llib/ssl.scm 900 */
long BgL_tmpz00_9534;
BgL_tmpz00_9534 = 
(long)(BgL_arg1744z00_2654); 
BgL_res2506z00_2664 = 
(BgL_offsetz00_2652/BgL_tmpz00_9534); } 
BgL_modz00_2653 = BgL_res2506z00_2664; } } 
{ /* Llib/ssl.scm 900 */
long BgL_restz00_2655;
{ /* Llib/ssl.scm 900 */
int BgL_arg1743z00_2656;
BgL_arg1743z00_2656 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 900 */
long BgL_res2513z00_2684;
{ /* Llib/ssl.scm 900 */
long BgL_n1z00_2666;long BgL_n2z00_2667;
BgL_n1z00_2666 = BgL_offsetz00_2652; 
BgL_n2z00_2667 = 
(long)(BgL_arg1743z00_2656); 
{ /* Llib/ssl.scm 900 */
bool_t BgL_testz00_9539;
{ /* Llib/ssl.scm 900 */
long BgL_arg1283z00_2669;
BgL_arg1283z00_2669 = 
(((BgL_n1z00_2666) | (BgL_n2z00_2667)) & -2147483648); 
BgL_testz00_9539 = 
(BgL_arg1283z00_2669==((long)0)); } 
if(BgL_testz00_9539)
{ /* Llib/ssl.scm 900 */
int32_t BgL_arg1272z00_2670;
{ /* Llib/ssl.scm 900 */
int32_t BgL_arg1278z00_2671;int32_t BgL_arg1279z00_2672;
{ /* Llib/ssl.scm 900 */
int32_t BgL_res2509z00_2676;
BgL_res2509z00_2676 = 
(int32_t)(BgL_n1z00_2666); 
BgL_arg1278z00_2671 = BgL_res2509z00_2676; } 
{ /* Llib/ssl.scm 900 */
int32_t BgL_res2510z00_2678;
BgL_res2510z00_2678 = 
(int32_t)(BgL_n2z00_2667); 
BgL_arg1279z00_2672 = BgL_res2510z00_2678; } 
BgL_arg1272z00_2670 = 
(BgL_arg1278z00_2671%BgL_arg1279z00_2672); } 
{ /* Llib/ssl.scm 900 */
long BgL_res2512z00_2683;
{ /* Llib/ssl.scm 900 */
long BgL_arg1409z00_2680;
BgL_arg1409z00_2680 = 
(long)(BgL_arg1272z00_2670); 
{ /* Llib/ssl.scm 900 */
long BgL_res2511z00_2682;
BgL_res2511z00_2682 = 
(long)(BgL_arg1409z00_2680); 
BgL_res2512z00_2683 = BgL_res2511z00_2682; } } 
BgL_res2513z00_2684 = BgL_res2512z00_2683; } }  else 
{ /* Llib/ssl.scm 900 */
BgL_res2513z00_2684 = 
(BgL_n1z00_2666%BgL_n2z00_2667); } } } 
BgL_restz00_2655 = BgL_res2513z00_2684; } } 
{ /* Llib/ssl.scm 900 */

{ /* Llib/ssl.scm 900 */
obj_t BgL_bucketz00_2657;
BgL_bucketz00_2657 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_2647),BgL_modz00_2653); 
BgL_res2514z00_2689 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2657),BgL_restz00_2655); } } } } } } } } 
BgL_method1267z00_1720 = BgL_res2514z00_2689; } 
return 
PROCEDURE_ENTRY(BgL_method1267z00_1720)(BgL_method1267z00_1720, 
((obj_t)BgL_sslz00_75), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-connection-init */
obj_t BGl_z62sslzd2connectionzd2initz62zz__ssl_sslz00(obj_t BgL_envz00_5161, obj_t BgL_sslz00_5162)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 900 */
{ /* Llib/ssl.scm 900 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_9557;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5162, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 900 */
BgL_auxz00_9557 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5162)
; }  else 
{ 
obj_t BgL_auxz00_9561;
BgL_auxz00_9561 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)36807)), BGl_string3749z00zz__ssl_sslz00, BGl_string3750z00zz__ssl_sslz00, BgL_sslz00_5162); 
FAILURE(BgL_auxz00_9561,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2initz00zz__ssl_sslz00(BgL_auxz00_9557);} } 
BGL_FUNCTION_END;
}



/* ssl-connection-start */
BGL_EXPORTED_DEF int BGl_sslzd2connectionzd2startz00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_76)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 910 */
{ /* Llib/ssl.scm 910 */
obj_t BgL_method1269z00_1721;
{ /* Llib/ssl.scm 910 */
obj_t BgL_res2526z00_2734;
{ /* Llib/ssl.scm 910 */
long BgL_objzd2classzd2numz00_2691;
{ /* Llib/ssl.scm 910 */
long BgL_res2515z00_2694;
BgL_res2515z00_2694 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_76)); 
BgL_objzd2classzd2numz00_2691 = BgL_res2515z00_2694; } 
{ /* Llib/ssl.scm 910 */
obj_t BgL_arg1742z00_2692;
BgL_arg1742z00_2692 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2startzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 910 */
int BgL_offsetz00_2696;
BgL_offsetz00_2696 = 
(int)(BgL_objzd2classzd2numz00_2691); 
{ /* Llib/ssl.scm 910 */
long BgL_offsetz00_2697;
BgL_offsetz00_2697 = 
(
(long)(BgL_offsetz00_2696)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 910 */
long BgL_modz00_2698;
{ /* Llib/ssl.scm 910 */
int BgL_arg1744z00_2699;
BgL_arg1744z00_2699 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 910 */
long BgL_res2518z00_2709;
{ /* Llib/ssl.scm 910 */
long BgL_tmpz00_9574;
BgL_tmpz00_9574 = 
(long)(BgL_arg1744z00_2699); 
BgL_res2518z00_2709 = 
(BgL_offsetz00_2697/BgL_tmpz00_9574); } 
BgL_modz00_2698 = BgL_res2518z00_2709; } } 
{ /* Llib/ssl.scm 910 */
long BgL_restz00_2700;
{ /* Llib/ssl.scm 910 */
int BgL_arg1743z00_2701;
BgL_arg1743z00_2701 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 910 */
long BgL_res2525z00_2729;
{ /* Llib/ssl.scm 910 */
long BgL_n1z00_2711;long BgL_n2z00_2712;
BgL_n1z00_2711 = BgL_offsetz00_2697; 
BgL_n2z00_2712 = 
(long)(BgL_arg1743z00_2701); 
{ /* Llib/ssl.scm 910 */
bool_t BgL_testz00_9579;
{ /* Llib/ssl.scm 910 */
long BgL_arg1283z00_2714;
BgL_arg1283z00_2714 = 
(((BgL_n1z00_2711) | (BgL_n2z00_2712)) & -2147483648); 
BgL_testz00_9579 = 
(BgL_arg1283z00_2714==((long)0)); } 
if(BgL_testz00_9579)
{ /* Llib/ssl.scm 910 */
int32_t BgL_arg1272z00_2715;
{ /* Llib/ssl.scm 910 */
int32_t BgL_arg1278z00_2716;int32_t BgL_arg1279z00_2717;
{ /* Llib/ssl.scm 910 */
int32_t BgL_res2521z00_2721;
BgL_res2521z00_2721 = 
(int32_t)(BgL_n1z00_2711); 
BgL_arg1278z00_2716 = BgL_res2521z00_2721; } 
{ /* Llib/ssl.scm 910 */
int32_t BgL_res2522z00_2723;
BgL_res2522z00_2723 = 
(int32_t)(BgL_n2z00_2712); 
BgL_arg1279z00_2717 = BgL_res2522z00_2723; } 
BgL_arg1272z00_2715 = 
(BgL_arg1278z00_2716%BgL_arg1279z00_2717); } 
{ /* Llib/ssl.scm 910 */
long BgL_res2524z00_2728;
{ /* Llib/ssl.scm 910 */
long BgL_arg1409z00_2725;
BgL_arg1409z00_2725 = 
(long)(BgL_arg1272z00_2715); 
{ /* Llib/ssl.scm 910 */
long BgL_res2523z00_2727;
BgL_res2523z00_2727 = 
(long)(BgL_arg1409z00_2725); 
BgL_res2524z00_2728 = BgL_res2523z00_2727; } } 
BgL_res2525z00_2729 = BgL_res2524z00_2728; } }  else 
{ /* Llib/ssl.scm 910 */
BgL_res2525z00_2729 = 
(BgL_n1z00_2711%BgL_n2z00_2712); } } } 
BgL_restz00_2700 = BgL_res2525z00_2729; } } 
{ /* Llib/ssl.scm 910 */

{ /* Llib/ssl.scm 910 */
obj_t BgL_bucketz00_2702;
BgL_bucketz00_2702 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_2692),BgL_modz00_2698); 
BgL_res2526z00_2734 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2702),BgL_restz00_2700); } } } } } } } } 
BgL_method1269z00_1721 = BgL_res2526z00_2734; } 
return 
CINT(
PROCEDURE_ENTRY(BgL_method1269z00_1721)(BgL_method1269z00_1721, 
((obj_t)BgL_sslz00_76), BEOA));} } 
BGL_FUNCTION_END;
}



/* &ssl-connection-start */
obj_t BGl_z62sslzd2connectionzd2startz62zz__ssl_sslz00(obj_t BgL_envz00_5443, obj_t BgL_sslz00_5444)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 910 */
{ /* Llib/ssl.scm 910 */
int BgL_tmpz00_9598;
{ /* Llib/ssl.scm 910 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_9599;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5444, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 910 */
BgL_auxz00_9599 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5444)
; }  else 
{ 
obj_t BgL_auxz00_9603;
BgL_auxz00_9603 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)37186)), BGl_string3751z00zz__ssl_sslz00, BGl_string3750z00zz__ssl_sslz00, BgL_sslz00_5444); 
FAILURE(BgL_auxz00_9603,BFALSE,BFALSE);} 
BgL_tmpz00_9598 = 
BGl_sslzd2connectionzd2startz00zz__ssl_sslz00(BgL_auxz00_9599); } 
return 
BINT(BgL_tmpz00_9598);} } 
BGL_FUNCTION_END;
}



/* ssl-connection-close */
BGL_EXPORTED_DEF int BGl_sslzd2connectionzd2closez00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_77)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 920 */
{ /* Llib/ssl.scm 920 */
obj_t BgL_method1271z00_1722;
{ /* Llib/ssl.scm 920 */
obj_t BgL_res2538z00_2779;
{ /* Llib/ssl.scm 920 */
long BgL_objzd2classzd2numz00_2736;
{ /* Llib/ssl.scm 920 */
long BgL_res2527z00_2739;
BgL_res2527z00_2739 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_77)); 
BgL_objzd2classzd2numz00_2736 = BgL_res2527z00_2739; } 
{ /* Llib/ssl.scm 920 */
obj_t BgL_arg1742z00_2737;
BgL_arg1742z00_2737 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2closezd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 920 */
int BgL_offsetz00_2741;
BgL_offsetz00_2741 = 
(int)(BgL_objzd2classzd2numz00_2736); 
{ /* Llib/ssl.scm 920 */
long BgL_offsetz00_2742;
BgL_offsetz00_2742 = 
(
(long)(BgL_offsetz00_2741)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 920 */
long BgL_modz00_2743;
{ /* Llib/ssl.scm 920 */
int BgL_arg1744z00_2744;
BgL_arg1744z00_2744 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 920 */
long BgL_res2530z00_2754;
{ /* Llib/ssl.scm 920 */
long BgL_tmpz00_9617;
BgL_tmpz00_9617 = 
(long)(BgL_arg1744z00_2744); 
BgL_res2530z00_2754 = 
(BgL_offsetz00_2742/BgL_tmpz00_9617); } 
BgL_modz00_2743 = BgL_res2530z00_2754; } } 
{ /* Llib/ssl.scm 920 */
long BgL_restz00_2745;
{ /* Llib/ssl.scm 920 */
int BgL_arg1743z00_2746;
BgL_arg1743z00_2746 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 920 */
long BgL_res2537z00_2774;
{ /* Llib/ssl.scm 920 */
long BgL_n1z00_2756;long BgL_n2z00_2757;
BgL_n1z00_2756 = BgL_offsetz00_2742; 
BgL_n2z00_2757 = 
(long)(BgL_arg1743z00_2746); 
{ /* Llib/ssl.scm 920 */
bool_t BgL_testz00_9622;
{ /* Llib/ssl.scm 920 */
long BgL_arg1283z00_2759;
BgL_arg1283z00_2759 = 
(((BgL_n1z00_2756) | (BgL_n2z00_2757)) & -2147483648); 
BgL_testz00_9622 = 
(BgL_arg1283z00_2759==((long)0)); } 
if(BgL_testz00_9622)
{ /* Llib/ssl.scm 920 */
int32_t BgL_arg1272z00_2760;
{ /* Llib/ssl.scm 920 */
int32_t BgL_arg1278z00_2761;int32_t BgL_arg1279z00_2762;
{ /* Llib/ssl.scm 920 */
int32_t BgL_res2533z00_2766;
BgL_res2533z00_2766 = 
(int32_t)(BgL_n1z00_2756); 
BgL_arg1278z00_2761 = BgL_res2533z00_2766; } 
{ /* Llib/ssl.scm 920 */
int32_t BgL_res2534z00_2768;
BgL_res2534z00_2768 = 
(int32_t)(BgL_n2z00_2757); 
BgL_arg1279z00_2762 = BgL_res2534z00_2768; } 
BgL_arg1272z00_2760 = 
(BgL_arg1278z00_2761%BgL_arg1279z00_2762); } 
{ /* Llib/ssl.scm 920 */
long BgL_res2536z00_2773;
{ /* Llib/ssl.scm 920 */
long BgL_arg1409z00_2770;
BgL_arg1409z00_2770 = 
(long)(BgL_arg1272z00_2760); 
{ /* Llib/ssl.scm 920 */
long BgL_res2535z00_2772;
BgL_res2535z00_2772 = 
(long)(BgL_arg1409z00_2770); 
BgL_res2536z00_2773 = BgL_res2535z00_2772; } } 
BgL_res2537z00_2774 = BgL_res2536z00_2773; } }  else 
{ /* Llib/ssl.scm 920 */
BgL_res2537z00_2774 = 
(BgL_n1z00_2756%BgL_n2z00_2757); } } } 
BgL_restz00_2745 = BgL_res2537z00_2774; } } 
{ /* Llib/ssl.scm 920 */

{ /* Llib/ssl.scm 920 */
obj_t BgL_bucketz00_2747;
BgL_bucketz00_2747 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_2737),BgL_modz00_2743); 
BgL_res2538z00_2779 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2747),BgL_restz00_2745); } } } } } } } } 
BgL_method1271z00_1722 = BgL_res2538z00_2779; } 
return 
CINT(
PROCEDURE_ENTRY(BgL_method1271z00_1722)(BgL_method1271z00_1722, 
((obj_t)BgL_sslz00_77), BEOA));} } 
BGL_FUNCTION_END;
}



/* &ssl-connection-close */
obj_t BGl_z62sslzd2connectionzd2closez62zz__ssl_sslz00(obj_t BgL_envz00_5445, obj_t BgL_sslz00_5446)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 920 */
{ /* Llib/ssl.scm 920 */
int BgL_tmpz00_9641;
{ /* Llib/ssl.scm 920 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_9642;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5446, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 920 */
BgL_auxz00_9642 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5446)
; }  else 
{ 
obj_t BgL_auxz00_9646;
BgL_auxz00_9646 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)37566)), BGl_string3752z00zz__ssl_sslz00, BGl_string3750z00zz__ssl_sslz00, BgL_sslz00_5446); 
FAILURE(BgL_auxz00_9646,BFALSE,BFALSE);} 
BgL_tmpz00_9641 = 
BGl_sslzd2connectionzd2closez00zz__ssl_sslz00(BgL_auxz00_9642); } 
return 
BINT(BgL_tmpz00_9641);} } 
BGL_FUNCTION_END;
}



/* ssl-connection-shutdown */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2shutdownz00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_78)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 930 */
{ /* Llib/ssl.scm 930 */
obj_t BgL_method1273z00_1723;
{ /* Llib/ssl.scm 930 */
obj_t BgL_res2550z00_2824;
{ /* Llib/ssl.scm 930 */
long BgL_objzd2classzd2numz00_2781;
{ /* Llib/ssl.scm 930 */
long BgL_res2539z00_2784;
BgL_res2539z00_2784 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_78)); 
BgL_objzd2classzd2numz00_2781 = BgL_res2539z00_2784; } 
{ /* Llib/ssl.scm 930 */
obj_t BgL_arg1742z00_2782;
BgL_arg1742z00_2782 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2shutdownzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 930 */
int BgL_offsetz00_2786;
BgL_offsetz00_2786 = 
(int)(BgL_objzd2classzd2numz00_2781); 
{ /* Llib/ssl.scm 930 */
long BgL_offsetz00_2787;
BgL_offsetz00_2787 = 
(
(long)(BgL_offsetz00_2786)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 930 */
long BgL_modz00_2788;
{ /* Llib/ssl.scm 930 */
int BgL_arg1744z00_2789;
BgL_arg1744z00_2789 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 930 */
long BgL_res2542z00_2799;
{ /* Llib/ssl.scm 930 */
long BgL_tmpz00_9660;
BgL_tmpz00_9660 = 
(long)(BgL_arg1744z00_2789); 
BgL_res2542z00_2799 = 
(BgL_offsetz00_2787/BgL_tmpz00_9660); } 
BgL_modz00_2788 = BgL_res2542z00_2799; } } 
{ /* Llib/ssl.scm 930 */
long BgL_restz00_2790;
{ /* Llib/ssl.scm 930 */
int BgL_arg1743z00_2791;
BgL_arg1743z00_2791 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 930 */
long BgL_res2549z00_2819;
{ /* Llib/ssl.scm 930 */
long BgL_n1z00_2801;long BgL_n2z00_2802;
BgL_n1z00_2801 = BgL_offsetz00_2787; 
BgL_n2z00_2802 = 
(long)(BgL_arg1743z00_2791); 
{ /* Llib/ssl.scm 930 */
bool_t BgL_testz00_9665;
{ /* Llib/ssl.scm 930 */
long BgL_arg1283z00_2804;
BgL_arg1283z00_2804 = 
(((BgL_n1z00_2801) | (BgL_n2z00_2802)) & -2147483648); 
BgL_testz00_9665 = 
(BgL_arg1283z00_2804==((long)0)); } 
if(BgL_testz00_9665)
{ /* Llib/ssl.scm 930 */
int32_t BgL_arg1272z00_2805;
{ /* Llib/ssl.scm 930 */
int32_t BgL_arg1278z00_2806;int32_t BgL_arg1279z00_2807;
{ /* Llib/ssl.scm 930 */
int32_t BgL_res2545z00_2811;
BgL_res2545z00_2811 = 
(int32_t)(BgL_n1z00_2801); 
BgL_arg1278z00_2806 = BgL_res2545z00_2811; } 
{ /* Llib/ssl.scm 930 */
int32_t BgL_res2546z00_2813;
BgL_res2546z00_2813 = 
(int32_t)(BgL_n2z00_2802); 
BgL_arg1279z00_2807 = BgL_res2546z00_2813; } 
BgL_arg1272z00_2805 = 
(BgL_arg1278z00_2806%BgL_arg1279z00_2807); } 
{ /* Llib/ssl.scm 930 */
long BgL_res2548z00_2818;
{ /* Llib/ssl.scm 930 */
long BgL_arg1409z00_2815;
BgL_arg1409z00_2815 = 
(long)(BgL_arg1272z00_2805); 
{ /* Llib/ssl.scm 930 */
long BgL_res2547z00_2817;
BgL_res2547z00_2817 = 
(long)(BgL_arg1409z00_2815); 
BgL_res2548z00_2818 = BgL_res2547z00_2817; } } 
BgL_res2549z00_2819 = BgL_res2548z00_2818; } }  else 
{ /* Llib/ssl.scm 930 */
BgL_res2549z00_2819 = 
(BgL_n1z00_2801%BgL_n2z00_2802); } } } 
BgL_restz00_2790 = BgL_res2549z00_2819; } } 
{ /* Llib/ssl.scm 930 */

{ /* Llib/ssl.scm 930 */
obj_t BgL_bucketz00_2792;
BgL_bucketz00_2792 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_2782),BgL_modz00_2788); 
BgL_res2550z00_2824 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2792),BgL_restz00_2790); } } } } } } } } 
BgL_method1273z00_1723 = BgL_res2550z00_2824; } 
return 
PROCEDURE_ENTRY(BgL_method1273z00_1723)(BgL_method1273z00_1723, 
((obj_t)BgL_sslz00_78), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-connection-shutdown */
obj_t BGl_z62sslzd2connectionzd2shutdownz62zz__ssl_sslz00(obj_t BgL_envz00_5447, obj_t BgL_sslz00_5448)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 930 */
{ /* Llib/ssl.scm 930 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_9683;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5448, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 930 */
BgL_auxz00_9683 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5448)
; }  else 
{ 
obj_t BgL_auxz00_9687;
BgL_auxz00_9687 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)37946)), BGl_string3753z00zz__ssl_sslz00, BGl_string3750z00zz__ssl_sslz00, BgL_sslz00_5448); 
FAILURE(BgL_auxz00_9687,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2shutdownz00zz__ssl_sslz00(BgL_auxz00_9683);} } 
BGL_FUNCTION_END;
}



/* ssl-connection-read */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2readz00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_79, obj_t BgL_bufferz00_80, long BgL_offsetz00_81, long BgL_lenz00_82)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 940 */
{ /* Llib/ssl.scm 940 */
obj_t BgL_method1275z00_1724;
{ /* Llib/ssl.scm 940 */
obj_t BgL_res2562z00_2869;
{ /* Llib/ssl.scm 940 */
long BgL_objzd2classzd2numz00_2826;
{ /* Llib/ssl.scm 940 */
long BgL_res2551z00_2829;
BgL_res2551z00_2829 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_79)); 
BgL_objzd2classzd2numz00_2826 = BgL_res2551z00_2829; } 
{ /* Llib/ssl.scm 940 */
obj_t BgL_arg1742z00_2827;
BgL_arg1742z00_2827 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2readzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 940 */
int BgL_offsetz00_2831;
BgL_offsetz00_2831 = 
(int)(BgL_objzd2classzd2numz00_2826); 
{ /* Llib/ssl.scm 940 */
long BgL_offsetz00_2832;
BgL_offsetz00_2832 = 
(
(long)(BgL_offsetz00_2831)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 940 */
long BgL_modz00_2833;
{ /* Llib/ssl.scm 940 */
int BgL_arg1744z00_2834;
BgL_arg1744z00_2834 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 940 */
long BgL_res2554z00_2844;
{ /* Llib/ssl.scm 940 */
long BgL_tmpz00_9700;
BgL_tmpz00_9700 = 
(long)(BgL_arg1744z00_2834); 
BgL_res2554z00_2844 = 
(BgL_offsetz00_2832/BgL_tmpz00_9700); } 
BgL_modz00_2833 = BgL_res2554z00_2844; } } 
{ /* Llib/ssl.scm 940 */
long BgL_restz00_2835;
{ /* Llib/ssl.scm 940 */
int BgL_arg1743z00_2836;
BgL_arg1743z00_2836 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 940 */
long BgL_res2561z00_2864;
{ /* Llib/ssl.scm 940 */
long BgL_n1z00_2846;long BgL_n2z00_2847;
BgL_n1z00_2846 = BgL_offsetz00_2832; 
BgL_n2z00_2847 = 
(long)(BgL_arg1743z00_2836); 
{ /* Llib/ssl.scm 940 */
bool_t BgL_testz00_9705;
{ /* Llib/ssl.scm 940 */
long BgL_arg1283z00_2849;
BgL_arg1283z00_2849 = 
(((BgL_n1z00_2846) | (BgL_n2z00_2847)) & -2147483648); 
BgL_testz00_9705 = 
(BgL_arg1283z00_2849==((long)0)); } 
if(BgL_testz00_9705)
{ /* Llib/ssl.scm 940 */
int32_t BgL_arg1272z00_2850;
{ /* Llib/ssl.scm 940 */
int32_t BgL_arg1278z00_2851;int32_t BgL_arg1279z00_2852;
{ /* Llib/ssl.scm 940 */
int32_t BgL_res2557z00_2856;
BgL_res2557z00_2856 = 
(int32_t)(BgL_n1z00_2846); 
BgL_arg1278z00_2851 = BgL_res2557z00_2856; } 
{ /* Llib/ssl.scm 940 */
int32_t BgL_res2558z00_2858;
BgL_res2558z00_2858 = 
(int32_t)(BgL_n2z00_2847); 
BgL_arg1279z00_2852 = BgL_res2558z00_2858; } 
BgL_arg1272z00_2850 = 
(BgL_arg1278z00_2851%BgL_arg1279z00_2852); } 
{ /* Llib/ssl.scm 940 */
long BgL_res2560z00_2863;
{ /* Llib/ssl.scm 940 */
long BgL_arg1409z00_2860;
BgL_arg1409z00_2860 = 
(long)(BgL_arg1272z00_2850); 
{ /* Llib/ssl.scm 940 */
long BgL_res2559z00_2862;
BgL_res2559z00_2862 = 
(long)(BgL_arg1409z00_2860); 
BgL_res2560z00_2863 = BgL_res2559z00_2862; } } 
BgL_res2561z00_2864 = BgL_res2560z00_2863; } }  else 
{ /* Llib/ssl.scm 940 */
BgL_res2561z00_2864 = 
(BgL_n1z00_2846%BgL_n2z00_2847); } } } 
BgL_restz00_2835 = BgL_res2561z00_2864; } } 
{ /* Llib/ssl.scm 940 */

{ /* Llib/ssl.scm 940 */
obj_t BgL_bucketz00_2837;
BgL_bucketz00_2837 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_2827),BgL_modz00_2833); 
BgL_res2562z00_2869 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2837),BgL_restz00_2835); } } } } } } } } 
BgL_method1275z00_1724 = BgL_res2562z00_2869; } 
return 
PROCEDURE_ENTRY(BgL_method1275z00_1724)(BgL_method1275z00_1724, 
((obj_t)BgL_sslz00_79), BgL_bufferz00_80, 
BINT(BgL_offsetz00_81), 
BINT(BgL_lenz00_82), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-connection-read */
obj_t BGl_z62sslzd2connectionzd2readz62zz__ssl_sslz00(obj_t BgL_envz00_5449, obj_t BgL_sslz00_5450, obj_t BgL_bufferz00_5451, obj_t BgL_offsetz00_5452, obj_t BgL_lenz00_5453)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 940 */
{ /* Llib/ssl.scm 940 */
long BgL_auxz00_9752;long BgL_auxz00_9743;obj_t BgL_auxz00_9736;BgL_sslzd2connectionzd2_bglt BgL_auxz00_9728;
{ /* Llib/ssl.scm 940 */
obj_t BgL_tmpz00_9753;
if(
INTEGERP(BgL_lenz00_5453))
{ /* Llib/ssl.scm 940 */
BgL_tmpz00_9753 = BgL_lenz00_5453
; }  else 
{ 
obj_t BgL_auxz00_9756;
BgL_auxz00_9756 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)38332)), BGl_string3754z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_lenz00_5453); 
FAILURE(BgL_auxz00_9756,BFALSE,BFALSE);} 
BgL_auxz00_9752 = 
(long)CINT(BgL_tmpz00_9753); } 
{ /* Llib/ssl.scm 940 */
obj_t BgL_tmpz00_9744;
if(
INTEGERP(BgL_offsetz00_5452))
{ /* Llib/ssl.scm 940 */
BgL_tmpz00_9744 = BgL_offsetz00_5452
; }  else 
{ 
obj_t BgL_auxz00_9747;
BgL_auxz00_9747 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)38332)), BGl_string3754z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_offsetz00_5452); 
FAILURE(BgL_auxz00_9747,BFALSE,BFALSE);} 
BgL_auxz00_9743 = 
(long)CINT(BgL_tmpz00_9744); } 
if(
STRINGP(BgL_bufferz00_5451))
{ /* Llib/ssl.scm 940 */
BgL_auxz00_9736 = BgL_bufferz00_5451
; }  else 
{ 
obj_t BgL_auxz00_9739;
BgL_auxz00_9739 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)38332)), BGl_string3754z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_bufferz00_5451); 
FAILURE(BgL_auxz00_9739,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5450, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 940 */
BgL_auxz00_9728 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5450)
; }  else 
{ 
obj_t BgL_auxz00_9732;
BgL_auxz00_9732 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)38332)), BGl_string3754z00zz__ssl_sslz00, BGl_string3750z00zz__ssl_sslz00, BgL_sslz00_5450); 
FAILURE(BgL_auxz00_9732,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2readz00zz__ssl_sslz00(BgL_auxz00_9728, BgL_auxz00_9736, BgL_auxz00_9743, BgL_auxz00_9752);} } 
BGL_FUNCTION_END;
}



/* ssl-connection-write */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2writez00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_83, obj_t BgL_bufferz00_84, long BgL_offsetz00_85, long BgL_lenz00_86)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 950 */
{ /* Llib/ssl.scm 950 */
obj_t BgL_method1277z00_1725;
{ /* Llib/ssl.scm 950 */
obj_t BgL_res2574z00_2914;
{ /* Llib/ssl.scm 950 */
long BgL_objzd2classzd2numz00_2871;
{ /* Llib/ssl.scm 950 */
long BgL_res2563z00_2874;
BgL_res2563z00_2874 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_83)); 
BgL_objzd2classzd2numz00_2871 = BgL_res2563z00_2874; } 
{ /* Llib/ssl.scm 950 */
obj_t BgL_arg1742z00_2872;
BgL_arg1742z00_2872 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2writezd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 950 */
int BgL_offsetz00_2876;
BgL_offsetz00_2876 = 
(int)(BgL_objzd2classzd2numz00_2871); 
{ /* Llib/ssl.scm 950 */
long BgL_offsetz00_2877;
BgL_offsetz00_2877 = 
(
(long)(BgL_offsetz00_2876)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 950 */
long BgL_modz00_2878;
{ /* Llib/ssl.scm 950 */
int BgL_arg1744z00_2879;
BgL_arg1744z00_2879 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 950 */
long BgL_res2566z00_2889;
{ /* Llib/ssl.scm 950 */
long BgL_tmpz00_9770;
BgL_tmpz00_9770 = 
(long)(BgL_arg1744z00_2879); 
BgL_res2566z00_2889 = 
(BgL_offsetz00_2877/BgL_tmpz00_9770); } 
BgL_modz00_2878 = BgL_res2566z00_2889; } } 
{ /* Llib/ssl.scm 950 */
long BgL_restz00_2880;
{ /* Llib/ssl.scm 950 */
int BgL_arg1743z00_2881;
BgL_arg1743z00_2881 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 950 */
long BgL_res2573z00_2909;
{ /* Llib/ssl.scm 950 */
long BgL_n1z00_2891;long BgL_n2z00_2892;
BgL_n1z00_2891 = BgL_offsetz00_2877; 
BgL_n2z00_2892 = 
(long)(BgL_arg1743z00_2881); 
{ /* Llib/ssl.scm 950 */
bool_t BgL_testz00_9775;
{ /* Llib/ssl.scm 950 */
long BgL_arg1283z00_2894;
BgL_arg1283z00_2894 = 
(((BgL_n1z00_2891) | (BgL_n2z00_2892)) & -2147483648); 
BgL_testz00_9775 = 
(BgL_arg1283z00_2894==((long)0)); } 
if(BgL_testz00_9775)
{ /* Llib/ssl.scm 950 */
int32_t BgL_arg1272z00_2895;
{ /* Llib/ssl.scm 950 */
int32_t BgL_arg1278z00_2896;int32_t BgL_arg1279z00_2897;
{ /* Llib/ssl.scm 950 */
int32_t BgL_res2569z00_2901;
BgL_res2569z00_2901 = 
(int32_t)(BgL_n1z00_2891); 
BgL_arg1278z00_2896 = BgL_res2569z00_2901; } 
{ /* Llib/ssl.scm 950 */
int32_t BgL_res2570z00_2903;
BgL_res2570z00_2903 = 
(int32_t)(BgL_n2z00_2892); 
BgL_arg1279z00_2897 = BgL_res2570z00_2903; } 
BgL_arg1272z00_2895 = 
(BgL_arg1278z00_2896%BgL_arg1279z00_2897); } 
{ /* Llib/ssl.scm 950 */
long BgL_res2572z00_2908;
{ /* Llib/ssl.scm 950 */
long BgL_arg1409z00_2905;
BgL_arg1409z00_2905 = 
(long)(BgL_arg1272z00_2895); 
{ /* Llib/ssl.scm 950 */
long BgL_res2571z00_2907;
BgL_res2571z00_2907 = 
(long)(BgL_arg1409z00_2905); 
BgL_res2572z00_2908 = BgL_res2571z00_2907; } } 
BgL_res2573z00_2909 = BgL_res2572z00_2908; } }  else 
{ /* Llib/ssl.scm 950 */
BgL_res2573z00_2909 = 
(BgL_n1z00_2891%BgL_n2z00_2892); } } } 
BgL_restz00_2880 = BgL_res2573z00_2909; } } 
{ /* Llib/ssl.scm 950 */

{ /* Llib/ssl.scm 950 */
obj_t BgL_bucketz00_2882;
BgL_bucketz00_2882 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_2872),BgL_modz00_2878); 
BgL_res2574z00_2914 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2882),BgL_restz00_2880); } } } } } } } } 
BgL_method1277z00_1725 = BgL_res2574z00_2914; } 
return 
PROCEDURE_ENTRY(BgL_method1277z00_1725)(BgL_method1277z00_1725, 
((obj_t)BgL_sslz00_83), BgL_bufferz00_84, 
BINT(BgL_offsetz00_85), 
BINT(BgL_lenz00_86), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-connection-write */
obj_t BGl_z62sslzd2connectionzd2writez62zz__ssl_sslz00(obj_t BgL_envz00_5454, obj_t BgL_sslz00_5455, obj_t BgL_bufferz00_5456, obj_t BgL_offsetz00_5457, obj_t BgL_lenz00_5458)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 950 */
{ /* Llib/ssl.scm 950 */
long BgL_auxz00_9822;long BgL_auxz00_9813;obj_t BgL_auxz00_9806;BgL_sslzd2connectionzd2_bglt BgL_auxz00_9798;
{ /* Llib/ssl.scm 950 */
obj_t BgL_tmpz00_9823;
if(
INTEGERP(BgL_lenz00_5458))
{ /* Llib/ssl.scm 950 */
BgL_tmpz00_9823 = BgL_lenz00_5458
; }  else 
{ 
obj_t BgL_auxz00_9826;
BgL_auxz00_9826 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)38744)), BGl_string3755z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_lenz00_5458); 
FAILURE(BgL_auxz00_9826,BFALSE,BFALSE);} 
BgL_auxz00_9822 = 
(long)CINT(BgL_tmpz00_9823); } 
{ /* Llib/ssl.scm 950 */
obj_t BgL_tmpz00_9814;
if(
INTEGERP(BgL_offsetz00_5457))
{ /* Llib/ssl.scm 950 */
BgL_tmpz00_9814 = BgL_offsetz00_5457
; }  else 
{ 
obj_t BgL_auxz00_9817;
BgL_auxz00_9817 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)38744)), BGl_string3755z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_offsetz00_5457); 
FAILURE(BgL_auxz00_9817,BFALSE,BFALSE);} 
BgL_auxz00_9813 = 
(long)CINT(BgL_tmpz00_9814); } 
if(
STRINGP(BgL_bufferz00_5456))
{ /* Llib/ssl.scm 950 */
BgL_auxz00_9806 = BgL_bufferz00_5456
; }  else 
{ 
obj_t BgL_auxz00_9809;
BgL_auxz00_9809 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)38744)), BGl_string3755z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_bufferz00_5456); 
FAILURE(BgL_auxz00_9809,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5455, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 950 */
BgL_auxz00_9798 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5455)
; }  else 
{ 
obj_t BgL_auxz00_9802;
BgL_auxz00_9802 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)38744)), BGl_string3755z00zz__ssl_sslz00, BGl_string3750z00zz__ssl_sslz00, BgL_sslz00_5455); 
FAILURE(BgL_auxz00_9802,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2writez00zz__ssl_sslz00(BgL_auxz00_9798, BgL_auxz00_9806, BgL_auxz00_9813, BgL_auxz00_9822);} } 
BGL_FUNCTION_END;
}



/* ssl-connection-clear-in */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2clearzd2inzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_87, obj_t BgL_bufferz00_88, long BgL_offsetz00_89, long BgL_lenz00_90)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 960 */
{ /* Llib/ssl.scm 960 */
obj_t BgL_method1279z00_1726;
{ /* Llib/ssl.scm 960 */
obj_t BgL_res2586z00_2959;
{ /* Llib/ssl.scm 960 */
long BgL_objzd2classzd2numz00_2916;
{ /* Llib/ssl.scm 960 */
long BgL_res2575z00_2919;
BgL_res2575z00_2919 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_87)); 
BgL_objzd2classzd2numz00_2916 = BgL_res2575z00_2919; } 
{ /* Llib/ssl.scm 960 */
obj_t BgL_arg1742z00_2917;
BgL_arg1742z00_2917 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2clearzd2inzd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 960 */
int BgL_offsetz00_2921;
BgL_offsetz00_2921 = 
(int)(BgL_objzd2classzd2numz00_2916); 
{ /* Llib/ssl.scm 960 */
long BgL_offsetz00_2922;
BgL_offsetz00_2922 = 
(
(long)(BgL_offsetz00_2921)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 960 */
long BgL_modz00_2923;
{ /* Llib/ssl.scm 960 */
int BgL_arg1744z00_2924;
BgL_arg1744z00_2924 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 960 */
long BgL_res2578z00_2934;
{ /* Llib/ssl.scm 960 */
long BgL_tmpz00_9840;
BgL_tmpz00_9840 = 
(long)(BgL_arg1744z00_2924); 
BgL_res2578z00_2934 = 
(BgL_offsetz00_2922/BgL_tmpz00_9840); } 
BgL_modz00_2923 = BgL_res2578z00_2934; } } 
{ /* Llib/ssl.scm 960 */
long BgL_restz00_2925;
{ /* Llib/ssl.scm 960 */
int BgL_arg1743z00_2926;
BgL_arg1743z00_2926 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 960 */
long BgL_res2585z00_2954;
{ /* Llib/ssl.scm 960 */
long BgL_n1z00_2936;long BgL_n2z00_2937;
BgL_n1z00_2936 = BgL_offsetz00_2922; 
BgL_n2z00_2937 = 
(long)(BgL_arg1743z00_2926); 
{ /* Llib/ssl.scm 960 */
bool_t BgL_testz00_9845;
{ /* Llib/ssl.scm 960 */
long BgL_arg1283z00_2939;
BgL_arg1283z00_2939 = 
(((BgL_n1z00_2936) | (BgL_n2z00_2937)) & -2147483648); 
BgL_testz00_9845 = 
(BgL_arg1283z00_2939==((long)0)); } 
if(BgL_testz00_9845)
{ /* Llib/ssl.scm 960 */
int32_t BgL_arg1272z00_2940;
{ /* Llib/ssl.scm 960 */
int32_t BgL_arg1278z00_2941;int32_t BgL_arg1279z00_2942;
{ /* Llib/ssl.scm 960 */
int32_t BgL_res2581z00_2946;
BgL_res2581z00_2946 = 
(int32_t)(BgL_n1z00_2936); 
BgL_arg1278z00_2941 = BgL_res2581z00_2946; } 
{ /* Llib/ssl.scm 960 */
int32_t BgL_res2582z00_2948;
BgL_res2582z00_2948 = 
(int32_t)(BgL_n2z00_2937); 
BgL_arg1279z00_2942 = BgL_res2582z00_2948; } 
BgL_arg1272z00_2940 = 
(BgL_arg1278z00_2941%BgL_arg1279z00_2942); } 
{ /* Llib/ssl.scm 960 */
long BgL_res2584z00_2953;
{ /* Llib/ssl.scm 960 */
long BgL_arg1409z00_2950;
BgL_arg1409z00_2950 = 
(long)(BgL_arg1272z00_2940); 
{ /* Llib/ssl.scm 960 */
long BgL_res2583z00_2952;
BgL_res2583z00_2952 = 
(long)(BgL_arg1409z00_2950); 
BgL_res2584z00_2953 = BgL_res2583z00_2952; } } 
BgL_res2585z00_2954 = BgL_res2584z00_2953; } }  else 
{ /* Llib/ssl.scm 960 */
BgL_res2585z00_2954 = 
(BgL_n1z00_2936%BgL_n2z00_2937); } } } 
BgL_restz00_2925 = BgL_res2585z00_2954; } } 
{ /* Llib/ssl.scm 960 */

{ /* Llib/ssl.scm 960 */
obj_t BgL_bucketz00_2927;
BgL_bucketz00_2927 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_2917),BgL_modz00_2923); 
BgL_res2586z00_2959 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2927),BgL_restz00_2925); } } } } } } } } 
BgL_method1279z00_1726 = BgL_res2586z00_2959; } 
return 
PROCEDURE_ENTRY(BgL_method1279z00_1726)(BgL_method1279z00_1726, 
((obj_t)BgL_sslz00_87), BgL_bufferz00_88, 
BINT(BgL_offsetz00_89), 
BINT(BgL_lenz00_90), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-connection-clear-in */
obj_t BGl_z62sslzd2connectionzd2clearzd2inzb0zz__ssl_sslz00(obj_t BgL_envz00_5459, obj_t BgL_sslz00_5460, obj_t BgL_bufferz00_5461, obj_t BgL_offsetz00_5462, obj_t BgL_lenz00_5463)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 960 */
{ /* Llib/ssl.scm 960 */
long BgL_auxz00_9892;long BgL_auxz00_9883;obj_t BgL_auxz00_9876;BgL_sslzd2connectionzd2_bglt BgL_auxz00_9868;
{ /* Llib/ssl.scm 960 */
obj_t BgL_tmpz00_9893;
if(
INTEGERP(BgL_lenz00_5463))
{ /* Llib/ssl.scm 960 */
BgL_tmpz00_9893 = BgL_lenz00_5463
; }  else 
{ 
obj_t BgL_auxz00_9896;
BgL_auxz00_9896 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)39158)), BGl_string3756z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_lenz00_5463); 
FAILURE(BgL_auxz00_9896,BFALSE,BFALSE);} 
BgL_auxz00_9892 = 
(long)CINT(BgL_tmpz00_9893); } 
{ /* Llib/ssl.scm 960 */
obj_t BgL_tmpz00_9884;
if(
INTEGERP(BgL_offsetz00_5462))
{ /* Llib/ssl.scm 960 */
BgL_tmpz00_9884 = BgL_offsetz00_5462
; }  else 
{ 
obj_t BgL_auxz00_9887;
BgL_auxz00_9887 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)39158)), BGl_string3756z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_offsetz00_5462); 
FAILURE(BgL_auxz00_9887,BFALSE,BFALSE);} 
BgL_auxz00_9883 = 
(long)CINT(BgL_tmpz00_9884); } 
if(
STRINGP(BgL_bufferz00_5461))
{ /* Llib/ssl.scm 960 */
BgL_auxz00_9876 = BgL_bufferz00_5461
; }  else 
{ 
obj_t BgL_auxz00_9879;
BgL_auxz00_9879 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)39158)), BGl_string3756z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_bufferz00_5461); 
FAILURE(BgL_auxz00_9879,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5460, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 960 */
BgL_auxz00_9868 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5460)
; }  else 
{ 
obj_t BgL_auxz00_9872;
BgL_auxz00_9872 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)39158)), BGl_string3756z00zz__ssl_sslz00, BGl_string3750z00zz__ssl_sslz00, BgL_sslz00_5460); 
FAILURE(BgL_auxz00_9872,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2clearzd2inzd2zz__ssl_sslz00(BgL_auxz00_9868, BgL_auxz00_9876, BgL_auxz00_9883, BgL_auxz00_9892);} } 
BGL_FUNCTION_END;
}



/* ssl-connection-clear-out */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2clearzd2outzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_91, obj_t BgL_bufferz00_92, long BgL_offsetz00_93, long BgL_lenz00_94)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 970 */
{ /* Llib/ssl.scm 970 */
obj_t BgL_method1281z00_1727;
{ /* Llib/ssl.scm 970 */
obj_t BgL_res2598z00_3004;
{ /* Llib/ssl.scm 970 */
long BgL_objzd2classzd2numz00_2961;
{ /* Llib/ssl.scm 970 */
long BgL_res2587z00_2964;
BgL_res2587z00_2964 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_91)); 
BgL_objzd2classzd2numz00_2961 = BgL_res2587z00_2964; } 
{ /* Llib/ssl.scm 970 */
obj_t BgL_arg1742z00_2962;
BgL_arg1742z00_2962 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2clearzd2outzd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 970 */
int BgL_offsetz00_2966;
BgL_offsetz00_2966 = 
(int)(BgL_objzd2classzd2numz00_2961); 
{ /* Llib/ssl.scm 970 */
long BgL_offsetz00_2967;
BgL_offsetz00_2967 = 
(
(long)(BgL_offsetz00_2966)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 970 */
long BgL_modz00_2968;
{ /* Llib/ssl.scm 970 */
int BgL_arg1744z00_2969;
BgL_arg1744z00_2969 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 970 */
long BgL_res2590z00_2979;
{ /* Llib/ssl.scm 970 */
long BgL_tmpz00_9910;
BgL_tmpz00_9910 = 
(long)(BgL_arg1744z00_2969); 
BgL_res2590z00_2979 = 
(BgL_offsetz00_2967/BgL_tmpz00_9910); } 
BgL_modz00_2968 = BgL_res2590z00_2979; } } 
{ /* Llib/ssl.scm 970 */
long BgL_restz00_2970;
{ /* Llib/ssl.scm 970 */
int BgL_arg1743z00_2971;
BgL_arg1743z00_2971 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 970 */
long BgL_res2597z00_2999;
{ /* Llib/ssl.scm 970 */
long BgL_n1z00_2981;long BgL_n2z00_2982;
BgL_n1z00_2981 = BgL_offsetz00_2967; 
BgL_n2z00_2982 = 
(long)(BgL_arg1743z00_2971); 
{ /* Llib/ssl.scm 970 */
bool_t BgL_testz00_9915;
{ /* Llib/ssl.scm 970 */
long BgL_arg1283z00_2984;
BgL_arg1283z00_2984 = 
(((BgL_n1z00_2981) | (BgL_n2z00_2982)) & -2147483648); 
BgL_testz00_9915 = 
(BgL_arg1283z00_2984==((long)0)); } 
if(BgL_testz00_9915)
{ /* Llib/ssl.scm 970 */
int32_t BgL_arg1272z00_2985;
{ /* Llib/ssl.scm 970 */
int32_t BgL_arg1278z00_2986;int32_t BgL_arg1279z00_2987;
{ /* Llib/ssl.scm 970 */
int32_t BgL_res2593z00_2991;
BgL_res2593z00_2991 = 
(int32_t)(BgL_n1z00_2981); 
BgL_arg1278z00_2986 = BgL_res2593z00_2991; } 
{ /* Llib/ssl.scm 970 */
int32_t BgL_res2594z00_2993;
BgL_res2594z00_2993 = 
(int32_t)(BgL_n2z00_2982); 
BgL_arg1279z00_2987 = BgL_res2594z00_2993; } 
BgL_arg1272z00_2985 = 
(BgL_arg1278z00_2986%BgL_arg1279z00_2987); } 
{ /* Llib/ssl.scm 970 */
long BgL_res2596z00_2998;
{ /* Llib/ssl.scm 970 */
long BgL_arg1409z00_2995;
BgL_arg1409z00_2995 = 
(long)(BgL_arg1272z00_2985); 
{ /* Llib/ssl.scm 970 */
long BgL_res2595z00_2997;
BgL_res2595z00_2997 = 
(long)(BgL_arg1409z00_2995); 
BgL_res2596z00_2998 = BgL_res2595z00_2997; } } 
BgL_res2597z00_2999 = BgL_res2596z00_2998; } }  else 
{ /* Llib/ssl.scm 970 */
BgL_res2597z00_2999 = 
(BgL_n1z00_2981%BgL_n2z00_2982); } } } 
BgL_restz00_2970 = BgL_res2597z00_2999; } } 
{ /* Llib/ssl.scm 970 */

{ /* Llib/ssl.scm 970 */
obj_t BgL_bucketz00_2972;
BgL_bucketz00_2972 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_2962),BgL_modz00_2968); 
BgL_res2598z00_3004 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2972),BgL_restz00_2970); } } } } } } } } 
BgL_method1281z00_1727 = BgL_res2598z00_3004; } 
return 
PROCEDURE_ENTRY(BgL_method1281z00_1727)(BgL_method1281z00_1727, 
((obj_t)BgL_sslz00_91), BgL_bufferz00_92, 
BINT(BgL_offsetz00_93), 
BINT(BgL_lenz00_94), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-connection-clear-out */
obj_t BGl_z62sslzd2connectionzd2clearzd2outzb0zz__ssl_sslz00(obj_t BgL_envz00_5464, obj_t BgL_sslz00_5465, obj_t BgL_bufferz00_5466, obj_t BgL_offsetz00_5467, obj_t BgL_lenz00_5468)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 970 */
{ /* Llib/ssl.scm 970 */
long BgL_auxz00_9962;long BgL_auxz00_9953;obj_t BgL_auxz00_9946;BgL_sslzd2connectionzd2_bglt BgL_auxz00_9938;
{ /* Llib/ssl.scm 970 */
obj_t BgL_tmpz00_9963;
if(
INTEGERP(BgL_lenz00_5468))
{ /* Llib/ssl.scm 970 */
BgL_tmpz00_9963 = BgL_lenz00_5468
; }  else 
{ 
obj_t BgL_auxz00_9966;
BgL_auxz00_9966 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)39578)), BGl_string3757z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_lenz00_5468); 
FAILURE(BgL_auxz00_9966,BFALSE,BFALSE);} 
BgL_auxz00_9962 = 
(long)CINT(BgL_tmpz00_9963); } 
{ /* Llib/ssl.scm 970 */
obj_t BgL_tmpz00_9954;
if(
INTEGERP(BgL_offsetz00_5467))
{ /* Llib/ssl.scm 970 */
BgL_tmpz00_9954 = BgL_offsetz00_5467
; }  else 
{ 
obj_t BgL_auxz00_9957;
BgL_auxz00_9957 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)39578)), BGl_string3757z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_offsetz00_5467); 
FAILURE(BgL_auxz00_9957,BFALSE,BFALSE);} 
BgL_auxz00_9953 = 
(long)CINT(BgL_tmpz00_9954); } 
if(
STRINGP(BgL_bufferz00_5466))
{ /* Llib/ssl.scm 970 */
BgL_auxz00_9946 = BgL_bufferz00_5466
; }  else 
{ 
obj_t BgL_auxz00_9949;
BgL_auxz00_9949 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)39578)), BGl_string3757z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_bufferz00_5466); 
FAILURE(BgL_auxz00_9949,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5465, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 970 */
BgL_auxz00_9938 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5465)
; }  else 
{ 
obj_t BgL_auxz00_9942;
BgL_auxz00_9942 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)39578)), BGl_string3757z00zz__ssl_sslz00, BGl_string3750z00zz__ssl_sslz00, BgL_sslz00_5465); 
FAILURE(BgL_auxz00_9942,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2clearzd2outzd2zz__ssl_sslz00(BgL_auxz00_9938, BgL_auxz00_9946, BgL_auxz00_9953, BgL_auxz00_9962);} } 
BGL_FUNCTION_END;
}



/* ssl-connection-init-finished? */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2initzd2finishedzf3z21zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_95)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 980 */
{ /* Llib/ssl.scm 980 */
obj_t BgL_method1283z00_1728;
{ /* Llib/ssl.scm 980 */
obj_t BgL_res2610z00_3049;
{ /* Llib/ssl.scm 980 */
long BgL_objzd2classzd2numz00_3006;
{ /* Llib/ssl.scm 980 */
long BgL_res2599z00_3009;
BgL_res2599z00_3009 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_95)); 
BgL_objzd2classzd2numz00_3006 = BgL_res2599z00_3009; } 
{ /* Llib/ssl.scm 980 */
obj_t BgL_arg1742z00_3007;
BgL_arg1742z00_3007 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2initzd2finishedzf3zd2envzf3zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 980 */
int BgL_offsetz00_3011;
BgL_offsetz00_3011 = 
(int)(BgL_objzd2classzd2numz00_3006); 
{ /* Llib/ssl.scm 980 */
long BgL_offsetz00_3012;
BgL_offsetz00_3012 = 
(
(long)(BgL_offsetz00_3011)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 980 */
long BgL_modz00_3013;
{ /* Llib/ssl.scm 980 */
int BgL_arg1744z00_3014;
BgL_arg1744z00_3014 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 980 */
long BgL_res2602z00_3024;
{ /* Llib/ssl.scm 980 */
long BgL_tmpz00_9980;
BgL_tmpz00_9980 = 
(long)(BgL_arg1744z00_3014); 
BgL_res2602z00_3024 = 
(BgL_offsetz00_3012/BgL_tmpz00_9980); } 
BgL_modz00_3013 = BgL_res2602z00_3024; } } 
{ /* Llib/ssl.scm 980 */
long BgL_restz00_3015;
{ /* Llib/ssl.scm 980 */
int BgL_arg1743z00_3016;
BgL_arg1743z00_3016 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 980 */
long BgL_res2609z00_3044;
{ /* Llib/ssl.scm 980 */
long BgL_n1z00_3026;long BgL_n2z00_3027;
BgL_n1z00_3026 = BgL_offsetz00_3012; 
BgL_n2z00_3027 = 
(long)(BgL_arg1743z00_3016); 
{ /* Llib/ssl.scm 980 */
bool_t BgL_testz00_9985;
{ /* Llib/ssl.scm 980 */
long BgL_arg1283z00_3029;
BgL_arg1283z00_3029 = 
(((BgL_n1z00_3026) | (BgL_n2z00_3027)) & -2147483648); 
BgL_testz00_9985 = 
(BgL_arg1283z00_3029==((long)0)); } 
if(BgL_testz00_9985)
{ /* Llib/ssl.scm 980 */
int32_t BgL_arg1272z00_3030;
{ /* Llib/ssl.scm 980 */
int32_t BgL_arg1278z00_3031;int32_t BgL_arg1279z00_3032;
{ /* Llib/ssl.scm 980 */
int32_t BgL_res2605z00_3036;
BgL_res2605z00_3036 = 
(int32_t)(BgL_n1z00_3026); 
BgL_arg1278z00_3031 = BgL_res2605z00_3036; } 
{ /* Llib/ssl.scm 980 */
int32_t BgL_res2606z00_3038;
BgL_res2606z00_3038 = 
(int32_t)(BgL_n2z00_3027); 
BgL_arg1279z00_3032 = BgL_res2606z00_3038; } 
BgL_arg1272z00_3030 = 
(BgL_arg1278z00_3031%BgL_arg1279z00_3032); } 
{ /* Llib/ssl.scm 980 */
long BgL_res2608z00_3043;
{ /* Llib/ssl.scm 980 */
long BgL_arg1409z00_3040;
BgL_arg1409z00_3040 = 
(long)(BgL_arg1272z00_3030); 
{ /* Llib/ssl.scm 980 */
long BgL_res2607z00_3042;
BgL_res2607z00_3042 = 
(long)(BgL_arg1409z00_3040); 
BgL_res2608z00_3043 = BgL_res2607z00_3042; } } 
BgL_res2609z00_3044 = BgL_res2608z00_3043; } }  else 
{ /* Llib/ssl.scm 980 */
BgL_res2609z00_3044 = 
(BgL_n1z00_3026%BgL_n2z00_3027); } } } 
BgL_restz00_3015 = BgL_res2609z00_3044; } } 
{ /* Llib/ssl.scm 980 */

{ /* Llib/ssl.scm 980 */
obj_t BgL_bucketz00_3017;
BgL_bucketz00_3017 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3007),BgL_modz00_3013); 
BgL_res2610z00_3049 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3017),BgL_restz00_3015); } } } } } } } } 
BgL_method1283z00_1728 = BgL_res2610z00_3049; } 
return 
PROCEDURE_ENTRY(BgL_method1283z00_1728)(BgL_method1283z00_1728, 
((obj_t)BgL_sslz00_95), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-connection-init-finished? */
obj_t BGl_z62sslzd2connectionzd2initzd2finishedzf3z43zz__ssl_sslz00(obj_t BgL_envz00_5469, obj_t BgL_sslz00_5470)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 980 */
{ /* Llib/ssl.scm 980 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_10003;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5470, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 980 */
BgL_auxz00_10003 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5470)
; }  else 
{ 
obj_t BgL_auxz00_10007;
BgL_auxz00_10007 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)40000)), BGl_string3758z00zz__ssl_sslz00, BGl_string3750z00zz__ssl_sslz00, BgL_sslz00_5470); 
FAILURE(BgL_auxz00_10007,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2initzd2finishedzf3z21zz__ssl_sslz00(BgL_auxz00_10003);} } 
BGL_FUNCTION_END;
}



/* ssl-connection-enc-pending */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2enczd2pendingzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_96)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 990 */
{ /* Llib/ssl.scm 990 */
obj_t BgL_method1285z00_1729;
{ /* Llib/ssl.scm 990 */
obj_t BgL_res2622z00_3094;
{ /* Llib/ssl.scm 990 */
long BgL_objzd2classzd2numz00_3051;
{ /* Llib/ssl.scm 990 */
long BgL_res2611z00_3054;
BgL_res2611z00_3054 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_96)); 
BgL_objzd2classzd2numz00_3051 = BgL_res2611z00_3054; } 
{ /* Llib/ssl.scm 990 */
obj_t BgL_arg1742z00_3052;
BgL_arg1742z00_3052 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2enczd2pendingzd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 990 */
int BgL_offsetz00_3056;
BgL_offsetz00_3056 = 
(int)(BgL_objzd2classzd2numz00_3051); 
{ /* Llib/ssl.scm 990 */
long BgL_offsetz00_3057;
BgL_offsetz00_3057 = 
(
(long)(BgL_offsetz00_3056)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 990 */
long BgL_modz00_3058;
{ /* Llib/ssl.scm 990 */
int BgL_arg1744z00_3059;
BgL_arg1744z00_3059 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 990 */
long BgL_res2614z00_3069;
{ /* Llib/ssl.scm 990 */
long BgL_tmpz00_10020;
BgL_tmpz00_10020 = 
(long)(BgL_arg1744z00_3059); 
BgL_res2614z00_3069 = 
(BgL_offsetz00_3057/BgL_tmpz00_10020); } 
BgL_modz00_3058 = BgL_res2614z00_3069; } } 
{ /* Llib/ssl.scm 990 */
long BgL_restz00_3060;
{ /* Llib/ssl.scm 990 */
int BgL_arg1743z00_3061;
BgL_arg1743z00_3061 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 990 */
long BgL_res2621z00_3089;
{ /* Llib/ssl.scm 990 */
long BgL_n1z00_3071;long BgL_n2z00_3072;
BgL_n1z00_3071 = BgL_offsetz00_3057; 
BgL_n2z00_3072 = 
(long)(BgL_arg1743z00_3061); 
{ /* Llib/ssl.scm 990 */
bool_t BgL_testz00_10025;
{ /* Llib/ssl.scm 990 */
long BgL_arg1283z00_3074;
BgL_arg1283z00_3074 = 
(((BgL_n1z00_3071) | (BgL_n2z00_3072)) & -2147483648); 
BgL_testz00_10025 = 
(BgL_arg1283z00_3074==((long)0)); } 
if(BgL_testz00_10025)
{ /* Llib/ssl.scm 990 */
int32_t BgL_arg1272z00_3075;
{ /* Llib/ssl.scm 990 */
int32_t BgL_arg1278z00_3076;int32_t BgL_arg1279z00_3077;
{ /* Llib/ssl.scm 990 */
int32_t BgL_res2617z00_3081;
BgL_res2617z00_3081 = 
(int32_t)(BgL_n1z00_3071); 
BgL_arg1278z00_3076 = BgL_res2617z00_3081; } 
{ /* Llib/ssl.scm 990 */
int32_t BgL_res2618z00_3083;
BgL_res2618z00_3083 = 
(int32_t)(BgL_n2z00_3072); 
BgL_arg1279z00_3077 = BgL_res2618z00_3083; } 
BgL_arg1272z00_3075 = 
(BgL_arg1278z00_3076%BgL_arg1279z00_3077); } 
{ /* Llib/ssl.scm 990 */
long BgL_res2620z00_3088;
{ /* Llib/ssl.scm 990 */
long BgL_arg1409z00_3085;
BgL_arg1409z00_3085 = 
(long)(BgL_arg1272z00_3075); 
{ /* Llib/ssl.scm 990 */
long BgL_res2619z00_3087;
BgL_res2619z00_3087 = 
(long)(BgL_arg1409z00_3085); 
BgL_res2620z00_3088 = BgL_res2619z00_3087; } } 
BgL_res2621z00_3089 = BgL_res2620z00_3088; } }  else 
{ /* Llib/ssl.scm 990 */
BgL_res2621z00_3089 = 
(BgL_n1z00_3071%BgL_n2z00_3072); } } } 
BgL_restz00_3060 = BgL_res2621z00_3089; } } 
{ /* Llib/ssl.scm 990 */

{ /* Llib/ssl.scm 990 */
obj_t BgL_bucketz00_3062;
BgL_bucketz00_3062 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3052),BgL_modz00_3058); 
BgL_res2622z00_3094 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3062),BgL_restz00_3060); } } } } } } } } 
BgL_method1285z00_1729 = BgL_res2622z00_3094; } 
return 
PROCEDURE_ENTRY(BgL_method1285z00_1729)(BgL_method1285z00_1729, 
((obj_t)BgL_sslz00_96), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-connection-enc-pending */
obj_t BGl_z62sslzd2connectionzd2enczd2pendingzb0zz__ssl_sslz00(obj_t BgL_envz00_5471, obj_t BgL_sslz00_5472)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 990 */
{ /* Llib/ssl.scm 990 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_10043;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5472, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 990 */
BgL_auxz00_10043 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5472)
; }  else 
{ 
obj_t BgL_auxz00_10047;
BgL_auxz00_10047 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)40396)), BGl_string3759z00zz__ssl_sslz00, BGl_string3750z00zz__ssl_sslz00, BgL_sslz00_5472); 
FAILURE(BgL_auxz00_10047,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2enczd2pendingzd2zz__ssl_sslz00(BgL_auxz00_10043);} } 
BGL_FUNCTION_END;
}



/* ssl-connection-clear-pending */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2clearzd2pendingzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_97)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1000 */
{ /* Llib/ssl.scm 1000 */
obj_t BgL_method1287z00_1730;
{ /* Llib/ssl.scm 1000 */
obj_t BgL_res2634z00_3139;
{ /* Llib/ssl.scm 1000 */
long BgL_objzd2classzd2numz00_3096;
{ /* Llib/ssl.scm 1000 */
long BgL_res2623z00_3099;
BgL_res2623z00_3099 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_97)); 
BgL_objzd2classzd2numz00_3096 = BgL_res2623z00_3099; } 
{ /* Llib/ssl.scm 1000 */
obj_t BgL_arg1742z00_3097;
BgL_arg1742z00_3097 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2clearzd2pendingzd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1000 */
int BgL_offsetz00_3101;
BgL_offsetz00_3101 = 
(int)(BgL_objzd2classzd2numz00_3096); 
{ /* Llib/ssl.scm 1000 */
long BgL_offsetz00_3102;
BgL_offsetz00_3102 = 
(
(long)(BgL_offsetz00_3101)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1000 */
long BgL_modz00_3103;
{ /* Llib/ssl.scm 1000 */
int BgL_arg1744z00_3104;
BgL_arg1744z00_3104 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1000 */
long BgL_res2626z00_3114;
{ /* Llib/ssl.scm 1000 */
long BgL_tmpz00_10060;
BgL_tmpz00_10060 = 
(long)(BgL_arg1744z00_3104); 
BgL_res2626z00_3114 = 
(BgL_offsetz00_3102/BgL_tmpz00_10060); } 
BgL_modz00_3103 = BgL_res2626z00_3114; } } 
{ /* Llib/ssl.scm 1000 */
long BgL_restz00_3105;
{ /* Llib/ssl.scm 1000 */
int BgL_arg1743z00_3106;
BgL_arg1743z00_3106 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1000 */
long BgL_res2633z00_3134;
{ /* Llib/ssl.scm 1000 */
long BgL_n1z00_3116;long BgL_n2z00_3117;
BgL_n1z00_3116 = BgL_offsetz00_3102; 
BgL_n2z00_3117 = 
(long)(BgL_arg1743z00_3106); 
{ /* Llib/ssl.scm 1000 */
bool_t BgL_testz00_10065;
{ /* Llib/ssl.scm 1000 */
long BgL_arg1283z00_3119;
BgL_arg1283z00_3119 = 
(((BgL_n1z00_3116) | (BgL_n2z00_3117)) & -2147483648); 
BgL_testz00_10065 = 
(BgL_arg1283z00_3119==((long)0)); } 
if(BgL_testz00_10065)
{ /* Llib/ssl.scm 1000 */
int32_t BgL_arg1272z00_3120;
{ /* Llib/ssl.scm 1000 */
int32_t BgL_arg1278z00_3121;int32_t BgL_arg1279z00_3122;
{ /* Llib/ssl.scm 1000 */
int32_t BgL_res2629z00_3126;
BgL_res2629z00_3126 = 
(int32_t)(BgL_n1z00_3116); 
BgL_arg1278z00_3121 = BgL_res2629z00_3126; } 
{ /* Llib/ssl.scm 1000 */
int32_t BgL_res2630z00_3128;
BgL_res2630z00_3128 = 
(int32_t)(BgL_n2z00_3117); 
BgL_arg1279z00_3122 = BgL_res2630z00_3128; } 
BgL_arg1272z00_3120 = 
(BgL_arg1278z00_3121%BgL_arg1279z00_3122); } 
{ /* Llib/ssl.scm 1000 */
long BgL_res2632z00_3133;
{ /* Llib/ssl.scm 1000 */
long BgL_arg1409z00_3130;
BgL_arg1409z00_3130 = 
(long)(BgL_arg1272z00_3120); 
{ /* Llib/ssl.scm 1000 */
long BgL_res2631z00_3132;
BgL_res2631z00_3132 = 
(long)(BgL_arg1409z00_3130); 
BgL_res2632z00_3133 = BgL_res2631z00_3132; } } 
BgL_res2633z00_3134 = BgL_res2632z00_3133; } }  else 
{ /* Llib/ssl.scm 1000 */
BgL_res2633z00_3134 = 
(BgL_n1z00_3116%BgL_n2z00_3117); } } } 
BgL_restz00_3105 = BgL_res2633z00_3134; } } 
{ /* Llib/ssl.scm 1000 */

{ /* Llib/ssl.scm 1000 */
obj_t BgL_bucketz00_3107;
BgL_bucketz00_3107 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3097),BgL_modz00_3103); 
BgL_res2634z00_3139 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3107),BgL_restz00_3105); } } } } } } } } 
BgL_method1287z00_1730 = BgL_res2634z00_3139; } 
return 
PROCEDURE_ENTRY(BgL_method1287z00_1730)(BgL_method1287z00_1730, 
((obj_t)BgL_sslz00_97), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-connection-clear-pending */
obj_t BGl_z62sslzd2connectionzd2clearzd2pendingzb0zz__ssl_sslz00(obj_t BgL_envz00_5473, obj_t BgL_sslz00_5474)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1000 */
{ /* Llib/ssl.scm 1000 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_10083;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5474, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1000 */
BgL_auxz00_10083 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5474)
; }  else 
{ 
obj_t BgL_auxz00_10087;
BgL_auxz00_10087 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)40786)), BGl_string3760z00zz__ssl_sslz00, BGl_string3750z00zz__ssl_sslz00, BgL_sslz00_5474); 
FAILURE(BgL_auxz00_10087,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2clearzd2pendingzd2zz__ssl_sslz00(BgL_auxz00_10083);} } 
BGL_FUNCTION_END;
}



/* ssl-connection-set-session */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2setzd2sessionzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_98, obj_t BgL_bufz00_99)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1010 */
{ /* Llib/ssl.scm 1010 */
obj_t BgL_method1289z00_1731;
{ /* Llib/ssl.scm 1010 */
obj_t BgL_res2646z00_3184;
{ /* Llib/ssl.scm 1010 */
long BgL_objzd2classzd2numz00_3141;
{ /* Llib/ssl.scm 1010 */
long BgL_res2635z00_3144;
BgL_res2635z00_3144 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_98)); 
BgL_objzd2classzd2numz00_3141 = BgL_res2635z00_3144; } 
{ /* Llib/ssl.scm 1010 */
obj_t BgL_arg1742z00_3142;
BgL_arg1742z00_3142 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2setzd2sessionzd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1010 */
int BgL_offsetz00_3146;
BgL_offsetz00_3146 = 
(int)(BgL_objzd2classzd2numz00_3141); 
{ /* Llib/ssl.scm 1010 */
long BgL_offsetz00_3147;
BgL_offsetz00_3147 = 
(
(long)(BgL_offsetz00_3146)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1010 */
long BgL_modz00_3148;
{ /* Llib/ssl.scm 1010 */
int BgL_arg1744z00_3149;
BgL_arg1744z00_3149 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1010 */
long BgL_res2638z00_3159;
{ /* Llib/ssl.scm 1010 */
long BgL_tmpz00_10100;
BgL_tmpz00_10100 = 
(long)(BgL_arg1744z00_3149); 
BgL_res2638z00_3159 = 
(BgL_offsetz00_3147/BgL_tmpz00_10100); } 
BgL_modz00_3148 = BgL_res2638z00_3159; } } 
{ /* Llib/ssl.scm 1010 */
long BgL_restz00_3150;
{ /* Llib/ssl.scm 1010 */
int BgL_arg1743z00_3151;
BgL_arg1743z00_3151 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1010 */
long BgL_res2645z00_3179;
{ /* Llib/ssl.scm 1010 */
long BgL_n1z00_3161;long BgL_n2z00_3162;
BgL_n1z00_3161 = BgL_offsetz00_3147; 
BgL_n2z00_3162 = 
(long)(BgL_arg1743z00_3151); 
{ /* Llib/ssl.scm 1010 */
bool_t BgL_testz00_10105;
{ /* Llib/ssl.scm 1010 */
long BgL_arg1283z00_3164;
BgL_arg1283z00_3164 = 
(((BgL_n1z00_3161) | (BgL_n2z00_3162)) & -2147483648); 
BgL_testz00_10105 = 
(BgL_arg1283z00_3164==((long)0)); } 
if(BgL_testz00_10105)
{ /* Llib/ssl.scm 1010 */
int32_t BgL_arg1272z00_3165;
{ /* Llib/ssl.scm 1010 */
int32_t BgL_arg1278z00_3166;int32_t BgL_arg1279z00_3167;
{ /* Llib/ssl.scm 1010 */
int32_t BgL_res2641z00_3171;
BgL_res2641z00_3171 = 
(int32_t)(BgL_n1z00_3161); 
BgL_arg1278z00_3166 = BgL_res2641z00_3171; } 
{ /* Llib/ssl.scm 1010 */
int32_t BgL_res2642z00_3173;
BgL_res2642z00_3173 = 
(int32_t)(BgL_n2z00_3162); 
BgL_arg1279z00_3167 = BgL_res2642z00_3173; } 
BgL_arg1272z00_3165 = 
(BgL_arg1278z00_3166%BgL_arg1279z00_3167); } 
{ /* Llib/ssl.scm 1010 */
long BgL_res2644z00_3178;
{ /* Llib/ssl.scm 1010 */
long BgL_arg1409z00_3175;
BgL_arg1409z00_3175 = 
(long)(BgL_arg1272z00_3165); 
{ /* Llib/ssl.scm 1010 */
long BgL_res2643z00_3177;
BgL_res2643z00_3177 = 
(long)(BgL_arg1409z00_3175); 
BgL_res2644z00_3178 = BgL_res2643z00_3177; } } 
BgL_res2645z00_3179 = BgL_res2644z00_3178; } }  else 
{ /* Llib/ssl.scm 1010 */
BgL_res2645z00_3179 = 
(BgL_n1z00_3161%BgL_n2z00_3162); } } } 
BgL_restz00_3150 = BgL_res2645z00_3179; } } 
{ /* Llib/ssl.scm 1010 */

{ /* Llib/ssl.scm 1010 */
obj_t BgL_bucketz00_3152;
BgL_bucketz00_3152 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3142),BgL_modz00_3148); 
BgL_res2646z00_3184 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3152),BgL_restz00_3150); } } } } } } } } 
BgL_method1289z00_1731 = BgL_res2646z00_3184; } 
return 
PROCEDURE_ENTRY(BgL_method1289z00_1731)(BgL_method1289z00_1731, 
((obj_t)BgL_sslz00_98), BgL_bufz00_99, BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-connection-set-session */
obj_t BGl_z62sslzd2connectionzd2setzd2sessionzb0zz__ssl_sslz00(obj_t BgL_envz00_5475, obj_t BgL_sslz00_5476, obj_t BgL_bufz00_5477)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1010 */
{ /* Llib/ssl.scm 1010 */
obj_t BgL_auxz00_10132;BgL_sslzd2connectionzd2_bglt BgL_auxz00_10124;
if(
STRINGP(BgL_bufz00_5477))
{ /* Llib/ssl.scm 1010 */
BgL_auxz00_10132 = BgL_bufz00_5477
; }  else 
{ 
obj_t BgL_auxz00_10135;
BgL_auxz00_10135 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)41180)), BGl_string3761z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_bufz00_5477); 
FAILURE(BgL_auxz00_10135,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5476, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1010 */
BgL_auxz00_10124 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5476)
; }  else 
{ 
obj_t BgL_auxz00_10128;
BgL_auxz00_10128 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)41180)), BGl_string3761z00zz__ssl_sslz00, BGl_string3750z00zz__ssl_sslz00, BgL_sslz00_5476); 
FAILURE(BgL_auxz00_10128,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2setzd2sessionzd2zz__ssl_sslz00(BgL_auxz00_10124, BgL_auxz00_10132);} } 
BGL_FUNCTION_END;
}



/* ssl-connection-get-session */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2getzd2sessionzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_100)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1020 */
{ /* Llib/ssl.scm 1020 */
obj_t BgL_method1291z00_1732;
{ /* Llib/ssl.scm 1020 */
obj_t BgL_res2658z00_3229;
{ /* Llib/ssl.scm 1020 */
long BgL_objzd2classzd2numz00_3186;
{ /* Llib/ssl.scm 1020 */
long BgL_res2647z00_3189;
BgL_res2647z00_3189 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_100)); 
BgL_objzd2classzd2numz00_3186 = BgL_res2647z00_3189; } 
{ /* Llib/ssl.scm 1020 */
obj_t BgL_arg1742z00_3187;
BgL_arg1742z00_3187 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2getzd2sessionzd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1020 */
int BgL_offsetz00_3191;
BgL_offsetz00_3191 = 
(int)(BgL_objzd2classzd2numz00_3186); 
{ /* Llib/ssl.scm 1020 */
long BgL_offsetz00_3192;
BgL_offsetz00_3192 = 
(
(long)(BgL_offsetz00_3191)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1020 */
long BgL_modz00_3193;
{ /* Llib/ssl.scm 1020 */
int BgL_arg1744z00_3194;
BgL_arg1744z00_3194 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1020 */
long BgL_res2650z00_3204;
{ /* Llib/ssl.scm 1020 */
long BgL_tmpz00_10148;
BgL_tmpz00_10148 = 
(long)(BgL_arg1744z00_3194); 
BgL_res2650z00_3204 = 
(BgL_offsetz00_3192/BgL_tmpz00_10148); } 
BgL_modz00_3193 = BgL_res2650z00_3204; } } 
{ /* Llib/ssl.scm 1020 */
long BgL_restz00_3195;
{ /* Llib/ssl.scm 1020 */
int BgL_arg1743z00_3196;
BgL_arg1743z00_3196 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1020 */
long BgL_res2657z00_3224;
{ /* Llib/ssl.scm 1020 */
long BgL_n1z00_3206;long BgL_n2z00_3207;
BgL_n1z00_3206 = BgL_offsetz00_3192; 
BgL_n2z00_3207 = 
(long)(BgL_arg1743z00_3196); 
{ /* Llib/ssl.scm 1020 */
bool_t BgL_testz00_10153;
{ /* Llib/ssl.scm 1020 */
long BgL_arg1283z00_3209;
BgL_arg1283z00_3209 = 
(((BgL_n1z00_3206) | (BgL_n2z00_3207)) & -2147483648); 
BgL_testz00_10153 = 
(BgL_arg1283z00_3209==((long)0)); } 
if(BgL_testz00_10153)
{ /* Llib/ssl.scm 1020 */
int32_t BgL_arg1272z00_3210;
{ /* Llib/ssl.scm 1020 */
int32_t BgL_arg1278z00_3211;int32_t BgL_arg1279z00_3212;
{ /* Llib/ssl.scm 1020 */
int32_t BgL_res2653z00_3216;
BgL_res2653z00_3216 = 
(int32_t)(BgL_n1z00_3206); 
BgL_arg1278z00_3211 = BgL_res2653z00_3216; } 
{ /* Llib/ssl.scm 1020 */
int32_t BgL_res2654z00_3218;
BgL_res2654z00_3218 = 
(int32_t)(BgL_n2z00_3207); 
BgL_arg1279z00_3212 = BgL_res2654z00_3218; } 
BgL_arg1272z00_3210 = 
(BgL_arg1278z00_3211%BgL_arg1279z00_3212); } 
{ /* Llib/ssl.scm 1020 */
long BgL_res2656z00_3223;
{ /* Llib/ssl.scm 1020 */
long BgL_arg1409z00_3220;
BgL_arg1409z00_3220 = 
(long)(BgL_arg1272z00_3210); 
{ /* Llib/ssl.scm 1020 */
long BgL_res2655z00_3222;
BgL_res2655z00_3222 = 
(long)(BgL_arg1409z00_3220); 
BgL_res2656z00_3223 = BgL_res2655z00_3222; } } 
BgL_res2657z00_3224 = BgL_res2656z00_3223; } }  else 
{ /* Llib/ssl.scm 1020 */
BgL_res2657z00_3224 = 
(BgL_n1z00_3206%BgL_n2z00_3207); } } } 
BgL_restz00_3195 = BgL_res2657z00_3224; } } 
{ /* Llib/ssl.scm 1020 */

{ /* Llib/ssl.scm 1020 */
obj_t BgL_bucketz00_3197;
BgL_bucketz00_3197 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3187),BgL_modz00_3193); 
BgL_res2658z00_3229 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3197),BgL_restz00_3195); } } } } } } } } 
BgL_method1291z00_1732 = BgL_res2658z00_3229; } 
return 
PROCEDURE_ENTRY(BgL_method1291z00_1732)(BgL_method1291z00_1732, 
((obj_t)BgL_sslz00_100), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-connection-get-session */
obj_t BGl_z62sslzd2connectionzd2getzd2sessionzb0zz__ssl_sslz00(obj_t BgL_envz00_5478, obj_t BgL_sslz00_5479)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1020 */
{ /* Llib/ssl.scm 1020 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_10171;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5479, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1020 */
BgL_auxz00_10171 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5479)
; }  else 
{ 
obj_t BgL_auxz00_10175;
BgL_auxz00_10175 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)41588)), BGl_string3762z00zz__ssl_sslz00, BGl_string3750z00zz__ssl_sslz00, BgL_sslz00_5479); 
FAILURE(BgL_auxz00_10175,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2getzd2sessionzd2zz__ssl_sslz00(BgL_auxz00_10171);} } 
BGL_FUNCTION_END;
}



/* ssl-connection-get-current-cipher */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2getzd2currentzd2cipherz00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_101)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1030 */
{ /* Llib/ssl.scm 1030 */
obj_t BgL_method1293z00_1733;
{ /* Llib/ssl.scm 1030 */
obj_t BgL_res2670z00_3274;
{ /* Llib/ssl.scm 1030 */
long BgL_objzd2classzd2numz00_3231;
{ /* Llib/ssl.scm 1030 */
long BgL_res2659z00_3234;
BgL_res2659z00_3234 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_101)); 
BgL_objzd2classzd2numz00_3231 = BgL_res2659z00_3234; } 
{ /* Llib/ssl.scm 1030 */
obj_t BgL_arg1742z00_3232;
BgL_arg1742z00_3232 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2getzd2currentzd2cipherzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1030 */
int BgL_offsetz00_3236;
BgL_offsetz00_3236 = 
(int)(BgL_objzd2classzd2numz00_3231); 
{ /* Llib/ssl.scm 1030 */
long BgL_offsetz00_3237;
BgL_offsetz00_3237 = 
(
(long)(BgL_offsetz00_3236)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1030 */
long BgL_modz00_3238;
{ /* Llib/ssl.scm 1030 */
int BgL_arg1744z00_3239;
BgL_arg1744z00_3239 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1030 */
long BgL_res2662z00_3249;
{ /* Llib/ssl.scm 1030 */
long BgL_tmpz00_10188;
BgL_tmpz00_10188 = 
(long)(BgL_arg1744z00_3239); 
BgL_res2662z00_3249 = 
(BgL_offsetz00_3237/BgL_tmpz00_10188); } 
BgL_modz00_3238 = BgL_res2662z00_3249; } } 
{ /* Llib/ssl.scm 1030 */
long BgL_restz00_3240;
{ /* Llib/ssl.scm 1030 */
int BgL_arg1743z00_3241;
BgL_arg1743z00_3241 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1030 */
long BgL_res2669z00_3269;
{ /* Llib/ssl.scm 1030 */
long BgL_n1z00_3251;long BgL_n2z00_3252;
BgL_n1z00_3251 = BgL_offsetz00_3237; 
BgL_n2z00_3252 = 
(long)(BgL_arg1743z00_3241); 
{ /* Llib/ssl.scm 1030 */
bool_t BgL_testz00_10193;
{ /* Llib/ssl.scm 1030 */
long BgL_arg1283z00_3254;
BgL_arg1283z00_3254 = 
(((BgL_n1z00_3251) | (BgL_n2z00_3252)) & -2147483648); 
BgL_testz00_10193 = 
(BgL_arg1283z00_3254==((long)0)); } 
if(BgL_testz00_10193)
{ /* Llib/ssl.scm 1030 */
int32_t BgL_arg1272z00_3255;
{ /* Llib/ssl.scm 1030 */
int32_t BgL_arg1278z00_3256;int32_t BgL_arg1279z00_3257;
{ /* Llib/ssl.scm 1030 */
int32_t BgL_res2665z00_3261;
BgL_res2665z00_3261 = 
(int32_t)(BgL_n1z00_3251); 
BgL_arg1278z00_3256 = BgL_res2665z00_3261; } 
{ /* Llib/ssl.scm 1030 */
int32_t BgL_res2666z00_3263;
BgL_res2666z00_3263 = 
(int32_t)(BgL_n2z00_3252); 
BgL_arg1279z00_3257 = BgL_res2666z00_3263; } 
BgL_arg1272z00_3255 = 
(BgL_arg1278z00_3256%BgL_arg1279z00_3257); } 
{ /* Llib/ssl.scm 1030 */
long BgL_res2668z00_3268;
{ /* Llib/ssl.scm 1030 */
long BgL_arg1409z00_3265;
BgL_arg1409z00_3265 = 
(long)(BgL_arg1272z00_3255); 
{ /* Llib/ssl.scm 1030 */
long BgL_res2667z00_3267;
BgL_res2667z00_3267 = 
(long)(BgL_arg1409z00_3265); 
BgL_res2668z00_3268 = BgL_res2667z00_3267; } } 
BgL_res2669z00_3269 = BgL_res2668z00_3268; } }  else 
{ /* Llib/ssl.scm 1030 */
BgL_res2669z00_3269 = 
(BgL_n1z00_3251%BgL_n2z00_3252); } } } 
BgL_restz00_3240 = BgL_res2669z00_3269; } } 
{ /* Llib/ssl.scm 1030 */

{ /* Llib/ssl.scm 1030 */
obj_t BgL_bucketz00_3242;
BgL_bucketz00_3242 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3232),BgL_modz00_3238); 
BgL_res2670z00_3274 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3242),BgL_restz00_3240); } } } } } } } } 
BgL_method1293z00_1733 = BgL_res2670z00_3274; } 
return 
PROCEDURE_ENTRY(BgL_method1293z00_1733)(BgL_method1293z00_1733, 
((obj_t)BgL_sslz00_101), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-connection-get-current-cipher */
obj_t BGl_z62sslzd2connectionzd2getzd2currentzd2cipherz62zz__ssl_sslz00(obj_t BgL_envz00_5480, obj_t BgL_sslz00_5481)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1030 */
{ /* Llib/ssl.scm 1030 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_10211;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5481, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1030 */
BgL_auxz00_10211 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5481)
; }  else 
{ 
obj_t BgL_auxz00_10215;
BgL_auxz00_10215 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)41979)), BGl_string3763z00zz__ssl_sslz00, BGl_string3750z00zz__ssl_sslz00, BgL_sslz00_5481); 
FAILURE(BgL_auxz00_10215,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2getzd2currentzd2cipherz00zz__ssl_sslz00(BgL_auxz00_10211);} } 
BGL_FUNCTION_END;
}



/* ssl-connection-load-session */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2loadzd2sessionzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_102, obj_t BgL_bufz00_103)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1040 */
{ /* Llib/ssl.scm 1040 */
obj_t BgL_method1295z00_1734;
{ /* Llib/ssl.scm 1040 */
obj_t BgL_res2682z00_3319;
{ /* Llib/ssl.scm 1040 */
long BgL_objzd2classzd2numz00_3276;
{ /* Llib/ssl.scm 1040 */
long BgL_res2671z00_3279;
BgL_res2671z00_3279 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_102)); 
BgL_objzd2classzd2numz00_3276 = BgL_res2671z00_3279; } 
{ /* Llib/ssl.scm 1040 */
obj_t BgL_arg1742z00_3277;
BgL_arg1742z00_3277 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2loadzd2sessionzd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1040 */
int BgL_offsetz00_3281;
BgL_offsetz00_3281 = 
(int)(BgL_objzd2classzd2numz00_3276); 
{ /* Llib/ssl.scm 1040 */
long BgL_offsetz00_3282;
BgL_offsetz00_3282 = 
(
(long)(BgL_offsetz00_3281)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1040 */
long BgL_modz00_3283;
{ /* Llib/ssl.scm 1040 */
int BgL_arg1744z00_3284;
BgL_arg1744z00_3284 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1040 */
long BgL_res2674z00_3294;
{ /* Llib/ssl.scm 1040 */
long BgL_tmpz00_10228;
BgL_tmpz00_10228 = 
(long)(BgL_arg1744z00_3284); 
BgL_res2674z00_3294 = 
(BgL_offsetz00_3282/BgL_tmpz00_10228); } 
BgL_modz00_3283 = BgL_res2674z00_3294; } } 
{ /* Llib/ssl.scm 1040 */
long BgL_restz00_3285;
{ /* Llib/ssl.scm 1040 */
int BgL_arg1743z00_3286;
BgL_arg1743z00_3286 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1040 */
long BgL_res2681z00_3314;
{ /* Llib/ssl.scm 1040 */
long BgL_n1z00_3296;long BgL_n2z00_3297;
BgL_n1z00_3296 = BgL_offsetz00_3282; 
BgL_n2z00_3297 = 
(long)(BgL_arg1743z00_3286); 
{ /* Llib/ssl.scm 1040 */
bool_t BgL_testz00_10233;
{ /* Llib/ssl.scm 1040 */
long BgL_arg1283z00_3299;
BgL_arg1283z00_3299 = 
(((BgL_n1z00_3296) | (BgL_n2z00_3297)) & -2147483648); 
BgL_testz00_10233 = 
(BgL_arg1283z00_3299==((long)0)); } 
if(BgL_testz00_10233)
{ /* Llib/ssl.scm 1040 */
int32_t BgL_arg1272z00_3300;
{ /* Llib/ssl.scm 1040 */
int32_t BgL_arg1278z00_3301;int32_t BgL_arg1279z00_3302;
{ /* Llib/ssl.scm 1040 */
int32_t BgL_res2677z00_3306;
BgL_res2677z00_3306 = 
(int32_t)(BgL_n1z00_3296); 
BgL_arg1278z00_3301 = BgL_res2677z00_3306; } 
{ /* Llib/ssl.scm 1040 */
int32_t BgL_res2678z00_3308;
BgL_res2678z00_3308 = 
(int32_t)(BgL_n2z00_3297); 
BgL_arg1279z00_3302 = BgL_res2678z00_3308; } 
BgL_arg1272z00_3300 = 
(BgL_arg1278z00_3301%BgL_arg1279z00_3302); } 
{ /* Llib/ssl.scm 1040 */
long BgL_res2680z00_3313;
{ /* Llib/ssl.scm 1040 */
long BgL_arg1409z00_3310;
BgL_arg1409z00_3310 = 
(long)(BgL_arg1272z00_3300); 
{ /* Llib/ssl.scm 1040 */
long BgL_res2679z00_3312;
BgL_res2679z00_3312 = 
(long)(BgL_arg1409z00_3310); 
BgL_res2680z00_3313 = BgL_res2679z00_3312; } } 
BgL_res2681z00_3314 = BgL_res2680z00_3313; } }  else 
{ /* Llib/ssl.scm 1040 */
BgL_res2681z00_3314 = 
(BgL_n1z00_3296%BgL_n2z00_3297); } } } 
BgL_restz00_3285 = BgL_res2681z00_3314; } } 
{ /* Llib/ssl.scm 1040 */

{ /* Llib/ssl.scm 1040 */
obj_t BgL_bucketz00_3287;
BgL_bucketz00_3287 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3277),BgL_modz00_3283); 
BgL_res2682z00_3319 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3287),BgL_restz00_3285); } } } } } } } } 
BgL_method1295z00_1734 = BgL_res2682z00_3319; } 
return 
PROCEDURE_ENTRY(BgL_method1295z00_1734)(BgL_method1295z00_1734, 
((obj_t)BgL_sslz00_102), BgL_bufz00_103, BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-connection-load-session */
obj_t BGl_z62sslzd2connectionzd2loadzd2sessionzb0zz__ssl_sslz00(obj_t BgL_envz00_5482, obj_t BgL_sslz00_5483, obj_t BgL_bufz00_5484)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1040 */
{ /* Llib/ssl.scm 1040 */
obj_t BgL_auxz00_10260;BgL_sslzd2connectionzd2_bglt BgL_auxz00_10252;
if(
STRINGP(BgL_bufz00_5484))
{ /* Llib/ssl.scm 1040 */
BgL_auxz00_10260 = BgL_bufz00_5484
; }  else 
{ 
obj_t BgL_auxz00_10263;
BgL_auxz00_10263 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)42384)), BGl_string3764z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_bufz00_5484); 
FAILURE(BgL_auxz00_10263,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5483, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1040 */
BgL_auxz00_10252 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5483)
; }  else 
{ 
obj_t BgL_auxz00_10256;
BgL_auxz00_10256 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)42384)), BGl_string3764z00zz__ssl_sslz00, BGl_string3750z00zz__ssl_sslz00, BgL_sslz00_5483); 
FAILURE(BgL_auxz00_10256,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2loadzd2sessionzd2zz__ssl_sslz00(BgL_auxz00_10252, BgL_auxz00_10260);} } 
BGL_FUNCTION_END;
}



/* ssl-connection-verify-error */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2verifyzd2errorzd2zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_104)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1050 */
{ /* Llib/ssl.scm 1050 */
obj_t BgL_method1297z00_1735;
{ /* Llib/ssl.scm 1050 */
obj_t BgL_res2694z00_3364;
{ /* Llib/ssl.scm 1050 */
long BgL_objzd2classzd2numz00_3321;
{ /* Llib/ssl.scm 1050 */
long BgL_res2683z00_3324;
BgL_res2683z00_3324 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_104)); 
BgL_objzd2classzd2numz00_3321 = BgL_res2683z00_3324; } 
{ /* Llib/ssl.scm 1050 */
obj_t BgL_arg1742z00_3322;
BgL_arg1742z00_3322 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2verifyzd2errorzd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1050 */
int BgL_offsetz00_3326;
BgL_offsetz00_3326 = 
(int)(BgL_objzd2classzd2numz00_3321); 
{ /* Llib/ssl.scm 1050 */
long BgL_offsetz00_3327;
BgL_offsetz00_3327 = 
(
(long)(BgL_offsetz00_3326)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1050 */
long BgL_modz00_3328;
{ /* Llib/ssl.scm 1050 */
int BgL_arg1744z00_3329;
BgL_arg1744z00_3329 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1050 */
long BgL_res2686z00_3339;
{ /* Llib/ssl.scm 1050 */
long BgL_tmpz00_10276;
BgL_tmpz00_10276 = 
(long)(BgL_arg1744z00_3329); 
BgL_res2686z00_3339 = 
(BgL_offsetz00_3327/BgL_tmpz00_10276); } 
BgL_modz00_3328 = BgL_res2686z00_3339; } } 
{ /* Llib/ssl.scm 1050 */
long BgL_restz00_3330;
{ /* Llib/ssl.scm 1050 */
int BgL_arg1743z00_3331;
BgL_arg1743z00_3331 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1050 */
long BgL_res2693z00_3359;
{ /* Llib/ssl.scm 1050 */
long BgL_n1z00_3341;long BgL_n2z00_3342;
BgL_n1z00_3341 = BgL_offsetz00_3327; 
BgL_n2z00_3342 = 
(long)(BgL_arg1743z00_3331); 
{ /* Llib/ssl.scm 1050 */
bool_t BgL_testz00_10281;
{ /* Llib/ssl.scm 1050 */
long BgL_arg1283z00_3344;
BgL_arg1283z00_3344 = 
(((BgL_n1z00_3341) | (BgL_n2z00_3342)) & -2147483648); 
BgL_testz00_10281 = 
(BgL_arg1283z00_3344==((long)0)); } 
if(BgL_testz00_10281)
{ /* Llib/ssl.scm 1050 */
int32_t BgL_arg1272z00_3345;
{ /* Llib/ssl.scm 1050 */
int32_t BgL_arg1278z00_3346;int32_t BgL_arg1279z00_3347;
{ /* Llib/ssl.scm 1050 */
int32_t BgL_res2689z00_3351;
BgL_res2689z00_3351 = 
(int32_t)(BgL_n1z00_3341); 
BgL_arg1278z00_3346 = BgL_res2689z00_3351; } 
{ /* Llib/ssl.scm 1050 */
int32_t BgL_res2690z00_3353;
BgL_res2690z00_3353 = 
(int32_t)(BgL_n2z00_3342); 
BgL_arg1279z00_3347 = BgL_res2690z00_3353; } 
BgL_arg1272z00_3345 = 
(BgL_arg1278z00_3346%BgL_arg1279z00_3347); } 
{ /* Llib/ssl.scm 1050 */
long BgL_res2692z00_3358;
{ /* Llib/ssl.scm 1050 */
long BgL_arg1409z00_3355;
BgL_arg1409z00_3355 = 
(long)(BgL_arg1272z00_3345); 
{ /* Llib/ssl.scm 1050 */
long BgL_res2691z00_3357;
BgL_res2691z00_3357 = 
(long)(BgL_arg1409z00_3355); 
BgL_res2692z00_3358 = BgL_res2691z00_3357; } } 
BgL_res2693z00_3359 = BgL_res2692z00_3358; } }  else 
{ /* Llib/ssl.scm 1050 */
BgL_res2693z00_3359 = 
(BgL_n1z00_3341%BgL_n2z00_3342); } } } 
BgL_restz00_3330 = BgL_res2693z00_3359; } } 
{ /* Llib/ssl.scm 1050 */

{ /* Llib/ssl.scm 1050 */
obj_t BgL_bucketz00_3332;
BgL_bucketz00_3332 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3322),BgL_modz00_3328); 
BgL_res2694z00_3364 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3332),BgL_restz00_3330); } } } } } } } } 
BgL_method1297z00_1735 = BgL_res2694z00_3364; } 
return 
PROCEDURE_ENTRY(BgL_method1297z00_1735)(BgL_method1297z00_1735, 
((obj_t)BgL_sslz00_104), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-connection-verify-error */
obj_t BGl_z62sslzd2connectionzd2verifyzd2errorzb0zz__ssl_sslz00(obj_t BgL_envz00_5485, obj_t BgL_sslz00_5486)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1050 */
{ /* Llib/ssl.scm 1050 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_10299;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5486, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1050 */
BgL_auxz00_10299 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5486)
; }  else 
{ 
obj_t BgL_auxz00_10303;
BgL_auxz00_10303 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)42794)), BGl_string3765z00zz__ssl_sslz00, BGl_string3750z00zz__ssl_sslz00, BgL_sslz00_5486); 
FAILURE(BgL_auxz00_10303,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2verifyzd2errorzd2zz__ssl_sslz00(BgL_auxz00_10299);} } 
BGL_FUNCTION_END;
}



/* ssl-connection-get-peer-certificate */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2getzd2peerzd2certificatez00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_105)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1060 */
{ /* Llib/ssl.scm 1060 */
obj_t BgL_method1299z00_1736;
{ /* Llib/ssl.scm 1060 */
obj_t BgL_res2706z00_3409;
{ /* Llib/ssl.scm 1060 */
long BgL_objzd2classzd2numz00_3366;
{ /* Llib/ssl.scm 1060 */
long BgL_res2695z00_3369;
BgL_res2695z00_3369 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_105)); 
BgL_objzd2classzd2numz00_3366 = BgL_res2695z00_3369; } 
{ /* Llib/ssl.scm 1060 */
obj_t BgL_arg1742z00_3367;
BgL_arg1742z00_3367 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2getzd2peerzd2certificatezd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1060 */
int BgL_offsetz00_3371;
BgL_offsetz00_3371 = 
(int)(BgL_objzd2classzd2numz00_3366); 
{ /* Llib/ssl.scm 1060 */
long BgL_offsetz00_3372;
BgL_offsetz00_3372 = 
(
(long)(BgL_offsetz00_3371)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1060 */
long BgL_modz00_3373;
{ /* Llib/ssl.scm 1060 */
int BgL_arg1744z00_3374;
BgL_arg1744z00_3374 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1060 */
long BgL_res2698z00_3384;
{ /* Llib/ssl.scm 1060 */
long BgL_tmpz00_10316;
BgL_tmpz00_10316 = 
(long)(BgL_arg1744z00_3374); 
BgL_res2698z00_3384 = 
(BgL_offsetz00_3372/BgL_tmpz00_10316); } 
BgL_modz00_3373 = BgL_res2698z00_3384; } } 
{ /* Llib/ssl.scm 1060 */
long BgL_restz00_3375;
{ /* Llib/ssl.scm 1060 */
int BgL_arg1743z00_3376;
BgL_arg1743z00_3376 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1060 */
long BgL_res2705z00_3404;
{ /* Llib/ssl.scm 1060 */
long BgL_n1z00_3386;long BgL_n2z00_3387;
BgL_n1z00_3386 = BgL_offsetz00_3372; 
BgL_n2z00_3387 = 
(long)(BgL_arg1743z00_3376); 
{ /* Llib/ssl.scm 1060 */
bool_t BgL_testz00_10321;
{ /* Llib/ssl.scm 1060 */
long BgL_arg1283z00_3389;
BgL_arg1283z00_3389 = 
(((BgL_n1z00_3386) | (BgL_n2z00_3387)) & -2147483648); 
BgL_testz00_10321 = 
(BgL_arg1283z00_3389==((long)0)); } 
if(BgL_testz00_10321)
{ /* Llib/ssl.scm 1060 */
int32_t BgL_arg1272z00_3390;
{ /* Llib/ssl.scm 1060 */
int32_t BgL_arg1278z00_3391;int32_t BgL_arg1279z00_3392;
{ /* Llib/ssl.scm 1060 */
int32_t BgL_res2701z00_3396;
BgL_res2701z00_3396 = 
(int32_t)(BgL_n1z00_3386); 
BgL_arg1278z00_3391 = BgL_res2701z00_3396; } 
{ /* Llib/ssl.scm 1060 */
int32_t BgL_res2702z00_3398;
BgL_res2702z00_3398 = 
(int32_t)(BgL_n2z00_3387); 
BgL_arg1279z00_3392 = BgL_res2702z00_3398; } 
BgL_arg1272z00_3390 = 
(BgL_arg1278z00_3391%BgL_arg1279z00_3392); } 
{ /* Llib/ssl.scm 1060 */
long BgL_res2704z00_3403;
{ /* Llib/ssl.scm 1060 */
long BgL_arg1409z00_3400;
BgL_arg1409z00_3400 = 
(long)(BgL_arg1272z00_3390); 
{ /* Llib/ssl.scm 1060 */
long BgL_res2703z00_3402;
BgL_res2703z00_3402 = 
(long)(BgL_arg1409z00_3400); 
BgL_res2704z00_3403 = BgL_res2703z00_3402; } } 
BgL_res2705z00_3404 = BgL_res2704z00_3403; } }  else 
{ /* Llib/ssl.scm 1060 */
BgL_res2705z00_3404 = 
(BgL_n1z00_3386%BgL_n2z00_3387); } } } 
BgL_restz00_3375 = BgL_res2705z00_3404; } } 
{ /* Llib/ssl.scm 1060 */

{ /* Llib/ssl.scm 1060 */
obj_t BgL_bucketz00_3377;
BgL_bucketz00_3377 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3367),BgL_modz00_3373); 
BgL_res2706z00_3409 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3377),BgL_restz00_3375); } } } } } } } } 
BgL_method1299z00_1736 = BgL_res2706z00_3409; } 
return 
PROCEDURE_ENTRY(BgL_method1299z00_1736)(BgL_method1299z00_1736, 
((obj_t)BgL_sslz00_105), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-connection-get-peer-certificate */
obj_t BGl_z62sslzd2connectionzd2getzd2peerzd2certificatez62zz__ssl_sslz00(obj_t BgL_envz00_5487, obj_t BgL_sslz00_5488)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1060 */
{ /* Llib/ssl.scm 1060 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_10339;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5488, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1060 */
BgL_auxz00_10339 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5488)
; }  else 
{ 
obj_t BgL_auxz00_10343;
BgL_auxz00_10343 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)43187)), BGl_string3766z00zz__ssl_sslz00, BGl_string3750z00zz__ssl_sslz00, BgL_sslz00_5488); 
FAILURE(BgL_auxz00_10343,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2getzd2peerzd2certificatez00zz__ssl_sslz00(BgL_auxz00_10339);} } 
BGL_FUNCTION_END;
}



/* ssl-connection-reused? */
BGL_EXPORTED_DEF bool_t BGl_sslzd2connectionzd2reusedzf3zf3zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_106)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1070 */
{ /* Llib/ssl.scm 1070 */
obj_t BgL_method1301z00_1737;
{ /* Llib/ssl.scm 1070 */
obj_t BgL_res2718z00_3454;
{ /* Llib/ssl.scm 1070 */
long BgL_objzd2classzd2numz00_3411;
{ /* Llib/ssl.scm 1070 */
long BgL_res2707z00_3414;
BgL_res2707z00_3414 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_106)); 
BgL_objzd2classzd2numz00_3411 = BgL_res2707z00_3414; } 
{ /* Llib/ssl.scm 1070 */
obj_t BgL_arg1742z00_3412;
BgL_arg1742z00_3412 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2reusedzf3zd2envz21zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1070 */
int BgL_offsetz00_3416;
BgL_offsetz00_3416 = 
(int)(BgL_objzd2classzd2numz00_3411); 
{ /* Llib/ssl.scm 1070 */
long BgL_offsetz00_3417;
BgL_offsetz00_3417 = 
(
(long)(BgL_offsetz00_3416)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1070 */
long BgL_modz00_3418;
{ /* Llib/ssl.scm 1070 */
int BgL_arg1744z00_3419;
BgL_arg1744z00_3419 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1070 */
long BgL_res2710z00_3429;
{ /* Llib/ssl.scm 1070 */
long BgL_tmpz00_10356;
BgL_tmpz00_10356 = 
(long)(BgL_arg1744z00_3419); 
BgL_res2710z00_3429 = 
(BgL_offsetz00_3417/BgL_tmpz00_10356); } 
BgL_modz00_3418 = BgL_res2710z00_3429; } } 
{ /* Llib/ssl.scm 1070 */
long BgL_restz00_3420;
{ /* Llib/ssl.scm 1070 */
int BgL_arg1743z00_3421;
BgL_arg1743z00_3421 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1070 */
long BgL_res2717z00_3449;
{ /* Llib/ssl.scm 1070 */
long BgL_n1z00_3431;long BgL_n2z00_3432;
BgL_n1z00_3431 = BgL_offsetz00_3417; 
BgL_n2z00_3432 = 
(long)(BgL_arg1743z00_3421); 
{ /* Llib/ssl.scm 1070 */
bool_t BgL_testz00_10361;
{ /* Llib/ssl.scm 1070 */
long BgL_arg1283z00_3434;
BgL_arg1283z00_3434 = 
(((BgL_n1z00_3431) | (BgL_n2z00_3432)) & -2147483648); 
BgL_testz00_10361 = 
(BgL_arg1283z00_3434==((long)0)); } 
if(BgL_testz00_10361)
{ /* Llib/ssl.scm 1070 */
int32_t BgL_arg1272z00_3435;
{ /* Llib/ssl.scm 1070 */
int32_t BgL_arg1278z00_3436;int32_t BgL_arg1279z00_3437;
{ /* Llib/ssl.scm 1070 */
int32_t BgL_res2713z00_3441;
BgL_res2713z00_3441 = 
(int32_t)(BgL_n1z00_3431); 
BgL_arg1278z00_3436 = BgL_res2713z00_3441; } 
{ /* Llib/ssl.scm 1070 */
int32_t BgL_res2714z00_3443;
BgL_res2714z00_3443 = 
(int32_t)(BgL_n2z00_3432); 
BgL_arg1279z00_3437 = BgL_res2714z00_3443; } 
BgL_arg1272z00_3435 = 
(BgL_arg1278z00_3436%BgL_arg1279z00_3437); } 
{ /* Llib/ssl.scm 1070 */
long BgL_res2716z00_3448;
{ /* Llib/ssl.scm 1070 */
long BgL_arg1409z00_3445;
BgL_arg1409z00_3445 = 
(long)(BgL_arg1272z00_3435); 
{ /* Llib/ssl.scm 1070 */
long BgL_res2715z00_3447;
BgL_res2715z00_3447 = 
(long)(BgL_arg1409z00_3445); 
BgL_res2716z00_3448 = BgL_res2715z00_3447; } } 
BgL_res2717z00_3449 = BgL_res2716z00_3448; } }  else 
{ /* Llib/ssl.scm 1070 */
BgL_res2717z00_3449 = 
(BgL_n1z00_3431%BgL_n2z00_3432); } } } 
BgL_restz00_3420 = BgL_res2717z00_3449; } } 
{ /* Llib/ssl.scm 1070 */

{ /* Llib/ssl.scm 1070 */
obj_t BgL_bucketz00_3422;
BgL_bucketz00_3422 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3412),BgL_modz00_3418); 
BgL_res2718z00_3454 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3422),BgL_restz00_3420); } } } } } } } } 
BgL_method1301z00_1737 = BgL_res2718z00_3454; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1301z00_1737)(BgL_method1301z00_1737, 
((obj_t)BgL_sslz00_106), BEOA));} } 
BGL_FUNCTION_END;
}



/* &ssl-connection-reused? */
obj_t BGl_z62sslzd2connectionzd2reusedzf3z91zz__ssl_sslz00(obj_t BgL_envz00_5489, obj_t BgL_sslz00_5490)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1070 */
{ /* Llib/ssl.scm 1070 */
bool_t BgL_tmpz00_10380;
{ /* Llib/ssl.scm 1070 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_10381;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5490, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1070 */
BgL_auxz00_10381 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5490)
; }  else 
{ 
obj_t BgL_auxz00_10385;
BgL_auxz00_10385 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)43596)), BGl_string3767z00zz__ssl_sslz00, BGl_string3750z00zz__ssl_sslz00, BgL_sslz00_5490); 
FAILURE(BgL_auxz00_10385,BFALSE,BFALSE);} 
BgL_tmpz00_10380 = 
BGl_sslzd2connectionzd2reusedzf3zf3zz__ssl_sslz00(BgL_auxz00_10381); } 
return 
BBOOL(BgL_tmpz00_10380);} } 
BGL_FUNCTION_END;
}



/* ssl-connection-get-negotiated-protocol */
BGL_EXPORTED_DEF obj_t BGl_sslzd2connectionzd2getzd2negotiatedzd2protocolz00zz__ssl_sslz00(BgL_sslzd2connectionzd2_bglt BgL_sslz00_107)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1081 */
{ /* Llib/ssl.scm 1081 */
obj_t BgL_method1303z00_1738;
{ /* Llib/ssl.scm 1081 */
obj_t BgL_res2730z00_3499;
{ /* Llib/ssl.scm 1081 */
long BgL_objzd2classzd2numz00_3456;
{ /* Llib/ssl.scm 1081 */
long BgL_res2719z00_3459;
BgL_res2719z00_3459 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslz00_107)); 
BgL_objzd2classzd2numz00_3456 = BgL_res2719z00_3459; } 
{ /* Llib/ssl.scm 1081 */
obj_t BgL_arg1742z00_3457;
BgL_arg1742z00_3457 = 
PROCEDURE_REF(BGl_sslzd2connectionzd2getzd2negotiatedzd2protocolzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1081 */
int BgL_offsetz00_3461;
BgL_offsetz00_3461 = 
(int)(BgL_objzd2classzd2numz00_3456); 
{ /* Llib/ssl.scm 1081 */
long BgL_offsetz00_3462;
BgL_offsetz00_3462 = 
(
(long)(BgL_offsetz00_3461)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1081 */
long BgL_modz00_3463;
{ /* Llib/ssl.scm 1081 */
int BgL_arg1744z00_3464;
BgL_arg1744z00_3464 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1081 */
long BgL_res2722z00_3474;
{ /* Llib/ssl.scm 1081 */
long BgL_tmpz00_10399;
BgL_tmpz00_10399 = 
(long)(BgL_arg1744z00_3464); 
BgL_res2722z00_3474 = 
(BgL_offsetz00_3462/BgL_tmpz00_10399); } 
BgL_modz00_3463 = BgL_res2722z00_3474; } } 
{ /* Llib/ssl.scm 1081 */
long BgL_restz00_3465;
{ /* Llib/ssl.scm 1081 */
int BgL_arg1743z00_3466;
BgL_arg1743z00_3466 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1081 */
long BgL_res2729z00_3494;
{ /* Llib/ssl.scm 1081 */
long BgL_n1z00_3476;long BgL_n2z00_3477;
BgL_n1z00_3476 = BgL_offsetz00_3462; 
BgL_n2z00_3477 = 
(long)(BgL_arg1743z00_3466); 
{ /* Llib/ssl.scm 1081 */
bool_t BgL_testz00_10404;
{ /* Llib/ssl.scm 1081 */
long BgL_arg1283z00_3479;
BgL_arg1283z00_3479 = 
(((BgL_n1z00_3476) | (BgL_n2z00_3477)) & -2147483648); 
BgL_testz00_10404 = 
(BgL_arg1283z00_3479==((long)0)); } 
if(BgL_testz00_10404)
{ /* Llib/ssl.scm 1081 */
int32_t BgL_arg1272z00_3480;
{ /* Llib/ssl.scm 1081 */
int32_t BgL_arg1278z00_3481;int32_t BgL_arg1279z00_3482;
{ /* Llib/ssl.scm 1081 */
int32_t BgL_res2725z00_3486;
BgL_res2725z00_3486 = 
(int32_t)(BgL_n1z00_3476); 
BgL_arg1278z00_3481 = BgL_res2725z00_3486; } 
{ /* Llib/ssl.scm 1081 */
int32_t BgL_res2726z00_3488;
BgL_res2726z00_3488 = 
(int32_t)(BgL_n2z00_3477); 
BgL_arg1279z00_3482 = BgL_res2726z00_3488; } 
BgL_arg1272z00_3480 = 
(BgL_arg1278z00_3481%BgL_arg1279z00_3482); } 
{ /* Llib/ssl.scm 1081 */
long BgL_res2728z00_3493;
{ /* Llib/ssl.scm 1081 */
long BgL_arg1409z00_3490;
BgL_arg1409z00_3490 = 
(long)(BgL_arg1272z00_3480); 
{ /* Llib/ssl.scm 1081 */
long BgL_res2727z00_3492;
BgL_res2727z00_3492 = 
(long)(BgL_arg1409z00_3490); 
BgL_res2728z00_3493 = BgL_res2727z00_3492; } } 
BgL_res2729z00_3494 = BgL_res2728z00_3493; } }  else 
{ /* Llib/ssl.scm 1081 */
BgL_res2729z00_3494 = 
(BgL_n1z00_3476%BgL_n2z00_3477); } } } 
BgL_restz00_3465 = BgL_res2729z00_3494; } } 
{ /* Llib/ssl.scm 1081 */

{ /* Llib/ssl.scm 1081 */
obj_t BgL_bucketz00_3467;
BgL_bucketz00_3467 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3457),BgL_modz00_3463); 
BgL_res2730z00_3499 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3467),BgL_restz00_3465); } } } } } } } } 
BgL_method1303z00_1738 = BgL_res2730z00_3499; } 
return 
PROCEDURE_ENTRY(BgL_method1303z00_1738)(BgL_method1303z00_1738, 
((obj_t)BgL_sslz00_107), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-connection-get-negotiated-protocol */
obj_t BGl_z62sslzd2connectionzd2getzd2negotiatedzd2protocolz62zz__ssl_sslz00(obj_t BgL_envz00_5491, obj_t BgL_sslz00_5492)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1081 */
{ /* Llib/ssl.scm 1081 */
BgL_sslzd2connectionzd2_bglt BgL_auxz00_10422;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslz00_5492, BGl_sslzd2connectionzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1081 */
BgL_auxz00_10422 = 
((BgL_sslzd2connectionzd2_bglt)BgL_sslz00_5492)
; }  else 
{ 
obj_t BgL_auxz00_10426;
BgL_auxz00_10426 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)44022)), BGl_string3768z00zz__ssl_sslz00, BGl_string3750z00zz__ssl_sslz00, BgL_sslz00_5492); 
FAILURE(BgL_auxz00_10426,BFALSE,BFALSE);} 
return 
BGl_sslzd2connectionzd2getzd2negotiatedzd2protocolz00zz__ssl_sslz00(BgL_auxz00_10422);} } 
BGL_FUNCTION_END;
}



/* &dh-init */
obj_t BGl_z62dhzd2initzb0zz__ssl_sslz00(obj_t BgL_envz00_5163, obj_t BgL_dhz00_5164)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1091 */
{ /* Llib/ssl.scm 1091 */
BgL_dhz00_bglt BgL_dhz00_6506;
if(
BGl_isazf3zf3zz__objectz00(BgL_dhz00_5164, BGl_dhz00zz__ssl_sslz00))
{ /* Llib/ssl.scm 1091 */
BgL_dhz00_6506 = 
((BgL_dhz00_bglt)BgL_dhz00_5164); }  else 
{ 
obj_t BgL_auxz00_10434;
BgL_auxz00_10434 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)44437)), BGl_string3769z00zz__ssl_sslz00, BGl_string3770z00zz__ssl_sslz00, BgL_dhz00_5164); 
FAILURE(BgL_auxz00_10434,BFALSE,BFALSE);} 
{ /* Llib/ssl.scm 1091 */
obj_t BgL_method1305z00_6507;
{ /* Llib/ssl.scm 1091 */
obj_t BgL_res2742z00_6508;
{ /* Llib/ssl.scm 1091 */
long BgL_objzd2classzd2numz00_6509;
{ /* Llib/ssl.scm 1091 */
long BgL_res2731z00_6510;
BgL_res2731z00_6510 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_dhz00_6506)); 
BgL_objzd2classzd2numz00_6509 = BgL_res2731z00_6510; } 
{ /* Llib/ssl.scm 1091 */
obj_t BgL_arg1742z00_6511;
BgL_arg1742z00_6511 = 
PROCEDURE_REF(BGl_dhzd2initzd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1091 */
int BgL_offsetz00_6512;
BgL_offsetz00_6512 = 
(int)(BgL_objzd2classzd2numz00_6509); 
{ /* Llib/ssl.scm 1091 */
long BgL_offsetz00_6513;
BgL_offsetz00_6513 = 
(
(long)(BgL_offsetz00_6512)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1091 */
long BgL_modz00_6514;
{ /* Llib/ssl.scm 1091 */
int BgL_arg1744z00_6515;
BgL_arg1744z00_6515 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1091 */
long BgL_res2734z00_6516;
{ /* Llib/ssl.scm 1091 */
long BgL_tmpz00_10446;
BgL_tmpz00_10446 = 
(long)(BgL_arg1744z00_6515); 
BgL_res2734z00_6516 = 
(BgL_offsetz00_6513/BgL_tmpz00_10446); } 
BgL_modz00_6514 = BgL_res2734z00_6516; } } 
{ /* Llib/ssl.scm 1091 */
long BgL_restz00_6517;
{ /* Llib/ssl.scm 1091 */
int BgL_arg1743z00_6518;
BgL_arg1743z00_6518 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1091 */
long BgL_res2741z00_6519;
{ /* Llib/ssl.scm 1091 */
long BgL_n1z00_6520;long BgL_n2z00_6521;
BgL_n1z00_6520 = BgL_offsetz00_6513; 
BgL_n2z00_6521 = 
(long)(BgL_arg1743z00_6518); 
{ /* Llib/ssl.scm 1091 */
bool_t BgL_testz00_10451;
{ /* Llib/ssl.scm 1091 */
long BgL_arg1283z00_6522;
BgL_arg1283z00_6522 = 
(((BgL_n1z00_6520) | (BgL_n2z00_6521)) & -2147483648); 
BgL_testz00_10451 = 
(BgL_arg1283z00_6522==((long)0)); } 
if(BgL_testz00_10451)
{ /* Llib/ssl.scm 1091 */
int32_t BgL_arg1272z00_6523;
{ /* Llib/ssl.scm 1091 */
int32_t BgL_arg1278z00_6524;int32_t BgL_arg1279z00_6525;
{ /* Llib/ssl.scm 1091 */
int32_t BgL_res2737z00_6526;
BgL_res2737z00_6526 = 
(int32_t)(BgL_n1z00_6520); 
BgL_arg1278z00_6524 = BgL_res2737z00_6526; } 
{ /* Llib/ssl.scm 1091 */
int32_t BgL_res2738z00_6527;
BgL_res2738z00_6527 = 
(int32_t)(BgL_n2z00_6521); 
BgL_arg1279z00_6525 = BgL_res2738z00_6527; } 
BgL_arg1272z00_6523 = 
(BgL_arg1278z00_6524%BgL_arg1279z00_6525); } 
{ /* Llib/ssl.scm 1091 */
long BgL_res2740z00_6528;
{ /* Llib/ssl.scm 1091 */
long BgL_arg1409z00_6529;
BgL_arg1409z00_6529 = 
(long)(BgL_arg1272z00_6523); 
{ /* Llib/ssl.scm 1091 */
long BgL_res2739z00_6530;
BgL_res2739z00_6530 = 
(long)(BgL_arg1409z00_6529); 
BgL_res2740z00_6528 = BgL_res2739z00_6530; } } 
BgL_res2741z00_6519 = BgL_res2740z00_6528; } }  else 
{ /* Llib/ssl.scm 1091 */
BgL_res2741z00_6519 = 
(BgL_n1z00_6520%BgL_n2z00_6521); } } } 
BgL_restz00_6517 = BgL_res2741z00_6519; } } 
{ /* Llib/ssl.scm 1091 */

{ /* Llib/ssl.scm 1091 */
obj_t BgL_bucketz00_6531;
BgL_bucketz00_6531 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_6511),BgL_modz00_6514); 
BgL_res2742z00_6508 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_6531),BgL_restz00_6517); } } } } } } } } 
BgL_method1305z00_6507 = BgL_res2742z00_6508; } 
return 
PROCEDURE_ENTRY(BgL_method1305z00_6507)(BgL_method1305z00_6507, 
((obj_t)BgL_dhz00_6506), BEOA);} } } 
BGL_FUNCTION_END;
}



/* dh-size */
BGL_EXPORTED_DEF int BGl_dhzd2siza7ez75zz__ssl_sslz00(BgL_dhz00_bglt BgL_dhz00_109)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1102 */
{ /* Llib/ssl.scm 1102 */
obj_t BgL_method1307z00_1740;
{ /* Llib/ssl.scm 1102 */
obj_t BgL_res2754z00_3589;
{ /* Llib/ssl.scm 1102 */
long BgL_objzd2classzd2numz00_3546;
{ /* Llib/ssl.scm 1102 */
long BgL_res2743z00_3549;
BgL_res2743z00_3549 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_dhz00_109)); 
BgL_objzd2classzd2numz00_3546 = BgL_res2743z00_3549; } 
{ /* Llib/ssl.scm 1102 */
obj_t BgL_arg1742z00_3547;
BgL_arg1742z00_3547 = 
PROCEDURE_REF(BGl_dhzd2siza7ezd2envza7zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1102 */
int BgL_offsetz00_3551;
BgL_offsetz00_3551 = 
(int)(BgL_objzd2classzd2numz00_3546); 
{ /* Llib/ssl.scm 1102 */
long BgL_offsetz00_3552;
BgL_offsetz00_3552 = 
(
(long)(BgL_offsetz00_3551)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1102 */
long BgL_modz00_3553;
{ /* Llib/ssl.scm 1102 */
int BgL_arg1744z00_3554;
BgL_arg1744z00_3554 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1102 */
long BgL_res2746z00_3564;
{ /* Llib/ssl.scm 1102 */
long BgL_tmpz00_10477;
BgL_tmpz00_10477 = 
(long)(BgL_arg1744z00_3554); 
BgL_res2746z00_3564 = 
(BgL_offsetz00_3552/BgL_tmpz00_10477); } 
BgL_modz00_3553 = BgL_res2746z00_3564; } } 
{ /* Llib/ssl.scm 1102 */
long BgL_restz00_3555;
{ /* Llib/ssl.scm 1102 */
int BgL_arg1743z00_3556;
BgL_arg1743z00_3556 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1102 */
long BgL_res2753z00_3584;
{ /* Llib/ssl.scm 1102 */
long BgL_n1z00_3566;long BgL_n2z00_3567;
BgL_n1z00_3566 = BgL_offsetz00_3552; 
BgL_n2z00_3567 = 
(long)(BgL_arg1743z00_3556); 
{ /* Llib/ssl.scm 1102 */
bool_t BgL_testz00_10482;
{ /* Llib/ssl.scm 1102 */
long BgL_arg1283z00_3569;
BgL_arg1283z00_3569 = 
(((BgL_n1z00_3566) | (BgL_n2z00_3567)) & -2147483648); 
BgL_testz00_10482 = 
(BgL_arg1283z00_3569==((long)0)); } 
if(BgL_testz00_10482)
{ /* Llib/ssl.scm 1102 */
int32_t BgL_arg1272z00_3570;
{ /* Llib/ssl.scm 1102 */
int32_t BgL_arg1278z00_3571;int32_t BgL_arg1279z00_3572;
{ /* Llib/ssl.scm 1102 */
int32_t BgL_res2749z00_3576;
BgL_res2749z00_3576 = 
(int32_t)(BgL_n1z00_3566); 
BgL_arg1278z00_3571 = BgL_res2749z00_3576; } 
{ /* Llib/ssl.scm 1102 */
int32_t BgL_res2750z00_3578;
BgL_res2750z00_3578 = 
(int32_t)(BgL_n2z00_3567); 
BgL_arg1279z00_3572 = BgL_res2750z00_3578; } 
BgL_arg1272z00_3570 = 
(BgL_arg1278z00_3571%BgL_arg1279z00_3572); } 
{ /* Llib/ssl.scm 1102 */
long BgL_res2752z00_3583;
{ /* Llib/ssl.scm 1102 */
long BgL_arg1409z00_3580;
BgL_arg1409z00_3580 = 
(long)(BgL_arg1272z00_3570); 
{ /* Llib/ssl.scm 1102 */
long BgL_res2751z00_3582;
BgL_res2751z00_3582 = 
(long)(BgL_arg1409z00_3580); 
BgL_res2752z00_3583 = BgL_res2751z00_3582; } } 
BgL_res2753z00_3584 = BgL_res2752z00_3583; } }  else 
{ /* Llib/ssl.scm 1102 */
BgL_res2753z00_3584 = 
(BgL_n1z00_3566%BgL_n2z00_3567); } } } 
BgL_restz00_3555 = BgL_res2753z00_3584; } } 
{ /* Llib/ssl.scm 1102 */

{ /* Llib/ssl.scm 1102 */
obj_t BgL_bucketz00_3557;
BgL_bucketz00_3557 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3547),BgL_modz00_3553); 
BgL_res2754z00_3589 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3557),BgL_restz00_3555); } } } } } } } } 
BgL_method1307z00_1740 = BgL_res2754z00_3589; } 
return 
CINT(
PROCEDURE_ENTRY(BgL_method1307z00_1740)(BgL_method1307z00_1740, 
((obj_t)BgL_dhz00_109), BEOA));} } 
BGL_FUNCTION_END;
}



/* &dh-size */
obj_t BGl_z62dhzd2siza7ez17zz__ssl_sslz00(obj_t BgL_envz00_5493, obj_t BgL_dhz00_5494)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1102 */
{ /* Llib/ssl.scm 1102 */
int BgL_tmpz00_10501;
{ /* Llib/ssl.scm 1102 */
BgL_dhz00_bglt BgL_auxz00_10502;
if(
BGl_isazf3zf3zz__objectz00(BgL_dhz00_5494, BGl_dhz00zz__ssl_sslz00))
{ /* Llib/ssl.scm 1102 */
BgL_auxz00_10502 = 
((BgL_dhz00_bglt)BgL_dhz00_5494)
; }  else 
{ 
obj_t BgL_auxz00_10506;
BgL_auxz00_10506 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)44817)), BGl_string3771z00zz__ssl_sslz00, BGl_string3770z00zz__ssl_sslz00, BgL_dhz00_5494); 
FAILURE(BgL_auxz00_10506,BFALSE,BFALSE);} 
BgL_tmpz00_10501 = 
BGl_dhzd2siza7ez75zz__ssl_sslz00(BgL_auxz00_10502); } 
return 
BINT(BgL_tmpz00_10501);} } 
BGL_FUNCTION_END;
}



/* dh-generate-parameters-ex */
BGL_EXPORTED_DEF obj_t BGl_dhzd2generatezd2parameterszd2exzd2zz__ssl_sslz00(BgL_dhz00_bglt BgL_dhz00_110, int BgL_lenz00_111, obj_t BgL_generatorz00_112)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1110 */
{ /* Llib/ssl.scm 1110 */
obj_t BgL_method1309z00_1741;
{ /* Llib/ssl.scm 1110 */
obj_t BgL_res2766z00_3634;
{ /* Llib/ssl.scm 1110 */
long BgL_objzd2classzd2numz00_3591;
{ /* Llib/ssl.scm 1110 */
long BgL_res2755z00_3594;
BgL_res2755z00_3594 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_dhz00_110)); 
BgL_objzd2classzd2numz00_3591 = BgL_res2755z00_3594; } 
{ /* Llib/ssl.scm 1110 */
obj_t BgL_arg1742z00_3592;
BgL_arg1742z00_3592 = 
PROCEDURE_REF(BGl_dhzd2generatezd2parameterszd2exzd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1110 */
int BgL_offsetz00_3596;
BgL_offsetz00_3596 = 
(int)(BgL_objzd2classzd2numz00_3591); 
{ /* Llib/ssl.scm 1110 */
long BgL_offsetz00_3597;
BgL_offsetz00_3597 = 
(
(long)(BgL_offsetz00_3596)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1110 */
long BgL_modz00_3598;
{ /* Llib/ssl.scm 1110 */
int BgL_arg1744z00_3599;
BgL_arg1744z00_3599 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1110 */
long BgL_res2758z00_3609;
{ /* Llib/ssl.scm 1110 */
long BgL_tmpz00_10520;
BgL_tmpz00_10520 = 
(long)(BgL_arg1744z00_3599); 
BgL_res2758z00_3609 = 
(BgL_offsetz00_3597/BgL_tmpz00_10520); } 
BgL_modz00_3598 = BgL_res2758z00_3609; } } 
{ /* Llib/ssl.scm 1110 */
long BgL_restz00_3600;
{ /* Llib/ssl.scm 1110 */
int BgL_arg1743z00_3601;
BgL_arg1743z00_3601 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1110 */
long BgL_res2765z00_3629;
{ /* Llib/ssl.scm 1110 */
long BgL_n1z00_3611;long BgL_n2z00_3612;
BgL_n1z00_3611 = BgL_offsetz00_3597; 
BgL_n2z00_3612 = 
(long)(BgL_arg1743z00_3601); 
{ /* Llib/ssl.scm 1110 */
bool_t BgL_testz00_10525;
{ /* Llib/ssl.scm 1110 */
long BgL_arg1283z00_3614;
BgL_arg1283z00_3614 = 
(((BgL_n1z00_3611) | (BgL_n2z00_3612)) & -2147483648); 
BgL_testz00_10525 = 
(BgL_arg1283z00_3614==((long)0)); } 
if(BgL_testz00_10525)
{ /* Llib/ssl.scm 1110 */
int32_t BgL_arg1272z00_3615;
{ /* Llib/ssl.scm 1110 */
int32_t BgL_arg1278z00_3616;int32_t BgL_arg1279z00_3617;
{ /* Llib/ssl.scm 1110 */
int32_t BgL_res2761z00_3621;
BgL_res2761z00_3621 = 
(int32_t)(BgL_n1z00_3611); 
BgL_arg1278z00_3616 = BgL_res2761z00_3621; } 
{ /* Llib/ssl.scm 1110 */
int32_t BgL_res2762z00_3623;
BgL_res2762z00_3623 = 
(int32_t)(BgL_n2z00_3612); 
BgL_arg1279z00_3617 = BgL_res2762z00_3623; } 
BgL_arg1272z00_3615 = 
(BgL_arg1278z00_3616%BgL_arg1279z00_3617); } 
{ /* Llib/ssl.scm 1110 */
long BgL_res2764z00_3628;
{ /* Llib/ssl.scm 1110 */
long BgL_arg1409z00_3625;
BgL_arg1409z00_3625 = 
(long)(BgL_arg1272z00_3615); 
{ /* Llib/ssl.scm 1110 */
long BgL_res2763z00_3627;
BgL_res2763z00_3627 = 
(long)(BgL_arg1409z00_3625); 
BgL_res2764z00_3628 = BgL_res2763z00_3627; } } 
BgL_res2765z00_3629 = BgL_res2764z00_3628; } }  else 
{ /* Llib/ssl.scm 1110 */
BgL_res2765z00_3629 = 
(BgL_n1z00_3611%BgL_n2z00_3612); } } } 
BgL_restz00_3600 = BgL_res2765z00_3629; } } 
{ /* Llib/ssl.scm 1110 */

{ /* Llib/ssl.scm 1110 */
obj_t BgL_bucketz00_3602;
BgL_bucketz00_3602 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3592),BgL_modz00_3598); 
BgL_res2766z00_3634 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3602),BgL_restz00_3600); } } } } } } } } 
BgL_method1309z00_1741 = BgL_res2766z00_3634; } 
return 
PROCEDURE_ENTRY(BgL_method1309z00_1741)(BgL_method1309z00_1741, 
((obj_t)BgL_dhz00_110), 
BINT(BgL_lenz00_111), BgL_generatorz00_112, BEOA);} } 
BGL_FUNCTION_END;
}



/* &dh-generate-parameters-ex */
obj_t BGl_z62dhzd2generatezd2parameterszd2exzb0zz__ssl_sslz00(obj_t BgL_envz00_5495, obj_t BgL_dhz00_5496, obj_t BgL_lenz00_5497, obj_t BgL_generatorz00_5498)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1110 */
{ /* Llib/ssl.scm 1110 */
obj_t BgL_auxz00_10563;int BgL_auxz00_10554;BgL_dhz00_bglt BgL_auxz00_10546;
if(
SYMBOLP(BgL_generatorz00_5498))
{ /* Llib/ssl.scm 1110 */
BgL_auxz00_10563 = BgL_generatorz00_5498
; }  else 
{ 
obj_t BgL_auxz00_10566;
BgL_auxz00_10566 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)45181)), BGl_string3772z00zz__ssl_sslz00, BGl_string3773z00zz__ssl_sslz00, BgL_generatorz00_5498); 
FAILURE(BgL_auxz00_10566,BFALSE,BFALSE);} 
{ /* Llib/ssl.scm 1110 */
obj_t BgL_tmpz00_10555;
if(
INTEGERP(BgL_lenz00_5497))
{ /* Llib/ssl.scm 1110 */
BgL_tmpz00_10555 = BgL_lenz00_5497
; }  else 
{ 
obj_t BgL_auxz00_10558;
BgL_auxz00_10558 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)45181)), BGl_string3772z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_lenz00_5497); 
FAILURE(BgL_auxz00_10558,BFALSE,BFALSE);} 
BgL_auxz00_10554 = 
CINT(BgL_tmpz00_10555); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_dhz00_5496, BGl_dhz00zz__ssl_sslz00))
{ /* Llib/ssl.scm 1110 */
BgL_auxz00_10546 = 
((BgL_dhz00_bglt)BgL_dhz00_5496)
; }  else 
{ 
obj_t BgL_auxz00_10550;
BgL_auxz00_10550 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)45181)), BGl_string3772z00zz__ssl_sslz00, BGl_string3770z00zz__ssl_sslz00, BgL_dhz00_5496); 
FAILURE(BgL_auxz00_10550,BFALSE,BFALSE);} 
return 
BGl_dhzd2generatezd2parameterszd2exzd2zz__ssl_sslz00(BgL_auxz00_10546, BgL_auxz00_10554, BgL_auxz00_10563);} } 
BGL_FUNCTION_END;
}



/* dh-check */
BGL_EXPORTED_DEF obj_t BGl_dhzd2checkzd2zz__ssl_sslz00(BgL_dhz00_bglt BgL_dhz00_113)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1126 */
{ /* Llib/ssl.scm 1126 */
obj_t BgL_method1311z00_1742;
{ /* Llib/ssl.scm 1126 */
obj_t BgL_res2778z00_3679;
{ /* Llib/ssl.scm 1126 */
long BgL_objzd2classzd2numz00_3636;
{ /* Llib/ssl.scm 1126 */
long BgL_res2767z00_3639;
BgL_res2767z00_3639 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_dhz00_113)); 
BgL_objzd2classzd2numz00_3636 = BgL_res2767z00_3639; } 
{ /* Llib/ssl.scm 1126 */
obj_t BgL_arg1742z00_3637;
BgL_arg1742z00_3637 = 
PROCEDURE_REF(BGl_dhzd2checkzd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1126 */
int BgL_offsetz00_3641;
BgL_offsetz00_3641 = 
(int)(BgL_objzd2classzd2numz00_3636); 
{ /* Llib/ssl.scm 1126 */
long BgL_offsetz00_3642;
BgL_offsetz00_3642 = 
(
(long)(BgL_offsetz00_3641)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1126 */
long BgL_modz00_3643;
{ /* Llib/ssl.scm 1126 */
int BgL_arg1744z00_3644;
BgL_arg1744z00_3644 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1126 */
long BgL_res2770z00_3654;
{ /* Llib/ssl.scm 1126 */
long BgL_tmpz00_10579;
BgL_tmpz00_10579 = 
(long)(BgL_arg1744z00_3644); 
BgL_res2770z00_3654 = 
(BgL_offsetz00_3642/BgL_tmpz00_10579); } 
BgL_modz00_3643 = BgL_res2770z00_3654; } } 
{ /* Llib/ssl.scm 1126 */
long BgL_restz00_3645;
{ /* Llib/ssl.scm 1126 */
int BgL_arg1743z00_3646;
BgL_arg1743z00_3646 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1126 */
long BgL_res2777z00_3674;
{ /* Llib/ssl.scm 1126 */
long BgL_n1z00_3656;long BgL_n2z00_3657;
BgL_n1z00_3656 = BgL_offsetz00_3642; 
BgL_n2z00_3657 = 
(long)(BgL_arg1743z00_3646); 
{ /* Llib/ssl.scm 1126 */
bool_t BgL_testz00_10584;
{ /* Llib/ssl.scm 1126 */
long BgL_arg1283z00_3659;
BgL_arg1283z00_3659 = 
(((BgL_n1z00_3656) | (BgL_n2z00_3657)) & -2147483648); 
BgL_testz00_10584 = 
(BgL_arg1283z00_3659==((long)0)); } 
if(BgL_testz00_10584)
{ /* Llib/ssl.scm 1126 */
int32_t BgL_arg1272z00_3660;
{ /* Llib/ssl.scm 1126 */
int32_t BgL_arg1278z00_3661;int32_t BgL_arg1279z00_3662;
{ /* Llib/ssl.scm 1126 */
int32_t BgL_res2773z00_3666;
BgL_res2773z00_3666 = 
(int32_t)(BgL_n1z00_3656); 
BgL_arg1278z00_3661 = BgL_res2773z00_3666; } 
{ /* Llib/ssl.scm 1126 */
int32_t BgL_res2774z00_3668;
BgL_res2774z00_3668 = 
(int32_t)(BgL_n2z00_3657); 
BgL_arg1279z00_3662 = BgL_res2774z00_3668; } 
BgL_arg1272z00_3660 = 
(BgL_arg1278z00_3661%BgL_arg1279z00_3662); } 
{ /* Llib/ssl.scm 1126 */
long BgL_res2776z00_3673;
{ /* Llib/ssl.scm 1126 */
long BgL_arg1409z00_3670;
BgL_arg1409z00_3670 = 
(long)(BgL_arg1272z00_3660); 
{ /* Llib/ssl.scm 1126 */
long BgL_res2775z00_3672;
BgL_res2775z00_3672 = 
(long)(BgL_arg1409z00_3670); 
BgL_res2776z00_3673 = BgL_res2775z00_3672; } } 
BgL_res2777z00_3674 = BgL_res2776z00_3673; } }  else 
{ /* Llib/ssl.scm 1126 */
BgL_res2777z00_3674 = 
(BgL_n1z00_3656%BgL_n2z00_3657); } } } 
BgL_restz00_3645 = BgL_res2777z00_3674; } } 
{ /* Llib/ssl.scm 1126 */

{ /* Llib/ssl.scm 1126 */
obj_t BgL_bucketz00_3647;
BgL_bucketz00_3647 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3637),BgL_modz00_3643); 
BgL_res2778z00_3679 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3647),BgL_restz00_3645); } } } } } } } } 
BgL_method1311z00_1742 = BgL_res2778z00_3679; } 
return 
PROCEDURE_ENTRY(BgL_method1311z00_1742)(BgL_method1311z00_1742, 
((obj_t)BgL_dhz00_113), BEOA);} } 
BGL_FUNCTION_END;
}



/* &dh-check */
obj_t BGl_z62dhzd2checkzb0zz__ssl_sslz00(obj_t BgL_envz00_5499, obj_t BgL_dhz00_5500)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1126 */
{ /* Llib/ssl.scm 1126 */
BgL_dhz00_bglt BgL_auxz00_10602;
if(
BGl_isazf3zf3zz__objectz00(BgL_dhz00_5500, BGl_dhz00zz__ssl_sslz00))
{ /* Llib/ssl.scm 1126 */
BgL_auxz00_10602 = 
((BgL_dhz00_bglt)BgL_dhz00_5500)
; }  else 
{ 
obj_t BgL_auxz00_10606;
BgL_auxz00_10606 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)45769)), BGl_string3774z00zz__ssl_sslz00, BGl_string3770z00zz__ssl_sslz00, BgL_dhz00_5500); 
FAILURE(BgL_auxz00_10606,BFALSE,BFALSE);} 
return 
BGl_dhzd2checkzd2zz__ssl_sslz00(BgL_auxz00_10602);} } 
BGL_FUNCTION_END;
}



/* dh-check-pub-key */
BGL_EXPORTED_DEF obj_t BGl_dhzd2checkzd2pubzd2keyzd2zz__ssl_sslz00(BgL_dhz00_bglt BgL_dhz00_114, obj_t BgL_keyz00_115)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1137 */
{ /* Llib/ssl.scm 1137 */
obj_t BgL_method1313z00_1743;
{ /* Llib/ssl.scm 1137 */
obj_t BgL_res2790z00_3724;
{ /* Llib/ssl.scm 1137 */
long BgL_objzd2classzd2numz00_3681;
{ /* Llib/ssl.scm 1137 */
long BgL_res2779z00_3684;
BgL_res2779z00_3684 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_dhz00_114)); 
BgL_objzd2classzd2numz00_3681 = BgL_res2779z00_3684; } 
{ /* Llib/ssl.scm 1137 */
obj_t BgL_arg1742z00_3682;
BgL_arg1742z00_3682 = 
PROCEDURE_REF(BGl_dhzd2checkzd2pubzd2keyzd2envz00zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1137 */
int BgL_offsetz00_3686;
BgL_offsetz00_3686 = 
(int)(BgL_objzd2classzd2numz00_3681); 
{ /* Llib/ssl.scm 1137 */
long BgL_offsetz00_3687;
BgL_offsetz00_3687 = 
(
(long)(BgL_offsetz00_3686)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1137 */
long BgL_modz00_3688;
{ /* Llib/ssl.scm 1137 */
int BgL_arg1744z00_3689;
BgL_arg1744z00_3689 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1137 */
long BgL_res2782z00_3699;
{ /* Llib/ssl.scm 1137 */
long BgL_tmpz00_10619;
BgL_tmpz00_10619 = 
(long)(BgL_arg1744z00_3689); 
BgL_res2782z00_3699 = 
(BgL_offsetz00_3687/BgL_tmpz00_10619); } 
BgL_modz00_3688 = BgL_res2782z00_3699; } } 
{ /* Llib/ssl.scm 1137 */
long BgL_restz00_3690;
{ /* Llib/ssl.scm 1137 */
int BgL_arg1743z00_3691;
BgL_arg1743z00_3691 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1137 */
long BgL_res2789z00_3719;
{ /* Llib/ssl.scm 1137 */
long BgL_n1z00_3701;long BgL_n2z00_3702;
BgL_n1z00_3701 = BgL_offsetz00_3687; 
BgL_n2z00_3702 = 
(long)(BgL_arg1743z00_3691); 
{ /* Llib/ssl.scm 1137 */
bool_t BgL_testz00_10624;
{ /* Llib/ssl.scm 1137 */
long BgL_arg1283z00_3704;
BgL_arg1283z00_3704 = 
(((BgL_n1z00_3701) | (BgL_n2z00_3702)) & -2147483648); 
BgL_testz00_10624 = 
(BgL_arg1283z00_3704==((long)0)); } 
if(BgL_testz00_10624)
{ /* Llib/ssl.scm 1137 */
int32_t BgL_arg1272z00_3705;
{ /* Llib/ssl.scm 1137 */
int32_t BgL_arg1278z00_3706;int32_t BgL_arg1279z00_3707;
{ /* Llib/ssl.scm 1137 */
int32_t BgL_res2785z00_3711;
BgL_res2785z00_3711 = 
(int32_t)(BgL_n1z00_3701); 
BgL_arg1278z00_3706 = BgL_res2785z00_3711; } 
{ /* Llib/ssl.scm 1137 */
int32_t BgL_res2786z00_3713;
BgL_res2786z00_3713 = 
(int32_t)(BgL_n2z00_3702); 
BgL_arg1279z00_3707 = BgL_res2786z00_3713; } 
BgL_arg1272z00_3705 = 
(BgL_arg1278z00_3706%BgL_arg1279z00_3707); } 
{ /* Llib/ssl.scm 1137 */
long BgL_res2788z00_3718;
{ /* Llib/ssl.scm 1137 */
long BgL_arg1409z00_3715;
BgL_arg1409z00_3715 = 
(long)(BgL_arg1272z00_3705); 
{ /* Llib/ssl.scm 1137 */
long BgL_res2787z00_3717;
BgL_res2787z00_3717 = 
(long)(BgL_arg1409z00_3715); 
BgL_res2788z00_3718 = BgL_res2787z00_3717; } } 
BgL_res2789z00_3719 = BgL_res2788z00_3718; } }  else 
{ /* Llib/ssl.scm 1137 */
BgL_res2789z00_3719 = 
(BgL_n1z00_3701%BgL_n2z00_3702); } } } 
BgL_restz00_3690 = BgL_res2789z00_3719; } } 
{ /* Llib/ssl.scm 1137 */

{ /* Llib/ssl.scm 1137 */
obj_t BgL_bucketz00_3692;
BgL_bucketz00_3692 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3682),BgL_modz00_3688); 
BgL_res2790z00_3724 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3692),BgL_restz00_3690); } } } } } } } } 
BgL_method1313z00_1743 = BgL_res2790z00_3724; } 
return 
PROCEDURE_ENTRY(BgL_method1313z00_1743)(BgL_method1313z00_1743, 
((obj_t)BgL_dhz00_114), BgL_keyz00_115, BEOA);} } 
BGL_FUNCTION_END;
}



/* &dh-check-pub-key */
obj_t BGl_z62dhzd2checkzd2pubzd2keyzb0zz__ssl_sslz00(obj_t BgL_envz00_5501, obj_t BgL_dhz00_5502, obj_t BgL_keyz00_5503)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1137 */
{ /* Llib/ssl.scm 1137 */
obj_t BgL_auxz00_10651;BgL_dhz00_bglt BgL_auxz00_10643;
if(
FOREIGNP(BgL_keyz00_5503))
{ /* Llib/ssl.scm 1137 */
BgL_auxz00_10651 = BgL_keyz00_5503
; }  else 
{ 
obj_t BgL_auxz00_10654;
BgL_auxz00_10654 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)46149)), BGl_string3775z00zz__ssl_sslz00, BGl_string3441z00zz__ssl_sslz00, BgL_keyz00_5503); 
FAILURE(BgL_auxz00_10654,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_dhz00_5502, BGl_dhz00zz__ssl_sslz00))
{ /* Llib/ssl.scm 1137 */
BgL_auxz00_10643 = 
((BgL_dhz00_bglt)BgL_dhz00_5502)
; }  else 
{ 
obj_t BgL_auxz00_10647;
BgL_auxz00_10647 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)46149)), BGl_string3775z00zz__ssl_sslz00, BGl_string3770z00zz__ssl_sslz00, BgL_dhz00_5502); 
FAILURE(BgL_auxz00_10647,BFALSE,BFALSE);} 
return 
BGl_dhzd2checkzd2pubzd2keyzd2zz__ssl_sslz00(BgL_auxz00_10643, BgL_auxz00_10651);} } 
BGL_FUNCTION_END;
}



/* dh-compute-key */
BGL_EXPORTED_DEF obj_t BGl_dhzd2computezd2keyz00zz__ssl_sslz00(BgL_dhz00_bglt BgL_dhz00_116, obj_t BgL_keyz00_117)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1148 */
{ /* Llib/ssl.scm 1148 */
obj_t BgL_method1315z00_1744;
{ /* Llib/ssl.scm 1148 */
obj_t BgL_res2802z00_3769;
{ /* Llib/ssl.scm 1148 */
long BgL_objzd2classzd2numz00_3726;
{ /* Llib/ssl.scm 1148 */
long BgL_res2791z00_3729;
BgL_res2791z00_3729 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_dhz00_116)); 
BgL_objzd2classzd2numz00_3726 = BgL_res2791z00_3729; } 
{ /* Llib/ssl.scm 1148 */
obj_t BgL_arg1742z00_3727;
BgL_arg1742z00_3727 = 
PROCEDURE_REF(BGl_dhzd2computezd2keyzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1148 */
int BgL_offsetz00_3731;
BgL_offsetz00_3731 = 
(int)(BgL_objzd2classzd2numz00_3726); 
{ /* Llib/ssl.scm 1148 */
long BgL_offsetz00_3732;
BgL_offsetz00_3732 = 
(
(long)(BgL_offsetz00_3731)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1148 */
long BgL_modz00_3733;
{ /* Llib/ssl.scm 1148 */
int BgL_arg1744z00_3734;
BgL_arg1744z00_3734 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1148 */
long BgL_res2794z00_3744;
{ /* Llib/ssl.scm 1148 */
long BgL_tmpz00_10667;
BgL_tmpz00_10667 = 
(long)(BgL_arg1744z00_3734); 
BgL_res2794z00_3744 = 
(BgL_offsetz00_3732/BgL_tmpz00_10667); } 
BgL_modz00_3733 = BgL_res2794z00_3744; } } 
{ /* Llib/ssl.scm 1148 */
long BgL_restz00_3735;
{ /* Llib/ssl.scm 1148 */
int BgL_arg1743z00_3736;
BgL_arg1743z00_3736 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1148 */
long BgL_res2801z00_3764;
{ /* Llib/ssl.scm 1148 */
long BgL_n1z00_3746;long BgL_n2z00_3747;
BgL_n1z00_3746 = BgL_offsetz00_3732; 
BgL_n2z00_3747 = 
(long)(BgL_arg1743z00_3736); 
{ /* Llib/ssl.scm 1148 */
bool_t BgL_testz00_10672;
{ /* Llib/ssl.scm 1148 */
long BgL_arg1283z00_3749;
BgL_arg1283z00_3749 = 
(((BgL_n1z00_3746) | (BgL_n2z00_3747)) & -2147483648); 
BgL_testz00_10672 = 
(BgL_arg1283z00_3749==((long)0)); } 
if(BgL_testz00_10672)
{ /* Llib/ssl.scm 1148 */
int32_t BgL_arg1272z00_3750;
{ /* Llib/ssl.scm 1148 */
int32_t BgL_arg1278z00_3751;int32_t BgL_arg1279z00_3752;
{ /* Llib/ssl.scm 1148 */
int32_t BgL_res2797z00_3756;
BgL_res2797z00_3756 = 
(int32_t)(BgL_n1z00_3746); 
BgL_arg1278z00_3751 = BgL_res2797z00_3756; } 
{ /* Llib/ssl.scm 1148 */
int32_t BgL_res2798z00_3758;
BgL_res2798z00_3758 = 
(int32_t)(BgL_n2z00_3747); 
BgL_arg1279z00_3752 = BgL_res2798z00_3758; } 
BgL_arg1272z00_3750 = 
(BgL_arg1278z00_3751%BgL_arg1279z00_3752); } 
{ /* Llib/ssl.scm 1148 */
long BgL_res2800z00_3763;
{ /* Llib/ssl.scm 1148 */
long BgL_arg1409z00_3760;
BgL_arg1409z00_3760 = 
(long)(BgL_arg1272z00_3750); 
{ /* Llib/ssl.scm 1148 */
long BgL_res2799z00_3762;
BgL_res2799z00_3762 = 
(long)(BgL_arg1409z00_3760); 
BgL_res2800z00_3763 = BgL_res2799z00_3762; } } 
BgL_res2801z00_3764 = BgL_res2800z00_3763; } }  else 
{ /* Llib/ssl.scm 1148 */
BgL_res2801z00_3764 = 
(BgL_n1z00_3746%BgL_n2z00_3747); } } } 
BgL_restz00_3735 = BgL_res2801z00_3764; } } 
{ /* Llib/ssl.scm 1148 */

{ /* Llib/ssl.scm 1148 */
obj_t BgL_bucketz00_3737;
BgL_bucketz00_3737 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3727),BgL_modz00_3733); 
BgL_res2802z00_3769 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3737),BgL_restz00_3735); } } } } } } } } 
BgL_method1315z00_1744 = BgL_res2802z00_3769; } 
return 
PROCEDURE_ENTRY(BgL_method1315z00_1744)(BgL_method1315z00_1744, 
((obj_t)BgL_dhz00_116), BgL_keyz00_117, BEOA);} } 
BGL_FUNCTION_END;
}



/* &dh-compute-key */
obj_t BGl_z62dhzd2computezd2keyz62zz__ssl_sslz00(obj_t BgL_envz00_5504, obj_t BgL_dhz00_5505, obj_t BgL_keyz00_5506)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1148 */
{ /* Llib/ssl.scm 1148 */
obj_t BgL_auxz00_10699;BgL_dhz00_bglt BgL_auxz00_10691;
if(
FOREIGNP(BgL_keyz00_5506))
{ /* Llib/ssl.scm 1148 */
BgL_auxz00_10699 = BgL_keyz00_5506
; }  else 
{ 
obj_t BgL_auxz00_10702;
BgL_auxz00_10702 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)46577)), BGl_string3776z00zz__ssl_sslz00, BGl_string3441z00zz__ssl_sslz00, BgL_keyz00_5506); 
FAILURE(BgL_auxz00_10702,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_dhz00_5505, BGl_dhz00zz__ssl_sslz00))
{ /* Llib/ssl.scm 1148 */
BgL_auxz00_10691 = 
((BgL_dhz00_bglt)BgL_dhz00_5505)
; }  else 
{ 
obj_t BgL_auxz00_10695;
BgL_auxz00_10695 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)46577)), BGl_string3776z00zz__ssl_sslz00, BGl_string3770z00zz__ssl_sslz00, BgL_dhz00_5505); 
FAILURE(BgL_auxz00_10695,BFALSE,BFALSE);} 
return 
BGl_dhzd2computezd2keyz00zz__ssl_sslz00(BgL_auxz00_10691, BgL_auxz00_10699);} } 
BGL_FUNCTION_END;
}



/* dh-generate-key */
BGL_EXPORTED_DEF bool_t BGl_dhzd2generatezd2keyz00zz__ssl_sslz00(BgL_dhz00_bglt BgL_dhz00_118)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1174 */
{ /* Llib/ssl.scm 1174 */
obj_t BgL_method1317z00_1745;
{ /* Llib/ssl.scm 1174 */
obj_t BgL_res2814z00_3814;
{ /* Llib/ssl.scm 1174 */
long BgL_objzd2classzd2numz00_3771;
{ /* Llib/ssl.scm 1174 */
long BgL_res2803z00_3774;
BgL_res2803z00_3774 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_dhz00_118)); 
BgL_objzd2classzd2numz00_3771 = BgL_res2803z00_3774; } 
{ /* Llib/ssl.scm 1174 */
obj_t BgL_arg1742z00_3772;
BgL_arg1742z00_3772 = 
PROCEDURE_REF(BGl_dhzd2generatezd2keyzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1174 */
int BgL_offsetz00_3776;
BgL_offsetz00_3776 = 
(int)(BgL_objzd2classzd2numz00_3771); 
{ /* Llib/ssl.scm 1174 */
long BgL_offsetz00_3777;
BgL_offsetz00_3777 = 
(
(long)(BgL_offsetz00_3776)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1174 */
long BgL_modz00_3778;
{ /* Llib/ssl.scm 1174 */
int BgL_arg1744z00_3779;
BgL_arg1744z00_3779 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1174 */
long BgL_res2806z00_3789;
{ /* Llib/ssl.scm 1174 */
long BgL_tmpz00_10715;
BgL_tmpz00_10715 = 
(long)(BgL_arg1744z00_3779); 
BgL_res2806z00_3789 = 
(BgL_offsetz00_3777/BgL_tmpz00_10715); } 
BgL_modz00_3778 = BgL_res2806z00_3789; } } 
{ /* Llib/ssl.scm 1174 */
long BgL_restz00_3780;
{ /* Llib/ssl.scm 1174 */
int BgL_arg1743z00_3781;
BgL_arg1743z00_3781 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1174 */
long BgL_res2813z00_3809;
{ /* Llib/ssl.scm 1174 */
long BgL_n1z00_3791;long BgL_n2z00_3792;
BgL_n1z00_3791 = BgL_offsetz00_3777; 
BgL_n2z00_3792 = 
(long)(BgL_arg1743z00_3781); 
{ /* Llib/ssl.scm 1174 */
bool_t BgL_testz00_10720;
{ /* Llib/ssl.scm 1174 */
long BgL_arg1283z00_3794;
BgL_arg1283z00_3794 = 
(((BgL_n1z00_3791) | (BgL_n2z00_3792)) & -2147483648); 
BgL_testz00_10720 = 
(BgL_arg1283z00_3794==((long)0)); } 
if(BgL_testz00_10720)
{ /* Llib/ssl.scm 1174 */
int32_t BgL_arg1272z00_3795;
{ /* Llib/ssl.scm 1174 */
int32_t BgL_arg1278z00_3796;int32_t BgL_arg1279z00_3797;
{ /* Llib/ssl.scm 1174 */
int32_t BgL_res2809z00_3801;
BgL_res2809z00_3801 = 
(int32_t)(BgL_n1z00_3791); 
BgL_arg1278z00_3796 = BgL_res2809z00_3801; } 
{ /* Llib/ssl.scm 1174 */
int32_t BgL_res2810z00_3803;
BgL_res2810z00_3803 = 
(int32_t)(BgL_n2z00_3792); 
BgL_arg1279z00_3797 = BgL_res2810z00_3803; } 
BgL_arg1272z00_3795 = 
(BgL_arg1278z00_3796%BgL_arg1279z00_3797); } 
{ /* Llib/ssl.scm 1174 */
long BgL_res2812z00_3808;
{ /* Llib/ssl.scm 1174 */
long BgL_arg1409z00_3805;
BgL_arg1409z00_3805 = 
(long)(BgL_arg1272z00_3795); 
{ /* Llib/ssl.scm 1174 */
long BgL_res2811z00_3807;
BgL_res2811z00_3807 = 
(long)(BgL_arg1409z00_3805); 
BgL_res2812z00_3808 = BgL_res2811z00_3807; } } 
BgL_res2813z00_3809 = BgL_res2812z00_3808; } }  else 
{ /* Llib/ssl.scm 1174 */
BgL_res2813z00_3809 = 
(BgL_n1z00_3791%BgL_n2z00_3792); } } } 
BgL_restz00_3780 = BgL_res2813z00_3809; } } 
{ /* Llib/ssl.scm 1174 */

{ /* Llib/ssl.scm 1174 */
obj_t BgL_bucketz00_3782;
BgL_bucketz00_3782 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3772),BgL_modz00_3778); 
BgL_res2814z00_3814 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3782),BgL_restz00_3780); } } } } } } } } 
BgL_method1317z00_1745 = BgL_res2814z00_3814; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1317z00_1745)(BgL_method1317z00_1745, 
((obj_t)BgL_dhz00_118), BEOA));} } 
BGL_FUNCTION_END;
}



/* &dh-generate-key */
obj_t BGl_z62dhzd2generatezd2keyz62zz__ssl_sslz00(obj_t BgL_envz00_5507, obj_t BgL_dhz00_5508)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1174 */
{ /* Llib/ssl.scm 1174 */
bool_t BgL_tmpz00_10739;
{ /* Llib/ssl.scm 1174 */
BgL_dhz00_bglt BgL_auxz00_10740;
if(
BGl_isazf3zf3zz__objectz00(BgL_dhz00_5508, BGl_dhz00zz__ssl_sslz00))
{ /* Llib/ssl.scm 1174 */
BgL_auxz00_10740 = 
((BgL_dhz00_bglt)BgL_dhz00_5508)
; }  else 
{ 
obj_t BgL_auxz00_10744;
BgL_auxz00_10744 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)47374)), BGl_string3777z00zz__ssl_sslz00, BGl_string3770z00zz__ssl_sslz00, BgL_dhz00_5508); 
FAILURE(BgL_auxz00_10744,BFALSE,BFALSE);} 
BgL_tmpz00_10739 = 
BGl_dhzd2generatezd2keyz00zz__ssl_sslz00(BgL_auxz00_10740); } 
return 
BBOOL(BgL_tmpz00_10739);} } 
BGL_FUNCTION_END;
}



/* ssl-hash-init */
BGL_EXPORTED_DEF obj_t BGl_sslzd2hashzd2initz00zz__ssl_sslz00(BgL_sslzd2hashzd2_bglt BgL_sslzd2hashzd2_119)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1185 */
{ /* Llib/ssl.scm 1185 */
obj_t BgL_method1319z00_1746;
{ /* Llib/ssl.scm 1185 */
obj_t BgL_res2826z00_3859;
{ /* Llib/ssl.scm 1185 */
long BgL_objzd2classzd2numz00_3816;
{ /* Llib/ssl.scm 1185 */
long BgL_res2815z00_3819;
BgL_res2815z00_3819 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2hashzd2_119)); 
BgL_objzd2classzd2numz00_3816 = BgL_res2815z00_3819; } 
{ /* Llib/ssl.scm 1185 */
obj_t BgL_arg1742z00_3817;
BgL_arg1742z00_3817 = 
PROCEDURE_REF(BGl_sslzd2hashzd2initzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1185 */
int BgL_offsetz00_3821;
BgL_offsetz00_3821 = 
(int)(BgL_objzd2classzd2numz00_3816); 
{ /* Llib/ssl.scm 1185 */
long BgL_offsetz00_3822;
BgL_offsetz00_3822 = 
(
(long)(BgL_offsetz00_3821)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1185 */
long BgL_modz00_3823;
{ /* Llib/ssl.scm 1185 */
int BgL_arg1744z00_3824;
BgL_arg1744z00_3824 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1185 */
long BgL_res2818z00_3834;
{ /* Llib/ssl.scm 1185 */
long BgL_tmpz00_10758;
BgL_tmpz00_10758 = 
(long)(BgL_arg1744z00_3824); 
BgL_res2818z00_3834 = 
(BgL_offsetz00_3822/BgL_tmpz00_10758); } 
BgL_modz00_3823 = BgL_res2818z00_3834; } } 
{ /* Llib/ssl.scm 1185 */
long BgL_restz00_3825;
{ /* Llib/ssl.scm 1185 */
int BgL_arg1743z00_3826;
BgL_arg1743z00_3826 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1185 */
long BgL_res2825z00_3854;
{ /* Llib/ssl.scm 1185 */
long BgL_n1z00_3836;long BgL_n2z00_3837;
BgL_n1z00_3836 = BgL_offsetz00_3822; 
BgL_n2z00_3837 = 
(long)(BgL_arg1743z00_3826); 
{ /* Llib/ssl.scm 1185 */
bool_t BgL_testz00_10763;
{ /* Llib/ssl.scm 1185 */
long BgL_arg1283z00_3839;
BgL_arg1283z00_3839 = 
(((BgL_n1z00_3836) | (BgL_n2z00_3837)) & -2147483648); 
BgL_testz00_10763 = 
(BgL_arg1283z00_3839==((long)0)); } 
if(BgL_testz00_10763)
{ /* Llib/ssl.scm 1185 */
int32_t BgL_arg1272z00_3840;
{ /* Llib/ssl.scm 1185 */
int32_t BgL_arg1278z00_3841;int32_t BgL_arg1279z00_3842;
{ /* Llib/ssl.scm 1185 */
int32_t BgL_res2821z00_3846;
BgL_res2821z00_3846 = 
(int32_t)(BgL_n1z00_3836); 
BgL_arg1278z00_3841 = BgL_res2821z00_3846; } 
{ /* Llib/ssl.scm 1185 */
int32_t BgL_res2822z00_3848;
BgL_res2822z00_3848 = 
(int32_t)(BgL_n2z00_3837); 
BgL_arg1279z00_3842 = BgL_res2822z00_3848; } 
BgL_arg1272z00_3840 = 
(BgL_arg1278z00_3841%BgL_arg1279z00_3842); } 
{ /* Llib/ssl.scm 1185 */
long BgL_res2824z00_3853;
{ /* Llib/ssl.scm 1185 */
long BgL_arg1409z00_3850;
BgL_arg1409z00_3850 = 
(long)(BgL_arg1272z00_3840); 
{ /* Llib/ssl.scm 1185 */
long BgL_res2823z00_3852;
BgL_res2823z00_3852 = 
(long)(BgL_arg1409z00_3850); 
BgL_res2824z00_3853 = BgL_res2823z00_3852; } } 
BgL_res2825z00_3854 = BgL_res2824z00_3853; } }  else 
{ /* Llib/ssl.scm 1185 */
BgL_res2825z00_3854 = 
(BgL_n1z00_3836%BgL_n2z00_3837); } } } 
BgL_restz00_3825 = BgL_res2825z00_3854; } } 
{ /* Llib/ssl.scm 1185 */

{ /* Llib/ssl.scm 1185 */
obj_t BgL_bucketz00_3827;
BgL_bucketz00_3827 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3817),BgL_modz00_3823); 
BgL_res2826z00_3859 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3827),BgL_restz00_3825); } } } } } } } } 
BgL_method1319z00_1746 = BgL_res2826z00_3859; } 
return 
PROCEDURE_ENTRY(BgL_method1319z00_1746)(BgL_method1319z00_1746, 
((obj_t)BgL_sslzd2hashzd2_119), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-hash-init */
obj_t BGl_z62sslzd2hashzd2initz62zz__ssl_sslz00(obj_t BgL_envz00_5165, obj_t BgL_sslzd2hashzd2_5166)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1185 */
{ /* Llib/ssl.scm 1185 */
BgL_sslzd2hashzd2_bglt BgL_auxz00_10781;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2hashzd2_5166, BGl_sslzd2hashzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1185 */
BgL_auxz00_10781 = 
((BgL_sslzd2hashzd2_bglt)BgL_sslzd2hashzd2_5166)
; }  else 
{ 
obj_t BgL_auxz00_10785;
BgL_auxz00_10785 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)47781)), BGl_string3778z00zz__ssl_sslz00, BGl_string3736z00zz__ssl_sslz00, BgL_sslzd2hashzd2_5166); 
FAILURE(BgL_auxz00_10785,BFALSE,BFALSE);} 
return 
BGl_sslzd2hashzd2initz00zz__ssl_sslz00(BgL_auxz00_10781);} } 
BGL_FUNCTION_END;
}



/* ssl-hash-update! */
BGL_EXPORTED_DEF obj_t BGl_sslzd2hashzd2updatez12z12zz__ssl_sslz00(BgL_sslzd2hashzd2_bglt BgL_sslzd2hashzd2_120, obj_t BgL_dataz00_121, long BgL_offsetz00_122, long BgL_lenz00_123)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1197 */
{ /* Llib/ssl.scm 1197 */
obj_t BgL_method1321z00_1747;
{ /* Llib/ssl.scm 1197 */
obj_t BgL_res2838z00_3904;
{ /* Llib/ssl.scm 1197 */
long BgL_objzd2classzd2numz00_3861;
{ /* Llib/ssl.scm 1197 */
long BgL_res2827z00_3864;
BgL_res2827z00_3864 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2hashzd2_120)); 
BgL_objzd2classzd2numz00_3861 = BgL_res2827z00_3864; } 
{ /* Llib/ssl.scm 1197 */
obj_t BgL_arg1742z00_3862;
BgL_arg1742z00_3862 = 
PROCEDURE_REF(BGl_sslzd2hashzd2updatez12zd2envzc0zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1197 */
int BgL_offsetz00_3866;
BgL_offsetz00_3866 = 
(int)(BgL_objzd2classzd2numz00_3861); 
{ /* Llib/ssl.scm 1197 */
long BgL_offsetz00_3867;
BgL_offsetz00_3867 = 
(
(long)(BgL_offsetz00_3866)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1197 */
long BgL_modz00_3868;
{ /* Llib/ssl.scm 1197 */
int BgL_arg1744z00_3869;
BgL_arg1744z00_3869 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1197 */
long BgL_res2830z00_3879;
{ /* Llib/ssl.scm 1197 */
long BgL_tmpz00_10798;
BgL_tmpz00_10798 = 
(long)(BgL_arg1744z00_3869); 
BgL_res2830z00_3879 = 
(BgL_offsetz00_3867/BgL_tmpz00_10798); } 
BgL_modz00_3868 = BgL_res2830z00_3879; } } 
{ /* Llib/ssl.scm 1197 */
long BgL_restz00_3870;
{ /* Llib/ssl.scm 1197 */
int BgL_arg1743z00_3871;
BgL_arg1743z00_3871 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1197 */
long BgL_res2837z00_3899;
{ /* Llib/ssl.scm 1197 */
long BgL_n1z00_3881;long BgL_n2z00_3882;
BgL_n1z00_3881 = BgL_offsetz00_3867; 
BgL_n2z00_3882 = 
(long)(BgL_arg1743z00_3871); 
{ /* Llib/ssl.scm 1197 */
bool_t BgL_testz00_10803;
{ /* Llib/ssl.scm 1197 */
long BgL_arg1283z00_3884;
BgL_arg1283z00_3884 = 
(((BgL_n1z00_3881) | (BgL_n2z00_3882)) & -2147483648); 
BgL_testz00_10803 = 
(BgL_arg1283z00_3884==((long)0)); } 
if(BgL_testz00_10803)
{ /* Llib/ssl.scm 1197 */
int32_t BgL_arg1272z00_3885;
{ /* Llib/ssl.scm 1197 */
int32_t BgL_arg1278z00_3886;int32_t BgL_arg1279z00_3887;
{ /* Llib/ssl.scm 1197 */
int32_t BgL_res2833z00_3891;
BgL_res2833z00_3891 = 
(int32_t)(BgL_n1z00_3881); 
BgL_arg1278z00_3886 = BgL_res2833z00_3891; } 
{ /* Llib/ssl.scm 1197 */
int32_t BgL_res2834z00_3893;
BgL_res2834z00_3893 = 
(int32_t)(BgL_n2z00_3882); 
BgL_arg1279z00_3887 = BgL_res2834z00_3893; } 
BgL_arg1272z00_3885 = 
(BgL_arg1278z00_3886%BgL_arg1279z00_3887); } 
{ /* Llib/ssl.scm 1197 */
long BgL_res2836z00_3898;
{ /* Llib/ssl.scm 1197 */
long BgL_arg1409z00_3895;
BgL_arg1409z00_3895 = 
(long)(BgL_arg1272z00_3885); 
{ /* Llib/ssl.scm 1197 */
long BgL_res2835z00_3897;
BgL_res2835z00_3897 = 
(long)(BgL_arg1409z00_3895); 
BgL_res2836z00_3898 = BgL_res2835z00_3897; } } 
BgL_res2837z00_3899 = BgL_res2836z00_3898; } }  else 
{ /* Llib/ssl.scm 1197 */
BgL_res2837z00_3899 = 
(BgL_n1z00_3881%BgL_n2z00_3882); } } } 
BgL_restz00_3870 = BgL_res2837z00_3899; } } 
{ /* Llib/ssl.scm 1197 */

{ /* Llib/ssl.scm 1197 */
obj_t BgL_bucketz00_3872;
BgL_bucketz00_3872 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3862),BgL_modz00_3868); 
BgL_res2838z00_3904 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3872),BgL_restz00_3870); } } } } } } } } 
BgL_method1321z00_1747 = BgL_res2838z00_3904; } 
return 
PROCEDURE_ENTRY(BgL_method1321z00_1747)(BgL_method1321z00_1747, 
((obj_t)BgL_sslzd2hashzd2_120), BgL_dataz00_121, 
BINT(BgL_offsetz00_122), 
BINT(BgL_lenz00_123), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-hash-update! */
obj_t BGl_z62sslzd2hashzd2updatez12z70zz__ssl_sslz00(obj_t BgL_envz00_5509, obj_t BgL_sslzd2hashzd2_5510, obj_t BgL_dataz00_5511, obj_t BgL_offsetz00_5512, obj_t BgL_lenz00_5513)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1197 */
{ /* Llib/ssl.scm 1197 */
long BgL_auxz00_10850;long BgL_auxz00_10841;obj_t BgL_auxz00_10834;BgL_sslzd2hashzd2_bglt BgL_auxz00_10826;
{ /* Llib/ssl.scm 1197 */
obj_t BgL_tmpz00_10851;
if(
INTEGERP(BgL_lenz00_5513))
{ /* Llib/ssl.scm 1197 */
BgL_tmpz00_10851 = BgL_lenz00_5513
; }  else 
{ 
obj_t BgL_auxz00_10854;
BgL_auxz00_10854 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)48236)), BGl_string3779z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_lenz00_5513); 
FAILURE(BgL_auxz00_10854,BFALSE,BFALSE);} 
BgL_auxz00_10850 = 
(long)CINT(BgL_tmpz00_10851); } 
{ /* Llib/ssl.scm 1197 */
obj_t BgL_tmpz00_10842;
if(
INTEGERP(BgL_offsetz00_5512))
{ /* Llib/ssl.scm 1197 */
BgL_tmpz00_10842 = BgL_offsetz00_5512
; }  else 
{ 
obj_t BgL_auxz00_10845;
BgL_auxz00_10845 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)48236)), BGl_string3779z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_offsetz00_5512); 
FAILURE(BgL_auxz00_10845,BFALSE,BFALSE);} 
BgL_auxz00_10841 = 
(long)CINT(BgL_tmpz00_10842); } 
if(
STRINGP(BgL_dataz00_5511))
{ /* Llib/ssl.scm 1197 */
BgL_auxz00_10834 = BgL_dataz00_5511
; }  else 
{ 
obj_t BgL_auxz00_10837;
BgL_auxz00_10837 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)48236)), BGl_string3779z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_dataz00_5511); 
FAILURE(BgL_auxz00_10837,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2hashzd2_5510, BGl_sslzd2hashzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1197 */
BgL_auxz00_10826 = 
((BgL_sslzd2hashzd2_bglt)BgL_sslzd2hashzd2_5510)
; }  else 
{ 
obj_t BgL_auxz00_10830;
BgL_auxz00_10830 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)48236)), BGl_string3779z00zz__ssl_sslz00, BGl_string3736z00zz__ssl_sslz00, BgL_sslzd2hashzd2_5510); 
FAILURE(BgL_auxz00_10830,BFALSE,BFALSE);} 
return 
BGl_sslzd2hashzd2updatez12z12zz__ssl_sslz00(BgL_auxz00_10826, BgL_auxz00_10834, BgL_auxz00_10841, BgL_auxz00_10850);} } 
BGL_FUNCTION_END;
}



/* ssl-hash-digest */
BGL_EXPORTED_DEF obj_t BGl_sslzd2hashzd2digestz00zz__ssl_sslz00(BgL_sslzd2hashzd2_bglt BgL_sslzd2hashzd2_124)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1209 */
{ /* Llib/ssl.scm 1209 */
obj_t BgL_method1323z00_1748;
{ /* Llib/ssl.scm 1209 */
obj_t BgL_res2850z00_3949;
{ /* Llib/ssl.scm 1209 */
long BgL_objzd2classzd2numz00_3906;
{ /* Llib/ssl.scm 1209 */
long BgL_res2839z00_3909;
BgL_res2839z00_3909 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2hashzd2_124)); 
BgL_objzd2classzd2numz00_3906 = BgL_res2839z00_3909; } 
{ /* Llib/ssl.scm 1209 */
obj_t BgL_arg1742z00_3907;
BgL_arg1742z00_3907 = 
PROCEDURE_REF(BGl_sslzd2hashzd2digestzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1209 */
int BgL_offsetz00_3911;
BgL_offsetz00_3911 = 
(int)(BgL_objzd2classzd2numz00_3906); 
{ /* Llib/ssl.scm 1209 */
long BgL_offsetz00_3912;
BgL_offsetz00_3912 = 
(
(long)(BgL_offsetz00_3911)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1209 */
long BgL_modz00_3913;
{ /* Llib/ssl.scm 1209 */
int BgL_arg1744z00_3914;
BgL_arg1744z00_3914 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1209 */
long BgL_res2842z00_3924;
{ /* Llib/ssl.scm 1209 */
long BgL_tmpz00_10868;
BgL_tmpz00_10868 = 
(long)(BgL_arg1744z00_3914); 
BgL_res2842z00_3924 = 
(BgL_offsetz00_3912/BgL_tmpz00_10868); } 
BgL_modz00_3913 = BgL_res2842z00_3924; } } 
{ /* Llib/ssl.scm 1209 */
long BgL_restz00_3915;
{ /* Llib/ssl.scm 1209 */
int BgL_arg1743z00_3916;
BgL_arg1743z00_3916 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1209 */
long BgL_res2849z00_3944;
{ /* Llib/ssl.scm 1209 */
long BgL_n1z00_3926;long BgL_n2z00_3927;
BgL_n1z00_3926 = BgL_offsetz00_3912; 
BgL_n2z00_3927 = 
(long)(BgL_arg1743z00_3916); 
{ /* Llib/ssl.scm 1209 */
bool_t BgL_testz00_10873;
{ /* Llib/ssl.scm 1209 */
long BgL_arg1283z00_3929;
BgL_arg1283z00_3929 = 
(((BgL_n1z00_3926) | (BgL_n2z00_3927)) & -2147483648); 
BgL_testz00_10873 = 
(BgL_arg1283z00_3929==((long)0)); } 
if(BgL_testz00_10873)
{ /* Llib/ssl.scm 1209 */
int32_t BgL_arg1272z00_3930;
{ /* Llib/ssl.scm 1209 */
int32_t BgL_arg1278z00_3931;int32_t BgL_arg1279z00_3932;
{ /* Llib/ssl.scm 1209 */
int32_t BgL_res2845z00_3936;
BgL_res2845z00_3936 = 
(int32_t)(BgL_n1z00_3926); 
BgL_arg1278z00_3931 = BgL_res2845z00_3936; } 
{ /* Llib/ssl.scm 1209 */
int32_t BgL_res2846z00_3938;
BgL_res2846z00_3938 = 
(int32_t)(BgL_n2z00_3927); 
BgL_arg1279z00_3932 = BgL_res2846z00_3938; } 
BgL_arg1272z00_3930 = 
(BgL_arg1278z00_3931%BgL_arg1279z00_3932); } 
{ /* Llib/ssl.scm 1209 */
long BgL_res2848z00_3943;
{ /* Llib/ssl.scm 1209 */
long BgL_arg1409z00_3940;
BgL_arg1409z00_3940 = 
(long)(BgL_arg1272z00_3930); 
{ /* Llib/ssl.scm 1209 */
long BgL_res2847z00_3942;
BgL_res2847z00_3942 = 
(long)(BgL_arg1409z00_3940); 
BgL_res2848z00_3943 = BgL_res2847z00_3942; } } 
BgL_res2849z00_3944 = BgL_res2848z00_3943; } }  else 
{ /* Llib/ssl.scm 1209 */
BgL_res2849z00_3944 = 
(BgL_n1z00_3926%BgL_n2z00_3927); } } } 
BgL_restz00_3915 = BgL_res2849z00_3944; } } 
{ /* Llib/ssl.scm 1209 */

{ /* Llib/ssl.scm 1209 */
obj_t BgL_bucketz00_3917;
BgL_bucketz00_3917 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3907),BgL_modz00_3913); 
BgL_res2850z00_3949 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3917),BgL_restz00_3915); } } } } } } } } 
BgL_method1323z00_1748 = BgL_res2850z00_3949; } 
return 
PROCEDURE_ENTRY(BgL_method1323z00_1748)(BgL_method1323z00_1748, 
((obj_t)BgL_sslzd2hashzd2_124), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-hash-digest */
obj_t BGl_z62sslzd2hashzd2digestz62zz__ssl_sslz00(obj_t BgL_envz00_5514, obj_t BgL_sslzd2hashzd2_5515)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1209 */
{ /* Llib/ssl.scm 1209 */
BgL_sslzd2hashzd2_bglt BgL_auxz00_10891;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2hashzd2_5515, BGl_sslzd2hashzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1209 */
BgL_auxz00_10891 = 
((BgL_sslzd2hashzd2_bglt)BgL_sslzd2hashzd2_5515)
; }  else 
{ 
obj_t BgL_auxz00_10895;
BgL_auxz00_10895 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)48732)), BGl_string3780z00zz__ssl_sslz00, BGl_string3736z00zz__ssl_sslz00, BgL_sslzd2hashzd2_5515); 
FAILURE(BgL_auxz00_10895,BFALSE,BFALSE);} 
return 
BGl_sslzd2hashzd2digestz00zz__ssl_sslz00(BgL_auxz00_10891);} } 
BGL_FUNCTION_END;
}



/* ssl-hmac-init */
BGL_EXPORTED_DEF obj_t BGl_sslzd2hmaczd2initz00zz__ssl_sslz00(BgL_sslzd2hmaczd2_bglt BgL_sslzd2hmaczd2_125, obj_t BgL_hmacz00_126, obj_t BgL_keyz00_127)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1220 */
{ /* Llib/ssl.scm 1220 */
obj_t BgL_method1325z00_1749;
{ /* Llib/ssl.scm 1220 */
obj_t BgL_res2862z00_3994;
{ /* Llib/ssl.scm 1220 */
long BgL_objzd2classzd2numz00_3951;
{ /* Llib/ssl.scm 1220 */
long BgL_res2851z00_3954;
BgL_res2851z00_3954 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2hmaczd2_125)); 
BgL_objzd2classzd2numz00_3951 = BgL_res2851z00_3954; } 
{ /* Llib/ssl.scm 1220 */
obj_t BgL_arg1742z00_3952;
BgL_arg1742z00_3952 = 
PROCEDURE_REF(BGl_sslzd2hmaczd2initzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1220 */
int BgL_offsetz00_3956;
BgL_offsetz00_3956 = 
(int)(BgL_objzd2classzd2numz00_3951); 
{ /* Llib/ssl.scm 1220 */
long BgL_offsetz00_3957;
BgL_offsetz00_3957 = 
(
(long)(BgL_offsetz00_3956)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1220 */
long BgL_modz00_3958;
{ /* Llib/ssl.scm 1220 */
int BgL_arg1744z00_3959;
BgL_arg1744z00_3959 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1220 */
long BgL_res2854z00_3969;
{ /* Llib/ssl.scm 1220 */
long BgL_tmpz00_10908;
BgL_tmpz00_10908 = 
(long)(BgL_arg1744z00_3959); 
BgL_res2854z00_3969 = 
(BgL_offsetz00_3957/BgL_tmpz00_10908); } 
BgL_modz00_3958 = BgL_res2854z00_3969; } } 
{ /* Llib/ssl.scm 1220 */
long BgL_restz00_3960;
{ /* Llib/ssl.scm 1220 */
int BgL_arg1743z00_3961;
BgL_arg1743z00_3961 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1220 */
long BgL_res2861z00_3989;
{ /* Llib/ssl.scm 1220 */
long BgL_n1z00_3971;long BgL_n2z00_3972;
BgL_n1z00_3971 = BgL_offsetz00_3957; 
BgL_n2z00_3972 = 
(long)(BgL_arg1743z00_3961); 
{ /* Llib/ssl.scm 1220 */
bool_t BgL_testz00_10913;
{ /* Llib/ssl.scm 1220 */
long BgL_arg1283z00_3974;
BgL_arg1283z00_3974 = 
(((BgL_n1z00_3971) | (BgL_n2z00_3972)) & -2147483648); 
BgL_testz00_10913 = 
(BgL_arg1283z00_3974==((long)0)); } 
if(BgL_testz00_10913)
{ /* Llib/ssl.scm 1220 */
int32_t BgL_arg1272z00_3975;
{ /* Llib/ssl.scm 1220 */
int32_t BgL_arg1278z00_3976;int32_t BgL_arg1279z00_3977;
{ /* Llib/ssl.scm 1220 */
int32_t BgL_res2857z00_3981;
BgL_res2857z00_3981 = 
(int32_t)(BgL_n1z00_3971); 
BgL_arg1278z00_3976 = BgL_res2857z00_3981; } 
{ /* Llib/ssl.scm 1220 */
int32_t BgL_res2858z00_3983;
BgL_res2858z00_3983 = 
(int32_t)(BgL_n2z00_3972); 
BgL_arg1279z00_3977 = BgL_res2858z00_3983; } 
BgL_arg1272z00_3975 = 
(BgL_arg1278z00_3976%BgL_arg1279z00_3977); } 
{ /* Llib/ssl.scm 1220 */
long BgL_res2860z00_3988;
{ /* Llib/ssl.scm 1220 */
long BgL_arg1409z00_3985;
BgL_arg1409z00_3985 = 
(long)(BgL_arg1272z00_3975); 
{ /* Llib/ssl.scm 1220 */
long BgL_res2859z00_3987;
BgL_res2859z00_3987 = 
(long)(BgL_arg1409z00_3985); 
BgL_res2860z00_3988 = BgL_res2859z00_3987; } } 
BgL_res2861z00_3989 = BgL_res2860z00_3988; } }  else 
{ /* Llib/ssl.scm 1220 */
BgL_res2861z00_3989 = 
(BgL_n1z00_3971%BgL_n2z00_3972); } } } 
BgL_restz00_3960 = BgL_res2861z00_3989; } } 
{ /* Llib/ssl.scm 1220 */

{ /* Llib/ssl.scm 1220 */
obj_t BgL_bucketz00_3962;
BgL_bucketz00_3962 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3952),BgL_modz00_3958); 
BgL_res2862z00_3994 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3962),BgL_restz00_3960); } } } } } } } } 
BgL_method1325z00_1749 = BgL_res2862z00_3994; } 
return 
PROCEDURE_ENTRY(BgL_method1325z00_1749)(BgL_method1325z00_1749, 
((obj_t)BgL_sslzd2hmaczd2_125), BgL_hmacz00_126, BgL_keyz00_127, BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-hmac-init */
obj_t BGl_z62sslzd2hmaczd2initz62zz__ssl_sslz00(obj_t BgL_envz00_5516, obj_t BgL_sslzd2hmaczd2_5517, obj_t BgL_hmacz00_5518, obj_t BgL_keyz00_5519)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1220 */
{ /* Llib/ssl.scm 1220 */
obj_t BgL_auxz00_10948;obj_t BgL_auxz00_10941;BgL_sslzd2hmaczd2_bglt BgL_auxz00_10933;
if(
STRINGP(BgL_keyz00_5519))
{ /* Llib/ssl.scm 1220 */
BgL_auxz00_10948 = BgL_keyz00_5519
; }  else 
{ 
obj_t BgL_auxz00_10951;
BgL_auxz00_10951 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)49178)), BGl_string3781z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_keyz00_5519); 
FAILURE(BgL_auxz00_10951,BFALSE,BFALSE);} 
if(
STRINGP(BgL_hmacz00_5518))
{ /* Llib/ssl.scm 1220 */
BgL_auxz00_10941 = BgL_hmacz00_5518
; }  else 
{ 
obj_t BgL_auxz00_10944;
BgL_auxz00_10944 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)49178)), BGl_string3781z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_hmacz00_5518); 
FAILURE(BgL_auxz00_10944,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2hmaczd2_5517, BGl_sslzd2hmaczd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1220 */
BgL_auxz00_10933 = 
((BgL_sslzd2hmaczd2_bglt)BgL_sslzd2hmaczd2_5517)
; }  else 
{ 
obj_t BgL_auxz00_10937;
BgL_auxz00_10937 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)49178)), BGl_string3781z00zz__ssl_sslz00, BGl_string3732z00zz__ssl_sslz00, BgL_sslzd2hmaczd2_5517); 
FAILURE(BgL_auxz00_10937,BFALSE,BFALSE);} 
return 
BGl_sslzd2hmaczd2initz00zz__ssl_sslz00(BgL_auxz00_10933, BgL_auxz00_10941, BgL_auxz00_10948);} } 
BGL_FUNCTION_END;
}



/* ssl-hmac-update! */
BGL_EXPORTED_DEF obj_t BGl_sslzd2hmaczd2updatez12z12zz__ssl_sslz00(BgL_sslzd2hmaczd2_bglt BgL_sslzd2hmaczd2_128, obj_t BgL_dataz00_129, long BgL_offsetz00_130, long BgL_lenz00_131)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1232 */
{ /* Llib/ssl.scm 1232 */
obj_t BgL_method1327z00_1750;
{ /* Llib/ssl.scm 1232 */
obj_t BgL_res2874z00_4039;
{ /* Llib/ssl.scm 1232 */
long BgL_objzd2classzd2numz00_3996;
{ /* Llib/ssl.scm 1232 */
long BgL_res2863z00_3999;
BgL_res2863z00_3999 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2hmaczd2_128)); 
BgL_objzd2classzd2numz00_3996 = BgL_res2863z00_3999; } 
{ /* Llib/ssl.scm 1232 */
obj_t BgL_arg1742z00_3997;
BgL_arg1742z00_3997 = 
PROCEDURE_REF(BGl_sslzd2hmaczd2updatez12zd2envzc0zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1232 */
int BgL_offsetz00_4001;
BgL_offsetz00_4001 = 
(int)(BgL_objzd2classzd2numz00_3996); 
{ /* Llib/ssl.scm 1232 */
long BgL_offsetz00_4002;
BgL_offsetz00_4002 = 
(
(long)(BgL_offsetz00_4001)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1232 */
long BgL_modz00_4003;
{ /* Llib/ssl.scm 1232 */
int BgL_arg1744z00_4004;
BgL_arg1744z00_4004 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1232 */
long BgL_res2866z00_4014;
{ /* Llib/ssl.scm 1232 */
long BgL_tmpz00_10964;
BgL_tmpz00_10964 = 
(long)(BgL_arg1744z00_4004); 
BgL_res2866z00_4014 = 
(BgL_offsetz00_4002/BgL_tmpz00_10964); } 
BgL_modz00_4003 = BgL_res2866z00_4014; } } 
{ /* Llib/ssl.scm 1232 */
long BgL_restz00_4005;
{ /* Llib/ssl.scm 1232 */
int BgL_arg1743z00_4006;
BgL_arg1743z00_4006 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1232 */
long BgL_res2873z00_4034;
{ /* Llib/ssl.scm 1232 */
long BgL_n1z00_4016;long BgL_n2z00_4017;
BgL_n1z00_4016 = BgL_offsetz00_4002; 
BgL_n2z00_4017 = 
(long)(BgL_arg1743z00_4006); 
{ /* Llib/ssl.scm 1232 */
bool_t BgL_testz00_10969;
{ /* Llib/ssl.scm 1232 */
long BgL_arg1283z00_4019;
BgL_arg1283z00_4019 = 
(((BgL_n1z00_4016) | (BgL_n2z00_4017)) & -2147483648); 
BgL_testz00_10969 = 
(BgL_arg1283z00_4019==((long)0)); } 
if(BgL_testz00_10969)
{ /* Llib/ssl.scm 1232 */
int32_t BgL_arg1272z00_4020;
{ /* Llib/ssl.scm 1232 */
int32_t BgL_arg1278z00_4021;int32_t BgL_arg1279z00_4022;
{ /* Llib/ssl.scm 1232 */
int32_t BgL_res2869z00_4026;
BgL_res2869z00_4026 = 
(int32_t)(BgL_n1z00_4016); 
BgL_arg1278z00_4021 = BgL_res2869z00_4026; } 
{ /* Llib/ssl.scm 1232 */
int32_t BgL_res2870z00_4028;
BgL_res2870z00_4028 = 
(int32_t)(BgL_n2z00_4017); 
BgL_arg1279z00_4022 = BgL_res2870z00_4028; } 
BgL_arg1272z00_4020 = 
(BgL_arg1278z00_4021%BgL_arg1279z00_4022); } 
{ /* Llib/ssl.scm 1232 */
long BgL_res2872z00_4033;
{ /* Llib/ssl.scm 1232 */
long BgL_arg1409z00_4030;
BgL_arg1409z00_4030 = 
(long)(BgL_arg1272z00_4020); 
{ /* Llib/ssl.scm 1232 */
long BgL_res2871z00_4032;
BgL_res2871z00_4032 = 
(long)(BgL_arg1409z00_4030); 
BgL_res2872z00_4033 = BgL_res2871z00_4032; } } 
BgL_res2873z00_4034 = BgL_res2872z00_4033; } }  else 
{ /* Llib/ssl.scm 1232 */
BgL_res2873z00_4034 = 
(BgL_n1z00_4016%BgL_n2z00_4017); } } } 
BgL_restz00_4005 = BgL_res2873z00_4034; } } 
{ /* Llib/ssl.scm 1232 */

{ /* Llib/ssl.scm 1232 */
obj_t BgL_bucketz00_4007;
BgL_bucketz00_4007 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_3997),BgL_modz00_4003); 
BgL_res2874z00_4039 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4007),BgL_restz00_4005); } } } } } } } } 
BgL_method1327z00_1750 = BgL_res2874z00_4039; } 
return 
PROCEDURE_ENTRY(BgL_method1327z00_1750)(BgL_method1327z00_1750, 
((obj_t)BgL_sslzd2hmaczd2_128), BgL_dataz00_129, 
BINT(BgL_offsetz00_130), 
BINT(BgL_lenz00_131), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-hmac-update! */
obj_t BGl_z62sslzd2hmaczd2updatez12z70zz__ssl_sslz00(obj_t BgL_envz00_5520, obj_t BgL_sslzd2hmaczd2_5521, obj_t BgL_dataz00_5522, obj_t BgL_offsetz00_5523, obj_t BgL_lenz00_5524)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1232 */
{ /* Llib/ssl.scm 1232 */
long BgL_auxz00_11016;long BgL_auxz00_11007;obj_t BgL_auxz00_11000;BgL_sslzd2hmaczd2_bglt BgL_auxz00_10992;
{ /* Llib/ssl.scm 1232 */
obj_t BgL_tmpz00_11017;
if(
INTEGERP(BgL_lenz00_5524))
{ /* Llib/ssl.scm 1232 */
BgL_tmpz00_11017 = BgL_lenz00_5524
; }  else 
{ 
obj_t BgL_auxz00_11020;
BgL_auxz00_11020 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)49647)), BGl_string3782z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_lenz00_5524); 
FAILURE(BgL_auxz00_11020,BFALSE,BFALSE);} 
BgL_auxz00_11016 = 
(long)CINT(BgL_tmpz00_11017); } 
{ /* Llib/ssl.scm 1232 */
obj_t BgL_tmpz00_11008;
if(
INTEGERP(BgL_offsetz00_5523))
{ /* Llib/ssl.scm 1232 */
BgL_tmpz00_11008 = BgL_offsetz00_5523
; }  else 
{ 
obj_t BgL_auxz00_11011;
BgL_auxz00_11011 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)49647)), BGl_string3782z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_offsetz00_5523); 
FAILURE(BgL_auxz00_11011,BFALSE,BFALSE);} 
BgL_auxz00_11007 = 
(long)CINT(BgL_tmpz00_11008); } 
if(
STRINGP(BgL_dataz00_5522))
{ /* Llib/ssl.scm 1232 */
BgL_auxz00_11000 = BgL_dataz00_5522
; }  else 
{ 
obj_t BgL_auxz00_11003;
BgL_auxz00_11003 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)49647)), BGl_string3782z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_dataz00_5522); 
FAILURE(BgL_auxz00_11003,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2hmaczd2_5521, BGl_sslzd2hmaczd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1232 */
BgL_auxz00_10992 = 
((BgL_sslzd2hmaczd2_bglt)BgL_sslzd2hmaczd2_5521)
; }  else 
{ 
obj_t BgL_auxz00_10996;
BgL_auxz00_10996 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)49647)), BGl_string3782z00zz__ssl_sslz00, BGl_string3732z00zz__ssl_sslz00, BgL_sslzd2hmaczd2_5521); 
FAILURE(BgL_auxz00_10996,BFALSE,BFALSE);} 
return 
BGl_sslzd2hmaczd2updatez12z12zz__ssl_sslz00(BgL_auxz00_10992, BgL_auxz00_11000, BgL_auxz00_11007, BgL_auxz00_11016);} } 
BGL_FUNCTION_END;
}



/* ssl-hmac-digest */
BGL_EXPORTED_DEF obj_t BGl_sslzd2hmaczd2digestz00zz__ssl_sslz00(BgL_sslzd2hmaczd2_bglt BgL_sslzd2hmaczd2_132)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1244 */
{ /* Llib/ssl.scm 1244 */
obj_t BgL_method1329z00_1751;
{ /* Llib/ssl.scm 1244 */
obj_t BgL_res2886z00_4084;
{ /* Llib/ssl.scm 1244 */
long BgL_objzd2classzd2numz00_4041;
{ /* Llib/ssl.scm 1244 */
long BgL_res2875z00_4044;
BgL_res2875z00_4044 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2hmaczd2_132)); 
BgL_objzd2classzd2numz00_4041 = BgL_res2875z00_4044; } 
{ /* Llib/ssl.scm 1244 */
obj_t BgL_arg1742z00_4042;
BgL_arg1742z00_4042 = 
PROCEDURE_REF(BGl_sslzd2hmaczd2digestzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1244 */
int BgL_offsetz00_4046;
BgL_offsetz00_4046 = 
(int)(BgL_objzd2classzd2numz00_4041); 
{ /* Llib/ssl.scm 1244 */
long BgL_offsetz00_4047;
BgL_offsetz00_4047 = 
(
(long)(BgL_offsetz00_4046)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1244 */
long BgL_modz00_4048;
{ /* Llib/ssl.scm 1244 */
int BgL_arg1744z00_4049;
BgL_arg1744z00_4049 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1244 */
long BgL_res2878z00_4059;
{ /* Llib/ssl.scm 1244 */
long BgL_tmpz00_11034;
BgL_tmpz00_11034 = 
(long)(BgL_arg1744z00_4049); 
BgL_res2878z00_4059 = 
(BgL_offsetz00_4047/BgL_tmpz00_11034); } 
BgL_modz00_4048 = BgL_res2878z00_4059; } } 
{ /* Llib/ssl.scm 1244 */
long BgL_restz00_4050;
{ /* Llib/ssl.scm 1244 */
int BgL_arg1743z00_4051;
BgL_arg1743z00_4051 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1244 */
long BgL_res2885z00_4079;
{ /* Llib/ssl.scm 1244 */
long BgL_n1z00_4061;long BgL_n2z00_4062;
BgL_n1z00_4061 = BgL_offsetz00_4047; 
BgL_n2z00_4062 = 
(long)(BgL_arg1743z00_4051); 
{ /* Llib/ssl.scm 1244 */
bool_t BgL_testz00_11039;
{ /* Llib/ssl.scm 1244 */
long BgL_arg1283z00_4064;
BgL_arg1283z00_4064 = 
(((BgL_n1z00_4061) | (BgL_n2z00_4062)) & -2147483648); 
BgL_testz00_11039 = 
(BgL_arg1283z00_4064==((long)0)); } 
if(BgL_testz00_11039)
{ /* Llib/ssl.scm 1244 */
int32_t BgL_arg1272z00_4065;
{ /* Llib/ssl.scm 1244 */
int32_t BgL_arg1278z00_4066;int32_t BgL_arg1279z00_4067;
{ /* Llib/ssl.scm 1244 */
int32_t BgL_res2881z00_4071;
BgL_res2881z00_4071 = 
(int32_t)(BgL_n1z00_4061); 
BgL_arg1278z00_4066 = BgL_res2881z00_4071; } 
{ /* Llib/ssl.scm 1244 */
int32_t BgL_res2882z00_4073;
BgL_res2882z00_4073 = 
(int32_t)(BgL_n2z00_4062); 
BgL_arg1279z00_4067 = BgL_res2882z00_4073; } 
BgL_arg1272z00_4065 = 
(BgL_arg1278z00_4066%BgL_arg1279z00_4067); } 
{ /* Llib/ssl.scm 1244 */
long BgL_res2884z00_4078;
{ /* Llib/ssl.scm 1244 */
long BgL_arg1409z00_4075;
BgL_arg1409z00_4075 = 
(long)(BgL_arg1272z00_4065); 
{ /* Llib/ssl.scm 1244 */
long BgL_res2883z00_4077;
BgL_res2883z00_4077 = 
(long)(BgL_arg1409z00_4075); 
BgL_res2884z00_4078 = BgL_res2883z00_4077; } } 
BgL_res2885z00_4079 = BgL_res2884z00_4078; } }  else 
{ /* Llib/ssl.scm 1244 */
BgL_res2885z00_4079 = 
(BgL_n1z00_4061%BgL_n2z00_4062); } } } 
BgL_restz00_4050 = BgL_res2885z00_4079; } } 
{ /* Llib/ssl.scm 1244 */

{ /* Llib/ssl.scm 1244 */
obj_t BgL_bucketz00_4052;
BgL_bucketz00_4052 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4042),BgL_modz00_4048); 
BgL_res2886z00_4084 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4052),BgL_restz00_4050); } } } } } } } } 
BgL_method1329z00_1751 = BgL_res2886z00_4084; } 
return 
PROCEDURE_ENTRY(BgL_method1329z00_1751)(BgL_method1329z00_1751, 
((obj_t)BgL_sslzd2hmaczd2_132), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-hmac-digest */
obj_t BGl_z62sslzd2hmaczd2digestz62zz__ssl_sslz00(obj_t BgL_envz00_5525, obj_t BgL_sslzd2hmaczd2_5526)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1244 */
{ /* Llib/ssl.scm 1244 */
BgL_sslzd2hmaczd2_bglt BgL_auxz00_11057;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2hmaczd2_5526, BGl_sslzd2hmaczd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1244 */
BgL_auxz00_11057 = 
((BgL_sslzd2hmaczd2_bglt)BgL_sslzd2hmaczd2_5526)
; }  else 
{ 
obj_t BgL_auxz00_11061;
BgL_auxz00_11061 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)50143)), BGl_string3783z00zz__ssl_sslz00, BGl_string3732z00zz__ssl_sslz00, BgL_sslzd2hmaczd2_5526); 
FAILURE(BgL_auxz00_11061,BFALSE,BFALSE);} 
return 
BGl_sslzd2hmaczd2digestz00zz__ssl_sslz00(BgL_auxz00_11057);} } 
BGL_FUNCTION_END;
}



/* ssl-sign-init */
BGL_EXPORTED_DEF obj_t BGl_sslzd2signzd2initz00zz__ssl_sslz00(BgL_sslzd2signzd2_bglt BgL_sslzd2signzd2_133, obj_t BgL_signz00_134)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1255 */
{ /* Llib/ssl.scm 1255 */
obj_t BgL_method1331z00_1752;
{ /* Llib/ssl.scm 1255 */
obj_t BgL_res2898z00_4129;
{ /* Llib/ssl.scm 1255 */
long BgL_objzd2classzd2numz00_4086;
{ /* Llib/ssl.scm 1255 */
long BgL_res2887z00_4089;
BgL_res2887z00_4089 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2signzd2_133)); 
BgL_objzd2classzd2numz00_4086 = BgL_res2887z00_4089; } 
{ /* Llib/ssl.scm 1255 */
obj_t BgL_arg1742z00_4087;
BgL_arg1742z00_4087 = 
PROCEDURE_REF(BGl_sslzd2signzd2initzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1255 */
int BgL_offsetz00_4091;
BgL_offsetz00_4091 = 
(int)(BgL_objzd2classzd2numz00_4086); 
{ /* Llib/ssl.scm 1255 */
long BgL_offsetz00_4092;
BgL_offsetz00_4092 = 
(
(long)(BgL_offsetz00_4091)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1255 */
long BgL_modz00_4093;
{ /* Llib/ssl.scm 1255 */
int BgL_arg1744z00_4094;
BgL_arg1744z00_4094 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1255 */
long BgL_res2890z00_4104;
{ /* Llib/ssl.scm 1255 */
long BgL_tmpz00_11074;
BgL_tmpz00_11074 = 
(long)(BgL_arg1744z00_4094); 
BgL_res2890z00_4104 = 
(BgL_offsetz00_4092/BgL_tmpz00_11074); } 
BgL_modz00_4093 = BgL_res2890z00_4104; } } 
{ /* Llib/ssl.scm 1255 */
long BgL_restz00_4095;
{ /* Llib/ssl.scm 1255 */
int BgL_arg1743z00_4096;
BgL_arg1743z00_4096 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1255 */
long BgL_res2897z00_4124;
{ /* Llib/ssl.scm 1255 */
long BgL_n1z00_4106;long BgL_n2z00_4107;
BgL_n1z00_4106 = BgL_offsetz00_4092; 
BgL_n2z00_4107 = 
(long)(BgL_arg1743z00_4096); 
{ /* Llib/ssl.scm 1255 */
bool_t BgL_testz00_11079;
{ /* Llib/ssl.scm 1255 */
long BgL_arg1283z00_4109;
BgL_arg1283z00_4109 = 
(((BgL_n1z00_4106) | (BgL_n2z00_4107)) & -2147483648); 
BgL_testz00_11079 = 
(BgL_arg1283z00_4109==((long)0)); } 
if(BgL_testz00_11079)
{ /* Llib/ssl.scm 1255 */
int32_t BgL_arg1272z00_4110;
{ /* Llib/ssl.scm 1255 */
int32_t BgL_arg1278z00_4111;int32_t BgL_arg1279z00_4112;
{ /* Llib/ssl.scm 1255 */
int32_t BgL_res2893z00_4116;
BgL_res2893z00_4116 = 
(int32_t)(BgL_n1z00_4106); 
BgL_arg1278z00_4111 = BgL_res2893z00_4116; } 
{ /* Llib/ssl.scm 1255 */
int32_t BgL_res2894z00_4118;
BgL_res2894z00_4118 = 
(int32_t)(BgL_n2z00_4107); 
BgL_arg1279z00_4112 = BgL_res2894z00_4118; } 
BgL_arg1272z00_4110 = 
(BgL_arg1278z00_4111%BgL_arg1279z00_4112); } 
{ /* Llib/ssl.scm 1255 */
long BgL_res2896z00_4123;
{ /* Llib/ssl.scm 1255 */
long BgL_arg1409z00_4120;
BgL_arg1409z00_4120 = 
(long)(BgL_arg1272z00_4110); 
{ /* Llib/ssl.scm 1255 */
long BgL_res2895z00_4122;
BgL_res2895z00_4122 = 
(long)(BgL_arg1409z00_4120); 
BgL_res2896z00_4123 = BgL_res2895z00_4122; } } 
BgL_res2897z00_4124 = BgL_res2896z00_4123; } }  else 
{ /* Llib/ssl.scm 1255 */
BgL_res2897z00_4124 = 
(BgL_n1z00_4106%BgL_n2z00_4107); } } } 
BgL_restz00_4095 = BgL_res2897z00_4124; } } 
{ /* Llib/ssl.scm 1255 */

{ /* Llib/ssl.scm 1255 */
obj_t BgL_bucketz00_4097;
BgL_bucketz00_4097 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4087),BgL_modz00_4093); 
BgL_res2898z00_4129 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4097),BgL_restz00_4095); } } } } } } } } 
BgL_method1331z00_1752 = BgL_res2898z00_4129; } 
return 
PROCEDURE_ENTRY(BgL_method1331z00_1752)(BgL_method1331z00_1752, 
((obj_t)BgL_sslzd2signzd2_133), BgL_signz00_134, BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-sign-init */
obj_t BGl_z62sslzd2signzd2initz62zz__ssl_sslz00(obj_t BgL_envz00_5527, obj_t BgL_sslzd2signzd2_5528, obj_t BgL_signz00_5529)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1255 */
{ /* Llib/ssl.scm 1255 */
obj_t BgL_auxz00_11106;BgL_sslzd2signzd2_bglt BgL_auxz00_11098;
if(
STRINGP(BgL_signz00_5529))
{ /* Llib/ssl.scm 1255 */
BgL_auxz00_11106 = BgL_signz00_5529
; }  else 
{ 
obj_t BgL_auxz00_11109;
BgL_auxz00_11109 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)50589)), BGl_string3784z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_signz00_5529); 
FAILURE(BgL_auxz00_11109,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2signzd2_5528, BGl_sslzd2signzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1255 */
BgL_auxz00_11098 = 
((BgL_sslzd2signzd2_bglt)BgL_sslzd2signzd2_5528)
; }  else 
{ 
obj_t BgL_auxz00_11102;
BgL_auxz00_11102 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)50589)), BGl_string3784z00zz__ssl_sslz00, BGl_string3727z00zz__ssl_sslz00, BgL_sslzd2signzd2_5528); 
FAILURE(BgL_auxz00_11102,BFALSE,BFALSE);} 
return 
BGl_sslzd2signzd2initz00zz__ssl_sslz00(BgL_auxz00_11098, BgL_auxz00_11106);} } 
BGL_FUNCTION_END;
}



/* ssl-sign-update! */
BGL_EXPORTED_DEF obj_t BGl_sslzd2signzd2updatez12z12zz__ssl_sslz00(BgL_sslzd2signzd2_bglt BgL_sslzd2signzd2_135, obj_t BgL_dataz00_136, long BgL_offsetz00_137, long BgL_lenz00_138)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1267 */
{ /* Llib/ssl.scm 1267 */
obj_t BgL_method1333z00_1753;
{ /* Llib/ssl.scm 1267 */
obj_t BgL_res2910z00_4174;
{ /* Llib/ssl.scm 1267 */
long BgL_objzd2classzd2numz00_4131;
{ /* Llib/ssl.scm 1267 */
long BgL_res2899z00_4134;
BgL_res2899z00_4134 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2signzd2_135)); 
BgL_objzd2classzd2numz00_4131 = BgL_res2899z00_4134; } 
{ /* Llib/ssl.scm 1267 */
obj_t BgL_arg1742z00_4132;
BgL_arg1742z00_4132 = 
PROCEDURE_REF(BGl_sslzd2signzd2updatez12zd2envzc0zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1267 */
int BgL_offsetz00_4136;
BgL_offsetz00_4136 = 
(int)(BgL_objzd2classzd2numz00_4131); 
{ /* Llib/ssl.scm 1267 */
long BgL_offsetz00_4137;
BgL_offsetz00_4137 = 
(
(long)(BgL_offsetz00_4136)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1267 */
long BgL_modz00_4138;
{ /* Llib/ssl.scm 1267 */
int BgL_arg1744z00_4139;
BgL_arg1744z00_4139 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1267 */
long BgL_res2902z00_4149;
{ /* Llib/ssl.scm 1267 */
long BgL_tmpz00_11122;
BgL_tmpz00_11122 = 
(long)(BgL_arg1744z00_4139); 
BgL_res2902z00_4149 = 
(BgL_offsetz00_4137/BgL_tmpz00_11122); } 
BgL_modz00_4138 = BgL_res2902z00_4149; } } 
{ /* Llib/ssl.scm 1267 */
long BgL_restz00_4140;
{ /* Llib/ssl.scm 1267 */
int BgL_arg1743z00_4141;
BgL_arg1743z00_4141 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1267 */
long BgL_res2909z00_4169;
{ /* Llib/ssl.scm 1267 */
long BgL_n1z00_4151;long BgL_n2z00_4152;
BgL_n1z00_4151 = BgL_offsetz00_4137; 
BgL_n2z00_4152 = 
(long)(BgL_arg1743z00_4141); 
{ /* Llib/ssl.scm 1267 */
bool_t BgL_testz00_11127;
{ /* Llib/ssl.scm 1267 */
long BgL_arg1283z00_4154;
BgL_arg1283z00_4154 = 
(((BgL_n1z00_4151) | (BgL_n2z00_4152)) & -2147483648); 
BgL_testz00_11127 = 
(BgL_arg1283z00_4154==((long)0)); } 
if(BgL_testz00_11127)
{ /* Llib/ssl.scm 1267 */
int32_t BgL_arg1272z00_4155;
{ /* Llib/ssl.scm 1267 */
int32_t BgL_arg1278z00_4156;int32_t BgL_arg1279z00_4157;
{ /* Llib/ssl.scm 1267 */
int32_t BgL_res2905z00_4161;
BgL_res2905z00_4161 = 
(int32_t)(BgL_n1z00_4151); 
BgL_arg1278z00_4156 = BgL_res2905z00_4161; } 
{ /* Llib/ssl.scm 1267 */
int32_t BgL_res2906z00_4163;
BgL_res2906z00_4163 = 
(int32_t)(BgL_n2z00_4152); 
BgL_arg1279z00_4157 = BgL_res2906z00_4163; } 
BgL_arg1272z00_4155 = 
(BgL_arg1278z00_4156%BgL_arg1279z00_4157); } 
{ /* Llib/ssl.scm 1267 */
long BgL_res2908z00_4168;
{ /* Llib/ssl.scm 1267 */
long BgL_arg1409z00_4165;
BgL_arg1409z00_4165 = 
(long)(BgL_arg1272z00_4155); 
{ /* Llib/ssl.scm 1267 */
long BgL_res2907z00_4167;
BgL_res2907z00_4167 = 
(long)(BgL_arg1409z00_4165); 
BgL_res2908z00_4168 = BgL_res2907z00_4167; } } 
BgL_res2909z00_4169 = BgL_res2908z00_4168; } }  else 
{ /* Llib/ssl.scm 1267 */
BgL_res2909z00_4169 = 
(BgL_n1z00_4151%BgL_n2z00_4152); } } } 
BgL_restz00_4140 = BgL_res2909z00_4169; } } 
{ /* Llib/ssl.scm 1267 */

{ /* Llib/ssl.scm 1267 */
obj_t BgL_bucketz00_4142;
BgL_bucketz00_4142 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4132),BgL_modz00_4138); 
BgL_res2910z00_4174 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4142),BgL_restz00_4140); } } } } } } } } 
BgL_method1333z00_1753 = BgL_res2910z00_4174; } 
return 
PROCEDURE_ENTRY(BgL_method1333z00_1753)(BgL_method1333z00_1753, 
((obj_t)BgL_sslzd2signzd2_135), BgL_dataz00_136, 
BINT(BgL_offsetz00_137), 
BINT(BgL_lenz00_138), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-sign-update! */
obj_t BGl_z62sslzd2signzd2updatez12z70zz__ssl_sslz00(obj_t BgL_envz00_5530, obj_t BgL_sslzd2signzd2_5531, obj_t BgL_dataz00_5532, obj_t BgL_offsetz00_5533, obj_t BgL_lenz00_5534)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1267 */
{ /* Llib/ssl.scm 1267 */
long BgL_auxz00_11174;long BgL_auxz00_11165;obj_t BgL_auxz00_11158;BgL_sslzd2signzd2_bglt BgL_auxz00_11150;
{ /* Llib/ssl.scm 1267 */
obj_t BgL_tmpz00_11175;
if(
INTEGERP(BgL_lenz00_5534))
{ /* Llib/ssl.scm 1267 */
BgL_tmpz00_11175 = BgL_lenz00_5534
; }  else 
{ 
obj_t BgL_auxz00_11178;
BgL_auxz00_11178 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)51052)), BGl_string3785z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_lenz00_5534); 
FAILURE(BgL_auxz00_11178,BFALSE,BFALSE);} 
BgL_auxz00_11174 = 
(long)CINT(BgL_tmpz00_11175); } 
{ /* Llib/ssl.scm 1267 */
obj_t BgL_tmpz00_11166;
if(
INTEGERP(BgL_offsetz00_5533))
{ /* Llib/ssl.scm 1267 */
BgL_tmpz00_11166 = BgL_offsetz00_5533
; }  else 
{ 
obj_t BgL_auxz00_11169;
BgL_auxz00_11169 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)51052)), BGl_string3785z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_offsetz00_5533); 
FAILURE(BgL_auxz00_11169,BFALSE,BFALSE);} 
BgL_auxz00_11165 = 
(long)CINT(BgL_tmpz00_11166); } 
if(
STRINGP(BgL_dataz00_5532))
{ /* Llib/ssl.scm 1267 */
BgL_auxz00_11158 = BgL_dataz00_5532
; }  else 
{ 
obj_t BgL_auxz00_11161;
BgL_auxz00_11161 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)51052)), BGl_string3785z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_dataz00_5532); 
FAILURE(BgL_auxz00_11161,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2signzd2_5531, BGl_sslzd2signzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1267 */
BgL_auxz00_11150 = 
((BgL_sslzd2signzd2_bglt)BgL_sslzd2signzd2_5531)
; }  else 
{ 
obj_t BgL_auxz00_11154;
BgL_auxz00_11154 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)51052)), BGl_string3785z00zz__ssl_sslz00, BGl_string3727z00zz__ssl_sslz00, BgL_sslzd2signzd2_5531); 
FAILURE(BgL_auxz00_11154,BFALSE,BFALSE);} 
return 
BGl_sslzd2signzd2updatez12z12zz__ssl_sslz00(BgL_auxz00_11150, BgL_auxz00_11158, BgL_auxz00_11165, BgL_auxz00_11174);} } 
BGL_FUNCTION_END;
}



/* ssl-sign-sign */
BGL_EXPORTED_DEF obj_t BGl_sslzd2signzd2signz00zz__ssl_sslz00(BgL_sslzd2signzd2_bglt BgL_sslzd2signzd2_139, obj_t BgL_keyz00_140, long BgL_offsetz00_141, long BgL_lenz00_142)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1279 */
{ /* Llib/ssl.scm 1279 */
obj_t BgL_method1335z00_1754;
{ /* Llib/ssl.scm 1279 */
obj_t BgL_res2922z00_4219;
{ /* Llib/ssl.scm 1279 */
long BgL_objzd2classzd2numz00_4176;
{ /* Llib/ssl.scm 1279 */
long BgL_res2911z00_4179;
BgL_res2911z00_4179 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2signzd2_139)); 
BgL_objzd2classzd2numz00_4176 = BgL_res2911z00_4179; } 
{ /* Llib/ssl.scm 1279 */
obj_t BgL_arg1742z00_4177;
BgL_arg1742z00_4177 = 
PROCEDURE_REF(BGl_sslzd2signzd2signzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1279 */
int BgL_offsetz00_4181;
BgL_offsetz00_4181 = 
(int)(BgL_objzd2classzd2numz00_4176); 
{ /* Llib/ssl.scm 1279 */
long BgL_offsetz00_4182;
BgL_offsetz00_4182 = 
(
(long)(BgL_offsetz00_4181)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1279 */
long BgL_modz00_4183;
{ /* Llib/ssl.scm 1279 */
int BgL_arg1744z00_4184;
BgL_arg1744z00_4184 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1279 */
long BgL_res2914z00_4194;
{ /* Llib/ssl.scm 1279 */
long BgL_tmpz00_11192;
BgL_tmpz00_11192 = 
(long)(BgL_arg1744z00_4184); 
BgL_res2914z00_4194 = 
(BgL_offsetz00_4182/BgL_tmpz00_11192); } 
BgL_modz00_4183 = BgL_res2914z00_4194; } } 
{ /* Llib/ssl.scm 1279 */
long BgL_restz00_4185;
{ /* Llib/ssl.scm 1279 */
int BgL_arg1743z00_4186;
BgL_arg1743z00_4186 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1279 */
long BgL_res2921z00_4214;
{ /* Llib/ssl.scm 1279 */
long BgL_n1z00_4196;long BgL_n2z00_4197;
BgL_n1z00_4196 = BgL_offsetz00_4182; 
BgL_n2z00_4197 = 
(long)(BgL_arg1743z00_4186); 
{ /* Llib/ssl.scm 1279 */
bool_t BgL_testz00_11197;
{ /* Llib/ssl.scm 1279 */
long BgL_arg1283z00_4199;
BgL_arg1283z00_4199 = 
(((BgL_n1z00_4196) | (BgL_n2z00_4197)) & -2147483648); 
BgL_testz00_11197 = 
(BgL_arg1283z00_4199==((long)0)); } 
if(BgL_testz00_11197)
{ /* Llib/ssl.scm 1279 */
int32_t BgL_arg1272z00_4200;
{ /* Llib/ssl.scm 1279 */
int32_t BgL_arg1278z00_4201;int32_t BgL_arg1279z00_4202;
{ /* Llib/ssl.scm 1279 */
int32_t BgL_res2917z00_4206;
BgL_res2917z00_4206 = 
(int32_t)(BgL_n1z00_4196); 
BgL_arg1278z00_4201 = BgL_res2917z00_4206; } 
{ /* Llib/ssl.scm 1279 */
int32_t BgL_res2918z00_4208;
BgL_res2918z00_4208 = 
(int32_t)(BgL_n2z00_4197); 
BgL_arg1279z00_4202 = BgL_res2918z00_4208; } 
BgL_arg1272z00_4200 = 
(BgL_arg1278z00_4201%BgL_arg1279z00_4202); } 
{ /* Llib/ssl.scm 1279 */
long BgL_res2920z00_4213;
{ /* Llib/ssl.scm 1279 */
long BgL_arg1409z00_4210;
BgL_arg1409z00_4210 = 
(long)(BgL_arg1272z00_4200); 
{ /* Llib/ssl.scm 1279 */
long BgL_res2919z00_4212;
BgL_res2919z00_4212 = 
(long)(BgL_arg1409z00_4210); 
BgL_res2920z00_4213 = BgL_res2919z00_4212; } } 
BgL_res2921z00_4214 = BgL_res2920z00_4213; } }  else 
{ /* Llib/ssl.scm 1279 */
BgL_res2921z00_4214 = 
(BgL_n1z00_4196%BgL_n2z00_4197); } } } 
BgL_restz00_4185 = BgL_res2921z00_4214; } } 
{ /* Llib/ssl.scm 1279 */

{ /* Llib/ssl.scm 1279 */
obj_t BgL_bucketz00_4187;
BgL_bucketz00_4187 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4177),BgL_modz00_4183); 
BgL_res2922z00_4219 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4187),BgL_restz00_4185); } } } } } } } } 
BgL_method1335z00_1754 = BgL_res2922z00_4219; } 
return 
PROCEDURE_ENTRY(BgL_method1335z00_1754)(BgL_method1335z00_1754, 
((obj_t)BgL_sslzd2signzd2_139), BgL_keyz00_140, 
BINT(BgL_offsetz00_141), 
BINT(BgL_lenz00_142), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-sign-sign */
obj_t BGl_z62sslzd2signzd2signz62zz__ssl_sslz00(obj_t BgL_envz00_5535, obj_t BgL_sslzd2signzd2_5536, obj_t BgL_keyz00_5537, obj_t BgL_offsetz00_5538, obj_t BgL_lenz00_5539)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1279 */
{ /* Llib/ssl.scm 1279 */
long BgL_auxz00_11244;long BgL_auxz00_11235;obj_t BgL_auxz00_11228;BgL_sslzd2signzd2_bglt BgL_auxz00_11220;
{ /* Llib/ssl.scm 1279 */
obj_t BgL_tmpz00_11245;
if(
INTEGERP(BgL_lenz00_5539))
{ /* Llib/ssl.scm 1279 */
BgL_tmpz00_11245 = BgL_lenz00_5539
; }  else 
{ 
obj_t BgL_auxz00_11248;
BgL_auxz00_11248 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)51548)), BGl_string3786z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_lenz00_5539); 
FAILURE(BgL_auxz00_11248,BFALSE,BFALSE);} 
BgL_auxz00_11244 = 
(long)CINT(BgL_tmpz00_11245); } 
{ /* Llib/ssl.scm 1279 */
obj_t BgL_tmpz00_11236;
if(
INTEGERP(BgL_offsetz00_5538))
{ /* Llib/ssl.scm 1279 */
BgL_tmpz00_11236 = BgL_offsetz00_5538
; }  else 
{ 
obj_t BgL_auxz00_11239;
BgL_auxz00_11239 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)51548)), BGl_string3786z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_offsetz00_5538); 
FAILURE(BgL_auxz00_11239,BFALSE,BFALSE);} 
BgL_auxz00_11235 = 
(long)CINT(BgL_tmpz00_11236); } 
if(
STRINGP(BgL_keyz00_5537))
{ /* Llib/ssl.scm 1279 */
BgL_auxz00_11228 = BgL_keyz00_5537
; }  else 
{ 
obj_t BgL_auxz00_11231;
BgL_auxz00_11231 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)51548)), BGl_string3786z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_keyz00_5537); 
FAILURE(BgL_auxz00_11231,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2signzd2_5536, BGl_sslzd2signzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1279 */
BgL_auxz00_11220 = 
((BgL_sslzd2signzd2_bglt)BgL_sslzd2signzd2_5536)
; }  else 
{ 
obj_t BgL_auxz00_11224;
BgL_auxz00_11224 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)51548)), BGl_string3786z00zz__ssl_sslz00, BGl_string3727z00zz__ssl_sslz00, BgL_sslzd2signzd2_5536); 
FAILURE(BgL_auxz00_11224,BFALSE,BFALSE);} 
return 
BGl_sslzd2signzd2signz00zz__ssl_sslz00(BgL_auxz00_11220, BgL_auxz00_11228, BgL_auxz00_11235, BgL_auxz00_11244);} } 
BGL_FUNCTION_END;
}



/* ssl-verify-init */
BGL_EXPORTED_DEF obj_t BGl_sslzd2verifyzd2initz00zz__ssl_sslz00(BgL_sslzd2verifyzd2_bglt BgL_sslzd2verifyzd2_143, obj_t BgL_verifyz00_144)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1290 */
{ /* Llib/ssl.scm 1290 */
obj_t BgL_method1337z00_1755;
{ /* Llib/ssl.scm 1290 */
obj_t BgL_res2934z00_4264;
{ /* Llib/ssl.scm 1290 */
long BgL_objzd2classzd2numz00_4221;
{ /* Llib/ssl.scm 1290 */
long BgL_res2923z00_4224;
BgL_res2923z00_4224 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2verifyzd2_143)); 
BgL_objzd2classzd2numz00_4221 = BgL_res2923z00_4224; } 
{ /* Llib/ssl.scm 1290 */
obj_t BgL_arg1742z00_4222;
BgL_arg1742z00_4222 = 
PROCEDURE_REF(BGl_sslzd2verifyzd2initzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1290 */
int BgL_offsetz00_4226;
BgL_offsetz00_4226 = 
(int)(BgL_objzd2classzd2numz00_4221); 
{ /* Llib/ssl.scm 1290 */
long BgL_offsetz00_4227;
BgL_offsetz00_4227 = 
(
(long)(BgL_offsetz00_4226)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1290 */
long BgL_modz00_4228;
{ /* Llib/ssl.scm 1290 */
int BgL_arg1744z00_4229;
BgL_arg1744z00_4229 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1290 */
long BgL_res2926z00_4239;
{ /* Llib/ssl.scm 1290 */
long BgL_tmpz00_11262;
BgL_tmpz00_11262 = 
(long)(BgL_arg1744z00_4229); 
BgL_res2926z00_4239 = 
(BgL_offsetz00_4227/BgL_tmpz00_11262); } 
BgL_modz00_4228 = BgL_res2926z00_4239; } } 
{ /* Llib/ssl.scm 1290 */
long BgL_restz00_4230;
{ /* Llib/ssl.scm 1290 */
int BgL_arg1743z00_4231;
BgL_arg1743z00_4231 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1290 */
long BgL_res2933z00_4259;
{ /* Llib/ssl.scm 1290 */
long BgL_n1z00_4241;long BgL_n2z00_4242;
BgL_n1z00_4241 = BgL_offsetz00_4227; 
BgL_n2z00_4242 = 
(long)(BgL_arg1743z00_4231); 
{ /* Llib/ssl.scm 1290 */
bool_t BgL_testz00_11267;
{ /* Llib/ssl.scm 1290 */
long BgL_arg1283z00_4244;
BgL_arg1283z00_4244 = 
(((BgL_n1z00_4241) | (BgL_n2z00_4242)) & -2147483648); 
BgL_testz00_11267 = 
(BgL_arg1283z00_4244==((long)0)); } 
if(BgL_testz00_11267)
{ /* Llib/ssl.scm 1290 */
int32_t BgL_arg1272z00_4245;
{ /* Llib/ssl.scm 1290 */
int32_t BgL_arg1278z00_4246;int32_t BgL_arg1279z00_4247;
{ /* Llib/ssl.scm 1290 */
int32_t BgL_res2929z00_4251;
BgL_res2929z00_4251 = 
(int32_t)(BgL_n1z00_4241); 
BgL_arg1278z00_4246 = BgL_res2929z00_4251; } 
{ /* Llib/ssl.scm 1290 */
int32_t BgL_res2930z00_4253;
BgL_res2930z00_4253 = 
(int32_t)(BgL_n2z00_4242); 
BgL_arg1279z00_4247 = BgL_res2930z00_4253; } 
BgL_arg1272z00_4245 = 
(BgL_arg1278z00_4246%BgL_arg1279z00_4247); } 
{ /* Llib/ssl.scm 1290 */
long BgL_res2932z00_4258;
{ /* Llib/ssl.scm 1290 */
long BgL_arg1409z00_4255;
BgL_arg1409z00_4255 = 
(long)(BgL_arg1272z00_4245); 
{ /* Llib/ssl.scm 1290 */
long BgL_res2931z00_4257;
BgL_res2931z00_4257 = 
(long)(BgL_arg1409z00_4255); 
BgL_res2932z00_4258 = BgL_res2931z00_4257; } } 
BgL_res2933z00_4259 = BgL_res2932z00_4258; } }  else 
{ /* Llib/ssl.scm 1290 */
BgL_res2933z00_4259 = 
(BgL_n1z00_4241%BgL_n2z00_4242); } } } 
BgL_restz00_4230 = BgL_res2933z00_4259; } } 
{ /* Llib/ssl.scm 1290 */

{ /* Llib/ssl.scm 1290 */
obj_t BgL_bucketz00_4232;
BgL_bucketz00_4232 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4222),BgL_modz00_4228); 
BgL_res2934z00_4264 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4232),BgL_restz00_4230); } } } } } } } } 
BgL_method1337z00_1755 = BgL_res2934z00_4264; } 
return 
PROCEDURE_ENTRY(BgL_method1337z00_1755)(BgL_method1337z00_1755, 
((obj_t)BgL_sslzd2verifyzd2_143), BgL_verifyz00_144, BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-verify-init */
obj_t BGl_z62sslzd2verifyzd2initz62zz__ssl_sslz00(obj_t BgL_envz00_5540, obj_t BgL_sslzd2verifyzd2_5541, obj_t BgL_verifyz00_5542)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1290 */
{ /* Llib/ssl.scm 1290 */
obj_t BgL_auxz00_11294;BgL_sslzd2verifyzd2_bglt BgL_auxz00_11286;
if(
STRINGP(BgL_verifyz00_5542))
{ /* Llib/ssl.scm 1290 */
BgL_auxz00_11294 = BgL_verifyz00_5542
; }  else 
{ 
obj_t BgL_auxz00_11297;
BgL_auxz00_11297 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)52025)), BGl_string3787z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_verifyz00_5542); 
FAILURE(BgL_auxz00_11297,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2verifyzd2_5541, BGl_sslzd2verifyzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1290 */
BgL_auxz00_11286 = 
((BgL_sslzd2verifyzd2_bglt)BgL_sslzd2verifyzd2_5541)
; }  else 
{ 
obj_t BgL_auxz00_11290;
BgL_auxz00_11290 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)52025)), BGl_string3787z00zz__ssl_sslz00, BGl_string3722z00zz__ssl_sslz00, BgL_sslzd2verifyzd2_5541); 
FAILURE(BgL_auxz00_11290,BFALSE,BFALSE);} 
return 
BGl_sslzd2verifyzd2initz00zz__ssl_sslz00(BgL_auxz00_11286, BgL_auxz00_11294);} } 
BGL_FUNCTION_END;
}



/* ssl-verify-update! */
BGL_EXPORTED_DEF obj_t BGl_sslzd2verifyzd2updatez12z12zz__ssl_sslz00(BgL_sslzd2verifyzd2_bglt BgL_sslzd2verifyzd2_145, obj_t BgL_dataz00_146, long BgL_offsetz00_147, long BgL_lenz00_148)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1302 */
{ /* Llib/ssl.scm 1302 */
obj_t BgL_method1339z00_1756;
{ /* Llib/ssl.scm 1302 */
obj_t BgL_res2946z00_4309;
{ /* Llib/ssl.scm 1302 */
long BgL_objzd2classzd2numz00_4266;
{ /* Llib/ssl.scm 1302 */
long BgL_res2935z00_4269;
BgL_res2935z00_4269 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2verifyzd2_145)); 
BgL_objzd2classzd2numz00_4266 = BgL_res2935z00_4269; } 
{ /* Llib/ssl.scm 1302 */
obj_t BgL_arg1742z00_4267;
BgL_arg1742z00_4267 = 
PROCEDURE_REF(BGl_sslzd2verifyzd2updatez12zd2envzc0zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1302 */
int BgL_offsetz00_4271;
BgL_offsetz00_4271 = 
(int)(BgL_objzd2classzd2numz00_4266); 
{ /* Llib/ssl.scm 1302 */
long BgL_offsetz00_4272;
BgL_offsetz00_4272 = 
(
(long)(BgL_offsetz00_4271)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1302 */
long BgL_modz00_4273;
{ /* Llib/ssl.scm 1302 */
int BgL_arg1744z00_4274;
BgL_arg1744z00_4274 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1302 */
long BgL_res2938z00_4284;
{ /* Llib/ssl.scm 1302 */
long BgL_tmpz00_11310;
BgL_tmpz00_11310 = 
(long)(BgL_arg1744z00_4274); 
BgL_res2938z00_4284 = 
(BgL_offsetz00_4272/BgL_tmpz00_11310); } 
BgL_modz00_4273 = BgL_res2938z00_4284; } } 
{ /* Llib/ssl.scm 1302 */
long BgL_restz00_4275;
{ /* Llib/ssl.scm 1302 */
int BgL_arg1743z00_4276;
BgL_arg1743z00_4276 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1302 */
long BgL_res2945z00_4304;
{ /* Llib/ssl.scm 1302 */
long BgL_n1z00_4286;long BgL_n2z00_4287;
BgL_n1z00_4286 = BgL_offsetz00_4272; 
BgL_n2z00_4287 = 
(long)(BgL_arg1743z00_4276); 
{ /* Llib/ssl.scm 1302 */
bool_t BgL_testz00_11315;
{ /* Llib/ssl.scm 1302 */
long BgL_arg1283z00_4289;
BgL_arg1283z00_4289 = 
(((BgL_n1z00_4286) | (BgL_n2z00_4287)) & -2147483648); 
BgL_testz00_11315 = 
(BgL_arg1283z00_4289==((long)0)); } 
if(BgL_testz00_11315)
{ /* Llib/ssl.scm 1302 */
int32_t BgL_arg1272z00_4290;
{ /* Llib/ssl.scm 1302 */
int32_t BgL_arg1278z00_4291;int32_t BgL_arg1279z00_4292;
{ /* Llib/ssl.scm 1302 */
int32_t BgL_res2941z00_4296;
BgL_res2941z00_4296 = 
(int32_t)(BgL_n1z00_4286); 
BgL_arg1278z00_4291 = BgL_res2941z00_4296; } 
{ /* Llib/ssl.scm 1302 */
int32_t BgL_res2942z00_4298;
BgL_res2942z00_4298 = 
(int32_t)(BgL_n2z00_4287); 
BgL_arg1279z00_4292 = BgL_res2942z00_4298; } 
BgL_arg1272z00_4290 = 
(BgL_arg1278z00_4291%BgL_arg1279z00_4292); } 
{ /* Llib/ssl.scm 1302 */
long BgL_res2944z00_4303;
{ /* Llib/ssl.scm 1302 */
long BgL_arg1409z00_4300;
BgL_arg1409z00_4300 = 
(long)(BgL_arg1272z00_4290); 
{ /* Llib/ssl.scm 1302 */
long BgL_res2943z00_4302;
BgL_res2943z00_4302 = 
(long)(BgL_arg1409z00_4300); 
BgL_res2944z00_4303 = BgL_res2943z00_4302; } } 
BgL_res2945z00_4304 = BgL_res2944z00_4303; } }  else 
{ /* Llib/ssl.scm 1302 */
BgL_res2945z00_4304 = 
(BgL_n1z00_4286%BgL_n2z00_4287); } } } 
BgL_restz00_4275 = BgL_res2945z00_4304; } } 
{ /* Llib/ssl.scm 1302 */

{ /* Llib/ssl.scm 1302 */
obj_t BgL_bucketz00_4277;
BgL_bucketz00_4277 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4267),BgL_modz00_4273); 
BgL_res2946z00_4309 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4277),BgL_restz00_4275); } } } } } } } } 
BgL_method1339z00_1756 = BgL_res2946z00_4309; } 
return 
PROCEDURE_ENTRY(BgL_method1339z00_1756)(BgL_method1339z00_1756, 
((obj_t)BgL_sslzd2verifyzd2_145), BgL_dataz00_146, 
BINT(BgL_offsetz00_147), 
BINT(BgL_lenz00_148), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-verify-update! */
obj_t BGl_z62sslzd2verifyzd2updatez12z70zz__ssl_sslz00(obj_t BgL_envz00_5543, obj_t BgL_sslzd2verifyzd2_5544, obj_t BgL_dataz00_5545, obj_t BgL_offsetz00_5546, obj_t BgL_lenz00_5547)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1302 */
{ /* Llib/ssl.scm 1302 */
long BgL_auxz00_11362;long BgL_auxz00_11353;obj_t BgL_auxz00_11346;BgL_sslzd2verifyzd2_bglt BgL_auxz00_11338;
{ /* Llib/ssl.scm 1302 */
obj_t BgL_tmpz00_11363;
if(
INTEGERP(BgL_lenz00_5547))
{ /* Llib/ssl.scm 1302 */
BgL_tmpz00_11363 = BgL_lenz00_5547
; }  else 
{ 
obj_t BgL_auxz00_11366;
BgL_auxz00_11366 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)52510)), BGl_string3788z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_lenz00_5547); 
FAILURE(BgL_auxz00_11366,BFALSE,BFALSE);} 
BgL_auxz00_11362 = 
(long)CINT(BgL_tmpz00_11363); } 
{ /* Llib/ssl.scm 1302 */
obj_t BgL_tmpz00_11354;
if(
INTEGERP(BgL_offsetz00_5546))
{ /* Llib/ssl.scm 1302 */
BgL_tmpz00_11354 = BgL_offsetz00_5546
; }  else 
{ 
obj_t BgL_auxz00_11357;
BgL_auxz00_11357 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)52510)), BGl_string3788z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_offsetz00_5546); 
FAILURE(BgL_auxz00_11357,BFALSE,BFALSE);} 
BgL_auxz00_11353 = 
(long)CINT(BgL_tmpz00_11354); } 
if(
STRINGP(BgL_dataz00_5545))
{ /* Llib/ssl.scm 1302 */
BgL_auxz00_11346 = BgL_dataz00_5545
; }  else 
{ 
obj_t BgL_auxz00_11349;
BgL_auxz00_11349 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)52510)), BGl_string3788z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_dataz00_5545); 
FAILURE(BgL_auxz00_11349,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2verifyzd2_5544, BGl_sslzd2verifyzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1302 */
BgL_auxz00_11338 = 
((BgL_sslzd2verifyzd2_bglt)BgL_sslzd2verifyzd2_5544)
; }  else 
{ 
obj_t BgL_auxz00_11342;
BgL_auxz00_11342 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)52510)), BGl_string3788z00zz__ssl_sslz00, BGl_string3722z00zz__ssl_sslz00, BgL_sslzd2verifyzd2_5544); 
FAILURE(BgL_auxz00_11342,BFALSE,BFALSE);} 
return 
BGl_sslzd2verifyzd2updatez12z12zz__ssl_sslz00(BgL_auxz00_11338, BgL_auxz00_11346, BgL_auxz00_11353, BgL_auxz00_11362);} } 
BGL_FUNCTION_END;
}



/* ssl-verify-final */
BGL_EXPORTED_DEF bool_t BGl_sslzd2verifyzd2finalz00zz__ssl_sslz00(BgL_sslzd2verifyzd2_bglt BgL_sslzd2verifyzd2_149, obj_t BgL_keyz00_150, long BgL_koffsetz00_151, long BgL_klenz00_152, obj_t BgL_sigz00_153, long BgL_soffsetz00_154, long BgL_slenz00_155)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1314 */
{ /* Llib/ssl.scm 1314 */
obj_t BgL_method1341z00_1757;
{ /* Llib/ssl.scm 1314 */
obj_t BgL_res2958z00_4354;
{ /* Llib/ssl.scm 1314 */
long BgL_objzd2classzd2numz00_4311;
{ /* Llib/ssl.scm 1314 */
long BgL_res2947z00_4314;
BgL_res2947z00_4314 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2verifyzd2_149)); 
BgL_objzd2classzd2numz00_4311 = BgL_res2947z00_4314; } 
{ /* Llib/ssl.scm 1314 */
obj_t BgL_arg1742z00_4312;
BgL_arg1742z00_4312 = 
PROCEDURE_REF(BGl_sslzd2verifyzd2finalzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1314 */
int BgL_offsetz00_4316;
BgL_offsetz00_4316 = 
(int)(BgL_objzd2classzd2numz00_4311); 
{ /* Llib/ssl.scm 1314 */
long BgL_offsetz00_4317;
BgL_offsetz00_4317 = 
(
(long)(BgL_offsetz00_4316)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1314 */
long BgL_modz00_4318;
{ /* Llib/ssl.scm 1314 */
int BgL_arg1744z00_4319;
BgL_arg1744z00_4319 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1314 */
long BgL_res2950z00_4329;
{ /* Llib/ssl.scm 1314 */
long BgL_tmpz00_11380;
BgL_tmpz00_11380 = 
(long)(BgL_arg1744z00_4319); 
BgL_res2950z00_4329 = 
(BgL_offsetz00_4317/BgL_tmpz00_11380); } 
BgL_modz00_4318 = BgL_res2950z00_4329; } } 
{ /* Llib/ssl.scm 1314 */
long BgL_restz00_4320;
{ /* Llib/ssl.scm 1314 */
int BgL_arg1743z00_4321;
BgL_arg1743z00_4321 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1314 */
long BgL_res2957z00_4349;
{ /* Llib/ssl.scm 1314 */
long BgL_n1z00_4331;long BgL_n2z00_4332;
BgL_n1z00_4331 = BgL_offsetz00_4317; 
BgL_n2z00_4332 = 
(long)(BgL_arg1743z00_4321); 
{ /* Llib/ssl.scm 1314 */
bool_t BgL_testz00_11385;
{ /* Llib/ssl.scm 1314 */
long BgL_arg1283z00_4334;
BgL_arg1283z00_4334 = 
(((BgL_n1z00_4331) | (BgL_n2z00_4332)) & -2147483648); 
BgL_testz00_11385 = 
(BgL_arg1283z00_4334==((long)0)); } 
if(BgL_testz00_11385)
{ /* Llib/ssl.scm 1314 */
int32_t BgL_arg1272z00_4335;
{ /* Llib/ssl.scm 1314 */
int32_t BgL_arg1278z00_4336;int32_t BgL_arg1279z00_4337;
{ /* Llib/ssl.scm 1314 */
int32_t BgL_res2953z00_4341;
BgL_res2953z00_4341 = 
(int32_t)(BgL_n1z00_4331); 
BgL_arg1278z00_4336 = BgL_res2953z00_4341; } 
{ /* Llib/ssl.scm 1314 */
int32_t BgL_res2954z00_4343;
BgL_res2954z00_4343 = 
(int32_t)(BgL_n2z00_4332); 
BgL_arg1279z00_4337 = BgL_res2954z00_4343; } 
BgL_arg1272z00_4335 = 
(BgL_arg1278z00_4336%BgL_arg1279z00_4337); } 
{ /* Llib/ssl.scm 1314 */
long BgL_res2956z00_4348;
{ /* Llib/ssl.scm 1314 */
long BgL_arg1409z00_4345;
BgL_arg1409z00_4345 = 
(long)(BgL_arg1272z00_4335); 
{ /* Llib/ssl.scm 1314 */
long BgL_res2955z00_4347;
BgL_res2955z00_4347 = 
(long)(BgL_arg1409z00_4345); 
BgL_res2956z00_4348 = BgL_res2955z00_4347; } } 
BgL_res2957z00_4349 = BgL_res2956z00_4348; } }  else 
{ /* Llib/ssl.scm 1314 */
BgL_res2957z00_4349 = 
(BgL_n1z00_4331%BgL_n2z00_4332); } } } 
BgL_restz00_4320 = BgL_res2957z00_4349; } } 
{ /* Llib/ssl.scm 1314 */

{ /* Llib/ssl.scm 1314 */
obj_t BgL_bucketz00_4322;
BgL_bucketz00_4322 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4312),BgL_modz00_4318); 
BgL_res2958z00_4354 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4322),BgL_restz00_4320); } } } } } } } } 
BgL_method1341z00_1757 = BgL_res2958z00_4354; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1341z00_1757)(BgL_method1341z00_1757, 
((obj_t)BgL_sslzd2verifyzd2_149), BgL_keyz00_150, 
BINT(BgL_koffsetz00_151), 
BINT(BgL_klenz00_152), BgL_sigz00_153, 
BINT(BgL_soffsetz00_154), 
BINT(BgL_slenz00_155), BEOA));} } 
BGL_FUNCTION_END;
}



/* &ssl-verify-final */
obj_t BGl_z62sslzd2verifyzd2finalz62zz__ssl_sslz00(obj_t BgL_envz00_5548, obj_t BgL_sslzd2verifyzd2_5549, obj_t BgL_keyz00_5550, obj_t BgL_koffsetz00_5551, obj_t BgL_klenz00_5552, obj_t BgL_sigz00_5553, obj_t BgL_soffsetz00_5554, obj_t BgL_slenz00_5555)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1314 */
{ /* Llib/ssl.scm 1314 */
bool_t BgL_tmpz00_11414;
{ /* Llib/ssl.scm 1314 */
long BgL_auxz00_11464;long BgL_auxz00_11455;obj_t BgL_auxz00_11448;long BgL_auxz00_11439;long BgL_auxz00_11430;obj_t BgL_auxz00_11423;BgL_sslzd2verifyzd2_bglt BgL_auxz00_11415;
{ /* Llib/ssl.scm 1314 */
obj_t BgL_tmpz00_11465;
if(
INTEGERP(BgL_slenz00_5555))
{ /* Llib/ssl.scm 1314 */
BgL_tmpz00_11465 = BgL_slenz00_5555
; }  else 
{ 
obj_t BgL_auxz00_11468;
BgL_auxz00_11468 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)53022)), BGl_string3789z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_slenz00_5555); 
FAILURE(BgL_auxz00_11468,BFALSE,BFALSE);} 
BgL_auxz00_11464 = 
(long)CINT(BgL_tmpz00_11465); } 
{ /* Llib/ssl.scm 1314 */
obj_t BgL_tmpz00_11456;
if(
INTEGERP(BgL_soffsetz00_5554))
{ /* Llib/ssl.scm 1314 */
BgL_tmpz00_11456 = BgL_soffsetz00_5554
; }  else 
{ 
obj_t BgL_auxz00_11459;
BgL_auxz00_11459 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)53022)), BGl_string3789z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_soffsetz00_5554); 
FAILURE(BgL_auxz00_11459,BFALSE,BFALSE);} 
BgL_auxz00_11455 = 
(long)CINT(BgL_tmpz00_11456); } 
if(
STRINGP(BgL_sigz00_5553))
{ /* Llib/ssl.scm 1314 */
BgL_auxz00_11448 = BgL_sigz00_5553
; }  else 
{ 
obj_t BgL_auxz00_11451;
BgL_auxz00_11451 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)53022)), BGl_string3789z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_sigz00_5553); 
FAILURE(BgL_auxz00_11451,BFALSE,BFALSE);} 
{ /* Llib/ssl.scm 1314 */
obj_t BgL_tmpz00_11440;
if(
INTEGERP(BgL_klenz00_5552))
{ /* Llib/ssl.scm 1314 */
BgL_tmpz00_11440 = BgL_klenz00_5552
; }  else 
{ 
obj_t BgL_auxz00_11443;
BgL_auxz00_11443 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)53022)), BGl_string3789z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_klenz00_5552); 
FAILURE(BgL_auxz00_11443,BFALSE,BFALSE);} 
BgL_auxz00_11439 = 
(long)CINT(BgL_tmpz00_11440); } 
{ /* Llib/ssl.scm 1314 */
obj_t BgL_tmpz00_11431;
if(
INTEGERP(BgL_koffsetz00_5551))
{ /* Llib/ssl.scm 1314 */
BgL_tmpz00_11431 = BgL_koffsetz00_5551
; }  else 
{ 
obj_t BgL_auxz00_11434;
BgL_auxz00_11434 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)53022)), BGl_string3789z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_koffsetz00_5551); 
FAILURE(BgL_auxz00_11434,BFALSE,BFALSE);} 
BgL_auxz00_11430 = 
(long)CINT(BgL_tmpz00_11431); } 
if(
STRINGP(BgL_keyz00_5550))
{ /* Llib/ssl.scm 1314 */
BgL_auxz00_11423 = BgL_keyz00_5550
; }  else 
{ 
obj_t BgL_auxz00_11426;
BgL_auxz00_11426 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)53022)), BGl_string3789z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_keyz00_5550); 
FAILURE(BgL_auxz00_11426,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2verifyzd2_5549, BGl_sslzd2verifyzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1314 */
BgL_auxz00_11415 = 
((BgL_sslzd2verifyzd2_bglt)BgL_sslzd2verifyzd2_5549)
; }  else 
{ 
obj_t BgL_auxz00_11419;
BgL_auxz00_11419 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)53022)), BGl_string3789z00zz__ssl_sslz00, BGl_string3722z00zz__ssl_sslz00, BgL_sslzd2verifyzd2_5549); 
FAILURE(BgL_auxz00_11419,BFALSE,BFALSE);} 
BgL_tmpz00_11414 = 
BGl_sslzd2verifyzd2finalz00zz__ssl_sslz00(BgL_auxz00_11415, BgL_auxz00_11423, BgL_auxz00_11430, BgL_auxz00_11439, BgL_auxz00_11448, BgL_auxz00_11455, BgL_auxz00_11464); } 
return 
BBOOL(BgL_tmpz00_11414);} } 
BGL_FUNCTION_END;
}



/* ssl-cipher-init */
BGL_EXPORTED_DEF obj_t BGl_sslzd2cipherzd2initz00zz__ssl_sslz00(BgL_sslzd2cipherzd2_bglt BgL_sslzd2cipherzd2_156, obj_t BgL_cipherz00_157, obj_t BgL_keyz00_158, long BgL_offsetz00_159, long BgL_lenz00_160, bool_t BgL_encz00_161)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1328 */
{ /* Llib/ssl.scm 1328 */
obj_t BgL_method1343z00_1758;
{ /* Llib/ssl.scm 1328 */
obj_t BgL_res2970z00_4399;
{ /* Llib/ssl.scm 1328 */
long BgL_objzd2classzd2numz00_4356;
{ /* Llib/ssl.scm 1328 */
long BgL_res2959z00_4359;
BgL_res2959z00_4359 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2cipherzd2_156)); 
BgL_objzd2classzd2numz00_4356 = BgL_res2959z00_4359; } 
{ /* Llib/ssl.scm 1328 */
obj_t BgL_arg1742z00_4357;
BgL_arg1742z00_4357 = 
PROCEDURE_REF(BGl_sslzd2cipherzd2initzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1328 */
int BgL_offsetz00_4361;
BgL_offsetz00_4361 = 
(int)(BgL_objzd2classzd2numz00_4356); 
{ /* Llib/ssl.scm 1328 */
long BgL_offsetz00_4362;
BgL_offsetz00_4362 = 
(
(long)(BgL_offsetz00_4361)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1328 */
long BgL_modz00_4363;
{ /* Llib/ssl.scm 1328 */
int BgL_arg1744z00_4364;
BgL_arg1744z00_4364 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1328 */
long BgL_res2962z00_4374;
{ /* Llib/ssl.scm 1328 */
long BgL_tmpz00_11483;
BgL_tmpz00_11483 = 
(long)(BgL_arg1744z00_4364); 
BgL_res2962z00_4374 = 
(BgL_offsetz00_4362/BgL_tmpz00_11483); } 
BgL_modz00_4363 = BgL_res2962z00_4374; } } 
{ /* Llib/ssl.scm 1328 */
long BgL_restz00_4365;
{ /* Llib/ssl.scm 1328 */
int BgL_arg1743z00_4366;
BgL_arg1743z00_4366 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1328 */
long BgL_res2969z00_4394;
{ /* Llib/ssl.scm 1328 */
long BgL_n1z00_4376;long BgL_n2z00_4377;
BgL_n1z00_4376 = BgL_offsetz00_4362; 
BgL_n2z00_4377 = 
(long)(BgL_arg1743z00_4366); 
{ /* Llib/ssl.scm 1328 */
bool_t BgL_testz00_11488;
{ /* Llib/ssl.scm 1328 */
long BgL_arg1283z00_4379;
BgL_arg1283z00_4379 = 
(((BgL_n1z00_4376) | (BgL_n2z00_4377)) & -2147483648); 
BgL_testz00_11488 = 
(BgL_arg1283z00_4379==((long)0)); } 
if(BgL_testz00_11488)
{ /* Llib/ssl.scm 1328 */
int32_t BgL_arg1272z00_4380;
{ /* Llib/ssl.scm 1328 */
int32_t BgL_arg1278z00_4381;int32_t BgL_arg1279z00_4382;
{ /* Llib/ssl.scm 1328 */
int32_t BgL_res2965z00_4386;
BgL_res2965z00_4386 = 
(int32_t)(BgL_n1z00_4376); 
BgL_arg1278z00_4381 = BgL_res2965z00_4386; } 
{ /* Llib/ssl.scm 1328 */
int32_t BgL_res2966z00_4388;
BgL_res2966z00_4388 = 
(int32_t)(BgL_n2z00_4377); 
BgL_arg1279z00_4382 = BgL_res2966z00_4388; } 
BgL_arg1272z00_4380 = 
(BgL_arg1278z00_4381%BgL_arg1279z00_4382); } 
{ /* Llib/ssl.scm 1328 */
long BgL_res2968z00_4393;
{ /* Llib/ssl.scm 1328 */
long BgL_arg1409z00_4390;
BgL_arg1409z00_4390 = 
(long)(BgL_arg1272z00_4380); 
{ /* Llib/ssl.scm 1328 */
long BgL_res2967z00_4392;
BgL_res2967z00_4392 = 
(long)(BgL_arg1409z00_4390); 
BgL_res2968z00_4393 = BgL_res2967z00_4392; } } 
BgL_res2969z00_4394 = BgL_res2968z00_4393; } }  else 
{ /* Llib/ssl.scm 1328 */
BgL_res2969z00_4394 = 
(BgL_n1z00_4376%BgL_n2z00_4377); } } } 
BgL_restz00_4365 = BgL_res2969z00_4394; } } 
{ /* Llib/ssl.scm 1328 */

{ /* Llib/ssl.scm 1328 */
obj_t BgL_bucketz00_4367;
BgL_bucketz00_4367 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4357),BgL_modz00_4363); 
BgL_res2970z00_4399 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4367),BgL_restz00_4365); } } } } } } } } 
BgL_method1343z00_1758 = BgL_res2970z00_4399; } 
return 
PROCEDURE_ENTRY(BgL_method1343z00_1758)(BgL_method1343z00_1758, 
((obj_t)BgL_sslzd2cipherzd2_156), BgL_cipherz00_157, BgL_keyz00_158, 
BINT(BgL_offsetz00_159), 
BINT(BgL_lenz00_160), 
BBOOL(BgL_encz00_161), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-cipher-init */
obj_t BGl_z62sslzd2cipherzd2initz62zz__ssl_sslz00(obj_t BgL_envz00_5556, obj_t BgL_sslzd2cipherzd2_5557, obj_t BgL_cipherz00_5558, obj_t BgL_keyz00_5559, obj_t BgL_offsetz00_5560, obj_t BgL_lenz00_5561, obj_t BgL_encz00_5562)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1328 */
{ /* Llib/ssl.scm 1328 */
long BgL_auxz00_11545;long BgL_auxz00_11536;obj_t BgL_auxz00_11529;obj_t BgL_auxz00_11522;BgL_sslzd2cipherzd2_bglt BgL_auxz00_11514;
{ /* Llib/ssl.scm 1328 */
obj_t BgL_tmpz00_11546;
if(
INTEGERP(BgL_lenz00_5561))
{ /* Llib/ssl.scm 1328 */
BgL_tmpz00_11546 = BgL_lenz00_5561
; }  else 
{ 
obj_t BgL_auxz00_11549;
BgL_auxz00_11549 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)53505)), BGl_string3790z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_lenz00_5561); 
FAILURE(BgL_auxz00_11549,BFALSE,BFALSE);} 
BgL_auxz00_11545 = 
(long)CINT(BgL_tmpz00_11546); } 
{ /* Llib/ssl.scm 1328 */
obj_t BgL_tmpz00_11537;
if(
INTEGERP(BgL_offsetz00_5560))
{ /* Llib/ssl.scm 1328 */
BgL_tmpz00_11537 = BgL_offsetz00_5560
; }  else 
{ 
obj_t BgL_auxz00_11540;
BgL_auxz00_11540 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)53505)), BGl_string3790z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_offsetz00_5560); 
FAILURE(BgL_auxz00_11540,BFALSE,BFALSE);} 
BgL_auxz00_11536 = 
(long)CINT(BgL_tmpz00_11537); } 
if(
STRINGP(BgL_keyz00_5559))
{ /* Llib/ssl.scm 1328 */
BgL_auxz00_11529 = BgL_keyz00_5559
; }  else 
{ 
obj_t BgL_auxz00_11532;
BgL_auxz00_11532 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)53505)), BGl_string3790z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_keyz00_5559); 
FAILURE(BgL_auxz00_11532,BFALSE,BFALSE);} 
if(
STRINGP(BgL_cipherz00_5558))
{ /* Llib/ssl.scm 1328 */
BgL_auxz00_11522 = BgL_cipherz00_5558
; }  else 
{ 
obj_t BgL_auxz00_11525;
BgL_auxz00_11525 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)53505)), BGl_string3790z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_cipherz00_5558); 
FAILURE(BgL_auxz00_11525,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2cipherzd2_5557, BGl_sslzd2cipherzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1328 */
BgL_auxz00_11514 = 
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_5557)
; }  else 
{ 
obj_t BgL_auxz00_11518;
BgL_auxz00_11518 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)53505)), BGl_string3790z00zz__ssl_sslz00, BGl_string3791z00zz__ssl_sslz00, BgL_sslzd2cipherzd2_5557); 
FAILURE(BgL_auxz00_11518,BFALSE,BFALSE);} 
return 
BGl_sslzd2cipherzd2initz00zz__ssl_sslz00(BgL_auxz00_11514, BgL_auxz00_11522, BgL_auxz00_11529, BgL_auxz00_11536, BgL_auxz00_11545, 
CBOOL(BgL_encz00_5562));} } 
BGL_FUNCTION_END;
}



/* ssl-cipher-initiv */
BGL_EXPORTED_DEF obj_t BGl_sslzd2cipherzd2initivz00zz__ssl_sslz00(BgL_sslzd2cipherzd2_bglt BgL_sslzd2cipherzd2_162, obj_t BgL_cipherz00_163, obj_t BgL_keyz00_164, long BgL_offsetz00_165, long BgL_lenz00_166, obj_t BgL_ivz00_167, long BgL_ivoffsetz00_168, long BgL_ivlenz00_169, bool_t BgL_encz00_170)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1342 */
{ /* Llib/ssl.scm 1342 */
obj_t BgL_method1345z00_1759;
{ /* Llib/ssl.scm 1342 */
obj_t BgL_res2982z00_4444;
{ /* Llib/ssl.scm 1342 */
long BgL_objzd2classzd2numz00_4401;
{ /* Llib/ssl.scm 1342 */
long BgL_res2971z00_4404;
BgL_res2971z00_4404 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2cipherzd2_162)); 
BgL_objzd2classzd2numz00_4401 = BgL_res2971z00_4404; } 
{ /* Llib/ssl.scm 1342 */
obj_t BgL_arg1742z00_4402;
BgL_arg1742z00_4402 = 
PROCEDURE_REF(BGl_sslzd2cipherzd2initivzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1342 */
int BgL_offsetz00_4406;
BgL_offsetz00_4406 = 
(int)(BgL_objzd2classzd2numz00_4401); 
{ /* Llib/ssl.scm 1342 */
long BgL_offsetz00_4407;
BgL_offsetz00_4407 = 
(
(long)(BgL_offsetz00_4406)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1342 */
long BgL_modz00_4408;
{ /* Llib/ssl.scm 1342 */
int BgL_arg1744z00_4409;
BgL_arg1744z00_4409 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1342 */
long BgL_res2974z00_4419;
{ /* Llib/ssl.scm 1342 */
long BgL_tmpz00_11564;
BgL_tmpz00_11564 = 
(long)(BgL_arg1744z00_4409); 
BgL_res2974z00_4419 = 
(BgL_offsetz00_4407/BgL_tmpz00_11564); } 
BgL_modz00_4408 = BgL_res2974z00_4419; } } 
{ /* Llib/ssl.scm 1342 */
long BgL_restz00_4410;
{ /* Llib/ssl.scm 1342 */
int BgL_arg1743z00_4411;
BgL_arg1743z00_4411 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1342 */
long BgL_res2981z00_4439;
{ /* Llib/ssl.scm 1342 */
long BgL_n1z00_4421;long BgL_n2z00_4422;
BgL_n1z00_4421 = BgL_offsetz00_4407; 
BgL_n2z00_4422 = 
(long)(BgL_arg1743z00_4411); 
{ /* Llib/ssl.scm 1342 */
bool_t BgL_testz00_11569;
{ /* Llib/ssl.scm 1342 */
long BgL_arg1283z00_4424;
BgL_arg1283z00_4424 = 
(((BgL_n1z00_4421) | (BgL_n2z00_4422)) & -2147483648); 
BgL_testz00_11569 = 
(BgL_arg1283z00_4424==((long)0)); } 
if(BgL_testz00_11569)
{ /* Llib/ssl.scm 1342 */
int32_t BgL_arg1272z00_4425;
{ /* Llib/ssl.scm 1342 */
int32_t BgL_arg1278z00_4426;int32_t BgL_arg1279z00_4427;
{ /* Llib/ssl.scm 1342 */
int32_t BgL_res2977z00_4431;
BgL_res2977z00_4431 = 
(int32_t)(BgL_n1z00_4421); 
BgL_arg1278z00_4426 = BgL_res2977z00_4431; } 
{ /* Llib/ssl.scm 1342 */
int32_t BgL_res2978z00_4433;
BgL_res2978z00_4433 = 
(int32_t)(BgL_n2z00_4422); 
BgL_arg1279z00_4427 = BgL_res2978z00_4433; } 
BgL_arg1272z00_4425 = 
(BgL_arg1278z00_4426%BgL_arg1279z00_4427); } 
{ /* Llib/ssl.scm 1342 */
long BgL_res2980z00_4438;
{ /* Llib/ssl.scm 1342 */
long BgL_arg1409z00_4435;
BgL_arg1409z00_4435 = 
(long)(BgL_arg1272z00_4425); 
{ /* Llib/ssl.scm 1342 */
long BgL_res2979z00_4437;
BgL_res2979z00_4437 = 
(long)(BgL_arg1409z00_4435); 
BgL_res2980z00_4438 = BgL_res2979z00_4437; } } 
BgL_res2981z00_4439 = BgL_res2980z00_4438; } }  else 
{ /* Llib/ssl.scm 1342 */
BgL_res2981z00_4439 = 
(BgL_n1z00_4421%BgL_n2z00_4422); } } } 
BgL_restz00_4410 = BgL_res2981z00_4439; } } 
{ /* Llib/ssl.scm 1342 */

{ /* Llib/ssl.scm 1342 */
obj_t BgL_bucketz00_4412;
BgL_bucketz00_4412 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4402),BgL_modz00_4408); 
BgL_res2982z00_4444 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4412),BgL_restz00_4410); } } } } } } } } 
BgL_method1345z00_1759 = BgL_res2982z00_4444; } 
return 
PROCEDURE_ENTRY(BgL_method1345z00_1759)(BgL_method1345z00_1759, 
((obj_t)BgL_sslzd2cipherzd2_162), BgL_cipherz00_163, BgL_keyz00_164, 
BINT(BgL_offsetz00_165), 
BINT(BgL_lenz00_166), BgL_ivz00_167, 
BINT(BgL_ivoffsetz00_168), 
BINT(BgL_ivlenz00_169), 
BBOOL(BgL_encz00_170), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-cipher-initiv */
obj_t BGl_z62sslzd2cipherzd2initivz62zz__ssl_sslz00(obj_t BgL_envz00_5563, obj_t BgL_sslzd2cipherzd2_5564, obj_t BgL_cipherz00_5565, obj_t BgL_keyz00_5566, obj_t BgL_offsetz00_5567, obj_t BgL_lenz00_5568, obj_t BgL_ivz00_5569, obj_t BgL_ivoffsetz00_5570, obj_t BgL_ivlenz00_5571, obj_t BgL_encz00_5572)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1342 */
{ /* Llib/ssl.scm 1342 */
long BgL_auxz00_11656;long BgL_auxz00_11647;obj_t BgL_auxz00_11640;long BgL_auxz00_11631;long BgL_auxz00_11622;obj_t BgL_auxz00_11615;obj_t BgL_auxz00_11608;BgL_sslzd2cipherzd2_bglt BgL_auxz00_11600;
{ /* Llib/ssl.scm 1342 */
obj_t BgL_tmpz00_11657;
if(
INTEGERP(BgL_ivlenz00_5571))
{ /* Llib/ssl.scm 1342 */
BgL_tmpz00_11657 = BgL_ivlenz00_5571
; }  else 
{ 
obj_t BgL_auxz00_11660;
BgL_auxz00_11660 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)54029)), BGl_string3792z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_ivlenz00_5571); 
FAILURE(BgL_auxz00_11660,BFALSE,BFALSE);} 
BgL_auxz00_11656 = 
(long)CINT(BgL_tmpz00_11657); } 
{ /* Llib/ssl.scm 1342 */
obj_t BgL_tmpz00_11648;
if(
INTEGERP(BgL_ivoffsetz00_5570))
{ /* Llib/ssl.scm 1342 */
BgL_tmpz00_11648 = BgL_ivoffsetz00_5570
; }  else 
{ 
obj_t BgL_auxz00_11651;
BgL_auxz00_11651 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)54029)), BGl_string3792z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_ivoffsetz00_5570); 
FAILURE(BgL_auxz00_11651,BFALSE,BFALSE);} 
BgL_auxz00_11647 = 
(long)CINT(BgL_tmpz00_11648); } 
if(
STRINGP(BgL_ivz00_5569))
{ /* Llib/ssl.scm 1342 */
BgL_auxz00_11640 = BgL_ivz00_5569
; }  else 
{ 
obj_t BgL_auxz00_11643;
BgL_auxz00_11643 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)54029)), BGl_string3792z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_ivz00_5569); 
FAILURE(BgL_auxz00_11643,BFALSE,BFALSE);} 
{ /* Llib/ssl.scm 1342 */
obj_t BgL_tmpz00_11632;
if(
INTEGERP(BgL_lenz00_5568))
{ /* Llib/ssl.scm 1342 */
BgL_tmpz00_11632 = BgL_lenz00_5568
; }  else 
{ 
obj_t BgL_auxz00_11635;
BgL_auxz00_11635 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)54029)), BGl_string3792z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_lenz00_5568); 
FAILURE(BgL_auxz00_11635,BFALSE,BFALSE);} 
BgL_auxz00_11631 = 
(long)CINT(BgL_tmpz00_11632); } 
{ /* Llib/ssl.scm 1342 */
obj_t BgL_tmpz00_11623;
if(
INTEGERP(BgL_offsetz00_5567))
{ /* Llib/ssl.scm 1342 */
BgL_tmpz00_11623 = BgL_offsetz00_5567
; }  else 
{ 
obj_t BgL_auxz00_11626;
BgL_auxz00_11626 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)54029)), BGl_string3792z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_offsetz00_5567); 
FAILURE(BgL_auxz00_11626,BFALSE,BFALSE);} 
BgL_auxz00_11622 = 
(long)CINT(BgL_tmpz00_11623); } 
if(
STRINGP(BgL_keyz00_5566))
{ /* Llib/ssl.scm 1342 */
BgL_auxz00_11615 = BgL_keyz00_5566
; }  else 
{ 
obj_t BgL_auxz00_11618;
BgL_auxz00_11618 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)54029)), BGl_string3792z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_keyz00_5566); 
FAILURE(BgL_auxz00_11618,BFALSE,BFALSE);} 
if(
STRINGP(BgL_cipherz00_5565))
{ /* Llib/ssl.scm 1342 */
BgL_auxz00_11608 = BgL_cipherz00_5565
; }  else 
{ 
obj_t BgL_auxz00_11611;
BgL_auxz00_11611 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)54029)), BGl_string3792z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_cipherz00_5565); 
FAILURE(BgL_auxz00_11611,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2cipherzd2_5564, BGl_sslzd2cipherzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1342 */
BgL_auxz00_11600 = 
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_5564)
; }  else 
{ 
obj_t BgL_auxz00_11604;
BgL_auxz00_11604 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)54029)), BGl_string3792z00zz__ssl_sslz00, BGl_string3791z00zz__ssl_sslz00, BgL_sslzd2cipherzd2_5564); 
FAILURE(BgL_auxz00_11604,BFALSE,BFALSE);} 
return 
BGl_sslzd2cipherzd2initivz00zz__ssl_sslz00(BgL_auxz00_11600, BgL_auxz00_11608, BgL_auxz00_11615, BgL_auxz00_11622, BgL_auxz00_11631, BgL_auxz00_11640, BgL_auxz00_11647, BgL_auxz00_11656, 
CBOOL(BgL_encz00_5572));} } 
BGL_FUNCTION_END;
}



/* ssl-cipher-update! */
BGL_EXPORTED_DEF obj_t BGl_sslzd2cipherzd2updatez12z12zz__ssl_sslz00(BgL_sslzd2cipherzd2_bglt BgL_sslzd2cipherzd2_171, obj_t BgL_dataz00_172, long BgL_offsetz00_173, long BgL_lenz00_174)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1359 */
{ /* Llib/ssl.scm 1359 */
obj_t BgL_method1347z00_1760;
{ /* Llib/ssl.scm 1359 */
obj_t BgL_res2994z00_4489;
{ /* Llib/ssl.scm 1359 */
long BgL_objzd2classzd2numz00_4446;
{ /* Llib/ssl.scm 1359 */
long BgL_res2983z00_4449;
BgL_res2983z00_4449 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2cipherzd2_171)); 
BgL_objzd2classzd2numz00_4446 = BgL_res2983z00_4449; } 
{ /* Llib/ssl.scm 1359 */
obj_t BgL_arg1742z00_4447;
BgL_arg1742z00_4447 = 
PROCEDURE_REF(BGl_sslzd2cipherzd2updatez12zd2envzc0zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1359 */
int BgL_offsetz00_4451;
BgL_offsetz00_4451 = 
(int)(BgL_objzd2classzd2numz00_4446); 
{ /* Llib/ssl.scm 1359 */
long BgL_offsetz00_4452;
BgL_offsetz00_4452 = 
(
(long)(BgL_offsetz00_4451)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1359 */
long BgL_modz00_4453;
{ /* Llib/ssl.scm 1359 */
int BgL_arg1744z00_4454;
BgL_arg1744z00_4454 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1359 */
long BgL_res2986z00_4464;
{ /* Llib/ssl.scm 1359 */
long BgL_tmpz00_11675;
BgL_tmpz00_11675 = 
(long)(BgL_arg1744z00_4454); 
BgL_res2986z00_4464 = 
(BgL_offsetz00_4452/BgL_tmpz00_11675); } 
BgL_modz00_4453 = BgL_res2986z00_4464; } } 
{ /* Llib/ssl.scm 1359 */
long BgL_restz00_4455;
{ /* Llib/ssl.scm 1359 */
int BgL_arg1743z00_4456;
BgL_arg1743z00_4456 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1359 */
long BgL_res2993z00_4484;
{ /* Llib/ssl.scm 1359 */
long BgL_n1z00_4466;long BgL_n2z00_4467;
BgL_n1z00_4466 = BgL_offsetz00_4452; 
BgL_n2z00_4467 = 
(long)(BgL_arg1743z00_4456); 
{ /* Llib/ssl.scm 1359 */
bool_t BgL_testz00_11680;
{ /* Llib/ssl.scm 1359 */
long BgL_arg1283z00_4469;
BgL_arg1283z00_4469 = 
(((BgL_n1z00_4466) | (BgL_n2z00_4467)) & -2147483648); 
BgL_testz00_11680 = 
(BgL_arg1283z00_4469==((long)0)); } 
if(BgL_testz00_11680)
{ /* Llib/ssl.scm 1359 */
int32_t BgL_arg1272z00_4470;
{ /* Llib/ssl.scm 1359 */
int32_t BgL_arg1278z00_4471;int32_t BgL_arg1279z00_4472;
{ /* Llib/ssl.scm 1359 */
int32_t BgL_res2989z00_4476;
BgL_res2989z00_4476 = 
(int32_t)(BgL_n1z00_4466); 
BgL_arg1278z00_4471 = BgL_res2989z00_4476; } 
{ /* Llib/ssl.scm 1359 */
int32_t BgL_res2990z00_4478;
BgL_res2990z00_4478 = 
(int32_t)(BgL_n2z00_4467); 
BgL_arg1279z00_4472 = BgL_res2990z00_4478; } 
BgL_arg1272z00_4470 = 
(BgL_arg1278z00_4471%BgL_arg1279z00_4472); } 
{ /* Llib/ssl.scm 1359 */
long BgL_res2992z00_4483;
{ /* Llib/ssl.scm 1359 */
long BgL_arg1409z00_4480;
BgL_arg1409z00_4480 = 
(long)(BgL_arg1272z00_4470); 
{ /* Llib/ssl.scm 1359 */
long BgL_res2991z00_4482;
BgL_res2991z00_4482 = 
(long)(BgL_arg1409z00_4480); 
BgL_res2992z00_4483 = BgL_res2991z00_4482; } } 
BgL_res2993z00_4484 = BgL_res2992z00_4483; } }  else 
{ /* Llib/ssl.scm 1359 */
BgL_res2993z00_4484 = 
(BgL_n1z00_4466%BgL_n2z00_4467); } } } 
BgL_restz00_4455 = BgL_res2993z00_4484; } } 
{ /* Llib/ssl.scm 1359 */

{ /* Llib/ssl.scm 1359 */
obj_t BgL_bucketz00_4457;
BgL_bucketz00_4457 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4447),BgL_modz00_4453); 
BgL_res2994z00_4489 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4457),BgL_restz00_4455); } } } } } } } } 
BgL_method1347z00_1760 = BgL_res2994z00_4489; } 
return 
PROCEDURE_ENTRY(BgL_method1347z00_1760)(BgL_method1347z00_1760, 
((obj_t)BgL_sslzd2cipherzd2_171), BgL_dataz00_172, 
BINT(BgL_offsetz00_173), 
BINT(BgL_lenz00_174), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-cipher-update! */
obj_t BGl_z62sslzd2cipherzd2updatez12z70zz__ssl_sslz00(obj_t BgL_envz00_5573, obj_t BgL_sslzd2cipherzd2_5574, obj_t BgL_dataz00_5575, obj_t BgL_offsetz00_5576, obj_t BgL_lenz00_5577)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1359 */
{ /* Llib/ssl.scm 1359 */
long BgL_auxz00_11727;long BgL_auxz00_11718;obj_t BgL_auxz00_11711;BgL_sslzd2cipherzd2_bglt BgL_auxz00_11703;
{ /* Llib/ssl.scm 1359 */
obj_t BgL_tmpz00_11728;
if(
INTEGERP(BgL_lenz00_5577))
{ /* Llib/ssl.scm 1359 */
BgL_tmpz00_11728 = BgL_lenz00_5577
; }  else 
{ 
obj_t BgL_auxz00_11731;
BgL_auxz00_11731 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)54598)), BGl_string3793z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_lenz00_5577); 
FAILURE(BgL_auxz00_11731,BFALSE,BFALSE);} 
BgL_auxz00_11727 = 
(long)CINT(BgL_tmpz00_11728); } 
{ /* Llib/ssl.scm 1359 */
obj_t BgL_tmpz00_11719;
if(
INTEGERP(BgL_offsetz00_5576))
{ /* Llib/ssl.scm 1359 */
BgL_tmpz00_11719 = BgL_offsetz00_5576
; }  else 
{ 
obj_t BgL_auxz00_11722;
BgL_auxz00_11722 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)54598)), BGl_string3793z00zz__ssl_sslz00, BGl_string3412z00zz__ssl_sslz00, BgL_offsetz00_5576); 
FAILURE(BgL_auxz00_11722,BFALSE,BFALSE);} 
BgL_auxz00_11718 = 
(long)CINT(BgL_tmpz00_11719); } 
if(
STRINGP(BgL_dataz00_5575))
{ /* Llib/ssl.scm 1359 */
BgL_auxz00_11711 = BgL_dataz00_5575
; }  else 
{ 
obj_t BgL_auxz00_11714;
BgL_auxz00_11714 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)54598)), BGl_string3793z00zz__ssl_sslz00, BGl_string3413z00zz__ssl_sslz00, BgL_dataz00_5575); 
FAILURE(BgL_auxz00_11714,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2cipherzd2_5574, BGl_sslzd2cipherzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1359 */
BgL_auxz00_11703 = 
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_5574)
; }  else 
{ 
obj_t BgL_auxz00_11707;
BgL_auxz00_11707 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)54598)), BGl_string3793z00zz__ssl_sslz00, BGl_string3791z00zz__ssl_sslz00, BgL_sslzd2cipherzd2_5574); 
FAILURE(BgL_auxz00_11707,BFALSE,BFALSE);} 
return 
BGl_sslzd2cipherzd2updatez12z12zz__ssl_sslz00(BgL_auxz00_11703, BgL_auxz00_11711, BgL_auxz00_11718, BgL_auxz00_11727);} } 
BGL_FUNCTION_END;
}



/* ssl-cipher-set-auto-padding */
BGL_EXPORTED_DEF bool_t BGl_sslzd2cipherzd2setzd2autozd2paddingz00zz__ssl_sslz00(BgL_sslzd2cipherzd2_bglt BgL_sslzd2cipherzd2_175, bool_t BgL_autozd2paddingzd2_176)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1370 */
{ /* Llib/ssl.scm 1370 */
obj_t BgL_method1349z00_1761;
{ /* Llib/ssl.scm 1370 */
obj_t BgL_res3006z00_4534;
{ /* Llib/ssl.scm 1370 */
long BgL_objzd2classzd2numz00_4491;
{ /* Llib/ssl.scm 1370 */
long BgL_res2995z00_4494;
BgL_res2995z00_4494 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2cipherzd2_175)); 
BgL_objzd2classzd2numz00_4491 = BgL_res2995z00_4494; } 
{ /* Llib/ssl.scm 1370 */
obj_t BgL_arg1742z00_4492;
BgL_arg1742z00_4492 = 
PROCEDURE_REF(BGl_sslzd2cipherzd2setzd2autozd2paddingzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1370 */
int BgL_offsetz00_4496;
BgL_offsetz00_4496 = 
(int)(BgL_objzd2classzd2numz00_4491); 
{ /* Llib/ssl.scm 1370 */
long BgL_offsetz00_4497;
BgL_offsetz00_4497 = 
(
(long)(BgL_offsetz00_4496)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1370 */
long BgL_modz00_4498;
{ /* Llib/ssl.scm 1370 */
int BgL_arg1744z00_4499;
BgL_arg1744z00_4499 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1370 */
long BgL_res2998z00_4509;
{ /* Llib/ssl.scm 1370 */
long BgL_tmpz00_11745;
BgL_tmpz00_11745 = 
(long)(BgL_arg1744z00_4499); 
BgL_res2998z00_4509 = 
(BgL_offsetz00_4497/BgL_tmpz00_11745); } 
BgL_modz00_4498 = BgL_res2998z00_4509; } } 
{ /* Llib/ssl.scm 1370 */
long BgL_restz00_4500;
{ /* Llib/ssl.scm 1370 */
int BgL_arg1743z00_4501;
BgL_arg1743z00_4501 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1370 */
long BgL_res3005z00_4529;
{ /* Llib/ssl.scm 1370 */
long BgL_n1z00_4511;long BgL_n2z00_4512;
BgL_n1z00_4511 = BgL_offsetz00_4497; 
BgL_n2z00_4512 = 
(long)(BgL_arg1743z00_4501); 
{ /* Llib/ssl.scm 1370 */
bool_t BgL_testz00_11750;
{ /* Llib/ssl.scm 1370 */
long BgL_arg1283z00_4514;
BgL_arg1283z00_4514 = 
(((BgL_n1z00_4511) | (BgL_n2z00_4512)) & -2147483648); 
BgL_testz00_11750 = 
(BgL_arg1283z00_4514==((long)0)); } 
if(BgL_testz00_11750)
{ /* Llib/ssl.scm 1370 */
int32_t BgL_arg1272z00_4515;
{ /* Llib/ssl.scm 1370 */
int32_t BgL_arg1278z00_4516;int32_t BgL_arg1279z00_4517;
{ /* Llib/ssl.scm 1370 */
int32_t BgL_res3001z00_4521;
BgL_res3001z00_4521 = 
(int32_t)(BgL_n1z00_4511); 
BgL_arg1278z00_4516 = BgL_res3001z00_4521; } 
{ /* Llib/ssl.scm 1370 */
int32_t BgL_res3002z00_4523;
BgL_res3002z00_4523 = 
(int32_t)(BgL_n2z00_4512); 
BgL_arg1279z00_4517 = BgL_res3002z00_4523; } 
BgL_arg1272z00_4515 = 
(BgL_arg1278z00_4516%BgL_arg1279z00_4517); } 
{ /* Llib/ssl.scm 1370 */
long BgL_res3004z00_4528;
{ /* Llib/ssl.scm 1370 */
long BgL_arg1409z00_4525;
BgL_arg1409z00_4525 = 
(long)(BgL_arg1272z00_4515); 
{ /* Llib/ssl.scm 1370 */
long BgL_res3003z00_4527;
BgL_res3003z00_4527 = 
(long)(BgL_arg1409z00_4525); 
BgL_res3004z00_4528 = BgL_res3003z00_4527; } } 
BgL_res3005z00_4529 = BgL_res3004z00_4528; } }  else 
{ /* Llib/ssl.scm 1370 */
BgL_res3005z00_4529 = 
(BgL_n1z00_4511%BgL_n2z00_4512); } } } 
BgL_restz00_4500 = BgL_res3005z00_4529; } } 
{ /* Llib/ssl.scm 1370 */

{ /* Llib/ssl.scm 1370 */
obj_t BgL_bucketz00_4502;
BgL_bucketz00_4502 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4492),BgL_modz00_4498); 
BgL_res3006z00_4534 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4502),BgL_restz00_4500); } } } } } } } } 
BgL_method1349z00_1761 = BgL_res3006z00_4534; } 
return 
CBOOL(
PROCEDURE_ENTRY(BgL_method1349z00_1761)(BgL_method1349z00_1761, 
((obj_t)BgL_sslzd2cipherzd2_175), 
BBOOL(BgL_autozd2paddingzd2_176), BEOA));} } 
BGL_FUNCTION_END;
}



/* &ssl-cipher-set-auto-padding */
obj_t BGl_z62sslzd2cipherzd2setzd2autozd2paddingz62zz__ssl_sslz00(obj_t BgL_envz00_5578, obj_t BgL_sslzd2cipherzd2_5579, obj_t BgL_autozd2paddingzd2_5580)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1370 */
{ /* Llib/ssl.scm 1370 */
bool_t BgL_tmpz00_11771;
{ /* Llib/ssl.scm 1370 */
BgL_sslzd2cipherzd2_bglt BgL_auxz00_11772;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2cipherzd2_5579, BGl_sslzd2cipherzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1370 */
BgL_auxz00_11772 = 
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_5579)
; }  else 
{ 
obj_t BgL_auxz00_11776;
BgL_auxz00_11776 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)55140)), BGl_string3794z00zz__ssl_sslz00, BGl_string3791z00zz__ssl_sslz00, BgL_sslzd2cipherzd2_5579); 
FAILURE(BgL_auxz00_11776,BFALSE,BFALSE);} 
BgL_tmpz00_11771 = 
BGl_sslzd2cipherzd2setzd2autozd2paddingz00zz__ssl_sslz00(BgL_auxz00_11772, 
CBOOL(BgL_autozd2paddingzd2_5580)); } 
return 
BBOOL(BgL_tmpz00_11771);} } 
BGL_FUNCTION_END;
}



/* ssl-cipher-final */
BGL_EXPORTED_DEF obj_t BGl_sslzd2cipherzd2finalz00zz__ssl_sslz00(BgL_sslzd2cipherzd2_bglt BgL_sslzd2cipherzd2_177)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1380 */
{ /* Llib/ssl.scm 1380 */
obj_t BgL_method1351z00_1762;
{ /* Llib/ssl.scm 1380 */
obj_t BgL_res3018z00_4579;
{ /* Llib/ssl.scm 1380 */
long BgL_objzd2classzd2numz00_4536;
{ /* Llib/ssl.scm 1380 */
long BgL_res3007z00_4539;
BgL_res3007z00_4539 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_sslzd2cipherzd2_177)); 
BgL_objzd2classzd2numz00_4536 = BgL_res3007z00_4539; } 
{ /* Llib/ssl.scm 1380 */
obj_t BgL_arg1742z00_4537;
BgL_arg1742z00_4537 = 
PROCEDURE_REF(BGl_sslzd2cipherzd2finalzd2envzd2zz__ssl_sslz00, 
(int)(((long)1))); 
{ /* Llib/ssl.scm 1380 */
int BgL_offsetz00_4541;
BgL_offsetz00_4541 = 
(int)(BgL_objzd2classzd2numz00_4536); 
{ /* Llib/ssl.scm 1380 */
long BgL_offsetz00_4542;
BgL_offsetz00_4542 = 
(
(long)(BgL_offsetz00_4541)-OBJECT_TYPE); 
{ /* Llib/ssl.scm 1380 */
long BgL_modz00_4543;
{ /* Llib/ssl.scm 1380 */
int BgL_arg1744z00_4544;
BgL_arg1744z00_4544 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1380 */
long BgL_res3010z00_4554;
{ /* Llib/ssl.scm 1380 */
long BgL_tmpz00_11791;
BgL_tmpz00_11791 = 
(long)(BgL_arg1744z00_4544); 
BgL_res3010z00_4554 = 
(BgL_offsetz00_4542/BgL_tmpz00_11791); } 
BgL_modz00_4543 = BgL_res3010z00_4554; } } 
{ /* Llib/ssl.scm 1380 */
long BgL_restz00_4545;
{ /* Llib/ssl.scm 1380 */
int BgL_arg1743z00_4546;
BgL_arg1743z00_4546 = 
(int)(((long)16)); 
{ /* Llib/ssl.scm 1380 */
long BgL_res3017z00_4574;
{ /* Llib/ssl.scm 1380 */
long BgL_n1z00_4556;long BgL_n2z00_4557;
BgL_n1z00_4556 = BgL_offsetz00_4542; 
BgL_n2z00_4557 = 
(long)(BgL_arg1743z00_4546); 
{ /* Llib/ssl.scm 1380 */
bool_t BgL_testz00_11796;
{ /* Llib/ssl.scm 1380 */
long BgL_arg1283z00_4559;
BgL_arg1283z00_4559 = 
(((BgL_n1z00_4556) | (BgL_n2z00_4557)) & -2147483648); 
BgL_testz00_11796 = 
(BgL_arg1283z00_4559==((long)0)); } 
if(BgL_testz00_11796)
{ /* Llib/ssl.scm 1380 */
int32_t BgL_arg1272z00_4560;
{ /* Llib/ssl.scm 1380 */
int32_t BgL_arg1278z00_4561;int32_t BgL_arg1279z00_4562;
{ /* Llib/ssl.scm 1380 */
int32_t BgL_res3013z00_4566;
BgL_res3013z00_4566 = 
(int32_t)(BgL_n1z00_4556); 
BgL_arg1278z00_4561 = BgL_res3013z00_4566; } 
{ /* Llib/ssl.scm 1380 */
int32_t BgL_res3014z00_4568;
BgL_res3014z00_4568 = 
(int32_t)(BgL_n2z00_4557); 
BgL_arg1279z00_4562 = BgL_res3014z00_4568; } 
BgL_arg1272z00_4560 = 
(BgL_arg1278z00_4561%BgL_arg1279z00_4562); } 
{ /* Llib/ssl.scm 1380 */
long BgL_res3016z00_4573;
{ /* Llib/ssl.scm 1380 */
long BgL_arg1409z00_4570;
BgL_arg1409z00_4570 = 
(long)(BgL_arg1272z00_4560); 
{ /* Llib/ssl.scm 1380 */
long BgL_res3015z00_4572;
BgL_res3015z00_4572 = 
(long)(BgL_arg1409z00_4570); 
BgL_res3016z00_4573 = BgL_res3015z00_4572; } } 
BgL_res3017z00_4574 = BgL_res3016z00_4573; } }  else 
{ /* Llib/ssl.scm 1380 */
BgL_res3017z00_4574 = 
(BgL_n1z00_4556%BgL_n2z00_4557); } } } 
BgL_restz00_4545 = BgL_res3017z00_4574; } } 
{ /* Llib/ssl.scm 1380 */

{ /* Llib/ssl.scm 1380 */
obj_t BgL_bucketz00_4547;
BgL_bucketz00_4547 = 
VECTOR_REF(
((obj_t)BgL_arg1742z00_4537),BgL_modz00_4543); 
BgL_res3018z00_4579 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4547),BgL_restz00_4545); } } } } } } } } 
BgL_method1351z00_1762 = BgL_res3018z00_4579; } 
return 
PROCEDURE_ENTRY(BgL_method1351z00_1762)(BgL_method1351z00_1762, 
((obj_t)BgL_sslzd2cipherzd2_177), BEOA);} } 
BGL_FUNCTION_END;
}



/* &ssl-cipher-final */
obj_t BGl_z62sslzd2cipherzd2finalz62zz__ssl_sslz00(obj_t BgL_envz00_5581, obj_t BgL_sslzd2cipherzd2_5582)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 1380 */
{ /* Llib/ssl.scm 1380 */
BgL_sslzd2cipherzd2_bglt BgL_auxz00_11814;
if(
BGl_isazf3zf3zz__objectz00(BgL_sslzd2cipherzd2_5582, BGl_sslzd2cipherzd2zz__ssl_sslz00))
{ /* Llib/ssl.scm 1380 */
BgL_auxz00_11814 = 
((BgL_sslzd2cipherzd2_bglt)BgL_sslzd2cipherzd2_5582)
; }  else 
{ 
obj_t BgL_auxz00_11818;
BgL_auxz00_11818 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3410z00zz__ssl_sslz00, 
BINT(((long)55569)), BGl_string3795z00zz__ssl_sslz00, BGl_string3791z00zz__ssl_sslz00, BgL_sslzd2cipherzd2_5582); 
FAILURE(BgL_auxz00_11818,BFALSE,BFALSE);} 
return 
BGl_sslzd2cipherzd2finalz00zz__ssl_sslz00(BgL_auxz00_11814);} } 
BGL_FUNCTION_END;
}



/* method-init */
obj_t BGl_methodzd2initzd2zz__ssl_sslz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/ssl.scm 15 */
return BUNSPEC;} 
BGL_FUNCTION_END;
}

#ifdef __cplusplus
}
#endif
