/*===========================================================================*/
/*   (Llib/wav_decoder.scm)                                                  */
/*   Bigloo (4.3f)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu 04 Jul 2019 08:10:18 AM CEST    */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo4.3f/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -I Llib -lib-dir /builddir/build/BUILD/bigloo4.3f/lib/bigloo/4.3f -safee -srfi wav -copt  -copt -fPIC -copt -IClib Llib/wav_decoder.scm -o objs/wav_decoder.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

/* runtime code modification */
#define BGL_SELF_MODIFYING_CODE 0

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_musicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
} *BgL_musicz00_bglt;

typedef struct BgL_musicstatusz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_statez00;
   obj_t BgL_volumez00;
   bool_t BgL_repeatz00;
   bool_t BgL_randomz00;
   int BgL_playlistidz00;
   int BgL_playlistlengthz00;
   int BgL_xfadez00;
   int BgL_songz00;
   int BgL_songidz00;
   obj_t BgL_songposz00;
   int BgL_songlengthz00;
   int BgL_bitratez00;
   int BgL_khza7za7;
   obj_t BgL_errz00;
   int BgL_bufferingz00;
} *BgL_musicstatusz00_bglt;

typedef struct BgL_musicbufferz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_urlz00;
   bool_t BgL_z52eofz52;
   obj_t BgL_z52bcondvz52;
   obj_t BgL_z52bmutexz52;
   long BgL_z52inlenz52;
   char * BgL_z52inbufpz52;
   long BgL_z52headz52;
   long BgL_z52tailz52;
   bool_t BgL_z52emptyz52;
} *BgL_musicbufferz00_bglt;

typedef struct BgL_musicbufz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
} *BgL_musicbufz00_bglt;

typedef struct BgL_musicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
} *BgL_musicdecoderz00_bglt;

typedef struct BgL_wavinfoz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_formatz00;
   long BgL_sampleratez00;
   int BgL_channelsz00;
   int BgL_bpsz00;
   long BgL_durationz00;
   obj_t BgL_audiofmtz00;
   int BgL_byteratez00;
   int BgL_blockalignz00;
   long BgL_chunksiza7eza7;
} *BgL_wavinfoz00_bglt;

typedef struct BgL_wavmusicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_outbufz00;
   obj_t BgL_z52headerz52;
   int BgL_z52cursorz52;
   int BgL_z52siza7ezf5;
   int BgL_z52positionz52;
} *BgL_wavmusicdecoderz00_bglt;


static long BGl_z42wavzd2statuszd2okz42zz__wav_decoderz00;
static obj_t BGl_z62zc3anonymousza31502ze3ze1zz__wav_decoderz00(obj_t);
BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
BGL_IMPORT obj_t BGl_musicbufferzd2blitzd2stringz12z12zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt, int, obj_t, int, int);
BGL_IMPORT obj_t BGl_musicbufzd2writezd2zz__multimediazd2musicbufzd2(BgL_musicbufz00_bglt, obj_t, long);
static obj_t BGl_objectzd2initzd2zz__wav_decoderz00();
extern obj_t BGl_wavinfoz00zz__wav_wavz00;
static obj_t BGl_z62musicdecoderzd2positio1134zb0zz__wav_decoderz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_musicbufz00zz__multimediazd2musicbufzd2;
static obj_t BGl_z62zc3anonymousza31258ze3ze1zz__wav_decoderz00(obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31526ze3ze1zz__wav_decoderz00(obj_t);
static obj_t BGl_methodzd2initzd2zz__wav_decoderz00();
BGL_IMPORT obj_t BGl_musicbufferz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t make_string(long, unsigned char);
static obj_t BGl_inczd2tailz12ze70z27zz__wav_decoderz00(BgL_musicbufferz00_bglt, long, BgL_musicbufferz00_bglt, obj_t, long);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_conditionzd2variablezd2nilz00zz__threadz00();
static long BGl_z42wavzd2statuszd2newzd2formatz90zz__wav_decoderz00;
BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
BGL_IMPORT int bgl_debug();
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__wav_decoderz00();
static obj_t BGl_z62lambda1604z62zz__wav_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1605z62zz__wav_decoderz00(obj_t, obj_t, obj_t);
BGL_IMPORT long BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt);
extern long BGl_wavzd2headerzd2siza7eza7zz__wav_wavz00();
BGL_IMPORT obj_t BGl_musicdecoderzd2hwparamszd2setz12z12zz__multimediazd2musicbufzd2(BgL_musicdecoderz00_bglt, BgL_musicz00_bglt, BgL_musicbufferz00_bglt);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
static obj_t BGl_za2debugzd2portza2zd2zz__wav_decoderz00 = BUNSPEC;
static bool_t BGl_flushze70ze7zz__wav_decoderz00(BgL_musicbufz00_bglt, BgL_wavmusicdecoderz00_bglt, int);
BGL_IMPORT obj_t BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t, obj_t);
BGL_IMPORT bool_t BGl_zd3fxzd3zz__r4_numbers_6_5_fixnumz00(long, long);
BGL_IMPORT long BGl_bitzd2andzd2zz__bitz00(long, long);
static obj_t BGl_z62musicdecoderzd2decodezd21136z62zz__wav_decoderz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__wav_decoderz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__wav_decoderz00();
BGL_IMPORT obj_t BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__wav_decoderz00();
static obj_t BGl_wavzd2decodezd2statuszd2ze3symbolz31zz__wav_decoderz00(obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
static obj_t BGl_debugz00zz__wav_decoderz00(obj_t);
static long BGl_z42wavzd2statuszd2needzd2morez90zz__wav_decoderz00;
static obj_t BGl_z62zc3anonymousza31606ze3ze1zz__wav_decoderz00(obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mutexzd2nilzd2zz__threadz00();
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_wavzd2decodezd2zz__wav_decoderz00(BgL_wavmusicdecoderz00_bglt, BgL_musicbufz00_bglt, BgL_musicbufferz00_bglt, int, int);
static obj_t BGl_z62zc3anonymousza31551ze3ze1zz__wav_decoderz00(obj_t);
BGL_IMPORT obj_t BGl_musicdecoderz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_modulezd2initzd2errorz00zz__errorz00(char *, char *);
BGL_IMPORT obj_t BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3anonymousza31374ze3ze1zz__wav_decoderz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2outputzd2filez00zz__r4_ports_6_10_1z00(obj_t, obj_t);
static int BGl_wavzd2debugzd2zz__wav_decoderz00();
BGL_IMPORT obj_t bgl_close_output_port(obj_t);
static long BGl_bufferzd2percentagezd2filledze70ze7zz__wav_decoderz00(long, BgL_musicbufferz00_bglt);
static obj_t BGl_z62zc3anonymousza31571ze3ze1zz__wav_decoderz00(obj_t);
BGL_IMPORT BGL_LONGLONG_T bgl_current_microseconds();
static obj_t BGl_z62musicdecoderzd2resetz12zd21132z70zz__wav_decoderz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
BGL_IMPORT obj_t BGl_musiczd2errorzd2setz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__wav_decoderz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__wav_wavz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__datez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
static obj_t BGl_z62lambda1500z62zz__wav_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1501z62zz__wav_decoderz00(obj_t, obj_t, obj_t);
static BgL_wavmusicdecoderz00_bglt BGl_z62lambda1341z62zz__wav_decoderz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_wavmusicdecoderz00_bglt BGl_z62lambda1344z62zz__wav_decoderz00(obj_t);
static obj_t BGl_cnstzd2initzd2zz__wav_decoderz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__wav_decoderz00();
static obj_t BGl_debugzd2initz12zc0zz__wav_decoderz00(obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__wav_decoderz00();
BGL_IMPORT long BGl_musicdecoderzd2positionzd2zz__multimediazd2musicbufzd2(BgL_musicdecoderz00_bglt, BgL_musicbufferz00_bglt);
static obj_t BGl_z62musicdecoderzd2initzd2wa1130z62zz__wav_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1524z62zz__wav_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1525z62zz__wav_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62musicdecoderzd2volumezd21138z62zz__wav_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_debugzd2stopz12zc0zz__wav_decoderz00(obj_t);
static obj_t BGl_z62objectzd2printzd2wavmusi1128z62zz__wav_decoderz00(obj_t, obj_t, obj_t, obj_t);
static long BGl_z42wavzd2statuszd2donez42zz__wav_decoderz00;
static obj_t BGl_z62lambda1549z62zz__wav_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1550z62zz__wav_decoderz00(obj_t, obj_t, obj_t);
extern obj_t BGl_wavzd2parsezd2headerz00zz__wav_wavz00(obj_t);
static obj_t BGl_z62lambda1569z62zz__wav_decoderz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_wavmusicdecoderz00zz__wav_decoderz00 = BUNSPEC;
static obj_t BGl_z62lambda1570z62zz__wav_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_zc3exitza31222ze3ze70z64zz__wav_decoderz00(int, BgL_wavmusicdecoderz00_bglt, BgL_musicbufferz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_musicbufferzd2substringzd2zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt, int, int);
static obj_t BGl_z62zc3anonymousza31232ze3ze1zz__wav_decoderz00(obj_t, obj_t);
static obj_t __cnst[ 25 ] ;


DEFINE_STRING( BGl_string2120z00zz__wav_decoderz00, BgL_bgl_string2120za700za7za7_2189za7, "condvar", 7 );
DEFINE_STRING( BGl_string2121z00zz__wav_decoderz00, BgL_bgl_string2121za700za7za7_2190za7, "&lambda1605", 11 );
DEFINE_STRING( BGl_string2122z00zz__wav_decoderz00, BgL_bgl_string2122za700za7za7_2191za7, "&lambda1604", 11 );
DEFINE_STRING( BGl_string2123z00zz__wav_decoderz00, BgL_bgl_string2123za700za7za7_2192za7, "&lambda1570", 11 );
DEFINE_STRING( BGl_string2124z00zz__wav_decoderz00, BgL_bgl_string2124za700za7za7_2193za7, "&lambda1569", 11 );
DEFINE_STRING( BGl_string2125z00zz__wav_decoderz00, BgL_bgl_string2125za700za7za7_2194za7, "&lambda1550", 11 );
DEFINE_STRING( BGl_string2126z00zz__wav_decoderz00, BgL_bgl_string2126za700za7za7_2195za7, "&lambda1549", 11 );
DEFINE_STRING( BGl_string2127z00zz__wav_decoderz00, BgL_bgl_string2127za700za7za7_2196za7, "&lambda1525", 11 );
DEFINE_STRING( BGl_string2128z00zz__wav_decoderz00, BgL_bgl_string2128za700za7za7_2197za7, "&lambda1524", 11 );
DEFINE_STRING( BGl_string2129z00zz__wav_decoderz00, BgL_bgl_string2129za700za7za7_2198za7, "&lambda1501", 11 );
DEFINE_STRING( BGl_string2130z00zz__wav_decoderz00, BgL_bgl_string2130za700za7za7_2199za7, "&lambda1500", 11 );
DEFINE_STRING( BGl_string2132z00zz__wav_decoderz00, BgL_bgl_string2132za700za7za7_2200za7, "object-print", 12 );
DEFINE_STRING( BGl_string2134z00zz__wav_decoderz00, BgL_bgl_string2134za700za7za7_2201za7, "musicdecoder-init", 17 );
DEFINE_STRING( BGl_string2136z00zz__wav_decoderz00, BgL_bgl_string2136za700za7za7_2202za7, "musicdecoder-reset!", 19 );
DEFINE_STRING( BGl_string2138z00zz__wav_decoderz00, BgL_bgl_string2138za700za7za7_2203za7, "musicdecoder-position", 21 );
DEFINE_STRING( BGl_string2140z00zz__wav_decoderz00, BgL_bgl_string2140za700za7za7_2204za7, "musicdecoder-decode", 19 );
DEFINE_STRING( BGl_string2142z00zz__wav_decoderz00, BgL_bgl_string2142za700za7za7_2205za7, "musicdecoder-volume-set!", 24 );
DEFINE_STRING( BGl_string2143z00zz__wav_decoderz00, BgL_bgl_string2143za700za7za7_2206za7, "&musicdecoder-volume-1138", 25 );
DEFINE_STRING( BGl_string2144z00zz__wav_decoderz00, BgL_bgl_string2144za700za7za7_2207za7, "~~~ WAV_DECODER, EOF ", 21 );
DEFINE_STRING( BGl_string2145z00zz__wav_decoderz00, BgL_bgl_string2145za700za7za7_2208za7, "...", 3 );
DEFINE_STRING( BGl_string2146z00zz__wav_decoderz00, BgL_bgl_string2146za700za7za7_2209za7, "<-- WAV_DECODER, wait not-empty ", 32 );
DEFINE_STRING( BGl_string2147z00zz__wav_decoderz00, BgL_bgl_string2147za700za7za7_2210za7, " -> status=", 11 );
DEFINE_STRING( BGl_string2148z00zz__wav_decoderz00, BgL_bgl_string2148za700za7za7_2211za7, " hd=", 4 );
DEFINE_STRING( BGl_string2149z00zz__wav_decoderz00, BgL_bgl_string2149za700za7za7_2212za7, " tl=", 4 );
DEFINE_STRING( BGl_string2150z00zz__wav_decoderz00, BgL_bgl_string2150za700za7za7_2213za7, "~~~ WAV_DECODER, s=", 19 );
DEFINE_STRING( BGl_string2151z00zz__wav_decoderz00, BgL_bgl_string2151za700za7za7_2214za7, "loop", 4 );
DEFINE_STRING( BGl_string2152z00zz__wav_decoderz00, BgL_bgl_string2152za700za7za7_2215za7, " size=", 6 );
DEFINE_STRING( BGl_string2153z00zz__wav_decoderz00, BgL_bgl_string2153za700za7za7_2216za7, "~~~ WAV_DECODER, OK s=", 22 );
DEFINE_STRING( BGl_string2154z00zz__wav_decoderz00, BgL_bgl_string2154za700za7za7_2217za7, " tail=", 6 );
DEFINE_STRING( BGl_string2155z00zz__wav_decoderz00, BgL_bgl_string2155za700za7za7_2218za7, " %empty=", 8 );
DEFINE_STRING( BGl_string2156z00zz__wav_decoderz00, BgL_bgl_string2156za700za7za7_2219za7, "~~~ WAV_DECODER, NEED-MORE s=", 29 );
DEFINE_STRING( BGl_string2157z00zz__wav_decoderz00, BgL_bgl_string2157za700za7za7_2220za7, "wav decoding error", 18 );
DEFINE_STRING( BGl_string2158z00zz__wav_decoderz00, BgL_bgl_string2158za700za7za7_2221za7, "&musicdecoder-decode-1136", 25 );
DEFINE_STRING( BGl_string2159z00zz__wav_decoderz00, BgL_bgl_string2159za700za7za7_2222za7, "musicbuf", 8 );
BGL_IMPORT obj_t BGl_musicdecoderzd2decodezd2envz00zz__multimediazd2musicbufzd2;
DEFINE_STRING( BGl_string2160z00zz__wav_decoderz00, BgL_bgl_string2160za700za7za7_2223za7, "musicbuffer", 11 );
DEFINE_STRING( BGl_string2161z00zz__wav_decoderz00, BgL_bgl_string2161za700za7za7_2224za7, "flush~0", 7 );
DEFINE_STRING( BGl_string2162z00zz__wav_decoderz00, BgL_bgl_string2162za700za7za7_2225za7, "\033[0m\033[1;33m", 11 );
DEFINE_STRING( BGl_string2163z00zz__wav_decoderz00, BgL_bgl_string2163za700za7za7_2226za7, "\033[0m\033[1;32m", 11 );
DEFINE_STRING( BGl_string2164z00zz__wav_decoderz00, BgL_bgl_string2164za700za7za7_2227za7, " EOF", 4 );
DEFINE_STRING( BGl_string2165z00zz__wav_decoderz00, BgL_bgl_string2165za700za7za7_2228za7, " url=", 5 );
DEFINE_STRING( BGl_string2166z00zz__wav_decoderz00, BgL_bgl_string2166za700za7za7_2229za7, "%\033[0m", 5 );
DEFINE_STRING( BGl_string2167z00zz__wav_decoderz00, BgL_bgl_string2167za700za7za7_2230za7, "--- WAV_DECODER, buffer fill: ", 30 );
DEFINE_STRING( BGl_string2168z00zz__wav_decoderz00, BgL_bgl_string2168za700za7za7_2231za7, "inc-tail!~0", 11 );
DEFINE_STRING( BGl_string2169z00zz__wav_decoderz00, BgL_bgl_string2169za700za7za7_2232za7, "bbool", 5 );
DEFINE_STRING( BGl_string2170z00zz__wav_decoderz00, BgL_bgl_string2170za700za7za7_2233za7, "--> WAV_DECODER, broadcast not-full ", 36 );
DEFINE_STRING( BGl_string2171z00zz__wav_decoderz00, BgL_bgl_string2171za700za7za7_2234za7, "&musicdecoder-positio1134", 25 );
DEFINE_STRING( BGl_string2172z00zz__wav_decoderz00, BgL_bgl_string2172za700za7za7_2235za7, "call-next-method:Wrong number of arguments", 42 );
DEFINE_STRING( BGl_string2173z00zz__wav_decoderz00, BgL_bgl_string2173za700za7za7_2236za7, "&musicdecoder-reset!-1132", 25 );
DEFINE_STRING( BGl_string2174z00zz__wav_decoderz00, BgL_bgl_string2174za700za7za7_2237za7, "&musicdecoder-init-wa1130", 25 );
DEFINE_STRING( BGl_string2175z00zz__wav_decoderz00, BgL_bgl_string2175za700za7za7_2238za7, "object-print-wavmusi1128", 24 );
DEFINE_STRING( BGl_string2176z00zz__wav_decoderz00, BgL_bgl_string2176za700za7za7_2239za7, "#|wavmusicdecoder|", 18 );
DEFINE_STRING( BGl_string2177z00zz__wav_decoderz00, BgL_bgl_string2177za700za7za7_2240za7, "&object-print-wavmusi1128", 25 );
DEFINE_STRING( BGl_string2178z00zz__wav_decoderz00, BgL_bgl_string2178za700za7za7_2241za7, "__wav_decoder", 13 );
DEFINE_STRING( BGl_string2179z00zz__wav_decoderz00, BgL_bgl_string2179za700za7za7_2242za7, "(\"audio/wav\" \"audio/x-wav\" \"audio/x-pn-windows-acm\") (funcall next-method1131 next-method1131 dec) error buffering ended stop play pause (funcall fun1342 fun1342 new1122) __wav_decoder wavmusicdecoder %position %size int %cursor obj %header bstring outbuf pcm unknown-status ok need-more done new-format ", 304 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2093z00zz__wav_decoderz00, BgL_bgl_za762za7c3anonymousza72243za7, BGl_z62zc3anonymousza31502ze3ze1zz__wav_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2094z00zz__wav_decoderz00, BgL_bgl_za762lambda1501za7622244z00, BGl_z62lambda1501z62zz__wav_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2095z00zz__wav_decoderz00, BgL_bgl_za762lambda1500za7622245z00, BGl_z62lambda1500z62zz__wav_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2096z00zz__wav_decoderz00, BgL_bgl_za762za7c3anonymousza72246za7, BGl_z62zc3anonymousza31526ze3ze1zz__wav_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2097z00zz__wav_decoderz00, BgL_bgl_za762lambda1525za7622247z00, BGl_z62lambda1525z62zz__wav_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2098z00zz__wav_decoderz00, BgL_bgl_za762lambda1524za7622248z00, BGl_z62lambda1524z62zz__wav_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2099z00zz__wav_decoderz00, BgL_bgl_za762za7c3anonymousza72249za7, BGl_z62zc3anonymousza31551ze3ze1zz__wav_decoderz00, 0L, BUNSPEC, 0 );
BGL_IMPORT obj_t BGl_musicdecoderzd2volumezd2setz12zd2envzc0zz__multimediazd2musicbufzd2;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2100z00zz__wav_decoderz00, BgL_bgl_za762lambda1550za7622250z00, BGl_z62lambda1550z62zz__wav_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2101z00zz__wav_decoderz00, BgL_bgl_za762lambda1549za7622251z00, BGl_z62lambda1549z62zz__wav_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2102z00zz__wav_decoderz00, BgL_bgl_za762za7c3anonymousza72252za7, BGl_z62zc3anonymousza31571ze3ze1zz__wav_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2103z00zz__wav_decoderz00, BgL_bgl_za762lambda1570za7622253z00, BGl_z62lambda1570z62zz__wav_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2104z00zz__wav_decoderz00, BgL_bgl_za762lambda1569za7622254z00, BGl_z62lambda1569z62zz__wav_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2105z00zz__wav_decoderz00, BgL_bgl_za762za7c3anonymousza72255za7, BGl_z62zc3anonymousza31606ze3ze1zz__wav_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2106z00zz__wav_decoderz00, BgL_bgl_za762lambda1605za7622256z00, BGl_z62lambda1605z62zz__wav_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2107z00zz__wav_decoderz00, BgL_bgl_za762lambda1604za7622257z00, BGl_z62lambda1604z62zz__wav_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2108z00zz__wav_decoderz00, BgL_bgl_za762za7c3anonymousza72258za7, BGl_z62zc3anonymousza31374ze3ze1zz__wav_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2109z00zz__wav_decoderz00, BgL_bgl_za762lambda1344za7622259z00, BGl_z62lambda1344z62zz__wav_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2110z00zz__wav_decoderz00, BgL_bgl_za762lambda1341za7622260z00, BGl_z62lambda1341z62zz__wav_decoderz00, 0L, BUNSPEC, 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2131z00zz__wav_decoderz00, BgL_bgl_za762objectza7d2prin2261z00, BGl_z62objectzd2printzd2wavmusi1128z62zz__wav_decoderz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2133z00zz__wav_decoderz00, BgL_bgl_za762musicdecoderza72262z00, BGl_z62musicdecoderzd2initzd2wa1130z62zz__wav_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2135z00zz__wav_decoderz00, BgL_bgl_za762musicdecoderza72263z00, BGl_z62musicdecoderzd2resetz12zd21132z70zz__wav_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2137z00zz__wav_decoderz00, BgL_bgl_za762musicdecoderza72264z00, BGl_z62musicdecoderzd2positio1134zb0zz__wav_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2139z00zz__wav_decoderz00, BgL_bgl_za762musicdecoderza72265z00, BGl_z62musicdecoderzd2decodezd21136z62zz__wav_decoderz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2141z00zz__wav_decoderz00, BgL_bgl_za762musicdecoderza72266z00, BGl_z62musicdecoderzd2volumezd21138z62zz__wav_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2073z00zz__wav_decoderz00, BgL_bgl_string2073za700za7za7_2267za7, "Llib/wav_decoder.scm", 20 );
DEFINE_STRING( BGl_string2074z00zz__wav_decoderz00, BgL_bgl_string2074za700za7za7_2268za7, "/builddir/build/BUILD/bigloo4.3f/api/wav/src/Llib/wav_decoder.scm", 65 );
DEFINE_STRING( BGl_string2075z00zz__wav_decoderz00, BgL_bgl_string2075za700za7za7_2269za7, "wav-decode-status->symbol", 25 );
DEFINE_STRING( BGl_string2076z00zz__wav_decoderz00, BgL_bgl_string2076za700za7za7_2270za7, "bint", 4 );
DEFINE_STRING( BGl_string2077z00zz__wav_decoderz00, BgL_bgl_string2077za700za7za7_2271za7, "wav-decode", 10 );
DEFINE_STRING( BGl_string2078z00zz__wav_decoderz00, BgL_bgl_string2078za700za7za7_2272za7, "wavinfo", 7 );
DEFINE_STRING( BGl_string2079z00zz__wav_decoderz00, BgL_bgl_string2079za700za7za7_2273za7, "<exit:1222>~0", 13 );
DEFINE_STRING( BGl_string2080z00zz__wav_decoderz00, BgL_bgl_string2080za700za7za7_2274za7, "bstring", 7 );
DEFINE_STRING( BGl_string2081z00zz__wav_decoderz00, BgL_bgl_string2081za700za7za7_2275za7, "Cannot play none PCM wav format", 31 );
DEFINE_STRING( BGl_string2082z00zz__wav_decoderz00, BgL_bgl_string2082za700za7za7_2276za7, "/tmp/WAV.log", 12 );
DEFINE_STRING( BGl_string2083z00zz__wav_decoderz00, BgL_bgl_string2083za700za7za7_2277za7, "\n", 1 );
DEFINE_STRING( BGl_string2084z00zz__wav_decoderz00, BgL_bgl_string2084za700za7za7_2278za7, " ", 1 );
DEFINE_STRING( BGl_string2085z00zz__wav_decoderz00, BgL_bgl_string2085za700za7za7_2279za7, ">>> WAV_DECODER init ", 21 );
DEFINE_STRING( BGl_string2086z00zz__wav_decoderz00, BgL_bgl_string2086za700za7za7_2280za7, ">>> WAV_DECODER stop ", 21 );
DEFINE_STRING( BGl_string2087z00zz__wav_decoderz00, BgL_bgl_string2087za700za7za7_2281za7, "debug-stop!", 11 );
DEFINE_STRING( BGl_string2088z00zz__wav_decoderz00, BgL_bgl_string2088za700za7za7_2282za7, "output-port", 11 );
DEFINE_STRING( BGl_string2089z00zz__wav_decoderz00, BgL_bgl_string2089za700za7za7_2283za7, "<anonymous:1319>", 16 );
DEFINE_STRING( BGl_string2090z00zz__wav_decoderz00, BgL_bgl_string2090za700za7za7_2284za7, "for-each", 8 );
DEFINE_STRING( BGl_string2091z00zz__wav_decoderz00, BgL_bgl_string2091za700za7za7_2285za7, "list", 4 );
DEFINE_STRING( BGl_string2092z00zz__wav_decoderz00, BgL_bgl_string2092za700za7za7_2286za7, "debug", 5 );
BGL_IMPORT obj_t BGl_objectzd2printzd2envz00zz__objectz00;
BGL_IMPORT obj_t BGl_musicdecoderzd2resetz12zd2envz12zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musicdecoderzd2positionzd2envz00zz__multimediazd2musicbufzd2;
DEFINE_STRING( BGl_string2111z00zz__wav_decoderz00, BgL_bgl_string2111za700za7za7_2287za7, "", 0 );
DEFINE_STRING( BGl_string2112z00zz__wav_decoderz00, BgL_bgl_string2112za700za7za7_2288za7, "&<anonymous:1374>", 17 );
DEFINE_STRING( BGl_string2113z00zz__wav_decoderz00, BgL_bgl_string2113za700za7za7_2289za7, "wavmusicdecoder", 15 );
DEFINE_STRING( BGl_string2114z00zz__wav_decoderz00, BgL_bgl_string2114za700za7za7_2290za7, "lambda1341", 10 );
DEFINE_STRING( BGl_string2115z00zz__wav_decoderz00, BgL_bgl_string2115za700za7za7_2291za7, "procedure", 9 );
DEFINE_STRING( BGl_string2116z00zz__wav_decoderz00, BgL_bgl_string2116za700za7za7_2292za7, "lambda1341:Wrong number of arguments", 36 );
DEFINE_STRING( BGl_string2117z00zz__wav_decoderz00, BgL_bgl_string2117za700za7za7_2293za7, "&lambda1341", 11 );
DEFINE_STRING( BGl_string2118z00zz__wav_decoderz00, BgL_bgl_string2118za700za7za7_2294za7, "pair-nil", 8 );
DEFINE_STRING( BGl_string2119z00zz__wav_decoderz00, BgL_bgl_string2119za700za7za7_2295za7, "mutex", 5 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_za2debugzd2portza2zd2zz__wav_decoderz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__wav_decoderz00) );
ADD_ROOT( (void *)(&BGl_wavmusicdecoderz00zz__wav_decoderz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__wav_decoderz00(long BgL_checksumz00_1148, char * BgL_fromz00_1149)
{ BGL_FUNCTION_BEGIN;
{ 
if(
BGl_zd3fxzd3zz__r4_numbers_6_5_fixnumz00(
(long)CINT(
BINT(
BGl_bitzd2andzd2zz__bitz00(BgL_checksumz00_1148, ((long)0)))), BgL_checksumz00_1148))
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__wav_decoderz00))
{ 
BGl_requirezd2initializa7ationz75zz__wav_decoderz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__wav_decoderz00(); 
BGl_libraryzd2moduleszd2initz00zz__wav_decoderz00(); 
BGl_cnstzd2initzd2zz__wav_decoderz00(); 
BGl_importedzd2moduleszd2initz00zz__wav_decoderz00(); 
BGl_objectzd2initzd2zz__wav_decoderz00(); 
BGl_methodzd2initzd2zz__wav_decoderz00(); 
return 
BGl_toplevelzd2initzd2zz__wav_decoderz00();}  else 
{ 
return BUNSPEC;} }  else 
{ 
char * BgL_sz00_1152;
BgL_sz00_1152 = 
"__wav_decoder"; 
return 
BGl_modulezd2initzd2errorz00zz__errorz00(BgL_sz00_1152, BgL_fromz00_1149);} } 
BGL_FUNCTION_END;
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__wav_decoderz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__paramz00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__datez00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__wav_decoder"); 
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__wav_decoderz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 15 */
{ /* Llib/wav_decoder.scm 15 */
obj_t BgL_cportz00_1002;
{ /* Llib/wav_decoder.scm 15 */
obj_t BgL_stringz00_1010;
BgL_stringz00_1010 = BGl_string2179z00zz__wav_decoderz00; 
{ /* Llib/wav_decoder.scm 15 */
obj_t BgL_startz00_1011;
BgL_startz00_1011 = 
BINT(((long)0)); 
{ /* Llib/wav_decoder.scm 15 */
obj_t BgL_endz00_1012;
BgL_endz00_1012 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_1010))); 
{ /* Llib/wav_decoder.scm 15 */

BgL_cportz00_1002 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_1010, BgL_startz00_1011, BgL_endz00_1012); } } } } 
{ 
long BgL_iz00_1003;
BgL_iz00_1003 = ((long)24); 
BgL_loopz00_1004:
if(
(BgL_iz00_1003==((long)-1)))
{ /* Llib/wav_decoder.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/wav_decoder.scm 15 */
{ /* Llib/wav_decoder.scm 15 */
obj_t BgL_arg2181z00_1006;
{ /* Llib/wav_decoder.scm 15 */

{ /* Llib/wav_decoder.scm 15 */
obj_t BgL_locationz00_1008;
BgL_locationz00_1008 = 
BBOOL(((bool_t)0)); 
{ /* Llib/wav_decoder.scm 15 */

BgL_arg2181z00_1006 = 
BGl_readz00zz__readerz00(BgL_cportz00_1002, BgL_locationz00_1008); } } } 
{ /* Llib/wav_decoder.scm 15 */
int BgL_tmpz00_1195;
BgL_tmpz00_1195 = 
(int)(BgL_iz00_1003); 
CNST_TABLE_SET(BgL_tmpz00_1195, BgL_arg2181z00_1006); } } 
{ /* Llib/wav_decoder.scm 15 */
int BgL_auxz00_1009;
BgL_auxz00_1009 = 
(int)(
(BgL_iz00_1003-((long)1))); 
{ 
long BgL_iz00_1200;
BgL_iz00_1200 = 
(long)(BgL_auxz00_1009); 
BgL_iz00_1003 = BgL_iz00_1200; 
goto BgL_loopz00_1004;} } } } } } 
BGL_FUNCTION_END;
}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__wav_decoderz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 15 */
return 
bgl_gc_roots_register();} 
BGL_FUNCTION_END;
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__wav_decoderz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), 
BSTRING_TO_STRING(BGl_string2073z00zz__wav_decoderz00)); 
BGl_z42wavzd2statuszd2newzd2formatz90zz__wav_decoderz00 = ((long)1); 
BGl_z42wavzd2statuszd2donez42zz__wav_decoderz00 = ((long)2); 
BGl_z42wavzd2statuszd2needzd2morez90zz__wav_decoderz00 = ((long)3); 
BGl_z42wavzd2statuszd2okz42zz__wav_decoderz00 = ((long)4); 
return ( 
BGl_za2debugzd2portza2zd2zz__wav_decoderz00 = BFALSE, BUNSPEC) ;} 
BGL_FUNCTION_END;
}



/* wav-debug */
int BGl_wavzd2debugzd2zz__wav_decoderz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 37 */
if(
(((long)0)>((long)0)))
{ /* Llib/wav_decoder.scm 38 */
return 
bgl_debug();}  else 
{ /* Llib/wav_decoder.scm 38 */
return 
(int)(((long)0));} } 
BGL_FUNCTION_END;
}



/* wav-decode-status->symbol */
obj_t BGl_wavzd2decodezd2statuszd2ze3symbolz31zz__wav_decoderz00(obj_t BgL_statusz00_10)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 82 */
{ /* Llib/wav_decoder.scm 84 */
bool_t BgL_testz00_1209;
{ /* Llib/wav_decoder.scm 84 */
long BgL_n2z00_525;
{ /* Llib/wav_decoder.scm 84 */
obj_t BgL_tmpz00_1210;
if(
INTEGERP(BgL_statusz00_10))
{ /* Llib/wav_decoder.scm 84 */
BgL_tmpz00_1210 = BgL_statusz00_10
; }  else 
{ 
obj_t BgL_auxz00_1213;
BgL_auxz00_1213 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)4039)), BGl_string2075z00zz__wav_decoderz00, BGl_string2076z00zz__wav_decoderz00, BgL_statusz00_10); 
FAILURE(BgL_auxz00_1213,BFALSE,BFALSE);} 
BgL_n2z00_525 = 
(long)CINT(BgL_tmpz00_1210); } 
BgL_testz00_1209 = 
(((long)1)==BgL_n2z00_525); } 
if(BgL_testz00_1209)
{ /* Llib/wav_decoder.scm 84 */
return 
CNST_TABLE_REF(((long)0));}  else 
{ /* Llib/wav_decoder.scm 85 */
bool_t BgL_testz00_1220;
{ /* Llib/wav_decoder.scm 85 */
long BgL_n2z00_527;
{ /* Llib/wav_decoder.scm 85 */
obj_t BgL_tmpz00_1221;
if(
INTEGERP(BgL_statusz00_10))
{ /* Llib/wav_decoder.scm 85 */
BgL_tmpz00_1221 = BgL_statusz00_10
; }  else 
{ 
obj_t BgL_auxz00_1224;
BgL_auxz00_1224 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)4089)), BGl_string2075z00zz__wav_decoderz00, BGl_string2076z00zz__wav_decoderz00, BgL_statusz00_10); 
FAILURE(BgL_auxz00_1224,BFALSE,BFALSE);} 
BgL_n2z00_527 = 
(long)CINT(BgL_tmpz00_1221); } 
BgL_testz00_1220 = 
(((long)2)==BgL_n2z00_527); } 
if(BgL_testz00_1220)
{ /* Llib/wav_decoder.scm 85 */
return 
CNST_TABLE_REF(((long)1));}  else 
{ /* Llib/wav_decoder.scm 86 */
bool_t BgL_testz00_1231;
{ /* Llib/wav_decoder.scm 86 */
long BgL_n2z00_529;
{ /* Llib/wav_decoder.scm 86 */
obj_t BgL_tmpz00_1232;
if(
INTEGERP(BgL_statusz00_10))
{ /* Llib/wav_decoder.scm 86 */
BgL_tmpz00_1232 = BgL_statusz00_10
; }  else 
{ 
obj_t BgL_auxz00_1235;
BgL_auxz00_1235 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)4138)), BGl_string2075z00zz__wav_decoderz00, BGl_string2076z00zz__wav_decoderz00, BgL_statusz00_10); 
FAILURE(BgL_auxz00_1235,BFALSE,BFALSE);} 
BgL_n2z00_529 = 
(long)CINT(BgL_tmpz00_1232); } 
BgL_testz00_1231 = 
(((long)3)==BgL_n2z00_529); } 
if(BgL_testz00_1231)
{ /* Llib/wav_decoder.scm 86 */
return 
CNST_TABLE_REF(((long)2));}  else 
{ /* Llib/wav_decoder.scm 87 */
bool_t BgL_testz00_1242;
{ /* Llib/wav_decoder.scm 87 */
long BgL_n2z00_531;
{ /* Llib/wav_decoder.scm 87 */
obj_t BgL_tmpz00_1243;
if(
INTEGERP(BgL_statusz00_10))
{ /* Llib/wav_decoder.scm 87 */
BgL_tmpz00_1243 = BgL_statusz00_10
; }  else 
{ 
obj_t BgL_auxz00_1246;
BgL_auxz00_1246 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)4185)), BGl_string2075z00zz__wav_decoderz00, BGl_string2076z00zz__wav_decoderz00, BgL_statusz00_10); 
FAILURE(BgL_auxz00_1246,BFALSE,BFALSE);} 
BgL_n2z00_531 = 
(long)CINT(BgL_tmpz00_1243); } 
BgL_testz00_1242 = 
(((long)4)==BgL_n2z00_531); } 
if(BgL_testz00_1242)
{ /* Llib/wav_decoder.scm 87 */
return 
CNST_TABLE_REF(((long)3));}  else 
{ /* Llib/wav_decoder.scm 87 */
return 
CNST_TABLE_REF(((long)4));} } } } } } 
BGL_FUNCTION_END;
}



/* wav-decode */
obj_t BGl_wavzd2decodezd2zz__wav_decoderz00(BgL_wavmusicdecoderz00_bglt BgL_decz00_14, BgL_musicbufz00_bglt BgL_amz00_15, BgL_musicbufferz00_bglt BgL_bufferz00_16, int BgL_tailz00_17, int BgL_sz00_18)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 267 */
if(
CBOOL(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52headerz52)))
{ /* Llib/wav_decoder.scm 288 */
BgL_wavinfoz00_bglt BgL_i1120z00_40;
{ /* Llib/wav_decoder.scm 290 */
obj_t BgL_aux1973z00_858;
BgL_aux1973z00_858 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52headerz52); 
if(
BGl_isazf3zf3zz__objectz00(BgL_aux1973z00_858, BGl_wavinfoz00zz__wav_wavz00))
{ /* Llib/wav_decoder.scm 290 */
BgL_i1120z00_40 = 
((BgL_wavinfoz00_bglt)BgL_aux1973z00_858); }  else 
{ 
obj_t BgL_auxz00_1261;
BgL_auxz00_1261 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)10725)), BGl_string2077z00zz__wav_decoderz00, BGl_string2078z00zz__wav_decoderz00, BgL_aux1973z00_858); 
FAILURE(BgL_auxz00_1261,BFALSE,BFALSE);} } 
if(
(
(long)(BgL_sz00_18)<
(long)(
(((BgL_wavinfoz00_bglt)COBJECT(BgL_i1120z00_40))->BgL_blockalignz00))))
{ /* Llib/wav_decoder.scm 290 */
{ /* Llib/wav_decoder.scm 291 */
long BgL_arg1153z00_43;obj_t BgL_arg1154z00_44;int BgL_arg1155z00_45;
BgL_arg1153z00_43 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_16))->BgL_z52tailz52); 
BgL_arg1154z00_44 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_outbufz00); 
BgL_arg1155z00_45 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52cursorz52); 
BGl_musicbufferzd2blitzd2stringz12z12zz__multimediazd2musicbufzd2(BgL_bufferz00_16, 
(int)(BgL_arg1153z00_43), BgL_arg1154z00_44, BgL_arg1155z00_45, BgL_sz00_18); } 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52cursorz52)=((int)
(int)(
(
(long)(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52cursorz52))+
(long)(BgL_sz00_18)))),BUNSPEC); 
return 
BINT(((long)3));}  else 
{ /* Llib/wav_decoder.scm 294 */
bool_t BgL_testz00_1282;
{ /* Llib/wav_decoder.scm 294 */
long BgL_n1z00_539;long BgL_n2z00_540;
BgL_n1z00_539 = 
(long)(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52positionz52)); 
{ /* Llib/wav_decoder.scm 294 */
long BgL_tmpz00_1285;
BgL_tmpz00_1285 = 
(((BgL_wavinfoz00_bglt)COBJECT(BgL_i1120z00_40))->BgL_chunksiza7eza7); 
BgL_n2z00_540 = 
(long)(BgL_tmpz00_1285); } 
BgL_testz00_1282 = 
(BgL_n1z00_539>=BgL_n2z00_540); } 
if(BgL_testz00_1282)
{ /* Llib/wav_decoder.scm 294 */
return 
BINT(((long)2));}  else 
{ /* Llib/wav_decoder.scm 294 */
{ 
int BgL_auxz00_1290;
{ /* Llib/wav_decoder.scm 297 */
long BgL_za71za7_545;
BgL_za71za7_545 = 
(long)(
(((BgL_wavinfoz00_bglt)COBJECT(BgL_i1120z00_40))->BgL_blockalignz00)); 
BgL_auxz00_1290 = 
(int)(
(BgL_za71za7_545*
(
(long)(BgL_sz00_18)/BgL_za71za7_545))); } 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52siza7ezf5)=((int)BgL_auxz00_1290),BUNSPEC); } 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52positionz52)=((int)
(int)(
(
(long)(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52positionz52))+
(long)(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52siza7ezf5))))),BUNSPEC); 
{ /* Llib/wav_decoder.scm 299 */
long BgL_arg1168z00_55;obj_t BgL_arg1169z00_56;int BgL_arg1170z00_57;int BgL_arg1171z00_58;
BgL_arg1168z00_55 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_16))->BgL_z52tailz52); 
BgL_arg1169z00_56 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_outbufz00); 
BgL_arg1170z00_57 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52cursorz52); 
BgL_arg1171z00_58 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52siza7ezf5); 
BGl_musicbufferzd2blitzd2stringz12z12zz__multimediazd2musicbufzd2(BgL_bufferz00_16, 
(int)(BgL_arg1168z00_55), BgL_arg1169z00_56, BgL_arg1170z00_57, BgL_arg1171z00_58); } 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52cursorz52)=((int)
(int)(((long)0))),BUNSPEC); 
return 
BINT(((long)4));} } }  else 
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_res1108z00_723;
BgL_res1108z00_723 = 
MAKE_CELL(BUNSPEC); 
if(
CBOOL(
BGl_zc3exitza31222ze3ze70z64zz__wav_decoderz00(BgL_sz00_18, BgL_decz00_14, BgL_bufferz00_16, BgL_res1108z00_723)))
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_ez00_556;
BgL_ez00_556 = 
CELL_REF(BgL_res1108z00_723); 
return 
BGl_musiczd2errorzd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_amz00_15), BgL_ez00_556);}  else 
{ /* Llib/wav_decoder.scm 271 */
return 
CELL_REF(BgL_res1108z00_723);} } } 
BGL_FUNCTION_END;
}



/* <exit:1222>~0 */
obj_t BGl_zc3exitza31222ze3ze70z64zz__wav_decoderz00(int BgL_sz00_849, BgL_wavmusicdecoderz00_bglt BgL_i1105z00_848, BgL_musicbufferz00_bglt BgL_bufferz00_847, obj_t BgL_res1108z00_846)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 271 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1115z00_94;
if( SET_EXIT(BgL_an_exit1115z00_94) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  bgl_restore_signal_handlers();
#endif

BgL_an_exit1115z00_94 = 
(void *)jmpbuf; 
{ /* Llib/wav_decoder.scm 271 */

PUSH_EXIT(BgL_an_exit1115z00_94, ((long)1)); 
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_an_exitd1116z00_95;
BgL_an_exitd1116z00_95 = 
((obj_t)(&exitd)); 
{ /* Llib/wav_decoder.scm 271 */
bool_t BgL_res1118z00_98;
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_ohs1106z00_99;
BgL_ohs1106z00_99 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_exitd1111z00_100;
BgL_exitd1111z00_100 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3anonymousza31258ze3z83_715;
BgL_zc3anonymousza31258ze3z83_715 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza31258ze3ze1zz__wav_decoderz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza31258ze3z83_715, 
(int)(((long)0)), BgL_ohs1106z00_99); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1111z00_100, BgL_zc3anonymousza31258ze3z83_715); 
{ /* Llib/wav_decoder.scm 271 */
bool_t BgL_tmp1113z00_102;
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_arg1225z00_103;
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_zc3anonymousza31232ze3z83_714;
BgL_zc3anonymousza31232ze3z83_714 = 
MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza31232ze3ze1zz__wav_decoderz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3anonymousza31232ze3z83_714, 
(int)(((long)0)), 
((obj_t)BgL_res1108z00_846)); 
PROCEDURE_SET(BgL_zc3anonymousza31232ze3z83_714, 
(int)(((long)1)), BgL_an_exitd1116z00_95); 
BgL_arg1225z00_103 = 
MAKE_YOUNG_PAIR(BgL_zc3anonymousza31232ze3z83_714, BgL_ohs1106z00_99); } 
BGL_ERROR_HANDLER_SET(BgL_arg1225z00_103); BUNSPEC; } 
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_auxz00_724;
{ /* Llib/wav_decoder.scm 274 */
bool_t BgL_testz00_1339;
{ /* Llib/wav_decoder.scm 274 */
long BgL_arg1257z00_116;
BgL_arg1257z00_116 = 
BGl_wavzd2headerzd2siza7eza7zz__wav_wavz00(); 
{ /* Llib/wav_decoder.scm 274 */
long BgL_n1z00_551;long BgL_n2z00_552;
BgL_n1z00_551 = 
(long)(BgL_sz00_849); 
BgL_n2z00_552 = 
(long)(BgL_arg1257z00_116); 
BgL_testz00_1339 = 
(BgL_n1z00_551<BgL_n2z00_552); } } 
if(BgL_testz00_1339)
{ /* Llib/wav_decoder.scm 274 */
BgL_auxz00_724 = 
BINT(((long)3)); }  else 
{ /* Llib/wav_decoder.scm 276 */
obj_t BgL_strz00_109;
{ /* Llib/wav_decoder.scm 277 */
long BgL_arg1236z00_114;
{ /* Llib/wav_decoder.scm 277 */
long BgL_arg1256z00_115;
BgL_arg1256z00_115 = 
BGl_wavzd2headerzd2siza7eza7zz__wav_wavz00(); 
{ /* Llib/wav_decoder.scm 277 */
long BgL_res1886z00_555;
BgL_res1886z00_555 = 
(long)(BgL_arg1256z00_115); 
BgL_arg1236z00_114 = BgL_res1886z00_555; } } 
BgL_strz00_109 = 
BGl_musicbufferzd2substringzd2zz__multimediazd2musicbufzd2(BgL_bufferz00_847, 
(int)(((long)0)), 
(int)(BgL_arg1236z00_114)); } 
{ 
obj_t BgL_auxz00_1350;
{ /* Llib/wav_decoder.scm 278 */
obj_t BgL_auxz00_1351;
if(
STRINGP(BgL_strz00_109))
{ /* Llib/wav_decoder.scm 278 */
BgL_auxz00_1351 = BgL_strz00_109
; }  else 
{ 
obj_t BgL_auxz00_1354;
BgL_auxz00_1354 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)10339)), BGl_string2079z00zz__wav_decoderz00, BGl_string2080z00zz__wav_decoderz00, BgL_strz00_109); 
FAILURE(BgL_auxz00_1354,BFALSE,BFALSE);} 
BgL_auxz00_1350 = 
BGl_wavzd2parsezd2headerz00zz__wav_wavz00(BgL_auxz00_1351); } 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_i1105z00_848))->BgL_z52headerz52)=((obj_t)BgL_auxz00_1350),BUNSPEC); } 
{ /* Llib/wav_decoder.scm 279 */
BgL_wavinfoz00_bglt BgL_i1114z00_110;
{ /* Llib/wav_decoder.scm 280 */
obj_t BgL_aux1977z00_864;
BgL_aux1977z00_864 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_i1105z00_848))->BgL_z52headerz52); 
if(
BGl_isazf3zf3zz__objectz00(BgL_aux1977z00_864, BGl_wavinfoz00zz__wav_wavz00))
{ /* Llib/wav_decoder.scm 280 */
BgL_i1114z00_110 = 
((BgL_wavinfoz00_bglt)BgL_aux1977z00_864); }  else 
{ 
obj_t BgL_auxz00_1364;
BgL_auxz00_1364 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)10401)), BGl_string2079z00zz__wav_decoderz00, BGl_string2078z00zz__wav_decoderz00, BgL_aux1977z00_864); 
FAILURE(BgL_auxz00_1364,BFALSE,BFALSE);} } 
if(
(
(((BgL_wavinfoz00_bglt)COBJECT(BgL_i1114z00_110))->BgL_audiofmtz00)==
CNST_TABLE_REF(((long)5))))
{ /* Llib/wav_decoder.scm 280 */BFALSE; }  else 
{ /* Llib/wav_decoder.scm 280 */
BGl_errorz00zz__errorz00(BGl_string2077z00zz__wav_decoderz00, BGl_string2081z00zz__wav_decoderz00, 
(((BgL_wavinfoz00_bglt)COBJECT(BgL_i1114z00_110))->BgL_audiofmtz00)); } } 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_i1105z00_848))->BgL_z52siza7ezf5)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_i1105z00_848))->BgL_z52cursorz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_i1105z00_848))->BgL_z52positionz52)=((int)
(int)(((long)0))),BUNSPEC); 
BgL_auxz00_724 = 
BINT(((long)1)); } } 
CELL_SET(BgL_res1108z00_846, BgL_auxz00_724); } 
BgL_tmp1113z00_102 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1111z00_100); 
BGL_ERROR_HANDLER_SET(BgL_ohs1106z00_99); BUNSPEC; 
BgL_res1118z00_98 = BgL_tmp1113z00_102; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1118z00_98);} } } 
} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1232> */
obj_t BGl_z62zc3anonymousza31232ze3ze1zz__wav_decoderz00(obj_t BgL_envz00_716, obj_t BgL_ez00_719)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 271 */
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_res1108z00_717;obj_t BgL_an_exitd1116z00_718;
BgL_res1108z00_717 = 
PROCEDURE_REF(BgL_envz00_716, 
(int)(((long)0))); 
BgL_an_exitd1116z00_718 = 
PROCEDURE_REF(BgL_envz00_716, 
(int)(((long)1))); 
CELL_SET(BgL_res1108z00_717, BgL_ez00_719); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1116z00_718, BTRUE);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1258> */
obj_t BGl_z62zc3anonymousza31258ze3ze1zz__wav_decoderz00(obj_t BgL_envz00_721)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 271 */
{ 
obj_t BgL_ohs1106z00_722;
BgL_ohs1106z00_722 = 
PROCEDURE_REF(BgL_envz00_721, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1106z00_722); 
return BUNSPEC;} } 
BGL_FUNCTION_END;
}



/* debug-init! */
obj_t BGl_debugzd2initz12zc0zz__wav_decoderz00(obj_t BgL_urlz00_21)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 317 */
{ /* Llib/wav_decoder.scm 318 */

BGl_za2debugzd2portza2zd2zz__wav_decoderz00 = 
BGl_openzd2outputzd2filez00zz__r4_ports_6_10_1z00(BGl_string2082z00zz__wav_decoderz00, BTRUE); } 
{ /* Llib/wav_decoder.scm 319 */
BGL_LONGLONG_T BgL_arg1261z00_124;
BgL_arg1261z00_124 = 
bgl_current_microseconds(); 
{ /* Llib/wav_decoder.scm 319 */
obj_t BgL_list1262z00_125;
{ /* Llib/wav_decoder.scm 319 */
obj_t BgL_arg1264z00_126;
{ /* Llib/wav_decoder.scm 319 */
obj_t BgL_arg1269z00_127;
{ /* Llib/wav_decoder.scm 319 */
obj_t BgL_arg1270z00_128;
{ /* Llib/wav_decoder.scm 319 */
obj_t BgL_arg1284z00_129;
BgL_arg1284z00_129 = 
MAKE_YOUNG_PAIR(BGl_string2083z00zz__wav_decoderz00, BNIL); 
BgL_arg1270z00_128 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1261z00_124), BgL_arg1284z00_129); } 
BgL_arg1269z00_127 = 
MAKE_YOUNG_PAIR(BGl_string2084z00zz__wav_decoderz00, BgL_arg1270z00_128); } 
BgL_arg1264z00_126 = 
MAKE_YOUNG_PAIR(BgL_urlz00_21, BgL_arg1269z00_127); } 
BgL_list1262z00_125 = 
MAKE_YOUNG_PAIR(BGl_string2085z00zz__wav_decoderz00, BgL_arg1264z00_126); } 
return 
BGl_debugz00zz__wav_decoderz00(BgL_list1262z00_125);} } } 
BGL_FUNCTION_END;
}



/* debug-stop! */
obj_t BGl_debugzd2stopz12zc0zz__wav_decoderz00(obj_t BgL_urlz00_22)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 324 */
{ /* Llib/wav_decoder.scm 325 */
BGL_LONGLONG_T BgL_arg1285z00_130;
BgL_arg1285z00_130 = 
bgl_current_microseconds(); 
{ /* Llib/wav_decoder.scm 325 */
obj_t BgL_list1286z00_131;
{ /* Llib/wav_decoder.scm 325 */
obj_t BgL_arg1290z00_132;
{ /* Llib/wav_decoder.scm 325 */
obj_t BgL_arg1302z00_133;
{ /* Llib/wav_decoder.scm 325 */
obj_t BgL_arg1317z00_134;
{ /* Llib/wav_decoder.scm 325 */
obj_t BgL_arg1318z00_135;
BgL_arg1318z00_135 = 
MAKE_YOUNG_PAIR(BGl_string2083z00zz__wav_decoderz00, BNIL); 
BgL_arg1317z00_134 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1285z00_130), BgL_arg1318z00_135); } 
BgL_arg1302z00_133 = 
MAKE_YOUNG_PAIR(BGl_string2084z00zz__wav_decoderz00, BgL_arg1317z00_134); } 
BgL_arg1290z00_132 = 
MAKE_YOUNG_PAIR(BgL_urlz00_22, BgL_arg1302z00_133); } 
BgL_list1286z00_131 = 
MAKE_YOUNG_PAIR(BGl_string2086z00zz__wav_decoderz00, BgL_arg1290z00_132); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1286z00_131); } } 
{ /* Llib/wav_decoder.scm 326 */
obj_t BgL_portz00_559;
{ /* Llib/wav_decoder.scm 326 */
obj_t BgL_aux1979z00_868;
BgL_aux1979z00_868 = BGl_za2debugzd2portza2zd2zz__wav_decoderz00; 
if(
OUTPUT_PORTP(BgL_aux1979z00_868))
{ /* Llib/wav_decoder.scm 326 */
BgL_portz00_559 = BgL_aux1979z00_868; }  else 
{ 
obj_t BgL_auxz00_1412;
BgL_auxz00_1412 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)12425)), BGl_string2087z00zz__wav_decoderz00, BGl_string2088z00zz__wav_decoderz00, BgL_aux1979z00_868); 
FAILURE(BgL_auxz00_1412,BFALSE,BFALSE);} } 
return 
bgl_close_output_port(BgL_portz00_559);} } 
BGL_FUNCTION_END;
}



/* debug */
obj_t BGl_debugz00zz__wav_decoderz00(obj_t BgL_argsz00_23)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 331 */
{ 
obj_t BgL_l1123z00_137;
BgL_l1123z00_137 = BgL_argsz00_23; 
BgL_zc3anonymousza31319ze3z83_138:
if(
PAIRP(BgL_l1123z00_137))
{ /* Llib/wav_decoder.scm 332 */
{ /* Llib/wav_decoder.scm 332 */
obj_t BgL_az00_140;
BgL_az00_140 = 
CAR(BgL_l1123z00_137); 
{ /* Llib/wav_decoder.scm 332 */
obj_t BgL_auxz00_1420;
{ /* Llib/wav_decoder.scm 332 */
obj_t BgL_aux1981z00_870;
BgL_aux1981z00_870 = BGl_za2debugzd2portza2zd2zz__wav_decoderz00; 
if(
OUTPUT_PORTP(BgL_aux1981z00_870))
{ /* Llib/wav_decoder.scm 332 */
BgL_auxz00_1420 = BgL_aux1981z00_870
; }  else 
{ 
obj_t BgL_auxz00_1423;
BgL_auxz00_1423 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)12714)), BGl_string2089z00zz__wav_decoderz00, BGl_string2088z00zz__wav_decoderz00, BgL_aux1981z00_870); 
FAILURE(BgL_auxz00_1423,BFALSE,BFALSE);} } 
bgl_display_obj(BgL_az00_140, BgL_auxz00_1420); } } 
{ 
obj_t BgL_l1123z00_1428;
BgL_l1123z00_1428 = 
CDR(BgL_l1123z00_137); 
BgL_l1123z00_137 = BgL_l1123z00_1428; 
goto BgL_zc3anonymousza31319ze3z83_138;} }  else 
{ /* Llib/wav_decoder.scm 332 */
if(
NULLP(BgL_l1123z00_137))
{ /* Llib/wav_decoder.scm 332 */BTRUE; }  else 
{ /* Llib/wav_decoder.scm 332 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2090z00zz__wav_decoderz00, BGl_string2091z00zz__wav_decoderz00, BgL_l1123z00_137, BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)12692))); } } } 
{ /* Llib/wav_decoder.scm 333 */
obj_t BgL_portz00_564;
{ /* Llib/wav_decoder.scm 333 */
obj_t BgL_aux1983z00_872;
BgL_aux1983z00_872 = BGl_za2debugzd2portza2zd2zz__wav_decoderz00; 
if(
OUTPUT_PORTP(BgL_aux1983z00_872))
{ /* Llib/wav_decoder.scm 333 */
BgL_portz00_564 = BgL_aux1983z00_872; }  else 
{ 
obj_t BgL_auxz00_1436;
BgL_auxz00_1436 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)12768)), BGl_string2092z00zz__wav_decoderz00, BGl_string2088z00zz__wav_decoderz00, BgL_aux1983z00_872); 
FAILURE(BgL_auxz00_1436,BFALSE,BFALSE);} } 
return 
bgl_flush_output_port(BgL_portz00_564);} } 
BGL_FUNCTION_END;
}



/* object-init */
obj_t BGl_objectzd2initzd2zz__wav_decoderz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 15 */
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_arg1339z00_147;obj_t BgL_arg1340z00_148;
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_v1125z00_174;
BgL_v1125z00_174 = 
create_vector(((long)5)); 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_arg1417z00_175;
BgL_arg1417z00_175 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)6)), BGl_proc2095z00zz__wav_decoderz00, BGl_proc2094z00zz__wav_decoderz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2093z00zz__wav_decoderz00, 
CNST_TABLE_REF(((long)7))); 
VECTOR_SET(BgL_v1125z00_174,((long)0),BgL_arg1417z00_175); } 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_arg1509z00_190;
BgL_arg1509z00_190 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)8)), BGl_proc2098z00zz__wav_decoderz00, BGl_proc2097z00zz__wav_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2096z00zz__wav_decoderz00, 
CNST_TABLE_REF(((long)9))); 
VECTOR_SET(BgL_v1125z00_174,((long)1),BgL_arg1509z00_190); } 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_arg1531z00_203;
BgL_arg1531z00_203 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)10)), BGl_proc2101z00zz__wav_decoderz00, BGl_proc2100z00zz__wav_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2099z00zz__wav_decoderz00, 
CNST_TABLE_REF(((long)11))); 
VECTOR_SET(BgL_v1125z00_174,((long)2),BgL_arg1531z00_203); } 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_arg1552z00_216;
BgL_arg1552z00_216 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)12)), BGl_proc2104z00zz__wav_decoderz00, BGl_proc2103z00zz__wav_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2102z00zz__wav_decoderz00, 
CNST_TABLE_REF(((long)11))); 
VECTOR_SET(BgL_v1125z00_174,((long)3),BgL_arg1552z00_216); } 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_arg1581z00_229;
BgL_arg1581z00_229 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)13)), BGl_proc2107z00zz__wav_decoderz00, BGl_proc2106z00zz__wav_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2105z00zz__wav_decoderz00, 
CNST_TABLE_REF(((long)11))); 
VECTOR_SET(BgL_v1125z00_174,((long)4),BgL_arg1581z00_229); } 
BgL_arg1339z00_147 = BgL_v1125z00_174; } 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_v1126z00_242;
BgL_v1126z00_242 = 
create_vector(((long)0)); 
BgL_arg1340z00_148 = BgL_v1126z00_242; } 
return ( 
BGl_wavmusicdecoderz00zz__wav_decoderz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)14)), 
CNST_TABLE_REF(((long)15)), BGl_musicdecoderz00zz__multimediazd2musicbufzd2, ((long)3767), BGl_proc2110z00zz__wav_decoderz00, BGl_proc2109z00zz__wav_decoderz00, BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_proc2108z00zz__wav_decoderz00, BFALSE, BgL_arg1339z00_147, BgL_arg1340z00_148), BUNSPEC) ;} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1374> */
obj_t BGl_z62zc3anonymousza31374ze3ze1zz__wav_decoderz00(obj_t BgL_envz00_744, obj_t BgL_new1090z00_745)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 21 */
{ 
BgL_wavmusicdecoderz00_bglt BgL_auxz00_1466;
{ /* Llib/wav_decoder.scm 21 */
BgL_wavmusicdecoderz00_bglt BgL_new1090z00_1015;
if(
BGl_isazf3zf3zz__objectz00(BgL_new1090z00_745, BGl_wavmusicdecoderz00zz__wav_decoderz00))
{ /* Llib/wav_decoder.scm 21 */
BgL_new1090z00_1015 = 
((BgL_wavmusicdecoderz00_bglt)BgL_new1090z00_745); }  else 
{ 
obj_t BgL_auxz00_1470;
BgL_auxz00_1470 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2112z00zz__wav_decoderz00, BGl_string2113z00zz__wav_decoderz00, BgL_new1090z00_745); 
FAILURE(BgL_auxz00_1470,BFALSE,BFALSE);} 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1090z00_1015)))->BgL_mimetypesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1090z00_1015)))->BgL_bufferzd2timezd2nearz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1090z00_1015)))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1090z00_1015)))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1090z00_1015)))->BgL_z52z12dpausez40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1090z00_1015)))->BgL_z52z12dabortz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1090z00_1015)))->BgL_z52z12stopz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1090z00_1015)))->BgL_z52dmutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1090z00_1015)))->BgL_z52dcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1090z00_1015)))->BgL_z52doutcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_new1090z00_1015))->BgL_outbufz00)=((obj_t)BGl_string2111z00zz__wav_decoderz00),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_new1090z00_1015))->BgL_z52headerz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_new1090z00_1015))->BgL_z52cursorz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_new1090z00_1015))->BgL_z52siza7ezf5)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_new1090z00_1015))->BgL_z52positionz52)=((int)
(int)(((long)0))),BUNSPEC); 
BgL_auxz00_1466 = BgL_new1090z00_1015; } 
return 
((obj_t)BgL_auxz00_1466);} } 
BGL_FUNCTION_END;
}



/* &lambda1344 */
BgL_wavmusicdecoderz00_bglt BGl_z62lambda1344z62zz__wav_decoderz00(obj_t BgL_envz00_746)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 21 */
BgL_wavmusicdecoderz00_bglt BgL_new1089z00_1016;
BgL_new1089z00_1016 = 
((BgL_wavmusicdecoderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_wavmusicdecoderz00_bgl) ))); 
{ /* Llib/wav_decoder.scm 21 */
long BgL_arg1373z00_1017;
{ /* Llib/wav_decoder.scm 21 */
long BgL_res1893z00_1018;
BgL_res1893z00_1018 = 
BGL_CLASS_INDEX(BGl_wavmusicdecoderz00zz__wav_decoderz00); 
BgL_arg1373z00_1017 = BgL_res1893z00_1018; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1089z00_1016), BgL_arg1373z00_1017); } 
return BgL_new1089z00_1016;} } 
BGL_FUNCTION_END;
}



/* &lambda1341 */
BgL_wavmusicdecoderz00_bglt BGl_z62lambda1341z62zz__wav_decoderz00(obj_t BgL_envz00_747, obj_t BgL_mimetypes1074z00_748, obj_t BgL_bufferzd2timezd2near1075z00_749, obj_t BgL_bufferzd2siza7ezd2nearzd2rat1076z75_750, obj_t BgL_periodzd2siza7ezd2nearzd2rat1077z75_751, obj_t BgL_z52z12dpause1078z40_752, obj_t BgL_z52z12dabort1079z40_753, obj_t BgL_z52z12stop1080z40_754, obj_t BgL_z52dmutex1081z52_755, obj_t BgL_z52dcondv1082z52_756, obj_t BgL_z52doutcondv1083z52_757, obj_t BgL_outbuf1084z00_758, obj_t BgL_z52header1085z52_759, obj_t BgL_z52cursor1086z52_760, obj_t BgL_z52siza7e1087zf5_761, obj_t BgL_z52position1088z52_762)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_mimetypes1074z00_1023;int BgL_bufferzd2timezd2near1075z00_1024;int BgL_bufferzd2siza7ezd2nearzd2rat1076z75_1025;int BgL_periodzd2siza7ezd2nearzd2rat1077z75_1026;bool_t BgL_z52z12dpause1078z40_1027;bool_t BgL_z52z12dabort1079z40_1028;bool_t BgL_z52z12stop1080z40_1029;obj_t BgL_z52dmutex1081z52_1030;obj_t BgL_z52dcondv1082z52_1031;obj_t BgL_z52doutcondv1083z52_1032;obj_t BgL_outbuf1084z00_1033;int BgL_z52cursor1086z52_1034;int BgL_z52siza7e1087zf5_1035;int BgL_z52position1088z52_1036;
{ /* Llib/wav_decoder.scm 21 */
bool_t BgL_testz00_1513;
if(
PAIRP(BgL_mimetypes1074z00_748))
{ /* Llib/wav_decoder.scm 21 */
BgL_testz00_1513 = ((bool_t)1)
; }  else 
{ /* Llib/wav_decoder.scm 21 */
BgL_testz00_1513 = 
NULLP(BgL_mimetypes1074z00_748)
; } 
if(BgL_testz00_1513)
{ /* Llib/wav_decoder.scm 21 */
BgL_mimetypes1074z00_1023 = BgL_mimetypes1074z00_748; }  else 
{ 
obj_t BgL_auxz00_1517;
BgL_auxz00_1517 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2117z00zz__wav_decoderz00, BGl_string2118z00zz__wav_decoderz00, BgL_mimetypes1074z00_748); 
FAILURE(BgL_auxz00_1517,BFALSE,BFALSE);} } 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_tmpz00_1521;
if(
INTEGERP(BgL_bufferzd2timezd2near1075z00_749))
{ /* Llib/wav_decoder.scm 21 */
BgL_tmpz00_1521 = BgL_bufferzd2timezd2near1075z00_749
; }  else 
{ 
obj_t BgL_auxz00_1524;
BgL_auxz00_1524 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2117z00zz__wav_decoderz00, BGl_string2076z00zz__wav_decoderz00, BgL_bufferzd2timezd2near1075z00_749); 
FAILURE(BgL_auxz00_1524,BFALSE,BFALSE);} 
BgL_bufferzd2timezd2near1075z00_1024 = 
CINT(BgL_tmpz00_1521); } 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_tmpz00_1529;
if(
INTEGERP(BgL_bufferzd2siza7ezd2nearzd2rat1076z75_750))
{ /* Llib/wav_decoder.scm 21 */
BgL_tmpz00_1529 = BgL_bufferzd2siza7ezd2nearzd2rat1076z75_750
; }  else 
{ 
obj_t BgL_auxz00_1532;
BgL_auxz00_1532 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2117z00zz__wav_decoderz00, BGl_string2076z00zz__wav_decoderz00, BgL_bufferzd2siza7ezd2nearzd2rat1076z75_750); 
FAILURE(BgL_auxz00_1532,BFALSE,BFALSE);} 
BgL_bufferzd2siza7ezd2nearzd2rat1076z75_1025 = 
CINT(BgL_tmpz00_1529); } 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_tmpz00_1537;
if(
INTEGERP(BgL_periodzd2siza7ezd2nearzd2rat1077z75_751))
{ /* Llib/wav_decoder.scm 21 */
BgL_tmpz00_1537 = BgL_periodzd2siza7ezd2nearzd2rat1077z75_751
; }  else 
{ 
obj_t BgL_auxz00_1540;
BgL_auxz00_1540 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2117z00zz__wav_decoderz00, BGl_string2076z00zz__wav_decoderz00, BgL_periodzd2siza7ezd2nearzd2rat1077z75_751); 
FAILURE(BgL_auxz00_1540,BFALSE,BFALSE);} 
BgL_periodzd2siza7ezd2nearzd2rat1077z75_1026 = 
CINT(BgL_tmpz00_1537); } 
BgL_z52z12dpause1078z40_1027 = 
CBOOL(BgL_z52z12dpause1078z40_752); 
BgL_z52z12dabort1079z40_1028 = 
CBOOL(BgL_z52z12dabort1079z40_753); 
BgL_z52z12stop1080z40_1029 = 
CBOOL(BgL_z52z12stop1080z40_754); 
if(
BGL_MUTEXP(BgL_z52dmutex1081z52_755))
{ /* Llib/wav_decoder.scm 21 */
BgL_z52dmutex1081z52_1030 = BgL_z52dmutex1081z52_755; }  else 
{ 
obj_t BgL_auxz00_1550;
BgL_auxz00_1550 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2117z00zz__wav_decoderz00, BGl_string2119z00zz__wav_decoderz00, BgL_z52dmutex1081z52_755); 
FAILURE(BgL_auxz00_1550,BFALSE,BFALSE);} 
if(
BGL_CONDVARP(BgL_z52dcondv1082z52_756))
{ /* Llib/wav_decoder.scm 21 */
BgL_z52dcondv1082z52_1031 = BgL_z52dcondv1082z52_756; }  else 
{ 
obj_t BgL_auxz00_1556;
BgL_auxz00_1556 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2117z00zz__wav_decoderz00, BGl_string2120z00zz__wav_decoderz00, BgL_z52dcondv1082z52_756); 
FAILURE(BgL_auxz00_1556,BFALSE,BFALSE);} 
if(
BGL_CONDVARP(BgL_z52doutcondv1083z52_757))
{ /* Llib/wav_decoder.scm 21 */
BgL_z52doutcondv1083z52_1032 = BgL_z52doutcondv1083z52_757; }  else 
{ 
obj_t BgL_auxz00_1562;
BgL_auxz00_1562 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2117z00zz__wav_decoderz00, BGl_string2120z00zz__wav_decoderz00, BgL_z52doutcondv1083z52_757); 
FAILURE(BgL_auxz00_1562,BFALSE,BFALSE);} 
if(
STRINGP(BgL_outbuf1084z00_758))
{ /* Llib/wav_decoder.scm 21 */
BgL_outbuf1084z00_1033 = BgL_outbuf1084z00_758; }  else 
{ 
obj_t BgL_auxz00_1568;
BgL_auxz00_1568 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2117z00zz__wav_decoderz00, BGl_string2080z00zz__wav_decoderz00, BgL_outbuf1084z00_758); 
FAILURE(BgL_auxz00_1568,BFALSE,BFALSE);} 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_tmpz00_1572;
if(
INTEGERP(BgL_z52cursor1086z52_760))
{ /* Llib/wav_decoder.scm 21 */
BgL_tmpz00_1572 = BgL_z52cursor1086z52_760
; }  else 
{ 
obj_t BgL_auxz00_1575;
BgL_auxz00_1575 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2117z00zz__wav_decoderz00, BGl_string2076z00zz__wav_decoderz00, BgL_z52cursor1086z52_760); 
FAILURE(BgL_auxz00_1575,BFALSE,BFALSE);} 
BgL_z52cursor1086z52_1034 = 
CINT(BgL_tmpz00_1572); } 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_tmpz00_1580;
if(
INTEGERP(BgL_z52siza7e1087zf5_761))
{ /* Llib/wav_decoder.scm 21 */
BgL_tmpz00_1580 = BgL_z52siza7e1087zf5_761
; }  else 
{ 
obj_t BgL_auxz00_1583;
BgL_auxz00_1583 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2117z00zz__wav_decoderz00, BGl_string2076z00zz__wav_decoderz00, BgL_z52siza7e1087zf5_761); 
FAILURE(BgL_auxz00_1583,BFALSE,BFALSE);} 
BgL_z52siza7e1087zf5_1035 = 
CINT(BgL_tmpz00_1580); } 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_tmpz00_1588;
if(
INTEGERP(BgL_z52position1088z52_762))
{ /* Llib/wav_decoder.scm 21 */
BgL_tmpz00_1588 = BgL_z52position1088z52_762
; }  else 
{ 
obj_t BgL_auxz00_1591;
BgL_auxz00_1591 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2117z00zz__wav_decoderz00, BGl_string2076z00zz__wav_decoderz00, BgL_z52position1088z52_762); 
FAILURE(BgL_auxz00_1591,BFALSE,BFALSE);} 
BgL_z52position1088z52_1036 = 
CINT(BgL_tmpz00_1588); } 
{ /* Llib/wav_decoder.scm 21 */
BgL_wavmusicdecoderz00_bglt BgL_new1122z00_1037;
{ /* Llib/wav_decoder.scm 21 */
BgL_wavmusicdecoderz00_bglt BgL_new1121z00_1038;
BgL_new1121z00_1038 = 
((BgL_wavmusicdecoderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_wavmusicdecoderz00_bgl) ))); 
{ /* Llib/wav_decoder.scm 21 */
long BgL_arg1343z00_1039;
{ /* Llib/wav_decoder.scm 21 */
long BgL_res1892z00_1040;
BgL_res1892z00_1040 = 
BGL_CLASS_INDEX(BGl_wavmusicdecoderz00zz__wav_decoderz00); 
BgL_arg1343z00_1039 = BgL_res1892z00_1040; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1121z00_1038), BgL_arg1343z00_1039); } 
BgL_new1122z00_1037 = BgL_new1121z00_1038; } 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_1037)))->BgL_mimetypesz00)=((obj_t)BgL_mimetypes1074z00_1023),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_1037)))->BgL_bufferzd2timezd2nearz00)=((int)BgL_bufferzd2timezd2near1075z00_1024),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_1037)))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)BgL_bufferzd2siza7ezd2nearzd2rat1076z75_1025),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_1037)))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)BgL_periodzd2siza7ezd2nearzd2rat1077z75_1026),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_1037)))->BgL_z52z12dpausez40)=((bool_t)BgL_z52z12dpause1078z40_1027),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_1037)))->BgL_z52z12dabortz40)=((bool_t)BgL_z52z12dabort1079z40_1028),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_1037)))->BgL_z52z12stopz40)=((bool_t)BgL_z52z12stop1080z40_1029),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_1037)))->BgL_z52dmutexz52)=((obj_t)BgL_z52dmutex1081z52_1030),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_1037)))->BgL_z52dcondvz52)=((obj_t)BgL_z52dcondv1082z52_1031),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_1037)))->BgL_z52doutcondvz52)=((obj_t)BgL_z52doutcondv1083z52_1032),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_new1122z00_1037))->BgL_outbufz00)=((obj_t)BgL_outbuf1084z00_1033),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_new1122z00_1037))->BgL_z52headerz52)=((obj_t)BgL_z52header1085z52_759),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_new1122z00_1037))->BgL_z52cursorz52)=((int)BgL_z52cursor1086z52_1034),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_new1122z00_1037))->BgL_z52siza7ezf5)=((int)BgL_z52siza7e1087zf5_1035),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_new1122z00_1037))->BgL_z52positionz52)=((int)BgL_z52position1088z52_1036),BUNSPEC); 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_fun1342z00_1041;
BgL_fun1342z00_1041 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_wavmusicdecoderz00zz__wav_decoderz00); 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_funz00_1042;
if(
PROCEDUREP(BgL_fun1342z00_1041))
{ /* Llib/wav_decoder.scm 21 */
BgL_funz00_1042 = BgL_fun1342z00_1041; }  else 
{ 
obj_t BgL_auxz00_1628;
BgL_auxz00_1628 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2114z00zz__wav_decoderz00, BGl_string2115z00zz__wav_decoderz00, BgL_fun1342z00_1041); 
FAILURE(BgL_auxz00_1628,BFALSE,BFALSE);} 
if(
PROCEDURE_CORRECT_ARITYP(BgL_funz00_1042, ((long)1)))
{ /* Llib/wav_decoder.scm 21 */
PROCEDURE_ENTRY(BgL_funz00_1042)(BgL_fun1342z00_1041, 
((obj_t)BgL_new1122z00_1037), BEOA); }  else 
{ 
obj_t BgL_auxz00_1639;
BgL_auxz00_1639 = 
CNST_TABLE_REF(((long)16)); 
FAILURE(BGl_string2116z00zz__wav_decoderz00,BgL_auxz00_1639,BgL_funz00_1042);} } } 
return BgL_new1122z00_1037;} } } 
BGL_FUNCTION_END;
}



/* &<anonymous:1606> */
obj_t BGl_z62zc3anonymousza31606ze3ze1zz__wav_decoderz00(obj_t BgL_envz00_763)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 21 */
return 
BINT(((long)0));} 
BGL_FUNCTION_END;
}



/* &lambda1605 */
obj_t BGl_z62lambda1605z62zz__wav_decoderz00(obj_t BgL_envz00_764, obj_t BgL_oz00_765, obj_t BgL_vz00_766)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 21 */
BgL_wavmusicdecoderz00_bglt BgL_oz00_1043;int BgL_vz00_1044;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_765, BGl_wavmusicdecoderz00zz__wav_decoderz00))
{ /* Llib/wav_decoder.scm 21 */
BgL_oz00_1043 = 
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_765); }  else 
{ 
obj_t BgL_auxz00_1646;
BgL_auxz00_1646 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2121z00zz__wav_decoderz00, BGl_string2113z00zz__wav_decoderz00, BgL_oz00_765); 
FAILURE(BgL_auxz00_1646,BFALSE,BFALSE);} 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_tmpz00_1650;
if(
INTEGERP(BgL_vz00_766))
{ /* Llib/wav_decoder.scm 21 */
BgL_tmpz00_1650 = BgL_vz00_766
; }  else 
{ 
obj_t BgL_auxz00_1653;
BgL_auxz00_1653 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2121z00zz__wav_decoderz00, BGl_string2076z00zz__wav_decoderz00, BgL_vz00_766); 
FAILURE(BgL_auxz00_1653,BFALSE,BFALSE);} 
BgL_vz00_1044 = 
CINT(BgL_tmpz00_1650); } 
return 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_oz00_1043))->BgL_z52positionz52)=((int)BgL_vz00_1044),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1604 */
obj_t BGl_z62lambda1604z62zz__wav_decoderz00(obj_t BgL_envz00_767, obj_t BgL_oz00_768)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 21 */
int BgL_tmpz00_1659;
{ /* Llib/wav_decoder.scm 21 */
BgL_wavmusicdecoderz00_bglt BgL_oz00_1045;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_768, BGl_wavmusicdecoderz00zz__wav_decoderz00))
{ /* Llib/wav_decoder.scm 21 */
BgL_oz00_1045 = 
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_768); }  else 
{ 
obj_t BgL_auxz00_1663;
BgL_auxz00_1663 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2122z00zz__wav_decoderz00, BGl_string2113z00zz__wav_decoderz00, BgL_oz00_768); 
FAILURE(BgL_auxz00_1663,BFALSE,BFALSE);} 
BgL_tmpz00_1659 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_oz00_1045))->BgL_z52positionz52); } 
return 
BINT(BgL_tmpz00_1659);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1571> */
obj_t BGl_z62zc3anonymousza31571ze3ze1zz__wav_decoderz00(obj_t BgL_envz00_769)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 21 */
return 
BINT(((long)0));} 
BGL_FUNCTION_END;
}



/* &lambda1570 */
obj_t BGl_z62lambda1570z62zz__wav_decoderz00(obj_t BgL_envz00_770, obj_t BgL_oz00_771, obj_t BgL_vz00_772)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 21 */
BgL_wavmusicdecoderz00_bglt BgL_oz00_1046;int BgL_vz00_1047;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_771, BGl_wavmusicdecoderz00zz__wav_decoderz00))
{ /* Llib/wav_decoder.scm 21 */
BgL_oz00_1046 = 
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_771); }  else 
{ 
obj_t BgL_auxz00_1673;
BgL_auxz00_1673 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2123z00zz__wav_decoderz00, BGl_string2113z00zz__wav_decoderz00, BgL_oz00_771); 
FAILURE(BgL_auxz00_1673,BFALSE,BFALSE);} 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_tmpz00_1677;
if(
INTEGERP(BgL_vz00_772))
{ /* Llib/wav_decoder.scm 21 */
BgL_tmpz00_1677 = BgL_vz00_772
; }  else 
{ 
obj_t BgL_auxz00_1680;
BgL_auxz00_1680 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2123z00zz__wav_decoderz00, BGl_string2076z00zz__wav_decoderz00, BgL_vz00_772); 
FAILURE(BgL_auxz00_1680,BFALSE,BFALSE);} 
BgL_vz00_1047 = 
CINT(BgL_tmpz00_1677); } 
return 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_oz00_1046))->BgL_z52siza7ezf5)=((int)BgL_vz00_1047),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1569 */
obj_t BGl_z62lambda1569z62zz__wav_decoderz00(obj_t BgL_envz00_773, obj_t BgL_oz00_774)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 21 */
int BgL_tmpz00_1686;
{ /* Llib/wav_decoder.scm 21 */
BgL_wavmusicdecoderz00_bglt BgL_oz00_1048;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_774, BGl_wavmusicdecoderz00zz__wav_decoderz00))
{ /* Llib/wav_decoder.scm 21 */
BgL_oz00_1048 = 
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_774); }  else 
{ 
obj_t BgL_auxz00_1690;
BgL_auxz00_1690 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2124z00zz__wav_decoderz00, BGl_string2113z00zz__wav_decoderz00, BgL_oz00_774); 
FAILURE(BgL_auxz00_1690,BFALSE,BFALSE);} 
BgL_tmpz00_1686 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_oz00_1048))->BgL_z52siza7ezf5); } 
return 
BINT(BgL_tmpz00_1686);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1551> */
obj_t BGl_z62zc3anonymousza31551ze3ze1zz__wav_decoderz00(obj_t BgL_envz00_775)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 21 */
return 
BINT(((long)0));} 
BGL_FUNCTION_END;
}



/* &lambda1550 */
obj_t BGl_z62lambda1550z62zz__wav_decoderz00(obj_t BgL_envz00_776, obj_t BgL_oz00_777, obj_t BgL_vz00_778)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 21 */
BgL_wavmusicdecoderz00_bglt BgL_oz00_1049;int BgL_vz00_1050;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_777, BGl_wavmusicdecoderz00zz__wav_decoderz00))
{ /* Llib/wav_decoder.scm 21 */
BgL_oz00_1049 = 
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_777); }  else 
{ 
obj_t BgL_auxz00_1700;
BgL_auxz00_1700 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2125z00zz__wav_decoderz00, BGl_string2113z00zz__wav_decoderz00, BgL_oz00_777); 
FAILURE(BgL_auxz00_1700,BFALSE,BFALSE);} 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_tmpz00_1704;
if(
INTEGERP(BgL_vz00_778))
{ /* Llib/wav_decoder.scm 21 */
BgL_tmpz00_1704 = BgL_vz00_778
; }  else 
{ 
obj_t BgL_auxz00_1707;
BgL_auxz00_1707 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2125z00zz__wav_decoderz00, BGl_string2076z00zz__wav_decoderz00, BgL_vz00_778); 
FAILURE(BgL_auxz00_1707,BFALSE,BFALSE);} 
BgL_vz00_1050 = 
CINT(BgL_tmpz00_1704); } 
return 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_oz00_1049))->BgL_z52cursorz52)=((int)BgL_vz00_1050),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1549 */
obj_t BGl_z62lambda1549z62zz__wav_decoderz00(obj_t BgL_envz00_779, obj_t BgL_oz00_780)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 21 */
int BgL_tmpz00_1713;
{ /* Llib/wav_decoder.scm 21 */
BgL_wavmusicdecoderz00_bglt BgL_oz00_1051;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_780, BGl_wavmusicdecoderz00zz__wav_decoderz00))
{ /* Llib/wav_decoder.scm 21 */
BgL_oz00_1051 = 
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_780); }  else 
{ 
obj_t BgL_auxz00_1717;
BgL_auxz00_1717 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2126z00zz__wav_decoderz00, BGl_string2113z00zz__wav_decoderz00, BgL_oz00_780); 
FAILURE(BgL_auxz00_1717,BFALSE,BFALSE);} 
BgL_tmpz00_1713 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_oz00_1051))->BgL_z52cursorz52); } 
return 
BINT(BgL_tmpz00_1713);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1526> */
obj_t BGl_z62zc3anonymousza31526ze3ze1zz__wav_decoderz00(obj_t BgL_envz00_781)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 21 */
return 
BBOOL(((bool_t)0));} 
BGL_FUNCTION_END;
}



/* &lambda1525 */
obj_t BGl_z62lambda1525z62zz__wav_decoderz00(obj_t BgL_envz00_782, obj_t BgL_oz00_783, obj_t BgL_vz00_784)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 21 */
BgL_wavmusicdecoderz00_bglt BgL_oz00_1052;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_783, BGl_wavmusicdecoderz00zz__wav_decoderz00))
{ /* Llib/wav_decoder.scm 21 */
BgL_oz00_1052 = 
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_783); }  else 
{ 
obj_t BgL_auxz00_1727;
BgL_auxz00_1727 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2127z00zz__wav_decoderz00, BGl_string2113z00zz__wav_decoderz00, BgL_oz00_783); 
FAILURE(BgL_auxz00_1727,BFALSE,BFALSE);} 
return 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_oz00_1052))->BgL_z52headerz52)=((obj_t)BgL_vz00_784),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1524 */
obj_t BGl_z62lambda1524z62zz__wav_decoderz00(obj_t BgL_envz00_785, obj_t BgL_oz00_786)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 21 */
BgL_wavmusicdecoderz00_bglt BgL_oz00_1053;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_786, BGl_wavmusicdecoderz00zz__wav_decoderz00))
{ /* Llib/wav_decoder.scm 21 */
BgL_oz00_1053 = 
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_786); }  else 
{ 
obj_t BgL_auxz00_1735;
BgL_auxz00_1735 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2128z00zz__wav_decoderz00, BGl_string2113z00zz__wav_decoderz00, BgL_oz00_786); 
FAILURE(BgL_auxz00_1735,BFALSE,BFALSE);} 
return 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_oz00_1053))->BgL_z52headerz52);} } 
BGL_FUNCTION_END;
}



/* &<anonymous:1502> */
obj_t BGl_z62zc3anonymousza31502ze3ze1zz__wav_decoderz00(obj_t BgL_envz00_787)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 22 */

return 
make_string(((long)2048), ((unsigned char)' '));} } 
BGL_FUNCTION_END;
}



/* &lambda1501 */
obj_t BGl_z62lambda1501z62zz__wav_decoderz00(obj_t BgL_envz00_788, obj_t BgL_oz00_789, obj_t BgL_vz00_790)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 21 */
BgL_wavmusicdecoderz00_bglt BgL_oz00_1054;obj_t BgL_vz00_1055;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_789, BGl_wavmusicdecoderz00zz__wav_decoderz00))
{ /* Llib/wav_decoder.scm 21 */
BgL_oz00_1054 = 
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_789); }  else 
{ 
obj_t BgL_auxz00_1744;
BgL_auxz00_1744 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2129z00zz__wav_decoderz00, BGl_string2113z00zz__wav_decoderz00, BgL_oz00_789); 
FAILURE(BgL_auxz00_1744,BFALSE,BFALSE);} 
if(
STRINGP(BgL_vz00_790))
{ /* Llib/wav_decoder.scm 21 */
BgL_vz00_1055 = BgL_vz00_790; }  else 
{ 
obj_t BgL_auxz00_1750;
BgL_auxz00_1750 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2129z00zz__wav_decoderz00, BGl_string2080z00zz__wav_decoderz00, BgL_vz00_790); 
FAILURE(BgL_auxz00_1750,BFALSE,BFALSE);} 
return 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_oz00_1054))->BgL_outbufz00)=((obj_t)BgL_vz00_1055),BUNSPEC);} } 
BGL_FUNCTION_END;
}



/* &lambda1500 */
obj_t BGl_z62lambda1500z62zz__wav_decoderz00(obj_t BgL_envz00_791, obj_t BgL_oz00_792)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 21 */
BgL_wavmusicdecoderz00_bglt BgL_oz00_1056;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_792, BGl_wavmusicdecoderz00zz__wav_decoderz00))
{ /* Llib/wav_decoder.scm 21 */
BgL_oz00_1056 = 
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_792); }  else 
{ 
obj_t BgL_auxz00_1758;
BgL_auxz00_1758 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)1048)), BGl_string2130z00zz__wav_decoderz00, BGl_string2113z00zz__wav_decoderz00, BgL_oz00_792); 
FAILURE(BgL_auxz00_1758,BFALSE,BFALSE);} 
return 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_oz00_1056))->BgL_outbufz00);} } 
BGL_FUNCTION_END;
}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__wav_decoderz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 15 */
return BUNSPEC;} 
BGL_FUNCTION_END;
}



/* method-init */
obj_t BGl_methodzd2initzd2zz__wav_decoderz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2printzd2envz00zz__objectz00, BGl_wavmusicdecoderz00zz__wav_decoderz00, BGl_proc2131z00zz__wav_decoderz00, BGl_string2132z00zz__wav_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_wavmusicdecoderz00zz__wav_decoderz00, BGl_proc2133z00zz__wav_decoderz00, BGl_string2134z00zz__wav_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2resetz12zd2envz12zz__multimediazd2musicbufzd2, BGl_wavmusicdecoderz00zz__wav_decoderz00, BGl_proc2135z00zz__wav_decoderz00, BGl_string2136z00zz__wav_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2positionzd2envz00zz__multimediazd2musicbufzd2, BGl_wavmusicdecoderz00zz__wav_decoderz00, BGl_proc2137z00zz__wav_decoderz00, BGl_string2138z00zz__wav_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2decodezd2envz00zz__multimediazd2musicbufzd2, BGl_wavmusicdecoderz00zz__wav_decoderz00, BGl_proc2139z00zz__wav_decoderz00, BGl_string2140z00zz__wav_decoderz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2volumezd2setz12zd2envzc0zz__multimediazd2musicbufzd2, BGl_wavmusicdecoderz00zz__wav_decoderz00, BGl_proc2141z00zz__wav_decoderz00, BGl_string2142z00zz__wav_decoderz00);} 
BGL_FUNCTION_END;
}



/* &musicdecoder-volume-1138 */
obj_t BGl_z62musicdecoderzd2volumezd21138z62zz__wav_decoderz00(obj_t BgL_envz00_803, obj_t BgL_decz00_804, obj_t BgL_volz00_805)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 306 */
{ /* Llib/wav_decoder.scm 306 */
BgL_wavmusicdecoderz00_bglt BgL_decz00_1057;
if(
BGl_isazf3zf3zz__objectz00(BgL_decz00_804, BGl_wavmusicdecoderz00zz__wav_decoderz00))
{ /* Llib/wav_decoder.scm 306 */
BgL_decz00_1057 = 
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_804); }  else 
{ 
obj_t BgL_auxz00_1772;
BgL_auxz00_1772 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)11383)), BGl_string2143z00zz__wav_decoderz00, BGl_string2113z00zz__wav_decoderz00, BgL_decz00_804); 
FAILURE(BgL_auxz00_1772,BFALSE,BFALSE);} 
return BFALSE;} } 
BGL_FUNCTION_END;
}



/* &musicdecoder-decode-1136 */
obj_t BGl_z62musicdecoderzd2decodezd21136z62zz__wav_decoderz00(obj_t BgL_envz00_806, obj_t BgL_decz00_807, obj_t BgL_amz00_808, obj_t BgL_bufferz00_809)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 93 */
{ /* Llib/wav_decoder.scm 96 */
BgL_wavmusicdecoderz00_bglt BgL_decz00_1058;BgL_musicbufz00_bglt BgL_amz00_1059;BgL_musicbufferz00_bglt BgL_bufferz00_1060;
if(
BGl_isazf3zf3zz__objectz00(BgL_decz00_807, BGl_wavmusicdecoderz00zz__wav_decoderz00))
{ /* Llib/wav_decoder.scm 96 */
BgL_decz00_1058 = 
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_807); }  else 
{ 
obj_t BgL_auxz00_1779;
BgL_auxz00_1779 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)4554)), BGl_string2158z00zz__wav_decoderz00, BGl_string2113z00zz__wav_decoderz00, BgL_decz00_807); 
FAILURE(BgL_auxz00_1779,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_amz00_808, BGl_musicbufz00zz__multimediazd2musicbufzd2))
{ /* Llib/wav_decoder.scm 96 */
BgL_amz00_1059 = 
((BgL_musicbufz00_bglt)BgL_amz00_808); }  else 
{ 
obj_t BgL_auxz00_1786;
BgL_auxz00_1786 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)4554)), BGl_string2158z00zz__wav_decoderz00, BGl_string2159z00zz__wav_decoderz00, BgL_amz00_808); 
FAILURE(BgL_auxz00_1786,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_bufferz00_809, BGl_musicbufferz00zz__multimediazd2musicbufzd2))
{ /* Llib/wav_decoder.scm 96 */
BgL_bufferz00_1060 = 
((BgL_musicbufferz00_bglt)BgL_bufferz00_809); }  else 
{ 
obj_t BgL_auxz00_1793;
BgL_auxz00_1793 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)4554)), BGl_string2158z00zz__wav_decoderz00, BGl_string2160z00zz__wav_decoderz00, BgL_bufferz00_809); 
FAILURE(BgL_auxz00_1793,BFALSE,BFALSE);} 
{ /* Llib/wav_decoder.scm 99 */
obj_t BgL_haszd2beenzd2emptyzd2oncezd2_1061;
BgL_haszd2beenzd2emptyzd2oncezd2_1061 = 
MAKE_CELL(BFALSE); 
{ /* Llib/wav_decoder.scm 99 */
long BgL_inlenz00_1062;
BgL_inlenz00_1062 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_1060))->BgL_z52inlenz52); 
{ /* Llib/wav_decoder.scm 107 */
long BgL_outlenz00_1063;
BgL_outlenz00_1063 = 
STRING_LENGTH(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_1058))->BgL_outbufz00)); 
{ 

{ /* Llib/wav_decoder.scm 169 */
bool_t BgL_testz00_1800;
{ /* Llib/wav_decoder.scm 169 */
int BgL_arg1641z00_1065;
BgL_arg1641z00_1065 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_testz00_1800 = 
(
(long)(BgL_arg1641z00_1065)>((long)0)); } 
if(BgL_testz00_1800)
{ /* Llib/wav_decoder.scm 169 */
BGl_debugzd2initz12zc0zz__wav_decoderz00(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_1060))->BgL_urlz00)); }  else 
{ /* Llib/wav_decoder.scm 169 */BFALSE; } } 
{ 

BgL_loopz00_1066:
if(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_decz00_1058)))->BgL_z52z12dpausez40))
{ /* Llib/wav_decoder.scm 173 */
{ /* Llib/wav_decoder.scm 175 */
BgL_musicstatusz00_bglt BgL_i1101z00_1067;
BgL_i1101z00_1067 = 
(((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_amz00_1059)))->BgL_z52statusz52); 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1101z00_1067))->BgL_songposz00)=((obj_t)
BINT(
BGl_musicdecoderzd2positionzd2zz__multimediazd2musicbufzd2(
((BgL_musicdecoderz00_bglt)BgL_decz00_1058), BgL_bufferz00_1060))),BUNSPEC); } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_amz00_1059), 
CNST_TABLE_REF(((long)17))); 
{ /* Llib/wav_decoder.scm 178 */
obj_t BgL_mutex1644z00_1068;
BgL_mutex1644z00_1068 = 
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_decz00_1058)))->BgL_z52dmutexz52); 
BGL_MUTEX_LOCK(BgL_mutex1644z00_1068); 
{ /* Llib/wav_decoder.scm 178 */
bool_t BgL_tmp2296z00_1820;
{ 

BgL_liipz00_1069:
if(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_decz00_1058)))->BgL_z52z12dpausez40))
{ /* Llib/wav_decoder.scm 180 */
{ /* Llib/wav_decoder.scm 181 */
obj_t BgL_arg1648z00_1070;obj_t BgL_arg1649z00_1071;
BgL_arg1648z00_1070 = 
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_decz00_1058)))->BgL_z52dcondvz52); 
BgL_arg1649z00_1071 = 
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_decz00_1058)))->BgL_z52dmutexz52); 
{ /* Llib/wav_decoder.scm 181 */

{ /* Llib/wav_decoder.scm 181 */
bool_t BgL_res1926z00_1072;
BgL_res1926z00_1072 = 
BGL_CONDVAR_WAIT(BgL_arg1648z00_1070, BgL_arg1649z00_1071); BgL_res1926z00_1072; } } } 
goto BgL_liipz00_1069;}  else 
{ /* Llib/wav_decoder.scm 180 */
BgL_tmp2296z00_1820 = ((bool_t)0); } } 
BGL_MUTEX_UNLOCK(BgL_mutex1644z00_1068); BgL_tmp2296z00_1820; } } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_amz00_1059), 
CNST_TABLE_REF(((long)18))); 
goto BgL_loopz00_1066;}  else 
{ /* Llib/wav_decoder.scm 173 */
if(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_decz00_1058)))->BgL_z52z12dabortz40))
{ /* Llib/wav_decoder.scm 185 */
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_amz00_1059), 
CNST_TABLE_REF(((long)19))); }  else 
{ /* Llib/wav_decoder.scm 185 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_1060))->BgL_z52emptyz52))
{ /* Llib/wav_decoder.scm 188 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_1060))->BgL_z52eofz52))
{ /* Llib/wav_decoder.scm 190 */
{ /* Llib/wav_decoder.scm 192 */
bool_t BgL_testz00_1844;
{ /* Llib/wav_decoder.scm 192 */
int BgL_arg1667z00_1073;
BgL_arg1667z00_1073 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_testz00_1844 = 
(
(long)(BgL_arg1667z00_1073)>=((long)2)); } 
if(BgL_testz00_1844)
{ /* Llib/wav_decoder.scm 193 */
obj_t BgL_arg1663z00_1074;
BgL_arg1663z00_1074 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_1060))->BgL_urlz00); 
{ /* Llib/wav_decoder.scm 193 */
obj_t BgL_list1664z00_1075;
{ /* Llib/wav_decoder.scm 193 */
obj_t BgL_arg1665z00_1076;
{ /* Llib/wav_decoder.scm 193 */
obj_t BgL_arg1666z00_1077;
BgL_arg1666z00_1077 = 
MAKE_YOUNG_PAIR(BGl_string2083z00zz__wav_decoderz00, BNIL); 
BgL_arg1665z00_1076 = 
MAKE_YOUNG_PAIR(BgL_arg1663z00_1074, BgL_arg1666z00_1077); } 
BgL_list1664z00_1075 = 
MAKE_YOUNG_PAIR(BGl_string2144z00zz__wav_decoderz00, BgL_arg1665z00_1076); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1664z00_1075); } }  else 
{ /* Llib/wav_decoder.scm 192 */BFALSE; } } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_amz00_1059), 
CNST_TABLE_REF(((long)20))); }  else 
{ /* Llib/wav_decoder.scm 190 */
{ /* Llib/wav_decoder.scm 196 */
bool_t BgL_testz00_1856;
{ /* Llib/wav_decoder.scm 196 */
int BgL_arg1681z00_1078;
BgL_arg1681z00_1078 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_testz00_1856 = 
(
(long)(BgL_arg1681z00_1078)>=((long)1)); } 
if(BgL_testz00_1856)
{ /* Llib/wav_decoder.scm 197 */
obj_t BgL_arg1672z00_1079;BGL_LONGLONG_T BgL_arg1675z00_1080;
BgL_arg1672z00_1079 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_1060))->BgL_urlz00); 
BgL_arg1675z00_1080 = 
bgl_current_microseconds(); 
{ /* Llib/wav_decoder.scm 197 */
obj_t BgL_list1676z00_1081;
{ /* Llib/wav_decoder.scm 197 */
obj_t BgL_arg1677z00_1082;
{ /* Llib/wav_decoder.scm 197 */
obj_t BgL_arg1678z00_1083;
{ /* Llib/wav_decoder.scm 197 */
obj_t BgL_arg1679z00_1084;
{ /* Llib/wav_decoder.scm 197 */
obj_t BgL_arg1680z00_1085;
BgL_arg1680z00_1085 = 
MAKE_YOUNG_PAIR(BGl_string2145z00zz__wav_decoderz00, BNIL); 
BgL_arg1679z00_1084 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1675z00_1080), BgL_arg1680z00_1085); } 
BgL_arg1678z00_1083 = 
MAKE_YOUNG_PAIR(BGl_string2084z00zz__wav_decoderz00, BgL_arg1679z00_1084); } 
BgL_arg1677z00_1082 = 
MAKE_YOUNG_PAIR(BgL_arg1672z00_1079, BgL_arg1678z00_1083); } 
BgL_list1676z00_1081 = 
MAKE_YOUNG_PAIR(BGl_string2146z00zz__wav_decoderz00, BgL_arg1677z00_1082); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1676z00_1081); } }  else 
{ /* Llib/wav_decoder.scm 196 */BFALSE; } } 
{ /* Llib/wav_decoder.scm 200 */
BgL_musicstatusz00_bglt BgL_i1103z00_1086;
BgL_i1103z00_1086 = 
(((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_amz00_1059)))->BgL_z52statusz52); 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1103z00_1086))->BgL_bufferingz00)=((int)
(int)(
BGl_bufferzd2percentagezd2filledze70ze7zz__wav_decoderz00(BgL_inlenz00_1062, BgL_bufferz00_1060))),BUNSPEC); } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_amz00_1059), 
CNST_TABLE_REF(((long)21))); 
{ /* Llib/wav_decoder.scm 204 */
obj_t BgL_mutex1682z00_1087;
BgL_mutex1682z00_1087 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_1060))->BgL_z52bmutexz52); 
{ /* Llib/wav_decoder.scm 204 */
obj_t BgL_top2298z00_1879;
BgL_top2298z00_1879 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mutex1682z00_1087); 
BGL_EXITD_PUSH_PROTECT(BgL_top2298z00_1879, BgL_mutex1682z00_1087); BUNSPEC; 
{ /* Llib/wav_decoder.scm 204 */
bool_t BgL_tmp2297z00_1878;
{ /* Llib/wav_decoder.scm 206 */
bool_t BgL_testz00_1883;
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_1060))->BgL_z52emptyz52))
{ /* Llib/wav_decoder.scm 206 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_1060))->BgL_z52eofz52))
{ /* Llib/wav_decoder.scm 206 */
BgL_testz00_1883 = ((bool_t)1)
; }  else 
{ /* Llib/wav_decoder.scm 206 */
if(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_decz00_1058)))->BgL_z52z12dabortz40))
{ /* Llib/wav_decoder.scm 206 */
BgL_testz00_1883 = ((bool_t)1)
; }  else 
{ /* Llib/wav_decoder.scm 206 */
BgL_testz00_1883 = 
(
(((long)8)*
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(BgL_bufferz00_1060))>BgL_inlenz00_1062)
; } } }  else 
{ /* Llib/wav_decoder.scm 206 */
BgL_testz00_1883 = ((bool_t)1)
; } 
if(BgL_testz00_1883)
{ /* Llib/wav_decoder.scm 206 */
BgL_tmp2297z00_1878 = ((bool_t)0); }  else 
{ /* Llib/wav_decoder.scm 210 */
obj_t BgL_arg1689z00_1088;obj_t BgL_arg1690z00_1089;
BgL_arg1689z00_1088 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_1060))->BgL_z52bcondvz52); 
BgL_arg1690z00_1089 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_1060))->BgL_z52bmutexz52); 
{ /* Llib/wav_decoder.scm 210 */

{ /* Llib/wav_decoder.scm 210 */
bool_t BgL_res1931z00_1090;
BgL_res1931z00_1090 = 
BGL_CONDVAR_WAIT(BgL_arg1689z00_1088, BgL_arg1690z00_1089); 
BgL_tmp2297z00_1878 = BgL_res1931z00_1090; } } } } 
BGL_EXITD_POP_PROTECT(BgL_top2298z00_1879); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mutex1682z00_1087); BgL_tmp2297z00_1878; } } } 
{ /* Llib/wav_decoder.scm 211 */
bool_t BgL_testz00_1899;
{ /* Llib/wav_decoder.scm 211 */
int BgL_arg1697z00_1091;
BgL_arg1697z00_1091 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_testz00_1899 = 
(
(long)(BgL_arg1697z00_1091)>=((long)1)); } 
if(BgL_testz00_1899)
{ /* Llib/wav_decoder.scm 212 */
BGL_LONGLONG_T BgL_arg1694z00_1092;
BgL_arg1694z00_1092 = 
bgl_current_microseconds(); 
{ /* Llib/wav_decoder.scm 212 */
obj_t BgL_list1695z00_1093;
{ /* Llib/wav_decoder.scm 212 */
obj_t BgL_arg1696z00_1094;
BgL_arg1696z00_1094 = 
MAKE_YOUNG_PAIR(BGl_string2083z00zz__wav_decoderz00, BNIL); 
BgL_list1695z00_1093 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1694z00_1092), BgL_arg1696z00_1094); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1695z00_1093); } }  else 
{ /* Llib/wav_decoder.scm 211 */BFALSE; } } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_amz00_1059), 
CNST_TABLE_REF(((long)18))); 
goto BgL_loopz00_1066;} }  else 
{ /* Llib/wav_decoder.scm 217 */
long BgL_sz00_1095;
{ /* Llib/wav_decoder.scm 217 */
long BgL_bz00_1096;
if(
(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_1060))->BgL_z52headz52)>
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_1060))->BgL_z52tailz52)))
{ /* Llib/wav_decoder.scm 218 */
BgL_bz00_1096 = 
(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_1060))->BgL_z52headz52)-
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_1060))->BgL_z52tailz52)); }  else 
{ /* Llib/wav_decoder.scm 218 */
BgL_bz00_1096 = 
(BgL_inlenz00_1062-
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_1060))->BgL_z52tailz52)); } 
if(
(BgL_outlenz00_1063<BgL_bz00_1096))
{ /* Llib/wav_decoder.scm 218 */
BgL_sz00_1095 = BgL_outlenz00_1063; }  else 
{ /* Llib/wav_decoder.scm 218 */
BgL_sz00_1095 = BgL_bz00_1096; } } 
if(
(BgL_sz00_1095==((long)0)))
{ /* Llib/wav_decoder.scm 221 */
goto BgL_loopz00_1066;}  else 
{ /* Llib/wav_decoder.scm 223 */
obj_t BgL_statusz00_1097;
{ /* Llib/wav_decoder.scm 223 */
long BgL_arg1785z00_1098;
BgL_arg1785z00_1098 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_1060))->BgL_z52tailz52); 
BgL_statusz00_1097 = 
BGl_wavzd2decodezd2zz__wav_decoderz00(BgL_decz00_1058, BgL_amz00_1059, BgL_bufferz00_1060, 
(int)(BgL_arg1785z00_1098), 
(int)(BgL_sz00_1095)); } 
{ /* Llib/wav_decoder.scm 224 */
bool_t BgL_testz00_1928;
{ /* Llib/wav_decoder.scm 224 */
int BgL_arg1750z00_1099;
BgL_arg1750z00_1099 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_testz00_1928 = 
(
(long)(BgL_arg1750z00_1099)>=((long)4)); } 
if(BgL_testz00_1928)
{ /* Llib/wav_decoder.scm 225 */
long BgL_arg1708z00_1100;long BgL_arg1712z00_1101;obj_t BgL_arg1715z00_1102;
BgL_arg1708z00_1100 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_1060))->BgL_z52tailz52); 
BgL_arg1712z00_1101 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_1060))->BgL_z52headz52); 
BgL_arg1715z00_1102 = 
BGl_wavzd2decodezd2statuszd2ze3symbolz31zz__wav_decoderz00(BgL_statusz00_1097); 
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_list1716z00_1103;
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_arg1719z00_1104;
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_arg1725z00_1105;
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_arg1737z00_1106;
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_arg1738z00_1107;
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_arg1740z00_1108;
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_arg1747z00_1109;
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_arg1748z00_1110;
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_arg1749z00_1111;
BgL_arg1749z00_1111 = 
MAKE_YOUNG_PAIR(BGl_string2083z00zz__wav_decoderz00, BNIL); 
BgL_arg1748z00_1110 = 
MAKE_YOUNG_PAIR(BgL_arg1715z00_1102, BgL_arg1749z00_1111); } 
BgL_arg1747z00_1109 = 
MAKE_YOUNG_PAIR(BGl_string2147z00zz__wav_decoderz00, BgL_arg1748z00_1110); } 
BgL_arg1740z00_1108 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1712z00_1101), BgL_arg1747z00_1109); } 
BgL_arg1738z00_1107 = 
MAKE_YOUNG_PAIR(BGl_string2148z00zz__wav_decoderz00, BgL_arg1740z00_1108); } 
BgL_arg1737z00_1106 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1708z00_1100), BgL_arg1738z00_1107); } 
BgL_arg1725z00_1105 = 
MAKE_YOUNG_PAIR(BGl_string2149z00zz__wav_decoderz00, BgL_arg1737z00_1106); } 
BgL_arg1719z00_1104 = 
MAKE_YOUNG_PAIR(
BINT(BgL_sz00_1095), BgL_arg1725z00_1105); } 
BgL_list1716z00_1103 = 
MAKE_YOUNG_PAIR(BGl_string2150z00zz__wav_decoderz00, BgL_arg1719z00_1104); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1716z00_1103); } }  else 
{ /* Llib/wav_decoder.scm 224 */BFALSE; } } 
{ /* Llib/wav_decoder.scm 231 */
bool_t BgL_testz00_1948;
{ /* Llib/wav_decoder.scm 231 */
long BgL_n1z00_1112;
{ /* Llib/wav_decoder.scm 231 */
obj_t BgL_tmpz00_1949;
if(
INTEGERP(BgL_statusz00_1097))
{ /* Llib/wav_decoder.scm 231 */
BgL_tmpz00_1949 = BgL_statusz00_1097
; }  else 
{ 
obj_t BgL_auxz00_1952;
BgL_auxz00_1952 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)8624)), BGl_string2151z00zz__wav_decoderz00, BGl_string2076z00zz__wav_decoderz00, BgL_statusz00_1097); 
FAILURE(BgL_auxz00_1952,BFALSE,BFALSE);} 
BgL_n1z00_1112 = 
(long)CINT(BgL_tmpz00_1949); } 
BgL_testz00_1948 = 
(BgL_n1z00_1112==((long)4)); } 
if(BgL_testz00_1948)
{ /* Llib/wav_decoder.scm 231 */
{ /* Llib/wav_decoder.scm 233 */
bool_t BgL_testz00_1958;
{ /* Llib/wav_decoder.scm 233 */
int BgL_arg1760z00_1113;
BgL_arg1760z00_1113 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_testz00_1958 = 
(
(long)(BgL_arg1760z00_1113)>=((long)5)); } 
if(BgL_testz00_1958)
{ /* Llib/wav_decoder.scm 234 */
int BgL_arg1754z00_1114;
BgL_arg1754z00_1114 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_1058))->BgL_z52siza7ezf5); 
{ /* Llib/wav_decoder.scm 234 */
obj_t BgL_list1755z00_1115;
{ /* Llib/wav_decoder.scm 234 */
obj_t BgL_arg1756z00_1116;
{ /* Llib/wav_decoder.scm 234 */
obj_t BgL_arg1757z00_1117;
{ /* Llib/wav_decoder.scm 234 */
obj_t BgL_arg1758z00_1118;
{ /* Llib/wav_decoder.scm 234 */
obj_t BgL_arg1759z00_1119;
BgL_arg1759z00_1119 = 
MAKE_YOUNG_PAIR(BGl_string2083z00zz__wav_decoderz00, BNIL); 
BgL_arg1758z00_1118 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1754z00_1114), BgL_arg1759z00_1119); } 
BgL_arg1757z00_1117 = 
MAKE_YOUNG_PAIR(BGl_string2152z00zz__wav_decoderz00, BgL_arg1758z00_1118); } 
BgL_arg1756z00_1116 = 
MAKE_YOUNG_PAIR(
BINT(BgL_sz00_1095), BgL_arg1757z00_1117); } 
BgL_list1755z00_1115 = 
MAKE_YOUNG_PAIR(BGl_string2153z00zz__wav_decoderz00, BgL_arg1756z00_1116); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1755z00_1115); } }  else 
{ /* Llib/wav_decoder.scm 233 */BFALSE; } } 
BGl_flushze70ze7zz__wav_decoderz00(BgL_amz00_1059, BgL_decz00_1058, 
(int)(BgL_sz00_1095)); 
BGl_inczd2tailz12ze70z27zz__wav_decoderz00(BgL_bufferz00_1060, BgL_inlenz00_1062, BgL_bufferz00_1060, BgL_haszd2beenzd2emptyzd2oncezd2_1061, BgL_sz00_1095); 
goto BgL_loopz00_1066;}  else 
{ /* Llib/wav_decoder.scm 239 */
bool_t BgL_testz00_1974;
{ /* Llib/wav_decoder.scm 239 */
long BgL_n1z00_1120;
{ /* Llib/wav_decoder.scm 239 */
obj_t BgL_tmpz00_1975;
if(
INTEGERP(BgL_statusz00_1097))
{ /* Llib/wav_decoder.scm 239 */
BgL_tmpz00_1975 = BgL_statusz00_1097
; }  else 
{ 
obj_t BgL_auxz00_1978;
BgL_auxz00_1978 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)8842)), BGl_string2151z00zz__wav_decoderz00, BGl_string2076z00zz__wav_decoderz00, BgL_statusz00_1097); 
FAILURE(BgL_auxz00_1978,BFALSE,BFALSE);} 
BgL_n1z00_1120 = 
(long)CINT(BgL_tmpz00_1975); } 
BgL_testz00_1974 = 
(BgL_n1z00_1120==((long)3)); } 
if(BgL_testz00_1974)
{ /* Llib/wav_decoder.scm 239 */
{ /* Llib/wav_decoder.scm 241 */
bool_t BgL_testz00_1984;
{ /* Llib/wav_decoder.scm 241 */
int BgL_arg1776z00_1121;
BgL_arg1776z00_1121 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_testz00_1984 = 
(
(long)(BgL_arg1776z00_1121)>=((long)5)); } 
if(BgL_testz00_1984)
{ /* Llib/wav_decoder.scm 242 */
int BgL_arg1764z00_1122;bool_t BgL_arg1765z00_1123;long BgL_arg1766z00_1124;
BgL_arg1764z00_1122 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_1058))->BgL_z52siza7ezf5); 
BgL_arg1765z00_1123 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_1060))->BgL_z52emptyz52); 
BgL_arg1766z00_1124 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_1060))->BgL_z52tailz52); 
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_list1767z00_1125;
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_arg1768z00_1126;
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_arg1769z00_1127;
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_arg1770z00_1128;
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_arg1771z00_1129;
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_arg1772z00_1130;
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_arg1773z00_1131;
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_arg1774z00_1132;
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_arg1775z00_1133;
BgL_arg1775z00_1133 = 
MAKE_YOUNG_PAIR(BGl_string2083z00zz__wav_decoderz00, BNIL); 
BgL_arg1774z00_1132 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1766z00_1124), BgL_arg1775z00_1133); } 
BgL_arg1773z00_1131 = 
MAKE_YOUNG_PAIR(BGl_string2154z00zz__wav_decoderz00, BgL_arg1774z00_1132); } 
BgL_arg1772z00_1130 = 
MAKE_YOUNG_PAIR(
BBOOL(BgL_arg1765z00_1123), BgL_arg1773z00_1131); } 
BgL_arg1771z00_1129 = 
MAKE_YOUNG_PAIR(BGl_string2155z00zz__wav_decoderz00, BgL_arg1772z00_1130); } 
BgL_arg1770z00_1128 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1764z00_1122), BgL_arg1771z00_1129); } 
BgL_arg1769z00_1127 = 
MAKE_YOUNG_PAIR(BGl_string2152z00zz__wav_decoderz00, BgL_arg1770z00_1128); } 
BgL_arg1768z00_1126 = 
MAKE_YOUNG_PAIR(
BINT(BgL_sz00_1095), BgL_arg1769z00_1127); } 
BgL_list1767z00_1125 = 
MAKE_YOUNG_PAIR(BGl_string2156z00zz__wav_decoderz00, BgL_arg1768z00_1126); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1767z00_1125); } }  else 
{ /* Llib/wav_decoder.scm 241 */BFALSE; } } 
goto BgL_loopz00_1066;}  else 
{ /* Llib/wav_decoder.scm 246 */
bool_t BgL_testz00_2005;
{ /* Llib/wav_decoder.scm 246 */
long BgL_n1z00_1134;
{ /* Llib/wav_decoder.scm 246 */
obj_t BgL_tmpz00_2006;
if(
INTEGERP(BgL_statusz00_1097))
{ /* Llib/wav_decoder.scm 246 */
BgL_tmpz00_2006 = BgL_statusz00_1097
; }  else 
{ 
obj_t BgL_auxz00_2009;
BgL_auxz00_2009 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)9093)), BGl_string2151z00zz__wav_decoderz00, BGl_string2076z00zz__wav_decoderz00, BgL_statusz00_1097); 
FAILURE(BgL_auxz00_2009,BFALSE,BFALSE);} 
BgL_n1z00_1134 = 
(long)CINT(BgL_tmpz00_2006); } 
BgL_testz00_2005 = 
(BgL_n1z00_1134==((long)1)); } 
if(BgL_testz00_2005)
{ /* Llib/wav_decoder.scm 246 */
BGl_musicdecoderzd2hwparamszd2setz12z12zz__multimediazd2musicbufzd2(
((BgL_musicdecoderz00_bglt)BgL_decz00_1058), 
((BgL_musicz00_bglt)BgL_amz00_1059), BgL_bufferz00_1060); 
{ /* Llib/wav_decoder.scm 249 */
long BgL_arg1778z00_1135;
{ /* Llib/wav_decoder.scm 249 */
long BgL_arg1779z00_1136;
BgL_arg1779z00_1136 = 
BGl_wavzd2headerzd2siza7eza7zz__wav_wavz00(); 
{ /* Llib/wav_decoder.scm 249 */
long BgL_res1947z00_1137;
BgL_res1947z00_1137 = 
(long)(BgL_arg1779z00_1136); 
BgL_arg1778z00_1135 = BgL_res1947z00_1137; } } 
BGl_inczd2tailz12ze70z27zz__wav_decoderz00(BgL_bufferz00_1060, BgL_inlenz00_1062, BgL_bufferz00_1060, BgL_haszd2beenzd2emptyzd2oncezd2_1061, BgL_arg1778z00_1135); } 
goto BgL_loopz00_1066;}  else 
{ /* Llib/wav_decoder.scm 251 */
bool_t BgL_testz00_2021;
{ /* Llib/wav_decoder.scm 251 */
long BgL_n1z00_1138;
{ /* Llib/wav_decoder.scm 251 */
obj_t BgL_tmpz00_2022;
if(
INTEGERP(BgL_statusz00_1097))
{ /* Llib/wav_decoder.scm 251 */
BgL_tmpz00_2022 = BgL_statusz00_1097
; }  else 
{ 
obj_t BgL_auxz00_2025;
BgL_auxz00_2025 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)9269)), BGl_string2151z00zz__wav_decoderz00, BGl_string2076z00zz__wav_decoderz00, BgL_statusz00_1097); 
FAILURE(BgL_auxz00_2025,BFALSE,BFALSE);} 
BgL_n1z00_1138 = 
(long)CINT(BgL_tmpz00_2022); } 
BgL_testz00_2021 = 
(BgL_n1z00_1138==((long)2)); } 
if(BgL_testz00_2021)
{ /* Llib/wav_decoder.scm 251 */
if(
(
(long)(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_1058))->BgL_z52siza7ezf5))>((long)0)))
{ /* Llib/wav_decoder.scm 253 */
BGl_flushze70ze7zz__wav_decoderz00(BgL_amz00_1059, BgL_decz00_1058, 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_1058))->BgL_z52siza7ezf5)); }  else 
{ /* Llib/wav_decoder.scm 253 */((bool_t)0); } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_amz00_1059), 
CNST_TABLE_REF(((long)20))); }  else 
{ /* Llib/wav_decoder.scm 251 */
{ /* Llib/wav_decoder.scm 257 */
BgL_musicstatusz00_bglt BgL_i1104z00_1139;
BgL_i1104z00_1139 = 
(((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_amz00_1059)))->BgL_z52statusz52); 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1104z00_1139))->BgL_errz00)=((obj_t)BGl_string2157z00zz__wav_decoderz00),BUNSPEC); 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1104z00_1139))->BgL_statez00)=((obj_t)
CNST_TABLE_REF(((long)22))),BUNSPEC); } 
BGl_musiczd2errorzd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_amz00_1059), BGl_string2157z00zz__wav_decoderz00); } } } } } } } } } } 
{ /* Llib/wav_decoder.scm 261 */
bool_t BgL_testz00_2047;
{ /* Llib/wav_decoder.scm 261 */
int BgL_arg1798z00_1140;
BgL_arg1798z00_1140 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_testz00_2047 = 
(
(long)(BgL_arg1798z00_1140)>((long)0)); } 
if(BgL_testz00_2047)
{ /* Llib/wav_decoder.scm 261 */
return 
BGl_debugzd2stopz12zc0zz__wav_decoderz00(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_1060))->BgL_urlz00));}  else 
{ /* Llib/wav_decoder.scm 261 */
return BFALSE;} } } } } } } } 
BGL_FUNCTION_END;
}



/* flush~0 */
bool_t BGl_flushze70ze7zz__wav_decoderz00(BgL_musicbufz00_bglt BgL_amz00_836, BgL_wavmusicdecoderz00_bglt BgL_i1099z00_835, int BgL_sza7za7_505)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 167 */
BGl_flushze70ze7zz__wav_decoderz00:
if(
(
(long)(BgL_sza7za7_505)>((long)0)))
{ /* Llib/wav_decoder.scm 167 */
long BgL_arg1870z00_508;
{ /* Llib/wav_decoder.scm 167 */
obj_t BgL_arg1871z00_509;
BgL_arg1871z00_509 = 
BGl_musicbufzd2writezd2zz__multimediazd2musicbufzd2(BgL_amz00_836, 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_i1099z00_835))->BgL_outbufz00), 
(long)(BgL_sza7za7_505)); 
{ /* Llib/wav_decoder.scm 167 */
long BgL_za71za7_653;long BgL_za72za7_654;
BgL_za71za7_653 = 
(long)(BgL_sza7za7_505); 
{ /* Llib/wav_decoder.scm 167 */
obj_t BgL_tmpz00_2060;
if(
INTEGERP(BgL_arg1871z00_509))
{ /* Llib/wav_decoder.scm 167 */
BgL_tmpz00_2060 = BgL_arg1871z00_509
; }  else 
{ 
obj_t BgL_auxz00_2063;
BgL_auxz00_2063 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)6726)), BGl_string2161z00zz__wav_decoderz00, BGl_string2076z00zz__wav_decoderz00, BgL_arg1871z00_509); 
FAILURE(BgL_auxz00_2063,BFALSE,BFALSE);} 
BgL_za72za7_654 = 
(long)CINT(BgL_tmpz00_2060); } 
BgL_arg1870z00_508 = 
(BgL_za71za7_653-BgL_za72za7_654); } } 
{ 
int BgL_sza7za7_2069;
BgL_sza7za7_2069 = 
(int)(BgL_arg1870z00_508); 
BgL_sza7za7_505 = BgL_sza7za7_2069; 
goto BGl_flushze70ze7zz__wav_decoderz00;} }  else 
{ /* Llib/wav_decoder.scm 166 */
return ((bool_t)0);} } 
BGL_FUNCTION_END;
}



/* inc-tail!~0 */
obj_t BGl_inczd2tailz12ze70z27zz__wav_decoderz00(BgL_musicbufferz00_bglt BgL_i1100z00_840, long BgL_inlenz00_839, BgL_musicbufferz00_bglt BgL_bufferz00_838, obj_t BgL_haszd2beenzd2emptyzd2oncezd2_837, long BgL_siza7eza7_474)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 152 */
{ 

{ /* Llib/wav_decoder.scm 145 */
long BgL_ntailz00_476;
BgL_ntailz00_476 = 
(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1100z00_840))->BgL_z52tailz52)+BgL_siza7eza7_474); 
if(
(BgL_ntailz00_476==BgL_inlenz00_839))
{ /* Llib/wav_decoder.scm 146 */
BgL_ntailz00_476 = ((long)0); }  else 
{ /* Llib/wav_decoder.scm 146 */BFALSE; } 
if(
(BgL_ntailz00_476==
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1100z00_840))->BgL_z52headz52)))
{ /* Llib/wav_decoder.scm 149 */
{ /* Llib/wav_decoder.scm 150 */
obj_t BgL_auxz00_841;
BgL_auxz00_841 = BTRUE; 
if(
BOOLEANP(BgL_auxz00_841))
{ /* Llib/wav_decoder.scm 150 */
CELL_SET(BgL_haszd2beenzd2emptyzd2oncezd2_837, BgL_auxz00_841); }  else 
{ 
obj_t BgL_auxz00_2080;
BgL_auxz00_2080 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)6133)), BGl_string2168z00zz__wav_decoderz00, BGl_string2169z00zz__wav_decoderz00, BgL_auxz00_841); 
FAILURE(BgL_auxz00_2080,BFALSE,BFALSE);} } 
((((BgL_musicbufferz00_bglt)COBJECT(BgL_i1100z00_840))->BgL_z52emptyz52)=((bool_t)((bool_t)1)),BUNSPEC); }  else 
{ /* Llib/wav_decoder.scm 149 */BFALSE; } 
((((BgL_musicbufferz00_bglt)COBJECT(BgL_i1100z00_840))->BgL_z52tailz52)=((long)BgL_ntailz00_476),BUNSPEC); } 
{ /* Llib/wav_decoder.scm 128 */
bool_t BgL_testz00_2086;
{ /* Llib/wav_decoder.scm 128 */
int BgL_arg1840z00_473;
BgL_arg1840z00_473 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_testz00_2086 = 
(
(long)(BgL_arg1840z00_473)>=((long)3)); } 
if(BgL_testz00_2086)
{ /* Llib/wav_decoder.scm 129 */
long BgL_pz00_434;
BgL_pz00_434 = 
BGl_bufferzd2percentagezd2filledze70ze7zz__wav_decoderz00(BgL_inlenz00_839, BgL_bufferz00_838); 
{ /* Llib/wav_decoder.scm 130 */
bool_t BgL_testz00_2091;
{ /* Llib/wav_decoder.scm 130 */
bool_t BgL_testz00_2092;
{ /* Llib/wav_decoder.scm 130 */
bool_t BgL_testz00_2093;
if(
(BgL_pz00_434<((long)75)))
{ /* Llib/wav_decoder.scm 130 */
BgL_testz00_2093 = ((bool_t)1)
; }  else 
{ /* Llib/wav_decoder.scm 130 */
BgL_testz00_2093 = 
CBOOL(
CELL_REF(BgL_haszd2beenzd2emptyzd2oncezd2_837))
; } 
if(BgL_testz00_2093)
{ /* Llib/wav_decoder.scm 130 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1100z00_840))->BgL_z52eofz52))
{ /* Llib/wav_decoder.scm 131 */
BgL_testz00_2092 = ((bool_t)0)
; }  else 
{ /* Llib/wav_decoder.scm 131 */
BgL_testz00_2092 = ((bool_t)1)
; } }  else 
{ /* Llib/wav_decoder.scm 130 */
BgL_testz00_2092 = ((bool_t)0)
; } } 
if(BgL_testz00_2092)
{ /* Llib/wav_decoder.scm 130 */
BgL_testz00_2091 = ((bool_t)1)
; }  else 
{ /* Llib/wav_decoder.scm 132 */
int BgL_arg1839z00_468;
BgL_arg1839z00_468 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_testz00_2091 = 
(
(long)(BgL_arg1839z00_468)>=((long)4)); } } 
if(BgL_testz00_2091)
{ /* Llib/wav_decoder.scm 135 */
obj_t BgL_arg1823z00_449;obj_t BgL_arg1824z00_450;obj_t BgL_arg1825z00_451;
if(
(BgL_pz00_434>=((long)80)))
{ /* Llib/wav_decoder.scm 135 */
BgL_arg1823z00_449 = BGl_string2111z00zz__wav_decoderz00; }  else 
{ /* Llib/wav_decoder.scm 135 */
if(
(BgL_pz00_434>((long)25)))
{ /* Llib/wav_decoder.scm 136 */
BgL_arg1823z00_449 = BGl_string2162z00zz__wav_decoderz00; }  else 
{ /* Llib/wav_decoder.scm 136 */
BgL_arg1823z00_449 = BGl_string2163z00zz__wav_decoderz00; } } 
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1100z00_840))->BgL_z52eofz52))
{ /* Llib/wav_decoder.scm 140 */
BgL_arg1824z00_450 = BGl_string2164z00zz__wav_decoderz00; }  else 
{ /* Llib/wav_decoder.scm 140 */
BgL_arg1824z00_450 = BGl_string2111z00zz__wav_decoderz00; } 
BgL_arg1825z00_451 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1100z00_840))->BgL_urlz00); 
{ /* Llib/wav_decoder.scm 133 */
obj_t BgL_list1826z00_452;
{ /* Llib/wav_decoder.scm 133 */
obj_t BgL_arg1827z00_453;
{ /* Llib/wav_decoder.scm 133 */
obj_t BgL_arg1828z00_454;
{ /* Llib/wav_decoder.scm 133 */
obj_t BgL_arg1829z00_455;
{ /* Llib/wav_decoder.scm 133 */
obj_t BgL_arg1830z00_456;
{ /* Llib/wav_decoder.scm 133 */
obj_t BgL_arg1831z00_457;
{ /* Llib/wav_decoder.scm 133 */
obj_t BgL_arg1832z00_458;
{ /* Llib/wav_decoder.scm 133 */
obj_t BgL_arg1833z00_459;
BgL_arg1833z00_459 = 
MAKE_YOUNG_PAIR(BGl_string2083z00zz__wav_decoderz00, BNIL); 
BgL_arg1832z00_458 = 
MAKE_YOUNG_PAIR(BgL_arg1825z00_451, BgL_arg1833z00_459); } 
BgL_arg1831z00_457 = 
MAKE_YOUNG_PAIR(BGl_string2165z00zz__wav_decoderz00, BgL_arg1832z00_458); } 
BgL_arg1830z00_456 = 
MAKE_YOUNG_PAIR(BgL_arg1824z00_450, BgL_arg1831z00_457); } 
BgL_arg1829z00_455 = 
MAKE_YOUNG_PAIR(BGl_string2166z00zz__wav_decoderz00, BgL_arg1830z00_456); } 
BgL_arg1828z00_454 = 
MAKE_YOUNG_PAIR(
BINT(BgL_pz00_434), BgL_arg1829z00_455); } 
BgL_arg1827z00_453 = 
MAKE_YOUNG_PAIR(BgL_arg1823z00_449, BgL_arg1828z00_454); } 
BgL_list1826z00_452 = 
MAKE_YOUNG_PAIR(BGl_string2167z00zz__wav_decoderz00, BgL_arg1827z00_453); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1826z00_452); } }  else 
{ /* Llib/wav_decoder.scm 130 */BFALSE; } } }  else 
{ /* Llib/wav_decoder.scm 128 */BFALSE; } } 
{ /* Llib/wav_decoder.scm 156 */
bool_t BgL_testz00_2119;
{ /* Llib/wav_decoder.scm 156 */
bool_t BgL_testz00_2120;
{ /* Llib/wav_decoder.scm 123 */
long BgL_arg1809z00_427;
{ /* Llib/wav_decoder.scm 123 */
long BgL_arg1810z00_428;long BgL_arg1811z00_429;
if(
CBOOL(
CELL_REF(BgL_haszd2beenzd2emptyzd2oncezd2_837)))
{ /* Llib/wav_decoder.scm 123 */
BgL_arg1810z00_428 = ((long)2); }  else 
{ /* Llib/wav_decoder.scm 123 */
BgL_arg1810z00_428 = ((long)4); } 
BgL_arg1811z00_429 = 
(BgL_inlenz00_839-
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(BgL_bufferz00_838)); 
BgL_arg1809z00_427 = 
(BgL_arg1810z00_428*BgL_arg1811z00_429); } 
BgL_testz00_2120 = 
(BgL_arg1809z00_427>BgL_inlenz00_839); } 
if(BgL_testz00_2120)
{ /* Llib/wav_decoder.scm 156 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1100z00_840))->BgL_z52eofz52))
{ /* Llib/wav_decoder.scm 156 */
BgL_testz00_2119 = ((bool_t)0)
; }  else 
{ /* Llib/wav_decoder.scm 156 */
BgL_testz00_2119 = ((bool_t)1)
; } }  else 
{ /* Llib/wav_decoder.scm 156 */
BgL_testz00_2119 = ((bool_t)0)
; } } 
if(BgL_testz00_2119)
{ /* Llib/wav_decoder.scm 156 */
{ /* Llib/wav_decoder.scm 157 */
bool_t BgL_testz00_2129;
{ /* Llib/wav_decoder.scm 157 */
int BgL_arg1859z00_494;
BgL_arg1859z00_494 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_testz00_2129 = 
(
(long)(BgL_arg1859z00_494)>=((long)2)); } 
if(BgL_testz00_2129)
{ /* Llib/wav_decoder.scm 158 */
obj_t BgL_arg1852z00_487;BGL_LONGLONG_T BgL_arg1853z00_488;
BgL_arg1852z00_487 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1100z00_840))->BgL_urlz00); 
BgL_arg1853z00_488 = 
bgl_current_microseconds(); 
{ /* Llib/wav_decoder.scm 158 */
obj_t BgL_list1854z00_489;
{ /* Llib/wav_decoder.scm 158 */
obj_t BgL_arg1855z00_490;
{ /* Llib/wav_decoder.scm 158 */
obj_t BgL_arg1856z00_491;
{ /* Llib/wav_decoder.scm 158 */
obj_t BgL_arg1857z00_492;
{ /* Llib/wav_decoder.scm 158 */
obj_t BgL_arg1858z00_493;
BgL_arg1858z00_493 = 
MAKE_YOUNG_PAIR(BGl_string2145z00zz__wav_decoderz00, BNIL); 
BgL_arg1857z00_492 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1853z00_488), BgL_arg1858z00_493); } 
BgL_arg1856z00_491 = 
MAKE_YOUNG_PAIR(BGl_string2084z00zz__wav_decoderz00, BgL_arg1857z00_492); } 
BgL_arg1855z00_490 = 
MAKE_YOUNG_PAIR(BgL_arg1852z00_487, BgL_arg1856z00_491); } 
BgL_list1854z00_489 = 
MAKE_YOUNG_PAIR(BGl_string2170z00zz__wav_decoderz00, BgL_arg1855z00_490); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1854z00_489); } }  else 
{ /* Llib/wav_decoder.scm 157 */BFALSE; } } 
{ /* Llib/wav_decoder.scm 160 */
obj_t BgL_mutex1860z00_495;
BgL_mutex1860z00_495 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1100z00_840))->BgL_z52bmutexz52); 
BGL_MUTEX_LOCK(BgL_mutex1860z00_495); 
{ /* Llib/wav_decoder.scm 160 */
bool_t BgL_tmp2299z00_2143;
{ /* Llib/wav_decoder.scm 161 */
obj_t BgL_arg1861z00_496;
BgL_arg1861z00_496 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1100z00_840))->BgL_z52bcondvz52); 
{ /* Llib/wav_decoder.scm 161 */
bool_t BgL_res1919z00_647;
BgL_res1919z00_647 = 
BGL_CONDVAR_BROADCAST(BgL_arg1861z00_496); 
BgL_tmp2299z00_2143 = BgL_res1919z00_647; } } 
BGL_MUTEX_UNLOCK(BgL_mutex1860z00_495); BgL_tmp2299z00_2143; } } 
{ /* Llib/wav_decoder.scm 162 */
bool_t BgL_testz00_2148;
{ /* Llib/wav_decoder.scm 162 */
int BgL_arg1867z00_502;
BgL_arg1867z00_502 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_testz00_2148 = 
(
(long)(BgL_arg1867z00_502)>=((long)2)); } 
if(BgL_testz00_2148)
{ /* Llib/wav_decoder.scm 163 */
BGL_LONGLONG_T BgL_arg1864z00_499;
BgL_arg1864z00_499 = 
bgl_current_microseconds(); 
{ /* Llib/wav_decoder.scm 163 */
obj_t BgL_list1865z00_500;
{ /* Llib/wav_decoder.scm 163 */
obj_t BgL_arg1866z00_501;
BgL_arg1866z00_501 = 
MAKE_YOUNG_PAIR(BGl_string2083z00zz__wav_decoderz00, BNIL); 
BgL_list1865z00_500 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1864z00_499), BgL_arg1866z00_501); } 
return 
BGl_debugz00zz__wav_decoderz00(BgL_list1865z00_500);} }  else 
{ /* Llib/wav_decoder.scm 162 */
return BFALSE;} } }  else 
{ /* Llib/wav_decoder.scm 156 */
return BFALSE;} } } } 
BGL_FUNCTION_END;
}



/* buffer-percentage-filled~0 */
long BGl_bufferzd2percentagezd2filledze70ze7zz__wav_decoderz00(long BgL_inlenz00_843, BgL_musicbufferz00_bglt BgL_bufferz00_842)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 115 */
{ /* Llib/wav_decoder.scm 114 */
BGL_LONGLONG_T BgL_arg1800z00_418;
{ /* Llib/wav_decoder.scm 114 */
BGL_LONGLONG_T BgL_arg1801z00_419;BGL_LONGLONG_T BgL_arg1802z00_420;
{ /* Llib/wav_decoder.scm 114 */
BGL_LONGLONG_T BgL_arg1803z00_421;
{ /* Llib/wav_decoder.scm 114 */
long BgL_arg1804z00_422;
BgL_arg1804z00_422 = 
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(BgL_bufferz00_842); 
{ /* Llib/wav_decoder.scm 114 */
BGL_LONGLONG_T BgL_res1896z00_596;
BgL_res1896z00_596 = 
LONG_TO_LLONG(BgL_arg1804z00_422); 
BgL_arg1803z00_421 = BgL_res1896z00_596; } } 
BgL_arg1801z00_419 = 
(((BGL_LONGLONG_T)100)*BgL_arg1803z00_421); } 
{ /* Llib/wav_decoder.scm 115 */
BGL_LONGLONG_T BgL_res1898z00_601;
BgL_res1898z00_601 = 
LONG_TO_LLONG(BgL_inlenz00_843); 
BgL_arg1802z00_420 = BgL_res1898z00_601; } 
{ /* Llib/wav_decoder.scm 113 */
BGL_LONGLONG_T BgL_res1899z00_604;
BgL_res1899z00_604 = 
(BgL_arg1801z00_419/BgL_arg1802z00_420); 
BgL_arg1800z00_418 = BgL_res1899z00_604; } } 
{ /* Llib/wav_decoder.scm 112 */
long BgL_res1900z00_606;
BgL_res1900z00_606 = 
LLONG_TO_LONG(BgL_arg1800z00_418); 
return BgL_res1900z00_606;} } } 
BGL_FUNCTION_END;
}



/* &musicdecoder-positio1134 */
obj_t BGl_z62musicdecoderzd2positio1134zb0zz__wav_decoderz00(obj_t BgL_envz00_810, obj_t BgL_decz00_811, obj_t BgL_bz00_812)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 67 */
{ /* Llib/wav_decoder.scm 68 */
int BgL_tmpz00_2163;
{ /* Llib/wav_decoder.scm 68 */
BgL_wavmusicdecoderz00_bglt BgL_decz00_1141;
if(
BGl_isazf3zf3zz__objectz00(BgL_decz00_811, BGl_wavmusicdecoderz00zz__wav_decoderz00))
{ /* Llib/wav_decoder.scm 68 */
BgL_decz00_1141 = 
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_811); }  else 
{ 
obj_t BgL_auxz00_2167;
BgL_auxz00_2167 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)3321)), BGl_string2171z00zz__wav_decoderz00, BGl_string2113z00zz__wav_decoderz00, BgL_decz00_811); 
FAILURE(BgL_auxz00_2167,BFALSE,BFALSE);} 
BgL_tmpz00_2163 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_1141))->BgL_z52positionz52); } 
return 
BINT(BgL_tmpz00_2163);} } 
BGL_FUNCTION_END;
}



/* &musicdecoder-reset!-1132 */
obj_t BGl_z62musicdecoderzd2resetz12zd21132z70zz__wav_decoderz00(obj_t BgL_envz00_813, obj_t BgL_decz00_814)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 59 */
{ /* Llib/wav_decoder.scm 59 */
BgL_wavmusicdecoderz00_bglt BgL_decz00_1142;
if(
BGl_isazf3zf3zz__objectz00(BgL_decz00_814, BGl_wavmusicdecoderz00zz__wav_decoderz00))
{ /* Llib/wav_decoder.scm 59 */
BgL_decz00_1142 = 
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_814); }  else 
{ 
obj_t BgL_auxz00_2176;
BgL_auxz00_2176 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)2877)), BGl_string2173z00zz__wav_decoderz00, BGl_string2113z00zz__wav_decoderz00, BgL_decz00_814); 
FAILURE(BgL_auxz00_2176,BFALSE,BFALSE);} 
{ 

((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_1142))->BgL_z52headerz52)=((obj_t)BFALSE),BUNSPEC); 
{ /* Llib/wav_decoder.scm 59 */
obj_t BgL_nextzd2method1131zd2_1144;
BgL_nextzd2method1131zd2_1144 = 
BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
((BgL_objectz00_bglt)BgL_decz00_1142), BGl_musicdecoderzd2resetz12zd2envz12zz__multimediazd2musicbufzd2, BGl_wavmusicdecoderz00zz__wav_decoderz00); 
if(
PROCEDURE_CORRECT_ARITYP(BgL_nextzd2method1131zd2_1144, ((long)1)))
{ /* Llib/wav_decoder.scm 59 */
return 
PROCEDURE_ENTRY(BgL_nextzd2method1131zd2_1144)(BgL_nextzd2method1131zd2_1144, 
((obj_t)BgL_decz00_1142), BEOA);}  else 
{ 
obj_t BgL_auxz00_2190;
BgL_auxz00_2190 = 
CNST_TABLE_REF(((long)23)); 
FAILURE(BGl_string2172z00zz__wav_decoderz00,BgL_auxz00_2190,BgL_nextzd2method1131zd2_1144);} } } } } 
BGL_FUNCTION_END;
}



/* &musicdecoder-init-wa1130 */
obj_t BGl_z62musicdecoderzd2initzd2wa1130z62zz__wav_decoderz00(obj_t BgL_envz00_815, obj_t BgL_decz00_816)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 51 */
{ /* Llib/wav_decoder.scm 52 */
BgL_wavmusicdecoderz00_bglt BgL_decz00_1145;
if(
BGl_isazf3zf3zz__objectz00(BgL_decz00_816, BGl_wavmusicdecoderz00zz__wav_decoderz00))
{ /* Llib/wav_decoder.scm 52 */
BgL_decz00_1145 = 
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_816); }  else 
{ 
obj_t BgL_auxz00_2196;
BgL_auxz00_2196 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)2502)), BGl_string2174z00zz__wav_decoderz00, BGl_string2113z00zz__wav_decoderz00, BgL_decz00_816); 
FAILURE(BgL_auxz00_2196,BFALSE,BFALSE);} 
if(
NULLP(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_decz00_1145)))->BgL_mimetypesz00)))
{ /* Llib/wav_decoder.scm 53 */
return 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_decz00_1145)))->BgL_mimetypesz00)=((obj_t)
CNST_TABLE_REF(((long)24))),BUNSPEC);}  else 
{ /* Llib/wav_decoder.scm 53 */
return BFALSE;} } } 
BGL_FUNCTION_END;
}



/* &object-print-wavmusi1128 */
obj_t BGl_z62objectzd2printzd2wavmusi1128z62zz__wav_decoderz00(obj_t BgL_envz00_817, obj_t BgL_oz00_818, obj_t BgL_portz00_819, obj_t BgL_printzd2slotzd2_820)
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 45 */
{ /* Llib/wav_decoder.scm 46 */
BgL_wavmusicdecoderz00_bglt BgL_oz00_1146;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_818, BGl_wavmusicdecoderz00zz__wav_decoderz00))
{ /* Llib/wav_decoder.scm 46 */
BgL_oz00_1146 = 
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_818); }  else 
{ 
obj_t BgL_auxz00_2210;
BgL_auxz00_2210 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)2183)), BGl_string2177z00zz__wav_decoderz00, BGl_string2113z00zz__wav_decoderz00, BgL_oz00_818); 
FAILURE(BgL_auxz00_2210,BFALSE,BFALSE);} 
{ /* Llib/wav_decoder.scm 46 */
obj_t BgL_portz00_1147;
if(
OUTPUT_PORTP(BgL_portz00_819))
{ /* Llib/wav_decoder.scm 46 */
BgL_portz00_1147 = BgL_portz00_819; }  else 
{ 
obj_t BgL_auxz00_2216;
BgL_auxz00_2216 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2074z00zz__wav_decoderz00, 
BINT(((long)2183)), BGl_string2175z00zz__wav_decoderz00, BGl_string2088z00zz__wav_decoderz00, BgL_portz00_819); 
FAILURE(BgL_auxz00_2216,BFALSE,BFALSE);} 
return 
bgl_display_string(BGl_string2176z00zz__wav_decoderz00, BgL_portz00_1147);} } } 
BGL_FUNCTION_END;
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__wav_decoderz00()
{ BGL_FUNCTION_BEGIN;
{ /* Llib/wav_decoder.scm 15 */
return 
BGl_modulezd2initializa7ationz75zz__wav_wavz00(((long)21080121), 
BSTRING_TO_STRING(BGl_string2178z00zz__wav_decoderz00));} 
BGL_FUNCTION_END;
}

#ifdef __cplusplus
}
#endif
